/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var x=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/errors","vs/base/common/resources","vs/base/common/buffer","vs/platform/files/common/files","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/platform/product/common/productService","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/base/common/uuid","fs","vs/platform/telemetry/common/telemetry","vs/platform/workspaces/common/workspaces","vs/base/common/arrays","vs/base/common/extpath","vs/base/common/labels","vs/base/common/process","vs/platform/windows/electron-main/windows","vs/base/common/map","vs/base/parts/ipc/common/ipc","vs/platform/state/electron-main/state","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/json","child_process","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/objects","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/stream","vs/platform/backup/electron-main/backup","vs/platform/environment/common/environment","vs/platform/environment/node/argvHelper","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/base/parts/ipc/node/ipc.net","vs/base/common/keybindings","crypto","net","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/keyCodes","vs/base/common/processes","vs/base/common/hash","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/remote/common/tunnel","vs/platform/storage/common/storage","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/codicons","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/keybindingParser","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/uriIpc","vs/base/common/worker/simpleWorker","vs/base/node/crypto","vs/base/node/decoder","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/parcel/parcelWatcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/resolvedKeybindingItem","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/extensions/electron-main/workerMainProcessExtensionHostStarter","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","path","assert","graceful-fs","worker_threads","vs/code/electron-main/main"],ee=function(j){for(var e=[],p=0,r=j.length;p<r;p++)e[p]=x[j[p]];return e};define(x[102],ee([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function p(r,D){if(!r)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=p}),define(x[103],ee([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function p(k){return k?k.replace(/\$\((.*?)\)/g,(I,d)=>` ${d} `).trim():""}e.getCodiconAriaLabel=p;class r{constructor(I,d,g){this.id=I,this.definition=d,this.description=g,r._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return r._allCodicons}}e.Codicon=r,r._allCodicons=[],r.add=new r("add",{fontCharacter:"\\ea60"}),r.plus=new r("plus",r.add.definition),r.gistNew=new r("gist-new",r.add.definition),r.repoCreate=new r("repo-create",r.add.definition),r.lightbulb=new r("lightbulb",{fontCharacter:"\\ea61"}),r.lightBulb=new r("light-bulb",{fontCharacter:"\\ea61"}),r.repo=new r("repo",{fontCharacter:"\\ea62"}),r.repoDelete=new r("repo-delete",{fontCharacter:"\\ea62"}),r.gistFork=new r("gist-fork",{fontCharacter:"\\ea63"}),r.repoForked=new r("repo-forked",{fontCharacter:"\\ea63"}),r.gitPullRequest=new r("git-pull-request",{fontCharacter:"\\ea64"}),r.gitPullRequestAbandoned=new r("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),r.recordKeys=new r("record-keys",{fontCharacter:"\\ea65"}),r.keyboard=new r("keyboard",{fontCharacter:"\\ea65"}),r.tag=new r("tag",{fontCharacter:"\\ea66"}),r.tagAdd=new r("tag-add",{fontCharacter:"\\ea66"}),r.tagRemove=new r("tag-remove",{fontCharacter:"\\ea66"}),r.person=new r("person",{fontCharacter:"\\ea67"}),r.personFollow=new r("person-follow",{fontCharacter:"\\ea67"}),r.personOutline=new r("person-outline",{fontCharacter:"\\ea67"}),r.personFilled=new r("person-filled",{fontCharacter:"\\ea67"}),r.gitBranch=new r("git-branch",{fontCharacter:"\\ea68"}),r.gitBranchCreate=new r("git-branch-create",{fontCharacter:"\\ea68"}),r.gitBranchDelete=new r("git-branch-delete",{fontCharacter:"\\ea68"}),r.sourceControl=new r("source-control",{fontCharacter:"\\ea68"}),r.mirror=new r("mirror",{fontCharacter:"\\ea69"}),r.mirrorPublic=new r("mirror-public",{fontCharacter:"\\ea69"}),r.star=new r("star",{fontCharacter:"\\ea6a"}),r.starAdd=new r("star-add",{fontCharacter:"\\ea6a"}),r.starDelete=new r("star-delete",{fontCharacter:"\\ea6a"}),r.starEmpty=new r("star-empty",{fontCharacter:"\\ea6a"}),r.comment=new r("comment",{fontCharacter:"\\ea6b"}),r.commentAdd=new r("comment-add",{fontCharacter:"\\ea6b"}),r.alert=new r("alert",{fontCharacter:"\\ea6c"}),r.warning=new r("warning",{fontCharacter:"\\ea6c"}),r.search=new r("search",{fontCharacter:"\\ea6d"}),r.searchSave=new r("search-save",{fontCharacter:"\\ea6d"}),r.logOut=new r("log-out",{fontCharacter:"\\ea6e"}),r.signOut=new r("sign-out",{fontCharacter:"\\ea6e"}),r.logIn=new r("log-in",{fontCharacter:"\\ea6f"}),r.signIn=new r("sign-in",{fontCharacter:"\\ea6f"}),r.eye=new r("eye",{fontCharacter:"\\ea70"}),r.eyeUnwatch=new r("eye-unwatch",{fontCharacter:"\\ea70"}),r.eyeWatch=new r("eye-watch",{fontCharacter:"\\ea70"}),r.circleFilled=new r("circle-filled",{fontCharacter:"\\ea71"}),r.primitiveDot=new r("primitive-dot",{fontCharacter:"\\ea71"}),r.closeDirty=new r("close-dirty",{fontCharacter:"\\ea71"}),r.debugBreakpoint=new r("debug-breakpoint",{fontCharacter:"\\ea71"}),r.debugBreakpointDisabled=new r("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),r.debugHint=new r("debug-hint",{fontCharacter:"\\ea71"}),r.primitiveSquare=new r("primitive-square",{fontCharacter:"\\ea72"}),r.edit=new r("edit",{fontCharacter:"\\ea73"}),r.pencil=new r("pencil",{fontCharacter:"\\ea73"}),r.info=new r("info",{fontCharacter:"\\ea74"}),r.issueOpened=new r("issue-opened",{fontCharacter:"\\ea74"}),r.gistPrivate=new r("gist-private",{fontCharacter:"\\ea75"}),r.gitForkPrivate=new r("git-fork-private",{fontCharacter:"\\ea75"}),r.lock=new r("lock",{fontCharacter:"\\ea75"}),r.mirrorPrivate=new r("mirror-private",{fontCharacter:"\\ea75"}),r.close=new r("close",{fontCharacter:"\\ea76"}),r.removeClose=new r("remove-close",{fontCharacter:"\\ea76"}),r.x=new r("x",{fontCharacter:"\\ea76"}),r.repoSync=new r("repo-sync",{fontCharacter:"\\ea77"}),r.sync=new r("sync",{fontCharacter:"\\ea77"}),r.clone=new r("clone",{fontCharacter:"\\ea78"}),r.desktopDownload=new r("desktop-download",{fontCharacter:"\\ea78"}),r.beaker=new r("beaker",{fontCharacter:"\\ea79"}),r.microscope=new r("microscope",{fontCharacter:"\\ea79"}),r.vm=new r("vm",{fontCharacter:"\\ea7a"}),r.deviceDesktop=new r("device-desktop",{fontCharacter:"\\ea7a"}),r.file=new r("file",{fontCharacter:"\\ea7b"}),r.fileText=new r("file-text",{fontCharacter:"\\ea7b"}),r.more=new r("more",{fontCharacter:"\\ea7c"}),r.ellipsis=new r("ellipsis",{fontCharacter:"\\ea7c"}),r.kebabHorizontal=new r("kebab-horizontal",{fontCharacter:"\\ea7c"}),r.mailReply=new r("mail-reply",{fontCharacter:"\\ea7d"}),r.reply=new r("reply",{fontCharacter:"\\ea7d"}),r.organization=new r("organization",{fontCharacter:"\\ea7e"}),r.organizationFilled=new r("organization-filled",{fontCharacter:"\\ea7e"}),r.organizationOutline=new r("organization-outline",{fontCharacter:"\\ea7e"}),r.newFile=new r("new-file",{fontCharacter:"\\ea7f"}),r.fileAdd=new r("file-add",{fontCharacter:"\\ea7f"}),r.newFolder=new r("new-folder",{fontCharacter:"\\ea80"}),r.fileDirectoryCreate=new r("file-directory-create",{fontCharacter:"\\ea80"}),r.trash=new r("trash",{fontCharacter:"\\ea81"}),r.trashcan=new r("trashcan",{fontCharacter:"\\ea81"}),r.history=new r("history",{fontCharacter:"\\ea82"}),r.clock=new r("clock",{fontCharacter:"\\ea82"}),r.folder=new r("folder",{fontCharacter:"\\ea83"}),r.fileDirectory=new r("file-directory",{fontCharacter:"\\ea83"}),r.symbolFolder=new r("symbol-folder",{fontCharacter:"\\ea83"}),r.logoGithub=new r("logo-github",{fontCharacter:"\\ea84"}),r.markGithub=new r("mark-github",{fontCharacter:"\\ea84"}),r.github=new r("github",{fontCharacter:"\\ea84"}),r.terminal=new r("terminal",{fontCharacter:"\\ea85"}),r.console=new r("console",{fontCharacter:"\\ea85"}),r.repl=new r("repl",{fontCharacter:"\\ea85"}),r.zap=new r("zap",{fontCharacter:"\\ea86"}),r.symbolEvent=new r("symbol-event",{fontCharacter:"\\ea86"}),r.error=new r("error",{fontCharacter:"\\ea87"}),r.stop=new r("stop",{fontCharacter:"\\ea87"}),r.variable=new r("variable",{fontCharacter:"\\ea88"}),r.symbolVariable=new r("symbol-variable",{fontCharacter:"\\ea88"}),r.array=new r("array",{fontCharacter:"\\ea8a"}),r.symbolArray=new r("symbol-array",{fontCharacter:"\\ea8a"}),r.symbolModule=new r("symbol-module",{fontCharacter:"\\ea8b"}),r.symbolPackage=new r("symbol-package",{fontCharacter:"\\ea8b"}),r.symbolNamespace=new r("symbol-namespace",{fontCharacter:"\\ea8b"}),r.symbolObject=new r("symbol-object",{fontCharacter:"\\ea8b"}),r.symbolMethod=new r("symbol-method",{fontCharacter:"\\ea8c"}),r.symbolFunction=new r("symbol-function",{fontCharacter:"\\ea8c"}),r.symbolConstructor=new r("symbol-constructor",{fontCharacter:"\\ea8c"}),r.symbolBoolean=new r("symbol-boolean",{fontCharacter:"\\ea8f"}),r.symbolNull=new r("symbol-null",{fontCharacter:"\\ea8f"}),r.symbolNumeric=new r("symbol-numeric",{fontCharacter:"\\ea90"}),r.symbolNumber=new r("symbol-number",{fontCharacter:"\\ea90"}),r.symbolStructure=new r("symbol-structure",{fontCharacter:"\\ea91"}),r.symbolStruct=new r("symbol-struct",{fontCharacter:"\\ea91"}),r.symbolParameter=new r("symbol-parameter",{fontCharacter:"\\ea92"}),r.symbolTypeParameter=new r("symbol-type-parameter",{fontCharacter:"\\ea92"}),r.symbolKey=new r("symbol-key",{fontCharacter:"\\ea93"}),r.symbolText=new r("symbol-text",{fontCharacter:"\\ea93"}),r.symbolReference=new r("symbol-reference",{fontCharacter:"\\ea94"}),r.goToFile=new r("go-to-file",{fontCharacter:"\\ea94"}),r.symbolEnum=new r("symbol-enum",{fontCharacter:"\\ea95"}),r.symbolValue=new r("symbol-value",{fontCharacter:"\\ea95"}),r.symbolRuler=new r("symbol-ruler",{fontCharacter:"\\ea96"}),r.symbolUnit=new r("symbol-unit",{fontCharacter:"\\ea96"}),r.activateBreakpoints=new r("activate-breakpoints",{fontCharacter:"\\ea97"}),r.archive=new r("archive",{fontCharacter:"\\ea98"}),r.arrowBoth=new r("arrow-both",{fontCharacter:"\\ea99"}),r.arrowDown=new r("arrow-down",{fontCharacter:"\\ea9a"}),r.arrowLeft=new r("arrow-left",{fontCharacter:"\\ea9b"}),r.arrowRight=new r("arrow-right",{fontCharacter:"\\ea9c"}),r.arrowSmallDown=new r("arrow-small-down",{fontCharacter:"\\ea9d"}),r.arrowSmallLeft=new r("arrow-small-left",{fontCharacter:"\\ea9e"}),r.arrowSmallRight=new r("arrow-small-right",{fontCharacter:"\\ea9f"}),r.arrowSmallUp=new r("arrow-small-up",{fontCharacter:"\\eaa0"}),r.arrowUp=new r("arrow-up",{fontCharacter:"\\eaa1"}),r.bell=new r("bell",{fontCharacter:"\\eaa2"}),r.bold=new r("bold",{fontCharacter:"\\eaa3"}),r.book=new r("book",{fontCharacter:"\\eaa4"}),r.bookmark=new r("bookmark",{fontCharacter:"\\eaa5"}),r.debugBreakpointConditionalUnverified=new r("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),r.debugBreakpointConditional=new r("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),r.debugBreakpointConditionalDisabled=new r("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),r.debugBreakpointDataUnverified=new r("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),r.debugBreakpointData=new r("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),r.debugBreakpointDataDisabled=new r("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),r.debugBreakpointLogUnverified=new r("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),r.debugBreakpointLog=new r("debug-breakpoint-log",{fontCharacter:"\\eaab"}),r.debugBreakpointLogDisabled=new r("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),r.briefcase=new r("briefcase",{fontCharacter:"\\eaac"}),r.broadcast=new r("broadcast",{fontCharacter:"\\eaad"}),r.browser=new r("browser",{fontCharacter:"\\eaae"}),r.bug=new r("bug",{fontCharacter:"\\eaaf"}),r.calendar=new r("calendar",{fontCharacter:"\\eab0"}),r.caseSensitive=new r("case-sensitive",{fontCharacter:"\\eab1"}),r.check=new r("check",{fontCharacter:"\\eab2"}),r.checklist=new r("checklist",{fontCharacter:"\\eab3"}),r.chevronDown=new r("chevron-down",{fontCharacter:"\\eab4"}),r.dropDownButton=new r("drop-down-button",r.chevronDown.definition),r.chevronLeft=new r("chevron-left",{fontCharacter:"\\eab5"}),r.chevronRight=new r("chevron-right",{fontCharacter:"\\eab6"}),r.chevronUp=new r("chevron-up",{fontCharacter:"\\eab7"}),r.chromeClose=new r("chrome-close",{fontCharacter:"\\eab8"}),r.chromeMaximize=new r("chrome-maximize",{fontCharacter:"\\eab9"}),r.chromeMinimize=new r("chrome-minimize",{fontCharacter:"\\eaba"}),r.chromeRestore=new r("chrome-restore",{fontCharacter:"\\eabb"}),r.circleOutline=new r("circle-outline",{fontCharacter:"\\eabc"}),r.debugBreakpointUnverified=new r("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),r.circleSlash=new r("circle-slash",{fontCharacter:"\\eabd"}),r.circuitBoard=new r("circuit-board",{fontCharacter:"\\eabe"}),r.clearAll=new r("clear-all",{fontCharacter:"\\eabf"}),r.clippy=new r("clippy",{fontCharacter:"\\eac0"}),r.closeAll=new r("close-all",{fontCharacter:"\\eac1"}),r.cloudDownload=new r("cloud-download",{fontCharacter:"\\eac2"}),r.cloudUpload=new r("cloud-upload",{fontCharacter:"\\eac3"}),r.code=new r("code",{fontCharacter:"\\eac4"}),r.collapseAll=new r("collapse-all",{fontCharacter:"\\eac5"}),r.colorMode=new r("color-mode",{fontCharacter:"\\eac6"}),r.commentDiscussion=new r("comment-discussion",{fontCharacter:"\\eac7"}),r.compareChanges=new r("compare-changes",{fontCharacter:"\\eafd"}),r.creditCard=new r("credit-card",{fontCharacter:"\\eac9"}),r.dash=new r("dash",{fontCharacter:"\\eacc"}),r.dashboard=new r("dashboard",{fontCharacter:"\\eacd"}),r.database=new r("database",{fontCharacter:"\\eace"}),r.debugContinue=new r("debug-continue",{fontCharacter:"\\eacf"}),r.debugDisconnect=new r("debug-disconnect",{fontCharacter:"\\ead0"}),r.debugPause=new r("debug-pause",{fontCharacter:"\\ead1"}),r.debugRestart=new r("debug-restart",{fontCharacter:"\\ead2"}),r.debugStart=new r("debug-start",{fontCharacter:"\\ead3"}),r.debugStepInto=new r("debug-step-into",{fontCharacter:"\\ead4"}),r.debugStepOut=new r("debug-step-out",{fontCharacter:"\\ead5"}),r.debugStepOver=new r("debug-step-over",{fontCharacter:"\\ead6"}),r.debugStop=new r("debug-stop",{fontCharacter:"\\ead7"}),r.debug=new r("debug",{fontCharacter:"\\ead8"}),r.deviceCameraVideo=new r("device-camera-video",{fontCharacter:"\\ead9"}),r.deviceCamera=new r("device-camera",{fontCharacter:"\\eada"}),r.deviceMobile=new r("device-mobile",{fontCharacter:"\\eadb"}),r.diffAdded=new r("diff-added",{fontCharacter:"\\eadc"}),r.diffIgnored=new r("diff-ignored",{fontCharacter:"\\eadd"}),r.diffModified=new r("diff-modified",{fontCharacter:"\\eade"}),r.diffRemoved=new r("diff-removed",{fontCharacter:"\\eadf"}),r.diffRenamed=new r("diff-renamed",{fontCharacter:"\\eae0"}),r.diff=new r("diff",{fontCharacter:"\\eae1"}),r.discard=new r("discard",{fontCharacter:"\\eae2"}),r.editorLayout=new r("editor-layout",{fontCharacter:"\\eae3"}),r.emptyWindow=new r("empty-window",{fontCharacter:"\\eae4"}),r.exclude=new r("exclude",{fontCharacter:"\\eae5"}),r.extensions=new r("extensions",{fontCharacter:"\\eae6"}),r.eyeClosed=new r("eye-closed",{fontCharacter:"\\eae7"}),r.fileBinary=new r("file-binary",{fontCharacter:"\\eae8"}),r.fileCode=new r("file-code",{fontCharacter:"\\eae9"}),r.fileMedia=new r("file-media",{fontCharacter:"\\eaea"}),r.filePdf=new r("file-pdf",{fontCharacter:"\\eaeb"}),r.fileSubmodule=new r("file-submodule",{fontCharacter:"\\eaec"}),r.fileSymlinkDirectory=new r("file-symlink-directory",{fontCharacter:"\\eaed"}),r.fileSymlinkFile=new r("file-symlink-file",{fontCharacter:"\\eaee"}),r.fileZip=new r("file-zip",{fontCharacter:"\\eaef"}),r.files=new r("files",{fontCharacter:"\\eaf0"}),r.filter=new r("filter",{fontCharacter:"\\eaf1"}),r.flame=new r("flame",{fontCharacter:"\\eaf2"}),r.foldDown=new r("fold-down",{fontCharacter:"\\eaf3"}),r.foldUp=new r("fold-up",{fontCharacter:"\\eaf4"}),r.fold=new r("fold",{fontCharacter:"\\eaf5"}),r.folderActive=new r("folder-active",{fontCharacter:"\\eaf6"}),r.folderOpened=new r("folder-opened",{fontCharacter:"\\eaf7"}),r.gear=new r("gear",{fontCharacter:"\\eaf8"}),r.gift=new r("gift",{fontCharacter:"\\eaf9"}),r.gistSecret=new r("gist-secret",{fontCharacter:"\\eafa"}),r.gist=new r("gist",{fontCharacter:"\\eafb"}),r.gitCommit=new r("git-commit",{fontCharacter:"\\eafc"}),r.gitCompare=new r("git-compare",{fontCharacter:"\\eafd"}),r.gitMerge=new r("git-merge",{fontCharacter:"\\eafe"}),r.githubAction=new r("github-action",{fontCharacter:"\\eaff"}),r.githubAlt=new r("github-alt",{fontCharacter:"\\eb00"}),r.globe=new r("globe",{fontCharacter:"\\eb01"}),r.grabber=new r("grabber",{fontCharacter:"\\eb02"}),r.graph=new r("graph",{fontCharacter:"\\eb03"}),r.gripper=new r("gripper",{fontCharacter:"\\eb04"}),r.heart=new r("heart",{fontCharacter:"\\eb05"}),r.home=new r("home",{fontCharacter:"\\eb06"}),r.horizontalRule=new r("horizontal-rule",{fontCharacter:"\\eb07"}),r.hubot=new r("hubot",{fontCharacter:"\\eb08"}),r.inbox=new r("inbox",{fontCharacter:"\\eb09"}),r.issueClosed=new r("issue-closed",{fontCharacter:"\\eba4"}),r.issueReopened=new r("issue-reopened",{fontCharacter:"\\eb0b"}),r.issues=new r("issues",{fontCharacter:"\\eb0c"}),r.italic=new r("italic",{fontCharacter:"\\eb0d"}),r.jersey=new r("jersey",{fontCharacter:"\\eb0e"}),r.json=new r("json",{fontCharacter:"\\eb0f"}),r.kebabVertical=new r("kebab-vertical",{fontCharacter:"\\eb10"}),r.key=new r("key",{fontCharacter:"\\eb11"}),r.law=new r("law",{fontCharacter:"\\eb12"}),r.lightbulbAutofix=new r("lightbulb-autofix",{fontCharacter:"\\eb13"}),r.linkExternal=new r("link-external",{fontCharacter:"\\eb14"}),r.link=new r("link",{fontCharacter:"\\eb15"}),r.listOrdered=new r("list-ordered",{fontCharacter:"\\eb16"}),r.listUnordered=new r("list-unordered",{fontCharacter:"\\eb17"}),r.liveShare=new r("live-share",{fontCharacter:"\\eb18"}),r.loading=new r("loading",{fontCharacter:"\\eb19"}),r.location=new r("location",{fontCharacter:"\\eb1a"}),r.mailRead=new r("mail-read",{fontCharacter:"\\eb1b"}),r.mail=new r("mail",{fontCharacter:"\\eb1c"}),r.markdown=new r("markdown",{fontCharacter:"\\eb1d"}),r.megaphone=new r("megaphone",{fontCharacter:"\\eb1e"}),r.mention=new r("mention",{fontCharacter:"\\eb1f"}),r.milestone=new r("milestone",{fontCharacter:"\\eb20"}),r.mortarBoard=new r("mortar-board",{fontCharacter:"\\eb21"}),r.move=new r("move",{fontCharacter:"\\eb22"}),r.multipleWindows=new r("multiple-windows",{fontCharacter:"\\eb23"}),r.mute=new r("mute",{fontCharacter:"\\eb24"}),r.noNewline=new r("no-newline",{fontCharacter:"\\eb25"}),r.note=new r("note",{fontCharacter:"\\eb26"}),r.octoface=new r("octoface",{fontCharacter:"\\eb27"}),r.openPreview=new r("open-preview",{fontCharacter:"\\eb28"}),r.package_=new r("package",{fontCharacter:"\\eb29"}),r.paintcan=new r("paintcan",{fontCharacter:"\\eb2a"}),r.pin=new r("pin",{fontCharacter:"\\eb2b"}),r.play=new r("play",{fontCharacter:"\\eb2c"}),r.run=new r("run",{fontCharacter:"\\eb2c"}),r.plug=new r("plug",{fontCharacter:"\\eb2d"}),r.preserveCase=new r("preserve-case",{fontCharacter:"\\eb2e"}),r.preview=new r("preview",{fontCharacter:"\\eb2f"}),r.project=new r("project",{fontCharacter:"\\eb30"}),r.pulse=new r("pulse",{fontCharacter:"\\eb31"}),r.question=new r("question",{fontCharacter:"\\eb32"}),r.quote=new r("quote",{fontCharacter:"\\eb33"}),r.radioTower=new r("radio-tower",{fontCharacter:"\\eb34"}),r.reactions=new r("reactions",{fontCharacter:"\\eb35"}),r.references=new r("references",{fontCharacter:"\\eb36"}),r.refresh=new r("refresh",{fontCharacter:"\\eb37"}),r.regex=new r("regex",{fontCharacter:"\\eb38"}),r.remoteExplorer=new r("remote-explorer",{fontCharacter:"\\eb39"}),r.remote=new r("remote",{fontCharacter:"\\eb3a"}),r.remove=new r("remove",{fontCharacter:"\\eb3b"}),r.replaceAll=new r("replace-all",{fontCharacter:"\\eb3c"}),r.replace=new r("replace",{fontCharacter:"\\eb3d"}),r.repoClone=new r("repo-clone",{fontCharacter:"\\eb3e"}),r.repoForcePush=new r("repo-force-push",{fontCharacter:"\\eb3f"}),r.repoPull=new r("repo-pull",{fontCharacter:"\\eb40"}),r.repoPush=new r("repo-push",{fontCharacter:"\\eb41"}),r.report=new r("report",{fontCharacter:"\\eb42"}),r.requestChanges=new r("request-changes",{fontCharacter:"\\eb43"}),r.rocket=new r("rocket",{fontCharacter:"\\eb44"}),r.rootFolderOpened=new r("root-folder-opened",{fontCharacter:"\\eb45"}),r.rootFolder=new r("root-folder",{fontCharacter:"\\eb46"}),r.rss=new r("rss",{fontCharacter:"\\eb47"}),r.ruby=new r("ruby",{fontCharacter:"\\eb48"}),r.saveAll=new r("save-all",{fontCharacter:"\\eb49"}),r.saveAs=new r("save-as",{fontCharacter:"\\eb4a"}),r.save=new r("save",{fontCharacter:"\\eb4b"}),r.screenFull=new r("screen-full",{fontCharacter:"\\eb4c"}),r.screenNormal=new r("screen-normal",{fontCharacter:"\\eb4d"}),r.searchStop=new r("search-stop",{fontCharacter:"\\eb4e"}),r.server=new r("server",{fontCharacter:"\\eb50"}),r.settingsGear=new r("settings-gear",{fontCharacter:"\\eb51"}),r.settings=new r("settings",{fontCharacter:"\\eb52"}),r.shield=new r("shield",{fontCharacter:"\\eb53"}),r.smiley=new r("smiley",{fontCharacter:"\\eb54"}),r.sortPrecedence=new r("sort-precedence",{fontCharacter:"\\eb55"}),r.splitHorizontal=new r("split-horizontal",{fontCharacter:"\\eb56"}),r.splitVertical=new r("split-vertical",{fontCharacter:"\\eb57"}),r.squirrel=new r("squirrel",{fontCharacter:"\\eb58"}),r.starFull=new r("star-full",{fontCharacter:"\\eb59"}),r.starHalf=new r("star-half",{fontCharacter:"\\eb5a"}),r.symbolClass=new r("symbol-class",{fontCharacter:"\\eb5b"}),r.symbolColor=new r("symbol-color",{fontCharacter:"\\eb5c"}),r.symbolCustomColor=new r("symbol-customcolor",{fontCharacter:"\\eb5c"}),r.symbolConstant=new r("symbol-constant",{fontCharacter:"\\eb5d"}),r.symbolEnumMember=new r("symbol-enum-member",{fontCharacter:"\\eb5e"}),r.symbolField=new r("symbol-field",{fontCharacter:"\\eb5f"}),r.symbolFile=new r("symbol-file",{fontCharacter:"\\eb60"}),r.symbolInterface=new r("symbol-interface",{fontCharacter:"\\eb61"}),r.symbolKeyword=new r("symbol-keyword",{fontCharacter:"\\eb62"}),r.symbolMisc=new r("symbol-misc",{fontCharacter:"\\eb63"}),r.symbolOperator=new r("symbol-operator",{fontCharacter:"\\eb64"}),r.symbolProperty=new r("symbol-property",{fontCharacter:"\\eb65"}),r.wrench=new r("wrench",{fontCharacter:"\\eb65"}),r.wrenchSubaction=new r("wrench-subaction",{fontCharacter:"\\eb65"}),r.symbolSnippet=new r("symbol-snippet",{fontCharacter:"\\eb66"}),r.tasklist=new r("tasklist",{fontCharacter:"\\eb67"}),r.telescope=new r("telescope",{fontCharacter:"\\eb68"}),r.textSize=new r("text-size",{fontCharacter:"\\eb69"}),r.threeBars=new r("three-bars",{fontCharacter:"\\eb6a"}),r.thumbsdown=new r("thumbsdown",{fontCharacter:"\\eb6b"}),r.thumbsup=new r("thumbsup",{fontCharacter:"\\eb6c"}),r.tools=new r("tools",{fontCharacter:"\\eb6d"}),r.triangleDown=new r("triangle-down",{fontCharacter:"\\eb6e"}),r.triangleLeft=new r("triangle-left",{fontCharacter:"\\eb6f"}),r.triangleRight=new r("triangle-right",{fontCharacter:"\\eb70"}),r.triangleUp=new r("triangle-up",{fontCharacter:"\\eb71"}),r.twitter=new r("twitter",{fontCharacter:"\\eb72"}),r.unfold=new r("unfold",{fontCharacter:"\\eb73"}),r.unlock=new r("unlock",{fontCharacter:"\\eb74"}),r.unmute=new r("unmute",{fontCharacter:"\\eb75"}),r.unverified=new r("unverified",{fontCharacter:"\\eb76"}),r.verified=new r("verified",{fontCharacter:"\\eb77"}),r.versions=new r("versions",{fontCharacter:"\\eb78"}),r.vmActive=new r("vm-active",{fontCharacter:"\\eb79"}),r.vmOutline=new r("vm-outline",{fontCharacter:"\\eb7a"}),r.vmRunning=new r("vm-running",{fontCharacter:"\\eb7b"}),r.watch=new r("watch",{fontCharacter:"\\eb7c"}),r.whitespace=new r("whitespace",{fontCharacter:"\\eb7d"}),r.wholeWord=new r("whole-word",{fontCharacter:"\\eb7e"}),r.window=new r("window",{fontCharacter:"\\eb7f"}),r.wordWrap=new r("word-wrap",{fontCharacter:"\\eb80"}),r.zoomIn=new r("zoom-in",{fontCharacter:"\\eb81"}),r.zoomOut=new r("zoom-out",{fontCharacter:"\\eb82"}),r.listFilter=new r("list-filter",{fontCharacter:"\\eb83"}),r.listFlat=new r("list-flat",{fontCharacter:"\\eb84"}),r.listSelection=new r("list-selection",{fontCharacter:"\\eb85"}),r.selection=new r("selection",{fontCharacter:"\\eb85"}),r.listTree=new r("list-tree",{fontCharacter:"\\eb86"}),r.debugBreakpointFunctionUnverified=new r("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),r.debugBreakpointFunction=new r("debug-breakpoint-function",{fontCharacter:"\\eb88"}),r.debugBreakpointFunctionDisabled=new r("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),r.debugStackframeActive=new r("debug-stackframe-active",{fontCharacter:"\\eb89"}),r.debugStackframeDot=new r("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),r.debugStackframe=new r("debug-stackframe",{fontCharacter:"\\eb8b"}),r.debugStackframeFocused=new r("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),r.debugBreakpointUnsupported=new r("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),r.symbolString=new r("symbol-string",{fontCharacter:"\\eb8d"}),r.debugReverseContinue=new r("debug-reverse-continue",{fontCharacter:"\\eb8e"}),r.debugStepBack=new r("debug-step-back",{fontCharacter:"\\eb8f"}),r.debugRestartFrame=new r("debug-restart-frame",{fontCharacter:"\\eb90"}),r.callIncoming=new r("call-incoming",{fontCharacter:"\\eb92"}),r.callOutgoing=new r("call-outgoing",{fontCharacter:"\\eb93"}),r.menu=new r("menu",{fontCharacter:"\\eb94"}),r.expandAll=new r("expand-all",{fontCharacter:"\\eb95"}),r.feedback=new r("feedback",{fontCharacter:"\\eb96"}),r.groupByRefType=new r("group-by-ref-type",{fontCharacter:"\\eb97"}),r.ungroupByRefType=new r("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),r.account=new r("account",{fontCharacter:"\\eb99"}),r.bellDot=new r("bell-dot",{fontCharacter:"\\eb9a"}),r.debugConsole=new r("debug-console",{fontCharacter:"\\eb9b"}),r.library=new r("library",{fontCharacter:"\\eb9c"}),r.output=new r("output",{fontCharacter:"\\eb9d"}),r.runAll=new r("run-all",{fontCharacter:"\\eb9e"}),r.syncIgnored=new r("sync-ignored",{fontCharacter:"\\eb9f"}),r.pinned=new r("pinned",{fontCharacter:"\\eba0"}),r.githubInverted=new r("github-inverted",{fontCharacter:"\\eba1"}),r.debugAlt=new r("debug-alt",{fontCharacter:"\\eb91"}),r.serverProcess=new r("server-process",{fontCharacter:"\\eba2"}),r.serverEnvironment=new r("server-environment",{fontCharacter:"\\eba3"}),r.pass=new r("pass",{fontCharacter:"\\eba4"}),r.stopCircle=new r("stop-circle",{fontCharacter:"\\eba5"}),r.playCircle=new r("play-circle",{fontCharacter:"\\eba6"}),r.record=new r("record",{fontCharacter:"\\eba7"}),r.debugAltSmall=new r("debug-alt-small",{fontCharacter:"\\eba8"}),r.vmConnect=new r("vm-connect",{fontCharacter:"\\eba9"}),r.cloud=new r("cloud",{fontCharacter:"\\ebaa"}),r.merge=new r("merge",{fontCharacter:"\\ebab"}),r.exportIcon=new r("export",{fontCharacter:"\\ebac"}),r.graphLeft=new r("graph-left",{fontCharacter:"\\ebad"}),r.magnet=new r("magnet",{fontCharacter:"\\ebae"}),r.notebook=new r("notebook",{fontCharacter:"\\ebaf"}),r.redo=new r("redo",{fontCharacter:"\\ebb0"}),r.checkAll=new r("check-all",{fontCharacter:"\\ebb1"}),r.pinnedDirty=new r("pinned-dirty",{fontCharacter:"\\ebb2"}),r.passFilled=new r("pass-filled",{fontCharacter:"\\ebb3"}),r.circleLargeFilled=new r("circle-large-filled",{fontCharacter:"\\ebb4"}),r.circleLargeOutline=new r("circle-large-outline",{fontCharacter:"\\ebb5"}),r.combine=new r("combine",{fontCharacter:"\\ebb6"}),r.gather=new r("gather",{fontCharacter:"\\ebb6"}),r.table=new r("table",{fontCharacter:"\\ebb7"}),r.variableGroup=new r("variable-group",{fontCharacter:"\\ebb8"}),r.typeHierarchy=new r("type-hierarchy",{fontCharacter:"\\ebb9"}),r.typeHierarchySub=new r("type-hierarchy-sub",{fontCharacter:"\\ebba"}),r.typeHierarchySuper=new r("type-hierarchy-super",{fontCharacter:"\\ebbb"}),r.gitPullRequestCreate=new r("git-pull-request-create",{fontCharacter:"\\ebbc"}),r.runAbove=new r("run-above",{fontCharacter:"\\ebbd"}),r.runBelow=new r("run-below",{fontCharacter:"\\ebbe"}),r.notebookTemplate=new r("notebook-template",{fontCharacter:"\\ebbf"}),r.debugRerun=new r("debug-rerun",{fontCharacter:"\\ebc0"}),r.workspaceTrusted=new r("workspace-trusted",{fontCharacter:"\\ebc1"}),r.workspaceUntrusted=new r("workspace-untrusted",{fontCharacter:"\\ebc2"}),r.workspaceUnspecified=new r("workspace-unspecified",{fontCharacter:"\\ebc3"}),r.terminalCmd=new r("terminal-cmd",{fontCharacter:"\\ebc4"}),r.terminalDebian=new r("terminal-debian",{fontCharacter:"\\ebc5"}),r.terminalLinux=new r("terminal-linux",{fontCharacter:"\\ebc6"}),r.terminalPowershell=new r("terminal-powershell",{fontCharacter:"\\ebc7"}),r.terminalTmux=new r("terminal-tmux",{fontCharacter:"\\ebc8"}),r.terminalUbuntu=new r("terminal-ubuntu",{fontCharacter:"\\ebc9"}),r.terminalBash=new r("terminal-bash",{fontCharacter:"\\ebca"}),r.arrowSwap=new r("arrow-swap",{fontCharacter:"\\ebcb"}),r.copy=new r("copy",{fontCharacter:"\\ebcc"}),r.personAdd=new r("person-add",{fontCharacter:"\\ebcd"}),r.filterFilled=new r("filter-filled",{fontCharacter:"\\ebce"}),r.wand=new r("wand",{fontCharacter:"\\ebcf"}),r.debugLineByLine=new r("debug-line-by-line",{fontCharacter:"\\ebd0"}),r.inspect=new r("inspect",{fontCharacter:"\\ebd1"}),r.layers=new r("layers",{fontCharacter:"\\ebd2"}),r.layersDot=new r("layers-dot",{fontCharacter:"\\ebd3"}),r.layersActive=new r("layers-active",{fontCharacter:"\\ebd4"}),r.compass=new r("compass",{fontCharacter:"\\ebd5"}),r.compassDot=new r("compass-dot",{fontCharacter:"\\ebd6"}),r.compassActive=new r("compass-active",{fontCharacter:"\\ebd7"}),r.azure=new r("azure",{fontCharacter:"\\ebd8"}),r.issueDraft=new r("issue-draft",{fontCharacter:"\\ebd9"}),r.gitPullRequestClosed=new r("git-pull-request-closed",{fontCharacter:"\\ebda"}),r.gitPullRequestDraft=new r("git-pull-request-draft",{fontCharacter:"\\ebdb"}),r.debugAll=new r("debug-all",{fontCharacter:"\\ebdc"}),r.debugCoverage=new r("debug-coverage",{fontCharacter:"\\ebdd"}),r.runErrors=new r("run-errors",{fontCharacter:"\\ebde"}),r.folderLibrary=new r("folder-library",{fontCharacter:"\\ebdf"}),r.debugContinueSmall=new r("debug-continue-small",{fontCharacter:"\\ebe0"}),r.beakerStop=new r("beaker-stop",{fontCharacter:"\\ebe1"}),r.graphLine=new r("graph-line",{fontCharacter:"\\ebe2"}),r.graphScatter=new r("graph-scatter",{fontCharacter:"\\ebe3"}),r.pieChart=new r("pie-chart",{fontCharacter:"\\ebe4"}),r.bracket=new r("bracket",r.json.definition),r.bracketDot=new r("bracket-dot",{fontCharacter:"\\ebe5"}),r.bracketError=new r("bracket-error",{fontCharacter:"\\ebe6"}),r.lockSmall=new r("lock-small",{fontCharacter:"\\ebe7"}),r.azureDevops=new r("azure-devops",{fontCharacter:"\\ebe8"}),r.verifiedFilled=new r("verified-filled",{fontCharacter:"\\ebe9"}),r.newLine=new r("newline",{fontCharacter:"\\ebea"}),r.layout=new r("layout",{fontCharacter:"\\ebeb"}),r.dialogError=new r("dialog-error",r.error.definition),r.dialogWarning=new r("dialog-warning",r.warning.definition),r.dialogInfo=new r("dialog-info",r.info.definition),r.dialogClose=new r("dialog-close",r.close.definition),r.treeItemExpanded=new r("tree-item-expanded",r.chevronDown.definition),r.treeFilterOnTypeOn=new r("tree-filter-on-type-on",r.listFilter.definition),r.treeFilterOnTypeOff=new r("tree-filter-on-type-off",r.listSelection.definition),r.treeFilterClear=new r("tree-filter-clear",r.close.definition),r.treeItemLoading=new r("tree-item-loading",r.loading.definition),r.menuSelection=new r("menu-selection",r.check.definition),r.menuSubmenu=new r("menu-submenu",r.chevronRight.definition),r.menuBarMore=new r("menubar-more",r.more.definition),r.scrollbarButtonLeft=new r("scrollbar-button-left",r.triangleLeft.definition),r.scrollbarButtonRight=new r("scrollbar-button-right",r.triangleRight.definition),r.scrollbarButtonUp=new r("scrollbar-button-up",r.triangleUp.definition),r.scrollbarButtonDown=new r("scrollbar-button-down",r.triangleDown.definition),r.toolBarMore=new r("toolbar-more",r.more.definition),r.quickInputBack=new r("quick-input-back",r.arrowLeft.definition);function D(k,I){const d=["codicon","codicon-"+k];return I&&d.push("codicon-modifier-"+I),d}e.getClassNamesArray=D;var C;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function d(E){if(E instanceof r)return["codicon","codicon-"+E.id];const w=I.exec(E.id);if(!w)return d(r.error);let[,v,t]=w;const f=["codicon","codicon-"+v];return t&&f.push("codicon-modifier-"+t.substr(1)),f}k.asClassNameArray=d;function g(E){return d(E).join(" ")}k.asClassName=g;function S(E){return"."+d(E).join(".")}k.asCSSSelector=S})(C=e.CSSIcon||(e.CSSIcon={}))}),define(x[46],ee([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function p(k){return(I,d,g)=>{let S=null,E=null;if(typeof g.value=="function"?(S="value",E=g.value):typeof g.get=="function"&&(S="get",E=g.get),!E)throw new Error("not supported");g[S]=k(E,d)}}e.createDecorator=p;function r(k,I,d){let g=null,S=null;if(typeof d.value=="function"?(g="value",S=d.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(g="get",S=d.get),!S)throw new Error("not supported");const E=`$memoize$${I}`;d[g]=function(...w){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:S.apply(this,w)}),this[E]}}e.memoize=r;function D(k,I,d){return p((g,S)=>{const E=`$debounce$${S}`,w=`$debounce$result$${S}`;return function(...v){this[w]||(this[w]=d?d():void 0),clearTimeout(this[E]),I&&(this[w]=I(this[w],...v),v=[this[w]]),this[E]=setTimeout(()=>{g.apply(this,v),this[w]=d?d():void 0},k)}})}e.debounce=D;function C(k,I,d){return p((g,S)=>{const E=`$throttle$timer$${S}`,w=`$throttle$result$${S}`,v=`$throttle$lastRun$${S}`,t=`$throttle$pending$${S}`;return function(...f){if(this[w]||(this[w]=d?d():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),I&&(this[w]=I(this[w],...f)),this[t])return;const y=this[v]+k;y<=Date.now()?(this[v]=Date.now(),g.apply(this,[this[w]]),this[w]=d?d():void 0):(this[t]=!0,this[E]=setTimeout(()=>{this[t]=!1,this[v]=Date.now(),g.apply(this,[this[w]]),this[w]=d?d():void 0},y-Date.now()))}})}e.throttle=C}),define(x[15],ee([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class p{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(o){setTimeout(()=>{throw o.stack?new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.listeners.push(o),()=>{this._removeListener(o)}}emit(o){this.listeners.forEach(h=>{h(o)})}_removeListener(o){this.listeners.splice(this.listeners.indexOf(o),1)}setUnexpectedErrorHandler(o){this.unexpectedErrorHandler=o}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(o){this.unexpectedErrorHandler(o),this.emit(o)}onUnexpectedExternalError(o){this.unexpectedErrorHandler(o)}}e.ErrorHandler=p,e.errorHandler=new p;function r(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=r;function D(l){d(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=D;function C(l){d(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=C;function k(l){if(l instanceof Error){let{name:o,message:h}=l;const n=l.stacktrace||l.stack;return{$isError:!0,name:o,message:h,stack:n}}return l}e.transformErrorForSerialization=k;const I="Canceled";function d(l){return l instanceof Error&&l.name===I&&l.message===I}e.isPromiseCanceledError=d;class g extends Error{constructor(){super(I);this.name=this.message}}e.CancellationError=g;function S(){const l=new Error(I);return l.name=l.message,l}e.canceled=S;function E(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=E;function w(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=w;function v(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=v;function t(l){const o=new Error(`${l} has been disposed`);return o.name="DISPOSED",o}e.disposed=t;function f(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=f;class y extends Error{constructor(o){super("NotImplemented");o&&(this.message=o)}}e.NotImplementedError=y;class b extends Error{constructor(o){super("NotSupported");o&&(this.message=o)}}e.NotSupportedError=b;class P extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=P;function c(l){const o=l;return o instanceof Error&&Array.isArray(o.actions)}e.isErrorWithActions=c;function a(l,o=Object.create(null)){const h=new Error(l);return o.actions&&(h.actions=o.actions),h}e.createErrorWithActions=a}),define(x[31],ee([0,1,15]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function r(F,N=0){return F[F.length-(1+N)]}e.tail=r;function D(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=D;function C(F,N,H=(O,z)=>O===z){if(F===N)return!0;if(!F||!N||F.length!==N.length)return!1;for(let O=0,z=F.length;O<z;O++)if(!H(F[O],N[O]))return!1;return!0}e.equals=C;function k(F,N,H){let O=0,z=F.length-1;for(;O<=z;){const te=(O+z)/2|0,ne=H(F[te],N);if(ne<0)O=te+1;else if(ne>0)z=te-1;else return te}return-(O+1)}e.binarySearch=k;function I(F,N){let H=0,O=F.length;if(O===0)return 0;for(;H<O;){const z=Math.floor((H+O)/2);N(F[z])?O=z:H=z+1}return H}e.findFirstInSorted=I;function d(F,N,H){if(F=F|0,F>=N.length)throw new TypeError("invalid index");let O=N[Math.floor(N.length*Math.random())],z=[],te=[],ne=[];for(let oe of N){const J=H(oe,O);J<0?z.push(oe):J>0?te.push(oe):ne.push(oe)}return F<z.length?d(F,z,H):F<z.length+ne.length?ne[0]:d(F-(z.length+ne.length),te,H)}e.quickSelect=d;function g(F,N){const H=[];let O;for(const z of F.slice(0).sort(N))!O||N(O[0],z)!==0?(O=[z],H.push(O)):O.push(z);return H}e.groupBy=g;function S(F,N,H){const O=[];function z(oe,J,ce){if(J===0&&ce.length===0)return;const le=O[O.length-1];le&&le.start+le.deleteCount===oe?(le.deleteCount+=J,le.toInsert.push(...ce)):O.push({start:oe,deleteCount:J,toInsert:ce})}let te=0,ne=0;for(;;){if(te===F.length){z(te,0,N.slice(ne));break}if(ne===N.length){z(te,F.length-te,[]);break}const oe=F[te],J=N[ne],ce=H(oe,J);ce===0?(te+=1,ne+=1):ce<0?(z(te,1,[]),te+=1):ce>0&&(z(te,0,[J]),ne+=1)}return O}e.sortedDiff=S;function E(F,N,H){const O=S(F,N,H),z=[],te=[];for(const ne of O)z.push(...F.slice(ne.start,ne.start+ne.deleteCount)),te.push(...ne.toInsert);return{removed:z,added:te}}e.delta=E;function w(F,N,H){if(H===0)return[];const O=F.slice(0,H).sort(N);return t(F,N,O,H,F.length),O}e.top=w;function v(F,N,H,O,z){return H===0?Promise.resolve([]):new Promise((te,ne)=>{(async()=>{const oe=F.length,J=F.slice(0,H).sort(N);for(let ce=H,le=Math.min(H+O,oe);ce<oe;ce=le,le=Math.min(le+O,oe)){if(ce>H&&await new Promise(ue=>setTimeout(ue)),z&&z.isCancellationRequested)throw(0,p.canceled)();t(F,N,J,ce,le)}return J})().then(te,ne)})}e.topAsync=v;function t(F,N,H,O,z){for(const te=H.length;O<z;O++){const ne=F[O];if(N(ne,H[te-1])<0){H.pop();const oe=I(H,J=>N(ne,J)<0);H.splice(oe,0,ne)}}}function f(F){return F.filter(N=>!!N)}e.coalesce=f;function y(F){let N=0;for(let H=0;H<F.length;H++)F[H]&&(F[N]=F[H],N+=1);F.length=N}e.coalesceInPlace=y;function b(F,N,H){F.splice(H,0,F.splice(N,1)[0])}e.move=b;function P(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=P;function c(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=c;function a(F,N=H=>H){const H=new Set;return F.filter(O=>{const z=N(O);return H.has(z)?!1:(H.add(z),!0)})}e.distinct=a;function l(F){const N=Object.create(null);return H=>{const O=F(H);return N[O]?!1:(N[O]=!0,!0)}}e.uniqueFilter=l;function o(F,N){const H=h(F,N);if(H!==-1)return F[H]}e.findLast=o;function h(F,N){for(let H=F.length-1;H>=0;H--){const O=F[H];if(N(O))return H}return-1}e.lastIndex=h;function n(F,N){return F.length>0?F[0]:N}e.firstOrDefault=n;function i(F,N,H=(O,z)=>O===z){let O=0;for(let z=0,te=Math.min(F.length,N.length);z<te&&H(F[z],N[z]);z++)O++;return O}e.commonPrefixLength=i;function s(F){return[].concat(...F)}e.flatten=s;function u(F,N){let H=typeof N=="number"?F:0;typeof N=="number"?H=F:(H=0,N=F);const O=[];if(H<=N)for(let z=H;z<N;z++)O.push(z);else for(let z=H;z>N;z--)O.push(z);return O}e.range=u;function m(F,N,H){return F.reduce((O,z)=>(O[N(z)]=H?H(z):z,O),Object.create(null))}e.index=m;function M(F,N){return F.push(N),()=>L(F,N)}e.insert=M;function L(F,N){const H=F.indexOf(N);if(H>-1)return F.splice(H,1),N}e.remove=L;function R(F,N,H){const O=F.slice(0,N),z=F.slice(N);return O.concat(H,z)}e.arrayInsert=R;function T(F,N){let H;if(typeof N=="number"){let O=N;H=()=>{const z=Math.sin(O++)*179426549;return z-Math.floor(z)}}else H=Math.random;for(let O=F.length-1;O>0;O-=1){const z=Math.floor(H()*(O+1)),te=F[O];F[O]=F[z],F[z]=te}}e.shuffle=T;function _(F,N){const H=F.indexOf(N);H>-1&&(F.splice(H,1),F.unshift(N))}e.pushToStart=_;function Q(F,N){const H=F.indexOf(N);H>-1&&(F.splice(H,1),F.push(N))}e.pushToEnd=Q;function se(F,N){return Array.isArray(F)?F.map(N):N(F)}e.mapArrayOrNot=se;function re(F){return Array.isArray(F)?F:[F]}e.asArray=re;function G(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=G;function X(F,N){for(const H of F){const O=N(H);if(O!==void 0)return O}}e.mapFind=X;function B(F,N,H){const O=Y(F,N),z=F.length,te=H.length;F.length=z+te;for(let ne=z-1;ne>=O;ne--)F[ne+te]=F[ne];for(let ne=0;ne<te;ne++)F[ne+O]=H[ne]}e.insertInto=B;function $(F,N,H,O){const z=Y(F,N),te=F.splice(z,H);return B(F,z,O),te}e.splice=$;function Y(F,N){return N<0?Math.max(N+F.length,0):Math.min(N,F.length)}function V(F,N){return(H,O)=>N(F(H),F(O))}e.compareBy=V;const q=(F,N)=>F-N;e.numberComparator=q;function Z(F,N){if(F.length===0)return;let H=F[0];for(let O=1;O<F.length;O++){const z=F[O];N(z,H)>0&&(H=z)}return H}e.findMaxBy=Z;function U(F,N){if(F.length===0)return;let H=F[0];for(let O=1;O<F.length;O++){const z=F[O];N(z,H)>=0&&(H=z)}return H}e.findLastMaxBy=U;function A(F,N){return Z(F,(H,O)=>-N(H,O))}e.findMinBy=A;class W{constructor(N){this.items=N,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(N){let H=this.firstIdx;for(;H<this.items.length&&N(this.items[H]);)H++;const O=H===this.firstIdx?null:this.items.slice(this.firstIdx,H);return this.firstIdx=H,O}takeFromEndWhile(N){let H=this.lastIdx;for(;H>=0&&N(this.items[H]);)H--;const O=H===this.lastIdx?null:this.items.slice(H+1,this.lastIdx+1);return this.lastIdx=H,O}peek(){return this.items[this.firstIdx]}dequeue(){const N=this.items[this.firstIdx];return this.firstIdx++,N}takeCount(N){const H=this.items.slice(this.firstIdx,this.firstIdx+N);return this.firstIdx+=N,H}}e.ArrayQueue=W}),define(x[42],ee([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function p(r){const D=this;let C=!1,k;return function(){return C||(C=!0,k=r.apply(D,arguments)),k}}e.once=p}),define(x[69],ee([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var p;(function(r){function D(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}r.is=D;const C=Object.freeze([]);function k(){return C}r.empty=k;function*I(l){yield l}r.single=I;function d(l){return l||C}r.from=d;function g(l){return!l||l[Symbol.iterator]().next().done===!0}r.isEmpty=g;function S(l){return l[Symbol.iterator]().next().value}r.first=S;function E(l,o){for(const h of l)if(o(h))return!0;return!1}r.some=E;function w(l,o){for(const h of l)if(o(h))return h}r.find=w;function*v(l,o){for(const h of l)o(h)&&(yield h)}r.filter=v;function*t(l,o){let h=0;for(const n of l)yield o(n,h++)}r.map=t;function*f(...l){for(const o of l)for(const h of o)yield h}r.concat=f;function*y(l){for(const o of l)for(const h of o)yield h}r.concatNested=y;function b(l,o,h){let n=h;for(const i of l)n=o(n,i);return n}r.reduce=b;function*P(l,o,h=l.length){for(o<0&&(o+=l.length),h<0?h+=l.length:h>l.length&&(h=l.length);o<h;o++)yield l[o]}r.slice=P;function c(l,o=Number.POSITIVE_INFINITY){const h=[];if(o===0)return[h,l];const n=l[Symbol.iterator]();for(let i=0;i<o;i++){const s=n.next();if(s.done)return[h,r.empty()];h.push(s.value)}return[h,{[Symbol.iterator](){return n}}]}r.consume=c;function a(l,o,h=(n,i)=>n===i){const n=l[Symbol.iterator](),i=o[Symbol.iterator]();for(;;){const s=n.next(),u=i.next();if(s.done!==u.done)return!1;if(s.done)return!0;if(!h(s.value,u.value))return!1}}r.equals=a})(p=e.Iterable||(e.Iterable={}))}),define(x[43],ee([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var p;(function(o){o[o.None=0]="None",o[o.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=2]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",o[o.InvalidUnicode=4]="InvalidUnicode",o[o.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",o[o.InvalidCharacter=6]="InvalidCharacter"})(p=e.ScanError||(e.ScanError={}));var r;(function(o){o[o.OpenBraceToken=1]="OpenBraceToken",o[o.CloseBraceToken=2]="CloseBraceToken",o[o.OpenBracketToken=3]="OpenBracketToken",o[o.CloseBracketToken=4]="CloseBracketToken",o[o.CommaToken=5]="CommaToken",o[o.ColonToken=6]="ColonToken",o[o.NullKeyword=7]="NullKeyword",o[o.TrueKeyword=8]="TrueKeyword",o[o.FalseKeyword=9]="FalseKeyword",o[o.StringLiteral=10]="StringLiteral",o[o.NumericLiteral=11]="NumericLiteral",o[o.LineCommentTrivia=12]="LineCommentTrivia",o[o.BlockCommentTrivia=13]="BlockCommentTrivia",o[o.LineBreakTrivia=14]="LineBreakTrivia",o[o.Trivia=15]="Trivia",o[o.Unknown=16]="Unknown",o[o.EOF=17]="EOF"})(r=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(o){o[o.InvalidSymbol=1]="InvalidSymbol",o[o.InvalidNumberFormat=2]="InvalidNumberFormat",o[o.PropertyNameExpected=3]="PropertyNameExpected",o[o.ValueExpected=4]="ValueExpected",o[o.ColonExpected=5]="ColonExpected",o[o.CommaExpected=6]="CommaExpected",o[o.CloseBraceExpected=7]="CloseBraceExpected",o[o.CloseBracketExpected=8]="CloseBracketExpected",o[o.EndOfFileExpected=9]="EndOfFileExpected",o[o.InvalidCommentToken=10]="InvalidCommentToken",o[o.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=12]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",o[o.InvalidUnicode=14]="InvalidUnicode",o[o.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",o[o.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(o){o.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function k(o,h=!1){let n=0,i=o.length,s="",u=0,m=16,M=0;function L(G){let X=0,B=0;for(;X<G;){const $=o.charCodeAt(n);if($>=48&&$<=57)B=B*16+$-48;else if($>=65&&$<=70)B=B*16+$-65+10;else if($>=97&&$<=102)B=B*16+$-97+10;else break;n++,X++}return X<G&&(B=-1),B}function R(G){n=G,s="",u=0,m=16,M=0}function T(){const G=n;if(o.charCodeAt(n)===48)n++;else for(n++;n<o.length&&g(o.charCodeAt(n));)n++;if(n<o.length&&o.charCodeAt(n)===46)if(n++,n<o.length&&g(o.charCodeAt(n)))for(n++;n<o.length&&g(o.charCodeAt(n));)n++;else return M=3,o.substring(G,n);let X=n;if(n<o.length&&(o.charCodeAt(n)===69||o.charCodeAt(n)===101))if(n++,(n<o.length&&o.charCodeAt(n)===43||o.charCodeAt(n)===45)&&n++,n<o.length&&g(o.charCodeAt(n))){for(n++;n<o.length&&g(o.charCodeAt(n));)n++;X=n}else M=3;return o.substring(G,X)}function _(){let G="",X=n;for(;;){if(n>=i){G+=o.substring(X,n),M=2;break}const B=o.charCodeAt(n);if(B===34){G+=o.substring(X,n),n++;break}if(B===92){if(G+=o.substring(X,n),n++,n>=i){M=2;break}switch(o.charCodeAt(n++)){case 34:G+='"';break;case 92:G+="\\";break;case 47:G+="/";break;case 98:G+="\b";break;case 102:G+="\f";break;case 110:G+=`
`;break;case 114:G+="\r";break;case 116:G+="	";break;case 117:{const Y=L(4);Y>=0?G+=String.fromCharCode(Y):M=4;break}default:M=5}X=n;continue}if(B>=0&&B<=31)if(d(B)){G+=o.substring(X,n),M=2;break}else M=6;n++}return G}function Q(){if(s="",M=0,u=n,n>=i)return u=i,m=17;let G=o.charCodeAt(n);if(I(G)){do n++,s+=String.fromCharCode(G),G=o.charCodeAt(n);while(I(G));return m=15}if(d(G))return n++,s+=String.fromCharCode(G),G===13&&o.charCodeAt(n)===10&&(n++,s+=`
`),m=14;switch(G){case 123:return n++,m=1;case 125:return n++,m=2;case 91:return n++,m=3;case 93:return n++,m=4;case 58:return n++,m=6;case 44:return n++,m=5;case 34:return n++,s=_(),m=10;case 47:{const X=n-1;if(o.charCodeAt(n+1)===47){for(n+=2;n<i&&!d(o.charCodeAt(n));)n++;return s=o.substring(X,n),m=12}if(o.charCodeAt(n+1)===42){n+=2;const B=i-1;let $=!1;for(;n<B;){if(o.charCodeAt(n)===42&&o.charCodeAt(n+1)===47){n+=2,$=!0;break}n++}return $||(n++,M=1),s=o.substring(X,n),m=13}return s+=String.fromCharCode(G),n++,m=16}case 45:if(s+=String.fromCharCode(G),n++,n===i||!g(o.charCodeAt(n)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=T(),m=11;default:for(;n<i&&se(G);)n++,G=o.charCodeAt(n);if(u!==n){switch(s=o.substring(u,n),s){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return s+=String.fromCharCode(G),n++,m=16}}function se(G){if(I(G)||d(G))return!1;switch(G){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let G;do G=Q();while(G>=12&&G<=15);return G}return{setPosition:R,getPosition:()=>n,scan:h?re:Q,getToken:()=>m,getTokenValue:()=>s,getTokenOffset:()=>u,getTokenLength:()=>n-u,getTokenError:()=>M}}e.createScanner=k;function I(o){return o===32||o===9||o===11||o===12||o===160||o===5760||o>=8192&&o<=8203||o===8239||o===8287||o===12288||o===65279}function d(o){return o===10||o===13||o===8232||o===8233}function g(o){return o>=48&&o<=57}var S;(function(o){o[o.nullCharacter=0]="nullCharacter",o[o.maxAsciiCharacter=127]="maxAsciiCharacter",o[o.lineFeed=10]="lineFeed",o[o.carriageReturn=13]="carriageReturn",o[o.lineSeparator=8232]="lineSeparator",o[o.paragraphSeparator=8233]="paragraphSeparator",o[o.nextLine=133]="nextLine",o[o.space=32]="space",o[o.nonBreakingSpace=160]="nonBreakingSpace",o[o.enQuad=8192]="enQuad",o[o.emQuad=8193]="emQuad",o[o.enSpace=8194]="enSpace",o[o.emSpace=8195]="emSpace",o[o.threePerEmSpace=8196]="threePerEmSpace",o[o.fourPerEmSpace=8197]="fourPerEmSpace",o[o.sixPerEmSpace=8198]="sixPerEmSpace",o[o.figureSpace=8199]="figureSpace",o[o.punctuationSpace=8200]="punctuationSpace",o[o.thinSpace=8201]="thinSpace",o[o.hairSpace=8202]="hairSpace",o[o.zeroWidthSpace=8203]="zeroWidthSpace",o[o.narrowNoBreakSpace=8239]="narrowNoBreakSpace",o[o.ideographicSpace=12288]="ideographicSpace",o[o.mathematicalSpace=8287]="mathematicalSpace",o[o.ogham=5760]="ogham",o[o._=95]="_",o[o.$=36]="$",o[o._0=48]="_0",o[o._1=49]="_1",o[o._2=50]="_2",o[o._3=51]="_3",o[o._4=52]="_4",o[o._5=53]="_5",o[o._6=54]="_6",o[o._7=55]="_7",o[o._8=56]="_8",o[o._9=57]="_9",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.ampersand=38]="ampersand",o[o.asterisk=42]="asterisk",o[o.at=64]="at",o[o.backslash=92]="backslash",o[o.bar=124]="bar",o[o.caret=94]="caret",o[o.closeBrace=125]="closeBrace",o[o.closeBracket=93]="closeBracket",o[o.closeParen=41]="closeParen",o[o.colon=58]="colon",o[o.comma=44]="comma",o[o.dot=46]="dot",o[o.doubleQuote=34]="doubleQuote",o[o.equals=61]="equals",o[o.exclamation=33]="exclamation",o[o.greaterThan=62]="greaterThan",o[o.lessThan=60]="lessThan",o[o.minus=45]="minus",o[o.openBrace=123]="openBrace",o[o.openBracket=91]="openBracket",o[o.openParen=40]="openParen",o[o.percent=37]="percent",o[o.plus=43]="plus",o[o.question=63]="question",o[o.semicolon=59]="semicolon",o[o.singleQuote=39]="singleQuote",o[o.slash=47]="slash",o[o.tilde=126]="tilde",o[o.backspace=8]="backspace",o[o.formFeed=12]="formFeed",o[o.byteOrderMark=65279]="byteOrderMark",o[o.tab=9]="tab",o[o.verticalTab=11]="verticalTab"})(S||(S={}));function E(o,h){const n=[],i=new Object;let s;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function M(L,R,T,_){u.value=L,u.offset=R,u.length=T,u.type=_,u.colonOffset=void 0,s=u}try{c(o,{onObjectBegin:(L,R)=>{if(h<=L)throw i;s=void 0,m=h>L,n.push("")},onObjectProperty:(L,R,T)=>{if(h<R||(M(L,R,T,"property"),n[n.length-1]=L,h<=R+T))throw i},onObjectEnd:(L,R)=>{if(h<=L)throw i;s=void 0,n.pop()},onArrayBegin:(L,R)=>{if(h<=L)throw i;s=void 0,n.push(0)},onArrayEnd:(L,R)=>{if(h<=L)throw i;s=void 0,n.pop()},onLiteralValue:(L,R,T)=>{if(h<R||(M(L,R,T,l(L)),h<=R+T))throw i},onSeparator:(L,R,T)=>{if(h<=R)throw i;if(L===":"&&s&&s.type==="property")s.colonOffset=R,m=!1,s=void 0;else if(L===","){const _=n[n.length-1];typeof _=="number"?n[n.length-1]=_+1:(m=!0,n[n.length-1]=""),s=void 0}}})}catch(L){if(L!==i)throw L}return{path:n,previousNode:s,isAtPropertyKey:m,matches:L=>{let R=0;for(let T=0;R<L.length&&T<n.length;T++)if(L[R]===n[T]||L[R]==="*")R++;else if(L[R]!=="**")return!1;return R===L.length}}}e.getLocation=E;function w(o,h=[],n=C.DEFAULT){let i=null,s=[];const u=[];function m(L){Array.isArray(s)?s.push(L):i!==null&&(s[i]=L)}return c(o,{onObjectBegin:()=>{const L={};m(L),u.push(s),s=L,i=null},onObjectProperty:L=>{i=L},onObjectEnd:()=>{s=u.pop()},onArrayBegin:()=>{const L=[];m(L),u.push(s),s=L,i=null},onArrayEnd:()=>{s=u.pop()},onLiteralValue:m,onError:(L,R,T)=>{h.push({error:L,offset:R,length:T})}},n),s[0]}e.parse=w;function v(o,h=[],n=C.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(L){i.type==="property"&&(i.length=L-i.offset,i=i.parent)}function u(L){return i.children.push(L),L}c(o,{onObjectBegin:L=>{i=u({type:"object",offset:L,length:-1,parent:i,children:[]})},onObjectProperty:(L,R,T)=>{i=u({type:"property",offset:R,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:L,offset:R,length:T,parent:i})},onObjectEnd:(L,R)=>{i.length=L+R-i.offset,i=i.parent,s(L+R)},onArrayBegin:(L,R)=>{i=u({type:"array",offset:L,length:-1,parent:i,children:[]})},onArrayEnd:(L,R)=>{i.length=L+R-i.offset,i=i.parent,s(L+R)},onLiteralValue:(L,R,T)=>{u({type:l(L),offset:R,length:T,parent:i,value:L}),s(R+T)},onSeparator:(L,R,T)=>{i.type==="property"&&(L===":"?i.colonOffset=R:L===","&&s(R))},onError:(L,R,T)=>{h.push({error:L,offset:R,length:T})}},n);const M=i.children[0];return M&&delete M.parent,M}e.parseTree=v;function t(o,h){if(!o)return;let n=o;for(let i of h)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let s=!1;for(const u of n.children)if(Array.isArray(u.children)&&u.children[0].value===i){n=u.children[1],s=!0;break}if(!s)return}else{const s=i;if(n.type!=="array"||s<0||!Array.isArray(n.children)||s>=n.children.length)return;n=n.children[s]}return n}e.findNodeAtLocation=t;function f(o){if(!o.parent||!o.parent.children)return[];const h=f(o.parent);if(o.parent.type==="property"){const n=o.parent.children[0].value;h.push(n)}else if(o.parent.type==="array"){const n=o.parent.children.indexOf(o);n!==-1&&h.push(n)}return h}e.getNodePath=f;function y(o){switch(o.type){case"array":return o.children.map(y);case"object":{const h=Object.create(null);for(let n of o.children){const i=n.children[1];i&&(h[n.children[0].value]=y(i))}return h}case"null":case"string":case"number":case"boolean":return o.value;default:return}}e.getNodeValue=y;function b(o,h,n=!1){return h>=o.offset&&h<o.offset+o.length||n&&h===o.offset+o.length}e.contains=b;function P(o,h,n=!1){if(b(o,h,n)){const i=o.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=h;s++){const u=P(i[s],h,n);if(u)return u}return o}}e.findNodeAtOffset=P;function c(o,h,n=C.DEFAULT){const i=k(o,!1);function s(W){return W?()=>W(i.getTokenOffset(),i.getTokenLength()):()=>!0}function u(W){return W?F=>W(F,i.getTokenOffset(),i.getTokenLength()):()=>!0}const m=s(h.onObjectBegin),M=u(h.onObjectProperty),L=s(h.onObjectEnd),R=s(h.onArrayBegin),T=s(h.onArrayEnd),_=u(h.onLiteralValue),Q=u(h.onSeparator),se=s(h.onComment),re=u(h.onError),G=n&&n.disallowComments,X=n&&n.allowTrailingComma;function B(){for(;;){const W=i.scan();switch(i.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:G||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(W){case 12:case 13:G?$(10):se();break;case 16:$(1);break;case 15:case 14:break;default:return W}}}function $(W,F=[],N=[]){if(re(W),F.length+N.length>0){let H=i.getToken();for(;H!==17;){if(F.indexOf(H)!==-1){B();break}else if(N.indexOf(H)!==-1)break;H=B()}}}function Y(W){const F=i.getTokenValue();return W?_(F):M(F),B(),!0}function V(){switch(i.getToken()){case 11:{let W=0;try{W=JSON.parse(i.getTokenValue()),typeof W!="number"&&($(2),W=0)}catch{$(2)}_(W);break}case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return B(),!0}function q(){return i.getToken()!==10?($(3,[],[2,5]),!1):(Y(!1),i.getToken()===6?(Q(":"),B(),A()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function Z(){m(),B();let W=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(W||$(4,[],[]),Q(","),B(),i.getToken()===2&&X)break}else W&&$(6,[],[]);q()||$(4,[],[2,5]),W=!0}return L(),i.getToken()!==2?$(7,[2],[]):B(),!0}function U(){R(),B();let W=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(W||$(4,[],[]),Q(","),B(),i.getToken()===4&&X)break}else W&&$(6,[],[]);A()||$(4,[],[4,5]),W=!0}return T(),i.getToken()!==4?$(8,[4],[]):B(),!0}function A(){switch(i.getToken()){case 3:return U();case 1:return Z();case 10:return Y(!0);default:return V()}}return B(),i.getToken()===17?n.allowEmptyContent?!0:($(4,[],[]),!1):A()?(i.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=c;function a(o,h){let n=k(o),i=[],s,u=0,m;do switch(m=n.getPosition(),s=n.scan(),s){case 12:case 13:case 17:u!==m&&i.push(o.substring(u,m)),h!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,h)),u=n.getPosition();break}while(s!==17);return i.join("")}e.stripComments=a;function l(o){switch(typeof o){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(o){if(Array.isArray(o))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(x[104],ee([0,1,43]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function r(g,S,E){let w,v,t,f,y;if(S){for(f=S.offset,y=f+S.length,t=f;t>0&&!d(g,t-1);)t--;let m=y;for(;m<g.length&&!d(g,m);)m++;v=g.substring(t,m),w=k(v,E)}else v=g,w=0,t=0,f=0,y=g.length;const b=I(E,g);let P=!1,c=0,a;E.insertSpaces?a=C(" ",E.tabSize||4):a="	";const l=(0,p.createScanner)(v,!1);let o=!1;function h(){return b+C(a,w+c)}function n(){let m=l.scan();for(P=!1;m===15||m===14;)P=P||m===14,m=l.scan();return o=m===16||l.getTokenError()!==0,m}const i=[];function s(m,M,L){!o&&M<y&&L>f&&g.substring(M,L)!==m&&i.push({offset:M,length:L-M,content:m})}let u=n();if(u!==17){const m=l.getTokenOffset()+t,M=C(a,w);s(M,t,m)}for(;u!==17;){let m=l.getTokenOffset()+l.getTokenLength()+t,M=n(),L="";for(;!P&&(M===12||M===13);){const T=l.getTokenOffset()+t;s(" ",m,T),m=l.getTokenOffset()+l.getTokenLength()+t,L=M===12?h():"",M=n()}if(M===2)u!==1&&(c--,L=h());else if(M===4)u!==3&&(c--,L=h());else{switch(u){case 3:case 1:c++,L=h();break;case 5:case 12:L=h();break;case 13:P?L=h():L=" ";break;case 6:L=" ";break;case 10:if(M===6){L="";break}case 7:case 8:case 9:case 11:case 2:case 4:M===12||M===13?L=" ":M!==5&&M!==17&&(o=!0);break;case 16:o=!0;break}P&&(M===12||M===13)&&(L=h())}const R=l.getTokenOffset()+t;s(L,m,R),u=M}return i}e.format=r;function D(g,S){const E=JSON.stringify(g,void 0,S.insertSpaces?S.tabSize||4:"	");return S.eol!==void 0?E.replace(/\r\n|\r|\n/g,S.eol):E}e.toFormattedString=D;function C(g,S){let E="";for(let w=0;w<S;w++)E+=g;return E}function k(g,S){let E=0,w=0;const v=S.tabSize||4;for(;E<g.length;){const t=g.charAt(E);if(t===" ")w++;else if(t==="	")w+=v;else break;E++}return Math.floor(w/v)}function I(g,S){for(let E=0;E<S.length;E++){const w=S.charAt(E);if(w==="\r")return E+1<S.length&&S.charAt(E+1)===`
`?`\r
`:"\r";if(w===`
`)return`
`}return g&&g.eol||`
`}e.getEOL=I;function d(g,S){return`\r
`.indexOf(g.charAt(S))!==-1}e.isEOL=d}),define(x[105],ee([0,1,43,104]),function(j,e,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(g,S,E){return C(g,S,void 0,E)}e.removeProperty=D;function C(g,S,E,w,v){const t=S.slice(),f=[],y=(0,p.parseTree)(g,f);let b,P;for(;t.length>0&&(P=t.pop(),b=(0,p.findNodeAtLocation)(y,t),b===void 0&&E!==void 0);)typeof P=="string"?E={[P]:E}:E=[E];if(b)if(b.type==="object"&&typeof P=="string"&&Array.isArray(b.children)){const c=(0,p.findNodeAtLocation)(b,[P]);if(c!==void 0)if(E===void 0){if(!c.parent)throw new Error("Malformed AST");const a=b.children.indexOf(c.parent);let l,o=c.parent.offset+c.parent.length;if(a>0){const h=b.children[a-1];l=h.offset+h.length}else l=b.offset+1,b.children.length>1&&(o=b.children[1].offset);return k(g,{offset:l,length:o-l,content:""},w)}else return k(g,{offset:c.offset,length:c.length,content:JSON.stringify(E)},w);else{if(E===void 0)return[];const a=`${JSON.stringify(P)}: ${JSON.stringify(E)}`,l=v?v(b.children.map(h=>h.children[0].value)):b.children.length;let o;if(l>0){const h=b.children[l-1];o={offset:h.offset+h.length,length:0,content:","+a}}else b.children.length===0?o={offset:b.offset+1,length:0,content:a}:o={offset:b.offset+1,length:0,content:a+","};return k(g,o,w)}}else if(b.type==="array"&&typeof P=="number"&&Array.isArray(b.children))if(E!==void 0){const c=`${JSON.stringify(E)}`;let a;if(b.children.length===0||P===0)a={offset:b.offset+1,length:0,content:b.children.length===0?c:c+","};else{const l=P===-1||P>b.children.length?b.children.length:P,o=b.children[l-1];a={offset:o.offset+o.length,length:0,content:","+c}}return k(g,a,w)}else{const c=P,a=b.children[c];let l;if(b.children.length===1)l={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===c){const o=b.children[c-1],h=o.offset+o.length,n=b.offset+b.length;l={offset:h,length:n-2-h,content:""}}else l={offset:a.offset,length:b.children[c+1].offset-a.offset,content:""};return k(g,l,w)}else throw new Error(`Can not add ${typeof P!="number"?"index":"property"} to parent of type ${b.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return k(g,{offset:y?y.offset:0,length:y?y.length:0,content:JSON.stringify(E)},w)}}e.setProperty=C;function k(g,S,E){let w=I(g,S),v=S.offset,t=S.offset+S.content.length;if(S.length===0||S.content.length===0){for(;v>0&&!(0,r.isEOL)(w,v-1);)v--;for(;t<w.length&&!(0,r.isEOL)(w,t);)t++}const f=(0,r.format)(w,{offset:v,length:t-v},E);for(let b=f.length-1;b>=0;b--){const P=f[b];w=I(w,P),v=Math.min(v,P.offset),t=Math.max(t,P.offset+P.length),t+=P.content.length-P.length}const y=g.length-(w.length-t)-v;return[{offset:v,length:y,content:w.substring(v,t)}]}e.withFormatting=k;function I(g,S){return g.substring(0,S.offset)+S.content+g.substring(S.offset+S.length)}e.applyEdit=I;function d(g,S){let E=S.slice(0).sort((v,t)=>{const f=v.offset-t.offset;return f===0?v.length-t.length:f}),w=g.length;for(let v=E.length-1;v>=0;v--){let t=E[v];if(t.offset+t.length<=w)g=I(g,t);else throw new Error("Overlapping edit");w=t.offset}return g}e.applyEdits=d}),define(x[78],ee([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=e.EVENT_KEY_CODE_MAP=e.ScanCode=e.KeyCode=void 0;var p;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.MAX_VALUE=126]="MAX_VALUE"})(p=e.KeyCode||(e.KeyCode={}));var r;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.None=0]="None",t[t.Hyper=1]="Hyper",t[t.Super=2]="Super",t[t.Fn=3]="Fn",t[t.FnLock=4]="FnLock",t[t.Suspend=5]="Suspend",t[t.Resume=6]="Resume",t[t.Turbo=7]="Turbo",t[t.Sleep=8]="Sleep",t[t.WakeUp=9]="WakeUp",t[t.KeyA=10]="KeyA",t[t.KeyB=11]="KeyB",t[t.KeyC=12]="KeyC",t[t.KeyD=13]="KeyD",t[t.KeyE=14]="KeyE",t[t.KeyF=15]="KeyF",t[t.KeyG=16]="KeyG",t[t.KeyH=17]="KeyH",t[t.KeyI=18]="KeyI",t[t.KeyJ=19]="KeyJ",t[t.KeyK=20]="KeyK",t[t.KeyL=21]="KeyL",t[t.KeyM=22]="KeyM",t[t.KeyN=23]="KeyN",t[t.KeyO=24]="KeyO",t[t.KeyP=25]="KeyP",t[t.KeyQ=26]="KeyQ",t[t.KeyR=27]="KeyR",t[t.KeyS=28]="KeyS",t[t.KeyT=29]="KeyT",t[t.KeyU=30]="KeyU",t[t.KeyV=31]="KeyV",t[t.KeyW=32]="KeyW",t[t.KeyX=33]="KeyX",t[t.KeyY=34]="KeyY",t[t.KeyZ=35]="KeyZ",t[t.Digit1=36]="Digit1",t[t.Digit2=37]="Digit2",t[t.Digit3=38]="Digit3",t[t.Digit4=39]="Digit4",t[t.Digit5=40]="Digit5",t[t.Digit6=41]="Digit6",t[t.Digit7=42]="Digit7",t[t.Digit8=43]="Digit8",t[t.Digit9=44]="Digit9",t[t.Digit0=45]="Digit0",t[t.Enter=46]="Enter",t[t.Escape=47]="Escape",t[t.Backspace=48]="Backspace",t[t.Tab=49]="Tab",t[t.Space=50]="Space",t[t.Minus=51]="Minus",t[t.Equal=52]="Equal",t[t.BracketLeft=53]="BracketLeft",t[t.BracketRight=54]="BracketRight",t[t.Backslash=55]="Backslash",t[t.IntlHash=56]="IntlHash",t[t.Semicolon=57]="Semicolon",t[t.Quote=58]="Quote",t[t.Backquote=59]="Backquote",t[t.Comma=60]="Comma",t[t.Period=61]="Period",t[t.Slash=62]="Slash",t[t.CapsLock=63]="CapsLock",t[t.F1=64]="F1",t[t.F2=65]="F2",t[t.F3=66]="F3",t[t.F4=67]="F4",t[t.F5=68]="F5",t[t.F6=69]="F6",t[t.F7=70]="F7",t[t.F8=71]="F8",t[t.F9=72]="F9",t[t.F10=73]="F10",t[t.F11=74]="F11",t[t.F12=75]="F12",t[t.PrintScreen=76]="PrintScreen",t[t.ScrollLock=77]="ScrollLock",t[t.Pause=78]="Pause",t[t.Insert=79]="Insert",t[t.Home=80]="Home",t[t.PageUp=81]="PageUp",t[t.Delete=82]="Delete",t[t.End=83]="End",t[t.PageDown=84]="PageDown",t[t.ArrowRight=85]="ArrowRight",t[t.ArrowLeft=86]="ArrowLeft",t[t.ArrowDown=87]="ArrowDown",t[t.ArrowUp=88]="ArrowUp",t[t.NumLock=89]="NumLock",t[t.NumpadDivide=90]="NumpadDivide",t[t.NumpadMultiply=91]="NumpadMultiply",t[t.NumpadSubtract=92]="NumpadSubtract",t[t.NumpadAdd=93]="NumpadAdd",t[t.NumpadEnter=94]="NumpadEnter",t[t.Numpad1=95]="Numpad1",t[t.Numpad2=96]="Numpad2",t[t.Numpad3=97]="Numpad3",t[t.Numpad4=98]="Numpad4",t[t.Numpad5=99]="Numpad5",t[t.Numpad6=100]="Numpad6",t[t.Numpad7=101]="Numpad7",t[t.Numpad8=102]="Numpad8",t[t.Numpad9=103]="Numpad9",t[t.Numpad0=104]="Numpad0",t[t.NumpadDecimal=105]="NumpadDecimal",t[t.IntlBackslash=106]="IntlBackslash",t[t.ContextMenu=107]="ContextMenu",t[t.Power=108]="Power",t[t.NumpadEqual=109]="NumpadEqual",t[t.F13=110]="F13",t[t.F14=111]="F14",t[t.F15=112]="F15",t[t.F16=113]="F16",t[t.F17=114]="F17",t[t.F18=115]="F18",t[t.F19=116]="F19",t[t.F20=117]="F20",t[t.F21=118]="F21",t[t.F22=119]="F22",t[t.F23=120]="F23",t[t.F24=121]="F24",t[t.Open=122]="Open",t[t.Help=123]="Help",t[t.Select=124]="Select",t[t.Again=125]="Again",t[t.Undo=126]="Undo",t[t.Cut=127]="Cut",t[t.Copy=128]="Copy",t[t.Paste=129]="Paste",t[t.Find=130]="Find",t[t.AudioVolumeMute=131]="AudioVolumeMute",t[t.AudioVolumeUp=132]="AudioVolumeUp",t[t.AudioVolumeDown=133]="AudioVolumeDown",t[t.NumpadComma=134]="NumpadComma",t[t.IntlRo=135]="IntlRo",t[t.KanaMode=136]="KanaMode",t[t.IntlYen=137]="IntlYen",t[t.Convert=138]="Convert",t[t.NonConvert=139]="NonConvert",t[t.Lang1=140]="Lang1",t[t.Lang2=141]="Lang2",t[t.Lang3=142]="Lang3",t[t.Lang4=143]="Lang4",t[t.Lang5=144]="Lang5",t[t.Abort=145]="Abort",t[t.Props=146]="Props",t[t.NumpadParenLeft=147]="NumpadParenLeft",t[t.NumpadParenRight=148]="NumpadParenRight",t[t.NumpadBackspace=149]="NumpadBackspace",t[t.NumpadMemoryStore=150]="NumpadMemoryStore",t[t.NumpadMemoryRecall=151]="NumpadMemoryRecall",t[t.NumpadMemoryClear=152]="NumpadMemoryClear",t[t.NumpadMemoryAdd=153]="NumpadMemoryAdd",t[t.NumpadMemorySubtract=154]="NumpadMemorySubtract",t[t.NumpadClear=155]="NumpadClear",t[t.NumpadClearEntry=156]="NumpadClearEntry",t[t.ControlLeft=157]="ControlLeft",t[t.ShiftLeft=158]="ShiftLeft",t[t.AltLeft=159]="AltLeft",t[t.MetaLeft=160]="MetaLeft",t[t.ControlRight=161]="ControlRight",t[t.ShiftRight=162]="ShiftRight",t[t.AltRight=163]="AltRight",t[t.MetaRight=164]="MetaRight",t[t.BrightnessUp=165]="BrightnessUp",t[t.BrightnessDown=166]="BrightnessDown",t[t.MediaPlay=167]="MediaPlay",t[t.MediaRecord=168]="MediaRecord",t[t.MediaFastForward=169]="MediaFastForward",t[t.MediaRewind=170]="MediaRewind",t[t.MediaTrackNext=171]="MediaTrackNext",t[t.MediaTrackPrevious=172]="MediaTrackPrevious",t[t.MediaStop=173]="MediaStop",t[t.Eject=174]="Eject",t[t.MediaPlayPause=175]="MediaPlayPause",t[t.MediaSelect=176]="MediaSelect",t[t.LaunchMail=177]="LaunchMail",t[t.LaunchApp2=178]="LaunchApp2",t[t.LaunchApp1=179]="LaunchApp1",t[t.SelectTask=180]="SelectTask",t[t.LaunchScreenSaver=181]="LaunchScreenSaver",t[t.BrowserSearch=182]="BrowserSearch",t[t.BrowserHome=183]="BrowserHome",t[t.BrowserBack=184]="BrowserBack",t[t.BrowserForward=185]="BrowserForward",t[t.BrowserStop=186]="BrowserStop",t[t.BrowserRefresh=187]="BrowserRefresh",t[t.BrowserFavorites=188]="BrowserFavorites",t[t.ZoomToggle=189]="ZoomToggle",t[t.MailReply=190]="MailReply",t[t.MailForward=191]="MailForward",t[t.MailSend=192]="MailSend",t[t.MAX_VALUE=193]="MAX_VALUE"})(r=e.ScanCode||(e.ScanCode={}));class D{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(f,y){this._keyCodeToStr[f]=y,this._strToKeyCode[y.toLowerCase()]=f}keyCodeToStr(f){return this._keyCodeToStr[f]}strToKeyCode(f){return this._strToKeyCode[f.toLowerCase()]||0}}const C=new D,k=new D,I=new D;e.EVENT_KEY_CODE_MAP=new Array(230),e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const d=[],g=Object.create(null),S=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:t=>S[t]||0,toEnum:t=>g[t]||0,toString:t=>d[t]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let t=0;t<=193;t++)e.IMMUTABLE_CODE_TO_KEY_CODE[t]=-1;for(let t=0;t<=126;t++)e.IMMUTABLE_KEY_CODE_TO_CODE[t]=-1;(function(){const t="",f=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[0,1,1,"Hyper",0,t,0,t,t,t],[0,1,2,"Super",0,t,0,t,t,t],[0,1,3,"Fn",0,t,0,t,t,t],[0,1,4,"FnLock",0,t,0,t,t,t],[0,1,5,"Suspend",0,t,0,t,t,t],[0,1,6,"Resume",0,t,0,t,t,t],[0,1,7,"Turbo",0,t,0,t,t,t],[0,1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[0,1,9,"WakeUp",0,t,0,t,t,t],[31,0,10,"KeyA",31,"A",65,"VK_A",t,t],[32,0,11,"KeyB",32,"B",66,"VK_B",t,t],[33,0,12,"KeyC",33,"C",67,"VK_C",t,t],[34,0,13,"KeyD",34,"D",68,"VK_D",t,t],[35,0,14,"KeyE",35,"E",69,"VK_E",t,t],[36,0,15,"KeyF",36,"F",70,"VK_F",t,t],[37,0,16,"KeyG",37,"G",71,"VK_G",t,t],[38,0,17,"KeyH",38,"H",72,"VK_H",t,t],[39,0,18,"KeyI",39,"I",73,"VK_I",t,t],[40,0,19,"KeyJ",40,"J",74,"VK_J",t,t],[41,0,20,"KeyK",41,"K",75,"VK_K",t,t],[42,0,21,"KeyL",42,"L",76,"VK_L",t,t],[43,0,22,"KeyM",43,"M",77,"VK_M",t,t],[44,0,23,"KeyN",44,"N",78,"VK_N",t,t],[45,0,24,"KeyO",45,"O",79,"VK_O",t,t],[46,0,25,"KeyP",46,"P",80,"VK_P",t,t],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[48,0,27,"KeyR",48,"R",82,"VK_R",t,t],[49,0,28,"KeyS",49,"S",83,"VK_S",t,t],[50,0,29,"KeyT",50,"T",84,"VK_T",t,t],[51,0,30,"KeyU",51,"U",85,"VK_U",t,t],[52,0,31,"KeyV",52,"V",86,"VK_V",t,t],[53,0,32,"KeyW",53,"W",87,"VK_W",t,t],[54,0,33,"KeyX",54,"X",88,"VK_X",t,t],[55,0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[22,0,36,"Digit1",22,"1",49,"VK_1",t,t],[23,0,37,"Digit2",23,"2",50,"VK_2",t,t],[24,0,38,"Digit3",24,"3",51,"VK_3",t,t],[25,0,39,"Digit4",25,"4",52,"VK_4",t,t],[26,0,40,"Digit5",26,"5",53,"VK_5",t,t],[27,0,41,"Digit6",27,"6",54,"VK_6",t,t],[28,0,42,"Digit7",28,"7",55,"VK_7",t,t],[29,0,43,"Digit8",29,"8",56,"VK_8",t,t],[30,0,44,"Digit9",30,"9",57,"VK_9",t,t],[21,0,45,"Digit0",21,"0",48,"VK_0",t,t],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[10,1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,t,0,t,t,t],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[59,1,64,"F1",59,"F1",112,"VK_F1",t,t],[60,1,65,"F2",60,"F2",113,"VK_F2",t,t],[61,1,66,"F3",61,"F3",114,"VK_F3",t,t],[62,1,67,"F4",62,"F4",115,"VK_F4",t,t],[63,1,68,"F5",63,"F5",116,"VK_F5",t,t],[64,1,69,"F6",64,"F6",117,"VK_F6",t,t],[65,1,70,"F7",65,"F7",118,"VK_F7",t,t],[66,1,71,"F8",66,"F8",119,"VK_F8",t,t],[67,1,72,"F9",67,"F9",120,"VK_F9",t,t],[68,1,73,"F10",68,"F10",121,"VK_F10",t,t],[69,1,74,"F11",69,"F11",122,"VK_F11",t,t],[70,1,75,"F12",70,"F12",123,"VK_F12",t,t],[0,1,76,"PrintScreen",0,t,0,t,t,t],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",t,t],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[14,1,80,"Home",14,"Home",36,"VK_HOME",t,t],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[13,1,83,"End",13,"End",35,"VK_END",t,t],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",t,t],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",t,t],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",t,t],[3,1,94,"NumpadEnter",3,t,0,t,t,t],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",t,t],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",t,t],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",t,t],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",t,t],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",t,t],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",t,t],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",t,t],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",t,t],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",t,t],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",t,t],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",t,t],[58,1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[0,1,108,"Power",0,t,0,t,t,t],[0,1,109,"NumpadEqual",0,t,0,t,t,t],[71,1,110,"F13",71,"F13",124,"VK_F13",t,t],[72,1,111,"F14",72,"F14",125,"VK_F14",t,t],[73,1,112,"F15",73,"F15",126,"VK_F15",t,t],[74,1,113,"F16",74,"F16",127,"VK_F16",t,t],[75,1,114,"F17",75,"F17",128,"VK_F17",t,t],[76,1,115,"F18",76,"F18",129,"VK_F18",t,t],[77,1,116,"F19",77,"F19",130,"VK_F19",t,t],[0,1,117,"F20",0,t,0,"VK_F20",t,t],[0,1,118,"F21",0,t,0,"VK_F21",t,t],[0,1,119,"F22",0,t,0,"VK_F22",t,t],[0,1,120,"F23",0,t,0,"VK_F23",t,t],[0,1,121,"F24",0,t,0,"VK_F24",t,t],[0,1,122,"Open",0,t,0,t,t,t],[0,1,123,"Help",0,t,0,t,t,t],[0,1,124,"Select",0,t,0,t,t,t],[0,1,125,"Again",0,t,0,t,t,t],[0,1,126,"Undo",0,t,0,t,t,t],[0,1,127,"Cut",0,t,0,t,t,t],[0,1,128,"Copy",0,t,0,t,t,t],[0,1,129,"Paste",0,t,0,t,t,t],[0,1,130,"Find",0,t,0,t,t,t],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",t,t],[0,1,136,"KanaMode",0,t,0,t,t,t],[0,0,137,"IntlYen",0,t,0,t,t,t],[0,1,138,"Convert",0,t,0,t,t,t],[0,1,139,"NonConvert",0,t,0,t,t,t],[0,1,140,"Lang1",0,t,0,t,t,t],[0,1,141,"Lang2",0,t,0,t,t,t],[0,1,142,"Lang3",0,t,0,t,t,t],[0,1,143,"Lang4",0,t,0,t,t,t],[0,1,144,"Lang5",0,t,0,t,t,t],[0,1,145,"Abort",0,t,0,t,t,t],[0,1,146,"Props",0,t,0,t,t,t],[0,1,147,"NumpadParenLeft",0,t,0,t,t,t],[0,1,148,"NumpadParenRight",0,t,0,t,t,t],[0,1,149,"NumpadBackspace",0,t,0,t,t,t],[0,1,150,"NumpadMemoryStore",0,t,0,t,t,t],[0,1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[0,1,152,"NumpadMemoryClear",0,t,0,t,t,t],[0,1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[0,1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[0,1,155,"NumpadClear",0,t,0,t,t,t],[0,1,156,"NumpadClearEntry",0,t,0,t,t,t],[5,1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[4,1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[6,1,0,t,6,"Alt",18,"VK_MENU",t,t],[57,1,0,t,57,"Meta",0,"VK_COMMAND",t,t],[5,1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[4,1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[6,1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[57,1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[5,1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[4,1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[6,1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[57,1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[0,1,165,"BrightnessUp",0,t,0,t,t,t],[0,1,166,"BrightnessDown",0,t,0,t,t,t],[0,1,167,"MediaPlay",0,t,0,t,t,t],[0,1,168,"MediaRecord",0,t,0,t,t,t],[0,1,169,"MediaFastForward",0,t,0,t,t,t],[0,1,170,"MediaRewind",0,t,0,t,t,t],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",t,t],[0,1,174,"Eject",0,t,0,t,t,t],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[0,1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[0,1,180,"SelectTask",0,t,0,t,t,t],[0,1,181,"LaunchScreenSaver",0,t,0,t,t,t],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[0,1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[0,1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[0,1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[0,1,189,"ZoomToggle",0,t,0,t,t,t],[0,1,190,"MailReply",0,t,0,t,t,t],[0,1,191,"MailForward",0,t,0,t,t,t],[0,1,192,"MailSend",0,t,0,t,t,t],[109,1,0,t,109,"KeyInComposition",229,t,t,t],[111,1,0,t,111,"ABNT_C2",194,"VK_ABNT_C2",t,t],[91,1,0,t,91,"OEM_8",223,"VK_OEM_8",t,t],[0,1,0,t,0,t,0,"VK_CLEAR",t,t],[0,1,0,t,0,t,0,"VK_KANA",t,t],[0,1,0,t,0,t,0,"VK_HANGUL",t,t],[0,1,0,t,0,t,0,"VK_JUNJA",t,t],[0,1,0,t,0,t,0,"VK_FINAL",t,t],[0,1,0,t,0,t,0,"VK_HANJA",t,t],[0,1,0,t,0,t,0,"VK_KANJI",t,t],[0,1,0,t,0,t,0,"VK_CONVERT",t,t],[0,1,0,t,0,t,0,"VK_NONCONVERT",t,t],[0,1,0,t,0,t,0,"VK_ACCEPT",t,t],[0,1,0,t,0,t,0,"VK_MODECHANGE",t,t],[0,1,0,t,0,t,0,"VK_SELECT",t,t],[0,1,0,t,0,t,0,"VK_PRINT",t,t],[0,1,0,t,0,t,0,"VK_EXECUTE",t,t],[0,1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[0,1,0,t,0,t,0,"VK_HELP",t,t],[0,1,0,t,0,t,0,"VK_APPS",t,t],[0,1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[0,1,0,t,0,t,0,"VK_PACKET",t,t],[0,1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_ATTN",t,t],[0,1,0,t,0,t,0,"VK_CRSEL",t,t],[0,1,0,t,0,t,0,"VK_EXSEL",t,t],[0,1,0,t,0,t,0,"VK_EREOF",t,t],[0,1,0,t,0,t,0,"VK_PLAY",t,t],[0,1,0,t,0,t,0,"VK_ZOOM",t,t],[0,1,0,t,0,t,0,"VK_NONAME",t,t],[0,1,0,t,0,t,0,"VK_PA1",t,t],[0,1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]];let y=[],b=[];for(const P of f){const[c,a,l,o,h,n,i,s,u,m]=P;if(b[l]||(b[l]=!0,d[l]=o,g[o]=l,S[o.toLowerCase()]=l,a&&(e.IMMUTABLE_CODE_TO_KEY_CODE[l]=h,h!==0&&h!==3&&h!==5&&h!==4&&h!==6&&h!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[h]=l))),!y[h]){if(y[h]=!0,!n)throw new Error(`String representation missing for key code ${h} around scan code ${o}`);C.define(h,n),k.define(h,u||n),I.define(h,m||u||n)}i&&(e.EVENT_KEY_CODE_MAP[i]=h),s&&(e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[s]=h)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var E;(function(t){function f(l){return C.keyCodeToStr(l)}t.toString=f;function y(l){return C.strToKeyCode(l)}t.fromString=y;function b(l){return k.keyCodeToStr(l)}t.toUserSettingsUS=b;function P(l){return I.keyCodeToStr(l)}t.toUserSettingsGeneral=P;function c(l){return k.strToKeyCode(l)||I.strToKeyCode(l)}t.fromUserSettings=c;function a(l){if(l>=93&&l<=108)return null;switch(l){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return C.keyCodeToStr(l)}t.toElectronAccelerator=a})(E=e.KeyCodeUtils||(e.KeyCodeUtils={}));var w;(function(t){t[t.CtrlCmd=2048]="CtrlCmd",t[t.Shift=1024]="Shift",t[t.Alt=512]="Alt",t[t.WinCtrl=256]="WinCtrl"})(w=e.KeyMod||(e.KeyMod={}));function v(t,f){const y=(f&65535)<<16>>>0;return(t|y)>>>0}e.KeyChord=v}),define(x[59],ee([0,1,15]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ScanCodeBinding=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=void 0;var r;(function(E){E[E.CtrlCmd=2048]="CtrlCmd",E[E.Shift=1024]="Shift",E[E.Alt=512]="Alt",E[E.WinCtrl=256]="WinCtrl",E[E.KeyCode=255]="KeyCode"})(r||(r={}));function D(E,w){if(E===0)return null;const v=(E&65535)>>>0,t=(E&4294901760)>>>16;return t!==0?new I([C(v,w),C(t,w)]):new I([C(v,w)])}e.createKeybinding=D;function C(E,w){const v=!!(E&2048),t=!!(E&256),f=w===2?t:v,y=!!(E&1024),b=!!(E&512),P=w===2?v:t,c=E&255;return new k(f,y,b,P,c)}e.createSimpleKeybinding=C;class k{constructor(w,v,t,f,y){this.ctrlKey=w,this.shiftKey=v,this.altKey=t,this.metaKey=f,this.keyCode=y}equals(w){return this.ctrlKey===w.ctrlKey&&this.shiftKey===w.shiftKey&&this.altKey===w.altKey&&this.metaKey===w.metaKey&&this.keyCode===w.keyCode}getHashCode(){const w=this.ctrlKey?"1":"0",v=this.shiftKey?"1":"0",t=this.altKey?"1":"0",f=this.metaKey?"1":"0";return`${w}${v}${t}${f}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new I([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=k;class I{constructor(w){if(w.length===0)throw(0,p.illegalArgument)("parts");this.parts=w}getHashCode(){let w="";for(let v=0,t=this.parts.length;v<t;v++)v!==0&&(w+=";"),w+=this.parts[v].getHashCode();return w}equals(w){if(w===null||this.parts.length!==w.parts.length)return!1;for(let v=0;v<this.parts.length;v++)if(!this.parts[v].equals(w.parts[v]))return!1;return!0}}e.ChordKeybinding=I;class d{constructor(w,v,t,f,y){this.ctrlKey=w,this.shiftKey=v,this.altKey=t,this.metaKey=f,this.scanCode=y}equals(w){return this.ctrlKey===w.ctrlKey&&this.shiftKey===w.shiftKey&&this.altKey===w.altKey&&this.metaKey===w.metaKey&&this.scanCode===w.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=d;class g{constructor(w,v,t,f,y,b){this.ctrlKey=w,this.shiftKey=v,this.altKey=t,this.metaKey=f,this.keyLabel=y,this.keyAriaLabel=b}}e.ResolvedKeybindingPart=g;class S{}e.ResolvedKeybinding=S}),define(x[106],ee([0,1,78,59]),function(j,e,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class D{static _readModifiers(k){k=k.toLowerCase().trim();let I=!1,d=!1,g=!1,S=!1,E;do E=!1,/^ctrl(\+|\-)/.test(k)&&(I=!0,k=k.substr("ctrl-".length),E=!0),/^shift(\+|\-)/.test(k)&&(d=!0,k=k.substr("shift-".length),E=!0),/^alt(\+|\-)/.test(k)&&(g=!0,k=k.substr("alt-".length),E=!0),/^meta(\+|\-)/.test(k)&&(S=!0,k=k.substr("meta-".length),E=!0),/^win(\+|\-)/.test(k)&&(S=!0,k=k.substr("win-".length),E=!0),/^cmd(\+|\-)/.test(k)&&(S=!0,k=k.substr("cmd-".length),E=!0);while(E);let w;const v=k.indexOf(" ");return v>0?(w=k.substring(0,v),k=k.substring(v)):(w=k,k=""),{remains:k,ctrl:I,shift:d,alt:g,meta:S,key:w}}static parseSimpleKeybinding(k){const I=this._readModifiers(k),d=p.KeyCodeUtils.fromUserSettings(I.key);return[new r.SimpleKeybinding(I.ctrl,I.shift,I.alt,I.meta,d),I.remains]}static parseKeybinding(k,I){if(!k)return null;const d=[];let g;do[g,k]=this.parseSimpleKeybinding(k),d.push(g);while(k.length>0);return new r.ChordKeybinding(d)}static parseSimpleUserBinding(k){const I=this._readModifiers(k),d=I.key.match(/^\[([^\]]+)\]$/);if(d){const S=d[1],E=p.ScanCodeUtils.lowerCaseToEnum(S);return[new r.ScanCodeBinding(I.ctrl,I.shift,I.alt,I.meta,E),I.remains]}const g=p.KeyCodeUtils.fromUserSettings(I.key);return[new r.SimpleKeybinding(I.ctrl,I.shift,I.alt,I.meta,g),I.remains]}static parseUserBinding(k){if(!k)return[];const I=[];let d;for(;k.length>0;)[d,k]=this.parseSimpleUserBinding(k),I.push(d);return I}}e.KeybindingParser=D}),define(x[2],ee([0,1,42,69]),function(j,e,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let C=null;function k(i){C=i}if(e.setDisposableTracker=k,D){const i="__is_disposable_tracked__";k(new class{trackDisposable(s){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[i]||console.log(u)},3e3)}setParent(s,u){if(s&&s!==P.None)try{s[i]=!0}catch{}}markAsDisposed(s){if(s&&s!==P.None)try{s[i]=!0}catch{}}markAsSingleton(s){}})}function I(i){return C?.trackDisposable(i),i}function d(i){C?.markAsDisposed(i)}function g(i,s){C?.setParent(i,s)}function S(i,s){if(!!C)for(const u of i)C.setParent(u,s)}function E(i){return C?.markAsSingleton(i),i}e.markAsSingleton=E;class w extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=w;function v(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=v;function t(i){if(r.Iterable.is(i)){let s=[];for(const u of i)if(u)try{u.dispose()}catch(m){s.push(m)}if(s.length===1)throw s[0];if(s.length>1)throw new w(s);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=t;function f(...i){const s=y(()=>t(i));return S(i,s),s}e.combinedDisposable=f;function y(i){const s=I({dispose:(0,p.once)(()=>{d(s),i()})});return s}e.toDisposable=y;class b{constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(d(this),this._isDisposed=!0,this.clear())}clear(){try{t(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return g(s,this),this._isDisposed?b.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=b,b.DISABLE_DISPOSED_WARNING=!1;class P{constructor(){this._store=new b,I(this),g(this._store,this)}dispose(){d(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=P,P.None=Object.freeze({dispose(){}});class c{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&g(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,d(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&g(s,null),s}}e.MutableDisposable=c;class a{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=a;class l{constructor(){this.references=new Map}acquire(s,...u){let m=this.references.get(s);m||(m={counter:0,object:this.createReferencedObject(s,...u)},this.references.set(s,m));const{object:M}=m,L=(0,p.once)(()=>{--m.counter==0&&(this.destroyReferencedObject(s,m.object),this.references.delete(s))});return m.counter++,{object:M,dispose:L}}}e.ReferenceCollection=l;class o{constructor(s){this.referenceCollection=s}async acquire(s,...u){const m=this.referenceCollection.acquire(s,...u);try{return{object:await m.object,dispose:()=>m.dispose()}}catch(M){throw m.dispose(),M}}}e.AsyncReferenceCollection=o;class h{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=h;function n(i){const s=new b;try{i(s)}finally{s.dispose()}}e.disposeOnReturn=n}),define(x[107],ee([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class p{constructor(C){this.element=C,this.next=p.Undefined,this.prev=p.Undefined}}p.Undefined=new p(void 0);class r{constructor(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===p.Undefined}clear(){let C=this._first;for(;C!==p.Undefined;){const k=C.next;C.prev=p.Undefined,C.next=p.Undefined,C=k}this._first=p.Undefined,this._last=p.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,k){const I=new p(C);if(this._first===p.Undefined)this._first=I,this._last=I;else if(k){const g=this._last;this._last=I,I.prev=g,g.next=I}else{const g=this._first;this._first=I,I.next=g,g.prev=I}this._size+=1;let d=!1;return()=>{d||(d=!0,this._remove(I))}}shift(){if(this._first!==p.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==p.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==p.Undefined&&C.next!==p.Undefined){const k=C.prev;k.next=C.next,C.next.prev=k}else C.prev===p.Undefined&&C.next===p.Undefined?(this._first=p.Undefined,this._last=p.Undefined):C.next===p.Undefined?(this._last=this._last.prev,this._last.next=p.Undefined):C.prev===p.Undefined&&(this._first=this._first.next,this._first.prev=p.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==p.Undefined;)yield C.element,C=C.next}}e.LinkedList=r}),function(){function j(D){const C=[];typeof D=="number"&&C.push("code/timeOrigin",D);function k(d){C.push(d,Date.now())}function I(){const d=[];for(let g=0;g<C.length;g+=2)d.push({name:C[g],startTime:C[g+1]});return d}return{mark:k,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?j():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const k of performance.getEntriesByType("mark"))C.push({name:k.name,startTime:Math.round(D+k.startTime)});return C}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return j(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),j()}function p(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var r;typeof global=="object"?r=global:typeof self=="object"?r=self:r={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(r)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(r):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),r.perf=p(r))}(),define(x[3],ee([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const p="en";let r=!1,D=!1,C=!1,k=!1,I=!1,d=!1,g=!1,S=!1,E,w=p,v,t;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?f=e.globals.vscode.process:typeof process!="undefined"&&(f=process);const y=typeof f?.versions?.electron=="string",b=y&&f?.type==="renderer";if(e.isElectronSandboxed=b&&f?.sandboxed,typeof navigator=="object"&&!b)t=navigator.userAgent,r=t.indexOf("Windows")>=0,D=t.indexOf("Macintosh")>=0,S=(t.indexOf("Macintosh")>=0||t.indexOf("iPad")>=0||t.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=t.indexOf("Linux")>=0,d=!0,E=navigator.language,w=E;else if(typeof f=="object"){r=f.platform==="win32",D=f.platform==="darwin",C=f.platform==="linux",k=C&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,g=y,E=p,w=p;const s=f.env.VSCODE_NLS_CONFIG;if(s)try{const u=JSON.parse(s),m=u.availableLanguages["*"];E=u.locale,w=m||p,v=u._translationsConfigFile}catch{}I=!0}else console.error("Unable to resolve platform.");var P;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(P=e.Platform||(e.Platform={}));function c(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=c;let a=0;D?a=1:r?a=3:C&&(a=2),e.isWindows=r,e.isMacintosh=D,e.isLinux=C,e.isLinuxSnap=k,e.isNative=I,e.isElectron=g,e.isWeb=d,e.isIOS=S,e.platform=a,e.userAgent=t,e.language=w;var l;(function(s){function u(){return e.language}s.value=u;function m(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=m;function M(){return e.language==="en"}s.isDefault=M})(l=e.Language||(e.Language={})),e.locale=E,e.translationsConfigFile=v,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let s=[];e.globals.addEventListener("message",m=>{if(m.data&&m.data.vscodeScheduleAsyncWork)for(let M=0,L=s.length;M<L;M++){const R=s[M];if(R.id===m.data.vscodeScheduleAsyncWork){s.splice(M,1),R.callback();return}}});let u=0;return m=>{const M=++u;s.push({id:M,callback:m}),e.globals.postMessage({vscodeScheduleAsyncWork:M},"*")}}return s=>setTimeout(s)})();var o;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||S?2:r?1:3;let h=!0,n=!1;function i(){if(!n){n=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,h=new Uint16Array(s.buffer)[0]===(2<<8)+1}return h}e.isLittleEndian=i}),define(x[34],ee([0,1,3]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let r;if(typeof p.globals.vscode!="undefined"&&typeof p.globals.vscode.process!="undefined"){const D=p.globals.vscode.process;r={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process!="undefined"?r={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:r={get platform(){return p.isWindows?"win32":p.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=r.cwd,e.env=r.env,e.platform=r.platform,e.arch=r.arch}),define(x[8],ee([0,1,34]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const r=65,D=97,C=90,k=122,I=46,d=47,g=92,S=58,E=63;class w extends Error{constructor(a,l,o){let h;typeof l=="string"&&l.indexOf("not ")===0?(h="must not be",l=l.replace(/^not /,"")):h="must be";const n=a.indexOf(".")!==-1?"property":"argument";let i=`The "${a}" ${n} ${h} of type ${l}`;i+=`. Received type ${typeof o}`;super(i);this.code="ERR_INVALID_ARG_TYPE"}}function v(c,a){if(typeof c!="string")throw new w(a,"string",c)}function t(c){return c===d||c===g}function f(c){return c===d}function y(c){return c>=r&&c<=C||c>=D&&c<=k}function b(c,a,l,o){let h="",n=0,i=-1,s=0,u=0;for(let m=0;m<=c.length;++m){if(m<c.length)u=c.charCodeAt(m);else{if(o(u))break;u=d}if(o(u)){if(!(i===m-1||s===1))if(s===2){if(h.length<2||n!==2||h.charCodeAt(h.length-1)!==I||h.charCodeAt(h.length-2)!==I){if(h.length>2){const M=h.lastIndexOf(l);M===-1?(h="",n=0):(h=h.slice(0,M),n=h.length-1-h.lastIndexOf(l)),i=m,s=0;continue}else if(h.length!==0){h="",n=0,i=m,s=0;continue}}a&&(h+=h.length>0?`${l}..`:"..",n=2)}else h.length>0?h+=`${l}${c.slice(i+1,m)}`:h=c.slice(i+1,m),n=m-i-1;i=m,s=0}else u===I&&s!==-1?++s:s=-1}return h}function P(c,a){if(a===null||typeof a!="object")throw new w("pathObject","Object",a);const l=a.dir||a.root,o=a.base||`${a.name||""}${a.ext||""}`;return l?l===a.root?`${l}${o}`:`${l}${c}${o}`:o}e.win32={resolve(...c){let a="",l="",o=!1;for(let h=c.length-1;h>=-1;h--){let n;if(h>=0){if(n=c[h],v(n,"path"),n.length===0)continue}else a.length===0?n=p.cwd():(n=p.env[`=${a}`]||p.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==a.toLowerCase()&&n.charCodeAt(2)===g)&&(n=`${a}\\`));const i=n.length;let s=0,u="",m=!1;const M=n.charCodeAt(0);if(i===1)t(M)&&(s=1,m=!0);else if(t(M))if(m=!0,t(n.charCodeAt(1))){let L=2,R=L;for(;L<i&&!t(n.charCodeAt(L));)L++;if(L<i&&L!==R){const T=n.slice(R,L);for(R=L;L<i&&t(n.charCodeAt(L));)L++;if(L<i&&L!==R){for(R=L;L<i&&!t(n.charCodeAt(L));)L++;(L===i||L!==R)&&(u=`\\\\${T}\\${n.slice(R,L)}`,s=L)}}}else s=1;else y(M)&&n.charCodeAt(1)===S&&(u=n.slice(0,2),s=2,i>2&&t(n.charCodeAt(2))&&(m=!0,s=3));if(u.length>0)if(a.length>0){if(u.toLowerCase()!==a.toLowerCase())continue}else a=u;if(o){if(a.length>0)break}else if(l=`${n.slice(s)}\\${l}`,o=m,m&&a.length>0)break}return l=b(l,!o,"\\",t),o?`${a}\\${l}`:`${a}${l}`||"."},normalize(c){v(c,"path");const a=c.length;if(a===0)return".";let l=0,o,h=!1;const n=c.charCodeAt(0);if(a===1)return f(n)?"\\":c;if(t(n))if(h=!0,t(c.charCodeAt(1))){let s=2,u=s;for(;s<a&&!t(c.charCodeAt(s));)s++;if(s<a&&s!==u){const m=c.slice(u,s);for(u=s;s<a&&t(c.charCodeAt(s));)s++;if(s<a&&s!==u){for(u=s;s<a&&!t(c.charCodeAt(s));)s++;if(s===a)return`\\\\${m}\\${c.slice(u)}\\`;s!==u&&(o=`\\\\${m}\\${c.slice(u,s)}`,l=s)}}}else l=1;else y(n)&&c.charCodeAt(1)===S&&(o=c.slice(0,2),l=2,a>2&&t(c.charCodeAt(2))&&(h=!0,l=3));let i=l<a?b(c.slice(l),!h,"\\",t):"";return i.length===0&&!h&&(i="."),i.length>0&&t(c.charCodeAt(a-1))&&(i+="\\"),o===void 0?h?`\\${i}`:i:h?`${o}\\${i}`:`${o}${i}`},isAbsolute(c){v(c,"path");const a=c.length;if(a===0)return!1;const l=c.charCodeAt(0);return t(l)||a>2&&y(l)&&c.charCodeAt(1)===S&&t(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let a,l;for(let n=0;n<c.length;++n){const i=c[n];v(i,"path"),i.length>0&&(a===void 0?a=l=i:a+=`\\${i}`)}if(a===void 0)return".";let o=!0,h=0;if(typeof l=="string"&&t(l.charCodeAt(0))){++h;const n=l.length;n>1&&t(l.charCodeAt(1))&&(++h,n>2&&(t(l.charCodeAt(2))?++h:o=!1))}if(o){for(;h<a.length&&t(a.charCodeAt(h));)h++;h>=2&&(a=`\\${a.slice(h)}`)}return e.win32.normalize(a)},relative(c,a){if(v(c,"from"),v(a,"to"),c===a)return"";const l=e.win32.resolve(c),o=e.win32.resolve(a);if(l===o||(c=l.toLowerCase(),a=o.toLowerCase(),c===a))return"";let h=0;for(;h<c.length&&c.charCodeAt(h)===g;)h++;let n=c.length;for(;n-1>h&&c.charCodeAt(n-1)===g;)n--;const i=n-h;let s=0;for(;s<a.length&&a.charCodeAt(s)===g;)s++;let u=a.length;for(;u-1>s&&a.charCodeAt(u-1)===g;)u--;const m=u-s,M=i<m?i:m;let L=-1,R=0;for(;R<M;R++){const _=c.charCodeAt(h+R);if(_!==a.charCodeAt(s+R))break;_===g&&(L=R)}if(R!==M){if(L===-1)return o}else{if(m>M){if(a.charCodeAt(s+R)===g)return o.slice(s+R+1);if(R===2)return o.slice(s+R)}i>M&&(c.charCodeAt(h+R)===g?L=R:R===2&&(L=3)),L===-1&&(L=0)}let T="";for(R=h+L+1;R<=n;++R)(R===n||c.charCodeAt(R)===g)&&(T+=T.length===0?"..":"\\..");return s+=L,T.length>0?`${T}${o.slice(s,u)}`:(o.charCodeAt(s)===g&&++s,o.slice(s,u))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const a=e.win32.resolve(c);if(a.length<=2)return c;if(a.charCodeAt(0)===g){if(a.charCodeAt(1)===g){const l=a.charCodeAt(2);if(l!==E&&l!==I)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(y(a.charCodeAt(0))&&a.charCodeAt(1)===S&&a.charCodeAt(2)===g)return`\\\\?\\${a}`;return c},dirname(c){v(c,"path");const a=c.length;if(a===0)return".";let l=-1,o=0;const h=c.charCodeAt(0);if(a===1)return t(h)?c:".";if(t(h)){if(l=o=1,t(c.charCodeAt(1))){let s=2,u=s;for(;s<a&&!t(c.charCodeAt(s));)s++;if(s<a&&s!==u){for(u=s;s<a&&t(c.charCodeAt(s));)s++;if(s<a&&s!==u){for(u=s;s<a&&!t(c.charCodeAt(s));)s++;if(s===a)return c;s!==u&&(l=o=s+1)}}}}else y(h)&&c.charCodeAt(1)===S&&(l=a>2&&t(c.charCodeAt(2))?3:2,o=l);let n=-1,i=!0;for(let s=a-1;s>=o;--s)if(t(c.charCodeAt(s))){if(!i){n=s;break}}else i=!1;if(n===-1){if(l===-1)return".";n=l}return c.slice(0,n)},basename(c,a){a!==void 0&&v(a,"ext"),v(c,"path");let l=0,o=-1,h=!0,n;if(c.length>=2&&y(c.charCodeAt(0))&&c.charCodeAt(1)===S&&(l=2),a!==void 0&&a.length>0&&a.length<=c.length){if(a===c)return"";let i=a.length-1,s=-1;for(n=c.length-1;n>=l;--n){const u=c.charCodeAt(n);if(t(u)){if(!h){l=n+1;break}}else s===-1&&(h=!1,s=n+1),i>=0&&(u===a.charCodeAt(i)?--i==-1&&(o=n):(i=-1,o=s))}return l===o?o=s:o===-1&&(o=c.length),c.slice(l,o)}for(n=c.length-1;n>=l;--n)if(t(c.charCodeAt(n))){if(!h){l=n+1;break}}else o===-1&&(h=!1,o=n+1);return o===-1?"":c.slice(l,o)},extname(c){v(c,"path");let a=0,l=-1,o=0,h=-1,n=!0,i=0;c.length>=2&&c.charCodeAt(1)===S&&y(c.charCodeAt(0))&&(a=o=2);for(let s=c.length-1;s>=a;--s){const u=c.charCodeAt(s);if(t(u)){if(!n){o=s+1;break}continue}h===-1&&(n=!1,h=s+1),u===I?l===-1?l=s:i!==1&&(i=1):l!==-1&&(i=-1)}return l===-1||h===-1||i===0||i===1&&l===h-1&&l===o+1?"":c.slice(l,h)},format:P.bind(null,"\\"),parse(c){v(c,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return a;const l=c.length;let o=0,h=c.charCodeAt(0);if(l===1)return t(h)?(a.root=a.dir=c,a):(a.base=a.name=c,a);if(t(h)){if(o=1,t(c.charCodeAt(1))){let L=2,R=L;for(;L<l&&!t(c.charCodeAt(L));)L++;if(L<l&&L!==R){for(R=L;L<l&&t(c.charCodeAt(L));)L++;if(L<l&&L!==R){for(R=L;L<l&&!t(c.charCodeAt(L));)L++;L===l?o=L:L!==R&&(o=L+1)}}}}else if(y(h)&&c.charCodeAt(1)===S){if(l<=2)return a.root=a.dir=c,a;if(o=2,t(c.charCodeAt(2))){if(l===3)return a.root=a.dir=c,a;o=3}}o>0&&(a.root=c.slice(0,o));let n=-1,i=o,s=-1,u=!0,m=c.length-1,M=0;for(;m>=o;--m){if(h=c.charCodeAt(m),t(h)){if(!u){i=m+1;break}continue}s===-1&&(u=!1,s=m+1),h===I?n===-1?n=m:M!==1&&(M=1):n!==-1&&(M=-1)}return s!==-1&&(n===-1||M===0||M===1&&n===s-1&&n===i+1?a.base=a.name=c.slice(i,s):(a.name=c.slice(i,n),a.base=c.slice(i,s),a.ext=c.slice(n,s))),i>0&&i!==o?a.dir=c.slice(0,i-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let a="",l=!1;for(let o=c.length-1;o>=-1&&!l;o--){const h=o>=0?c[o]:p.cwd();v(h,"path"),h.length!==0&&(a=`${h}/${a}`,l=h.charCodeAt(0)===d)}return a=b(a,!l,"/",f),l?`/${a}`:a.length>0?a:"."},normalize(c){if(v(c,"path"),c.length===0)return".";const a=c.charCodeAt(0)===d,l=c.charCodeAt(c.length-1)===d;return c=b(c,!a,"/",f),c.length===0?a?"/":l?"./":".":(l&&(c+="/"),a?`/${c}`:c)},isAbsolute(c){return v(c,"path"),c.length>0&&c.charCodeAt(0)===d},join(...c){if(c.length===0)return".";let a;for(let l=0;l<c.length;++l){const o=c[l];v(o,"path"),o.length>0&&(a===void 0?a=o:a+=`/${o}`)}return a===void 0?".":e.posix.normalize(a)},relative(c,a){if(v(c,"from"),v(a,"to"),c===a||(c=e.posix.resolve(c),a=e.posix.resolve(a),c===a))return"";const l=1,o=c.length,h=o-l,n=1,i=a.length-n,s=h<i?h:i;let u=-1,m=0;for(;m<s;m++){const L=c.charCodeAt(l+m);if(L!==a.charCodeAt(n+m))break;L===d&&(u=m)}if(m===s)if(i>s){if(a.charCodeAt(n+m)===d)return a.slice(n+m+1);if(m===0)return a.slice(n+m)}else h>s&&(c.charCodeAt(l+m)===d?u=m:m===0&&(u=0));let M="";for(m=l+u+1;m<=o;++m)(m===o||c.charCodeAt(m)===d)&&(M+=M.length===0?"..":"/..");return`${M}${a.slice(n+u)}`},toNamespacedPath(c){return c},dirname(c){if(v(c,"path"),c.length===0)return".";const a=c.charCodeAt(0)===d;let l=-1,o=!0;for(let h=c.length-1;h>=1;--h)if(c.charCodeAt(h)===d){if(!o){l=h;break}}else o=!1;return l===-1?a?"/":".":a&&l===1?"//":c.slice(0,l)},basename(c,a){a!==void 0&&v(a,"ext"),v(c,"path");let l=0,o=-1,h=!0,n;if(a!==void 0&&a.length>0&&a.length<=c.length){if(a===c)return"";let i=a.length-1,s=-1;for(n=c.length-1;n>=0;--n){const u=c.charCodeAt(n);if(u===d){if(!h){l=n+1;break}}else s===-1&&(h=!1,s=n+1),i>=0&&(u===a.charCodeAt(i)?--i==-1&&(o=n):(i=-1,o=s))}return l===o?o=s:o===-1&&(o=c.length),c.slice(l,o)}for(n=c.length-1;n>=0;--n)if(c.charCodeAt(n)===d){if(!h){l=n+1;break}}else o===-1&&(h=!1,o=n+1);return o===-1?"":c.slice(l,o)},extname(c){v(c,"path");let a=-1,l=0,o=-1,h=!0,n=0;for(let i=c.length-1;i>=0;--i){const s=c.charCodeAt(i);if(s===d){if(!h){l=i+1;break}continue}o===-1&&(h=!1,o=i+1),s===I?a===-1?a=i:n!==1&&(n=1):a!==-1&&(n=-1)}return a===-1||o===-1||n===0||n===1&&a===o-1&&a===l+1?"":c.slice(a,o)},format:P.bind(null,"/"),parse(c){v(c,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return a;const l=c.charCodeAt(0)===d;let o;l?(a.root="/",o=1):o=0;let h=-1,n=0,i=-1,s=!0,u=c.length-1,m=0;for(;u>=o;--u){const M=c.charCodeAt(u);if(M===d){if(!s){n=u+1;break}continue}i===-1&&(s=!1,i=u+1),M===I?h===-1?h=u:m!==1&&(m=1):h!==-1&&(m=-1)}if(i!==-1){const M=n===0&&l?1:n;h===-1||m===0||m===1&&h===i-1&&h===n+1?a.base=a.name=c.slice(M,i):(a.name=c.slice(M,h),a.base=c.slice(M,i),a.ext=c.slice(h,i))}return n>0?a.dir=c.slice(0,n-1):l&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=p.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p.platform==="win32"?e.win32.join:e.posix.join,e.resolve=p.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=p.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=p.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=p.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=p.platform==="win32"?e.win32.extname:e.posix.extname,e.format=p.platform==="win32"?e.win32.format:e.posix.format,e.parse=p.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=p.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=p.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(x[79],ee([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var p;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(p=e.Source||(e.Source={}));var r;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(r=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(C,...k){const I=k.reduce((S,E)=>(S[E]=!0,S),{}),d=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(S=>!I[S]).forEach(S=>{for(let E=0;E<d.length;E++)if(S.search(d[E])!==-1){delete C[S];break}})}e.sanitizeProcessEnvironment=D}),define(x[108],ee([0,1,3]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const r=p.globals.performance&&typeof p.globals.performance.now=="function";class D{constructor(k){this._highResolution=r&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new D(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?p.globals.performance.now():Date.now()}}e.StopWatch=D}),define(x[4],ee([0,1,15,42,2,107,108]),function(j,e,p,r,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var I;(function(a){a.None=()=>D.Disposable.None;function l($){return(Y,V=null,q)=>{let Z=!1,U;return U=$(A=>{if(!Z)return U?U.dispose():Z=!0,Y.call(V,A)},null,q),Z&&U.dispose(),U}}a.once=l;function o($,Y){return m((V,q=null,Z)=>$(U=>V.call(q,Y(U)),null,Z))}a.map=o;function h($,Y){return m((V,q=null,Z)=>$(U=>{Y(U),V.call(q,U)},null,Z))}a.forEach=h;function n($,Y){return m((V,q=null,Z)=>$(U=>Y(U)&&V.call(q,U),null,Z))}a.filter=n;function i($){return $}a.signal=i;function s(...$){return(Y,V=null,q)=>(0,D.combinedDisposable)(...$.map(Z=>Z(U=>Y.call(V,U),null,q)))}a.any=s;function u($,Y,V){let q=V;return o($,Z=>(q=Y(q,Z),q))}a.reduce=u;function m($){let Y;const V=new w({onFirstListenerAdd(){Y=$(V.fire,V)},onLastListenerRemove(){Y.dispose()}});return V.event}function M($,Y,V,q=100,Z=!1){let U,A,W=0;return $(F=>{W++,U=V(U,F),Z&&!A&&(Y(U),U=void 0),clearTimeout(A),A=setTimeout(()=>{const N=U;U=void 0,A=void 0,(!Z||W>1)&&Y(N),W=0},q)})}a.debouncedListener=M;function L($,Y,V=100,q=!1,Z){let U,A,W,F=0;const N=new w({leakWarningThreshold:Z,onFirstListenerAdd(){U=$(H=>{F++,A=Y(A,H),q&&!W&&(N.fire(A),A=void 0),clearTimeout(W),W=setTimeout(()=>{const O=A;A=void 0,W=void 0,(!q||F>1)&&N.fire(O),F=0},V)})},onLastListenerRemove(){U.dispose()}});return N.event}a.debounce=L;function R($,Y=(V,q)=>V===q){let V=!0,q;return n($,Z=>{const U=V||!Y(Z,q);return V=!1,q=Z,U})}a.latch=R;function T($,Y){return[a.filter($,Y),a.filter($,V=>!Y(V))]}a.split=T;function _($,Y=!1,V=[]){let q=V.slice(),Z=$(W=>{q?q.push(W):A.fire(W)});const U=()=>{q&&q.forEach(W=>A.fire(W)),q=null},A=new w({onFirstListenerAdd(){Z||(Z=$(W=>A.fire(W)))},onFirstListenerDidAdd(){q&&(Y?setTimeout(U):U())},onLastListenerRemove(){Z&&Z.dispose(),Z=null}});return A.event}a.buffer=_;class Q{constructor(Y){this.event=Y}map(Y){return new Q(o(this.event,Y))}forEach(Y){return new Q(h(this.event,Y))}filter(Y){return new Q(n(this.event,Y))}reduce(Y,V){return new Q(u(this.event,Y,V))}latch(){return new Q(R(this.event))}debounce(Y,V=100,q=!1,Z){return new Q(L(this.event,Y,V,q,Z))}on(Y,V,q){return this.event(Y,V,q)}once(Y,V,q){return l(this.event)(Y,V,q)}}function se($){return new Q($)}a.chain=se;function re($,Y,V=q=>q){const q=(...W)=>A.fire(V(...W)),Z=()=>$.on(Y,q),U=()=>$.removeListener(Y,q),A=new w({onFirstListenerAdd:Z,onLastListenerRemove:U});return A.event}a.fromNodeEventEmitter=re;function G($,Y,V=q=>q){const q=(...W)=>A.fire(V(...W)),Z=()=>$.addEventListener(Y,q),U=()=>$.removeEventListener(Y,q),A=new w({onFirstListenerAdd:Z,onLastListenerRemove:U});return A.event}a.fromDOMEventEmitter=G;function X($){return new Promise(Y=>l($)(Y))}a.toPromise=X;function B($,Y){return Y(void 0),$(V=>Y(V))}a.runAndSubscribe=B})(I=e.Event||(e.Event={}));class d{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${d._idPool++}`}start(l){this._stopWatch=new k.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}d._idPool=0;let g=-1;function S(a){const l=g;return g=a,{dispose(){g=l}}}e.setGlobalLeakWarningThreshold=S;class E{constructor(l,o=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=o,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l){let o=g;if(typeof this.customThreshold=="number"&&(o=this.customThreshold),o<=0||l<o)return;this._stacks||(this._stacks=new Map);const h=new Error().stack.split(`
`).slice(3).join(`
`),n=this._stacks.get(h)||0;if(this._stacks.set(h,n+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=o*.5;let i,s=0;for(const[u,m]of this._stacks)(!i||s<m)&&(i=u,s=m);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${s}):`),console.warn(i)}return()=>{const i=this._stacks.get(h)||0;this._stacks.set(h,i-1)}}}class w{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=g>0?new E(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new d(this._options._profName):void 0}get event(){return this._event||(this._event=(l,o,h)=>{this._listeners||(this._listeners=new C.LinkedList);const n=this._listeners.isEmpty();n&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(o?[l,o]:l);n&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,o);const s=this._leakageMon?.check(this._listeners.size),u=(0,D.toDisposable)(()=>{s&&s(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return h instanceof D.DisposableStore?h.add(u):Array.isArray(h)&&h.push(u),u}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let o of this._listeners)this._deliveryQueue.push([o,l]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[o,h]=this._deliveryQueue.shift();try{typeof o=="function"?o.call(void 0,h):o[0].call(o[1],h)}catch(n){(0,p.onUnexpectedError)(n)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=w;class v extends w{async fireAsync(l,o,h){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const n of this._listeners)this._asyncDeliveryQueue.push([n,l]);for(;this._asyncDeliveryQueue.size>0&&!o.isCancellationRequested;){const[n,i]=this._asyncDeliveryQueue.shift(),s=[],u={...i,token:o,waitUntil:m=>{if(Object.isFrozen(s))throw new Error("waitUntil can NOT be called asynchronous");h&&(m=h(m,typeof n=="function"?n:n[0])),s.push(m)}};try{typeof n=="function"?n.call(void 0,u):n[0].call(n[1],u)}catch(m){(0,p.onUnexpectedError)(m);continue}Object.freeze(s),await Promise.allSettled(s).then(m=>{for(const M of m)M.status==="rejected"&&(0,p.onUnexpectedError)(M.reason)})}}}}e.AsyncEmitter=v;class t extends w{constructor(l){super(l);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=t;class f extends t{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=f;class y extends w{constructor(l){super(l);this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(o=>super.fire(o)),this._queuedEvents=[]})}}e.MicrotaskEmitter=y;class b{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new w({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const o={event:l,listener:null};this.events.push(o),this.hasListeners&&this.hook(o);const h=()=>{this.hasListeners&&this.unhook(o);const n=this.events.indexOf(o);this.events.splice(n,1)};return(0,D.toDisposable)((0,r.once)(h))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(o=>this.emitter.fire(o))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=b;class P{constructor(){this.buffers=[]}wrapEvent(l){return(o,h,n)=>l(i=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>o.call(h,i)):o.call(h,i)},void 0,n)}bufferEvents(l){const o=[];this.buffers.push(o);const h=l();return this.buffers.pop(),o.forEach(n=>n()),h}}e.EventBufferer=P;class c{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=D.Disposable.None,this.emitter=new w({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=c}),define(x[23],ee([0,1,4]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const r=Object.freeze(function(I,d){const g=setTimeout(I.bind(d),0);return{dispose(){clearTimeout(g)}}});var D;(function(I){function d(g){return g===I.None||g===I.Cancelled||g instanceof C?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}I.isCancellationToken=d,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:r})})(D=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?r:(this._emitter||(this._emitter=new p.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(d){this._token=void 0,this._parentListener=void 0,this._parentListener=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=D.Cancelled}dispose(d=!1){d&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=k}),define(x[51],ee([0,1,15,2]),function(j,e,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(c){const a=c;return a?[a.on,a.pause,a.resume,a.destroy].every(l=>typeof l=="function"):!1}e.isReadableStream=D;function C(c){const a=c;return a?D(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=C;function k(c,a){return new I(c,a)}e.newWriteableStream=k;class I{constructor(a,l){this.reducer=a,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a!="undefined"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(l=>l(a))}emitError(a){this.listeners.error.length===0?(0,p.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(l=>l(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,l){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(a,l){if(this.state.destroyed)return;let o;switch(a){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const h=o.indexOf(l);h>=0&&o.splice(h,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function d(c,a){const l=[];let o;for(;(o=c.read())!==null;)l.push(o);return a(l)}e.consumeReadable=d;function g(c,a,l){const o=[];let h;for(;(h=c.read())!==null&&o.length<l;)o.push(h);return h===null&&o.length>0?a(o):{read:()=>{if(o.length>0)return o.shift();if(typeof h!="undefined"){const n=h;return h=void 0,n}return c.read()}}}e.peekReadable=g;function S(c,a){return new Promise((l,o)=>{const h=[];E(c,{onData:n=>{a&&h.push(n)},onError:n=>{a?o(n):l(void 0)},onEnd:()=>{l(a?a(h):void 0)}})})}e.consumeStream=S;function E(c,a){let l=!1;return c.on("error",o=>{l||a.onError(o)}),c.on("end",()=>{l||a.onEnd()}),c.on("data",o=>{l||a.onData(o)}),(0,r.toDisposable)(()=>l=!0)}e.listenStream=E;function w(c,a){return new Promise((l,o)=>{const h=new r.DisposableStore,n=[],i=m=>{if(n.push(m),n.length>a)return h.dispose(),c.pause(),l({stream:c,buffer:n,ended:!1})},s=m=>o(m),u=()=>l({stream:c,buffer:n,ended:!0});h.add((0,r.toDisposable)(()=>c.removeListener("error",s))),c.on("error",s),h.add((0,r.toDisposable)(()=>c.removeListener("end",u))),c.on("end",u),h.add((0,r.toDisposable)(()=>c.removeListener("data",i))),c.on("data",i)})}e.peekStream=w;function v(c,a){const l=k(a);return l.end(c),l}e.toStream=v;function t(){const c=k(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=t;function f(c){let a=!1;return{read:()=>a?null:(a=!0,c)}}e.toReadable=f;function y(c,a,l){const o=k(l);return E(c,{onData:h=>o.write(a.data(h)),onError:h=>o.error(a.error?a.error(h):h),onEnd:()=>o.end()}),o}e.transform=y;function b(c,a,l){let o=!1;return{read:()=>{const h=a.read();return o?h:(o=!0,h!==null?l([c,h]):c)}}}e.prefixedReadable=b;function P(c,a,l){let o=!1;const h=k(l);return E(a,{onData:n=>o?h.write(n):(o=!0,h.write(l([c,n]))),onError:n=>h.error(n),onEnd:()=>{o||(o=!0,h.write(c)),h.end()}}),h}e.prefixedStream=P}),define(x[17],ee([0,1,51]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const r=typeof Buffer!="undefined";let D,C;class k{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return r?new k(Buffer.allocUnsafe(i)):new k(new Uint8Array(i))}static wrap(i){return r&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new k(i)}static fromString(i,s){return!(s?.dontUseNodeBuffer||!1)&&r?new k(Buffer.from(i)):(D||(D=new TextEncoder),new k(D.encode(i)))}static fromByteArray(i){const s=k.alloc(i.length);for(let u=0,m=i.length;u<m;u++)s.buffer[u]=i[u];return s}static concat(i,s){if(typeof s=="undefined"){s=0;for(let M=0,L=i.length;M<L;M++)s+=i[M].byteLength}const u=k.alloc(s);let m=0;for(let M=0,L=i.length;M<L;M++){const R=i[M];u.set(R,m),m+=R.byteLength}return u}clone(){const i=k.alloc(this.byteLength);return i.set(this),i}toString(){return r?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(i,s){return new k(this.buffer.subarray(i,s))}set(i,s){if(i instanceof k)this.buffer.set(i.buffer,s);else if(i instanceof Uint8Array)this.buffer.set(i,s);else if(i instanceof ArrayBuffer)this.buffer.set(new Uint8Array(i),s);else if(ArrayBuffer.isView(i))this.buffer.set(new Uint8Array(i.buffer,i.byteOffset,i.byteLength),s);else throw new Error("Unkown argument 'array'")}readUInt32BE(i){return g(this.buffer,i)}writeUInt32BE(i,s){S(this.buffer,i,s)}readUInt32LE(i){return E(this.buffer,i)}writeUInt32LE(i,s){w(this.buffer,i,s)}readUInt8(i){return v(this.buffer,i)}writeUInt8(i,s){t(this.buffer,i,s)}}e.VSBuffer=k;function I(n,i){return n[i+0]<<0>>>0|n[i+1]<<8>>>0}e.readUInt16LE=I;function d(n,i,s){n[s+0]=i&255,i=i>>>8,n[s+1]=i&255}e.writeUInt16LE=d;function g(n,i){return n[i]*2**24+n[i+1]*2**16+n[i+2]*2**8+n[i+3]}e.readUInt32BE=g;function S(n,i,s){n[s+3]=i,i=i>>>8,n[s+2]=i,i=i>>>8,n[s+1]=i,i=i>>>8,n[s]=i}e.writeUInt32BE=S;function E(n,i){return n[i+0]<<0>>>0|n[i+1]<<8>>>0|n[i+2]<<16>>>0|n[i+3]<<24>>>0}e.readUInt32LE=E;function w(n,i,s){n[s+0]=i&255,i=i>>>8,n[s+1]=i&255,i=i>>>8,n[s+2]=i&255,i=i>>>8,n[s+3]=i&255}e.writeUInt32LE=w;function v(n,i){return n[i]}e.readUInt8=v;function t(n,i,s){n[s]=i}e.writeUInt8=t;function f(n){return p.consumeReadable(n,i=>k.concat(i))}e.readableToBuffer=f;function y(n){return p.toReadable(n)}e.bufferToReadable=y;function b(n){return p.consumeStream(n,i=>k.concat(i))}e.streamToBuffer=b;async function P(n){return n.ended?k.concat(n.buffer):k.concat([...n.buffer,await b(n.stream)])}e.bufferedStreamToBuffer=P;function c(n){return p.toStream(n,i=>k.concat(i))}e.bufferToStream=c;function a(n){return p.transform(n,{data:i=>typeof i=="string"?k.fromString(i):k.wrap(i)},i=>k.concat(i))}e.streamToBufferReadableStream=a;function l(n){return p.newWriteableStream(i=>k.concat(i),n)}e.newWriteableBufferStream=l;function o(n,i){return p.prefixedReadable(n,i,s=>k.concat(s))}e.prefixedBufferReadable=o;function h(n,i){return p.prefixedStream(n,i,s=>k.concat(s))}e.prefixedBufferStream=h}),define(x[25],ee([0,1,3]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function r(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=r;const D=/{(\d+)}/g;function C(K,...ae){return ae.length===0?K:K.replace(D,function(he,ve){const Ie=parseInt(ve,10);return isNaN(Ie)||Ie<0||Ie>=ae.length?he:ae[Ie]})}e.format=C;const k=/{([^}]+)}/g;function I(K,ae){return K.replace(k,(he,ve)=>ae[ve]??he)}e.format2=I;function d(K){return K.replace(/[<>&]/g,function(ae){switch(ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ae}})}e.escape=d;function g(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=g;function S(K,ae){let he=0;const ve=ae.charCodeAt(0);for(let Ie=K.length-1;Ie>=0;Ie--)K.charCodeAt(Ie)===ve&&he++;return he}e.count=S;function E(K,ae,he="\u2026"){return K.length<=ae?K:`${K.substr(0,ae)}${he}`}e.truncate=E;function w(K,ae=" "){const he=v(K,ae);return t(he,ae)}e.trim=w;function v(K,ae){if(!K||!ae)return K;const he=ae.length;if(he===0||K.length===0)return K;let ve=0;for(;K.indexOf(ae,ve)===ve;)ve=ve+he;return K.substring(ve)}e.ltrim=v;function t(K,ae){if(!K||!ae)return K;const he=ae.length,ve=K.length;if(he===0||ve===0)return K;let Ie=ve,Ce=-1;for(;Ce=K.lastIndexOf(ae,Ie-1),!(Ce===-1||Ce+he!==Ie);){if(Ce===0)return"";Ie=Ce}return K.substring(0,Ie)}e.rtrim=t;function f(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=f;function y(K){return K.replace(/\*/g,"")}e.stripWildcards=y;function b(K,ae,he={}){if(!K)throw new Error("Cannot create regex from empty string");ae||(K=g(K)),he.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let ve="";return he.global&&(ve+="g"),he.matchCase||(ve+="i"),he.multiline&&(ve+="m"),he.unicode&&(ve+="u"),new RegExp(K,ve)}e.createRegExp=b;function P(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=P;function c(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function a(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=a;function l(K){return K.split(/\r\n|\r|\n/)}e.splitLines=l;function o(K){for(let ae=0,he=K.length;ae<he;ae++){const ve=K.charCodeAt(ae);if(ve!==32&&ve!==9)return ae}return-1}e.firstNonWhitespaceIndex=o;function h(K,ae=0,he=K.length){for(let ve=ae;ve<he;ve++){const Ie=K.charCodeAt(ve);if(Ie!==32&&Ie!==9)return K.substring(ae,ve)}return K.substring(ae,he)}e.getLeadingWhitespace=h;function n(K,ae=K.length-1){for(let he=ae;he>=0;he--){const ve=K.charCodeAt(he);if(ve!==32&&ve!==9)return he}return-1}e.lastNonWhitespaceIndex=n;function i(K,ae){return K<ae?-1:K>ae?1:0}e.compare=i;function s(K,ae,he=0,ve=K.length,Ie=0,Ce=ae.length){for(;he<ve&&Ie<Ce;he++,Ie++){let _e=K.charCodeAt(he),Ne=ae.charCodeAt(Ie);if(_e<Ne)return-1;if(_e>Ne)return 1}const Fe=ve-he,Oe=Ce-Ie;return Fe<Oe?-1:Fe>Oe?1:0}e.compareSubstring=s;function u(K,ae){return m(K,ae,0,K.length,0,ae.length)}e.compareIgnoreCase=u;function m(K,ae,he=0,ve=K.length,Ie=0,Ce=ae.length){for(;he<ve&&Ie<Ce;he++,Ie++){let _e=K.charCodeAt(he),Ne=ae.charCodeAt(Ie);if(_e===Ne)continue;if(_e>=128||Ne>=128)return s(K.toLowerCase(),ae.toLowerCase(),he,ve,Ie,Ce);M(_e)&&(_e-=32),M(Ne)&&(Ne-=32);const He=_e-Ne;if(He!==0)return He}const Fe=ve-he,Oe=Ce-Ie;return Fe<Oe?-1:Fe>Oe?1:0}e.compareSubstringIgnoreCase=m;function M(K){return K>=97&&K<=122}e.isLowerAsciiLetter=M;function L(K){return K>=65&&K<=90}e.isUpperAsciiLetter=L;function R(K,ae){return K.length===ae.length&&m(K,ae)===0}e.equalsIgnoreCase=R;function T(K,ae){const he=ae.length;return ae.length>K.length?!1:m(K,ae,0,he)===0}e.startsWithIgnoreCase=T;function _(K,ae){let he,ve=Math.min(K.length,ae.length);for(he=0;he<ve;he++)if(K.charCodeAt(he)!==ae.charCodeAt(he))return he;return ve}e.commonPrefixLength=_;function Q(K,ae){let he,ve=Math.min(K.length,ae.length);const Ie=K.length-1,Ce=ae.length-1;for(he=0;he<ve;he++)if(K.charCodeAt(Ie-he)!==ae.charCodeAt(Ce-he))return he;return ve}e.commonSuffixLength=Q;function se(K){return 55296<=K&&K<=56319}e.isHighSurrogate=se;function re(K){return 56320<=K&&K<=57343}e.isLowSurrogate=re;function G(K,ae){return(K-55296<<10)+(ae-56320)+65536}e.computeCodePoint=G;function X(K,ae,he){const ve=K.charCodeAt(he);if(se(ve)&&he+1<ae){const Ie=K.charCodeAt(he+1);if(re(Ie))return G(ve,Ie)}return ve}e.getNextCodePoint=X;function B(K,ae){const he=K.charCodeAt(ae-1);if(re(he)&&ae>1){const ve=K.charCodeAt(ae-2);if(se(ve))return G(ve,he)}return he}function $(K,ae){const he=Be.getInstance(),ve=ae,Ie=K.length,Ce=X(K,Ie,ae);ae+=Ce>=65536?2:1;let Fe=he.getGraphemeBreakType(Ce);for(;ae<Ie;){const Oe=X(K,Ie,ae),_e=he.getGraphemeBreakType(Oe);if(We(Fe,_e))break;ae+=Oe>=65536?2:1,Fe=_e}return ae-ve}e.nextCharLength=$;function Y(K,ae){const he=Be.getInstance(),ve=ae,Ie=B(K,ae);ae-=Ie>=65536?2:1;let Ce=he.getGraphemeBreakType(Ie);for(;ae>0;){const Fe=B(K,ae),Oe=he.getGraphemeBreakType(Fe);if(We(Oe,Ce))break;ae-=Fe>=65536?2:1,Ce=Oe}return ve-ae}e.prevCharLength=Y;function V(K,ae){const he=Be.getInstance(),ve=K.length,Ie=ae,Ce=X(K,ve,ae),Fe=he.getGraphemeBreakType(Ce);ae+=Ce>=65536?2:1;let Oe=Fe;for(;ae<ve;){const Ne=X(K,ve,ae),He=he.getGraphemeBreakType(Ne);if(We(Oe,He))break;ae+=Ne>=65536?2:1,Oe=He}const _e=ae;for(ae=Ie,Oe=Fe;ae>0;){const Ne=B(K,ae),He=he.getGraphemeBreakType(Ne);if(We(He,Oe))break;ae-=Ne>=65536?2:1,Oe=He}return[ae,_e]}function q(K,ae){return ae>0&&re(K.charCodeAt(ae))?V(K,ae-1):V(K,ae)}e.getCharContainingOffset=q;const Z=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function U(K){return Z.test(K)}e.containsRTL=U;const A=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFF0]|\uD83E[\uDD00-\uDDFF\uDE70-\uDEF6])/;function W(K){return A.test(K)}e.containsEmoji=W;const F=/^[\t\n\r\x20-\x7E]*$/;function N(K){return F.test(K)}e.isBasicASCII=N,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function H(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=H;function O(K){for(let ae=0,he=K.length;ae<he;ae++)if(z(K.charCodeAt(ae)))return!0;return!1}e.containsFullWidthCharacter=O;function z(K){return K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=z;function te(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129008||K>=129280&&K<=129535||K>=129648&&K<=129782}e.isEmojiImprecise=te;function ne(K,ae){if(K.length<ae)return K;const he=/\b/g;let ve=0;for(;he.test(K)&&!(K.length-he.lastIndex<ae);)ve=he.lastIndex,he.lastIndex+=1;return K.substring(ve).replace(/^\s/,"")}e.lcut=ne;const oe=/\x1B\x5B[12]?K/g,J=/\x1b\[\d+m/g,ce=/\x1b\[0?m/g;function le(K){return K&&(K=K.replace(oe,""),K=K.replace(J,""),K=K.replace(ce,"")),K}e.removeAnsiEscapeCodes=le,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ue(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ue;function me(K){return ue(K)?K.substr(1):K}e.stripUTF8BOM=me;function Ee(K,ae){if(!K||!ae||K.length<ae.length)return!1;const he=ae.length,ve=K.toLowerCase();let Ie=0,Ce=-1;for(;Ie<he;){const Fe=ve.indexOf(ae[Ie],Ce+1);if(Fe<0)return!1;Ce=Fe,Ie++}return!0}e.fuzzyContains=Ee;function de(K,ae=!1){return K?(ae&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=de;function ge(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=ge;function pe(K,ae=1){if(ae===0)return"";let he=-1;do he=K.indexOf(`
`,he+1),ae--;while(ae>0&&he>=0);return he===-1?K:(K[he-1]==="\r"&&he--,K.substr(0,he))}e.getNLines=pe;function ke(K){const ae=90-65+1;return K=K%(2*ae),K<ae?String.fromCharCode(97+K):String.fromCharCode(65+K-ae)}e.singleLetterHash=ke;function Le(K){return Be.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=Le;function We(K,ae){return K===0?ae!==5&&ae!==7:K===2&&ae===3?!1:K===4||K===2||K===3||ae===4||ae===2||ae===3?!0:!(K===8&&(ae===8||ae===9||ae===11||ae===12)||(K===11||K===9)&&(ae===9||ae===10)||(K===12||K===10)&&ae===10||ae===5||ae===13||ae===7||K===1||K===13&&ae===14||K===6&&ae===6)}e.breakBetweenGraphemeBreakType=We;var ze;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(ze=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Be{constructor(){this._data=Xe()}static getInstance(){return Be._INSTANCE||(Be._INSTANCE=new Be),Be._INSTANCE}getGraphemeBreakType(ae){if(ae<32)return ae===10?3:ae===13?2:4;if(ae<127)return 0;const he=this._data,ve=he.length/3;let Ie=1;for(;Ie<=ve;)if(ae<he[3*Ie])Ie=2*Ie;else if(ae>he[3*Ie+1])Ie=2*Ie+1;else return he[3*Ie+2];return 0}}Be._INSTANCE=null;function Xe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ke(K,ae){if(K===0)return 0;const he=gt(K,ae);if(he!==void 0)return he;const ve=B(ae,K);return K-=Qe(ve),K}e.getLeftDeleteOffset=Ke;function gt(K,ae){let he=B(ae,K);for(K-=Qe(he);at(he)||he===65039||he===8419;){if(K===0)return;he=B(ae,K),K-=Qe(he)}if(!!te(he)){if(K>=0){const ve=B(ae,K);ve===8205&&(K-=Qe(ve))}return K}}function Qe(K){return K>=65536?2:1}function at(K){return 127995<=K&&K<=127999}var ct;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(ct||(ct={})),e.noBreakWhitespace="\xA0";class $e{static getData(){return JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,40,10088,40,10098,40,12308,40,64830,40,65341,41,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,124,8739,124,9213,124,65512,124,1633,124,1777,124,66336,124,125127,124,120783,124,120793,124,120803,124,120813,124,120823,124,130033,124,65321,124,8544,124,8464,124,8465,124,119816,124,119868,124,119920,124,120024,124,120128,124,120180,124,120232,124,120284,124,120336,124,120388,124,120440,124,406,124,65356,124,8572,124,8467,124,119845,124,119897,124,119949,124,120001,124,120053,124,120105,124,120157,124,120209,124,120261,124,120313,124,120365,124,120417,124,120469,124,448,124,120496,124,120554,124,120612,124,120670,124,120728,124,11410,124,1030,124,1216,124,1493,124,1503,124,1575,124,126464,124,126592,124,65166,124,65165,124,1994,124,11599,124,5825,124,42226,124,93992,124,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90],"_default":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"cs":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"de":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"es":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"fr":[65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"it":[160,32,8211,45,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ko":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pl":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pt-BR":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"qps-ploc":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ru":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,124,1009,112,215,120],"tr":[160,32,8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hans":[65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hant":[8211,45,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89]}')}static getConfusablesForCurrentLocale(){if(!$e.map){let ve=function(Fe){const Oe=new Map;for(let _e=0;_e<Fe.length;_e+=2)Oe.set(Fe[_e],Fe[_e+1]);return Oe};const ae=$e.getData();let he=p.locale;(!he||!(he in ae))&&(he=p.language),(!he||!(he in ae))&&(he="_default");const Ie=ve(ae._common),Ce=ve(ae[he]);for(const[Fe,Oe]of Ce)Ie.set(Fe,Oe);$e.map=Ie}return $e.map}static isAmbiguous(ae){return $e.getConfusablesForCurrentLocale().has(ae)}static getPrimaryConfusable(ae){return $e.getConfusablesForCurrentLocale().get(ae)}static getPrimaryConfusableCodePoints(){return new Set($e.getConfusablesForCurrentLocale().keys())}}e.AmbiguousCharacters=$e;class qe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(qe.getRawData())),this._data}static isInvisibleCharacter(ae){return qe.getData().has(ae)}static get codePoints(){return qe.getData()}}e.InvisibleCharacters=qe,qe._data=void 0}),define(x[80],ee([0,1,25]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function r(b){return D(b,0)}e.hash=r;function D(b,P){switch(typeof b){case"object":return b===null?C(349,P):Array.isArray(b)?d(b,P):g(b,P);case"string":return I(b,P);case"boolean":return k(b,P);case"number":return C(b,P);case"undefined":return C(937,P);default:return C(617,P)}}e.doHash=D;function C(b,P){return(P<<5)-P+b|0}e.numberHash=C;function k(b,P){return C(b?433:863,P)}function I(b,P){P=C(149417,P);for(let c=0,a=b.length;c<a;c++)P=C(b.charCodeAt(c),P);return P}e.stringHash=I;function d(b,P){return P=C(104579,P),b.reduce((c,a)=>D(a,c),P)}function g(b,P){return P=C(181387,P),Object.keys(b).sort().reduce((c,a)=>(c=I(a,c),D(b[a],c)),P)}class S{constructor(){this._value=0}get value(){return this._value}hash(P){return this._value=D(P,this._value),this._value}}e.Hasher=S;var E;(function(b){b[b.BLOCK_SIZE=64]="BLOCK_SIZE",b[b.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function w(b,P,c=32){const a=c-P,l=~((1<<a)-1);return(b<<P|(l&b)>>>a)>>>0}function v(b,P=0,c=b.byteLength,a=0){for(let l=0;l<c;l++)b[P+l]=a}function t(b,P,c="0"){for(;b.length<P;)b=c+b;return b}function f(b,P=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(c=>c.toString(16).padStart(2,"0")).join(""):t((b>>>0).toString(16),P/4)}e.toHexString=f;class y{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(P){const c=P.length;if(c===0)return;const a=this._buff;let l=this._buffLen,o=this._leftoverHighSurrogate,h,n;for(o!==0?(h=o,n=-1,o=0):(h=P.charCodeAt(0),n=0);;){let i=h;if(p.isHighSurrogate(h))if(n+1<c){const s=P.charCodeAt(n+1);p.isLowSurrogate(s)?(n++,i=p.computeCodePoint(h,s)):i=65533}else{o=h;break}else p.isLowSurrogate(h)&&(i=65533);if(l=this._push(a,l,i),n++,n<c)h=P.charCodeAt(n);else break}this._buffLen=l,this._leftoverHighSurrogate=o}_push(P,c,a){return a<128?P[c++]=a:a<2048?(P[c++]=192|(a&1984)>>>6,P[c++]=128|(a&63)>>>0):a<65536?(P[c++]=224|(a&61440)>>>12,P[c++]=128|(a&4032)>>>6,P[c++]=128|(a&63)>>>0):(P[c++]=240|(a&1835008)>>>18,P[c++]=128|(a&258048)>>>12,P[c++]=128|(a&4032)>>>6,P[c++]=128|(a&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,P[0]=P[64+0],P[1]=P[64+1],P[2]=P[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),f(this._h0)+f(this._h1)+f(this._h2)+f(this._h3)+f(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,v(this._buff,this._buffLen),this._buffLen>56&&(this._step(),v(this._buff));const P=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(P/4294967296),!1),this._buffDV.setUint32(60,P%4294967296,!1),this._step()}_step(){const P=y._bigBlock32,c=this._buffDV;for(let m=0;m<64;m+=4)P.setUint32(m,c.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)P.setUint32(m,w(P.getUint32(m-12,!1)^P.getUint32(m-32,!1)^P.getUint32(m-56,!1)^P.getUint32(m-64,!1),1),!1);let a=this._h0,l=this._h1,o=this._h2,h=this._h3,n=this._h4,i,s,u;for(let m=0;m<80;m++)m<20?(i=l&o|~l&h,s=1518500249):m<40?(i=l^o^h,s=1859775393):m<60?(i=l&o|l&h|o&h,s=2400959708):(i=l^o^h,s=3395469782),u=w(a,5)+i+n+s+P.getUint32(m*4,!1)&4294967295,n=h,h=o,o=w(l,30),l=a,a=u;this._h0=this._h0+a&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+o&4294967295,this._h3=this._h3+h&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=y,y._bigBlock32=new DataView(new ArrayBuffer(320))});var kt=this&&this.__classPrivateFieldSet||function(j,e,p,r,D){if(r==="m")throw new TypeError("Private method is not writable");if(r==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?j!==e||!D:!e.has(j))throw new TypeError("Cannot write private member to an object whose class did not declare it");return r==="a"?D.call(j,p):D?D.value=p:e.set(j,p),p},je=this&&this.__classPrivateFieldGet||function(j,e,p,r){if(p==="a"&&!r)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?j!==e||!r:!e.has(j))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?r:p==="a"?r.call(j):r?r.value:e.get(j)};define(x[36],ee([0,1,31,25]),function(j,e,p,r){"use strict";var D,C,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(n,i,s){let u=n.get(i);return u===void 0&&(u=s,n.set(i,u)),u}e.getOrSet=I;function d(n){const i=[];return n.forEach((s,u)=>{i.push(`${u} => ${s}`)}),`Map(${n.size}) {${i.join(", ")}}`}e.mapToString=d;function g(n){const i=[];return n.forEach(s=>{i.push(s)}),`Set(${n.size}) {${i.join(", ")}}`}e.setToString=g;class S{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const s=i.charCodeAt(0),u=this._value.charCodeAt(this._pos);return s-u}value(){return this._value[this._pos]}}e.StringIterator=S;class E{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,r.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,r.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=E;class w{constructor(i=!0,s=!0){this._splitOnBackslash=i,this._caseSensitive=s}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let s=i.length-1;s>=0;s--,this._valueLen--){const u=this._value.charCodeAt(s);if(!(u===47||this._splitOnBackslash&&u===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,r.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,r.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=w;var v;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(v||(v={}));class t{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new w(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,r.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,r.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,r.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,r.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=t;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(y||(y={}));class b{constructor(i){this._iter=i}static forUris(i=()=>!1){return new b(new t(i))}static forPaths(){return new b(new w)}static forStrings(){return new b(new S)}static forConfigKeys(){return new b(new E)}clear(){this._root=void 0}fill(i,s){if(s){const u=s.slice(0);(0,p.shuffle)(u);for(let m of u)this.set(m,i)}else{const u=i.slice(0);(0,p.shuffle)(u);for(let m of u)this.set(m[0],m[1])}}set(i,s){const u=this._iter.reset(i);let m;this._root||(this._root=new f,this._root.segment=u.value());const M=[];for(m=this._root;;){const R=u.cmp(m.segment);if(R>0)m.left||(m.left=new f,m.left.segment=u.value()),M.push([-1,m]),m=m.left;else if(R<0)m.right||(m.right=new f,m.right.segment=u.value()),M.push([1,m]),m=m.right;else if(u.hasNext())u.next(),m.mid||(m.mid=new f,m.mid.segment=u.value()),M.push([0,m]),m=m.mid;else break}const L=m.value;m.value=s,m.key=i;for(let R=M.length-1;R>=0;R--){const T=M[R][1];T.updateHeight();const _=T.balanceFactor();if(_<-1||_>1){const Q=M[R][0],se=M[R+1][0];if(Q===1&&se===1)M[R][1]=T.rotateLeft();else if(Q===-1&&se===-1)M[R][1]=T.rotateRight();else if(Q===1&&se===-1)T.right=M[R+1][1]=M[R+1][1].rotateRight(),M[R][1]=T.rotateLeft();else if(Q===-1&&se===1)T.left=M[R+1][1]=M[R+1][1].rotateLeft(),M[R][1]=T.rotateRight();else throw new Error;if(R>0)switch(M[R-1][0]){case-1:M[R-1][1].left=M[R][1];break;case 1:M[R-1][1].right=M[R][1];break;case 0:M[R-1][1].mid=M[R][1];break}else this._root=M[0][1]}}return L}get(i){return this._getNode(i)?.value}_getNode(i){const s=this._iter.reset(i);let u=this._root;for(;u;){const m=s.cmp(u.segment);if(m>0)u=u.left;else if(m<0)u=u.right;else if(s.hasNext())s.next(),u=u.mid;else break}return u}has(i){const s=this._getNode(i);return!(s?.value===void 0&&s?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,s){const u=this._iter.reset(i),m=[];let M=this._root;for(;M;){const L=u.cmp(M.segment);if(L>0)m.push([-1,M]),M=M.left;else if(L<0)m.push([1,M]),M=M.right;else if(u.hasNext())u.next(),m.push([0,M]),M=M.mid;else break}if(!!M){if(s?(M.left=void 0,M.mid=void 0,M.right=void 0,M.height=1):(M.key=void 0,M.value=void 0),!M.mid&&!M.value)if(M.left&&M.right){const L=this._min(M.right),{key:R,value:T,segment:_}=L;this._delete(L.key,!1),M.key=R,M.value=T,M.segment=_}else{const L=M.left??M.right;if(m.length>0){const[R,T]=m[m.length-1];switch(R){case-1:T.left=L;break;case 0:T.mid=L;break;case 1:T.right=L;break}}else this._root=L}for(let L=m.length-1;L>=0;L--){const R=m[L][1];R.updateHeight();const T=R.balanceFactor();if(T>1?(R.right.balanceFactor()>=0||(R.right=R.right.rotateRight()),m[L][1]=R.rotateLeft()):T<-1&&(R.left.balanceFactor()<=0||(R.left=R.left.rotateLeft()),m[L][1]=R.rotateRight()),L>0)switch(m[L-1][0]){case-1:m[L-1][1].left=m[L][1];break;case 1:m[L-1][1].right=m[L][1];break;case 0:m[L-1][1].mid=m[L][1];break}else this._root=m[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const s=this._iter.reset(i);let u=this._root,m;for(;u;){const M=s.cmp(u.segment);if(M>0)u=u.left;else if(M<0)u=u.right;else if(s.hasNext())s.next(),m=u.value||m,u=u.mid;else break}return u&&u.value||m}findSuperstr(i){const s=this._iter.reset(i);let u=this._root;for(;u;){const m=s.cmp(u.segment);if(m>0)u=u.left;else if(m<0)u=u.right;else if(s.hasNext())s.next(),u=u.mid;else return u.mid?this._entries(u.mid):void 0}}forEach(i){for(const[s,u]of this)i(u,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=s=>{if(!s)return!0;const u=s.balanceFactor();return u<-1||u>1?!1:i(s.left)&&i(s.right)};return i(this._root)}}e.TernarySearchTree=b;class P{constructor(i,s){this.uri=i,this.value=s}}class c{constructor(i,s){this[D]="ResourceMap",i instanceof c?(this.map=new Map(i.map),this.toKey=s??c.defaultToKey):(this.map=new Map,this.toKey=i??c.defaultToKey)}set(i,s){return this.map.set(this.toKey(i),new P(i,s)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,s){typeof s!="undefined"&&(i=i.bind(s));for(let[u,m]of this.map)i(m.value,m.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=c,c.defaultToKey=n=>n.toString();var a;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(a=e.Touch||(e.Touch={}));class l{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,s=0){const u=this._map.get(i);if(!!u)return s!==0&&this.touch(u,s),u.value}set(i,s,u=0){let m=this._map.get(i);if(m)m.value=s,u!==0&&this.touch(m,u);else{switch(m={key:i,value:s,next:void 0,previous:void 0},u){case 0:this.addItemLast(m);break;case 1:this.addItemFirst(m);break;case 2:this.addItemLast(m);break;default:this.addItemLast(m);break}this._map.set(i,m),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this._map.get(i);if(!!s)return this._map.delete(i),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,s){const u=this._state;let m=this._head;for(;m;){if(s?i.bind(s)(m.value,m.key,this):i(m.value,m.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const i=this,s=this._state;let u=this._head;const m={[Symbol.iterator](){return m},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const M={value:u.key,done:!1};return u=u.next,M}else return{value:void 0,done:!0}}};return m}values(){const i=this,s=this._state;let u=this._head;const m={[Symbol.iterator](){return m},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const M={value:u.value,done:!1};return u=u.next,M}else return{value:void 0,done:!0}}};return m}entries(){const i=this,s=this._state;let u=this._head;const m={[Symbol.iterator](){return m},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const M={value:[u.key,u.value],done:!1};return u=u.next,M}else return{value:void 0,done:!0}}};return m}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let s=this._head,u=this.size;for(;s&&u>i;)this._map.delete(s.key),s=s.next,u--;this._head=s,this._size=u,s&&(s.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const s=i.next,u=i.previous;if(!s||!u)throw new Error("Invalid list");s.previous=u,u.next=s}i.next=void 0,i.previous=void 0,this._state++}touch(i,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(i===this._head)return;const u=i.next,m=i.previous;i===this._tail?(m.next=void 0,this._tail=m):(u.previous=m,m.next=u),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(s===2){if(i===this._tail)return;const u=i.next,m=i.previous;i===this._head?(u.previous=void 0,this._head=u):(u.previous=m,m.next=u),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((s,u)=>{i.push([u,s])}),i}fromJSON(i){this.clear();for(const[s,u]of i)this.set(s,u)}}e.LinkedMap=l;class o extends l{constructor(i,s=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,s=2){return super.get(i,s)}peek(i){return super.get(i,0)}set(i,s){return super.set(i,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class h{constructor(i){k.set(this,void 0),kt(this,k,i,"f")}get size(){return je(this,k,"f").size}forEach(i,s){je(this,k,"f").forEach(i,s)}get(i){return je(this,k,"f").get(i)}has(i){return je(this,k,"f").has(i)}entries(){return je(this,k,"f").entries()}keys(){return je(this,k,"f").keys()}values(){return je(this,k,"f").values()}[(k=new WeakMap,Symbol.iterator)](){return je(this,k,"f").entries()}}e.ReadonlyMapView=h}),define(x[70],ee([0,1,36]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const r=new p.LRUCache(1e4);function D(g){return d(g,"NFC",r)}e.normalizeNFC=D;const C=new p.LRUCache(1e4);function k(g){return d(g,"NFD",C)}e.normalizeNFD=k;const I=/[^\u0000-\u0080]/;function d(g,S,E){if(!g)return g;const w=E.get(g);if(w)return w;let v;return I.test(g)?v=g.normalize(S):v=g,E.set(g,v),v}e.removeAccents=function(){const g=/[\u0300-\u036f]/g;return function(S){return k(S).replace(g,"")}}()}),define(x[13],ee([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function p(M){return Array.isArray(M)}e.isArray=p;function r(M){return typeof M=="string"}e.isString=r;function D(M){return Array.isArray(M)&&M.every(L=>r(L))}e.isStringArray=D;function C(M){return typeof M=="object"&&M!==null&&!Array.isArray(M)&&!(M instanceof RegExp)&&!(M instanceof Date)}e.isObject=C;function k(M){return typeof M=="number"&&!isNaN(M)}e.isNumber=k;function I(M){return!!M&&typeof M[Symbol.iterator]=="function"}e.isIterable=I;function d(M){return M===!0||M===!1}e.isBoolean=d;function g(M){return typeof M=="undefined"}e.isUndefined=g;function S(M){return!E(M)}e.isDefined=S;function E(M){return g(M)||M===null}e.isUndefinedOrNull=E;function w(M,L){if(!M)throw new Error(L?`Unexpected type, expected '${L}'`:"Unexpected type")}e.assertType=w;function v(M){if(E(M))throw new Error("Assertion Failed: argument is undefined or null");return M}e.assertIsDefined=v;function t(...M){const L=[];for(let R=0;R<M.length;R++){const T=M[R];if(E(T))throw new Error(`Assertion Failed: argument at index ${R} is undefined or null`);L.push(T)}return L}e.assertAllDefined=t;const f=Object.prototype.hasOwnProperty;function y(M){if(!C(M))return!1;for(let L in M)if(f.call(M,L))return!1;return!0}e.isEmptyObject=y;function b(M){return typeof M=="function"}e.isFunction=b;function P(...M){return M.length>0&&M.every(b)}e.areFunctions=P;function c(M,L){const R=Math.min(M.length,L.length);for(let T=0;T<R;T++)a(M[T],L[T])}e.validateConstraints=c;function a(M,L){if(r(L)){if(typeof M!==L)throw new Error(`argument does not match constraint: typeof ${L}`)}else if(b(L)){try{if(M instanceof L)return}catch{}if(!E(M)&&M.constructor===L||L.length===1&&L.call(void 0,M)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function l(M){let L=[],R=Object.getPrototypeOf(M);for(;Object.prototype!==R;)L=L.concat(Object.getOwnPropertyNames(R)),R=Object.getPrototypeOf(R);return L}e.getAllPropertyNames=l;function o(M){const L=[];for(const R of l(M))typeof M[R]=="function"&&L.push(R);return L}e.getAllMethodNames=o;function h(M,L){const R=_=>function(){const Q=Array.prototype.slice.call(arguments,0);return L(_,Q)};let T={};for(const _ of M)T[_]=R(_);return T}e.createProxyObject=h;function n(M){return M===null?void 0:M}e.withNullAsUndefined=n;function i(M){return typeof M=="undefined"?null:M}e.withUndefinedAsNull=i;function s(M){return class{constructor(){return new Proxy({},{get(L,R){if(L[R])return L[R];throw new Error(`Not Implemented: ${M}->${String(R)}`)}})}}}e.NotImplementedProxy=s;function u(M,L="Unreachable"){throw new Error(L)}e.assertNever=u;function m(M){return!!M&&typeof M.then=="function"&&typeof M.catch=="function"}e.isPromise=m}),define(x[32],ee([0,1,8,3,25,13]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(n){return n===47||n===92}e.isPathSeparator=k;function I(n){return n.replace(/[\\/]/g,p.posix.sep)}e.toSlashes=I;function d(n){return n.indexOf("/")===-1&&(n=I(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=d;function g(n,i=p.posix.sep){if(!n)return"";const s=n.length,u=n.charCodeAt(0);if(k(u)){if(k(n.charCodeAt(1))&&!k(n.charCodeAt(2))){let M=3;const L=M;for(;M<s&&!k(n.charCodeAt(M));M++);if(L!==M&&!k(n.charCodeAt(M+1))){for(M+=1;M<s;M++)if(k(n.charCodeAt(M)))return n.slice(0,M+1).replace(/[\\/]/g,i)}}return i}else if(b(u)&&n.charCodeAt(1)===58)return k(n.charCodeAt(2))?n.slice(0,2)+i:n.slice(0,2);let m=n.indexOf("://");if(m!==-1){for(m+=3;m<s;m++)if(k(n.charCodeAt(m)))return n.slice(0,m+1)}return""}e.getRoot=g;function S(n){if(!r.isWindows||!n||n.length<5)return!1;let i=n.charCodeAt(0);if(i!==92||(i=n.charCodeAt(1),i!==92))return!1;let s=2;const u=s;for(;s<n.length&&(i=n.charCodeAt(s),i!==92);s++);return!(u===s||(i=n.charCodeAt(s+1),isNaN(i)||i===92))}e.isUNC=S;const E=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function t(n,i=r.isWindows){const s=i?E:w;return!(!n||n.length===0||/^\s+$/.test(n)||(s.lastIndex=0,s.test(n))||i&&v.test(n)||n==="."||n===".."||i&&n[n.length-1]==="."||i&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=t;function f(n,i,s){const u=n===i;return!s||u?u:!n||!i?!1:(0,D.equalsIgnoreCase)(n,i)}e.isEqual=f;function y(n,i,s,u=p.sep){if(n===i)return!0;if(!n||!i||i.length>n.length)return!1;if(s){if(!(0,D.startsWithIgnoreCase)(n,i))return!1;if(i.length===n.length)return!0;let M=i.length;return i.charAt(i.length-1)===u&&M--,n.charAt(M)===u}return i.charAt(i.length-1)!==u&&(i+=u),n.indexOf(i)===0}e.isEqualOrParent=y;function b(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=b;function P(n,i){return r.isWindows&&n.endsWith(":")&&(n+=p.sep),(0,p.isAbsolute)(n)||(n=(0,p.join)(i,n)),n=(0,p.normalize)(n),r.isWindows?(n=(0,D.rtrim)(n,p.sep),n.endsWith(":")&&(n+=p.sep)):(n=(0,D.rtrim)(n,p.sep),n||(n=p.sep)),n}e.sanitizeFilePath=P;function c(n){const i=(0,p.normalize)(n);return r.isWindows?n.length>3?!1:a(i)&&(n.length===2||i.charCodeAt(2)===92):i===p.posix.sep}e.isRootOrDriveLetter=c;function a(n,i){return(i!==void 0?i:r.isWindows)?b(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function l(n){return a(n)?n[0]:void 0}e.getDriveLetter=l;function o(n,i,s){return i.length>n.length?-1:n===i?0:(s&&(n=n.toLowerCase(),i=i.toLowerCase()),n.indexOf(i))}e.indexOfPath=o;function h(n){const i=n.split(":");let s,u,m;if(i.forEach(M=>{const L=Number(M);(0,C.isNumber)(L)?u===void 0?u=L:m===void 0&&(m=L):s=s?[s,M].join(":"):M}),!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:u!==void 0?u:void 0,column:m!==void 0?m:u!==void 0?1:void 0}}e.parseLineAndColumnAware=h}),define(x[47],ee([0,1,13]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function r(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const y=Array.isArray(f)?[]:{};return Object.keys(f).forEach(b=>{f[b]&&typeof f[b]=="object"?y[b]=r(f[b]):y[b]=f[b]}),y}e.deepClone=r;function D(f){if(!f||typeof f!="object")return f;const y=[f];for(;y.length>0;){const b=y.shift();Object.freeze(b);for(const P in b)if(C.call(b,P)){const c=b[P];typeof c=="object"&&!Object.isFrozen(c)&&y.push(c)}}return f}e.deepFreeze=D;const C=Object.prototype.hasOwnProperty;function k(f,y){return I(f,y,new Set)}e.cloneAndChange=k;function I(f,y,b){if((0,p.isUndefinedOrNull)(f))return f;const P=y(f);if(typeof P!="undefined")return P;if((0,p.isArray)(f)){const c=[];for(const a of f)c.push(I(a,y,b));return c}if((0,p.isObject)(f)){if(b.has(f))throw new Error("Cannot clone recursive data-structure");b.add(f);const c={};for(let a in f)C.call(f,a)&&(c[a]=I(f[a],y,b));return b.delete(f),c}return f}function d(f,y,b=!0){return(0,p.isObject)(f)?((0,p.isObject)(y)&&Object.keys(y).forEach(P=>{P in f?b&&((0,p.isObject)(f[P])&&(0,p.isObject)(y[P])?d(f[P],y[P],b):f[P]=y[P]):f[P]=y[P]}),f):y}e.mixin=d;function g(f,y){if(f===y)return!0;if(f==null||y===null||y===void 0||typeof f!=typeof y||typeof f!="object"||Array.isArray(f)!==Array.isArray(y))return!1;let b,P;if(Array.isArray(f)){if(f.length!==y.length)return!1;for(b=0;b<f.length;b++)if(!g(f[b],y[b]))return!1}else{const c=[];for(P in f)c.push(P);c.sort();const a=[];for(P in y)a.push(P);if(a.sort(),!g(c,a))return!1;for(b=0;b<c.length;b++)if(!g(f[c[b]],y[c[b]]))return!1}return!0}e.equals=g;function S(f){const y=new Set;return JSON.stringify(f,(b,P)=>{if((0,p.isObject)(P)||Array.isArray(P)){if(y.has(P))return"[Circular]";y.add(P)}return P})}e.safeStringify=S;function E(f,y,b){const P=y(f);return typeof P=="undefined"?b:P}e.getOrDefault=E;function w(f,y){const b=Object.create(null);return!f||!y||Object.keys(y).forEach(c=>{const a=f[c],l=y[c];g(a,l)||(b[c]=l)}),b}e.distinct=w;function v(f,y){const b=y.toLowerCase(),P=Object.keys(f).find(c=>c.toLowerCase()===b);return P?f[P]:f[y]}e.getCaseInsensitive=v;function t(f,y){const b=Object.create(null);for(const[P,c]of Object.entries(f))y(P,c)&&(b[P]=c);return b}e.filter=t}),define(x[7],ee([0,1,8,3]),function(j,e,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,C=/^\//,k=/^\/\//;function I(n,i){if(!n.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!D.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!C.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function d(n,i){return!n&&!i?"file":n}function g(n,i){switch(n){case"https":case"http":case"file":i?i[0]!==E&&(i=E+i):i=E;break}return i}const S="",E="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{constructor(i,s,u,m,M,L=!1){typeof i=="object"?(this.scheme=i.scheme||S,this.authority=i.authority||S,this.path=i.path||S,this.query=i.query||S,this.fragment=i.fragment||S):(this.scheme=d(i,L),this.authority=s||S,this.path=g(this.scheme,u||S),this.query=m||S,this.fragment=M||S,I(this,L))}static isUri(i){return i instanceof v?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return c(this,!1)}with(i){if(!i)return this;let{scheme:s,authority:u,path:m,query:M,fragment:L}=i;return s===void 0?s=this.scheme:s===null&&(s=S),u===void 0?u=this.authority:u===null&&(u=S),m===void 0?m=this.path:m===null&&(m=S),M===void 0?M=this.query:M===null&&(M=S),L===void 0?L=this.fragment:L===null&&(L=S),s===this.scheme&&u===this.authority&&m===this.path&&M===this.query&&L===this.fragment?this:new f(s,u,m,M,L)}static parse(i,s=!1){const u=w.exec(i);return u?new f(u[2]||S,h(u[4]||S),h(u[5]||S),h(u[7]||S),h(u[9]||S),s):new f(S,S,S,S,S)}static file(i){let s=S;if(r.isWindows&&(i=i.replace(/\\/g,E)),i[0]===E&&i[1]===E){const u=i.indexOf(E,2);u===-1?(s=i.substring(2),i=E):(s=i.substring(2,u),i=i.substring(u)||E)}return new f("file",s,i,S,S)}static from(i){const s=new f(i.scheme,i.authority,i.path,i.query,i.fragment);return I(s,!0),s}static joinPath(i,...s){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return r.isWindows&&i.scheme==="file"?u=v.file(p.win32.join(c(i,!0),...s)).path:u=p.posix.join(i.path,...s),i.with({path:u})}toString(i=!1){return a(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof v)return i;{const s=new f(i);return s._formatted=i.external,s._fsPath=i._sep===t?i.fsPath:null,s}}else return i}}e.URI=v;const t=r.isWindows?1:void 0;class f extends v{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(i=!1){return i?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=t),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const y={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(n,i){let s,u=-1;for(let m=0;m<n.length;m++){const M=n.charCodeAt(m);if(M>=97&&M<=122||M>=65&&M<=90||M>=48&&M<=57||M===45||M===46||M===95||M===126||i&&M===47)u!==-1&&(s+=encodeURIComponent(n.substring(u,m)),u=-1),s!==void 0&&(s+=n.charAt(m));else{s===void 0&&(s=n.substr(0,m));const L=y[M];L!==void 0?(u!==-1&&(s+=encodeURIComponent(n.substring(u,m)),u=-1),s+=L):u===-1&&(u=m)}}return u!==-1&&(s+=encodeURIComponent(n.substring(u))),s!==void 0?s:n}function P(n){let i;for(let s=0;s<n.length;s++){const u=n.charCodeAt(s);u===35||u===63?(i===void 0&&(i=n.substr(0,s)),i+=y[u]):i!==void 0&&(i+=n[s])}return i!==void 0?i:n}function c(n,i){let s;return n.authority&&n.path.length>1&&n.scheme==="file"?s=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?i?s=n.path.substr(1):s=n.path[1].toLowerCase()+n.path.substr(2):s=n.path,r.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=c;function a(n,i){const s=i?P:b;let u="",{scheme:m,authority:M,path:L,query:R,fragment:T}=n;if(m&&(u+=m,u+=":"),(M||m==="file")&&(u+=E,u+=E),M){let _=M.indexOf("@");if(_!==-1){const Q=M.substr(0,_);M=M.substr(_+1),_=Q.indexOf(":"),_===-1?u+=s(Q,!1):(u+=s(Q.substr(0,_),!1),u+=":",u+=s(Q.substr(_+1),!1)),u+="@"}M=M.toLowerCase(),_=M.indexOf(":"),_===-1?u+=s(M,!1):(u+=s(M.substr(0,_),!1),u+=M.substr(_))}if(L){if(L.length>=3&&L.charCodeAt(0)===47&&L.charCodeAt(2)===58){const _=L.charCodeAt(1);_>=65&&_<=90&&(L=`/${String.fromCharCode(_+32)}:${L.substr(3)}`)}else if(L.length>=2&&L.charCodeAt(1)===58){const _=L.charCodeAt(0);_>=65&&_<=90&&(L=`${String.fromCharCode(_+32)}:${L.substr(2)}`)}u+=s(L,!0)}return R&&(u+="?",u+=s(R,!1)),T&&(u+="#",u+=i?T:b(T,!1)),u}function l(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+l(n.substr(3)):n}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function h(n){return n.match(o)?n.replace(o,i=>l(i)):n}}),define(x[109],ee([0,1,7]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function r(g){const S=g;return S&&typeof S.type=="string"&&typeof S.severity=="string"}e.isRemoteConsoleLog=r;function D(g){const S=[];let E;try{const w=JSON.parse(g.arguments),v=w[w.length-1];v&&v.__$stack&&(w.pop(),E=v.__$stack),S.push(...w)}catch{S.push("Unable to log remote console arguments",g.arguments)}return{args:S,stack:E}}e.parse=D;function C(g){if(typeof g!="string")return C(D(g).stack);const S=g;if(S){const E=k(S),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(w&&w.length===4)return{uri:p.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}e.getFirstFrame=C;function k(g){if(!g)return g;const S=g.indexOf(`
`);return S===-1?g:g.substring(0,S)}function I(g,S){const{args:E,stack:w}=D(g),v=typeof E[0]=="string"&&E.length===1;let t=k(w);t&&(t=`(${t.trim()})`);let f=[];if(typeof E[0]=="string"?t&&v?f=[`%c[${S}] %c${E[0]} %c${t}`,d("blue"),d(""),d("grey")]:f=[`%c[${S}] %c${E[0]}`,d("blue"),d(""),...E.slice(1)]:f=[`%c[${S}]%`,d("blue"),...E],t&&!v&&f.push(t),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,f)}e.log=I;function d(g){return`color: ${g}`}}),define(x[110],ee([0,1,17,25,7]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function C(S){return JSON.stringify(S,d)}e.stringify=C;function k(S){let E=JSON.parse(S);return E=g(E),E}e.parse=k;var I;(function(S){S[S.Uri=1]="Uri",S[S.Regexp=2]="Regexp",S[S.ScmResource=3]="ScmResource",S[S.ScmResourceGroup=4]="ScmResourceGroup",S[S.ScmProvider=5]="ScmProvider",S[S.CommentController=6]="CommentController",S[S.CommentThread=7]="CommentThread",S[S.CommentThreadReply=8]="CommentThreadReply",S[S.CommentNode=9]="CommentNode",S[S.CommentThreadNode=10]="CommentThreadNode",S[S.TimelineActionContext=11]="TimelineActionContext",S[S.NotebookCellActionContext=12]="NotebookCellActionContext",S[S.TestItemContext=13]="TestItemContext"})(I=e.MarshalledId||(e.MarshalledId={}));function d(S,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:(0,r.regExpFlags)(E)}:E}function g(S,E=0){if(!S||E>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return D.URI.revive(S);case 2:return new RegExp(S.source,S.flags)}if(S instanceof p.VSBuffer||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let w=0;w<S.length;++w)S[w]=g(S[w],E+1);else for(const w in S)Object.hasOwnProperty.call(S,w)&&(S[w]=g(S[w],E+1))}return S}e.revive=g}),define(x[10],ee([0,1,3,7]),function(j,e,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.userData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls"})(D=e.Schemas||(e.Schemas={}));class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(d){this._preferredWebSchema=d}setDelegate(d){this._delegate=d}set(d,g,S){this._hosts[d]=g,this._ports[d]=S}setConnectionToken(d,g){this._connectionTokens[d]=g}rewrite(d){if(this._delegate)return this._delegate(d);const g=d.authority;let S=this._hosts[g];S&&S.indexOf(":")!==-1&&(S=`[${S}]`);const E=this._ports[g],w=this._connectionTokens[g];let v=`path=${encodeURIComponent(d.path)}`;return typeof w=="string"&&(v+=`&tkn=${encodeURIComponent(w)}`),r.URI.from({scheme:p.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${S}:${E}`,path:"/vscode-remote-resource",query:v})}}e.RemoteAuthorities=new C;class k{asBrowserUri(d,g){const S=this.toUri(d,g);return S.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(S):S.scheme===D.file&&(p.isNative||typeof p.globals.importScripts=="function"&&p.globals.origin===`${D.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?S.with({scheme:D.vscodeFileResource,authority:S.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):S}asFileUri(d,g){const S=this.toUri(d,g);return S.scheme===D.vscodeFileResource?S.with({scheme:D.file,authority:S.authority!==k.FALLBACK_AUTHORITY?S.authority:null,query:null,fragment:null}):S}toUri(d,g){return r.URI.isUri(d)?d:r.URI.parse(g.toUrl(d))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k}),define(x[16],ee([0,1,32,10,8,3,25,7]),function(j,e,p,r,D,C,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function d(v){return(0,I.uriToFsPath)(v,!0)}e.originalFSPath=d;class g{constructor(t){this._ignorePathCasing=t}compare(t,f,y=!1){return t===f?0:(0,k.compare)(this.getComparisonKey(t,y),this.getComparisonKey(f,y))}isEqual(t,f,y=!1){return t===f?!0:!t||!f?!1:this.getComparisonKey(t,y)===this.getComparisonKey(f,y)}getComparisonKey(t,f=!1){return t.with({path:this._ignorePathCasing(t)?t.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(t){return this._ignorePathCasing(t)}isEqualOrParent(t,f,y=!1){if(t.scheme===f.scheme){if(t.scheme===r.Schemas.file)return p.isEqualOrParent(d(t),d(f),this._ignorePathCasing(t))&&t.query===f.query&&(y||t.fragment===f.fragment);if((0,e.isEqualAuthority)(t.authority,f.authority))return p.isEqualOrParent(t.path,f.path,this._ignorePathCasing(t),"/")&&t.query===f.query&&(y||t.fragment===f.fragment)}return!1}joinPath(t,...f){return I.URI.joinPath(t,...f)}basenameOrAuthority(t){return(0,e.basename)(t)||t.authority}basename(t){return D.posix.basename(t.path)}extname(t){return D.posix.extname(t.path)}dirname(t){if(t.path.length===0)return t;let f;return t.scheme===r.Schemas.file?f=I.URI.file(D.dirname(d(t))).path:(f=D.posix.dirname(t.path),t.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${t.toString})) resulted in a relative path`),f="/")),t.with({path:f})}normalizePath(t){if(!t.path.length)return t;let f;return t.scheme===r.Schemas.file?f=I.URI.file(D.normalize(d(t))).path:f=D.posix.normalize(t.path),t.with({path:f})}relativePath(t,f){if(t.scheme!==f.scheme||!(0,e.isEqualAuthority)(t.authority,f.authority))return;if(t.scheme===r.Schemas.file){const P=D.relative(d(t),d(f));return C.isWindows?p.toSlashes(P):P}let y=t.path||"/",b=f.path||"/";if(this._ignorePathCasing(t)){let P=0;for(const c=Math.min(y.length,b.length);P<c&&!(y.charCodeAt(P)!==b.charCodeAt(P)&&y.charAt(P).toLowerCase()!==b.charAt(P).toLowerCase());P++);y=b.substr(0,P)+y.substr(P)}return D.posix.relative(y,b)}resolvePath(t,f){if(t.scheme===r.Schemas.file){const y=I.URI.file(D.resolve(d(t),f));return t.with({authority:y.authority,path:y.path})}return f=p.toPosixPath(f),t.with({path:D.posix.resolve(t.path,f)})}isAbsolutePath(t){return!!t.path&&t.path[0]==="/"}isEqualAuthority(t,f){return t===f||t!==void 0&&f!==void 0&&(0,k.equalsIgnoreCase)(t,f)}hasTrailingPathSeparator(t,f=D.sep){if(t.scheme===r.Schemas.file){const y=d(t);return y.length>p.getRoot(y).length&&y[y.length-1]===f}else{const y=t.path;return y.length>1&&y.charCodeAt(y.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(t.fsPath)}}removeTrailingPathSeparator(t,f=D.sep){return(0,e.hasTrailingPathSeparator)(t,f)?t.with({path:t.path.substr(0,t.path.length-1)}):t}addTrailingPathSeparator(t,f=D.sep){let y=!1;if(t.scheme===r.Schemas.file){const b=d(t);y=b!==void 0&&b.length===p.getRoot(b).length&&b[b.length-1]===f}else{f="/";const b=t.path;y=b.length===1&&b.charCodeAt(b.length-1)===47}return!y&&!(0,e.hasTrailingPathSeparator)(t,f)?t.with({path:t.path+"/"}):t}}e.ExtUri=g,e.extUri=new g(()=>!1),e.extUriBiasedIgnorePathCase=new g(v=>v.scheme===r.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new g(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function S(v,t){const f=[];for(let y=0;y<v.length;y++){const b=t(v[y]);v.some((P,c)=>c===y?!1:(0,e.isEqualOrParent)(b,t(P)))||f.push(v[y])}return f}e.distinctParents=S;var E;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function t(f){const y=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(c=>{const[a,l]=c.split(":");a&&l&&y.set(a,l)});const P=f.path.substring(0,f.path.indexOf(";"));return P&&y.set(v.META_DATA_MIME,P),y}v.parseMetaData=t})(E=e.DataUri||(e.DataUri={}));function w(v,t,f){if(t){let y=v.path;return y&&y[0]!==D.posix.sep&&(y=D.posix.sep+y),v.with({scheme:f,authority:t,path:y})}return v.with({scheme:f})}e.toLocalResource=w}),define(x[9],ee([0,1,23,15,4,2,16,3]),function(j,e,p,r,D,C,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function d(U){return!!U&&typeof U.then=="function"}e.isThenable=d;function g(U){const A=new p.CancellationTokenSource,W=U(A.token),F=new Promise((N,H)=>{const O=A.token.onCancellationRequested(()=>{O.dispose(),A.dispose(),H((0,r.canceled)())});Promise.resolve(W).then(z=>{O.dispose(),A.dispose(),N(z)},z=>{O.dispose(),A.dispose(),H(z)})});return new class{cancel(){A.cancel()}then(N,H){return F.then(N,H)}catch(N){return this.then(void 0,N)}finally(N){return F.finally(N)}}}e.createCancelablePromise=g;function S(U,A,W){return Promise.race([U,new Promise(F=>A.onCancellationRequested(()=>F(W)))])}e.raceCancellation=S;async function E(U){let A=-1;const W=U.map((N,H)=>N.then(O=>(A=H,O))),F=await Promise.race(W);return U.forEach((N,H)=>{H!==A&&N.cancel()}),F}e.raceCancellablePromises=E;function w(U,A,W){let F;const N=setTimeout(()=>{F?.(void 0),W?.()},A);return Promise.race([U.finally(()=>clearTimeout(N)),new Promise(H=>F=H)])}e.raceTimeout=w;function v(U){return new Promise((A,W)=>{const F=U();d(F)?F.then(A,W):A(F)})}e.asPromise=v;class t{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(A){if(this.activePromise){if(this.queuedPromiseFactory=A,!this.queuedPromise){const W=()=>{this.queuedPromise=null;const F=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,F};this.queuedPromise=new Promise(F=>{this.activePromise.then(W,W).then(F)})}return new Promise((W,F)=>{this.queuedPromise.then(W,F)})}return this.activePromise=A(),new Promise((W,F)=>{this.activePromise.then(N=>{this.activePromise=null,W(N)},N=>{this.activePromise=null,F(N)})})}}e.Throttler=t;class f{constructor(){this.current=Promise.resolve(null)}queue(A){return this.current=this.current.then(()=>A(),()=>A())}}e.Sequencer=f;class y{constructor(){this.promiseMap=new Map}queue(A,W){const N=(this.promiseMap.get(A)??Promise.resolve()).catch(()=>{}).then(W).finally(()=>{this.promiseMap.get(A)===N&&this.promiseMap.delete(A)});return this.promiseMap.set(A,N),N}}e.SequencerByKey=y;class b{constructor(A){this.defaultDelay=A,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(A,W=this.defaultDelay){return this.task=A,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((F,N)=>{this.doResolve=F,this.doReject=N}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const F=this.task;return this.task=null,F()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},W),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,r.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=b;class P{constructor(A){this.delayer=new b(A),this.throttler=new t}trigger(A,W){return this.delayer.trigger(()=>this.throttler.queue(A),W)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=P;class c{constructor(){this._isOpen=!1,this._promise=new Promise((A,W)=>{this._completePromise=A})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=c;class a extends c{constructor(A){super();this._timeout=setTimeout(()=>this.open(),A)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function l(U,A){return A?new Promise((W,F)=>{const N=setTimeout(()=>{H.dispose(),W()},U),H=A.onCancellationRequested(()=>{clearTimeout(N),H.dispose(),F((0,r.canceled)())})}):g(W=>l(U,W))}e.timeout=l;function o(U,A=0){const W=setTimeout(U,A);return(0,C.toDisposable)(()=>clearTimeout(W))}e.disposableTimeout=o;function h(U){const A=[];let W=0;const F=U.length;function N(){return W<F?U[W++]():null}function H(O){O!=null&&A.push(O);const z=N();return z?z.then(H):Promise.resolve(A)}return Promise.resolve(null).then(H)}e.sequence=h;function n(U,A=F=>!!F,W=null){let F=0;const N=U.length,H=()=>{if(F>=N)return Promise.resolve(W);const O=U[F++];return Promise.resolve(O()).then(te=>A(te)?Promise.resolve(te):H())};return H()}e.first=n;function i(U,A=F=>!!F,W=null){if(U.length===0)return Promise.resolve(W);let F=U.length;const N=()=>{F=-1;for(const H of U)H.cancel?.()};return new Promise((H,O)=>{for(const z of U)z.then(te=>{--F>=0&&A(te)?(N(),H(te)):F===0&&H(W)}).catch(te=>{--F>=0&&(N(),O(te))})})}e.firstParallel=i;class s{constructor(A){this._size=0,this.maxDegreeOfParalellism=A,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(A){return this._size++,new Promise((W,F)=>{this.outstandingPromises.push({factory:A,c:W,e:F}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const A=this.outstandingPromises.shift();this.runningPromises++;const W=A.factory();W.then(A.c,A.e),W.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=s;class u extends s{constructor(){super(1)}}e.Queue=u;class m{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const A=new B;return this.drainers.add(A),A.p}isDrained(){for(const[,A]of this.queues)if(A.size>0)return!1;return!0}queueFor(A,W=k.extUri){const F=W.getComparisonKey(A);let N=this.queues.get(F);return N||(N=new u,D.Event.once(N.onFinished)(()=>{N?.dispose(),this.queues.delete(F),this.onDidQueueFinish()}),this.queues.set(F,N)),N}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const A of this.drainers)A.complete();this.drainers.clear()}dispose(){for(const[,A]of this.queues)A.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=m;class M{constructor(A,W){this._token=-1,typeof A=="function"&&typeof W=="number"&&this.setIfNotSet(A,W)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(A,W){this.cancel(),this._token=setTimeout(()=>{this._token=-1,A()},W)}setIfNotSet(A,W){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,A()},W))}}e.TimeoutTimer=M;class L{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(A,W){this.cancel(),this._token=setInterval(()=>{A()},W)}}e.IntervalTimer=L;class R{constructor(A,W){this.timeoutToken=-1,this.runner=A,this.timeout=W,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(A=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,A)}get delay(){return this.timeout}set delay(A){this.timeout=A}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class T{constructor(A,W){W%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.runner=A,this.timeout=W,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(A=this.timeout){A%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(A/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=T;class _ extends R{constructor(A,W){super(A,W);this.units=[]}work(A){this.units.push(A),this.isScheduled()||this.schedule()}doRun(){const A=this.units;this.units=[],this.runner&&this.runner(A)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=_;class Q extends C.Disposable{constructor(A,W,F,N){super();this.maxWorkChunkSize=A,this.maxPendingWork=W,this.throttleDelay=F,this.handler=N,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(A){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+A.length>this.maxPendingWork)return!1}else if(this.pending+A.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...A),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new R(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=Q,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=U=>{(0,I.setTimeout0)(()=>{if(A)return;const W=Date.now()+15;U(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,W-Date.now())}}))});let A=!1;return{dispose(){A||(A=!0)}}}:e.runWhenIdle=(U,A)=>{const W=requestIdleCallback(U,typeof A=="number"?{timeout:A}:void 0);let F=!1;return{dispose(){F||(F=!0,cancelIdleCallback(W))}}}}();class se{constructor(A){this._didRun=!1,this._executor=()=>{try{this._value=A()}catch(W){this._error=W}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=se;async function re(U,A,W){let F;for(let N=0;N<W;N++)try{return await U()}catch(H){F=H,await l(A)}throw F}e.retry=re;class G{hasPending(A){return this._pending?typeof A=="number"?this._pending.taskId===A:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(A,W,F){return this._pending={taskId:A,cancel:()=>F?.(),promise:W},W.then(()=>this.donePending(A),()=>this.donePending(A)),W}donePending(A){this._pending&&A===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const A=this._next;this._next=void 0,A.run().then(A.promiseResolve,A.promiseReject)}}setNext(A){if(this._next)this._next.run=A;else{let W,F;const N=new Promise((H,O)=>{W=H,F=O});this._next={run:A,promise:N,promiseResolve:W,promiseReject:F}}return this._next.promise}}e.TaskSequentializer=G;class X{constructor(A,W=()=>Date.now()){this.interval=A,this.nowFn=W,this.lastIncrementTime=0,this.value=0}increment(){const A=this.nowFn();return A-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=A,this.value=0),this.value++,this.value}}e.IntervalCounter=X;class B{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((A,W)=>{this.completeCallback=A,this.errorCallback=W})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(A){return new Promise(W=>{this.completeCallback(A),this.resolved=!0,W()})}error(A){return new Promise(W=>{this.errorCallback(A),this.rejected=!0,W()})}cancel(){new Promise(A=>{this.errorCallback((0,r.canceled)()),this.rejected=!0,A()})}}e.DeferredPromise=B;var $;(function(U){async function A(F){let N;const H=await Promise.all(F.map(O=>O.then(z=>z,z=>{N||(N=z)})));if(typeof N!="undefined")throw N;return H}U.settled=A;function W(F){return new Promise(async(N,H)=>{try{await F(N,H)}catch(O){H(O)}})}U.withAsyncBody=W})($=e.Promises||(e.Promises={}));var Y;(function(U){U[U.Initial=0]="Initial",U[U.DoneOK=1]="DoneOK",U[U.DoneError=2]="DoneError"})(Y||(Y={}));class V{constructor(A){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const W={emitOne:F=>this.emitOne(F),emitMany:F=>this.emitMany(F),reject:F=>this.reject(F)};try{await Promise.resolve(A(W)),this.resolve()}catch(F){this.reject(F)}finally{W.emitOne=void 0,W.emitMany=void 0,W.reject=void 0}})}static fromArray(A){return new V(W=>{W.emitMany(A)})}static fromPromise(A){return new V(async W=>{W.emitMany(await A)})}static fromPromises(A){return new V(async W=>{await Promise.all(A.map(async F=>W.emitOne(await F)))})}static merge(A){return new V(async W=>{await Promise.all(A.map(async F=>{for await(const N of F)W.emitOne(N)}))})}[Symbol.asyncIterator](){let A=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(A<this._results.length)return{done:!1,value:this._results[A++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(A,W){return new V(async F=>{for await(const N of A)F.emitOne(W(N))})}map(A){return V.map(this,A)}static filter(A,W){return new V(async F=>{for await(const N of A)W(N)&&F.emitOne(N)})}filter(A){return V.filter(this,A)}static coalesce(A){return V.filter(A,W=>!!W)}coalesce(){return V.coalesce(this)}static async toPromise(A){const W=[];for await(const F of A)W.push(F);return W}toPromise(){return V.toPromise(this)}emitOne(A){this._state===0&&(this._results.push(A),this._onStateChanged.fire())}emitMany(A){this._state===0&&(this._results=this._results.concat(A),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(A){this._state===0&&(this._state=2,this._error=A,this._onStateChanged.fire())}}e.AsyncIterableObject=V,V.EMPTY=V.fromArray([]);class q extends V{constructor(A,W){super(W);this._source=A}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=q;function Z(U){const A=new p.CancellationTokenSource,W=U(A.token);return new q(A,async F=>{const N=A.token.onCancellationRequested(()=>{N.dispose(),A.dispose(),F.reject((0,r.canceled)())});try{for await(const H of W){if(A.token.isCancellationRequested)return;F.emitOne(H)}N.dispose(),A.dispose()}catch(H){N.dispose(),A.dispose(),F.reject(H)}})}e.createCancelableAsyncIterable=Z}),define(x[33],ee([0,1,32,10,8,3,16,25,7]),function(j,e,p,r,D,C,k,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function g(i,s,u){if(typeof i=="string"&&(i=d.URI.file(i)),u){const M=u.getWorkspaceFolder(i);if(M){const L=u.getWorkspace().folders.length>1;let R;if((0,k.isEqual)(M.uri,i)?R="":R=(0,k.relativePath)(M.uri,i),L){const T=M.name?M.name:(0,k.basename)(M.uri);R=R?T+" \u2022 "+R:T}return R}}if(i.scheme!==r.Schemas.file&&i.scheme!==r.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,p.hasDriveLetter)(i.fsPath))return(0,D.normalize)(E(i.fsPath));let m=(0,D.normalize)(i.fsPath);return!C.isWindows&&s?.userHome&&(m=v(m,s.userHome.fsPath)),m}e.getPathLabel=g;function S(i){if(!i)return;typeof i=="string"&&(i=d.URI.file(i));const s=(0,k.basename)(i)||(i.scheme===r.Schemas.file?i.fsPath:i.path);return C.isWindows&&(0,p.isRootOrDriveLetter)(s)?E(s):s}e.getBaseLabel=S;function E(i,s){return(0,p.hasDriveLetter)(i,s)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=E;let w=Object.create(null);function v(i,s){if(C.isWindows||!i||!s)return i;let u=w.original===s?w.normalized:void 0;return u||(u=`${(0,I.rtrim)(s,D.posix.sep)}${D.posix.sep}`,w={original:s,normalized:u}),(C.isLinux?i.startsWith(u):(0,I.startsWithIgnoreCase)(i,u))&&(i=`~/${i.substr(u.length)}`),i}e.tildify=v;function t(i,s){return i.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=t;const f="\u2026",y="\\\\",b="~";function P(i,s=D.sep){const u=new Array(i.length);let m=!1;for(let M=0;M<i.length;M++){let L=i[M];if(L===""){u[M]=`.${s}`;continue}if(!L){u[M]=L;continue}m=!0;let R="";L.indexOf(y)===0?(R=L.substr(0,L.indexOf(y)+y.length),L=L.substr(L.indexOf(y)+y.length)):L.indexOf(s)===0?(R=L.substr(0,L.indexOf(s)+s.length),L=L.substr(L.indexOf(s)+s.length)):L.indexOf(b)===0&&(R=L.substr(0,L.indexOf(b)+b.length),L=L.substr(L.indexOf(b)+b.length));const T=L.split(s);for(let _=1;m&&_<=T.length;_++)for(let Q=T.length-_;m&&Q>=0;Q--){m=!1;let se=T.slice(Q,Q+_).join(s);for(let re=0;!m&&re<i.length;re++)if(re!==M&&i[re]&&i[re].indexOf(se)>-1){const G=Q+_===T.length,X=Q>0&&i[re].indexOf(s)>-1?s+se:se,B=i[re].endsWith(X);m=!G||B}if(!m){let re="";(T[0].endsWith(":")||R!=="")&&(Q===1&&(Q=0,_++,se=T[0]+s+se),Q>0&&(re=T[0]+s),re=R+re),Q>0&&(re=re+f+s),re=re+se,Q+_<T.length&&(re=re+s+f),u[M]=re}}m&&(u[M]=L)}return u}e.shorten=P;var c;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function a(i,s=Object.create(null)){const u=[];let m=!1,M="";for(const L of i)if(L==="$"||m&&L==="{")M&&u.push({value:M,type:c.TEXT}),M="",m=!0;else if(L==="}"&&m){const R=s[M];if(typeof R=="string")R.length&&u.push({value:R,type:c.VARIABLE});else if(R){const T=u[u.length-1];(!T||T.type!==c.SEPARATOR)&&u.push({value:R.label,type:c.SEPARATOR})}M="",m=!1}else M+=L;return M&&!m&&u.push({value:M,type:c.TEXT}),u.filter((L,R)=>{if(L.type===c.SEPARATOR){const T=u[R-1],_=u[R+1];return[T,_].every(Q=>Q&&(Q.type===c.VARIABLE||Q.type===c.TEXT)&&Q.value.length>0)}return!0}).map(L=>L.value).join("")}e.template=a;function l(i,s){return C.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):i.replace(/&&|&/g,u=>u==="&"?"&&":"&")}e.mnemonicMenuLabel=l;function o(i,s){return C.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,""):C.isWindows?i.replace(/&&|&/g,u=>u==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=o;function h(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=h;function n(i){const s=i.indexOf("/")!==-1?D.posix:D.win32,u=s.basename(i),m=s.dirname(i);return u.length?{name:u,parentPath:m}:{name:m,parentPath:""}}e.splitName=n}),define(x[111],ee([0,1,7]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function r(S){return S.toJSON()}class D{constructor(E){this._uriTransformer=E}transformIncoming(E){const w=this._uriTransformer.transformIncoming(E);return w===E?E:r(p.URI.from(w))}transformOutgoing(E){const w=this._uriTransformer.transformOutgoing(E);return w===E?E:r(p.URI.from(w))}transformOutgoingURI(E){const w=this._uriTransformer.transformOutgoing(E);return w===E?E:p.URI.from(w)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function C(S,E,w){if(!S||w>200)return null;if(typeof S=="object"){if(S instanceof p.URI)return E.transformOutgoing(S);for(let v in S)if(Object.hasOwnProperty.call(S,v)){const t=C(S[v],E,w+1);t!==null&&(S[v]=t)}}return null}function k(S,E){const w=C(S,E,0);return w===null?S:w}e.transformOutgoingURIs=k;function I(S,E,w,v){if(!S||v>200)return null;if(typeof S=="object"){if(S.$mid===1)return w?p.URI.revive(E.transformIncoming(S)):E.transformIncoming(S);for(let t in S)if(Object.hasOwnProperty.call(S,t)){const f=I(S[t],E,w,v+1);f!==null&&(S[t]=f)}}return null}function d(S,E){const w=I(S,E,!1,0);return w===null?S:w}e.transformIncomingURIs=d;function g(S,E){const w=I(S,E,!0,0);return w===null?S:w}e.transformAndReviveIncomingURIs=g}),define(x[27],ee([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const p=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function r(d){return p.test(d)}e.isUUID=r;const D=new Uint8Array(16),C=[];for(let d=0;d<256;d++)C.push(d.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(d){for(let g=0;g<d.length;g++)d[g]=Math.floor(Math.random()*256);return d};function I(){k(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let d=0,g="";return g+=C[D[d++]],g+=C[D[d++]],g+=C[D[d++]],g+=C[D[d++]],g+="-",g+=C[D[d++]],g+=C[D[d++]],g+="-",g+=C[D[d++]],g+=C[D[d++]],g+="-",g+=C[D[d++]],g+=C[D[d++]],g+="-",g+=C[D[d++]],g+=C[D[d++]],g+=C[D[d++]],g+=C[D[d++]],g+=C[D[d++]],g+=C[D[d++]],g}e.generateUuid=I}),define(x[112],ee([0,1,15,4,2,3,13,25]),function(j,e,p,r,D,C,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=e.SimpleWorkerServer=e.SimpleWorkerClient=e.logOnceWebWorkerWarning=void 0;const d="$initialize";let g=!1;function S(n){!C.isWeb||(g||(g=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(n.message))}e.logOnceWebWorkerWarning=S;var E;(function(n){n[n.Request=0]="Request",n[n.Reply=1]="Reply",n[n.SubscribeEvent=2]="SubscribeEvent",n[n.Event=3]="Event",n[n.UnsubscribeEvent=4]="UnsubscribeEvent"})(E||(E={}));class w{constructor(i,s,u,m){this.vsWorker=i,this.req=s,this.method=u,this.args=m,this.type=0}}class v{constructor(i,s,u,m){this.vsWorker=i,this.seq=s,this.res=u,this.err=m,this.type=1}}class t{constructor(i,s,u,m){this.vsWorker=i,this.req=s,this.eventName=u,this.arg=m,this.type=2}}class f{constructor(i,s,u){this.vsWorker=i,this.req=s,this.event=u,this.type=3}}class y{constructor(i,s){this.vsWorker=i,this.req=s,this.type=4}}class b{constructor(i){this._workerId=-1,this._handler=i,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(i){this._workerId=i}sendMessage(i,s){const u=String(++this._lastSentReq);return new Promise((m,M)=>{this._pendingReplies[u]={resolve:m,reject:M},this._send(new w(this._workerId,u,i,s))})}listen(i,s){let u=null;const m=new r.Emitter({onFirstListenerAdd:()=>{u=String(++this._lastSentReq),this._pendingEmitters.set(u,m),this._send(new t(this._workerId,u,i,s))},onLastListenerRemove:()=>{this._pendingEmitters.delete(u),this._send(new y(this._workerId,u)),u=null}});return m.event}handleMessage(i){!i||!i.vsWorker||this._workerId!==-1&&i.vsWorker!==this._workerId||this._handleMessage(i)}_handleMessage(i){switch(i.type){case 1:return this._handleReplyMessage(i);case 0:return this._handleRequestMessage(i);case 2:return this._handleSubscribeEventMessage(i);case 3:return this._handleEventMessage(i);case 4:return this._handleUnsubscribeEventMessage(i)}}_handleReplyMessage(i){if(!this._pendingReplies[i.seq]){console.warn("Got reply to unknown seq");return}let s=this._pendingReplies[i.seq];if(delete this._pendingReplies[i.seq],i.err){let u=i.err;i.err.$isError&&(u=new Error,u.name=i.err.name,u.message=i.err.message,u.stack=i.err.stack),s.reject(u);return}s.resolve(i.res)}_handleRequestMessage(i){let s=i.req;this._handler.handleMessage(i.method,i.args).then(m=>{this._send(new v(this._workerId,s,m,void 0))},m=>{m.detail instanceof Error&&(m.detail=(0,p.transformErrorForSerialization)(m.detail)),this._send(new v(this._workerId,s,void 0,(0,p.transformErrorForSerialization)(m)))})}_handleSubscribeEventMessage(i){const s=i.req,u=this._handler.handleEvent(i.eventName,i.arg)(m=>{this._send(new f(this._workerId,s,m))});this._pendingEvents.set(s,u)}_handleEventMessage(i){if(!this._pendingEmitters.has(i.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(i.req).fire(i.event)}_handleUnsubscribeEventMessage(i){if(!this._pendingEvents.has(i.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(i.req).dispose(),this._pendingEvents.delete(i.req)}_send(i){let s=[];if(i.type===0)for(let u=0;u<i.args.length;u++)i.args[u]instanceof ArrayBuffer&&s.push(i.args[u]);else i.type===1&&i.res instanceof ArrayBuffer&&s.push(i.res);this._handler.sendMessage(i,s)}}class P extends D.Disposable{constructor(i,s,u){super();let m=null;this._worker=this._register(i.create("vs/base/common/worker/simpleWorker",_=>{this._protocol.handleMessage(_)},_=>{m&&m(_)})),this._protocol=new b({sendMessage:(_,Q)=>{this._worker.postMessage(_,Q)},handleMessage:(_,Q)=>{if(typeof u[_]!="function")return Promise.reject(new Error("Missing method "+_+" on main thread host."));try{return Promise.resolve(u[_].apply(u,Q))}catch(se){return Promise.reject(se)}},handleEvent:(_,Q)=>{if(a(_)){const se=u[_].call(u,Q);if(typeof se!="function")throw new Error(`Missing dynamic event ${_} on main thread host.`);return se}if(c(_)){const se=u[_];if(typeof se!="function")throw new Error(`Missing event ${_} on main thread host.`);return se}throw new Error(`Malformed event name ${_}`)}}),this._protocol.setWorkerId(this._worker.getId());let M=null;typeof C.globals.require!="undefined"&&typeof C.globals.require.getConfig=="function"?M=C.globals.require.getConfig():typeof C.globals.requirejs!="undefined"&&(M=C.globals.requirejs.s.contexts._.config);const L=k.getAllMethodNames(u);this._onModuleLoaded=this._protocol.sendMessage(d,[this._worker.getId(),JSON.parse(JSON.stringify(M)),s,L]);const R=(_,Q)=>this._request(_,Q),T=(_,Q)=>this._protocol.listen(_,Q);this._lazyProxy=new Promise((_,Q)=>{m=Q,this._onModuleLoaded.then(se=>{_(l(se,R,T))},se=>{Q(se),this._onError("Worker failed to load "+s,se)})})}getProxyObject(){return this._lazyProxy}_request(i,s){return new Promise((u,m)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(i,s).then(u,m)},m)})}_onError(i,s){console.error(i),console.info(s)}}e.SimpleWorkerClient=P;function c(n){return n[0]==="o"&&n[1]==="n"&&I.isUpperAsciiLetter(n.charCodeAt(2))}function a(n){return/^onDynamic/.test(n)&&I.isUpperAsciiLetter(n.charCodeAt(9))}function l(n,i,s){const u=L=>function(){const R=Array.prototype.slice.call(arguments,0);return i(L,R)},m=L=>function(R){return s(L,R)};let M={};for(const L of n){if(a(L)){M[L]=m(L);continue}if(c(L)){M[L]=s(L,void 0);continue}M[L]=u(L)}return M}class o{constructor(i,s){this._requestHandlerFactory=s,this._requestHandler=null,this._protocol=new b({sendMessage:(u,m)=>{i(u,m)},handleMessage:(u,m)=>this._handleMessage(u,m),handleEvent:(u,m)=>this._handleEvent(u,m)})}onmessage(i){this._protocol.handleMessage(i)}_handleMessage(i,s){if(i===d)return this.initialize(s[0],s[1],s[2],s[3]);if(!this._requestHandler||typeof this._requestHandler[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._requestHandler[i].apply(this._requestHandler,s))}catch(u){return Promise.reject(u)}}_handleEvent(i,s){if(!this._requestHandler)throw new Error("Missing requestHandler");if(a(i)){const u=this._requestHandler[i].call(this._requestHandler,s);if(typeof u!="function")throw new Error(`Missing dynamic event ${i} on request handler.`);return u}if(c(i)){const u=this._requestHandler[i];if(typeof u!="function")throw new Error(`Missing event ${i} on request handler.`);return u}throw new Error(`Malformed event name ${i}`)}initialize(i,s,u,m){this._protocol.setWorkerId(i);const R=l(m,(T,_)=>this._protocol.sendMessage(T,_),(T,_)=>this._protocol.listen(T,_));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(R),Promise.resolve(k.getAllMethodNames(this._requestHandler))):(s&&(typeof s.baseUrl!="undefined"&&delete s.baseUrl,typeof s.paths!="undefined"&&typeof s.paths.vs!="undefined"&&delete s.paths.vs,typeof s.trustedTypesPolicy!==void 0&&delete s.trustedTypesPolicy,s.catchError=!0,C.globals.require.config(s)),new Promise((T,_)=>{(C.globals.require||j)([u],se=>{if(this._requestHandler=se.create(R),!this._requestHandler){_(new Error("No RequestHandler!"));return}T(k.getAllMethodNames(this._requestHandler))},_)}))}}e.SimpleWorkerServer=o;function h(n){return new o(n,null)}e.create=h}),define(x[113],ee([0,1,60,28,42]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function C(k,I){if(await new Promise((S,E)=>{const w=r.createReadStream(k),v=p.createHash("sha1");w.pipe(v);const t=(0,D.once)((f,y)=>{w.removeAllListeners(),v.removeAllListeners(),f?E(f):S(y)});w.once("error",t),w.once("end",t),v.once("error",t),v.once("data",f=>t(void 0,f.toString("hex")))})!==I)throw new Error("Hash mismatch")}e.checksum=C}),define(x[114],ee([0,1,245]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class r{constructor(C="utf8"){this.stringDecoder=new p.StringDecoder(C),this.remaining=null}write(C){const k=[],I=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(I.length<1)return k;let d=0,g,S=d;for(;S<I.length;)if(g=I.charCodeAt(S),g===13||g===10){if(k.push(I.substring(d,S)),S++,S<I.length){const E=g;g=I.charCodeAt(S),(E===13&&g===10||E===10&&g===13)&&S++}d=S}else S++;return this.remaining=d<I.length?I.substr(d):null,k}end(){return this.remaining}}e.LineDecoder=r}),define(x[115],ee([0,1,26]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const r=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(k){const I=k.replace(/\-/g,":").toLowerCase();return!r.has(I)}function C(){const k=(0,p.networkInterfaces)();for(let I in k){const d=k[I];if(d){for(const{mac:g}of d)if(D(g))return g}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=C}),define(x[71],ee([0,1,26,15,36,27,115]),function(j,e,p,r,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(S){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(S)}value(){if(this._value===void 0){let S=0,E=0;const w=(0,p.networkInterfaces)();for(let v in w){const t=w[v];if(t)for(const{mac:f,internal:y}of t)y||(E+=1,this._isVirtualMachineMacAddress(f.toUpperCase())&&(S+=1))}this._value=E>0?S/E:0}return this._value}};let I;async function d(){return I||(I=(async()=>await g()||C.generateUuid())()),I}e.getMachineId=d;async function g(){try{const S=await new Promise((w,v)=>{j(["crypto"],w,v)}),E=(0,k.getMac)();return S.createHash("sha256").update(E,"utf8").digest("hex")}catch(S){r.onUnexpectedError(S);return}}}),define(x[21],ee([0,1,28,26,116,9,32,70,8,3,16,7,27]),function(j,e,p,r,D,C,k,I,d,g,S,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(X){X[X.UNLINK=0]="UNLINK",X[X.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function t(X,B=v.UNLINK){if((0,k.isRootOrDriveLetter)(X))throw new Error("rimraf - will refuse to recursively delete root");return B===v.UNLINK?y(X):f(X)}async function f(X){try{const B=(0,d.join)((0,r.tmpdir)(),(0,w.generateUuid)());try{await e.Promises.rename(X,B)}catch{return y(X)}y(B).catch($=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function y(X){return e.Promises.rmdir(X,{recursive:!0,maxRetries:3})}function b(X){if((0,k.isRootOrDriveLetter)(X))throw new Error("rimraf - will refuse to recursively delete root");p.rmdirSync(X,{recursive:!0})}e.rimrafSync=b;async function P(X,B){return l(await(B?c(X):(0,D.promisify)(p.readdir)(X)))}async function c(X){try{return await(0,D.promisify)(p.readdir)(X,{withFileTypes:!0})}catch(Y){console.warn("[node.js fs] readdir with filetypes failed with error: ",Y)}const B=[],$=await P(X);for(const Y of $){let V=!1,q=!1,Z=!1;try{const U=await e.Promises.lstat((0,d.join)(X,Y));V=U.isFile(),q=U.isDirectory(),Z=U.isSymbolicLink()}catch(U){console.warn("[node.js fs] unexpected error from lstat after readdir: ",U)}B.push({name:Y,isFile:()=>V,isDirectory:()=>q,isSymbolicLink:()=>Z})}return B}function a(X){return l(p.readdirSync(X))}e.readdirSync=a;function l(X){return X.map(B=>typeof B=="string"?g.isMacintosh?(0,I.normalizeNFC)(B):B:(B.name=g.isMacintosh?(0,I.normalizeNFC)(B.name):B.name,B))}async function o(X){const B=await P(X),$=[];for(const Y of B)await n.existsDirectory((0,d.join)(X,Y))&&$.push(Y);return $}function h(X,B=1e3){return new Promise($=>{let Y=!1;const V=setInterval(()=>{Y||(Y=!0,p.access(X,q=>{Y=!1,q&&(clearInterval(V),$(void 0))}))},B)})}e.whenDeleted=h;var n;(function(X){async function B(V){let q;try{if(q=await e.Promises.lstat(V),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Z){if(Z.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(g.isWindows&&Z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(U){if(U.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw U}throw Z}}X.stat=B;async function $(V){try{const{stat:q,symbolicLink:Z}=await X.stat(V);return q.isFile()&&Z?.dangling!==!0}catch{}return!1}X.existsFile=$;async function Y(V){try{const{stat:q,symbolicLink:Z}=await X.stat(V);return q.isDirectory()&&Z?.dangling!==!0}catch{}return!1}X.existsDirectory=Y})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new C.ResourceQueue;function s(X,B,$){return i.queueFor(E.URI.file(X),S.extUriBiasedIgnorePathCase).queue(()=>{const Y=L($);return new Promise((V,q)=>m(X,B,Y,Z=>Z?q(Z):V()))})}let u=!0;function m(X,B,$,Y){if(!u)return p.writeFile(X,B,{mode:$.mode,flag:$.flag},Y);p.open(X,$.flag,$.mode,(V,q)=>{if(V)return Y(V);p.writeFile(q,B,Z=>{if(Z)return p.close(q,()=>Y(Z));p.fdatasync(q,U=>(U&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",U),u=!1),p.close(q,A=>Y(A))))})})}function M(X,B,$){const Y=L($);if(!u)return p.writeFileSync(X,B,{mode:Y.mode,flag:Y.flag});const V=p.openSync(X,Y.flag,Y.mode);try{p.writeFileSync(V,B);try{p.fdatasyncSync(V)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),u=!1}}finally{p.closeSync(V)}}e.writeFileSync=M;function L(X){return X?{mode:typeof X.mode=="number"?X.mode:438,flag:typeof X.flag=="string"?X.flag:"w"}:{mode:438,flag:"w"}}async function R(X,B){if(X===B)return;async function $(Y){try{const V=await e.Promises.lstat(Y);if(V.isDirectory()||V.isSymbolicLink())return;await e.Promises.utimes(Y,V.atime,new Date)}catch{}}try{await e.Promises.rename(X,B),await $(B)}catch(Y){if(X.toLowerCase()!==B.toLowerCase()&&Y.code==="EXDEV"||X.endsWith("."))await T(X,B,{preserveSymlinks:!1}),await t(X,v.MOVE),await $(B);else throw Y}}async function T(X,B,$){return Q(X,B,{root:{source:X,target:B},options:$,handledSourcePaths:new Set})}const _=511;async function Q(X,B,$){if($.handledSourcePaths.has(X))return;$.handledSourcePaths.add(X);const{stat:Y,symbolicLink:V}=await n.stat(X);if(V){if($.options.preserveSymlinks)try{return await G(X,B,$)}catch(q){console.warn("[node.js fs] copy of symlink failed: ",q)}if(V.dangling)return}return Y.isDirectory()?se(X,B,Y.mode&_,$):re(X,B,Y.mode&_)}async function se(X,B,$,Y){await e.Promises.mkdir(B,{recursive:!0,mode:$});const V=await P(X);for(const q of V)await Q((0,d.join)(X,q),(0,d.join)(B,q),Y)}async function re(X,B,$){await e.Promises.copyFile(X,B),await e.Promises.chmod(B,$)}async function G(X,B,$){let Y=await e.Promises.readlink(X);(0,k.isEqualOrParent)(Y,$.root.source,!g.isLinux)&&(Y=(0,d.join)($.root.target,Y.substr($.root.source.length+1))),await e.Promises.symlink(Y,B)}e.Promises=new class{get access(){return(0,D.promisify)(p.access)}get stat(){return(0,D.promisify)(p.stat)}get lstat(){return(0,D.promisify)(p.lstat)}get utimes(){return(0,D.promisify)(p.utimes)}get read(){return(0,D.promisify)(p.read)}get readFile(){return(0,D.promisify)(p.readFile)}get write(){return(0,D.promisify)(p.write)}get appendFile(){return(0,D.promisify)(p.appendFile)}get fdatasync(){return(0,D.promisify)(p.fdatasync)}get truncate(){return(0,D.promisify)(p.truncate)}get rename(){return(0,D.promisify)(p.rename)}get copyFile(){return(0,D.promisify)(p.copyFile)}get open(){return(0,D.promisify)(p.open)}get close(){return(0,D.promisify)(p.close)}get symlink(){return(0,D.promisify)(p.symlink)}get readlink(){return(0,D.promisify)(p.readlink)}get chmod(){return(0,D.promisify)(p.chmod)}get mkdir(){return(0,D.promisify)(p.mkdir)}get unlink(){return(0,D.promisify)(p.unlink)}get rmdir(){return(0,D.promisify)(p.rmdir)}get realpath(){return(0,D.promisify)(p.realpath)}async exists(X){try{return await e.Promises.access(X),!0}catch{return!1}}get readdir(){return P}get readDirsInDir(){return o}get writeFile(){return s}get rm(){return t}get move(){return R}get copy(){return T}}}),define(x[81],ee([0,1,28,8,25,21]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function k(S){const E=(0,r.dirname)(S);if(S===E)return S;const w=((0,r.basename)(S)||S).toLowerCase();try{const t=(0,C.readdirSync)(E).filter(f=>f.toLowerCase()===w);if(t.length===1){const f=k(E);if(f)return(0,r.join)(f,t[0])}else if(t.length>1){const f=t.indexOf(w);if(f>=0){const y=k(E);if(y)return(0,r.join)(y,t[f])}}}catch{}return null}e.realcaseSync=k;async function I(S){try{return await C.Promises.realpath(S)}catch{const w=g(S);return await C.Promises.access(w,p.constants.R_OK),w}}e.realpath=I;function d(S){try{return p.realpathSync(S)}catch{const w=g(S);return p.accessSync(w,p.constants.R_OK),w}}e.realpathSync=d;function g(S){return(0,D.rtrim)((0,r.normalize)(S),r.sep)}}),define(x[117],ee([0,1,61]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function r(I,d,g,S=1){let E=!1;return new Promise(w=>{const v=setTimeout(()=>{if(!E)return E=!0,w(0)},g);D(I,d,S,t=>{if(!E)return E=!0,clearTimeout(v),w(t)})})}e.findFreePort=r;function D(I,d,g,S){if(d===0)return S(0);const E=new p.Socket;E.once("connect",()=>(k(E),D(I+g,d-1,g,S))),E.once("data",()=>{}),E.once("error",w=>(k(E),w.code!=="ECONNREFUSED"?D(I+g,d-1,g,S):S(I))),E.connect(I,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function C(I,d,g){let S=!1,E,w=1;const v=p.createServer({pauseOnConnect:!0});function t(f,y){S||(S=!0,v.removeAllListeners(),v.close(),E&&clearTimeout(E),y(f))}return new Promise(f=>{E=setTimeout(()=>{t(0,f)},g),v.on("listening",()=>{t(I,f)}),v.on("error",y=>{y&&(y.code==="EADDRINUSE"||y.code==="EACCES")&&w<d?(I++,w++,v.listen(I,"127.0.0.1")):t(0,f)}),v.on("close",()=>{t(0,f)}),v.listen(I,"127.0.0.1")})}e.findFreePortFaster=C;function k(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(d){console.error(d)}}}),define(x[118],ee([0,1,26,8,21]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const C=/^\d+$/,k=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var d;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(d||(d={}));let g;switch(process.arch){case"ia32":case"x32":g=1;break;case"arm":case"arm64":g=2;break;default:g=0;break}let S;process.env.PROCESSOR_ARCHITEW6432?S=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?S=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?S=1:S=0;class E{constructor(l,o,h){this.exePath=l,this.displayName=o,this.knownToExist=h}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function w({useAlternateBitness:a=!1}={}){return a?g===0?process.env["ProgramFiles(x86)"]||null:S===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:a=!1,findPreview:l=!1}={}){const o=w({useAlternateBitness:a});if(!o)return null;const h=r.join(o,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(h))return null;let n=-1,i=null;for(const m of await D.Promises.readdir(h)){let M=-1;if(l){const R=m.indexOf("-");if(R<0)continue;const T=m.substring(0,R);if(!C.test(T)||m.substring(R+1)!=="preview")continue;M=parseInt(T,10)}else{if(!C.test(m))continue;M=parseInt(m,10)}if(M<=n)continue;const L=r.join(h,m,"pwsh.exe");!await D.SymlinkSupport.existsFile(L)||(i=L,n=M)}if(!i)return null;const s=o.includes("x86")?" (x86)":"",u=l?" Preview":"";return new E(i,`PowerShell${u}${s}`,!0)}async function t({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const l=r.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:o,pwshMsixName:h}=a?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const n of await D.Promises.readdir(l))if(o.test(n)){const i=r.join(l,n,"pwsh.exe");return new E(i,h)}return null}function f(){const a=r.join(p.homedir(),".dotnet","tools","pwsh.exe");return new E(a,".NET Core PowerShell Global Tool")}function y(){const a=r.join(process.env.windir,g===1&&S!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(a,"Windows PowerShell",!0)}async function*b(){let a=await v();a&&(yield a),a=await v({useAlternateBitness:!0}),a&&(yield a),a=await t(),a&&(yield a),a=f(),a&&(yield a),a=await v({findPreview:!0}),a&&(yield a),a=await t({findPreview:!0}),a&&(yield a),a=await v({useAlternateBitness:!0,findPreview:!0}),a&&(yield a),a=y(),a&&(yield a)}async function*P(){for await(const a of b())await a.exists()&&(yield a)}e.enumeratePowerShellInstallations=P;async function c(){for await(const a of P())return a;return null}e.getFirstAvailablePowerShellInstallation=c}),define(x[82],ee([0,1,44,10]),function(j,e,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(k){return new Promise((I,d)=>{let g;const S=new Map;function E(v,t,f,y,b){const P=S.get(t);if(v===k||P){const c={name:w(f),cmd:f,pid:v,ppid:t,load:y,mem:b};S.set(v,c),v===k&&(g=c),P&&(P.children||(P.children=[]),P.children.push(c),P.children.length>1&&(P.children=P.children.sort((a,l)=>a.pid-l.pid)))}}function w(v){const t=/--vscode-window-kind=shared-process/,f=/--vscode-window-kind=issue-reporter/,y=/--vscode-window-kind=process-explorer/,b=/--utility-sub-type=network/,P=/--crashes-directory/,c=/\\pipe\\winpty-control/,a=/conhost\.exe/,l=/--type=([a-zA-Z-]+)/;if(P.exec(v))return"electron-crash-reporter";if(c.exec(v))return"winpty-process";if(a.exec(v))return"console-window-host (Windows internal process)";let o=l.exec(v);if(o&&o.length===2)return o[1]==="renderer"?t.exec(v)?"shared-process":f.exec(v)?"issue-reporter":y.exec(v)?"process-explorer":"window":o[1]==="utility"&&b.exec(v)?"utility-network-service":o[1];const h=/[a-zA-Z-]+\.js/g;let n="";do o=h.exec(v),o&&(n+=o+" ");while(o);return n&&v.indexOf("node ")<0&&v.indexOf("node.exe")<0?`electron_node ${n}`:v}if(process.platform==="win32"){const v=t=>t.indexOf("\\\\?\\")===0||t.indexOf("\\??\\")===0?t.substr(4):t.indexOf('"\\\\?\\')===0||t.indexOf('"\\??\\')===0?'"'+t.substr(5):t;new Promise((t,f)=>{j(["windows-process-tree"],t,f)}).then(t=>{t.getProcessList(k,f=>{t.getProcessCpuUsage(f,y=>{const b=new Map;y.forEach(P=>{const c=v(P.commandLine||"");b.set(P.pid,{name:w(c),cmd:c,pid:P.pid,ppid:P.ppid,load:P.cpu||0,mem:P.memory||0})}),g=b.get(k),g?(b.forEach(P=>{const c=b.get(P.ppid);c&&(c.children||(c.children=[]),c.children.push(P))}),b.forEach(P=>{P.children&&(P.children=P.children.sort((c,a)=>c.pid-a.pid))}),I(g)):d(new Error(`Root process ${k} not found`))})},t.ProcessDataFlag.CommandLine|t.ProcessDataFlag.Memory)})}else{let v=function(){let t=[g];const f=[];for(;t.length;){const b=t.shift();b&&(f.push(b.pid),b.children&&(t=t.concat(b.children)))}let y=JSON.stringify(r.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",j).fsPath);y+=" "+f.join(" "),(0,p.exec)(y,{},(b,P,c)=>{if(b||c)d(b||new Error(c.toString()));else{const a=P.toString().split(`
`);for(let l=0;l<f.length;l++){const o=S.get(f[l]);o.load=parseFloat(a[l])}if(!g){d(new Error(`Root process ${k} not found`));return}I(g)}})};(0,p.exec)("which ps",{},(t,f,y)=>{if(t||y)if(process.platform!=="linux")d(t||new Error(y.toString()));else{const b=JSON.stringify(r.FileAccess.asFileUri("vs/base/node/ps.sh",j).fsPath);(0,p.exec)(b,{},(P,c,a)=>{P||a?d(P||new Error(a.toString())):(C(c,E),v())})}else{const b=f.toString().trim(),P="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,p.exec)(`${b} ${P}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,a,l)=>{c||l&&!l.includes("screen size is bogus")?d(c||new Error(l.toString())):(C(a,E),process.platform==="linux"?v():g?I(g):d(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=D;function C(k,I){const d=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,g=k.toString().split(`
`);for(const S of g){const E=d.exec(S.trim());E&&E.length===6&&I(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}}),define(x[119],ee([0,1,28,23,32,2,70,8,3,21]),function(j,e,p,r,D,C,k,I,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function S(t,f,y){return w({path:t,isDirectory:!1},f,y)}e.watchFile=S;function E(t,f,y){return w({path:t,isDirectory:!0},f,y)}e.watchFolder=E,e.CHANGE_BUFFER_DELAY=100;function w(t,f,y){if(d.isMacintosh&&(0,D.isEqualOrParent)(t.path,"/Volumes/"))return y(`Refusing to watch ${t.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),C.Disposable.None;const b=(0,I.basename)(t.path),P=new Map;let c=!1,a=[(0,C.toDisposable)(()=>{P.forEach(l=>(0,C.dispose)(l)),P.clear()})];try{const l=(0,p.watch)(t.path);a.push((0,C.toDisposable)(()=>{l.removeAllListeners(),l.close()}));const o=new Set;t.isDirectory&&g.Promises.readdir(t.path).then(h=>h.forEach(n=>o.add(n))),l.on("error",(h,n)=>{c||y(`Failed to watch ${t.path} for changes using fs.watch() (${h}, ${n})`)}),l.on("change",(h,n)=>{if(c)return;let i="";if(n&&(i=n.toString(),d.isMacintosh&&(i=(0,k.normalizeNFC)(i))),!i||h!=="change"&&h!=="rename")return;const s=t.isDirectory?(0,I.join)(t.path,i):t.path;if(t.isDirectory)if(h==="rename"){const u=P.get(s);u&&(0,C.dispose)(u);const m=setTimeout(async()=>{P.delete(s);const M=await g.Promises.exists(s);if(c)return;let L;M?o.has(i)?L="changed":(L="added",o.add(i)):(o.delete(i),L="deleted"),f(L,s)},e.CHANGE_BUFFER_DELAY);P.set(s,(0,C.toDisposable)(()=>clearTimeout(m)))}else{let u;o.has(i)?u="changed":(u="added",o.add(i)),f(u,s)}else if(h==="rename"||i!==b){const u=setTimeout(async()=>{const m=await g.Promises.exists(s);c||(m?(f("changed",s),a=[w(t,f,y)]):f("deleted",s))},e.CHANGE_BUFFER_DELAY);(0,C.dispose)(a),a=[(0,C.toDisposable)(()=>clearTimeout(u))]}else f("changed",s)})}catch(l){g.Promises.exists(t.path).then(o=>{o&&!c&&y(`Failed to watch ${t.path} for changes using fs.watch() (${l.toString()})`)})}return(0,C.toDisposable)(()=>{c=!0,a=(0,C.dispose)(a)})}async function v(t,f,y,b=512){const P=await g.Promises.open(t,"r"),c=Buffer.allocUnsafe(b),a=new r.CancellationTokenSource(y);let l,o=!1;const h=S(t,async n=>{if(n==="changed"){if(o)return;o=!0;try{for(;!a.token.isCancellationRequested;){const{bytesRead:i}=await g.Promises.read(P,c,0,b,null);if(!i||a.token.isCancellationRequested)break;f(c.slice(0,i))}}catch(i){l=new Error(i),a.dispose(!0)}finally{o=!1}}},n=>{l=new Error(n),a.dispose(!0)});return new Promise((n,i)=>{a.token.onCancellationRequested(async()=>{h.dispose(),await g.Promises.close(P),l?i(l):n()})})}e.watchFileContents=v}),define(x[120],ee([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(x[121],ee([0,1,14,13,120]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function C(){p.ipcMain.on(D.CONTEXT_MENU_CHANNEL,(I,d,g,S,E)=>{const w=k(I,S,g);w.popup({window:(0,r.withNullAsUndefined)(p.BrowserWindow.fromWebContents(I.sender)),x:E?E.x:void 0,y:E?E.y:void 0,positioningItem:E?E.positioningItem:void 0,callback:()=>{w&&I.sender.send(D.CONTEXT_MENU_CLOSE_CHANNEL,d)}})})}e.registerContextMenuListener=C;function k(I,d,g){const S=new p.Menu;return g.forEach(E=>{let w;E.type==="separator"?w=new p.MenuItem({type:E.type}):Array.isArray(E.submenu)?w=new p.MenuItem({submenu:k(I,d,E.submenu),label:E.label}):w=new p.MenuItem({label:E.label,type:E.type,accelerator:E.accelerator,checked:E.checked,enabled:E.enabled,visible:E.visible,click:(v,t,f)=>I.sender.send(d,E.id,f)}),S.append(w)}),S}});var fe=this&&this.__decorate||function(j,e,p,r){var D=arguments.length,C=D<3?e:r===null?r=Object.getOwnPropertyDescriptor(e,p):r,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(j,e,p,r);else for(var I=j.length-1;I>=0;I--)(k=j[I])&&(C=(D<3?k(C):D>3?k(e,p,C):k(e,p))||C);return D>3&&C&&Object.defineProperty(e,p,C),C};define(x[37],ee([0,1,31,9,17,23,46,15,4,2,110,25,13]),function(j,e,p,r,D,C,k,I,d,g,S,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var v;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(v=e.RequestType||(e.RequestType={}));function t(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var f;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(f=e.ResponseType||(e.ResponseType={}));function y(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(b||(b={}));class P{constructor(q){this.buffer=q,this.pos=0}read(q){const Z=this.buffer.slice(this.pos,this.pos+q);return this.pos+=Z.byteLength,Z}}class c{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(q){this.buffers.push(q)}}var a;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object"})(a||(a={}));function l(V){const q=D.VSBuffer.alloc(4);return q.writeUInt32BE(V,0),q}function o(V){return V.read(4).readUInt32BE(0)}function h(V){const q=D.VSBuffer.alloc(1);return q.writeUInt8(V,0),q}const n={Undefined:h(a.Undefined),String:h(a.String),Buffer:h(a.Buffer),VSBuffer:h(a.VSBuffer),Array:h(a.Array),Object:h(a.Object)},i=typeof Buffer!="undefined";function s(V,q){if(typeof q=="undefined")V.write(n.Undefined);else if(typeof q=="string"){const Z=D.VSBuffer.fromString(q);V.write(n.String),V.write(l(Z.byteLength)),V.write(Z)}else if(i&&Buffer.isBuffer(q)){const Z=D.VSBuffer.wrap(q);V.write(n.Buffer),V.write(l(Z.byteLength)),V.write(Z)}else if(q instanceof D.VSBuffer)V.write(n.VSBuffer),V.write(l(q.byteLength)),V.write(q);else if(Array.isArray(q)){V.write(n.Array),V.write(l(q.length));for(const Z of q)s(V,Z)}else{const Z=D.VSBuffer.fromString(JSON.stringify(q));V.write(n.Object),V.write(l(Z.byteLength)),V.write(Z)}}function u(V){switch(V.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return V.read(o(V)).toString();case a.Buffer:return V.read(o(V)).buffer;case a.VSBuffer:return V.read(o(V));case a.Array:{const Z=o(V),U=[];for(let A=0;A<Z;A++)U.push(u(V));return U}case a.Object:return JSON.parse(V.read(o(V)).toString())}}class m{constructor(q,Z,U=null,A=1e3){this.protocol=q,this.ctx=Z,this.logger=U,this.timeoutDelay=A,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(W=>this.onRawMessage(W)),this.sendResponse({type:200})}registerChannel(q,Z){this.channels.set(q,Z),setTimeout(()=>this.flushPendingRequests(q),0)}sendResponse(q){switch(q.type){case 200:{const Z=this.send([q.type]);this.logger&&this.logger.logOutgoing(Z,0,1,y(q.type));return}case 201:case 202:case 204:case 203:{const Z=this.send([q.type,q.id],q.data);this.logger&&this.logger.logOutgoing(Z,q.id,1,y(q.type),q.data);return}}}send(q,Z=void 0){const U=new c;return s(U,q),s(U,Z),this.sendBuffer(U.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onRawMessage(q){const Z=new P(q),U=u(Z),A=u(Z),W=U[0];switch(W){case 100:return this.logger&&this.logger.logIncoming(q.byteLength,U[1],1,`${t(W)}: ${U[2]}.${U[3]}`,A),this.onPromise({type:W,id:U[1],channelName:U[2],name:U[3],arg:A});case 102:return this.logger&&this.logger.logIncoming(q.byteLength,U[1],1,`${t(W)}: ${U[2]}.${U[3]}`,A),this.onEventListen({type:W,id:U[1],channelName:U[2],name:U[3],arg:A});case 101:return this.logger&&this.logger.logIncoming(q.byteLength,U[1],1,`${t(W)}`),this.disposeActiveRequest({type:W,id:U[1]});case 103:return this.logger&&this.logger.logIncoming(q.byteLength,U[1],1,`${t(W)}`),this.disposeActiveRequest({type:W,id:U[1]})}}onPromise(q){const Z=this.channels.get(q.channelName);if(!Z){this.collectPendingRequest(q);return}const U=new C.CancellationTokenSource;let A;try{A=Z.call(this.ctx,q.name,q.arg,U.token)}catch(N){A=Promise.reject(N)}const W=q.id;A.then(N=>{this.sendResponse({id:W,data:N,type:201}),this.activeRequests.delete(q.id)},N=>{N instanceof Error?this.sendResponse({id:W,data:{message:N.message,name:N.name,stack:N.stack?N.stack.split?N.stack.split(`
`):N.stack:void 0},type:202}):this.sendResponse({id:W,data:N,type:203}),this.activeRequests.delete(q.id)});const F=(0,g.toDisposable)(()=>U.cancel());this.activeRequests.set(q.id,F)}onEventListen(q){const Z=this.channels.get(q.channelName);if(!Z){this.collectPendingRequest(q);return}const U=q.id,W=Z.listen(this.ctx,q.name,q.arg)(F=>this.sendResponse({id:U,data:F,type:204}));this.activeRequests.set(q.id,W)}disposeActiveRequest(q){const Z=this.activeRequests.get(q.id);Z&&(Z.dispose(),this.activeRequests.delete(q.id))}collectPendingRequest(q){let Z=this.pendingRequests.get(q.channelName);Z||(Z=[],this.pendingRequests.set(q.channelName,Z));const U=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.sendResponse({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Z.push({request:q,timeoutTimer:U})}flushPendingRequests(q){const Z=this.pendingRequests.get(q);if(Z){for(const U of Z)switch(clearTimeout(U.timeoutTimer),U.request.type){case 100:this.onPromise(U.request);break;case 102:this.onEventListen(U.request);break}this.pendingRequests.delete(q)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(q=>q.dispose()),this.activeRequests.clear()}}e.ChannelServer=m;var M;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(M=e.RequestInitiator||(e.RequestInitiator={}));class L{constructor(q,Z=null){this.protocol=q,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new d.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(U=>this.onBuffer(U)),this.logger=Z}getChannel(q){const Z=this;return{call(U,A,W){return Z.isDisposed?Promise.reject(I.canceled()):Z.requestPromise(q,U,A,W)},listen(U,A){return Z.isDisposed?Promise.reject(I.canceled()):Z.requestEvent(q,U,A)}}}requestPromise(q,Z,U,A=C.CancellationToken.None){const W=this.lastRequestId++,N={id:W,type:100,channelName:q,name:Z,arg:U};if(A.isCancellationRequested)return Promise.reject(I.canceled());let H;return new Promise((z,te)=>{if(A.isCancellationRequested)return te(I.canceled());const ne=()=>{const le=ue=>{switch(ue.type){case 201:this.handlers.delete(W),z(ue.data);break;case 202:{this.handlers.delete(W);const me=new Error(ue.data.message);me.stack=ue.data.stack,me.name=ue.data.name,te(me);break}case 203:this.handlers.delete(W),te(ue.data);break}};this.handlers.set(W,le),this.sendRequest(N)};let oe=null;this.state===b.Idle?ne():(oe=(0,r.createCancelablePromise)(le=>this.whenInitialized()),oe.then(()=>{oe=null,ne()}));const J=()=>{oe?(oe.cancel(),oe=null):this.sendRequest({id:W,type:101}),te(I.canceled())},ce=A.onCancellationRequested(J);H=(0,g.combinedDisposable)((0,g.toDisposable)(J),ce),this.activeRequests.add(H)}).finally(()=>{this.activeRequests.delete(H)})}requestEvent(q,Z,U){const A=this.lastRequestId++,F={id:A,type:102,channelName:q,name:Z,arg:U};let N=null;const H=new d.Emitter({onFirstListenerAdd:()=>{N=(0,r.createCancelablePromise)(z=>this.whenInitialized()),N.then(()=>{N=null,this.activeRequests.add(H),this.sendRequest(F)})},onLastListenerRemove:()=>{N?(N.cancel(),N=null):(this.activeRequests.delete(H),this.sendRequest({id:A,type:103}))}}),O=z=>H.fire(z.data);return this.handlers.set(A,O),H.event}sendRequest(q){switch(q.type){case 100:case 102:{const Z=this.send([q.type,q.id,q.channelName,q.name],q.arg);this.logger&&this.logger.logOutgoing(Z,q.id,0,`${t(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const Z=this.send([q.type,q.id]);this.logger&&this.logger.logOutgoing(Z,q.id,0,t(q.type));return}}}send(q,Z=void 0){const U=new c;return s(U,q),s(U,Z),this.sendBuffer(U.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onBuffer(q){const Z=new P(q),U=u(Z),A=u(Z),W=U[0];switch(W){case 200:return this.logger&&this.logger.logIncoming(q.byteLength,0,0,y(W)),this.onResponse({type:U[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(q.byteLength,U[1],0,y(W),A),this.onResponse({type:U[0],id:U[1],data:A})}}onResponse(q){if(q.type===200){this.state=b.Idle,this._onDidInitialize.fire();return}const Z=this.handlers.get(q.id);Z&&Z(q)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(q=>q.dispose()),this.activeRequests.clear()}}fe([k.memoize],L.prototype,"onDidInitializePromise",null),e.ChannelClient=L;class R{constructor(q){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new d.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new d.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,q(({protocol:Z,onDidClientDisconnect:U})=>{d.Event.once(Z.onMessage)(W=>{const F=new P(W),N=u(F),H=new m(Z,N),O=new L(Z);this.channels.forEach((te,ne)=>H.registerChannel(ne,te));const z={channelServer:H,channelClient:O,ctx:N};this._connections.add(z),this._onDidAddConnection.fire(z),U(()=>{H.dispose(),O.dispose(),this._connections.delete(z),this._onDidRemoveConnection.fire(z)})})})}get connections(){const q=[];return this._connections.forEach(Z=>q.push(Z)),q}getChannel(q,Z){const U=this;return{call(A,W,F){let N;if((0,w.isFunction)(Z)){let O=(0,p.getRandomElement)(U.connections.filter(Z));N=O?Promise.resolve(O):d.Event.toPromise(d.Event.filter(U.onDidAddConnection,Z))}else N=Z.routeCall(U,A,W);const H=N.then(O=>O.channelClient.getChannel(q));return _(H).call(A,W,F)},listen(A,W){if((0,w.isFunction)(Z))return U.getMulticastEvent(q,Z,A,W);const F=Z.routeEvent(U,A,W).then(N=>N.channelClient.getChannel(q));return _(F).listen(A,W)}}}getMulticastEvent(q,Z,U,A){const W=this;let F=new g.DisposableStore;const N=new d.Emitter({onFirstListenerAdd:()=>{F=new g.DisposableStore;const H=new d.EventMultiplexer,O=new Map,z=ne=>{const J=ne.channelClient.getChannel(q).listen(U,A),ce=H.add(J);O.set(ne,ce)},te=ne=>{const oe=O.get(ne);!oe||(oe.dispose(),O.delete(ne))};W.connections.filter(Z).forEach(z),d.Event.filter(W.onDidAddConnection,Z)(z,void 0,F),W.onDidRemoveConnection(te,void 0,F),H.event(N.fire,N,F),F.add(H)},onLastListenerRemove:()=>{F.dispose()}});return N.event}registerChannel(q,Z){this.channels.set(q,Z),this._connections.forEach(U=>{U.channelServer.registerChannel(q,Z)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=R;class T{constructor(q,Z,U=null){const A=new c;s(A,Z),q.send(A.buffer),this.channelClient=new L(q,U),this.channelServer=new m(q,Z,U)}getChannel(q){return this.channelClient.getChannel(q)}registerChannel(q,Z){this.channelServer.registerChannel(q,Z)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function _(V){return{call(q,Z,U){return V.then(A=>A.call(q,Z,U))},listen(q,Z){const U=new d.Relay;return V.then(A=>U.input=A.listen(q,Z)),U.event}}}e.getDelayedChannel=_;function Q(V){let q=!1;return{call(Z,U,A){return q?V.call(Z,U,A):(0,r.timeout)(0).then(()=>q=!0).then(()=>V.call(Z,U,A))},listen(Z,U){if(q)return V.listen(Z,U);const A=new d.Relay;return(0,r.timeout)(0).then(()=>q=!0).then(()=>A.input=V.listen(Z,U)),A.event}}}e.getNextTickChannel=Q;class se{constructor(q){this.fn=q}routeCall(q){return this.route(q)}routeEvent(q){return this.route(q)}async route(q){for(const Z of q.connections)if(await Promise.resolve(this.fn(Z.ctx)))return Promise.resolve(Z);return await d.Event.toPromise(q.onDidAddConnection),await this.route(q)}}e.StaticRouter=se;var re;(function(V){function q(W,F){const N=W,H=F&&F.disableMarshalling,O=new Map;for(const z in N)U(z)&&O.set(z,d.Event.buffer(N[z],!0));return new class{listen(z,te,ne){const oe=O.get(te);if(oe)return oe;if(A(te)){const J=N[te];if(typeof J=="function")return J.call(N,ne)}throw new Error(`Event not found: ${te}`)}call(z,te,ne){const oe=N[te];if(typeof oe=="function"){if(!H&&Array.isArray(ne))for(let J=0;J<ne.length;J++)ne[J]=(0,S.revive)(ne[J]);return oe.apply(N,ne)}throw new Error(`Method not found: ${te}`)}}}V.fromService=q;function Z(W,F){const N=F&&F.disableMarshalling;return new Proxy({},{get(H,O){if(typeof O=="string")return F?.properties?.has(O)?F.properties.get(O):A(O)?function(z){return W.listen(O,z)}:U(O)?W.listen(O):async function(...z){let te;F&&!(0,w.isUndefinedOrNull)(F.context)?te=[F.context,...z]:te=z;const ne=await W.call(O,te);return N?ne:(0,S.revive)(ne)};throw new Error(`Property not found: ${String(O)}`)}})}V.toService=Z;function U(W){return W[0]==="o"&&W[1]==="n"&&E.isUpperAsciiLetter(W.charCodeAt(2))}function A(W){return/^onDynamic/.test(W)&&E.isUpperAsciiLetter(W.charCodeAt(9))}})(re=e.ProxyChannel||(e.ProxyChannel={}));const G=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function X(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){let q=V.toString();if(q!=="[object Object]")return q}return V}function B(V){return Array.isArray(V)?V.map(X):X(V)}function $(V,q,Z,U,A,W,F){F=B(F);const N=G[A],H=N[U%N.length];let O=[`%c[${V}]%c[${String(q).padStart(7," ")}]%c[len: ${String(Z).padStart(5," ")}]%c${String(U).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${H}`];/\($/.test(W)?(O=O.concat(F),O.push(")")):O.push(F),console.log.apply(console,O)}e.logWithColors=$;class Y{constructor(q,Z){this._outgoingPrefix=q,this._incomingPrefix=Z,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(q,Z,U,A,W){this._totalOutgoing+=q,$(this._outgoingPrefix,this._totalOutgoing,q,Z,U,A,W)}logIncoming(q,Z,U,A,W){this._totalIncoming+=q,$(this._incomingPrefix,this._totalIncoming,q,Z,U,A,W)}}e.IPCLogger=Y}),define(x[122],ee([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class p{constructor(D,C){this.sender=D,this.onMessage=C}send(D){try{this.sender.send("vscode:message",D.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=p}),define(x[123],ee([0,1,17,4,37]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class C{constructor(d){this.port=d,this.onMessage=r.Event.fromDOMEventEmitter(this.port,"message",g=>p.VSBuffer.wrap(g.data)),d.start()}send(d){this.port.postMessage(d.buffer)}disconnect(){this.port.close()}}e.Protocol=C;class k extends D.IPCClient{constructor(d,g){const S=new C(d);super(S,g);this.protocol=S}dispose(){this.protocol.disconnect()}}e.Client=k}),define(x[83],ee([0,1,17,4,2,37]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(k=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var I;(function(i){i.enableDiagnostics=!1,i.records=[];const s=new WeakMap;let u=0;function m(L,R){if(!s.has(L)){const T=String(++u);s.set(L,T)}return s.get(L)}function M(L,R,T,_){if(!i.enableDiagnostics)return;const Q=m(L,R);if(_ instanceof p.VSBuffer||_ instanceof Uint8Array||_ instanceof ArrayBuffer||ArrayBuffer.isView(_)){const se=p.VSBuffer.alloc(_.byteLength);se.set(_),i.records.push({timestamp:Date.now(),id:Q,label:R,type:T,buff:se})}else i.records.push({timestamp:Date.now(),id:Q,label:R,type:T,data:_})}i.traceSocketEvent=M})(I=e.SocketDiagnostics||(e.SocketDiagnostics={}));var d;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(d=e.SocketCloseEventType||(e.SocketCloseEventType={}));let g=null;function S(){return g||(g=p.VSBuffer.alloc(0)),g}class E{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,u){if(s===0)return S();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const R=this._chunks[0];return u&&(this._chunks.shift(),this._totalLength-=s),R}if(this._chunks[0].byteLength>s){const R=this._chunks[0].slice(0,s);return u&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),R}let m=p.VSBuffer.alloc(s),M=0,L=0;for(;s>0;){const R=this._chunks[L];if(R.byteLength>s){const T=R.slice(0,s);m.set(T,M),M+=s,u&&(this._chunks[L]=R.slice(s),this._totalLength-=s),s-=s}else m.set(R,M),M+=R.byteLength,u?(this._chunks.shift(),this._totalLength-=R.byteLength):L++,s-=R.byteLength}return m}}e.ChunkStream=E;var w;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume"})(w||(w={}));function v(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var t;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(t=e.ProtocolConstants||(e.ProtocolConstants={}));class f{constructor(s,u,m,M){this.type=s,this.id=u,this.ack=m,this.data=M,this.writtenTime=0}get size(){return this.data.byteLength}}class y extends D.Disposable{constructor(s){super();this._onMessage=this._register(new r.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new E,this._register(this._socket.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const u=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=u.readUInt32BE(9),this._state.messageType=u.readUInt8(0),this._state.id=u.readUInt32BE(1),this._state.ack=u.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:v(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const m=this._state.messageType,M=this._state.id,L=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",u),this._onMessage.fire(new f(m,M,L,u)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class b{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=p.VSBuffer.alloc(13);u.writeUInt8(s.type,0),u.writeUInt32BE(s.id,1),u.writeUInt32BE(s.ack,5),u.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:v(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(u,s.data)}_bufferAdd(s,u){const m=this._totalLength===0;return this._data.push(s,u),this._totalLength+=s.byteLength+u.byteLength,m}_bufferTake(){const s=p.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,u){this._bufferAdd(s,u)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class P extends D.Disposable{constructor(s){super();this._onMessage=new r.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new r.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new b(this._socket)),this._socketReader=this._register(new y(this._socket)),this._register(this._socketReader.onMessage(u=>{u.type===1&&this._onMessage.fire(u.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new f(1,0,0,s))}}e.Protocol=P;class c extends C.IPCClient{constructor(s,u,m=null){super(s,u,m);this.protocol=s}static fromSocket(s,u){return new c(new P(s),u)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=c;class a{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new r.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=a;class l{constructor(s){this.data=s,this.next=null}}class o{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],u=0,m=this._first;for(;m;)s[u++]=m.data,m=m.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const u=new l(s);if(!this._first){this._first=u,this._last=u;return}this._last.next=u,this._last=u}}class h{constructor(){this.lastRuns=[];const s=Date.now();for(let u=0;u<h._HISTORY_LENGTH;u++)this.lastRuns[u]=s-1e3*u;setInterval(()=>{for(let u=h._HISTORY_LENGTH;u>=1;u--)this.lastRuns[u]=this.lastRuns[u-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return h._INSTANCE||(h._INSTANCE=new h),h._INSTANCE}load(){const s=Date.now(),u=(1+h._HISTORY_LENGTH)*1e3;let m=0;for(let M=0;M<h._HISTORY_LENGTH;M++)s-this.lastRuns[M]<=u&&m++;return 1-m/h._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}h._HISTORY_LENGTH=10,h._INSTANCE=null;class n{constructor(s,u=null,m=h.getInstance()){this._onControlMessage=new a,this.onControlMessage=this._onControlMessage.event,this._onMessage=new a,this.onMessage=this._onMessage.event,this._onDidDispose=new a,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new a,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new a,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=m,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new b(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new y(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(M=>this._receiveMessage(M))),this._socketDisposables.push(this._socket.onClose(M=>this._onSocketClose.fire(M))),u&&this._socketReader.acceptChunk(u)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new f(5,0,0,S());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new f(7,0,0,S());this._socketWriter.write(s)}sendResume(){const s=new f(8,0,0,S());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,u){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new b(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new y(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(m=>this._receiveMessage(m))),this._socketDisposables.push(this._socket.onClose(m=>this._onSocketClose.fire(m))),this._socketReader.acceptChunk(u)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new f(3,0,this._incomingAckId,S());this._socketWriter.write(s);const u=this._outgoingUnackMsg.toArray();for(let m=0,M=u.length;m<M;m++)this._socketWriter.write(u[m]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const u=this._outgoingUnackMsg.peek();if(u&&u.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const u=Date.now();u-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=u,this._socketWriter.write(new f(6,0,0,S())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const u=this._outgoingUnackMsg.toArray();for(let m=0,M=u.length;m<M;m++)this._socketWriter.write(u[m]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const u=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const m=new f(1,u,this._incomingAckId,s);this._outgoingUnackMsg.push(m),this._isReconnecting||(this._socketWriter.write(m),this._recvAckCheck())}sendControl(s){const u=new f(2,0,0,s);this._socketWriter.write(u)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),u=Date.now()-s.writtenTime,m=Date.now()-this._socketReader.lastReadTime,M=Date.now()-this._lastSocketTimeoutTime;if(u>=2e4&&m>=2e4&&M>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const L=Math.max(2e4-u,2e4-m,2e4-M,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},L)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new f(3,0,this._incomingAckId,S());this._socketWriter.write(s)}}e.PersistentProtocol=n}),define(x[124],ee([0,1,14,17,4,2,37,122]),function(j,e,p,r,D,C,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function d(S,E){const w=D.Event.fromNodeEventEmitter(p.ipcMain,E,(t,f)=>({event:t,message:f})),v=D.Event.filter(w,({event:t})=>t.sender.id===S);return D.Event.map(v,({message:t})=>t&&r.VSBuffer.wrap(t))}class g extends k.IPCServer{constructor(){super(g.getOnDidClientConnect())}static getOnDidClientConnect(){const E=D.Event.fromNodeEventEmitter(p.ipcMain,"vscode:hello",({sender:w})=>w);return D.Event.map(E,w=>{const v=w.id,t=g.Clients.get(v);t&&t.dispose();const f=new D.Emitter;g.Clients.set(v,(0,C.toDisposable)(()=>f.fire()));const y=d(v,"vscode:message"),b=D.Event.any(D.Event.signal(d(v,"vscode:disconnect")),f.event);return{protocol:new I.Protocol(w,y),onDidClientDisconnect:b}})}}e.Server=g,g.Clients=new Map}),define(x[84],ee([0,1,14,4,27,123]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class k extends C.Client{constructor(g,S){super({addEventListener:(E,w)=>g.addListener(E,w),removeEventListener:(E,w)=>g.removeListener(E,w),postMessage:E=>g.postMessage(E),start:()=>g.start(),close:()=>g.close()},S)}}e.Client=k;async function I(d){if(d.isDestroyed()||d.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const g=(0,D.generateUuid)();d.webContents.send("vscode:createMessageChannel",g);const S=r.Event.fromNodeEventEmitter(p.ipcMain,"vscode:createMessageChannelResult",(w,v)=>({nonce:v,port:w.ports[0]})),{port:E}=await r.Event.toPromise(r.Event.once(r.Event.filter(S,w=>w.nonce===g)));return E}e.connect=I}),define(x[85],ee([0,1,9,4,2,13]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var k;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=e.StorageHint||(e.StorageHint={}));function I(E){const w=E;return w?.changed instanceof Map||w?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var d;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(d||(d={}));class g extends D.Disposable{constructor(w,v=Object.create(null)){super();this.database=w,this.options=v,this._onDidChangeStorage=this._register(new r.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=d.None,this.cache=new Map,this.flushDelayer=new p.ThrottledDelayer(g.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(w=>this.onDidChangeItemsExternal(w)))}onDidChangeItemsExternal(w){w.changed?.forEach((v,t)=>this.accept(t,v)),w.deleted?.forEach(v=>this.accept(v,void 0))}accept(w,v){if(this.state===d.Closed)return;let t=!1;(0,C.isUndefinedOrNull)(v)?t=this.cache.delete(w):this.cache.get(w)!==v&&(this.cache.set(w,v),t=!0),t&&this._onDidChangeStorage.fire(w)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===d.None&&(this.state=d.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(w,v){const t=this.cache.get(w);return(0,C.isUndefinedOrNull)(t)?v:t}getBoolean(w,v){const t=this.get(w);return(0,C.isUndefinedOrNull)(t)?v:t==="true"}getNumber(w,v){const t=this.get(w);return(0,C.isUndefinedOrNull)(t)?v:parseInt(t,10)}async set(w,v){if(this.state===d.Closed)return;if((0,C.isUndefinedOrNull)(v))return this.delete(w);const t=String(v);if(this.cache.get(w)!==t)return this.cache.set(w,t),this.pendingInserts.set(w,t),this.pendingDeletes.delete(w),this._onDidChangeStorage.fire(w),this.doFlush()}async delete(w){if(!(this.state===d.Closed||!this.cache.delete(w)))return this.pendingDeletes.has(w)||this.pendingDeletes.add(w),this.pendingInserts.delete(w),this._onDidChangeStorage.fire(w),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=d.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const w={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(w).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(w){if(!!this.hasPending)return this.doFlush(w)}async doFlush(w){return this.flushDelayer.trigger(()=>this.flushPending(),w)}async whenFlushed(){if(!!this.hasPending)return new Promise(w=>this.whenFlushedCallbacks.push(w))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=g,g.DEFAULT_FLUSH_DELAY=100;class S{constructor(){this.onDidChangeItemsExternal=r.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(w){w.insert&&w.insert.forEach((v,t)=>this.items.set(t,v)),w.delete&&w.delete.forEach(v=>this.items.delete(v))}async close(){}}e.InMemoryStorageDatabase=S}),define(x[125],ee([0,1,9,4,36,8,21]),function(j,e,p,r,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class I{constructor(S,E=Object.create(null)){this.path=S,this.options=E,this.name=(0,C.basename)(this.path),this.logger=new d(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return r.Event.None}async getItems(){const S=await this.whenConnected,E=new Map;return(await this.all(S,"SELECT * FROM ItemTable")).forEach(v=>E.set(v.key,v.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${E.size} rows`),E}async updateItems(S){const E=await this.whenConnected;return this.doUpdateItems(E,S)}doUpdateItems(S,E){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${E.insert?(0,D.mapToString)(E.insert):"0"}), delete(${E.delete?(0,D.setToString)(E.delete):"0"})`),this.transaction(S,()=>{const w=E.insert,v=E.delete;if(w&&w.size>0){const t=[];t.push([]);let f=0;w.forEach((y,b)=>{let P=t[f];P.length>I.MAX_HOST_PARAMETERS&&(f++,P=[],t.push(P)),P.push(b,y)}),t.forEach(y=>{this.prepare(S,`INSERT INTO ItemTable VALUES ${new Array(y.length/2).fill("(?,?)").join(",")}`,b=>b.run(y),()=>{const b=[];let P=0;return w.forEach((c,a)=>{b.push(a),P+=c.length}),`Keys: ${b.join(", ")} Length: ${P}`})})}if(v&&v.size){const t=[];t.push([]);let f=0;v.forEach(y=>{let b=t[f];b.length>I.MAX_HOST_PARAMETERS&&(f++,b=[],t.push(b)),b.push(y)}),t.forEach(y=>{this.prepare(S,`DELETE FROM ItemTable WHERE key IN (${new Array(y.length).fill("?").join(",")})`,b=>b.run(y),()=>{const b=[];return v.forEach(P=>{b.push(P)}),`Keys: ${b.join(", ")}`})})}})}async close(S){this.logger.trace(`[storage ${this.name}] close()`);const E=await this.whenConnected;return this.doClose(E,S)}doClose(S,E){return new Promise((w,v)=>{S.db.close(t=>(t&&this.handleSQLiteError(S,`[storage ${this.name}] close(): ${t}`),this.path===I.IN_MEMORY_PATH?w():!S.isErroneous&&!S.isInMemory?this.backup().then(w,f=>(this.logger.error(`[storage ${this.name}] backup(): ${f}`),w())):typeof E=="function"?k.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(f=>{const y=()=>this.doClose(f,void 0);return this.doUpdateItems(f,{insert:E()}).then(()=>y(),b=>(y(),Promise.reject(b)))})).then(w,v):v(t||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const S=this.toBackupPath(this.path);return k.Promises.copy(this.path,S,{preserveSymlinks:!1})}toBackupPath(S){return`${S}.backup`}async checkIntegrity(S){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${S})`);const E=await this.whenConnected,w=await this.get(E,S?"PRAGMA integrity_check":"PRAGMA quick_check"),v=S?w.integrity_check:w.quick_check;return E.isErroneous?`${v} (last error: ${E.lastError})`:E.isInMemory?`${v} (in-memory!)`:v}async connect(S,E=!0){this.logger.trace(`[storage ${this.name}] open(${S}, retryOnBusy: ${E})`);try{return await this.doConnect(S)}catch(w){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${w}`),w.code==="SQLITE_BUSY"&&E)return await(0,p.timeout)(I.BUSY_OPEN_TIMEOUT),this.connect(S,!1);try{await k.Promises.unlink(S);try{await k.Promises.rename(this.toBackupPath(S),S)}catch{}return await this.doConnect(S)}catch(v){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${v}`),this.doConnect(I.IN_MEMORY_PATH)}}}handleSQLiteError(S,E){S.isErroneous=!0,S.lastError=E,this.logger.error(E)}doConnect(S){return new Promise((E,w)=>{new Promise((v,t)=>{j(["@vscode/sqlite3"],v,t)}).then(v=>{const t={db:new(this.logger.isTracing?v.verbose().Database:v.Database)(S,f=>f?t.db?t.db.close(()=>w(f)):w(f):this.exec(t,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>E(t),y=>t.db.close(()=>w(y)))),isInMemory:S===I.IN_MEMORY_PATH};t.db.on("error",f=>this.handleSQLiteError(t,`[storage ${this.name}] Error (event): ${f}`)),this.logger.isTracing&&t.db.on("trace",f=>this.logger.trace(`[storage ${this.name}] Trace (event): ${f}`))},w)})}exec(S,E){return new Promise((w,v)=>{S.db.exec(E,t=>t?(this.handleSQLiteError(S,`[storage ${this.name}] exec(): ${t}`),v(t)):w())})}get(S,E){return new Promise((w,v)=>{S.db.get(E,(t,f)=>t?(this.handleSQLiteError(S,`[storage ${this.name}] get(): ${t}`),v(t)):w(f))})}all(S,E){return new Promise((w,v)=>{S.db.all(E,(t,f)=>t?(this.handleSQLiteError(S,`[storage ${this.name}] all(): ${t}`),v(t)):w(f))})}transaction(S,E){return new Promise((w,v)=>{S.db.serialize(()=>{S.db.run("BEGIN TRANSACTION"),E(),S.db.run("END TRANSACTION",t=>t?(this.handleSQLiteError(S,`[storage ${this.name}] transaction(): ${t}`),v(t)):w())})})}prepare(S,E,w,v){const t=S.db.prepare(E),f=y=>{this.handleSQLiteError(S,`[storage ${this.name}] prepare(): ${y} (${E}). Details: ${v()}`)};t.on("error",f),w(t),t.finalize(y=>{y&&f(y),t.removeListener("error",f)})}}e.SQLiteStorageDatabase=I,I.IN_MEMORY_PATH=":memory:",I.BUSY_OPEN_TIMEOUT=2e3,I.MAX_HOST_PARAMETERS=256;class d{constructor(S){S&&typeof S.logTrace=="function"&&process.env[d.VSCODE_TRACE_STORAGE]&&(this.logTrace=S.logTrace),S&&typeof S.logError=="function"&&(this.logError=S.logError)}get isTracing(){return!!this.logTrace}trace(S){this.logTrace&&this.logTrace(S)}error(S){this.logError&&this.logError(S)}}d.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(x[126],ee([12,11]),function(j,e){return j.create("vs/base/common/date",e)}),define(x[127],ee([0,1,126]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const r=60,D=r*60,C=D*24,k=C*7,I=C*30,d=C*365;function g(E,w){typeof E!="number"&&(E=E.getTime());const v=Math.round((new Date().getTime()-E)/1e3);if(v<-30)return(0,p.localize)(0,null,g(new Date().getTime()+v*1e3,!1));if(v<30)return(0,p.localize)(1,null);let t;return v<r?(t=v,w?t===1?(0,p.localize)(2,null,t):(0,p.localize)(3,null,t):t===1?(0,p.localize)(4,null,t):(0,p.localize)(5,null,t)):v<D?(t=Math.floor(v/r),w?t===1?(0,p.localize)(6,null,t):(0,p.localize)(7,null,t):t===1?(0,p.localize)(8,null,t):(0,p.localize)(9,null,t)):v<C?(t=Math.floor(v/D),w?t===1?(0,p.localize)(10,null,t):(0,p.localize)(11,null,t):t===1?(0,p.localize)(12,null,t):(0,p.localize)(13,null,t)):v<k?(t=Math.floor(v/C),w?t===1?(0,p.localize)(14,null,t):(0,p.localize)(15,null,t):t===1?(0,p.localize)(16,null,t):(0,p.localize)(17,null,t)):v<I?(t=Math.floor(v/k),w?t===1?(0,p.localize)(18,null,t):(0,p.localize)(19,null,t):t===1?(0,p.localize)(20,null,t):(0,p.localize)(21,null,t)):v<d?(t=Math.floor(v/I),w?t===1?(0,p.localize)(22,null,t):(0,p.localize)(23,null,t):t===1?(0,p.localize)(24,null,t):(0,p.localize)(25,null,t)):(t=Math.floor(v/d),w?t===1?(0,p.localize)(26,null,t):(0,p.localize)(27,null,t):t===1?(0,p.localize)(28,null,t):(0,p.localize)(29,null,t))}e.fromNow=g;function S(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=S}),define(x[128],ee([12,11]),function(j,e){return j.create("vs/base/common/errorMessage",e)}),define(x[39],ee([0,1,31,13,128]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function C(g,S){return S&&(g.stack||g.stacktrace)?D.localize(0,null,I(g),k(g.stack)||k(g.stacktrace)):I(g)}function k(g){return Array.isArray(g)?g.join(`
`):g}function I(g){return typeof g.code=="string"&&typeof g.errno=="number"&&typeof g.syscall=="string"?D.localize(1,null,g.message):g.message||D.localize(2,null)}function d(g=null,S=!1){if(!g)return D.localize(3,null);if(Array.isArray(g)){const E=p.coalesce(g),w=d(E[0],S);return E.length>1?D.localize(4,null,w,E.length):w}if(r.isString(g))return g;if(g.detail){const E=g.detail;if(E.error)return C(E.error,S);if(E.exception)return C(E.exception,S)}return g.stack?C(g,S):g.message?g.message:D.localize(5,null)}e.toErrorMessage=d}),define(x[129],ee([12,11]),function(j,e){return j.create("vs/base/common/keybindingLabels",e)}),define(x[130],ee([0,1,129]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class r{constructor(k,I,d=I){this.modifierLabels=[null],this.modifierLabels[2]=k,this.modifierLabels[1]=I,this.modifierLabels[3]=d}toLabel(k,I,d){if(I.length===0)return null;const g=[];for(let S=0,E=I.length;S<E;S++){const w=I[S],v=d(w);if(v===null)return null;g[S]=D(w,v,this.modifierLabels[k])}return g.join(" ")}}e.ModifierLabelProvider=r,e.UILabelProvider=new r({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:p.localize(0,null),shiftKey:p.localize(1,null),altKey:p.localize(2,null),metaKey:p.localize(3,null),separator:"+"},{ctrlKey:p.localize(4,null),shiftKey:p.localize(5,null),altKey:p.localize(6,null),metaKey:p.localize(7,null),separator:"+"}),e.AriaLabelProvider=new r({ctrlKey:p.localize(8,null),shiftKey:p.localize(9,null),altKey:p.localize(10,null),metaKey:p.localize(11,null),separator:"+"},{ctrlKey:p.localize(12,null),shiftKey:p.localize(13,null),altKey:p.localize(14,null),metaKey:p.localize(15,null),separator:"+"},{ctrlKey:p.localize(16,null),shiftKey:p.localize(17,null),altKey:p.localize(18,null),metaKey:p.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new r({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new r({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function D(C,k,I){if(k===null)return"";const d=[];return C.ctrlKey&&d.push(I.ctrlKey),C.shiftKey&&d.push(I.shiftKey),C.altKey&&d.push(I.altKey),C.metaKey&&d.push(I.metaKey),k!==""&&d.push(k),d.join(I.separator)}}),define(x[131],ee([12,11]),function(j,e){return j.create("vs/base/node/processes",e)}),define(x[72],ee([0,1,44,32,10,47,8,3,34,79,13,114,21,131]),function(j,e,p,r,D,C,k,I,d,g,S,E,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return g.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return g.TerminateResponseCode}});function t(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function f(o,h){if(I.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};h&&(n.cwd=h);const i=p.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],n);return new Promise(s=>{i.once("error",u=>{s({success:!1,error:u})}),i.once("exit",(u,m)=>{s(u===0?{success:!0}:{success:!1,code:u!==null?u:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?t(n.status):1})}else if(I.isLinux||I.isMacintosh)try{const n=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",j).fsPath;return new Promise(i=>{p.execFile(n,[o.pid.toString()],{encoding:"utf8",shell:!0},(s,u,m)=>{i(s?{success:!1,error:s}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function y(o){!o||(delete o.DEBUG,I.isMacintosh&&delete o.DYLD_LIBRARY_PATH,I.isLinux&&delete o.LD_PRELOAD)}e.removeDangerousEnvVariables=y;function b(o=d.env){return o.comspec||"cmd.exe"}e.getWindowsShell=b;class P{constructor(h,n,i,s){if(n!==void 0&&i!==void 0&&s!==void 0)this.cmd=h,this.args=n,this.shell=i,this.options=s;else{const u=h;this.cmd=u.command,this.shell=u.isShellCommand,this.args=u.args.slice(0),this.options=u.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const u=Object.create(null);Object.keys(d.env).forEach(m=>{u[m]=d.env[m]}),Object.keys(this.options.env).forEach(m=>{u[m]=this.options.env[m]}),this.options.env=u}}getSanitizedCommand(){let h=this.cmd.toLowerCase();const n=h.lastIndexOf(k.sep);return n!==-1&&(h=h.substring(n+1)),P.WellKnowCommands[h]?h:"other"}start(h){return I.isWindows&&(this.options&&this.options.cwd&&r.isUNC(this.options.cwd)||!this.options&&r.isUNC(d.cwd()))?Promise.reject(new Error(v.localize(0,null))):this.useExec().then(n=>{let i,s;const u=new Promise((m,M)=>{i=m,s=M});if(n){let m=this.cmd;this.args&&(m=m+" "+this.args.join(" ")),this.childProcess=p.exec(m,this.options,(M,L,R)=>{this.childProcess=null;const T=M;T&&T.killed?s({killed:this.terminateRequested,stdout:L.toString(),stderr:R.toString()}):this.handleExec(i,h,M,L,R)})}else{let m=null;const M=L=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(L,i,h,s);const R={terminated:this.terminateRequested};S.isNumber(L)&&(R.cmdCode=L),i(R)};if(this.shell&&I.isWindows){const L=C.deepClone(this.options);L.windowsVerbatimArguments=!0,L.detached=!1;let R=!1,T=!1;const _=[];let Q=this.ensureQuotes(this.cmd);_.push(Q.value),R=Q.quoted,this.args&&this.args.forEach(re=>{Q=this.ensureQuotes(re),_.push(Q.value),T=T&&Q.quoted});const se=["/s","/c"];R?T?se.push('"'+_.join(" ")+'"'):_.length>1?se.push('"'+_[0]+'" '+_.slice(1).join(" ")):se.push('"'+_[0]+'"'):se.push(_.join(" ")),m=p.spawn(b(),se,L)}else this.cmd&&(m=p.spawn(this.cmd,this.args,this.options));m&&(this.childProcess=m,this.childProcessPromise=Promise.resolve(m),this.pidResolve&&(this.pidResolve(S.isNumber(m.pid)?m.pid:-1),this.pidResolve=void 0),m.on("error",L=>{this.childProcess=null,s({terminated:this.terminateRequested,error:L})}),m.pid&&(this.childProcess.on("close",M),this.handleSpawn(m,i,h,s,!0)))}return u})}handleClose(h,n,i,s){}ensureQuotes(h){return P.regexp.test(h)?{value:'"'+h+'"',quoted:!0}:{value:h,quoted:h.length>0&&h[0]==='"'&&h[h.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(h=>h.pid,h=>-1):new Promise(h=>{this.pidResolve=h})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(h=>(this.terminateRequested=!0,f(h,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),h=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(h=>{if(!this.shell||!I.isWindows)return h(!1);const n=p.spawn(b(),["/s","/c"]);n.on("error",i=>h(!0)),n.on("exit",i=>h(!1))})}}e.AbstractProcess=P,P.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},P.regexp=/^[^"].* .*[^"]/;class c extends P{constructor(h,n,i,s){super(h,n,i,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(h,n,i,s,u){[s,u].forEach((m,M)=>{const L=new E.LineDecoder;L.write(m).forEach(_=>{n({line:_,source:M===0?0:1})});const T=L.end();T&&n({line:T,source:M===0?0:1})}),h({terminated:this.terminateRequested,error:i})}handleSpawn(h,n,i,s,u){const m=new E.LineDecoder,M=new E.LineDecoder;h.stdout.on("data",L=>{m.write(L).forEach(T=>i({line:T,source:0}))}),h.stderr.on("data",L=>{M.write(L).forEach(T=>i({line:T,source:1}))}),this.stdoutLineDecoder=m,this.stderrLineDecoder=M}handleClose(h,n,i,s){const u=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;u&&i({line:u,source:0});const m=this.stderrLineDecoder?this.stderrLineDecoder.end():null;m&&i({line:m,source:1})}}e.LineProcess=c;function a(o){let h=[],n=!1;const i=function(s){if(n){h.push(s);return}(!o.send(s,m=>{if(m&&console.error(m),n=!1,h.length>0){const M=h.slice(0);h=[],M.forEach(L=>i(L))}})||I.isWindows)&&(n=!0)};return{send:i}}e.createQueuedSender=a;var l;(function(o){async function h(n,i,s){if(k.isAbsolute(n))return n;if(i===void 0&&(i=d.cwd()),k.dirname(n)!=="."||(s===void 0&&S.isString(d.env.PATH)&&(s=d.env.PATH.split(k.delimiter)),s===void 0||s.length===0))return k.join(i,n);async function m(M){if(await w.Promises.exists(M)){let L;try{L=await w.Promises.stat(M)}catch(R){R.message.startsWith("EACCES")&&(L=await w.Promises.lstat(M))}return L?!L.isDirectory():!1}return!1}for(let M of s){let L;if(k.isAbsolute(M)?L=k.join(M,n):L=k.join(i,M,n),await m(L))return L;let R=L+".com";if(await m(R)||(R=L+".exe",await m(R)))return R}return k.join(i,n)}o.findExecutable=h})(l=e.win32||(e.win32={}))}),define(x[132],ee([0,1,26,3,118,72]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function k(v,t){return v===1?r.isWindows?E():C.getWindowsShell(t):g(v,t)}e.getSystemShell=k;function I(v,t){return v===1?r.isWindows?w(t):C.getWindowsShell(t):g(v,t)}e.getSystemShellSync=I;let d=null;function g(v,t){if(r.isLinux&&v===2||r.isMacintosh&&v===3)return"/bin/bash";if(!d){let f;if(r.isWindows)f="/bin/bash";else{if(f=t.SHELL,!f)try{f=(0,p.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}d=f}return d}let S=null;async function E(){return S||(S=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),S}function w(v){if(S)return S;const t=r.isWindows&&parseFloat((0,p.release)())>=10,f=v.hasOwnProperty("PROCESSOR_ARCHITEW6432"),y=`${v.windir}\\${f?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return t?y:C.getWindowsShell(v)}}),define(x[133],ee([0,1,44,9,17,23,109,15,4,2,47,72,37]),function(j,e,p,r,D,C,k,I,d,g,S,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class v extends w.ChannelServer{constructor(y){super({send:b=>{try{process.send&&process.send(b.buffer.toString("base64"))}catch{}},onMessage:d.Event.fromNodeEventEmitter(process,"message",b=>D.VSBuffer.wrap(Buffer.from(b,"base64")))},y);process.once("disconnect",()=>this.dispose())}}e.Server=v;class t{constructor(y,b){this.modulePath=y,this.options=b,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new d.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const P=b&&b.timeout?b.timeout:6e4;this.disposeDelayer=new r.Delayer(P),this.child=null,this._client=null}getChannel(y){const b=this;return{call(P,c,a){return b.requestPromise(y,P,c,a)},listen(P,c){return b.requestEvent(y,P,c)}}}requestPromise(y,b,P,c=C.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(y),l=(0,r.createCancelablePromise)(n=>a.call(b,P,n)),o=c.onCancellationRequested(()=>l.cancel()),h=(0,g.toDisposable)(()=>l.cancel());return this.activeRequests.add(h),l.finally(()=>{o.dispose(),this.activeRequests.delete(h),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),l}requestEvent(y,b,P){if(!this.disposeDelayer)return d.Event.None;this.disposeDelayer.cancel();let c;const a=new d.Emitter({onFirstListenerAdd:()=>{c=this.getCachedChannel(y).listen(b,P)(a.fire,a),this.activeRequests.add(c)},onLastListenerRemove:()=>{this.activeRequests.delete(c),c.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const y=this.options&&this.options.args?this.options.args:[],b=Object.create(null);b.env={...(0,S.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(b.env={...b.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(b.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(b.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(b.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),b.execArgv===void 0&&(b.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i))),(0,E.removeDangerousEnvVariables)(b.env),this.child=(0,p.fork)(this.modulePath,y,b);const P=new d.Emitter;d.Event.fromNodeEventEmitter(this.child,"message",i=>i)(i=>{if((0,k.isRemoteConsoleLog)(i)){(0,k.log)(i,`IPC Library: ${this.options.serverName}`);return}P.fire(D.VSBuffer.wrap(Buffer.from(i,"base64")))});const a=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,l=i=>this.child&&this.child.connected&&a.send(i.buffer.toString("base64")),o=P.event,h={send:l,onMessage:o};this._client=new w.ChannelClient(h);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",i=>console.warn('IPC "'+this.options.serverName+'" errored with '+i)),this.child.on("exit",(i,s)=>{process.removeListener("exit",n),this.activeRequests.forEach(u=>(0,g.dispose)(u)),this.activeRequests.clear(),i!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+i+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:i,signal:s})})}return this._client}getCachedChannel(y){let b=this.channels.get(y);return b||(b=this.client.getChannel(y),this.channels.set(y,b)),b}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=t}),define(x[134],ee([12,11]),function(j,e){return j.create("vs/code/electron-main/app",e)}),define(x[135],ee([12,11]),function(j,e){return j.create("vs/platform/configuration/common/configurationRegistry",e)}),define(x[136],ee([12,11]),function(j,e){return j.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(x[137],ee([12,11]),function(j,e){return j.create("vs/platform/environment/node/argv",e)}),define(x[138],ee([12,11]),function(j,e){return j.create("vs/platform/environment/node/argvHelper",e)}),define(x[139],ee([12,11]),function(j,e){return j.create("vs/platform/environment/node/shellEnv",e)}),define(x[140],ee([12,11]),function(j,e){return j.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(x[141],ee([12,11]),function(j,e){return j.create("vs/platform/extensions/common/extensionValidator",e)}),define(x[142],ee([12,11]),function(j,e){return j.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(x[143],ee([12,11]),function(j,e){return j.create("vs/platform/files/common/fileService",e)}),define(x[144],ee([12,11]),function(j,e){return j.create("vs/platform/files/common/files",e)}),define(x[145],ee([12,11]),function(j,e){return j.create("vs/platform/files/common/io",e)}),define(x[146],ee([12,11]),function(j,e){return j.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(x[147],ee([12,11]),function(j,e){return j.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(x[148],ee([12,11]),function(j,e){return j.create("vs/platform/issue/electron-main/issueMainService",e)}),define(x[149],ee([12,11]),function(j,e){return j.create("vs/platform/menubar/electron-main/menubar",e)}),define(x[150],ee([12,11]),function(j,e){return j.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(x[151],ee([12,11]),function(j,e){return j.create("vs/platform/request/common/request",e)}),define(x[152],ee([12,11]),function(j,e){return j.create("vs/platform/telemetry/common/telemetryService",e)}),define(x[153],ee([12,11]),function(j,e){return j.create("vs/platform/update/common/update.config.contribution",e)}),define(x[154],ee([12,11]),function(j,e){return j.create("vs/platform/windows/electron-main/window",e)}),define(x[155],ee([12,11]),function(j,e){return j.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(x[156],ee([12,11]),function(j,e){return j.create("vs/platform/workspaces/common/workspaces",e)}),define(x[157],ee([12,11]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(x[158],ee([12,11]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(x[159],ee([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=void 0;function p(r){return typeof r?.backupFolder=="string"}e.isEmptyWindowBackupInfo=p}),define(x[160],ee([0,1,4,2]),function(j,e,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class D{constructor(){this._onCloseEmitter=new p.Emitter,this._onReloadEmitter=new p.Emitter,this._onTerminateEmitter=new p.Emitter,this._onAttachEmitter=new p.Emitter}call(I,d,g){switch(d){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:g[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:g[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:g[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:g[0],port:g[1],subId:g[2]}))}throw new Error("Method not implemented.")}listen(I,d,g){switch(d){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=D,D.ChannelName="extensionhostdebugservice";class C extends r.Disposable{constructor(I){super();this.channel=I}reload(I){this.channel.call("reload",[I])}get onReload(){return this.channel.listen("reload")}close(I){this.channel.call("close",[I])}get onClose(){return this.channel.listen("close")}attachSession(I,d,g){this.channel.call("attach",[I,d,g])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(I,d){this.channel.call("terminate",[I,d])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(I,d){return this.channel.call("openExtensionDevelopmentHostWindow",[I,d])}}e.ExtensionHostDebugChannelClient=C}),define(x[161],ee([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class p{constructor(k){this.driver=k}listen(k,I){throw new Error(`No event found: ${I}`)}call(k,I,d){switch(I){case"click":return this.driver.click(d[0],d[1],d[2]);case"doubleClick":return this.driver.doubleClick(d);case"setValue":return this.driver.setValue(d[0],d[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(d);case"getElements":return this.driver.getElements(d[0],d[1]);case"getElementXY":return this.driver.getElementXY(d[0],d[1],d[2]);case"typeInEditor":return this.driver.typeInEditor(d[0],d[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(d);case"writeInTerminal":return this.driver.writeInTerminal(d[0],d[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${I}`)}}e.WindowDriverChannel=p;class r{constructor(k){this.channel=k}click(k,I,d){return this.channel.call("click",[k,I,d])}doubleClick(k){return this.channel.call("doubleClick",k)}setValue(k,I){return this.channel.call("setValue",[k,I])}getTitle(){return this.channel.call("getTitle")}isActiveElement(k){return this.channel.call("isActiveElement",k)}getElements(k,I){return this.channel.call("getElements",[k,I])}getElementXY(k,I,d){return this.channel.call("getElementXY",[k,I,d])}typeInEditor(k,I){return this.channel.call("typeInEditor",[k,I])}getTerminalBuffer(k){return this.channel.call("getTerminalBuffer",k)}writeInTerminal(k,I){return this.channel.call("writeInTerminal",[k,I])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=r;class D{constructor(k){this.channel=k}registerWindowDriver(k){return this.channel.call("registerWindowDriver",k)}reloadWindowDriver(k){return this.channel.call("reloadWindowDriver",k)}}e.WindowDriverRegistryChannelClient=D}),define(x[162],ee([0,1,127,46,10,8,34,16,7]),function(j,e,p,r,D,C,k,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class g{constructor(f,y,b){this._args=f,this.paths=y,this.productService=b}get appRoot(){return(0,C.dirname)(D.FileAccess.asFileUri("",j).fsPath)}get userHome(){return d.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return d.URI.file((0,C.join)(this.userDataPath,"User"))}get tmpDir(){return d.URI.file(this.paths.tmpDir)}get cacheHome(){return d.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,I.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const f=(0,p.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,C.join)(this.userDataPath,"logs",f)}return this.args.logsPath}get userDataSyncLogResource(){return d.URI.file((0,C.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(d.URI.file((0,C.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return d.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return d.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=k.env.VSCODE_PORTABLE;return f?d.URI.file((0,C.join)(f,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,I.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return d.URI.file((0,C.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,C.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,C.resolve)(f):(0,C.normalize)((0,C.join)(D.FileAccess.asFileUri("",j).fsPath,"..","extensions"))}get extensionsDownloadPath(){const f=this.args["extensions-download-dir"];return f?(0,C.resolve)(f):(0,C.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,C.resolve)(f);const y=k.env.VSCODE_EXTENSIONS;if(y)return y;const b=k.env.VSCODE_PORTABLE;return b?(0,C.join)(b,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(y=>/^[^:/?#]+?:\/\//.test(y)?d.URI.parse(y):d.URI.file((0,C.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?d.URI.parse(f):d.URI.file((0,C.normalize)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return S(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,I.joinPath)(d.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return d.URI.file((0,C.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}fe([r.memoize],g.prototype,"appRoot",null),fe([r.memoize],g.prototype,"userHome",null),fe([r.memoize],g.prototype,"userDataPath",null),fe([r.memoize],g.prototype,"appSettingsHome",null),fe([r.memoize],g.prototype,"tmpDir",null),fe([r.memoize],g.prototype,"cacheHome",null),fe([r.memoize],g.prototype,"userRoamingDataHome",null),fe([r.memoize],g.prototype,"settingsResource",null),fe([r.memoize],g.prototype,"userDataSyncHome",null),fe([r.memoize],g.prototype,"userDataSyncLogResource",null),fe([r.memoize],g.prototype,"sync",null),fe([r.memoize],g.prototype,"machineSettingsResource",null),fe([r.memoize],g.prototype,"globalStorageHome",null),fe([r.memoize],g.prototype,"workspaceStorageHome",null),fe([r.memoize],g.prototype,"keybindingsResource",null),fe([r.memoize],g.prototype,"keyboardLayoutResource",null),fe([r.memoize],g.prototype,"argvResource",null),fe([r.memoize],g.prototype,"snippetsHome",null),fe([r.memoize],g.prototype,"isExtensionDevelopment",null),fe([r.memoize],g.prototype,"untitledWorkspacesHome",null),fe([r.memoize],g.prototype,"installSourcePath",null),fe([r.memoize],g.prototype,"builtinExtensionsPath",null),fe([r.memoize],g.prototype,"extensionsPath",null),fe([r.memoize],g.prototype,"extensionDevelopmentLocationURI",null),fe([r.memoize],g.prototype,"extensionDevelopmentKind",null),fe([r.memoize],g.prototype,"extensionTestsLocationURI",null),fe([r.memoize],g.prototype,"debugExtensionHost",null),fe([r.memoize],g.prototype,"serviceMachineIdResource",null),fe([r.memoize],g.prototype,"telemetryLogResource",null),fe([r.memoize],g.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=g;function S(t,f){return v(t["inspect-extensions"],t["inspect-brk-extensions"],5870,f,t.debugId,t.extensionEnvironment)}e.parseExtensionHostPort=S;function E(t,f){return v(t["inspect-search"],t["inspect-brk-search"],5876,f,t.extensionEnvironment)}e.parseSearchPort=E;function w(t,f){return v(t["inspect-ptyhost"],t["inspect-brk-ptyhost"],5877,f,t.extensionEnvironment)}e.parsePtyHostPort=w;function v(t,f,y,b,P,c){const l=Number(f||t)||(b?null:y),o=l?Boolean(!!f):!1;let h;if(c)try{h=JSON.parse(c)}catch{}return{port:l,break:o,debugId:P,env:h}}}),define(x[86],ee([0,1,246,3,137]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const C={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,D.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(14,null)},category:{type:"string",cat:"e",description:(0,D.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,D.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,D.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,D.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(27,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,D.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,D.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function I(t,f,y=k){const b={},P=[],c=[];for(let h in f){const n=f[h];n.alias&&(b[h]=n.alias),n.type==="string"||n.type==="string[]"?(P.push(h),n.deprecates&&P.push(n.deprecates)):n.type==="boolean"&&(c.push(h),n.deprecates&&c.push(n.deprecates))}const a=p(t,{string:P,boolean:c,alias:b}),l={},o=a;l._=a._.map(h=>String(h)).filter(h=>h.length>0),delete o._;for(let h in f){const n=f[h];n.alias&&delete o[n.alias];let i=o[h];n.deprecates&&o.hasOwnProperty(n.deprecates)&&(i||(i=o[n.deprecates],i&&y.onDeprecatedOption(n.deprecates,h)),delete o[n.deprecates]),typeof i!="undefined"&&(n.type==="string[]"?i&&!Array.isArray(i)&&(i=[i]):n.type==="string"&&Array.isArray(i)&&(i=i.pop(),y.onMultipleValues(h,i)),l[h]=i),delete o[h]}for(let h in o)y.onUnknownOption(h);return l}e.parseArgs=I;function d(t,f){let y="";return f.args&&(Array.isArray(f.args)?y=` <${f.args.join("> <")}>`:y=` <${f.args}>`),f.alias?`-${f.alias} --${t}${y}`:`--${t}${y}`}function g(t,f){let y=0,b=[];for(const l in t){const o=t[l],h=d(l,o);y=Math.max(y,h.length),b.push([h,o.description])}let P=y+2+1;if(f-P<25)return b.reduce((l,o)=>l.concat([`  ${o[0]}`,`      ${o[1]}`]),[]);let c=f-P-1,a=[];for(const l of b){let o=l[0],h=E(l[1],c),n=S(P-o.length-2);a.push("  "+o+n+h[0]);for(let i=1;i<h.length;i++)a.push(S(P)+h[i])}return a}e.formatOptions=g;function S(t){return" ".repeat(t)}function E(t,f){let y=[];for(;t.length;){let b=t.length<f?t.length:t.lastIndexOf(" ",f),P=t.slice(0,b).trim();t=t.slice(b),y.push(P)}return y}function w(t,f,y,b,P){const c=process.stdout.isTTY&&process.stdout.columns||80,a=P?.noInputFiles!==!0?`[${(0,D.localize)(33,null)}...]`:"",l=[`${t} ${y}`];l.push(""),l.push(`${(0,D.localize)(34,null)}: ${f} [${(0,D.localize)(35,null)}]${a}`),l.push(""),P?.noPipe!==!0&&(r.isWindows?l.push((0,D.localize)(36,null,f)):l.push((0,D.localize)(37,null,f)),l.push(""));const o={};for(const h in b){const n=b[h];if(n.description&&n.cat){let i=o[n.cat];i||(o[n.cat]=i={}),i[h]=n}}for(let h in o){const n=h;let i=o[n];i&&(l.push(C[n]),l.push(...g(i,c)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=w;function v(t,f){return`${t||(0,D.localize)(38,null)}
${f||(0,D.localize)(39,null)}
${process.arch}`}e.buildVersionMessage=v}),define(x[163],ee([0,1,61,160,86]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class C extends r.ExtensionHostDebugBroadcastChannel{constructor(I){super();this.windowsMainService=I}call(I,d,g){return d==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(g[0],g[1]):super.call(I,d,g)}async openExtensionDevelopmentHostWindow(I,d){const g=(0,D.parseArgs)(I,D.OPTIONS);g.debugRenderer=d;const S=g.extensionDevelopmentPath;if(!S)return{success:!1};const[E]=this.windowsMainService.openExtensionDevelopmentHostWindow(S,{context:5,cli:g});if(!d)return{success:!0};const w=E.win;if(!w)return{success:!0};const v=w.webContents.debugger;let t=v.isAttached()?1/0:0;const f=(0,p.createServer)(y=>{t++==0&&v.attach();let b=!1;const P=l=>{b||y.write(JSON.stringify(l)+"\0")},c=(l,o,h,n)=>P({method:o,params:h,sessionId:n});w.on("close",()=>{v.removeListener("message",c),y.end(),b=!0}),v.addListener("message",c);let a=Buffer.alloc(0);y.on("data",l=>{a=Buffer.concat([a,l]);for(let o=a.indexOf(0);o!==-1;o=a.indexOf(0)){let h;try{const n=a.slice(0,o).toString("utf8");a=a.slice(o+1),h=JSON.parse(n)}catch(n){console.error("error reading cdp line",n)}v.sendCommand(h.method,h.params,h.sessionId).then(n=>P({id:h.id,sessionId:h.sessionId,result:n})).catch(n=>P({id:h.id,sessionId:h.sessionId,error:{code:0,message:n.message}}))}}),y.on("error",l=>{console.error("error on cdp pipe:",l)}),y.on("close",()=>{b=!0,--t==0&&v.detach()})});return await new Promise(y=>f.listen(0,y)),w.on("close",()=>f.close()),{rendererDebugPort:f.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=C}),function(){"use strict";function j(e,p,r,D){function C(I){const d=k(I),g=[d];return e.isAbsolute(d)||g.unshift(D),e.resolve(...g)}function k(I){const d=process.env.VSCODE_PORTABLE;if(d)return e.join(d,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return e.join(g,r);const S=I["user-data-dir"];if(S)return S;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=e.join(E,"AppData","Roaming")}break;case"darwin":g=e.join(p.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||e.join(p.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(g,r)}return{getUserDataPath:C}}if(typeof define=="function")define(x[164],ee([0,247,26,10,16,34]),function(e,p,r,D,C,k){const I=C.dirname(D.FileAccess.asFileUri("",e)),d=e.__$__nodeRequire(C.joinPath(I,"package.json").fsPath);return j(p,r,d.name,k.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),p=require("path"),r=require("os");module.exports=j(p,r,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(x[165],ee([0,1,26,162,164]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class C extends r.AbstractNativeEnvironmentService{constructor(I,d){super(I,{homeDir:(0,p.homedir)(),tmpDir:(0,p.tmpdir)(),userDataDir:(0,D.getUserDataPath)(I)},d)}}e.NativeEnvironmentService=C}),define(x[166],ee([0,1,28,26,8]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function C(k){const I=(0,D.join)((0,r.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return p.writeFileSync(I,""),k&&console.log(`Marker file for --wait created: ${I}`),I}catch(d){k&&console.error(`Failed to create marker file for --wait: ${d}`);return}}e.createWaitMarkerFile=C}),define(x[167],ee([0,1,141]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const r=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function C(w){return w=w.trim(),w==="*"||r.test(w)}e.isValidVersionStr=C;function k(w){if(!C(w))return null;if(w=w.trim(),w==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let v=w.match(r);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=k;function I(w){if(!w)return null;let v=w.majorBase,t=w.majorMustEqual,f=w.minorBase,y=w.minorMustEqual,b=w.patchBase,P=w.patchMustEqual;w.hasCaret&&(v===0||(y=!1),P=!1);let c=0;if(w.preRelease){const a=D.exec(w.preRelease);if(a){const[,l,o,h]=a;c=Date.UTC(Number(l),Number(o)-1,Number(h))}}return{majorBase:v,majorMustEqual:t,minorBase:f,minorMustEqual:y,patchBase:b,patchMustEqual:P,isMinimum:w.hasGreaterEquals,notBefore:c}}e.normalizeVersion=I;function d(w,v,t){let f;typeof w=="string"?f=I(k(w)):f=w;let y;v instanceof Date?y=v.getTime():typeof v=="string"&&(y=new Date(v).getTime());let b;if(typeof t=="string"?b=I(k(t)):b=t,!f||!b)return!1;let P=f.majorBase,c=f.minorBase,a=f.patchBase,l=b.majorBase,o=b.minorBase,h=b.patchBase,n=b.notBefore,i=b.majorMustEqual,s=b.minorMustEqual,u=b.patchMustEqual;return b.isMinimum?P>l?!0:P<l?!1:c>o?!0:c<o||y&&y<n?!1:a>=h:(P===1&&l===0&&(!i||!s||!u)&&(l=1,o=0,h=0,i=!0,s=!1,u=!1),P<l?!1:P>l?!i:c<o?!1:c>o?!s:a<h?!1:a>h?!u:!(y&&y<n))}e.isValidVersion=d;function g(w,v,t,f){return t.isBuiltin||typeof t.main=="undefined"?!0:E(w,v,t.engines.vscode,f)}e.isValidExtensionVersion=g;function S(w,v,t){return w==="*"||E(v,t,w)}e.isEngineValid=S;function E(w,v,t,f=[]){let y=I(k(t));if(!y)return f.push(p.localize(0,null,t)),!1;if(y.majorBase===0){if(!y.majorMustEqual||!y.minorMustEqual)return f.push(p.localize(1,null,t)),!1}else if(!y.majorMustEqual)return f.push(p.localize(2,null,t)),!1;return d(w,v,y)?!0:(f.push(p.localize(3,null,w,t)),!1)}}),define(x[168],ee([0,1,4,2,17,51,23]),function(j,e,p,r,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProviderChannel=void 0;class I extends r.Disposable{constructor(g,S){super();this.provider=g,this.logService=S,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(g,S,E){const w=this.getUriTransformer(g);switch(S){case"stat":return this.stat(w,E[0]);case"readdir":return this.readdir(w,E[0]);case"open":return this.open(w,E[0],E[1]);case"close":return this.close(E[0]);case"read":return this.read(E[0],E[1],E[2]);case"readFile":return this.readFile(w,E[0],E[1]);case"write":return this.write(E[0],E[1],E[2],E[3],E[4]);case"writeFile":return this.writeFile(w,E[0],E[1],E[2]);case"rename":return this.rename(w,E[0],E[1],E[2]);case"copy":return this.copy(w,E[0],E[1],E[2]);case"mkdir":return this.mkdir(w,E[0]);case"delete":return this.delete(w,E[0],E[1]);case"watch":return this.watch(w,E[0],E[1],E[2],E[3]);case"unwatch":return this.unwatch(E[0],E[1])}throw new Error(`IPC Command ${S} not found`)}listen(g,S,E){const w=this.getUriTransformer(g);switch(S){case"fileChange":return this.onFileChange(w,E[0]);case"readFileStream":return this.onReadFileStream(w,E[0],E[1])}throw new Error(`Unknown event ${S}`)}stat(g,S){const E=this.transformIncoming(g,S,!0);return this.provider.stat(E)}readdir(g,S){const E=this.transformIncoming(g,S);return this.provider.readdir(E)}async readFile(g,S,E){const w=this.transformIncoming(g,S,!0),v=await this.provider.readFile(w,E);return D.VSBuffer.wrap(v)}onReadFileStream(g,S,E){const w=this.transformIncoming(g,S,!0),v=new k.CancellationTokenSource,t=new p.Emitter({onLastListenerRemove:()=>{v.cancel()}}),f=this.provider.readFileStream(w,E,v.token);return(0,C.listenStream)(f,{onData:y=>t.fire(D.VSBuffer.wrap(y)),onError:y=>t.fire(y),onEnd:()=>{t.fire("end"),t.dispose(),v.dispose()}}),t.event}writeFile(g,S,E,w){const v=this.transformIncoming(g,S);return this.provider.writeFile(v,E.buffer,w)}open(g,S,E){const w=this.transformIncoming(g,S,!0);return this.provider.open(w,E)}close(g){return this.provider.close(g)}async read(g,S,E){const w=D.VSBuffer.alloc(E),v=0,t=await this.provider.read(g,S,w.buffer,v,E);return[w,t]}write(g,S,E,w,v){return this.provider.write(g,S,E.buffer,w,v)}mkdir(g,S){const E=this.transformIncoming(g,S);return this.provider.mkdir(E)}delete(g,S,E){const w=this.transformIncoming(g,S);return this.provider.delete(w,E)}rename(g,S,E,w){const v=this.transformIncoming(g,S),t=this.transformIncoming(g,E);return this.provider.rename(v,t,w)}copy(g,S,E,w){const v=this.transformIncoming(g,S),t=this.transformIncoming(g,E);return this.provider.copy(v,t,w)}onFileChange(g,S){const E=new p.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(S,this.createSessionFileWatcher(g,E))},onLastListenerRemove:()=>{(0,r.dispose)(this.sessionToWatcher.get(S)),this.sessionToWatcher.delete(S)}});return E.event}async watch(g,S,E,w,v){const t=this.sessionToWatcher.get(S);if(t){const f=this.transformIncoming(g,w),y=t.watch(E,f,v);this.watchRequests.set(S+E,y)}}async unwatch(g,S){const E=g+S,w=this.watchRequests.get(E);w&&((0,r.dispose)(w),this.watchRequests.delete(E))}dispose(){super.dispose(),this.watchRequests.forEach(g=>(0,r.dispose)(g)),this.watchRequests.clear(),this.sessionToWatcher.forEach(g=>(0,r.dispose)(g)),this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=I}),define(x[73],ee([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class p{constructor(D,C=[],k=!1){this.ctor=D,this.staticArguments=C,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=p}),define(x[169],ee([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class p{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=p;class r{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let k of this._nodes.values())k.outgoing.size===0&&C.push(k);return C}insertEdge(C,k){const I=this.lookupOrInsertNode(C),d=this.lookupOrInsertNode(k);I.outgoing.set(this._hashFn(k),d),d.incoming.set(this._hashFn(C),I)}removeNode(C){const k=this._hashFn(C);this._nodes.delete(k);for(let I of this._nodes.values())I.outgoing.delete(k),I.incoming.delete(k)}lookupOrInsertNode(C){const k=this._hashFn(C);let I=this._nodes.get(k);return I||(I=new p(C),this._nodes.set(k,I)),I}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[k,I]of this._nodes)C.push(`${k}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,k]of this._nodes){const I=new Set([C]),d=this._findCycle(k,I);if(d)return d}}_findCycle(C,k){for(let[I,d]of C.outgoing){if(k.has(I))return[...k,I].join(" -> ");k.add(I);const g=this._findCycle(d,k);if(g)return g;k.delete(I)}}}e.Graph=r}),define(x[5],ee([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var p;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function I(d){return d[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=I})(p=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function r(k,I,d,g){I[p.DI_TARGET]===I?I[p.DI_DEPENDENCIES].push({id:k,index:d,optional:g}):(I[p.DI_DEPENDENCIES]=[{id:k,index:d,optional:g}],I[p.DI_TARGET]=I)}function D(k){if(p.serviceIds.has(k))return p.serviceIds.get(k);const I=function(d,g,S){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");r(I,d,S,!1)};return I.toString=()=>k,p.serviceIds.set(k,I),I}e.createDecorator=D;function C(k){return k}e.refineServiceDecorator=C}),define(x[52],ee([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,p.createDecorator)("backupMainService")}),define(x[19],ee([0,1,13,7,5]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function C(y){return y&&typeof y=="object"&&(!y.overrideIdentifier||typeof y.overrideIdentifier=="string")&&(!y.resource||y.resource instanceof r.URI)}e.isConfigurationOverrides=C;function k(y){return y&&typeof y=="object"&&(!y.overrideIdentifiers||p.isArray(y.overrideIdentifiers))&&!y.overrideIdentifier&&(!y.resource||y.resource instanceof r.URI)}e.isConfigurationUpdateOverrides=k;var I;(function(y){y[y.USER=1]="USER",y[y.USER_LOCAL=2]="USER_LOCAL",y[y.USER_REMOTE=3]="USER_REMOTE",y[y.WORKSPACE=4]="WORKSPACE",y[y.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",y[y.DEFAULT=6]="DEFAULT",y[y.MEMORY=7]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function d(y){switch(y){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=d;function g(y,b){const P=Object.create(null);for(let c in y)S(P,c,y[c],b);return P}e.toValuesTree=g;function S(y,b,P,c){const a=b.split("."),l=a.pop();let o=y;for(let h=0;h<a.length;h++){let n=a[h],i=o[n];switch(typeof i){case"undefined":i=o[n]=Object.create(null);break;case"object":break;default:c(`Ignoring ${b} as ${a.slice(0,h+1).join(".")} is ${JSON.stringify(i)}`);return}o=i}if(typeof o=="object"&&o!==null)try{o[l]=P}catch{c(`Ignoring ${b} as ${a.join(".")} is ${JSON.stringify(o)}`)}else c(`Ignoring ${b} as ${a.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=S;function E(y,b){const P=b.split(".");w(y,P)}e.removeFromValueTree=E;function w(y,b){const P=b.shift();if(b.length===0){delete y[P];return}if(Object.keys(y).indexOf(P)!==-1){const c=y[P];typeof c=="object"&&!Array.isArray(c)&&(w(c,b),Object.keys(c).length===0&&delete y[P])}}function v(y,b,P){function c(o,h){let n=o;for(const i of h){if(typeof n!="object"||n===null)return;n=n[i]}return n}const a=b.split("."),l=c(y,a);return typeof l=="undefined"?P:l}e.getConfigurationValue=v;function t(y,b,P){Object.keys(b).forEach(c=>{c!=="__proto__"&&(c in y?p.isObject(y[c])&&p.isObject(b[c])?t(y[c],b[c],P):P&&(y[c]=b[c]):y[c]=b[c])})}e.merge=t;function f(y,b,P){const c=y.inspect(b),a=y.inspect(P);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:c.defaultValue}e.getMigratedSettingValue=f}),define(x[74],ee([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,p.createDecorator)(e.ID);function r(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=r}),define(x[87],ee([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,p.createDecorator)("encryptionMainService");class r{constructor(C){this.machineId=C}encryption(){return new Promise((C,k)=>j(["vscode-encrypt"],C,k))}async encrypt(C){try{return(await this.encryption()).encrypt(this.machineId,C)}catch{return C}}async decrypt(C){try{return(await this.encryption()).decrypt(this.machineId,C)}catch{return C}}}e.EncryptionMainService=r}),define(x[53],ee([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,p.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,p.refineServiceDecorator)(e.IEnvironmentService)}),define(x[170],ee([0,1,10,140,5]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var C;(function(c){c.WIN32_X64="win32-x64",c.WIN32_IA32="win32-ia32",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(C=e.TargetPlatform||(e.TargetPlatform={}));function k(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function I(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=I;function d(c,a){switch(c){case 3:return a==="x64"?"win32-x64":a==="ia32"?"win32-ia32":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=d;function g(c,a){return a==="web"&&!c.includes("web")}e.isNotWebExtensionInWebTargetPlatform=g;function S(c,a,l){return g(a,l)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===l?!0:E(l).includes(c)}e.isTargetPlatformCompatible=S;function E(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=E;function w(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=w;var v;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(v=e.SortBy||(e.SortBy={}));var t;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(t=e.SortOrder||(e.SortOrder={}));var f;(function(c){c.Install="install",c.Uninstall="uninstall"})(f=e.StatisticType||(e.StatisticType={}));var y;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(y=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var b;(function(c){c.Unsupported="Unsupported",c.UnsupportedPreRelease="UnsupportedPreRelease",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatiblePreRelease="IncompatiblePreRelease",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Internal="Internal"})(b=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class P extends Error{constructor(a,l){super(a);this.code=l,this.name=l}}e.ExtensionManagementError=P,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=p.FileAccess.asBrowserUri("./media/defaultIcon.png",j).toString(!0),e.ExtensionsLabel=(0,r.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,r.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")}),define(x[171],ee([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,p.createDecorator)("extensionUrlTrustService")}),define(x[172],ee([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,p.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(x[88],ee([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,p.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,p.createDecorator)("externalTerminal")}),define(x[173],ee([0,1,44,10,8,3,79,21,72,142,88]),function(j,e,p,r,D,C,k,I,d,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const E=g.localize(0,null);class w{async getDefaultTerminalForPlatforms(){return{windows:v.getDefaultTerminalWindows(),linux:await f.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class v extends w{openTerminal(a,l){return this.spawnTerminal(p,a,d.getWindowsShell(),l)}spawnTerminal(a,l,o,h){const n=l.windowsExec||v.getDefaultTerminalWindows();h&&h[1]===":"&&(h=h[0].toUpperCase()+h.substr(1));const i=D.basename(n).toLowerCase();if(i==="cmder"||i==="cmder.exe")return a.spawn(n,h?[h]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return n.indexOf(" ")>=0&&s.push('""'),s.push(n),(i==="wt"||i==="wt.exe")&&s.push("-d ."),new Promise((u,m)=>{const M=y(process),L=a.spawn(o,s,{cwd:h,env:M});L.on("error",m),L.on("exit",()=>u())})}runInTerminal(a,l,o,h,n){const i="windowsExec"in n&&n.windowsExec?n.windowsExec:v.getDefaultTerminalWindows();return new Promise((s,u)=>{const m=`"${l} - ${E}"`,M=`""${o.join('" "')}" & pause"`,L=["/c","start",m,"/wait",i,"/c",M],R=Object.assign({},y(process),h);Object.keys(R).filter(Q=>R[Q]===null).forEach(Q=>delete R[Q]);const T={cwd:l,env:R,windowsVerbatimArguments:!0};p.spawn(v.CMD,L,T).on("error",Q=>{u(b(Q))}),s(void 0)})}static getDefaultTerminalWindows(){if(!v._DEFAULT_TERMINAL_WINDOWS){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");v._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return v._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=v,v.CMD="cmd.exe";class t extends w{openTerminal(a,l){return this.spawnTerminal(p,a,l)}runInTerminal(a,l,o,h,n){const i=n.osxExec||S.DEFAULT_TERMINAL_OSX;return new Promise((s,u)=>{if(i===S.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const m=i===S.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",L=[r.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${m}.scpt`,j).fsPath,"-t",a||E,"-w",l];for(let _ of o)L.push("-a"),L.push(_);if(h){const _=Object.assign({},y(process),h);for(let Q in _){const se=_[Q];se===null?(L.push("-u"),L.push(Q)):(L.push("-e"),L.push(`${Q}=${se}`))}}let R="";const T=p.spawn(t.OSASCRIPT,L);T.on("error",_=>{u(b(_))}),T.stderr.on("data",_=>{R+=_.toString()}),T.on("exit",_=>{if(_===0)s(void 0);else if(R){const Q=R.split(`
`,1);u(new Error(Q[0]))}else u(new Error(g.localize(1,null,m,_)))})}else u(new Error(g.localize(2,null,i)))})}spawnTerminal(a,l,o){const h=l.osxExec||S.DEFAULT_TERMINAL_OSX;return new Promise((n,i)=>{const s=["-a",h];o&&s.push(o);const u=y(process),m=a.spawn("/usr/bin/open",s,{cwd:o,env:u});m.on("error",i),m.on("exit",()=>n())})}}e.MacExternalTerminalService=t,t.OSASCRIPT="/usr/bin/osascript";class f extends w{openTerminal(a,l){return this.spawnTerminal(p,a,l)}runInTerminal(a,l,o,h,n){const i=n.linuxExec?Promise.resolve(n.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((s,u)=>{let m=[];i.then(M=>{M.indexOf("gnome-terminal")>=0?m.push("-x"):m.push("-e"),m.push("bash"),m.push("-c");const L=`${P(o)}; echo; read -p "${f.WAIT_MESSAGE}" -n1;`;m.push(`''${L}''`);const R=Object.assign({},y(process),h);Object.keys(R).filter(se=>R[se]===null).forEach(se=>delete R[se]);const T={cwd:l,env:R};let _="";const Q=p.spawn(M,m,T);Q.on("error",se=>{u(b(se))}),Q.stderr.on("data",se=>{_+=se.toString()}),Q.on("exit",se=>{if(se===0)s(void 0);else if(_){const re=_.split(`
`,1);u(new Error(re[0]))}else u(new Error(g.localize(4,null,M,se)))})})})}static async getDefaultTerminalLinuxReady(){if(!f._DEFAULT_TERMINAL_LINUX_READY)if(!C.isLinux)f._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const a=await I.Promises.exists("/etc/debian_version");f._DEFAULT_TERMINAL_LINUX_READY=new Promise(l=>{a?l("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?l("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?l("konsole"):process.env.COLORTERM?l(process.env.COLORTERM):process.env.TERM?l(process.env.TERM):l("xterm")})}return f._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(a,l,o){const h=l.linuxExec?Promise.resolve(l.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((n,i)=>{h.then(s=>{const u=y(process),m=a.spawn(s,[],{cwd:o,env:u});m.on("error",i),m.on("exit",()=>n())})})}}e.LinuxExternalTerminalService=f,f.WAIT_MESSAGE=g.localize(3,null);function y(c){const a={...c.env};return(0,k.sanitizeProcessEnvironment)(a),a}function b(c){return"errno"in c&&c.errno==="ENOENT"&&"path"in c&&typeof c.path=="string"?new Error(g.localize(5,null,c.path)):c}function P(c){let a="";for(let l of c)l.indexOf(" ")>=0?a+='"'+l+'"':a+=l,a+=" ";return a}}),define(x[18],ee([0,1,36,8,25,13,7,144,5]),function(j,e,p,r,D,C,k,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,d.createDecorator)("fileService");function g(B){return B.create===!0}e.isFileOpenForWriteOptions=g;var S;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(S=e.FileType||(e.FileType={}));var E;(function(B){B[B.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var w;(function(B){B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock",B[B.FileAtomicRead=16384]="FileAtomicRead"})(w=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function v(B){return!!(B.capabilities&2)}e.hasReadWriteCapability=v;function t(B){return!!(B.capabilities&8)}e.hasFileFolderCopyCapability=t;function f(B){return!!(B.capabilities&4)}e.hasOpenReadWriteCloseCapability=f;function y(B){return!!(B.capabilities&16)}e.hasFileReadStreamCapability=y;function b(B){return v(B)?!!(B.capabilities&16384):!1}e.hasFileAtomicReadCapability=b;var P;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(P=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor($,Y){super($);this.code=Y}}e.FileSystemProviderError=c;function a(B,$){const Y=new c(B.toString(),$);return o(Y,$),Y}e.createFileSystemProviderError=a;function l(B){return B||a((0,I.localize)(0,null),P.Unknown)}e.ensureFileSystemProviderError=l;function o(B,$){return B.name=$?`${$} (FileSystemError)`:"FileSystemError",B}e.markAsFileSystemProviderError=o;function h(B){if(!B)return P.Unknown;if(B instanceof c)return B.code;const $=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!$)return P.Unknown;switch($[1]){case P.FileExists:return P.FileExists;case P.FileIsADirectory:return P.FileIsADirectory;case P.FileNotADirectory:return P.FileNotADirectory;case P.FileNotFound:return P.FileNotFound;case P.FileExceedsMemoryLimit:return P.FileExceedsMemoryLimit;case P.FileTooLarge:return P.FileTooLarge;case P.FileWriteLocked:return P.FileWriteLocked;case P.NoPermissions:return P.NoPermissions;case P.Unavailable:return P.Unavailable}return P.Unknown}e.toFileSystemProviderErrorCode=h;function n(B){if(B instanceof L)return B.fileOperationResult;switch(h(B)){case P.FileNotFound:return 1;case P.FileIsADirectory:return 0;case P.FileNotADirectory:return 10;case P.FileWriteLocked:return 5;case P.NoPermissions:return 6;case P.FileExists:return 4;case P.FileExceedsMemoryLimit:return 9;case P.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var i;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class s{constructor($,Y,V){this.resource=$,this.operation=Y,this.target=V}isOperation($){return this.operation===$}}e.FileOperationEvent=s;var u;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class m{constructor($,Y){this.added=void 0,this.updated=void 0,this.deleted=void 0;const V=new Map;for(const q of $){const Z=V.get(q.type);Z?Z.push([q.resource,q]):V.set(q.type,[[q.resource,q]])}for(const[q,Z]of V)switch(q){case 1:this.added=p.TernarySearchTree.forUris(()=>Y),this.added.fill(Z);break;case 0:this.updated=p.TernarySearchTree.forUris(()=>Y),this.updated.fill(Z);break;case 2:this.deleted=p.TernarySearchTree.forUris(()=>Y),this.deleted.fill(Z);break}}contains($,...Y){return this.doContains($,{includeChildren:!1},...Y)}affects($,...Y){return this.doContains($,{includeChildren:!0},...Y)}doContains($,Y,...V){if(!$)return!1;const q=V.length>0;return!!((!q||V.includes(1))&&(this.added?.get($)||Y.includeChildren&&this.added?.findSuperstr($))||(!q||V.includes(0))&&(this.updated?.get($)||Y.includeChildren&&this.updated?.findSuperstr($))||(!q||V.includes(2))&&(this.deleted?.findSubstr($)||Y.includeChildren&&this.deleted?.findSuperstr($)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=m;function M(B,$,Y){return!B||!$||B===$||$.length>B.length?!1:($.charAt($.length-1)!==r.sep&&($+=r.sep),Y?(0,D.startsWithIgnoreCase)(B,$):B.indexOf($)===0)}e.isParent=M;class L extends Error{constructor($,Y,V){super($);this.fileOperationResult=Y,this.options=V}}e.FileOperationError=L;class R extends L{constructor($,Y,V){super($,2,V);this.stat=Y}}e.NotModifiedSinceFileOperationError=R;var T;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",B[B.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(T=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var _;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(_=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function Q(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}e.etag=Q;async function se(B,$){if(!$.hasProvider(k.URI.from({scheme:B.scheme})))return new Promise(Y=>{const V=$.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===B.scheme&&q.added&&(V.dispose(),Y())})})}e.whenProviderRegistered=se,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class re{static formatSize($){return(0,C.isNumber)($)||($=0),$<re.KB?(0,I.localize)(1,null,$.toFixed(0)):$<re.MB?(0,I.localize)(2,null,($/re.KB).toFixed(2)):$<re.GB?(0,I.localize)(3,null,($/re.MB).toFixed(2)):$<re.TB?(0,I.localize)(4,null,($/re.GB).toFixed(2)):(0,I.localize)(5,null,($/re.TB).toFixed(2))}}e.ByteSize=re,re.KB=1024,re.MB=re.KB*re.KB,re.GB=re.MB*re.KB,re.TB=re.GB*re.KB;var G;(function(B){B[B.IA32=0]="IA32",B[B.OTHER=1]="OTHER"})(G=e.Arch||(e.Arch={}));function X(B){return{maxFileSize:B===0?300*re.MB:16*re.GB,maxHeapSize:B===0?700*re.MB:2*700*re.MB}}e.getPlatformLimits=X}),define(x[54],ee([0,1,248,138,86,18]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function k(w,v){const t={onUnknownOption:y=>{console.warn((0,r.localize)(0,null,y))},onMultipleValues:(y,b)=>{console.warn((0,r.localize)(1,null,y,b))},onDeprecatedOption:(y,b)=>{console.warn((0,r.localize)(2,null,y,b))}},f=(0,D.parseArgs)(w,D.OPTIONS,v?t:void 0);return f.goto&&f._.forEach(y=>p(/^(\w:)?[^:]+(:\d*){0,2}$/.test(y),(0,r.localize)(3,null))),f["max-memory"]&&p(parseInt(f["max-memory"])>=C.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${C.MIN_MAX_MEMORY_SIZE_MB} MB.`),f}function I(w){const v=w.findIndex(t=>!/^-/.test(t));if(v>-1)return[...w.slice(0,v),...w.slice(v+1)]}function d(w){let[,...v]=w;process.env.VSCODE_DEV&&(v=I(v)||[]);const t=!E(process.env);return k(v,t)}e.parseMainProcessArgv=d;function g(w){const[,,...v]=w;return k(v,!0)}e.parseCLIProcessArgv=g;function S(w,...v){const t=w.indexOf("--");return t===-1?w.push(...v):w.splice(t,0,...v),w}e.addArg=S;function E(w){return w.VSCODE_CLI==="1"}e.isLaunchedFromCli=E}),define(x[89],ee([0,1,44,8,139,23,39,15,3,27,132,54,9]),function(j,e,p,r,D,C,k,I,d,g,S,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const v=1e4;let t;async function f(b,P,c){return P["force-disable-user-env"]?(b.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):d.isWindows?(b.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(c)&&!P["force-user-env"]?(b.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(c)?b.trace("resolveShellEnv(): running (--force-user-env)"):b.trace("resolveShellEnv(): running (macOS/Linux)"),t||(t=w.Promises.withAsyncBody(async(a,l)=>{const o=new C.CancellationTokenSource,h=setTimeout(()=>{o.dispose(!0),l(new Error((0,D.localize)(0,null)))},v);try{a(await y(b,o.token))}catch(n){!(0,I.isPromiseCanceledError)(n)&&!o.token.isCancellationRequested?l(new Error((0,D.localize)(1,null,(0,k.toErrorMessage)(n)))):a({})}finally{clearTimeout(h),o.dispose()}})),t)}e.getResolvedShellEnv=f;async function y(b,P){const c=process.env.ELECTRON_RUN_AS_NODE;b.trace("getUnixShellEnvironment#runAsNode",c);const a=process.env.ELECTRON_NO_ATTACH_CONSOLE;b.trace("getUnixShellEnvironment#noAttach",a);const l=(0,g.generateUuid)().replace(/-/g,"").substr(0,12),o=new RegExp(l+"(.*)"+l),h={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};b.trace("getUnixShellEnvironment#env",h);const n=await(0,S.getSystemShell)(d.OS,h);return b.trace("getUnixShellEnvironment#shell",n),new Promise((i,s)=>{if(P.isCancellationRequested)return s((0,I.canceled)());const u=(0,r.basename)(n);let m,M;const L=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(u)?(m=`& '${process.execPath}' ${L} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,M=["-Login","-Command"]):(m=`'${process.execPath}' ${L} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,u==="tcsh"?M=["-ic"]:M=["-ilc"]),b.trace("getUnixShellEnvironment#spawn",JSON.stringify(M),m);const R=(0,p.spawn)(n,[...M,m],{detached:!0,stdio:["ignore","pipe","pipe"],env:h});P.onCancellationRequested(()=>(R.kill(),s((0,I.canceled)()))),R.on("error",Q=>{b.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)(Q)),s(Q)});const T=[];R.stdout.on("data",Q=>T.push(Q));const _=[];R.stderr.on("data",Q=>_.push(Q)),R.on("close",(Q,se)=>{const re=Buffer.concat(T).toString("utf8");b.trace("getUnixShellEnvironment#raw",re);const G=Buffer.concat(_).toString("utf8");if(G.trim()&&b.trace("getUnixShellEnvironment#stderr",G),Q||se)return s(new Error((0,D.localize)(2,null,Q,se)));const X=o.exec(re),B=X?X[1]:"{}";try{const $=JSON.parse(B);c?$.ELECTRON_RUN_AS_NODE=c:delete $.ELECTRON_RUN_AS_NODE,a?$.ELECTRON_NO_ATTACH_CONSOLE=a:delete $.ELECTRON_NO_ATTACH_CONSOLE,delete $.XDG_RUNTIME_DIR,b.trace("getUnixShellEnvironment#result",$),i($)}catch($){b.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)($)),s($)}})})}}),define(x[174],ee([0,1,17,39,15,4,2,51,7,27,18]),function(j,e,p,r,D,C,k,I,d,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class E extends k.Disposable{constructor(v,t){super();this.channel=v,this.extraCapabilities=t,this.onDidChangeCapabilities=C.Event.None,this._onDidChange=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,g.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(v){return this.channel.call("stat",[v])}readdir(v){return this.channel.call("readdir",[v])}async readFile(v,t){const{buffer:f}=await this.channel.call("readFile",[v,t]);return f}readFileStream(v,t,f){const y=(0,I.newWriteableStream)(P=>p.VSBuffer.concat(P.map(c=>p.VSBuffer.wrap(c))).buffer),b=this.channel.listen("readFileStream",[v,t])(P=>{if(P instanceof p.VSBuffer)y.write(P.buffer);else{if(P==="end")y.end();else{let c=P;c instanceof Error||(c=(0,S.createFileSystemProviderError)((0,r.toErrorMessage)(c),S.FileSystemProviderErrorCode.Unknown)),y.error(c),y.end()}b.dispose()}});return f.onCancellationRequested(()=>{y.error((0,D.canceled)()),y.end(),b.dispose()}),y}writeFile(v,t,f){return this.channel.call("writeFile",[v,p.VSBuffer.wrap(t),f])}open(v,t){return this.channel.call("open",[v,t])}close(v){return this.channel.call("close",[v])}async read(v,t,f,y,b){const[P,c]=await this.channel.call("read",[v,t,b]);return f.set(P.buffer.slice(0,c),y),c}write(v,t,f,y,b){return this.channel.call("write",[v,t,p.VSBuffer.wrap(f),y,b])}mkdir(v){return this.channel.call("mkdir",[v])}delete(v,t){return this.channel.call("delete",[v,t])}rename(v,t,f){return this.channel.call("rename",[v,t,f])}copy(v,t,f){return this.channel.call("copy",[v,t,f])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(v=>{if(Array.isArray(v)){const t=v;this._onDidChange.fire(t.map(f=>({resource:d.URI.revive(f.resource),type:f.type})))}else{const t=v;this._onDidWatchError.fire(t)}}))}watch(v,t){const f=(0,g.generateUuid)();return this.channel.call("watch",[this.sessionId,f,v,t]),(0,k.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,f]))}}e.DiskFileSystemProviderClient=E}),define(x[90],ee([0,1,17,15,145,18]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function k(S,E,w,v,t,f){let y;try{await I(S,E,w,v,t,f)}catch(b){y=b}finally{y&&t.errorTransformer&&(y=t.errorTransformer(y)),typeof y!="undefined"&&w.error(y),w.end()}}e.readFileIntoStream=k;async function I(S,E,w,v,t,f){d(f);const y=await S.open(E,{create:!1});try{d(f);let b=0,P=0,c=t&&typeof t.length=="number"?t.length:void 0,a=p.VSBuffer.alloc(Math.min(t.bufferSize,typeof c=="number"?c:t.bufferSize)),l=t&&typeof t.position=="number"?t.position:0,o=0;do P=await S.read(y,l,a.buffer,o,a.byteLength-o),l+=P,o+=P,b+=P,typeof c=="number"&&(c-=P),o===a.byteLength&&(await w.write(v(a)),a=p.VSBuffer.alloc(Math.min(t.bufferSize,typeof c=="number"?c:t.bufferSize)),o=0);while(P>0&&(typeof c!="number"||c>0)&&d(f)&&g(b,t));if(o>0){let h=o;typeof c=="number"&&(h=Math.min(o,c)),w.write(v(a.slice(0,h)))}}catch(b){throw(0,C.ensureFileSystemProviderError)(b)}finally{await S.close(y)}}function d(S){if(S.isCancellationRequested)throw(0,r.canceled)();return!0}function g(S,E){if(E?.limits){if(typeof E.limits.memory=="number"&&S>E.limits.memory)throw(0,C.createFileSystemProviderError)((0,D.localize)(0,null),C.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&S>E.limits.size)throw(0,C.createFileSystemProviderError)((0,D.localize)(1,null),C.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(x[62],ee([0,1,2,3,7,18]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractRecursiveWatcherClient=void 0;class k extends p.Disposable{constructor(E,w,v){super();this.onFileChanges=E,this.onLogMessage=w,this.verboseLogging=v,this.watcherDisposables=this._register(new p.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const E=new p.DisposableStore;this.watcherDisposables.value=E,this.watcher=this.createWatcher(E),this.watcher.setVerboseLogging(this.verboseLogging),E.add(this.watcher.onDidChangeFile(w=>this.onFileChanges(w))),E.add(this.watcher.onDidLogMessage(w=>this.onLogMessage(w))),E.add(this.watcher.onDidError(w=>this.onError(w)))}onError(E){this.restartCounter<k.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${E}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${E}`)}restart(E){this.restartCounter++,this.init(),this.watch(E)}async watch(E){this.requests=E,await this.watcher?.watch(E)}async setVerboseLogging(E){this.verboseLogging=E,await this.watcher?.setVerboseLogging(E)}error(E){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${E}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractRecursiveWatcherClient=k,k.MAX_RESTARTS=5;function I(S){return S.map(E=>({type:E.type,resource:D.URI.file(E.path)}))}e.toFileChanges=I;function d(S){const E=new g;for(const w of S)E.processEvent(w);return E.coalesce()}e.coalesceEvents=d;class g{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(E){return r.isLinux?E.path:E.path.toLowerCase()}processEvent(E){const w=this.mapPathToChange.get(this.toKey(E));let v=!1;if(w){const t=w.type,f=E.type;w.path!==E.path&&E.type===2?v=!0:t===1&&f===2?(this.mapPathToChange.delete(this.toKey(E)),this.coalesced.delete(w)):t===2&&f===1?w.type=0:t===1&&f===0||(w.type=f)}else v=!0;v&&(this.coalesced.add(E),this.mapPathToChange.set(this.toKey(E),E))}coalesce(){const E=[],w=[];return Array.from(this.coalesced).filter(v=>v.type!==2?(E.push(v),!1):!0).sort((v,t)=>v.path.length-t.path.length).filter(v=>w.some(t=>(0,C.isParent)(v.path,t,!r.isLinux))?!1:(w.push(v.path),!0)).concat(E)}}}),define(x[91],ee([0,1,9,2,8,81,21,119,62]),function(j,e,p,r,D,C,k,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSFileWatcher=void 0;class g extends r.Disposable{constructor(E,w,v,t){super();this.path=E,this.onDidFilesChange=w,this.onLogMessage=v,this.verboseLogging=t,this.fileChangesDelayer=this._register(new p.ThrottledDelayer(I.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(E){this.verboseLogging=E}async startWatching(){try{const{stat:E,symbolicLink:w}=await k.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let v=this.path;if(w)try{v=await(0,C.realpath)(v)}catch(t){if(this.onError(t),w.dangling)return}E.isDirectory()?this._register((0,I.watchFolder)(v,(t,f)=>{this.onFileChange({type:t==="changed"?0:t==="added"?1:2,path:(0,D.join)(this.path,(0,D.basename)(f))})},t=>this.onError(t))):this._register((0,I.watchFile)(v,t=>{this.onFileChange({type:t==="changed"?0:2,path:this.path})},t=>this.onError(t)))}catch(E){E.code!=="ENOENT"&&this.onError(E)}}onFileChange(E){this.fileChangesBuffer.push(E),this.verboseLogging&&this.onVerbose(`${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.path}`),this.fileChangesDelayer.trigger(async()=>{const w=this.fileChangesBuffer;this.fileChangesBuffer=[];const v=(0,d.coalesceEvents)(w);if(this.verboseLogging)for(const t of v)this.onVerbose(`>> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.path}`);v.length>0&&this.onDidFilesChange(v)})}onError(E){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${E}`})}onVerbose(E){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${E}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.NodeJSFileWatcher=g}),define(x[175],ee([0,1,10,37,133,62]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParcelWatcherClient=void 0;class k extends C.AbstractRecursiveWatcherClient{constructor(d,g,S){super(d,g,S);this.init()}createWatcher(d){const g=d.add(new D.Client(p.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=parcelWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/parcelWatcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return d.add(g.onDidProcessExit(({code:S,signal:E})=>this.onError(`terminated by itself with code ${S}, signal: ${E}`))),r.ProxyChannel.toService((0,r.getNextTickChannel)(g.getChannel("watcher")))}}e.ParcelWatcherClient=k}),define(x[75],ee([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class p{constructor(...D){this._entries=new Map;for(let[C,k]of D)this.set(C,k)}set(D,C){const k=this._entries.get(D);return this._entries.set(D,C),k}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=p}),define(x[176],ee([0,1,9,15,73,169,5,75]),function(j,e,p,r,D,C,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const d=!1;class g extends Error{constructor(t){super("cyclic dependency between services");this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class S{constructor(t=new I.ServiceCollection,f=!1,y){this._activeInstantiations=new Set,this._services=t,this._strict=f,this._parent=y,this._services.set(k.IInstantiationService,this)}createChild(t){return new S(t,this._strict,this)}invokeFunction(t,...f){let y=w.traceInvocation(t),b=!1;try{return t({get:c=>{if(b)throw(0,r.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(c,y);if(!a)throw new Error(`[invokeFunction] unknown service '${c}'`);return a}},...f)}finally{b=!0,y.stop()}}createInstance(t,...f){let y,b;return t instanceof D.SyncDescriptor?(y=w.traceCreation(t.ctor),b=this._createInstance(t.ctor,t.staticArguments.concat(f),y)):(y=w.traceCreation(t),b=this._createInstance(t,f,y)),y.stop(),b}_createInstance(t,f=[],y){let b=k._util.getServiceDependencies(t).sort((a,l)=>a.index-l.index),P=[];for(const a of b){let l=this._getOrCreateServiceInstance(a.id,y);if(!l&&this._strict&&!a.optional)throw new Error(`[createInstance] ${t.name} depends on UNKNOWN service ${a.id}.`);P.push(l)}let c=b.length>0?b[0].index:f.length;if(f.length!==c){console.warn(`[createInstance] First service dependency of ${t.name} at position ${c+1} conflicts with ${f.length} static arguments`);let a=c-f.length;a>0?f=f.concat(new Array(a)):f=f.slice(0,c)}return new t(...[...f,...P])}_setServiceInstance(t,f){if(this._services.get(t)instanceof D.SyncDescriptor)this._services.set(t,f);else if(this._parent)this._parent._setServiceInstance(t,f);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(t){let f=this._services.get(t);return!f&&this._parent?this._parent._getServiceInstanceOrDescriptor(t):f}_getOrCreateServiceInstance(t,f){let y=this._getServiceInstanceOrDescriptor(t);return y instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(t,y,f.branch(t,!0)):(f.branch(t,!1),y)}_safeCreateAndCacheServiceInstance(t,f,y){if(this._activeInstantiations.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this._activeInstantiations.add(t);try{return this._createAndCacheServiceInstance(t,f,y)}finally{this._activeInstantiations.delete(t)}}_createAndCacheServiceInstance(t,f,y){const b=new C.Graph(a=>a.id.toString());let P=0;const c=[{id:t,desc:f,_trace:y}];for(;c.length;){const a=c.pop();if(b.lookupOrInsertNode(a),P++>1e3)throw new g(b);for(let l of k._util.getServiceDependencies(a.desc.ctor)){let o=this._getServiceInstanceOrDescriptor(l.id);if(!o&&!l.optional&&console.warn(`[createInstance] ${t} depends on ${l.id} which is NOT registered.`),o instanceof D.SyncDescriptor){const h={id:l.id,desc:o,_trace:a._trace.branch(l.id,!0)};b.insertEdge(a,h),c.push(h)}}}for(;;){const a=b.roots();if(a.length===0){if(!b.isEmpty())throw new g(b);break}for(const{data:l}of a){if(this._getServiceInstanceOrDescriptor(l.id)instanceof D.SyncDescriptor){const h=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,h)}b.removeNode(l)}}return this._getServiceInstanceOrDescriptor(t)}_createServiceInstanceWithOwner(t,f,y=[],b,P){if(this._services.get(t)instanceof D.SyncDescriptor)return this._createServiceInstance(f,y,b,P);if(this._parent)return this._parent._createServiceInstanceWithOwner(t,f,y,b,P);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}_createServiceInstance(t,f=[],y,b){if(y){const P=new p.IdleValue(()=>this._createInstance(t,f,b));return new Proxy(Object.create(null),{get(c,a){if(a in c)return c[a];let l=P.value,o=l[a];return typeof o!="function"||(o=o.bind(l),c[a]=o),o},set(c,a,l){return P.value[a]=l,!0}})}else return this._createInstance(t,f,b)}}e.InstantiationService=S;var E;(function(v){v[v.Creation=0]="Creation",v[v.Invocation=1]="Invocation",v[v.Branch=2]="Branch"})(E||(E={}));class w{constructor(t,f){this.type=t,this.name=f,this._start=Date.now(),this._dep=[]}static traceInvocation(t){return d?new w(1,t.name||t.toString().substring(0,42).replace(/\n/g,"")):w._None}static traceCreation(t){return d?new w(0,t.name):w._None}branch(t,f){let y=new w(2,t.toString());return this._dep.push([t,f,y]),y}stop(){let t=Date.now()-this._start;w._totals+=t;let f=!1;function y(P,c){let a=[],l=new Array(P+1).join("	");for(const[o,h,n]of c._dep)if(h&&n){f=!0,a.push(`${l}CREATES -> ${o}`);let i=y(P+1,n);i&&a.push(i)}else a.push(`${l}uses -> ${o}`);return a.join(`
`)}let b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${y(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${w._totals.toFixed(2)}ms)`];(t>2||f)&&console.log(b.join(`
`))}}w._None=new class extends w{constructor(){super(-1,null)}stop(){}branch(){return this}},w._totals=0}),define(x[177],ee([0,1,15,130,59]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class C extends D.ResolvedKeybinding{constructor(I,d){super();if(d.length===0)throw(0,p.illegalArgument)("parts");this._os=I,this._parts=d}getLabel(){return r.UILabelProvider.toLabel(this._os,this._parts,I=>this._getLabel(I))}getAriaLabel(){return r.AriaLabelProvider.toLabel(this._os,this._parts,I=>this._getAriaLabel(I))}getElectronAccelerator(){return this._parts.length>1||this._parts[0].isDuplicateModifierCase()?null:r.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,I=>this._getElectronAccelerator(I))}getUserSettingsLabel(){return r.UserSettingsLabelProvider.toLabel(this._os,this._parts,I=>this._getUserSettingsLabel(I))}isWYSIWYG(){return this._parts.every(I=>this._isWYSIWYG(I))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(I=>this._getPart(I))}_getPart(I){return new D.ResolvedKeybindingPart(I.ctrlKey,I.shiftKey,I.altKey,I.metaKey,this._getLabel(I),this._getAriaLabel(I))}getDispatchParts(){return this._parts.map(I=>this._getDispatchPart(I))}getSingleModifierDispatchParts(){return this._parts.map(I=>this._getSingleModifierDispatchPart(I))}}e.BaseResolvedKeybinding=C}),define(x[178],ee([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeElementsAfterNulls=e.ResolvedKeybindingItem=void 0;class p{constructor(C,k,I,d,g,S,E){this._resolvedKeybindingItemBrand=void 0,this.resolvedKeybinding=C,this.keypressParts=C?r(C.getDispatchParts()):[],C&&this.keypressParts.length===0&&(this.keypressParts=r(C.getSingleModifierDispatchParts())),this.bubble=k?k.charCodeAt(0)===94:!1,this.command=this.bubble?k.substr(1):k,this.commandArgs=I,this.when=d,this.isDefault=g,this.extensionId=S,this.isBuiltinExtension=E}}e.ResolvedKeybindingItem=p;function r(D){let C=[];for(let k=0,I=D.length;k<I;k++){const d=D[k];if(!d)return C;C.push(d)}return C}e.removeElementsAfterNulls=r}),define(x[179],ee([0,1,78,59,177,178]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class k extends D.BaseResolvedKeybinding{constructor(d,g){super(g,d.parts)}_keyCodeToUILabel(d){if(this._os===2)switch(d){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return p.KeyCodeUtils.toString(d)}_getLabel(d){return d.isDuplicateModifierCase()?"":this._keyCodeToUILabel(d.keyCode)}_getAriaLabel(d){return d.isDuplicateModifierCase()?"":p.KeyCodeUtils.toString(d.keyCode)}_getElectronAccelerator(d){return p.KeyCodeUtils.toElectronAccelerator(d.keyCode)}_getUserSettingsLabel(d){if(d.isDuplicateModifierCase())return"";const g=p.KeyCodeUtils.toUserSettingsUS(d.keyCode);return g&&g.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(d){return k.getDispatchStr(d)}static getDispatchStr(d){if(d.isModifierKey())return null;let g="";return d.ctrlKey&&(g+="ctrl+"),d.shiftKey&&(g+="shift+"),d.altKey&&(g+="alt+"),d.metaKey&&(g+="meta+"),g+=p.KeyCodeUtils.toString(d.keyCode),g}_getSingleModifierDispatchPart(d){return d.keyCode===5&&!d.shiftKey&&!d.altKey&&!d.metaKey?"ctrl":d.keyCode===4&&!d.ctrlKey&&!d.altKey&&!d.metaKey?"shift":d.keyCode===6&&!d.ctrlKey&&!d.shiftKey&&!d.metaKey?"alt":d.keyCode===57&&!d.ctrlKey&&!d.shiftKey&&!d.altKey?"meta":null}static _scanCodeToKeyCode(d){const g=p.IMMUTABLE_CODE_TO_KEY_CODE[d];if(g!==-1)return g;switch(d){case 10:return 31;case 11:return 32;case 12:return 33;case 13:return 34;case 14:return 35;case 15:return 36;case 16:return 37;case 17:return 38;case 18:return 39;case 19:return 40;case 20:return 41;case 21:return 42;case 22:return 43;case 23:return 44;case 24:return 45;case 25:return 46;case 26:return 47;case 27:return 48;case 28:return 49;case 29:return 50;case 30:return 51;case 31:return 52;case 32:return 53;case 33:return 54;case 34:return 55;case 35:return 56;case 36:return 22;case 37:return 23;case 38:return 24;case 39:return 25;case 40:return 26;case 41:return 27;case 42:return 28;case 43:return 29;case 44:return 30;case 45:return 21;case 51:return 83;case 52:return 81;case 53:return 87;case 54:return 89;case 55:return 88;case 56:return 0;case 57:return 80;case 58:return 90;case 59:return 86;case 60:return 82;case 61:return 84;case 62:return 85;case 106:return 92}return 0}static _resolveSimpleUserBinding(d){if(!d)return null;if(d instanceof r.SimpleKeybinding)return d;const g=this._scanCodeToKeyCode(d.scanCode);return g===0?null:new r.SimpleKeybinding(d.ctrlKey,d.shiftKey,d.altKey,d.metaKey,g)}static resolveUserBinding(d,g){const S=(0,C.removeElementsAfterNulls)(d.map(E=>this._resolveSimpleUserBinding(E)));return S.length>0?[new k(new r.ChordKeybinding(S),g)]:[]}}e.USLayoutResolvedKeybinding=k}),define(x[180],ee([0,1,9]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function r(D,C){if(D.length===0)return Promise.resolve(!1);const k=[];let I=!1;for(let d of D){if(d===!0)return Promise.resolve(!0);(0,p.isThenable)(d)&&k.push(d.then(g=>{g&&(I=!0)},g=>{C(g),I=!0}))}return p.Promises.settled(k).then(()=>I)}e.handleVetos=r}),define(x[6],ee([0,1,39,4,2,3,5]),function(j,e,p,r,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function I(){return new Date().toISOString()}var d;(function(h){h[h.Trace=0]="Trace",h[h.Debug=1]="Debug",h[h.Info=2]="Info",h[h.Warning=3]="Warning",h[h.Error=4]="Error",h[h.Critical=5]="Critical",h[h.Off=6]="Off"})(d=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=d.Info;function g(h,n,i){switch(n){case d.Trace:h.trace(i);break;case d.Debug:h.debug(i);break;case d.Info:h.info(i);break;case d.Warning:h.warn(i);break;case d.Error:h.error(i);break;case d.Critical:h.critical(i);break;default:throw new Error("Invalid log level")}}e.log=g;function S(h){let n="";for(let i=0;i<h.length;i++){let s=h[i];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}n+=(i>0?" ":"")+s}return n}e.format=S;class E extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new r.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class w extends E{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...i){this.checkLogLevel(d.Trace)&&this.log(d.Trace,S([n,...i]))}debug(n,...i){this.checkLogLevel(d.Debug)&&this.log(d.Debug,S([n,...i]))}info(n,...i){this.checkLogLevel(d.Info)&&this.log(d.Info,S([n,...i]))}warn(n,...i){this.checkLogLevel(d.Warning)&&this.log(d.Warning,S([n,...i]))}error(n,...i){if(this.checkLogLevel(d.Error))if(n instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=n.stack,this.log(d.Error,S(s))}else this.log(d.Error,S([n,...i]))}critical(n,...i){this.checkLogLevel(d.Critical)&&this.log(d.Critical,S([n,...i]))}flush(){}}e.AbstractMessageLogger=w;class v extends E{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!C.isWindows}trace(n,...i){this.getLevel()<=d.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,n,...i):console.log(`[main ${I()}]`,n,...i))}debug(n,...i){this.getLevel()<=d.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,n,...i):console.log(`[main ${I()}]`,n,...i))}info(n,...i){this.getLevel()<=d.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,n,...i):console.log(`[main ${I()}]`,n,...i))}warn(n,...i){this.getLevel()<=d.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,n,...i):console.warn(`[main ${I()}]`,n,...i))}error(n,...i){this.getLevel()<=d.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,n,...i):console.error(`[main ${I()}]`,n,...i))}critical(n,...i){this.getLevel()<=d.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,n,...i):console.error(`[main ${I()}]`,n,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=v;class t extends E{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...i){this.getLevel()<=d.Trace&&console.log("%cTRACE","color: #888",n,...i)}debug(n,...i){this.getLevel()<=d.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...i)}info(n,...i){this.getLevel()<=d.Info&&console.log("%c INFO","color: #33f",n,...i)}warn(n,...i){this.getLevel()<=d.Warning&&console.log("%c WARN","color: #993",n,...i)}error(n,...i){this.getLevel()<=d.Error&&console.log("%c  ERR","color: #f33",n,...i)}critical(n,...i){this.getLevel()<=d.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...i)}dispose(){}flush(){}}e.ConsoleLogger=t;class f extends E{constructor(n,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(i)}trace(n,...i){this.getLevel()<=d.Trace&&this.adapter.log(d.Trace,[this.extractMessage(n),...i])}debug(n,...i){this.getLevel()<=d.Debug&&this.adapter.log(d.Debug,[this.extractMessage(n),...i])}info(n,...i){this.getLevel()<=d.Info&&this.adapter.log(d.Info,[this.extractMessage(n),...i])}warn(n,...i){this.getLevel()<=d.Warning&&this.adapter.log(d.Warning,[this.extractMessage(n),...i])}error(n,...i){this.getLevel()<=d.Error&&this.adapter.log(d.Error,[this.extractMessage(n),...i])}critical(n,...i){this.getLevel()<=d.Critical&&this.adapter.log(d.Critical,[this.extractMessage(n),...i])}extractMessage(n){return typeof n=="string"?n:(0,p.toErrorMessage)(n,this.getLevel()<=d.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class y extends E{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const i of this.logServices)i.setLevel(n);super.setLevel(n)}trace(n,...i){for(const s of this.logServices)s.trace(n,...i)}debug(n,...i){for(const s of this.logServices)s.debug(n,...i)}info(n,...i){for(const s of this.logServices)s.info(n,...i)}warn(n,...i){for(const s of this.logServices)s.warn(n,...i)}error(n,...i){for(const s of this.logServices)s.error(n,...i)}critical(n,...i){for(const s of this.logServices)s.critical(n,...i)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=y;class b extends D.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...i){this.logger.trace(n,...i)}debug(n,...i){this.logger.debug(n,...i)}info(n,...i){this.logger.info(n,...i)}warn(n,...i){this.logger.warn(n,...i)}error(n,...i){this.logger.error(n,...i)}critical(n,...i){this.logger.critical(n,...i)}flush(){this.logger.flush()}}e.LogService=b;class P extends D.Disposable{constructor(n,i){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(u=>u.setLevel(s))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,i){let s=this.loggers.get(n.toString());return s||(s=this.doCreateLogger(n,i?.always?d.Trace:this.logLevel,i),this.loggers.set(n.toString(),s),i?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=P;class c{constructor(){this.onDidChangeLogLevel=new r.Emitter().event}setLevel(n){}getLevel(){return d.Info}trace(n,...i){}debug(n,...i){}info(n,...i){}warn(n,...i){}error(n,...i){}critical(n,...i){}dispose(){}flush(){}}e.NullLogService=c;function a(h){if(h.verbose)return d.Trace;if(typeof h.logLevel=="string"){const n=l(h.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function l(h){switch(h){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Critical;case"off":return d.Off}}e.parseLogLevel=l;function o(h){switch(h){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Critical:return"critical";case d.Off:return"off"}}e.LogLevelToString=o}),define(x[181],ee([0,1,31,9,15,4,2,8,62,6]),function(j,e,p,r,D,C,k,I,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class S extends k.Disposable{constructor(w){super();this.logService=w,this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new r.ThrottledDelayer(0))}watch(w,v){return v.recursive?this.watchRecursive(w,v):this.watchNonRecursive(w)}watchRecursive(w,v){const t={path:this.toFilePath(w),excludes:v.excludes},f=(0,p.insert)(this.recursiveFoldersToWatch,t);return this.refreshRecursiveWatchers(),(0,k.toDisposable)(()=>{f(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(w=>(0,D.onUnexpectedError)(w))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(w=>this._onDidChangeFile.fire((0,d.toFileChanges)(w)),w=>this.onWatcherLogMessage(w),this.logService.getLevel()===g.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===g.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(w,v){return w.watch(v)}watchNonRecursive(w){const v=this.createNonRecursiveWatcher(this.toFilePath(w),f=>this._onDidChangeFile.fire((0,d.toFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===g.LogLevel.Trace),t=this.logService.onDidChangeLogLevel(()=>{v.setVerboseLogging(this.logService.getLevel()===g.LogLevel.Trace)});return(0,k.combinedDisposable)(v,t)}onWatcherLogMessage(w){w.type==="error"&&this._onDidWatchError.fire(w.message),this.logService[w.type](w.message)}toFilePath(w){return(0,I.normalize)(w.fsPath)}}e.AbstractDiskFileSystemProvider=S});var ie=this&&this.__param||function(j,e){return function(p,r){e(p,r,j)}};define(x[182],ee([0,1,31,9,17,23,4,69,2,36,10,63,16,51,143,18,90,6]),function(j,e,p,r,D,C,k,I,d,g,S,E,w,v,t,f,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let P=class Ye extends d.Disposable{constructor(a){super();this.logService=a,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this._onDidChangeFilesRaw=this._register(new k.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new r.ThrottledWorker(Ye.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ye.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ye.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new f.FileChangesEvent(l,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new r.ThrottledWorker(Ye.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ye.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ye.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new f.FileChangesEvent(l,!0)))),this.watchedResources=g.TernarySearchTree.forUris(l=>{const o=this.getProvider(l.scheme);return o?!this.isPathCaseSensitive(o):!1}),this.writeQueue=this._register(new r.ResourceQueue)}registerProvider(a,l){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,E.mark)(`code/registerFilesystem/${a}`),this.provider.set(a,l),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:l});const o=new d.DisposableStore;return o.add(l.onDidChangeFile(h=>this.onDidChangeFile(h,this.isPathCaseSensitive(l)))),o.add(l.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:l,scheme:a}))),typeof l.onDidWatchError=="function"&&o.add(l.onDidWatchError(h=>this._onDidWatchError.fire(new Error(h)))),(0,d.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:l}),this.provider.delete(a),(0,d.dispose)(o)})}getProvider(a){return this.provider.get(a)}async activateProvider(a){const l=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(o){l.push(o)}}),!this.provider.has(a)&&await r.Promises.settled(l)}async canHandleResource(a){return await this.activateProvider(a.scheme),this.hasProvider(a)}hasProvider(a){return this.provider.has(a.scheme)}hasCapability(a,l){const o=this.provider.get(a.scheme);return!!(o&&o.capabilities&l)}listCapabilities(){return I.Iterable.map(this.provider,([a,l])=>({scheme:a,capabilities:l.capabilities}))}async withProvider(a){if(!(0,w.isAbsolutePath)(a))throw new f.FileOperationError((0,t.localize)(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const l=this.provider.get(a.scheme);if(!l){const o=new Error;throw o.name="ENOPRO",o.message=(0,t.localize)(1,null,a.toString()),o}return l}async withReadProvider(a){const l=await this.withProvider(a);if((0,f.hasOpenReadWriteCloseCapability)(l)||(0,f.hasReadWriteCapability)(l)||(0,f.hasFileReadStreamCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const l=await this.withProvider(a);if((0,f.hasOpenReadWriteCloseCapability)(l)||(0,f.hasReadWriteCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,l){try{return await this.doResolveFile(a,l)}catch(o){throw(0,f.toFileSystemProviderErrorCode)(o)===f.FileSystemProviderErrorCode.FileNotFound?new f.FileOperationError((0,t.localize)(2,null,this.resourceForError(a)),1):(0,f.ensureFileSystemProviderError)(o)}}async doResolveFile(a,l){const o=await this.withProvider(a),h=this.isPathCaseSensitive(o),n=l?.resolveTo,i=l?.resolveSingleChildDescendants,s=l?.resolveMetadata,u=await o.stat(a);let m;return this.toFileStat(o,a,u,void 0,!!s,(M,L)=>(m||(m=g.TernarySearchTree.forUris(()=>!h),m.set(a,!0),n&&m.fill(!0,n)),m.get(M.resource)||m.findSuperstr(M.resource.with({query:null,fragment:null}))?!0:M.isDirectory&&i?L===1:!1))}async toFileStat(a,l,o,h,n,i){const{providerExtUri:s}=this.getExtUri(a),u={resource:l,name:s.basename(l),isFile:(o.type&f.FileType.File)!=0,isDirectory:(o.type&f.FileType.Directory)!=0,isSymbolicLink:(o.type&f.FileType.SymbolicLink)!=0,mtime:o.mtime,ctime:o.ctime,size:o.size,readonly:Boolean((o.permissions??0)&f.FilePermission.Readonly)||Boolean(a.capabilities&2048),etag:(0,f.etag)({mtime:o.mtime,size:o.size})};if(u.isDirectory&&i(u,h)){try{const m=await a.readdir(l),M=await r.Promises.settled(m.map(async([L,R])=>{try{const T=s.joinPath(l,L),_=n?await a.stat(T):{type:R};return await this.toFileStat(a,T,_,m.length,n,i)}catch(T){return this.logService.trace(T),null}}));u.children=(0,p.coalesce)(M)}catch(m){this.logService.trace(m),u.children=[]}return u}return u}async resolveAll(a){return r.Promises.settled(a.map(async l=>{try{return{stat:await this.doResolveFile(l.resource,l.options),success:!0}}catch(o){return this.logService.trace(o),{stat:void 0,success:!1}}}))}async exists(a){const l=await this.withProvider(a);try{return!!await l.stat(a)}catch{return!1}}async canCreateFile(a,l){try{await this.doValidateCreateFile(a,l)}catch(o){return o}return!0}async doValidateCreateFile(a,l){if(!l?.overwrite&&await this.exists(a))throw new f.FileOperationError((0,t.localize)(3,null,this.resourceForError(a)),3,l)}async createFile(a,l=D.VSBuffer.fromString(""),o){await this.doValidateCreateFile(a,o);const h=await this.writeFile(a,l);return this._onDidRunOperation.fire(new f.FileOperationEvent(a,0,h)),h}async writeFile(a,l,o){const h=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:n}=this.getExtUri(h);try{await this.validateWriteFile(h,a,o)||await this.mkdirp(h,n.dirname(a));let s;if((0,f.hasReadWriteCapability)(h)&&!(l instanceof D.VSBuffer))if((0,v.isReadableStream)(l)){const u=await(0,v.peekStream)(l,3);u.ended?s=D.VSBuffer.concat(u.buffer):s=u}else s=(0,v.peekReadable)(l,u=>D.VSBuffer.concat(u),3);else s=l;!(0,f.hasOpenReadWriteCloseCapability)(h)||(0,f.hasReadWriteCapability)(h)&&s instanceof D.VSBuffer?await this.doWriteUnbuffered(h,a,o,s):await this.doWriteBuffered(h,a,o,s instanceof D.VSBuffer?(0,D.bufferToReadable)(s):s)}catch(i){throw new f.FileOperationError((0,t.localize)(4,null,this.resourceForError(a),(0,f.ensureFileSystemProviderError)(i).toString()),(0,f.toFileOperationResult)(i),o)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,l,o){if(!!o?.unlock&&!(a.capabilities&8192))throw new Error((0,t.localize)(5,null,this.resourceForError(l)));let n;try{n=await a.stat(l)}catch{return}if((n.type&f.FileType.Directory)!=0)throw new f.FileOperationError((0,t.localize)(6,null,this.resourceForError(l)),0,o);if(this.throwIfFileIsReadonly(l,n),typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==f.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&o.mtime<n.mtime&&o.etag!==(0,f.etag)({mtime:o.mtime,size:n.size}))throw new f.FileOperationError((0,t.localize)(7,null),3,o);return n}async readFile(a,l,o){const h=await this.withReadProvider(a);return l?.atomic?this.doReadFileAtomic(h,a,l,o):this.doReadFile(h,a,l,o)}async doReadFileAtomic(a,l,o,h){return new Promise((n,i)=>{this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(a,l,o,h);n(s)}catch(s){i(s)}})})}async doReadFile(a,l,o,h){const n=await this.doReadFileStream(a,l,{...o,preferUnbuffered:!0},h);return{...n,value:await(0,D.streamToBuffer)(n.value)}}async readFileStream(a,l,o){const h=await this.withReadProvider(a);return this.doReadFileStream(h,a,l,o)}async doReadFileStream(a,l,o,h){const n=new C.CancellationTokenSource(h),i=this.validateReadFile(l,o).then(u=>u,u=>{throw n.cancel(),u});let s;try{return typeof o?.etag=="string"&&o.etag!==f.ETAG_DISABLED&&await i,o?.atomic&&(0,f.hasFileAtomicReadCapability)(a)||!((0,f.hasOpenReadWriteCloseCapability)(a)||(0,f.hasFileReadStreamCapability)(a))||(0,f.hasReadWriteCapability)(a)&&o?.preferUnbuffered?s=this.readFileUnbuffered(a,l,o):(0,f.hasFileReadStreamCapability)(a)?s=this.readFileStreamed(a,l,n.token,o):s=this.readFileBuffered(a,l,n.token,o),{...await i,value:s}}catch(u){s&&await(0,v.consumeStream)(s);const m=(0,t.localize)(8,null,this.resourceForError(l),(0,f.ensureFileSystemProviderError)(u).toString());throw u instanceof f.NotModifiedSinceFileOperationError?new f.NotModifiedSinceFileOperationError(m,u.stat,o):new f.FileOperationError(m,(0,f.toFileOperationResult)(u),o)}}readFileStreamed(a,l,o,h=Object.create(null)){const n=a.readFileStream(l,h,o);return(0,v.transform)(n,{data:i=>i instanceof D.VSBuffer?i:D.VSBuffer.wrap(i),error:i=>new f.FileOperationError((0,t.localize)(9,null,this.resourceForError(l),(0,f.ensureFileSystemProviderError)(i).toString()),(0,f.toFileOperationResult)(i),h)},i=>D.VSBuffer.concat(i))}readFileBuffered(a,l,o,h=Object.create(null)){const n=(0,D.newWriteableBufferStream)();return(0,y.readFileIntoStream)(a,l,n,i=>i,{...h,bufferSize:this.BUFFER_SIZE,errorTransformer:i=>new f.FileOperationError((0,t.localize)(10,null,this.resourceForError(l),(0,f.ensureFileSystemProviderError)(i).toString()),(0,f.toFileOperationResult)(i),h)},o),n}readFileUnbuffered(a,l,o){const h=(0,v.newWriteableStream)(n=>D.VSBuffer.concat(n));return(async()=>{try{let n;o?.atomic&&(0,f.hasFileAtomicReadCapability)(a)?n=await a.readFile(l,{atomic:!0}):n=await a.readFile(l),typeof o?.position=="number"&&(n=n.slice(o.position)),typeof o?.length=="number"&&(n=n.slice(0,o.length)),this.validateReadFileLimits(l,n.byteLength,o),h.end(D.VSBuffer.wrap(n))}catch(n){h.error(n),h.end()}})(),h}async validateReadFile(a,l){const o=await this.resolve(a,{resolveMetadata:!0});if(o.isDirectory)throw new f.FileOperationError((0,t.localize)(11,null,this.resourceForError(a)),0,l);if(typeof l?.etag=="string"&&l.etag!==f.ETAG_DISABLED&&l.etag===o.etag)throw new f.NotModifiedSinceFileOperationError((0,t.localize)(12,null),o,l);return this.validateReadFileLimits(a,o.size,l),o}validateReadFileLimits(a,l,o){if(o?.limits){let h;if(typeof o.limits.memory=="number"&&l>o.limits.memory&&(h=9),typeof o.limits.size=="number"&&l>o.limits.size&&(h=7),typeof h=="number")throw new f.FileOperationError((0,t.localize)(13,null,this.resourceForError(a)),h)}}async canMove(a,l,o){return this.doCanMoveCopy(a,l,"move",o)}async canCopy(a,l,o){return this.doCanMoveCopy(a,l,"copy",o)}async doCanMoveCopy(a,l,o,h){if(a.toString()!==l.toString())try{const n=o==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l);await this.doValidateMoveCopy(n,a,i,l,o,h)}catch(n){return n}return!0}async move(a,l,o){const h=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),i=await this.doMoveCopy(h,a,n,l,"move",!!o),s=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(a,i==="move"?2:3,s)),s}async copy(a,l,o){const h=await this.withReadProvider(a),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),i=await this.doMoveCopy(h,a,n,l,"copy",!!o),s=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(a,i==="copy"?3:2,s)),s}async doMoveCopy(a,l,o,h,n,i){if(l.toString()===h.toString())return n;const{exists:s,isSameResourceWithDifferentPathCase:u}=await this.doValidateMoveCopy(a,l,o,h,n,i);if(s&&!u&&i&&await this.del(h,{recursive:!0}),await this.mkdirp(o,this.getExtUri(o).providerExtUri.dirname(h)),n==="copy"){if(a===o&&(0,f.hasFileFolderCopyCapability)(a))await a.copy(l,h,{overwrite:i});else{const m=await this.resolve(l);m.isDirectory?await this.doCopyFolder(a,m,o,h):await this.doCopyFile(a,l,o,h)}return n}else return a===o?(await a.rename(l,h,{overwrite:i}),n):(await this.doMoveCopy(a,l,o,h,"copy",i),await this.del(l,{recursive:!0}),"copy")}async doCopyFile(a,l,o,h){if((0,f.hasOpenReadWriteCloseCapability)(a)&&(0,f.hasOpenReadWriteCloseCapability)(o))return this.doPipeBuffered(a,l,o,h);if((0,f.hasOpenReadWriteCloseCapability)(a)&&(0,f.hasReadWriteCapability)(o))return this.doPipeBufferedToUnbuffered(a,l,o,h);if((0,f.hasReadWriteCapability)(a)&&(0,f.hasOpenReadWriteCloseCapability)(o))return this.doPipeUnbufferedToBuffered(a,l,o,h);if((0,f.hasReadWriteCapability)(a)&&(0,f.hasReadWriteCapability)(o))return this.doPipeUnbuffered(a,l,o,h)}async doCopyFolder(a,l,o,h){await o.mkdir(h),Array.isArray(l.children)&&await r.Promises.settled(l.children.map(async n=>{const i=this.getExtUri(o).providerExtUri.joinPath(h,n.name);return n.isDirectory?this.doCopyFolder(a,await this.resolve(n.resource),o,i):this.doCopyFile(a,n.resource,o,i)}))}async doValidateMoveCopy(a,l,o,h,n,i){let s=!1;if(a===o){const{providerExtUri:m,isPathCaseSensitive:M}=this.getExtUri(a);if(M||(s=m.isEqual(l,h)),s&&n==="copy")throw new Error((0,t.localize)(14,null,this.resourceForError(l),this.resourceForError(h)));if(!s&&m.isEqualOrParent(h,l))throw new Error((0,t.localize)(15,null,this.resourceForError(l),this.resourceForError(h)))}const u=await this.exists(h);if(u&&!s){if(!i)throw new f.FileOperationError((0,t.localize)(16,null,this.resourceForError(l),this.resourceForError(h)),4);if(a===o){const{providerExtUri:m}=this.getExtUri(a);if(m.isEqualOrParent(l,h))throw new Error((0,t.localize)(17,null,this.resourceForError(l),this.resourceForError(h)))}}return{exists:u,isSameResourceWithDifferentPathCase:s}}getExtUri(a){const l=this.isPathCaseSensitive(a);return{providerExtUri:l?w.extUri:w.extUriIgnorePathCase,isPathCaseSensitive:l}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(l,a);const o=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(a,0,o)),o}async mkdirp(a,l){const o=[],{providerExtUri:h}=this.getExtUri(a);for(;!h.isEqual(l,h.dirname(l));)try{if(((await a.stat(l)).type&f.FileType.Directory)==0)throw new Error((0,t.localize)(18,null,this.resourceForError(l)));break}catch(n){if((0,f.toFileSystemProviderErrorCode)(n)!==f.FileSystemProviderErrorCode.FileNotFound)throw n;o.push(h.basename(l)),l=h.dirname(l)}for(let n=o.length-1;n>=0;n--){l=h.joinPath(l,o[n]);try{await a.mkdir(l)}catch(i){if((0,f.toFileSystemProviderErrorCode)(i)!==f.FileSystemProviderErrorCode.FileExists)throw i}}}async canDelete(a,l){try{await this.doValidateDelete(a,l)}catch(o){return o}return!0}async doValidateDelete(a,l){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!l?.useTrash&&!(o.capabilities&4096))throw new Error((0,t.localize)(19,null,this.resourceForError(a)));let n;try{n=await o.stat(a)}catch{}if(n)this.throwIfFileIsReadonly(a,n);else throw new f.FileOperationError((0,t.localize)(20,null,this.resourceForError(a)),1);if(!!!l?.recursive){const s=await this.resolve(a);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,t.localize)(21,null,this.resourceForError(a)))}return o}async del(a,l){const o=await this.doValidateDelete(a,l),h=!!l?.useTrash,n=!!l?.recursive;await o.delete(a,{recursive:n,useTrash:h}),this._onDidRunOperation.fire(new f.FileOperationEvent(a,1))}onDidChangeFile(a,l){this._onDidChangeFilesRaw.fire({changes:a});let o,h;{for(const n of a)this.watchedResources.has(n.resource)?(o||(o=[]),o.push(n)):(h||(h=[]),h.push(n));o&&this._onDidFilesChange.fire(new f.FileChangesEvent(o,!l))}if(h){const n=l?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(h)&&Ye.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${h[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(a,l={recursive:!1,excludes:[]}){const o=new d.DisposableStore;let h=!1,n=()=>{h=!0};return o.add((0,d.toDisposable)(()=>n())),this.doWatch(a,l).then(i=>{h?(0,d.dispose)(i):n=()=>(0,d.dispose)(i)},i=>this.logService.error(i)),l.recursive||(this.watchedResources.set(a,(this.watchedResources.get(a)??0)+1),o.add((0,d.toDisposable)(()=>{const i=this.watchedResources.get(a);typeof i=="number"&&(i<=1?this.watchedResources.delete(a):this.watchedResources.set(a,i-1))}))),o}async doWatch(a,l){const o=await this.withProvider(a),h=this.toWatchKey(o,a,l);let n=this.activeWatchers.get(h);return n||(n={count:0,disposable:o.watch(a,l)},this.activeWatchers.set(h,n)),n.count+=1,(0,d.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,d.dispose)(n.disposable),this.activeWatchers.delete(h)))})}toWatchKey(a,l,o){const{providerExtUri:h}=this.getExtUri(a);return[h.getComparisonKey(l),String(o.recursive),o.excludes.join()].join()}dispose(){super.dispose();for(const[,a]of this.activeWatchers)(0,d.dispose)(a.disposable);this.activeWatchers.clear()}async doWriteBuffered(a,l,o,h){return this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(async()=>{const n=await a.open(l,{create:!0,unlock:o?.unlock??!1});try{(0,v.isReadableStream)(h)||(0,v.isReadableBufferedStream)(h)?await this.doWriteStreamBufferedQueued(a,n,h):await this.doWriteReadableBufferedQueued(a,n,h)}catch(i){throw(0,f.ensureFileSystemProviderError)(i)}finally{await a.close(n)}})}async doWriteStreamBufferedQueued(a,l,o){let h=0,n;if((0,v.isReadableBufferedStream)(o)){if(o.buffer.length>0){const i=D.VSBuffer.concat(o.buffer);await this.doWriteBuffer(a,l,i,i.byteLength,h,0),h+=i.byteLength}if(o.ended)return;n=o.stream}else n=o;return new Promise((i,s)=>{(0,v.listenStream)(n,{onData:async u=>{n.pause();try{await this.doWriteBuffer(a,l,u,u.byteLength,h,0)}catch(m){return s(m)}h+=u.byteLength,setTimeout(()=>n.resume())},onError:u=>s(u),onEnd:()=>i()})})}async doWriteReadableBufferedQueued(a,l,o){let h=0,n;for(;(n=o.read())!==null;)await this.doWriteBuffer(a,l,n,n.byteLength,h,0),h+=n.byteLength}async doWriteBuffer(a,l,o,h,n,i){let s=0;for(;s<h;)s+=await a.write(l,n+s,o.buffer,i+s,h-s)}async doWriteUnbuffered(a,l,o,h){return this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(a,l,o,h))}async doWriteUnbufferedQueued(a,l,o,h){let n;h instanceof D.VSBuffer?n=h:(0,v.isReadableStream)(h)?n=await(0,D.streamToBuffer)(h):(0,v.isReadableBufferedStream)(h)?n=await(0,D.bufferedStreamToBuffer)(h):n=(0,D.readableToBuffer)(h),await a.writeFile(l,n.buffer,{create:!0,overwrite:!0,unlock:o?.unlock??!1})}async doPipeBuffered(a,l,o,h){return this.writeQueue.queueFor(h,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeBufferedQueued(a,l,o,h))}async doPipeBufferedQueued(a,l,o,h){let n,i;try{n=await a.open(l,{create:!1}),i=await o.open(h,{create:!0,unlock:!1});const s=D.VSBuffer.alloc(this.BUFFER_SIZE);let u=0,m=0,M=0;do M=await a.read(n,u,s.buffer,m,s.byteLength-m),await this.doWriteBuffer(o,i,s,M,u,m),u+=M,m+=M,m===s.byteLength&&(m=0);while(M>0)}catch(s){throw(0,f.ensureFileSystemProviderError)(s)}finally{await r.Promises.settled([typeof n=="number"?a.close(n):Promise.resolve(),typeof i=="number"?o.close(i):Promise.resolve()])}}async doPipeUnbuffered(a,l,o,h){return this.writeQueue.queueFor(h,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(a,l,o,h))}async doPipeUnbufferedQueued(a,l,o,h){return o.writeFile(h,await a.readFile(l),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(a,l,o,h){return this.writeQueue.queueFor(h,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,l,o,h))}async doPipeUnbufferedToBufferedQueued(a,l,o,h){const n=await o.open(h,{create:!0,unlock:!1});try{const i=await a.readFile(l);await this.doWriteBuffer(o,n,D.VSBuffer.wrap(i),i.byteLength,0,0)}catch(i){throw(0,f.ensureFileSystemProviderError)(i)}finally{await o.close(n)}}async doPipeBufferedToUnbuffered(a,l,o,h){const n=await(0,D.streamToBuffer)(this.readFileBuffered(a,l,C.CancellationToken.None));await this.doWriteUnbuffered(o,h,void 0,n)}throwIfFileSystemIsReadonly(a,l){if(a.capabilities&2048)throw new f.FileOperationError((0,t.localize)(22,null,this.resourceForError(l)),6);return a}throwIfFileIsReadonly(a,l){if((l.permissions??0)&f.FilePermission.Readonly)throw new f.FileOperationError((0,t.localize)(23,null,this.resourceForError(a)),6)}resourceForError(a){return a.scheme===S.Schemas.file?a.fsPath:a.toString(!0)}};P.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},P=fe([ie(0,b.ILogService)],P),e.FileService=P}),define(x[183],ee([0,1,14,146,3,7,18,91,8,2,62,6,168,111]),function(j,e,p,r,D,C,k,I,d,g,S,E,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class t extends w.AbstractDiskFileSystemProviderChannel{constructor(b,P){super(b,P)}getUriTransformer(b){return v.DefaultURITransformer}transformIncoming(b,P){return C.URI.revive(P)}async delete(b,P,c){if(!c.useTrash)return super.delete(b,P,c);const a=this.transformIncoming(b,P),l=(0,d.normalize)(a.fsPath);try{await p.shell.trashItem(l)}catch{throw(0,k.createFileSystemProviderError)(D.isWindows?(0,r.localize)(0,null,(0,d.basename)(l)):(0,r.localize)(1,null,(0,d.basename)(l)),k.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(b,P){return new f(P,this.logService)}}e.DiskFileSystemProviderChannel=t;class f extends g.Disposable{constructor(b,P){super();this.sessionEmitter=b,this.logService=P,this.watcherRequests=new Map}watch(b,P,c){if(c.recursive)throw(0,k.createFileSystemProviderError)("Recursive watcher is not supported from main process",k.FileSystemProviderErrorCode.Unavailable);const a=new g.DisposableStore;this.watcherRequests.set(b,a),a.add((0,g.toDisposable)(()=>this.watcherRequests.delete(b)));const l=a.add(new I.NodeJSFileWatcher((0,d.normalize)(P.fsPath),o=>this.sessionEmitter.fire((0,S.toFileChanges)(o)),o=>this.onWatcherLogMessage(o),this.logService.getLevel()===E.LogLevel.Trace));return a.add(this.logService.onDidChangeLogLevel(()=>{l.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)})),a}onWatcherLogMessage(b){b.type==="error"&&this.sessionEmitter.fire(b.message),this.logService[b.type](b.message)}dispose(){super.dispose(),this.watcherRequests.forEach(b=>(0,g.dispose)(b)),this.watcherRequests.clear()}}}),define(x[92],ee([0,1,28,249,9,36,17,4,32,2,8,3,16,51,21,147,18,90,91,175,181,39]),function(j,e,p,r,D,C,k,I,d,g,S,E,w,v,t,f,y,b,P,c,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,r.gracefulify)(p)}catch(h){console.error(`Error enabling graceful-fs: ${(0,l.toErrorMessage)(h)}`)}})();class o extends a.AbstractDiskFileSystemProvider{constructor(n,i){super(n);this.options=i,this.onDidChangeCapabilities=I.Event.None,this.resourceLocks=new C.ResourceMap(s=>w.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,E.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:i,symbolicLink:s}=await t.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(n){try{const i=await t.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async u=>{try{let m;u.isSymbolicLink()?m=(await this.stat((0,w.joinPath)(n,u.name))).type:m=this.toType(u),s.push([u.name,m])}catch(m){this.logService.trace(m)}})),s}catch(i){throw this.toFileSystemProviderError(i)}}toType(n,i){let s;return i?.dangling?s=y.FileType.Unknown:n.isFile()?s=y.FileType.File:n.isDirectory()?s=y.FileType.Directory:s=y.FileType.Unknown,i&&(s|=y.FileType.SymbolicLink),s}async createResourceLock(n){this.logService.trace(`[Disk FileSystemProvider]: request to acquire resource lock (${this.toFilePath(n)})`);let i;for(;i=this.resourceLocks.get(n);)this.logService.trace(`[Disk FileSystemProvider]: waiting for resource lock to be released (${this.toFilePath(n)})`),await i.wait();const s=new D.Barrier;return this.resourceLocks.set(n,s),this.logService.trace(`[Disk FileSystemProvider]: new resource lock created (${this.toFilePath(n)})`),(0,g.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: resource lock disposed (${this.toFilePath(n)})`),this.resourceLocks.delete(n),s.open()})}async readFile(n,i){let s;try{i?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(n)})`),s=await this.createResourceLock(n));const u=this.toFilePath(n);return await t.Promises.readFile(u)}catch(u){throw this.toFileSystemProviderError(u)}finally{s?.dispose()}}readFileStream(n,i,s){const u=(0,v.newWriteableStream)(m=>k.VSBuffer.concat(m.map(M=>k.VSBuffer.wrap(M))).buffer);return(0,b.readFileIntoStream)(this,n,u,m=>m.buffer,{...i,bufferSize:256*1024},s),u}async writeFile(n,i,s){let u;try{const m=this.toFilePath(n);if(!s.create||!s.overwrite){if(await t.Promises.exists(m)){if(!s.overwrite)throw(0,y.createFileSystemProviderError)((0,f.localize)(0,null),y.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,y.createFileSystemProviderError)((0,f.localize)(1,null),y.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(n,{create:!0,unlock:s.unlock}),await this.write(u,0,i,0,i.byteLength)}catch(m){throw await this.toFileSystemProviderWriteError(n,m)}finally{typeof u=="number"&&await this.close(u)}}async open(n,i){let s;(0,y.isFileOpenForWriteOptions)(i)&&(s=await this.createResourceLock(n));let u;try{const m=this.toFilePath(n);if((0,y.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:L}=await t.SymlinkSupport.stat(m);L.mode&128||await t.Promises.chmod(m,L.mode|128)}catch(L){this.logService.trace(L)}let M;if((0,y.isFileOpenForWriteOptions)(i)){if(E.isWindows)try{await t.Promises.truncate(m,0),M="r+"}catch(L){L.code!=="ENOENT"&&this.logService.trace(L)}M||(M="w")}else M="r";u=await t.Promises.open(m,M)}catch(m){throw s?.dispose(),(0,y.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(n,m):this.toFileSystemProviderError(m)}return this.mapHandleToPos.set(u,0),(0,y.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(u,n),s&&this.mapHandleToLock.set(u,s),u}async close(n){try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&this.canFlush)try{await t.Promises.fdatasync(n)}catch(i){this.canFlush=!1,this.logService.error(i)}return await t.Promises.close(n)}catch(i){throw this.toFileSystemProviderError(i)}finally{const i=this.mapHandleToLock.get(n);i&&(this.mapHandleToLock.delete(n),i.dispose())}}async read(n,i,s,u,m){const M=this.normalizePos(n,i);let L=null;try{const R=await t.Promises.read(n,s,u,m,M);return typeof R=="number"?L=R:L=R.bytesRead,L}catch(R){throw this.toFileSystemProviderError(R)}finally{this.updatePos(n,M,L)}}normalizePos(n,i){return i===this.mapHandleToPos.get(n)?null:i}updatePos(n,i,s){const u=this.mapHandleToPos.get(n);typeof u=="number"&&(typeof i=="number"||(typeof s=="number"?this.mapHandleToPos.set(n,u+s):this.mapHandleToPos.delete(n)))}async write(n,i,s,u,m){return(0,D.retry)(()=>this.doWrite(n,i,s,u,m),100,3)}async doWrite(n,i,s,u,m){const M=this.normalizePos(n,i);let L=null;try{const R=await t.Promises.write(n,s,u,m,M);return typeof R=="number"?L=R:L=R.bytesWritten,L}catch(R){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),R)}finally{this.updatePos(n,M,L)}}async mkdir(n){try{await t.Promises.mkdir(this.toFilePath(n))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(n,i){try{const s=this.toFilePath(n);i.recursive?await t.Promises.rm(s,t.RimRafMode.MOVE):await t.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(n,i,s){const u=this.toFilePath(n),m=this.toFilePath(i);if(u!==m)try{await this.validateTargetDeleted(n,i,"move",s.overwrite),await t.Promises.move(u,m)}catch(M){throw(M.code==="EINVAL"||M.code==="EBUSY"||M.code==="ENAMETOOLONG")&&(M=new Error((0,f.localize)(2,null,(0,S.basename)(u),(0,S.basename)((0,S.dirname)(m)),M.toString()))),this.toFileSystemProviderError(M)}}async copy(n,i,s){const u=this.toFilePath(n),m=this.toFilePath(i);if(u!==m)try{await this.validateTargetDeleted(n,i,"copy",s.overwrite),await t.Promises.copy(u,m,{preserveSymlinks:!0})}catch(M){throw(M.code==="EINVAL"||M.code==="EBUSY"||M.code==="ENAMETOOLONG")&&(M=new Error((0,f.localize)(3,null,(0,S.basename)(u),(0,S.basename)((0,S.dirname)(m)),M.toString()))),this.toFileSystemProviderError(M)}}async validateTargetDeleted(n,i,s,u){const m=this.toFilePath(n),M=this.toFilePath(i);let L=!1;if(!!(this.capabilities&1024)||(L=(0,d.isEqual)(m,M,!0)),L&&s==="copy")throw(0,y.createFileSystemProviderError)((0,f.localize)(4,null),y.FileSystemProviderErrorCode.FileExists);if(!L&&await t.Promises.exists(M)){if(!u)throw(0,y.createFileSystemProviderError)((0,f.localize)(5,null),y.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(n,i,s){return new c.ParcelWatcherClient(u=>n(u),u=>i(u),s)}doWatch(n,i){const s=this.options?.watcher?.usePolling;if(s===!0)for(const u of i)u.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(s))for(const u of i)s.includes(u.path)&&(u.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(n,i)}createNonRecursiveWatcher(n,i,s,u){return new P.NodeJSFileWatcher(n,m=>i(m),m=>s(m),u)}toFileSystemProviderError(n){if(n instanceof y.FileSystemProviderError)return n;let i;switch(n.code){case"ENOENT":i=y.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=y.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=y.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=y.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=y.FileSystemProviderErrorCode.NoPermissions;break;default:i=y.FileSystemProviderErrorCode.Unknown}return(0,y.createFileSystemProviderError)(n,i)}async toFileSystemProviderWriteError(n,i){let s=this.toFileSystemProviderError(i);if(n&&s.code===y.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await t.SymlinkSupport.stat(this.toFilePath(n));u.mode&128||(s=(0,y.createFileSystemProviderError)(i,y.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.logService.trace(u)}return s}}e.DiskFileSystemProvider=o}),define(x[93],ee([0,1,6]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function r(C,k){switch(k){case p.LogLevel.Trace:return C.trace;case p.LogLevel.Debug:return C.debug;case p.LogLevel.Info:return C.info;case p.LogLevel.Warning:return C.warn;case p.LogLevel.Error:return C.error;case p.LogLevel.Critical:return C.critical;default:throw new Error("Invalid log level")}}class D extends p.AbstractLogger{constructor(k=p.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(k),this._register(this.onDidChangeLogLevel(I=>{this._logger&&this._logger.setLevel(I)}))}set logger(k){this._logger=k;for(const{level:I,args:d}of this.buffer)r(k,I).apply(k,d);this.buffer=[]}_log(k,...I){this._logger?r(this._logger,k).apply(this._logger,I):this.getLevel()<=k&&this.buffer.push({level:k,args:I})}trace(k,...I){this._log(p.LogLevel.Trace,k,...I)}debug(k,...I){this._log(p.LogLevel.Debug,k,...I)}info(k,...I){this._log(p.LogLevel.Info,k,...I)}warn(k,...I){this._log(p.LogLevel.Warning,k,...I)}error(k,...I){this._log(p.LogLevel.Error,k,...I)}critical(k,...I){this._log(p.LogLevel.Critical,k,...I)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=D}),define(x[184],ee([0,1,9,17,16,18,5,93,6]),function(j,e,p,r,D,C,k,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const g=5*C.ByteSize.MB;let S=class extends d.AbstractLogger{constructor(v,t,f,y,b){super();this.name=v,this.resource=t,this.donotUseFormatters=y,this.fileService=b,this.backupIndex=1,this.setLevel(f),this.queue=this._register(new p.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=d.LogLevel.Trace&&this._log(d.LogLevel.Trace,(0,d.format)(arguments))}debug(){this.getLevel()<=d.LogLevel.Debug&&this._log(d.LogLevel.Debug,(0,d.format)(arguments))}info(){this.getLevel()<=d.LogLevel.Info&&this._log(d.LogLevel.Info,(0,d.format)(arguments))}warn(){this.getLevel()<=d.LogLevel.Warning&&this._log(d.LogLevel.Warning,(0,d.format)(arguments))}error(){if(this.getLevel()<=d.LogLevel.Error){const v=arguments[0];if(v instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=v.stack,this._log(d.LogLevel.Error,(0,d.format)(t))}else this._log(d.LogLevel.Error,(0,d.format)(arguments))}}critical(){this.getLevel()<=d.LogLevel.Critical&&this._log(d.LogLevel.Critical,(0,d.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(v){if(v.fileOperationResult!==3)throw v}}_log(v,t){this.queue.queue(async()=>{await this.initializePromise;let f=await this.loadContent();f.length>g&&(await this.fileService.writeFile(this.getBackupResource(),r.VSBuffer.fromString(f)),f=""),this.donotUseFormatters?f+=t:f+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(v)}] ${t}
`,await this.fileService.writeFile(this.resource,r.VSBuffer.fromString(f))})}getCurrentTimestamp(){const v=y=>y<10?`0${y}`:y,t=y=>y<10?`00${y}`:y<100?`0${y}`:y,f=new Date;return`${f.getFullYear()}-${v(f.getMonth()+1)}-${v(f.getDate())} ${v(f.getHours())}:${v(f.getMinutes())}:${v(f.getSeconds())}.${t(f.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,D.joinPath)((0,D.dirname)(this.resource),`${(0,D.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch{return""}}stringifyLogLevel(v){switch(v){case d.LogLevel.Critical:return"critical";case d.LogLevel.Debug:return"debug";case d.LogLevel.Error:return"error";case d.LogLevel.Info:return"info";case d.LogLevel.Trace:return"trace";case d.LogLevel.Warning:return"warning"}return""}};S=fe([ie(4,C.IFileService)],S),e.FileLogger=S;let E=class extends d.AbstractLoggerService{constructor(v,t,f){super(v.getLevel(),v.onDidChangeLogLevel);this.instantiationService=t,this.fileService=f}doCreateLogger(v,t,f){const y=new I.BufferLogService(t);return(0,C.whenProviderRegistered)(v,this.fileService).then(()=>y.logger=this.instantiationService.createInstance(S,f?.name||(0,D.basename)(v),v,y.getLevel(),!!f?.donotUseFormatters)),y}};E=fe([ie(0,d.ILogService),ie(1,k.IInstantiationService),ie(2,C.IFileService)],E),e.FileLoggerService=E}),define(x[185],ee([0,1,4,7,6]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class C{constructor(w){this.service=w,this.onDidChangeLogLevel=p.Event.buffer(w.onDidChangeLogLevel,!0)}listen(w,v){switch(v){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${v}`)}async call(w,v,t){switch(v){case"setLevel":return this.service.setLevel(t)}throw new Error(`Call not found: ${v}`)}}e.LogLevelChannel=C;class k{constructor(w){this.channel=w}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(w){k.setLevel(this.channel,w)}static setLevel(w,v){return w.call("setLevel",v)}}e.LogLevelChannelClient=k;class I{constructor(w){this.loggerService=w,this.loggers=new Map}listen(w,v){throw new Error(`Event not found: ${v}`)}async call(w,v,t){switch(v){case"createLogger":this.createLogger(r.URI.revive(t[0]),t[1]);return;case"log":return this.log(r.URI.revive(t[0]),t[1]);case"consoleLog":return this.consoleLog(t[0],t[1])}throw new Error(`Call not found: ${v}`)}createLogger(w,v){this.loggers.set(w.toString(),this.loggerService.createLogger(w,v))}consoleLog(w,v){let t=console.log;switch(w){case D.LogLevel.Error:t=console.error;break;case D.LogLevel.Warning:t=console.warn;break;case D.LogLevel.Info:t=console.info;break}t.call(console,...v)}log(w,v){const t=this.loggers.get(w.toString());if(!t)throw new Error("Create the logger before logging");for(const[f,y]of v)(0,D.log)(t,f,y)}}e.LoggerChannel=I;class d extends D.AbstractLoggerService{constructor(w,v,t){super(w,v);this.channel=t}createConsoleMainLogger(){return new D.AdapterLogger({log:(w,v)=>{this.channel.call("consoleLog",[w,v])}})}doCreateLogger(w,v,t){return new g(this.channel,w,v,t)}}e.LoggerChannelClient=d;class g extends D.AbstractMessageLogger{constructor(w,v,t,f){super(f?.always);this.channel=w,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(t),this.channel.call("createLogger",[v,f]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(w,v){const t=[[w,v]];this.isLoggerCreated?this.doLog(t):this.buffer.push(...t)}doLog(w){this.channel.call("log",[this.file,w])}}class S extends D.LogService{constructor(w,v){super(v);this.parent=w,this._register(w.onDidChangeLogLevel(t=>v.setLevel(t)))}setLevel(w){super.setLevel(w),this.parent.setLevel(w)}}e.FollowerLogService=S}),define(x[94],ee([0,1,18,6]),function(j,e,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function D(I,d,g,S,E){try{const w=await new Promise((t,f)=>{j(["spdlog"],t,f)});w.setFlushOn(r.LogLevel.Trace);const v=await w.createAsyncRotatingLogger(I,d,g,S);return E&&v.clearFormatters(),v}catch(w){console.error(w)}return null}function C(I,d,g){switch(d){case r.LogLevel.Trace:I.trace(g);break;case r.LogLevel.Debug:I.debug(g);break;case r.LogLevel.Info:I.info(g);break;case r.LogLevel.Warning:I.warn(g);break;case r.LogLevel.Error:I.error(g);break;case r.LogLevel.Critical:I.critical(g);break;default:throw new Error("Invalid log level")}}class k extends r.AbstractMessageLogger{constructor(d,g,S,E,w){super();this.buffer=[],this.setLevel(w),this._loggerCreationPromise=this._createSpdLogLogger(d,g,S,E),this._register(this.onDidChangeLogLevel(v=>{this._logger&&this._logger.setLevel(v)}))}async _createSpdLogLogger(d,g,S,E){const w=S?6:1,v=30/w*p.ByteSize.MB,t=await D(d,g,v,w,E);if(t){this._logger=t,this._logger.setLevel(this.getLevel());for(const{level:f,message:y}of this.buffer)C(this._logger,f,y);this.buffer=[]}}log(d,g){this._logger?C(this._logger,d,g):this.getLevel()<=d&&this.buffer.push({level:d,message:g})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=k}),define(x[186],ee([0,1,10,16,27,18,184,6,94]),function(j,e,p,r,D,C,k,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let g=class extends I.AbstractLoggerService{constructor(E,w){super(E.getLevel(),E.onDidChangeLogLevel);this.fileService=w}doCreateLogger(E,w,v){return E.scheme===p.Schemas.file?new d.SpdLogLogger(v?.name||(0,D.generateUuid)(),E.fsPath,!v?.donotRotate,!!v?.donotUseFormatters,w):new k.FileLogger(v?.name??(0,r.basename)(E),E,w,!!v?.donotUseFormatters,this.fileService)}};g=fe([ie(0,I.ILogService),ie(1,C.IFileService)],g),e.LoggerService=g}),define(x[187],ee([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function p(k){return k.submenu!==void 0}e.isMenubarMenuItemSubmenu=p;function r(k){return k.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=r;function D(k){return k.uri!==void 0}e.isMenubarMenuItemRecentAction=D;function C(k){return!p(k)&&!r(k)&&!D(k)}e.isMenubarMenuItemAction=C}),define(x[55],ee([0,1,10,3,34,16]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof r.globals.vscode!="undefined"&&typeof r.globals.vscode.context!="undefined"){const I=r.globals.vscode.context.configuration();if(I)k=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof j?.__$__nodeRequire=="function"){const I=(0,C.dirname)(p.FileAccess.asFileUri("",j));k=j.__$__nodeRequire((0,C.joinPath)(I,"product.json").fsPath);const d=j.__$__nodeRequire((0,C.joinPath)(I,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`}),Object.assign(k,{version:d.version})}else k={},Object.keys(k).length===0&&Object.assign(k,{version:"1.64.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=k}),define(x[22],ee([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,p.createDecorator)("productService")}),define(x[188],ee([0,1,60,6,22]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let C=class{constructor(I,d){this.productService=I,this.logService=d,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(I,d){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const g=/^(.*)#([^#]+)$/.exec(d);if(!g)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",d),!1;const[,S,E]=g;let w=this.trustedExtensionUrlPublicKeys.get(I);if(!w){if(w=this.productService.trustedExtensionUrlPublicKeys[I],!w||w.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",I),!1;this.trustedExtensionUrlPublicKeys.set(I,[...w])}const v=Buffer.from(decodeURIComponent(E),"base64");if(v.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",d),!1;const t=v.slice(0,6),f=v.readUIntBE(0,6),y=Date.now()-f;if(y<0||y>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",d),!1;const b=v.slice(6),P=p.createVerify("SHA256");P.write(t),P.write(Buffer.from(S)),P.end();for(let c=0;c<w.length;c++){let a=w[c];if(a!==null){if(typeof a=="string")try{a=p.createPublicKey({key:Buffer.from(a,"base64"),format:"der",type:"spki"}),w[c]=a}catch(l){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${c+1} for ${I}:`,l),w[c]=null;continue}if(P.verify(a,b))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",d),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",d),!1}};C=fe([ie(0,D.IProductService),ie(1,r.ILogService)],C),e.ExtensionUrlTrustService=C}),define(x[56],ee([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,p.createDecorator)("protocolMainService")}),define(x[189],ee([0,1,14,2,36,10,3,16,7,27,53,6]),function(j,e,p,r,D,C,k,I,d,g,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let w=class extends r.Disposable{constructor(t,f){super();this.logService=f,this.validRoots=D.TernarySearchTree.forUris(()=>!k.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(d.URI.file(t.appRoot)),this.addValidFileRoot(d.URI.file(t.extensionsPath)),this.addValidFileRoot(t.globalStorageHome),this.addValidFileRoot(t.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:t}=p.session;t.protocol.registerFileProtocol(C.Schemas.vscodeFileResource,(f,y)=>this.handleResourceRequest(f,y)),t.protocol.interceptFileProtocol(C.Schemas.file,(f,y)=>this.handleFileRequest(f,y)),this._register((0,r.toDisposable)(()=>{t.protocol.unregisterProtocol(C.Schemas.vscodeFileResource),t.protocol.uninterceptProtocol(C.Schemas.file)}))}addValidFileRoot(t){return this.validRoots.get(t)?r.Disposable.None:(this.validRoots.set(t,!0),(0,r.toDisposable)(()=>this.validRoots.delete(t)))}handleFileRequest(t,f){const y=d.URI.parse(t.url);return this.logService.error(`Refused to load resource ${y.fsPath} from ${C.Schemas.file}: protocol (original URL: ${t.url})`),f({error:-3})}handleResourceRequest(t,f){const y=d.URI.parse(t.url),b=C.FileAccess.asFileUri(y);return this.validRoots.findSubstr(b)?f({path:b.fsPath}):this.validExtensions.has((0,I.extname)(b))?f({path:b.fsPath}):(this.logService.error(`${C.Schemas.vscodeFileResource}: Refused to load resource ${b.fsPath} from ${C.Schemas.vscodeFileResource}: protocol (original URL: ${t.url})`),f({error:-3}))}createIPCObjectUrl(){let t;const f=d.URI.from({scheme:"vscode",path:(0,g.generateUuid)()}),y=f.toString(),b=async()=>t;return p.ipcMain.handle(y,b),this.logService.trace(`IPC Object URL: Registered new channel ${y}.`),{resource:f,update:P=>t=P,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${y}.`),p.ipcMain.removeHandler(y)}}}};w=fe([ie(0,S.INativeEnvironmentService),ie(1,E.ILogService)],w),e.ProtocolMainService=w}),define(x[40],ee([0,1,102,13]),function(j,e,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(k,I){p.ok(r.isString(k)),p.ok(r.isObject(I)),p.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,I)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new D}),define(x[190],ee([0,1,4,40]),function(j,e,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class C{constructor(){this._onDidChangeSchema=new p.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(d,g){this.schemasById[D(d)]=g,this._onDidChangeSchema.fire(d)}notifySchemaChanged(d){this._onDidChangeSchema.fire(d)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new C;r.Registry.add(e.Extensions.JSONContribution,k)}),define(x[57],ee([0,1,31,4,13,135,190,40]),function(j,e,p,r,D,C,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var d;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(d=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var g;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(g=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const S=I.Registry.as(k.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new r.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new r.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(l,o=!0){this.registerConfigurations([l],o)}registerConfigurations(l,o=!0){const h=this.doRegisterConfigurations(l,o);S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h})}deregisterConfigurations(l){const o=this.doDeregisterConfigurations(l);S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:l,remove:o}){const h=[];h.push(...this.doDeregisterConfigurations(o)),h.push(...this.doRegisterConfigurations(l,!1)),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,p.distinct)(h)})}registerDefaultConfigurations(l){const o=[],h=[];for(const{overrides:n,source:i}of l)for(const s in n)if(o.push(s),e.OVERRIDE_PROPERTY_REGEX.test(s)){const u={...this.configurationDefaultsOverrides.get(s)?.value||{},...n[s]};this.configurationDefaultsOverrides.set(s,{source:i,value:u});const m={type:"object",default:u,description:C.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:u,source:D.isString(i)?void 0:i};h.push(...t(s)),this.configurationProperties[s]=m,this.defaultLanguageConfigurationOverridesNode.properties[s]=m}else{this.configurationDefaultsOverrides.set(s,{value:n[s],source:i});const u=this.configurationProperties[s];u&&(this.updatePropertyDefaultValue(s,u),this.updateSchema(s,u))}this.registerOverrideIdentifiers(h),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(l){const o=[];for(const{overrides:h,source:n}of l)for(const i in h){const s=this.configurationDefaultsOverrides.get(i),u=D.isString(n)?n:n?.id,m=D.isString(s?.source)?s?.source:s?.source?.id;if(u===m)if(o.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const M=this.configurationProperties[i];M&&(this.updatePropertyDefaultValue(i,M),this.updateSchema(i,M))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...l){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(l){for(const o of l)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(l,o){const h=[];return l.forEach(n=>{h.push(...this.validateAndRegisterProperties(n,o,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),h}doDeregisterConfigurations(l){const o=[],h=n=>{if(n.properties)for(const i in n.properties)o.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,n.properties[i]);n.allOf&&n.allOf.forEach(i=>h(i))};for(const n of l){h(n);const i=this.configurationContributors.indexOf(n);i!==-1&&this.configurationContributors.splice(i,1)}return o}validateAndRegisterProperties(l,o=!0,h,n,i=3){i=D.isUndefinedOrNull(l.scope)?i:l.scope;let s=[],u=l.properties;if(u)for(let M in u){if(o&&P(M)){delete u[M];continue}const L=u[M];if(L.source=h,L.defaultDefaultValue=u[M].default,this.updatePropertyDefaultValue(M,L),e.OVERRIDE_PROPERTY_REGEX.test(M)?L.scope=void 0:(L.scope=D.isUndefinedOrNull(L.scope)?i:L.scope,L.restricted=D.isUndefinedOrNull(L.restricted)?!!n?.includes(M):L.restricted),u[M].hasOwnProperty("included")&&!u[M].included){this.excludedConfigurationProperties[M]=u[M],delete u[M];continue}else this.configurationProperties[M]=u[M];!u[M].deprecationMessage&&u[M].markdownDeprecationMessage&&(u[M].deprecationMessage=u[M].markdownDeprecationMessage),s.push(M)}let m=l.allOf;if(m)for(let M of m)s.push(...this.validateAndRegisterProperties(M,o,h,n,i));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(l){const o=h=>{let n=h.properties;if(n)for(const s in n)this.updateSchema(s,n[s]);let i=h.allOf;i&&i.forEach(o)};o(l)}updateSchema(l,o){switch(e.allSettings.properties[l]=o,o.scope){case 1:e.applicationSettings.properties[l]=o;break;case 2:e.machineSettings.properties[l]=o;break;case 6:e.machineOverridableSettings.properties[l]=o;break;case 3:e.windowSettings.properties[l]=o;break;case 4:e.resourceSettings.properties[l]=o;break;case 5:e.resourceSettings.properties[l]=o,this.resourceLanguageSettingsSchema.properties[l]=o;break}}removeFromSchema(l,o){switch(delete e.allSettings.properties[l],o.scope){case 1:delete e.applicationSettings.properties[l];break;case 2:delete e.machineSettings.properties[l];break;case 6:delete e.machineOverridableSettings.properties[l];break;case 3:delete e.windowSettings.properties[l];break;case 4:case 5:delete e.resourceSettings.properties[l],delete this.resourceLanguageSettingsSchema.properties[l];break}}updateOverridePropertyPatternKey(){for(const l of this.overrideIdentifiers.values()){const o=`[${l}]`,h={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,h),e.allSettings.properties[o]=h,e.applicationSettings.properties[o]=h,e.machineSettings.properties[o]=h,e.machineOverridableSettings.properties[o]=h,e.windowSettings.properties[o]=h,e.resourceSettings.properties[o]=h}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const l={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(l,o){const h=this.configurationDefaultsOverrides.get(l);let n=h?.value,i=h?.source;D.isUndefined(n)&&(n=o.defaultDefaultValue,i=void 0),D.isUndefined(n)&&(n=y(o.type)),o.default=n,o.defaultValueSource=i}}const w="\\[([^\\]]+)\\]",v=new RegExp(w,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${w})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function t(a){const l=[];if(e.OVERRIDE_PROPERTY_REGEX.test(a)){let o=v.exec(a);for(;o?.length;){const h=o[1].trim();h&&l.push(h),o=v.exec(a)}}return(0,p.distinct)(l)}e.overrideIdentifiersFromKey=t;function f(a){return a.reduce((l,o)=>`${l}[${o}]`,"")}e.keyFromOverrideIdentifiers=f;function y(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=y;const b=new E;I.Registry.add(e.Extensions.Configuration,b);function P(a){return a.trim()?e.OVERRIDE_PROPERTY_REGEX.test(a)?C.localize(7,null,a):b.getConfigurationProperties()[a]!==void 0?C.localize(8,null,a):null:C.localize(6,null)}e.validateProperty=P;function c(){const a=[],l=b.getConfigurationProperties();for(const o of Object.keys(l))a.push([o,l[o].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.getScopes=c}),define(x[191],ee([0,1,31,4,43,2,36,47,13,7,19,57,40]),function(j,e,p,r,D,C,k,I,d,g,S,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class v{constructor(n={},i=[],s=[]){this._contents=n,this._keys=i,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,S.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,i){const s=this.getContentsForOverrideIdentifer(i);return s?n?(0,S.getConfigurationValue)(s,n):s:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const s of this.overrides)s.identifiers.includes(n)&&i.push(...s.keys);return p.distinct(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return p.distinct(n)}override(n){let i=this.overrideConfigurations.get(n);return i||(i=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,i)),i}merge(...n){const i=I.deepClone(this.contents),s=I.deepClone(this.overrides),u=[...this.keys];for(const m of n){this.mergeContents(i,m.contents);for(const M of m.overrides){const[L]=s.filter(R=>p.equals(R.identifiers,M.identifiers));L?(this.mergeContents(L.contents,M.contents),L.keys.push(...M.keys),L.keys=p.distinct(L.keys)):s.push(I.deepClone(M))}for(const M of m.keys)u.indexOf(M)===-1&&u.push(M)}return new v(i,u,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(n){const i=this.getContentsForOverrideIdentifer(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let s={};for(const u of p.distinct([...Object.keys(this.contents),...Object.keys(i)])){let m=this.contents[u],M=i[u];M&&(typeof m=="object"&&typeof M=="object"?(m=I.deepClone(m),this.mergeContents(m,M)):m=M),s[u]=m}return new v(s,this.keys,this.overrides)}mergeContents(n,i){for(const s of Object.keys(i)){if(s in n&&d.isObject(n[s])&&d.isObject(i[s])){this.mergeContents(n[s],i[s]);continue}n[s]=I.deepClone(i[s])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?I.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let i=null,s=null;const u=m=>{m&&(s?this.mergeContents(s,m):s=I.deepClone(m))};for(const m of this.overrides)p.equals(m.identifiers,[n])?i=m.contents:m.identifiers.includes(n)&&u(m.contents);return u(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,i){this.addKey(n),(0,S.addToValueTree)(this.contents,n,i,s=>{throw new Error(s)})}removeValue(n){this.removeKey(n)&&(0,S.removeFromValueTree)(this.contents,n)}addKey(n){let i=this.keys.length;for(let s=0;s<i;s++)n.indexOf(this.keys[s])===0&&(i=s);this.keys.splice(i,1,n)}removeKey(n){let i=this.keys.indexOf(n);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=v;class t extends v{constructor(n={}){const i=w.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(i),u=Object.create(null),m=[];for(const M in i){const L=n[M],R=L!==void 0?L:i[M].default;(0,S.addToValueTree)(u,M,R,T=>console.error(`Conflict in default settings: ${T}`))}for(const M of Object.keys(u))E.OVERRIDE_PROPERTY_REGEX.test(M)&&m.push({identifiers:(0,E.overrideIdentifiersFromKey)(M),keys:Object.keys(u[M]),contents:(0,S.toValuesTree)(u[M],L=>console.error(`Conflict in default settings file: ${L}`))});super(u,s,m)}}e.DefaultConfigurationModel=t;class f{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,i){if(!d.isUndefinedOrNull(n)){const s=this.doParseContent(n);this.parseRaw(s,i)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,i){this._raw=n;const{contents:s,keys:u,overrides:m,restricted:M}=this.doParseRaw(n,i);this._configurationModel=new v(s,u,m),this._restrictedConfigurations=M||[]}doParseContent(n){let i={},s=null,u=[],m=[],M=[];function L(T){Array.isArray(u)?u.push(T):s!==null&&(u[s]=T)}let R={onObjectBegin:()=>{let T={};L(T),m.push(u),u=T,s=null},onObjectProperty:T=>{s=T},onObjectEnd:()=>{u=m.pop()},onArrayBegin:()=>{let T=[];L(T),m.push(u),u=T,s=null},onArrayEnd:()=>{u=m.pop()},onLiteralValue:L,onError:(T,_,Q)=>{M.push({error:T,offset:_,length:Q})}};if(n)try{D.visit(n,R),i=u[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return i}doParseRaw(n,i){const s=w.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),u=this.filter(n,s,!0,i);n=u.raw;const m=(0,S.toValuesTree)(n,R=>console.error(`Conflict in settings file ${this._name}: ${R}`)),M=Object.keys(n),L=this.toOverrides(n,R=>console.error(`Conflict in settings file ${this._name}: ${R}`));return{contents:m,keys:M,overrides:L,restricted:u.restricted}}filter(n,i,s,u){if(!u?.scopes&&!u?.skipRestricted)return{raw:n,restricted:[]};const m={},M=[];for(let L in n)if(E.OVERRIDE_PROPERTY_REGEX.test(L)&&s){const R=this.filter(n[L],i,!1,u);m[L]=R.raw,M.push(...R.restricted)}else{const R=i[L],T=R?typeof R.scope!="undefined"?R.scope:3:void 0;R?.restricted&&M.push(L),(T===void 0||u.scopes===void 0||u.scopes.includes(T))&&(u.skipRestricted&&R?.restricted||(m[L]=n[L]))}return{raw:m,restricted:M}}toOverrides(n,i){const s=[];for(const u of Object.keys(n))if(E.OVERRIDE_PROPERTY_REGEX.test(u)){const m={};for(const M in n[u])m[M]=n[u][M];s.push({identifiers:(0,E.overrideIdentifiersFromKey)(u),keys:Object.keys(m),contents:(0,S.toValuesTree)(m,i)})}return s}}e.ConfigurationModelParser=f;class y extends C.Disposable{constructor(n,i,s,u){super();this.userSettingsResource=n,this.scopes=i,this.fileService=u,this._onDidChange=this._register(new r.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(r.Event.filter(this.fileService.onDidFilesChange,m=>m.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=y;class b{constructor(n,i,s=new v,u=new v,m=new k.ResourceMap,M=new v,L=new k.ResourceMap,R=!0){this._defaultConfiguration=n,this._localUserConfiguration=i,this._remoteUserConfiguration=s,this._workspaceConfiguration=u,this._folderConfigurations=m,this._memoryConfiguration=M,this._memoryConfigurationByResource=L,this._freeze=R,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(n,i,s){return this.getConsolidateConfigurationModel(i,s).getValue(n)}updateValue(n,i,s={}){let u;s.resource?(u=this._memoryConfigurationByResource.get(s.resource),u||(u=new v,this._memoryConfigurationByResource.set(s.resource,u))):u=this._memoryConfiguration,i===void 0?u.removeValue(n):u.setValue(n,i),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,i,s){const u=this.getConsolidateConfigurationModel(i,s),m=this.getFolderConfigurationModelForResource(i.resource,s),M=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,L=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),R=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),T=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),_=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),Q=s?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,se=m?i.overrideIdentifier?m.freeze().override(i.overrideIdentifier).getValue(n):m.freeze().getValue(n):void 0,re=i.overrideIdentifier?M.override(i.overrideIdentifier).getValue(n):M.getValue(n),G=u.getValue(n),X=p.distinct(p.flatten(u.overrides.map(B=>B.identifiers))).filter(B=>u.getOverrideValue(n,B)!==void 0);return{defaultValue:L,userValue:R,userLocalValue:T,userRemoteValue:_,workspaceValue:Q,workspaceFolderValue:se,memoryValue:re,value:G,default:L!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,user:R!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,userRemote:_!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,workspace:Q!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,workspaceFolder:se!==void 0?{value:m?.freeze().getValue(n),override:i.overrideIdentifier?m?.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,memory:re!==void 0?{value:M.getValue(n),override:i.overrideIdentifier?M.getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:X.length?X:void 0}}keys(n){const i=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,i){this._folderConfigurations.set(n,i),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const s=[];if(!i){const{added:u,updated:m,removed:M}=l(this._defaultConfiguration,n);i=[...u,...m,...M]}for(const u of i)for(const m of(0,E.overrideIdentifiersFromKey)(u)){const M=this._defaultConfiguration.getKeysForOverrideIdentifier(m),L=n.getKeysForOverrideIdentifier(m),R=[...L.filter(T=>M.indexOf(T)===-1),...M.filter(T=>L.indexOf(T)===-1),...M.filter(T=>!I.equals(this._defaultConfiguration.override(m).getValue(T),n.override(m).getValue(T)))];s.push([m,R])}return this.updateDefaultConfiguration(n),{keys:i,overrides:s}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:s,removed:u,overrides:m}=l(this.localUserConfiguration,n),M=[...i,...s,...u];return M.length&&this.updateLocalUserConfiguration(n),{keys:M,overrides:m}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:s,removed:u,overrides:m}=l(this.remoteUserConfiguration,n);let M=[...i,...s,...u];return M.length&&this.updateRemoteUserConfiguration(n),{keys:M,overrides:m}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:s,removed:u,overrides:m}=l(this.workspaceConfiguration,n);let M=[...i,...s,...u];return M.length&&this.updateWorkspaceConfiguration(n),{keys:M,overrides:m}}compareAndUpdateFolderConfiguration(n,i){const s=this.folderConfigurations.get(n),{added:u,updated:m,removed:M,overrides:L}=l(s,i);let R=[...u,...m,...M];return(R.length||!s)&&this.updateFolderConfiguration(n,i),{keys:R,overrides:L}}compareAndDeleteFolderConfiguration(n){const i=this.folderConfigurations.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:s,updated:u,removed:m,overrides:M}=l(i,void 0);return{keys:[...s,...u,...m],overrides:M}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,i){let s=this.getConsolidatedConfigurationModelForResource(n,i);return n.overrideIdentifier?s.override(n.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:n},i){let s=this.getWorkspaceConsolidatedConfiguration();if(i&&n){const u=i.getFolder(n);u&&(s=this.getFolderConsolidatedConfiguration(u.uri)||s);const m=this._memoryConfigurationByResource.get(n);m&&(s=s.merge(m))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let i=this._foldersConsolidatedConfigurations.get(n);if(!i){const s=this.getWorkspaceConsolidatedConfiguration(),u=this._folderConfigurations.get(n);u?(i=s.merge(u),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(n,i)):i=s}return i}getFolderConfigurationModelForResource(n,i){if(i&&n){const s=i.getFolder(n);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,i)=>{const{contents:s,overrides:u,keys:m}=this._folderConfigurations.get(i);return n.push([i,{contents:s,overrides:u,keys:m}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>n.add(i)),this.userConfiguration.freeze().keys.forEach(i=>n.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(s=>n.add(s))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(s=>n.add(s))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>i.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(n).forEach(u=>i.add(u))),[...i.values()]}static parse(n){const i=this.parseConfigurationModel(n.defaults),s=this.parseConfigurationModel(n.user),u=this.parseConfigurationModel(n.workspace),m=n.folders.reduce((M,L)=>(M.set(g.URI.revive(L[0]),this.parseConfigurationModel(L[1])),M),new k.ResourceMap);return new b(i,s,new v,u,m,new v,new k.ResourceMap,!1)}static parseConfigurationModel(n){return new v(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=b;function P(...h){if(h.length===0)return{keys:[],overrides:[]};if(h.length===1)return h[0];const n=new Set,i=new Map;for(const u of h)u.keys.forEach(m=>n.add(m)),u.overrides.forEach(([m,M])=>{const L=(0,k.getOrSet)(i,m,new Set);M.forEach(R=>L.add(R))});const s=[];return i.forEach((u,m)=>s.push([m,[...u.values()]])),{keys:[...n.values()],overrides:s}}e.mergeChanges=P;class c{constructor(n,i,s,u){this.change=n,this.previous=i,this.currentConfiguraiton=s,this.currentWorkspace=u,this._previousConfiguration=void 0;const m=new Set;n.keys.forEach(L=>m.add(L)),n.overrides.forEach(([,L])=>L.forEach(R=>m.add(R))),this.affectedKeys=[...m.values()];const M=new v;this.affectedKeys.forEach(L=>M.setValue(L,{})),this.affectedKeysTree=M.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(i){const s=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.previous?.workspace):void 0,u=this.currentConfiguraiton.getValue(n,i,this.currentWorkspace);return!I.equals(s,u)}return!0}return!1}doesAffectedKeysTreeContains(n,i){let s=(0,S.toValuesTree)({[i]:!0},()=>{}),u;for(;typeof s=="object"&&(u=Object.keys(s)[0]);){if(n=n[u],!n)return!1;s=s[u]}return!0}}e.ConfigurationChangeEvent=c;class a extends c{constructor(n,i,s,u){super({keys:n.allKeys(),overrides:[]},void 0,n,i);this.source=s,this.sourceConfig=u}}e.AllKeysConfigurationChangeEvent=a;function l(h,n){const{added:i,removed:s,updated:u}=o(n,h),m=[],M=h?.getAllOverrideIdentifiers()||[],L=n?.getAllOverrideIdentifiers()||[];if(n){const R=L.filter(T=>!M.includes(T));for(const T of R)m.push([T,n.getKeysForOverrideIdentifier(T)])}if(h){const R=M.filter(T=>!L.includes(T));for(const T of R)m.push([T,h.getKeysForOverrideIdentifier(T)])}if(n&&h){for(const R of M)if(L.includes(R)){const T=o({contents:h.getOverrideValue(void 0,R)||{},keys:h.getKeysForOverrideIdentifier(R)},{contents:n.getOverrideValue(void 0,R)||{},keys:n.getKeysForOverrideIdentifier(R)});m.push([R,[...T.added,...T.removed,...T.updated]])}}return{added:i,removed:s,updated:u,overrides:m}}function o(h,n){const i=h?n?h.keys.filter(m=>n.keys.indexOf(m)===-1):[...h.keys]:[],s=n?h?n.keys.filter(m=>h.keys.indexOf(m)===-1):[...n.keys]:[],u=[];if(h&&n){for(const m of n.keys)if(h.keys.indexOf(m)!==-1){const M=(0,S.getConfigurationValue)(n.contents,m),L=(0,S.getConfigurationValue)(h.contents,m);I.equals(M,L)||u.push(m)}}return{added:i,removed:s,updated:u}}}),define(x[192],ee([0,1,9,4,2,16,19,191,57,40]),function(j,e,p,r,D,C,k,I,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class S extends D.Disposable{constructor(w,v){super();this.settingsResource=w,this._onDidChangeConfiguration=this._register(new r.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,C.extUriBiasedIgnorePathCase,v)),this.configuration=new I.Configuration(new I.DefaultConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new p.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(g.Registry.as(d.Extensions.Configuration).onDidUpdateConfiguration(({properties:t})=>this.onDidDefaultConfigurationChange(t))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const w=await this.userConfiguration.loadConfiguration();this.configuration=new I.Configuration(new I.DefaultConfigurationModel,w)}getConfigurationData(){return this.configuration.toData()}getValue(w,v){const t=typeof w=="string"?w:void 0,f=(0,k.isConfigurationOverrides)(w)?w:(0,k.isConfigurationOverrides)(v)?v:{};return this.configuration.getValue(t,f,void 0)}updateValue(w,v,t,f){return Promise.reject(new Error("not supported"))}inspect(w){return this.configuration.inspect(w,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const w=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(w)}onDidChangeUserConfiguration(w){const v=this.configuration.toData(),t=this.configuration.compareAndUpdateLocalUserConfiguration(w);this.trigger(t,v,1)}onDidDefaultConfigurationChange(w){const v=this.configuration.toData(),t=this.configuration.compareAndUpdateDefaultConfiguration(new I.DefaultConfigurationModel,w);this.trigger(t,v,6)}trigger(w,v,t){const f=new I.ConfigurationChangeEvent(w,{data:v},this.configuration);f.source=t,f.sourceConfig=this.getTargetConfiguration(t),this._onDidChangeConfiguration.fire(f)}getTargetConfiguration(w){switch(w){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=S}),define(x[193],ee([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,p.createDecorator)("remoteAuthorityResolverService");var r;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(r=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(k,I=r.Unknown,d){super(k);this._message=k,this._code=I,this._detail=d,this.isHandled=I===r.NotAvailable&&d===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(k){return k instanceof D&&k._code===r.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof D&&k._code===r.NoResolverFound}static isHandled(k){return k instanceof D&&k.isHandled}}e.RemoteAuthorityResolverError=D}),define(x[194],ee([0,1,9,17,23,15,4,2,27,83,193]),function(j,e,p,r,D,C,k,I,d,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const E=30*1e3;var w;(function(U){U[U.Management=1]="Management",U[U.ExtensionHost=2]="ExtensionHost",U[U.Tunnel=3]="Tunnel"})(w=e.ConnectionType||(e.ConnectionType={}));function v(U){switch(U){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function t(U){const A=new D.CancellationTokenSource;return setTimeout(()=>A.cancel(),U),A.token}function f(U,A){if(U.isCancellationRequested||A.isCancellationRequested)return D.CancellationToken.Cancelled;const W=new D.CancellationTokenSource;return U.onCancellationRequested(()=>W.cancel()),A.onCancellationRequested(()=>W.cancel()),W.token}class y{constructor(A){this._state="pending",this._disposables=new I.DisposableStore,this.promise=new Promise((W,F)=>{this._resolvePromise=W,this._rejectPromise=F}),A.isCancellationRequested?this._timeout():this._disposables.add(A.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(A){this._state==="pending"?this._disposables.add(A):A.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const A=new Error("Time limit reached");return A.code="ETIMEDOUT",A.syscall="connect",A}resolve(A){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(A))}reject(A){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(A))}}function b(U,A){const W=new y(A);return W.registerDisposable(U.onControlMessage(F=>{const N=JSON.parse(F.toString()),H=$(N);H?W.reject(H):W.resolve(N)})),W.promise}function P(U,A,W,F,N,H,O){const z=new y(O);return A.connect(W,F,N,H,(te,ne)=>{z.didTimeout?(te&&U.error(te),ne?.dispose()):te||!ne?z.reject(te):z.resolve(ne)}),z.promise}function c(U,A){const W=new y(A);return U.then(F=>{W.didTimeout||W.resolve(F)},F=>{W.didTimeout||W.reject(F)}),W.promise}async function a(U,A,W,F){const N=q(U,A);U.logService.trace(`${N} 1/6. invoking socketFactory.connect().`);let H;try{H=await P(U.logService,U.socketFactory,U.host,U.port,`reconnectionToken=${U.reconnectionToken}&reconnection=${U.reconnectionProtocol?"true":"false"}`,`renderer-${v(A)}-${U.reconnectionToken}`,F)}catch(oe){throw U.logService.error(`${N} socketFactory.connect() failed or timed out. Error:`),U.logService.error(oe),oe}U.logService.trace(`${N} 2/6. socketFactory.connect() was successful.`);let O,z;U.reconnectionProtocol?(U.reconnectionProtocol.beginAcceptReconnection(H,null),O=U.reconnectionProtocol,z=!1):(O=new g.PersistentProtocol(H,null),z=!0),U.logService.trace(`${N} 3/6. sending AuthRequest control message.`);const te=await c(U.signService.createNewMessage((0,d.generateUuid)()),F),ne={type:"auth",auth:U.connectionToken||"00000000000000000000",data:te.data};O.sendControl(r.VSBuffer.fromString(JSON.stringify(ne)));try{const oe=await b(O,f(F,t(1e4)));if(oe.type!=="sign"||typeof oe.data!="string"){const ue=new Error("Unexpected handshake message");throw ue.code="VSCODE_CONNECTION_ERROR",ue}if(U.logService.trace(`${N} 4/6. received SignRequest control message.`),!await c(U.signService.validate(te,oe.signedData),F)){const ue=new Error("Refused to connect to unsupported server");throw ue.code="VSCODE_CONNECTION_ERROR",ue}const ce=await c(U.signService.sign(oe.data),F),le={type:"connectionType",commit:U.commit,signedData:ce,desiredConnectionType:A};return W&&(le.args=W),U.logService.trace(`${N} 5/6. sending ConnectionTypeRequest control message.`),O.sendControl(r.VSBuffer.fromString(JSON.stringify(le))),{protocol:O,ownsProtocol:z}}catch(oe){throw oe&&oe.code==="ETIMEDOUT"&&(U.logService.error(`${N} the handshake timed out. Error:`),U.logService.error(oe)),oe&&oe.code==="VSCODE_CONNECTION_ERROR"&&(U.logService.error(`${N} received error control message when negotiating connection. Error:`),U.logService.error(oe)),z&&B(O),oe}}async function l(U,A,W,F){const N=Date.now(),H=q(U,A),{protocol:O,ownsProtocol:z}=await a(U,A,W,F),te=new y(F);return te.registerDisposable(O.onControlMessage(ne=>{const oe=JSON.parse(ne.toString()),J=$(oe);J?(U.logService.error(`${H} received error control message when negotiating connection. Error:`),U.logService.error(J),z&&B(O),te.reject(J)):(U.reconnectionProtocol&&U.reconnectionProtocol.endAcceptReconnection(),U.logService.trace(`${H} 6/6. handshake finished, connection is up and running after ${Z(N)}!`),te.resolve({protocol:O,firstMessage:oe}))})),te.promise}async function o(U,A){const{protocol:W}=await l(U,1,void 0,A);return{protocol:W}}async function h(U,A,W){const{protocol:F,firstMessage:N}=await l(U,2,A,W),H=N&&N.debugPort;return{protocol:F,debugPort:H}}async function n(U,A,W){const F=Date.now(),N=q(U,3),{protocol:H}=await a(U,3,A,W);return U.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${Z(F)}!`),H}async function i(U,A,W){const{host:F,port:N,connectionToken:H}=await U.addressProvider.getAddress();return{commit:U.commit,host:F,port:N,connectionToken:H,reconnectionToken:A,reconnectionProtocol:W,socketFactory:U.socketFactory,signService:U.signService,logService:U.logService}}async function s(U,A,W){try{const F=(0,d.generateUuid)(),N=await i(U,F,null),{protocol:H}=await o(N,D.CancellationToken.None);return new G(U,A,W,F,H)}catch(F){throw U.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),U.logService.error(F),re.triggerPermanentFailure(0,0,S.RemoteAuthorityResolverError.isHandled(F)),F}}e.connectRemoteAgentManagement=s;async function u(U,A){try{const W=(0,d.generateUuid)(),F=await i(U,W,null),{protocol:N,debugPort:H}=await h(F,A,D.CancellationToken.None);return new X(U,A,W,N,H)}catch(W){throw U.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),U.logService.error(W),re.triggerPermanentFailure(0,0,S.RemoteAuthorityResolverError.isHandled(W)),W}}e.connectRemoteAgentExtensionHost=u;async function m(U,A,W){const F=await i(U,(0,d.generateUuid)(),null);return await n(F,{host:A,port:W},D.CancellationToken.None)}e.connectRemoteAgentTunnel=m;function M(U){return(0,p.createCancelablePromise)(A=>new Promise((W,F)=>{const N=setTimeout(W,U*1e3);A.onCancellationRequested(()=>{clearTimeout(N),W()})}))}var L;(function(U){U[U.ConnectionLost=0]="ConnectionLost",U[U.ReconnectionWait=1]="ReconnectionWait",U[U.ReconnectionRunning=2]="ReconnectionRunning",U[U.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",U[U.ConnectionGain=4]="ConnectionGain"})(L=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class R{constructor(A,W){this.reconnectionToken=A,this.millisSinceLastIncomingData=W,this.type=0}}e.ConnectionLostEvent=R;class T{constructor(A,W,F,N){this.reconnectionToken=A,this.millisSinceLastIncomingData=W,this.durationSeconds=F,this.cancellableTimer=N,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=T;class _{constructor(A,W,F){this.reconnectionToken=A,this.millisSinceLastIncomingData=W,this.attempt=F,this.type=2}}e.ReconnectionRunningEvent=_;class Q{constructor(A,W,F){this.reconnectionToken=A,this.millisSinceLastIncomingData=W,this.attempt=F,this.type=4}}e.ConnectionGainEvent=Q;class se{constructor(A,W,F,N){this.reconnectionToken=A,this.millisSinceLastIncomingData=W,this.attempt=F,this.handled=N,this.type=3}}e.ReconnectionPermanentFailureEvent=se;class re extends I.Disposable{constructor(A,W,F,N){super();this._connectionType=A,this._onDidStateChange=this._register(new k.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=W,this.reconnectionToken=F,this.protocol=N,this._isReconnecting=!1,this._onDidStateChange.fire(new Q(this.reconnectionToken,0,0)),this._register(N.onSocketClose(H=>{const O=V(this._connectionType,this.reconnectionToken,!0);H?H.type===0?(this._options.logService.info(`${O} received socket close event (hadError: ${H.hadError}).`),H.error&&this._options.logService.error(H.error)):(this._options.logService.info(`${O} received socket close event (wasClean: ${H.wasClean}, code: ${H.code}, reason: ${H.reason}).`),H.event&&this._options.logService.error(H.event)):this._options.logService.info(`${O} received socket close event.`),this._beginReconnecting()})),this._register(N.onSocketTimeout(()=>{const H=V(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${H} received socket timeout event.`),this._beginReconnecting()})),re._instances.push(this),re._permanentFailure&&this._gotoPermanentFailure(re._permanentFailureMillisSinceLastIncomingData,re._permanentFailureAttempt,re._permanentFailureHandled)}static triggerPermanentFailure(A,W,F){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=A,this._permanentFailureAttempt=W,this._permanentFailureHandled=F,this._instances.forEach(N=>N._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(A=>A._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(A=>A._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(re._permanentFailure)return;const A=V(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${A} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new R(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const W=[0,5,5,10,10,10,10,10,30];let F=-1;do{F++;const N=F<W.length?W[F]:W[W.length-1];try{if(N>0){const O=M(N);this._onDidStateChange.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N,O)),this._options.logService.info(`${A} waiting for ${N} seconds before reconnecting...`);try{await O}catch{}}if(re._permanentFailure){this._options.logService.error(`${A} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1)),this._options.logService.info(`${A} resolving connection...`);const H=await i(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${A} connecting to ${H.host}:${H.port}...`),await this._reconnect(H,t(E)),this._options.logService.info(`${A} reconnected!`),this._onDidStateChange.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1));break}catch(H){if(H.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${A} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(H),re.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(F>360){this._options.logService.error(`${A} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(H),re.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(S.RemoteAuthorityResolverError.isTemporarilyNotAvailable(H)){this._options.logService.info(`${A} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(H);continue}if((H.code==="ETIMEDOUT"||H.code==="ENETUNREACH"||H.code==="ECONNREFUSED"||H.code==="ECONNRESET")&&H.syscall==="connect"){this._options.logService.info(`${A} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(H);continue}if((0,C.isPromiseCanceledError)(H)){this._options.logService.info(`${A} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(H);continue}if(H instanceof S.RemoteAuthorityResolverError){this._options.logService.error(`${A} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(H),re.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,S.RemoteAuthorityResolverError.isHandled(H));break}this._options.logService.error(`${A} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(H),re.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}}while(!re._permanentFailure)}_gotoPermanentFailure(A,W,F){this._onDidStateChange.fire(new se(this.reconnectionToken,A,W,F)),B(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=re,re._permanentFailure=!1,re._permanentFailureMillisSinceLastIncomingData=0,re._permanentFailureAttempt=0,re._permanentFailureHandled=!1,re._instances=[];class G extends re{constructor(A,W,F,N,H){super(1,A,N,H);this.client=this._register(new g.Client(H,{remoteAuthority:W,clientId:F},A.ipcLogger))}async _reconnect(A,W){await o(A,W)}}e.ManagementPersistentConnection=G;class X extends re{constructor(A,W,F,N,H){super(2,A,F,N);this._startArguments=W,this.debugPort=H}async _reconnect(A,W){await h(A,this._startArguments,W)}}e.ExtensionHostPersistentConnection=X;function B(U){try{U.acceptDisconnect();const A=U.getSocket();U.dispose(),A.dispose()}catch(A){(0,C.onUnexpectedError)(A)}}function $(U){if(U&&U.type==="error"){const A=new Error(`Connection error: ${U.reason}`);return A.code="VSCODE_CONNECTION_ERROR",A}return null}function Y(U,A){for(;U.length<A;)U+=" ";return U}function V(U,A,W){return`[remote-connection][${Y(v(U),13)}][${A.substr(0,5)}\u2026][${W?"reconnect":"initial"}]`}function q(U,A){return`${V(A,U.reconnectionToken,!!U.reconnectionProtocol)}[${U.host}:${U.port}]`}function Z(U){return`${Date.now()-U} ms`}}),define(x[64],ee([0,1,10]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function r(g){return g.scheme===p.Schemas.vscodeRemote?g.authority:void 0}e.getRemoteAuthority=r;function D(g){if(!g)return;const S=g.indexOf("+");return S<0?g:g.substr(0,S)}e.getRemoteName=D;function C(g){return g.scheme!==p.Schemas.file&&g.scheme!==p.Schemas.vscodeRemote}e.isVirtualResource=C;function k(g){if(g.folders.length)return g.folders.every(S=>C(S.uri))?g.folders[0].uri:void 0;if(g.configuration&&C(g.configuration))return g.configuration}e.getVirtualWorkspaceLocation=k;function I(g){return k(g)?.scheme}e.getVirtualWorkspaceScheme=I;function d(g){return k(g)!==void 0}e.isVirtualWorkspace=d}),define(x[195],ee([0,1,25,5,64]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.getWorkspaceSupportTypeMessage=C;function k(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(!w.uuid||typeof w.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));class d{constructor(v){this.value=v,this._lower=v.toLowerCase()}static equals(v,t){if(typeof v=="undefined"||v===null)return typeof t=="undefined"||t===null;if(typeof t=="undefined"||t===null)return!1;if(typeof v=="string"||typeof t=="string"){let f=typeof v=="string"?v:v.value,y=typeof t=="string"?t:t.value;return p.equalsIgnoreCase(f,y)}return v._lower===t._lower}static toKey(v){return typeof v=="string"?v.toLowerCase():v._lower}}e.ExtensionIdentifier=d;function g(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.isLanguagePackExtension=g;function S(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=S;function E(w,v){if(v){const t=`onResolveRemoteAuthority:${(0,D.getRemoteName)(v)}`;return w.activationEvents?.indexOf(t)!==-1}return!1}e.isResolverExtension=E,e.IBuiltinExtensionsScannerService=(0,r.createDecorator)("IBuiltinExtensionsScannerService")}),define(x[196],ee([0,1,25,195]),function(j,e,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(t,f){return t.uuid&&f.uuid?t.uuid===f.uuid:t.id===f.id?!0:(0,p.compareIgnoreCase)(t.id,f.id)===0}e.areSameExtensions=D;class C{constructor(f,y){this.version=y,this.id=f.id,this.uuid=f.uuid}key(){return`${this.id}-${this.version}`}equals(f){return f instanceof C?D(this,f)&&this.version===f.version:!1}}e.ExtensionIdentifierWithVersion=C;function k(t,f){return`${t}.${f}`}e.getExtensionId=k;function I(t){return t.toLocaleLowerCase()}e.adoptToGalleryExtensionId=I;function d(t,f){return I(k(t,f))}e.getGalleryExtensionId=d;function g(t,f){const y=[],b=P=>{for(const c of y)if(c.some(a=>D(f(a),f(P))))return c;return null};for(const P of t){const c=b(P);c?c.push(P):y.push([P])}return y}e.groupByExtension=g;function S(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=S;function E(t){return{id:t.identifier.id,name:t.name,galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),...t.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new r.ExtensionIdentifier("pprice.better-merge");function w(t){const f=new Set;if(t.malicious)for(const y of t.malicious)f.add(y.id);return f}e.getMaliciousExtensionsSet=w;function v(t,f){const y=[],b=f.manifest.extensionDependencies?.slice(0)??[];for(;b.length;){const P=b.shift();if(P&&y.every(c=>!D(c.identifier,{id:P}))){const c=t.filter(a=>D(a.identifier,{id:P}));c.length===1&&(y.push(c[0]),b.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return y}e.getExtensionDependencies=v}),define(x[95],ee([0,1,4,3,5,6]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var k;(function(t){t.Http="http",t.Https="https"})(k=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var d;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(d=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function g(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const f=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!f)return{address:f[1],port:+f[2]}}e.extractLocalHostUriMetaDataForPortMapping=g,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=S,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=E;function w(t,f){return f?f!==1&&t<1024:!r.isWindows&&t<1024}e.isPortPrivileged=w;let v=class{constructor(f){this.logService=f,this._onTunnelOpened=new p.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new p.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new p.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(f,y){return this._tunnelProvider=f,f?(this._canElevate=y.elevation,this._privacyOptions=y.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const f=[],y=Array.from(this._tunnels.values());for(let b of y){const P=Array.from(b.values());for(let c of P){const a=await c.value;a&&f.push(a)}}return f}async dispose(){for(const f of this._tunnels.values()){for(const{value:y}of f.values())await y.then(b=>b?.dispose());f.clear()}this._tunnels.clear()}openTunnel(f,y,b,P,c=!1,a=I.Private,l){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${y}:${b} on local port ${P}.`),!f)return;y||(y="localhost");const o=this.retainOrCreateTunnel(f,y,b,P,c,a,l);return o?o.then(h=>{if(!h){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(y,b);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(h);return(h.tunnelRemoteHost!==y||h.tunnelRemotePort!==b)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(f){return{tunnelRemotePort:f.tunnelRemotePort,tunnelRemoteHost:f.tunnelRemoteHost,tunnelLocalPort:f.tunnelLocalPort,localAddress:f.localAddress,privacy:f.privacy,protocol:f.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${f.tunnelRemoteHost}:${f.tunnelRemotePort} `);const y=this._tunnels.get(f.tunnelRemoteHost);if(y){const b=y.get(f.tunnelRemotePort);b&&(b.refcount--,await this.tryDisposeTunnel(f.tunnelRemoteHost,f.tunnelRemotePort,b))}}}}async tryDisposeTunnel(f,y,b){if(b.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${f}:${y}.`);const P=b.value.then(async c=>{c&&(await c.dispose(!0),this._onTunnelClosed.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this._tunnels.has(f)&&this._tunnels.get(f).delete(y),P}}async closeTunnel(f,y){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${f}:${y} `);const b=this._tunnels.get(f);if(b&&b.has(y)){const P=b.get(y);P.refcount=0,await this.tryDisposeTunnel(f,y,P)}}addTunnelToMap(f,y,b){this._tunnels.has(f)||this._tunnels.set(f,new Map),this._tunnels.get(f).set(y,{refcount:1,value:b})}async removeEmptyTunnelFromMap(f,y){const b=this._tunnels.get(f);b&&(await b.get(y)||b.delete(y),b.size===0&&this._tunnels.delete(f))}getTunnelFromMap(f,y){let b=[f];S(f)?(b.push(...e.LOCALHOST_ADDRESSES),b.push(...e.ALL_INTERFACES_ADDRESSES)):E(f)&&b.push(...e.ALL_INTERFACES_ADDRESSES);const P=b.map(c=>this._tunnels.get(c));for(const c of P){const a=c?.get(y);if(a)return a}}canTunnel(f){return!!g(f)}createWithProvider(f,y,b,P,c,a,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${y}:${b} on local port ${P}.`);const h={elevationRequired:c?w(P===void 0?b:P):!1},n={remoteAddress:{host:y,port:b},localAddressPort:P,privacy:a,public:a!==I.Private,protocol:l},i=f.forwardPort(n,h);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(y,b,i),i}};v=fe([ie(0,C.ILogService)],v),e.AbstractTunnelService=v}),define(x[48],ee([0,1,17,151,57,5,40]),function(j,e,p,r,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,C.createDecorator)("requestService");function I(t){return t.res.statusCode&&t.res.statusCode>=200&&t.res.statusCode<300||t.res.statusCode===1223}e.isSuccess=I;function d(t){return t.res.statusCode===204}async function g(t){if(!I(t))throw new Error("Server returned "+t.res.statusCode);return d(t)?null:(await(0,p.streamToBuffer)(t.stream)).toString()}e.asText=g;async function S(t){if(!I(t))throw new Error("Server returned "+t.res.statusCode);if(d(t))return null;const y=(await(0,p.streamToBuffer)(t.stream)).toString();try{return JSON.parse(y)}catch(b){throw b.message+=`:
`+y,b}}e.asJson=S;function E(t){v(t)}e.updateProxyConfigurationsScope=E;let w;function v(t){const f=k.Registry.as(D.Extensions.Configuration),y=w;w={id:"http",order:15,title:(0,r.localize)(0,null),type:"object",scope:t,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,r.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,r.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,r.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,r.localize)(4,null),(0,r.localize)(5,null),(0,r.localize)(6,null),(0,r.localize)(7,null)],default:"override",description:(0,r.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,r.localize)(9,null),restricted:!0}}},f.updateConfigurations({add:[w],remove:y?[y]:[]})}v(2)}),define(x[197],ee([0,1,198,13]),function(j,e,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function D(k,I){return k.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:k.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function C(k,I,d={}){const g=(0,p.parse)(k),S=d.proxyUrl||D(g,I);if(!S)return null;const E=(0,p.parse)(S);if(!/^https?:$/.test(E.protocol||""))return null;const w={host:E.hostname||"",port:E.port||(E.protocol==="https"?"443":"80"),auth:E.auth,rejectUnauthorized:(0,r.isBoolean)(d.strictSSL)?d.strictSSL:!0};return g.protocol==="http:"?new(await new Promise((v,t)=>{j(["http-proxy-agent"],v,t)}))(w):new(await new Promise((v,t)=>{j(["https-proxy-agent"],v,t)}))(w)}e.getProxyAgent=C}),define(x[199],ee([0,1,17,27]),function(j,e,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(C,k,I){let d=I&&I.get("storage.serviceMachineId",0)||null;if(d)return d;try{const S=(await k.readFile(C.serviceMachineIdResource)).value.toString();d=(0,r.isUUID)(S)?S:null}catch{d=null}if(!d){d=(0,r.generateUuid)();try{await k.writeFile(C.serviceMachineIdResource,p.VSBuffer.fromString(d))}catch{}}return I&&I.store("storage.serviceMachineId",d,0,1),d}e.getServiceMachineId=D}),define(x[76],ee([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,p.createDecorator)(e.SIGN_SERVICE_ID)}),define(x[200],ee([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class p{constructor(){this.validators=new Map}vsda(){return new Promise((D,C)=>j(["vsda"],D,C))}async createNewMessage(D){try{const C=await this.vsda(),k=new C.validator;if(k){const I=String(p._nextId++);return this.validators.set(I,k),{id:I,data:k.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,C){if(!D.id)return!0;const k=this.validators.get(D.id);if(!k)return!1;this.validators.delete(D.id);try{return k.validate(C)==="ok"}catch{return!1}}async sign(D){try{const C=await this.vsda(),k=new C.signer;if(k)return k.sign(D)}catch{}return D}}e.SignService=p,p._nextId=1}),define(x[38],ee([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,p.createDecorator)("stateMainService")}),define(x[20],ee([0,1,14,9,4,2,3,34,13,5,180,6,38]),function(j,e,p,r,D,C,k,I,d,g,S,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,g.createDecorator)("lifecycleMainService");var v;(function(f){f[f.Starting=1]="Starting",f[f.Ready=2]="Ready",f[f.AfterWindowOpen=3]="AfterWindowOpen"})(v=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let t=class dt extends C.Disposable{constructor(y,b){super();this.logService=y,this.stateMainService=b,this._onBeforeShutdown=this._register(new D.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new D.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new D.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new D.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new D.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(dt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(dt.QUIT_AND_RESTART_KEY)}registerListeners(){const y=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),k.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown())};p.app.addListener("before-quit",y);const b=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!k.isMacintosh)&&p.app.quit()};p.app.addListener("window-all-closed",b),p.app.once("will-quit",P=>{this.logService.trace("Lifecycle#app.on(will-quit)"),P.preventDefault(),this.fireOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),p.app.removeListener("before-quit",y),p.app.removeListener("window-all-closed",b),p.app.quit()})})}fireOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const y=[];return this._onWillShutdown.fire({join(b){y.push(b)}}),this.pendingWillShutdownPromise=(async()=>{try{await r.Promises.settled(y)}catch(b){this.logService.error(b)}try{await this.stateMainService.close()}catch(b){this.logService.error(b)}})(),this.pendingWillShutdownPromise}set phase(y){if(y<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===y)return;this.logService.trace(`lifecycle (main): phase changed (value: ${y})`),this._phase=y;const b=this.phaseWhen.get(this._phase);b&&(b.open(),this.phaseWhen.delete(this._phase))}async when(y){if(y<=this._phase)return;let b=this.phaseWhen.get(y);b||(b=new r.Barrier,this.phaseWhen.set(y,b)),await b.wait()}registerWindow(y){const b=new C.DisposableStore;this.windowCounter++,b.add(y.onWillLoad(c=>this._onWillLoadWindow.fire({window:y,workspace:c.workspace,reason:c.reason})));const P=(0,d.assertIsDefined)(y.win);P.on("close",c=>{const a=y.id;if(this.windowToCloseRequest.has(a)){this.windowToCloseRequest.delete(a);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${y.id}`),c.preventDefault(),this.unload(y,1).then(l=>{if(l){this.windowToCloseRequest.delete(a);return}this.windowToCloseRequest.add(a),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${a}`),this._onBeforeCloseWindow.fire(y),y.close()})}),P.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${y.id}`),this.windowCounter--,b.dispose(),this.windowCounter===0&&(!k.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown()})}async reload(y,b){await this.unload(y,3)||y.reload(b)}async unload(y,b){if(!y.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${y.id}`);const P=this._quitRequested?2:b;let c=await this.onBeforeUnloadWindowInRenderer(y,P);return c?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${y.id})`),this.handleWindowUnloadVeto(c)):(c=await this.onBeforeUnloadWindowInMain(y,P),c?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${y.id})`),this.handleWindowUnloadVeto(c)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${y.id})`),await this.onWillUnloadWindowInRenderer(y,P),!1))}handleWindowUnloadVeto(y){return y?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(y){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(y),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(y,b){return new Promise(P=>{const c=this.oneTimeListenerTokenGenerator++,a=`vscode:ok${c}`,l=`vscode:cancel${c}`;p.ipcMain.once(a,()=>{P(!1)}),p.ipcMain.once(l,()=>{P(!0)}),y.send("vscode:onBeforeUnload",{okChannel:a,cancelChannel:l,reason:b})})}onBeforeUnloadWindowInMain(y,b){const P=[];return this._onBeforeUnloadWindow.fire({reason:b,window:y,veto(c){P.push(c)}}),(0,S.handleVetos)(P,c=>this.logService.error(c))}onWillUnloadWindowInRenderer(y,b){return new Promise(P=>{const a=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;p.ipcMain.once(a,()=>P()),y.send("vscode:onWillUnload",{replyChannel:a,reason:b})})}quit(y){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${y}`),y&&this.stateMainService.setItem(dt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(b=>{this.pendingQuitPromiseResolve=b,this.logService.trace("Lifecycle#quit() - calling app.quit()"),p.app.quit()}),this.pendingQuitPromise)}async relaunch(y){this.logService.trace("Lifecycle#relaunch()");const b=process.argv.slice(1);if(y?.addArgs&&b.push(...y.addArgs),y?.removeArgs)for(const a of y.removeArgs){const l=b.indexOf(a);l>=0&&b.splice(l,1)}const P=()=>{try{if(k.isWindows){const a=(0,I.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.logService.error(a)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),p.app.relaunch({args:b})};p.app.once("quit",P),await this.quit(!0)&&p.app.removeListener("quit",P)}async kill(y){this.logService.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(),await Promise.race([(0,r.timeout)(1e3),(async()=>{for(const b of p.BrowserWindow.getAllWindows())if(b&&!b.isDestroyed()){let P;b.webContents&&!b.webContents.isDestroyed()?P=new Promise(c=>b.once("closed",c)):P=Promise.resolve(),b.destroy(),await P}})()]),p.app.exit(y)}};t.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",t=fe([ie(0,E.ILogService),ie(1,w.IStateMainService)],t),e.LifecycleMainService=t}),define(x[201],ee([0,1,4,2,5,20]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,D.createDecorator)("keyboardLayoutMainService");let k=class extends r.Disposable{constructor(g){super();this._onDidChangeKeyboardLayout=this._register(new p.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,g.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const g=await new Promise((S,E)=>{j(["native-keymap"],S,E)});this._keyboardLayoutData=I(g),g.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=I(g),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};k=fe([ie(0,C.ILifecycleMainService)],k),e.KeyboardLayoutMainService=k;function I(d){const g=d.getKeyMap(),S=d.getCurrentKeyboardLayout();return{keyboardMapping:g,keyboardLayoutInfo:S}}}),define(x[96],ee([0,1,9,4,2,63,13,85,5]),function(j,e,p,r,D,C,k,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const g="__$__targetStorageMarker";e.IStorageService=(0,d.createDecorator)("storageService");var S;(function(y){y[y.NONE=0]="NONE",y[y.SHUTDOWN=1]="SHUTDOWN"})(S=e.WillSaveStateReason||(e.WillSaveStateReason={}));var E;(function(y){y[y.GLOBAL=0]="GLOBAL",y[y.WORKSPACE=1]="WORKSPACE"})(E=e.StorageScope||(e.StorageScope={}));var w;(function(y){y[y.USER=0]="USER",y[y.MACHINE=1]="MACHINE"})(w=e.StorageTarget||(e.StorageTarget={}));class v extends D.Disposable{constructor(b={flushInterval:v.DEFAULT_FLUSH_INTERVAL}){super();this.options=b,this._onDidChangeValue=this._register(new r.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new r.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new r.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new p.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,p.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,C.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,C.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(b,P){P===g?(b===0?this._globalKeyTargets=void 0:b===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:b})):this._onDidChangeValue.fire({scope:b,key:P,target:this.getKeyTargets(b)[P]})}emitWillSaveState(b){this._onWillSaveState.fire({reason:b})}get(b,P,c){return this.getStorage(P)?.get(b,c)}getBoolean(b,P,c){return this.getStorage(P)?.getBoolean(b,c)}getNumber(b,P,c){return this.getStorage(P)?.getNumber(b,c)}store(b,P,c,a){if((0,k.isUndefinedOrNull)(P)){this.remove(b,c);return}this.withPausedEmitters(()=>{this.updateKeyTarget(b,c,a),this.getStorage(c)?.set(b,P)})}remove(b,P){this.withPausedEmitters(()=>{this.updateKeyTarget(b,P,void 0),this.getStorage(P)?.delete(b)})}withPausedEmitters(b){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{b()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(b,P){const c=[],a=this.getKeyTargets(b);for(const l of Object.keys(a))a[l]===P&&c.push(l);return c}updateKeyTarget(b,P,c){const a=this.getKeyTargets(P);typeof c=="number"?a[b]!==c&&(a[b]=c,this.getStorage(P)?.set(g,JSON.stringify(a))):typeof a[b]=="number"&&(delete a[b],this.getStorage(P)?.set(g,JSON.stringify(a)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(b){return b===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(b){const P=this.get(g,b);if(P)try{return JSON.parse(P)}catch{}return Object.create(null)}isNew(b){return this.getBoolean(e.IS_NEW_KEY,b)===!0}async flush(b=S.NONE){this._onWillSaveState.fire({reason:b});const P=this.getStorage(0),c=this.getStorage(1);switch(b){case S.NONE:await p.Promises.settled([P?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve()]);break;case S.SHUTDOWN:await p.Promises.settled([P?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve()]);break}}async logStorage(){const b=this.getStorage(0)?.items??new Map,P=this.getStorage(1)?.items??new Map;return f(b,P,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=v,v.DEFAULT_FLUSH_INTERVAL=60*1e3;class t extends v{constructor(){super();this.globalStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(b=>this.emitDidChangeValue(1,b))),this._register(this.globalStorage.onDidChangeStorage(b=>this.emitDidChangeValue(0,b)))}getStorage(b){return b===0?this.globalStorage:this.workspaceStorage}getLogDetails(b){return b===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(b){}}e.InMemoryStorageService=t;async function f(y,b,P,c){const a=u=>{try{return JSON.parse(u)}catch{return u}},l=new Map,o=new Map;y.forEach((u,m)=>{l.set(m,u),o.set(m,a(u))});const h=new Map,n=new Map;b.forEach((u,m)=>{h.set(m,u),n.set(m,a(u))}),console.group(`Storage: Global (path: ${P})`);let i=[];l.forEach((u,m)=>{i.push({key:m,value:u})}),console.table(i),console.groupEnd(),console.log(o),console.group(`Storage: Workspace (path: ${c})`);let s=[];h.forEach((u,m)=>{s.push({key:m,value:u})}),console.table(s),console.groupEnd(),console.log(n)}e.logStorage=f}),define(x[202],ee([0,1,3,34,7,27]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(g){if(p.platform===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}async function I(g,S,E,w,v,t,f,y,b,P){const c=Object.create(null);c["common.machineId"]=f,c.sessionID=(0,C.generateUuid)()+Date.now(),c.commitHash=v,c.version=t,c["common.platformVersion"]=(S||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,p.PlatformToString)(p.platform),c["common.nodePlatform"]=r.platform,c["common.nodeArch"]=w,c["common.product"]=P||"desktop";const a=d(y||[]);a&&(c["common.msftInternal"]=a);let l=0;const o=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),p.isLinuxSnap&&(c["common.snap"]="true");const h=k(E);h&&(c["common.platformDetail"]=h);try{const n=await g.readFile(D.URI.file(b));c["common.source"]=n.value.toString().slice(0,30)}catch{}return c}e.resolveCommonProperties=I;function d(g){const S=r.env.USERDNSDOMAIN;if(!S)return!1;const E=S.toLowerCase();return g.some(w=>E===w)}e.verifyMicrosoftInternalDomain=d}),define(x[29],ee([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,p.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,p.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var r;(function(C){C[C.NONE=0]="NONE",C[C.CRASH=1]="CRASH",C[C.ERROR=2]="ERROR",C[C.USAGE=3]="USAGE"})(r=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(C){C.OFF="off",C.CRASH="crash",C.ERROR="error",C.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(x[203],ee([0,1,26,69,9,43,10,8,3,7,71,21,82,74,18,22,29]),function(j,e,p,r,D,C,k,I,d,g,S,E,w,v,t,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function b(o,h){const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}];let i;const s=p.homedir().toLowerCase();switch(process.platform){case"win32":i=[{tag:"gdrive",matcher:_=>/^[a-z]:\\(my drive|shared drives)\\/.test(_)||_.startsWith(s+"\\my drive\\")},{tag:"dropbox",matcher:_=>_.startsWith(s+"\\dropbox")},{tag:"onedrive",matcher:_=>_.startsWith(s+"\\onedrive")},{tag:"box",matcher:_=>_.startsWith(s+"\\box\\")},{tag:"nextcloud",matcher:_=>_.startsWith(s+"\\nextcloud\\")},{tag:"owncloud",matcher:_=>_.startsWith(s+"\\owncloud\\")}];break;case"darwin":i=[{tag:"gdrive",matcher:_=>_.startsWith("/volumes/googledrive/")||_.startsWith(s+"/my drive/")},{tag:"dropbox",matcher:_=>_.startsWith(s+"/dropbox")},{tag:"onedrive",matcher:_=>_.startsWith(s+"/onedrive")||_.startsWith(s+"/library/cloudstorage/onedrive")},{tag:"icloud",matcher:_=>_.startsWith(s+"/library/mobile documents/")},{tag:"box",matcher:_=>_.startsWith(s+"/box/")},{tag:"nextcloud",matcher:_=>_.startsWith(s+"/nextcloud/")},{tag:"owncloud",matcher:_=>_.startsWith(s+"/owncloud/")}];break}const u=new Map,m=new Map,M=2e4;function L(_,Q,se,re){for(const X of i){const B=_.toLowerCase();X.matcher(B)&&m.set(X.tag,1)}const G=Q.substring(_.length+1);return D.Promises.withAsyncBody(async X=>{let B;try{B=await E.Promises.readdir(Q,{withFileTypes:!0})}catch{X();return}if(re.count>=M){re.count+=B.length,re.maxReached=!0,X();return}let $=B.length;if($===0){X();return}let Y=B;re.count+B.length>M&&(re.maxReached=!0,$=M-re.count,Y=B.slice(0,$)),re.count+=B.length;for(const V of Y)if(V.isDirectory()){if(se.includes(V.name)||await L(_,(0,I.join)(Q,V.name),se,re),--$==0){X();return}}else{const q=V.name.lastIndexOf(".");if(q>=0){const Z=V.name.substring(q+1);Z&&u.set(Z,(u.get(Z)??0)+1)}for(const Z of n)Z.relativePathPattern?.test(G)!==!1&&Z.filePattern.test(V.name)&&m.set(Z.tag,(m.get(Z.tag)??0)+1);if(--$==0){X();return}}})}const R={count:0,maxReached:!1};await L(o,o,h,R);const T=await a(o);return{configFiles:P(m),fileTypes:P(u),fileCount:R.count,maxFilesReached:R.maxReached,launchConfigFiles:T}}e.collectWorkspaceStats=b;function P(o){return[...r.Iterable.map(o.entries(),([h,n])=>({name:h,count:n}))].sort((h,n)=>n.count-h.count)}function c(){const o={os:`${p.type()} ${p.arch()} ${p.release()}`,memory:`${(p.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(S.virtualMachineHint.value()*100)}%`},h=p.cpus();return h&&h.length>0&&(o.cpus=`${h[0].model} (${h.length} x ${h[0].speed})`),o}e.getMachineInfo=c;async function a(o){try{const h=new Map,n=(0,I.join)(o,".vscode","launch.json"),i=await E.Promises.readFile(n),s=[],u=(0,C.parse)(i.toString(),s);if(s.length)return console.log(`Unable to parse ${n}`),[];if((0,C.getNodeType)(u)==="object"&&u.configurations)for(const m of u.configurations){const M=m.type;M&&(h.has(M)?h.set(M,h.get(M)+1):h.set(M,1))}return P(h)}catch{return[]}}e.collectLaunchConfigs=a;let l=class{constructor(h,n){this.telemetryService=h,this.productService=n}formatMachineInfo(h){const n=[];return n.push(`OS Version:       ${h.os}`),n.push(`CPUs:             ${h.cpus}`),n.push(`Memory (System):  ${h.memory}`),n.push(`VM:               ${h.vmHint}`),n.join(`
`)}formatEnvironment(h){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${p.type()} ${p.arch()} ${p.release()}`);const i=p.cpus();return i&&i.length>0&&n.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),n.push(`Memory (System):  ${(p.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`),d.isWindows||n.push(`Load (avg):       ${p.loadavg().map(s=>Math.round(s)).join(", ")}`),n.push(`VM:               ${Math.round(S.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${h.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${h.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(h.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(h,n){return Promise.all([(0,w.listProcesses)(h.mainPID),this.formatWorkspaceMetadata(h)]).then(async i=>{let[s,u]=i,m=this.formatProcessList(h,s);return n.forEach(M=>{if((0,v.isRemoteDiagnosticError)(M))m+=`
${M.errorMessage}`,u+=`
${M.errorMessage}`;else if(m+=`

Remote: ${M.hostName}`,M.processes&&(m+=`
${this.formatProcessList(h,M.processes)}`),M.workspaceMetadata){u+=`
|  Remote: ${M.hostName}`;for(const L of Object.keys(M.workspaceMetadata)){const R=M.workspaceMetadata[L];let T=`${R.fileCount} files`;R.maxFilesReached&&(T=`more than ${T}`),u+=`|    Folder (${L}): ${T}`,u+=this.formatWorkspaceStats(R)}}}),{processInfo:m,workspaceInfo:u}})}async getSystemInfo(h,n){const{memory:i,vmHint:s,os:u,cpus:m}=c(),M={os:u,memory:i,cpus:m,vmHint:s,processArgs:`${h.mainArguments.join(" ")}`,gpuStatus:h.gpuFeatureStatus,screenReader:`${h.screenReader?"yes":"no"}`,remoteData:n};return d.isWindows||(M.load=`${p.loadavg().map(L=>Math.round(L)).join(", ")}`),d.isLinux&&(M.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(M)}async getDiagnostics(h,n){const i=[];return(0,w.listProcesses)(h.mainPID).then(async s=>(i.push(""),i.push(this.formatEnvironment(h)),i.push(""),i.push(this.formatProcessList(h,s)),h.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(h))),n.forEach(u=>{if((0,v.isRemoteDiagnosticError)(u))i.push(`
${u.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${u.hostName}`),i.push(this.formatMachineInfo(u.machineInfo)),u.processes&&i.push(this.formatProcessList(h,u.processes)),u.workspaceMetadata)for(const m of Object.keys(u.workspaceMetadata)){const M=u.workspaceMetadata[m];let L=`${M.fileCount} files`;M.maxFilesReached&&(L=`more than ${L}`),i.push(`Folder (${m}): ${L}`),i.push(this.formatWorkspaceStats(M))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(h){const n=[],i=60;let s=0;const u=(R,T)=>{const _=` ${R}(${T})`;s+_.length>i?(n.push(m),m="|                 ",s=m.length):s+=_.length,m+=_};let m="|      File types:";const M=10;let L=h.fileTypes.length>M?M:h.fileTypes.length;for(let R=0;R<L;R++){const T=h.fileTypes[R];u(T.name,T.count)}if(n.push(m),h.configFiles.length>=0&&(m="|      Conf files:",s=0,h.configFiles.forEach(R=>{u(R.name,R.count)}),n.push(m)),h.launchConfigFiles.length>0){let R="|      Launch Configs:";h.launchConfigFiles.forEach(T=>{R+=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`}),n.push(R)}return n.join(`
`)}expandGPUFeatures(h){const n=Math.max(...Object.keys(h).map(i=>i.length));return Object.keys(h).map(i=>`${i}:  ${" ".repeat(n-i.length)}  ${h[i]}`).join(`
                  `)}formatWorkspaceMetadata(h){const n=[],i=[];return h.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(n.push(`|  Window (${s.title})`),s.folderURIs.forEach(u=>{const m=g.URI.revive(u);if(m.scheme===k.Schemas.file){const M=m.fsPath;i.push(b(M,["node_modules",".git"]).then(L=>{let R=`${L.fileCount} files`;L.maxFilesReached&&(R=`more than ${R}`),n.push(`|    Folder (${(0,I.basename)(M)}): ${R}`),n.push(this.formatWorkspaceStats(L))}).catch(L=>{n.push(`|      Error: Unable to collect workspace stats for folder ${M} (${L.toString()})`)}))}else n.push(`|    Folder (${m.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(s=>n.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(h,n){const i=new Map;h.windows.forEach(u=>i.set(u.pid,u.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(h.mainPID,i,s,n,0),s.join(`
`)}formatProcessItem(h,n,i,s,u){const m=u===0;let M;m?M=s.pid===h?`${this.productService.applicationName} main`:"remote agent":(M=`${"  ".repeat(u)} ${s.name}`,s.name==="window"&&(M=`${M} (${n.get(s.pid)})`));const L=process.platform==="win32"?s.mem:p.totalmem()*(s.mem/100);i.push(`${s.load.toFixed(0).padStart(5," ")}	${(L/t.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${M}`),Array.isArray(s.children)&&s.children.forEach(R=>this.formatProcessItem(h,n,i,R,u+1))}async reportWorkspaceStats(h){for(const{uri:n}of h.folders){const i=g.URI.revive(n);if(i.scheme!==k.Schemas.file)continue;const s=i.fsPath;try{const u=await b(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":h.telemetryId,rendererSessionId:h.rendererSessionId}),u.fileTypes.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:h.rendererSessionId,type:m.name,count:m.count})}),u.launchConfigFiles.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:h.rendererSessionId,type:m.name,count:m.count})}),u.configFiles.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:h.rendererSessionId,type:m.name,count:m.count})})}catch{}}}};l=fe([ie(0,y.ITelemetryService),ie(1,f.IProductService)],l),e.DiagnosticsService=l}),define(x[204],ee([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class p{constructor(C){this.appenders=C}listen(C,k){throw new Error(`Event not found: ${k}`)}call(C,k,{eventName:I,data:d}){return this.appenders.forEach(g=>g.log(I,d)),Promise.resolve(null)}}e.TelemetryAppenderChannel=p;class r{constructor(C){this.channel=C}log(C,k){return this.channel.call("log",{eventName:C,data:k}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=r}),define(x[65],ee([0,1,47,13,19,29]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class k{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(b,P){return Promise.resolve(void 0)}publicLog2(b,P){return this.publicLog(b,P)}publicLogError(b,P){return Promise.resolve(void 0)}publicLogError2(b,P){return this.publicLogError(b,P)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=k,e.NullTelemetryService=new k;class I{async publicLog(b,P,c){}async publicLogError(b,P,c){}}e.NullEndpointTelemetryService=I,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function d(y,b){return b.onDidChangeConfiguration(P=>{P.source!==6&&y.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(P.source),configurationKeys:t(P.sourceConfig)})})}e.configurationTelemetry=d;function g(y,b){return!(b.disableTelemetry||!y.enableTelemetry)}e.supportsTelemetry=g;function S(y){const b=y.getValue(C.TELEMETRY_SETTING_ID),P=y.getValue("telemetry.enableCrashReporter");if(y.getValue(C.TELEMETRY_OLD_SETTING_ID)===!1||P===!1)return 0;switch(b??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=S;function E(y){const b=Object.create(null),P=Object.create(null),c=Object.create(null);v(y,c);for(let a in c){a=a.length>150?a.substr(a.length-149):a;const l=c[a];typeof l=="number"?P[a]=l:typeof l=="boolean"?P[a]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${l.length}`),b[a]=l.substring(0,8191)):typeof l!="undefined"&&l!==null&&(b[a]=l)}return{properties:b,measurements:P}}e.validateTelemetryData=E;function w(y){if(!y)return"none";let b="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(c=>{y.indexOf(`${c}+`)===0&&(b=c)}),b}e.cleanRemoteAuthority=w;function v(y,b,P=0,c){if(!!y)for(let a of Object.getOwnPropertyNames(y)){const l=y[a],o=c?c+a:a;Array.isArray(l)?b[o]=(0,p.safeStringify)(l):l instanceof Date?b[o]=l.toISOString():(0,r.isObject)(l)?P<2?v(l,b,P+1,o+"."):b[o]=(0,p.safeStringify)(l):b[o]=l}}function t(y){if(!y)return[];const b=[];return f(b,"",y),b}function f(y,b,P){P&&typeof P=="object"&&!Array.isArray(P)?Object.keys(P).forEach(c=>f(y,b?`${b}.${c}`:c,P[c])):y.push(b)}}),define(x[205],ee([0,1,31,23,15,47,3,34,13,7,19,53,170,196,167,18,6,22,48,199,96,29,65]),function(j,e,p,r,D,C,k,I,d,g,S,E,w,v,t,f,y,b,P,c,a,l,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const h=k.isWeb?"web":(0,w.getTargetPlatform)(k.platform,I.arch);var n;(function(O){O[O.None=0]="None",O[O.IncludeVersions=1]="IncludeVersions",O[O.IncludeFiles=2]="IncludeFiles",O[O.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",O[O.IncludeSharedAccounts=8]="IncludeSharedAccounts",O[O.IncludeVersionProperties=16]="IncludeVersionProperties",O[O.ExcludeNonValidated=32]="ExcludeNonValidated",O[O.IncludeInstallationTargets=64]="IncludeInstallationTargets",O[O.IncludeAssetUri=128]="IncludeAssetUri",O[O.IncludeStatistics=256]="IncludeStatistics",O[O.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",O[O.Unpublished=4096]="Unpublished"})(n||(n={}));function i(...O){return String(O.reduce((z,te)=>z|te,0))}var s;(function(O){O[O.Tag=1]="Tag",O[O.ExtensionId=4]="ExtensionId",O[O.Category=5]="Category",O[O.ExtensionName=7]="ExtensionName",O[O.Target=8]="Target",O[O.Featured=9]="Featured",O[O.SearchText=10]="SearchText",O[O.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const u={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},m={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},L={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class R{constructor(z=L){this.state=z}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(z,te=this.state.pageSize){return new R({...this.state,pageNumber:z,pageSize:te})}withFilter(z,...te){const ne=[...this.state.criteria,...te.length?te.map(oe=>({filterType:z,value:oe})):[{filterType:z}]];return new R({...this.state,criteria:ne})}withSortBy(z){return new R({...this.state,sortBy:z})}withSortOrder(z){return new R({...this.state,sortOrder:z})}withFlags(...z){return new R({...this.state,flags:z.reduce((te,ne)=>te|ne,0)})}withAssetTypes(...z){return new R({...this.state,assetTypes:z})}get raw(){const{criteria:z,pageNumber:te,pageSize:ne,sortBy:oe,sortOrder:J,flags:ce,assetTypes:le}=this.state;return{filters:[{criteria:z,pageNumber:te,pageSize:ne,sortBy:oe,sortOrder:J}],assetTypes:le,flags:ce}}get searchText(){const z=this.state.criteria.filter(te=>te.filterType===s.SearchText)[0];return z&&z.value?z.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(z=>String(z.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function T(O,z){const te=(O||[]).filter(ne=>ne.statisticName===z)[0];return te?te.value:0}function _(O){const z="Microsoft.VisualStudio.Code.Translation.";return O.files.filter(ne=>ne.assetType.indexOf(z)===0).reduce((ne,oe)=>{const J=G(O,oe.assetType);return J&&ne.push([oe.assetType.substring(z.length),J]),ne},[])}function Q(O){if(O.properties){const z=O.properties.filter(oe=>oe.key===u.Repository),te=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ne=z.filter(oe=>te.test(oe.value))[0];return ne?{uri:ne.value,fallbackUri:ne.value}:null}return G(O,u.Repository)}function se(O){return{uri:`${O.fallbackAssetUri}/${u.VSIX}?redirect=true${O.targetPlatform?`&targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${u.VSIX}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}}function re(O){const z=G(O,u.Icon);if(z)return z;const te=w.DefaultIconPath;return{uri:te,fallbackUri:te}}function G(O,z){return O.files.filter(ne=>ne.assetType===z)[0]?{uri:`${O.assetUri}/${z}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${z}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}:null}function X(O,z){const te=O.properties?O.properties.filter(oe=>oe.key===z):[],ne=te.length>0&&te[0].value;return ne?ne.split(",").map(oe=>(0,v.adoptToGalleryExtensionId)(oe)):[]}function B(O){const z=O.properties?O.properties.filter(te=>te.key===m.Engine):[];return z.length>0&&z[0].value||""}function $(O){const z=O.properties?O.properties.filter(te=>te.key===m.PreRelease):[];return z.length>0&&z[0].value==="true"}function Y(O){const z=O.properties?O.properties.filter(ne=>ne.key===m.LocalizedLanguages):[],te=z.length>0&&z[0].value||"";return te?te.split(","):[]}function V(O){return O.indexOf("preview")!==-1}function q(O){return O.targetPlatform?(0,w.toTargetPlatform)(O.targetPlatform):"undefined"}function Z(O){const z=(0,p.distinct)(O.versions.map(q)),te=!!O.tags?.includes(w.WEB_EXTENSION_TAG),ne=z.indexOf("web");return te?ne===-1&&z.push("web"):ne!==-1&&z.splice(ne,1),z}function U(O,z){const te=(0,w.getFallbackTargetPlarforms)(z);for(let ne=0;ne<O.length;ne++){const oe=O[ne];if(oe.version===O[ne-1]?.version){let J=ne;const ce=q(oe);if(ce===z)for(;J>0&&O[J-1].version===oe.version;)J--;else if(te.includes(ce))for(;J>0&&O[J-1].version===oe.version&&q(O[J-1])!==z;)J--;J!==ne&&(O.splice(ne,1),O.splice(J,0,oe))}}return O}e.sortExtensionVersions=U;function A(O,z,te,ne,oe){const J=O.versions[0],ce={manifest:G(z,u.Manifest),readme:G(z,u.Details),changelog:G(z,u.Changelog),license:G(z,u.License),repository:Q(z),download:se(z),icon:re(z),coreTranslations:_(z)};return{identifier:{id:(0,v.getGalleryExtensionId)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},name:O.extensionName,version:z.version,displayName:O.displayName,publisherId:O.publisher.publisherId,publisher:O.publisher.publisherName,publisherDisplayName:O.publisher.displayName,publisherDomain:O.publisher.domain?{link:O.publisher.domain,verified:!!O.publisher.isDomainVerified}:void 0,description:O.shortDescription||"",installCount:T(O.statistics,"install"),rating:T(O.statistics,"averagerating"),ratingCount:T(O.statistics,"ratingcount"),categories:O.categories||[],tags:O.tags||[],releaseDate:Date.parse(O.releaseDate),lastUpdated:Date.parse(O.lastUpdated),allTargetPlatforms:te,assets:ce,properties:{dependencies:X(z,m.Dependency),extensionPack:X(z,m.ExtensionPack),engine:B(z),localizedLanguages:Y(z),targetPlatform:q(z),isPreReleaseVersion:$(z)},hasPreReleaseVersion:$(J),hasReleaseVersion:ne,preview:V(O.flags),telemetryData:oe}}let W=class{constructor(z,te,ne,oe,J,ce,le,ue){this.requestService=te,this.logService=ne,this.environmentService=oe,this.telemetryService=J,this.fileService=ce,this.productService=le,this.configurationService=ue;const me=le.extensionsGallery;this.extensionsGalleryUrl=me&&me.serviceUrl,this.extensionsControlUrl=me&&me.controlUrl,this.commonHeadersPromise=H(le.version,le,this.environmentService,this.configurationService,this.fileService,z)}api(z=""){return`${this.extensionsGalleryUrl}${z}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(z,te,ne){const oe=(0,d.isBoolean)(te)?te:!1,J=(0,d.isBoolean)(te)?ne:te;let ce=new R().withFlags(n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,z.length).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExtensionName,...z.map(({id:me})=>me.toLowerCase()));z.every(me=>!me.version)&&(ce=ce.withFlags(n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties,n.IncludeLatestVersionOnly));const{galleryExtensions:le}=await this.queryGallery(ce,h,r.CancellationToken.None),ue=le.map(me=>{const Ee=(0,v.getGalleryExtensionId)(me.publisher.publisherName,me.extensionName);return{rawGalleryExtension:me,version:z.find(de=>(0,v.areSameExtensions)(de,{id:Ee}))?.version,preRelease:oe}});return this.converToGalleryExtensions(ue,h,()=>{},J)}async getExtensions2(z){const te=[],ne=[];for(const le of z)le.uuid?ne.push(le.uuid):te.push(le.id.toLowerCase());let oe=new R().withFlags(n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties,n.IncludeLatestVersionOnly).withPage(1,z.length).withFilter(s.Target,"Microsoft.VisualStudio.Code");ne.length&&(oe=oe.withFilter(s.ExtensionId,...ne)),te.length&&(oe=oe.withFilter(s.ExtensionId,...te));const{galleryExtensions:J}=await this.queryGallery(oe,h,r.CancellationToken.None),ce=J.map(le=>{const ue=(0,v.getGalleryExtensionId)(le.publisher.publisherName,le.extensionName),me=z.find(Ee=>(0,v.areSameExtensions)(Ee,{id:ue,uuid:le.extensionId}));return{rawGalleryExtension:le,preRelease:!!me?.preRelease}});return this.converToGalleryExtensions(ce,h,()=>{},r.CancellationToken.None)}async getCompatibleExtension(z,te,ne){const oe=(0,w.isIExtensionIdentifier)(z)?null:z;if(oe){if((0,w.isNotWebExtensionInWebTargetPlatform)(oe.allTargetPlatforms,ne))return null;if(await this.isExtensionCompatible(oe,te,ne))return oe}const{id:J,uuid:ce}=oe?oe.identifier:z;let le=new R().withFlags(n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");ce?le=le.withFilter(s.ExtensionId,ce):le=le.withFilter(s.ExtensionName,J);const{galleryExtensions:ue}=await this.queryGallery(le,ne,r.CancellationToken.None),[me]=ue;if(!me||!me.versions.length)return null;const Ee=Z(me);if((0,w.isNotWebExtensionInWebTargetPlatform)(Ee,ne))return null;for(let de of me.versions){if(!B(de)){const ge=await this.getEngine(de);de={...de,properties:[...de.properties||[],{key:m.Engine,value:ge}]}}if(await this.isRawExtensionVersionCompatible(de,te,Ee,ne)){const ge=me.versions.some(pe=>!$(pe));return A(me,de,Ee,ge)}}return null}async isExtensionCompatible(z,te,ne){if(!(0,w.isTargetPlatformCompatible)(z.properties.targetPlatform,z.allTargetPlatforms,ne)||!te&&z.properties.isPreReleaseVersion)return!1;let oe=z.properties.engine;if(!oe){const J=await this.getManifest(z,r.CancellationToken.None);if(!J)throw new Error("Manifest was not found");oe=J.engines.vscode}return(0,t.isEngineValid)(oe,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(z,te,ne,oe){if(!(0,w.isTargetPlatformCompatible)(q(z),ne,oe)||!te&&$(z))return!1;const J=await this.getEngine(z);return(0,t.isEngineValid)(J,this.productService.version,this.productService.date)}async query(z,te){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let ne=z.text||"";const oe=(0,C.getOrDefault)(z,de=>de.pageSize,50);let J=new R().withFlags(n.IncludeLatestVersionOnly,n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,oe).withFilter(s.Target,"Microsoft.VisualStudio.Code");ne?(ne=ne.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,ge,pe)=>(J=J.withFilter(s.Category,pe||ge),"")),ne=ne.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,ge,pe)=>(J=J.withFilter(s.Tag,pe||ge),"")),ne=ne.replace(/\bfeatured(\s+|\b|$)/g,()=>(J=J.withFilter(s.Featured),"")),ne=ne.trim(),ne&&(ne=ne.length<200?ne:ne.substring(0,200),J=J.withFilter(s.SearchText,ne)),J=J.withSortBy(0)):z.ids?J=J.withFilter(s.ExtensionId,...z.ids):z.names?J=J.withFilter(s.ExtensionName,...z.names):J=J.withSortBy(4),typeof z.sortBy=="number"&&(J=J.withSortBy(z.sortBy)),typeof z.sortOrder=="number"&&(J=J.withSortOrder(z.sortOrder));const{galleryExtensions:ce,total:le}=await this.queryGallery(J,h,te),ue=de=>({index:(J.pageNumber-1)*J.pageSize+de,querySource:z.source}),me=await this.converToGalleryExtensions(ce.map(de=>({rawGalleryExtension:de,preRelease:!!z.includePreRelease})),h,ue,te),Ee=async(de,ge)=>{if(ge.isCancellationRequested)throw(0,D.canceled)();const pe=J.withPage(de+1),{galleryExtensions:ke}=await this.queryGallery(pe,h,ge);return await this.converToGalleryExtensions(ke.map(Le=>({rawGalleryExtension:Le,preRelease:!!z.includePreRelease})),h,ue,te)};return{firstPage:me,total:le,pageSize:J.pageSize,getPage:Ee}}async converToGalleryExtensions(z,te,ne,oe){const J=(ue,me,Ee,de)=>{const ge=Z(ue);let pe=ue.versions[0];return pe=ue.versions.find(ke=>ke.version===pe.version&&(0,w.isTargetPlatformCompatible)(q(ke),ge,te))||pe,$(pe)&&!de&&(pe=ue.versions.find(ke=>ke.version!==pe.version&&!$(ke))||pe),A(ue,pe,ge,Ee,ne(me))},ce=[],le=new Map;for(let ue=0;ue<z.length;ue++){const{rawGalleryExtension:me,version:Ee,preRelease:de}=z[ue],ge=me.versions.some(pe=>!$(pe));if(Ee){const pe=me.versions.find(ke=>ke.version===Ee);pe&&ce.push([ue,A(me,pe,Z(me),ge)])}else{const pe=J(me,ue,ge,de);pe.properties.isPreReleaseVersion?le.set(pe.identifier.uuid,{index:ue,preRelease:de}):ce.push([ue,pe])}}if(le.size){const ue=new Date().getTime(),me=new R().withFlags(n.IncludeVersions,n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,le.size).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExtensionId,...le.keys()),{galleryExtensions:Ee}=await this.queryGallery(me,te,oe);if(this.telemetryService.publicLog2("galleryService:preReleasesQuery",{duration:new Date().getTime()-ue,count:le.size}),Ee.length!==le.size)throw new Error("Not all extensions with latest versions are returned");for(const de of Ee){const ge=de.versions.some(We=>!$(We)),{index:pe,preRelease:ke}=le.get(de.extensionId),Le=J(de,pe,ge,ke);ce.push([pe,Le])}}return ce.sort((ue,me)=>ue[0]-me[0]).map(([,ue])=>ue)}async queryGallery(z,te,ne){if(!this.isEnabled())throw new Error("No extension gallery service configured.");z=z.withFlags(z.flags,n.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,i(n.Unpublished));const oe=await this.commonHeadersPromise,J=JSON.stringify(z.raw),ce={...oe,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(J.length)},le=new Date().getTime();let ue,me,Ee=0;try{if(ue=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:J,headers:ce},ne),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:Ee};const de=await(0,P.asJson)(ue);if(de){const ge=de.results[0],pe=ge.extensions;pe.forEach(Le=>U(Le.versions,te));const ke=ge.resultMetadata&&ge.resultMetadata.filter(Le=>Le.metadataType==="ResultCount")[0];return Ee=ke&&ke.metadataItems.filter(Le=>Le.name==="TotalCount")[0].count||0,{galleryExtensions:pe,total:Ee}}return{galleryExtensions:[],total:Ee}}catch(de){throw me=de,de}finally{this.telemetryService.publicLog2("galleryService:query",{...z.telemetryData,requestBodySize:String(J.length),duration:new Date().getTime()-le,success:!!ue&&(0,P.isSuccess)(ue),responseBodySize:ue?.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:me?(0,D.isPromiseCanceledError)(me)?"canceled":(0,D.getErrorMessage)(me).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Ee)})}}async reportStatistic(z,te,ne,oe){if(!this.isEnabled())return;const J=k.isWeb?this.api(`/itemName/${z}.${te}/version/${ne}/statType/${oe==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${z}/extensions/${te}/${ne}/stats?statType=${oe}`),ce=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.commonHeadersPromise,Accept:ce};try{await this.requestService.request({type:"POST",url:J,headers:ue},r.CancellationToken.None)}catch{}}async download(z,te,ne){this.logService.trace("ExtensionGalleryService#download",z.identifier.id);const oe=(0,v.getGalleryExtensionTelemetryData)(z),J=new Date().getTime(),ce=Ee=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...oe,duration:Ee}),le=ne===2?"install":ne===3?"update":"",ue=le?{uri:`${z.assets.download.uri}${g.URI.parse(z.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${z.assets.download.fallbackUri}${g.URI.parse(z.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:z.assets.download,me=await this.getAsset(ue);await this.fileService.writeFile(te,me.stream),ce(new Date().getTime()-J)}async getReadme(z,te){if(z.assets.readme){const ne=await this.getAsset(z.assets.readme,{},te);return await(0,P.asText)(ne)||""}return""}async getManifest(z,te){if(z.assets.manifest){const ne=await this.getAsset(z.assets.manifest,{},te),oe=await(0,P.asText)(ne);return oe?JSON.parse(oe):null}return null}async getManifestFromRawExtensionVersion(z,te){const ne=G(z,u.Manifest);if(!ne)throw new Error("Manifest was not found");const oe={"Accept-Encoding":"gzip"},J=await this.getAsset(ne,{headers:oe});return await(0,P.asJson)(J)}async getCoreTranslation(z,te){const ne=z.assets.coreTranslations.filter(oe=>oe[0]===te.toUpperCase())[0];if(ne){const oe=await this.getAsset(ne[1]),J=await(0,P.asText)(oe);return J?JSON.parse(J):null}return null}async getChangelog(z,te){if(z.assets.changelog){const ne=await this.getAsset(z.assets.changelog,{},te);return await(0,P.asText)(ne)||""}return""}async getAllCompatibleVersions(z,te,ne){let oe=new R().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");z.identifier.uuid?oe=oe.withFilter(s.ExtensionId,z.identifier.uuid):oe=oe.withFilter(s.ExtensionName,z.identifier.id);const{galleryExtensions:J}=await this.queryGallery(oe,ne,r.CancellationToken.None);if(!J.length)return[];const ce=Z(J[0]);if((0,w.isNotWebExtensionInWebTargetPlatform)(ce,ne))return[];const le=[];for(const ue of J[0].versions)try{le[le.length-1]?.version!==ue.version&&await this.isRawExtensionVersionCompatible(ue,te,ce,ne)&&le.push({version:ue.version,date:ue.lastUpdated,isPreReleaseVersion:$(ue)})}catch{}return le}async getAsset(z,te={},ne=r.CancellationToken.None){const oe=await this.commonHeadersPromise,J={type:"GET"},ce={...oe,...te.headers||{}};te={...te,...J,headers:ce};const le=z.uri,ue=z.fallbackUri,me={...te,url:le};try{const Ee=await this.requestService.request(me,ne);if(Ee.res.statusCode===200)return Ee;const de=await(0,P.asText)(Ee);throw new Error(`Expected 200, got back ${Ee.res.statusCode} instead.

${de}`)}catch(Ee){if((0,D.isPromiseCanceledError)(Ee))throw Ee;const de=(0,D.getErrorMessage)(Ee);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:le,message:de});const ge={...te,url:ue};return this.requestService.request(ge,ne)}}async getEngine(z){let te=B(z);if(!te){const ne=await this.getManifestFromRawExtensionVersion(z,r.CancellationToken.None);if(!ne)throw new Error("Manifest was not found");te=ne.engines.vscode}return te}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const z=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},r.CancellationToken.None);if(z.res.statusCode!==200)throw new Error("Could not get extensions report.");const te=await(0,P.asJson)(z),ne=[],oe={};if(te){for(const J of te.malicious)ne.push({id:J});if(te.unsupported)for(const J of Object.keys(te.unsupported)){const ce=te.unsupported[J];(0,d.isBoolean)(ce)||(oe[J.toLowerCase()]=ce.preReleaseExtension)}}return{malicious:ne,unsupportedPreReleaseExtensions:oe}}};W=fe([ie(1,P.IRequestService),ie(2,y.ILogService),ie(3,E.IEnvironmentService),ie(4,l.ITelemetryService),ie(5,f.IFileService),ie(6,b.IProductService),ie(7,S.IConfigurationService)],W);let F=class extends W{constructor(z,te,ne,oe,J,ce,le,ue){super(z,te,ne,oe,J,ce,le,ue)}};F=fe([ie(0,a.IStorageService),ie(1,P.IRequestService),ie(2,y.ILogService),ie(3,E.IEnvironmentService),ie(4,l.ITelemetryService),ie(5,f.IFileService),ie(6,b.IProductService),ie(7,S.IConfigurationService)],F),e.ExtensionGalleryService=F;let N=class extends W{constructor(z,te,ne,oe,J,ce,le){super(void 0,z,te,ne,oe,J,ce,le)}};N=fe([ie(0,P.IRequestService),ie(1,y.ILogService),ie(2,E.IEnvironmentService),ie(3,l.ITelemetryService),ie(4,f.IFileService),ie(5,b.IProductService),ie(6,S.IConfigurationService)],N),e.ExtensionGalleryServiceWithNoStorageService=N;async function H(O,z,te,ne,oe,J){const ce={"X-Market-Client-Id":`VSCode ${O}`,"User-Agent":`VSCode ${O} (${z.nameShort})`},le=await(0,c.getServiceMachineId)(te,oe,J);return(0,o.supportsTelemetry)(z,te)&&(0,o.getTelemetryLevel)(ne)===3&&(ce["X-Market-User-Id"]=le),ce}e.resolveMarketplaceHeaders=H}),define(x[206],ee([0,1,2,47,3,25,152,19,57,55,40,29,65]),function(j,e,p,r,D,C,k,I,d,g,S,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let v=class{constructor(y,b){this._configurationService=b,this._experimentProperties={},this._disposables=new p.DisposableStore,this._cleanupPatterns=[],this._appenders=y.appenders,this._commonProperties=y.commonProperties||Promise.resolve({}),this._piiPaths=y.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!y.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let P of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,C.escapeRegExpCharacters)(P),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(P=>{const c=/^[a-f0-9]+$/i.test(P["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!c})})}setExperimentProperty(y,b){this._experimentProperties[y]=b}_updateTelemetryLevel(){this._telemetryLevel=(0,w.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const y=await this._commonProperties;let b=y.sessionID,P=y["common.machineId"],c=y["common.firstSessionDate"],a=y["common.msftInternal"];return{sessionId:b,machineId:P,firstSessionDate:c,msftInternal:a}}dispose(){this._disposables.dispose()}_log(y,b,P,c){return this.telemetryLevel<b?Promise.resolve(void 0):this._commonProperties.then(a=>{P=(0,r.mixin)(P,a),P=(0,r.mixin)(P,this._experimentProperties),P=(0,r.cloneAndChange)(P,l=>{if(typeof l=="string")return this._cleanupInfo(l,c)}),this._appenders.forEach(l=>l.log(y,P))},a=>{console.error(a)})}publicLog(y,b,P){return this._log(y,3,b,P)}publicLog2(y,b,P){return this.publicLog(y,b,P)}publicLogError(y,b){return this.sendErrorTelemetry?this._log(y,2,b,!0):Promise.resolve(void 0)}publicLogError2(y,b){return this.publicLogError(y,b)}_anonymizeFilePaths(y){let b=y;const P=[];for(let o of this._cleanupPatterns)for(;;){const h=o.exec(y);if(!h)break;P.push([h.index,o.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,a=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(b="";;){const o=a.exec(y);if(!o)break;!c.test(o[0])&&P.every(([h,n])=>o.index<h||o.index>=n)&&(b+=y.substring(l,o.index)+"<REDACTED: user-file-path>",l=a.lastIndex)}return l<y.length&&(b+=y.substr(l)),b}_removePropertiesWithPossibleUserInfo(y){if(!y)return y;const b=y.toLowerCase(),P=/@[a-zA-Z0-9-.]+/;return/(key|token|sig|signature|password|passwd|pwd)[="':\s]/.test(b)?"<REDACTED: secret>":P.test(b)?"<REDACTED: email>":y}_cleanupInfo(y,b){let P=y;b&&(P=this._anonymizeFilePaths(P));for(let c of this._cleanupPatterns)P=P.replace(c,"");return P=this._removePropertiesWithPossibleUserInfo(P),P}};v.IDLE_START_EVENT_NAME="UserIdleStart",v.IDLE_STOP_EVENT_NAME="UserIdleStop",v=fe([ie(1,I.IConfigurationService)],v),e.TelemetryService=v;function t(){const f=(0,k.localize)(0,null,g.default.nameLong),y=g.default.privacyStatementUrl?(0,k.localize)(2,null,"https://aka.ms/vscode-telemetry",g.default.privacyStatementUrl):(0,k.localize)(1,null,"https://aka.ms/vscode-telemetry"),b=D.isWeb?"":(0,k.localize)(3,null),P=(0,k.localize)(4,null),c=(0,k.localize)(5,null),a=(0,k.localize)(6,null),l=(0,k.localize)(7,null),o=`
|       | ${P} | ${c} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,h=(0,k.localize)(8,null);return`
${f} ${y} ${b}

&nbsp;

${l}
${o}

&nbsp;

${h}
`}S.Registry.as(d.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(9,null),properties:{[E.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,k.localize)(10,null),(0,k.localize)(11,null),(0,k.localize)(12,null),(0,k.localize)(13,null)],markdownDescription:t(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.Registry.as(d.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(14,null),properties:{[E.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:g.default.privacyStatementUrl?(0,k.localize)(16,null,g.default.nameLong,g.default.privacyStatementUrl):(0,k.localize)(15,null,g.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,k.localize)(17,null,`\`#${E.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(x[207],ee([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var p;(function(r){r.DARK="dark",r.LIGHT="light",r.HIGH_CONTRAST="hc"})(p=e.ColorScheme||(e.ColorScheme={}))}),define(x[208],ee([0,1,103,4,2,5,40,207]),function(j,e,p,r,D,C,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var d;(function(y){function b(P){return P&&typeof P=="object"&&typeof P.id=="string"}y.isThemeColor=b})(d=e.ThemeColor||(e.ThemeColor={}));function g(y){return{id:y}}e.themeColorFromId=g;var S;(function(y){function b(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||d.isThemeColor(i.color))}y.isThemeIcon=b;const P=new RegExp(`^\\$\\((${p.CSSIcon.iconNameExpression}(?:${p.CSSIcon.iconModifierExpression})?)\\)$`);function c(i){const s=P.exec(i);if(!s)return;let[,u]=s;return{id:u}}y.fromString=c;function a(i){return{id:i}}y.fromId=a;function l(i,s){let u=i.id;const m=u.lastIndexOf("~");return m!==-1&&(u=u.substring(0,m)),s&&(u=`${u}~${s}`),{id:u}}y.modify=l;function o(i){const s=i.id.lastIndexOf("~");if(s!==-1)return i.id.substring(s+1)}y.getModifier=o;function h(i,s){return i.id===s.id&&i.color?.id===s.color?.id}y.isEqual=h;function n(i,s){return{id:i.id,color:s?g(s):void 0}}y.asThemeIcon=n,y.asClassNameArray=p.CSSIcon.asClassNameArray,y.asClassName=p.CSSIcon.asClassName,y.asCSSSelector=p.CSSIcon.asCSSSelector})(S=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=p.Codicon.file,e.FolderThemeIcon=p.Codicon.folder;function E(y){switch(y){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class w{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new r.Emitter}onColorThemeChange(b){return this.themingParticipants.push(b),this.onThemingParticipantAddedEmitter.fire(b),(0,D.toDisposable)(()=>{const P=this.themingParticipants.indexOf(b);this.themingParticipants.splice(P,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let v=new w;k.Registry.add(e.Extensions.ThemingContribution,v);function t(y){return v.onColorThemeChange(y)}e.registerThemingParticipant=t;class f extends D.Disposable{constructor(b){super();this.themeService=b,this.theme=b.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(P=>this.onThemeChange(P)))}onThemeChange(b){this.theme=b,this.updateStyles()}updateStyles(){}getColor(b,P){let c=this.theme.getColor(b);return c&&P&&(c=P(c,this.theme)),c?c.toString():null}}e.Themable=f}),define(x[66],ee([0,1,14,3,5,38]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const k="#FFFFFF",I="#1E1E1E",d="#000000",g="theme",S="themeBackground",E="windowSplash";e.IThemeMainService=(0,D.createDecorator)("themeMainService");let w=class{constructor(t){this.stateMainService=t}getBackgroundColor(){if((r.isWindows||r.isMacintosh)&&p.nativeTheme.shouldUseInvertedColorScheme)return d;let t=this.stateMainService.getItem(S,null);if(!t){let f;(r.isWindows||r.isMacintosh)&&p.nativeTheme.shouldUseInvertedColorScheme?f="hc-black":f=this.stateMainService.getItem(g,"vs-dark").split(" ")[0],t=f==="hc-black"?d:f==="vs"?k:I}return r.isMacintosh&&t.toUpperCase()===I&&(t="#171717"),t}saveWindowSplash(t,f){this.stateMainService.setItems([{key:g,data:f.baseTheme},{key:S,data:f.colorInfo.background},{key:E,data:f}]),typeof t=="number"&&this.updateBackgroundColor(t,f)}updateBackgroundColor(t,f){for(const y of p.BrowserWindow.getAllWindows())if(y.id===t){y.setBackgroundColor(f.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(E)}};w=fe([ie(0,C.IStateMainService)],w),e.ThemeMainService=w}),define(x[41],ee([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var r;(function(C){C.Uninitialized="uninitialized",C.Idle="idle",C.CheckingForUpdates="checking for updates",C.AvailableForDownload="available for download",C.Downloading="downloading",C.Downloaded="downloaded",C.Updating="updating",C.Ready="ready"})(r=e.StateType||(e.StateType={}));var D;(function(C){C[C.Setup=0]="Setup",C[C.Archive=1]="Archive",C[C.Snap=2]="Snap"})(D=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(C,k)=>({type:"idle",updateType:C,error:k}),CheckingForUpdates:C=>({type:"checking for updates",explicit:C}),AvailableForDownload:C=>({type:"available for download",update:C}),Downloading:C=>({type:"downloading",update:C}),Downloaded:C=>({type:"downloaded",update:C}),Updating:C=>({type:"updating",update:C}),Ready:C=>({type:"ready",update:C})},e.IUpdateService=(0,p.createDecorator)("updateService")}),define(x[209],ee([0,1,3,153,57,40]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),C.Registry.as(D.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,r.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,r.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,r.localize)(2,null),(0,r.localize)(3,null),(0,r.localize)(4,null),(0,r.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,r.localize)(6,null),deprecationMessage:(0,r.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,r.localize)(8,null),description:(0,r.localize)(9,null),included:p.isWindows&&!p.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,r.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(x[210],ee([0,1,4,41]),function(j,e,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class D{constructor(I){this.service=I}listen(I,d){switch(d){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${d}`)}call(I,d,g){switch(d){case"checkForUpdates":return this.service.checkForUpdates(g);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${d}`)}}e.UpdateChannel=D;class C{constructor(I){this.channel=I,this._onStateChange=new p.Emitter,this.onStateChange=this._onStateChange.event,this._state=r.State.Uninitialized,this.channel.listen("onStateChange")(d=>this.state=d),this.channel.call("_getInitialState").then(d=>this.state=d)}get state(){return this._state}set state(I){this._state=I,this._onStateChange.fire(I)}checkForUpdates(I){return this.channel.call("checkForUpdates",I)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=C}),define(x[97],ee([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,p.createDecorator)("urlService")}),define(x[211],ee([0,1,7]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class r{constructor(I){this.handler=I}listen(I,d){throw new Error(`Event not found: ${d}`)}call(I,d,g){switch(d){case"handleURL":return this.handler.handleURL(p.URI.revive(g[0]),g[1])}throw new Error(`Call not found: ${d}`)}}e.URLHandlerChannel=r;class D{constructor(I){this.channel=I}handleURL(I,d){return this.channel.call("handleURL",[I.toJSON(),d])}}e.URLHandlerChannelClient=D;class C{constructor(I){this.next=I}async routeCall(I,d,g,S){if(d!=="handleURL")throw new Error(`Call not found: ${d}`);if(g){const E=p.URI.revive(g);if(E&&E.query){const w=/\bwindowId=(\d+)/.exec(E.query);if(w){const v=w[1],t=new RegExp(`window:${v}`),f=I.connections.find(y=>t.test(y.ctx));if(f)return f}}}return this.next.routeCall(I,d,g,S)}routeEvent(I,d){throw new Error(`Event not found: ${d}`)}}e.URLHandlerRouter=C}),define(x[212],ee([0,1,9,2,7,22]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class k extends r.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(g,S){const E=[...this.handlers.values()];return(0,p.first)(E.map(w=>()=>w.handleURL(g,S)),void 0,!1).then(w=>w||!1)}registerHandler(g){return this.handlers.add(g),(0,r.toDisposable)(()=>this.handlers.delete(g))}}e.AbstractURLService=k;let I=class extends k{constructor(g){super();this.productService=g}create(g){let{authority:S,path:E,query:w,fragment:v}=g||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return S&&E&&E.indexOf("/")!==0&&(E=`/${E}`),D.URI.from({scheme:this.productService.urlProtocol,authority:S,path:E,query:w,fragment:v})}};I=fe([ie(0,C.IProductService)],I),e.NativeURLService=I}),define(x[213],ee([0,1,14,9,4,2,3,7]),function(j,e,p,r,D,C,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function d(S){try{return I.URI.parse(S)}catch{return null}}class g{constructor(E,w,v,t,f){if(this.urlService=w,this.uris=[],this.retryCount=0,this.flushDisposable=C.Disposable.None,this.disposables=new C.DisposableStore,this.uris=E,k.isWindows){const P=t.isBuilt?[]:[`"${t.appRoot}"`];P.push("--open-url","--"),p.app.setAsDefaultProtocolClient(f.urlProtocol,process.execPath,P)}const y=D.Event.map(D.Event.fromNodeEventEmitter(p.app,"open-url",(P,c)=>({event:P,url:c})),({event:P,url:c})=>(P.preventDefault(),c));this.disposables.add(y(P=>{const c=d(P);!c||this.urlService.open(c,{originalUrl:P})})),v.getWindows().filter(P=>P.isReady).length>0?this.flush():D.Event.once(v.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const E=[];for(const w of this.uris)await this.urlService.open(w.uri,{originalUrl:w.url})||E.push(w);E.length!==0&&(this.uris=E,this.flushDisposable=(0,r.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=g}),define(x[214],ee([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,p.createDecorator)("webviewManagerService")}),define(x[215],ee([0,1,14,2,10,7]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class k extends r.Disposable{constructor(){super();const d=this.handleWebviewRequest.bind(this);p.protocol.registerFileProtocol(D.Schemas.vscodeWebview,d)}handleWebviewRequest(d,g){try{const S=C.URI.parse(d.url),E=k.validWebviewFilePaths.get(S.path);if(typeof E=="string"){const w=`vs/workbench/contrib/webview/browser/pre/${E}`,v=D.FileAccess.asFileUri(w,j);return g(decodeURIComponent(v.fsPath))}else return g({error:-10})}catch{}return g({error:-2})}}e.WebviewProtocolProvider=k,k.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(x[67],ee([0,1,3]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function r(g){return!!g.workspaceUri}e.isWorkspaceToOpen=r;function D(g){return!!g.folderUri}e.isFolderToOpen=D;function C(g){return!!g.fileUri}e.isFileToOpen=C;function k(g){const S=I(g),E=g.getValue("window.menuBarVisibility");return E==="default"||S==="native"&&E==="compact"||p.isMacintosh&&p.isNative?"classic":E}e.getMenuBarVisibility=k;function I(g){if(p.isWeb)return"custom";const S=g.getValue("window");if(S){if(p.isMacintosh&&S.nativeTabs===!0||p.isMacintosh&&S.nativeFullScreen===!1)return"native";const v=g.getValue("workbench.colorCustomizations");if(v?.["window.activeBorder"]||v?.["window.inactiveBorder"])return"custom";const t=S.titleBarStyle;if(t==="native"||t==="custom")return t}return p.isLinux?"native":"custom"}e.getTitleBarStyle=I;function d(g=0){return Math.pow(1.2,g)}e.zoomLevelToZoomFactor=d}),define(x[35],ee([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var r;(function(g){g[g.INITIAL=1]="INITIAL",g[g.LOAD=2]="LOAD",g[g.RELOAD=3]="RELOAD"})(r=e.LoadReason||(e.LoadReason={}));var D;(function(g){g[g.CLOSE=1]="CLOSE",g[g.QUIT=2]="QUIT",g[g.RELOAD=3]="RELOAD",g[g.LOAD=4]="LOAD"})(D=e.UnloadReason||(e.UnloadReason={}));var C;(function(g){g[g.CLI=0]="CLI",g[g.DOCK=1]="DOCK",g[g.MENU=2]="MENU",g[g.DIALOG=3]="DIALOG",g[g.DESKTOP=4]="DESKTOP",g[g.API=5]="API"})(C=e.OpenContext||(e.OpenContext={}));const k=function(g=1){return{width:1024,height:768,mode:g}};e.defaultWindowState=k;var I;(function(g){g[g.Maximized=0]="Maximized",g[g.Normal=1]="Normal",g[g.Minimized=2]="Minimized",g[g.Fullscreen=3]="Fullscreen"})(I=e.WindowMode||(e.WindowMode={}));var d;(function(g){g[g.UNRESPONSIVE=1]="UNRESPONSIVE",g[g.CRASHED=2]="CRASHED",g[g.LOAD=3]="LOAD"})(d=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,p.createDecorator)("windowsMainService")}),define(x[216],ee([0,1,14,4,2,215,35]),function(j,e,p,r,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let I=class extends D.Disposable{constructor(g){super();this.windowsMainService=g,this._onFoundInFrame=this._register(new r.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new C.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(g,S){let E;if(typeof g.windowId=="number"){const{windowId:w}=g,v=this.windowsMainService.getWindowById(w);if(!v?.win)throw new Error(`Invalid windowId: ${w}`);E=v.win.webContents}else{const{webContentsId:w}=g;if(E=p.webContents.fromId(w),!E)throw new Error(`Invalid webContentsId: ${w}`)}E.isDestroyed()||E.setIgnoreMenuShortcuts(S)}async findInFrame(g,S,E,w){const v=this.getFrameByName(g,S),t=v;if(typeof t.findInFrame=="function"){t.findInFrame(E,{findNext:w.findNext,forward:w.forward});const f=(y,b)=>{b.finalUpdate&&(this._onFoundInFrame.fire(b),v.removeListener("found-in-frame",f))};v.on("found-in-frame",f)}}async stopFindInFrame(g,S,E){const v=this.getFrameByName(g,S);typeof v.stopFindInFrame=="function"&&v.stopFindInFrame(E.keepSelection?"keepSelection":"clearSelection")}getFrameByName(g,S){const E=this.windowsMainService.getWindowById(g.windowId);if(!E?.win)throw new Error(`Invalid windowId: ${g}`);const w=E.win.webContents.mainFrame.framesInSubtree.find(v=>v.name===S);if(!w)throw new Error(`Unknown frame: ${S}`);return w}};I=fe([ie(0,k.IWindowsMainService)],I),e.WebviewMainService=I}),define(x[217],ee([0,1,9,4,2]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class C extends D.Disposable{constructor({onDidOpenWindow:I,onDidFocusWindow:d,getActiveWindowId:g}){super();this.disposables=this._register(new D.DisposableStore),r.Event.latch(r.Event.any(I,d))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,p.createCancelablePromise)(()=>g()),(async()=>{try{const E=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:E}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(I){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=I}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=C}),define(x[218],ee([0,1,36,16,7,5]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var k;(function(w){w[w.EMPTY=1]="EMPTY",w[w.FOLDER=2]="FOLDER",w[w.WORKSPACE=3]="WORKSPACE"})(k=e.WorkbenchState||(e.WorkbenchState={}));function I(w){const v=w;return!!(v&&typeof v=="object"&&typeof v.id=="string"&&Array.isArray(v.folders))}e.isWorkspace=I;function d(w){const v=w;return!!(v&&typeof v=="object"&&D.URI.isUri(v.uri)&&typeof v.name=="string"&&typeof v.toResource=="function")}e.isWorkspaceFolder=d;class g{constructor(v,t,f,y,b){this._id=v,this._transient=f,this._configuration=y,this._ignorePathCasing=b,this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=t}update(v){this._id=v.id,this._configuration=v.configuration,this._transient=v.transient,this._ignorePathCasing=v._ignorePathCasing,this.folders=v.folders}get folders(){return this._folders}set folders(v){this._folders=v,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(v){this._configuration=v}getFolder(v){return v&&this._foldersMap.findSubstr(v.with({scheme:v.scheme,authority:v.authority,path:v.path}))||null}updateFoldersMap(){this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing);for(const v of this.folders)this._foldersMap.set(v.uri,v)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=g;class S{constructor(v,t){this.raw=t,this.uri=v.uri,this.index=v.index,this.name=v.name}toResource(v){return(0,r.joinPath)(this.uri,v)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=S;function E(w){return new S({uri:w,index:0,name:(0,r.basenameOrAuthority)(w)},{uri:w.toString()})}e.toWorkspaceFolder=E}),define(x[30],ee([0,1,32,43,105,33,10,8,3,16,7,156,5,64,218]),function(j,e,p,r,D,C,k,I,d,g,S,E,w,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isWorkspaceBackupInfo=e.isFolderBackupInfo=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const f=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,E.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function y($){return(typeof $=="string"?(0,I.extname)($):(0,g.extname)($))===f}e.hasWorkspaceFileExtension=y,e.IWorkspacesService=(0,w.createDecorator)("workspacesService");function b($){return $.hasOwnProperty("workspace")}e.isRecentWorkspace=b;function P($){return $.hasOwnProperty("folderUri")}e.isRecentFolder=P;function c($){return $.hasOwnProperty("fileUri")}e.isRecentFile=c;function a($){return $&&$.hasOwnProperty("folderUri")}e.isFolderBackupInfo=a;function l($){return $&&$.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=l;function o($){const Y=$;return typeof Y?.id=="string"&&S.URI.isUri(Y.uri)}e.isSingleFolderWorkspaceIdentifier=o;function h($){if($.configuration)return{id:$.id,configPath:$.configuration};if($.folders.length===1)return{id:$.id,uri:$.folders[0].uri}}e.toWorkspaceIdentifier=h;function n($){const Y=$;return typeof Y?.id=="string"&&S.URI.isUri(Y.configPath)}e.isWorkspaceIdentifier=n;function i($){const Y=$;if(Y?.uri)return{id:Y.id,uri:S.URI.revive(Y.uri)};const V=$;if(V?.configPath)return{id:V.id,configPath:S.URI.revive(V.configPath)};if($?.id)return{id:$.id}}e.reviveIdentifier=i;function s($,Y){return g.extUriBiasedIgnorePathCase.isEqualOrParent($,Y.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function u($){return m($)||M($)}e.isStoredWorkspaceFolder=u;function m($){const Y=$;return typeof Y?.path=="string"&&(!Y.name||typeof Y.name=="string")}e.isRawFileWorkspaceFolder=m;function M($){const Y=$;return typeof Y?.uri=="string"&&(!Y.name||typeof Y.name=="string")}e.isRawUriWorkspaceFolder=M;function L($,Y,V,q,Z=!d.isWindows,U){if($.scheme!==q.scheme)return{name:V,uri:$.toString(!0)};let A=Y?void 0:U.relativePath(q,$);if(A!==void 0)A.length===0?A=".":d.isWindows&&$.scheme===k.Schemas.file&&!Z&&(A=A.replace(/\//g,"\\"));else if($.scheme===k.Schemas.file)A=$.fsPath,d.isWindows&&(A=(0,C.normalizeDriveLetter)(A),Z&&(A=(0,p.toSlashes)(A)));else{if(!U.isEqualAuthority($.authority,q.authority))return{name:V,uri:$.toString(!0)};A=$.path}return{name:V,path:A}}e.getStoredWorkspaceFolder=L;function R($,Y,V){let q=[],Z=new Set;const U=V.dirname(Y);for(let A of $){let W;if(m(A))A.path&&(W=V.resolvePath(U,A.path));else if(M(A))try{W=S.URI.parse(A.uri),W.path[0]!=="/"&&(W=W.with({path:"/"+W.path}))}catch(F){console.warn(F)}if(W){let F=V.getComparisonKey(W);if(!Z.has(F)){Z.add(F);const N=A.name||V.basenameOrAuthority(W);q.push(new t.WorkspaceFolder({uri:W,name:N,index:q.length},A))}}}return q}e.toWorkspaceFolders=R;function T($,Y,V,q,Z){let U=_(Y,$);const A=Z.dirname(Y),W=Z.dirname(q),F=[],N=Q(U.folders);for(const te of U.folders){const ne=m(te)?Z.resolvePath(A,te.path):S.URI.parse(te.uri);let oe;V?oe=!1:oe=!m(te)||(0,I.isAbsolute)(te.path),F.push(L(ne,oe,te.name,W,N,Z))}const H={insertSpaces:!1,tabSize:4,eol:d.isLinux||d.isMacintosh?`
`:`\r
`},O=D.setProperty($,["folders"],F,H);let z=D.applyEdits($,O);return(0,g.isEqualAuthority)(U.remoteAuthority,(0,v.getRemoteAuthority)(q))&&(z=D.applyEdits(z,D.removeProperty(z,["remoteAuthority"],H))),z}e.rewriteWorkspaceFileForNewLocation=T;function _($,Y){let V=r.parse(Y);if(V&&Array.isArray(V.folders))V.folders=V.folders.filter(q=>u(q));else throw new Error(`${$} looks like an invalid workspace file.`);return V}function Q($){return d.isWindows?$.some(Y=>m(Y)&&Y.path.indexOf("/")>=0):!0}e.useSlashForPath=Q;function se($){return $.workspace&&typeof $.workspace=="object"&&typeof $.workspace.id=="string"&&typeof $.workspace.configPath=="string"}function re($){return typeof $.folderUri=="string"}function G($){return typeof $.fileUri=="string"}function X($,Y){const V={workspaces:[],files:[]};if($){const q=function(U,A){for(let W=0;W<U.length;W++)try{A(U[W],W)}catch(F){Y.warn(`Error restoring recent entry ${JSON.stringify(U[W])}: ${F.toString()}. Skip entry.`)}},Z=$;if(Array.isArray(Z.entries))q(Z.entries,U=>{const A=U.label,W=U.remoteAuthority;se(U)?V.workspaces.push({label:A,remoteAuthority:W,workspace:{id:U.workspace.id,configPath:S.URI.parse(U.workspace.configPath)}}):re(U)?V.workspaces.push({label:A,remoteAuthority:W,folderUri:S.URI.parse(U.folderUri)}):G(U)&&V.files.push({label:A,remoteAuthority:W,fileUri:S.URI.parse(U.fileUri)})});else{const U=$;Array.isArray(U.workspaces3)&&q(U.workspaces3,(A,W)=>{const F=Array.isArray(U.workspaceLabels)&&U.workspaceLabels[W]||void 0;typeof A=="object"&&typeof A.id=="string"&&typeof A.configURIPath=="string"?V.workspaces.push({label:F,workspace:{id:A.id,configPath:S.URI.parse(A.configURIPath)}}):typeof A=="string"&&V.workspaces.push({label:F,folderUri:S.URI.parse(A)})}),Array.isArray(U.files2)&&q(U.files2,(A,W)=>{const F=Array.isArray(U.fileLabels)&&U.fileLabels[W]||void 0;typeof A=="string"&&V.files.push({label:F,fileUri:S.URI.parse(A)})})}}return V}e.restoreRecentlyOpened=X;function B($){const Y={entries:[]};for(const V of $.workspaces)P(V)?Y.entries.push({folderUri:V.folderUri.toString(),label:V.label,remoteAuthority:V.remoteAuthority}):Y.entries.push({workspace:{id:V.workspace.id,configPath:V.workspace.configPath.toString()},label:V.label,remoteAuthority:V.remoteAuthority});for(const V of $.files)Y.entries.push({fileUri:V.fileUri.toString(),label:V.label,remoteAuthority:V.remoteAuthority});return Y}e.toStoreData=B}),define(x[49],ee([0,1,14,9,80,33,2,70,8,3,13,21,136,5,6,38,30]),function(j,e,p,r,D,C,k,I,d,g,S,E,w,v,t,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,v.createDecorator)("dialogMainService");let b=class vt{constructor(c,a){this.stateMainService=c,this.logService=a,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new r.Queue}pickFileFolder(c,a){return this.doPick({...c,pickFolders:!0,pickFiles:!0,title:(0,w.localize)(0,null)},a)}pickFolder(c,a){return this.doPick({...c,pickFolders:!0,title:(0,w.localize)(1,null)},a)}pickFile(c,a){return this.doPick({...c,pickFiles:!0,title:(0,w.localize)(2,null)},a)}pickWorkspace(c,a){const l=(0,w.localize)(3,null),o=(0,C.mnemonicButtonLabel)((0,w.localize)(4,null)),h=y.WORKSPACE_FILTER;return this.doPick({...c,pickFiles:!0,title:l,filters:h,buttonLabel:o},a)}async doPick(c,a){const l={title:c.title,buttonLabel:c.buttonLabel,filters:c.filters};l.defaultPath=c.defaultPath||this.stateMainService.getItem(vt.workingDirPickerStorageKey),(typeof c.pickFiles=="boolean"||typeof c.pickFolders=="boolean")&&(l.properties=void 0,c.pickFiles&&c.pickFolders&&(l.properties=["multiSelections","openDirectory","openFile","createDirectory"])),l.properties||(l.properties=["multiSelections",c.pickFolders?"openDirectory":"openFile","createDirectory"]),g.isMacintosh&&l.properties.push("treatPackageAsDirectory");const o=a||p.BrowserWindow.getFocusedWindow(),h=await this.showOpenDialog(l,(0,S.withNullAsUndefined)(o));if(h&&h.filePaths&&h.filePaths.length>0)return this.stateMainService.setItem(vt.workingDirPickerStorageKey,(0,d.dirname)(h.filePaths[0])),h.filePaths}getWindowDialogQueue(c){if(c){let a=this.windowDialogQueues.get(c.id);return a||(a=new r.Queue,this.windowDialogQueues.set(c.id,a)),a}else return this.noWindowDialogueQueue}showMessageBox(c,a){return this.getWindowDialogQueue(a).queue(async()=>a?p.dialog.showMessageBox(a,c):p.dialog.showMessageBox(c))}async showSaveDialog(c,a){const l=this.acquireFileDialogLock(c,a);if(!l)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(a).queue(async()=>{let o;return a?o=await p.dialog.showSaveDialog(a,c):o=await p.dialog.showSaveDialog(c),o.filePath=this.normalizePath(o.filePath),o})}finally{(0,k.dispose)(l)}}normalizePath(c){return c&&g.isMacintosh&&(c=(0,I.normalizeNFC)(c)),c}normalizePaths(c){return c.map(a=>this.normalizePath(a))}async showOpenDialog(c,a){c.defaultPath&&(await E.Promises.exists(c.defaultPath)||(c.defaultPath=void 0));const l=this.acquireFileDialogLock(c,a);if(!l)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(a).queue(async()=>{let o;return a?o=await p.dialog.showOpenDialog(a,c):o=await p.dialog.showOpenDialog(c),o.filePaths=this.normalizePaths(o.filePaths),o})}finally{(0,k.dispose)(l)}}acquireFileDialogLock(c,a){if(!a)return k.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",c);let l=this.windowFileDialogLocks.get(a.id);l||(l=new Set,this.windowFileDialogLocks.set(a.id,l));const o=(0,D.hash)(c);if(!l.has(o))return this.logService.trace("[DialogMainService]: new file dialog lock created",c),l.add(o),(0,k.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",c),l?.delete(o),l?.size===0&&this.windowFileDialogLocks.delete(a.id)})}};b.workingDirPickerStorageKey="pickerWorkingDir",b=fe([ie(0,f.IStateMainService),ie(1,t.ILogService)],b),e.DialogMainService=b}),define(x[219],ee([0,1,4,2,30]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class C extends r.Disposable{constructor(I,d){super();this.logService=I,this.storageMainService=d,this._onDidChangeGlobalStorage=this._register(new p.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(p.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(I,d)=>(I?I.push(d):I=[d],I),C.STORAGE_CHANGE_DEBOUNCE_TIME)(I=>{I.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(I))}))}serializeGlobalStorageEvents(I){const d=new Map,g=new Set;return I.forEach(S=>{const E=this.storageMainService.globalStorage.get(S.key);typeof E=="string"?d.set(S.key,E):g.add(S.key)}),{changed:Array.from(d.entries()),deleted:Array.from(g.values())}}listen(I,d){switch(d){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${d}`)}async call(I,d,g){const S=(0,D.reviveIdentifier)(g.workspace),E=await this.withStorageInitialized(S);switch(d){case"getItems":return Array.from(E.items.entries());case"updateItems":{const w=g;if(w.insert)for(const[v,t]of w.insert)E.set(v,t);w.delete&&w.delete.forEach(v=>E.delete(v));break}case"close":{if(S)return E.close();break}default:throw new Error(`Call not found: ${d}`)}}async withStorageInitialized(I){const d=I?this.storageMainService.workspaceStorage(I):this.storageMainService.globalStorage;try{await d.init()}catch(g){this.logService.error(`StorageIPC#init: Unable to init ${I?"workspace":"global"} storage due to ${g}`)}return d}}e.StorageDatabaseChannel=C,C.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(x[220],ee([0,1,9,4,2,8,21,85,125,6,96,29,30]),function(j,e,p,r,D,C,k,I,d,g,S,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class v extends D.Disposable{constructor(b){super();this.logService=b,this._onDidChangeStorage=this._register(new r.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new r.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new I.Storage(new I.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new p.DeferredPromise,this.whenInit=this.whenInitPromise.p}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const b=await this.doCreate();this.storage.dispose(),this.storage=b,this._register(b.onDidChangeStorage(c=>this._onDidChangeStorage.fire({key:c}))),await this.doInit(b);const P=b.getBoolean(S.IS_NEW_KEY);P===void 0?b.set(S.IS_NEW_KEY,!0):P&&b.set(S.IS_NEW_KEY,!1)}catch(b){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${b}`)}finally{this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===g.LogLevel.Trace?b=>this.logService.trace(b):void 0,logError:b=>this.logService.error(b)}}doInit(b){return b.init()}get items(){return this.storage.items}get(b,P){return this.storage.get(b,P)}set(b,P){return this.storage.set(b,P)}delete(b){return this.storage.delete(b)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class t extends v{constructor(b,P,c){super(P);this.options=b,this.environmentService=c}async doCreate(){let b;return this.options.useInMemoryStorage?b=d.SQLiteStorageDatabase.IN_MEMORY_PATH:b=(0,C.join)(this.environmentService.globalStorageHome.fsPath,t.STORAGE_NAME),new I.Storage(new d.SQLiteStorageDatabase(b,{logging:this.createLoggingOptions()}))}async doInit(b){await super.doInit(b),this.updateTelemetryState(b)}updateTelemetryState(b){b.get(E.firstSessionDateStorageKey,void 0)===void 0&&b.set(E.firstSessionDateStorageKey,new Date().toUTCString());const c=b.get(E.currentSessionDateStorageKey,void 0),a=new Date().toUTCString();b.set(E.lastSessionDateStorageKey,typeof c=="undefined"?null:c),b.set(E.currentSessionDateStorageKey,a)}}e.GlobalStorageMain=t,t.STORAGE_NAME="state.vscdb";class f extends v{constructor(b,P,c,a){super(c);this.workspace=b,this.options=P,this.environmentService=a}async doCreate(){const{storageFilePath:b,wasCreated:P}=await this.prepareWorkspaceStorageFolder();return new I.Storage(new d.SQLiteStorageDatabase(b,{logging:this.createLoggingOptions()}),{hint:P?I.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:d.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const b=(0,C.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),P=(0,C.join)(b,f.WORKSPACE_STORAGE_NAME);return await k.Promises.exists(b)?{storageFilePath:P,wasCreated:!1}:(await k.Promises.mkdir(b,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(b),{storageFilePath:P,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(b){let P;if((0,w.isSingleFolderWorkspaceIdentifier)(this.workspace)?P={folder:this.workspace.uri.toString()}:(0,w.isWorkspaceIdentifier)(this.workspace)&&(P={workspace:this.workspace.configPath.toString()}),P)try{const c=(0,C.join)(b,f.WORKSPACE_META_NAME);await k.Promises.exists(c)||await k.Promises.writeFile(c,JSON.stringify(P,void 0,2))}catch(c){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${c}`)}}}e.WorkspaceStorageMain=f,f.WORKSPACE_STORAGE_NAME="state.vscdb",f.WORKSPACE_META_NAME="workspace.json"}),define(x[98],ee([0,1,42,2,53,5,20,6,220]),function(j,e,p,r,D,C,k,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,C.createDecorator)("storageMainService");let g=class extends r.Disposable{constructor(E,w,v){super();this.logService=E,this.environmentService=w,this.lifecycleMainService=v,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async E=>{E.workspace&&this.workspaceStorage(E.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(E=>{E.join(this.globalStorage.close());for(const[,w]of this.mapWorkspaceToStorage)E.join(w.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const E=new d.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,p.once)(E.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),E}createWorkspaceStorage(E){return new d.WorkspaceStorageMain(E,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(E){let w=this.mapWorkspaceToStorage.get(E.id);return w||(this.logService.trace(`StorageMainService: creating workspace storage (${E.id})`),w=this.createWorkspaceStorage(E),this.mapWorkspaceToStorage.set(E.id,w),(0,p.once)(w.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${E.id})`),this.mapWorkspaceToStorage.delete(E.id)})),w}};g=fe([ie(0,I.ILogService),ie(1,D.IEnvironmentService),ie(2,k.ILifecycleMainService)],g),e.StorageMainService=g}),define(x[99],ee([0,1,16,7,30]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function C(d,g,S){for(const w of d){const v=w.openedWorkspace;if((0,D.isWorkspaceIdentifier)(v)){const t=S(v);if(t){if(t.folders.some(f=>p.extUriBiasedIgnorePathCase.isEqualOrParent(g,f.uri)))return w}else if(p.extUriBiasedIgnorePathCase.isEqualOrParent(g,v.configPath))return w}}const E=d.filter(w=>(0,D.isSingleFolderWorkspaceIdentifier)(w.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqualOrParent(g,w.openedWorkspace.uri));if(E.length)return E.sort((w,v)=>-(w.openedWorkspace.uri.path.length-v.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=C;function k(d,g){for(const S of d)if((0,D.isWorkspaceIdentifier)(S.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(S.openedWorkspace.configPath,g)||(0,D.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(S.openedWorkspace.uri,g))return S}e.findWindowOnWorkspaceOrFolder=k;function I(d,g){const S=E=>g.some(w=>p.extUriBiasedIgnorePathCase.isEqual(r.URI.file(w),r.URI.file(E)));for(const E of d)if(E.config?.extensionDevelopmentPath?.some(w=>S(w)))return E}e.findWindowOnExtensionDevelopmentPath=I}),define(x[221],ee([0,1,14,2,3,16,7,19,20,6,38,35,30]),function(j,e,p,r,D,C,k,I,d,g,S,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let v=class yt extends r.Disposable{constructor(c,a,l,o,h){super();this.windowsMainService=c,this.stateMainService=a,this.lifecycleMainService=l,this.logService=o,this.configurationService=h,this._state=t(this.stateMainService.getItem(yt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){p.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(c=>this.onBeforeCloseWindow(c)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(c=>{c.newCount-c.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(c=>this.onBeforeCloseWindow(c))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const c={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!c.lastActiveWindow){let o=this.windowsMainService.getLastActiveWindow();(!o||o.isExtensionDevelopmentHost)&&(o=this.windowsMainService.getWindows().find(h=>!h.isExtensionDevelopmentHost)),o&&(c.lastActiveWindow=this.toWindowState(o))}const a=this.windowsMainService.getWindows().find(o=>o.isExtensionDevelopmentHost&&!o.isExtensionTestHost);a&&(c.lastPluginDevelopmentHostWindow=this.toWindowState(a)),this.windowsMainService.getWindowCount()>1&&(c.openedWindows=this.windowsMainService.getWindows().filter(o=>!o.isExtensionDevelopmentHost).map(o=>this.toWindowState(o)));const l=y(c);this.stateMainService.setItem(yt.windowsStateStorageKey,l),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",l)}onBeforeCloseWindow(c){if(this.lifecycleMainService.quitRequested)return;const a=this.toWindowState(c);c.isExtensionDevelopmentHost&&!c.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=a:!c.isExtensionDevelopmentHost&&c.openedWorkspace&&this._state.openedWindows.forEach(l=>{const o=(0,w.isWorkspaceIdentifier)(c.openedWorkspace)&&l.workspace?.id===c.openedWorkspace.id,h=(0,w.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)&&l.folderUri&&C.extUriBiasedIgnorePathCase.isEqual(l.folderUri,c.openedWorkspace.uri);(o||h)&&(l.uiState=a.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=a)}toWindowState(c){return{workspace:(0,w.isWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace:void 0,folderUri:(0,w.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace.uri:void 0,backupPath:c.backupPath,remoteAuthority:c.remoteAuthority,uiState:c.serializeWindowState()}}getNewWindowState(c){const a=this.doGetNewWindowState(c),l=this.configurationService.getValue("window");let o;return a.hasDefaultState?o=!!(l?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(l.newWindowDimensions)>=0):(o=!!(this.lifecycleMainService.wasRestarted||l?.restoreFullscreen),o&&D.isMacintosh&&this.windowsMainService.getWindows().some(h=>h.isFullScreen)&&(o=!1)),a.mode===3&&!o&&(a.mode=1),a}doGetNewWindowState(c){const a=this.windowsMainService.getLastActiveWindow();if(!c.extensionTestsPath){if(!!c.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const s=c.workspace;if((0,w.isWorkspaceIdentifier)(s)){const m=this.state.openedWindows.filter(M=>M.workspace&&M.workspace.id===s.id).map(M=>M.uiState);if(m.length)return m[0]}if((0,w.isSingleFolderWorkspaceIdentifier)(s)){const m=this.state.openedWindows.filter(M=>M.folderUri&&C.extUriBiasedIgnorePathCase.isEqual(M.folderUri,s.uri)).map(M=>M.uiState);if(m.length)return m[0]}else if(c.backupPath){const m=this.state.openedWindows.filter(M=>M.backupPath===c.backupPath).map(M=>M.uiState);if(m.length)return m[0]}const u=this.lastClosedState||this.state.lastActiveWindow;if(!a&&u)return u.uiState}let l;const o=p.screen.getAllDisplays();if(o.length===1)l=o[0];else{if(D.isMacintosh){const s=p.screen.getCursorScreenPoint();l=p.screen.getDisplayNearestPoint(s)}!l&&a&&(l=p.screen.getDisplayMatching(a.getBounds())),l||(l=p.screen.getPrimaryDisplay()||o[0])}let h=(0,E.defaultWindowState)();h.x=Math.round(l.bounds.x+l.bounds.width/2-h.width/2),h.y=Math.round(l.bounds.y+l.bounds.height/2-h.height/2);const n=this.configurationService.getValue("window");let i=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")h.mode=0,i=!1;else if(n.newWindowDimensions==="fullscreen")h.mode=3,i=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&a){const s=a.serializeWindowState();s.mode===3?h.mode=3:h=s,i=h.mode!==3&&n.newWindowDimensions==="offset"}}return i&&(h=this.ensureNoOverlap(h)),h.hasDefaultState=!0,h}ensureNoOverlap(c){if(this.windowsMainService.getWindows().length===0)return c;c.x=typeof c.x=="number"?c.x:0,c.y=typeof c.y=="number"?c.y:0;const a=this.windowsMainService.getWindows().map(l=>l.getBounds());for(;a.some(l=>l.x===c.x||l.y===c.y);)c.x+=30,c.y+=30;return c}};v.windowsStateStorageKey="windowsState",v=fe([ie(0,E.IWindowsMainService),ie(1,S.IStateMainService),ie(2,d.ILifecycleMainService),ie(3,g.ILogService),ie(4,I.IConfigurationService)],v),e.WindowsStateHandler=v;function t(P){const c={openedWindows:[]},a=P||{openedWindows:[]};return a.lastActiveWindow&&(c.lastActiveWindow=f(a.lastActiveWindow)),a.lastPluginDevelopmentHostWindow&&(c.lastPluginDevelopmentHostWindow=f(a.lastPluginDevelopmentHostWindow)),Array.isArray(a.openedWindows)&&(c.openedWindows=a.openedWindows.map(l=>f(l))),c}e.restoreWindowsState=t;function f(P){const c={uiState:P.uiState};return P.backupPath&&(c.backupPath=P.backupPath),P.remoteAuthority&&(c.remoteAuthority=P.remoteAuthority),P.folder&&(c.folderUri=k.URI.parse(P.folder)),P.workspaceIdentifier&&(c.workspace={id:P.workspaceIdentifier.id,configPath:k.URI.parse(P.workspaceIdentifier.configURIPath)}),c}function y(P){return{lastActiveWindow:P.lastActiveWindow&&b(P.lastActiveWindow),lastPluginDevelopmentHostWindow:P.lastPluginDevelopmentHostWindow&&b(P.lastPluginDevelopmentHostWindow),openedWindows:P.openedWindows.map(c=>b(c))}}e.getWindowsStateStoreData=y;function b(P){return{workspaceIdentifier:P.workspace&&{id:P.workspace.id,configURIPath:P.workspace.configPath.toString()},folder:P.folderUri&&P.folderUri.toString(),backupPath:P.backupPath,remoteAuthority:P.remoteAuthority,uiState:P.uiState}}}),define(x[100],ee([0,1,60,28,10,3,16]),function(j,e,p,r,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function I(g){function S(){let E=g.scheme===D.Schemas.file?(0,k.originalFSPath)(g):g.toString();return C.isLinux||(E=E.toLowerCase()),(0,p.createHash)("md5").update(E).digest("hex")}return{id:S(),configPath:g}}e.getWorkspaceIdentifier=I;function d(g,S){function E(){if(g.scheme!==D.Schemas.file)return(0,p.createHash)("md5").update(g.toString()).digest("hex");if(!S)try{S=(0,r.statSync)(g.fsPath)}catch{return}let v;return C.isLinux?v=S.ino:C.isMacintosh?v=S.birthtime.getTime():C.isWindows&&(typeof S.birthtimeMs=="number"?v=Math.floor(S.birthtimeMs):v=S.birthtime.getTime()),(0,p.createHash)("md5").update(g.fsPath).update(v?String(v):"").digest("hex")}const w=E();if(typeof w=="string")return{id:w,uri:g}}e.getSingleFolderWorkspaceIdentifier=d}),define(x[222],ee([0,1,15,10,6,250,112,20]),function(j,e,p,r,D,C,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerMainProcessExtensionHostStarter=void 0;class d{constructor(w,v){this._worker=new C.Worker(r.FileAccess.asFileUri("vs/platform/extensions/node/extensionHostStarterWorkerMain.js",j).fsPath),this._worker.on("message",w),this._worker.on("error",v)}getId(){return 1}postMessage(w,v){this._worker.postMessage(w,v)}dispose(){this._worker.terminate()}}let g=class{constructor(w){this._logService=w}async logInfo(w){this._logService.info(w)}};g=fe([ie(0,D.ILogService)],g);let S=class{constructor(w,v){this._logService=w,this._shutdown=!1,this._proxy=null;const t={create:(f,y,b)=>{const P=new d(y,b);return P.postMessage(f,[]),P}};this._worker=new k.SimpleWorkerClient(t,"vs/platform/extensions/node/extensionHostStarterWorker",new g(this._logService)),this._initialize(),v.onWillShutdown(f=>{this._shutdown=!0,this._proxy&&f.join(this._proxy.waitForAllExit(6e3))})}dispose(){}async _initialize(){this._proxy=await this._worker.getProxyObject(),this._logService.info("ExtensionHostStarterWorker created")}onDynamicStdout(w){return this._proxy.onDynamicStdout(w)}onDynamicStderr(w){return this._proxy.onDynamicStderr(w)}onDynamicMessage(w){return this._proxy.onDynamicMessage(w)}onDynamicError(w){return this._proxy.onDynamicError(w)}onDynamicExit(w){return this._proxy.onDynamicExit(w)}async createExtensionHost(){const w=await this._worker.getProxyObject();if(this._shutdown)throw(0,p.canceled)();return w.createExtensionHost()}async start(w,v){const t=await this._worker.getProxyObject();if(this._shutdown)throw(0,p.canceled)();return t.start(w,v)}async enableInspectPort(w){const v=await this._worker.getProxyObject();if(this._shutdown)throw(0,p.canceled)();return v.enableInspectPort(w)}async kill(w){const v=await this._worker.getProxyObject();if(this._shutdown)throw(0,p.canceled)();return v.kill(w)}};S=fe([ie(0,D.ILogService),ie(1,I.ILifecycleMainService)],S),e.WorkerMainProcessExtensionHostStarter=S}),define(x[58],ee([0,1,60,61,26,17,15,4,2,8,3,27,37,83,223]),function(j,e,p,r,D,C,k,I,d,g,S,E,w,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class f{constructor(R,T=""){this.debugLabel=T,this.socket=R,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=_=>{if(this.traceSocketEvent("error",{code:_?.code,message:_?.message}),_){if(_.code==="EPIPE")return;(0,k.onUnexpectedError)(_)}},this.socket.on("error",this._errorListener)}traceSocketEvent(R,T){v.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,R,T)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(R){const T=_=>{this.traceSocketEvent("read",_),R(C.VSBuffer.wrap(_))};return this.socket.on("data",T),{dispose:()=>this.socket.off("data",T)}}onClose(R){const T=_=>{this.traceSocketEvent("close",{hadError:_}),R({type:0,hadError:_,error:void 0})};return this.socket.on("close",T),{dispose:()=>this.socket.off("close",T)}}onEnd(R){const T=()=>{this.traceSocketEvent("nodeEndReceived"),R()};return this.socket.on("end",T),{dispose:()=>this.socket.off("end",T)}}write(R){if(!this.socket.destroyed)try{this.traceSocketEvent("write",R),this.socket.write(R.buffer,T=>{if(T){if(T.code==="EPIPE")return;(0,k.onUnexpectedError)(T)}})}catch(T){if(T.code==="EPIPE")return;(0,k.onUnexpectedError)(T)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((R,T)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),R();return}const _=()=>{this.socket.off("close",_),this.socket.off("end",_),this.socket.off("error",_),this.socket.off("timeout",_),this.socket.off("drain",_),this.traceSocketEvent("nodeDrainEnd"),R()};this.socket.on("close",_),this.socket.on("end",_),this.socket.on("error",_),this.socket.on("timeout",_),this.socket.on("drain",_)})}}e.NodeSocket=f;var y;(function(L){L[L.MinHeaderByteSize=2]="MinHeaderByteSize"})(y||(y={}));var b;(function(L){L[L.PeekHeader=1]="PeekHeader",L[L.ReadHeader=2]="ReadHeader",L[L.ReadBody=3]="ReadBody",L[L.Fin=4]="Fin"})(b||(b={}));class P extends d.Disposable{constructor(R,T,_,Q){super();this._onData=this._register(new I.Emitter),this._onClose=this._register(new I.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=R,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:T,inflateBytesLength:_?.byteLength||0,recordInflateBytes:Q}),this._flowManager=this._register(new c(this,T,_,Q,this._onData,(se,re)=>this._write(se,re))),this._register(this._flowManager.onError(se=>{console.error(se),(0,k.onUnexpectedError)(se),this._onClose.fire({type:0,hadError:!0,error:se})})),this._incomingData=new v.ChunkStream,this._register(this.socket.onData(se=>this._acceptChunk(se))),this._register(this.socket.onClose(se=>this._onClose.fire(se)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(R,T){this.socket.traceSocketEvent(R,T)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(R){return this._onData.event(R)}onClose(R){return this._onClose.event(R)}onEnd(R){return this.socket.onEnd(R)}write(R){this._flowManager.writeMessage(R)}_write(R,T){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",R);let _=2;R.byteLength<126?_+=0:R.byteLength<2**16?_+=2:_+=8;const Q=C.VSBuffer.alloc(_);if(T?Q.writeUInt8(194,0):Q.writeUInt8(130,0),R.byteLength<126)Q.writeUInt8(R.byteLength,1);else if(R.byteLength<2**16){Q.writeUInt8(126,1);let se=1;Q.writeUInt8(R.byteLength>>>8&255,++se),Q.writeUInt8(R.byteLength>>>0&255,++se)}else{Q.writeUInt8(127,1);let se=1;Q.writeUInt8(0,++se),Q.writeUInt8(0,++se),Q.writeUInt8(0,++se),Q.writeUInt8(0,++se),Q.writeUInt8(R.byteLength>>>24&255,++se),Q.writeUInt8(R.byteLength>>>16&255,++se),Q.writeUInt8(R.byteLength>>>8&255,++se),Q.writeUInt8(R.byteLength>>>0&255,++se)}this.socket.write(C.VSBuffer.concat([Q,R]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(R){if(R.byteLength!==0){for(this._incomingData.acceptChunk(R);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const T=this._incomingData.peek(this._state.readLen),_=T.readUInt8(0),Q=(_&128)>>>7,se=(_&64)>>>6,re=T.readUInt8(1),G=(re&128)>>>7,X=re&127;this._state.state=2,this._state.readLen=2+(G?4:0)+(X===126?2:0)+(X===127?8:0),this._state.fin=Q,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(se)),this._state.firstFrameOfMessage=Boolean(Q),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const T=this._incomingData.read(this._state.readLen),_=T.readUInt8(1),Q=(_&128)>>>7;let se=_&127,re=1;se===126?se=T.readUInt8(++re)*2**8+T.readUInt8(++re):se===127&&(se=T.readUInt8(++re)*0+T.readUInt8(++re)*0+T.readUInt8(++re)*0+T.readUInt8(++re)*0+T.readUInt8(++re)*2**24+T.readUInt8(++re)*2**16+T.readUInt8(++re)*2**8+T.readUInt8(++re));let G=0;Q&&(G=T.readUInt8(++re)*2**24+T.readUInt8(++re)*2**16+T.readUInt8(++re)*2**8+T.readUInt8(++re)),this._state.state=3,this._state.readLen=se,this._state.mask=G,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const T=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",T),o(T,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",T),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(T,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await I.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=P;class c extends d.Disposable{constructor(R,T,_,Q,se,re){super();this._tracer=R,this._onData=se,this._writeFn=re,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new I.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,T?(this._zlibInflateStream=this._register(new a(this._tracer,Q,_,{windowBits:15})),this._zlibDeflateStream=this._register(new l(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(G=>this._onError.fire(G))),this._register(this._zlibDeflateStream.onError(G=>this._onError.fire(G)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:C.VSBuffer.alloc(0)}writeMessage(R){this._writeQueue.push(R),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const R=this._writeQueue.shift();if(this._zlibDeflateStream){const T=await this._deflateMessage(this._zlibDeflateStream,R);this._writeFn(T,!0)}else this._writeFn(R,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(R,T){return new Promise((_,Q)=>{R.write(T),R.flush(se=>_(se))})}acceptFrame(R,T,_){this._readQueue.push({data:R,isCompressed:T,isLastFrameOfMessage:_}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const R=this._readQueue.shift();if(this._zlibInflateStream&&R.isCompressed){const T=await this._inflateFrame(this._zlibInflateStream,R.data,R.isLastFrameOfMessage);this._onData.fire(T)}else this._onData.fire(R.data)}this._isProcessingReadQueue=!1}}_inflateFrame(R,T,_){return new Promise((Q,se)=>{R.write(T),_&&R.write(C.VSBuffer.fromByteArray([0,0,255,255])),R.flush(re=>Q(re))})}}class a extends d.Disposable{constructor(R,T,_,Q){super();this._tracer=R,this._recordInflateBytes=T,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=t.createInflateRaw(Q),this._zlibInflate.on("error",se=>{this._tracer.traceSocketEvent("zlibInflateError",{message:se?.message,code:se?.code}),this._onError.fire(se)}),this._zlibInflate.on("data",se=>{this._tracer.traceSocketEvent("zlibInflateData",se),this._pendingInflateData.push(C.VSBuffer.wrap(se))}),_&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",_.buffer),this._zlibInflate.write(_.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.concat(this._recordedInflateBytes):C.VSBuffer.alloc(0)}write(R){this._recordInflateBytes&&this._recordedInflateBytes.push(R.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",R),this._zlibInflate.write(R.buffer)}flush(R){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const T=C.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,R(T)})}}class l extends d.Disposable{constructor(R,T){super();this._tracer=R,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=t.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",_=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:_?.message,code:_?.code}),this._onError.fire(_)}),this._zlibDeflate.on("data",_=>{this._tracer.traceSocketEvent("zlibDeflateData",_),this._pendingDeflateData.push(C.VSBuffer.wrap(_))})}write(R){this._tracer.traceSocketEvent("zlibDeflateWrite",R.buffer),this._zlibDeflate.write(R.buffer)}flush(R){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let T=C.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,T=T.slice(0,T.byteLength-4),R(T)})}}function o(L,R){if(R===0)return;let T=L.byteLength>>>2;for(let X=0;X<T;X++){const B=L.readUInt32BE(X*4);L.writeUInt32BE(B^R,X*4)}let _=T*4,Q=L.byteLength-_;const se=R>>>24&255,re=R>>>16&255,G=R>>>8&255;Q>=1&&L.writeUInt8(L.readUInt8(_)^se,_),Q>=2&&L.writeUInt8(L.readUInt8(_+1)^re,_+1),Q>=3&&L.writeUInt8(L.readUInt8(_+2)^G,_+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const h={[2]:107,[1]:103};function n(){const L=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${L}-sock`;let R;return e.XDG_RUNTIME_DIR?R=(0,g.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${L}.sock`):R=(0,g.join)((0,D.tmpdir)(),`vscode-ipc-${L}.sock`),s(R),R}e.createRandomIPCHandle=n;function i(L,R,T){const _=(0,p.createHash)("md5").update(L).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${_}-${T}-${R}-sock`;let Q;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?Q=(0,g.join)(e.XDG_RUNTIME_DIR,`vscode-${_.substr(0,8)}-${T}-${R}.sock`):Q=(0,g.join)(L,`${T}-${R}.sock`),s(Q),Q}e.createStaticIPCHandle=i;function s(L){const R=h[S.platform];typeof R=="number"&&L.length>=R&&console.warn(`WARNING: IPC handle "${L}" is longer than ${R} chars, try a shorter --user-data-dir`)}class u extends w.IPCServer{constructor(R){super(u.toClientConnectionEvent(R));this.server=R}static toClientConnectionEvent(R){const T=I.Event.fromNodeEventEmitter(R,"connection");return I.Event.map(T,_=>({protocol:new v.Protocol(new f(_,"ipc-server-connection")),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(_,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=u;function m(L){return new Promise((R,T)=>{const _=(0,r.createServer)();_.on("error",T),_.listen(L,()=>{_.removeListener("error",T),R(new u(_))})})}e.serve=m;function M(L,R){return new Promise((T,_)=>{const Q=(0,r.createConnection)(L,()=>{Q.removeListener("error",_),T(v.Client.fromSocket(new f(Q,`ipc-client${R}`),R))});Q.once("error",_)})}e.connect=M}),define(x[224],ee([0,1,58]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class r{constructor(d){this.driver=d}listen(d,g){throw new Error("No event found")}call(d,g,S){switch(g){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(S);case"startTracing":return this.driver.startTracing(S[0],S[1]);case"stopTracing":return this.driver.stopTracing(S[0],S[1],S[2]);case"reloadWindow":return this.driver.reloadWindow(S);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(S[0],S[1]);case"click":return this.driver.click(S[0],S[1],S[2],S[3]);case"doubleClick":return this.driver.doubleClick(S[0],S[1]);case"setValue":return this.driver.setValue(S[0],S[1],S[2]);case"getTitle":return this.driver.getTitle(S[0]);case"isActiveElement":return this.driver.isActiveElement(S[0],S[1]);case"getElements":return this.driver.getElements(S[0],S[1],S[2]);case"getElementXY":return this.driver.getElementXY(S[0],S[1],S[2]);case"typeInEditor":return this.driver.typeInEditor(S[0],S[1],S[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(S[0],S[1]);case"writeInTerminal":return this.driver.writeInTerminal(S[0],S[1],S[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(S);case"getLocalizedStrings":return this.driver.getLocalizedStrings(S)}throw new Error(`Call not found: ${g}`)}}e.DriverChannel=r;class D{constructor(d){this.channel=d}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(d){return this.channel.call("capturePage",d)}startTracing(d,g){return this.channel.call("startTracing",[d,g])}stopTracing(d,g,S){return this.channel.call("stopTracing",[d,g,S])}reloadWindow(d){return this.channel.call("reloadWindow",d)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(d,g){return this.channel.call("dispatchKeybinding",[d,g])}click(d,g,S,E){return this.channel.call("click",[d,g,S,E])}doubleClick(d,g){return this.channel.call("doubleClick",[d,g])}setValue(d,g,S){return this.channel.call("setValue",[d,g,S])}getTitle(d){return this.channel.call("getTitle",[d])}isActiveElement(d,g){return this.channel.call("isActiveElement",[d,g])}getElements(d,g,S){return this.channel.call("getElements",[d,g,S])}getElementXY(d,g,S,E){return this.channel.call("getElementXY",[d,g,S,E])}typeInEditor(d,g,S){return this.channel.call("typeInEditor",[d,g,S])}getTerminalBuffer(d,g){return this.channel.call("getTerminalBuffer",[d,g])}writeInTerminal(d,g,S){return this.channel.call("writeInTerminal",[d,g,S])}getLocaleInfo(d){return this.channel.call("getLocaleInfo",d)}getLocalizedStrings(d){return this.channel.call("getLocalizedStrings",d)}}e.DriverChannelClient=D;class C{constructor(d){this.registry=d}listen(d,g){throw new Error(`Event not found: ${g}`)}call(d,g,S){switch(g){case"registerWindowDriver":return this.registry.registerWindowDriver(S);case"reloadWindowDriver":return this.registry.reloadWindowDriver(S)}throw new Error(`Call not found: ${g}`)}}e.WindowDriverRegistryChannel=C;async function k(I){const d=await(0,p.connect)(I,"driverClient"),g=d.getChannel("driver"),S=new D(g);return{client:d,driver:S}}e.connect=k}),define(x[24],ee([0,1,46,8,58,53,165,5]),function(j,e,p,r,D,C,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,I.refineServiceDecorator)(C.IEnvironmentService);class d extends k.NativeEnvironmentService{get cachedLanguagesPath(){return(0,r.join)(this.userDataPath,"clp")}get backupHome(){return(0,r.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,r.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,D.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,r.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}fe([p.memoize],d.prototype,"cachedLanguagesPath",null),fe([p.memoize],d.prototype,"backupHome",null),fe([p.memoize],d.prototype,"backupWorkspacesPath",null),fe([p.memoize],d.prototype,"mainIPCHandle",null),fe([p.memoize],d.prototype,"mainLockfile",null),fe([p.memoize],d.prototype,"sandbox",null),fe([p.memoize],d.prototype,"driverVerbose",null),fe([p.memoize],d.prototype,"disableUpdates",null),fe([p.memoize],d.prototype,"disableKeytar",null),fe([p.memoize],d.prototype,"codeCachePath",null),fe([p.memoize],d.prototype,"useCodeCache",null),e.EnvironmentMainService=d}),define(x[225],ee([0,1,60,28,32,10,8,3,16,7,21,159,19,24,18,6,30]),function(j,e,p,r,D,C,k,I,d,g,S,E,w,v,t,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let b=class{constructor(c,a,l){this.configurationService=a,this.logService=l,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=d.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(o,h)=>(0,D.isEqual)(o,h,!I.isLinux)},this.backupHome=c.backupHome,this.workspacesJsonPath=c.backupWorkspacesPath}async initialize(){let c;try{c=JSON.parse(await S.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch{c=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(c.emptyWorkspaceInfos);let a=[];try{Array.isArray(c.rootURIWorkspaces)&&(a=c.rootURIWorkspaces.map(o=>({workspace:{id:o.id,configPath:g.URI.parse(o.configURIPath)},remoteAuthority:o.remoteAuthority})))}catch{}this.workspaces=await this.validateWorkspaces(a);let l=[];try{Array.isArray(c.folderWorkspaceInfos)?l=c.folderWorkspaceInfos.map(o=>({folderUri:g.URI.parse(o.folderUri),remoteAuthority:o.remoteAuthority})):Array.isArray(c.folderURIWorkspaces)&&(l=c.folderURIWorkspaces.map(o=>({folderUri:g.URI.parse(o),remoteAuthority:void 0})))}catch{}this.folders=await this.validateFolders(l),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==t.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===t.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||t.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(c,a){this.workspaces.some(o=>c.workspace.id===o.workspace.id)||(this.workspaces.push(c),this.saveSync());const l=this.getBackupPath(c.workspace.id);return a&&this.moveBackupFolderSync(l,a),l}moveBackupFolderSync(c,a){if(r.existsSync(c)&&this.convertToEmptyWindowBackupSync(c),r.existsSync(a))try{r.renameSync(a,c)}catch(l){this.logService.error(`Backup: Could not move backup folder to new location: ${l.toString()}`)}}unregisterWorkspaceBackupSync(c){const a=c.id,l=this.workspaces.findIndex(o=>o.workspace.id===a);l!==-1&&(this.workspaces.splice(l,1),this.saveSync())}registerFolderBackupSync(c){return this.folders.some(a=>this.backupUriComparer.isEqual(c.folderUri,a.folderUri))||(this.folders.push(c),this.saveSync()),this.getBackupPath(this.getFolderHash(c))}unregisterFolderBackupSync(c){const a=this.folders.findIndex(l=>this.backupUriComparer.isEqual(c,l.folderUri));a!==-1&&(this.folders.splice(a,1),this.saveSync())}registerEmptyWindowBackupSync(c,a){const l=c||this.getRandomEmptyWindowId();return this.emptyWindows.some(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,l))||(this.emptyWindows.push({backupFolder:l,remoteAuthority:a}),this.saveSync()),this.getBackupPath(l)}unregisterEmptyWindowBackupSync(c){const a=this.emptyWindows.findIndex(l=>!!l.backupFolder&&this.backupPathComparer.isEqual(l.backupFolder,c));a!==-1&&(this.emptyWindows.splice(a,1),this.saveSync())}getBackupPath(c){return(0,k.join)(this.backupHome,c)}async validateWorkspaces(c){if(!Array.isArray(c))return[];const a=new Set,l=[];for(let o of c){const h=o.workspace;if(!(0,y.isWorkspaceIdentifier)(h))return[];if(!a.has(h.id)){a.add(h.id);const n=this.getBackupPath(h.id);await this.doHasBackups(n)?h.configPath.scheme!==C.Schemas.file||await S.Promises.exists(h.configPath.fsPath)?l.push(o):await this.convertToEmptyWindowBackup(n):await this.deleteStaleBackup(n)}}return l}async validateFolders(c){if(!Array.isArray(c))return[];const a=[],l=new Set;for(let o of c){const h=o.folderUri,n=this.backupUriComparer.getComparisonKey(h);if(!l.has(n)){l.add(n);const i=this.getBackupPath(this.getFolderHash(o));await this.doHasBackups(i)?h.scheme!==C.Schemas.file||await S.Promises.exists(h.fsPath)?a.push(o):await this.convertToEmptyWindowBackup(i):await this.deleteStaleBackup(i)}}return a}async validateEmptyWorkspaces(c){if(!Array.isArray(c))return[];const a=[],l=new Set;for(let o of c){const h=o.backupFolder;if(typeof h!="string")return[];if(!l.has(h)){l.add(h);const n=this.getBackupPath(h);await this.doHasBackups(n)?a.push(o):await this.deleteStaleBackup(n)}}return a}async deleteStaleBackup(c){try{await S.Promises.exists(c)&&await S.Promises.rm(c,S.RimRafMode.MOVE)}catch(a){this.logService.error(`Backup: Could not delete stale backup: ${a.toString()}`)}}async convertToEmptyWindowBackup(c){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,a));)a=this.getRandomEmptyWindowId();const l=this.getBackupPath(a);try{await S.Promises.rename(c,l)}catch(o){return this.logService.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}convertToEmptyWindowBackupSync(c){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,a));)a=this.getRandomEmptyWindowId();const l=this.getBackupPath(a);try{r.renameSync(c,l)}catch(o){return this.logService.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}async getDirtyWorkspaces(){const c=[];for(const a of this.workspaces)await this.hasBackups(a)&&c.push(a);for(const a of this.folders)await this.hasBackups(a)&&c.push(a);return c}hasBackups(c){let a;return(0,E.isEmptyWindowBackupInfo)(c)?a=c.backupFolder:(0,y.isFolderBackupInfo)(c)?a=this.getBackupPath(this.getFolderHash(c)):a=this.getBackupPath(c.workspace.id),this.doHasBackups(a)}async doHasBackups(c){try{const a=await S.Promises.readdir(c);for(const l of a)try{if((await S.Promises.readdir((0,k.join)(c,l))).length>0)return!0}catch{}}catch{}return!1}saveSync(){try{(0,S.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}async save(){try{await S.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(c=>({id:c.workspace.id,configURIPath:c.workspace.configPath.toString(),remoteAuthority:c.remoteAuthority})),folderWorkspaceInfos:this.folders.map(c=>({folderUri:c.folderUri.toString(),remoteAuthority:c.remoteAuthority})),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(c){const a=c.folderUri;let l;return a.scheme===C.Schemas.file?l=I.isLinux?a.fsPath:a.fsPath.toLowerCase():l=a.toString().toLowerCase(),(0,p.createHash)("md5").update(l).digest("hex")}};b=fe([ie(0,v.IEnvironmentMainService),ie(1,w.IConfigurationService),ie(2,f.ILogService)],b),e.BackupMainService=b}),define(x[226],ee([0,1,9,4,106,59,2,3,37,58,161,224,24,179,20,35,18,7,8,17]),function(j,e,p,r,D,C,k,I,d,g,S,E,w,v,t,f,y,b,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function a(h){return h<21}let l=class{constructor(n,i,s,u,m,M){this.windowServer=n,this.options=i,this.windowsMainService=s,this.lifecycleMainService=u,this.fileService=m,this.environmentMainService=M,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new r.Emitter}async registerWindowDriver(n){return this.registeredWindowIds.add(n),this.reloadingWindowIds.delete(n),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(n){this.reloadingWindowIds.add(n)}async getWindowIds(){return this.windowsMainService.getWindows().map(n=>n.id).filter(n=>this.registeredWindowIds.has(n)&&!this.reloadingWindowIds.has(n))}async capturePage(n){await this.whenUnfrozen(n);const i=this.windowsMainService.getWindowById(n);if(!i?.win)throw new Error("Invalid window");return(await i.win.webContents.capturePage()).toPNG().toString("base64")}async startTracing(n,i){}async stopTracing(n,i,s){if(!s)return;const u=await this.capturePage(n),m=Buffer.from(u,"base64");await this.fileService.writeFile(b.URI.file((0,P.join)(this.environmentMainService.logsPath,`${i}.png`)),c.VSBuffer.wrap(m))}async reloadWindow(n){await this.whenUnfrozen(n);const i=this.windowsMainService.getWindowById(n);if(!i)throw new Error("Invalid window");this.reloadingWindowIds.add(n),this.lifecycleMainService.reload(i)}exitApplication(){return this.lifecycleMainService.quit()}async dispatchKeybinding(n,i){await this.whenUnfrozen(n);const s=D.KeybindingParser.parseUserBinding(i);for(let u of s)await this._dispatchKeybinding(n,u)}async _dispatchKeybinding(n,i){if(i instanceof C.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const s=this.windowsMainService.getWindowById(n);if(!s?.win)throw new Error("Invalid window");const u=s.win.webContents,m=new C.SimpleKeybinding(!1,!1,!1,!1,i.keyCode),L=new v.USLayoutResolvedKeybinding(m.toChord(),I.OS).getElectronAccelerator(),R=[];i.ctrlKey&&R.push("ctrl"),i.metaKey&&R.push("meta"),i.shiftKey&&R.push("shift"),i.altKey&&R.push("alt"),u.sendInputEvent({type:"keyDown",keyCode:L,modifiers:R}),a(i.keyCode)||u.sendInputEvent({type:"char",keyCode:L,modifiers:R}),u.sendInputEvent({type:"keyUp",keyCode:L,modifiers:R}),await(0,p.timeout)(100)}async click(n,i,s,u){await(await this.getWindowDriver(n)).click(i,s,u)}async doubleClick(n,i){await(await this.getWindowDriver(n)).doubleClick(i)}async setValue(n,i,s){await(await this.getWindowDriver(n)).setValue(i,s)}async getTitle(n){return await(await this.getWindowDriver(n)).getTitle()}async isActiveElement(n,i){return await(await this.getWindowDriver(n)).isActiveElement(i)}async getElements(n,i,s){return await(await this.getWindowDriver(n)).getElements(i,s)}async getElementXY(n,i,s,u){return await(await this.getWindowDriver(n)).getElementXY(i,s,u)}async typeInEditor(n,i,s){await(await this.getWindowDriver(n)).typeInEditor(i,s)}async getTerminalBuffer(n,i){return await(await this.getWindowDriver(n)).getTerminalBuffer(i)}async writeInTerminal(n,i,s){await(await this.getWindowDriver(n)).writeInTerminal(i,s)}async getLocaleInfo(n){return await(await this.getWindowDriver(n)).getLocaleInfo()}async getLocalizedStrings(n){return await(await this.getWindowDriver(n)).getLocalizedStrings()}async getWindowDriver(n){await this.whenUnfrozen(n);const i=`window:${n}`,s=new d.StaticRouter(m=>m===i),u=this.windowServer.getChannel("windowDriver",s);return new S.WindowDriverChannelClient(u)}async whenUnfrozen(n){for(;this.reloadingWindowIds.has(n);)await r.Event.toPromise(this.onDidReloadingChange.event)}};l=fe([ie(2,f.IWindowsMainService),ie(3,t.ILifecycleMainService),ie(4,y.IFileService),ie(5,w.IEnvironmentMainService)],l),e.Driver=l;async function o(h,n,i,s){const u=i.driverVerbose,m=s.createInstance(l,h,{verbose:u}),M=new E.WindowDriverRegistryChannel(m);h.registerChannel("windowDriverRegistry",M);const L=await(0,g.serve)(n),R=new E.DriverChannel(m);return L.registerChannel("driver",R),(0,k.combinedDisposable)(L,h)}e.serve=o}),define(x[227],ee([0,1,61,58]),function(j,e,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,C,k,I,d){const g=E=>d(E,void 0),S=p.createConnection({host:D,port:C},()=>{S.removeListener("error",g);const E=Buffer.alloc(16);for(let f=0;f<16;f++)E[f]=Math.round(Math.random()*256);const w=E.toString("base64"),v=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${C}/?${k}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${w}`];S.write(v.join(`\r
`)+`\r
\r
`);const t=f=>{f.toString().indexOf(`\r
\r
`)>=0&&(S.off("data",t),d(void 0,new r.NodeSocket(S,I)))};S.on("data",t)});S.setNoDelay(!0),S.once("error",g)}}}),define(x[228],ee([0,1,61,117,227,9,2,19,6,22,194,95,76]),function(j,e,p,r,D,C,k,I,d,g,S,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function v(P,c,a,l,o){let h;for(let n=3;n&&(h&&h.dispose(),h=await new t(P,c,a,l,o).waitForReady(),!(o&&r.BROWSER_RESTRICTED_PORTS[o]||!r.BROWSER_RESTRICTED_PORTS[h.tunnelLocalPort]));n--);return h}class t extends k.Disposable{constructor(c,a,l,o,h){super();this.defaultTunnelHost=a,this.suggestedLocalPort=h,this.privacy=E.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=c,this._server=p.createServer(),this._barrier=new C.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=n=>this._onConnection(n),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=o,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(a=>{a()})}async waitForReady(){let c=await(0,r.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),a=null;return this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),a=this._server.address(),a||(c=0,this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),a=this._server.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async _onConnection(c){c.pause();const a=(0,E.isLocalhost)(this.tunnelRemoteHost)||(0,E.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,S.connectRemoteAgentTunnel)(this._options,a,this.tunnelRemotePort),o=l.getSocket().socket,h=l.readEntireBuffer();l.dispose(),h.byteLength>0&&c.write(h.buffer),c.on("end",()=>{this._socketsDispose.delete(c.localAddress),o.end()}),c.on("close",()=>o.end()),c.on("error",()=>{this._socketsDispose.delete(c.localAddress),o.destroy()}),o.on("end",()=>c.end()),o.on("close",()=>c.end()),o.on("error",()=>{c.destroy()}),c.pipe(o),o.pipe(c),this._socketsDispose.set(c.localAddress,()=>{c.end(),o.end()})}}let f=class extends E.AbstractTunnelService{constructor(c,a,l,o,h){super(a);this.socketFactory=c,this.signService=l,this.productService=o,this.configurationService=h}get defaultTunnelHost(){const c=this.configurationService.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(c,a,l,o,h,n,i){const s=this.getTunnelFromMap(a,l);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,a,l,o,h,n,i);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${a}:${l} on local port ${o}.`);const u={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:c,signService:this.signService,logService:this.logService,ipcLogger:null},m=v(u,this.defaultTunnelHost,a,l,o);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(a,l,m),m}}};f=fe([ie(1,d.ILogService),ie(2,w.ISignService),ie(3,g.IProductService),ie(4,I.IConfigurationService)],f),e.BaseTunnelService=f;let y=class extends f{constructor(c,a,l,o){super(D.nodeSocketFactory,c,a,l,o)}};y=fe([ie(0,d.ILogService),ie(1,w.ISignService),ie(2,g.IProductService),ie(3,I.IConfigurationService)],y),e.TunnelService=y;let b=class extends k.Disposable{constructor(c,a,l,o){super();this.logService=c,this.productService=a,this.signService=l,this.configurationService=o,this._tunnelServices=new Map}async openTunnel(c,a,l,o,h,n,i,s){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${o} on local port ${h}.`),!this._tunnelServices.has(c)){const u=new y(this.logService,this.signService,this.productService,this.configurationService);this._register(u),this._tunnelServices.set(c,u),u.onTunnelClosed(async()=>{(await u.tunnels).length===0&&(u.dispose(),this._tunnelServices.delete(c))})}return this._tunnelServices.get(c).openTunnel(a,l,o,h,n,i,s)}};b=fe([ie(0,d.ILogService),ie(1,g.IProductService),ie(2,w.ISignService),ie(3,I.IConfigurationService)],b),e.SharedTunnelsService=b}),define(x[229],ee([0,1,198,9,17,15,2,13,19,53,89,6,197,223]),function(j,e,p,r,D,C,k,I,d,g,S,E,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let t=class extends k.Disposable{constructor(y,b,P){super();this.environmentService=b,this.logService=P,this.configure(y.getValue()),this._register(y.onDidChangeConfiguration(()=>this.configure(y.getValue()),this))}configure(y){this.proxyUrl=y.http&&y.http.proxy,this.strictSSL=!!(y.http&&y.http.proxyStrictSSL),this.authorization=y.http&&y.http.proxyAuthorization}async request(y,b){this.logService.trace("RequestService#request",y.url);const{proxyUrl:P,strictSSL:c}=this;let a;try{a=await(0,S.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(h){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",h))}const l={...process.env,...a},o=y.agent?y.agent:await(0,w.getProxyAgent)(y.url||"",l,{proxyUrl:P,strictSSL:c});return y.agent=o,y.strictSSL=c,this.authorization&&(y.headers={...y.headers||{},"Proxy-Authorization":this.authorization}),this._request(y,b)}async getNodeRequest(y){return((0,p.parse)(y.url).protocol==="https:"?await new Promise((c,a)=>{j(["https"],c,a)}):await new Promise((c,a)=>{j(["http"],c,a)})).request}_request(y,b){return r.Promises.withAsyncBody(async(P,c)=>{let a;const l=(0,p.parse)(y.url),o=y.getRawRequest?y.getRawRequest(y):await this.getNodeRequest(y),h={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:y.type||"GET",headers:y.headers,agent:y.agent,rejectUnauthorized:(0,I.isBoolean)(y.strictSSL)?y.strictSSL:!0};y.user&&y.password&&(h.auth=y.user+":"+y.password),a=o(h,n=>{const i=(0,I.isNumber)(y.followRedirects)?y.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&i>0&&n.headers.location)this._request({...y,url:n.headers.location,followRedirects:i-1},b).then(P,c);else{let s=n;n.headers["content-encoding"]==="gzip"&&(s=n.pipe((0,v.createGunzip)())),P({res:n,stream:(0,D.streamToBufferReadableStream)(s)})}}),a.on("error",c),y.timeout&&a.setTimeout(y.timeout),y.data&&typeof y.data=="string"&&a.write(y.data),a.end(),b.onCancellationRequested(()=>{a.abort(),c((0,C.canceled)())})})}async resolveProxy(y){}};t=fe([ie(0,d.IConfigurationService),ie(1,g.INativeEnvironmentService),ie(2,E.ILogService)],t),e.RequestService=t}),define(x[230],ee([0,1,14,229]),function(j,e,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function D(k){return p.net.request}class C extends r.RequestService{request(I,d){return super.request({...I||{},getRawRequest:D},d)}}e.RequestMainService=C}),define(x[231],ee([0,1,14,9,4,2,10,13,84,24,20,6,55,56,66,39]),function(j,e,p,r,D,C,k,I,d,g,S,E,w,v,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let y=class extends C.Disposable{constructor(P,c,a,l,o,h,n){super();this.machineId=P,this.userEnv=c,this.environmentMainService=a,this.lifecycleMainService=l,this.logService=o,this.themeMainService=h,this.protocolMainService=n,this.firstWindowConnectionBarrier=new r.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new D.Emitter),this.onDidError=D.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){p.ipcMain.on("vscode:createSharedProcessMessageChannel",(P,c)=>this.onWindowConnection(P,c)),p.ipcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(P,c)=>this.onWorkerConnection(P,c)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(P,c){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const a=await this.connect();if(P.sender.isDestroyed())return a.close();P.sender.postMessage("vscode:createSharedProcessMessageChannelResult",c,[a])}onWorkerConnection(P,c){this.logService.trace("SharedProcess: onWorkerConnection",c);const a=new C.DisposableStore,l=h=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${h}')`,c),a.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",c))},o=p.BrowserWindow.fromId(c.reply.windowId);if(!o||o.isDestroyed()||o.webContents.isDestroyed()||!c.reply.channel){l("unavailable");return}a.add(D.Event.filter(this.lifecycleMainService.onWillLoadWindow,h=>h.window.win===o)(()=>l("load"))),a.add(D.Event.fromNodeEventEmitter(o,"closed")(()=>l("closed"))),o.webContents.postMessage(c.reply.channel,c.reply.nonce,P.ports)}onWillShutdown(){const P=this.window;!P||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(P.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{P.close()}catch{}this.window=void 0},0))}send(P,...c){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${P}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(P,...c)}catch(a){this.logService.warn(`Error sending IPC message to channel '${P}' of shared process: ${(0,f.toErrorMessage)(a)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(P=>p.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),P()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(P=>p.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),P()}))})()),this._whenIpcReady}createWindow(){const P=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new p.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:k.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${P.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1}}),P.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:w.default}),this.window.loadURL(k.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",j).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=P=>{this.logService.trace("SharedProcess#close prevented"),P.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(P,c)=>this._onDidError.fire({type:2,details:c})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(P,c,a)=>this._onDidError.fire({type:3,details:{reason:a,exitCode:c}})))}async connect(){await this.whenIpcReady;const P=(0,I.assertIsDefined)(this.window);return(0,d.connect)(P)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const P=this.window;return P?!P.isDestroyed()&&!P.webContents.isDestroyed():!1}};y=fe([ie(2,g.IEnvironmentMainService),ie(3,S.ILifecycleMainService),ie(4,E.ILogService),ie(5,t.IThemeMainService),ie(6,v.IProtocolMainService)],y),e.SharedProcess=y}),define(x[232],ee([0,1,9,17,8,13,7,24,18,6]),function(j,e,p,r,D,C,k,I,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class S{constructor(v,t,f){this.storagePath=v,this.logService=t,this.fileService=f,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new p.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(v){v.fileOperationResult!==1&&this.logService.error(v)}}getItem(v,t){const f=this.storage[v];return(0,C.isUndefinedOrNull)(f)?t:f}setItem(v,t){this.setItems([{key:v,data:t}])}setItems(v){let t=!1;for(const{key:f,data:y}of v)this.storage[f]!==y&&((0,C.isUndefinedOrNull)(y)?(0,C.isUndefined)(this.storage[f])||(this.storage[f]=void 0,t=!0):(this.storage[f]=y,t=!0));t&&this.save()}removeItem(v){(0,C.isUndefined)(this.storage[v])||(this.storage[v]=void 0,this.save())}async save(v){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),v)}async doSave(){if(!this.initializing)return;await this.initializing;const v=JSON.stringify(this.storage,null,4);if(v!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,r.VSBuffer.fromString(v)),this.lastSavedStorageContents=v}catch(t){this.logService.error(t)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=S;let E=class It{constructor(v,t,f){this.fileStorage=new S(k.URI.file((0,D.join)(v.userDataPath,It.STATE_FILE)),t,f)}async init(){return this.fileStorage.init()}getItem(v,t){return this.fileStorage.getItem(v,t)}setItem(v,t){this.fileStorage.setItem(v,t)}setItems(v){this.fileStorage.setItems(v)}removeItem(v){this.fileStorage.removeItem(v)}close(){return this.fileStorage.close()}};E.STATE_FILE="storage.json",E=fe([ie(0,I.IEnvironmentMainService),ie(1,g.ILogService),ie(2,d.IFileService)],E),e.StateMainService=E}),define(x[77],ee([0,1,9,23,4,19,24,20,6,22,48,41]),function(j,e,p,r,D,C,k,I,d,g,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function w(t,f,y){return`${y.updateUrl}/api/update/${t}/${f}/${y.commit}`}e.createUpdateURL=w;let v=class{constructor(f,y,b,P,c,a){this.lifecycleMainService=f,this.configurationService=y,this.environmentMainService=b,this.requestService=P,this.logService=c,this.productService=a,this._state=E.State.Uninitialized,this._onStateChange=new D.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(f){this.logService.info("update#setState",f.type),this._state=f,this._onStateChange.fire(f)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const f=this.getUpdateMode(),y=this.getProductQuality(f);if(!y){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(y),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(E.State.Idle(this.getUpdateType())),f==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}f==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,b=>this.logService.error(b))}getUpdateMode(){return(0,C.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(f){return f==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(f=60*60*1e3){return(0,p.timeout)(f).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(f){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(f)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(f){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(f=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${f}`),!f&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(this.url){if(this.getUpdateMode()==="none")return!1}else return;return(await this.requestService.request({url:this.url},r.CancellationToken.None)).res.statusCode===204}getUpdateType(){return 1}doQuitAndInstall(){}};v=fe([ie(0,I.ILifecycleMainService),ie(1,C.IConfigurationService),ie(2,k.IEnvironmentMainService),ie(3,S.IRequestService),ie(4,d.ILogService),ie(5,g.IProductService)],v),e.AbstractUpdateService=v}),define(x[233],ee([0,1,14,46,4,2,19,24,20,6,22,48,29,41,77]),function(j,e,p,r,D,C,k,I,d,g,S,E,w,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let f=class extends t.AbstractUpdateService{constructor(b,P,c,a,l,o,h){super(b,P,a,l,o,h);this.telemetryService=c,this.disposables=new C.DisposableStore}get onRawError(){return D.Event.fromNodeEventEmitter(p.autoUpdater,"error",(b,P)=>P)}get onRawUpdateNotAvailable(){return D.Event.fromNodeEventEmitter(p.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return D.Event.fromNodeEventEmitter(p.autoUpdater,"update-available",(b,P,c)=>({url:P,version:c,productVersion:c}))}get onRawUpdateDownloaded(){return D.Event.fromNodeEventEmitter(p.autoUpdater,"update-downloaded",(b,P,c,a)=>({releaseNotes:P,version:c,productVersion:c,date:a}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(b){this.logService.error("UpdateService error:",b);const c=(this.state.type==="checking for updates"?this.state.explicit:!0)?b:void 0;this.setState(v.State.Idle(1,c))}buildUpdateFeedUrl(b){let P;this.productService.darwinUniversalAssetId?P=this.productService.darwinUniversalAssetId:P=process.arch==="x64"?"darwin":"darwin-arm64";const c=(0,t.createUpdateURL)(P,b,this.productService);try{p.autoUpdater.setFeedURL({url:c})}catch(a){this.logService.error("Failed to set update feed URL",a);return}return c}doCheckForUpdates(b){this.setState(v.State.CheckingForUpdates(b)),p.autoUpdater.checkForUpdates()}onUpdateAvailable(b){this.state.type==="checking for updates"&&this.setState(v.State.Downloading(b))}onUpdateDownloaded(b){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:b.version}),this.setState(v.State.Ready(b)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(v.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),p.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};fe([r.memoize],f.prototype,"onRawError",null),fe([r.memoize],f.prototype,"onRawUpdateNotAvailable",null),fe([r.memoize],f.prototype,"onRawUpdateAvailable",null),fe([r.memoize],f.prototype,"onRawUpdateDownloaded",null),f=fe([ie(0,d.ILifecycleMainService),ie(1,k.IConfigurationService),ie(2,w.ITelemetryService),ie(3,I.IEnvironmentMainService),ie(4,E.IRequestService),ie(5,g.ILogService),ie(6,S.IProductService)],f),e.DarwinUpdateService=f}),define(x[234],ee([0,1,44,28,9,4,8,24,20,6,29,41]),function(j,e,p,r,D,C,k,I,d,g,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let w=class{constructor(f,y,b){if(this.lifecycleMainService=f,this.logService=b,this._state=E.State.Uninitialized,this._onStateChange=new C.Emitter,this.onStateChange=this._onStateChange.event,y.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(E.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,P=>this.logService.error(P))}get state(){return this._state}setState(f){this.logService.info("update#setState",f.type),this._state=f,this._onStateChange.fire(f)}scheduleCheckForUpdates(f=60*60*1e3){return(0,D.timeout)(f).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(f){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(f)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(f){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(f=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${f}`),!f&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};w=fe([ie(0,d.ILifecycleMainService),ie(1,I.IEnvironmentMainService),ie(2,g.ILogService)],w);let v=class extends w{constructor(f,y,b,P,c,a){super(b,P,c);this.snap=f,this.snapRevision=y,this.telemetryService=a;const l=(0,r.watch)(k.dirname(this.snap)),o=C.Event.fromNodeEventEmitter(l,"change",(s,u)=>u),h=C.Event.filter(o,s=>s==="current"),i=C.Event.debounce(h,(s,u)=>u,2e3)(()=>this.checkForUpdates(!1));b.onWillShutdown(()=>{i.dispose(),l.close()})}doCheckForUpdates(){this.setState(E.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(f=>{f?this.setState(E.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(E.State.Idle(2)))},f=>{this.logService.error(f),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(E.State.Idle(2,f.message||f))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,p.spawn)("sleep 3 && "+k.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const f=await new Promise((b,P)=>(0,r.realpath)(`${k.dirname(this.snap)}/current`,(c,a)=>c?P(c):b(a))),y=k.basename(f);return this.snapRevision!==y}isLatestVersion(){return this.isUpdateAvailable().then(void 0,f=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};v=fe([ie(2,d.ILifecycleMainService),ie(3,I.IEnvironmentMainService),ie(4,g.ILogService),ie(5,S.ITelemetryService)],v),e.SnapUpdateService=v}),define(x[45],ee([0,1,14,28,4,43,33,2,10,8,3,16,13,21,158,52,49,24,5,6,22,99,30,100]),function(j,e,p,r,D,C,k,I,d,g,S,E,w,v,t,f,y,b,P,c,a,l,o,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,P.createDecorator)("workspacesManagementMainService");let n=class extends I.Disposable{constructor(s,u,m,M,L){super();this.environmentMainService=s,this.logService=u,this.backupMainService=m,this.dialogMainService=M,this.productService=L,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new D.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new D.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(s){return this.doResolveLocalWorkspace(s,u=>(0,r.readFileSync)(u,"utf8"))}resolveLocalWorkspace(s){return this.doResolveLocalWorkspace(s,u=>v.Promises.readFile(u,"utf8"))}doResolveLocalWorkspace(s,u){if(!!this.isWorkspacePath(s)&&s.scheme===d.Schemas.file)try{const m=u(s.fsPath);return m instanceof Promise?m.then(M=>this.doResolveWorkspace(s,M),M=>{}):this.doResolveWorkspace(s,m)}catch{return}}isWorkspacePath(s){return(0,o.isUntitledWorkspace)(s,this.environmentMainService)||(0,o.hasWorkspaceFileExtension)(s)}doResolveWorkspace(s,u){try{const m=this.doParseStoredWorkspace(s,u),M=(0,h.getWorkspaceIdentifier)(s);return{id:M.id,configPath:M.configPath,folders:(0,o.toWorkspaceFolders)(m.folders,M.configPath,E.extUriBiasedIgnorePathCase),remoteAuthority:m.remoteAuthority,transient:m.transient}}catch(m){this.logService.warn(m.toString())}}doParseStoredWorkspace(s,u){const m=(0,C.parse)(u);if(m&&Array.isArray(m.folders))m.folders=m.folders.filter(M=>(0,o.isStoredWorkspaceFolder)(M));else throw new Error(`${s.toString(!0)} looks like an invalid workspace file.`);return m}async createUntitledWorkspace(s,u){const{workspace:m,storedWorkspace:M}=this.newUntitledWorkspace(s,u),L=m.configPath.fsPath;return await v.Promises.mkdir((0,g.dirname)(L),{recursive:!0}),await v.Promises.writeFile(L,JSON.stringify(M,null,"	")),m}createUntitledWorkspaceSync(s,u){const{workspace:m,storedWorkspace:M}=this.newUntitledWorkspace(s,u),L=m.configPath.fsPath;return(0,r.mkdirSync)((0,g.dirname)(L),{recursive:!0}),(0,v.writeFileSync)(L,JSON.stringify(M,null,"	")),m}newUntitledWorkspace(s=[],u){const m=(Date.now()+Math.round(Math.random()*1e3)).toString(),M=(0,E.joinPath)(this.untitledWorkspacesHome,m),L=(0,E.joinPath)(M,o.UNTITLED_WORKSPACE_NAME),R=[];for(const T of s)R.push((0,o.getStoredWorkspaceFolder)(T.uri,!0,T.name,M,!S.isWindows,E.extUriBiasedIgnorePathCase));return{workspace:(0,h.getWorkspaceIdentifier)(L),storedWorkspace:{folders:R,remoteAuthority:u}}}async getWorkspaceIdentifier(s){return(0,h.getWorkspaceIdentifier)(s)}isUntitledWorkspace(s){return(0,o.isUntitledWorkspace)(s.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(s){!this.isUntitledWorkspace(s)||(this.doDeleteUntitledWorkspaceSync(s),this._onDidDeleteUntitledWorkspace.fire(s))}async deleteUntitledWorkspace(s){this.deleteUntitledWorkspaceSync(s)}doDeleteUntitledWorkspaceSync(s){const u=(0,E.originalFSPath)(s.configPath);try{(0,v.rimrafSync)((0,g.dirname)(u));const m=(0,g.join)(this.environmentMainService.workspaceStorageHome.fsPath,s.id);(0,r.existsSync)(m)&&(0,v.writeFileSync)((0,g.join)(m,"obsolete"),"")}catch(m){this.logService.warn(`Unable to delete untitled workspace ${u} (${m}).`)}}getUntitledWorkspacesSync(){const s=[];try{const u=(0,v.readdirSync)(this.untitledWorkspacesHome.fsPath).map(m=>(0,E.joinPath)(this.untitledWorkspacesHome,m,o.UNTITLED_WORKSPACE_NAME));for(const m of u){const M=(0,h.getWorkspaceIdentifier)(m),L=this.resolveLocalWorkspaceSync(m);L?s.push({workspace:M,remoteAuthority:L.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(M)}}catch(u){u.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${u}).`)}return s}async enterWorkspace(s,u,m){if(!s||!s.win||!s.isReady||!await this.isValidTargetWorkspacePath(s,u,m))return;const L=this.doEnterWorkspace(s,(0,h.getWorkspaceIdentifier)(m));if(!!L)return this._onDidEnterWorkspace.fire({window:s,workspace:L.workspace}),L}async isValidTargetWorkspacePath(s,u,m){if(!m)return!0;if((0,o.isWorkspaceIdentifier)(s.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(s.openedWorkspace.configPath,m))return!1;if((0,l.findWindowOnWorkspaceOrFolder)(u,m)){const M={title:this.productService.nameLong,type:"info",buttons:[(0,k.mnemonicButtonLabel)((0,t.localize)(0,null))],message:(0,t.localize)(1,null,(0,E.basename)(m)),detail:(0,t.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(M,(0,w.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(s,u){if(!s.config)return;s.focus();let m;return s.config.extensionDevelopmentPath||(m=this.backupMainService.registerWorkspaceBackupSync({workspace:u,remoteAuthority:s.remoteAuthority},s.config.backupPath)),(0,o.isWorkspaceIdentifier)(s.openedWorkspace)&&this.isUntitledWorkspace(s.openedWorkspace)&&this.deleteUntitledWorkspaceSync(s.openedWorkspace),s.config.workspace=u,s.config.backupPath=m,{workspace:u,backupPath:m}}};n=fe([ie(0,b.IEnvironmentMainService),ie(1,c.ILogService),ie(2,f.IBackupMainService),ie(3,y.IDialogMainService),ie(4,a.IProductService)],n),e.WorkspacesManagementMainService=n}),define(x[101],ee([0,1,14,31,23,3,13,7,21,19,54,5,6,97,35,30,45]),function(j,e,p,r,D,C,k,I,d,g,S,E,w,v,t,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,E.createDecorator)(e.ID);let b=class{constructor(c,a,l,o,h){this.logService=c,this.windowsMainService=a,this.urlService=l,this.workspacesManagementMainService=o,this.configurationService=h}async start(c,a){this.logService.trace("Received data from other instance: ",c,a),C.isMacintosh&&p.app.focus({steal:!0});const l=this.parseOpenUrl(c);if(l.length){let o=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(o=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),o.then(()=>{for(const{uri:h,url:n}of l)this.urlService.open(h,{originalUrl:n})})}else return this.startOpenWindow(c,a)}parseOpenUrl(c){return c["open-url"]&&c._urls&&c._urls.length>0?(0,r.coalesce)(c._urls.map(a=>{try{return{uri:I.URI.parse(a),url:a}}catch{return null}})):[]}async startOpenWindow(c,a){const l=(0,S.isLaunchedFromCli)(a)?0:4;let o=[];const h=c.wait&&c.waitMarkerFilePath?I.URI.file(c.waitMarkerFilePath):void 0,n=c.remote||void 0,i={context:l,cli:c,userEnv:a,waitMarkerFileURI:h,remoteAuthority:n};if(c.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(c.extensionDevelopmentPath,i);else if(!c._.length&&!c["folder-uri"]&&!c["file-uri"]){let s=!1;if(c["new-window"]||c["unity-launch"])s=!0;else if(c["reuse-window"])s=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":s=!0;break;case"off":s=!1;break;default:s=!C.isMacintosh}if(s)o=this.windowsMainService.open({...i,forceNewWindow:!0,forceEmpty:!0});else{const u=this.windowsMainService.getLastActiveWindow();u?(this.windowsMainService.openExistingWindow(u,i),o=[u]):o=this.windowsMainService.open({...i,forceEmpty:!0})}}else o=this.windowsMainService.open({...i,forceNewWindow:c["new-window"],preferNewWindow:!c["reuse-window"]&&!c.wait,forceReuseWindow:c["reuse-window"],diffMode:c.diff,addMode:c.add,noRecentEntry:!!c["skip-add-to-recently-opened"],gotoLineMode:c.goto});if(h&&o.length===1&&o[0])return Promise.race([o[0].whenClosedOrLoaded,(0,d.whenDeleted)(h.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const c=[];return p.BrowserWindow.getAllWindows().forEach(a=>{const l=this.windowsMainService.getWindowById(a.id);l?c.push(this.codeWindowToInfo(l)):c.push(this.browserWindowToInfo(a))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:c,screenReader:!!p.app.accessibilitySupportEnabled,gpuFeatureStatus:p.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(c){const a=this.windowsMainService.getWindows();return(await Promise.all(a.map(o=>new Promise(h=>{const n=o.remoteAuthority;if(n){const i=`vscode:getDiagnosticInfoResponse${o.id}`,s={includeProcesses:c.includeProcesses,folders:c.includeWorkspaceMetadata?this.getFolderURIs(o):void 0};o.sendWhenReady("vscode:getDiagnosticInfo",D.CancellationToken.None,{replyChannel:i,args:s}),p.ipcMain.once(i,(u,m)=>{m||h({hostName:n,errorMessage:`Unable to resolve connection to '${n}'.`}),h(m)}),setTimeout(()=>{h({hostName:n,errorMessage:`Fetching remote diagnostics for '${n}' timed out.`})},5e3)}else h(void 0)})))).filter(o=>!!o)}getFolderURIs(c){const a=[],l=c.openedWorkspace;if((0,f.isSingleFolderWorkspaceIdentifier)(l))a.push(l.uri);else if((0,f.isWorkspaceIdentifier)(l)){const o=this.workspacesManagementMainService.resolveLocalWorkspaceSync(l.configPath);o&&o.folders.forEach(n=>{a.push(n.uri)})}return a}codeWindowToInfo(c){const a=this.getFolderURIs(c),l=(0,k.assertIsDefined)(c.win);return this.browserWindowToInfo(l,a,c.remoteAuthority)}browserWindowToInfo(c,a=[],l){return{pid:c.webContents.getOSProcessId(),title:c.getTitle(),folderURIs:a,remoteAuthority:l}}};b=fe([ie(0,w.ILogService),ie(1,t.IWindowsMainService),ie(2,v.IURLService),ie(3,y.IWorkspacesManagementMainService),ie(4,g.IConfigurationService)],b),e.LaunchMainService=b}),define(x[50],ee([0,1,44,14,26,116,46,4,33,2,10,8,3,7,81,71,21,150,49,24,5,20,6,22,29,66,35,30,45]),function(j,e,p,r,D,C,k,I,d,g,S,E,w,v,t,f,y,b,P,c,a,l,o,h,n,i,s,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,a.createDecorator)("nativeHostMainService");let M=class ft extends g.Disposable{constructor(R,T,_,Q,se,re,G,X,B,$){super();this.sharedProcess=R,this.windowsMainService=T,this.dialogMainService=_,this.lifecycleMainService=Q,this.environmentMainService=se,this.telemetryService=re,this.logService=G,this.productService=X,this.themeMainService=B,this.workspacesManagementMainService=$,this.onDidOpenWindow=I.Event.map(this.windowsMainService.onDidOpenWindow,Y=>Y.id),this.onDidMaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(r.app,"browser-window-maximize",(Y,V)=>V.id),Y=>!!this.windowsMainService.getWindowById(Y)),this.onDidUnmaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(r.app,"browser-window-unmaximize",(Y,V)=>V.id),Y=>!!this.windowsMainService.getWindowById(Y)),this.onDidBlurWindow=I.Event.filter(I.Event.fromNodeEventEmitter(r.app,"browser-window-blur",(Y,V)=>V.id),Y=>!!this.windowsMainService.getWindowById(Y)),this.onDidFocusWindow=I.Event.any(I.Event.map(I.Event.filter(I.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),Y=>!!Y),Y=>Y.id),I.Event.filter(I.Event.fromNodeEventEmitter(r.app,"browser-window-focus",(Y,V)=>V.id),Y=>!!this.windowsMainService.getWindowById(Y))),this.onDidResumeOS=I.Event.fromNodeEventEmitter(r.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new I.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new I.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=I.Event.debounce(I.Event.any(I.Event.filter(I.Event.fromNodeEventEmitter(r.screen,"display-metrics-changed",(Y,V,q)=>q),Y=>!(Array.isArray(Y)&&Y.length===1&&Y[0]==="workArea")),I.Event.fromNodeEventEmitter(r.screen,"display-added"),I.Event.fromNodeEventEmitter(r.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){r.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.osColorScheme)})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(T=>({id:T.id,workspace:T.openedWorkspace,title:T.win?.getTitle()??"",filename:T.getRepresentedFilename(),dirty:T.isDocumentEdited()}))}async getWindowCount(R){return this.windowsMainService.getWindowCount()}async getActiveWindowId(R){const T=r.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(T)return T.id}openWindow(R,T,_){return Array.isArray(T)?this.doOpenWindow(R,T,_):this.doOpenEmptyWindow(R,T)}async doOpenWindow(R,T,_=Object.create(null)){T.length>0&&this.windowsMainService.open({context:5,contextWindowId:R,urisToOpen:T,cli:this.environmentMainService.args,forceNewWindow:_.forceNewWindow,forceReuseWindow:_.forceReuseWindow,preferNewWindow:_.preferNewWindow,diffMode:_.diffMode,addMode:_.addMode,gotoLineMode:_.gotoLineMode,noRecentEntry:_.noRecentEntry,waitMarkerFileURI:_.waitMarkerFileURI,remoteAuthority:_.remoteAuthority||void 0})}async doOpenEmptyWindow(R,T){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:R},T)}async toggleFullScreen(R){const T=this.windowById(R);T&&T.toggleFullScreen()}async handleTitleDoubleClick(R){const T=this.windowById(R);T&&T.handleTitleDoubleClick()}async isMaximized(R){const T=this.windowById(R);return T?.win?T.win.isMaximized():!1}async maximizeWindow(R){const T=this.windowById(R);T?.win&&T.win.maximize()}async unmaximizeWindow(R){const T=this.windowById(R);T?.win&&T.win.unmaximize()}async minimizeWindow(R){const T=this.windowById(R);T?.win&&T.win.minimize()}async focusWindow(R,T){T&&typeof T.windowId=="number"&&(R=T.windowId);const _=this.windowById(R);_&&_.focus({force:T?.force??!1})}async setMinimumSize(R,T,_){const Q=this.windowById(R);if(Q?.win){const[se,re]=Q.win.getSize(),[G,X]=Q.win.getMinimumSize(),[B,$]=[T??G,_??X],[Y,V]=[Math.max(se,B),Math.max(re,$)];(G!==B||X!==$)&&Q.win.setMinimumSize(B,$),(se!==Y||re!==V)&&Q.win.setSize(Y,V)}}async saveWindowSplash(R,T){this.themeMainService.saveWindowSplash(R,T)}async installShellCommand(R){const{source:T,target:_}=await this.getShellCommandLink();try{const{symbolicLink:Q}=await y.SymlinkSupport.stat(T);if(Q&&!Q.dangling){const se=await(0,t.realpath)(T);if(_===se)return}await y.Promises.unlink(T)}catch(Q){if(Q.code!=="ENOENT")throw Q}try{await y.Promises.symlink(_,T)}catch(Q){if(Q.code!=="EACCES"&&Q.code!=="ENOENT")throw Q;const{response:se}=await this.showMessageBox(R,{title:this.productService.nameLong,type:"info",message:(0,b.localize)(0,null,this.productService.nameShort),buttons:[(0,d.mnemonicButtonLabel)((0,b.localize)(1,null)),(0,d.mnemonicButtonLabel)((0,b.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(se===0)try{const re=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${_}' '${T}'\\" with administrator privileges"`;await(0,C.promisify)(p.exec)(re)}catch{throw new Error((0,b.localize)(3,null,T))}}}async uninstallShellCommand(R){const{source:T}=await this.getShellCommandLink();try{await y.Promises.unlink(T)}catch(_){switch(_.code){case"EACCES":{const{response:Q}=await this.showMessageBox(R,{title:this.productService.nameLong,type:"info",message:(0,b.localize)(4,null,this.productService.nameShort),buttons:[(0,d.mnemonicButtonLabel)((0,b.localize)(5,null)),(0,d.mnemonicButtonLabel)((0,b.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(Q===0)try{const se=`osascript -e "do shell script \\"rm '${T}'\\" with administrator privileges"`;await(0,C.promisify)(p.exec)(se)}catch{throw new Error((0,b.localize)(7,null,T))}break}case"ENOENT":break;default:throw _}}}async getShellCommandLink(){const R=(0,E.resolve)(this.environmentMainService.appRoot,"bin","code"),T=`/usr/local/bin/${this.productService.applicationName}`;if(!await y.Promises.exists(R))throw new Error((0,b.localize)(8,null,R));return{source:T,target:R}}async showMessageBox(R,T){return this.dialogMainService.showMessageBox(T,this.toBrowserWindow(R))}async showSaveDialog(R,T){return this.dialogMainService.showSaveDialog(T,this.toBrowserWindow(R))}async showOpenDialog(R,T){return this.dialogMainService.showOpenDialog(T,this.toBrowserWindow(R))}toBrowserWindow(R){const T=this.windowById(R);if(T?.win)return T.win}async pickFileFolderAndOpen(R,T){const _=await this.dialogMainService.pickFileFolder(T);_&&(this.sendPickerTelemetry(_,T.telemetryEventName||"openFileFolder",T.telemetryExtraData),this.doOpenPicked(await Promise.all(_.map(async Q=>await y.SymlinkSupport.existsDirectory(Q)?{folderUri:v.URI.file(Q)}:{fileUri:v.URI.file(Q)})),T,R))}async pickFolderAndOpen(R,T){const _=await this.dialogMainService.pickFolder(T);_&&(this.sendPickerTelemetry(_,T.telemetryEventName||"openFolder",T.telemetryExtraData),this.doOpenPicked(_.map(Q=>({folderUri:v.URI.file(Q)})),T,R))}async pickFileAndOpen(R,T){const _=await this.dialogMainService.pickFile(T);_&&(this.sendPickerTelemetry(_,T.telemetryEventName||"openFile",T.telemetryExtraData),this.doOpenPicked(_.map(Q=>({fileUri:v.URI.file(Q)})),T,R))}async pickWorkspaceAndOpen(R,T){const _=await this.dialogMainService.pickWorkspace(T);_&&(this.sendPickerTelemetry(_,T.telemetryEventName||"openWorkspace",T.telemetryExtraData),this.doOpenPicked(_.map(Q=>({workspaceUri:v.URI.file(Q)})),T,R))}doOpenPicked(R,T,_){this.windowsMainService.open({context:3,contextWindowId:_,cli:this.environmentMainService.args,urisToOpen:R,forceNewWindow:T.forceNewWindow})}sendPickerTelemetry(R,T,_){const Q=R?R.length:0;this.telemetryService.publicLog(T,{..._,outcome:Q?"success":"canceled",numberOfPaths:Q})}async showItemInFolder(R,T){r.shell.showItemInFolder(T)}async setRepresentedFilename(R,T){const _=this.windowById(R);_&&_.setRepresentedFilename(T)}async setDocumentEdited(R,T){const _=this.windowById(R);_&&_.setDocumentEdited(T)}async openExternal(R,T){return w.isLinuxSnap?this.safeSnapOpenExternal(T):r.shell.openExternal(T),!0}safeSnapOpenExternal(R){const T=process.env.GDK_PIXBUF_MODULE_FILE,_=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,r.shell.openExternal(R),process.env.GDK_PIXBUF_MODULE_FILE=T,process.env.GDK_PIXBUF_MODULEDIR=_}moveItemToTrash(R,T){return r.shell.trashItem(T)}async isAdmin(){let R;return w.isWindows?R=(await new Promise((T,_)=>{j(["native-is-elevated"],T,_)}))():R=process.getuid()===0,R}async writeElevated(R,T,_,Q){const se=await new Promise((re,G)=>{j(["@vscode/sudo-prompt"],re,G)});return new Promise((re,G)=>{const X=[`"${this.cliPath}"`];Q?.unlock&&X.push("--file-chmod"),X.push("--file-write",`"${T.fsPath}"`,`"${_.fsPath}"`);const B={name:this.productService.nameLong.replace("-",""),icns:w.isMacintosh&&this.environmentMainService.isBuilt?(0,E.join)((0,E.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};se.exec(X.join(" "),B,($,Y,V)=>{Y&&this.logService.trace(`[sudo-prompt] received stdout: ${Y}`),V&&this.logService.trace(`[sudo-prompt] received stderr: ${V}`),$?G($):re(void 0)})})}get cliPath(){return w.isWindows?this.environmentMainService.isBuilt?(0,E.join)((0,E.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,E.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):w.isLinux?this.environmentMainService.isBuilt?(0,E.join)((0,E.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,E.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,E.join)(this.environmentMainService.appRoot,"bin","code"):(0,E.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,D.totalmem)(),freemem:(0,D.freemem)(),loadavg:(0,D.loadavg)()}}async getOSProperties(){return{arch:(0,D.arch)(),platform:(0,D.platform)(),release:(0,D.release)(),type:(0,D.type)(),cpus:(0,D.cpus)()}}async getOSVirtualMachineHint(){return f.virtualMachineHint.value()}get osColorScheme(){return{highContrast:r.nativeTheme.shouldUseInvertedColorScheme||r.nativeTheme.shouldUseHighContrastColors,dark:r.nativeTheme.shouldUseDarkColors}}async getOSColorScheme(){return this.osColorScheme}async killProcess(R,T,_){process.kill(T,_)}async readClipboardText(R,T){return r.clipboard.readText(T)}async writeClipboardText(R,T,_){return r.clipboard.writeText(T,_)}async readClipboardFindText(R){return r.clipboard.readFindText()}async writeClipboardFindText(R,T){return r.clipboard.writeFindText(T)}async writeClipboardBuffer(R,T,_,Q){return r.clipboard.writeBuffer(T,Buffer.from(_),Q)}async readClipboardBuffer(R,T){return r.clipboard.readBuffer(T)}async hasClipboard(R,T,_){return r.clipboard.has(T,_)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){r.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){r.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){r.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){r.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){r.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(R,T){const _=this.windowById(R);_&&_.updateTouchBar(T)}async notifyReady(R){const T=this.windowById(R);T&&T.setReady()}async relaunch(R,T){return this.lifecycleMainService.relaunch(T)}async reload(R,T){const _=this.windowById(R);if(_){if((0,u.isWorkspaceIdentifier)(_.openedWorkspace)){const Q=_.openedWorkspace.configPath;if(Q.scheme===S.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(Q))?.transient)return this.openWindow(_.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(_,T?.disableExtensions!==void 0?{_:[],"disable-extensions":T.disableExtensions}:void 0)}}async closeWindow(R){this.closeWindowById(R,R)}async closeWindowById(R,T){const _=this.windowById(T);if(_?.win)return _.win.close()}async quit(R){const T=this.windowsMainService.getLastActiveWindow();T?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&T.win?T.win.close():this.lifecycleMainService.quit()}async exit(R,T){await this.lifecycleMainService.kill(T)}async resolveProxy(R,T){const Q=this.windowById(R)?.win?.webContents?.session;if(Q)return Q.resolveProxy(T)}async openDevTools(R,T){const _=this.windowById(R);_?.win&&_.win.webContents.openDevTools(T)}async toggleDevTools(R){const T=this.windowById(R);T?.win&&T.win.webContents.toggleDevTools()}async sendInputEvent(R,T){const _=this.windowById(R);_?.win&&(T.type==="mouseDown"||T.type==="mouseUp")&&_.win.webContents.sendInputEvent(T)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(R,T,_,Q){if(!w.isWindows)return;const se=await new Promise((re,G)=>{j(["vscode-windows-registry"],re,G)});try{return se.GetStringRegKey(T,_,Q)}catch{return}}async getPassword(R,T,_){const Q=await this.withKeytar(),se=await Q.getPassword(T,_);if(se)try{let{content:re,hasNextChunk:G}=JSON.parse(se);if(!re||!G)return se;let X=1;for(;G;){const B=await Q.getPassword(T,`${_}-${X}`),$=JSON.parse(B);re+=$.content,G=$.hasNextChunk,X++}return re}catch{return se}return se}async setPassword(R,T,_,Q){const se=await this.withKeytar(),re=3,G=async(X,B,$)=>{let Y=0,V;for(;Y<re;)try{await se.setPassword(X,B,$);return}catch(q){V=q,this.logService.warn("Error attempting to set a password: ",q),Y++,await new Promise(Z=>setTimeout(Z,200))}throw V};if(w.isWindows&&Q.length>ft.MAX_PASSWORD_LENGTH){let X=0,B=0,$=!0;for(;$;){const Y=Q.substring(X,X+ft.PASSWORD_CHUNK_SIZE);X+=ft.PASSWORD_CHUNK_SIZE,$=Q.length-X>0;const V={content:Y,hasNextChunk:$};await G(T,B?`${_}-${B}`:_,JSON.stringify(V)),B++}}else await G(T,_,Q);this._onDidChangePassword.fire({service:T,account:_})}async deletePassword(R,T,_){const se=await(await this.withKeytar()).deletePassword(T,_);return se&&this._onDidChangePassword.fire({service:T,account:_}),se}async findPassword(R,T){return(await this.withKeytar()).findPassword(T)}async findCredentials(R,T){return(await this.withKeytar()).findCredentials(T)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((R,T)=>{j(["keytar"],R,T)})}windowById(R){if(typeof R=="number")return this.windowsMainService.getWindowById(R)}};M.MAX_PASSWORD_LENGTH=2500,M.PASSWORD_CHUNK_SIZE=M.MAX_PASSWORD_LENGTH-100,fe([k.memoize],M.prototype,"cliPath",null),M=fe([ie(1,s.IWindowsMainService),ie(2,P.IDialogMainService),ie(3,l.ILifecycleMainService),ie(4,c.IEnvironmentMainService),ie(5,n.ITelemetryService),ie(6,o.ILogService),ie(7,h.IProductService),ie(8,i.IThemeMainService),ie(9,m.IWorkspacesManagementMainService)],M),e.NativeHostMainService=M}),define(x[235],ee([0,1,14,23,4,80,2,27,87,6,50,22,35]),function(j,e,p,r,D,C,k,I,d,g,S,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var v;(function(f){f[f.Initial=1]="Initial",f[f.StoredCredentialsUsed=2]="StoredCredentialsUsed",f[f.LoginDialogShown=3]="LoginDialogShown"})(v||(v={}));let t=class extends k.Disposable{constructor(y,b,P,c,a){super();this.logService=y,this.windowsMainService=b,this.nativeHostMainService=P,this.encryptionMainService=c,this.productService=a,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=v.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const y=D.Event.fromNodeEventEmitter(p.app,"login",(b,P,c,a,l)=>({event:b,webContents:P,req:c,authInfo:a,callback:l}));this._register(y(this.onLogin,this))}async onLogin({event:y,authInfo:b,req:P,callback:c}){if(!b.isProxy)return;if(!this.pendingProxyResolve&&this.state===v.LoginDialogShown&&P.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}y.preventDefault();let a;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),a=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(b);try{a=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}c(a?.username,a?.password)}async resolveProxyCredentials(y){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const b=await this.doResolveProxyCredentials(y);if(b)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),b;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(y){this.logService.trace("auth#doResolveProxyCredentials - enter",y);const b=String((0,C.hash)({scheme:y.scheme,host:y.host,port:y.port}));let P,c;try{const h=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,b);if(h){const n=JSON.parse(await this.encryptionMainService.decrypt(h));P=n.username,c=n.password}}catch(h){this.logService.error(h)}if(this.state!==v.StoredCredentialsUsed&&typeof P=="string"&&typeof c=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=v.StoredCredentialsUsed,{username:P,password:c};const a=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!a){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${a.id} to handle proxy login`);const l={authInfo:y,username:this.sessionCredentials?.username??P,password:this.sessionCredentials?.password??c,replyChannel:`vscode:proxyAuthResponse:${(0,I.generateUuid)()}`};a.sendWhenReady("vscode:openProxyAuthenticationDialog",r.CancellationToken.None,l),this.state=v.LoginDialogShown;const o=await new Promise(h=>{const n=async(i,s,u)=>{if(s===l.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${a.id}`),a.win?.webContents.off("ipc-message",n),u){const m={username:u.username,password:u.password};try{if(u.remember){const M=await this.encryptionMainService.encrypt(JSON.stringify(m));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,b,M)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,b)}catch(M){this.logService.error(M)}h({username:m.username,password:m.password})}else h(void 0)};a.win?.webContents.on("ipc-message",n)});return this.sessionCredentials=o,o}};t=fe([ie(0,g.ILogService),ie(1,w.IWindowsMainService),ie(2,S.INativeHostMainService),ie(3,d.IEncryptionMainService),ie(4,E.IProductService)],t),e.ProxyAuthHandler=t}),define(x[236],ee([0,1,14,26,33,2,10,3,82,148,74,49,24,5,101,6,50,55,22,56,67]),function(j,e,p,r,D,C,k,I,d,g,S,E,w,v,t,f,y,b,P,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,v.createDecorator)("issueMainService");let l=class Pt{constructor(h,n,i,s,u,m,M,L,R){this.userEnv=h,this.environmentMainService=n,this.launchMainService=i,this.logService=s,this.diagnosticsService=u,this.dialogMainService=m,this.nativeHostMainService=M,this.protocolMainService=L,this.productService=R,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){p.ipcMain.on("vscode:issueSystemInfoRequest",async h=>{const[n,i]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),s=await this.diagnosticsService.getSystemInfo(n,i);this.safeSend(h,"vscode:issueSystemInfoResponse",s)}),p.ipcMain.on("vscode:listProcesses",async h=>{const n=[];try{const i=await this.launchMainService.getMainProcessId();n.push({name:(0,g.localize)(0,null),rootProcess:await(0,d.listProcesses)(i)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(u=>{(0,S.isRemoteDiagnosticError)(u)?n.push({name:u.hostName,rootProcess:u}):u.processes&&n.push({name:u.hostName,rootProcess:u.processes})})}catch(i){this.logService.error(`Listing processes failed: ${i}`)}this.safeSend(h,"vscode:listProcessesResponse",n)}),p.ipcMain.on("vscode:issueReporterClipboard",async h=>{const n={title:this.productService.nameLong,message:(0,g.localize)(1,null),type:"warning",buttons:[(0,D.mnemonicButtonLabel)((0,g.localize)(2,null)),(0,D.mnemonicButtonLabel)((0,g.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const i=await this.dialogMainService.showMessageBox(n,this.issueReporterWindow);this.safeSend(h,"vscode:issueReporterClipboardResponse",i.response===0)}}),p.ipcMain.on("vscode:issuePerformanceInfoRequest",async h=>{const n=await this.getPerformanceInfo();this.safeSend(h,"vscode:issuePerformanceInfoResponse",n)}),p.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const h={title:this.productService.nameLong,message:(0,g.localize)(4,null),type:"warning",buttons:[(0,D.mnemonicButtonLabel)((0,g.localize)(5,null)),(0,D.mnemonicButtonLabel)((0,g.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(h,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),p.ipcMain.on("vscode:workbenchCommand",(h,n)=>{const{id:i,from:s,args:u}=n;let m;switch(s){case"issueReporter":m=this.issueReporterParentWindow;break;case"processExplorer":m=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${s}`)}m&&m.webContents.send("vscode:runAction",{id:i,from:s,args:u})}),p.ipcMain.on("vscode:openExternal",(h,n)=>{this.nativeHostMainService.openExternal(void 0,n)}),p.ipcMain.on("vscode:closeIssueReporter",h=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),p.ipcMain.on("vscode:closeProcessExplorer",h=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),p.ipcMain.on("vscode:windowsInfoRequest",async h=>{const n=await this.launchMainService.getMainProcessInfo();this.safeSend(h,"vscode:windowsInfoResponse",n.windows)})}safeSend(h,n,...i){h.sender.isDestroyed()||h.sender.send(n,...i)}async openReporter(h){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=p.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const n=new C.DisposableStore,i=n.add(this.protocolMainService.createIPCObjectUrl()),s=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(s,i,{backgroundColor:h.styles.backgroundColor,title:(0,g.localize)(7,null),zoomLevel:h.zoomLevel,alwaysOnTop:!1},"issue-reporter"),i.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:h,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,r.type)(),arch:(0,r.arch)(),release:(0,r.release)()},product:b.default}),this.issueReporterWindow.loadURL(k.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",j).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,n.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,n.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(h){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=p.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const n=new C.DisposableStore,i=n.add(this.protocolMainService.createIPCObjectUrl()),s=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(s,i,{backgroundColor:h.styles.backgroundColor,title:(0,g.localize)(8,null),zoomLevel:h.zoomLevel,alwaysOnTop:!0},"process-explorer"),i.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:h,product:b.default}),this.processExplorerWindow.loadURL(k.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",j).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,n.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,n.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(h){h.isMinimized()&&h.restore(),h.focus()}createBrowserWindow(h,n,i,s){const u=new p.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:h.width,height:h.height,minWidth:300,minHeight:200,x:h.x,y:h.y,title:i.title,backgroundColor:i.backgroundColor||Pt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:k.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${n.resource.toString()}`,`--vscode-window-kind=${s}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,a.zoomLevelToZoomFactor)(i.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:i.alwaysOnTop});return u.setMenuBarVisibility(!1),u}async getSystemStatus(){const[h,n]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(h,n)}getWindowPosition(h,n,i){let s;const u=p.screen.getAllDisplays();if(u.length===1)s=u[0];else{if(I.isMacintosh){const L=p.screen.getCursorScreenPoint();s=p.screen.getDisplayNearestPoint(L)}!s&&h&&(s=p.screen.getDisplayMatching(h.getBounds())),s||(s=p.screen.getPrimaryDisplay()||u[0])}const m={width:n,height:i},M=s.bounds;return m.x=M.x+M.width/2-m.width/2,m.y=M.y+M.height/2-m.height/2,M.width>0&&M.height>0&&(m.x<M.x&&(m.x=M.x),m.y<M.y&&(m.y=M.y),m.x>M.x+M.width&&(m.x=M.x),m.y>M.y+M.height&&(m.y=M.y),m.width>M.width&&(m.width=M.width),m.height>M.height&&(m.height=M.height)),m}async getPerformanceInfo(){try{const[h,n]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(h,n)}catch(h){throw this.logService.warn("issueService#getPerformanceInfo ",h.message),h}}};l.DEFAULT_BACKGROUND_COLOR="#1E1E1E",l=fe([ie(1,w.IEnvironmentMainService),ie(2,t.ILaunchMainService),ie(3,f.ILogService),ie(4,S.IDiagnosticsService),ie(5,E.IDialogMainService),ie(6,y.INativeHostMainService),ie(7,c.IProtocolMainService),ie(8,P.IProductService)],l),e.IssueMainService=l}),define(x[237],ee([0,1,23,19,24,20,6,50,22,48,29,41,77]),function(j,e,p,r,D,C,k,I,d,g,S,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let v=class extends w.AbstractUpdateService{constructor(f,y,b,P,c,a,l,o){super(f,y,P,c,a,o);this.telemetryService=b,this.nativeHostMainService=l}buildUpdateFeedUrl(f){return(0,w.createUpdateURL)(`linux-${process.arch}`,f,this.productService)}doCheckForUpdates(f){!this.url||(this.setState(E.State.CheckingForUpdates(f)),this.requestService.request({url:this.url},p.CancellationToken.None).then(g.asJson).then(y=>{!y||!y.url||!y.version||!y.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!f}),this.setState(E.State.Idle(1))):this.setState(E.State.AvailableForDownload(y))}).then(void 0,y=>{this.logService.error(y),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!f});const b=f?y.message||y:void 0;this.setState(E.State.Idle(1,b))}))}async doDownloadUpdate(f){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):f.update.url&&this.nativeHostMainService.openExternal(void 0,f.update.url),this.setState(E.State.Idle(1))}};v=fe([ie(0,C.ILifecycleMainService),ie(1,r.IConfigurationService),ie(2,S.ITelemetryService),ie(3,D.IEnvironmentMainService),ie(4,g.IRequestService),ie(5,k.ILogService),ie(6,I.INativeHostMainService),ie(7,d.IProductService)],v),e.LinuxUpdateService=v}),define(x[238],ee([0,1,44,28,26,9,23,46,8,7,113,21,19,24,18,20,6,50,22,48,29,41,77]),function(j,e,p,r,D,C,k,I,d,g,S,E,w,v,t,f,y,b,P,c,a,l,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function h(u,m=1e3){for(;!u();)await(0,C.timeout)(m)}let n;function i(){return typeof n=="undefined"&&(n=r.existsSync(d.join(d.dirname(process.execPath),"unins000.exe"))?0:1),n}let s=class extends o.AbstractUpdateService{constructor(m,M,L,R,T,_,Q,se,re){super(m,M,R,T,_,re);this.telemetryService=L,this.fileService=Q,this.nativeHostMainService=se}get cachePath(){const m=d.join((0,D.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return E.Promises.mkdir(m,{recursive:!0}).then(()=>m)}initialize(){super.initialize(),i()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(m){let M="win32";return process.arch!=="ia32"&&(M+=`-${process.arch}`),i()===1?M+="-archive":this.productService.target==="user"&&(M+="-user"),(0,o.createUpdateURL)(M,m,this.productService)}doCheckForUpdates(m){!this.url||(this.setState(l.State.CheckingForUpdates(m)),this.requestService.request({url:this.url},k.CancellationToken.None).then(c.asJson).then(M=>{const L=i();return!M||!M.url||!M.version||!M.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m}),this.setState(l.State.Idle(L)),Promise.resolve(null)):L===1?(this.setState(l.State.AvailableForDownload(M)),Promise.resolve(null)):(this.setState(l.State.Downloading(M)),this.cleanup(M.version).then(()=>this.getUpdatePackagePath(M.version).then(R=>E.Promises.exists(R).then(T=>{if(T)return Promise.resolve(R);const _=M.url,Q=M.hash,se=`${R}.tmp`;return this.requestService.request({url:_},k.CancellationToken.None).then(re=>this.fileService.writeFile(g.URI.file(se),re.stream)).then(Q?()=>(0,S.checksum)(se,M.hash):()=>{}).then(()=>E.Promises.rename(se,R)).then(()=>R)})).then(R=>{const T=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:R},T&&M.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(l.State.Downloaded(M)):this.setState(l.State.Ready(M))})))}).then(void 0,M=>{this.logService.error(M),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m});const L=m?M.message||M:void 0;this.setState(l.State.Idle(i(),L))}))}async doDownloadUpdate(m){m.update.url&&this.nativeHostMainService.openExternal(void 0,m.update.url),this.setState(l.State.Idle(i()))}async getUpdatePackagePath(m){const M=await this.cachePath;return d.join(M,`CodeSetup-${this.productService.quality}-${m}.exe`)}async cleanup(m=null){const M=m?_=>!new RegExp(`${this.productService.quality}-${m}\\.exe$`).test(_):()=>!0,L=await this.cachePath,T=(await E.Promises.readdir(L)).filter(M).map(async _=>{try{await E.Promises.unlink(d.join(L,_))}catch{}});await Promise.all(T)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const m=this.state.update;this.setState(l.State.Updating(m));const M=await this.cachePath;this.availableUpdate.updateFilePath=d.join(M,`CodeSetup-${this.productService.quality}-${m.version}.flag`),await E.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,p.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(l.State.Idle(i()))});const R=`${this.productService.win32MutexName}-ready`,T=await new Promise((_,Q)=>{j(["windows-mutex"],_,Q)});h(()=>T.isActive(R)).then(()=>this.setState(l.State.Ready(m)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?r.unlinkSync(this.availableUpdate.updateFilePath):(0,p.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return i()}};fe([I.memoize],s.prototype,"cachePath",null),s=fe([ie(0,f.ILifecycleMainService),ie(1,w.IConfigurationService),ie(2,a.ITelemetryService),ie(3,v.IEnvironmentMainService),ie(4,c.IRequestService),ie(5,y.ILogService),ie(6,t.IFileService),ie(7,b.INativeHostMainService),ie(8,P.IProductService)],s),e.Win32UpdateService=s}),define(x[239],ee([0,1,14,9,23,39,4,33,2,10,8,63,3,7,154,52,19,49,24,54,205,18,20,6,22,56,98,29,208,66,67,35,30,45]),function(j,e,p,r,D,C,k,I,d,g,S,E,w,v,t,f,y,b,P,c,a,l,o,h,n,i,s,u,m,M,L,R,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var Q;(function(re){re[re.NONE=0]="NONE",re[re.LOADING=1]="LOADING",re[re.NAVIGATING=2]="NAVIGATING",re[re.READY=3]="READY"})(Q||(Q={}));let se=class extends d.Disposable{constructor(G,X,B,$,Y,V,q,Z,U,A,W,F,N,H,O){super();this.logService=X,this.environmentMainService=B,this.fileService=$,this.storageMainService=Y,this.configurationService=V,this.themeMainService=q,this.workspacesManagementMainService=Z,this.backupMainService=U,this.telemetryService=A,this.dialogMainService=W,this.lifecycleMainService=F,this.productService=N,this.protocolMainService=H,this.windowsMainService=O,this._onWillLoad=this._register(new k.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new k.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new k.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new k.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[z,te]=this.restoreWindowState(G.state);this.windowState=z,this.logService.trace("window#ctor: using window state",z);const ne=this.windowState.mode===0||this.windowState.mode===3,oe=this.configurationService.getValue("window"),J={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:L.WindowMinimumSize.WIDTH,minHeight:L.WindowMinimumSize.HEIGHT,show:!ne,title:this.productService.nameLong,webPreferences:{preload:g.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,L.zoomLevelToZoomFactor)(oe?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};w.isLinux?J.icon=(0,S.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):w.isWindows&&!this.environmentMainService.isBuilt&&(J.icon=(0,S.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),w.isMacintosh&&!this.useNativeFullScreen()&&(J.fullscreenable=!1),w.isMacintosh&&(J.acceptFirstMouse=!0,oe?.clickThroughInactive===!1&&(J.acceptFirstMouse=!1));const ce=w.isMacintosh&&oe?.nativeTabs===!0;ce&&(J.tabbingIdentifier=this.productService.nameShort);const le=(0,L.getTitleBarStyle)(this.configurationService)==="custom";if(le&&(J.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,w.isMacintosh||(J.frame=!1)),(0,E.mark)("code/willCreateCodeBrowserWindow"),this._win=new p.BrowserWindow(J),(0,E.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),w.isMacintosh&&le&&this._win.setSheetOffset(22),w.isMacintosh&&te&&(!ce||p.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(ue=>typeof ue=="number")){const ue=this.windowState;this._win.setBounds({width:ue.width,height:ue.height,x:ue.x,y:ue.y})}ne&&((0,E.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,E.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(G){w.isMacintosh?this._win.setRepresentedFilename(G):this.representedFilename=G}getRepresentedFilename(){return w.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(G){w.isMacintosh&&this._win.setDocumentEdited(G),this.documentEdited=G}isDocumentEdited(){return w.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(G){w.isMacintosh&&G?.force&&p.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(G=>{if(this.isReady)return G(this);this.whenReadyCallbacks.push(G)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(G=>{function X(){B.dispose(),$.dispose(),G()}const B=this.onDidClose(()=>X()),$=this.onWillLoad(()=>X())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(Y,V)=>this.onWindowError(2,V)),this._win.webContents.on("did-fail-load",(Y,V,q)=>this.onWindowError(3,{reason:q,exitCode:V})),this._win.webContents.on("will-prevent-unload",Y=>{Y.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const G=new Set([g.Schemas.file,g.Schemas.vscodeFileResource,g.Schemas.vscodeRemoteResource,"devtools"]),X=Y=>{for(let V=Y;V;V=V.parent)if(V.url.startsWith(`${g.Schemas.vscodeWebview}://`))return!0;return!1},B=Y=>Y.resourceType==="xhr"||X(Y.frame);this._win.webContents.session.webRequest.onBeforeRequest((Y,V)=>{const q=v.URI.parse(Y.url);return q.path.endsWith(".svg")&&!G.has(q.scheme)?V({cancel:!B(Y)}):V({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((Y,V)=>{const q=Y.responseHeaders,Z=q["content-type"]||q["Content-Type"];if(Z&&Array.isArray(Z)){const U=v.URI.parse(Y.url);if(U.path.endsWith(".svg")&&G.has(U.scheme))return q["Content-Type"]=["image/svg+xml"],V({cancel:!1,responseHeaders:q});if(!U.path.includes(g.Schemas.vscodeRemoteResource)&&Z.some(A=>A.toLowerCase().includes("image/svg")))return V({cancel:!B(Y)})}return V({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",Y=>{this.currentConfig&&(this.currentConfig.maximized=!0),p.app.emit("browser-window-maximize",Y,this._win)}),this._win.on("unmaximize",Y=>{this.currentConfig&&(this.currentConfig.maximized=!1),p.app.emit("browser-window-unmaximize",Y,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",D.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",D.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(Y=>this.onDidDeleteUntitledWorkspace(Y)));const $=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:$},async(Y,V)=>{const q=await this.getMarketplaceHeaders();V({cancel:!1,requestHeaders:Object.assign(Y.requestHeaders,q)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,a.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,{get:G=>this.storageMainService.globalStorage.get(G),store:(G,X)=>this.storageMainService.globalStorage.set(G,X)})),this.marketplaceHeadersPromise}async onWindowError(G,X){switch(G){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${X?.reason||"<unknown>"}, code: ${X?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${X?.reason||"<unknown>"}, code: ${X?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:G,reason:X?.reason,code:X?.exitCode}),G){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.driverHandle){this.destroyWindow(!1);return}if(G===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const B=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,t.localize)(0,null)),(0,I.mnemonicButtonLabel)((0,t.localize)(1,null)),(0,I.mnemonicButtonLabel)((0,t.localize)(2,null))],message:(0,t.localize)(3,null),detail:(0,t.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(B.response!==1){const $=B.response===0;this.destroyWindow($)}}else if(G===2){let B;X?B=(0,t.localize)(6,null,X.reason,X.exitCode??"<unknown>"):B=(0,t.localize)(5,null);const Y=(await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,t.localize)(7,null)),(0,I.mnemonicButtonLabel)((0,t.localize)(8,null))],message:B,detail:(0,t.localize)(9,null),noLink:!0,defaultId:0},this._win)).response===0;this.destroyWindow(Y)}break}}destroyWindow(G){if(this._onDidDestroy.fire(),this._win?.destroy(),G&&this.config){let X,B;(0,T.isSingleFolderWorkspaceIdentifier)(this.openedWorkspace)?X={folderUri:this.openedWorkspace.uri}:(0,T.isWorkspaceIdentifier)(this.openedWorkspace)?X={workspaceUri:this.openedWorkspace.configPath}:B=!0;const[$]=this.windowsMainService.open({context:5,userEnv:this.config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:X?[X]:void 0,forceEmpty:B,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});$.focus()}}onDidDeleteUntitledWorkspace(G){this.openedWorkspace?.id===G.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const G=this.getMenuBarVisibility();G!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=G,this.setMenuBarVisibility(G));let X=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;X?.endsWith("/")&&(X=X.substr(0,X.length-1));const B=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((X||"").indexOf("@")===-1&&(X!==this.currentHttpProxy||B!==this.currentNoProxy)){this.currentHttpProxy=X,this.currentNoProxy=B;const $=X||"",Y=B?`${B},<local>`:"<local>";this.logService.trace(`Setting proxy to '${$}', bypassing '${Y}'`),this._win.webContents.session.setProxy({proxyRules:$,proxyBypassRules:Y,pacScript:""})}}addTabbedWindow(G){w.isMacintosh&&G.win&&this._win.addTabbedWindow(G.win)}load(G,X=Object.create(null)){this.isDocumentEdited()&&(!X.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),X.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(G,X),this.readyState===0?this.currentConfig=G:(this.pendingLoadConfig=G,this.readyState=2),this._win.loadURL(g.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",j).toString(!0));const B=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new r.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:G.workspace,reason:X.isReload?3:B?2:1})}updateConfiguration(G,X){const B=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(B){const $=(0,c.isLaunchedFromCli)(B)&&!(0,c.isLaunchedFromCli)(G.userEnv),Y=this.isExtensionDevelopmentHost;($||Y)&&(G.userEnv={...B,...G.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(G.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),X.disableExtensions!==void 0&&(G["disable-extensions"]=X.disableExtensions),G.fullscreen=this.isFullScreen,G.maximized=this._win.isMaximized(),G.partsSplash=this.themeMainService.getWindowSplash(),(0,E.mark)("code/willOpenNewWindow"),G.perfMarks=(0,E.getMarks)(),this.configObjectUrl.update(G)}async reload(G){const X=Object.assign({},this.currentConfig);X.workspace=await this.validateWorkspaceBeforeReload(X),delete X.filesToOpenOrCreate,delete X.filesToDiff,delete X.filesToWait,this.isExtensionDevelopmentHost&&G&&(X.verbose=G.verbose,X.debugId=G.debugId,X.extensionEnvironment=G.extensionEnvironment,X["inspect-extensions"]=G["inspect-extensions"],X["inspect-brk-extensions"]=G["inspect-brk-extensions"],X["extensions-dir"]=G["extensions-dir"]),X.isInitialStartup=!1,this.load(X,{isReload:!0,disableExtensions:G?.["disable-extensions"]})}async validateWorkspaceBeforeReload(G){if((0,T.isWorkspaceIdentifier)(G.workspace)){const X=G.workspace.configPath;if(X.scheme===g.Schemas.file&&!await this.fileService.exists(X))return}else if((0,T.isSingleFolderWorkspaceIdentifier)(G.workspace)){const X=G.workspace.uri;if(X.scheme===g.Schemas.file&&!await this.fileService.exists(X))return}return G.workspace}serializeWindowState(){if(!this._win)return(0,R.defaultWindowState)();if(this.isFullScreen){let B;try{B=p.screen.getDisplayMatching(this.getBounds())}catch{}const $=(0,R.defaultWindowState)();return{mode:3,display:B?B.id:void 0,width:this.windowState.width||$.width,height:this.windowState.height||$.height,x:this.windowState.x||0,y:this.windowState.y||0}}const G=Object.create(null);let X;if(!w.isMacintosh&&this._win.isMaximized()?X=0:X=1,X===0?G.mode=0:G.mode=1,X===1||X===0){let B;X===1?B=this.getBounds():B=this._win.getNormalBounds(),G.x=B.x,G.y=B.y,G.width=B.width,G.height=B.height}return G}restoreWindowState(G){(0,E.mark)("code/willRestoreCodeWindowState");let X=!1;if(G)try{const B=p.screen.getAllDisplays();X=B.length>1,G=this.validateWindowState(G,B)}catch(B){this.logService.warn(`Unexpected error validating window state: ${B}
${B.stack}`)}return(0,E.mark)("code/didRestoreCodeWindowState"),[G||(0,R.defaultWindowState)(),X]}validateWindowState(G,X){if(this.logService.trace(`window#validateWindowState: validating window state on ${X.length} display(s)`,G),typeof G.x!="number"||typeof G.y!="number"||typeof G.width!="number"||typeof G.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(G.width<=0||G.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(X.length===1){const Y=this.getWorkingArea(X[0]);if(Y){let V=function(){!G||typeof G.x!="number"||typeof G.y!="number"||!Y||(G.x<Y.x&&(G.x=Y.x),G.y<Y.y&&(G.y=Y.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",Y),V(),G.width>Y.width&&(G.width=Y.width),G.height>Y.height&&(G.height=Y.height),G.x>Y.x+Y.width-128&&(G.x=Y.x+Y.width-G.width),G.y>Y.y+Y.height-128&&(G.y=Y.y+Y.height-G.height),V()}return G}if(G.display&&G.mode===3){const Y=X.find(V=>V.id===G.display);if(Y&&typeof Y.bounds?.x=="number"&&typeof Y.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const V=(0,R.defaultWindowState)(3);return V.x=Y.bounds.x,V.y=Y.bounds.y,V}}let B,$;try{B=p.screen.getDisplayMatching({x:G.x,y:G.y,width:G.width,height:G.height}),$=this.getWorkingArea(B)}catch{}if(B&&$&&G.x+G.width>$.x&&G.y+G.height>$.y&&G.x<$.x+$.width&&G.y<$.y+$.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",$),G}getWorkingArea(G){if(G.workArea.width>0&&G.workArea.height>0)return G.workArea;if(G.bounds.width>0&&G.bounds.height>0)return G.bounds}getBounds(){const[G,X]=this._win.getPosition(),[B,$]=this._win.getSize();return{x:G,y:X,width:B,height:$}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(G){this.useNativeFullScreen()?this.setNativeFullScreen(G):this.setSimpleFullScreen(G),this.sendWhenReady(G?"vscode:enterFullScreen":"vscode:leaveFullScreen",D.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(G){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(G)}setSimpleFullScreen(G){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(G),this._win.webContents.focus()}useNativeFullScreen(){const G=this.configurationService.getValue("window");return!G||typeof G.nativeFullScreen!="boolean"||G.nativeTabs?!0:G.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let G=(0,L.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(G)<0&&(G="classic"),G}setMenuBarVisibility(G,X=!0){w.isMacintosh||(G==="toggle"&&X&&this.send("vscode:showInfoMessage",(0,t.localize)(10,null)),G==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(G)}):this.doSetMenuBarVisibility(G))}doSetMenuBarVisibility(G){const X=this.isFullScreen;switch(G){case"classic":this._win.setMenuBarVisibility(!X),this._win.autoHideMenuBar=X;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(w.isMacintosh)switch(p.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(G,X,...B){this.isReady?this.send(G,...B):this.ready().then(()=>{X.isCancellationRequested||this.send(G,...B)})}send(G,...X){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${G}' for window that is destroyed`);return}try{this._win.webContents.send(G,...X)}catch(B){this.logService.warn(`Error sending IPC message to channel '${G}' of window ${this._id}: ${(0,C.toErrorMessage)(B)}`)}}}updateTouchBar(G){!w.isMacintosh||this.touchBarGroups.forEach((X,B)=>{const $=G[B];X.segments=this.createTouchBarGroupSegments($)})}createTouchBar(){if(!!w.isMacintosh){for(let G=0;G<10;G++){const X=this.createTouchBarGroup();this.touchBarGroups.push(X)}this._win.setTouchBar(new p.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(G=[]){const X=this.createTouchBarGroupSegments(G),B=new p.TouchBar.TouchBarSegmentedControl({segments:X,mode:"buttons",segmentStyle:"automatic",change:$=>{this.sendWhenReady("vscode:runAction",D.CancellationToken.None,{id:B.segments[$].id,from:"touchbar"})}});return B}createTouchBarGroupSegments(G=[]){return G.map(B=>{let $;B.icon&&!m.ThemeIcon.isThemeIcon(B.icon)&&B.icon?.dark?.scheme===g.Schemas.file&&($=p.nativeImage.createFromPath(v.URI.revive(B.icon.dark).fsPath),$.isEmpty()&&($=void 0));let Y;return typeof B.title=="string"?Y=B.title:Y=B.title.value,{id:B.id,label:$?void 0:Y,icon:$}})}dispose(){super.dispose(),this._win=null}};se=fe([ie(1,h.ILogService),ie(2,P.IEnvironmentMainService),ie(3,l.IFileService),ie(4,s.IStorageMainService),ie(5,y.IConfigurationService),ie(6,M.IThemeMainService),ie(7,_.IWorkspacesManagementMainService),ie(8,f.IBackupMainService),ie(9,u.ITelemetryService),ie(10,b.IDialogMainService),ie(11,o.ILifecycleMainService),ie(12,n.IProductService),ie(13,i.IProtocolMainService),ie(14,R.IWindowsMainService)],se),e.CodeWindow=se}),define(x[68],ee([0,1,14,31,9,4,33,2,10,3,16,7,21,157,5,20,6,38,30,45]),function(j,e,p,r,D,C,k,I,d,g,S,E,w,v,t,f,y,b,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,t.createDecorator)("workspacesHistoryMainService");let a=class Ve extends I.Disposable{constructor(o,h,n,i){super();this.stateMainService=o,this.logService=h,this.workspacesManagementMainService=n,this.lifecycleMainService=i,this._onDidChangeRecentlyOpened=this._register(new C.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new D.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(o=>this.addRecentlyOpened([{workspace:o.workspace,remoteAuthority:o.window.remoteAuthority}])))}handleWindowsJumpList(){!g.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(o){const h=[],n=[];for(let i of o)if((0,P.isRecentWorkspace)(i))!this.workspacesManagementMainService.isUntitledWorkspace(i.workspace)&&this.indexOfWorkspace(h,i.workspace)===-1&&h.push(i);else if((0,P.isRecentFolder)(i))this.indexOfFolder(h,i.folderUri)===-1&&h.push(i);else{const s=this.indexOfFile(n,i.fileUri)>=0,u=i.fileUri.scheme===d.Schemas.file&&Ve.COMMON_FILES_FILTER.indexOf((0,S.basename)(i.fileUri))>=0;!s&&!u&&(n.push(i),g.isWindows&&i.fileUri.scheme===d.Schemas.file&&p.app.addRecentDocument(i.fileUri.fsPath))}this.addEntriesFromStorage(h,n),h.length>Ve.MAX_TOTAL_RECENT_ENTRIES&&(h.length=Ve.MAX_TOTAL_RECENT_ENTRIES),n.length>Ve.MAX_TOTAL_RECENT_ENTRIES&&(n.length=Ve.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:h,files:n}),this._onDidChangeRecentlyOpened.fire(),g.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(o){const h=u=>{const m=this.location(u);for(const M of o)if(S.extUriBiasedIgnorePathCase.isEqual(M,m))return!1;return!0},n=this.getRecentlyOpened(),i=n.workspaces.filter(h),s=n.files.filter(h);(i.length!==n.workspaces.length||s.length!==n.files.length)&&(this.saveRecentlyOpened({files:s,workspaces:i}),this._onDidChangeRecentlyOpened.fire(),g.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!g.isMacintosh)return;p.app.clearRecentDocuments();const o=this.getRecentlyOpened(),h=[];let n=0;for(let s=0;s<o.workspaces.length&&n<Ve.MAX_MACOS_DOCK_RECENT_WORKSPACES;s++){const u=this.location(o.workspaces[s]);if(u.scheme===d.Schemas.file){const m=(0,S.originalFSPath)(u);await w.Promises.exists(m)&&(h.push(m),n++)}}const i=[];for(let s=0;s<o.files.length&&n<Ve.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;s++){const u=this.location(o.files[s]);if(u.scheme===d.Schemas.file){const m=(0,S.originalFSPath)(u);if(Ve.COMMON_FILES_FILTER.includes((0,S.basename)(u))||h.includes(m))continue;await w.Promises.exists(m)&&(i.push(m),n++)}}i.reverse().forEach(s=>p.app.addRecentDocument(s)),h.reverse().forEach(s=>p.app.addRecentDocument(s))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),p.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(o){const h=[],n=[];if(o){const s=o.config?.workspace;(0,P.isWorkspaceIdentifier)(s)&&!this.workspacesManagementMainService.isUntitledWorkspace(s)?h.push({workspace:s,remoteAuthority:o.remoteAuthority}):(0,P.isSingleFolderWorkspaceIdentifier)(s)&&h.push({folderUri:s.uri,remoteAuthority:o.remoteAuthority})}const i=o?.config?.filesToOpenOrCreate;if(i)for(let s of i){const u=s.fileUri;u&&this.indexOfFile(n,u)===-1&&n.push({fileUri:u})}return this.addEntriesFromStorage(h,n),{workspaces:h,files:n}}addEntriesFromStorage(o,h){let n=this.getRecentlyOpenedFromStorage();for(let i of n.workspaces){let s=(0,P.isRecentFolder)(i)?this.indexOfFolder(o,i.folderUri):this.indexOfWorkspace(o,i.workspace);s>=0?o[s].label=o[s].label||i.label:o.push(i)}for(let i of n.files){let s=this.indexOfFile(h,i.fileUri);s>=0?h[s].label=h[s].label||i.label:h.push(i)}}getRecentlyOpenedFromStorage(){const o=this.stateMainService.getItem(Ve.recentlyOpenedStorageKey);return(0,P.restoreRecentlyOpened)(o,this.logService)}saveRecentlyOpened(o){const h=(0,P.toStoreData)(o);this.stateMainService.setItem(Ve.recentlyOpenedStorageKey,h)}updateWindowsJumpList(){if(!g.isWindows)return;const o=[];if(o.push({type:"tasks",items:[{type:"task",title:(0,v.localize)(0,null),description:(0,v.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let h=[];for(let s of p.app.getJumpListSettings().removedItems){const u=s.args;if(u){const m=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(u);m&&h.push(E.URI.parse(m[2]))}}this.removeRecentlyOpened(h);let n=!1;const i=(0,r.coalesce)(this.getRecentlyOpened().workspaces.slice(0,Ve.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(s=>{const u=(0,P.isRecentWorkspace)(s)?s.workspace:s.folderUri,{title:m,description:M}=this.getWindowsJumpListLabel(u,s.label);let L;return E.URI.isUri(u)?L=`--folder-uri "${u.toString()}"`:(n=!0,L=`--file-uri "${u.configPath.toString()}"`),{type:"task",title:m.substr(0,255),description:M.substr(0,255),program:process.execPath,args:L,iconPath:"explorer.exe",iconIndex:0}}));i.length>0&&o.push({type:"custom",name:n?(0,v.localize)(2,null):(0,v.localize)(3,null),items:i})}o.push({type:"recent"});try{p.app.setJumpList(o)}catch(h){this.logService.warn("updateWindowsJumpList#setJumpList",h)}}getWindowsJumpListLabel(o,h){if(h)return{title:(0,k.splitName)(h).name,description:h};if(E.URI.isUri(o))return{title:(0,S.basename)(o),description:this.renderJumpListPathDescription(o)};if(this.workspacesManagementMainService.isUntitledWorkspace(o))return{title:(0,v.localize)(4,null),description:""};let n=(0,S.basename)(o.configPath);return n.endsWith(P.WORKSPACE_EXTENSION)&&(n=n.substr(0,n.length-P.WORKSPACE_EXTENSION.length-1)),{title:(0,v.localize)(5,null,n),description:this.renderJumpListPathDescription(o.configPath)}}renderJumpListPathDescription(o){return o.scheme==="file"?(0,k.normalizeDriveLetter)(o.fsPath):o.toString()}location(o){return(0,P.isRecentFolder)(o)?o.folderUri:(0,P.isRecentFile)(o)?o.fileUri:o.workspace.configPath}indexOfWorkspace(o,h){return o.findIndex(n=>(0,P.isRecentWorkspace)(n)&&n.workspace.id===h.id)}indexOfFolder(o,h){return o.findIndex(n=>(0,P.isRecentFolder)(n)&&S.extUriBiasedIgnorePathCase.isEqual(n.folderUri,h))}indexOfFile(o,h){return o.findIndex(n=>S.extUriBiasedIgnorePathCase.isEqual(n.fileUri,h))}};a.MAX_TOTAL_RECENT_ENTRIES=500,a.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,a.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,a.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,a.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],a.recentlyOpenedStorageKey="openedPathsList",a=fe([ie(0,b.IStateMainService),ie(1,y.ILogService),ie(2,c.IWorkspacesManagementMainService),ie(3,f.ILifecycleMainService)],a),e.WorkspacesHistoryMainService=a}),define(x[240],ee([0,1,14,9,23,33,3,7,149,19,24,20,6,187,50,22,38,29,41,67,35,68]),function(j,e,p,r,D,C,k,I,d,g,S,E,w,v,t,f,y,b,P,c,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const o="menu";let h=class St{constructor(s,u,m,M,L,R,T,_,Q,se,re){this.updateService=s,this.configurationService=u,this.windowsMainService=m,this.environmentMainService=M,this.telemetryService=L,this.workspacesHistoryMainService=R,this.stateMainService=T,this.lifecycleMainService=_,this.logService=Q,this.nativeHostMainService=se,this.productService=re,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new r.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new r.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(k.isMacintosh||(0,c.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const s=this.stateMainService.getItem(St.lastKnownMenubarStorageKey);s&&(s.menus&&(this.menubarMenus=s.menus),s.keybindings&&(this.keybindings=s.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(R,T,_)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:T?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(R,T,_)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:T?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(R,T,_)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(_),telemetryExtraData:{from:o}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(R,T,_)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(_),telemetryExtraData:{from:o}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const s=this.productService.twitterUrl;s&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(s,"openTwitterUrl"));const u=this.productService.requestFeatureUrl;u&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(u,"openUserVoiceUrl"));const m=this.productService.reportIssueUrl;m&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(m,"openReportIssues"));const M=this.productService.licenseUrl;M&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(k.language){const R=M.indexOf("?")>0?"&":"?";this.openUrl(`${M}${R}lang=${k.language}`,"openLicenseUrl")}else this.openUrl(M,"openLicenseUrl")});const L=this.productService.privacyStatementUrl;L&&M&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(L,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(s=>this.onDidChangeWindowsCount(s)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let s=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof s!="boolean"?!0:s}get currentEnableNativeTabs(){if(!k.isMacintosh)return!1;let s=this.configurationService.getValue("window.nativeTabs");return typeof s!="boolean"?!1:s}updateMenu(s,u){this.menubarMenus=s.menus,this.keybindings=s.keybindings,this.stateMainService.setItem(St.lastKnownMenubarStorageKey,s),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(s){!k.isMacintosh||(s.oldCount===0&&s.newCount>0||s.oldCount>0&&s.newCount===0)&&(this.closedLastWindow=s.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!k.isMacintosh||(this.noActiveWindow=!p.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const s=p.Menu.getApplicationMenu();if(s&&this.oldMenus.push(s),Object.keys(this.menubarMenus).length===0){p.Menu.setApplicationMenu(k.isMacintosh?new p.Menu:null);return}const u=new p.Menu;let m;if(k.isMacintosh){const L=new p.Menu;m=new p.MenuItem({label:this.productService.nameShort,submenu:L}),this.setMacApplicationMenu(L),u.append(m)}if(k.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const L=new p.Menu;L.append(new p.MenuItem({label:this.mnemonicLabel(d.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),p.app.dock.setMenu(L)}if(this.shouldDrawMenu("File")){const L=new p.Menu,R=new p.MenuItem({label:this.mnemonicLabel(d.localize(1,null)),submenu:L});this.setMenuById(L,"File"),u.append(R)}if(this.shouldDrawMenu("Edit")){const L=new p.Menu,R=new p.MenuItem({label:this.mnemonicLabel(d.localize(2,null)),submenu:L});this.setMenuById(L,"Edit"),u.append(R)}if(this.shouldDrawMenu("Selection")){const L=new p.Menu,R=new p.MenuItem({label:this.mnemonicLabel(d.localize(3,null)),submenu:L});this.setMenuById(L,"Selection"),u.append(R)}if(this.shouldDrawMenu("View")){const L=new p.Menu,R=new p.MenuItem({label:this.mnemonicLabel(d.localize(4,null)),submenu:L});this.setMenuById(L,"View"),u.append(R)}if(this.shouldDrawMenu("Go")){const L=new p.Menu,R=new p.MenuItem({label:this.mnemonicLabel(d.localize(5,null)),submenu:L});this.setMenuById(L,"Go"),u.append(R)}if(this.shouldDrawMenu("Run")){const L=new p.Menu,R=new p.MenuItem({label:this.mnemonicLabel(d.localize(6,null)),submenu:L});this.setMenuById(L,"Run"),u.append(R)}if(this.shouldDrawMenu("Terminal")){const L=new p.Menu,R=new p.MenuItem({label:this.mnemonicLabel(d.localize(7,null)),submenu:L});this.setMenuById(L,"Terminal"),u.append(R)}let M;if(this.shouldDrawMenu("Window")){const L=new p.Menu;M=new p.MenuItem({label:this.mnemonicLabel(d.localize(8,null)),submenu:L,role:"window"}),this.setMacWindowMenu(L)}if(M&&u.append(M),this.shouldDrawMenu("Help")){const L=new p.Menu,R=new p.MenuItem({label:this.mnemonicLabel(d.localize(9,null)),submenu:L,role:"help"});this.setMenuById(L,"Help"),u.append(R)}u.items&&u.items.length>0?p.Menu.setApplicationMenu(u):p.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(s){const u=this.createMenuItem(d.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),m=this.getUpdateMenuItems();let M;if(this.shouldDrawMenu("Preferences")){const G=new p.Menu;this.setMenuById(G,"Preferences"),M=new p.MenuItem({label:this.mnemonicLabel(d.localize(11,null)),submenu:G})}const L=new p.Menu,R=new p.MenuItem({label:d.localize(12,null),role:"services",submenu:L}),T=new p.MenuItem({label:d.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),_=new p.MenuItem({label:d.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),Q=new p.MenuItem({label:d.localize(15,null),role:"unhide"}),se=new p.MenuItem(this.likeAction("workbench.action.quit",{label:d.localize(16,null,this.productService.nameLong),click:()=>{const G=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!p.BrowserWindow.getFocusedWindow()||G?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),re=[u];re.push(...m),M&&re.push(n(),M),re.push(n(),R,n(),T,_,Q,n(),se),re.forEach(G=>s.append(G))}shouldDrawMenu(s){if(!k.isMacintosh&&(0,c.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(s){case"File":case"Help":if(k.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[s];case"Window":if(k.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[s]}}setMenu(s,u){u.forEach(m=>{if((0,v.isMenubarMenuItemSeparator)(m))s.append(n());else if((0,v.isMenubarMenuItemSubmenu)(m)){const M=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(m.label),submenu:M});this.setMenu(M,m.submenu.items),s.append(L)}else(0,v.isMenubarMenuItemRecentAction)(m)?s.append(this.createOpenRecentMenuItem(m)):(0,v.isMenubarMenuItemAction)(m)&&(m.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(s),k.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[m.id]?s.append(new p.MenuItem(this.likeAction(m.id,{label:this.mnemonicLabel(m.label),click:this.fallbackMenuHandlers[m.id]}))):s.append(this.createMenuItem(m.label,m.id,!1,m.checked)):s.append(this.createMenuItem(m.label,m.id,m.enabled!==!1,!!m.checked)):s.append(this.createMenuItem(m.label,m.id,m.enabled!==!1,!!m.checked)))})}setMenuById(s,u){this.menubarMenus&&this.menubarMenus[u]&&this.setMenu(s,this.menubarMenus[u].items)}insertCheckForUpdatesItems(s){const u=this.getUpdateMenuItems();u.length&&(u.forEach(m=>s.append(m)),s.append(n()))}createOpenRecentMenuItem(s){const u=I.URI.revive(s.uri),m=s.id,M=m==="openRecentFile"?{fileUri:u}:m==="openRecentWorkspace"?{workspaceUri:u}:{folderUri:u};return new p.MenuItem(this.likeAction(m,{label:s.label,click:(L,R,T)=>{const _=this.isOptionClick(T);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[M],forceNewWindow:_,gotoLineMode:!1,remoteAuthority:s.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([u])}},!1))}isOptionClick(s){return!!(s&&(!k.isMacintosh&&(s.ctrlKey||s.shiftKey)||k.isMacintosh&&(s.metaKey||s.altKey)))}createRoleMenuItem(s,u,m){const M={label:this.mnemonicLabel(s),role:m,enabled:!0};return new p.MenuItem(this.withKeybinding(u,M))}setMacWindowMenu(s){const u=new p.MenuItem({label:d.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),m=new p.MenuItem({label:d.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),M=new p.MenuItem({label:d.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),L=this.createMenuItem(d.localize(20,null),"workbench.action.switchWindow"),R=[];this.currentEnableNativeTabs&&(R.push(n()),R.push(this.createMenuItem(d.localize(21,null),"workbench.action.newWindowTab")),R.push(this.createRoleMenuItem(d.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),R.push(this.createRoleMenuItem(d.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),R.push(this.createRoleMenuItem(d.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),R.push(this.createRoleMenuItem(d.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[u,m,n(),L,...R,n(),M].forEach(T=>s.append(T))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new p.MenuItem({label:this.mnemonicLabel(d.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new p.MenuItem({label:d.localize(27,null),enabled:!1})];case"available for download":return[new p.MenuItem({label:this.mnemonicLabel(d.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new p.MenuItem({label:d.localize(29,null),enabled:!1})];case"downloaded":return[new p.MenuItem({label:this.mnemonicLabel(d.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new p.MenuItem({label:d.localize(31,null),enabled:!1})];case"ready":return[new p.MenuItem({label:this.mnemonicLabel(d.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(s,u,m,M){const L=this.mnemonicLabel(s),R=typeof u=="function"?u:(re,G,X)=>{const B=re?re.userSettingsLabel:null;let $=u;Array.isArray(u)&&($=this.isOptionClick(X)?u[1]:u[0]),B&&X.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:B}):this.runActionInRenderer({type:"commandId",commandId:$})},T=typeof m=="boolean"?m:this.windowsMainService.getWindowCount()>0,_=typeof M=="boolean"?M:!1,Q={label:L,click:R,enabled:T};_&&(Q.type="checkbox",Q.checked=_);let se;return typeof u=="string"?se=u:Array.isArray(u)&&(se=u[0]),k.isMacintosh&&(se==="editor.action.clipboardCutAction"?Q.role="cut":se==="editor.action.clipboardCopyAction"?Q.role="copy":se==="editor.action.clipboardPasteAction"&&(Q.role="paste"),se==="undo"?Q.click=this.makeContextAwareClickHandler(R,{inDevTools:re=>re.undo(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("undo:")}):se==="redo"?Q.click=this.makeContextAwareClickHandler(R,{inDevTools:re=>re.redo(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("redo:")}):se==="editor.action.selectAll"&&(Q.click=this.makeContextAwareClickHandler(R,{inDevTools:re=>re.selectAll(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("selectAll:")}))),new p.MenuItem(this.withKeybinding(se,Q))}makeContextAwareClickHandler(s,u){return(m,M,L)=>{const R=p.BrowserWindow.getFocusedWindow();if(!R)return u.inNoWindow();if(R.webContents.isDevToolsFocused()&&R.webContents.devToolsWebContents)return u.inDevTools(R.webContents.devToolsWebContents);s(m,M||R,L)}}runActionInRenderer(s){let u=p.BrowserWindow.getFocusedWindow();if(!u){const M=this.windowsMainService.getLastActiveWindow();M?.isMinimized()&&(u=M.win)}const m=u?this.windowsMainService.getWindowById(u.id):void 0;if(m){if(this.logService.trace("menubar#runActionInRenderer",s),k.isMacintosh&&!this.environmentMainService.isBuilt&&!m.isReady&&(s.type==="commandId"&&s.commandId==="workbench.action.toggleDevTools"||s.type!=="commandId"&&s.userSettingsLabel==="alt+cmd+i"))return;if(s.type==="commandId"){const M={id:s.commandId,from:"menu"};m.sendWhenReady("vscode:runAction",D.CancellationToken.None,M)}else{const M={userSettingsLabel:s.userSettingsLabel};m.sendWhenReady("vscode:runKeybinding",D.CancellationToken.None,M)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",s)}withKeybinding(s,u){const m=typeof s=="string"?this.keybindings[s]:void 0;if(m?.label){if(m.isNative!==!1)u.accelerator=m.label,u.userSettingsLabel=m.userSettingsLabel;else if(typeof u.label=="string"){const M=u.label.indexOf("[");M>=0?u.label=`${u.label.substr(0,M)} [${m.label}]`:u.label=`${u.label} [${m.label}]`}}else u.accelerator=void 0;return u}likeAction(s,u,m=!u.accelerator){m&&(u=this.withKeybinding(s,u));const M=u.click;return u.click=(L,R,T)=>{this.reportMenuActionTelemetry(s),M&&M(L,R,T)},u}openUrl(s,u){this.nativeHostMainService.openExternal(void 0,s),this.reportMenuActionTelemetry(u)}reportMenuActionTelemetry(s){this.telemetryService.publicLog2("workbenchActionExecuted",{id:s,from:o})}mnemonicLabel(s){return(0,C.mnemonicMenuLabel)(s,!this.currentEnableMenuBarMnemonics)}};h.lastKnownMenubarStorageKey="lastKnownMenubarData",h=fe([ie(0,P.IUpdateService),ie(1,g.IConfigurationService),ie(2,a.IWindowsMainService),ie(3,S.IEnvironmentMainService),ie(4,b.ITelemetryService),ie(5,l.IWorkspacesHistoryMainService),ie(6,y.IStateMainService),ie(7,E.ILifecycleMainService),ie(8,w.ILogService),ie(9,t.INativeHostMainService),ie(10,f.IProductService)],h),e.Menubar=h;function n(){return new p.MenuItem({type:"separator"})}}),define(x[241],ee([0,1,5,20,6,240]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,p.createDecorator)("menubarMainService");let k=class{constructor(d,g,S){this.instantiationService=d,this.lifecycleMainService=g,this.logService=S,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(C.Menubar)}async updateMenubar(d,g){this.logService.trace("menubarService#updateMenubar",d),(await this.menubar).updateMenu(g,d)}};k=fe([ie(0,p.IInstantiationService),ie(1,r.ILifecycleMainService),ie(2,D.ILogService)],k),e.MenubarMainService=k}),define(x[242],ee([0,1,14,28,26,31,23,4,32,42,33,2,10,8,63,3,34,16,13,7,155,52,19,49,24,18,5,20,6,55,22,56,64,38,67,239,99,221,30,100,68,45]),function(j,e,p,r,D,C,k,I,d,g,S,E,w,v,t,f,y,b,P,c,a,l,o,h,n,i,s,u,m,M,L,R,T,_,Q,se,re,G,X,B,$,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function V(U){return(0,X.isWorkspaceIdentifier)(U?.workspace)}function q(U){return(0,X.isSingleFolderWorkspaceIdentifier)(U?.workspace)}let Z=class it extends E.Disposable{constructor(A,W,F,N,H,O,z,te,ne,oe,J,ce,le,ue,me){super();this.machineId=A,this.initialUserEnv=W,this.logService=F,this.stateMainService=N,this.environmentMainService=H,this.lifecycleMainService=O,this.backupMainService=z,this.configurationService=te,this.workspacesHistoryMainService=ne,this.workspacesManagementMainService=oe,this.instantiationService=J,this.dialogMainService=ce,this.fileService=le,this.productService=ue,this.protocolMainService=me,this._onDidOpenWindow=this._register(new I.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new I.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new I.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new I.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new G.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(A=>this._onDidSignalReadyWindow.fire(A.window))),this._register(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const W=new E.DisposableStore;if(W.add(I.Event.any(A.onDidClose,A.onDidDestroy)(()=>W.dispose())),A.config.extensionDevelopmentPath)for(const F of A.config.extensionDevelopmentPath)W.add(this.protocolMainService.addValidFileRoot(c.URI.file(F)));A.config.extensionTestsPath&&W.add(this.protocolMainService.addValidFileRoot(c.URI.file(A.config.extensionTestsPath)))}}))}openEmptyWindow(A,W){let F=this.environmentMainService.args;const N=W?.remoteAuthority||void 0,H=!0,O=W?.forceReuseWindow,z=!O;return this.open({...A,cli:F,forceEmpty:H,forceNewWindow:z,forceReuseWindow:O,remoteAuthority:N})}openExistingWindow(A,W){A.focus(),this.handleWaitMarkerFile(W,[A])}open(A){this.logService.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const W=[],F=[],N=[],H=[],O=[];let z,te=0;const ne=this.getPathsToOpen(A);this.logService.trace("windowsManager#open pathsToOpen",ne);for(const le of ne)q(le)?A.addMode?W.push(le):F.push(le):V(le)?N.push(le):le.fileUri?(z||(z={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:le.remoteAuthority}),z.filesToOpenOrCreate.push(le)):le.backupPath?O.push({backupFolder:(0,v.basename)(le.backupPath),remoteAuthority:le.remoteAuthority}):te++;A.diffMode&&z&&z.filesToOpenOrCreate.length>=2&&(z.filesToDiff=z.filesToOpenOrCreate.slice(0,2),z.filesToOpenOrCreate=[]),z&&A.waitMarkerFileURI&&(z.filesToWait={paths:[...z.filesToDiff,...z.filesToOpenOrCreate],waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?(H.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),N.push(...H),O.push(...this.backupMainService.getEmptyWindowBackupPaths())):O.length=0;const{windows:oe,filesOpenedInWindow:J}=this.doOpen(A,N,F,O,te,z,W);if(this.logService.trace(`windowsManager#open used window count ${oe.length} (workspacesToOpen: ${N.length}, foldersToOpen: ${F.length}, emptyToRestore: ${O.length}, emptyToOpen: ${te})`),oe.length>1)if(J)J.focus();else{const le=this.windowsStateHandler.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let ue=!0,me=!0;if(le){const Ee=oe.filter(de=>this.windowsStateHandler.state.lastActiveWindow&&de.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Ee.length&&(Ee[0].focus(),ue=!1,me=!1)}if(ue)for(let Ee=oe.length-1;Ee>=0;Ee--){const de=oe[Ee];if(!(de.openedWorkspace&&H.some(ge=>de.openedWorkspace&&ge.workspace.id===de.openedWorkspace.id)||de.backupPath&&O.some(ge=>de.backupPath&&ge.backupFolder===(0,v.basename)(de.backupPath)))){de.focus(),me=!1;break}}me&&oe[oe.length-1].focus()}const ce=z&&z.filesToDiff.length>0;if(!oe.some(le=>le.isExtensionDevelopmentHost)&&!ce&&!A.noRecentEntry){const le=[];for(const ue of ne)V(ue)&&!ue.transient?le.push({label:ue.label,workspace:ue.workspace,remoteAuthority:ue.remoteAuthority}):q(ue)?le.push({label:ue.label,folderUri:ue.workspace.uri,remoteAuthority:ue.remoteAuthority}):ue.fileUri&&le.push({label:ue.label,fileUri:ue.fileUri,remoteAuthority:ue.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(le)}return this.handleWaitMarkerFile(A,oe),oe}handleWaitMarkerFile(A,W){const F=A.waitMarkerFileURI;A.context===0&&F&&W.length===1&&W[0]&&(async()=>{await W[0].whenClosedOrLoaded;try{await this.fileService.del(F)}catch{}})()}doOpen(A,W,F,N,H,O,z){const te=[];let ne;function oe(de,ge){te.push(de),ge&&(ne=de,O=void 0)}let{openFolderInNewWindow:J,openFilesInNewWindow:ce}=this.shouldOpenNewWindow(A);if(!A.initialStartup&&z.length>0){const de=z[0].remoteAuthority,ge=this.getLastActiveWindowForAuthority(de);ge&&oe(this.doAddFoldersToExistingWindow(ge,z.map(pe=>pe.workspace.uri)))}const le=F.length+W.length+N.length;if(O&&le===0){const de=O.filesToOpenOrCreate[0]||O.filesToDiff[0],ge=this.getWindows().filter(ke=>O&&(0,b.isEqualAuthority)(ke.remoteAuthority,O.remoteAuthority));let pe;de?.fileUri&&!ce&&((A.context===4||A.context===0||A.context===1)&&(pe=(0,re.findWindowOnFile)(ge,de.fileUri,ke=>ke.configPath.scheme===w.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(ke.configPath):void 0)),pe||(pe=this.doGetLastActiveWindow(ge))),pe?(0,X.isWorkspaceIdentifier)(pe.openedWorkspace)?W.push({workspace:pe.openedWorkspace,remoteAuthority:pe.remoteAuthority}):(0,X.isSingleFolderWorkspaceIdentifier)(pe.openedWorkspace)?F.push({workspace:pe.openedWorkspace,remoteAuthority:pe.remoteAuthority}):oe(this.doOpenFilesInExistingWindow(A,pe,O),!0):oe(this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:O,forceNewWindow:!0,remoteAuthority:O.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow}),!0)}const ue=(0,C.distinct)(W,de=>de.workspace.id);if(ue.length>0){const de=(0,C.coalesce)(ue.map(ge=>(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),ge.workspace.configPath)));if(de.length>0){const ge=de[0],pe=(0,b.isEqualAuthority)(O?.remoteAuthority,ge.remoteAuthority)?O:void 0;oe(this.doOpenFilesInExistingWindow(A,ge,pe),!!pe),J=!0}ue.forEach(ge=>{if(de.some(Le=>Le.openedWorkspace&&Le.openedWorkspace.id===ge.workspace.id))return;const pe=ge.remoteAuthority,ke=(0,b.isEqualAuthority)(O?.remoteAuthority,pe)?O:void 0;oe(this.doOpenFolderOrWorkspace(A,ge,J,ke),!!ke),J=!0})}const me=(0,C.distinct)(F,de=>b.extUriBiasedIgnorePathCase.getComparisonKey(de.workspace.uri));if(me.length>0){const de=(0,C.coalesce)(me.map(ge=>(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),ge.workspace.uri)));if(de.length>0){const ge=de[0],pe=(0,b.isEqualAuthority)(O?.remoteAuthority,ge.remoteAuthority)?O:void 0;oe(this.doOpenFilesInExistingWindow(A,ge,pe),!!pe),J=!0}me.forEach(ge=>{if(de.some(Le=>(0,X.isSingleFolderWorkspaceIdentifier)(Le.openedWorkspace)&&b.extUriBiasedIgnorePathCase.isEqual(Le.openedWorkspace.uri,ge.workspace.uri)))return;const pe=ge.remoteAuthority,ke=(0,b.isEqualAuthority)(O?.remoteAuthority,pe)?O:void 0;oe(this.doOpenFolderOrWorkspace(A,ge,J,ke),!!ke),J=!0})}const Ee=(0,C.distinct)(N,de=>de.backupFolder);if(Ee.length>0&&Ee.forEach(de=>{const ge=de.remoteAuthority,pe=(0,b.isEqualAuthority)(O?.remoteAuthority,ge)?O:void 0;oe(this.doOpenEmpty(A,!0,ge,pe,de),!!pe),J=!0}),te.length===0||O){O&&!H&&H++;const de=O?O.remoteAuthority:A.remoteAuthority;for(let ge=0;ge<H;ge++)oe(this.doOpenEmpty(A,J,de,O),!!O),J=!0}return{windows:(0,C.distinct)(te),filesOpenedInWindow:ne}}doOpenFilesInExistingWindow(A,W,F){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:F}),W.focus();const N={filesToOpenOrCreate:F?.filesToOpenOrCreate,filesToDiff:F?.filesToDiff,filesToWait:F?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return W.sendWhenReady("vscode:openFiles",k.CancellationToken.None,N),W}doAddFoldersToExistingWindow(A,W){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:W}),A.focus();const F={foldersToAdd:W};return A.sendWhenReady("vscode:addFolders",k.CancellationToken.None,F),A}doOpenEmpty(A,W,F,N,H){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!H,remoteAuthority:F,filesToOpen:N,forceNewWindow:W});let O;return!W&&typeof A.contextWindowId=="number"&&(O=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:F,forceNewWindow:W,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:N,windowToUse:O,emptyWindowBackupInfo:H})}doOpenFolderOrWorkspace(A,W,F,N,H){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:W,filesToOpen:N}),!F&&!H&&typeof A.contextWindowId=="number"&&(H=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({workspace:W.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:W.remoteAuthority,forceNewWindow:F,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:N,windowToUse:H})}getPathsToOpen(A){let W,F=!1,N=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(W=this.doExtractPathsFromAPI(A),F=!0):A.forceEmpty?W=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(W=this.doExtractPathsFromCLI(A.cli),W.length===0&&W.push(Object.create(null)),F=!0):(W=this.doGetPathsFromLastSession(),W.length===0&&W.push(Object.create(null)),N=!0),!A.addMode&&F){const H=W.filter(O=>q(O));if(H.length>1){const O=H[0].remoteAuthority;if(H.every(z=>(0,b.isEqualAuthority)(z.remoteAuthority,O))){const z=this.workspacesManagementMainService.createUntitledWorkspaceSync(H.map(te=>({uri:te.workspace.uri})));W.push({workspace:z,remoteAuthority:O}),W=W.filter(te=>!q(te))}}}return A.initialStartup&&!N&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&W.unshift(...this.doGetPathsFromLastSession().filter(H=>V(H)||q(H)||H.backupPath)),W}doExtractPathsFromAPI(A){const W=[],F={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority};for(const N of(0,C.coalesce)(A.urisToOpen||[])){const H=this.resolveOpenable(N,F);if(H)H.label=N.label,W.push(H);else{const O=this.resourceFromOpenable(N),z={title:this.productService.nameLong,type:"info",buttons:[(0,S.mnemonicButtonLabel)((0,a.localize)(0,null))],defaultId:0,message:O.scheme===w.Schemas.file?(0,a.localize)(1,null):(0,a.localize)(2,null),detail:O.scheme===w.Schemas.file?(0,a.localize)(3,null,(0,S.getPathLabel)(O.fsPath,this.environmentMainService)):(0,a.localize)(4,null,O.toString()),noLink:!0};this.dialogMainService.showMessageBox(z,(0,P.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow()))}}return W}doExtractPathsFromCLI(A){const W=[],F={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:!1},N=A["folder-uri"];if(N)for(const z of N){const te=this.cliArgToUri(z);if(te){const ne=this.resolveOpenable({folderUri:te},F);ne&&W.push(ne)}}const H=A["file-uri"];if(H)for(const z of H){const te=this.cliArgToUri(z);if(te){const ne=this.resolveOpenable((0,X.hasWorkspaceFileExtension)(z)?{workspaceUri:te}:{fileUri:te},F);ne&&W.push(ne)}}const O=A._;for(const z of O){const te=F.remoteAuthority?this.doResolvePathRemote(z,F):this.doResolveFilePath(z,F);te&&W.push(te)}return W}cliArgToUri(A){try{const W=c.URI.parse(A);if(!W.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${A}`);return}return W}catch(W){this.logService.error(`Invalid URI input string: ${A}, ${W.message}`)}}doGetPathsFromLastSession(){const A=this.getRestoreWindowsSetting();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":{const W=[];A!=="one"&&W.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&W.push(this.windowsStateHandler.state.lastActiveWindow);const F=[];for(const N of W)if(N.workspace){const H=this.resolveOpenable({workspaceUri:N.workspace.configPath},{remoteAuthority:N.remoteAuthority,rejectTransientWorkspaces:!0});V(H)&&F.push(H)}else if(N.folderUri){const H=this.resolveOpenable({folderUri:N.folderUri},{remoteAuthority:N.remoteAuthority});q(H)&&F.push(H)}else A!=="folders"&&N.backupPath&&F.push({backupPath:N.backupPath,remoteAuthority:N.remoteAuthority});return F}}}getRestoreWindowsSetting(){let A;return this.lifecycleMainService.wasRestarted?A="all":(A=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}resolveOpenable(A,W=Object.create(null)){let F=this.resourceFromOpenable(A);return F.scheme===w.Schemas.file?((0,Q.isFileToOpen)(A)&&(W={...W,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(F.fsPath,W)):this.doResolveRemoteOpenable(A,W)}doResolveRemoteOpenable(A,W){let F=this.resourceFromOpenable(A);const N=(0,T.getRemoteAuthority)(F)||W.remoteAuthority;if(F=(0,b.removeTrailingPathSeparator)((0,b.normalizePath)(F)),(0,Q.isFileToOpen)(A)){if(W.gotoLineMode){const{path:H,line:O,column:z}=(0,d.parseLineAndColumnAware)(F.path);return{fileUri:F.with({path:H}),selection:O?{startLineNumber:O,startColumn:z||1}:void 0,remoteAuthority:N}}return{fileUri:F,remoteAuthority:N}}else if((0,Q.isWorkspaceToOpen)(A))return{workspace:(0,B.getWorkspaceIdentifier)(F),remoteAuthority:N};return{workspace:(0,B.getSingleFolderWorkspaceIdentifier)(F),remoteAuthority:N}}resourceFromOpenable(A){return(0,Q.isWorkspaceToOpen)(A)?A.workspaceUri:(0,Q.isFolderToOpen)(A)?A.folderUri:A.fileUri}doResolveFilePath(A,W){let F,N;W.gotoLineMode&&({path:A,line:F,column:N}=(0,d.parseLineAndColumnAware)(A)),A=(0,d.sanitizeFilePath)((0,v.normalize)(A),(0,y.cwd)());try{const H=(0,r.statSync)(A);if(H.isFile()){if(!W.forceOpenWorkspaceAsFile){const O=this.workspacesManagementMainService.resolveLocalWorkspaceSync(c.URI.file(A));if(O)return O.transient&&W.rejectTransientWorkspaces?void 0:{workspace:{id:O.id,configPath:O.configPath},type:i.FileType.File,exists:!0,remoteAuthority:O.remoteAuthority,transient:O.transient}}return{fileUri:c.URI.file(A),type:i.FileType.File,exists:!0,selection:F?{startLineNumber:F,startColumn:N||1}:void 0}}else{if(H.isDirectory())return{workspace:(0,B.getSingleFolderWorkspaceIdentifier)(c.URI.file(A),H),type:i.FileType.Directory,exists:!0};if(!f.isWindows&&A==="/dev/null")return{fileUri:c.URI.file(A),type:i.FileType.File,exists:!0}}}catch{const O=c.URI.file(A);if(this.workspacesHistoryMainService.removeRecentlyOpened([O]),W.ignoreFileNotFound)return{fileUri:O,type:i.FileType.File,exists:!1}}}doResolvePathRemote(A,W){const F=A.charCodeAt(0),N=W.remoteAuthority;let H,O;W.gotoLineMode&&({path:A,line:H,column:O}=(0,d.parseLineAndColumnAware)(A)),F!==47&&((0,d.isWindowsDriveLetter)(F)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=(0,d.toSlashes)(A)),A=`/${A}`);const z=c.URI.from({scheme:w.Schemas.vscodeRemote,authority:N,path:A});if(A.charCodeAt(A.length-1)!==47){if((0,X.hasWorkspaceFileExtension)(A))return W.forceOpenWorkspaceAsFile?{fileUri:z,selection:H?{startLineNumber:H,startColumn:O||1}:void 0,remoteAuthority:W.remoteAuthority}:{workspace:(0,B.getWorkspaceIdentifier)(z),remoteAuthority:N};if(W.gotoLineMode||v.posix.basename(A).indexOf(".")!==-1)return{fileUri:z,selection:H?{startLineNumber:H,startColumn:O||1}:void 0,remoteAuthority:N}}return{workspace:(0,B.getSingleFolderWorkspaceIdentifier)(z),remoteAuthority:N}}shouldOpenNewWindow(A){const W=this.configurationService.getValue("window"),F=W?.openFoldersInNewWindow||"default",N=W?.openFilesInNewWindow||"off";let H=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&(F==="on"||F==="off")&&(H=F==="on");let O=!1;return A.forceNewWindow||A.forceReuseWindow?O=!!A.forceNewWindow&&!A.forceReuseWindow:(f.isMacintosh?A.context===1&&(O=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&(O=!0),!A.cli.extensionDevelopmentPath&&(N==="on"||N==="off")&&(O=N==="on")),{openFolderInNewWindow:!!H,openFilesInNewWindow:O}}openExtensionDevelopmentHostWindow(A,W){const F=(0,re.findWindowOnExtensionDevelopmentPath)(this.getWindows(),A);if(F)return this.lifecycleMainService.reload(F,W.cli),F.focus(),[F];let N=W.cli["folder-uri"]||[],H=W.cli["file-uri"]||[],O=W.cli._;if(!O.length&&!N.length&&!H.length&&!W.cli.extensionTestsPath){const oe=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,J=oe&&(oe.workspace||oe.folderUri);J&&(c.URI.isUri(J)?J.scheme===w.Schemas.file?O=[J.fsPath]:N=[J.toString()]:J.configPath.scheme===w.Schemas.file?O=[(0,b.originalFSPath)(J.configPath)]:H=[J.configPath.toString()])}let z=W.remoteAuthority;for(const oe of A)if(oe.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const J=c.URI.parse(oe),ce=(0,T.getRemoteAuthority)(J);ce&&(z?(0,b.isEqualAuthority)(ce,z)||this.logService.error("more than one extension development path authority"):z=ce)}O=O.filter(oe=>{const J=c.URI.file(oe);return(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),J)?!1:(0,b.isEqualAuthority)((0,T.getRemoteAuthority)(J),z)}),N=N.filter(oe=>{const J=this.cliArgToUri(oe);return J&&!!(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),J)?!1:J?(0,b.isEqualAuthority)((0,T.getRemoteAuthority)(J),z):!1}),H=H.filter(oe=>{const J=this.cliArgToUri(oe);return J&&!!(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),J)?!1:J?(0,b.isEqualAuthority)((0,T.getRemoteAuthority)(J),z):!1}),W.cli._=O,W.cli["folder-uri"]=N,W.cli["file-uri"]=H;const te=!O.length&&!N.length&&!H.length,ne={context:W.context,cli:W.cli,forceNewWindow:!0,forceEmpty:te,userEnv:W.userEnv,noRecentEntry:!0,waitMarkerFileURI:W.waitMarkerFileURI,remoteAuthority:z};return this.open(ne)}openInBrowserWindow(A){const W=this.configurationService.getValue("window"),F={...this.environmentMainService.args,...A.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:A.emptyWindowBackupInfo?(0,v.join)(this.environmentMainService.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.initialUserEnv,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:M.default,isInitialStartup:A.initialStartup,perfMarks:(0,t.getMarks)(),os:{release:(0,D.release)(),hostname:(0,D.hostname)()},zoomLevel:typeof W?.zoomLevel=="number"?W.zoomLevel:void 0,autoDetectHighContrast:W?.autoDetectHighContrast??!0,accessibilitySupport:p.app.accessibilitySupportEnabled,colorScheme:{dark:p.nativeTheme.shouldUseDarkColors,highContrast:p.nativeTheme.shouldUseInvertedColorScheme||p.nativeTheme.shouldUseHighContrastColors}};let N;if(!A.forceNewWindow&&!A.forceNewTabbedWindow&&(N=A.windowToUse||this.getLastActiveWindow(),N&&N.focus()),N){const H=N.config;!F.extensionDevelopmentPath&&H&&!!H.extensionDevelopmentPath&&(F.extensionDevelopmentPath=H.extensionDevelopmentPath,F.verbose=H.verbose,F["inspect-brk-extensions"]=H["inspect-brk-extensions"],F.debugId=H.debugId,F.extensionEnvironment=H.extensionEnvironment,F["inspect-extensions"]=H["inspect-extensions"],F["extensions-dir"]=H["extensions-dir"])}else{const H=this.windowsStateHandler.getNewWindowState(F);(0,t.mark)("code/willCreateCodeWindow");const O=N=this.instantiationService.createInstance(se.CodeWindow,{state:H,extensionDevelopmentPath:F.extensionDevelopmentPath,isExtensionTestHost:!!F.extensionTestsPath});if((0,t.mark)("code/didCreateCodeWindow"),A.forceNewTabbedWindow){const te=this.getLastActiveWindow();te&&te.addTabbedWindow(O)}it.WINDOWS.push(O),this._onDidOpenWindow.fire(O),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,g.once)(O.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(O)),(0,g.once)(O.onDidClose)(()=>this.onWindowClosed(O)),(0,g.once)(O.onDidDestroy)(()=>this._onDidDestroyWindow.fire(O));const z=(0,P.assertIsDefined)(O.win?.webContents);z.removeAllListeners("devtools-reload-page"),z.on("devtools-reload-page",()=>this.lifecycleMainService.reload(O)),this.lifecycleMainService.registerWindow(O)}return F.windowId=N.id,N.isReady?this.lifecycleMainService.unload(N,4).then(H=>{H||this.doOpenInBrowserWindow(N,F,A)}):this.doOpenInBrowserWindow(N,F,A),N}doOpenInBrowserWindow(A,W,F){if(!W.extensionDevelopmentPath)if((0,X.isWorkspaceIdentifier)(W.workspace))W.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:W.workspace,remoteAuthority:W.remoteAuthority});else if((0,X.isSingleFolderWorkspaceIdentifier)(W.workspace))W.backupPath=this.backupMainService.registerFolderBackupSync({folderUri:W.workspace.uri,remoteAuthority:W.remoteAuthority});else{const N=F.emptyWindowBackupInfo&&F.emptyWindowBackupInfo.backupFolder;W.backupPath=this.backupMainService.registerEmptyWindowBackupSync(N,W.remoteAuthority)}A.load(W)}onWindowClosed(A){const W=it.WINDOWS.indexOf(A);it.WINDOWS.splice(W,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const A=p.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(A){return this.doGetLastActiveWindow(this.getWindows().filter(W=>(0,b.isEqualAuthority)(W.remoteAuthority,A)))}doGetLastActiveWindow(A){const W=Math.max.apply(Math,A.map(F=>F.lastFocusTime));return A.find(F=>F.lastFocusTime===W)}sendToFocused(A,...W){const F=this.getFocusedWindow()||this.getLastActiveWindow();F&&F.sendWhenReady(A,k.CancellationToken.None,...W)}sendToAll(A,W,F){for(const N of this.getWindows())F&&F.indexOf(N.id)>=0||N.sendWhenReady(A,k.CancellationToken.None,W)}getWindows(){return it.WINDOWS}getWindowCount(){return it.WINDOWS.length}getWindowById(A){const W=this.getWindows().filter(F=>F.id===A);return(0,C.firstOrDefault)(W)}getWindowByWebContents(A){const W=p.BrowserWindow.fromWebContents(A);if(!!W)return this.getWindowById(W.id)}};Z.WINDOWS=[],Z=fe([ie(2,m.ILogService),ie(3,_.IStateMainService),ie(4,n.IEnvironmentMainService),ie(5,u.ILifecycleMainService),ie(6,l.IBackupMainService),ie(7,o.IConfigurationService),ie(8,$.IWorkspacesHistoryMainService),ie(9,Y.IWorkspacesManagementMainService),ie(10,s.IInstantiationService),ie(11,h.IDialogMainService),ie(12,i.IFileService),ie(13,L.IProductService),ie(14,R.IProtocolMainService)],Z),e.WindowsMainService=Z}),define(x[243],ee([0,1,52,35,68,45]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let k=class{constructor(d,g,S,E){this.workspacesManagementMainService=d,this.windowsMainService=g,this.workspacesHistoryMainService=S,this.backupMainService=E,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(d,g){const S=this.windowsMainService.getWindowById(d);if(S)return this.workspacesManagementMainService.enterWorkspace(S,this.windowsMainService.getWindows(),g)}createUntitledWorkspace(d,g,S){return this.workspacesManagementMainService.createUntitledWorkspace(g,S)}deleteUntitledWorkspace(d,g){return this.workspacesManagementMainService.deleteUntitledWorkspace(g)}getWorkspaceIdentifier(d,g){return this.workspacesManagementMainService.getWorkspaceIdentifier(g)}async getRecentlyOpened(d){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(d))}async addRecentlyOpened(d,g){return this.workspacesHistoryMainService.addRecentlyOpened(g)}async removeRecentlyOpened(d,g){return this.workspacesHistoryMainService.removeRecentlyOpened(g)}async clearRecentlyOpened(d){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};k=fe([ie(0,C.IWorkspacesManagementMainService),ie(1,r.IWindowsMainService),ie(2,D.IWorkspacesHistoryMainService),ie(3,p.IBackupMainService)],k),e.WorkspacesMainService=k}),define(x[244],ee([0,1,14,28,26,17,39,15,32,42,43,33,2,10,8,3,16,13,7,27,71,121,37,124,84,235,134,52,225,19,163,74,49,226,87,24,54,89,171,188,172,222,88,173,174,18,183,92,73,5,75,236,201,101,20,6,185,241,50,22,64,231,76,38,219,98,202,29,204,206,65,41,210,233,237,234,238,97,211,212,213,214,216,35,242,217,30,68,243,45]),function(j,e,p,r,D,C,k,I,d,g,S,E,w,v,t,f,y,b,P,c,a,l,o,h,n,i,s,u,m,M,L,R,T,_,Q,se,re,G,X,B,$,Y,V,q,Z,U,A,W,F,N,H,O,z,te,ne,oe,J,ce,le,ue,me,Ee,de,ge,pe,ke,Le,We,ze,Be,Xe,Ke,gt,Qe,at,ct,$e,qe,K,ae,he,ve,Ie,Ce,Fe,Oe,_e,Ne,He,bt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let mt=class extends w.Disposable{constructor(we,Se,be,ye,Pe,De,Me,Ae,Te,Ge){super();this.mainProcessNodeIpcServer=we,this.userEnv=Se,this.mainInstantiationService=be,this.logService=ye,this.environmentMainService=Pe,this.lifecycleMainService=De,this.configurationService=Me,this.stateMainService=Ae,this.fileService=Te,this.productService=Ge,this.configureSession(),this.registerListeners()}configureSession(){const we=ye=>ye?.startsWith(`${v.Schemas.vscodeWebview}://`),Se=new Set(["clipboard-read","clipboard-sanitized-write"]);p.session.defaultSession.setPermissionRequestHandler((ye,Pe,De,Me)=>we(Me.requestingUrl)?De(Se.has(Pe)):De(!1)),p.session.defaultSession.setPermissionCheckHandler((ye,Pe,De,Me)=>we(Me.requestingUrl)?Se.has(Pe):!1);const be=p.session.defaultSession;typeof be.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&be.setCodeCachePath((0,t.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,I.setUnexpectedErrorHandler)(be=>this.onUnexpectedError(be)),process.on("uncaughtException",be=>(0,I.onUnexpectedError)(be)),process.on("unhandledRejection",be=>(0,I.onUnexpectedError)(be)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,l.registerContextMenuListener)(),p.app.on("accessibility-support-changed",(be,ye)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",ye)}),p.app.on("activate",(be,ye)=>{this.logService.trace("app#activate"),ye||this.windowsMainService?.openEmptyWindow({context:1})}),p.app.on("web-contents-created",(be,ye)=>{ye.on("will-navigate",Pe=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Pe.preventDefault()}),ye.setWindowOpenHandler(({url:Pe})=>(this.nativeHostMainService?.openExternal(void 0,Pe),{action:"deny"}))});let we=[],Se;p.app.on("open-file",(be,ye)=>{this.logService.trace("app#open-file: ",ye),be.preventDefault(),we.push(this.getWindowOpenableFromPathSync(ye)),Se!==void 0&&(clearTimeout(Se),Se=void 0),Se=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:we,gotoLineMode:!1,preferNewWindow:!0}),we=[],Se=void 0},100)}),p.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),p.ipcMain.handle("vscode:fetchShellEnv",be=>{const ye=this.windowsMainService?.getWindowByWebContents(be.sender);let Pe,De;return ye?.config?(Pe=ye.config,De={...process.env,...ye.config.userEnv}):(Pe=this.environmentMainService.args,De=process.env),this.resolveShellEnvironment(Pe,De,!1)}),p.ipcMain.handle("vscode:writeNlsFile",(be,ye,Pe)=>{const De=this.validateNlsPath([ye]);if(!De||typeof Pe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(De,C.VSBuffer.fromString(Pe))}),p.ipcMain.handle("vscode:readNlsFile",async(be,...ye)=>{const Pe=this.validateNlsPath(ye);if(!Pe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Pe)).value.toString()}),p.ipcMain.on("vscode:toggleDevTools",be=>be.sender.toggleDevTools()),p.ipcMain.on("vscode:openDevTools",be=>be.sender.openDevTools()),p.ipcMain.on("vscode:reloadWindow",be=>be.sender.reload())}validateNlsPath(we){let Se;for(const be of we)typeof be=="string"&&(typeof Se!="string"?Se=be:Se=(0,t.join)(Se,be));if(!(typeof Se!="string"||!(0,t.isAbsolute)(Se)||!(0,d.isEqualOrParent)(Se,this.environmentMainService.cachedLanguagesPath,!f.isLinux)))return P.URI.file(Se)}onUnexpectedError(we){if(we){const Se={message:`[uncaught exception in main]: ${we.message}`,stack:we.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Se))}this.logService.error(`[uncaught exception in main]: ${we}`),we.stack&&this.logService.error(we.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const we=this.productService.win32AppUserModelId;f.isWindows&&we&&p.app.setAppUserModelId(we);try{f.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!p.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&p.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Te){this.logService.error(Te)}const Se=new h.Server;this.logService.trace("Resolving machine identifier...");const be=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${be}`);const{sharedProcess:ye,sharedProcessReady:Pe,sharedProcessClient:De}=this.setupSharedProcess(be),Me=await this.initServices(be,ye,Pe);if(this.environmentMainService.driverHandle){const Te=await(0,_.serve)(Se,this.environmentMainService.driverHandle,this.environmentMainService,Me);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Te)}this._register(Me.createInstance(i.ProxyAuthHandler)),Me.invokeFunction(Te=>this.initChannels(Te,Se,De));const Ae=Me.invokeFunction(Te=>this.openFirstWindow(Te,Se));Me.invokeFunction(Te=>this.afterWindowOpen(Te,ye)),this.environmentMainService.args.trace&&Me.invokeFunction(Te=>this.stopTracingEventually(Te,Ae))}async resolveMachineId(){let we=this.stateMainService.getItem(We.machineIdKey);return(!we||f.isMacintosh&&we==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(we=await(0,a.getMachineId)(),this.stateMainService.setItem(We.machineIdKey,we)),we}setupSharedProcess(we){const Se=this._register(this.mainInstantiationService.createInstance(Ee.SharedProcess,we,this.userEnv)),be=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Pe=await Se.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new n.Client(Pe,"main")})(),ye=(async()=>(await Se.whenReady(),be))();return{sharedProcess:Se,sharedProcessReady:ye,sharedProcessClient:be}}async initServices(we,Se,be){const ye=new H.ServiceCollection;switch(process.platform){case"win32":ye.set(Ke.IUpdateService,new F.SyncDescriptor($e.Win32UpdateService));break;case"linux":f.isLinuxSnap?ye.set(Ke.IUpdateService,new F.SyncDescriptor(ct.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ye.set(Ke.IUpdateService,new F.SyncDescriptor(at.LinuxUpdateService));break;case"darwin":ye.set(Ke.IUpdateService,new F.SyncDescriptor(Qe.DarwinUpdateService));break}ye.set(Ce.IWindowsMainService,new F.SyncDescriptor(Fe.WindowsMainService,[we,this.userEnv])),ye.set(T.IDialogMainService,new F.SyncDescriptor(T.DialogMainService)),ye.set(te.ILaunchMainService,new F.SyncDescriptor(te.LaunchMainService)),ye.set(R.IDiagnosticsService,o.ProxyChannel.toService((0,o.getDelayedChannel)(be.then(De=>De.getChannel("diagnostics"))))),ye.set(O.IIssueMainService,new F.SyncDescriptor(O.IssueMainService,[this.userEnv])),ye.set(Q.IEncryptionMainService,new F.SyncDescriptor(Q.EncryptionMainService,[we])),ye.set(z.IKeyboardLayoutMainService,new F.SyncDescriptor(z.KeyboardLayoutMainService)),ye.set(le.INativeHostMainService,new F.SyncDescriptor(le.NativeHostMainService,[Se])),ye.set(ve.IWebviewManagerService,new F.SyncDescriptor(Ie.WebviewMainService)),ye.set(_e.IWorkspacesService,new F.SyncDescriptor(He.WorkspacesMainService)),ye.set(bt.IWorkspacesManagementMainService,new F.SyncDescriptor(bt.WorkspacesManagementMainService)),ye.set(Ne.IWorkspacesHistoryMainService,new F.SyncDescriptor(Ne.WorkspacesHistoryMainService)),ye.set(ce.IMenubarMainService,new F.SyncDescriptor(ce.MenubarMainService)),ye.set(X.IExtensionUrlTrustService,new F.SyncDescriptor(B.ExtensionUrlTrustService)),ye.set($.IExtensionHostStarter,new F.SyncDescriptor(Y.WorkerMainProcessExtensionHostStarter)),ye.set(ke.IStorageMainService,new F.SyncDescriptor(ke.StorageMainService)),f.isWindows?ye.set(V.IExternalTerminalMainService,new F.SyncDescriptor(q.WindowsExternalTerminalService)):f.isMacintosh?ye.set(V.IExternalTerminalMainService,new F.SyncDescriptor(q.MacExternalTerminalService)):f.isLinux&&ye.set(V.IExternalTerminalMainService,new F.SyncDescriptor(q.LinuxExternalTerminalService));const Pe=new m.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(ye.set(u.IBackupMainService,Pe),ye.set(qe.IURLService,new F.SyncDescriptor(ae.NativeURLService)),(0,Xe.supportsTelemetry)(this.productService,this.environmentMainService)){const De=(0,o.getDelayedChannel)(be.then(Je=>Je.getChannel("telemetryAppender"))),Me=new ze.TelemetryAppenderClient(De),Ae=(0,Le.resolveCommonProperties)(this.fileService,(0,D.release)(),(0,D.hostname)(),process.arch,this.productService.commit,this.productService.version,we,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Te=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],Ge={appenders:[Me],commonProperties:Ae,piiPaths:Te,sendErrorTelemetry:!0};ye.set(We.ITelemetryService,new F.SyncDescriptor(Be.TelemetryService,[Ge]))}else ye.set(We.ITelemetryService,Xe.NullTelemetryService);return await Pe.initialize(),this.mainInstantiationService.createChild(ye)}initChannels(we,Se,be){const ye=o.ProxyChannel.fromService(we.get(te.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",ye);const Pe=this.fileService.getProvider(v.Schemas.file);(0,b.assertType)(Pe instanceof W.DiskFileSystemProvider);const De=new A.DiskFileSystemProviderChannel(Pe,this.logService);Se.registerChannel(Z.LOCAL_FILE_SYSTEM_CHANNEL_NAME,De),be.then(Re=>Re.registerChannel(Z.LOCAL_FILE_SYSTEM_CHANNEL_NAME,De));const Me=new gt.UpdateChannel(we.get(Ke.IUpdateService));Se.registerChannel("update",Me);const Ae=o.ProxyChannel.fromService(we.get(O.IIssueMainService));Se.registerChannel("issue",Ae);const Te=o.ProxyChannel.fromService(we.get(Q.IEncryptionMainService));Se.registerChannel("encryption",Te);const Ge=o.ProxyChannel.fromService(we.get(de.ISignService));Se.registerChannel("sign",Ge);const Je=o.ProxyChannel.fromService(we.get(z.IKeyboardLayoutMainService));Se.registerChannel("keyboardLayout",Je),this.nativeHostMainService=we.get(le.INativeHostMainService);const Ze=o.ProxyChannel.fromService(this.nativeHostMainService);Se.registerChannel("nativeHost",Ze),be.then(Re=>Re.registerChannel("nativeHost",Ze));const nt=o.ProxyChannel.fromService(we.get(_e.IWorkspacesService));Se.registerChannel("workspaces",nt);const wt=o.ProxyChannel.fromService(we.get(ce.IMenubarMainService));Se.registerChannel("menubar",wt);const Ue=o.ProxyChannel.fromService(we.get(qe.IURLService));Se.registerChannel("url",Ue);const lt=o.ProxyChannel.fromService(we.get(X.IExtensionUrlTrustService));Se.registerChannel("extensionUrlTrust",lt);const rt=o.ProxyChannel.fromService(we.get(ve.IWebviewManagerService));Se.registerChannel("webview",rt);const xe=this._register(new pe.StorageDatabaseChannel(this.logService,we.get(ke.IStorageMainService)));Se.registerChannel("storage",xe),be.then(Re=>Re.registerChannel("storage",xe));const ut=o.ProxyChannel.fromService(we.get(V.IExternalTerminalMainService));Se.registerChannel("externalTerminal",ut);const st=new J.LogLevelChannel(we.get(oe.ILogService));Se.registerChannel("logLevel",st),be.then(Re=>Re.registerChannel("logLevel",st));const et=new J.LoggerChannel(we.get(oe.ILoggerService));Se.registerChannel("logger",et),be.then(Re=>Re.registerChannel("logger",et));const ot=new L.ElectronExtensionHostDebugBroadcastChannel(we.get(Ce.IWindowsMainService));Se.registerChannel("extensionhostdebugservice",ot);const ht=o.ProxyChannel.fromService(we.get($.IExtensionHostStarter));Se.registerChannel($.ipcExtensionHostStarterChannelName,ht)}openFirstWindow(we,Se){const be=this.windowsMainService=we.get(Ce.IWindowsMainService),ye=we.get(qe.IURLService),Pe=we.get(le.INativeHostMainService);this.lifecycleMainService.phase=2;const De=[],Me=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Re=>{try{return{uri:P.URI.parse(Re),url:Re}}catch{return}}).filter(Re=>{if(!Re||this.shouldBlockURI(Re.uri))return!1;const tt=this.getWindowOpenableFromProtocolLink(Re.uri);return tt?(De.push(tt),!1):!0}),Ae=this,Te=this.environmentMainService,Ge=this.productService;ye.registerHandler({async handleURL(Re,tt){if(Re.scheme===Ge.urlProtocol&&Re.path==="workspace"&&(Re=Re.with({authority:"file",path:P.URI.parse(Re.query).path,query:""})),Ae.shouldBlockURI(Re))return!0;const Et=Ae.getWindowOpenableFromProtocolLink(Re);if(Et){const[pt]=be.open({context:5,cli:{...Te.args},urisToOpen:[Et],gotoLineMode:!0});return pt.focus(),!0}if(f.isMacintosh&&be.getWindowCount()===0){const[pt]=be.open({context:5,cli:{...Te.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,me.getRemoteAuthority)(Re)});return await pt.ready(),ye.open(Re,tt)}return!1}});const Je=this._register(new Oe.ActiveWindowManager({onDidOpenWindow:Pe.onDidOpenWindow,onDidFocusWindow:Pe.onDidFocusWindow,getActiveWindowId:()=>Pe.getActiveWindowId(-1)})),Ze=new o.StaticRouter(Re=>Je.getActiveClientId().then(tt=>Re===tt)),nt=new K.URLHandlerRouter(Ze),wt=Se.getChannel("urlHandler",nt);ye.registerHandler(new K.URLHandlerChannelClient(wt)),this._register(new he.ElectronURLListener(Me,ye,be,this.environmentMainService,this.productService));const Ue=this.environmentMainService.args,lt=global.macOpenFiles,rt=(0,re.isLaunchedFromCli)(process.env)?0:4,xe=Ue._.length,ut=!!Ue["folder-uri"],st=!!Ue["file-uri"],et=Ue["skip-add-to-recently-opened"]===!0,ot=Ue.wait&&Ue.waitMarkerFilePath?P.URI.file(Ue.waitMarkerFilePath):void 0,ht=Ue.remote||void 0;return De.length>0?be.open({context:rt,cli:Ue,urisToOpen:De,gotoLineMode:!0,initialStartup:!0}):Ue["new-window"]&&!xe&&!ut&&!st?be.open({context:rt,cli:Ue,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:et,waitMarkerFileURI:ot,initialStartup:!0,remoteAuthority:ht}):lt.length&&!xe&&!ut&&!st?be.open({context:1,cli:Ue,urisToOpen:lt.map(Re=>this.getWindowOpenableFromPathSync(Re)),noRecentEntry:et,waitMarkerFileURI:ot,initialStartup:!0}):be.open({context:rt,cli:Ue,forceNewWindow:Ue["new-window"]||!xe&&Ue["unity-launch"],diffMode:Ue.diff,noRecentEntry:et,waitMarkerFileURI:ot,gotoLineMode:Ue.goto,initialStartup:!0,remoteAuthority:ht})}shouldBlockURI(we){return!!(we.authority===v.Schemas.file&&f.isWindows&&p.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,E.mnemonicButtonLabel)((0,s.localize)(0,null)),(0,E.mnemonicButtonLabel)((0,s.localize)(1,null))],defaultId:0,cancelId:1,message:(0,s.localize)(2,null,(0,E.getPathLabel)(we.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,s.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(we){if(!!we.path){if(we.authority===v.Schemas.file){const Se=P.URI.file(we.fsPath);return(0,_e.hasWorkspaceFileExtension)(Se)?{workspaceUri:Se}:{fileUri:Se}}else if(we.authority===v.Schemas.vscodeRemote){const Se=we.path.indexOf(t.posix.sep,1);if(Se!==-1){const be=we.path.substring(1,Se),ye=we.path.substring(Se),Pe=P.URI.from({scheme:v.Schemas.vscodeRemote,authority:be,path:ye,query:we.query,fragment:we.fragment});return(0,_e.hasWorkspaceFileExtension)(ye)?{workspaceUri:Pe}:/:[\d]+$/.test(ye)?{fileUri:Pe}:{folderUri:Pe}}}}}getWindowOpenableFromPathSync(we){try{if((0,r.statSync)(we).isDirectory())return{folderUri:P.URI.file(we)};if((0,_e.hasWorkspaceFileExtension)(we))return{workspaceUri:P.URI.file(we)}}catch{}return{fileUri:P.URI.file(we)}}async afterWindowOpen(we,Se){this.lifecycleMainService.phase=3;let be=!1;(0,g.once)(this.lifecycleMainService.onWillShutdown)(()=>be=!0);const ye=we.get(We.ITelemetryService);this._register(Se.onDidError(({type:Me,details:Ae})=>{let Te;switch(Me){case 1:Te="SharedProcess: detected unresponsive window";break;case 2:Te=`SharedProcess: crashed (detail: ${Ae?.reason??"<unknown>"}, code: ${Ae?.exitCode??"<unknown>"})`;break;case 3:Te=`SharedProcess: failed to load (detail: ${Ae?.reason??"<unknown>"}, code: ${Ae?.exitCode??"<unknown>"})`;break}(0,I.onUnexpectedError)(new Error(Te)),ye.publicLog2("sharedprocesserror",{type:Me,reason:Ae?.reason,code:Ae?.exitCode,visible:Se.isVisible(),shuttingdown:be})}));const Pe=this.productService.win32MutexName;if(f.isWindows&&Pe)try{const Me=j.__$__nodeRequire("windows-mutex").Mutex,Ae=new Me(Pe);(0,g.once)(this.lifecycleMainService.onWillShutdown)(()=>Ae.release())}catch(Me){this.logService.error(Me)}p.protocol.registerHttpProtocol(v.Schemas.vscodeRemoteResource,(Me,Ae)=>{Ae({url:Me.url.replace(/^vscode-remote-resource:/,"http:"),method:Me.method})});const De=we.get(Ke.IUpdateService);(De instanceof $e.Win32UpdateService||De instanceof at.LinuxUpdateService||De instanceof Qe.DarwinUpdateService)&&De.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const Ae=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,S.stripComments)(Ae))["enable-crash-reporter"]===void 0){const Je=(0,Xe.getTelemetryLevel)(this.configurationService)>=1,Ze=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Je},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,c.generateUuid)()}"`,"}"],nt=Ae.substring(0,Ae.length-2).concat(`,
`,Ze.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,C.VSBuffer.fromString(nt))}}catch(Me){this.logService.error(Me)}}async resolveShellEnvironment(we,Se,be){try{return await(0,G.getResolvedShellEnv)(this.logService,we,Se)}catch(ye){const Pe=(0,k.toErrorMessage)(ye);be?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Pe):this.logService.error(Pe)}return{}}stopTracingEventually(we,Se){this.logService.info("Tracing: waiting for windows to get ready...");const be=we.get(T.IDialogMainService);let ye=!1;const Pe=async Me=>{if(ye)return;ye=!0;const Ae=await p.contentTracing.stopRecording((0,y.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);Me?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Ae}`):be.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,s.localize)(4,null),detail:(0,s.localize)(5,null,Ae),buttons:[(0,E.mnemonicButtonLabel)((0,s.localize)(6,null))],defaultId:0,noLink:!0},(0,b.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow()))},De=setTimeout(()=>Pe(!0),3e4);Promise.all(Se.map(Me=>Me.ready())).then(()=>{clearTimeout(De),Pe(!1)})}};mt=fe([ie(2,N.IInstantiationService),ie(3,oe.ILogService),ie(4,se.IEnvironmentMainService),ie(5,ne.ILifecycleMainService),ie(6,M.IConfigurationService),ie(7,ge.IStateMainService),ie(8,U.IFileService),ie(9,ue.IProductService)],mt),e.CodeApplication=mt}),define(x[251],ee([0,1,14,28,31,9,39,15,32,42,33,10,8,63,3,34,25,21,37,58,244,11,19,192,203,24,54,166,18,182,92,73,176,75,20,93,6,186,94,55,22,56,189,95,228,48,230,76,200,38,232,65,66,209]),function(j,e,p,r,D,C,k,I,d,g,S,E,w,v,t,f,y,b,P,c,a,l,o,h,n,i,s,u,m,M,L,R,T,_,Q,se,re,G,X,B,$,Y,V,q,Z,U,A,W,F,N,H,O,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class te{main(){try{this.startup()}catch(J){console.error(J.message),p.app.exit(1)}}async startup(){(0,I.setUnexpectedErrorHandler)(ge=>console.error(ge));const[J,ce,le,ue,me,Ee,de]=this.createServices();try{try{await this.initServices(le,ue,me)}catch(ge){throw this.handleStartupDataDirError(le,de.nameLong,ge),ge}await J.invokeFunction(async ge=>{const pe=ge.get(re.ILogService),ke=ge.get(Q.ILifecycleMainService),Le=ge.get(m.IFileService),We=await this.claimInstance(pe,le,ke,J,de,!0);return b.Promises.writeFile(le.mainLockfile,String(process.pid)).catch(ze=>{pe.warn(`Error writing main lockfile: ${ze.stack}`)}),Ee.logger=new X.SpdLogLogger("main",(0,w.join)(le.logsPath,"main.log"),!0,!1,Ee.getLevel()),(0,g.once)(ke.onWillShutdown)(ze=>{Le.dispose(),ue.dispose(),ze.join(b.Promises.unlink(le.mainLockfile).catch(()=>{}))}),J.createInstance(a.CodeApplication,We,ce).startup()})}catch(ge){J.invokeFunction(this.quit,ge)}}createServices(){const J=new _.ServiceCollection,ce={_serviceBrand:void 0,...B.default};J.set($.IProductService,ce);const le=new i.EnvironmentMainService(this.resolveArgs(),ce),ue=this.patchEnvironment(le);J.set(i.IEnvironmentMainService,le);const me=new se.BufferLogService,Ee=new re.MultiplexLogService([new re.ConsoleMainLogger((0,re.getLogLevel)(le)),me]);process.once("exit",()=>Ee.dispose()),J.set(re.ILogService,Ee);const de=new M.FileService(Ee);J.set(m.IFileService,de);const ge=new L.DiskFileSystemProvider(Ee);de.registerProvider(E.Schemas.file,ge),J.set(re.ILoggerService,new G.LoggerService(Ee,de));const pe=new h.ConfigurationService(le.settingsResource,de);J.set(o.IConfigurationService,pe),J.set(Q.ILifecycleMainService,new R.SyncDescriptor(Q.LifecycleMainService));const ke=new H.StateMainService(le,Ee,de);return J.set(N.IStateMainService,ke),J.set(U.IRequestService,new R.SyncDescriptor(A.RequestMainService)),J.set(z.IThemeMainService,new R.SyncDescriptor(z.ThemeMainService)),J.set(W.ISignService,new R.SyncDescriptor(F.SignService)),J.set(q.ITunnelService,new R.SyncDescriptor(Z.TunnelService)),J.set(Y.IProtocolMainService,new R.SyncDescriptor(V.ProtocolMainService)),[new T.InstantiationService(J,!0),ue,le,pe,ke,me,ce]}patchEnvironment(J){const ce={VSCODE_IPC_HOOK:J.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(le=>{const ue=process.env[le];typeof ue=="string"&&(ce[le]=ue)}),Object.assign(process.env,ce),ce}initServices(J,ce,le){return C.Promises.settled([Promise.all([J.extensionsPath,J.codeCachePath,J.logsPath,J.globalStorageHome.fsPath,J.workspaceStorageHome.fsPath,J.backupHome].map(ue=>ue?b.Promises.mkdir(ue,{recursive:!0}):void 0)),ce.initialize(),le.init()])}async claimInstance(J,ce,le,ue,me,Ee){let de;try{(0,v.mark)("code/willStartMainServer"),de=await(0,c.serve)(ce.mainIPCHandle),(0,v.mark)("code/didStartMainServer"),(0,g.once)(le.onWillShutdown)(()=>de.dispose())}catch(ge){if(ge.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ce,me.nameLong,ge),ge;let pe;try{pe=await(0,c.connect)(ce.mainIPCHandle,"main")}catch(We){if(!Ee||t.isWindows||We.code!=="ECONNREFUSED")throw We.code==="EPERM"&&this.showStartupWarningDialog((0,l.localize)(0,null,me.nameShort),(0,l.localize)(1,null),me.nameLong),We;try{(0,r.unlinkSync)(ce.mainIPCHandle)}catch(ze){throw J.warn("Could not delete obsolete instance handle",ze),ze}return this.claimInstance(J,ce,le,ue,me,!1)}if(ce.extensionTestsLocationURI&&!ce.debugExtensionHost.break){const We="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw J.error(We),pe.dispose(),new Error(We)}let ke;!ce.args.wait&&!ce.args.status&&(ke=setTimeout(()=>{this.showStartupWarningDialog((0,l.localize)(2,null,me.nameShort),(0,l.localize)(3,null),me.nameLong)},1e4));const Le=P.ProxyChannel.toService(pe.getChannel("launch"),{disableMarshalling:!0});if(ce.args.status)return ue.invokeFunction(async()=>{const We=new n.DiagnosticsService(O.NullTelemetryService,me),ze=await Le.getMainProcessInfo(),Be=await Le.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Xe=await We.getDiagnostics(ze,Be);throw console.log(Xe),new I.ExpectedError});throw t.isWindows&&await this.windowsAllowSetForegroundWindow(Le,J),J.trace("Sending env to running instance..."),await Le.start(ce.args,process.env),pe.dispose(),ke&&clearTimeout(ke),new I.ExpectedError("Sent env to running instance. Terminating...")}if(ce.args.status)throw J.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new I.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),de}handleStartupDataDirError(J,ce,le){if(le.code==="EACCES"||le.code==="EPERM"){const ue=(0,D.coalesce)([J.userDataPath,J.extensionsPath,c.XDG_RUNTIME_DIR]).map(me=>(0,S.getPathLabel)(me,J));this.showStartupWarningDialog((0,l.localize)(4,null),(0,l.localize)(5,null,(0,k.toErrorMessage)(le),ue.join(`
`)),ce)}}showStartupWarningDialog(J,ce,le){p.dialog.showMessageBoxSync({title:le,type:"warning",buttons:[(0,S.mnemonicButtonLabel)((0,l.localize)(6,null))],message:J,detail:ce,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(J,ce){if(t.isWindows){const le=await J.getMainProcessId();ce.trace("Sending some foreground love to the running instance:",le);try{(await new Promise((ue,me)=>{j(["windows-foreground-love"],ue,me)})).allowSetForegroundWindow(le)}catch(ue){ce.error(ue)}}}quit(J,ce){const le=J.get(re.ILogService),ue=J.get(Q.ILifecycleMainService);let me=0;ce&&(ce.isExpected?ce.message&&le.trace(ce.message):(me=1,ce.stack?le.error(ce.stack):le.error(`Startup error: ${ce.toString()}`))),ue.kill(me)}resolveArgs(){const J=this.validatePaths((0,s.parseMainProcessArgv)(process.argv));if(J.wait&&!J.waitMarkerFilePath){const ce=(0,u.createWaitMarkerFile)(J.verbose);ce&&((0,s.addArg)(process.argv,"--waitMarkerFilePath",ce),J.waitMarkerFilePath=ce)}return J}validatePaths(J){if(J["open-url"]&&(J._urls=J._,J._=[]),!J.remote){const ce=this.doValidatePaths(J._,J.goto);J._=ce}return J}doValidatePaths(J,ce){const le=(0,f.cwd)(),ue=J.map(de=>{let ge=String(de),pe;ce&&(pe=(0,d.parseLineAndColumnAware)(ge),ge=pe.path),ge&&(ge=this.preparePath(le,ge));const ke=(0,d.sanitizeFilePath)(ge,le),Le=(0,w.basename)(ke);return Le&&!(0,d.isValidBasename)(Le)?null:ce&&pe?(pe.path=ke,this.toPath(pe)):ke}),me=t.isWindows||t.isMacintosh,Ee=(0,D.distinct)(ue,de=>de&&me?de.toLowerCase():de||"");return(0,D.coalesce)(Ee)}preparePath(J,ce){return t.isWindows&&(ce=(0,y.rtrim)(ce,'"')),ce=(0,y.trim)((0,y.trim)(ce," "),"	"),t.isWindows&&(ce=(0,w.resolve)(J,ce),ce=(0,y.rtrim)(ce,".")),ce}toPath(J){const ce=[J.path];return typeof J.line=="number"&&ce.push(String(J.line)),typeof J.column=="number"&&ce.push(String(J.column)),ce.join(":")}}new te().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d12df34e31b4a018735d312a8947d79331132368/core/vs/code/electron-main/main.js.map
