/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/path","vs/base/common/errors","vs/base/common/types","vs/base/common/uri","vs/base/common/event","vs/base/common/network","vs/base/common/platform","vs/base/node/pfs","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/resources","vs/base/common/arrays","vs/platform/environment/common/environment","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetry","vs/base/common/uuid","vs/platform/product/common/productService","os","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/stream","child_process","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/node/zip","vs/base/common/decorators","vs/base/common/extpath","fs","vs/base/parts/ipc/common/ipc","vs/base/node/processes","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/base/common/map","vs/base/common/assert","vs/base/common/json","vs/base/common/processes","vs/base/common/skipList","vs/base/common/console","vs/base/common/marshalling","vs/base/common/labels","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/parcel/parcelWatcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/node/spdlogLog","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","path","vs/platform/environment/node/argvHelper","vs/base/node/watcher","vs/base/common/iterator","graceful-fs","crypto","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Q=function(x){for(var i=[],T=0,R=x.length;T<R;T++)i[T]=J[x[T]];return i};define(J[56],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ok=void 0;function T(R,P){if(!R)throw new Error(P?`Assertion failed (${P})`:"Assertion Failed")}i.ok=T}),define(J[45],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.throttle=i.debounce=i.memoize=i.createDecorator=void 0;function T(C){return(w,c,v)=>{let y=null,I=null;if(typeof v.value=="function"?(y="value",I=v.value):typeof v.get=="function"&&(y="get",I=v.get),!I)throw new Error("not supported");v[y]=C(I,c)}}i.createDecorator=T;function R(C,w,c){let v=null,y=null;if(typeof c.value=="function"?(v="value",y=c.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(v="get",y=c.get),!y)throw new Error("not supported");const I=`$memoize$${w}`;c[v]=function(...d){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,d)}),this[I]}}i.memoize=R;function P(C,w,c){return T((v,y)=>{const I=`$debounce$${y}`,d=`$debounce$result$${y}`;return function(...E){this[d]||(this[d]=c?c():void 0),clearTimeout(this[I]),w&&(this[d]=w(this[d],...E),E=[this[d]]),this[I]=setTimeout(()=>{v.apply(this,E),this[d]=c?c():void 0},C)}})}i.debounce=P;function D(C,w,c){return T((v,y)=>{const I=`$throttle$timer$${y}`,d=`$throttle$result$${y}`,E=`$throttle$lastRun$${y}`,u=`$throttle$pending$${y}`;return function(...g){if(this[d]||(this[d]=c?c():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),w&&(this[d]=w(this[d],...g)),this[u])return;const h=this[E]+C;h<=Date.now()?(this[E]=Date.now(),v.apply(this,[this[d]]),this[d]=c?c():void 0):(this[u]=!0,this[I]=setTimeout(()=>{this[u]=!1,this[E]=Date.now(),v.apply(this,[this[d]]),this[d]=c?c():void 0},h-Date.now()))}})}i.throttle=D}),define(J[57],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getNodeType=i.stripComments=i.visit=i.findNodeAtOffset=i.contains=i.getNodeValue=i.getNodePath=i.findNodeAtLocation=i.parseTree=i.parse=i.getLocation=i.createScanner=i.ParseOptions=i.ParseErrorCode=i.SyntaxKind=i.ScanError=void 0;var T;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(T=i.ScanError||(i.ScanError={}));var R;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(R=i.SyntaxKind||(i.SyntaxKind={}));var P;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(P=i.ParseErrorCode||(i.ParseErrorCode={}));var D;(function(n){n.DEFAULT={allowTrailingComma:!0}})(D=i.ParseOptions||(i.ParseOptions={}));function C(n,o=!1){let e=0,t=n.length,r="",l=0,m=16,L=0;function b(te){let he=0,W=0;for(;he<te;){const B=n.charCodeAt(e);if(B>=48&&B<=57)W=W*16+B-48;else if(B>=65&&B<=70)W=W*16+B-65+10;else if(B>=97&&B<=102)W=W*16+B-97+10;else break;e++,he++}return he<te&&(W=-1),W}function O(te){e=te,r="",l=0,m=16,L=0}function N(){const te=e;if(n.charCodeAt(e)===48)e++;else for(e++;e<n.length&&v(n.charCodeAt(e));)e++;if(e<n.length&&n.charCodeAt(e)===46)if(e++,e<n.length&&v(n.charCodeAt(e)))for(e++;e<n.length&&v(n.charCodeAt(e));)e++;else return L=3,n.substring(te,e);let he=e;if(e<n.length&&(n.charCodeAt(e)===69||n.charCodeAt(e)===101))if(e++,(e<n.length&&n.charCodeAt(e)===43||n.charCodeAt(e)===45)&&e++,e<n.length&&v(n.charCodeAt(e))){for(e++;e<n.length&&v(n.charCodeAt(e));)e++;he=e}else L=3;return n.substring(te,he)}function G(){let te="",he=e;for(;;){if(e>=t){te+=n.substring(he,e),L=2;break}const W=n.charCodeAt(e);if(W===34){te+=n.substring(he,e),e++;break}if(W===92){if(te+=n.substring(he,e),e++,e>=t){L=2;break}switch(n.charCodeAt(e++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:{const ne=b(4);ne>=0?te+=String.fromCharCode(ne):L=4;break}default:L=5}he=e;continue}if(W>=0&&W<=31)if(c(W)){te+=n.substring(he,e),L=2;break}else L=6;e++}return te}function ee(){if(r="",L=0,l=e,e>=t)return l=t,m=17;let te=n.charCodeAt(e);if(w(te)){do e++,r+=String.fromCharCode(te),te=n.charCodeAt(e);while(w(te));return m=15}if(c(te))return e++,r+=String.fromCharCode(te),te===13&&n.charCodeAt(e)===10&&(e++,r+=`
`),m=14;switch(te){case 123:return e++,m=1;case 125:return e++,m=2;case 91:return e++,m=3;case 93:return e++,m=4;case 58:return e++,m=6;case 44:return e++,m=5;case 34:return e++,r=G(),m=10;case 47:{const he=e-1;if(n.charCodeAt(e+1)===47){for(e+=2;e<t&&!c(n.charCodeAt(e));)e++;return r=n.substring(he,e),m=12}if(n.charCodeAt(e+1)===42){e+=2;const W=t-1;let B=!1;for(;e<W;){if(n.charCodeAt(e)===42&&n.charCodeAt(e+1)===47){e+=2,B=!0;break}e++}return B||(e++,L=1),r=n.substring(he,e),m=13}return r+=String.fromCharCode(te),e++,m=16}case 45:if(r+=String.fromCharCode(te),e++,e===t||!v(n.charCodeAt(e)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=N(),m=11;default:for(;e<t&&ge(te);)e++,te=n.charCodeAt(e);if(l!==e){switch(r=n.substring(l,e),r){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return r+=String.fromCharCode(te),e++,m=16}}function ge(te){if(w(te)||c(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ce(){let te;do te=ee();while(te>=12&&te<=15);return te}return{setPosition:O,getPosition:()=>e,scan:o?ce:ee,getToken:()=>m,getTokenValue:()=>r,getTokenOffset:()=>l,getTokenLength:()=>e-l,getTokenError:()=>L}}i.createScanner=C;function w(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function c(n){return n===10||n===13||n===8232||n===8233}function v(n){return n>=48&&n<=57}var y;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(y||(y={}));function I(n,o){const e=[],t=new Object;let r;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function L(b,O,N,G){l.value=b,l.offset=O,l.length=N,l.type=G,l.colonOffset=void 0,r=l}try{f(n,{onObjectBegin:(b,O)=>{if(o<=b)throw t;r=void 0,m=o>b,e.push("")},onObjectProperty:(b,O,N)=>{if(o<O||(L(b,O,N,"property"),e[e.length-1]=b,o<=O+N))throw t},onObjectEnd:(b,O)=>{if(o<=b)throw t;r=void 0,e.pop()},onArrayBegin:(b,O)=>{if(o<=b)throw t;r=void 0,e.push(0)},onArrayEnd:(b,O)=>{if(o<=b)throw t;r=void 0,e.pop()},onLiteralValue:(b,O,N)=>{if(o<O||(L(b,O,N,a(b)),o<=O+N))throw t},onSeparator:(b,O,N)=>{if(o<=O)throw t;if(b===":"&&r&&r.type==="property")r.colonOffset=O,m=!1,r=void 0;else if(b===","){const G=e[e.length-1];typeof G=="number"?e[e.length-1]=G+1:(m=!0,e[e.length-1]=""),r=void 0}}})}catch(b){if(b!==t)throw b}return{path:e,previousNode:r,isAtPropertyKey:m,matches:b=>{let O=0;for(let N=0;O<b.length&&N<e.length;N++)if(b[O]===e[N]||b[O]==="*")O++;else if(b[O]!=="**")return!1;return O===b.length}}}i.getLocation=I;function d(n,o=[],e=D.DEFAULT){let t=null,r=[];const l=[];function m(b){Array.isArray(r)?r.push(b):t!==null&&(r[t]=b)}return f(n,{onObjectBegin:()=>{const b={};m(b),l.push(r),r=b,t=null},onObjectProperty:b=>{t=b},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{const b=[];m(b),l.push(r),r=b,t=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:m,onError:(b,O,N)=>{o.push({error:b,offset:O,length:N})}},e),r[0]}i.parse=d;function E(n,o=[],e=D.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(b){t.type==="property"&&(t.length=b-t.offset,t=t.parent)}function l(b){return t.children.push(b),b}f(n,{onObjectBegin:b=>{t=l({type:"object",offset:b,length:-1,parent:t,children:[]})},onObjectProperty:(b,O,N)=>{t=l({type:"property",offset:O,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:b,offset:O,length:N,parent:t})},onObjectEnd:(b,O)=>{t.length=b+O-t.offset,t=t.parent,r(b+O)},onArrayBegin:(b,O)=>{t=l({type:"array",offset:b,length:-1,parent:t,children:[]})},onArrayEnd:(b,O)=>{t.length=b+O-t.offset,t=t.parent,r(b+O)},onLiteralValue:(b,O,N)=>{l({type:a(b),offset:O,length:N,parent:t,value:b}),r(O+N)},onSeparator:(b,O,N)=>{t.type==="property"&&(b===":"?t.colonOffset=O:b===","&&r(O))},onError:(b,O,N)=>{o.push({error:b,offset:O,length:N})}},e);const L=t.children[0];return L&&delete L.parent,L}i.parseTree=E;function u(n,o){if(!n)return;let e=n;for(let t of o)if(typeof t=="string"){if(e.type!=="object"||!Array.isArray(e.children))return;let r=!1;for(const l of e.children)if(Array.isArray(l.children)&&l.children[0].value===t){e=l.children[1],r=!0;break}if(!r)return}else{const r=t;if(e.type!=="array"||r<0||!Array.isArray(e.children)||r>=e.children.length)return;e=e.children[r]}return e}i.findNodeAtLocation=u;function g(n){if(!n.parent||!n.parent.children)return[];const o=g(n.parent);if(n.parent.type==="property"){const e=n.parent.children[0].value;o.push(e)}else if(n.parent.type==="array"){const e=n.parent.children.indexOf(n);e!==-1&&o.push(e)}return o}i.getNodePath=g;function h(n){switch(n.type){case"array":return n.children.map(h);case"object":{const o=Object.create(null);for(let e of n.children){const t=e.children[1];t&&(o[e.children[0].value]=h(t))}return o}case"null":case"string":case"number":case"boolean":return n.value;default:return}}i.getNodeValue=h;function p(n,o,e=!1){return o>=n.offset&&o<n.offset+n.length||e&&o===n.offset+n.length}i.contains=p;function S(n,o,e=!1){if(p(n,o,e)){const t=n.children;if(Array.isArray(t))for(let r=0;r<t.length&&t[r].offset<=o;r++){const l=S(t[r],o,e);if(l)return l}return n}}i.findNodeAtOffset=S;function f(n,o,e=D.DEFAULT){const t=C(n,!1);function r(K){return K?()=>K(t.getTokenOffset(),t.getTokenLength()):()=>!0}function l(K){return K?Z=>K(Z,t.getTokenOffset(),t.getTokenLength()):()=>!0}const m=r(o.onObjectBegin),L=l(o.onObjectProperty),b=r(o.onObjectEnd),O=r(o.onArrayBegin),N=r(o.onArrayEnd),G=l(o.onLiteralValue),ee=l(o.onSeparator),ge=r(o.onComment),ce=l(o.onError),te=e&&e.disallowComments,he=e&&e.allowTrailingComma;function W(){for(;;){const K=t.scan();switch(t.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:te||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(K){case 12:case 13:te?B(10):ge();break;case 16:B(1);break;case 15:case 14:break;default:return K}}}function B(K,Z=[],_=[]){if(ce(K),Z.length+_.length>0){let ue=t.getToken();for(;ue!==17;){if(Z.indexOf(ue)!==-1){W();break}else if(_.indexOf(ue)!==-1)break;ue=W()}}}function ne(K){const Z=t.getTokenValue();return K?G(Z):L(Z),W(),!0}function M(){switch(t.getToken()){case 11:{let K=0;try{K=JSON.parse(t.getTokenValue()),typeof K!="number"&&(B(2),K=0)}catch{B(2)}G(K);break}case 7:G(null);break;case 8:G(!0);break;case 9:G(!1);break;default:return!1}return W(),!0}function k(){return t.getToken()!==10?(B(3,[],[2,5]),!1):(ne(!1),t.getToken()===6?(ee(":"),W(),ie()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function j(){m(),W();let K=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(K||B(4,[],[]),ee(","),W(),t.getToken()===2&&he)break}else K&&B(6,[],[]);k()||B(4,[],[2,5]),K=!0}return b(),t.getToken()!==2?B(7,[2],[]):W(),!0}function H(){O(),W();let K=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(K||B(4,[],[]),ee(","),W(),t.getToken()===4&&he)break}else K&&B(6,[],[]);ie()||B(4,[],[4,5]),K=!0}return N(),t.getToken()!==4?B(8,[4],[]):W(),!0}function ie(){switch(t.getToken()){case 3:return H();case 1:return j();case 10:return ne(!0);default:return M()}}return W(),t.getToken()===17?e.allowEmptyContent?!0:(B(4,[],[]),!1):ie()?(t.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}i.visit=f;function s(n,o){let e=C(n),t=[],r,l=0,m;do switch(m=e.getPosition(),r=e.scan(),r){case 12:case 13:case 17:l!==m&&t.push(n.substring(l,m)),o!==void 0&&t.push(e.getTokenValue().replace(/[^\r\n]/g,o)),l=e.getPosition();break}while(r!==17);return t.join("")}i.stripComments=s;function a(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}i.getNodeType=a}),function(){function x(P){const D=[];typeof P=="number"&&D.push("code/timeOrigin",P);function C(c){D.push(c,Date.now())}function w(){const c=[];for(let v=0;v<D.length;v+=2)c.push({name:D[v],startTime:D[v+1]});return c}return{mark:C,getMarks:w}}function i(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const C of performance.getEntriesByType("mark"))D.push({name:C.name,startTime:Math.round(P+C.startTime)});return D}};if(typeof process=="object"){const P=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function T(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=i()),P.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return T(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=T(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=T(R))}(),define(J[58],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.sanitizeProcessEnvironment=i.TerminateResponseCode=i.Source=void 0;var T;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(T=i.Source||(i.Source={}));var R;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(R=i.TerminateResponseCode||(i.TerminateResponseCode={}));function P(D,...C){const w=C.reduce((y,I)=>(y[I]=!0,y),{}),c=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(y=>!w[y]).forEach(y=>{for(let I=0;I<c.length;I++)if(y.search(c[I])!==-1){delete D[y];break}})}i.sanitizeProcessEnvironment=P}),function(x,i){if(typeof exports=="object"&&typeof module=="object")module.exports=i();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],i);else{var T=i();for(var R in T)(typeof exports=="object"?exports:x)[R]=T[R]}}(typeof self!="undefined"?self:this,function(){return function(x){var i={};function T(R){if(i[R])return i[R].exports;var P=i[R]={i:R,l:!1,exports:{}};return x[R].call(P.exports,P,P.exports,T),P.l=!0,P.exports}return T.m=x,T.c=i,T.d=function(R,P,D){T.o(R,P)||Object.defineProperty(R,P,{enumerable:!0,get:D})},T.r=function(R){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},T.t=function(R,P){if(1&P&&(R=T(R)),8&P||4&P&&typeof R=="object"&&R&&R.__esModule)return R;var D=Object.create(null);if(T.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:R}),2&P&&typeof R!="string")for(var C in R)T.d(D,C,function(w){return R[w]}.bind(null,C));return D},T.n=function(R){var P=R&&R.__esModule?function(){return R.default}:function(){return R};return T.d(P,"a",P),P},T.o=function(R,P){return Object.prototype.hasOwnProperty.call(R,P)},T.p="",T(T.s=0)}([function(x,i,T){(function(R){var P;i=x.exports=_,P=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var F=Array.prototype.slice.call(arguments,0);F.unshift("SEMVER"),console.log.apply(console,F)}:function(){},i.SEMVER_SPEC_VERSION="2.0.0";var D=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,w=i.re=[],c=i.src=[],v=0,y=v++;c[y]="0|[1-9]\\d*";var I=v++;c[I]="[0-9]+";var d=v++;c[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=v++;c[E]="("+c[y]+")\\.("+c[y]+")\\.("+c[y]+")";var u=v++;c[u]="("+c[I]+")\\.("+c[I]+")\\.("+c[I]+")";var g=v++;c[g]="(?:"+c[y]+"|"+c[d]+")";var h=v++;c[h]="(?:"+c[I]+"|"+c[d]+")";var p=v++;c[p]="(?:-("+c[g]+"(?:\\."+c[g]+")*))";var S=v++;c[S]="(?:-?("+c[h]+"(?:\\."+c[h]+")*))";var f=v++;c[f]="[0-9A-Za-z-]+";var s=v++;c[s]="(?:\\+("+c[f]+"(?:\\."+c[f]+")*))";var a=v++,n="v?"+c[E]+c[p]+"?"+c[s]+"?";c[a]="^"+n+"$";var o="[v=\\s]*"+c[u]+c[S]+"?"+c[s]+"?",e=v++;c[e]="^"+o+"$";var t=v++;c[t]="((?:<|>)?=?)";var r=v++;c[r]=c[I]+"|x|X|\\*";var l=v++;c[l]=c[y]+"|x|X|\\*";var m=v++;c[m]="[v=\\s]*("+c[l]+")(?:\\.("+c[l]+")(?:\\.("+c[l]+")(?:"+c[p]+")?"+c[s]+"?)?)?";var L=v++;c[L]="[v=\\s]*("+c[r]+")(?:\\.("+c[r]+")(?:\\.("+c[r]+")(?:"+c[S]+")?"+c[s]+"?)?)?";var b=v++;c[b]="^"+c[t]+"\\s*"+c[m]+"$";var O=v++;c[O]="^"+c[t]+"\\s*"+c[L]+"$";var N=v++;c[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var G=v++;c[G]="(?:~>?)";var ee=v++;c[ee]="(\\s*)"+c[G]+"\\s+",w[ee]=new RegExp(c[ee],"g");var ge=v++;c[ge]="^"+c[G]+c[m]+"$";var ce=v++;c[ce]="^"+c[G]+c[L]+"$";var te=v++;c[te]="(?:\\^)";var he=v++;c[he]="(\\s*)"+c[te]+"\\s+",w[he]=new RegExp(c[he],"g");var W=v++;c[W]="^"+c[te]+c[m]+"$";var B=v++;c[B]="^"+c[te]+c[L]+"$";var ne=v++;c[ne]="^"+c[t]+"\\s*("+o+")$|^$";var M=v++;c[M]="^"+c[t]+"\\s*("+n+")$|^$";var k=v++;c[k]="(\\s*)"+c[t]+"\\s*("+o+"|"+c[m]+")",w[k]=new RegExp(c[k],"g");var j=v++;c[j]="^\\s*("+c[m]+")\\s+-\\s+("+c[m]+")\\s*$";var H=v++;c[H]="^\\s*("+c[L]+")\\s+-\\s+("+c[L]+")\\s*$";var ie=v++;c[ie]="(<|>)?=?\\s*\\*";for(var K=0;K<35;K++)P(K,c[K]),w[K]||(w[K]=new RegExp(c[K]));function Z(F,V){if(F instanceof _)return F;if(typeof F!="string"||F.length>D||!(V?w[e]:w[a]).test(F))return null;try{return new _(F,V)}catch{return null}}function _(F,V){if(F instanceof _){if(F.loose===V)return F;F=F.version}else if(typeof F!="string")throw new TypeError("Invalid Version: "+F);if(F.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof _))return new _(F,V);P("SemVer",F,V),this.loose=V;var q=F.trim().match(V?w[e]:w[a]);if(!q)throw new TypeError("Invalid Version: "+F);if(this.raw=F,this.major=+q[1],this.minor=+q[2],this.patch=+q[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");q[4]?this.prerelease=q[4].split(".").map(function(fe){if(/^[0-9]+$/.test(fe)){var me=+fe;if(me>=0&&me<C)return me}return fe}):this.prerelease=[],this.build=q[5]?q[5].split("."):[],this.format()}i.parse=Z,i.valid=function(F,V){var q=Z(F,V);return q?q.version:null},i.clean=function(F,V){var q=Z(F.trim().replace(/^[=v]+/,""),V);return q?q.version:null},i.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(F){return P("SemVer.compare",this.version,this.loose,F),F instanceof _||(F=new _(F,this.loose)),this.compareMain(F)||this.comparePre(F)},_.prototype.compareMain=function(F){return F instanceof _||(F=new _(F,this.loose)),U(this.major,F.major)||U(this.minor,F.minor)||U(this.patch,F.patch)},_.prototype.comparePre=function(F){if(F instanceof _||(F=new _(F,this.loose)),this.prerelease.length&&!F.prerelease.length)return-1;if(!this.prerelease.length&&F.prerelease.length)return 1;if(!this.prerelease.length&&!F.prerelease.length)return 0;var V=0;do{var q=this.prerelease[V],fe=F.prerelease[V];if(P("prerelease compare",V,q,fe),q===void 0&&fe===void 0)return 0;if(fe===void 0)return 1;if(q===void 0)return-1;if(q!==fe)return U(q,fe)}while(++V)},_.prototype.inc=function(F,V){switch(F){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",V);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",V);break;case"prepatch":this.prerelease.length=0,this.inc("patch",V),this.inc("pre",V);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",V),this.inc("pre",V);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var q=this.prerelease.length;--q>=0;)typeof this.prerelease[q]=="number"&&(this.prerelease[q]++,q=-2);q===-1&&this.prerelease.push(0)}V&&(this.prerelease[0]===V?isNaN(this.prerelease[1])&&(this.prerelease=[V,0]):this.prerelease=[V,0]);break;default:throw new Error("invalid increment argument: "+F)}return this.format(),this.raw=this.version,this},i.inc=function(F,V,q,fe){typeof q=="string"&&(fe=q,q=void 0);try{return new _(F,q).inc(V,fe).version}catch{return null}},i.diff=function(F,V){if(X(F,V))return null;var q=Z(F),fe=Z(V);if(q.prerelease.length||fe.prerelease.length){for(var me in q)if((me==="major"||me==="minor"||me==="patch")&&q[me]!==fe[me])return"pre"+me;return"prerelease"}for(var me in q)if((me==="major"||me==="minor"||me==="patch")&&q[me]!==fe[me])return me},i.compareIdentifiers=U;var ue=/^[0-9]+$/;function U(F,V){var q=ue.test(F),fe=ue.test(V);return q&&fe&&(F=+F,V=+V),q&&!fe?-1:fe&&!q?1:F<V?-1:F>V?1:0}function A(F,V,q){return new _(F,q).compare(new _(V,q))}function $(F,V,q){return A(F,V,q)>0}function z(F,V,q){return A(F,V,q)<0}function X(F,V,q){return A(F,V,q)===0}function Y(F,V,q){return A(F,V,q)!==0}function de(F,V,q){return A(F,V,q)>=0}function se(F,V,q){return A(F,V,q)<=0}function re(F,V,q,fe){var me;switch(V){case"===":typeof F=="object"&&(F=F.version),typeof q=="object"&&(q=q.version),me=F===q;break;case"!==":typeof F=="object"&&(F=F.version),typeof q=="object"&&(q=q.version),me=F!==q;break;case"":case"=":case"==":me=X(F,q,fe);break;case"!=":me=Y(F,q,fe);break;case">":me=$(F,q,fe);break;case">=":me=de(F,q,fe);break;case"<":me=z(F,q,fe);break;case"<=":me=se(F,q,fe);break;default:throw new TypeError("Invalid operator: "+V)}return me}function oe(F,V){if(F instanceof oe){if(F.loose===V)return F;F=F.value}if(!(this instanceof oe))return new oe(F,V);P("comparator",F,V),this.loose=V,this.parse(F),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}i.rcompareIdentifiers=function(F,V){return U(V,F)},i.major=function(F,V){return new _(F,V).major},i.minor=function(F,V){return new _(F,V).minor},i.patch=function(F,V){return new _(F,V).patch},i.compare=A,i.compareLoose=function(F,V){return A(F,V,!0)},i.rcompare=function(F,V,q){return A(V,F,q)},i.sort=function(F,V){return F.sort(function(q,fe){return i.compare(q,fe,V)})},i.rsort=function(F,V){return F.sort(function(q,fe){return i.rcompare(q,fe,V)})},i.gt=$,i.lt=z,i.eq=X,i.neq=Y,i.gte=de,i.lte=se,i.cmp=re,i.Comparator=oe;var ye={};function le(F,V){if(F instanceof le)return F.loose===V?F:new le(F.raw,V);if(F instanceof oe)return new le(F.value,V);if(!(this instanceof le))return new le(F,V);if(this.loose=V,this.raw=F,this.set=F.split(/\s*\|\|\s*/).map(function(q){return this.parseRange(q.trim())},this).filter(function(q){return q.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+F);this.format()}function Ee(F){return!F||F.toLowerCase()==="x"||F==="*"}function Se(F,V,q,fe,me,Ce,be,Ae,Re,ke,Ue,De,Te){return((V=Ee(q)?"":Ee(fe)?">="+q+".0.0":Ee(me)?">="+q+"."+fe+".0":">="+V)+" "+(Ae=Ee(Re)?"":Ee(ke)?"<"+(+Re+1)+".0.0":Ee(Ue)?"<"+Re+"."+(+ke+1)+".0":De?"<="+Re+"."+ke+"."+Ue+"-"+De:"<="+Ae)).trim()}function Oe(F,V){for(var q=0;q<F.length;q++)if(!F[q].test(V))return!1;if(V.prerelease.length){for(q=0;q<F.length;q++)if(P(F[q].semver),F[q].semver!==ye&&F[q].semver.prerelease.length>0){var fe=F[q].semver;if(fe.major===V.major&&fe.minor===V.minor&&fe.patch===V.patch)return!0}return!1}return!0}function Fe(F,V,q){try{V=new le(V,q)}catch{return!1}return V.test(F)}function ze(F,V,q,fe){var me,Ce,be,Ae,Re;switch(F=new _(F,fe),V=new le(V,fe),q){case">":me=$,Ce=se,be=z,Ae=">",Re=">=";break;case"<":me=z,Ce=de,be=$,Ae="<",Re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Fe(F,V,fe))return!1;for(var ke=0;ke<V.set.length;++ke){var Ue=V.set[ke],De=null,Te=null;if(Ue.forEach(function(Ne){Ne.semver===ye&&(Ne=new oe(">=0.0.0")),De=De||Ne,Te=Te||Ne,me(Ne.semver,De.semver,fe)?De=Ne:be(Ne.semver,Te.semver,fe)&&(Te=Ne)}),De.operator===Ae||De.operator===Re||(!Te.operator||Te.operator===Ae)&&Ce(F,Te.semver)||Te.operator===Re&&be(F,Te.semver))return!1}return!0}oe.prototype.parse=function(F){var V=this.loose?w[ne]:w[M],q=F.match(V);if(!q)throw new TypeError("Invalid comparator: "+F);this.operator=q[1],this.operator==="="&&(this.operator=""),q[2]?this.semver=new _(q[2],this.loose):this.semver=ye},oe.prototype.toString=function(){return this.value},oe.prototype.test=function(F){return P("Comparator.test",F,this.loose),this.semver===ye||(typeof F=="string"&&(F=new _(F,this.loose)),re(F,this.operator,this.semver,this.loose))},oe.prototype.intersects=function(F,V){if(!(F instanceof oe))throw new TypeError("a Comparator is required");var q;if(this.operator==="")return q=new le(F.value,V),Fe(this.value,q,V);if(F.operator==="")return q=new le(this.value,V),Fe(F.semver,q,V);var fe=!(this.operator!==">="&&this.operator!==">"||F.operator!==">="&&F.operator!==">"),me=!(this.operator!=="<="&&this.operator!=="<"||F.operator!=="<="&&F.operator!=="<"),Ce=this.semver.version===F.semver.version,be=!(this.operator!==">="&&this.operator!=="<="||F.operator!==">="&&F.operator!=="<="),Ae=re(this.semver,"<",F.semver,V)&&(this.operator===">="||this.operator===">")&&(F.operator==="<="||F.operator==="<"),Re=re(this.semver,">",F.semver,V)&&(this.operator==="<="||this.operator==="<")&&(F.operator===">="||F.operator===">");return fe||me||Ce&&be||Ae||Re},i.Range=le,le.prototype.format=function(){return this.range=this.set.map(function(F){return F.join(" ").trim()}).join("||").trim(),this.range},le.prototype.toString=function(){return this.range},le.prototype.parseRange=function(F){var V=this.loose;F=F.trim(),P("range",F,V);var q=V?w[H]:w[j];F=F.replace(q,Se),P("hyphen replace",F),F=F.replace(w[k],"$1$2$3"),P("comparator trim",F,w[k]),F=(F=(F=F.replace(w[ee],"$1~")).replace(w[he],"$1^")).split(/\s+/).join(" ");var fe=V?w[ne]:w[M],me=F.split(" ").map(function(Ce){return function(be,Ae){return P("comp",be),be=function(Re,ke){return Re.trim().split(/\s+/).map(function(Ue){return function(De,Te){P("caret",De,Te);var Ne=Te?w[B]:w[W];return De.replace(Ne,function(Me,ve,we,Pe,Ie){var Le;return P("caret",De,Me,ve,we,Pe,Ie),Ee(ve)?Le="":Ee(we)?Le=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ee(Pe)?Le=ve==="0"?">="+ve+"."+we+".0 <"+ve+"."+(+we+1)+".0":">="+ve+"."+we+".0 <"+(+ve+1)+".0.0":Ie?(P("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Le=ve==="0"?we==="0"?">="+ve+"."+we+"."+Pe+Ie+" <"+ve+"."+we+"."+(+Pe+1):">="+ve+"."+we+"."+Pe+Ie+" <"+ve+"."+(+we+1)+".0":">="+ve+"."+we+"."+Pe+Ie+" <"+(+ve+1)+".0.0"):(P("no pr"),Le=ve==="0"?we==="0"?">="+ve+"."+we+"."+Pe+" <"+ve+"."+we+"."+(+Pe+1):">="+ve+"."+we+"."+Pe+" <"+ve+"."+(+we+1)+".0":">="+ve+"."+we+"."+Pe+" <"+(+ve+1)+".0.0"),P("caret return",Le),Le})}(Ue,ke)}).join(" ")}(be,Ae),P("caret",be),be=function(Re,ke){return Re.trim().split(/\s+/).map(function(Ue){return function(De,Te){var Ne=Te?w[ce]:w[ge];return De.replace(Ne,function(Me,ve,we,Pe,Ie){var Le;return P("tilde",De,Me,ve,we,Pe,Ie),Ee(ve)?Le="":Ee(we)?Le=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ee(Pe)?Le=">="+ve+"."+we+".0 <"+ve+"."+(+we+1)+".0":Ie?(P("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Le=">="+ve+"."+we+"."+Pe+Ie+" <"+ve+"."+(+we+1)+".0"):Le=">="+ve+"."+we+"."+Pe+" <"+ve+"."+(+we+1)+".0",P("tilde return",Le),Le})}(Ue,ke)}).join(" ")}(be,Ae),P("tildes",be),be=function(Re,ke){return P("replaceXRanges",Re,ke),Re.split(/\s+/).map(function(Ue){return function(De,Te){De=De.trim();var Ne=Te?w[O]:w[b];return De.replace(Ne,function(Me,ve,we,Pe,Ie,Le){P("xRange",De,Me,ve,we,Pe,Ie,Le);var We=Ee(we),Ve=We||Ee(Pe),je=Ve||Ee(Ie);return ve==="="&&je&&(ve=""),We?Me=ve===">"||ve==="<"?"<0.0.0":"*":ve&&je?(Ve&&(Pe=0),je&&(Ie=0),ve===">"?(ve=">=",Ve?(we=+we+1,Pe=0,Ie=0):je&&(Pe=+Pe+1,Ie=0)):ve==="<="&&(ve="<",Ve?we=+we+1:Pe=+Pe+1),Me=ve+we+"."+Pe+"."+Ie):Ve?Me=">="+we+".0.0 <"+(+we+1)+".0.0":je&&(Me=">="+we+"."+Pe+".0 <"+we+"."+(+Pe+1)+".0"),P("xRange return",Me),Me})}(Ue,ke)}).join(" ")}(be,Ae),P("xrange",be),be=function(Re,ke){return P("replaceStars",Re,ke),Re.trim().replace(w[ie],"")}(be,Ae),P("stars",be),be}(Ce,V)}).join(" ").split(/\s+/);return this.loose&&(me=me.filter(function(Ce){return!!Ce.match(fe)})),me=me.map(function(Ce){return new oe(Ce,V)})},le.prototype.intersects=function(F,V){if(!(F instanceof le))throw new TypeError("a Range is required");return this.set.some(function(q){return q.every(function(fe){return F.set.some(function(me){return me.every(function(Ce){return fe.intersects(Ce,V)})})})})},i.toComparators=function(F,V){return new le(F,V).set.map(function(q){return q.map(function(fe){return fe.value}).join(" ").trim().split(" ")})},le.prototype.test=function(F){if(!F)return!1;typeof F=="string"&&(F=new _(F,this.loose));for(var V=0;V<this.set.length;V++)if(Oe(this.set[V],F))return!0;return!1},i.satisfies=Fe,i.maxSatisfying=function(F,V,q){var fe=null,me=null;try{var Ce=new le(V,q)}catch{return null}return F.forEach(function(be){Ce.test(be)&&(fe&&me.compare(be)!==-1||(me=new _(fe=be,q)))}),fe},i.minSatisfying=function(F,V,q){var fe=null,me=null;try{var Ce=new le(V,q)}catch{return null}return F.forEach(function(be){Ce.test(be)&&(fe&&me.compare(be)!==1||(me=new _(fe=be,q)))}),fe},i.validRange=function(F,V){try{return new le(F,V).range||"*"}catch{return null}},i.ltr=function(F,V,q){return ze(F,V,"<",q)},i.gtr=function(F,V,q){return ze(F,V,">",q)},i.outside=ze,i.prerelease=function(F,V){var q=Z(F,V);return q&&q.prerelease.length?q.prerelease:null},i.intersects=function(F,V,q){return F=new le(F,q),V=new le(V,q),F.intersects(V)},i.coerce=function(F){if(F instanceof _)return F;if(typeof F!="string")return null;var V=F.match(w[N]);return V==null?null:Z((V[1]||"0")+"."+(V[2]||"0")+"."+(V[3]||"0"))}}).call(this,T(1))},function(x,i){var T,R,P=x.exports={};function D(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function w(h){if(T===setTimeout)return setTimeout(h,0);if((T===D||!T)&&setTimeout)return T=setTimeout,setTimeout(h,0);try{return T(h,0)}catch{try{return T.call(null,h,0)}catch{return T.call(this,h,0)}}}(function(){try{T=typeof setTimeout=="function"?setTimeout:D}catch{T=D}try{R=typeof clearTimeout=="function"?clearTimeout:C}catch{R=C}})();var c,v=[],y=!1,I=-1;function d(){y&&c&&(y=!1,c.length?v=c.concat(v):I=-1,v.length&&E())}function E(){if(!y){var h=w(d);y=!0;for(var p=v.length;p;){for(c=v,v=[];++I<p;)c&&c[I].run();I=-1,p=v.length}c=null,y=!1,function(S){if(R===clearTimeout)return clearTimeout(S);if((R===C||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(S);try{R(S)}catch{try{return R.call(null,S)}catch{return R.call(this,S)}}}(h)}}function u(h,p){this.fun=h,this.array=p}function g(){}P.nextTick=function(h){var p=new Array(arguments.length-1);if(arguments.length>1)for(var S=1;S<arguments.length;S++)p[S-1]=arguments[S];v.push(new u(h,p)),v.length!==1||y||w(E)},u.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=g,P.addListener=g,P.once=g,P.off=g,P.removeListener=g,P.removeAllListeners=g,P.emit=g,P.prependListener=g,P.prependOnceListener=g,P.listeners=function(h){return[]},P.binding=function(h){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(h){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(J[59],Q([0,1]),function(x,i){"use strict";var T;Object.defineProperty(i,"__esModule",{value:!0}),i.SkipList=void 0;class R{constructor(w,c,v){this.level=w,this.key=c,this.value=v,this.forward=[]}}const P=void 0;class D{constructor(w,c=2**16){this.comparator=w,this[T]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(c)|0),this._header=new R(this._maxLevel,P,P)}get size(){return this._size}clear(){this._header=new R(this._maxLevel,P,P)}has(w){return Boolean(D._search(this,w,this.comparator))}get(w){return D._search(this,w,this.comparator)?.value}set(w,c){return D._insert(this,w,c,this.comparator)&&(this._size+=1),this}delete(w){const c=D._delete(this,w,this.comparator);return c&&(this._size-=1),c}forEach(w,c){let v=this._header.forward[0];for(;v;)w.call(c,v.value,v.key,this),v=v.forward[0]}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let w=this._header.forward[0];for(;w;)yield[w.key,w.value],w=w.forward[0]}*keys(){let w=this._header.forward[0];for(;w;)yield w.key,w=w.forward[0]}*values(){let w=this._header.forward[0];for(;w;)yield w.value,w=w.forward[0]}toString(){let w="[SkipList]:",c=this._header.forward[0];for(;c;)w+=`node(${c.key}, ${c.value}, lvl:${c.level})`,c=c.forward[0];return w}static _search(w,c,v){let y=w._header;for(let I=w._level-1;I>=0;I--)for(;y.forward[I]&&v(y.forward[I].key,c)<0;)y=y.forward[I];if(y=y.forward[0],y&&v(y.key,c)===0)return y}static _insert(w,c,v,y){let I=[],d=w._header;for(let E=w._level-1;E>=0;E--){for(;d.forward[E]&&y(d.forward[E].key,c)<0;)d=d.forward[E];I[E]=d}if(d=d.forward[0],d&&y(d.key,c)===0)return d.value=v,!1;{let E=D._randomLevel(w);if(E>w._level){for(let u=w._level;u<E;u++)I[u]=w._header;w._level=E}d=new R(E,c,v);for(let u=0;u<E;u++)d.forward[u]=I[u].forward[u],I[u].forward[u]=d;return!0}}static _randomLevel(w,c=.5){let v=1;for(;Math.random()<c&&v<w._maxLevel;)v+=1;return v}static _delete(w,c,v){let y=[],I=w._header;for(let d=w._level-1;d>=0;d--){for(;I.forward[d]&&v(I.forward[d].key,c)<0;)I=I.forward[d];y[d]=I}if(I=I.forward[0],!I||v(I.key,c)!==0)return!1;for(let d=0;d<w._level&&y[d].forward[d]===I;d++)y[d].forward[d]=I.forward[d];for(;w._level>0&&w._header.forward[w._level-1]===P;)w._level-=1;return!0}}i.SkipList=D}),define(J[37],Q([0,1,7,2]),function(x,i,T,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.prefixedStream=i.prefixedReadable=i.transform=i.toReadable=i.emptyStream=i.toStream=i.peekStream=i.listenStream=i.consumeStream=i.peekReadable=i.consumeReadable=i.newWriteableStream=i.isReadableBufferedStream=i.isReadableStream=void 0;function P(f){const s=f;return s?[s.on,s.pause,s.resume,s.destroy].every(a=>typeof a=="function"):!1}i.isReadableStream=P;function D(f){const s=f;return s?P(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}i.isReadableBufferedStream=D;function C(f,s){return new w(f,s)}i.newWriteableStream=C;class w{constructor(s,a){this.reducer=s,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(a=>a(s))}emitError(s){this.listeners.error.length===0?(0,T.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(a=>a(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,a){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(s,a){if(this.state.destroyed)return;let n;switch(s){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const o=n.indexOf(a);o>=0&&n.splice(o,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function c(f,s){const a=[];let n;for(;(n=f.read())!==null;)a.push(n);return s(a)}i.consumeReadable=c;function v(f,s,a){const n=[];let o;for(;(o=f.read())!==null&&n.length<a;)n.push(o);return o===null&&n.length>0?s(n):{read:()=>{if(n.length>0)return n.shift();if(typeof o!="undefined"){const e=o;return o=void 0,e}return f.read()}}}i.peekReadable=v;function y(f,s){return new Promise((a,n)=>{const o=[];I(f,{onData:e=>{s&&o.push(e)},onError:e=>{s?n(e):a(void 0)},onEnd:()=>{a(s?s(o):void 0)}})})}i.consumeStream=y;function I(f,s){let a=!1;return f.on("error",n=>{a||s.onError(n)}),f.on("end",()=>{a||s.onEnd()}),f.on("data",n=>{a||s.onData(n)}),(0,R.toDisposable)(()=>a=!0)}i.listenStream=I;function d(f,s){return new Promise((a,n)=>{const o=new R.DisposableStore,e=[],t=m=>{if(e.push(m),e.length>s)return o.dispose(),f.pause(),a({stream:f,buffer:e,ended:!1})},r=m=>n(m),l=()=>a({stream:f,buffer:e,ended:!0});o.add((0,R.toDisposable)(()=>f.removeListener("error",r))),f.on("error",r),o.add((0,R.toDisposable)(()=>f.removeListener("end",l))),f.on("end",l),o.add((0,R.toDisposable)(()=>f.removeListener("data",t))),f.on("data",t)})}i.peekStream=d;function E(f,s){const a=C(s);return a.end(f),a}i.toStream=E;function u(){const f=C(()=>{throw new Error("not supported")});return f.end(),f}i.emptyStream=u;function g(f){let s=!1;return{read:()=>s?null:(s=!0,f)}}i.toReadable=g;function h(f,s,a){const n=C(a);return I(f,{onData:o=>n.write(s.data(o)),onError:o=>n.error(s.error?s.error(o):o),onEnd:()=>n.end()}),n}i.transform=h;function p(f,s,a){let n=!1;return{read:()=>{const o=s.read();return n?o:(n=!0,o!==null?a([f,o]):f)}}}i.prefixedReadable=p;function S(f,s,a){let n=!1;const o=C(a);return I(s,{onData:e=>n?o.write(e):(n=!0,o.write(a([f,e]))),onError:e=>o.error(e),onEnd:()=>{n||(n=!0,o.write(f)),o.end()}}),o}i.prefixedStream=S}),define(J[17],Q([0,1,37]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.prefixedBufferStream=i.prefixedBufferReadable=i.newWriteableBufferStream=i.streamToBufferReadableStream=i.bufferToStream=i.bufferedStreamToBuffer=i.streamToBuffer=i.bufferToReadable=i.readableToBuffer=i.writeUInt8=i.readUInt8=i.writeUInt32LE=i.readUInt32LE=i.writeUInt32BE=i.readUInt32BE=i.writeUInt16LE=i.readUInt16LE=i.VSBuffer=void 0;const R=typeof Buffer!="undefined";let P,D;class C{constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}static alloc(t){return R?new C(Buffer.allocUnsafe(t)):new C(new Uint8Array(t))}static wrap(t){return R&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new C(t)}static fromString(t,r){return!(r?.dontUseNodeBuffer||!1)&&R?new C(Buffer.from(t)):(P||(P=new TextEncoder),new C(P.encode(t)))}static fromByteArray(t){const r=C.alloc(t.length);for(let l=0,m=t.length;l<m;l++)r.buffer[l]=t[l];return r}static concat(t,r){if(typeof r=="undefined"){r=0;for(let L=0,b=t.length;L<b;L++)r+=t[L].byteLength}const l=C.alloc(r);let m=0;for(let L=0,b=t.length;L<b;L++){const O=t[L];l.set(O,m),m+=O.byteLength}return l}clone(){const t=C.alloc(this.byteLength);return t.set(this),t}toString(){return R?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(t,r){return new C(this.buffer.subarray(t,r))}set(t,r){if(t instanceof C)this.buffer.set(t.buffer,r);else if(t instanceof Uint8Array)this.buffer.set(t,r);else if(t instanceof ArrayBuffer)this.buffer.set(new Uint8Array(t),r);else if(ArrayBuffer.isView(t))this.buffer.set(new Uint8Array(t.buffer,t.byteOffset,t.byteLength),r);else throw new Error("Unkown argument 'array'")}readUInt32BE(t){return v(this.buffer,t)}writeUInt32BE(t,r){y(this.buffer,t,r)}readUInt32LE(t){return I(this.buffer,t)}writeUInt32LE(t,r){d(this.buffer,t,r)}readUInt8(t){return E(this.buffer,t)}writeUInt8(t,r){u(this.buffer,t,r)}}i.VSBuffer=C;function w(e,t){return e[t+0]<<0>>>0|e[t+1]<<8>>>0}i.readUInt16LE=w;function c(e,t,r){e[r+0]=t&255,t=t>>>8,e[r+1]=t&255}i.writeUInt16LE=c;function v(e,t){return e[t]*2**24+e[t+1]*2**16+e[t+2]*2**8+e[t+3]}i.readUInt32BE=v;function y(e,t,r){e[r+3]=t,t=t>>>8,e[r+2]=t,t=t>>>8,e[r+1]=t,t=t>>>8,e[r]=t}i.writeUInt32BE=y;function I(e,t){return e[t+0]<<0>>>0|e[t+1]<<8>>>0|e[t+2]<<16>>>0|e[t+3]<<24>>>0}i.readUInt32LE=I;function d(e,t,r){e[r+0]=t&255,t=t>>>8,e[r+1]=t&255,t=t>>>8,e[r+2]=t&255,t=t>>>8,e[r+3]=t&255}i.writeUInt32LE=d;function E(e,t){return e[t]}i.readUInt8=E;function u(e,t,r){e[r]=t}i.writeUInt8=u;function g(e){return T.consumeReadable(e,t=>C.concat(t))}i.readableToBuffer=g;function h(e){return T.toReadable(e)}i.bufferToReadable=h;function p(e){return T.consumeStream(e,t=>C.concat(t))}i.streamToBuffer=p;async function S(e){return e.ended?C.concat(e.buffer):C.concat([...e.buffer,await p(e.stream)])}i.bufferedStreamToBuffer=S;function f(e){return T.toStream(e,t=>C.concat(t))}i.bufferToStream=f;function s(e){return T.transform(e,{data:t=>typeof t=="string"?C.fromString(t):C.wrap(t)},t=>C.concat(t))}i.streamToBufferReadableStream=s;function a(e){return T.newWriteableStream(t=>C.concat(t),e)}i.newWriteableBufferStream=a;function n(e,t){return T.prefixedReadable(e,t,r=>C.concat(r))}i.prefixedBufferReadable=n;function o(e,t){return T.prefixedStream(e,t,r=>C.concat(r))}i.prefixedBufferStream=o}),define(J[21],Q([0,1,8]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.filter=i.getCaseInsensitive=i.distinct=i.getOrDefault=i.safeStringify=i.equals=i.mixin=i.cloneAndChange=i.deepFreeze=i.deepClone=void 0;function R(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const h=Array.isArray(g)?[]:{};return Object.keys(g).forEach(p=>{g[p]&&typeof g[p]=="object"?h[p]=R(g[p]):h[p]=g[p]}),h}i.deepClone=R;function P(g){if(!g||typeof g!="object")return g;const h=[g];for(;h.length>0;){const p=h.shift();Object.freeze(p);for(const S in p)if(D.call(p,S)){const f=p[S];typeof f=="object"&&!Object.isFrozen(f)&&h.push(f)}}return g}i.deepFreeze=P;const D=Object.prototype.hasOwnProperty;function C(g,h){return w(g,h,new Set)}i.cloneAndChange=C;function w(g,h,p){if((0,T.isUndefinedOrNull)(g))return g;const S=h(g);if(typeof S!="undefined")return S;if((0,T.isArray)(g)){const f=[];for(const s of g)f.push(w(s,h,p));return f}if((0,T.isObject)(g)){if(p.has(g))throw new Error("Cannot clone recursive data-structure");p.add(g);const f={};for(let s in g)D.call(g,s)&&(f[s]=w(g[s],h,p));return p.delete(g),f}return g}function c(g,h,p=!0){return(0,T.isObject)(g)?((0,T.isObject)(h)&&Object.keys(h).forEach(S=>{S in g?p&&((0,T.isObject)(g[S])&&(0,T.isObject)(h[S])?c(g[S],h[S],p):g[S]=h[S]):g[S]=h[S]}),g):h}i.mixin=c;function v(g,h){if(g===h)return!0;if(g==null||h===null||h===void 0||typeof g!=typeof h||typeof g!="object"||Array.isArray(g)!==Array.isArray(h))return!1;let p,S;if(Array.isArray(g)){if(g.length!==h.length)return!1;for(p=0;p<g.length;p++)if(!v(g[p],h[p]))return!1}else{const f=[];for(S in g)f.push(S);f.sort();const s=[];for(S in h)s.push(S);if(s.sort(),!v(f,s))return!1;for(p=0;p<f.length;p++)if(!v(g[f[p]],h[f[p]]))return!1}return!0}i.equals=v;function y(g){const h=new Set;return JSON.stringify(g,(p,S)=>{if((0,T.isObject)(S)||Array.isArray(S)){if(h.has(S))return"[Circular]";h.add(S)}return S})}i.safeStringify=y;function I(g,h,p){const S=h(g);return typeof S=="undefined"?p:S}i.getOrDefault=I;function d(g,h){const p=Object.create(null);return!g||!h||Object.keys(h).forEach(f=>{const s=g[f],a=h[f];v(s,a)||(p[f]=a)}),p}i.distinct=d;function E(g,h){const p=h.toLowerCase(),S=Object.keys(g).find(f=>f.toLowerCase()===p);return S?g[S]:g[h]}i.getCaseInsensitive=E;function u(g,h){const p=Object.create(null);for(const[S,f]of Object.entries(g))h(S,f)&&(p[S]=f);return p}i.filter=u}),define(J[60],Q([0,1,9]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.log=i.getFirstFrame=i.parse=i.isRemoteConsoleLog=void 0;function R(v){const y=v;return y&&typeof y.type=="string"&&typeof y.severity=="string"}i.isRemoteConsoleLog=R;function P(v){const y=[];let I;try{const d=JSON.parse(v.arguments),E=d[d.length-1];E&&E.__$stack&&(d.pop(),I=E.__$stack),y.push(...d)}catch{y.push("Unable to log remote console arguments",v.arguments)}return{args:y,stack:I}}i.parse=P;function D(v){if(typeof v!="string")return D(P(v).stack);const y=v;if(y){const I=C(y),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(d&&d.length===4)return{uri:T.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}i.getFirstFrame=D;function C(v){if(!v)return v;const y=v.indexOf(`
`);return y===-1?v:v.substring(0,y)}function w(v,y){const{args:I,stack:d}=P(v),E=typeof I[0]=="string"&&I.length===1;let u=C(d);u&&(u=`(${u.trim()})`);let g=[];if(typeof I[0]=="string"?u&&E?g=[`%c[${y}] %c${I[0]} %c${u}`,c("blue"),c(""),c("grey")]:g=[`%c[${y}] %c${I[0]}`,c("blue"),c(""),...I.slice(1)]:g=[`%c[${y}]%`,c("blue"),...I],u&&!E&&g.push(u),typeof console[v.severity]!="function")throw new Error("Unknown console method");console[v.severity].apply(console,g)}i.log=w;function c(v){return`color: ${v}`}}),define(J[61],Q([0,1,17,26,9]),function(x,i,T,R,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.revive=i.MarshalledId=i.parse=i.stringify=void 0;function D(y){return JSON.stringify(y,c)}i.stringify=D;function C(y){let I=JSON.parse(y);return I=v(I),I}i.parse=C;var w;(function(y){y[y.Uri=1]="Uri",y[y.Regexp=2]="Regexp",y[y.ScmResource=3]="ScmResource",y[y.ScmResourceGroup=4]="ScmResourceGroup",y[y.ScmProvider=5]="ScmProvider",y[y.CommentController=6]="CommentController",y[y.CommentThread=7]="CommentThread",y[y.CommentThreadReply=8]="CommentThreadReply",y[y.CommentNode=9]="CommentNode",y[y.CommentThreadNode=10]="CommentThreadNode",y[y.TimelineActionContext=11]="TimelineActionContext",y[y.NotebookCellActionContext=12]="NotebookCellActionContext",y[y.TestItemContext=13]="TestItemContext"})(w=i.MarshalledId||(i.MarshalledId={}));function c(y,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,R.regExpFlags)(I)}:I}function v(y,I=0){if(!y||I>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return P.URI.revive(y);case 2:return new RegExp(y.source,y.flags)}if(y instanceof T.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let d=0;d<y.length;++d)y[d]=v(y[d],I+1);else for(const d in y)Object.hasOwnProperty.call(y,d)&&(y[d]=v(y[d],I+1))}return y}i.revive=v}),define(J[62],Q([0,1,46,11,6,12,18,26,9]),function(x,i,T,R,P,D,C,w,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.splitName=i.unmnemonicLabel=i.mnemonicButtonLabel=i.mnemonicMenuLabel=i.template=i.shorten=i.untildify=i.tildify=i.normalizeDriveLetter=i.getBaseLabel=i.getPathLabel=void 0;function v(t,r,l){if(typeof t=="string"&&(t=c.URI.file(t)),l){const L=l.getWorkspaceFolder(t);if(L){const b=l.getWorkspace().folders.length>1;let O;if((0,C.isEqual)(L.uri,t)?O="":O=(0,C.relativePath)(L.uri,t),b){const N=L.name?L.name:(0,C.basename)(L.uri);O=O?N+" \u2022 "+O:N}return O}}if(t.scheme!==R.Schemas.file&&t.scheme!==R.Schemas.untitled)return t.with({query:null,fragment:null}).toString(!0);if((0,T.hasDriveLetter)(t.fsPath))return(0,P.normalize)(I(t.fsPath));let m=(0,P.normalize)(t.fsPath);return!D.isWindows&&r?.userHome&&(m=E(m,r.userHome.fsPath)),m}i.getPathLabel=v;function y(t){if(!t)return;typeof t=="string"&&(t=c.URI.file(t));const r=(0,C.basename)(t)||(t.scheme===R.Schemas.file?t.fsPath:t.path);return D.isWindows&&(0,T.isRootOrDriveLetter)(r)?I(r):r}i.getBaseLabel=y;function I(t,r){return(0,T.hasDriveLetter)(t,r)?t.charAt(0).toUpperCase()+t.slice(1):t}i.normalizeDriveLetter=I;let d=Object.create(null);function E(t,r){if(D.isWindows||!t||!r)return t;let l=d.original===r?d.normalized:void 0;return l||(l=`${(0,w.rtrim)(r,P.posix.sep)}${P.posix.sep}`,d={original:r,normalized:l}),(D.isLinux?t.startsWith(l):(0,w.startsWithIgnoreCase)(t,l))&&(t=`~/${t.substr(l.length)}`),t}i.tildify=E;function u(t,r){return t.replace(/^~($|\/|\\)/,`${r}$1`)}i.untildify=u;const g="\u2026",h="\\\\",p="~";function S(t,r=P.sep){const l=new Array(t.length);let m=!1;for(let L=0;L<t.length;L++){let b=t[L];if(b===""){l[L]=`.${r}`;continue}if(!b){l[L]=b;continue}m=!0;let O="";b.indexOf(h)===0?(O=b.substr(0,b.indexOf(h)+h.length),b=b.substr(b.indexOf(h)+h.length)):b.indexOf(r)===0?(O=b.substr(0,b.indexOf(r)+r.length),b=b.substr(b.indexOf(r)+r.length)):b.indexOf(p)===0&&(O=b.substr(0,b.indexOf(p)+p.length),b=b.substr(b.indexOf(p)+p.length));const N=b.split(r);for(let G=1;m&&G<=N.length;G++)for(let ee=N.length-G;m&&ee>=0;ee--){m=!1;let ge=N.slice(ee,ee+G).join(r);for(let ce=0;!m&&ce<t.length;ce++)if(ce!==L&&t[ce]&&t[ce].indexOf(ge)>-1){const te=ee+G===N.length,he=ee>0&&t[ce].indexOf(r)>-1?r+ge:ge,W=t[ce].endsWith(he);m=!te||W}if(!m){let ce="";(N[0].endsWith(":")||O!=="")&&(ee===1&&(ee=0,G++,ge=N[0]+r+ge),ee>0&&(ce=N[0]+r),ce=O+ce),ee>0&&(ce=ce+g+r),ce=ce+ge,ee+G<N.length&&(ce=ce+r+g),l[L]=ce}}m&&(l[L]=b)}return l}i.shorten=S;var f;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function s(t,r=Object.create(null)){const l=[];let m=!1,L="";for(const b of t)if(b==="$"||m&&b==="{")L&&l.push({value:L,type:f.TEXT}),L="",m=!0;else if(b==="}"&&m){const O=r[L];if(typeof O=="string")O.length&&l.push({value:O,type:f.VARIABLE});else if(O){const N=l[l.length-1];(!N||N.type!==f.SEPARATOR)&&l.push({value:O.label,type:f.SEPARATOR})}L="",m=!1}else L+=b;return L&&!m&&l.push({value:L,type:f.TEXT}),l.filter((b,O)=>{if(b.type===f.SEPARATOR){const N=l[O-1],G=l[O+1];return[N,G].every(ee=>ee&&(ee.type===f.VARIABLE||ee.type===f.TEXT)&&ee.value.length>0)}return!0}).map(b=>b.value).join("")}i.template=s;function a(t,r){return D.isMacintosh||r?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.isMacintosh?"&":"&&"):t.replace(/&&|&/g,l=>l==="&"?"&&":"&")}i.mnemonicMenuLabel=a;function n(t,r){return D.isMacintosh||r?t.replace(/\(&&\w\)|&&/g,""):D.isWindows?t.replace(/&&|&/g,l=>l==="&"?"&&":"&"):t.replace(/&&/g,"_")}i.mnemonicButtonLabel=n;function o(t){return t.replace(/&/g,"&&")}i.unmnemonicLabel=o;function e(t){const r=t.indexOf("/")!==-1?P.posix:P.win32,l=r.basename(t),m=r.dirname(t);return l.length?{name:l,parentPath:m}:{name:m,parentPath:""}}i.splitName=e}),define(J[63],Q([0,1,130]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LineDecoder=void 0;class R{constructor(D="utf8"){this.stringDecoder=new T.StringDecoder(D),this.remaining=null}write(D){const C=[],w=this.remaining?this.remaining+this.stringDecoder.write(D):this.stringDecoder.write(D);if(w.length<1)return C;let c=0,v,y=c;for(;y<w.length;)if(v=w.charCodeAt(y),v===13||v===10){if(C.push(w.substring(c,y)),y++,y<w.length){const I=v;v=w.charCodeAt(y),(I===13&&v===10||I===10&&v===13)&&y++}c=y}else y++;return this.remaining=c<w.length?w.substr(c):null,C}end(){return this.remaining}}i.LineDecoder=R}),define(J[64],Q([0,1,47,6,26,13]),function(x,i,T,R,P,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.realpathSync=i.realpath=i.realcaseSync=void 0;function C(y){const I=(0,R.dirname)(y);if(y===I)return y;const d=((0,R.basename)(y)||y).toLowerCase();try{const u=(0,D.readdirSync)(I).filter(g=>g.toLowerCase()===d);if(u.length===1){const g=C(I);if(g)return(0,R.join)(g,u[0])}else if(u.length>1){const g=u.indexOf(d);if(g>=0){const h=C(I);if(h)return(0,R.join)(h,u[g])}}}catch{}return null}i.realcaseSync=C;async function w(y){try{return await D.Promises.realpath(y)}catch{const d=v(y);return await D.Promises.access(d,T.constants.R_OK),d}}i.realpath=w;function c(y){try{return T.realpathSync(y)}catch{const d=v(y);return T.accessSync(d,T.constants.R_OK),d}}i.realpathSync=c;function v(y){return(0,P.rtrim)((0,R.normalize)(y),R.sep)}}),define(J[65],Q([0,1,33,6,13]),function(x,i,T,R,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getFirstAvailablePowerShellInstallation=i.enumeratePowerShellInstallations=void 0;const D=/^\d+$/,C=/^Microsoft.PowerShell_.*/,w=/^Microsoft.PowerShellPreview_.*/;var c;(function(s){s[s.x64=0]="x64",s[s.x86=1]="x86",s[s.ARM=2]="ARM"})(c||(c={}));let v;switch(process.arch){case"ia32":case"x32":v=1;break;case"arm":case"arm64":v=2;break;default:v=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class I{constructor(a,n,o){this.exePath=a,this.displayName=n,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await P.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function d({useAlternateBitness:s=!1}={}){return s?v===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function E({useAlternateBitness:s=!1,findPreview:a=!1}={}){const n=d({useAlternateBitness:s});if(!n)return null;const o=R.join(n,"PowerShell");if(!await P.SymlinkSupport.existsDirectory(o))return null;let e=-1,t=null;for(const m of await P.Promises.readdir(o)){let L=-1;if(a){const O=m.indexOf("-");if(O<0)continue;const N=m.substring(0,O);if(!D.test(N)||m.substring(O+1)!=="preview")continue;L=parseInt(N,10)}else{if(!D.test(m))continue;L=parseInt(m,10)}if(L<=e)continue;const b=R.join(o,m,"pwsh.exe");!await P.SymlinkSupport.existsFile(b)||(t=b,e=L)}if(!t)return null;const r=n.includes("x86")?" (x86)":"",l=a?" Preview":"";return new I(t,`PowerShell${l}${r}`,!0)}async function u({findPreview:s}={}){if(!process.env.LOCALAPPDATA)return null;const a=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await P.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:n,pwshMsixName:o}=s?{pwshMsixDirRegex:w,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const e of await P.Promises.readdir(a))if(n.test(e)){const t=R.join(a,e,"pwsh.exe");return new I(t,o)}return null}function g(){const s=R.join(T.homedir(),".dotnet","tools","pwsh.exe");return new I(s,".NET Core PowerShell Global Tool")}function h(){const s=R.join(process.env.windir,v===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(s,"Windows PowerShell",!0)}async function*p(){let s=await E();s&&(yield s),s=await E({useAlternateBitness:!0}),s&&(yield s),s=await u(),s&&(yield s),s=g(),s&&(yield s),s=await E({findPreview:!0}),s&&(yield s),s=await u({findPreview:!0}),s&&(yield s),s=await E({useAlternateBitness:!0,findPreview:!0}),s&&(yield s),s=h(),s&&(yield s)}async function*S(){for await(const s of p())await s.exists()&&(yield s)}i.enumeratePowerShellInstallations=S;async function f(){for await(const s of S())return s;return null}i.getFirstAvailablePowerShellInstallation=f});var pe=this&&this.__decorate||function(x,i,T,R){var P=arguments.length,D=P<3?i:R===null?R=Object.getOwnPropertyDescriptor(i,T):R,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(x,i,T,R);else for(var w=x.length-1;w>=0;w--)(C=x[w])&&(D=(P<3?C(D):P>3?C(i,T,D):C(i,T))||D);return P>3&&D&&Object.defineProperty(i,T,D),D};define(J[48],Q([0,1,19,3,17,24,45,7,10,2,61,26,8]),function(x,i,T,R,P,D,C,w,c,v,y,I,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IPCLogger=i.logWithColors=i.ProxyChannel=i.StaticRouter=i.getNextTickChannel=i.getDelayedChannel=i.IPCClient=i.IPCServer=i.ChannelClient=i.RequestInitiator=i.ChannelServer=i.ResponseType=i.RequestType=void 0;var E;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(E=i.RequestType||(i.RequestType={}));function u(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(g=i.ResponseType||(i.ResponseType={}));function h(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(p||(p={}));class S{constructor(k){this.buffer=k,this.pos=0}read(k){const j=this.buffer.slice(this.pos,this.pos+k);return this.pos+=j.byteLength,j}}class f{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(k){this.buffers.push(k)}}var s;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(s||(s={}));function a(M){const k=P.VSBuffer.alloc(4);return k.writeUInt32BE(M,0),k}function n(M){return M.read(4).readUInt32BE(0)}function o(M){const k=P.VSBuffer.alloc(1);return k.writeUInt8(M,0),k}const e={Undefined:o(s.Undefined),String:o(s.String),Buffer:o(s.Buffer),VSBuffer:o(s.VSBuffer),Array:o(s.Array),Object:o(s.Object)},t=typeof Buffer!="undefined";function r(M,k){if(typeof k=="undefined")M.write(e.Undefined);else if(typeof k=="string"){const j=P.VSBuffer.fromString(k);M.write(e.String),M.write(a(j.byteLength)),M.write(j)}else if(t&&Buffer.isBuffer(k)){const j=P.VSBuffer.wrap(k);M.write(e.Buffer),M.write(a(j.byteLength)),M.write(j)}else if(k instanceof P.VSBuffer)M.write(e.VSBuffer),M.write(a(k.byteLength)),M.write(k);else if(Array.isArray(k)){M.write(e.Array),M.write(a(k.length));for(const j of k)r(M,j)}else{const j=P.VSBuffer.fromString(JSON.stringify(k));M.write(e.Object),M.write(a(j.byteLength)),M.write(j)}}function l(M){switch(M.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return M.read(n(M)).toString();case s.Buffer:return M.read(n(M)).buffer;case s.VSBuffer:return M.read(n(M));case s.Array:{const j=n(M),H=[];for(let ie=0;ie<j;ie++)H.push(l(M));return H}case s.Object:return JSON.parse(M.read(n(M)).toString())}}class m{constructor(k,j,H=null,ie=1e3){this.protocol=k,this.ctx=j,this.logger=H,this.timeoutDelay=ie,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(K=>this.onRawMessage(K)),this.sendResponse({type:200})}registerChannel(k,j){this.channels.set(k,j),setTimeout(()=>this.flushPendingRequests(k),0)}sendResponse(k){switch(k.type){case 200:{const j=this.send([k.type]);this.logger&&this.logger.logOutgoing(j,0,1,h(k.type));return}case 201:case 202:case 204:case 203:{const j=this.send([k.type,k.id],k.data);this.logger&&this.logger.logOutgoing(j,k.id,1,h(k.type),k.data);return}}}send(k,j=void 0){const H=new f;return r(H,k),r(H,j),this.sendBuffer(H.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch{return 0}}onRawMessage(k){const j=new S(k),H=l(j),ie=l(j),K=H[0];switch(K){case 100:return this.logger&&this.logger.logIncoming(k.byteLength,H[1],1,`${u(K)}: ${H[2]}.${H[3]}`,ie),this.onPromise({type:K,id:H[1],channelName:H[2],name:H[3],arg:ie});case 102:return this.logger&&this.logger.logIncoming(k.byteLength,H[1],1,`${u(K)}: ${H[2]}.${H[3]}`,ie),this.onEventListen({type:K,id:H[1],channelName:H[2],name:H[3],arg:ie});case 101:return this.logger&&this.logger.logIncoming(k.byteLength,H[1],1,`${u(K)}`),this.disposeActiveRequest({type:K,id:H[1]});case 103:return this.logger&&this.logger.logIncoming(k.byteLength,H[1],1,`${u(K)}`),this.disposeActiveRequest({type:K,id:H[1]})}}onPromise(k){const j=this.channels.get(k.channelName);if(!j){this.collectPendingRequest(k);return}const H=new D.CancellationTokenSource;let ie;try{ie=j.call(this.ctx,k.name,k.arg,H.token)}catch(_){ie=Promise.reject(_)}const K=k.id;ie.then(_=>{this.sendResponse({id:K,data:_,type:201}),this.activeRequests.delete(k.id)},_=>{_ instanceof Error?this.sendResponse({id:K,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.sendResponse({id:K,data:_,type:203}),this.activeRequests.delete(k.id)});const Z=(0,v.toDisposable)(()=>H.cancel());this.activeRequests.set(k.id,Z)}onEventListen(k){const j=this.channels.get(k.channelName);if(!j){this.collectPendingRequest(k);return}const H=k.id,K=j.listen(this.ctx,k.name,k.arg)(Z=>this.sendResponse({id:H,data:Z,type:204}));this.activeRequests.set(k.id,K)}disposeActiveRequest(k){const j=this.activeRequests.get(k.id);j&&(j.dispose(),this.activeRequests.delete(k.id))}collectPendingRequest(k){let j=this.pendingRequests.get(k.channelName);j||(j=[],this.pendingRequests.set(k.channelName,j));const H=setTimeout(()=>{console.error(`Unknown channel: ${k.channelName}`),k.type===100&&this.sendResponse({id:k.id,data:{name:"Unknown channel",message:`Channel name '${k.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:k,timeoutTimer:H})}flushPendingRequests(k){const j=this.pendingRequests.get(k);if(j){for(const H of j)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(k)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(k=>k.dispose()),this.activeRequests.clear()}}i.ChannelServer=m;var L;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(L=i.RequestInitiator||(i.RequestInitiator={}));class b{constructor(k,j=null){this.protocol=k,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new c.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=j}getChannel(k){const j=this;return{call(H,ie,K){return j.isDisposed?Promise.reject(w.canceled()):j.requestPromise(k,H,ie,K)},listen(H,ie){return j.isDisposed?Promise.reject(w.canceled()):j.requestEvent(k,H,ie)}}}requestPromise(k,j,H,ie=D.CancellationToken.None){const K=this.lastRequestId++,_={id:K,type:100,channelName:k,name:j,arg:H};if(ie.isCancellationRequested)return Promise.reject(w.canceled());let ue;return new Promise((A,$)=>{if(ie.isCancellationRequested)return $(w.canceled());const z=()=>{const se=re=>{switch(re.type){case 201:this.handlers.delete(K),A(re.data);break;case 202:{this.handlers.delete(K);const oe=new Error(re.data.message);oe.stack=re.data.stack,oe.name=re.data.name,$(oe);break}case 203:this.handlers.delete(K),$(re.data);break}};this.handlers.set(K,se),this.sendRequest(_)};let X=null;this.state===p.Idle?z():(X=(0,R.createCancelablePromise)(se=>this.whenInitialized()),X.then(()=>{X=null,z()}));const Y=()=>{X?(X.cancel(),X=null):this.sendRequest({id:K,type:101}),$(w.canceled())},de=ie.onCancellationRequested(Y);ue=(0,v.combinedDisposable)((0,v.toDisposable)(Y),de),this.activeRequests.add(ue)}).finally(()=>{this.activeRequests.delete(ue)})}requestEvent(k,j,H){const ie=this.lastRequestId++,Z={id:ie,type:102,channelName:k,name:j,arg:H};let _=null;const ue=new c.Emitter({onFirstListenerAdd:()=>{_=(0,R.createCancelablePromise)(A=>this.whenInitialized()),_.then(()=>{_=null,this.activeRequests.add(ue),this.sendRequest(Z)})},onLastListenerRemove:()=>{_?(_.cancel(),_=null):(this.activeRequests.delete(ue),this.sendRequest({id:ie,type:103}))}}),U=A=>ue.fire(A.data);return this.handlers.set(ie,U),ue.event}sendRequest(k){switch(k.type){case 100:case 102:{const j=this.send([k.type,k.id,k.channelName,k.name],k.arg);this.logger&&this.logger.logOutgoing(j,k.id,0,`${u(k.type)}: ${k.channelName}.${k.name}`,k.arg);return}case 101:case 103:{const j=this.send([k.type,k.id]);this.logger&&this.logger.logOutgoing(j,k.id,0,u(k.type));return}}}send(k,j=void 0){const H=new f;return r(H,k),r(H,j),this.sendBuffer(H.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch{return 0}}onBuffer(k){const j=new S(k),H=l(j),ie=l(j),K=H[0];switch(K){case 200:return this.logger&&this.logger.logIncoming(k.byteLength,0,0,h(K)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(k.byteLength,H[1],0,h(K),ie),this.onResponse({type:H[0],id:H[1],data:ie})}}onResponse(k){if(k.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}const j=this.handlers.get(k.id);j&&j(k)}get onDidInitializePromise(){return c.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(k=>k.dispose()),this.activeRequests.clear()}}pe([C.memoize],b.prototype,"onDidInitializePromise",null),i.ChannelClient=b;class O{constructor(k){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new c.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new c.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,k(({protocol:j,onDidClientDisconnect:H})=>{c.Event.once(j.onMessage)(K=>{const Z=new S(K),_=l(Z),ue=new m(j,_),U=new b(j);this.channels.forEach(($,z)=>ue.registerChannel(z,$));const A={channelServer:ue,channelClient:U,ctx:_};this._connections.add(A),this._onDidAddConnection.fire(A),H(()=>{ue.dispose(),U.dispose(),this._connections.delete(A),this._onDidRemoveConnection.fire(A)})})})}get connections(){const k=[];return this._connections.forEach(j=>k.push(j)),k}getChannel(k,j){const H=this;return{call(ie,K,Z){let _;if((0,d.isFunction)(j)){let U=(0,T.getRandomElement)(H.connections.filter(j));_=U?Promise.resolve(U):c.Event.toPromise(c.Event.filter(H.onDidAddConnection,j))}else _=j.routeCall(H,ie,K);const ue=_.then(U=>U.channelClient.getChannel(k));return G(ue).call(ie,K,Z)},listen(ie,K){if((0,d.isFunction)(j))return H.getMulticastEvent(k,j,ie,K);const Z=j.routeEvent(H,ie,K).then(_=>_.channelClient.getChannel(k));return G(Z).listen(ie,K)}}}getMulticastEvent(k,j,H,ie){const K=this;let Z=new v.DisposableStore;const _=new c.Emitter({onFirstListenerAdd:()=>{Z=new v.DisposableStore;const ue=new c.EventMultiplexer,U=new Map,A=z=>{const Y=z.channelClient.getChannel(k).listen(H,ie),de=ue.add(Y);U.set(z,de)},$=z=>{const X=U.get(z);!X||(X.dispose(),U.delete(z))};K.connections.filter(j).forEach(A),c.Event.filter(K.onDidAddConnection,j)(A,void 0,Z),K.onDidRemoveConnection($,void 0,Z),ue.event(_.fire,_,Z),Z.add(ue)},onLastListenerRemove:()=>{Z.dispose()}});return _.event}registerChannel(k,j){this.channels.set(k,j),this._connections.forEach(H=>{H.channelServer.registerChannel(k,j)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}i.IPCServer=O;class N{constructor(k,j,H=null){const ie=new f;r(ie,j),k.send(ie.buffer),this.channelClient=new b(k,H),this.channelServer=new m(k,j,H)}getChannel(k){return this.channelClient.getChannel(k)}registerChannel(k,j){this.channelServer.registerChannel(k,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}i.IPCClient=N;function G(M){return{call(k,j,H){return M.then(ie=>ie.call(k,j,H))},listen(k,j){const H=new c.Relay;return M.then(ie=>H.input=ie.listen(k,j)),H.event}}}i.getDelayedChannel=G;function ee(M){let k=!1;return{call(j,H,ie){return k?M.call(j,H,ie):(0,R.timeout)(0).then(()=>k=!0).then(()=>M.call(j,H,ie))},listen(j,H){if(k)return M.listen(j,H);const ie=new c.Relay;return(0,R.timeout)(0).then(()=>k=!0).then(()=>ie.input=M.listen(j,H)),ie.event}}}i.getNextTickChannel=ee;class ge{constructor(k){this.fn=k}routeCall(k){return this.route(k)}routeEvent(k){return this.route(k)}async route(k){for(const j of k.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await c.Event.toPromise(k.onDidAddConnection),await this.route(k)}}i.StaticRouter=ge;var ce;(function(M){function k(K,Z){const _=K,ue=Z&&Z.disableMarshalling,U=new Map;for(const A in _)H(A)&&U.set(A,c.Event.buffer(_[A],!0));return new class{listen(A,$,z){const X=U.get($);if(X)return X;if(ie($)){const Y=_[$];if(typeof Y=="function")return Y.call(_,z)}throw new Error(`Event not found: ${$}`)}call(A,$,z){const X=_[$];if(typeof X=="function"){if(!ue&&Array.isArray(z))for(let Y=0;Y<z.length;Y++)z[Y]=(0,y.revive)(z[Y]);return X.apply(_,z)}throw new Error(`Method not found: ${$}`)}}}M.fromService=k;function j(K,Z){const _=Z&&Z.disableMarshalling;return new Proxy({},{get(ue,U){if(typeof U=="string")return Z?.properties?.has(U)?Z.properties.get(U):ie(U)?function(A){return K.listen(U,A)}:H(U)?K.listen(U):async function(...A){let $;Z&&!(0,d.isUndefinedOrNull)(Z.context)?$=[Z.context,...A]:$=A;const z=await K.call(U,$);return _?z:(0,y.revive)(z)};throw new Error(`Property not found: ${String(U)}`)}})}M.toService=j;function H(K){return K[0]==="o"&&K[1]==="n"&&I.isUpperAsciiLetter(K.charCodeAt(2))}function ie(K){return/^onDynamic/.test(K)&&I.isUpperAsciiLetter(K.charCodeAt(9))}})(ce=i.ProxyChannel||(i.ProxyChannel={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function he(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let k=M.toString();if(k!=="[object Object]")return k}return M}function W(M){return Array.isArray(M)?M.map(he):he(M)}function B(M,k,j,H,ie,K,Z){Z=W(Z);const _=te[ie],ue=_[H%_.length];let U=[`%c[${M}]%c[${String(k).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${ue}`];/\($/.test(K)?(U=U.concat(Z),U.push(")")):U.push(Z),console.log.apply(console,U)}i.logWithColors=B;class ne{constructor(k,j){this._outgoingPrefix=k,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(k,j,H,ie,K){this._totalOutgoing+=k,B(this._outgoingPrefix,this._totalOutgoing,k,j,H,ie,K)}logIncoming(k,j,H,ie,K){this._totalIncoming+=k,B(this._incomingPrefix,this._totalIncoming,k,j,H,ie,K)}}i.IPCLogger=ne}),define(J[66],Q([0,1,3,10,2,8]),function(x,i,T,R,P,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InMemoryStorageDatabase=i.Storage=i.isStorageItemsChangeEvent=i.StorageHint=void 0;var C;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(C=i.StorageHint||(i.StorageHint={}));function w(I){const d=I;return d?.changed instanceof Map||d?.deleted instanceof Set}i.isStorageItemsChangeEvent=w;var c;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(c||(c={}));class v extends P.Disposable{constructor(d,E=Object.create(null)){super();this.database=d,this.options=E,this._onDidChangeStorage=this._register(new R.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=c.None,this.cache=new Map,this.flushDelayer=new T.ThrottledDelayer(v.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){d.changed?.forEach((E,u)=>this.accept(u,E)),d.deleted?.forEach(E=>this.accept(E,void 0))}accept(d,E){if(this.state===c.Closed)return;let u=!1;(0,D.isUndefinedOrNull)(E)?u=this.cache.delete(d):this.cache.get(d)!==E&&(this.cache.set(d,E),u=!0),u&&this._onDidChangeStorage.fire(d)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===c.None&&(this.state=c.Initialized,this.options.hint!==C.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,E){const u=this.cache.get(d);return(0,D.isUndefinedOrNull)(u)?E:u}getBoolean(d,E){const u=this.get(d);return(0,D.isUndefinedOrNull)(u)?E:u==="true"}getNumber(d,E){const u=this.get(d);return(0,D.isUndefinedOrNull)(u)?E:parseInt(u,10)}async set(d,E){if(this.state===c.Closed)return;if((0,D.isUndefinedOrNull)(E))return this.delete(d);const u=String(E);if(this.cache.get(d)!==u)return this.cache.set(d,u),this.pendingInserts.set(d,u),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async delete(d){if(!(this.state===c.Closed||!this.cache.delete(d)))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=c.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(d){if(!!this.hasPending)return this.doFlush(d)}async doFlush(d){return this.flushDelayer.trigger(()=>this.flushPending(),d)}async whenFlushed(){if(!!this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}dispose(){this.flushDelayer.dispose(),super.dispose()}}i.Storage=v,v.DEFAULT_FLUSH_DELAY=100;class y{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert&&d.insert.forEach((E,u)=>this.items.set(u,E)),d.delete&&d.delete.forEach(E=>this.items.delete(E))}async close(){}}i.InMemoryStorageDatabase=y}),define(J[67],Q([4,5]),function(x,i){return x.create("vs/base/common/date",i)}),define(J[68],Q([0,1,67]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.toLocalISOString=i.fromNow=void 0;const R=60,P=R*60,D=P*24,C=D*7,w=D*30,c=D*365;function v(I,d){typeof I!="number"&&(I=I.getTime());const E=Math.round((new Date().getTime()-I)/1e3);if(E<-30)return(0,T.localize)(0,null,v(new Date().getTime()+E*1e3,!1));if(E<30)return(0,T.localize)(1,null);let u;return E<R?(u=E,d?u===1?(0,T.localize)(2,null,u):(0,T.localize)(3,null,u):u===1?(0,T.localize)(4,null,u):(0,T.localize)(5,null,u)):E<P?(u=Math.floor(E/R),d?u===1?(0,T.localize)(6,null,u):(0,T.localize)(7,null,u):u===1?(0,T.localize)(8,null,u):(0,T.localize)(9,null,u)):E<D?(u=Math.floor(E/P),d?u===1?(0,T.localize)(10,null,u):(0,T.localize)(11,null,u):u===1?(0,T.localize)(12,null,u):(0,T.localize)(13,null,u)):E<C?(u=Math.floor(E/D),d?u===1?(0,T.localize)(14,null,u):(0,T.localize)(15,null,u):u===1?(0,T.localize)(16,null,u):(0,T.localize)(17,null,u)):E<w?(u=Math.floor(E/C),d?u===1?(0,T.localize)(18,null,u):(0,T.localize)(19,null,u):u===1?(0,T.localize)(20,null,u):(0,T.localize)(21,null,u)):E<c?(u=Math.floor(E/w),d?u===1?(0,T.localize)(22,null,u):(0,T.localize)(23,null,u):u===1?(0,T.localize)(24,null,u):(0,T.localize)(25,null,u)):(u=Math.floor(E/c),d?u===1?(0,T.localize)(26,null,u):(0,T.localize)(27,null,u):u===1?(0,T.localize)(28,null,u):(0,T.localize)(29,null,u))}i.fromNow=v;function y(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}i.toLocalISOString=y}),define(J[69],Q([4,5]),function(x,i){return x.create("vs/base/common/errorMessage",i)}),define(J[27],Q([0,1,19,8,69]),function(x,i,T,R,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.toErrorMessage=void 0;function D(v,y){return y&&(v.stack||v.stacktrace)?P.localize(0,null,w(v),C(v.stack)||C(v.stacktrace)):w(v)}function C(v){return Array.isArray(v)?v.join(`
`):v}function w(v){return typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?P.localize(1,null,v.message):v.message||P.localize(2,null)}function c(v=null,y=!1){if(!v)return P.localize(3,null);if(Array.isArray(v)){const I=T.coalesce(v),d=c(I[0],y);return I.length>1?P.localize(4,null,d,I.length):d}if(R.isString(v))return v;if(v.detail){const I=v.detail;if(I.error)return D(I.error,y);if(I.exception)return D(I.exception,y)}return v.stack?D(v,y):v.message?v.message:P.localize(5,null)}i.toErrorMessage=c}),define(J[70],Q([4,5]),function(x,i){return x.create("vs/base/node/processes",i)}),define(J[49],Q([0,1,38,46,11,21,6,12,28,58,8,63,13,70]),function(x,i,T,R,P,D,C,w,c,v,y,I,d,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.win32=i.createQueuedSender=i.LineProcess=i.AbstractProcess=i.getWindowsShell=i.removeDangerousEnvVariables=i.TerminateResponseCode=i.Source=void 0,Object.defineProperty(i,"Source",{enumerable:!0,get:function(){return v.Source}}),Object.defineProperty(i,"TerminateResponseCode",{enumerable:!0,get:function(){return v.TerminateResponseCode}});function u(n){switch(n){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function g(n,o){if(w.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};o&&(e.cwd=o);const t=T.execFile("taskkill",["/T","/F","/PID",n.pid.toString()],e);return new Promise(r=>{t.once("error",l=>{r({success:!1,error:l})}),t.once("exit",(l,m)=>{r(l===0?{success:!0}:{success:!1,code:l!==null?l:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?u(e.status):1})}else if(w.isLinux||w.isMacintosh)try{const e=P.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",x).fsPath;return new Promise(t=>{T.execFile(e,[n.pid.toString()],{encoding:"utf8",shell:!0},(r,l,m)=>{t(r?{success:!1,error:r}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else n.kill("SIGKILL");return Promise.resolve({success:!0})}function h(n){!n||(delete n.DEBUG,w.isMacintosh&&delete n.DYLD_LIBRARY_PATH,w.isLinux&&delete n.LD_PRELOAD)}i.removeDangerousEnvVariables=h;function p(n=c.env){return n.comspec||"cmd.exe"}i.getWindowsShell=p;class S{constructor(o,e,t,r){if(e!==void 0&&t!==void 0&&r!==void 0)this.cmd=o,this.args=e,this.shell=t,this.options=r;else{const l=o;this.cmd=l.command,this.shell=l.isShellCommand,this.args=l.args.slice(0),this.options=l.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const l=Object.create(null);Object.keys(c.env).forEach(m=>{l[m]=c.env[m]}),Object.keys(this.options.env).forEach(m=>{l[m]=this.options.env[m]}),this.options.env=l}}getSanitizedCommand(){let o=this.cmd.toLowerCase();const e=o.lastIndexOf(C.sep);return e!==-1&&(o=o.substring(e+1)),S.WellKnowCommands[o]?o:"other"}start(o){return w.isWindows&&(this.options&&this.options.cwd&&R.isUNC(this.options.cwd)||!this.options&&R.isUNC(c.cwd()))?Promise.reject(new Error(E.localize(0,null))):this.useExec().then(e=>{let t,r;const l=new Promise((m,L)=>{t=m,r=L});if(e){let m=this.cmd;this.args&&(m=m+" "+this.args.join(" ")),this.childProcess=T.exec(m,this.options,(L,b,O)=>{this.childProcess=null;const N=L;N&&N.killed?r({killed:this.terminateRequested,stdout:b.toString(),stderr:O.toString()}):this.handleExec(t,o,L,b,O)})}else{let m=null;const L=b=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(b,t,o,r);const O={terminated:this.terminateRequested};y.isNumber(b)&&(O.cmdCode=b),t(O)};if(this.shell&&w.isWindows){const b=D.deepClone(this.options);b.windowsVerbatimArguments=!0,b.detached=!1;let O=!1,N=!1;const G=[];let ee=this.ensureQuotes(this.cmd);G.push(ee.value),O=ee.quoted,this.args&&this.args.forEach(ce=>{ee=this.ensureQuotes(ce),G.push(ee.value),N=N&&ee.quoted});const ge=["/s","/c"];O?N?ge.push('"'+G.join(" ")+'"'):G.length>1?ge.push('"'+G[0]+'" '+G.slice(1).join(" ")):ge.push('"'+G[0]+'"'):ge.push(G.join(" ")),m=T.spawn(p(),ge,b)}else this.cmd&&(m=T.spawn(this.cmd,this.args,this.options));m&&(this.childProcess=m,this.childProcessPromise=Promise.resolve(m),this.pidResolve&&(this.pidResolve(y.isNumber(m.pid)?m.pid:-1),this.pidResolve=void 0),m.on("error",b=>{this.childProcess=null,r({terminated:this.terminateRequested,error:b})}),m.pid&&(this.childProcess.on("close",L),this.handleSpawn(m,t,o,r,!0)))}return l})}handleClose(o,e,t,r){}ensureQuotes(o){return S.regexp.test(o)?{value:'"'+o+'"',quoted:!0}:{value:o,quoted:o.length>0&&o[0]==='"'&&o[o.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(o=>o.pid,o=>-1):new Promise(o=>{this.pidResolve=o})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(o=>(this.terminateRequested=!0,g(o,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),o=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(o=>{if(!this.shell||!w.isWindows)return o(!1);const e=T.spawn(p(),["/s","/c"]);e.on("error",t=>o(!0)),e.on("exit",t=>o(!1))})}}i.AbstractProcess=S,S.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},S.regexp=/^[^"].* .*[^"]/;class f extends S{constructor(o,e,t,r){super(o,e,t,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(o,e,t,r,l){[r,l].forEach((m,L)=>{const b=new I.LineDecoder;b.write(m).forEach(G=>{e({line:G,source:L===0?0:1})});const N=b.end();N&&e({line:N,source:L===0?0:1})}),o({terminated:this.terminateRequested,error:t})}handleSpawn(o,e,t,r,l){const m=new I.LineDecoder,L=new I.LineDecoder;o.stdout.on("data",b=>{m.write(b).forEach(N=>t({line:N,source:0}))}),o.stderr.on("data",b=>{L.write(b).forEach(N=>t({line:N,source:1}))}),this.stdoutLineDecoder=m,this.stderrLineDecoder=L}handleClose(o,e,t,r){const l=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;l&&t({line:l,source:0});const m=this.stderrLineDecoder?this.stderrLineDecoder.end():null;m&&t({line:m,source:1})}}i.LineProcess=f;function s(n){let o=[],e=!1;const t=function(r){if(e){o.push(r);return}(!n.send(r,m=>{if(m&&console.error(m),e=!1,o.length>0){const L=o.slice(0);o=[],L.forEach(b=>t(b))}})||w.isWindows)&&(e=!0)};return{send:t}}i.createQueuedSender=s;var a;(function(n){async function o(e,t,r){if(C.isAbsolute(e))return e;if(t===void 0&&(t=c.cwd()),C.dirname(e)!=="."||(r===void 0&&y.isString(c.env.PATH)&&(r=c.env.PATH.split(C.delimiter)),r===void 0||r.length===0))return C.join(t,e);async function m(L){if(await d.Promises.exists(L)){let b;try{b=await d.Promises.stat(L)}catch(O){O.message.startsWith("EACCES")&&(b=await d.Promises.lstat(L))}return b?!b.isDirectory():!1}return!1}for(let L of r){let b;if(C.isAbsolute(L)?b=C.join(L,e):b=C.join(t,L,e),await m(b))return b;let O=b+".com";if(await m(O)||(O=b+".exe",await m(O)))return O}return C.join(t,e)}n.findExecutable=o})(a=i.win32||(i.win32={}))}),define(J[71],Q([0,1,33,12,65,49]),function(x,i,T,R,P,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSystemShellSync=i.getSystemShell=void 0;async function C(E,u){return E===1?R.isWindows?I():D.getWindowsShell(u):v(E,u)}i.getSystemShell=C;function w(E,u){return E===1?R.isWindows?d(u):D.getWindowsShell(u):v(E,u)}i.getSystemShellSync=w;let c=null;function v(E,u){if(R.isLinux&&E===2||R.isMacintosh&&E===3)return"/bin/bash";if(!c){let g;if(R.isWindows)g="/bin/bash";else{if(g=u.SHELL,!g)try{g=(0,T.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}c=g}return c}let y=null;async function I(){return y||(y=(await(0,P.getFirstAvailablePowerShellInstallation)()).exePath),y}function d(E){if(y)return y;const u=R.isWindows&&parseFloat((0,T.release)())>=10,g=E.hasOwnProperty("PROCESSOR_ARCHITEW6432"),h=`${E.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?h:D.getWindowsShell(E)}}),define(J[72],Q([0,1,38,3,17,24,60,7,10,2,21,49,48]),function(x,i,T,R,P,D,C,w,c,v,y,I,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Client=i.Server=void 0;class E extends d.ChannelServer{constructor(h){super({send:p=>{try{process.send&&process.send(p.buffer.toString("base64"))}catch{}},onMessage:c.Event.fromNodeEventEmitter(process,"message",p=>P.VSBuffer.wrap(Buffer.from(p,"base64")))},h);process.once("disconnect",()=>this.dispose())}}i.Server=E;class u{constructor(h,p){this.modulePath=h,this.options=p,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new c.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const S=p&&p.timeout?p.timeout:6e4;this.disposeDelayer=new R.Delayer(S),this.child=null,this._client=null}getChannel(h){const p=this;return{call(S,f,s){return p.requestPromise(h,S,f,s)},listen(S,f){return p.requestEvent(h,S,f)}}}requestPromise(h,p,S,f=D.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(w.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(h),a=(0,R.createCancelablePromise)(e=>s.call(p,S,e)),n=f.onCancellationRequested(()=>a.cancel()),o=(0,v.toDisposable)(()=>a.cancel());return this.activeRequests.add(o),a.finally(()=>{n.dispose(),this.activeRequests.delete(o),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),a}requestEvent(h,p,S){if(!this.disposeDelayer)return c.Event.None;this.disposeDelayer.cancel();let f;const s=new c.Emitter({onFirstListenerAdd:()=>{f=this.getCachedChannel(h).listen(p,S)(s.fire,s),this.activeRequests.add(f)},onLastListenerRemove:()=>{this.activeRequests.delete(f),f.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const h=this.options&&this.options.args?this.options.args:[],p=Object.create(null);p.env={...(0,y.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(p.env={...p.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(p.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t))),(0,I.removeDangerousEnvVariables)(p.env),this.child=(0,T.fork)(this.modulePath,h,p);const S=new c.Emitter;c.Event.fromNodeEventEmitter(this.child,"message",t=>t)(t=>{if((0,C.isRemoteConsoleLog)(t)){(0,C.log)(t,`IPC Library: ${this.options.serverName}`);return}S.fire(P.VSBuffer.wrap(Buffer.from(t,"base64")))});const s=this.options.useQueue?(0,I.createQueuedSender)(this.child):this.child,a=t=>this.child&&this.child.connected&&s.send(t.buffer.toString("base64")),n=S.event,o={send:a,onMessage:n};this._client=new d.ChannelClient(o);const e=()=>this.disposeClient();process.once("exit",e),this.child.on("error",t=>console.warn('IPC "'+this.options.serverName+'" errored with '+t)),this.child.on("exit",(t,r)=>{process.removeListener("exit",e),this.activeRequests.forEach(l=>(0,v.dispose)(l)),this.activeRequests.clear(),t!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+t+" and signal "+r),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:t,signal:r})})}return this._client}getCachedChannel(h){let p=this.channels.get(h);return p||(p=this.client.getChannel(h),this.channels.set(h,p)),p}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}i.Client=u}),define(J[73],Q([4,5]),function(x,i){return x.create("vs/base/node/zip",i)}),define(J[74],Q([4,5]),function(x,i){return x.create("vs/platform/configuration/common/configurationRegistry",i)}),define(J[75],Q([4,5]),function(x,i){return x.create("vs/platform/environment/node/shellEnv",i)}),define(J[76],Q([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",i)}),define(J[77],Q([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/common/extensionManagement",i)}),define(J[78],Q([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/common/extensionManagementCLIService",i)}),define(J[79],Q([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/node/extensionManagementService",i)}),define(J[80],Q([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/node/extensionManagementUtil",i)}),define(J[81],Q([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/node/extensionsScanner",i)}),define(J[82],Q([4,5]),function(x,i){return x.create("vs/platform/extensions/common/extensionValidator",i)}),define(J[83],Q([4,5]),function(x,i){return x.create("vs/platform/files/common/fileService",i)}),define(J[84],Q([4,5]),function(x,i){return x.create("vs/platform/files/common/io",i)}),define(J[85],Q([4,5]),function(x,i){return x.create("vs/platform/files/node/diskFileSystemProvider",i)}),define(J[86],Q([4,5]),function(x,i){return x.create("vs/platform/request/common/request",i)}),define(J[87],Q([4,5]),function(x,i){return x.create("vs/platform/telemetry/common/telemetryService",i)}),define(J[88],Q([0,1,68,45,11,6,28,18,9]),function(x,i,T,R,P,D,C,w,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.parsePtyHostPort=i.parseSearchPort=i.parseExtensionHostPort=i.AbstractNativeEnvironmentService=void 0;class v{constructor(g,h,p){this._args=g,this.paths=h,this.productService=p}get appRoot(){return(0,D.dirname)(P.FileAccess.asFileUri("",x).fsPath)}get userHome(){return c.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return c.URI.file((0,D.join)(this.userDataPath,"User"))}get tmpDir(){return c.URI.file(this.paths.tmpDir)}get cacheHome(){return c.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,w.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,w.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const g=(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.join)(this.userDataPath,"logs",g)}return this.args.logsPath}get userDataSyncLogResource(){return c.URI.file((0,D.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,w.joinPath)(c.URI.file((0,D.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return c.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return c.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,w.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,w.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=C.env.VSCODE_PORTABLE;return g?c.URI.file((0,D.join)(g,"argv.json")):(0,w.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,w.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return c.URI.file((0,D.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,D.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,D.resolve)(g):(0,D.normalize)((0,D.join)(P.FileAccess.asFileUri("",x).fsPath,"..","extensions"))}get extensionsDownloadPath(){const g=this.args["extensions-download-dir"];return g?(0,D.resolve)(g):(0,D.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,D.resolve)(g);const h=C.env.VSCODE_EXTENSIONS;if(h)return h;const p=C.env.VSCODE_PORTABLE;return p?(0,D.join)(p,"extensions"):(0,w.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(h=>/^[^:/?#]+?:\/\//.test(h)?c.URI.parse(h):c.URI.file((0,D.normalize)(h)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?c.URI.parse(g):c.URI.file((0,D.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,w.joinPath)(c.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return c.URI.file((0,D.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}pe([R.memoize],v.prototype,"appRoot",null),pe([R.memoize],v.prototype,"userHome",null),pe([R.memoize],v.prototype,"userDataPath",null),pe([R.memoize],v.prototype,"appSettingsHome",null),pe([R.memoize],v.prototype,"tmpDir",null),pe([R.memoize],v.prototype,"cacheHome",null),pe([R.memoize],v.prototype,"userRoamingDataHome",null),pe([R.memoize],v.prototype,"settingsResource",null),pe([R.memoize],v.prototype,"userDataSyncHome",null),pe([R.memoize],v.prototype,"userDataSyncLogResource",null),pe([R.memoize],v.prototype,"sync",null),pe([R.memoize],v.prototype,"machineSettingsResource",null),pe([R.memoize],v.prototype,"globalStorageHome",null),pe([R.memoize],v.prototype,"workspaceStorageHome",null),pe([R.memoize],v.prototype,"keybindingsResource",null),pe([R.memoize],v.prototype,"keyboardLayoutResource",null),pe([R.memoize],v.prototype,"argvResource",null),pe([R.memoize],v.prototype,"snippetsHome",null),pe([R.memoize],v.prototype,"isExtensionDevelopment",null),pe([R.memoize],v.prototype,"untitledWorkspacesHome",null),pe([R.memoize],v.prototype,"installSourcePath",null),pe([R.memoize],v.prototype,"builtinExtensionsPath",null),pe([R.memoize],v.prototype,"extensionsPath",null),pe([R.memoize],v.prototype,"extensionDevelopmentLocationURI",null),pe([R.memoize],v.prototype,"extensionDevelopmentKind",null),pe([R.memoize],v.prototype,"extensionTestsLocationURI",null),pe([R.memoize],v.prototype,"debugExtensionHost",null),pe([R.memoize],v.prototype,"serviceMachineIdResource",null),pe([R.memoize],v.prototype,"telemetryLogResource",null),pe([R.memoize],v.prototype,"disableWorkspaceTrust",null),i.AbstractNativeEnvironmentService=v;function y(u,g){return E(u["inspect-extensions"],u["inspect-brk-extensions"],5870,g,u.debugId,u.extensionEnvironment)}i.parseExtensionHostPort=y;function I(u,g){return E(u["inspect-search"],u["inspect-brk-search"],5876,g,u.extensionEnvironment)}i.parseSearchPort=I;function d(u,g){return E(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,g,u.extensionEnvironment)}i.parsePtyHostPort=d;function E(u,g,h,p,S,f){const a=Number(g||u)||(p?null:h),n=a?Boolean(!!g):!1;let o;if(f)try{o=JSON.parse(f)}catch{}return{port:a,break:n,debugId:S,env:o}}}),function(){"use strict";function x(i,T,R,P){function D(w){const c=C(w),v=[c];return i.isAbsolute(c)||v.unshift(P),i.resolve(...v)}function C(w){const c=process.env.VSCODE_PORTABLE;if(c)return i.join(c,"user-data");let v=process.env.VSCODE_APPDATA;if(v)return i.join(v,R);const y=w["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(v=process.env.APPDATA,!v){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");v=i.join(I,"AppData","Roaming")}break;case"darwin":v=i.join(T.homedir(),"Library","Application Support");break;case"linux":v=process.env.XDG_CONFIG_HOME||i.join(T.homedir(),".config");break;default:throw new Error("Platform not supported")}return i.join(v,R)}return{getUserDataPath:D}}if(typeof define=="function")define(J[89],Q([0,131,33,11,18,28]),function(i,T,R,P,D,C){const w=D.dirname(P.FileAccess.asFileUri("",i)),c=i.__$__nodeRequire(D.joinPath(w,"package.json").fsPath);return x(T,R,c.name,C.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const i=require("../../../../../package.json"),T=require("path"),R=require("os");module.exports=x(T,R,i.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[90],Q([0,1,33,88,89]),function(x,i,T,R,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeEnvironmentService=void 0;class D extends R.AbstractNativeEnvironmentService{constructor(w,c){super(w,{homeDir:(0,T.homedir)(),tmpDir:(0,T.tmpdir)(),userDataDir:(0,P.getUserDataPath)(w)},c)}}i.NativeEnvironmentService=D}),define(J[91],Q([0,1,21]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.localizeManifest=void 0;const R=/^%([\w\d.-]+)%$/i;function P(D,C){const w=c=>{if(typeof c!="string")return;const v=R.exec(c);if(!v)return;const y=C[v[1]]??c;return typeof y=="string"?y:typeof y.message=="string"?y.message:c};return(0,T.cloneAndChange)(D,w)}i.localizeManifest=P}),define(J[50],Q([0,1,82]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isEngineValid=i.isValidExtensionVersion=i.isValidVersion=i.normalizeVersion=i.parseVersion=i.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function D(d){return d=d.trim(),d==="*"||R.test(d)}i.isValidVersionStr=D;function C(d){if(!D(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=d.match(R);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}i.parseVersion=C;function w(d){if(!d)return null;let E=d.majorBase,u=d.majorMustEqual,g=d.minorBase,h=d.minorMustEqual,p=d.patchBase,S=d.patchMustEqual;d.hasCaret&&(E===0||(h=!1),S=!1);let f=0;if(d.preRelease){const s=P.exec(d.preRelease);if(s){const[,a,n,o]=s;f=Date.UTC(Number(a),Number(n)-1,Number(o))}}return{majorBase:E,majorMustEqual:u,minorBase:g,minorMustEqual:h,patchBase:p,patchMustEqual:S,isMinimum:d.hasGreaterEquals,notBefore:f}}i.normalizeVersion=w;function c(d,E,u){let g;typeof d=="string"?g=w(C(d)):g=d;let h;E instanceof Date?h=E.getTime():typeof E=="string"&&(h=new Date(E).getTime());let p;if(typeof u=="string"?p=w(C(u)):p=u,!g||!p)return!1;let S=g.majorBase,f=g.minorBase,s=g.patchBase,a=p.majorBase,n=p.minorBase,o=p.patchBase,e=p.notBefore,t=p.majorMustEqual,r=p.minorMustEqual,l=p.patchMustEqual;return p.isMinimum?S>a?!0:S<a?!1:f>n?!0:f<n||h&&h<e?!1:s>=o:(S===1&&a===0&&(!t||!r||!l)&&(a=1,n=0,o=0,t=!0,r=!1,l=!1),S<a?!1:S>a?!t:f<n?!1:f>n?!r:s<o?!1:s>o?!l:!(h&&h<e))}i.isValidVersion=c;function v(d,E,u,g){return u.isBuiltin||typeof u.main=="undefined"?!0:I(d,E,u.engines.vscode,g)}i.isValidExtensionVersion=v;function y(d,E,u){return d==="*"||I(E,u,d)}i.isEngineValid=y;function I(d,E,u,g=[]){let h=w(C(u));if(!h)return g.push(T.localize(0,null,u)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return g.push(T.localize(1,null,u)),!1}else if(!h.majorMustEqual)return g.push(T.localize(2,null,u)),!1;return c(d,E,h)?!0:(g.push(T.localize(3,null,d,u)),!1)}}),define(J[39],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SyncDescriptor=void 0;class T{constructor(P,D=[],C=!1){this.ctor=P,this.staticArguments=D,this.supportsDelayedInstantiation=C}}i.SyncDescriptor=T}),define(J[92],Q([0,1,39]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSingletonServiceDescriptors=i.registerSingleton=void 0;const R=[];function P(C,w,c){w instanceof T.SyncDescriptor||(w=new T.SyncDescriptor(w,[],c)),R.push([C,w])}i.registerSingleton=P;function D(){return R}i.getSingletonServiceDescriptors=D}),define(J[93],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Graph=i.Node=void 0;class T{constructor(D){this.incoming=new Map,this.outgoing=new Map,this.data=D}}i.Node=T;class R{constructor(D){this._hashFn=D,this._nodes=new Map}roots(){const D=[];for(let C of this._nodes.values())C.outgoing.size===0&&D.push(C);return D}insertEdge(D,C){const w=this.lookupOrInsertNode(D),c=this.lookupOrInsertNode(C);w.outgoing.set(this._hashFn(C),c),c.incoming.set(this._hashFn(D),w)}removeNode(D){const C=this._hashFn(D);this._nodes.delete(C);for(let w of this._nodes.values())w.outgoing.delete(C),w.incoming.delete(C)}lookupOrInsertNode(D){const C=this._hashFn(D);let w=this._nodes.get(C);return w||(w=new T(D),this._nodes.set(C,w)),w}lookup(D){return this._nodes.get(this._hashFn(D))}isEmpty(){return this._nodes.size===0}toString(){let D=[];for(let[C,w]of this._nodes)D.push(`${C}, (incoming)[${[...w.incoming.keys()].join(", ")}], (outgoing)[${[...w.outgoing.keys()].join(",")}]`);return D.join(`
`)}findCycleSlow(){for(let[D,C]of this._nodes){const w=new Set([D]),c=this._findCycle(C,w);if(c)return c}}_findCycle(D,C){for(let[w,c]of D.outgoing){if(C.has(w))return[...C,w].join(" -> ");C.add(w);const v=this._findCycle(c,C);if(v)return v;C.delete(w)}}}i.Graph=R}),define(J[25],Q([0,1,8,9,14]),function(x,i,T,R,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getMigratedSettingValue=i.merge=i.getConfigurationValue=i.removeFromValueTree=i.addToValueTree=i.toValuesTree=i.ConfigurationTargetToString=i.ConfigurationTarget=i.isConfigurationUpdateOverrides=i.isConfigurationOverrides=i.IConfigurationService=void 0,i.IConfigurationService=(0,P.createDecorator)("configurationService");function D(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof R.URI)}i.isConfigurationOverrides=D;function C(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||T.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof R.URI)}i.isConfigurationUpdateOverrides=C;var w;(function(h){h[h.USER=1]="USER",h[h.USER_LOCAL=2]="USER_LOCAL",h[h.USER_REMOTE=3]="USER_REMOTE",h[h.WORKSPACE=4]="WORKSPACE",h[h.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",h[h.DEFAULT=6]="DEFAULT",h[h.MEMORY=7]="MEMORY"})(w=i.ConfigurationTarget||(i.ConfigurationTarget={}));function c(h){switch(h){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}i.ConfigurationTargetToString=c;function v(h,p){const S=Object.create(null);for(let f in h)y(S,f,h[f],p);return S}i.toValuesTree=v;function y(h,p,S,f){const s=p.split("."),a=s.pop();let n=h;for(let o=0;o<s.length;o++){let e=s[o],t=n[e];switch(typeof t){case"undefined":t=n[e]=Object.create(null);break;case"object":break;default:f(`Ignoring ${p} as ${s.slice(0,o+1).join(".")} is ${JSON.stringify(t)}`);return}n=t}if(typeof n=="object"&&n!==null)try{n[a]=S}catch{f(`Ignoring ${p} as ${s.join(".")} is ${JSON.stringify(n)}`)}else f(`Ignoring ${p} as ${s.join(".")} is ${JSON.stringify(n)}`)}i.addToValueTree=y;function I(h,p){const S=p.split(".");d(h,S)}i.removeFromValueTree=I;function d(h,p){const S=p.shift();if(p.length===0){delete h[S];return}if(Object.keys(h).indexOf(S)!==-1){const f=h[S];typeof f=="object"&&!Array.isArray(f)&&(d(f,p),Object.keys(f).length===0&&delete h[S])}}function E(h,p,S){function f(n,o){let e=n;for(const t of o){if(typeof e!="object"||e===null)return;e=e[t]}return e}const s=p.split("."),a=f(h,s);return typeof a=="undefined"?S:a}i.getConfigurationValue=E;function u(h,p,S){Object.keys(p).forEach(f=>{f!=="__proto__"&&(f in h?T.isObject(h[f])&&T.isObject(p[f])?u(h[f],p[f],S):S&&(h[f]=p[f]):h[f]=p[f])})}i.merge=u;function g(h,p,S){const f=h.inspect(p),s=h.inspect(S);return typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:f.defaultValue}i.getMigratedSettingValue=g}),define(J[51],Q([0,1,14]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IDownloadService=void 0,i.IDownloadService=(0,T.createDecorator)("downloadService")}),define(J[20],Q([0,1,14]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.INativeEnvironmentService=i.IEnvironmentService=void 0,i.IEnvironmentService=(0,T.createDecorator)("environmentService"),i.INativeEnvironmentService=(0,T.refineServiceDecorator)(i.IEnvironmentService)}),define(J[22],Q([0,1,11,77,14]),function(x,i,T,R,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IExtensionManagementCLIService=i.PreferencesLocalizedLabel=i.PreferencesLabel=i.ExtensionsChannelId=i.ExtensionsLocalizedLabel=i.ExtensionsLabel=i.DefaultIconPath=i.IExtensionTipsService=i.IGlobalExtensionEnablementService=i.ENABLED_EXTENSIONS_STORAGE_PATH=i.DISABLED_EXTENSIONS_STORAGE_PATH=i.IExtensionManagementService=i.ExtensionManagementError=i.ExtensionManagementErrorCode=i.IExtensionGalleryService=i.InstallOperation=i.StatisticType=i.SortOrder=i.SortBy=i.isIExtensionIdentifier=i.getFallbackTargetPlarforms=i.isTargetPlatformCompatible=i.isNotWebExtensionInWebTargetPlatform=i.getTargetPlatform=i.toTargetPlatform=i.TargetPlatformToString=i.TargetPlatform=i.WEB_EXTENSION_TAG=i.EXTENSION_IDENTIFIER_REGEX=i.EXTENSION_IDENTIFIER_PATTERN=void 0,i.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",i.EXTENSION_IDENTIFIER_REGEX=new RegExp(i.EXTENSION_IDENTIFIER_PATTERN),i.WEB_EXTENSION_TAG="__web_extension";var D;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(D=i.TargetPlatform||(i.TargetPlatform={}));function C(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}i.TargetPlatformToString=C;function w(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}i.toTargetPlatform=w;function c(f,s){switch(f){case 3:return s==="x64"?"win32-x64":s==="ia32"?"win32-ia32":s==="arm64"?"win32-arm64":"unknown";case 2:return s==="x64"?"linux-x64":s==="arm64"?"linux-arm64":s==="arm"?"linux-armhf":"unknown";case"alpine":return s==="x64"?"alpine-x64":s==="arm64"?"alpine-arm64":"unknown";case 1:return s==="x64"?"darwin-x64":s==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}i.getTargetPlatform=c;function v(f,s){return s==="web"&&!f.includes("web")}i.isNotWebExtensionInWebTargetPlatform=v;function y(f,s,a){return v(s,a)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===a?!0:I(a).includes(f)}i.isTargetPlatformCompatible=y;function I(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}i.getFallbackTargetPlarforms=I;function d(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}i.isIExtensionIdentifier=d;var E;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(E=i.SortBy||(i.SortBy={}));var u;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(u=i.SortOrder||(i.SortOrder={}));var g;(function(f){f.Install="install",f.Uninstall="uninstall"})(g=i.StatisticType||(i.StatisticType={}));var h;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(h=i.InstallOperation||(i.InstallOperation={})),i.IExtensionGalleryService=(0,P.createDecorator)("extensionGalleryService");var p;(function(f){f.Unsupported="Unsupported",f.UnsupportedPreRelease="UnsupportedPreRelease",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal"})(p=i.ExtensionManagementErrorCode||(i.ExtensionManagementErrorCode={}));class S extends Error{constructor(s,a){super(s);this.code=a,this.name=a}}i.ExtensionManagementError=S,i.IExtensionManagementService=(0,P.createDecorator)("extensionManagementService"),i.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",i.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",i.IGlobalExtensionEnablementService=(0,P.createDecorator)("IGlobalExtensionEnablementService"),i.IExtensionTipsService=(0,P.createDecorator)("IExtensionTipsService"),i.DefaultIconPath=T.FileAccess.asBrowserUri("./media/defaultIcon.png",x).toString(!0),i.ExtensionsLabel=(0,R.localize)(0,null),i.ExtensionsLocalizedLabel={value:i.ExtensionsLabel,original:"Extensions"},i.ExtensionsChannelId="extensions",i.PreferencesLabel=(0,R.localize)(1,null),i.PreferencesLocalizedLabel={value:i.PreferencesLabel,original:"Preferences"},i.IExtensionManagementCLIService=(0,P.createDecorator)("IExtensionManagementCLIService")}),define(J[94],Q([0,1,38,6,75,24,27,7,12,31,71,132,3]),function(x,i,T,R,P,D,C,w,c,v,y,I,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getResolvedShellEnv=void 0;const E=1e4;let u;async function g(p,S,f){return S["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):c.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.isLaunchedFromCli)(f)&&!S["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.isLaunchedFromCli)(f)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),u||(u=d.Promises.withAsyncBody(async(s,a)=>{const n=new D.CancellationTokenSource,o=setTimeout(()=>{n.dispose(!0),a(new Error((0,P.localize)(0,null)))},E);try{s(await h(p,n.token))}catch(e){!(0,w.isPromiseCanceledError)(e)&&!n.token.isCancellationRequested?a(new Error((0,P.localize)(1,null,(0,C.toErrorMessage)(e)))):s({})}finally{clearTimeout(o),n.dispose()}})),u)}i.getResolvedShellEnv=g;async function h(p,S){const f=process.env.ELECTRON_RUN_AS_NODE;p.trace("getUnixShellEnvironment#runAsNode",f);const s=process.env.ELECTRON_NO_ATTACH_CONSOLE;p.trace("getUnixShellEnvironment#noAttach",s);const a=(0,v.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(a+"(.*)"+a),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};p.trace("getUnixShellEnvironment#env",o);const e=await(0,y.getSystemShell)(c.OS,o);return p.trace("getUnixShellEnvironment#shell",e),new Promise((t,r)=>{if(S.isCancellationRequested)return r((0,w.canceled)());const l=(0,R.basename)(e);let m,L;const b=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(m=`& '${process.execPath}' ${b} -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,L=["-Login","-Command"]):(m=`'${process.execPath}' ${b} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,l==="tcsh"?L=["-ic"]:L=["-ilc"]),p.trace("getUnixShellEnvironment#spawn",JSON.stringify(L),m);const O=(0,T.spawn)(e,[...L,m],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});S.onCancellationRequested(()=>(O.kill(),r((0,w.canceled)()))),O.on("error",ee=>{p.error("getUnixShellEnvironment#errorChildProcess",(0,C.toErrorMessage)(ee)),r(ee)});const N=[];O.stdout.on("data",ee=>N.push(ee));const G=[];O.stderr.on("data",ee=>G.push(ee)),O.on("close",(ee,ge)=>{const ce=Buffer.concat(N).toString("utf8");p.trace("getUnixShellEnvironment#raw",ce);const te=Buffer.concat(G).toString("utf8");if(te.trim()&&p.trace("getUnixShellEnvironment#stderr",te),ee||ge)return r(new Error((0,P.localize)(2,null,ee,ge)));const he=n.exec(ce),W=he?he[1]:"{}";try{const B=JSON.parse(W);f?B.ELECTRON_RUN_AS_NODE=f:delete B.ELECTRON_RUN_AS_NODE,s?B.ELECTRON_NO_ATTACH_CONSOLE=s:delete B.ELECTRON_NO_ATTACH_CONSOLE,delete B.XDG_RUNTIME_DIR,p.trace("getUnixShellEnvironment#result",B),t(B)}catch(B){p.error("getUnixShellEnvironment#errorCaught",(0,C.toErrorMessage)(B)),r(B)}})})}}),define(J[52],Q([0,1,17,7,84,16]),function(x,i,T,R,P,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.readFileIntoStream=void 0;async function C(y,I,d,E,u,g){let h;try{await w(y,I,d,E,u,g)}catch(p){h=p}finally{h&&u.errorTransformer&&(h=u.errorTransformer(h)),typeof h!="undefined"&&d.error(h),d.end()}}i.readFileIntoStream=C;async function w(y,I,d,E,u,g){c(g);const h=await y.open(I,{create:!1});try{c(g);let p=0,S=0,f=u&&typeof u.length=="number"?u.length:void 0,s=T.VSBuffer.alloc(Math.min(u.bufferSize,typeof f=="number"?f:u.bufferSize)),a=u&&typeof u.position=="number"?u.position:0,n=0;do S=await y.read(h,a,s.buffer,n,s.byteLength-n),a+=S,n+=S,p+=S,typeof f=="number"&&(f-=S),n===s.byteLength&&(await d.write(E(s)),s=T.VSBuffer.alloc(Math.min(u.bufferSize,typeof f=="number"?f:u.bufferSize)),n=0);while(S>0&&(typeof f!="number"||f>0)&&c(g)&&v(p,u));if(n>0){let o=n;typeof f=="number"&&(o=Math.min(n,f)),d.write(E(s.slice(0,o)))}}catch(p){throw(0,D.ensureFileSystemProviderError)(p)}finally{await y.close(h)}}function c(y){if(y.isCancellationRequested)throw(0,R.canceled)();return!0}function v(y,I){if(I?.limits){if(typeof I.limits.memory=="number"&&y>I.limits.memory)throw(0,D.createFileSystemProviderError)((0,P.localize)(0,null),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof I.limits.size=="number"&&y>I.limits.size)throw(0,D.createFileSystemProviderError)((0,P.localize)(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[40],Q([0,1,2,12,9,16]),function(x,i,T,R,P,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.coalesceEvents=i.toFileChanges=i.AbstractRecursiveWatcherClient=void 0;class C extends T.Disposable{constructor(I,d,E){super();this.onFileChanges=I,this.onLogMessage=d,this.verboseLogging=E,this.watcherDisposables=this._register(new T.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const I=new T.DisposableStore;this.watcherDisposables.value=I,this.watcher=this.createWatcher(I),this.watcher.setVerboseLogging(this.verboseLogging),I.add(this.watcher.onDidChangeFile(d=>this.onFileChanges(d))),I.add(this.watcher.onDidLogMessage(d=>this.onLogMessage(d))),I.add(this.watcher.onDidError(d=>this.onError(d)))}onError(I){this.restartCounter<C.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${I}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${I}`)}restart(I){this.restartCounter++,this.init(),this.watch(I)}async watch(I){this.requests=I,await this.watcher?.watch(I)}async setVerboseLogging(I){this.verboseLogging=I,await this.watcher?.setVerboseLogging(I)}error(I){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${I}`})}dispose(){return this.watcher=void 0,super.dispose()}}i.AbstractRecursiveWatcherClient=C,C.MAX_RESTARTS=5;function w(y){return y.map(I=>({type:I.type,resource:P.URI.file(I.path)}))}i.toFileChanges=w;function c(y){const I=new v;for(const d of y)I.processEvent(d);return I.coalesce()}i.coalesceEvents=c;class v{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(I){return R.isLinux?I.path:I.path.toLowerCase()}processEvent(I){const d=this.mapPathToChange.get(this.toKey(I));let E=!1;if(d){const u=d.type,g=I.type;d.path!==I.path&&I.type===2?E=!0:u===1&&g===2?(this.mapPathToChange.delete(this.toKey(I)),this.coalesced.delete(d)):u===2&&g===1?d.type=0:u===1&&g===0||(d.type=g)}else E=!0;E&&(this.coalesced.add(I),this.mapPathToChange.set(this.toKey(I),I))}coalesce(){const I=[],d=[];return Array.from(this.coalesced).filter(E=>E.type!==2?(I.push(E),!1):!0).sort((E,u)=>E.path.length-u.path.length).filter(E=>d.some(u=>(0,D.isParent)(E.path,u,!R.isLinux))?!1:(d.push(E.path),!0)).concat(I)}}}),define(J[95],Q([0,1,3,2,6,64,13,133,40]),function(x,i,T,R,P,D,C,w,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NodeJSFileWatcher=void 0;class v extends R.Disposable{constructor(I,d,E,u){super();this.path=I,this.onDidFilesChange=d,this.onLogMessage=E,this.verboseLogging=u,this.fileChangesDelayer=this._register(new T.ThrottledDelayer(w.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(I){this.verboseLogging=I}async startWatching(){try{const{stat:I,symbolicLink:d}=await C.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let E=this.path;if(d)try{E=await(0,D.realpath)(E)}catch(u){if(this.onError(u),d.dangling)return}I.isDirectory()?this._register((0,w.watchFolder)(E,(u,g)=>{this.onFileChange({type:u==="changed"?0:u==="added"?1:2,path:(0,P.join)(this.path,(0,P.basename)(g))})},u=>this.onError(u))):this._register((0,w.watchFile)(E,u=>{this.onFileChange({type:u==="changed"?0:2,path:this.path})},u=>this.onError(u)))}catch(I){I.code!=="ENOENT"&&this.onError(I)}}onFileChange(I){this.fileChangesBuffer.push(I),this.verboseLogging&&this.onVerbose(`${I.type===1?"[ADDED]":I.type===2?"[DELETED]":"[CHANGED]"} ${I.path}`),this.fileChangesDelayer.trigger(async()=>{const d=this.fileChangesBuffer;this.fileChangesBuffer=[];const E=(0,c.coalesceEvents)(d);if(this.verboseLogging)for(const u of E)this.onVerbose(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);E.length>0&&this.onDidFilesChange(E)})}onError(I){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${I}`})}onVerbose(I){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${I}`})}dispose(){this.isDisposed=!0,super.dispose()}}i.NodeJSFileWatcher=v}),define(J[96],Q([0,1,11,48,72,40]),function(x,i,T,R,P,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ParcelWatcherClient=void 0;class C extends D.AbstractRecursiveWatcherClient{constructor(c,v,y){super(c,v,y);this.init()}createWatcher(c){const v=c.add(new P.Client(T.FileAccess.asFileUri("bootstrap-fork",x).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=parcelWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/parcelWatcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return c.add(v.onDidProcessExit(({code:y,signal:I})=>this.onError(`terminated by itself with code ${y}, signal: ${I}`))),R.ProxyChannel.toService((0,R.getNextTickChannel)(v.getChannel("watcher")))}}i.ParcelWatcherClient=C}),define(J[53],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ServiceCollection=void 0;class T{constructor(...P){this._entries=new Map;for(let[D,C]of P)this.set(D,C)}set(P,D){const C=this._entries.get(P);return this._entries.set(P,D),C}has(P){return this._entries.has(P)}get(P){return this._entries.get(P)}}i.ServiceCollection=T}),define(J[97],Q([0,1,3,7,39,93,14,53]),function(x,i,T,R,P,D,C,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InstantiationService=void 0;const c=!1;class v extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class y{constructor(u=new w.ServiceCollection,g=!1,h){this._activeInstantiations=new Set,this._services=u,this._strict=g,this._parent=h,this._services.set(C.IInstantiationService,this)}createChild(u){return new y(u,this._strict,this)}invokeFunction(u,...g){let h=d.traceInvocation(u),p=!1;try{return u({get:f=>{if(p)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(f,h);if(!s)throw new Error(`[invokeFunction] unknown service '${f}'`);return s}},...g)}finally{p=!0,h.stop()}}createInstance(u,...g){let h,p;return u instanceof P.SyncDescriptor?(h=d.traceCreation(u.ctor),p=this._createInstance(u.ctor,u.staticArguments.concat(g),h)):(h=d.traceCreation(u),p=this._createInstance(u,g,h)),h.stop(),p}_createInstance(u,g=[],h){let p=C._util.getServiceDependencies(u).sort((s,a)=>s.index-a.index),S=[];for(const s of p){let a=this._getOrCreateServiceInstance(s.id,h);if(!a&&this._strict&&!s.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${s.id}.`);S.push(a)}let f=p.length>0?p[0].index:g.length;if(g.length!==f){console.warn(`[createInstance] First service dependency of ${u.name} at position ${f+1} conflicts with ${g.length} static arguments`);let s=f-g.length;s>0?g=g.concat(new Array(s)):g=g.slice(0,f)}return new u(...[...g,...S])}_setServiceInstance(u,g){if(this._services.get(u)instanceof P.SyncDescriptor)this._services.set(u,g);else if(this._parent)this._parent._setServiceInstance(u,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let g=this._services.get(u);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):g}_getOrCreateServiceInstance(u,g){let h=this._getServiceInstanceOrDescriptor(u);return h instanceof P.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,h,g.branch(u,!0)):(g.branch(u,!1),h)}_safeCreateAndCacheServiceInstance(u,g,h){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,g,h)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,g,h){const p=new D.Graph(s=>s.id.toString());let S=0;const f=[{id:u,desc:g,_trace:h}];for(;f.length;){const s=f.pop();if(p.lookupOrInsertNode(s),S++>1e3)throw new v(p);for(let a of C._util.getServiceDependencies(s.desc.ctor)){let n=this._getServiceInstanceOrDescriptor(a.id);if(!n&&!a.optional&&console.warn(`[createInstance] ${u} depends on ${a.id} which is NOT registered.`),n instanceof P.SyncDescriptor){const o={id:a.id,desc:n,_trace:s._trace.branch(a.id,!0)};p.insertEdge(s,o),f.push(o)}}}for(;;){const s=p.roots();if(s.length===0){if(!p.isEmpty())throw new v(p);break}for(const{data:a}of s){if(this._getServiceInstanceOrDescriptor(a.id)instanceof P.SyncDescriptor){const o=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,o)}p.removeNode(a)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,g,h=[],p,S){if(this._services.get(u)instanceof P.SyncDescriptor)return this._createServiceInstance(g,h,p,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,g,h,p,S);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(u,g=[],h,p){if(h){const S=new T.IdleValue(()=>this._createInstance(u,g,p));return new Proxy(Object.create(null),{get(f,s){if(s in f)return f[s];let a=S.value,n=a[s];return typeof n!="function"||(n=n.bind(a),f[s]=n),n},set(f,s,a){return S.value[s]=a,!0}})}else return this._createInstance(u,g,p)}}i.InstantiationService=y;var I;(function(E){E[E.Creation=0]="Creation",E[E.Invocation=1]="Invocation",E[E.Branch=2]="Branch"})(I||(I={}));class d{constructor(u,g){this.type=u,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return c?new d(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(u){return c?new d(0,u.name):d._None}branch(u,g){let h=new d(2,u.toString());return this._dep.push([u,g,h]),h}stop(){let u=Date.now()-this._start;d._totals+=u;let g=!1;function h(S,f){let s=[],a=new Array(S+1).join("	");for(const[n,o,e]of f._dep)if(o&&e){g=!0,s.push(`${a}CREATES -> ${n}`);let t=h(S+1,e);t&&s.push(t)}else s.push(`${a}uses -> ${n}`);return s.join(`
`)}let p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(u>2||g)&&console.log(p.join(`
`))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(J[54],Q([0,1,14]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isValidLocalization=i.ILocalizationsService=void 0,i.ILocalizationsService=(0,T.createDecorator)("localizationsService");function R(P){if(typeof P.languageId!="string"||!Array.isArray(P.translations)||P.translations.length===0)return!1;for(const D of P.translations)if(typeof D.id!="string"||typeof D.path!="string")return!1;return!(P.languageName&&typeof P.languageName!="string"||P.localizedLanguageName&&typeof P.localizedLanguageName!="string")}i.isValidLocalization=R}),define(J[15],Q([0,1,27,10,2,12,14]),function(x,i,T,R,P,D,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LogLevelToString=i.parseLogLevel=i.getLogLevel=i.NullLogService=i.AbstractLoggerService=i.LogService=i.MultiplexLogService=i.AdapterLogger=i.ConsoleLogger=i.ConsoleMainLogger=i.AbstractMessageLogger=i.AbstractLogger=i.format=i.log=i.DEFAULT_LOG_LEVEL=i.LogLevel=i.ILoggerService=i.ILogService=void 0,i.ILogService=(0,C.createDecorator)("logService"),i.ILoggerService=(0,C.createDecorator)("loggerService");function w(){return new Date().toISOString()}var c;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(c=i.LogLevel||(i.LogLevel={})),i.DEFAULT_LOG_LEVEL=c.Info;function v(o,e,t){switch(e){case c.Trace:o.trace(t);break;case c.Debug:o.debug(t);break;case c.Info:o.info(t);break;case c.Warning:o.warn(t);break;case c.Error:o.error(t);break;case c.Critical:o.critical(t);break;default:throw new Error("Invalid log level")}}i.log=v;function y(o){let e="";for(let t=0;t<o.length;t++){let r=o[t];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}e+=(t>0?" ":"")+r}return e}i.format=y;class I extends P.Disposable{constructor(){super(...arguments);this.level=i.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}i.AbstractLogger=I;class d extends I{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...t){this.checkLogLevel(c.Trace)&&this.log(c.Trace,y([e,...t]))}debug(e,...t){this.checkLogLevel(c.Debug)&&this.log(c.Debug,y([e,...t]))}info(e,...t){this.checkLogLevel(c.Info)&&this.log(c.Info,y([e,...t]))}warn(e,...t){this.checkLogLevel(c.Warning)&&this.log(c.Warning,y([e,...t]))}error(e,...t){if(this.checkLogLevel(c.Error))if(e instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=e.stack,this.log(c.Error,y(r))}else this.log(c.Error,y([e,...t]))}critical(e,...t){this.checkLogLevel(c.Critical)&&this.log(c.Critical,y([e,...t]))}flush(){}}i.AbstractMessageLogger=d;class E extends I{constructor(e=i.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!D.isWindows}trace(e,...t){this.getLevel()<=c.Trace&&(this.useColors?console.log(`[90m[main ${w()}][0m`,e,...t):console.log(`[main ${w()}]`,e,...t))}debug(e,...t){this.getLevel()<=c.Debug&&(this.useColors?console.log(`[90m[main ${w()}][0m`,e,...t):console.log(`[main ${w()}]`,e,...t))}info(e,...t){this.getLevel()<=c.Info&&(this.useColors?console.log(`[90m[main ${w()}][0m`,e,...t):console.log(`[main ${w()}]`,e,...t))}warn(e,...t){this.getLevel()<=c.Warning&&(this.useColors?console.warn(`[93m[main ${w()}][0m`,e,...t):console.warn(`[main ${w()}]`,e,...t))}error(e,...t){this.getLevel()<=c.Error&&(this.useColors?console.error(`[91m[main ${w()}][0m`,e,...t):console.error(`[main ${w()}]`,e,...t))}critical(e,...t){this.getLevel()<=c.Critical&&(this.useColors?console.error(`[90m[main ${w()}][0m`,e,...t):console.error(`[main ${w()}]`,e,...t))}dispose(){}flush(){}}i.ConsoleMainLogger=E;class u extends I{constructor(e=i.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...t){this.getLevel()<=c.Trace&&console.log("%cTRACE","color: #888",e,...t)}debug(e,...t){this.getLevel()<=c.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...t)}info(e,...t){this.getLevel()<=c.Info&&console.log("%c INFO","color: #33f",e,...t)}warn(e,...t){this.getLevel()<=c.Warning&&console.log("%c WARN","color: #993",e,...t)}error(e,...t){this.getLevel()<=c.Error&&console.log("%c  ERR","color: #f33",e,...t)}critical(e,...t){this.getLevel()<=c.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...t)}dispose(){}flush(){}}i.ConsoleLogger=u;class g extends I{constructor(e,t=i.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(t)}trace(e,...t){this.getLevel()<=c.Trace&&this.adapter.log(c.Trace,[this.extractMessage(e),...t])}debug(e,...t){this.getLevel()<=c.Debug&&this.adapter.log(c.Debug,[this.extractMessage(e),...t])}info(e,...t){this.getLevel()<=c.Info&&this.adapter.log(c.Info,[this.extractMessage(e),...t])}warn(e,...t){this.getLevel()<=c.Warning&&this.adapter.log(c.Warning,[this.extractMessage(e),...t])}error(e,...t){this.getLevel()<=c.Error&&this.adapter.log(c.Error,[this.extractMessage(e),...t])}critical(e,...t){this.getLevel()<=c.Critical&&this.adapter.log(c.Critical,[this.extractMessage(e),...t])}extractMessage(e){return typeof e=="string"?e:(0,T.toErrorMessage)(e,this.getLevel()<=c.Trace)}dispose(){}flush(){}}i.AdapterLogger=g;class h extends I{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const t of this.logServices)t.setLevel(e);super.setLevel(e)}trace(e,...t){for(const r of this.logServices)r.trace(e,...t)}debug(e,...t){for(const r of this.logServices)r.debug(e,...t)}info(e,...t){for(const r of this.logServices)r.info(e,...t)}warn(e,...t){for(const r of this.logServices)r.warn(e,...t)}error(e,...t){for(const r of this.logServices)r.error(e,...t)}critical(e,...t){for(const r of this.logServices)r.critical(e,...t)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}i.MultiplexLogService=h;class p extends P.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...t){this.logger.trace(e,...t)}debug(e,...t){this.logger.debug(e,...t)}info(e,...t){this.logger.info(e,...t)}warn(e,...t){this.logger.warn(e,...t)}error(e,...t){this.logger.error(e,...t)}critical(e,...t){this.logger.critical(e,...t)}flush(){this.logger.flush()}}i.LogService=p;class S extends P.Disposable{constructor(e,t){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(l=>l.setLevel(r))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,t){let r=this.loggers.get(e.toString());return r||(r=this.doCreateLogger(e,t?.always?c.Trace:this.logLevel,t),this.loggers.set(e.toString(),r),t?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}i.AbstractLoggerService=S;class f{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(e){}getLevel(){return c.Info}trace(e,...t){}debug(e,...t){}info(e,...t){}warn(e,...t){}error(e,...t){}critical(e,...t){}dispose(){}flush(){}}i.NullLogService=f;function s(o){if(o.verbose)return c.Trace;if(typeof o.logLevel=="string"){const e=a(o.logLevel.toLowerCase());if(e!==void 0)return e}return i.DEFAULT_LOG_LEVEL}i.getLogLevel=s;function a(o){switch(o){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Critical;case"off":return c.Off}}i.parseLogLevel=a;function n(o){switch(o){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Critical:return"critical";case c.Off:return"off"}}i.LogLevelToString=n});var ae=this&&this.__param||function(x,i){return function(T,R){i(T,R,x)}};define(J[98],Q([0,1,38,3,27,10,2,11,6,13,20,15]),function(x,i,T,R,P,D,C,w,c,v,y,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsLifecycle=void 0;let d=class extends C.Disposable{constructor(u,g){super();this.environmentService=u,this.logService=g,this.processesLimiter=new R.Limiter(5)}async postUninstall(u){const g=this.parseScript(u,"uninstall");return g&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(g.script,"uninstall",g.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),h=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${h}`)))),v.Promises.rm(this.getExtensionStoragePath(u)).then(void 0,h=>this.logService.error("Error while removing extension storage path",h))}parseScript(u,g){const h=`vscode:${g}`;if(u.location.scheme===w.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[h]=="string"){const p=u.manifest.scripts[h].split(" ");return p.length<2||p[0]!=="node"||!p[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${h} should be a node script`),null):{script:(0,c.join)(u.location.fsPath,p[1]),args:p.slice(2)||[]}}return null}runLifecycleHook(u,g,h,p,S){return new Promise((f,s)=>{const a=this.start(u,g,h,S);let n;const o=e=>{n&&(clearTimeout(n),n=null),e?s(e):f(void 0)};a.on("error",e=>{o((0,P.toErrorMessage)(e)||"Unknown")}),a.on("exit",(e,t)=>{o(e?`post-${g} process exited with code ${e}`:void 0)}),p&&(n=setTimeout(()=>{n=null,a.kill(),s("timed out")},5e3))})}start(u,g,h,p){const S={silent:!0,execArgv:void 0},f=(0,T.fork)(u,[`--type=extension-post-${g}`,...h],S);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const s=D.Event.fromNodeEventEmitter(f.stdout,"data"),a=D.Event.fromNodeEventEmitter(f.stderr,"data");s(e=>this.logService.info(p.identifier.id,p.manifest.version,`post-${g}`,e)),a(e=>this.logService.error(p.identifier.id,p.manifest.version,`post-${g}`,e));const n=D.Event.any(D.Event.map(s,e=>({data:`%c${e}`,format:[""]})),D.Event.map(a,e=>({data:`%c${e}`,format:["color: red"]})));return D.Event.debounce(n,(e,t)=>e?{data:e.data+t.data,format:[...e.format,...t.format]}:{data:t.data,format:t.format},100)(e=>{console.group(p.identifier.id),console.log(e.data,...e.format),console.groupEnd()}),f}getExtensionStoragePath(u){return(0,c.join)(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};d=pe([ae(0,y.IEnvironmentService),ae(1,I.ILogService)],d),i.ExtensionsLifecycle=d}),define(J[99],Q([0,1,19,3,7,10,2,6,40,15]),function(x,i,T,R,P,D,C,w,c,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractDiskFileSystemProvider=void 0;class y extends C.Disposable{constructor(d){super();this.logService=d,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new R.ThrottledDelayer(0))}watch(d,E){return E.recursive?this.watchRecursive(d,E):this.watchNonRecursive(d)}watchRecursive(d,E){const u={path:this.toFilePath(d),excludes:E.excludes},g=(0,T.insert)(this.recursiveFoldersToWatch,u);return this.refreshRecursiveWatchers(),(0,C.toDisposable)(()=>{g(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(d=>(0,P.onUnexpectedError)(d))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(d=>this._onDidChangeFile.fire((0,c.toFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===v.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(d,E){return d.watch(E)}watchNonRecursive(d){const E=this.createNonRecursiveWatcher(this.toFilePath(d),g=>this._onDidChangeFile.fire((0,c.toFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===v.LogLevel.Trace),u=this.logService.onDidChangeLogLevel(()=>{E.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)});return(0,C.combinedDisposable)(E,u)}onWatcherLogMessage(d){d.type==="error"&&this._onDidWatchError.fire(d.message),this.logService[d.type](d.message)}toFilePath(d){return(0,w.normalize)(d.fsPath)}}i.AbstractDiskFileSystemProvider=y}),define(J[100],Q([0,1,19,3,17,24,10,134,2,55,11,101,18,37,83,16,52,15]),function(x,i,T,R,P,D,C,w,c,v,y,I,d,E,u,g,h,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileService=void 0;let S=class xe extends c.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new C.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new C.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new C.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new C.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new C.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this._onDidChangeFilesRaw=this._register(new C.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new R.ThrottledWorker(xe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,xe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,xe.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new g.FileChangesEvent(a,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new R.ThrottledWorker(xe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,xe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,xe.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new g.FileChangesEvent(a,!0)))),this.watchedResources=v.TernarySearchTree.forUris(a=>{const n=this.getProvider(a.scheme);return n?!this.isPathCaseSensitive(n):!1}),this.writeQueue=this._register(new R.ResourceQueue)}registerProvider(s,a){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,I.mark)(`code/registerFilesystem/${s}`),this.provider.set(s,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:a});const n=new c.DisposableStore;return n.add(a.onDidChangeFile(o=>this.onDidChangeFile(o,this.isPathCaseSensitive(a)))),n.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:s}))),typeof a.onDidWatchError=="function"&&n.add(a.onDidWatchError(o=>this._onDidWatchError.fire(new Error(o)))),(0,c.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:a}),this.provider.delete(s),(0,c.dispose)(n)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(n){a.push(n)}}),!this.provider.has(s)&&await R.Promises.settled(a)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.provider.has(s.scheme)}hasCapability(s,a){const n=this.provider.get(s.scheme);return!!(n&&n.capabilities&a)}listCapabilities(){return w.Iterable.map(this.provider,([s,a])=>({scheme:s,capabilities:a.capabilities}))}async withProvider(s){if(!(0,d.isAbsolutePath)(s))throw new g.FileOperationError((0,u.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const a=this.provider.get(s.scheme);if(!a){const n=new Error;throw n.name="ENOPRO",n.message=(0,u.localize)(1,null,s.toString()),n}return a}async withReadProvider(s){const a=await this.withProvider(s);if((0,g.hasOpenReadWriteCloseCapability)(a)||(0,g.hasReadWriteCapability)(a)||(0,g.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const a=await this.withProvider(s);if((0,g.hasOpenReadWriteCloseCapability)(a)||(0,g.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,a){try{return await this.doResolveFile(s,a)}catch(n){throw(0,g.toFileSystemProviderErrorCode)(n)===g.FileSystemProviderErrorCode.FileNotFound?new g.FileOperationError((0,u.localize)(2,null,this.resourceForError(s)),1):(0,g.ensureFileSystemProviderError)(n)}}async doResolveFile(s,a){const n=await this.withProvider(s),o=this.isPathCaseSensitive(n),e=a?.resolveTo,t=a?.resolveSingleChildDescendants,r=a?.resolveMetadata,l=await n.stat(s);let m;return this.toFileStat(n,s,l,void 0,!!r,(L,b)=>(m||(m=v.TernarySearchTree.forUris(()=>!o),m.set(s,!0),e&&m.fill(!0,e)),m.get(L.resource)||m.findSuperstr(L.resource.with({query:null,fragment:null}))?!0:L.isDirectory&&t?b===1:!1))}async toFileStat(s,a,n,o,e,t){const{providerExtUri:r}=this.getExtUri(s),l={resource:a,name:r.basename(a),isFile:(n.type&g.FileType.File)!=0,isDirectory:(n.type&g.FileType.Directory)!=0,isSymbolicLink:(n.type&g.FileType.SymbolicLink)!=0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&g.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,g.etag)({mtime:n.mtime,size:n.size})};if(l.isDirectory&&t(l,o)){try{const m=await s.readdir(a),L=await R.Promises.settled(m.map(async([b,O])=>{try{const N=r.joinPath(a,b),G=e?await s.stat(N):{type:O};return await this.toFileStat(s,N,G,m.length,e,t)}catch(N){return this.logService.trace(N),null}}));l.children=(0,T.coalesce)(L)}catch(m){this.logService.trace(m),l.children=[]}return l}return l}async resolveAll(s){return R.Promises.settled(s.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async exists(s){const a=await this.withProvider(s);try{return!!await a.stat(s)}catch{return!1}}async canCreateFile(s,a){try{await this.doValidateCreateFile(s,a)}catch(n){return n}return!0}async doValidateCreateFile(s,a){if(!a?.overwrite&&await this.exists(s))throw new g.FileOperationError((0,u.localize)(3,null,this.resourceForError(s)),3,a)}async createFile(s,a=P.VSBuffer.fromString(""),n){await this.doValidateCreateFile(s,n);const o=await this.writeFile(s,a);return this._onDidRunOperation.fire(new g.FileOperationEvent(s,0,o)),o}async writeFile(s,a,n){const o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:e}=this.getExtUri(o);try{await this.validateWriteFile(o,s,n)||await this.mkdirp(o,e.dirname(s));let r;if((0,g.hasReadWriteCapability)(o)&&!(a instanceof P.VSBuffer))if((0,E.isReadableStream)(a)){const l=await(0,E.peekStream)(a,3);l.ended?r=P.VSBuffer.concat(l.buffer):r=l}else r=(0,E.peekReadable)(a,l=>P.VSBuffer.concat(l),3);else r=a;!(0,g.hasOpenReadWriteCloseCapability)(o)||(0,g.hasReadWriteCapability)(o)&&r instanceof P.VSBuffer?await this.doWriteUnbuffered(o,s,n,r):await this.doWriteBuffered(o,s,n,r instanceof P.VSBuffer?(0,P.bufferToReadable)(r):r)}catch(t){throw new g.FileOperationError((0,u.localize)(4,null,this.resourceForError(s),(0,g.ensureFileSystemProviderError)(t).toString()),(0,g.toFileOperationResult)(t),n)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,a,n){if(!!n?.unlock&&!(s.capabilities&8192))throw new Error((0,u.localize)(5,null,this.resourceForError(a)));let e;try{e=await s.stat(a)}catch{return}if((e.type&g.FileType.Directory)!=0)throw new g.FileOperationError((0,u.localize)(6,null,this.resourceForError(a)),0,n);if(this.throwIfFileIsReadonly(a,e),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==g.ETAG_DISABLED&&typeof e.mtime=="number"&&typeof e.size=="number"&&n.mtime<e.mtime&&n.etag!==(0,g.etag)({mtime:n.mtime,size:e.size}))throw new g.FileOperationError((0,u.localize)(7,null),3,n);return e}async readFile(s,a,n){const o=await this.withReadProvider(s);return a?.atomic?this.doReadFileAtomic(o,s,a,n):this.doReadFile(o,s,a,n)}async doReadFileAtomic(s,a,n,o){return new Promise((e,t)=>{this.writeQueue.queueFor(a,this.getExtUri(s).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(s,a,n,o);e(r)}catch(r){t(r)}})})}async doReadFile(s,a,n,o){const e=await this.doReadFileStream(s,a,{...n,preferUnbuffered:!0},o);return{...e,value:await(0,P.streamToBuffer)(e.value)}}async readFileStream(s,a,n){const o=await this.withReadProvider(s);return this.doReadFileStream(o,s,a,n)}async doReadFileStream(s,a,n,o){const e=new D.CancellationTokenSource(o),t=this.validateReadFile(a,n).then(l=>l,l=>{throw e.cancel(),l});let r;try{return typeof n?.etag=="string"&&n.etag!==g.ETAG_DISABLED&&await t,n?.atomic&&(0,g.hasFileAtomicReadCapability)(s)||!((0,g.hasOpenReadWriteCloseCapability)(s)||(0,g.hasFileReadStreamCapability)(s))||(0,g.hasReadWriteCapability)(s)&&n?.preferUnbuffered?r=this.readFileUnbuffered(s,a,n):(0,g.hasFileReadStreamCapability)(s)?r=this.readFileStreamed(s,a,e.token,n):r=this.readFileBuffered(s,a,e.token,n),{...await t,value:r}}catch(l){r&&await(0,E.consumeStream)(r);const m=(0,u.localize)(8,null,this.resourceForError(a),(0,g.ensureFileSystemProviderError)(l).toString());throw l instanceof g.NotModifiedSinceFileOperationError?new g.NotModifiedSinceFileOperationError(m,l.stat,n):new g.FileOperationError(m,(0,g.toFileOperationResult)(l),n)}}readFileStreamed(s,a,n,o=Object.create(null)){const e=s.readFileStream(a,o,n);return(0,E.transform)(e,{data:t=>t instanceof P.VSBuffer?t:P.VSBuffer.wrap(t),error:t=>new g.FileOperationError((0,u.localize)(9,null,this.resourceForError(a),(0,g.ensureFileSystemProviderError)(t).toString()),(0,g.toFileOperationResult)(t),o)},t=>P.VSBuffer.concat(t))}readFileBuffered(s,a,n,o=Object.create(null)){const e=(0,P.newWriteableBufferStream)();return(0,h.readFileIntoStream)(s,a,e,t=>t,{...o,bufferSize:this.BUFFER_SIZE,errorTransformer:t=>new g.FileOperationError((0,u.localize)(10,null,this.resourceForError(a),(0,g.ensureFileSystemProviderError)(t).toString()),(0,g.toFileOperationResult)(t),o)},n),e}readFileUnbuffered(s,a,n){const o=(0,E.newWriteableStream)(e=>P.VSBuffer.concat(e));return(async()=>{try{let e;n?.atomic&&(0,g.hasFileAtomicReadCapability)(s)?e=await s.readFile(a,{atomic:!0}):e=await s.readFile(a),typeof n?.position=="number"&&(e=e.slice(n.position)),typeof n?.length=="number"&&(e=e.slice(0,n.length)),this.validateReadFileLimits(a,e.byteLength,n),o.end(P.VSBuffer.wrap(e))}catch(e){o.error(e),o.end()}})(),o}async validateReadFile(s,a){const n=await this.resolve(s,{resolveMetadata:!0});if(n.isDirectory)throw new g.FileOperationError((0,u.localize)(11,null,this.resourceForError(s)),0,a);if(typeof a?.etag=="string"&&a.etag!==g.ETAG_DISABLED&&a.etag===n.etag)throw new g.NotModifiedSinceFileOperationError((0,u.localize)(12,null),n,a);return this.validateReadFileLimits(s,n.size,a),n}validateReadFileLimits(s,a,n){if(n?.limits){let o;if(typeof n.limits.memory=="number"&&a>n.limits.memory&&(o=9),typeof n.limits.size=="number"&&a>n.limits.size&&(o=7),typeof o=="number")throw new g.FileOperationError((0,u.localize)(13,null,this.resourceForError(s)),o)}}async canMove(s,a,n){return this.doCanMoveCopy(s,a,"move",n)}async canCopy(s,a,n){return this.doCanMoveCopy(s,a,"copy",n)}async doCanMoveCopy(s,a,n,o){if(s.toString()!==a.toString())try{const e=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(e,s,t,a,n,o)}catch(e){return e}return!0}async move(s,a,n){const o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),t=await this.doMoveCopy(o,s,e,a,"move",!!n),r=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(s,t==="move"?2:3,r)),r}async copy(s,a,n){const o=await this.withReadProvider(s),e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),t=await this.doMoveCopy(o,s,e,a,"copy",!!n),r=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(s,t==="copy"?3:2,r)),r}async doMoveCopy(s,a,n,o,e,t){if(a.toString()===o.toString())return e;const{exists:r,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(s,a,n,o,e,t);if(r&&!l&&t&&await this.del(o,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(o)),e==="copy"){if(s===n&&(0,g.hasFileFolderCopyCapability)(s))await s.copy(a,o,{overwrite:t});else{const m=await this.resolve(a);m.isDirectory?await this.doCopyFolder(s,m,n,o):await this.doCopyFile(s,a,n,o)}return e}else return s===n?(await s.rename(a,o,{overwrite:t}),e):(await this.doMoveCopy(s,a,n,o,"copy",t),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(s,a,n,o){if((0,g.hasOpenReadWriteCloseCapability)(s)&&(0,g.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(s,a,n,o);if((0,g.hasOpenReadWriteCloseCapability)(s)&&(0,g.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(s,a,n,o);if((0,g.hasReadWriteCapability)(s)&&(0,g.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(s,a,n,o);if((0,g.hasReadWriteCapability)(s)&&(0,g.hasReadWriteCapability)(n))return this.doPipeUnbuffered(s,a,n,o)}async doCopyFolder(s,a,n,o){await n.mkdir(o),Array.isArray(a.children)&&await R.Promises.settled(a.children.map(async e=>{const t=this.getExtUri(n).providerExtUri.joinPath(o,e.name);return e.isDirectory?this.doCopyFolder(s,await this.resolve(e.resource),n,t):this.doCopyFile(s,e.resource,n,t)}))}async doValidateMoveCopy(s,a,n,o,e,t){let r=!1;if(s===n){const{providerExtUri:m,isPathCaseSensitive:L}=this.getExtUri(s);if(L||(r=m.isEqual(a,o)),r&&e==="copy")throw new Error((0,u.localize)(14,null,this.resourceForError(a),this.resourceForError(o)));if(!r&&m.isEqualOrParent(o,a))throw new Error((0,u.localize)(15,null,this.resourceForError(a),this.resourceForError(o)))}const l=await this.exists(o);if(l&&!r){if(!t)throw new g.FileOperationError((0,u.localize)(16,null,this.resourceForError(a),this.resourceForError(o)),4);if(s===n){const{providerExtUri:m}=this.getExtUri(s);if(m.isEqualOrParent(a,o))throw new Error((0,u.localize)(17,null,this.resourceForError(a),this.resourceForError(o)))}}return{exists:l,isSameResourceWithDifferentPathCase:r}}getExtUri(s){const a=this.isPathCaseSensitive(s);return{providerExtUri:a?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(a,s);const n=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(s,0,n)),n}async mkdirp(s,a){const n=[],{providerExtUri:o}=this.getExtUri(s);for(;!o.isEqual(a,o.dirname(a));)try{if(((await s.stat(a)).type&g.FileType.Directory)==0)throw new Error((0,u.localize)(18,null,this.resourceForError(a)));break}catch(e){if((0,g.toFileSystemProviderErrorCode)(e)!==g.FileSystemProviderErrorCode.FileNotFound)throw e;n.push(o.basename(a)),a=o.dirname(a)}for(let e=n.length-1;e>=0;e--){a=o.joinPath(a,n[e]);try{await s.mkdir(a)}catch(t){if((0,g.toFileSystemProviderErrorCode)(t)!==g.FileSystemProviderErrorCode.FileExists)throw t}}}async canDelete(s,a){try{await this.doValidateDelete(s,a)}catch(n){return n}return!0}async doValidateDelete(s,a){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!a?.useTrash&&!(n.capabilities&4096))throw new Error((0,u.localize)(19,null,this.resourceForError(s)));let e;try{e=await n.stat(s)}catch{}if(e)this.throwIfFileIsReadonly(s,e);else throw new g.FileOperationError((0,u.localize)(20,null,this.resourceForError(s)),1);if(!!!a?.recursive){const r=await this.resolve(s);if(r.isDirectory&&Array.isArray(r.children)&&r.children.length>0)throw new Error((0,u.localize)(21,null,this.resourceForError(s)))}return n}async del(s,a){const n=await this.doValidateDelete(s,a),o=!!a?.useTrash,e=!!a?.recursive;await n.delete(s,{recursive:e,useTrash:o}),this._onDidRunOperation.fire(new g.FileOperationEvent(s,1))}onDidChangeFile(s,a){this._onDidChangeFilesRaw.fire({changes:s});let n,o;{for(const e of s)this.watchedResources.has(e.resource)?(n||(n=[]),n.push(e)):(o||(o=[]),o.push(e));n&&this._onDidFilesChange.fire(new g.FileChangesEvent(n,!a))}if(o){const e=a?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!e.work(o)&&xe.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${o.length}, most recent change: ${o[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),e.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${e.pending}, most recent change: ${o[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(s,a={recursive:!1,excludes:[]}){const n=new c.DisposableStore;let o=!1,e=()=>{o=!0};return n.add((0,c.toDisposable)(()=>e())),this.doWatch(s,a).then(t=>{o?(0,c.dispose)(t):e=()=>(0,c.dispose)(t)},t=>this.logService.error(t)),a.recursive||(this.watchedResources.set(s,(this.watchedResources.get(s)??0)+1),n.add((0,c.toDisposable)(()=>{const t=this.watchedResources.get(s);typeof t=="number"&&(t<=1?this.watchedResources.delete(s):this.watchedResources.set(s,t-1))}))),n}async doWatch(s,a){const n=await this.withProvider(s),o=this.toWatchKey(n,s,a);let e=this.activeWatchers.get(o);return e||(e={count:0,disposable:n.watch(s,a)},this.activeWatchers.set(o,e)),e.count+=1,(0,c.toDisposable)(()=>{e&&(e.count--,e.count===0&&((0,c.dispose)(e.disposable),this.activeWatchers.delete(o)))})}toWatchKey(s,a,n){const{providerExtUri:o}=this.getExtUri(s);return[o.getComparisonKey(a),String(n.recursive),n.excludes.join()].join()}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,c.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,a,n,o){return this.writeQueue.queueFor(a,this.getExtUri(s).providerExtUri).queue(async()=>{const e=await s.open(a,{create:!0,unlock:n?.unlock??!1});try{(0,E.isReadableStream)(o)||(0,E.isReadableBufferedStream)(o)?await this.doWriteStreamBufferedQueued(s,e,o):await this.doWriteReadableBufferedQueued(s,e,o)}catch(t){throw(0,g.ensureFileSystemProviderError)(t)}finally{await s.close(e)}})}async doWriteStreamBufferedQueued(s,a,n){let o=0,e;if((0,E.isReadableBufferedStream)(n)){if(n.buffer.length>0){const t=P.VSBuffer.concat(n.buffer);await this.doWriteBuffer(s,a,t,t.byteLength,o,0),o+=t.byteLength}if(n.ended)return;e=n.stream}else e=n;return new Promise((t,r)=>{(0,E.listenStream)(e,{onData:async l=>{e.pause();try{await this.doWriteBuffer(s,a,l,l.byteLength,o,0)}catch(m){return r(m)}o+=l.byteLength,setTimeout(()=>e.resume())},onError:l=>r(l),onEnd:()=>t()})})}async doWriteReadableBufferedQueued(s,a,n){let o=0,e;for(;(e=n.read())!==null;)await this.doWriteBuffer(s,a,e,e.byteLength,o,0),o+=e.byteLength}async doWriteBuffer(s,a,n,o,e,t){let r=0;for(;r<o;)r+=await s.write(a,e+r,n.buffer,t+r,o-r)}async doWriteUnbuffered(s,a,n,o){return this.writeQueue.queueFor(a,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,a,n,o))}async doWriteUnbufferedQueued(s,a,n,o){let e;o instanceof P.VSBuffer?e=o:(0,E.isReadableStream)(o)?e=await(0,P.streamToBuffer)(o):(0,E.isReadableBufferedStream)(o)?e=await(0,P.bufferedStreamToBuffer)(o):e=(0,P.readableToBuffer)(o),await s.writeFile(a,e.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async doPipeBuffered(s,a,n,o){return this.writeQueue.queueFor(o,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,a,n,o))}async doPipeBufferedQueued(s,a,n,o){let e,t;try{e=await s.open(a,{create:!1}),t=await n.open(o,{create:!0,unlock:!1});const r=P.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,m=0,L=0;do L=await s.read(e,l,r.buffer,m,r.byteLength-m),await this.doWriteBuffer(n,t,r,L,l,m),l+=L,m+=L,m===r.byteLength&&(m=0);while(L>0)}catch(r){throw(0,g.ensureFileSystemProviderError)(r)}finally{await R.Promises.settled([typeof e=="number"?s.close(e):Promise.resolve(),typeof t=="number"?n.close(t):Promise.resolve()])}}async doPipeUnbuffered(s,a,n,o){return this.writeQueue.queueFor(o,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,a,n,o))}async doPipeUnbufferedQueued(s,a,n,o){return n.writeFile(o,await s.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,a,n,o){return this.writeQueue.queueFor(o,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,a,n,o))}async doPipeUnbufferedToBufferedQueued(s,a,n,o){const e=await n.open(o,{create:!0,unlock:!1});try{const t=await s.readFile(a);await this.doWriteBuffer(n,e,P.VSBuffer.wrap(t),t.byteLength,0,0)}catch(t){throw(0,g.ensureFileSystemProviderError)(t)}finally{await n.close(e)}}async doPipeBufferedToUnbuffered(s,a,n,o){const e=await(0,P.streamToBuffer)(this.readFileBuffered(s,a,D.CancellationToken.None));await this.doWriteUnbuffered(n,o,void 0,e)}throwIfFileSystemIsReadonly(s,a){if(s.capabilities&2048)throw new g.FileOperationError((0,u.localize)(22,null,this.resourceForError(a)),6);return s}throwIfFileIsReadonly(s,a){if((a.permissions??0)&g.FilePermission.Readonly)throw new g.FileOperationError((0,u.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===y.Schemas.file?s.fsPath:s.toString(!0)}};S.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},S=pe([ae(0,p.ILogService)],S),i.FileService=S}),define(J[102],Q([0,1,47,135,3,55,17,10,46,2,6,12,18,37,13,85,16,52,95,96,99,27]),function(x,i,T,R,P,D,C,w,c,v,y,I,d,E,u,g,h,p,S,f,s,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DiskFileSystemProvider=void 0,(()=>{try{(0,R.gracefulify)(T)}catch(o){console.error(`Error enabling graceful-fs: ${(0,a.toErrorMessage)(o)}`)}})();class n extends s.AbstractDiskFileSystemProvider{constructor(e,t){super(e);this.options=t,this.onDidChangeCapabilities=w.Event.None,this.resourceLocks=new D.ResourceMap(r=>d.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,I.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(e){try{const{stat:t,symbolicLink:r}=await u.SymlinkSupport.stat(this.toFilePath(e));return{type:this.toType(t,r),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size}}catch(t){throw this.toFileSystemProviderError(t)}}async readdir(e){try{const t=await u.Promises.readdir(this.toFilePath(e),{withFileTypes:!0}),r=[];return await Promise.all(t.map(async l=>{try{let m;l.isSymbolicLink()?m=(await this.stat((0,d.joinPath)(e,l.name))).type:m=this.toType(l),r.push([l.name,m])}catch(m){this.logService.trace(m)}})),r}catch(t){throw this.toFileSystemProviderError(t)}}toType(e,t){let r;return t?.dangling?r=h.FileType.Unknown:e.isFile()?r=h.FileType.File:e.isDirectory()?r=h.FileType.Directory:r=h.FileType.Unknown,t&&(r|=h.FileType.SymbolicLink),r}async createResourceLock(e){this.logService.trace(`[Disk FileSystemProvider]: request to acquire resource lock (${this.toFilePath(e)})`);let t;for(;t=this.resourceLocks.get(e);)this.logService.trace(`[Disk FileSystemProvider]: waiting for resource lock to be released (${this.toFilePath(e)})`),await t.wait();const r=new P.Barrier;return this.resourceLocks.set(e,r),this.logService.trace(`[Disk FileSystemProvider]: new resource lock created (${this.toFilePath(e)})`),(0,v.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: resource lock disposed (${this.toFilePath(e)})`),this.resourceLocks.delete(e),r.open()})}async readFile(e,t){let r;try{t?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(e)})`),r=await this.createResourceLock(e));const l=this.toFilePath(e);return await u.Promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}finally{r?.dispose()}}readFileStream(e,t,r){const l=(0,E.newWriteableStream)(m=>C.VSBuffer.concat(m.map(L=>C.VSBuffer.wrap(L))).buffer);return(0,p.readFileIntoStream)(this,e,l,m=>m.buffer,{...t,bufferSize:256*1024},r),l}async writeFile(e,t,r){let l;try{const m=this.toFilePath(e);if(!r.create||!r.overwrite){if(await u.Promises.exists(m)){if(!r.overwrite)throw(0,h.createFileSystemProviderError)((0,g.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,h.createFileSystemProviderError)((0,g.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(e,{create:!0,unlock:r.unlock}),await this.write(l,0,t,0,t.byteLength)}catch(m){throw await this.toFileSystemProviderWriteError(e,m)}finally{typeof l=="number"&&await this.close(l)}}async open(e,t){let r;(0,h.isFileOpenForWriteOptions)(t)&&(r=await this.createResourceLock(e));let l;try{const m=this.toFilePath(e);if((0,h.isFileOpenForWriteOptions)(t)&&t.unlock)try{const{stat:b}=await u.SymlinkSupport.stat(m);b.mode&128||await u.Promises.chmod(m,b.mode|128)}catch(b){this.logService.trace(b)}let L;if((0,h.isFileOpenForWriteOptions)(t)){if(I.isWindows)try{await u.Promises.truncate(m,0),L="r+"}catch(b){b.code!=="ENOENT"&&this.logService.trace(b)}L||(L="w")}else L="r";l=await u.Promises.open(m,L)}catch(m){throw r?.dispose(),(0,h.isFileOpenForWriteOptions)(t)?await this.toFileSystemProviderWriteError(e,m):this.toFileSystemProviderError(m)}return this.mapHandleToPos.set(l,0),(0,h.isFileOpenForWriteOptions)(t)&&this.writeHandles.set(l,e),r&&this.mapHandleToLock.set(l,r),l}async close(e){try{if(this.mapHandleToPos.delete(e),this.writeHandles.delete(e)&&this.canFlush)try{await u.Promises.fdatasync(e)}catch(t){this.canFlush=!1,this.logService.error(t)}return await u.Promises.close(e)}catch(t){throw this.toFileSystemProviderError(t)}finally{const t=this.mapHandleToLock.get(e);t&&(this.mapHandleToLock.delete(e),t.dispose())}}async read(e,t,r,l,m){const L=this.normalizePos(e,t);let b=null;try{const O=await u.Promises.read(e,r,l,m,L);return typeof O=="number"?b=O:b=O.bytesRead,b}catch(O){throw this.toFileSystemProviderError(O)}finally{this.updatePos(e,L,b)}}normalizePos(e,t){return t===this.mapHandleToPos.get(e)?null:t}updatePos(e,t,r){const l=this.mapHandleToPos.get(e);typeof l=="number"&&(typeof t=="number"||(typeof r=="number"?this.mapHandleToPos.set(e,l+r):this.mapHandleToPos.delete(e)))}async write(e,t,r,l,m){return(0,P.retry)(()=>this.doWrite(e,t,r,l,m),100,3)}async doWrite(e,t,r,l,m){const L=this.normalizePos(e,t);let b=null;try{const O=await u.Promises.write(e,r,l,m,L);return typeof O=="number"?b=O:b=O.bytesWritten,b}catch(O){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(e),O)}finally{this.updatePos(e,L,b)}}async mkdir(e){try{await u.Promises.mkdir(this.toFilePath(e))}catch(t){throw this.toFileSystemProviderError(t)}}async delete(e,t){try{const r=this.toFilePath(e);t.recursive?await u.Promises.rm(r,u.RimRafMode.MOVE):await u.Promises.unlink(r)}catch(r){throw this.toFileSystemProviderError(r)}}async rename(e,t,r){const l=this.toFilePath(e),m=this.toFilePath(t);if(l!==m)try{await this.validateTargetDeleted(e,t,"move",r.overwrite),await u.Promises.move(l,m)}catch(L){throw(L.code==="EINVAL"||L.code==="EBUSY"||L.code==="ENAMETOOLONG")&&(L=new Error((0,g.localize)(2,null,(0,y.basename)(l),(0,y.basename)((0,y.dirname)(m)),L.toString()))),this.toFileSystemProviderError(L)}}async copy(e,t,r){const l=this.toFilePath(e),m=this.toFilePath(t);if(l!==m)try{await this.validateTargetDeleted(e,t,"copy",r.overwrite),await u.Promises.copy(l,m,{preserveSymlinks:!0})}catch(L){throw(L.code==="EINVAL"||L.code==="EBUSY"||L.code==="ENAMETOOLONG")&&(L=new Error((0,g.localize)(3,null,(0,y.basename)(l),(0,y.basename)((0,y.dirname)(m)),L.toString()))),this.toFileSystemProviderError(L)}}async validateTargetDeleted(e,t,r,l){const m=this.toFilePath(e),L=this.toFilePath(t);let b=!1;if(!!(this.capabilities&1024)||(b=(0,c.isEqual)(m,L,!0)),b&&r==="copy")throw(0,h.createFileSystemProviderError)((0,g.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(!b&&await u.Promises.exists(L)){if(!l)throw(0,h.createFileSystemProviderError)((0,g.localize)(5,null),h.FileSystemProviderErrorCode.FileExists);await this.delete(t,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(e,t,r){return new f.ParcelWatcherClient(l=>e(l),l=>t(l),r)}doWatch(e,t){const r=this.options?.watcher?.usePolling;if(r===!0)for(const l of t)l.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(r))for(const l of t)r.includes(l.path)&&(l.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(e,t)}createNonRecursiveWatcher(e,t,r,l){return new S.NodeJSFileWatcher(e,m=>t(m),m=>r(m),l)}toFileSystemProviderError(e){if(e instanceof h.FileSystemProviderError)return e;let t;switch(e.code){case"ENOENT":t=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=h.FileSystemProviderErrorCode.NoPermissions;break;default:t=h.FileSystemProviderErrorCode.Unknown}return(0,h.createFileSystemProviderError)(e,t)}async toFileSystemProviderWriteError(e,t){let r=this.toFileSystemProviderError(t);if(e&&r.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await u.SymlinkSupport.stat(this.toFilePath(e));l.mode&128||(r=(0,h.createFileSystemProviderError)(t,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.logService.trace(l)}return r}}i.DiskFileSystemProvider=n}),define(J[103],Q([0,1,16,15]),function(x,i,T,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SpdLogLogger=void 0;async function P(w,c,v,y,I){try{const d=await new Promise((u,g)=>{x(["spdlog"],u,g)});d.setFlushOn(R.LogLevel.Trace);const E=await d.createAsyncRotatingLogger(w,c,v,y);return I&&E.clearFormatters(),E}catch(d){console.error(d)}return null}function D(w,c,v){switch(c){case R.LogLevel.Trace:w.trace(v);break;case R.LogLevel.Debug:w.debug(v);break;case R.LogLevel.Info:w.info(v);break;case R.LogLevel.Warning:w.warn(v);break;case R.LogLevel.Error:w.error(v);break;case R.LogLevel.Critical:w.critical(v);break;default:throw new Error("Invalid log level")}}class C extends R.AbstractMessageLogger{constructor(c,v,y,I,d){super();this.buffer=[],this.setLevel(d),this._loggerCreationPromise=this._createSpdLogLogger(c,v,y,I),this._register(this.onDidChangeLogLevel(E=>{this._logger&&this._logger.setLevel(E)}))}async _createSpdLogLogger(c,v,y,I){const d=y?6:1,E=30/d*T.ByteSize.MB,u=await P(c,v,E,d,I);if(u){this._logger=u,this._logger.setLevel(this.getLevel());for(const{level:g,message:h}of this.buffer)D(this._logger,g,h);this.buffer=[]}}log(c,v){this._logger?D(this._logger,c,v):this.getLevel()<=c&&this.buffer.push({level:c,message:v})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}i.SpdLogLogger=C}),define(J[32],Q([0,1,14]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IProductService=void 0,i.IProductService=(0,T.createDecorator)("productService")}),define(J[29],Q([0,1,56,8]),function(x,i,T,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Registry=void 0;class P{constructor(){this.data=new Map}add(C,w){T.ok(R.isString(C)),T.ok(R.isObject(w)),T.ok(!this.data.has(C),"There is already an extension with this id"),this.data.set(C,w)}knows(C){return this.data.has(C)}as(C){return this.data.get(C)||null}}i.Registry=new P}),define(J[104],Q([0,1,10,29]),function(x,i,T,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Extensions=void 0,i.Extensions={JSONContribution:"base.contributions.json"};function P(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class D{constructor(){this._onDidChangeSchema=new T.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(c,v){this.schemasById[P(c)]=v,this._onDidChangeSchema.fire(c)}notifySchemaChanged(c){this._onDidChangeSchema.fire(c)}getSchemaContributions(){return{schemas:this.schemasById}}}const C=new D;R.Registry.add(i.Extensions.JSONContribution,C)}),define(J[34],Q([0,1,19,10,8,74,104,29]),function(x,i,T,R,P,D,C,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getScopes=i.validateProperty=i.getDefaultValue=i.keyFromOverrideIdentifiers=i.overrideIdentifiersFromKey=i.OVERRIDE_PROPERTY_REGEX=i.OVERRIDE_PROPERTY_PATTERN=i.configurationDefaultsSchemaId=i.resourceLanguageSettingsSchemaId=i.resourceSettings=i.windowSettings=i.machineOverridableSettings=i.machineSettings=i.applicationSettings=i.allSettings=i.ConfigurationScope=i.Extensions=i.EditPresentationTypes=void 0;var c;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(c=i.EditPresentationTypes||(i.EditPresentationTypes={})),i.Extensions={Configuration:"base.contributions.configuration"};var v;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(v=i.ConfigurationScope||(i.ConfigurationScope={})),i.allSettings={properties:{},patternProperties:{}},i.applicationSettings={properties:{},patternProperties:{}},i.machineSettings={properties:{},patternProperties:{}},i.machineOverridableSettings={properties:{},patternProperties:{}},i.windowSettings={properties:{},patternProperties:{}},i.resourceSettings={properties:{},patternProperties:{}},i.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",i.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const y=w.Registry.as(C.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(a,n=!0){this.registerConfigurations([a],n)}registerConfigurations(a,n=!0){const o=this.doRegisterConfigurations(a,n);y.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}deregisterConfigurations(a){const n=this.doDeregisterConfigurations(a);y.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}updateConfigurations({add:a,remove:n}){const o=[];o.push(...this.doDeregisterConfigurations(n)),o.push(...this.doRegisterConfigurations(a,!1)),y.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,T.distinct)(o)})}registerDefaultConfigurations(a){const n=[],o=[];for(const{overrides:e,source:t}of a)for(const r in e)if(n.push(r),i.OVERRIDE_PROPERTY_REGEX.test(r)){const l={...this.configurationDefaultsOverrides.get(r)?.value||{},...e[r]};this.configurationDefaultsOverrides.set(r,{source:t,value:l});const m={type:"object",default:l,description:D.localize(1,null,r),$ref:i.resourceLanguageSettingsSchemaId,defaultDefaultValue:l,source:P.isString(t)?void 0:t};o.push(...u(r)),this.configurationProperties[r]=m,this.defaultLanguageConfigurationOverridesNode.properties[r]=m}else{this.configurationDefaultsOverrides.set(r,{value:e[r],source:t});const l=this.configurationProperties[r];l&&(this.updatePropertyDefaultValue(r,l),this.updateSchema(r,l))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(a){const n=[];for(const{overrides:o,source:e}of a)for(const t in o){const r=this.configurationDefaultsOverrides.get(t),l=P.isString(e)?e:e?.id,m=P.isString(r?.source)?r?.source:r?.source?.id;if(l===m)if(n.push(t),this.configurationDefaultsOverrides.delete(t),i.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const L=this.configurationProperties[t];L&&(this.updatePropertyDefaultValue(t,L),this.updateSchema(t,L))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...a){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(a){for(const n of a)this.overrideIdentifiers.add(n);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(a,n){const o=[];return a.forEach(e=>{o.push(...this.validateAndRegisterProperties(e,n,e.extensionInfo,e.restrictedProperties)),this.configurationContributors.push(e),this.registerJSONConfiguration(e)}),o}doDeregisterConfigurations(a){const n=[],o=e=>{if(e.properties)for(const t in e.properties)n.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,e.properties[t]);e.allOf&&e.allOf.forEach(t=>o(t))};for(const e of a){o(e);const t=this.configurationContributors.indexOf(e);t!==-1&&this.configurationContributors.splice(t,1)}return n}validateAndRegisterProperties(a,n=!0,o,e,t=3){t=P.isUndefinedOrNull(a.scope)?t:a.scope;let r=[],l=a.properties;if(l)for(let L in l){if(n&&S(L)){delete l[L];continue}const b=l[L];if(b.source=o,b.defaultDefaultValue=l[L].default,this.updatePropertyDefaultValue(L,b),i.OVERRIDE_PROPERTY_REGEX.test(L)?b.scope=void 0:(b.scope=P.isUndefinedOrNull(b.scope)?t:b.scope,b.restricted=P.isUndefinedOrNull(b.restricted)?!!e?.includes(L):b.restricted),l[L].hasOwnProperty("included")&&!l[L].included){this.excludedConfigurationProperties[L]=l[L],delete l[L];continue}else this.configurationProperties[L]=l[L];!l[L].deprecationMessage&&l[L].markdownDeprecationMessage&&(l[L].deprecationMessage=l[L].markdownDeprecationMessage),r.push(L)}let m=a.allOf;if(m)for(let L of m)r.push(...this.validateAndRegisterProperties(L,n,o,e,t));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(a){const n=o=>{let e=o.properties;if(e)for(const r in e)this.updateSchema(r,e[r]);let t=o.allOf;t&&t.forEach(n)};n(a)}updateSchema(a,n){switch(i.allSettings.properties[a]=n,n.scope){case 1:i.applicationSettings.properties[a]=n;break;case 2:i.machineSettings.properties[a]=n;break;case 6:i.machineOverridableSettings.properties[a]=n;break;case 3:i.windowSettings.properties[a]=n;break;case 4:i.resourceSettings.properties[a]=n;break;case 5:i.resourceSettings.properties[a]=n,this.resourceLanguageSettingsSchema.properties[a]=n;break}}removeFromSchema(a,n){switch(delete i.allSettings.properties[a],n.scope){case 1:delete i.applicationSettings.properties[a];break;case 2:delete i.machineSettings.properties[a];break;case 6:delete i.machineOverridableSettings.properties[a];break;case 3:delete i.windowSettings.properties[a];break;case 4:case 5:delete i.resourceSettings.properties[a],delete this.resourceLanguageSettingsSchema.properties[a];break}}updateOverridePropertyPatternKey(){for(const a of this.overrideIdentifiers.values()){const n=`[${a}]`,o={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:i.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(n,o),i.allSettings.properties[n]=o,i.applicationSettings.properties[n]=o,i.machineSettings.properties[n]=o,i.machineOverridableSettings.properties[n]=o,i.windowSettings.properties[n]=o,i.resourceSettings.properties[n]=o}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const a={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:i.resourceLanguageSettingsSchemaId};i.allSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.applicationSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.machineSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.machineOverridableSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.windowSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.resourceSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(a,n){const o=this.configurationDefaultsOverrides.get(a);let e=o?.value,t=o?.source;P.isUndefined(e)&&(e=n.defaultDefaultValue,t=void 0),P.isUndefined(e)&&(e=h(n.type)),n.default=e,n.defaultValueSource=t}}const d="\\[([^\\]]+)\\]",E=new RegExp(d,"g");i.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,i.OVERRIDE_PROPERTY_REGEX=new RegExp(i.OVERRIDE_PROPERTY_PATTERN);function u(s){const a=[];if(i.OVERRIDE_PROPERTY_REGEX.test(s)){let n=E.exec(s);for(;n?.length;){const o=n[1].trim();o&&a.push(o),n=E.exec(s)}}return(0,T.distinct)(a)}i.overrideIdentifiersFromKey=u;function g(s){return s.reduce((a,n)=>`${a}[${n}]`,"")}i.keyFromOverrideIdentifiers=g;function h(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}i.getDefaultValue=h;const p=new I;w.Registry.add(i.Extensions.Configuration,p);function S(s){return s.trim()?i.OVERRIDE_PROPERTY_REGEX.test(s)?D.localize(7,null,s):p.getConfigurationProperties()[s]!==void 0?D.localize(8,null,s):null:D.localize(6,null)}i.validateProperty=S;function f(){const s=[],a=p.getConfigurationProperties();for(const n of Object.keys(a))s.push([n,a[n].scope]);return s.push(["launch",4]),s.push(["task",4]),s}i.getScopes=f}),define(J[105],Q([0,1,19,10,57,2,55,21,8,9,25,34,29]),function(x,i,T,R,P,D,C,w,c,v,y,I,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AllKeysConfigurationChangeEvent=i.ConfigurationChangeEvent=i.mergeChanges=i.Configuration=i.UserSettings=i.ConfigurationModelParser=i.DefaultConfigurationModel=i.ConfigurationModel=void 0;class E{constructor(e={},t=[],r=[]){this._contents=e,this._keys=t,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,y.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,t){const r=this.getContentsForOverrideIdentifer(t);return r?e?(0,y.getConfigurationValue)(r,e):r:void 0}getKeysForOverrideIdentifier(e){const t=[];for(const r of this.overrides)r.identifiers.includes(e)&&t.push(...r.keys);return T.distinct(t)}getAllOverrideIdentifiers(){const e=[];for(const t of this.overrides)e.push(...t.identifiers);return T.distinct(e)}override(e){let t=this.overrideConfigurations.get(e);return t||(t=this.createOverrideConfigurationModel(e),this.overrideConfigurations.set(e,t)),t}merge(...e){const t=w.deepClone(this.contents),r=w.deepClone(this.overrides),l=[...this.keys];for(const m of e){this.mergeContents(t,m.contents);for(const L of m.overrides){const[b]=r.filter(O=>T.equals(O.identifiers,L.identifiers));b?(this.mergeContents(b.contents,L.contents),b.keys.push(...L.keys),b.keys=T.distinct(b.keys)):r.push(w.deepClone(L))}for(const L of m.keys)l.indexOf(L)===-1&&l.push(L)}return new E(t,l,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(e){const t=this.getContentsForOverrideIdentifer(e);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let r={};for(const l of T.distinct([...Object.keys(this.contents),...Object.keys(t)])){let m=this.contents[l],L=t[l];L&&(typeof m=="object"&&typeof L=="object"?(m=w.deepClone(m),this.mergeContents(m,L)):m=L),r[l]=m}return new E(r,this.keys,this.overrides)}mergeContents(e,t){for(const r of Object.keys(t)){if(r in e&&c.isObject(e[r])&&c.isObject(t[r])){this.mergeContents(e[r],t[r]);continue}e[r]=w.deepClone(t[r])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?w.deepFreeze(e):e}getContentsForOverrideIdentifer(e){let t=null,r=null;const l=m=>{m&&(r?this.mergeContents(r,m):r=w.deepClone(m))};for(const m of this.overrides)T.equals(m.identifiers,[e])?t=m.contents:m.identifiers.includes(e)&&l(m.contents);return l(t),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,t){this.addKey(e),(0,y.addToValueTree)(this.contents,e,t,r=>{throw new Error(r)})}removeValue(e){this.removeKey(e)&&(0,y.removeFromValueTree)(this.contents,e)}addKey(e){let t=this.keys.length;for(let r=0;r<t;r++)e.indexOf(this.keys[r])===0&&(t=r);this.keys.splice(t,1,e)}removeKey(e){let t=this.keys.indexOf(e);return t!==-1?(this.keys.splice(t,1),!0):!1}}i.ConfigurationModel=E;class u extends E{constructor(e={}){const t=d.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(t),l=Object.create(null),m=[];for(const L in t){const b=e[L],O=b!==void 0?b:t[L].default;(0,y.addToValueTree)(l,L,O,N=>console.error(`Conflict in default settings: ${N}`))}for(const L of Object.keys(l))I.OVERRIDE_PROPERTY_REGEX.test(L)&&m.push({identifiers:(0,I.overrideIdentifiersFromKey)(L),keys:Object.keys(l[L]),contents:(0,y.toValuesTree)(l[L],b=>console.error(`Conflict in default settings file: ${b}`))});super(l,r,m)}}i.DefaultConfigurationModel=u;class g{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,t){if(!c.isUndefinedOrNull(e)){const r=this.doParseContent(e);this.parseRaw(r,t)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,t){this._raw=e;const{contents:r,keys:l,overrides:m,restricted:L}=this.doParseRaw(e,t);this._configurationModel=new E(r,l,m),this._restrictedConfigurations=L||[]}doParseContent(e){let t={},r=null,l=[],m=[],L=[];function b(N){Array.isArray(l)?l.push(N):r!==null&&(l[r]=N)}let O={onObjectBegin:()=>{let N={};b(N),m.push(l),l=N,r=null},onObjectProperty:N=>{r=N},onObjectEnd:()=>{l=m.pop()},onArrayBegin:()=>{let N=[];b(N),m.push(l),l=N,r=null},onArrayEnd:()=>{l=m.pop()},onLiteralValue:b,onError:(N,G,ee)=>{L.push({error:N,offset:G,length:ee})}};if(e)try{P.visit(e,O),t=l[0]||{}}catch(N){console.error(`Error while parsing settings file ${this._name}: ${N}`),this._parseErrors=[N]}return t}doParseRaw(e,t){const r=d.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),l=this.filter(e,r,!0,t);e=l.raw;const m=(0,y.toValuesTree)(e,O=>console.error(`Conflict in settings file ${this._name}: ${O}`)),L=Object.keys(e),b=this.toOverrides(e,O=>console.error(`Conflict in settings file ${this._name}: ${O}`));return{contents:m,keys:L,overrides:b,restricted:l.restricted}}filter(e,t,r,l){if(!l?.scopes&&!l?.skipRestricted)return{raw:e,restricted:[]};const m={},L=[];for(let b in e)if(I.OVERRIDE_PROPERTY_REGEX.test(b)&&r){const O=this.filter(e[b],t,!1,l);m[b]=O.raw,L.push(...O.restricted)}else{const O=t[b],N=O?typeof O.scope!="undefined"?O.scope:3:void 0;O?.restricted&&L.push(b),(N===void 0||l.scopes===void 0||l.scopes.includes(N))&&(l.skipRestricted&&O?.restricted||(m[b]=e[b]))}return{raw:m,restricted:L}}toOverrides(e,t){const r=[];for(const l of Object.keys(e))if(I.OVERRIDE_PROPERTY_REGEX.test(l)){const m={};for(const L in e[l])m[L]=e[l][L];r.push({identifiers:(0,I.overrideIdentifiersFromKey)(l),keys:Object.keys(m),contents:(0,y.toValuesTree)(m,t)})}return r}}i.ConfigurationModelParser=g;class h extends D.Disposable{constructor(e,t,r,l){super();this.userSettingsResource=e,this.scopes=t,this.fileService=l,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(R.Event.filter(this.fileService.onDidFilesChange,m=>m.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new E}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}i.UserSettings=h;class p{constructor(e,t,r=new E,l=new E,m=new C.ResourceMap,L=new E,b=new C.ResourceMap,O=!0){this._defaultConfiguration=e,this._localUserConfiguration=t,this._remoteUserConfiguration=r,this._workspaceConfiguration=l,this._folderConfigurations=m,this._memoryConfiguration=L,this._memoryConfigurationByResource=b,this._freeze=O,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new C.ResourceMap,this._userConfiguration=null}getValue(e,t,r){return this.getConsolidateConfigurationModel(t,r).getValue(e)}updateValue(e,t,r={}){let l;r.resource?(l=this._memoryConfigurationByResource.get(r.resource),l||(l=new E,this._memoryConfigurationByResource.set(r.resource,l))):l=this._memoryConfiguration,t===void 0?l.removeValue(e):l.setValue(e,t),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,t,r){const l=this.getConsolidateConfigurationModel(t,r),m=this.getFolderConfigurationModelForResource(t.resource,r),L=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,b=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),O=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),N=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),G=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),ee=r?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,ge=m?t.overrideIdentifier?m.freeze().override(t.overrideIdentifier).getValue(e):m.freeze().getValue(e):void 0,ce=t.overrideIdentifier?L.override(t.overrideIdentifier).getValue(e):L.getValue(e),te=l.getValue(e),he=T.distinct(T.flatten(l.overrides.map(W=>W.identifiers))).filter(W=>l.getOverrideValue(e,W)!==void 0);return{defaultValue:b,userValue:O,userLocalValue:N,userRemoteValue:G,workspaceValue:ee,workspaceFolderValue:ge,memoryValue:ce,value:te,default:b!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,user:O!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,userLocal:N!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,userRemote:G!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,workspace:ee!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,workspaceFolder:ge!==void 0?{value:m?.freeze().getValue(e),override:t.overrideIdentifier?m?.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,memory:ce!==void 0?{value:L.getValue(e),override:t.overrideIdentifier?L.getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:he.length?he:void 0}}keys(e){const t=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,t){this._folderConfigurations.set(e,t),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,t){const r=[];if(!t){const{added:l,updated:m,removed:L}=a(this._defaultConfiguration,e);t=[...l,...m,...L]}for(const l of t)for(const m of(0,I.overrideIdentifiersFromKey)(l)){const L=this._defaultConfiguration.getKeysForOverrideIdentifier(m),b=e.getKeysForOverrideIdentifier(m),O=[...b.filter(N=>L.indexOf(N)===-1),...L.filter(N=>b.indexOf(N)===-1),...L.filter(N=>!w.equals(this._defaultConfiguration.override(m).getValue(N),e.override(m).getValue(N)))];r.push([m,O])}return this.updateDefaultConfiguration(e),{keys:t,overrides:r}}compareAndUpdateLocalUserConfiguration(e){const{added:t,updated:r,removed:l,overrides:m}=a(this.localUserConfiguration,e),L=[...t,...r,...l];return L.length&&this.updateLocalUserConfiguration(e),{keys:L,overrides:m}}compareAndUpdateRemoteUserConfiguration(e){const{added:t,updated:r,removed:l,overrides:m}=a(this.remoteUserConfiguration,e);let L=[...t,...r,...l];return L.length&&this.updateRemoteUserConfiguration(e),{keys:L,overrides:m}}compareAndUpdateWorkspaceConfiguration(e){const{added:t,updated:r,removed:l,overrides:m}=a(this.workspaceConfiguration,e);let L=[...t,...r,...l];return L.length&&this.updateWorkspaceConfiguration(e),{keys:L,overrides:m}}compareAndUpdateFolderConfiguration(e,t){const r=this.folderConfigurations.get(e),{added:l,updated:m,removed:L,overrides:b}=a(r,t);let O=[...l,...m,...L];return(O.length||!r)&&this.updateFolderConfiguration(e,t),{keys:O,overrides:b}}compareAndDeleteFolderConfiguration(e){const t=this.folderConfigurations.get(e);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:r,updated:l,removed:m,overrides:L}=a(t,void 0);return{keys:[...r,...l,...m],overrides:L}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,t){let r=this.getConsolidatedConfigurationModelForResource(e,t);return e.overrideIdentifier?r.override(e.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:e},t){let r=this.getWorkspaceConsolidatedConfiguration();if(t&&e){const l=t.getFolder(e);l&&(r=this.getFolderConsolidatedConfiguration(l.uri)||r);const m=this._memoryConfigurationByResource.get(e);m&&(r=r.merge(m))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let t=this._foldersConsolidatedConfigurations.get(e);if(!t){const r=this.getWorkspaceConsolidatedConfiguration(),l=this._folderConfigurations.get(e);l?(t=r.merge(l),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(e,t)):t=r}return t}getFolderConfigurationModelForResource(e,t){if(t&&e){const r=t.getFolder(e);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,t)=>{const{contents:r,overrides:l,keys:m}=this._folderConfigurations.get(t);return e.push([t,{contents:r,overrides:l,keys:m}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>e.add(t)),this.userConfiguration.freeze().keys.forEach(t=>e.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>e.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(r=>e.add(r))),[...e.values()]}allOverrideIdentifiers(){const e=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>e.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>e.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>e.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(r=>e.add(r))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(r=>t.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(r=>t.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(e).forEach(l=>t.add(l))),[...t.values()]}static parse(e){const t=this.parseConfigurationModel(e.defaults),r=this.parseConfigurationModel(e.user),l=this.parseConfigurationModel(e.workspace),m=e.folders.reduce((L,b)=>(L.set(v.URI.revive(b[0]),this.parseConfigurationModel(b[1])),L),new C.ResourceMap);return new p(t,r,new E,l,m,new E,new C.ResourceMap,!1)}static parseConfigurationModel(e){return new E(e.contents,e.keys,e.overrides).freeze()}}i.Configuration=p;function S(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const e=new Set,t=new Map;for(const l of o)l.keys.forEach(m=>e.add(m)),l.overrides.forEach(([m,L])=>{const b=(0,C.getOrSet)(t,m,new Set);L.forEach(O=>b.add(O))});const r=[];return t.forEach((l,m)=>r.push([m,[...l.values()]])),{keys:[...e.values()],overrides:r}}i.mergeChanges=S;class f{constructor(e,t,r,l){this.change=e,this.previous=t,this.currentConfiguraiton=r,this.currentWorkspace=l,this._previousConfiguration=void 0;const m=new Set;e.keys.forEach(b=>m.add(b)),e.overrides.forEach(([,b])=>b.forEach(O=>m.add(O))),this.affectedKeys=[...m.values()];const L=new E;this.affectedKeys.forEach(b=>L.setValue(b,{})),this.affectedKeysTree=L.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=p.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(t){const r=this.previousConfiguration?this.previousConfiguration.getValue(e,t,this.previous?.workspace):void 0,l=this.currentConfiguraiton.getValue(e,t,this.currentWorkspace);return!w.equals(r,l)}return!0}return!1}doesAffectedKeysTreeContains(e,t){let r=(0,y.toValuesTree)({[t]:!0},()=>{}),l;for(;typeof r=="object"&&(l=Object.keys(r)[0]);){if(e=e[l],!e)return!1;r=r[l]}return!0}}i.ConfigurationChangeEvent=f;class s extends f{constructor(e,t,r,l){super({keys:e.allKeys(),overrides:[]},void 0,e,t);this.source=r,this.sourceConfig=l}}i.AllKeysConfigurationChangeEvent=s;function a(o,e){const{added:t,removed:r,updated:l}=n(e,o),m=[],L=o?.getAllOverrideIdentifiers()||[],b=e?.getAllOverrideIdentifiers()||[];if(e){const O=b.filter(N=>!L.includes(N));for(const N of O)m.push([N,e.getKeysForOverrideIdentifier(N)])}if(o){const O=L.filter(N=>!b.includes(N));for(const N of O)m.push([N,o.getKeysForOverrideIdentifier(N)])}if(e&&o){for(const O of L)if(b.includes(O)){const N=n({contents:o.getOverrideValue(void 0,O)||{},keys:o.getKeysForOverrideIdentifier(O)},{contents:e.getOverrideValue(void 0,O)||{},keys:e.getKeysForOverrideIdentifier(O)});m.push([O,[...N.added,...N.removed,...N.updated]])}}return{added:t,removed:r,updated:l,overrides:m}}function n(o,e){const t=o?e?o.keys.filter(m=>e.keys.indexOf(m)===-1):[...o.keys]:[],r=e?o?e.keys.filter(m=>o.keys.indexOf(m)===-1):[...e.keys]:[],l=[];if(o&&e){for(const m of e.keys)if(o.keys.indexOf(m)!==-1){const L=(0,y.getConfigurationValue)(e.contents,m),b=(0,y.getConfigurationValue)(o.contents,m);w.equals(L,b)||l.push(m)}}return{added:t,removed:r,updated:l}}}),define(J[106],Q([0,1,3,10,2,18,25,105,34,29]),function(x,i,T,R,P,D,C,w,c,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ConfigurationService=void 0;class y extends P.Disposable{constructor(d,E){super();this.settingsResource=d,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new w.UserSettings(this.settingsResource,void 0,D.extUriBiasedIgnorePathCase,E)),this.configuration=new w.Configuration(new w.DefaultConfigurationModel,new w.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new T.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(v.Registry.as(c.Extensions.Configuration).onDidUpdateConfiguration(({properties:u})=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const d=await this.userConfiguration.loadConfiguration();this.configuration=new w.Configuration(new w.DefaultConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(d,E){const u=typeof d=="string"?d:void 0,g=(0,C.isConfigurationOverrides)(d)?d:(0,C.isConfigurationOverrides)(E)?E:{};return this.configuration.getValue(u,g,void 0)}updateValue(d,E,u,g){return Promise.reject(new Error("not supported"))}inspect(d){return this.configuration.inspect(d,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const d=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(d)}onDidChangeUserConfiguration(d){const E=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(d);this.trigger(u,E,1)}onDidDefaultConfigurationChange(d){const E=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new w.DefaultConfigurationModel,d);this.trigger(u,E,6)}trigger(d,E,u){const g=new w.ConfigurationChangeEvent(d,{data:E},this.configuration);g.source=u,g.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(d){switch(d){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}i.ConfigurationService=y}),define(J[107],Q([0,1,11]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isVirtualWorkspace=i.getVirtualWorkspaceScheme=i.getVirtualWorkspaceLocation=i.isVirtualResource=i.getRemoteName=i.getRemoteAuthority=void 0;function R(v){return v.scheme===T.Schemas.vscodeRemote?v.authority:void 0}i.getRemoteAuthority=R;function P(v){if(!v)return;const y=v.indexOf("+");return y<0?v:v.substr(0,y)}i.getRemoteName=P;function D(v){return v.scheme!==T.Schemas.file&&v.scheme!==T.Schemas.vscodeRemote}i.isVirtualResource=D;function C(v){if(v.folders.length)return v.folders.every(y=>D(y.uri))?v.folders[0].uri:void 0;if(v.configuration&&D(v.configuration))return v.configuration}i.getVirtualWorkspaceLocation=C;function w(v){return C(v)?.scheme}i.getVirtualWorkspaceScheme=w;function c(v){return C(v)!==void 0}i.isVirtualWorkspace=c}),define(J[41],Q([0,1,26,14,107]),function(x,i,T,R,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IBuiltinExtensionsScannerService=i.isResolverExtension=i.isAuthenticationProviderExtension=i.isLanguagePackExtension=i.ExtensionIdentifier=i.ExtensionType=i.EXTENSION_CATEGORIES=i.isIExtensionIdentifier=i.getWorkspaceSupportTypeMessage=i.ALL_EXTENSION_KINDS=i.BUILTIN_MANIFEST_CACHE_FILE=i.USER_MANIFEST_CACHE_FILE=i.MANIFEST_CACHE_FOLDER=void 0,i.MANIFEST_CACHE_FOLDER="CachedExtensions",i.USER_MANIFEST_CACHE_FILE="user",i.BUILTIN_MANIFEST_CACHE_FILE="builtin",i.ALL_EXTENSION_KINDS=["ui","workspace","web"];function D(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}i.getWorkspaceSupportTypeMessage=D;function C(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}i.isIExtensionIdentifier=C,i.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var w;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(w=i.ExtensionType||(i.ExtensionType={}));class c{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,u){if(typeof E=="undefined"||E===null)return typeof u=="undefined"||u===null;if(typeof u=="undefined"||u===null)return!1;if(typeof E=="string"||typeof u=="string"){let g=typeof E=="string"?E:E.value,h=typeof u=="string"?u:u.value;return T.equalsIgnoreCase(g,h)}return E._lower===u._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}i.ExtensionIdentifier=c;function v(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}i.isLanguagePackExtension=v;function y(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}i.isAuthenticationProviderExtension=y;function I(d,E){if(E){const u=`onResolveRemoteAuthority:${(0,P.getRemoteName)(E)}`;return d.activationEvents?.indexOf(u)!==-1}return!1}i.isResolverExtension=I,i.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(J[23],Q([0,1,26,41]),function(x,i,T,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getExtensionDependencies=i.getMaliciousExtensionsSet=i.BetterMergeId=i.getGalleryExtensionTelemetryData=i.getLocalExtensionTelemetryData=i.groupByExtension=i.getGalleryExtensionId=i.adoptToGalleryExtensionId=i.getExtensionId=i.ExtensionIdentifierWithVersion=i.areSameExtensions=void 0;function P(u,g){return u.uuid&&g.uuid?u.uuid===g.uuid:u.id===g.id?!0:(0,T.compareIgnoreCase)(u.id,g.id)===0}i.areSameExtensions=P;class D{constructor(g,h){this.version=h,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof D?P(this,g)&&this.version===g.version:!1}}i.ExtensionIdentifierWithVersion=D;function C(u,g){return`${u}.${g}`}i.getExtensionId=C;function w(u){return u.toLocaleLowerCase()}i.adoptToGalleryExtensionId=w;function c(u,g){return w(C(u,g))}i.getGalleryExtensionId=c;function v(u,g){const h=[],p=S=>{for(const f of h)if(f.some(s=>P(g(s),g(S))))return f;return null};for(const S of u){const f=p(S);f?f.push(S):h.push([S])}return h}i.groupByExtension=v;function y(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}i.getLocalExtensionTelemetryData=y;function I(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}i.getGalleryExtensionTelemetryData=I,i.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function d(u){const g=new Set;if(u.malicious)for(const h of u.malicious)g.add(h.id);return g}i.getMaliciousExtensionsSet=d;function E(u,g){const h=[],p=g.manifest.extensionDependencies?.slice(0)??[];for(;p.length;){const S=p.shift();if(S&&h.every(f=>!P(f.identifier,{id:S}))){const f=u.filter(s=>P(s.identifier,{id:S}));f.length===1&&(h.push(f[0]),p.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return h}i.getExtensionDependencies=E}),define(J[108],Q([0,1,24,7,62,11,42,9,78,22,23,41]),function(x,i,T,R,P,D,C,w,c,v,y,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementCLIService=i.getIdAndVersion=void 0;const d=S=>(0,c.localize)(0,null,S),E=(0,c.localize)(1,null,"ms-dotnettools.csharp");function u(S,f){return f?`${S.publisher}.${S.name}@${S.version}`:`${S.publisher}.${S.name}`}const g=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function h(S){const f=g.exec(S);return f&&f[1]?[(0,y.adoptToGalleryExtensionId)(f[1]),f[2]]:[(0,y.adoptToGalleryExtensionId)(S),void 0]}i.getIdAndVersion=h;let p=class{constructor(f,s){this.extensionManagementService=f,this.extensionGalleryService=s}get location(){}async listExtensions(f,s,a=console){let n=await this.extensionManagementService.getInstalled(1);const o=I.EXTENSION_CATEGORIES.map(t=>t.toLowerCase());if(s&&s!==""){if(o.indexOf(s.toLowerCase())<0){a.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}n=n.filter(t=>t.manifest.categories?t.manifest.categories.map(l=>l.toLowerCase()).indexOf(s.toLowerCase())>-1:!1)}else if(s===""){a.log("Possible Categories: "),o.forEach(t=>{a.log(t)});return}this.location&&a.log((0,c.localize)(2,null,this.location)),n=n.sort((t,r)=>t.identifier.id.localeCompare(r.identifier.id));let e;for(let t of n)e!==t.identifier.id&&(e=t.identifier.id,a.log(u(t.manifest,f)))}async installExtensions(f,s,a,n,o=console){const e=[],t=[];f.length&&o.log(this.location?(0,c.localize)(3,null,this.location):(0,c.localize)(4,null));const r=await this.extensionManagementService.getInstalled(1),l=(b,O)=>{const N=r.find(G=>(0,y.areSameExtensions)(G.identifier,{id:b}));if(N){if(!O&&!n)return o.log((0,c.localize)(5,null,b,N.manifest.version,b)),!1;if(O&&N.manifest.version===O)return o.log((0,c.localize)(6,null,`${b}@${O}`)),!1}return!0},m=[],L=[];for(const b of f)if(b instanceof w.URI)m.push(b);else{const[O,N]=h(b);l(O,N)&&L.push({id:O,version:N,installOptions:{...a,isBuiltin:!1}})}for(const b of s){const[O,N]=h(b);l(O,N)&&L.push({id:O,version:N,installOptions:{...a,isBuiltin:!0}})}if(m.length&&await Promise.all(m.map(async b=>{try{const O=await this.installVSIX(b,{...a,isBuiltin:!1},n,o);O&&t.push(O)}catch(O){o.error(O.message||O.stack||O),e.push(b.toString())}})),L.length){const b=await this.getGalleryExtensions(L);await Promise.all(L.map(async O=>{const N=b.get(O.id.toLowerCase());if(N)try{const G=await this.installFromGallery(O,N,r,n,o);G&&t.push(G)}catch(G){o.error(G.message||G.stack||G),e.push(O.id)}else o.error(`${d(O.version?`${O.id}@${O.version}`:O.id)}
${E}`),e.push(O.id)}))}if(e.length)throw new Error((0,c.localize)(7,null,e.join(", ")))}async installVSIX(f,s,a,n){const o=await this.extensionManagementService.getManifest(f);if(!o)throw new Error("Invalid vsix");if(await this.validateVSIX(o,a,n))try{return await this.extensionManagementService.install(f,s),n.log((0,c.localize)(8,null,(0,P.getBaseLabel)(f))),o}catch(t){if((0,R.isPromiseCanceledError)(t))return n.log((0,c.localize)(9,null,(0,P.getBaseLabel)(f))),null;throw t}return null}async getGalleryExtensions(f){const s=new Map,a=await this.extensionGalleryService.getExtensions(f,f.some(n=>n.installOptions.installPreReleaseVersion),T.CancellationToken.None);for(const n of a)s.set(n.identifier.id.toLowerCase(),n);return s}async installFromGallery({id:f,version:s,installOptions:a},n,o,e,t){const r=await this.extensionGalleryService.getManifest(n,T.CancellationToken.None);if(r&&!this.validateExtensionKind(r,t))return null;const l=o.find(m=>(0,y.areSameExtensions)(m.identifier,n.identifier));if(l){if(n.version===l.manifest.version)return t.log((0,c.localize)(10,null,s?`${f}@${s}`:f)),null;t.log((0,c.localize)(11,null,f,n.version))}try{return a.isBuiltin?t.log(s?(0,c.localize)(12,null,f,s):(0,c.localize)(13,null,f)):t.log(s?(0,c.localize)(14,null,f,s):(0,c.localize)(15,null,f)),await this.extensionManagementService.installFromGallery(n,{...a,installGivenVersion:!!s}),t.log((0,c.localize)(16,null,f,n.version)),r}catch(m){if((0,R.isPromiseCanceledError)(m))return t.log((0,c.localize)(17,null,f)),null;throw m}}validateExtensionKind(f,s){return!0}async validateVSIX(f,s,a){const n={id:(0,y.getGalleryExtensionId)(f.publisher,f.name)},e=(await this.extensionManagementService.getInstalled(1)).find(t=>(0,y.areSameExtensions)(n,t.identifier)&&(0,C.gt)(t.manifest.version,f.version));return e&&!s?(a.log((0,c.localize)(18,null,e.identifier.id,e.manifest.version,f.version)),!1):this.validateExtensionKind(f,a)}async uninstallExtensions(f,s,a=console){const n=async e=>{if(e instanceof w.URI){const t=await this.extensionManagementService.getManifest(e);return u(t)}return e},o=[];for(const e of f){const t=await n(e),l=(await this.extensionManagementService.getInstalled()).filter(m=>(0,y.areSameExtensions)(m.identifier,{id:t}));if(!l.length)throw new Error(`${this.notInstalled(t)}
${E}`);if(l.some(m=>m.type===0)){a.log((0,c.localize)(19,null,t));return}if(!s&&l.some(m=>m.isBuiltin)){a.log((0,c.localize)(20,null,t));return}a.log((0,c.localize)(21,null,t));for(const m of l)await this.extensionManagementService.uninstall(m),o.push(m);this.location?a.log((0,c.localize)(22,null,t,this.location)):a.log((0,c.localize)(23,null,t))}}async locateExtension(f,s=console){const a=await this.extensionManagementService.getInstalled();f.forEach(n=>{a.forEach(o=>{if(o.identifier.id===n&&o.location.scheme===D.Schemas.file){s.log(o.location.fsPath);return}})})}notInstalled(f){return this.location?(0,c.localize)(24,null,f,this.location):(0,c.localize)(25,null,f)}};p=pe([ae(0,v.IExtensionManagementService),ae(1,v.IExtensionGalleryService)],p),i.ExtensionManagementCLIService=p}),define(J[109],Q([0,1,3,7,2,12,18,42,9,31,13,20,22,23,16,15]),function(x,i,T,R,P,D,C,w,c,v,y,I,d,E,u,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsDownloader=void 0;const h=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let p=class extends P.Disposable{constructor(f,s,a,n){super();this.fileService=s,this.extensionGalleryService=a,this.logService=n,this.extensionsDownloadDir=c.URI.file(f.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(f,s){await this.cleanUpPromise;const a=this.getName(f),n=(0,C.joinPath)(this.extensionsDownloadDir,a);if(!await this.fileService.exists(n)){const o=(0,C.joinPath)(this.extensionsDownloadDir,`.${(0,v.generateUuid)()}`);await this.fileService.exists(o)||await this.extensionGalleryService.download(f,o,s);try{await this.rename(o,n,Date.now()+2*60*1e3)}catch(e){try{await this.fileService.del(o)}catch{}if(e.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",f.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,R.getErrorMessage)(e)}. Deleted the vsix from downloaded location`,o.path),e}}return n}async delete(f){await this.cleanUpPromise,await this.fileService.del(f)}async rename(f,s,a){try{await y.Promises.rename(f.fsPath,s.fsPath)}catch(n){if(D.isWindows&&n&&n.code==="EPERM"&&Date.now()<a)return this.logService.info(`Failed renaming ${f} to ${s} with 'EPERM' error. Trying again...`),this.rename(f,s,a);throw n}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const s=[],a=[];for(const e of f.children){const t=this.parse(e.name);t&&a.push([t,e])}const n=(0,E.groupByExtension)(a,([e])=>e),o=[];for(const e of n)e.sort((t,r)=>w.rcompare(t[0].version,r[0].version)),s.push(...e.slice(1).map(t=>t[1].resource)),o.push(e[0][1]);o.sort((e,t)=>e.mtime-t.mtime),s.push(...o.slice(0,Math.max(0,o.length-this.cache)).map(e=>e.resource)),await T.Promises.settled(s.map(e=>(this.logService.trace("Deleting vsix from cache",e.path),this.fileService.del(e))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?`${new E.ExtensionIdentifierWithVersion(f.identifier,f.version).key().toLowerCase()}${f.properties.targetPlatform!=="undefined"?`-${f.properties.targetPlatform}`:""}`:(0,v.generateUuid)()}parse(f){const s=h.exec(f);return s&&s[1]&&s[2]?new E.ExtensionIdentifierWithVersion({id:s[1]},s[2]):null}};p=pe([ae(0,I.INativeEnvironmentService),ae(1,u.IFileService),ae(2,d.IExtensionGalleryService),ae(3,g.ILogService)],p),i.ExtensionsDownloader=p}),define(J[110],Q([0,1,2,6,13,41]),function(x,i,T,R,P,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsManifestCache=void 0;class C extends T.Disposable{constructor(c,v){super();this.environmentService=c,this.extensionsManifestCache=(0,R.join)(this.environmentService.userDataPath,D.MANIFEST_CACHE_FOLDER,D.USER_MANIFEST_CACHE_FILE),this._register(v.onDidInstallExtensions(y=>this.onDidInstallExtensions(y))),this._register(v.onDidUninstallExtension(y=>this.onDidUnInstallExtension(y)))}onDidInstallExtensions(c){c.some(v=>!!v.local)&&this.invalidate()}onDidUnInstallExtension(c){c.error||this.invalidate()}invalidate(){P.Promises.rm(this.extensionsManifestCache,P.RimRafMode.MOVE).then(()=>{},()=>{})}}i.ExtensionsManifestCache=C}),define(J[111],Q([0,1,136,19,3,2,11,6,13,20,22,23,54,15]),function(x,i,T,R,P,D,C,w,c,v,y,I,d,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LocalizationsService=void 0;let u=class extends D.Disposable{constructor(p,S,f){super();this.extensionManagementService=p,this.logService=f,this.cache=this._register(new g(S,f)),this.extensionManagementService.registerParticipant({postInstall:async s=>this.postInstallExtension(s),postUninstall:async s=>this.postUninstallExtension(s)})}async getLanguageIds(){const p=await this.cache.getLanguagePacks(),S=["en",...Object.keys(p)];return(0,R.distinct)(S)}async postInstallExtension(p){p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",p.identifier.id),await this.update())}async postUninstallExtension(p){const S=await this.cache.getLanguagePacks();Object.keys(S).some(f=>S[f]&&S[f].extensions.some(s=>(0,I.areSameExtensions)(s.extensionIdentifier,p.identifier)))&&(this.logService.info("Removing language packs from the extension",p.identifier.id),await this.update())}async update(){const[p,S]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),f=await this.cache.update(S);return!(0,R.equals)(Object.keys(p),Object.keys(f))}};u=pe([ae(0,y.IExtensionManagementService),ae(1,v.INativeEnvironmentService),ae(2,E.ILogService)],u),i.LocalizationsService=u;let g=class extends D.Disposable{constructor(p,S){super();this.logService=S,this.languagePacks={},this.languagePacksFilePath=(0,w.join)(p.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new P.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(p){return this.withLanguagePacks(S=>{Object.keys(S).forEach(f=>delete S[f]),this.createLanguagePacksFromExtensions(S,...p)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(p,...S){for(const f of S)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(p,f);Object.keys(p).forEach(f=>this.updateHash(p[f]))}createLanguagePacksFromExtension(p,S){const f=S.identifier,s=S.manifest.contributes&&S.manifest.contributes.localizations?S.manifest.contributes.localizations:[];for(const a of s)if(S.location.scheme===C.Schemas.file&&(0,d.isValidLocalization)(a)){let n=p[a.languageId];n||(n={hash:"",extensions:[],translations:{}},p[a.languageId]=n);let o=n.extensions.filter(e=>(0,I.areSameExtensions)(e.extensionIdentifier,f))[0];o?o.version=S.manifest.version:n.extensions.push({extensionIdentifier:f,version:S.manifest.version});for(const e of a.translations)n.translations[e.id]=(0,w.join)(S.location.fsPath,e.path)}}updateHash(p){if(p){const S=(0,T.createHash)("md5");for(const f of p.extensions)S.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);p.hash=S.digest("hex")}}withLanguagePacks(p=()=>null){return this.languagePacksFileLimiter.queue(()=>{let S=null;return c.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch{return{}}}).then(f=>(S=p(f),f)).then(f=>{for(const a of Object.keys(f))f[a]||delete f[a];this.languagePacks=f,this.initializedCache=!0;const s=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",s),c.Promises.writeFile(this.languagePacksFilePath,s)}).then(()=>S,f=>this.logService.error(f))})}};g=pe([ae(0,v.INativeEnvironmentService),ae(1,E.ILogService)],g)}),define(J[43],Q([0,1,17,86,34,14,29]),function(x,i,T,R,P,D,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.updateProxyConfigurationsScope=i.asJson=i.asText=i.isSuccess=i.IRequestService=void 0,i.IRequestService=(0,D.createDecorator)("requestService");function w(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}i.isSuccess=w;function c(u){return u.res.statusCode===204}async function v(u){if(!w(u))throw new Error("Server returned "+u.res.statusCode);return c(u)?null:(await(0,T.streamToBuffer)(u.stream)).toString()}i.asText=v;async function y(u){if(!w(u))throw new Error("Server returned "+u.res.statusCode);if(c(u))return null;const h=(await(0,T.streamToBuffer)(u.stream)).toString();try{return JSON.parse(h)}catch(p){throw p.message+=`:
`+h,p}}i.asJson=y;function I(u){E(u)}i.updateProxyConfigurationsScope=I;let d;function E(u){const g=C.Registry.as(P.Extensions.Configuration),h=d;d={id:"http",order:15,title:(0,R.localize)(0,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(4,null),(0,R.localize)(5,null),(0,R.localize)(6,null),(0,R.localize)(7,null)],default:"override",description:(0,R.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(9,null),restricted:!0}}},g.updateConfigurations({add:[d],remove:h?[h]:[]})}E(2)}),define(J[112],Q([0,1,24,11,16,43]),function(x,i,T,R,P,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DownloadService=void 0;let C=class{constructor(c,v){this.requestService=c,this.fileService=v}async download(c,v,y=T.CancellationToken.None){if(c.scheme===R.Schemas.file||c.scheme===R.Schemas.vscodeRemote){await this.fileService.copy(c,v);return}const I={type:"GET",url:c.toString()},d=await this.requestService.request(I,y);if(d.res.statusCode===200)await this.fileService.writeFile(v,d.stream);else{const E=await(0,D.asText)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${E}`)}}};C=pe([ae(0,D.IRequestService),ae(1,P.IFileService)],C),i.DownloadService=C}),define(J[113],Q([0,1,114,8]),function(x,i,T,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getProxyAgent=void 0;function P(C,w){return C.protocol==="http:"?w.HTTP_PROXY||w.http_proxy||null:C.protocol==="https:"&&(w.HTTPS_PROXY||w.https_proxy||w.HTTP_PROXY||w.http_proxy)||null}async function D(C,w,c={}){const v=(0,T.parse)(C),y=c.proxyUrl||P(v,w);if(!y)return null;const I=(0,T.parse)(y);if(!/^https?:$/.test(I.protocol||""))return null;const d={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:(0,R.isBoolean)(c.strictSSL)?c.strictSSL:!0};return v.protocol==="http:"?new(await new Promise((E,u)=>{x(["http-proxy-agent"],E,u)}))(d):new(await new Promise((E,u)=>{x(["https-proxy-agent"],E,u)}))(d)}i.getProxyAgent=D}),define(J[115],Q([0,1,17,31]),function(x,i,T,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getServiceMachineId=void 0;async function P(D,C,w){let c=w&&w.get("storage.serviceMachineId",0)||null;if(c)return c;try{const y=(await C.readFile(D.serviceMachineIdResource)).value.toString();c=(0,R.isUUID)(y)?y:null}catch{c=null}if(!c){c=(0,R.generateUuid)();try{await C.writeFile(D.serviceMachineIdResource,T.VSBuffer.fromString(c))}catch{}}return w&&w.store("storage.serviceMachineId",c,0,1),c}i.getServiceMachineId=P}),define(J[116],Q([0,1,3,10,2,101,8,66,14]),function(x,i,T,R,P,D,C,w,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.logStorage=i.InMemoryStorageService=i.AbstractStorageService=i.StorageTarget=i.StorageScope=i.WillSaveStateReason=i.IStorageService=i.IS_NEW_KEY=void 0,i.IS_NEW_KEY="__$__isNewStorageMarker";const v="__$__targetStorageMarker";i.IStorageService=(0,c.createDecorator)("storageService");var y;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(y=i.WillSaveStateReason||(i.WillSaveStateReason={}));var I;(function(h){h[h.GLOBAL=0]="GLOBAL",h[h.WORKSPACE=1]="WORKSPACE"})(I=i.StorageScope||(i.StorageScope={}));var d;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(d=i.StorageTarget||(i.StorageTarget={}));class E extends P.Disposable{constructor(p={flushInterval:E.DEFAULT_FLUSH_INTERVAL}){super();this.options=p,this._onDidChangeValue=this._register(new R.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new R.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new R.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new T.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new P.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,T.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,P.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,D.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(p,S){S===v?(p===0?this._globalKeyTargets=void 0:p===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:p})):this._onDidChangeValue.fire({scope:p,key:S,target:this.getKeyTargets(p)[S]})}emitWillSaveState(p){this._onWillSaveState.fire({reason:p})}get(p,S,f){return this.getStorage(S)?.get(p,f)}getBoolean(p,S,f){return this.getStorage(S)?.getBoolean(p,f)}getNumber(p,S,f){return this.getStorage(S)?.getNumber(p,f)}store(p,S,f,s){if((0,C.isUndefinedOrNull)(S)){this.remove(p,f);return}this.withPausedEmitters(()=>{this.updateKeyTarget(p,f,s),this.getStorage(f)?.set(p,S)})}remove(p,S){this.withPausedEmitters(()=>{this.updateKeyTarget(p,S,void 0),this.getStorage(S)?.delete(p)})}withPausedEmitters(p){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{p()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(p,S){const f=[],s=this.getKeyTargets(p);for(const a of Object.keys(s))s[a]===S&&f.push(a);return f}updateKeyTarget(p,S,f){const s=this.getKeyTargets(S);typeof f=="number"?s[p]!==f&&(s[p]=f,this.getStorage(S)?.set(v,JSON.stringify(s))):typeof s[p]=="number"&&(delete s[p],this.getStorage(S)?.set(v,JSON.stringify(s)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(p){return p===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(p){const S=this.get(v,p);if(S)try{return JSON.parse(S)}catch{}return Object.create(null)}isNew(p){return this.getBoolean(i.IS_NEW_KEY,p)===!0}async flush(p=y.NONE){this._onWillSaveState.fire({reason:p});const S=this.getStorage(0),f=this.getStorage(1);switch(p){case y.NONE:await T.Promises.settled([S?.whenFlushed()??Promise.resolve(),f?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await T.Promises.settled([S?.flush(0)??Promise.resolve(),f?.flush(0)??Promise.resolve()]);break}}async logStorage(){const p=this.getStorage(0)?.items??new Map,S=this.getStorage(1)?.items??new Map;return g(p,S,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}i.AbstractStorageService=E,E.DEFAULT_FLUSH_INTERVAL=60*1e3;class u extends E{constructor(){super();this.globalStorage=this._register(new w.Storage(new w.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new w.Storage(new w.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(p=>this.emitDidChangeValue(1,p))),this._register(this.globalStorage.onDidChangeStorage(p=>this.emitDidChangeValue(0,p)))}getStorage(p){return p===0?this.globalStorage:this.workspaceStorage}getLogDetails(p){return p===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(p){}}i.InMemoryStorageService=u;async function g(h,p,S,f){const s=l=>{try{return JSON.parse(l)}catch{return l}},a=new Map,n=new Map;h.forEach((l,m)=>{a.set(m,l),n.set(m,s(l))});const o=new Map,e=new Map;p.forEach((l,m)=>{o.set(m,l),e.set(m,s(l))}),console.group(`Storage: Global (path: ${S})`);let t=[];a.forEach((l,m)=>{t.push({key:m,value:l})}),console.table(t),console.groupEnd(),console.log(n),console.group(`Storage: Workspace (path: ${f})`);let r=[];o.forEach((l,m)=>{r.push({key:m,value:l})}),console.table(r),console.groupEnd(),console.log(e)}i.logStorage=g}),define(J[117],Q([0,1,12,28,9,31]),function(x,i,T,R,P,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.verifyMicrosoftInternalDomain=i.resolveCommonProperties=void 0;function C(v){if(T.platform===2&&/^penguin(\.|$)/i.test(v))return"chromebook"}async function w(v,y,I,d,E,u,g,h,p,S){const f=Object.create(null);f["common.machineId"]=g,f.sessionID=(0,D.generateUuid)()+Date.now(),f.commitHash=E,f.version=u,f["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,T.PlatformToString)(T.platform),f["common.nodePlatform"]=R.platform,f["common.nodeArch"]=d,f["common.product"]=S||"desktop";const s=c(h||[]);s&&(f["common.msftInternal"]=s);let a=0;const n=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),T.isLinuxSnap&&(f["common.snap"]="true");const o=C(I);o&&(f["common.platformDetail"]=o);try{const e=await v.readFile(P.URI.file(p));f["common.source"]=e.value.toString().slice(0,30)}catch{}return f}i.resolveCommonProperties=w;function c(v){const y=R.env.USERDNSDOMAIN;if(!y)return!1;const I=y.toLowerCase();return v.some(d=>I===d)}i.verifyMicrosoftInternalDomain=c}),define(J[30],Q([0,1,14]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryConfiguration=i.TelemetryLevel=i.TELEMETRY_OLD_SETTING_ID=i.TELEMETRY_SETTING_ID=i.TELEMETRY_SECTION_ID=i.machineIdKey=i.lastSessionDateStorageKey=i.firstSessionDateStorageKey=i.currentSessionDateStorageKey=i.ICustomEndpointTelemetryService=i.ITelemetryService=void 0,i.ITelemetryService=(0,T.createDecorator)("telemetryService"),i.ICustomEndpointTelemetryService=(0,T.createDecorator)("customEndpointTelemetryService"),i.currentSessionDateStorageKey="telemetry.currentSessionDate",i.firstSessionDateStorageKey="telemetry.firstSessionDate",i.lastSessionDateStorageKey="telemetry.lastSessionDate",i.machineIdKey="telemetry.machineId",i.TELEMETRY_SECTION_ID="telemetry",i.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",i.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var R;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(R=i.TelemetryLevel||(i.TelemetryLevel={}));var P;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(P=i.TelemetryConfiguration||(i.TelemetryConfiguration={}))}),define(J[118],Q([0,1,19,3,24,7,10,2,12,8,9,76,22,23,15,32,30]),function(x,i,T,R,P,D,C,w,c,v,y,I,d,E,u,g,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractExtensionTask=i.reportTelemetry=i.joinErrors=i.AbstractExtensionManagementService=void 0;let p=class extends w.Disposable{constructor(o,e,t,r){super();this.galleryService=o,this.telemetryService=e,this.logService=t,this.productService=r,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new C.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new C.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new C.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new C.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,w.toDisposable)(()=>{this.installingExtensions.forEach(l=>l.cancel()),this.uninstallingExtensions.forEach(l=>l.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(o){const e=await this.getTargetPlatform();return o.allTargetPlatforms.some(t=>(0,d.isTargetPlatformCompatible)(t,o.allTargetPlatforms,e))}async installFromGallery(o,e={}){try{if(!this.galleryService.isEnabled())throw new d.ExtensionManagementError(I.localize(0,null),d.ExtensionManagementErrorCode.Internal);const t=await this.checkAndGetCompatibleVersion(o,!e.installGivenVersion,!!e.installPreReleaseVersion);return await this.installExtension(t.manifest,t.extension,e)}catch(t){throw s(this.telemetryService,"extensionGallery:install",(0,E.getGalleryExtensionTelemetryData)(o),void 0,t),this.logService.error("Failed to install extension.",o.identifier.id),this.logService.error(t),f(t)}}async migrateUnsupportedExtensions(){try{const o=await this.getExtensionsControlManifest();if(!o.unsupportedPreReleaseExtensions)return;const e=await this.getInstalled(1);for(const[t,r]of Object.entries(o.unsupportedPreReleaseExtensions)){const l=e.find(b=>(0,E.areSameExtensions)(b.identifier,{id:t}));if(!l)continue;const m=await this.galleryService.getCompatibleExtension({id:r.id},!0,await this.getTargetPlatform());if(!m){this.logService.info(`Skipping migrating '${l.identifier.id}' extension because, the comaptible target '${r.id}' extension is not found`);continue}const L=await this.galleryService.getManifest(m,P.CancellationToken.None);if(!L){this.logService.info(`Skipping migrating '${l.identifier.id}' extension because, the manifest for '${r.id}' extension is not found`);continue}try{this.logService.info(`Migrating '${l.identifier.id}' extension to '${r.id}' extension...`),await Promise.allSettled([this.uninstall(l),this.installExtension(L,m,{installPreReleaseVersion:!0,isMachineScoped:l.isMachineScoped,operation:4})]),this.logService.info(`Migrated '${l.identifier.id}' extension to '${r.id}' extension.`)}catch(b){this.logService.error(b)}}}catch(o){this.logService.error(o)}}async uninstall(o,e={}){return this.logService.trace("ExtensionManagementService#uninstall",o.identifier.id),this.unininstallExtension(o,e)}async reinstallFromGallery(o){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",o.identifier.id),!this.galleryService.isEnabled())throw new Error(I.localize(1,null));const e=await this.findGalleryExtension(o);if(!e)throw new Error(I.localize(2,null));await this.createUninstallExtensionTask(o,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(e)}getExtensionsControlManifest(){const o=new Date().getTime();return(!this.extensionsControlManifest||o-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=o),this.extensionsControlManifest}registerParticipant(o){this.participants.push(o)}async installExtension(o,e,t){if(!y.URI.isUri(e)){let b=this.installingExtensions.get(new E.ExtensionIdentifierWithVersion(e.identifier,e.version).key());if(b)return this.logService.info("Extensions is already requested to install",e.identifier.id),b.waitUntilTaskIsFinished();t={...t,installOnlyNewlyAddedFromExtensionPack:!0}}const r=[],l=[],m=this.createInstallExtensionTask(o,e,t);y.URI.isUri(e)||this.installingExtensions.set(new E.ExtensionIdentifierWithVersion(m.identifier,o.version).key(),m),this._onInstallExtension.fire({identifier:m.identifier,source:e}),this.logService.info("Installing extension:",m.identifier.id),r.push({task:m,manifest:o});let L=!1;try{if(t.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",m.identifier.id);else try{const O=await this.getAllDepsAndPackExtensionsToInstall(m.identifier,o,!!t.installOnlyNewlyAddedFromExtensionPack,!!t.installPreReleaseVersion);for(const{gallery:N,manifest:G}of O)if(L=L||!!G.extensionDependencies?.some(ee=>(0,E.areSameExtensions)({id:ee},m.identifier)),this.installingExtensions.has(new E.ExtensionIdentifierWithVersion(N.identifier,N.version).key()))this.logService.info("Extension is already requested to install",N.identifier.id);else{const ee=this.createInstallExtensionTask(G,N,{...t,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new E.ExtensionIdentifierWithVersion(ee.identifier,G.version).key(),ee),this._onInstallExtension.fire({identifier:ee.identifier,source:N}),this.logService.info("Installing extension:",ee.identifier.id),r.push({task:ee,manifest:G})}}catch(O){if(y.URI.isUri(m.source))(0,T.isNonEmptyArray)(o.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",m.identifier.id,O.message),(0,T.isNonEmptyArray)(o.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",m.identifier.id,O.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",m.identifier.id),O}const b=r.reduce((O,{task:N,manifest:G})=>(O.set(N.identifier.id.toLowerCase(),{task:N,manifest:G}),O),new Map);for(;b.size;){let O;const N=[...b.values()].filter(({manifest:G})=>!G.extensionDependencies?.some(ee=>b.has(ee.toLowerCase())));N.length?O=b.size===1?N:N.filter(({task:G})=>!(G===m&&!L)):(this.logService.info("Found extensions with circular dependencies",N.map(({task:G})=>G.identifier.id)),O=[...b.values()]),await this.joinAllSettled(O.map(async({task:G})=>{const ee=new Date().getTime(),ge=(0,v.isUndefined)(t.operation)?G.operation:t.operation;try{const ce=await G.run();if(await this.joinAllSettled(this.participants.map(te=>te.postInstall(ce,G.source,t,P.CancellationToken.None))),!y.URI.isUri(G.source)&&(s(this.telemetryService,ge===3?"extensionGallery:update":"extensionGallery:install",(0,E.getGalleryExtensionTelemetryData)(G.source),new Date().getTime()-ee,void 0),c.isWeb&&ge!==3))try{await this.galleryService.reportStatistic(ce.manifest.publisher,ce.manifest.name,ce.manifest.version,"install")}catch{}l.push({local:ce,identifier:G.identifier,operation:ge,source:G.source})}catch(ce){throw y.URI.isUri(G.source)||s(this.telemetryService,ge===3?"extensionGallery:update":"extensionGallery:install",(0,E.getGalleryExtensionTelemetryData)(G.source),new Date().getTime()-ee,ce),this.logService.error("Error while installing the extension:",G.identifier.id),ce}finally{b.delete(G.identifier.id.toLowerCase())}}))}return l.forEach(({identifier:O})=>this.logService.info("Extension installed successfully:",O.id)),this._onDidInstallExtensions.fire(l),l.filter(({identifier:O})=>(0,E.areSameExtensions)(O,m.identifier))[0].local}catch(b){if(r.forEach(({task:O})=>O.cancel()),l.length)try{const O=await Promise.allSettled(l.map(({local:N})=>this.createUninstallExtensionTask(N,{versionOnly:!0}).run()));for(let N=0;N<O.length;N++){const G=O[N],{identifier:ee}=l[N];G.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",ee.id):this.logService.warn("Rollback: Error while uninstalling extension",ee.id,(0,D.getErrorMessage)(G.reason))}}catch(O){this.logService.warn("Error while rolling back extensions",(0,D.getErrorMessage)(O),l.map(({identifier:N})=>N.id))}throw this._onDidInstallExtensions.fire(r.map(({task:O})=>({identifier:O.identifier,operation:2,source:O.source}))),b}finally{for(const{task:b,manifest:O}of r)if(!y.URI.isUri(b.source)){const N=new E.ExtensionIdentifierWithVersion(b.identifier,O.version).key();this.installingExtensions.delete(N)||this.logService.warn("Installation task is not found in the cache",N)}}}async joinAllSettled(o){const e=[],t=[],r=await Promise.allSettled(o);for(const l of r)l.status==="fulfilled"?e.push(l.value):t.push(l.reason);if(t.length)throw S(t);return e}async getAllDepsAndPackExtensionsToInstall(o,e,t,r){if(!this.galleryService.isEnabled())return[];let l=await this.getInstalled();const m=[o,...l.map(O=>O.identifier)],L=[],b=async(O,N)=>{const G=N.extensionDependencies||[],ee=[...G];if(N.extensionPack){const ge=t?l.find(ce=>(0,E.areSameExtensions)(ce.identifier,O)):void 0;for(const ce of N.extensionPack)ge&&ge.manifest.extensionPack&&ge.manifest.extensionPack.some(te=>(0,E.areSameExtensions)({id:te},{id:ce}))||ee.every(te=>!(0,E.areSameExtensions)({id:te},{id:ce}))&&ee.push(ce)}if(ee.length){const ge=[...m,...L.map(te=>te.gallery.identifier)],ce=ee.filter(te=>ge.every(he=>!(0,E.areSameExtensions)(he,{id:te})));if(ce.length){const te=await this.galleryService.query({names:ce,pageSize:ee.length},P.CancellationToken.None);for(const he of te.firstPage){if(ge.find(ne=>(0,E.areSameExtensions)(ne,he.identifier)))continue;const W=G.some(ne=>(0,E.areSameExtensions)({id:ne},he.identifier));let B;try{B=await this.checkAndGetCompatibleVersion(he,!0,r)}catch(ne){if(ne instanceof d.ExtensionManagementError&&ne.code===d.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!W){this.logService.info("Skipping the packed extension as it cannot be installed",he.identifier.id);continue}else throw ne}L.push({gallery:B.extension,manifest:B.manifest}),await b(B.extension.identifier,N)}}}};return await b(o,e),l=await this.getInstalled(),L.filter(O=>!l.some(N=>(0,E.areSameExtensions)(N.identifier,O.gallery.identifier)))}async checkAndGetCompatibleVersion(o,e,t){const r=await this.getExtensionsControlManifest();if((0,E.getMaliciousExtensionsSet)(r).has(o.identifier.id))throw new d.ExtensionManagementError(I.localize(3,null,o.identifier.id),d.ExtensionManagementErrorCode.Malicious);if(!!r.unsupportedPreReleaseExtensions&&!!r.unsupportedPreReleaseExtensions[o.identifier.id])throw new d.ExtensionManagementError(I.localize(4,null,o.identifier.id,r.unsupportedPreReleaseExtensions[o.identifier.id].displayName),d.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(o)){const L=await this.getTargetPlatform();throw new d.ExtensionManagementError(I.localize(5,null,o.identifier.id,this.productService.nameLong,(0,d.TargetPlatformToString)(L)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const l=await this.getCompatibleVersion(o,e,t);if(l){if(t&&o.hasPreReleaseVersion&&!l.properties.isPreReleaseVersion)throw new d.ExtensionManagementError(I.localize(6,null,o.identifier.id,this.productService.nameLong,this.productService.version),d.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw new d.ExtensionManagementError(I.localize(7,null,o.identifier.id,this.productService.nameLong,this.productService.version),d.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",l.identifier.id);const m=await this.galleryService.getManifest(l,P.CancellationToken.None);if(m===null)throw new d.ExtensionManagementError(`Missing manifest for extension ${o.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(m.version!==l.version)throw new d.ExtensionManagementError(`Cannot install '${o.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:l,manifest:m}}async getCompatibleVersion(o,e,t){const r=await this.getTargetPlatform();let l=null;return e&&o.hasPreReleaseVersion&&o.properties.isPreReleaseVersion!==t&&(l=await this.galleryService.getCompatibleExtension(o.identifier,t,r)),!l&&await this.galleryService.isExtensionCompatible(o,t,r)&&(l=o),!l&&e&&(l=await this.galleryService.getCompatibleExtension(o,t,r)),l}async unininstallExtension(o,e){const t=this.uninstallingExtensions.get(o.identifier.id.toLowerCase());if(t)return this.logService.info("Extensions is already requested to uninstall",o.identifier.id),t.waitUntilTaskIsFinished();const r=(b,O)=>{const N=this.createUninstallExtensionTask(b,O);return this.uninstallingExtensions.set(N.extension.identifier.id.toLowerCase(),N),this.logService.info("Uninstalling extension:",b.identifier.id),this._onUninstallExtension.fire(b.identifier),N},l=(b,O)=>{O?this.logService.error("Failed to uninstall extension:",b.identifier.id,O.message):this.logService.info("Successfully uninstalled extension:",b.identifier.id),s(this.telemetryService,"extensionGallery:uninstall",(0,E.getLocalExtensionTelemetryData)(b),void 0,O),this._onDidUninstallExtension.fire({identifier:b.identifier,error:O?.code})},m=[],L=[];try{m.push(r(o,{}));const b=await this.getInstalled(1);if(e.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",o.identifier.id);else{const O=this.getAllPackExtensionsToUninstall(o,b);for(const N of O)this.uninstallingExtensions.has(N.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",N.identifier.id):m.push(r(N,{}))}e.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",o.identifier.id):this.checkForDependents(m.map(O=>O.extension),b,o),await this.joinAllSettled(m.map(async O=>{try{if(await O.run(),await this.joinAllSettled(this.participants.map(N=>N.postUninstall(O.extension,e,P.CancellationToken.None))),O.extension.identifier.uuid)try{await this.galleryService.reportStatistic(O.extension.manifest.publisher,O.extension.manifest.name,O.extension.manifest.version,"uninstall")}catch{}l(O.extension)}catch(N){const G=N instanceof d.ExtensionManagementError?N:new d.ExtensionManagementError((0,D.getErrorMessage)(N),d.ExtensionManagementErrorCode.Internal);throw l(O.extension,G),G}finally{L.push(O)}}))}catch(b){const O=b instanceof d.ExtensionManagementError?b:new d.ExtensionManagementError((0,D.getErrorMessage)(b),d.ExtensionManagementErrorCode.Internal);for(const N of m){try{N.cancel()}catch{}L.includes(N)||l(N.extension,O)}throw O}finally{for(const b of m)this.uninstallingExtensions.delete(b.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",b.extension.identifier.id)}}checkForDependents(o,e,t){for(const r of o){const l=this.getDependents(r,e);if(l.length){const m=l.filter(L=>!o.some(b=>(0,E.areSameExtensions)(b.identifier,L.identifier)));if(m.length)throw new Error(this.getDependentsErrorMessage(r,m,t))}}}getDependentsErrorMessage(o,e,t){return t===o?e.length===1?I.localize(8,null,t.manifest.displayName||t.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?I.localize(9,null,t.manifest.displayName||t.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):I.localize(10,null,t.manifest.displayName||t.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):e.length===1?I.localize(11,null,t.manifest.displayName||t.manifest.name,o.manifest.displayName||o.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?I.localize(12,null,t.manifest.displayName||t.manifest.name,o.manifest.displayName||o.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):I.localize(13,null,t.manifest.displayName||t.manifest.name,o.manifest.displayName||o.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name)}getAllPackExtensionsToUninstall(o,e,t=[]){if(t.indexOf(o)!==-1)return[];t.push(o);const r=o.manifest.extensionPack?o.manifest.extensionPack:[];if(r.length){const l=e.filter(L=>!L.isBuiltin&&r.some(b=>(0,E.areSameExtensions)({id:b},L.identifier))),m=[];for(const L of l)m.push(...this.getAllPackExtensionsToUninstall(L,e,t));return[...l,...m]}return[]}getDependents(o,e){return e.filter(t=>t.manifest.extensionDependencies&&t.manifest.extensionDependencies.some(r=>(0,E.areSameExtensions)({id:r},o.identifier)))}async findGalleryExtension(o){if(o.identifier.uuid){const e=await this.findGalleryExtensionById(o.identifier.uuid);return e||this.findGalleryExtensionByName(o.identifier.id)}return this.findGalleryExtensionByName(o.identifier.id)}async findGalleryExtensionById(o){return(await this.galleryService.query({ids:[o],pageSize:1},P.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(o){return(await this.galleryService.query({names:[o],pageSize:1},P.CancellationToken.None)).firstPage[0]}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const o=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",o),o}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};p=pe([ae(0,d.IExtensionGalleryService),ae(1,h.ITelemetryService),ae(2,u.ILogService),ae(3,g.IProductService)],p),i.AbstractExtensionManagementService=p;function S(n){const o=Array.isArray(n)?n:[n];return o.length===1?o[0]instanceof Error?o[0]:new Error(o[0]):o.reduce((e,t)=>new Error(`${e.message}${e.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}i.joinErrors=S;function f(n){if(n instanceof d.ExtensionManagementError)return n;const o=new d.ExtensionManagementError(n.message,d.ExtensionManagementErrorCode.Internal);return o.stack=n.stack,o}function s(n,o,e,t,r){const l=r?r instanceof d.ExtensionManagementError?r.code:d.ExtensionManagementErrorCode.Internal:void 0;n.publicLogError(o,{...e,success:!r,duration:t,errorcode:l})}i.reportTelemetry=s;class a{constructor(){this.barrier=new R.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,R.createCancelablePromise)(o=>this.doRun(o))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,R.createCancelablePromise)(o=>new Promise((e,t)=>{const r=o.onCancellationRequested(()=>{r.dispose(),t((0,D.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}i.AbstractExtensionTask=a}),define(J[35],Q([0,1,21,8,25,30]),function(x,i,T,R,P,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.cleanRemoteAuthority=i.validateTelemetryData=i.getTelemetryLevel=i.supportsTelemetry=i.configurationTelemetry=i.NullAppender=i.NullEndpointTelemetryService=i.NullTelemetryService=i.NullTelemetryServiceShape=void 0;class C{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(p,S){return Promise.resolve(void 0)}publicLog2(p,S){return this.publicLog(p,S)}publicLogError(p,S){return Promise.resolve(void 0)}publicLogError2(p,S){return this.publicLogError(p,S)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}i.NullTelemetryServiceShape=C,i.NullTelemetryService=new C;class w{async publicLog(p,S,f){}async publicLogError(p,S,f){}}i.NullEndpointTelemetryService=w,i.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function c(h,p){return p.onDidChangeConfiguration(S=>{S.source!==6&&h.publicLog2("updateConfiguration",{configurationSource:(0,P.ConfigurationTargetToString)(S.source),configurationKeys:u(S.sourceConfig)})})}i.configurationTelemetry=c;function v(h,p){return!(p.disableTelemetry||!h.enableTelemetry)}i.supportsTelemetry=v;function y(h){const p=h.getValue(D.TELEMETRY_SETTING_ID),S=h.getValue("telemetry.enableCrashReporter");if(h.getValue(D.TELEMETRY_OLD_SETTING_ID)===!1||S===!1)return 0;switch(p??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}i.getTelemetryLevel=y;function I(h){const p=Object.create(null),S=Object.create(null),f=Object.create(null);E(h,f);for(let s in f){s=s.length>150?s.substr(s.length-149):s;const a=f[s];typeof a=="number"?S[s]=a:typeof a=="boolean"?S[s]=a?1:0:typeof a=="string"?(a.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${a.length}`),p[s]=a.substring(0,8191)):typeof a!="undefined"&&a!==null&&(p[s]=a)}return{properties:p,measurements:S}}i.validateTelemetryData=I;function d(h){if(!h)return"none";let p="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(f=>{h.indexOf(`${f}+`)===0&&(p=f)}),p}i.cleanRemoteAuthority=d;function E(h,p,S=0,f){if(!!h)for(let s of Object.getOwnPropertyNames(h)){const a=h[s],n=f?f+s:s;Array.isArray(a)?p[n]=(0,T.safeStringify)(a):a instanceof Date?p[n]=a.toISOString():(0,R.isObject)(a)?S<2?E(a,p,S+1,n+"."):p[n]=(0,T.safeStringify)(a):p[n]=a}}function u(h){if(!h)return[];const p=[];return g(p,"",h),p}function g(h,p,S){S&&typeof S=="object"&&!Array.isArray(S)?Object.keys(S).forEach(f=>g(h,p?`${p}.${f}`:f,S[f])):h.push(p)}}),define(J[119],Q([0,1,19,24,7,21,12,28,8,9,25,20,22,23,50,16,15,32,43,115,116,30,35]),function(x,i,T,R,P,D,C,w,c,v,y,I,d,E,u,g,h,p,S,f,s,a,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.resolveMarketplaceHeaders=i.ExtensionGalleryServiceWithNoStorageService=i.ExtensionGalleryService=i.sortExtensionVersions=void 0;const o=C.isWeb?"web":(0,d.getTargetPlatform)(C.platform,w.arch);var e;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished"})(e||(e={}));function t(...U){return String(U.reduce((A,$)=>A|$,0))}var r;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const l={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},m={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},b={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:e.None,criteria:[],assetTypes:[]};class O{constructor(A=b){this.state=A}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(A,$=this.state.pageSize){return new O({...this.state,pageNumber:A,pageSize:$})}withFilter(A,...$){const z=[...this.state.criteria,...$.length?$.map(X=>({filterType:A,value:X})):[{filterType:A}]];return new O({...this.state,criteria:z})}withSortBy(A){return new O({...this.state,sortBy:A})}withSortOrder(A){return new O({...this.state,sortOrder:A})}withFlags(...A){return new O({...this.state,flags:A.reduce(($,z)=>$|z,0)})}withAssetTypes(...A){return new O({...this.state,assetTypes:A})}get raw(){const{criteria:A,pageNumber:$,pageSize:z,sortBy:X,sortOrder:Y,flags:de,assetTypes:se}=this.state;return{filters:[{criteria:A,pageNumber:$,pageSize:z,sortBy:X,sortOrder:Y}],assetTypes:se,flags:de}}get searchText(){const A=this.state.criteria.filter($=>$.filterType===r.SearchText)[0];return A&&A.value?A.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(A=>String(A.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function N(U,A){const $=(U||[]).filter(z=>z.statisticName===A)[0];return $?$.value:0}function G(U){const A="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(z=>z.assetType.indexOf(A)===0).reduce((z,X)=>{const Y=te(U,X.assetType);return Y&&z.push([X.assetType.substring(A.length),Y]),z},[])}function ee(U){if(U.properties){const A=U.properties.filter(X=>X.key===l.Repository),$=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),z=A.filter(X=>$.test(X.value))[0];return z?{uri:z.value,fallbackUri:z.value}:null}return te(U,l.Repository)}function ge(U){return{uri:`${U.fallbackAssetUri}/${l.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${l.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function ce(U){const A=te(U,l.Icon);if(A)return A;const $=d.DefaultIconPath;return{uri:$,fallbackUri:$}}function te(U,A){return U.files.filter(z=>z.assetType===A)[0]?{uri:`${U.assetUri}/${A}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${A}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}:null}function he(U,A){const $=U.properties?U.properties.filter(X=>X.key===A):[],z=$.length>0&&$[0].value;return z?z.split(",").map(X=>(0,E.adoptToGalleryExtensionId)(X)):[]}function W(U){const A=U.properties?U.properties.filter($=>$.key===m.Engine):[];return A.length>0&&A[0].value||""}function B(U){const A=U.properties?U.properties.filter($=>$.key===m.PreRelease):[];return A.length>0&&A[0].value==="true"}function ne(U){const A=U.properties?U.properties.filter(z=>z.key===m.LocalizedLanguages):[],$=A.length>0&&A[0].value||"";return $?$.split(","):[]}function M(U){return U.indexOf("preview")!==-1}function k(U){return U.targetPlatform?(0,d.toTargetPlatform)(U.targetPlatform):"undefined"}function j(U){const A=(0,T.distinct)(U.versions.map(k)),$=!!U.tags?.includes(d.WEB_EXTENSION_TAG),z=A.indexOf("web");return $?z===-1&&A.push("web"):z!==-1&&A.splice(z,1),A}function H(U,A){const $=(0,d.getFallbackTargetPlarforms)(A);for(let z=0;z<U.length;z++){const X=U[z];if(X.version===U[z-1]?.version){let Y=z;const de=k(X);if(de===A)for(;Y>0&&U[Y-1].version===X.version;)Y--;else if($.includes(de))for(;Y>0&&U[Y-1].version===X.version&&k(U[Y-1])!==A;)Y--;Y!==z&&(U.splice(z,1),U.splice(Y,0,X))}}return U}i.sortExtensionVersions=H;function ie(U,A,$,z,X){const Y=U.versions[0],de={manifest:te(A,l.Manifest),readme:te(A,l.Details),changelog:te(A,l.Changelog),license:te(A,l.License),repository:ee(A),download:ge(A),icon:ce(A),coreTranslations:G(A)};return{identifier:{id:(0,E.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:A.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,description:U.shortDescription||"",installCount:N(U.statistics,"install"),rating:N(U.statistics,"averagerating"),ratingCount:N(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:$,assets:de,properties:{dependencies:he(A,m.Dependency),extensionPack:he(A,m.ExtensionPack),engine:W(A),localizedLanguages:ne(A),targetPlatform:k(A),isPreReleaseVersion:B(A)},hasPreReleaseVersion:B(Y),hasReleaseVersion:z,preview:M(U.flags),telemetryData:X}}let K=class{constructor(A,$,z,X,Y,de,se,re){this.requestService=$,this.logService=z,this.environmentService=X,this.telemetryService=Y,this.fileService=de,this.productService=se,this.configurationService=re;const oe=se.extensionsGallery;this.extensionsGalleryUrl=oe&&oe.serviceUrl,this.extensionsControlUrl=oe&&oe.controlUrl,this.commonHeadersPromise=ue(se.version,se,this.environmentService,this.configurationService,this.fileService,A)}api(A=""){return`${this.extensionsGalleryUrl}${A}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(A,$,z){const X=(0,c.isBoolean)($)?$:!1,Y=(0,c.isBoolean)($)?z:$;let de=new O().withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,A.length).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExtensionName,...A.map(({id:oe})=>oe.toLowerCase()));A.every(oe=>!oe.version)&&(de=de.withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties,e.IncludeLatestVersionOnly));const{galleryExtensions:se}=await this.queryGallery(de,o,R.CancellationToken.None),re=se.map(oe=>{const ye=(0,E.getGalleryExtensionId)(oe.publisher.publisherName,oe.extensionName);return{rawGalleryExtension:oe,version:A.find(le=>(0,E.areSameExtensions)(le,{id:ye}))?.version,preRelease:X}});return this.converToGalleryExtensions(re,o,()=>{},Y)}async getExtensions2(A){const $=[],z=[];for(const se of A)se.uuid?z.push(se.uuid):$.push(se.id.toLowerCase());let X=new O().withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties,e.IncludeLatestVersionOnly).withPage(1,A.length).withFilter(r.Target,"Microsoft.VisualStudio.Code");z.length&&(X=X.withFilter(r.ExtensionId,...z)),$.length&&(X=X.withFilter(r.ExtensionId,...$));const{galleryExtensions:Y}=await this.queryGallery(X,o,R.CancellationToken.None),de=Y.map(se=>{const re=(0,E.getGalleryExtensionId)(se.publisher.publisherName,se.extensionName),oe=A.find(ye=>(0,E.areSameExtensions)(ye,{id:re,uuid:se.extensionId}));return{rawGalleryExtension:se,preRelease:!!oe?.preRelease}});return this.converToGalleryExtensions(de,o,()=>{},R.CancellationToken.None)}async getCompatibleExtension(A,$,z){const X=(0,d.isIExtensionIdentifier)(A)?null:A;if(X){if((0,d.isNotWebExtensionInWebTargetPlatform)(X.allTargetPlatforms,z))return null;if(await this.isExtensionCompatible(X,$,z))return X}const{id:Y,uuid:de}=X?X.identifier:A;let se=new O().withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");de?se=se.withFilter(r.ExtensionId,de):se=se.withFilter(r.ExtensionName,Y);const{galleryExtensions:re}=await this.queryGallery(se,z,R.CancellationToken.None),[oe]=re;if(!oe||!oe.versions.length)return null;const ye=j(oe);if((0,d.isNotWebExtensionInWebTargetPlatform)(ye,z))return null;for(let le of oe.versions){if(!W(le)){const Ee=await this.getEngine(le);le={...le,properties:[...le.properties||[],{key:m.Engine,value:Ee}]}}if(await this.isRawExtensionVersionCompatible(le,$,ye,z)){const Ee=oe.versions.some(Se=>!B(Se));return ie(oe,le,ye,Ee)}}return null}async isExtensionCompatible(A,$,z){if(!(0,d.isTargetPlatformCompatible)(A.properties.targetPlatform,A.allTargetPlatforms,z)||!$&&A.properties.isPreReleaseVersion)return!1;let X=A.properties.engine;if(!X){const Y=await this.getManifest(A,R.CancellationToken.None);if(!Y)throw new Error("Manifest was not found");X=Y.engines.vscode}return(0,u.isEngineValid)(X,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(A,$,z,X){if(!(0,d.isTargetPlatformCompatible)(k(A),z,X)||!$&&B(A))return!1;const Y=await this.getEngine(A);return(0,u.isEngineValid)(Y,this.productService.version,this.productService.date)}async query(A,$){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let z=A.text||"";const X=(0,D.getOrDefault)(A,le=>le.pageSize,50);let Y=new O().withFlags(e.IncludeLatestVersionOnly,e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,X).withFilter(r.Target,"Microsoft.VisualStudio.Code");z?(z=z.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,Ee,Se)=>(Y=Y.withFilter(r.Category,Se||Ee),"")),z=z.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,Ee,Se)=>(Y=Y.withFilter(r.Tag,Se||Ee),"")),z=z.replace(/\bfeatured(\s+|\b|$)/g,()=>(Y=Y.withFilter(r.Featured),"")),z=z.trim(),z&&(z=z.length<200?z:z.substring(0,200),Y=Y.withFilter(r.SearchText,z)),Y=Y.withSortBy(0)):A.ids?Y=Y.withFilter(r.ExtensionId,...A.ids):A.names?Y=Y.withFilter(r.ExtensionName,...A.names):Y=Y.withSortBy(4),typeof A.sortBy=="number"&&(Y=Y.withSortBy(A.sortBy)),typeof A.sortOrder=="number"&&(Y=Y.withSortOrder(A.sortOrder));const{galleryExtensions:de,total:se}=await this.queryGallery(Y,o,$),re=le=>({index:(Y.pageNumber-1)*Y.pageSize+le,querySource:A.source}),oe=await this.converToGalleryExtensions(de.map(le=>({rawGalleryExtension:le,preRelease:!!A.includePreRelease})),o,re,$),ye=async(le,Ee)=>{if(Ee.isCancellationRequested)throw(0,P.canceled)();const Se=Y.withPage(le+1),{galleryExtensions:Oe}=await this.queryGallery(Se,o,Ee);return await this.converToGalleryExtensions(Oe.map(Fe=>({rawGalleryExtension:Fe,preRelease:!!A.includePreRelease})),o,re,$)};return{firstPage:oe,total:se,pageSize:Y.pageSize,getPage:ye}}async converToGalleryExtensions(A,$,z,X){const Y=(re,oe,ye,le)=>{const Ee=j(re);let Se=re.versions[0];return Se=re.versions.find(Oe=>Oe.version===Se.version&&(0,d.isTargetPlatformCompatible)(k(Oe),Ee,$))||Se,B(Se)&&!le&&(Se=re.versions.find(Oe=>Oe.version!==Se.version&&!B(Oe))||Se),ie(re,Se,Ee,ye,z(oe))},de=[],se=new Map;for(let re=0;re<A.length;re++){const{rawGalleryExtension:oe,version:ye,preRelease:le}=A[re],Ee=oe.versions.some(Se=>!B(Se));if(ye){const Se=oe.versions.find(Oe=>Oe.version===ye);Se&&de.push([re,ie(oe,Se,j(oe),Ee)])}else{const Se=Y(oe,re,Ee,le);Se.properties.isPreReleaseVersion?se.set(Se.identifier.uuid,{index:re,preRelease:le}):de.push([re,Se])}}if(se.size){const re=new Date().getTime(),oe=new O().withFlags(e.IncludeVersions,e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,se.size).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExtensionId,...se.keys()),{galleryExtensions:ye}=await this.queryGallery(oe,$,X);if(this.telemetryService.publicLog2("galleryService:preReleasesQuery",{duration:new Date().getTime()-re,count:se.size}),ye.length!==se.size)throw new Error("Not all extensions with latest versions are returned");for(const le of ye){const Ee=le.versions.some(ze=>!B(ze)),{index:Se,preRelease:Oe}=se.get(le.extensionId),Fe=Y(le,Se,Ee,Oe);de.push([Se,Fe])}}return de.sort((re,oe)=>re[0]-oe[0]).map(([,re])=>re)}async queryGallery(A,$,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");A=A.withFlags(A.flags,e.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,t(e.Unpublished));const X=await this.commonHeadersPromise,Y=JSON.stringify(A.raw),de={...X,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Y.length)},se=new Date().getTime();let re,oe,ye=0;try{if(re=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Y,headers:de},z),re.res.statusCode&&re.res.statusCode>=400&&re.res.statusCode<500)return{galleryExtensions:[],total:ye};const le=await(0,S.asJson)(re);if(le){const Ee=le.results[0],Se=Ee.extensions;Se.forEach(Fe=>H(Fe.versions,$));const Oe=Ee.resultMetadata&&Ee.resultMetadata.filter(Fe=>Fe.metadataType==="ResultCount")[0];return ye=Oe&&Oe.metadataItems.filter(Fe=>Fe.name==="TotalCount")[0].count||0,{galleryExtensions:Se,total:ye}}return{galleryExtensions:[],total:ye}}catch(le){throw oe=le,le}finally{this.telemetryService.publicLog2("galleryService:query",{...A.telemetryData,requestBodySize:String(Y.length),duration:new Date().getTime()-se,success:!!re&&(0,S.isSuccess)(re),responseBodySize:re?.res.headers["Content-Length"],statusCode:re?String(re.res.statusCode):void 0,errorCode:oe?(0,P.isPromiseCanceledError)(oe)?"canceled":(0,P.getErrorMessage)(oe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ye)})}}async reportStatistic(A,$,z,X){if(!this.isEnabled())return;const Y=C.isWeb?this.api(`/itemName/${A}.${$}/version/${z}/statType/${X==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${A}/extensions/${$}/${z}/stats?statType=${X}`),de=C.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",re={...await this.commonHeadersPromise,Accept:de};try{await this.requestService.request({type:"POST",url:Y,headers:re},R.CancellationToken.None)}catch{}}async download(A,$,z){this.logService.trace("ExtensionGalleryService#download",A.identifier.id);const X=(0,E.getGalleryExtensionTelemetryData)(A),Y=new Date().getTime(),de=ye=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...X,duration:ye}),se=z===2?"install":z===3?"update":"",re=se?{uri:`${A.assets.download.uri}${v.URI.parse(A.assets.download.uri).query?"&":"?"}${se}=true`,fallbackUri:`${A.assets.download.fallbackUri}${v.URI.parse(A.assets.download.fallbackUri).query?"&":"?"}${se}=true`}:A.assets.download,oe=await this.getAsset(re);await this.fileService.writeFile($,oe.stream),de(new Date().getTime()-Y)}async getReadme(A,$){if(A.assets.readme){const z=await this.getAsset(A.assets.readme,{},$);return await(0,S.asText)(z)||""}return""}async getManifest(A,$){if(A.assets.manifest){const z=await this.getAsset(A.assets.manifest,{},$),X=await(0,S.asText)(z);return X?JSON.parse(X):null}return null}async getManifestFromRawExtensionVersion(A,$){const z=te(A,l.Manifest);if(!z)throw new Error("Manifest was not found");const X={"Accept-Encoding":"gzip"},Y=await this.getAsset(z,{headers:X});return await(0,S.asJson)(Y)}async getCoreTranslation(A,$){const z=A.assets.coreTranslations.filter(X=>X[0]===$.toUpperCase())[0];if(z){const X=await this.getAsset(z[1]),Y=await(0,S.asText)(X);return Y?JSON.parse(Y):null}return null}async getChangelog(A,$){if(A.assets.changelog){const z=await this.getAsset(A.assets.changelog,{},$);return await(0,S.asText)(z)||""}return""}async getAllCompatibleVersions(A,$,z){let X=new O().withFlags(e.IncludeVersions,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");A.identifier.uuid?X=X.withFilter(r.ExtensionId,A.identifier.uuid):X=X.withFilter(r.ExtensionName,A.identifier.id);const{galleryExtensions:Y}=await this.queryGallery(X,z,R.CancellationToken.None);if(!Y.length)return[];const de=j(Y[0]);if((0,d.isNotWebExtensionInWebTargetPlatform)(de,z))return[];const se=[];for(const re of Y[0].versions)try{se[se.length-1]?.version!==re.version&&await this.isRawExtensionVersionCompatible(re,$,de,z)&&se.push({version:re.version,date:re.lastUpdated,isPreReleaseVersion:B(re)})}catch{}return se}async getAsset(A,$={},z=R.CancellationToken.None){const X=await this.commonHeadersPromise,Y={type:"GET"},de={...X,...$.headers||{}};$={...$,...Y,headers:de};const se=A.uri,re=A.fallbackUri,oe={...$,url:se};try{const ye=await this.requestService.request(oe,z);if(ye.res.statusCode===200)return ye;const le=await(0,S.asText)(ye);throw new Error(`Expected 200, got back ${ye.res.statusCode} instead.

${le}`)}catch(ye){if((0,P.isPromiseCanceledError)(ye))throw ye;const le=(0,P.getErrorMessage)(ye);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:se,message:le});const Ee={...$,url:re};return this.requestService.request(Ee,z)}}async getEngine(A){let $=W(A);if(!$){const z=await this.getManifestFromRawExtensionVersion(A,R.CancellationToken.None);if(!z)throw new Error("Manifest was not found");$=z.engines.vscode}return $}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const A=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},R.CancellationToken.None);if(A.res.statusCode!==200)throw new Error("Could not get extensions report.");const $=await(0,S.asJson)(A),z=[],X={};if($){for(const Y of $.malicious)z.push({id:Y});if($.unsupported)for(const Y of Object.keys($.unsupported)){const de=$.unsupported[Y];(0,c.isBoolean)(de)||(X[Y.toLowerCase()]=de.preReleaseExtension)}}return{malicious:z,unsupportedPreReleaseExtensions:X}}};K=pe([ae(1,S.IRequestService),ae(2,h.ILogService),ae(3,I.IEnvironmentService),ae(4,a.ITelemetryService),ae(5,g.IFileService),ae(6,p.IProductService),ae(7,y.IConfigurationService)],K);let Z=class extends K{constructor(A,$,z,X,Y,de,se,re){super(A,$,z,X,Y,de,se,re)}};Z=pe([ae(0,s.IStorageService),ae(1,S.IRequestService),ae(2,h.ILogService),ae(3,I.IEnvironmentService),ae(4,a.ITelemetryService),ae(5,g.IFileService),ae(6,p.IProductService),ae(7,y.IConfigurationService)],Z),i.ExtensionGalleryService=Z;let _=class extends K{constructor(A,$,z,X,Y,de,se){super(void 0,A,$,z,X,Y,de,se)}};_=pe([ae(0,S.IRequestService),ae(1,h.ILogService),ae(2,I.IEnvironmentService),ae(3,a.ITelemetryService),ae(4,g.IFileService),ae(5,p.IProductService),ae(6,y.IConfigurationService)],_),i.ExtensionGalleryServiceWithNoStorageService=_;async function ue(U,A,$,z,X,Y){const de={"X-Market-Client-Id":`VSCode ${U}`,"User-Agent":`VSCode ${U} (${A.nameShort})`},se=await(0,f.getServiceMachineId)($,X,Y);return(0,n.supportsTelemetry)(A,$)&&(0,n.getTelemetryLevel)(z)===3&&(de["X-Market-User-Id"]=se),de}i.resolveMarketplaceHeaders=ue}),define(J[120],Q([0,1,2,21,12,26,87,25,34,121,29,30,35]),function(x,i,T,R,P,D,C,w,c,v,y,I,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryService=void 0;let E=class{constructor(h,p){this._configurationService=p,this._experimentProperties={},this._disposables=new T.DisposableStore,this._cleanupPatterns=[],this._appenders=h.appenders,this._commonProperties=h.commonProperties||Promise.resolve({}),this._piiPaths=h.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!h.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let S of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(S),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(S=>{const f=/^[a-f0-9]+$/i.test(S["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!f})})}setExperimentProperty(h,p){this._experimentProperties[h]=p}_updateTelemetryLevel(){this._telemetryLevel=(0,d.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const h=await this._commonProperties;let p=h.sessionID,S=h["common.machineId"],f=h["common.firstSessionDate"],s=h["common.msftInternal"];return{sessionId:p,machineId:S,firstSessionDate:f,msftInternal:s}}dispose(){this._disposables.dispose()}_log(h,p,S,f){return this.telemetryLevel<p?Promise.resolve(void 0):this._commonProperties.then(s=>{S=(0,R.mixin)(S,s),S=(0,R.mixin)(S,this._experimentProperties),S=(0,R.cloneAndChange)(S,a=>{if(typeof a=="string")return this._cleanupInfo(a,f)}),this._appenders.forEach(a=>a.log(h,S))},s=>{console.error(s)})}publicLog(h,p,S){return this._log(h,3,p,S)}publicLog2(h,p,S){return this.publicLog(h,p,S)}publicLogError(h,p){return this.sendErrorTelemetry?this._log(h,2,p,!0):Promise.resolve(void 0)}publicLogError2(h,p){return this.publicLogError(h,p)}_anonymizeFilePaths(h){let p=h;const S=[];for(let n of this._cleanupPatterns)for(;;){const o=n.exec(h);if(!o)break;S.push([o.index,n.lastIndex])}const f=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,s=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(p="";;){const n=s.exec(h);if(!n)break;!f.test(n[0])&&S.every(([o,e])=>n.index<o||n.index>=e)&&(p+=h.substring(a,n.index)+"<REDACTED: user-file-path>",a=s.lastIndex)}return a<h.length&&(p+=h.substr(a)),p}_removePropertiesWithPossibleUserInfo(h){if(!h)return h;const p=h.toLowerCase(),S=/@[a-zA-Z0-9-.]+/;return/(key|token|sig|signature|password|passwd|pwd)[="':\s]/.test(p)?"<REDACTED: secret>":S.test(p)?"<REDACTED: email>":h}_cleanupInfo(h,p){let S=h;p&&(S=this._anonymizeFilePaths(S));for(let f of this._cleanupPatterns)S=S.replace(f,"");return S=this._removePropertiesWithPossibleUserInfo(S),S}};E.IDLE_START_EVENT_NAME="UserIdleStart",E.IDLE_STOP_EVENT_NAME="UserIdleStop",E=pe([ae(1,w.IConfigurationService)],E),i.TelemetryService=E;function u(){const g=(0,C.localize)(0,null,v.default.nameLong),h=v.default.privacyStatementUrl?(0,C.localize)(2,null,"https://aka.ms/vscode-telemetry",v.default.privacyStatementUrl):(0,C.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=P.isWeb?"":(0,C.localize)(3,null),S=(0,C.localize)(4,null),f=(0,C.localize)(5,null),s=(0,C.localize)(6,null),a=(0,C.localize)(7,null),n=`
|       | ${S} | ${f} | ${s} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,C.localize)(8,null);return`
${g} ${h} ${p}

&nbsp;

${a}
${n}

&nbsp;

${o}
`}y.Registry.as(c.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,C.localize)(9,null),properties:{[I.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,C.localize)(10,null),(0,C.localize)(11,null),(0,C.localize)(12,null),(0,C.localize)(13,null)],markdownDescription:u(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.Registry.as(c.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,C.localize)(14,null),properties:{[I.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:v.default.privacyStatementUrl?(0,C.localize)(16,null,v.default.nameLong,v.default.privacyStatementUrl):(0,C.localize)(15,null,v.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(17,null,`\`#${I.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(J[122],Q([0,1,7,21,35]),function(x,i,T,R,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AppInsightsAppender=void 0;async function D(w,c){const v=await new Promise((I,d)=>{x(["applicationinsights"],I,d)});let y;return v.defaultClient?(y=new v.TelemetryClient(w),y.channel.setUseDiskRetryCaching(!0)):(v.setup(w).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),y=v.defaultClient),w.indexOf("AIF-")===0&&(y.config.endpointUrl=c?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),y}class C{constructor(c,v,y,I,d){this._eventPrefix=c,this._defaultData=v,this.testCollector=I,this.mirrored=d,this._defaultData||(this._defaultData=Object.create(null)),typeof y=="function"?this._aiClient=y():this._aiClient=y,this._asyncAIClient=null}_withAIClient(c){if(!!this._aiClient){if(typeof this._aiClient!="string"){c(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=D(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(v=>{c(v)},v=>{(0,T.onUnexpectedError)(v),console.error(v)})}}log(c,v){!this._aiClient||(v=(0,R.mixin)(v,this._defaultData),v=(0,P.validateTelemetryData)(v),this.testCollector&&(v.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++"),this._withAIClient(y=>y.trackEvent({name:this._eventPrefix+"/"+c,properties:v.properties,measurements:v.measurements})))}flush(){return this._aiClient?new Promise(c=>{this._withAIClient(v=>{v.flush({callback:()=>{this._aiClient=void 0,c(void 0)}})})}):Promise.resolve(void 0)}}i.AppInsightsAppender=C}),define(J[123],Q([0,1,6,13]),function(x,i,T,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buildTelemetryMessage=void 0;async function P(D,C){const w=Object.create(null),c=(y,I)=>{const d=JSON.parse(y);w[I]=d};if(C){const y=[],I=await R.Promises.readdir(C);for(const E of I)try{(await R.Promises.stat((0,T.join)(C,E))).isDirectory()&&y.push(E)}catch{}const d=[];for(const E of y)(await R.Promises.readdir((0,T.join)(C,E))).filter(g=>g==="telemetry.json").length===1&&d.push(E);for(const E of d){const u=(await R.Promises.readFile((0,T.join)(C,E,"telemetry.json"))).toString();c(u,E)}}let v=(await R.Promises.readFile((0,T.join)(D,"telemetry-core.json"))).toString();return c(v,"vscode-core"),v=(await R.Promises.readFile((0,T.join)(D,"telemetry-extensions.json"))).toString(),c(v,"vscode-extensions"),JSON.stringify(w,null,4)}i.buildTelemetryMessage=P}),define(J[36],Q([0,1,14]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IUriIdentityService=void 0,i.IUriIdentityService=(0,T.createDecorator)("IUriIdentityService")}),define(J[124],Q([0,1,10,2,9,20,23,16,15,36]),function(x,i,T,R,P,D,C,w,c,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsWatcher=void 0;let y=class extends R.Disposable{constructor(d,E,u,g,h){super();this.extensionsManagementService=d,this.logService=g,this.uriIdentityService=h,this._onDidChangeExtensionsByAnotherSource=this._register(new T.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(S=>{this.installedExtensions=S.map(f=>f.identifier),this.startTimestamp=Date.now()}),this._register(d.onInstallExtension(S=>this.onInstallExtension(S))),this._register(d.onDidInstallExtensions(S=>this.onDidInstallExtensions(S))),this._register(d.onDidUninstallExtension(S=>this.onDidUninstallExtension(S)));const p=P.URI.file(u.extensionsPath);this._register(E.watch(p)),this._register(T.Event.filter(E.onDidChangeFilesRaw,S=>S.changes.some(f=>this.doesChangeAffects(f,p)))(()=>this.onDidChange()))}doesChangeAffects(d,E){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(d.resource),E)?this.uriIdentityService.extUri.isEqual(d.resource,this.uriIdentityService.extUri.joinPath(E,".obsolete"))?!0:!(d.type!==1&&d.type!==2||this.uriIdentityService.extUri.basename(d.resource).startsWith(".")):!1}onInstallExtension(d){this.addInstallingExtension(d.identifier)}onDidInstallExtensions(d){for(const E of d)this.removeInstallingExtension(E.identifier),E.local&&this.addInstalledExtension(E.identifier)}onDidUninstallExtension(d){d.error||this.removeInstalledExtension(d.identifier)}addInstallingExtension(d){this.removeInstallingExtension(d),this.installingExtensions.push(d)}removeInstallingExtension(d){this.installingExtensions=this.installingExtensions.filter(E=>!(0,C.areSameExtensions)(E,d))}addInstalledExtension(d){this.installedExtensions&&(this.removeInstalledExtension(d),this.installedExtensions.push(d))}removeInstalledExtension(d){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(E=>!(0,C.areSameExtensions)(E,d)))}async onDidChange(){if(this.installedExtensions){const d=await this.extensionsManagementService.getInstalled(1),E=d.filter(g=>[...this.installingExtensions,...this.installedExtensions].some(h=>(0,C.areSameExtensions)(h,g.identifier))?!1:g.installedTimestamp&&g.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",g.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",g.identifier.id),!1)),u=this.installedExtensions.filter(g=>this.installingExtensions.some(h=>(0,C.areSameExtensions)(h,g))?!1:d.every(h=>!(0,C.areSameExtensions)(h.identifier,g))?(this.logService.info("Detected extension removed from another source",g.id),!0):!1);this.installedExtensions=d.map(g=>g.identifier),(E.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:E,removed:u})}}};y=pe([ae(1,w.IFileService),ae(2,D.INativeEnvironmentService),ae(3,c.ILogService),ae(4,v.IUriIdentityService)],y),i.ExtensionsWatcher=y}),define(J[125],Q([0,1,36,92,16,18,59,10,2]),function(x,i,T,R,P,D,C,w,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UriIdentityService=void 0;class v{constructor(d){this.uri=d,this.time=v._clock++}touch(){return this.time=v._clock++,this}}v._clock=0;let y=class{constructor(d){this._fileService=d,this._dispooables=new c.DisposableStore,this._limit=2**16;const E=new Map,u=g=>{let h=E.get(g.scheme);return h===void 0&&(h=d.hasProvider(g)&&!this._fileService.hasCapability(g,1024),E.set(g.scheme,h)),h};this._dispooables.add(w.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(g=>{E.delete(g.scheme)})),this.extUri=new D.ExtUri(u),this._canonicalUris=new C.SkipList((g,h)=>this.extUri.compare(g,h,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(d){this._fileService.hasProvider(d)&&(d=(0,D.normalizePath)(d));let E=this._canonicalUris.get(d);return E?E.touch().uri.with({fragment:d.fragment}):(this._canonicalUris.set(d,new v(d)),this._checkTrim(),d)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const d=[...this._canonicalUris.entries()].sort((u,g)=>u[1].touch<g[1].touch?1:u[1].touch>g[1].touch?-1:0);v._clock=0,this._canonicalUris.clear();const E=this._limit*.5;for(let u=0;u<E;u++)this._canonicalUris.set(d[u][0],d[u][1].touch())}};y=pe([ae(0,P.IFileService)],y),i.UriIdentityService=y,(0,R.registerSingleton)(T.IUriIdentityService,y,!0)}),define(J[44],Q([0,1,47,3,6,8,13,73,137,138]),function(x,i,T,R,P,D,C,w,c,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buffer=i.extract=i.zip=i.ExtractError=void 0;class y extends Error{constructor(n,o){let e=o.message;switch(n){case"CorruptZip":e=`Corrupt ZIP: ${e}`;break}super(e);this.type=n,this.cause=o}}i.ExtractError=y;function I(a){const n=a.externalFileAttributes>>16||33188;return[448,56,7].map(o=>n&o).reduce((o,e)=>o+e,n&61440)}function d(a){if(a instanceof y)return a;let n;return/end of central directory record signature not found/.test(a.message)&&(n="CorruptZip"),new y(n,a)}function E(a,n,o,e,t,r){const l=P.dirname(n),m=P.join(e,l);if(!m.startsWith(e))return Promise.reject(new Error(w.localize(0,null,n)));const L=P.join(e,n);let b;return r.onCancellationRequested(()=>{b&&b.destroy()}),Promise.resolve(C.Promises.mkdir(m,{recursive:!0})).then(()=>new Promise((O,N)=>{if(!r.isCancellationRequested)try{b=(0,T.createWriteStream)(L,{mode:o}),b.once("close",()=>O()),b.once("error",N),a.once("error",N),a.pipe(b)}catch(G){N(G)}}))}function u(a,n,o,e){let t=(0,R.createCancelablePromise)(()=>Promise.resolve()),r=0;return e.onCancellationRequested(()=>{t.cancel(),a.close()}),new Promise((l,m)=>{const L=new R.Sequencer,b=O=>{O.isCancellationRequested||(r++,a.readEntry())};a.once("error",m),a.once("close",()=>t.then(()=>{e.isCancellationRequested||a.entryCount===r?l():m(new y("Incomplete",new Error(w.localize(1,null,r,a.entryCount))))},m)),a.readEntry(),a.on("entry",O=>{if(e.isCancellationRequested)return;if(!o.sourcePathRegex.test(O.fileName)){b(e);return}const N=O.fileName.replace(o.sourcePathRegex,"");if(/\/$/.test(N)){const ge=P.join(n,N);t=(0,R.createCancelablePromise)(ce=>C.Promises.mkdir(ge,{recursive:!0}).then(()=>b(ce)).then(void 0,m));return}const G=h(a,O),ee=I(O);t=(0,R.createCancelablePromise)(ge=>L.queue(()=>G.then(ce=>E(ce,N,ee,n,o,ge).then(()=>b(ge)))).then(null,m))})})}function g(a,n=!1){return new Promise((o,e)=>{(0,c.open)(a,n?{lazyEntries:!0}:void 0,(t,r)=>{t?e(d(t)):o((0,D.assertIsDefined)(r))})})}function h(a,n){return new Promise((o,e)=>{a.openReadStream(n,(t,r)=>{t?e(d(t)):o((0,D.assertIsDefined)(r))})})}function p(a,n){return new Promise((o,e)=>{const t=new v.ZipFile;n.forEach(l=>{l.contents?t.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&t.addFile(l.localPath,l.path)}),t.end();const r=(0,T.createWriteStream)(a);t.outputStream.pipe(r),t.outputStream.once("error",e),r.once("error",e),r.once("finish",()=>o(a))})}i.zip=p;function S(a,n,o={},e){const t=new RegExp(o.sourcePath?`^${o.sourcePath}`:"");let r=g(a,!0);return o.overwrite&&(r=r.then(l=>C.Promises.rm(n).then(()=>l))),r.then(l=>u(l,n,{sourcePathRegex:t},e))}i.extract=S;function f(a,n){return g(a).then(o=>new Promise((e,t)=>{o.on("entry",r=>{r.fileName===n&&h(o,r).then(l=>e(l),l=>t(l))}),o.once("close",()=>t(new Error(w.localize(2,null,n))))}))}function s(a,n){return f(a,n).then(o=>new Promise((e,t)=>{const r=[];o.once("error",t),o.on("data",l=>r.push(l)),o.on("end",()=>e(Buffer.concat(r)))}))}i.buffer=s}),define(J[126],Q([0,1,44,80]),function(x,i,T,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getManifest=void 0;function P(D){return(0,T.buffer)(D,"extension/package.json").then(C=>{try{return JSON.parse(C.toString("utf8"))}catch{throw new Error((0,R.localize)(0,null))}})}i.getManifest=P}),define(J[127],Q([0,1,19,3,7,2,11,6,12,18,42,9,31,13,44,81,20,22,23,91,16,15,32]),function(x,i,T,R,P,D,C,w,c,v,y,I,d,E,u,g,h,p,S,f,s,a,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsScanner=void 0;let o=class extends D.Disposable{constructor(t,r,l,m,L){super();this.beforeRemovingExtension=t,this.fileService=r,this.logService=l,this.environmentService=m,this.productService=L,this._devSystemExtensionsPath=null,this.systemExtensionsPath=m.builtinExtensionsPath,this.extensionsPath=m.extensionsPath,this.uninstalledPath=w.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new R.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(t){const r=[];(t===null||t===0)&&r.push(this.scanSystemExtensions().then(null,l=>Promise.reject(new p.ExtensionManagementError(this.joinErrors(l).message,p.ExtensionManagementErrorCode.Internal)))),(t===null||t===1)&&r.push(this.scanUserExtensions(!0).then(null,l=>Promise.reject(new p.ExtensionManagementError(this.joinErrors(l).message,p.ExtensionManagementErrorCode.Internal))));try{const l=await Promise.all(r);return(0,T.flatten)(l)}catch(l){throw this.joinErrors(l)}}async scanUserExtensions(t){this.logService.trace("Started scanning user extensions");let[r,l]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return l=l.filter(m=>!r[new S.ExtensionIdentifierWithVersion(m.identifier,m.manifest.version).key()]),t&&(l=(0,S.groupByExtension)(l,L=>L.identifier).map(L=>L.sort((b,O)=>y.rcompare(b.manifest.version,O.manifest.version))[0])),this.logService.trace("Scanned user extensions:",l.length),l}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(t,r,l,m){const L=t.key(),b=w.join(this.extensionsPath,`.${(0,d.generateUuid)()}`),O=w.join(this.extensionsPath,L);try{await E.Promises.rm(O)}catch{try{await E.Promises.rm(O)}catch{}throw new p.ExtensionManagementError((0,g.localize)(0,null,O,t.id),p.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(t,r,b,m);let N=await this.scanExtension(I.URI.file(b),1);if(!N)throw new Error((0,g.localize)(1,null,b));await this.storeMetadata(N,{...l,installedTimestamp:Date.now()});try{await this.rename(t,b,O,Date.now()+2*60*1e3),this.logService.info("Renamed to",O)}catch(G){try{await E.Promises.rm(b)}catch{}if(G.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",t.id);else throw this.logService.info(`Rename failed because of ${(0,P.getErrorMessage)(G)}. Deleted from extracted location`,b),G}try{N=await this.scanExtension(I.URI.file(O),1)}catch{}if(N)return N;throw new Error((0,g.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(t,r){return this.setMetadata(t,r),await this.storeMetadata(t,{...r,installedTimestamp:t.installedTimestamp}),t}async storeMetadata(t,r){r.isMachineScoped=r.isMachineScoped||void 0,r.isBuiltin=r.isBuiltin||void 0,r.installedTimestamp=r.installedTimestamp||void 0;const l=w.join(t.location.fsPath,"package.json"),m=await E.Promises.readFile(l,"utf8"),{manifest:L}=await this.parseManifest(m);return L.__metadata=r,await E.Promises.writeFile(l,JSON.stringify(L,null,"	")),t}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...t){const r=t.map(l=>new S.ExtensionIdentifierWithVersion(l.identifier,l.manifest.version));await this.withUninstalledExtensions(l=>{r.forEach(m=>l[m.key()]=!0)})}async setInstalled(t){await this.withUninstalledExtensions(m=>delete m[t.key()]);const l=(await this.scanExtensions(1)).find(m=>new S.ExtensionIdentifierWithVersion(m.identifier,m.manifest.version).equals(t))||null;return l?(await this.storeMetadata(l,{installedTimestamp:Date.now()}),this.scanExtension(l.location,1)):null}async withUninstalledExtensions(t){return this.uninstalledFileLimiter.queue(async()=>{let r;try{r=await E.Promises.readFile(this.uninstalledPath,"utf8")}catch(m){if(m.code!=="ENOENT")throw m}let l={};if(r)try{l=JSON.parse(r)}catch{}return t&&(t(l),Object.keys(l).length?await E.Promises.writeFile(this.uninstalledPath,JSON.stringify(l)):await E.Promises.rm(this.uninstalledPath)),l})}async removeExtension(t,r){this.logService.trace(`Deleting ${r} extension from disk`,t.identifier.id,t.location.fsPath),await E.Promises.rm(t.location.fsPath),this.logService.info("Deleted from disk",t.identifier.id,t.location.fsPath)}async removeUninstalledExtension(t){await this.removeExtension(t,"uninstalled"),await this.withUninstalledExtensions(r=>delete r[new S.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).key()])}async extractAtLocation(t,r,l,m){this.logService.trace(`Started extracting the extension from ${r} to ${l}`);try{await E.Promises.rm(l)}catch(L){throw new p.ExtensionManagementError(this.joinErrors(L).message,p.ExtensionManagementErrorCode.Delete)}try{await(0,u.extract)(r,l,{sourcePath:"extension",overwrite:!0},m),this.logService.info(`Extracted extension to ${l}:`,t.id)}catch(L){try{await E.Promises.rm(l)}catch{}let b=p.ExtensionManagementErrorCode.Extract;throw L instanceof u.ExtractError&&(L.type==="CorruptZip"?b=p.ExtensionManagementErrorCode.CorruptZip:L.type==="Incomplete"&&(b=p.ExtensionManagementErrorCode.IncompleteZip)),new p.ExtensionManagementError(L.message,b)}}async rename(t,r,l,m){try{await E.Promises.rename(r,l)}catch(L){if(c.isWindows&&L&&L.code==="EPERM"&&Date.now()<m)return this.logService.info(`Failed renaming ${r} to ${l} with 'EPERM' error. Trying again...`,t.id),this.rename(t,r,l,m);throw new p.ExtensionManagementError(L.message||(0,g.localize)(3,null,r,l),L.code||p.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const t=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return t;const r=this.scanDevSystemExtensions(),[l,m]=await Promise.all([t,r]);return[...l,...m]}async scanExtensionsInDir(t,r){const l=new R.Limiter(10),m=await this.fileService.resolve(I.URI.file(t));return m.children?(await Promise.all(m.children.filter(b=>b.isDirectory).map(b=>l.queue(async()=>r===1&&(0,v.basename)(b.resource).indexOf(".")===0?null:this.scanExtension(b.resource,r))))).filter(b=>b&&b.identifier):[]}async scanExtension(t,r){try{const l=await this.fileService.resolve(t);if(l.children){const{manifest:m,metadata:L}=await this.readManifest(t.fsPath),b=l.children.find(({name:ee})=>/^readme(\.txt|\.md|)$/i.test(ee))?.resource,O=l.children.find(({name:ee})=>/^changelog(\.txt|\.md|)$/i.test(ee))?.resource,N={id:(0,S.getGalleryExtensionId)(m.publisher,m.name)},G={type:r,identifier:N,manifest:m,location:t,readmeUrl:b,changelogUrl:O,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:r===0};return this.setMetadata(G,L),G}}catch(l){r!==0&&this.logService.trace(l)}return null}async scanDefaultSystemExtensions(){const t=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",t.length),t}async scanDevSystemExtensions(){const t=this.getDevSystemExtensionsList();if(t.length){const r=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",r.length),r.filter(l=>t.some(m=>(0,S.areSameExtensions)(l.identifier,{id:m})))}else return[]}setMetadata(t,r){t.publisherDisplayName=r?.publisherDisplayName||null,t.publisherId=r?.publisherId||null,t.identifier.uuid=r?.id,t.isMachineScoped=!!r?.isMachineScoped,t.isPreReleaseVersion=!!r?.isPreReleaseVersion,t.preRelease=!!r?.preRelease,t.isBuiltin=t.type===0||!!r?.isBuiltin,t.installedTimestamp=r?.installedTimestamp}async removeUninstalledExtensions(){const t=await this.getUninstalledExtensions(),r=await this.scanAllUserExtensions(),l=new Set;for(const b of r)t[new S.ExtensionIdentifierWithVersion(b.identifier,b.manifest.version).key()]||l.add(b.identifier.id.toLowerCase());const m=(0,S.groupByExtension)(r,b=>b.identifier);await R.Promises.settled(m.map(async b=>{const O=b.sort((N,G)=>y.rcompare(N.manifest.version,G.manifest.version))[0];l.has(O.identifier.id.toLowerCase())||await this.beforeRemovingExtension(O)}));const L=r.filter(b=>t[new S.ExtensionIdentifierWithVersion(b.identifier,b.manifest.version).key()]);await R.Promises.settled(L.map(b=>this.removeUninstalledExtension(b)))}async removeOutdatedExtensions(){const t=await this.scanAllUserExtensions(),r=[],l=(0,S.groupByExtension)(t,m=>m.identifier);r.push(...(0,T.flatten)(l.map(m=>m.sort((L,b)=>y.rcompare(L.manifest.version,b.manifest.version)).slice(1)))),await R.Promises.settled(r.map(m=>this.removeExtension(m,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(t=>t.name)}joinErrors(t){const r=Array.isArray(t)?t:[t];return r.length===1?r[0]instanceof Error?r[0]:new Error(r[0]):r.reduce((l,m)=>new Error(`${l.message}${l.message?",":""}${m instanceof Error?m.message:m}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=w.normalize(w.join(C.FileAccess.asFileUri("",x).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(t){const r=[E.Promises.readFile(w.join(t,"package.json"),"utf8").then(b=>this.parseManifest(b)),E.Promises.readFile(w.join(t,"package.nls.json"),"utf8").then(void 0,b=>b.code!=="ENOENT"?Promise.reject(b):"{}").then(b=>JSON.parse(b))],[{manifest:l,metadata:m},L]=await Promise.all(r);return{manifest:(0,f.localizeManifest)(l,L),metadata:m}}parseManifest(t){return new Promise((r,l)=>{try{const m=JSON.parse(t),L=m.__metadata||null;r({manifest:m,metadata:L})}catch{l(new Error((0,g.localize)(4,null)))}})}};o=pe([ae(1,s.IFileService),ae(2,a.ILogService),ae(3,h.INativeEnvironmentService),ae(4,n.IProductService)],o),i.ExtensionsScanner=o}),define(J[128],Q([0,1,27,7,11,6,12,28,18,42,9,31,13,44,79,51,20,118,22,23,109,98,126,110,127,124,50,16,14,15,32,30,36]),function(x,i,T,R,P,D,C,w,c,v,y,I,d,E,u,g,h,p,S,f,s,a,n,o,e,t,r,l,m,L,b,O,N){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementService=void 0;let G=class extends p.AbstractExtensionManagementService{constructor(W,B,ne,M,k,j,H,ie,K){super(W,B,ne,ie);this.environmentService=M,this.downloadService=k,this.fileService=H;const Z=this._register(j.createInstance(a.ExtensionsLifecycle));this.extensionsScanner=this._register(j.createInstance(e.ExtensionsScanner,ue=>Z.postUninstall(ue))),this.manifestCache=this._register(new o.ExtensionsManifestCache(M,this)),this.extensionsDownloader=this._register(j.createInstance(s.ExtensionsDownloader));const _=this._register(new t.ExtensionsWatcher(this,H,M,ne,K));this._register(_.onDidChangeExtensionsByAnotherSource(({added:ue,removed:U})=>{ue.length&&this._onDidInstallExtensions.fire(ue.map(A=>({identifier:A.identifier,operation:1,local:A}))),U.forEach(A=>this._onDidUninstallExtension.fire({identifier:A}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const W=await this.isAlpineLinux(),B=(0,S.getTargetPlatform)(W?"alpine":C.platform,w.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",B),B})()),this._targetPlatformPromise}async isAlpineLinux(){if(!C.isLinux)return!1;let W;try{W=(await this.fileService.readFile(y.URI.file("/etc/os-release"))).value.toString()}catch{try{W=(await this.fileService.readFile(y.URI.file("/usr/lib/os-release"))).value.toString()}catch(ne){this.logService.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(ne))}}return!!W&&(W.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(W){this.logService.trace("ExtensionManagementService#zip",W.identifier.id);const B=await this.collectFiles(W),ne=await(0,E.zip)((0,c.joinPath)(this.environmentService.tmpDir,(0,I.generateUuid)()).fsPath,B);return y.URI.file(ne)}async unzip(W){return this.logService.trace("ExtensionManagementService#unzip",W.toString()),(await this.install(W)).identifier}async getManifest(W){const B=await this.downloadVsix(W),ne=D.resolve(B.fsPath);return(0,n.getManifest)(ne)}getInstalled(W=null){return this.extensionsScanner.scanExtensions(W)}async install(W,B={}){this.logService.trace("ExtensionManagementService#install",W.toString());const ne=await this.downloadVsix(W),M=await(0,n.getManifest)(D.resolve(ne.fsPath));if(M.engines&&M.engines.vscode&&!(0,r.isEngineValid)(M.engines.vscode,this.productService.version,this.productService.date))throw new Error(u.localize(0,null,(0,f.getGalleryExtensionId)(M.publisher,M.name),this.productService.version));return this.installExtension(M,ne,B)}async updateMetadata(W,B){this.logService.trace("ExtensionManagementService#updateMetadata",W.identifier.id);const ne={...W.manifest.__metadata||{},...B};return B.isPreReleaseVersion&&(ne.preRelease=!0),W=await this.extensionsScanner.saveMetadataForLocalExtension(W,ne),this.manifestCache.invalidate(),W}async updateExtensionScope(W,B){return this.logService.trace("ExtensionManagementService#updateExtensionScope",W.identifier.id),W=await this.extensionsScanner.saveMetadataForLocalExtension(W,{...W.manifest.__metadata||{},isMachineScoped:B}),this.manifestCache.invalidate(),W}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(W){if(W.scheme===P.Schemas.file)return W;const B=(0,c.joinPath)(this.environmentService.tmpDir,(0,I.generateUuid)());return await this.downloadService.download(W,B),B}createInstallExtensionTask(W,B,ne){return y.URI.isUri(B)?new ce(W,B,ne,this.galleryService,this.extensionsScanner,this.logService):new ge(B,ne,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(W,B){return new te(W,B,this.extensionsScanner)}async collectFiles(W){const B=async M=>{let k=await d.Promises.readdir(M);k=k.map(ie=>D.join(M,ie));const j=await Promise.all(k.map(ie=>d.Promises.stat(ie)));let H=Promise.resolve([]);return j.forEach((ie,K)=>{const Z=k[K];ie.isFile()&&(H=H.then(_=>[..._,Z])),ie.isDirectory()&&(H=H.then(_=>B(Z).then(ue=>[..._,...ue])))}),H};return(await B(W.location.fsPath)).map(M=>({path:`extension/${D.relative(W.location.fsPath,M)}`,localPath:M}))}};G=pe([ae(0,S.IExtensionGalleryService),ae(1,O.ITelemetryService),ae(2,L.ILogService),ae(3,h.INativeEnvironmentService),ae(4,g.IDownloadService),ae(5,m.IInstantiationService),ae(6,l.IFileService),ae(7,b.IProductService),ae(8,N.IUriIdentityService)],G),i.ExtensionManagementService=G;class ee extends p.AbstractExtensionTask{constructor(W,B,ne,M){super();this.identifier=W,this.source=B,this.extensionsScanner=ne,this.logService=M,this._operation=2}get operation(){return this._operation}async installExtension(W,B){try{const ne=await this.unsetUninstalledAndGetLocal(W.identifierWithVersion);if(ne)return W.metadata?this.extensionsScanner.saveMetadataForLocalExtension(ne,{...ne.manifest.__metadata||{},...W.metadata}):ne}catch{throw C.isMacintosh?new S.ExtensionManagementError(u.localize(1,null),S.ExtensionManagementErrorCode.Internal):new S.ExtensionManagementError(u.localize(2,null),S.ExtensionManagementErrorCode.Internal)}return this.extract(W,B)}async unsetUninstalledAndGetLocal(W){if(!await this.isUninstalled(W))return null;this.logService.trace("Removing the extension from uninstalled list:",W.id);const ne=await this.extensionsScanner.setInstalled(W);return this.logService.info("Removed the extension from uninstalled list:",W.id),ne}async isUninstalled(W){return!!(await this.extensionsScanner.getUninstalledExtensions())[W.key()]}async extract({zipPath:W,identifierWithVersion:B,metadata:ne},M){let k=await this.extensionsScanner.extractUserExtension(B,W,ne,M);return this.logService.info("Extracting completed.",B.id),k}}class ge extends ee{constructor(W,B,ne,M,k){super(W.identifier,W,M,k);this.gallery=W,this.options=B,this.extensionsDownloader=ne}async doRun(W){const ne=(await this.extensionsScanner.scanExtensions(null)).find(k=>(0,f.areSameExtensions)(k.identifier,this.gallery.identifier));ne&&(this._operation=3);const M=await this.downloadInstallableExtension(this.gallery,this._operation);M.metadata.isMachineScoped=this.options.isMachineScoped||ne?.isMachineScoped,M.metadata.isBuiltin=this.options.isBuiltin||ne?.isBuiltin,M.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,M.metadata.preRelease=this.gallery.hasPreReleaseVersion?this.gallery.properties.isPreReleaseVersion:ne?.preRelease;try{const k=await this.installExtension(M,W);return ne&&v.neq(ne.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(ne),k}catch(k){throw await this.deleteDownloadedVSIX(M.zipPath),k}}async deleteDownloadedVSIX(W){try{await this.extensionsDownloader.delete(y.URI.file(W))}catch(B){this.logService.warn("Error while deleting the downloaded vsix",W.toString(),(0,R.getErrorMessage)(B))}}async downloadInstallableExtension(W,B){const ne={id:W.identifier.uuid,publisherId:W.publisherId,publisherDisplayName:W.publisherDisplayName};let M;try{this.logService.trace("Started downloading extension:",W.identifier.id),M=(await this.extensionsDownloader.downloadExtension(W,B)).fsPath,this.logService.info("Downloaded extension:",W.identifier.id,M)}catch(k){throw new S.ExtensionManagementError((0,p.joinErrors)(k).message,S.ExtensionManagementErrorCode.Download)}try{const k=await(0,n.getManifest)(M);return{zipPath:M,identifierWithVersion:new f.ExtensionIdentifierWithVersion(W.identifier,k.version),metadata:ne}}catch(k){throw await this.deleteDownloadedVSIX(M),new S.ExtensionManagementError((0,p.joinErrors)(k).message,S.ExtensionManagementErrorCode.Invalid)}}}class ce extends ee{constructor(W,B,ne,M,k,j){super({id:(0,f.getGalleryExtensionId)(W.publisher,W.name)},B,k,j);this.manifest=W,this.location=B,this.options=ne,this.galleryService=M}async doRun(W){const B=new f.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),M=(await this.extensionsScanner.scanExtensions(1)).find(j=>(0,f.areSameExtensions)(this.identifier,j.identifier)),k=await this.getMetadata(this.identifier.id,this.manifest.version,W);if(k.isMachineScoped=this.options.isMachineScoped||M?.isMachineScoped,k.isBuiltin=this.options.isBuiltin||M?.isBuiltin,M)if(this._operation=3,B.equals(new f.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version)))try{await this.extensionsScanner.removeExtension(M,"existing")}catch{throw new Error(u.localize(3,null,this.manifest.displayName||this.manifest.name))}else v.gt(M.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(M);else{const j=await this.unsetUninstalledAndGetLocal(B);if(j)try{await this.extensionsScanner.removeExtension(j,"existing")}catch{throw new Error(u.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:D.resolve(this.location.fsPath),identifierWithVersion:B,metadata:k},W)}async getMetadata(W,B,ne){try{let[M]=await this.galleryService.getExtensions([{id:W,version:B}],ne);if(M||([M]=await this.galleryService.getExtensions([{id:W}],ne)),M)return{id:M.identifier.uuid,publisherDisplayName:M.publisherDisplayName,publisherId:M.publisherId,isPreReleaseVersion:M.properties.isPreReleaseVersion,preRelease:M.properties.isPreReleaseVersion}}catch{}return{}}}class te extends p.AbstractExtensionTask{constructor(W,B,ne){super();this.extension=W,this.options=B,this.extensionsScanner=ne}async doRun(W){const B=[],ne=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const M=new f.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);B.push(...ne.filter(k=>M.equals(new f.ExtensionIdentifierWithVersion(k.identifier,k.manifest.version))))}else B.push(...ne.filter(M=>(0,f.areSameExtensions)(M.identifier,this.extension.identifier)));if(!B.length)throw new Error(u.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...B),this.options.remove)for(const M of B)try{W.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(M)}catch(k){throw new Error(u.localize(6,null,(0,T.toErrorMessage)(k)))}}}}),define(J[129],Q([0,1,114,3,17,7,2,8,25,20,94,15,113,139]),function(x,i,T,R,P,D,C,w,c,v,y,I,d,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.RequestService=void 0;let u=class extends C.Disposable{constructor(h,p,S){super();this.environmentService=p,this.logService=S,this.configure(h.getValue()),this._register(h.onDidChangeConfiguration(()=>this.configure(h.getValue()),this))}configure(h){this.proxyUrl=h.http&&h.http.proxy,this.strictSSL=!!(h.http&&h.http.proxyStrictSSL),this.authorization=h.http&&h.http.proxyAuthorization}async request(h,p){this.logService.trace("RequestService#request",h.url);const{proxyUrl:S,strictSSL:f}=this;let s;try{s=await(0,y.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(o){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",o))}const a={...process.env,...s},n=h.agent?h.agent:await(0,d.getProxyAgent)(h.url||"",a,{proxyUrl:S,strictSSL:f});return h.agent=n,h.strictSSL=f,this.authorization&&(h.headers={...h.headers||{},"Proxy-Authorization":this.authorization}),this._request(h,p)}async getNodeRequest(h){return((0,T.parse)(h.url).protocol==="https:"?await new Promise((f,s)=>{x(["https"],f,s)}):await new Promise((f,s)=>{x(["http"],f,s)})).request}_request(h,p){return R.Promises.withAsyncBody(async(S,f)=>{let s;const a=(0,T.parse)(h.url),n=h.getRawRequest?h.getRawRequest(h):await this.getNodeRequest(h),o={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:h.type||"GET",headers:h.headers,agent:h.agent,rejectUnauthorized:(0,w.isBoolean)(h.strictSSL)?h.strictSSL:!0};h.user&&h.password&&(o.auth=h.user+":"+h.password),s=n(o,e=>{const t=(0,w.isNumber)(h.followRedirects)?h.followRedirects:3;if(e.statusCode&&e.statusCode>=300&&e.statusCode<400&&t>0&&e.headers.location)this._request({...h,url:e.headers.location,followRedirects:t-1},p).then(S,f);else{let r=e;e.headers["content-encoding"]==="gzip"&&(r=e.pipe((0,E.createGunzip)())),S({res:e,stream:(0,P.streamToBufferReadableStream)(r)})}}),s.on("error",f),h.timeout&&s.setTimeout(h.timeout),h.data&&typeof h.data=="string"&&s.write(h.data),s.end(),p.onCancellationRequested(()=>{s.abort(),f((0,D.canceled)())})})}async resolveProxy(h){}};u=pe([ae(0,c.IConfigurationService),ae(1,v.INativeEnvironmentService),ae(2,I.ILogService)],u),i.RequestService=u}),define(J[140],Q([0,1,33,3,17,27,7,2,11,6,28,9,13,25,106,51,112,20,90,119,22,108,128,16,100,102,39,97,53,54,111,15,103,121,32,43,129,117,30,120,35,122,123,36,125]),function(x,i,T,R,P,D,C,w,c,v,y,I,d,E,u,g,h,p,S,f,s,a,n,o,e,t,r,l,m,L,b,O,N,G,ee,ge,ce,te,he,W,B,ne,M,k,j){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.main=void 0;class H extends w.Disposable{constructor(Z){super();this.argv=Z,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[Z,_]=await this.initServices();return Z.invokeFunction(async ue=>{const U=ue.get(O.ILogService),A=ue.get(o.IFileService),$=ue.get(p.INativeEnvironmentService),z=ue.get(s.IExtensionManagementCLIService);U.info("CLI main",this.argv),this.registerErrorHandler(U),await this.doRun($,z,A),await Promise.all(_.map(X=>{(0,R.raceTimeout)(X.flush(),1e3)}))})}async initServices(){const Z=new m.ServiceCollection,_={_serviceBrand:void 0,...G.default};Z.set(ee.IProductService,_);const ue=new S.NativeEnvironmentService(this.argv,_);Z.set(p.INativeEnvironmentService,ue),await Promise.all([ue.appSettingsHome.fsPath,ue.extensionsPath].map(se=>se?d.Promises.mkdir(se,{recursive:!0}):void 0));const U=(0,O.getLogLevel)(ue),A=[];A.push(new N.SpdLogLogger("cli",(0,v.join)(ue.logsPath,"cli.log"),!0,!1,U)),U===O.LogLevel.Trace&&A.push(new O.ConsoleLogger(U));const $=this._register(new O.MultiplexLogService(A));Z.set(O.ILogService,$);const z=this._register(new e.FileService($));Z.set(o.IFileService,z);const X=this._register(new t.DiskFileSystemProvider($));z.registerProvider(c.Schemas.file,X);const Y=this._register(new u.ConfigurationService(ue.settingsResource,z));Z.set(E.IConfigurationService,Y),await Y.initialize(),Z.set(k.IUriIdentityService,new j.UriIdentityService(z)),Z.set(ge.IRequestService,new r.SyncDescriptor(ce.RequestService)),Z.set(g.IDownloadService,new r.SyncDescriptor(h.DownloadService)),Z.set(s.IExtensionManagementService,new r.SyncDescriptor(n.ExtensionManagementService)),Z.set(s.IExtensionGalleryService,new r.SyncDescriptor(f.ExtensionGalleryServiceWithNoStorageService)),Z.set(s.IExtensionManagementCLIService,new r.SyncDescriptor(a.ExtensionManagementCLIService)),Z.set(L.ILocalizationsService,new r.SyncDescriptor(b.LocalizationsService));const de=[];if((0,B.supportsTelemetry)(_,ue)){_.aiConfig&&_.aiConfig.asimovKey&&de.push(new ne.AppInsightsAppender("monacoworkbench",null,_.aiConfig.asimovKey));const{appRoot:se,extensionsPath:re,installSourcePath:oe}=ue,ye={appenders:de,sendErrorTelemetry:!1,commonProperties:(async()=>{let le;try{const Ee=await d.Promises.readFile((0,v.join)(ue.userDataPath,"storage.json"));le=JSON.parse(Ee.toString())[he.machineIdKey]}catch(Ee){Ee.code!=="ENOENT"&&$.error(Ee)}return(0,te.resolveCommonProperties)(z,(0,T.release)(),(0,T.hostname)(),process.arch,_.commit,_.version,le,_.msftInternalDomains,oe)})(),piiPaths:[se,re]};Z.set(he.ITelemetryService,new r.SyncDescriptor(W.TelemetryService,[ye]))}else Z.set(he.ITelemetryService,B.NullTelemetryService);return[new l.InstantiationService(Z),de]}registerErrorHandler(Z){(0,C.setUnexpectedErrorHandler)(_=>{const ue=(0,D.toErrorMessage)(_,!0);!ue||Z.error(`[uncaught exception in CLI]: ${ue}`)}),process.on("uncaughtException",_=>(0,C.onUnexpectedError)(_)),process.on("unhandledRejection",_=>(0,C.onUnexpectedError)(_))}async doRun(Z,_,ue){if(this.argv["install-source"])return this.setInstallSource(Z,ue,this.argv["install-source"]);if(this.argv["list-extensions"])return _.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const U={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"]};return _.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],U,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return _.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return _.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(Z.appRoot,Z.extensionsPath))}}asExtensionIdOrVSIX(Z){return Z.map(_=>/\.vsix$/i.test(_)?I.URI.file((0,v.isAbsolute)(_)?_:(0,v.join)((0,y.cwd)(),_)):_)}async setInstallSource(Z,_,ue){await _.writeFile(I.URI.file(Z.installSourcePath),P.VSBuffer.fromString(ue.slice(0,30)))}}async function ie(K){const Z=new H(K);try{await Z.run()}finally{Z.dispose()}}i.main=ie})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d12df34e31b4a018735d312a8947d79331132368/core/vs/code/node/cliProcessMain.js.map
