/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ee=["require","exports","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/network","vs/base/common/types","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/map","vs/base/common/buffer","vs/base/common/platform","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/base/common/uuid","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/extpath","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostWebview","vs/base/common/codicons","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/base/common/hash","vs/editor/common/modes","vs/editor/common/core/range","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/numbers","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/remote/common/tunnel","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/editor/common/core/position","vs/editor/common/modes/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/services/extensions/worker/extensionHostWorker"],ye=function(re){for(var e=[],a=0,t=re.length;a<t;a++)e[a]=Ee[re[a]];return e};define(Ee[41],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function a(t,w){if(!t)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=a}),define(Ee[51],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function a(k){return k?k.replace(/\$\((.*?)\)/g,(P,C)=>` ${C} `).trim():""}e.getCodiconAriaLabel=a;class t{constructor(P,C,R){this.id=P,this.definition=C,this.description=R,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function w(k,P){const C=["codicon","codicon-"+k];return P&&C.push("codicon-modifier-"+P),C}e.getClassNamesArray=w;var T;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function C(_){if(_ instanceof t)return["codicon","codicon-"+_.id];const n=P.exec(_.id);if(!n)return C(t.error);let[,f,o]=n;const g=["codicon","codicon-"+f];return o&&g.push("codicon-modifier-"+o.substr(1)),g}k.asClassNameArray=C;function R(_){return C(_).join(" ")}k.asClassName=R;function F(_){return"."+C(_).join(".")}k.asCSSSelector=F})(T=e.CSSIcon||(e.CSSIcon={}))}),define(Ee[74],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const a=Object.prototype.hasOwnProperty;function t(F){const _=[];for(let n in F)a.call(F,n)&&_.push(F[n]);return _}e.values=t;function w(F,_){for(let n in F)if(a.call(F,n)&&_({key:n,value:F[n]},function(){delete F[n]})===!1)return}e.forEach=w;function T(F,_){const n=Object.create(null);for(const f of F){const o=_(f);let g=n[o];g||(g=n[o]=[]),g.push(f)}return n}e.groupBy=T;function k(F){const _=Object.create(null);return F&&F.forEach((n,f)=>{_[f]=n}),_}e.fromMap=k;function P(F,_){const n=[],f=[];for(let o of F)_.has(o)||n.push(o);for(let o of _)F.has(o)||f.push(o);return{removed:n,added:f}}e.diffSets=P;function C(F,_){const n=[],f=[];for(let[o,g]of F)_.has(o)||n.push(g);for(let[o,g]of _)F.has(o)||f.push(g);return{removed:n,added:f}}e.diffMaps=C;class R{constructor(){this.map=new Map}add(_,n){let f=this.map.get(_);f||(f=new Set,this.map.set(_,f)),f.add(n)}delete(_,n){const f=this.map.get(_);!f||(f.delete(n),f.size===0&&this.map.delete(_))}forEach(_,n){const f=this.map.get(_);!f||f.forEach(n)}}e.SetMap=R}),define(Ee[52],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function a(k){return(P,C,R)=>{let F=null,_=null;if(typeof R.value=="function"?(F="value",_=R.value):typeof R.get=="function"&&(F="get",_=R.get),!_)throw new Error("not supported");R[F]=k(_,C)}}e.createDecorator=a;function t(k,P,C){let R=null,F=null;if(typeof C.value=="function"?(R="value",F=C.value,F.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(R="get",F=C.get),!F)throw new Error("not supported");const _=`$memoize$${P}`;C[R]=function(...n){return this.hasOwnProperty(_)||Object.defineProperty(this,_,{configurable:!1,enumerable:!1,writable:!1,value:F.apply(this,n)}),this[_]}}e.memoize=t;function w(k,P,C){return a((R,F)=>{const _=`$debounce$${F}`,n=`$debounce$result$${F}`;return function(...f){this[n]||(this[n]=C?C():void 0),clearTimeout(this[_]),P&&(this[n]=P(this[n],...f),f=[this[n]]),this[_]=setTimeout(()=>{R.apply(this,f),this[n]=C?C():void 0},k)}})}e.debounce=w;function T(k,P,C){return a((R,F)=>{const _=`$throttle$timer$${F}`,n=`$throttle$result$${F}`,f=`$throttle$lastRun$${F}`,o=`$throttle$pending$${F}`;return function(...g){if(this[n]||(this[n]=C?C():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),P&&(this[n]=P(this[n],...g)),this[o])return;const c=this[f]+k;c<=Date.now()?(this[f]=Date.now(),R.apply(this,[this[n]]),this[n]=C?C():void 0):(this[o]=!0,this[_]=setTimeout(()=>{this[o]=!1,this[f]=Date.now(),R.apply(this,[this[n]]),this[n]=C?C():void 0},c-Date.now()))}})}e.throttle=T}),define(Ee[53],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class a{constructor(w){this._prefix=w,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=a,e.defaultGenerator=new a("id#")}),define(Ee[100],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var a;(function(l){l[l.None=0]="None",l[l.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",l[l.UnexpectedEndOfString=2]="UnexpectedEndOfString",l[l.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",l[l.InvalidUnicode=4]="InvalidUnicode",l[l.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",l[l.InvalidCharacter=6]="InvalidCharacter"})(a=e.ScanError||(e.ScanError={}));var t;(function(l){l[l.OpenBraceToken=1]="OpenBraceToken",l[l.CloseBraceToken=2]="CloseBraceToken",l[l.OpenBracketToken=3]="OpenBracketToken",l[l.CloseBracketToken=4]="CloseBracketToken",l[l.CommaToken=5]="CommaToken",l[l.ColonToken=6]="ColonToken",l[l.NullKeyword=7]="NullKeyword",l[l.TrueKeyword=8]="TrueKeyword",l[l.FalseKeyword=9]="FalseKeyword",l[l.StringLiteral=10]="StringLiteral",l[l.NumericLiteral=11]="NumericLiteral",l[l.LineCommentTrivia=12]="LineCommentTrivia",l[l.BlockCommentTrivia=13]="BlockCommentTrivia",l[l.LineBreakTrivia=14]="LineBreakTrivia",l[l.Trivia=15]="Trivia",l[l.Unknown=16]="Unknown",l[l.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var w;(function(l){l[l.InvalidSymbol=1]="InvalidSymbol",l[l.InvalidNumberFormat=2]="InvalidNumberFormat",l[l.PropertyNameExpected=3]="PropertyNameExpected",l[l.ValueExpected=4]="ValueExpected",l[l.ColonExpected=5]="ColonExpected",l[l.CommaExpected=6]="CommaExpected",l[l.CloseBraceExpected=7]="CloseBraceExpected",l[l.CloseBracketExpected=8]="CloseBracketExpected",l[l.EndOfFileExpected=9]="EndOfFileExpected",l[l.InvalidCommentToken=10]="InvalidCommentToken",l[l.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",l[l.UnexpectedEndOfString=12]="UnexpectedEndOfString",l[l.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",l[l.InvalidUnicode=14]="InvalidUnicode",l[l.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",l[l.InvalidCharacter=16]="InvalidCharacter"})(w=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(l){l.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function k(l,M=!1){let r=0,i=l.length,m="",d=0,s=16,b=0;function y(L){let z=0,N=0;for(;z<L;){const B=l.charCodeAt(r);if(B>=48&&B<=57)N=N*16+B-48;else if(B>=65&&B<=70)N=N*16+B-65+10;else if(B>=97&&B<=102)N=N*16+B-97+10;else break;r++,z++}return z<L&&(N=-1),N}function u(L){r=L,m="",d=0,s=16,b=0}function S(){const L=r;if(l.charCodeAt(r)===48)r++;else for(r++;r<l.length&&R(l.charCodeAt(r));)r++;if(r<l.length&&l.charCodeAt(r)===46)if(r++,r<l.length&&R(l.charCodeAt(r)))for(r++;r<l.length&&R(l.charCodeAt(r));)r++;else return b=3,l.substring(L,r);let z=r;if(r<l.length&&(l.charCodeAt(r)===69||l.charCodeAt(r)===101))if(r++,(r<l.length&&l.charCodeAt(r)===43||l.charCodeAt(r)===45)&&r++,r<l.length&&R(l.charCodeAt(r))){for(r++;r<l.length&&R(l.charCodeAt(r));)r++;z=r}else b=3;return l.substring(L,z)}function A(){let L="",z=r;for(;;){if(r>=i){L+=l.substring(z,r),b=2;break}const N=l.charCodeAt(r);if(N===34){L+=l.substring(z,r),r++;break}if(N===92){if(L+=l.substring(z,r),r++,r>=i){b=2;break}switch(l.charCodeAt(r++)){case 34:L+='"';break;case 92:L+="\\";break;case 47:L+="/";break;case 98:L+="\b";break;case 102:L+="\f";break;case 110:L+=`
`;break;case 114:L+="\r";break;case 116:L+="	";break;case 117:{const j=y(4);j>=0?L+=String.fromCharCode(j):b=4;break}default:b=5}z=r;continue}if(N>=0&&N<=31)if(C(N)){L+=l.substring(z,r),b=2;break}else b=6;r++}return L}function U(){if(m="",b=0,d=r,r>=i)return d=i,s=17;let L=l.charCodeAt(r);if(P(L)){do r++,m+=String.fromCharCode(L),L=l.charCodeAt(r);while(P(L));return s=15}if(C(L))return r++,m+=String.fromCharCode(L),L===13&&l.charCodeAt(r)===10&&(r++,m+=`
`),s=14;switch(L){case 123:return r++,s=1;case 125:return r++,s=2;case 91:return r++,s=3;case 93:return r++,s=4;case 58:return r++,s=6;case 44:return r++,s=5;case 34:return r++,m=A(),s=10;case 47:{const z=r-1;if(l.charCodeAt(r+1)===47){for(r+=2;r<i&&!C(l.charCodeAt(r));)r++;return m=l.substring(z,r),s=12}if(l.charCodeAt(r+1)===42){r+=2;const N=i-1;let B=!1;for(;r<N;){if(l.charCodeAt(r)===42&&l.charCodeAt(r+1)===47){r+=2,B=!0;break}r++}return B||(r++,b=1),m=l.substring(z,r),s=13}return m+=String.fromCharCode(L),r++,s=16}case 45:if(m+=String.fromCharCode(L),r++,r===i||!R(l.charCodeAt(r)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return m+=S(),s=11;default:for(;r<i&&H(L);)r++,L=l.charCodeAt(r);if(d!==r){switch(m=l.substring(d,r),m){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return m+=String.fromCharCode(L),r++,s=16}}function H(L){if(P(L)||C(L))return!1;switch(L){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function E(){let L;do L=U();while(L>=12&&L<=15);return L}return{setPosition:u,getPosition:()=>r,scan:M?E:U,getToken:()=>s,getTokenValue:()=>m,getTokenOffset:()=>d,getTokenLength:()=>r-d,getTokenError:()=>b}}e.createScanner=k;function P(l){return l===32||l===9||l===11||l===12||l===160||l===5760||l>=8192&&l<=8203||l===8239||l===8287||l===12288||l===65279}function C(l){return l===10||l===13||l===8232||l===8233}function R(l){return l>=48&&l<=57}var F;(function(l){l[l.nullCharacter=0]="nullCharacter",l[l.maxAsciiCharacter=127]="maxAsciiCharacter",l[l.lineFeed=10]="lineFeed",l[l.carriageReturn=13]="carriageReturn",l[l.lineSeparator=8232]="lineSeparator",l[l.paragraphSeparator=8233]="paragraphSeparator",l[l.nextLine=133]="nextLine",l[l.space=32]="space",l[l.nonBreakingSpace=160]="nonBreakingSpace",l[l.enQuad=8192]="enQuad",l[l.emQuad=8193]="emQuad",l[l.enSpace=8194]="enSpace",l[l.emSpace=8195]="emSpace",l[l.threePerEmSpace=8196]="threePerEmSpace",l[l.fourPerEmSpace=8197]="fourPerEmSpace",l[l.sixPerEmSpace=8198]="sixPerEmSpace",l[l.figureSpace=8199]="figureSpace",l[l.punctuationSpace=8200]="punctuationSpace",l[l.thinSpace=8201]="thinSpace",l[l.hairSpace=8202]="hairSpace",l[l.zeroWidthSpace=8203]="zeroWidthSpace",l[l.narrowNoBreakSpace=8239]="narrowNoBreakSpace",l[l.ideographicSpace=12288]="ideographicSpace",l[l.mathematicalSpace=8287]="mathematicalSpace",l[l.ogham=5760]="ogham",l[l._=95]="_",l[l.$=36]="$",l[l._0=48]="_0",l[l._1=49]="_1",l[l._2=50]="_2",l[l._3=51]="_3",l[l._4=52]="_4",l[l._5=53]="_5",l[l._6=54]="_6",l[l._7=55]="_7",l[l._8=56]="_8",l[l._9=57]="_9",l[l.a=97]="a",l[l.b=98]="b",l[l.c=99]="c",l[l.d=100]="d",l[l.e=101]="e",l[l.f=102]="f",l[l.g=103]="g",l[l.h=104]="h",l[l.i=105]="i",l[l.j=106]="j",l[l.k=107]="k",l[l.l=108]="l",l[l.m=109]="m",l[l.n=110]="n",l[l.o=111]="o",l[l.p=112]="p",l[l.q=113]="q",l[l.r=114]="r",l[l.s=115]="s",l[l.t=116]="t",l[l.u=117]="u",l[l.v=118]="v",l[l.w=119]="w",l[l.x=120]="x",l[l.y=121]="y",l[l.z=122]="z",l[l.A=65]="A",l[l.B=66]="B",l[l.C=67]="C",l[l.D=68]="D",l[l.E=69]="E",l[l.F=70]="F",l[l.G=71]="G",l[l.H=72]="H",l[l.I=73]="I",l[l.J=74]="J",l[l.K=75]="K",l[l.L=76]="L",l[l.M=77]="M",l[l.N=78]="N",l[l.O=79]="O",l[l.P=80]="P",l[l.Q=81]="Q",l[l.R=82]="R",l[l.S=83]="S",l[l.T=84]="T",l[l.U=85]="U",l[l.V=86]="V",l[l.W=87]="W",l[l.X=88]="X",l[l.Y=89]="Y",l[l.Z=90]="Z",l[l.ampersand=38]="ampersand",l[l.asterisk=42]="asterisk",l[l.at=64]="at",l[l.backslash=92]="backslash",l[l.bar=124]="bar",l[l.caret=94]="caret",l[l.closeBrace=125]="closeBrace",l[l.closeBracket=93]="closeBracket",l[l.closeParen=41]="closeParen",l[l.colon=58]="colon",l[l.comma=44]="comma",l[l.dot=46]="dot",l[l.doubleQuote=34]="doubleQuote",l[l.equals=61]="equals",l[l.exclamation=33]="exclamation",l[l.greaterThan=62]="greaterThan",l[l.lessThan=60]="lessThan",l[l.minus=45]="minus",l[l.openBrace=123]="openBrace",l[l.openBracket=91]="openBracket",l[l.openParen=40]="openParen",l[l.percent=37]="percent",l[l.plus=43]="plus",l[l.question=63]="question",l[l.semicolon=59]="semicolon",l[l.singleQuote=39]="singleQuote",l[l.slash=47]="slash",l[l.tilde=126]="tilde",l[l.backspace=8]="backspace",l[l.formFeed=12]="formFeed",l[l.byteOrderMark=65279]="byteOrderMark",l[l.tab=9]="tab",l[l.verticalTab=11]="verticalTab"})(F||(F={}));function _(l,M){const r=[],i=new Object;let m;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function b(y,u,S,A){d.value=y,d.offset=u,d.length=S,d.type=A,d.colonOffset=void 0,m=d}try{h(l,{onObjectBegin:(y,u)=>{if(M<=y)throw i;m=void 0,s=M>y,r.push("")},onObjectProperty:(y,u,S)=>{if(M<u||(b(y,u,S,"property"),r[r.length-1]=y,M<=u+S))throw i},onObjectEnd:(y,u)=>{if(M<=y)throw i;m=void 0,r.pop()},onArrayBegin:(y,u)=>{if(M<=y)throw i;m=void 0,r.push(0)},onArrayEnd:(y,u)=>{if(M<=y)throw i;m=void 0,r.pop()},onLiteralValue:(y,u,S)=>{if(M<u||(b(y,u,S,I(y)),M<=u+S))throw i},onSeparator:(y,u,S)=>{if(M<=u)throw i;if(y===":"&&m&&m.type==="property")m.colonOffset=u,s=!1,m=void 0;else if(y===","){const A=r[r.length-1];typeof A=="number"?r[r.length-1]=A+1:(s=!0,r[r.length-1]=""),m=void 0}}})}catch(y){if(y!==i)throw y}return{path:r,previousNode:m,isAtPropertyKey:s,matches:y=>{let u=0;for(let S=0;u<y.length&&S<r.length;S++)if(y[u]===r[S]||y[u]==="*")u++;else if(y[u]!=="**")return!1;return u===y.length}}}e.getLocation=_;function n(l,M=[],r=T.DEFAULT){let i=null,m=[];const d=[];function s(y){Array.isArray(m)?m.push(y):i!==null&&(m[i]=y)}return h(l,{onObjectBegin:()=>{const y={};s(y),d.push(m),m=y,i=null},onObjectProperty:y=>{i=y},onObjectEnd:()=>{m=d.pop()},onArrayBegin:()=>{const y=[];s(y),d.push(m),m=y,i=null},onArrayEnd:()=>{m=d.pop()},onLiteralValue:s,onError:(y,u,S)=>{M.push({error:y,offset:u,length:S})}},r),m[0]}e.parse=n;function f(l,M=[],r=T.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function m(y){i.type==="property"&&(i.length=y-i.offset,i=i.parent)}function d(y){return i.children.push(y),y}h(l,{onObjectBegin:y=>{i=d({type:"object",offset:y,length:-1,parent:i,children:[]})},onObjectProperty:(y,u,S)=>{i=d({type:"property",offset:u,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:y,offset:u,length:S,parent:i})},onObjectEnd:(y,u)=>{i.length=y+u-i.offset,i=i.parent,m(y+u)},onArrayBegin:(y,u)=>{i=d({type:"array",offset:y,length:-1,parent:i,children:[]})},onArrayEnd:(y,u)=>{i.length=y+u-i.offset,i=i.parent,m(y+u)},onLiteralValue:(y,u,S)=>{d({type:I(y),offset:u,length:S,parent:i,value:y}),m(u+S)},onSeparator:(y,u,S)=>{i.type==="property"&&(y===":"?i.colonOffset=u:y===","&&m(u))},onError:(y,u,S)=>{M.push({error:y,offset:u,length:S})}},r);const b=i.children[0];return b&&delete b.parent,b}e.parseTree=f;function o(l,M){if(!l)return;let r=l;for(let i of M)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let m=!1;for(const d of r.children)if(Array.isArray(d.children)&&d.children[0].value===i){r=d.children[1],m=!0;break}if(!m)return}else{const m=i;if(r.type!=="array"||m<0||!Array.isArray(r.children)||m>=r.children.length)return;r=r.children[m]}return r}e.findNodeAtLocation=o;function g(l){if(!l.parent||!l.parent.children)return[];const M=g(l.parent);if(l.parent.type==="property"){const r=l.parent.children[0].value;M.push(r)}else if(l.parent.type==="array"){const r=l.parent.children.indexOf(l);r!==-1&&M.push(r)}return M}e.getNodePath=g;function c(l){switch(l.type){case"array":return l.children.map(c);case"object":{const M=Object.create(null);for(let r of l.children){const i=r.children[1];i&&(M[r.children[0].value]=c(i))}return M}case"null":case"string":case"number":case"boolean":return l.value;default:return}}e.getNodeValue=c;function D(l,M,r=!1){return M>=l.offset&&M<l.offset+l.length||r&&M===l.offset+l.length}e.contains=D;function v(l,M,r=!1){if(D(l,M,r)){const i=l.children;if(Array.isArray(i))for(let m=0;m<i.length&&i[m].offset<=M;m++){const d=v(i[m],M,r);if(d)return d}return l}}e.findNodeAtOffset=v;function h(l,M,r=T.DEFAULT){const i=k(l,!1);function m(ie){return ie?()=>ie(i.getTokenOffset(),i.getTokenLength()):()=>!0}function d(ie){return ie?we=>ie(we,i.getTokenOffset(),i.getTokenLength()):()=>!0}const s=m(M.onObjectBegin),b=d(M.onObjectProperty),y=m(M.onObjectEnd),u=m(M.onArrayBegin),S=m(M.onArrayEnd),A=d(M.onLiteralValue),U=d(M.onSeparator),H=m(M.onComment),E=d(M.onError),L=r&&r.disallowComments,z=r&&r.allowTrailingComma;function N(){for(;;){const ie=i.scan();switch(i.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:L||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(ie){case 12:case 13:L?B(10):H();break;case 16:B(1);break;case 15:case 14:break;default:return ie}}}function B(ie,we=[],Me=[]){if(E(ie),we.length+Me.length>0){let Re=i.getToken();for(;Re!==17;){if(we.indexOf(Re)!==-1){N();break}else if(Me.indexOf(Re)!==-1)break;Re=N()}}}function j(ie){const we=i.getTokenValue();return ie?A(we):b(we),N(),!0}function ce(){switch(i.getToken()){case 11:{let ie=0;try{ie=JSON.parse(i.getTokenValue()),typeof ie!="number"&&(B(2),ie=0)}catch{B(2)}A(ie);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return N(),!0}function K(){return i.getToken()!==10?(B(3,[],[2,5]),!1):(j(!1),i.getToken()===6?(U(":"),N(),Y()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function le(){s(),N();let ie=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(ie||B(4,[],[]),U(","),N(),i.getToken()===2&&z)break}else ie&&B(6,[],[]);K()||B(4,[],[2,5]),ie=!0}return y(),i.getToken()!==2?B(7,[2],[]):N(),!0}function ue(){u(),N();let ie=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(ie||B(4,[],[]),U(","),N(),i.getToken()===4&&z)break}else ie&&B(6,[],[]);Y()||B(4,[],[4,5]),ie=!0}return S(),i.getToken()!==4?B(8,[4],[]):N(),!0}function Y(){switch(i.getToken()){case 3:return ue();case 1:return le();case 10:return j(!0);default:return ce()}}return N(),i.getToken()===17?r.allowEmptyContent?!0:(B(4,[],[]),!1):Y()?(i.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}e.visit=h;function p(l,M){let r=k(l),i=[],m,d=0,s;do switch(s=r.getPosition(),m=r.scan(),m){case 12:case 13:case 17:d!==s&&i.push(l.substring(d,s)),M!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,M)),d=r.getPosition();break}while(m!==17);return i.join("")}e.stripComments=p;function I(l){switch(typeof l){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(l){if(Array.isArray(l))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=I}),define(Ee[101],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class a{constructor(w){this.executor=w,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(w){this._error=w}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(w){return new a(()=>w(this.getValue()))}}e.Lazy=a}),function(re,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(re=typeof globalThis!="undefined"?globalThis:re||self,re.marked=e())}(this,function(){"use strict";function re(Ie,Ce){for(var ve=0;ve<Ce.length;ve++){var oe=Ce[ve];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(Ie,oe.key,oe)}}function e(Ie,Ce,ve){return Ce&&re(Ie.prototype,Ce),ve&&re(Ie,ve),Ie}function a(Ie,Ce){if(!!Ie){if(typeof Ie=="string")return t(Ie,Ce);var ve=Object.prototype.toString.call(Ie).slice(8,-1);if(ve==="Object"&&Ie.constructor&&(ve=Ie.constructor.name),ve==="Map"||ve==="Set")return Array.from(Ie);if(ve==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ve))return t(Ie,Ce)}}function t(Ie,Ce){(Ce==null||Ce>Ie.length)&&(Ce=Ie.length);for(var ve=0,oe=new Array(Ce);ve<Ce;ve++)oe[ve]=Ie[ve];return oe}function w(Ie,Ce){var ve=typeof Symbol!="undefined"&&Ie[Symbol.iterator]||Ie["@@iterator"];if(ve)return(ve=ve.call(Ie)).next.bind(ve);if(Array.isArray(Ie)||(ve=a(Ie))||Ce&&Ie&&typeof Ie.length=="number"){ve&&(Ie=ve);var oe=0;return function(){return oe>=Ie.length?{done:!0}:{done:!1,value:Ie[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var T={exports:{}};function k(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function P(Ie){T.exports.defaults=Ie}T.exports={defaults:k(),getDefaults:k,changeDefaults:P};var C=/[&<>"']/,R=/[&<>"']/g,F=/[<>"']|&(?!#?\w+;)/,_=/[<>"']|&(?!#?\w+;)/g,n={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},f=function(Ce){return n[Ce]};function o(Ie,Ce){if(Ce){if(C.test(Ie))return Ie.replace(R,f)}else if(F.test(Ie))return Ie.replace(_,f);return Ie}var g=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function c(Ie){return Ie.replace(g,function(Ce,ve){return ve=ve.toLowerCase(),ve==="colon"?":":ve.charAt(0)==="#"?ve.charAt(1)==="x"?String.fromCharCode(parseInt(ve.substring(2),16)):String.fromCharCode(+ve.substring(1)):""})}var D=/(^|[^\[])\^/g;function v(Ie,Ce){Ie=Ie.source||Ie,Ce=Ce||"";var ve={replace:function(se,fe){return fe=fe.source||fe,fe=fe.replace(D,"$1"),Ie=Ie.replace(se,fe),ve},getRegex:function(){return new RegExp(Ie,Ce)}};return ve}var h=/[^\w:]/g,p=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function I(Ie,Ce,ve){if(Ie){var oe;try{oe=decodeURIComponent(c(ve)).replace(h,"").toLowerCase()}catch{return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}Ce&&!p.test(ve)&&(ve=m(Ce,ve));try{ve=encodeURI(ve).replace(/%25/g,"%")}catch{return null}return ve}var l={},M=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function m(Ie,Ce){l[" "+Ie]||(M.test(Ie)?l[" "+Ie]=Ie+"/":l[" "+Ie]=y(Ie,"/",!0)),Ie=l[" "+Ie];var ve=Ie.indexOf(":")===-1;return Ce.substring(0,2)==="//"?ve?Ce:Ie.replace(r,"$1")+Ce:Ce.charAt(0)==="/"?ve?Ce:Ie.replace(i,"$1")+Ce:Ie+Ce}var d={exec:function(){}};function s(Ie){for(var Ce=1,ve,oe;Ce<arguments.length;Ce++){ve=arguments[Ce];for(oe in ve)Object.prototype.hasOwnProperty.call(ve,oe)&&(Ie[oe]=ve[oe])}return Ie}function b(Ie,Ce){var ve=Ie.replace(/\|/g,function(fe,ge,ke){for(var ze=!1,Oe=ge;--Oe>=0&&ke[Oe]==="\\";)ze=!ze;return ze?"|":" |"}),oe=ve.split(/ \|/),se=0;if(oe[0].trim()||oe.shift(),oe[oe.length-1].trim()||oe.pop(),oe.length>Ce)oe.splice(Ce);else for(;oe.length<Ce;)oe.push("");for(;se<oe.length;se++)oe[se]=oe[se].trim().replace(/\\\|/g,"|");return oe}function y(Ie,Ce,ve){var oe=Ie.length;if(oe===0)return"";for(var se=0;se<oe;){var fe=Ie.charAt(oe-se-1);if(fe===Ce&&!ve)se++;else if(fe!==Ce&&ve)se++;else break}return Ie.substr(0,oe-se)}function u(Ie,Ce){if(Ie.indexOf(Ce[1])===-1)return-1;for(var ve=Ie.length,oe=0,se=0;se<ve;se++)if(Ie[se]==="\\")se++;else if(Ie[se]===Ce[0])oe++;else if(Ie[se]===Ce[1]&&(oe--,oe<0))return se;return-1}function S(Ie){Ie&&Ie.sanitize&&!Ie.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(Ie,Ce){if(Ce<1)return"";for(var ve="";Ce>1;)Ce&1&&(ve+=Ie),Ce>>=1,Ie+=Ie;return ve+Ie}var U={escape:o,unescape:c,edit:v,cleanUrl:I,resolveUrl:m,noopTest:d,merge:s,splitCells:b,rtrim:y,findClosingBracket:u,checkSanitizeDeprecation:S,repeatString:A},H=T.exports.defaults,E=U.rtrim,L=U.splitCells,z=U.escape,N=U.findClosingBracket;function B(Ie,Ce,ve,oe){var se=Ce.href,fe=Ce.title?z(Ce.title):null,ge=Ie[1].replace(/\\([\[\]])/g,"$1");if(Ie[0].charAt(0)!=="!"){oe.state.inLink=!0;var ke={type:"link",raw:ve,href:se,title:fe,text:ge,tokens:oe.inlineTokens(ge,[])};return oe.state.inLink=!1,ke}else return{type:"image",raw:ve,href:se,title:fe,text:z(ge)}}function j(Ie,Ce){var ve=Ie.match(/^(\s+)(?:```)/);if(ve===null)return Ce;var oe=ve[1];return Ce.split(`
`).map(function(se){var fe=se.match(/^\s+/);if(fe===null)return se;var ge=fe[0];return ge.length>=oe.length?se.slice(oe.length):se}).join(`
`)}var ce=function(){function Ie(ve){this.options=ve||H}var Ce=Ie.prototype;return Ce.space=function(oe){var se=this.rules.block.newline.exec(oe);if(se)return se[0].length>1?{type:"space",raw:se[0]}:{raw:`
`}},Ce.code=function(oe){var se=this.rules.block.code.exec(oe);if(se){var fe=se[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:se[0],codeBlockStyle:"indented",text:this.options.pedantic?fe:E(fe,`
`)}}},Ce.fences=function(oe){var se=this.rules.block.fences.exec(oe);if(se){var fe=se[0],ge=j(fe,se[3]||"");return{type:"code",raw:fe,lang:se[2]?se[2].trim():se[2],text:ge}}},Ce.heading=function(oe){var se=this.rules.block.heading.exec(oe);if(se){var fe=se[2].trim();if(/#$/.test(fe)){var ge=E(fe,"#");(this.options.pedantic||!ge||/ $/.test(ge))&&(fe=ge.trim())}var ke={type:"heading",raw:se[0],depth:se[1].length,text:fe,tokens:[]};return this.lexer.inline(ke.text,ke.tokens),ke}},Ce.hr=function(oe){var se=this.rules.block.hr.exec(oe);if(se)return{type:"hr",raw:se[0]}},Ce.blockquote=function(oe){var se=this.rules.block.blockquote.exec(oe);if(se){var fe=se[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:se[0],tokens:this.lexer.blockTokens(fe,[]),text:fe}}},Ce.list=function(oe){var se=this.rules.block.list.exec(oe);if(se){var fe,ge,ke,ze,Oe,Ve,it,rt,ne,pe,ee=se[1].trim(),W=ee.length>1,be={type:"list",raw:"",ordered:W,start:W?+ee.slice(0,-1):"",loose:!1,items:[]};ee=W?"\\d{1,9}\\"+ee.slice(-1):"\\"+ee,this.options.pedantic&&(ee=W?ee:"[*+-]");for(var De=new RegExp("^( {0,3}"+ee+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");oe&&!(this.rules.block.hr.test(oe)||!(se=De.exec(oe)));){ne=se[2].split(`
`),this.options.pedantic?(ze=2,pe=ne[0].trimLeft()):(ze=se[2].search(/[^ ]/),ze=se[1].length+(ze>4?1:ze),pe=ne[0].slice(ze-se[1].length)),Ve=!1,fe=se[0],!ne[0]&&/^ *$/.test(ne[1])&&(fe=se[1]+ne.slice(0,2).join(`
`)+`
`,be.loose=!0,ne=[]);var qe=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Oe=1;Oe<ne.length;Oe++){if(rt=ne[Oe],this.options.pedantic&&(rt=rt.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),qe.test(rt)){fe=se[1]+ne.slice(0,Oe).join(`
`)+`
`;break}if(!Ve){rt.trim()||(Ve=!0),rt.search(/[^ ]/)>=ze?pe+=`
`+rt.slice(ze):pe+=`
`+rt;continue}if(rt.search(/[^ ]/)>=ze||!rt.trim()){pe+=`
`+rt.slice(ze);continue}else{fe=se[1]+ne.slice(0,Oe).join(`
`)+`
`;break}}be.loose||(it?be.loose=!0:/\n *\n *$/.test(fe)&&(it=!0)),this.options.gfm&&(ge=/^\[[ xX]\] /.exec(pe),ge&&(ke=ge[0]!=="[ ] ",pe=pe.replace(/^\[[ xX]\] +/,""))),be.items.push({type:"list_item",raw:fe,task:!!ge,checked:ke,loose:!1,text:pe}),be.raw+=fe,oe=oe.slice(fe.length)}be.items[be.items.length-1].raw=fe.trimRight(),be.items[be.items.length-1].text=pe.trimRight(),be.raw=be.raw.trimRight();var xe=be.items.length;for(Oe=0;Oe<xe;Oe++)this.lexer.state.top=!1,be.items[Oe].tokens=this.lexer.blockTokens(be.items[Oe].text,[]),be.items[Oe].tokens.some(function(ut){return ut.type==="space"})&&(be.loose=!0,be.items[Oe].loose=!0);return be}},Ce.html=function(oe){var se=this.rules.block.html.exec(oe);if(se){var fe={type:"html",raw:se[0],pre:!this.options.sanitizer&&(se[1]==="pre"||se[1]==="script"||se[1]==="style"),text:se[0]};return this.options.sanitize&&(fe.type="paragraph",fe.text=this.options.sanitizer?this.options.sanitizer(se[0]):z(se[0]),fe.tokens=[],this.lexer.inline(fe.text,fe.tokens)),fe}},Ce.def=function(oe){var se=this.rules.block.def.exec(oe);if(se){se[3]&&(se[3]=se[3].substring(1,se[3].length-1));var fe=se[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:fe,raw:se[0],href:se[2],title:se[3]}}},Ce.table=function(oe){var se=this.rules.block.table.exec(oe);if(se){var fe={type:"table",header:L(se[1]).map(function(it){return{text:it}}),align:se[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:se[3]?se[3].replace(/\n$/,"").split(`
`):[]};if(fe.header.length===fe.align.length){fe.raw=se[0];var ge=fe.align.length,ke,ze,Oe,Ve;for(ke=0;ke<ge;ke++)/^ *-+: *$/.test(fe.align[ke])?fe.align[ke]="right":/^ *:-+: *$/.test(fe.align[ke])?fe.align[ke]="center":/^ *:-+ *$/.test(fe.align[ke])?fe.align[ke]="left":fe.align[ke]=null;for(ge=fe.rows.length,ke=0;ke<ge;ke++)fe.rows[ke]=L(fe.rows[ke],fe.header.length).map(function(it){return{text:it}});for(ge=fe.header.length,ze=0;ze<ge;ze++)fe.header[ze].tokens=[],this.lexer.inlineTokens(fe.header[ze].text,fe.header[ze].tokens);for(ge=fe.rows.length,ze=0;ze<ge;ze++)for(Ve=fe.rows[ze],Oe=0;Oe<Ve.length;Oe++)Ve[Oe].tokens=[],this.lexer.inlineTokens(Ve[Oe].text,Ve[Oe].tokens);return fe}}},Ce.lheading=function(oe){var se=this.rules.block.lheading.exec(oe);if(se){var fe={type:"heading",raw:se[0],depth:se[2].charAt(0)==="="?1:2,text:se[1],tokens:[]};return this.lexer.inline(fe.text,fe.tokens),fe}},Ce.paragraph=function(oe){var se=this.rules.block.paragraph.exec(oe);if(se){var fe={type:"paragraph",raw:se[0],text:se[1].charAt(se[1].length-1)===`
`?se[1].slice(0,-1):se[1],tokens:[]};return this.lexer.inline(fe.text,fe.tokens),fe}},Ce.text=function(oe){var se=this.rules.block.text.exec(oe);if(se){var fe={type:"text",raw:se[0],text:se[0],tokens:[]};return this.lexer.inline(fe.text,fe.tokens),fe}},Ce.escape=function(oe){var se=this.rules.inline.escape.exec(oe);if(se)return{type:"escape",raw:se[0],text:z(se[1])}},Ce.tag=function(oe){var se=this.rules.inline.tag.exec(oe);if(se)return!this.lexer.state.inLink&&/^<a /i.test(se[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(se[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(se[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(se[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:se[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):z(se[0]):se[0]}},Ce.link=function(oe){var se=this.rules.inline.link.exec(oe);if(se){var fe=se[2].trim();if(!this.options.pedantic&&/^</.test(fe)){if(!/>$/.test(fe))return;var ge=E(fe.slice(0,-1),"\\");if((fe.length-ge.length)%2==0)return}else{var ke=N(se[2],"()");if(ke>-1){var ze=se[0].indexOf("!")===0?5:4,Oe=ze+se[1].length+ke;se[2]=se[2].substring(0,ke),se[0]=se[0].substring(0,Oe).trim(),se[3]=""}}var Ve=se[2],it="";if(this.options.pedantic){var rt=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ve);rt&&(Ve=rt[1],it=rt[3])}else it=se[3]?se[3].slice(1,-1):"";return Ve=Ve.trim(),/^</.test(Ve)&&(this.options.pedantic&&!/>$/.test(fe)?Ve=Ve.slice(1):Ve=Ve.slice(1,-1)),B(se,{href:Ve&&Ve.replace(this.rules.inline._escapes,"$1"),title:it&&it.replace(this.rules.inline._escapes,"$1")},se[0],this.lexer)}},Ce.reflink=function(oe,se){var fe;if((fe=this.rules.inline.reflink.exec(oe))||(fe=this.rules.inline.nolink.exec(oe))){var ge=(fe[2]||fe[1]).replace(/\s+/g," ");if(ge=se[ge.toLowerCase()],!ge||!ge.href){var ke=fe[0].charAt(0);return{type:"text",raw:ke,text:ke}}return B(fe,ge,fe[0],this.lexer)}},Ce.emStrong=function(oe,se,fe){fe===void 0&&(fe="");var ge=this.rules.inline.emStrong.lDelim.exec(oe);if(!!ge&&!(ge[3]&&fe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ke=ge[1]||ge[2]||"";if(!ke||ke&&(fe===""||this.rules.inline.punctuation.exec(fe))){var ze=ge[0].length-1,Oe,Ve,it=ze,rt=0,ne=ge[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ne.lastIndex=0,se=se.slice(-1*oe.length+ze);(ge=ne.exec(se))!=null;)if(Oe=ge[1]||ge[2]||ge[3]||ge[4]||ge[5]||ge[6],!!Oe){if(Ve=Oe.length,ge[3]||ge[4]){it+=Ve;continue}else if((ge[5]||ge[6])&&ze%3&&!((ze+Ve)%3)){rt+=Ve;continue}if(it-=Ve,!(it>0)){if(Ve=Math.min(Ve,Ve+it+rt),Math.min(ze,Ve)%2){var pe=oe.slice(1,ze+ge.index+Ve);return{type:"em",raw:oe.slice(0,ze+ge.index+Ve+1),text:pe,tokens:this.lexer.inlineTokens(pe,[])}}var ee=oe.slice(2,ze+ge.index+Ve-1);return{type:"strong",raw:oe.slice(0,ze+ge.index+Ve+1),text:ee,tokens:this.lexer.inlineTokens(ee,[])}}}}}},Ce.codespan=function(oe){var se=this.rules.inline.code.exec(oe);if(se){var fe=se[2].replace(/\n/g," "),ge=/[^ ]/.test(fe),ke=/^ /.test(fe)&&/ $/.test(fe);return ge&&ke&&(fe=fe.substring(1,fe.length-1)),fe=z(fe,!0),{type:"codespan",raw:se[0],text:fe}}},Ce.br=function(oe){var se=this.rules.inline.br.exec(oe);if(se)return{type:"br",raw:se[0]}},Ce.del=function(oe){var se=this.rules.inline.del.exec(oe);if(se)return{type:"del",raw:se[0],text:se[2],tokens:this.lexer.inlineTokens(se[2],[])}},Ce.autolink=function(oe,se){var fe=this.rules.inline.autolink.exec(oe);if(fe){var ge,ke;return fe[2]==="@"?(ge=z(this.options.mangle?se(fe[1]):fe[1]),ke="mailto:"+ge):(ge=z(fe[1]),ke=ge),{type:"link",raw:fe[0],text:ge,href:ke,tokens:[{type:"text",raw:ge,text:ge}]}}},Ce.url=function(oe,se){var fe;if(fe=this.rules.inline.url.exec(oe)){var ge,ke;if(fe[2]==="@")ge=z(this.options.mangle?se(fe[0]):fe[0]),ke="mailto:"+ge;else{var ze;do ze=fe[0],fe[0]=this.rules.inline._backpedal.exec(fe[0])[0];while(ze!==fe[0]);ge=z(fe[0]),fe[1]==="www."?ke="http://"+ge:ke=ge}return{type:"link",raw:fe[0],text:ge,href:ke,tokens:[{type:"text",raw:ge,text:ge}]}}},Ce.inlineText=function(oe,se){var fe=this.rules.inline.text.exec(oe);if(fe){var ge;return this.lexer.state.inRawBlock?ge=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):z(fe[0]):fe[0]:ge=z(this.options.smartypants?se(fe[0]):fe[0]),{type:"text",raw:fe[0],text:ge}}},Ie}(),K=U.noopTest,le=U.edit,ue=U.merge,Y={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:K,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};Y._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,Y._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,Y.def=le(Y.def).replace("label",Y._label).replace("title",Y._title).getRegex(),Y.bullet=/(?:[*+-]|\d{1,9}[.)])/,Y.listItemStart=le(/^( *)(bull) */).replace("bull",Y.bullet).getRegex(),Y.list=le(Y.list).replace(/bull/g,Y.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+Y.def.source+")").getRegex(),Y._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",Y._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,Y.html=le(Y.html,"i").replace("comment",Y._comment).replace("tag",Y._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),Y.paragraph=le(Y._paragraph).replace("hr",Y.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Y._tag).getRegex(),Y.blockquote=le(Y.blockquote).replace("paragraph",Y.paragraph).getRegex(),Y.normal=ue({},Y),Y.gfm=ue({},Y.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),Y.gfm.table=le(Y.gfm.table).replace("hr",Y.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Y._tag).getRegex(),Y.pedantic=ue({},Y.normal,{html:le(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",Y._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:K,paragraph:le(Y.normal._paragraph).replace("hr",Y.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",Y.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ie={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:K,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:K,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ie._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ie.punctuation=le(ie.punctuation).replace(/punctuation/g,ie._punctuation).getRegex(),ie.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ie.escapedEmSt=/\\\*|\\_/g,ie._comment=le(Y._comment).replace("(?:-->|$)","-->").getRegex(),ie.emStrong.lDelim=le(ie.emStrong.lDelim).replace(/punct/g,ie._punctuation).getRegex(),ie.emStrong.rDelimAst=le(ie.emStrong.rDelimAst,"g").replace(/punct/g,ie._punctuation).getRegex(),ie.emStrong.rDelimUnd=le(ie.emStrong.rDelimUnd,"g").replace(/punct/g,ie._punctuation).getRegex(),ie._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ie._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ie._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ie.autolink=le(ie.autolink).replace("scheme",ie._scheme).replace("email",ie._email).getRegex(),ie._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ie.tag=le(ie.tag).replace("comment",ie._comment).replace("attribute",ie._attribute).getRegex(),ie._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ie._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ie._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ie.link=le(ie.link).replace("label",ie._label).replace("href",ie._href).replace("title",ie._title).getRegex(),ie.reflink=le(ie.reflink).replace("label",ie._label).getRegex(),ie.reflinkSearch=le(ie.reflinkSearch,"g").replace("reflink",ie.reflink).replace("nolink",ie.nolink).getRegex(),ie.normal=ue({},ie),ie.pedantic=ue({},ie.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:le(/^!?\[(label)\]\((.*?)\)/).replace("label",ie._label).getRegex(),reflink:le(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ie._label).getRegex()}),ie.gfm=ue({},ie.normal,{escape:le(ie.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ie.gfm.url=le(ie.gfm.url,"i").replace("email",ie.gfm._extended_email).getRegex(),ie.breaks=ue({},ie.gfm,{br:le(ie.br).replace("{2,}","*").getRegex(),text:le(ie.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var we={block:Y,inline:ie},Me=ce,Re=T.exports.defaults,Be=we.block,Qe=we.inline,Ke=U.repeatString;function Xe(Ie){return Ie.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function $(Ie){var Ce="",ve,oe,se=Ie.length;for(ve=0;ve<se;ve++)oe=Ie.charCodeAt(ve),Math.random()>.5&&(oe="x"+oe.toString(16)),Ce+="&#"+oe+";";return Ce}var G=function(){function Ie(ve){this.tokens=[],this.tokens.links=Object.create(null),this.options=ve||Re,this.options.tokenizer=this.options.tokenizer||new Me,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var oe={block:Be.normal,inline:Qe.normal};this.options.pedantic?(oe.block=Be.pedantic,oe.inline=Qe.pedantic):this.options.gfm&&(oe.block=Be.gfm,this.options.breaks?oe.inline=Qe.breaks:oe.inline=Qe.gfm),this.tokenizer.rules=oe}Ie.lex=function(oe,se){var fe=new Ie(se);return fe.lex(oe)},Ie.lexInline=function(oe,se){var fe=new Ie(se);return fe.inlineTokens(oe)};var Ce=Ie.prototype;return Ce.lex=function(oe){oe=oe.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(oe,this.tokens);for(var se;se=this.inlineQueue.shift();)this.inlineTokens(se.src,se.tokens);return this.tokens},Ce.blockTokens=function(oe,se){var fe=this;se===void 0&&(se=[]),this.options.pedantic&&(oe=oe.replace(/^ +$/gm,""));for(var ge,ke,ze,Oe;oe;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(it){return(ge=it.call({lexer:fe},oe,se))?(oe=oe.substring(ge.raw.length),se.push(ge),!0):!1}))){if(ge=this.tokenizer.space(oe)){oe=oe.substring(ge.raw.length),ge.type&&se.push(ge);continue}if(ge=this.tokenizer.code(oe)){oe=oe.substring(ge.raw.length),ke=se[se.length-1],ke&&(ke.type==="paragraph"||ke.type==="text")?(ke.raw+=`
`+ge.raw,ke.text+=`
`+ge.text,this.inlineQueue[this.inlineQueue.length-1].src=ke.text):se.push(ge);continue}if(ge=this.tokenizer.fences(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.heading(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.hr(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.blockquote(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.list(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.html(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.def(oe)){oe=oe.substring(ge.raw.length),ke=se[se.length-1],ke&&(ke.type==="paragraph"||ke.type==="text")?(ke.raw+=`
`+ge.raw,ke.text+=`
`+ge.raw,this.inlineQueue[this.inlineQueue.length-1].src=ke.text):this.tokens.links[ge.tag]||(this.tokens.links[ge.tag]={href:ge.href,title:ge.title});continue}if(ge=this.tokenizer.table(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.lheading(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ze=oe,this.options.extensions&&this.options.extensions.startBlock&&function(){var it=1/0,rt=oe.slice(1),ne=void 0;fe.options.extensions.startBlock.forEach(function(pe){ne=pe.call({lexer:this},rt),typeof ne=="number"&&ne>=0&&(it=Math.min(it,ne))}),it<1/0&&it>=0&&(ze=oe.substring(0,it+1))}(),this.state.top&&(ge=this.tokenizer.paragraph(ze))){ke=se[se.length-1],Oe&&ke.type==="paragraph"?(ke.raw+=`
`+ge.raw,ke.text+=`
`+ge.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ke.text):se.push(ge),Oe=ze.length!==oe.length,oe=oe.substring(ge.raw.length);continue}if(ge=this.tokenizer.text(oe)){oe=oe.substring(ge.raw.length),ke=se[se.length-1],ke&&ke.type==="text"?(ke.raw+=`
`+ge.raw,ke.text+=`
`+ge.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ke.text):se.push(ge);continue}if(oe){var Ve="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(Ve);break}else throw new Error(Ve)}}return this.state.top=!0,se},Ce.inline=function(oe,se){this.inlineQueue.push({src:oe,tokens:se})},Ce.inlineTokens=function(oe,se){var fe=this;se===void 0&&(se=[]);var ge,ke,ze,Oe=oe,Ve,it,rt;if(this.tokens.links){var ne=Object.keys(this.tokens.links);if(ne.length>0)for(;(Ve=this.tokenizer.rules.inline.reflinkSearch.exec(Oe))!=null;)ne.includes(Ve[0].slice(Ve[0].lastIndexOf("[")+1,-1))&&(Oe=Oe.slice(0,Ve.index)+"["+Ke("a",Ve[0].length-2)+"]"+Oe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ve=this.tokenizer.rules.inline.blockSkip.exec(Oe))!=null;)Oe=Oe.slice(0,Ve.index)+"["+Ke("a",Ve[0].length-2)+"]"+Oe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ve=this.tokenizer.rules.inline.escapedEmSt.exec(Oe))!=null;)Oe=Oe.slice(0,Ve.index)+"++"+Oe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;)if(it||(rt=""),it=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ee){return(ge=ee.call({lexer:fe},oe,se))?(oe=oe.substring(ge.raw.length),se.push(ge),!0):!1}))){if(ge=this.tokenizer.escape(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.tag(oe)){oe=oe.substring(ge.raw.length),ke=se[se.length-1],ke&&ge.type==="text"&&ke.type==="text"?(ke.raw+=ge.raw,ke.text+=ge.text):se.push(ge);continue}if(ge=this.tokenizer.link(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(ge.raw.length),ke=se[se.length-1],ke&&ge.type==="text"&&ke.type==="text"?(ke.raw+=ge.raw,ke.text+=ge.text):se.push(ge);continue}if(ge=this.tokenizer.emStrong(oe,Oe,rt)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.codespan(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.br(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.del(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.autolink(oe,$)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(!this.state.inLink&&(ge=this.tokenizer.url(oe,$))){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ze=oe,this.options.extensions&&this.options.extensions.startInline&&function(){var ee=1/0,W=oe.slice(1),be=void 0;fe.options.extensions.startInline.forEach(function(De){be=De.call({lexer:this},W),typeof be=="number"&&be>=0&&(ee=Math.min(ee,be))}),ee<1/0&&ee>=0&&(ze=oe.substring(0,ee+1))}(),ge=this.tokenizer.inlineText(ze,Xe)){oe=oe.substring(ge.raw.length),ge.raw.slice(-1)!=="_"&&(rt=ge.raw.slice(-1)),it=!0,ke=se[se.length-1],ke&&ke.type==="text"?(ke.raw+=ge.raw,ke.text+=ge.text):se.push(ge);continue}if(oe){var pe="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(pe);break}else throw new Error(pe)}}return se},e(Ie,null,[{key:"rules",get:function(){return{block:Be,inline:Qe}}}]),Ie}(),J=T.exports.defaults,ae=U.cleanUrl,q=U.escape,te=function(){function Ie(ve){this.options=ve||J}var Ce=Ie.prototype;return Ce.code=function(oe,se,fe){var ge=(se||"").match(/\S*/)[0];if(this.options.highlight){var ke=this.options.highlight(oe,ge);ke!=null&&ke!==oe&&(fe=!0,oe=ke)}return oe=oe.replace(/\n$/,"")+`
`,ge?'<pre><code class="'+this.options.langPrefix+q(ge,!0)+'">'+(fe?oe:q(oe,!0))+`</code></pre>
`:"<pre><code>"+(fe?oe:q(oe,!0))+`</code></pre>
`},Ce.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},Ce.html=function(oe){return oe},Ce.heading=function(oe,se,fe,ge){return this.options.headerIds?"<h"+se+' id="'+this.options.headerPrefix+ge.slug(fe)+'">'+oe+"</h"+se+`>
`:"<h"+se+">"+oe+"</h"+se+`>
`},Ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ce.list=function(oe,se,fe){var ge=se?"ol":"ul",ke=se&&fe!==1?' start="'+fe+'"':"";return"<"+ge+ke+`>
`+oe+"</"+ge+`>
`},Ce.listitem=function(oe){return"<li>"+oe+`</li>
`},Ce.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ce.paragraph=function(oe){return"<p>"+oe+`</p>
`},Ce.table=function(oe,se){return se&&(se="<tbody>"+se+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+se+`</table>
`},Ce.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},Ce.tablecell=function(oe,se){var fe=se.header?"th":"td",ge=se.align?"<"+fe+' align="'+se.align+'">':"<"+fe+">";return ge+oe+"</"+fe+`>
`},Ce.strong=function(oe){return"<strong>"+oe+"</strong>"},Ce.em=function(oe){return"<em>"+oe+"</em>"},Ce.codespan=function(oe){return"<code>"+oe+"</code>"},Ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ce.del=function(oe){return"<del>"+oe+"</del>"},Ce.link=function(oe,se,fe){if(oe=ae(this.options.sanitize,this.options.baseUrl,oe),oe===null)return fe;var ge='<a href="'+q(oe)+'"';return se&&(ge+=' title="'+se+'"'),ge+=">"+fe+"</a>",ge},Ce.image=function(oe,se,fe){if(oe=ae(this.options.sanitize,this.options.baseUrl,oe),oe===null)return fe;var ge='<img src="'+oe+'" alt="'+fe+'"';return se&&(ge+=' title="'+se+'"'),ge+=this.options.xhtml?"/>":">",ge},Ce.text=function(oe){return oe},Ie}(),me=function(){function Ie(){}var Ce=Ie.prototype;return Ce.strong=function(oe){return oe},Ce.em=function(oe){return oe},Ce.codespan=function(oe){return oe},Ce.del=function(oe){return oe},Ce.html=function(oe){return oe},Ce.text=function(oe){return oe},Ce.link=function(oe,se,fe){return""+fe},Ce.image=function(oe,se,fe){return""+fe},Ce.br=function(){return""},Ie}(),Pe=function(){function Ie(){this.seen={}}var Ce=Ie.prototype;return Ce.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ce.getNextSafeSlug=function(oe,se){var fe=oe,ge=0;if(this.seen.hasOwnProperty(fe)){ge=this.seen[oe];do ge++,fe=oe+"-"+ge;while(this.seen.hasOwnProperty(fe))}return se||(this.seen[oe]=ge,this.seen[fe]=0),fe},Ce.slug=function(oe,se){se===void 0&&(se={});var fe=this.serialize(oe);return this.getNextSafeSlug(fe,se.dryrun)},Ie}(),Ne=te,He=me,Ye=Pe,et=T.exports.defaults,st=U.unescape,Je=function(){function Ie(ve){this.options=ve||et,this.options.renderer=this.options.renderer||new Ne,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new He,this.slugger=new Ye}Ie.parse=function(oe,se){var fe=new Ie(se);return fe.parse(oe)},Ie.parseInline=function(oe,se){var fe=new Ie(se);return fe.parseInline(oe)};var Ce=Ie.prototype;return Ce.parse=function(oe,se){se===void 0&&(se=!0);var fe="",ge,ke,ze,Oe,Ve,it,rt,ne,pe,ee,W,be,De,qe,xe,ut,vt,St,bt,ht=oe.length;for(ge=0;ge<ht;ge++){if(ee=oe[ge],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ee.type]&&(bt=this.options.extensions.renderers[ee.type].call({parser:this},ee),bt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ee.type))){fe+=bt||"";continue}switch(ee.type){case"space":continue;case"hr":{fe+=this.renderer.hr();continue}case"heading":{fe+=this.renderer.heading(this.parseInline(ee.tokens),ee.depth,st(this.parseInline(ee.tokens,this.textRenderer)),this.slugger);continue}case"code":{fe+=this.renderer.code(ee.text,ee.lang,ee.escaped);continue}case"table":{for(ne="",rt="",Oe=ee.header.length,ke=0;ke<Oe;ke++)rt+=this.renderer.tablecell(this.parseInline(ee.header[ke].tokens),{header:!0,align:ee.align[ke]});for(ne+=this.renderer.tablerow(rt),pe="",Oe=ee.rows.length,ke=0;ke<Oe;ke++){for(it=ee.rows[ke],rt="",Ve=it.length,ze=0;ze<Ve;ze++)rt+=this.renderer.tablecell(this.parseInline(it[ze].tokens),{header:!1,align:ee.align[ze]});pe+=this.renderer.tablerow(rt)}fe+=this.renderer.table(ne,pe);continue}case"blockquote":{pe=this.parse(ee.tokens),fe+=this.renderer.blockquote(pe);continue}case"list":{for(W=ee.ordered,be=ee.start,De=ee.loose,Oe=ee.items.length,pe="",ke=0;ke<Oe;ke++)xe=ee.items[ke],ut=xe.checked,vt=xe.task,qe="",xe.task&&(St=this.renderer.checkbox(ut),De?xe.tokens.length>0&&xe.tokens[0].type==="paragraph"?(xe.tokens[0].text=St+" "+xe.tokens[0].text,xe.tokens[0].tokens&&xe.tokens[0].tokens.length>0&&xe.tokens[0].tokens[0].type==="text"&&(xe.tokens[0].tokens[0].text=St+" "+xe.tokens[0].tokens[0].text)):xe.tokens.unshift({type:"text",text:St}):qe+=St),qe+=this.parse(xe.tokens,De),pe+=this.renderer.listitem(qe,vt,ut);fe+=this.renderer.list(pe,W,be);continue}case"html":{fe+=this.renderer.html(ee.text);continue}case"paragraph":{fe+=this.renderer.paragraph(this.parseInline(ee.tokens));continue}case"text":{for(pe=ee.tokens?this.parseInline(ee.tokens):ee.text;ge+1<ht&&oe[ge+1].type==="text";)ee=oe[++ge],pe+=`
`+(ee.tokens?this.parseInline(ee.tokens):ee.text);fe+=se?this.renderer.paragraph(pe):pe;continue}default:{var gt='Token with "'+ee.type+'" type was not found.';if(this.options.silent){console.error(gt);return}else throw new Error(gt)}}}return fe},Ce.parseInline=function(oe,se){se=se||this.renderer;var fe="",ge,ke,ze,Oe=oe.length;for(ge=0;ge<Oe;ge++){if(ke=oe[ge],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&(ze=this.options.extensions.renderers[ke.type].call({parser:this},ke),ze!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ke.type))){fe+=ze||"";continue}switch(ke.type){case"escape":{fe+=se.text(ke.text);break}case"html":{fe+=se.html(ke.text);break}case"link":{fe+=se.link(ke.href,ke.title,this.parseInline(ke.tokens,se));break}case"image":{fe+=se.image(ke.href,ke.title,ke.text);break}case"strong":{fe+=se.strong(this.parseInline(ke.tokens,se));break}case"em":{fe+=se.em(this.parseInline(ke.tokens,se));break}case"codespan":{fe+=se.codespan(ke.text);break}case"br":{fe+=se.br();break}case"del":{fe+=se.del(this.parseInline(ke.tokens,se));break}case"text":{fe+=se.text(ke.text);break}default:{var Ve='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error(Ve);return}else throw new Error(Ve)}}}return fe},Ie}(),nt=G,lt=Je,pt=ce,Ft=te,Fe=me,Mt=Pe,V=U.merge,Q=U.checkSanitizeDeprecation,he=U.escape,Le=T.exports.getDefaults,We=T.exports.changeDefaults,ot=T.exports.defaults;function Ge(Ie,Ce,ve){if(typeof Ie=="undefined"||Ie===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");if(typeof Ce=="function"&&(ve=Ce,Ce=null),Ce=V({},Ge.defaults,Ce||{}),Q(Ce),ve){var oe=Ce.highlight,se;try{se=nt.lex(Ie,Ce)}catch(ze){return ve(ze)}var fe=function(Oe){var Ve;if(!Oe)try{Ce.walkTokens&&Ge.walkTokens(se,Ce.walkTokens),Ve=lt.parse(se,Ce)}catch(it){Oe=it}return Ce.highlight=oe,Oe?ve(Oe):ve(null,Ve)};if(!oe||oe.length<3||(delete Ce.highlight,!se.length))return fe();var ge=0;Ge.walkTokens(se,function(ze){ze.type==="code"&&(ge++,setTimeout(function(){oe(ze.text,ze.lang,function(Oe,Ve){if(Oe)return fe(Oe);Ve!=null&&Ve!==ze.text&&(ze.text=Ve,ze.escaped=!0),ge--,ge===0&&fe()})},0))}),ge===0&&fe();return}try{var ke=nt.lex(Ie,Ce);return Ce.walkTokens&&Ge.walkTokens(ke,Ce.walkTokens),lt.parse(ke,Ce)}catch(ze){if(ze.message+=`
Please report this to https://github.com/markedjs/marked.`,Ce.silent)return"<p>An error occurred:</p><pre>"+he(ze.message+"",!0)+"</pre>";throw ze}}Ge.options=Ge.setOptions=function(Ie){return V(Ge.defaults,Ie),We(Ge.defaults),Ge},Ge.getDefaults=Le,Ge.defaults=ot,Ge.use=function(){for(var Ie=this,Ce=arguments.length,ve=new Array(Ce),oe=0;oe<Ce;oe++)ve[oe]=arguments[oe];var se=V.apply(void 0,[{}].concat(ve)),fe=Ge.defaults.extensions||{renderers:{},childTokens:{}},ge;ve.forEach(function(ke){if(ke.extensions&&(ge=!0,ke.extensions.forEach(function(Oe){if(!Oe.name)throw new Error("extension name required");if(Oe.renderer){var Ve=fe.renderers?fe.renderers[Oe.name]:null;Ve?fe.renderers[Oe.name]=function(){for(var it=arguments.length,rt=new Array(it),ne=0;ne<it;ne++)rt[ne]=arguments[ne];var pe=Oe.renderer.apply(this,rt);return pe===!1&&(pe=Ve.apply(this,rt)),pe}:fe.renderers[Oe.name]=Oe.renderer}if(Oe.tokenizer){if(!Oe.level||Oe.level!=="block"&&Oe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");fe[Oe.level]?fe[Oe.level].unshift(Oe.tokenizer):fe[Oe.level]=[Oe.tokenizer],Oe.start&&(Oe.level==="block"?fe.startBlock?fe.startBlock.push(Oe.start):fe.startBlock=[Oe.start]:Oe.level==="inline"&&(fe.startInline?fe.startInline.push(Oe.start):fe.startInline=[Oe.start]))}Oe.childTokens&&(fe.childTokens[Oe.name]=Oe.childTokens)})),ke.renderer&&function(){var Oe=Ge.defaults.renderer||new Ft,Ve=function(ne){var pe=Oe[ne];Oe[ne]=function(){for(var ee=arguments.length,W=new Array(ee),be=0;be<ee;be++)W[be]=arguments[be];var De=ke.renderer[ne].apply(Oe,W);return De===!1&&(De=pe.apply(Oe,W)),De}};for(var it in ke.renderer)Ve(it);se.renderer=Oe}(),ke.tokenizer&&function(){var Oe=Ge.defaults.tokenizer||new pt,Ve=function(ne){var pe=Oe[ne];Oe[ne]=function(){for(var ee=arguments.length,W=new Array(ee),be=0;be<ee;be++)W[be]=arguments[be];var De=ke.tokenizer[ne].apply(Oe,W);return De===!1&&(De=pe.apply(Oe,W)),De}};for(var it in ke.tokenizer)Ve(it);se.tokenizer=Oe}(),ke.walkTokens){var ze=Ge.defaults.walkTokens;se.walkTokens=function(Oe){ke.walkTokens.call(Ie,Oe),ze&&ze(Oe)}}ge&&(se.extensions=fe),Ge.setOptions(se)})},Ge.walkTokens=function(Ie,Ce){for(var ve=function(){var ge=se.value;switch(Ce(ge),ge.type){case"table":{for(var ke=w(ge.header),ze;!(ze=ke()).done;){var Oe=ze.value;Ge.walkTokens(Oe.tokens,Ce)}for(var Ve=w(ge.rows),it;!(it=Ve()).done;)for(var rt=it.value,ne=w(rt),pe;!(pe=ne()).done;){var ee=pe.value;Ge.walkTokens(ee.tokens,Ce)}break}case"list":{Ge.walkTokens(ge.items,Ce);break}default:Ge.defaults.extensions&&Ge.defaults.extensions.childTokens&&Ge.defaults.extensions.childTokens[ge.type]?Ge.defaults.extensions.childTokens[ge.type].forEach(function(W){Ge.walkTokens(ge[W],Ce)}):ge.tokens&&Ge.walkTokens(ge.tokens,Ce)}},oe=w(Ie),se;!(se=oe()).done;)ve()},Ge.parseInline=function(Ie,Ce){if(typeof Ie=="undefined"||Ie===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");Ce=V({},Ge.defaults,Ce||{}),Q(Ce);try{var ve=nt.lexInline(Ie,Ce);return Ce.walkTokens&&Ge.walkTokens(ve,Ce.walkTokens),lt.parseInline(ve,Ce)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,Ce.silent)return"<p>An error occurred:</p><pre>"+he(oe.message+"",!0)+"</pre>";throw oe}},Ge.Parser=lt,Ge.parser=lt.parse,Ge.Renderer=Ft,Ge.TextRenderer=Fe,Ge.Lexer=nt,Ge.lexer=nt.lex,Ge.Tokenizer=pt,Ge.Slugger=Mt,Ge.parse=Ge;var yt=Ge;return yt}),define(Ee[75],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function a(k,P,C){return Math.min(Math.max(k,P),C)}e.clamp=a;function t(k,P){return(P+k%P)%P}e.rot=t;class w{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=w;class T{constructor(){this._n=1,this._val=0}update(P){return this._val=this._val+(P-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=T}),function(){function re(w){const T=[];typeof w=="number"&&T.push("code/timeOrigin",w);function k(C){T.push(C,Date.now())}function P(){const C=[];for(let R=0;R<T.length;R+=2)C.push({name:T[R],startTime:T[R+1]});return C}return{mark:k,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?re():{mark(w){performance.mark(w)},getMarks(){let w=performance.timeOrigin;typeof w!="number"&&(w=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(w)}];for(const k of performance.getEntriesByType("mark"))T.push({name:k.name,startTime:Math.round(w+k.startTime)});return T}};if(typeof process=="object"){const w=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return re(w)}else return console.trace("perf-util loaded in UNKNOWN environment"),re()}function a(w){return w.MonacoPerformanceMarks||(w.MonacoPerformanceMarks=e()),w.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return a(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=a(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=a(t))}(),define(Ee[102],ye([0,1,15,6]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function w(h){const p=h;return p?[p.on,p.pause,p.resume,p.destroy].every(I=>typeof I=="function"):!1}e.isReadableStream=w;function T(h){const p=h;return p?w(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=T;function k(h,p){return new P(h,p)}e.newWriteableStream=k;class P{constructor(p,I){this.reducer=p,this.options=I,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(I=>this.pendingWritePromises.push(I))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(typeof p!="undefined"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(I=>I(p))}emitError(p){this.listeners.error.length===0?(0,a.onUnexpectedError)(p):this.listeners.error.slice(0).forEach(I=>I(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,I){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(I),this.resume();break;case"end":this.listeners.end.push(I),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(I),this.state.flowing&&this.flowErrors();break}}removeListener(p,I){if(this.state.destroyed)return;let l;switch(p){case"data":l=this.listeners.data;break;case"end":l=this.listeners.end;break;case"error":l=this.listeners.error;break}if(l){const M=l.indexOf(I);M>=0&&l.splice(M,1)}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const I=[...this.pendingWritePromises];this.pendingWritePromises.length=0,I.forEach(l=>l())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function C(h,p){const I=[];let l;for(;(l=h.read())!==null;)I.push(l);return p(I)}e.consumeReadable=C;function R(h,p,I){const l=[];let M;for(;(M=h.read())!==null&&l.length<I;)l.push(M);return M===null&&l.length>0?p(l):{read:()=>{if(l.length>0)return l.shift();if(typeof M!="undefined"){const r=M;return M=void 0,r}return h.read()}}}e.peekReadable=R;function F(h,p){return new Promise((I,l)=>{const M=[];_(h,{onData:r=>{p&&M.push(r)},onError:r=>{p?l(r):I(void 0)},onEnd:()=>{I(p?p(M):void 0)}})})}e.consumeStream=F;function _(h,p){let I=!1;return h.on("error",l=>{I||p.onError(l)}),h.on("end",()=>{I||p.onEnd()}),h.on("data",l=>{I||p.onData(l)}),(0,t.toDisposable)(()=>I=!0)}e.listenStream=_;function n(h,p){return new Promise((I,l)=>{const M=new t.DisposableStore,r=[],i=s=>{if(r.push(s),r.length>p)return M.dispose(),h.pause(),I({stream:h,buffer:r,ended:!1})},m=s=>l(s),d=()=>I({stream:h,buffer:r,ended:!0});M.add((0,t.toDisposable)(()=>h.removeListener("error",m))),h.on("error",m),M.add((0,t.toDisposable)(()=>h.removeListener("end",d))),h.on("end",d),M.add((0,t.toDisposable)(()=>h.removeListener("data",i))),h.on("data",i)})}e.peekStream=n;function f(h,p){const I=k(p);return I.end(h),I}e.toStream=f;function o(){const h=k(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=o;function g(h){let p=!1;return{read:()=>p?null:(p=!0,h)}}e.toReadable=g;function c(h,p,I){const l=k(I);return _(h,{onData:M=>l.write(p.data(M)),onError:M=>l.error(p.error?p.error(M):M),onEnd:()=>l.end()}),l}e.transform=c;function D(h,p,I){let l=!1;return{read:()=>{const M=p.read();return l?M:(l=!0,M!==null?I([h,M]):h)}}}e.prefixedReadable=D;function v(h,p,I){let l=!1;const M=k(I);return _(p,{onData:r=>l?M.write(r):(l=!0,M.write(I([h,r]))),onError:r=>M.error(r),onEnd:()=>{l||(l=!0,M.write(h)),M.end()}}),M}e.prefixedStream=v}),define(Ee[22],ye([0,1,102]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let w,T;class k{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return t?new k(Buffer.allocUnsafe(i)):new k(new Uint8Array(i))}static wrap(i){return t&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new k(i)}static fromString(i,m){return!(m?.dontUseNodeBuffer||!1)&&t?new k(Buffer.from(i)):(w||(w=new TextEncoder),new k(w.encode(i)))}static fromByteArray(i){const m=k.alloc(i.length);for(let d=0,s=i.length;d<s;d++)m.buffer[d]=i[d];return m}static concat(i,m){if(typeof m=="undefined"){m=0;for(let b=0,y=i.length;b<y;b++)m+=i[b].byteLength}const d=k.alloc(m);let s=0;for(let b=0,y=i.length;b<y;b++){const u=i[b];d.set(u,s),s+=u.byteLength}return d}clone(){const i=k.alloc(this.byteLength);return i.set(this),i}toString(){return t?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(i,m){return new k(this.buffer.subarray(i,m))}set(i,m){if(i instanceof k)this.buffer.set(i.buffer,m);else if(i instanceof Uint8Array)this.buffer.set(i,m);else if(i instanceof ArrayBuffer)this.buffer.set(new Uint8Array(i),m);else if(ArrayBuffer.isView(i))this.buffer.set(new Uint8Array(i.buffer,i.byteOffset,i.byteLength),m);else throw new Error("Unkown argument 'array'")}readUInt32BE(i){return R(this.buffer,i)}writeUInt32BE(i,m){F(this.buffer,i,m)}readUInt32LE(i){return _(this.buffer,i)}writeUInt32LE(i,m){n(this.buffer,i,m)}readUInt8(i){return f(this.buffer,i)}writeUInt8(i,m){o(this.buffer,i,m)}}e.VSBuffer=k;function P(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0}e.readUInt16LE=P;function C(r,i,m){r[m+0]=i&255,i=i>>>8,r[m+1]=i&255}e.writeUInt16LE=C;function R(r,i){return r[i]*2**24+r[i+1]*2**16+r[i+2]*2**8+r[i+3]}e.readUInt32BE=R;function F(r,i,m){r[m+3]=i,i=i>>>8,r[m+2]=i,i=i>>>8,r[m+1]=i,i=i>>>8,r[m]=i}e.writeUInt32BE=F;function _(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0|r[i+2]<<16>>>0|r[i+3]<<24>>>0}e.readUInt32LE=_;function n(r,i,m){r[m+0]=i&255,i=i>>>8,r[m+1]=i&255,i=i>>>8,r[m+2]=i&255,i=i>>>8,r[m+3]=i&255}e.writeUInt32LE=n;function f(r,i){return r[i]}e.readUInt8=f;function o(r,i,m){r[m]=i}e.writeUInt8=o;function g(r){return a.consumeReadable(r,i=>k.concat(i))}e.readableToBuffer=g;function c(r){return a.toReadable(r)}e.bufferToReadable=c;function D(r){return a.consumeStream(r,i=>k.concat(i))}e.streamToBuffer=D;async function v(r){return r.ended?k.concat(r.buffer):k.concat([...r.buffer,await D(r.stream)])}e.bufferedStreamToBuffer=v;function h(r){return a.toStream(r,i=>k.concat(i))}e.bufferToStream=h;function p(r){return a.transform(r,{data:i=>typeof i=="string"?k.fromString(i):k.wrap(i)},i=>k.concat(i))}e.streamToBufferReadableStream=p;function I(r){return a.newWriteableStream(i=>k.concat(i),r)}e.newWriteableBufferStream=I;function l(r,i){return a.prefixedReadable(r,i,m=>k.concat(m))}e.prefixedBufferReadable=l;function M(r,i){return a.prefixedStream(r,i,m=>k.concat(m))}e.prefixedBufferStream=M});var Ze=this&&this.__classPrivateFieldSet||function(re,e,a,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(re,a):w?w.value=a:e.set(re,a),a},Te=this&&this.__classPrivateFieldGet||function(re,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!t:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(re):t?t.value:e.get(re)};define(Ee[21],ye([0,1,16,9]),function(re,e,a,t){"use strict";var w,T,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(r,i,m){let d=r.get(i);return d===void 0&&(d=m,r.set(i,d)),d}e.getOrSet=P;function C(r){const i=[];return r.forEach((m,d)=>{i.push(`${d} => ${m}`)}),`Map(${r.size}) {${i.join(", ")}}`}e.mapToString=C;function R(r){const i=[];return r.forEach(m=>{i.push(m)}),`Set(${r.size}) {${i.join(", ")}}`}e.setToString=R;class F{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const m=i.charCodeAt(0),d=this._value.charCodeAt(this._pos);return m-d}value(){return this._value[this._pos]}}e.StringIterator=F;class _{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=_;class n{constructor(i=!0,m=!0){this._splitOnBackslash=i,this._caseSensitive=m}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let m=i.length-1;m>=0;m--,this._valueLen--){const d=this._value.charCodeAt(m);if(!(d===47||this._splitOnBackslash&&d===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const m=this._value.charCodeAt(this._to);if(m===47||this._splitOnBackslash&&m===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=n;var f;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(f||(f={}));class o{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new n(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,t.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=o;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var c;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(c||(c={}));class D{constructor(i){this._iter=i}static forUris(i=()=>!1){return new D(new o(i))}static forPaths(){return new D(new n)}static forStrings(){return new D(new F)}static forConfigKeys(){return new D(new _)}clear(){this._root=void 0}fill(i,m){if(m){const d=m.slice(0);(0,a.shuffle)(d);for(let s of d)this.set(s,i)}else{const d=i.slice(0);(0,a.shuffle)(d);for(let s of d)this.set(s[0],s[1])}}set(i,m){const d=this._iter.reset(i);let s;this._root||(this._root=new g,this._root.segment=d.value());const b=[];for(s=this._root;;){const u=d.cmp(s.segment);if(u>0)s.left||(s.left=new g,s.left.segment=d.value()),b.push([-1,s]),s=s.left;else if(u<0)s.right||(s.right=new g,s.right.segment=d.value()),b.push([1,s]),s=s.right;else if(d.hasNext())d.next(),s.mid||(s.mid=new g,s.mid.segment=d.value()),b.push([0,s]),s=s.mid;else break}const y=s.value;s.value=m,s.key=i;for(let u=b.length-1;u>=0;u--){const S=b[u][1];S.updateHeight();const A=S.balanceFactor();if(A<-1||A>1){const U=b[u][0],H=b[u+1][0];if(U===1&&H===1)b[u][1]=S.rotateLeft();else if(U===-1&&H===-1)b[u][1]=S.rotateRight();else if(U===1&&H===-1)S.right=b[u+1][1]=b[u+1][1].rotateRight(),b[u][1]=S.rotateLeft();else if(U===-1&&H===1)S.left=b[u+1][1]=b[u+1][1].rotateLeft(),b[u][1]=S.rotateRight();else throw new Error;if(u>0)switch(b[u-1][0]){case-1:b[u-1][1].left=b[u][1];break;case 1:b[u-1][1].right=b[u][1];break;case 0:b[u-1][1].mid=b[u][1];break}else this._root=b[0][1]}}return y}get(i){return this._getNode(i)?.value}_getNode(i){const m=this._iter.reset(i);let d=this._root;for(;d;){const s=m.cmp(d.segment);if(s>0)d=d.left;else if(s<0)d=d.right;else if(m.hasNext())m.next(),d=d.mid;else break}return d}has(i){const m=this._getNode(i);return!(m?.value===void 0&&m?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,m){const d=this._iter.reset(i),s=[];let b=this._root;for(;b;){const y=d.cmp(b.segment);if(y>0)s.push([-1,b]),b=b.left;else if(y<0)s.push([1,b]),b=b.right;else if(d.hasNext())d.next(),s.push([0,b]),b=b.mid;else break}if(!!b){if(m?(b.left=void 0,b.mid=void 0,b.right=void 0,b.height=1):(b.key=void 0,b.value=void 0),!b.mid&&!b.value)if(b.left&&b.right){const y=this._min(b.right),{key:u,value:S,segment:A}=y;this._delete(y.key,!1),b.key=u,b.value=S,b.segment=A}else{const y=b.left??b.right;if(s.length>0){const[u,S]=s[s.length-1];switch(u){case-1:S.left=y;break;case 0:S.mid=y;break;case 1:S.right=y;break}}else this._root=y}for(let y=s.length-1;y>=0;y--){const u=s[y][1];u.updateHeight();const S=u.balanceFactor();if(S>1?(u.right.balanceFactor()>=0||(u.right=u.right.rotateRight()),s[y][1]=u.rotateLeft()):S<-1&&(u.left.balanceFactor()<=0||(u.left=u.left.rotateLeft()),s[y][1]=u.rotateRight()),y>0)switch(s[y-1][0]){case-1:s[y-1][1].left=s[y][1];break;case 1:s[y-1][1].right=s[y][1];break;case 0:s[y-1][1].mid=s[y][1];break}else this._root=s[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const m=this._iter.reset(i);let d=this._root,s;for(;d;){const b=m.cmp(d.segment);if(b>0)d=d.left;else if(b<0)d=d.right;else if(m.hasNext())m.next(),s=d.value||s,d=d.mid;else break}return d&&d.value||s}findSuperstr(i){const m=this._iter.reset(i);let d=this._root;for(;d;){const s=m.cmp(d.segment);if(s>0)d=d.left;else if(s<0)d=d.right;else if(m.hasNext())m.next(),d=d.mid;else return d.mid?this._entries(d.mid):void 0}}forEach(i){for(const[m,d]of this)i(d,m)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=m=>{if(!m)return!0;const d=m.balanceFactor();return d<-1||d>1?!1:i(m.left)&&i(m.right)};return i(this._root)}}e.TernarySearchTree=D;class v{constructor(i,m){this.uri=i,this.value=m}}class h{constructor(i,m){this[w]="ResourceMap",i instanceof h?(this.map=new Map(i.map),this.toKey=m??h.defaultToKey):(this.map=new Map,this.toKey=i??h.defaultToKey)}set(i,m){return this.map.set(this.toKey(i),new v(i,m)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,m){typeof m!="undefined"&&(i=i.bind(m));for(let[d,s]of this.map)i(s.value,s.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(w=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=h,h.defaultToKey=r=>r.toString();var p;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(p=e.Touch||(e.Touch={}));class I{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,m=0){const d=this._map.get(i);if(!!d)return m!==0&&this.touch(d,m),d.value}set(i,m,d=0){let s=this._map.get(i);if(s)s.value=m,d!==0&&this.touch(s,d);else{switch(s={key:i,value:m,next:void 0,previous:void 0},d){case 0:this.addItemLast(s);break;case 1:this.addItemFirst(s);break;case 2:this.addItemLast(s);break;default:this.addItemLast(s);break}this._map.set(i,s),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const m=this._map.get(i);if(!!m)return this._map.delete(i),this.removeItem(m),this._size--,m.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,m){const d=this._state;let s=this._head;for(;s;){if(m?i.bind(m)(s.value,s.key,this):i(s.value,s.key,this),this._state!==d)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const i=this,m=this._state;let d=this._head;const s={[Symbol.iterator](){return s},next(){if(i._state!==m)throw new Error("LinkedMap got modified during iteration.");if(d){const b={value:d.key,done:!1};return d=d.next,b}else return{value:void 0,done:!0}}};return s}values(){const i=this,m=this._state;let d=this._head;const s={[Symbol.iterator](){return s},next(){if(i._state!==m)throw new Error("LinkedMap got modified during iteration.");if(d){const b={value:d.value,done:!1};return d=d.next,b}else return{value:void 0,done:!0}}};return s}entries(){const i=this,m=this._state;let d=this._head;const s={[Symbol.iterator](){return s},next(){if(i._state!==m)throw new Error("LinkedMap got modified during iteration.");if(d){const b={value:[d.key,d.value],done:!1};return d=d.next,b}else return{value:void 0,done:!0}}};return s}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let m=this._head,d=this.size;for(;m&&d>i;)this._map.delete(m.key),m=m.next,d--;this._head=m,this._size=d,m&&(m.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const m=i.next,d=i.previous;if(!m||!d)throw new Error("Invalid list");m.previous=d,d.next=m}i.next=void 0,i.previous=void 0,this._state++}touch(i,m){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(m!==1&&m!==2)){if(m===1){if(i===this._head)return;const d=i.next,s=i.previous;i===this._tail?(s.next=void 0,this._tail=s):(d.previous=s,s.next=d),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(m===2){if(i===this._tail)return;const d=i.next,s=i.previous;i===this._head?(d.previous=void 0,this._head=d):(d.previous=s,s.next=d),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((m,d)=>{i.push([d,m])}),i}fromJSON(i){this.clear();for(const[m,d]of i)this.set(m,d)}}e.LinkedMap=I;class l extends I{constructor(i,m=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,m),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,m=2){return super.get(i,m)}peek(i){return super.get(i,0)}set(i,m){return super.set(i,m,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=l;class M{constructor(i){k.set(this,void 0),Ze(this,k,i,"f")}get size(){return Te(this,k,"f").size}forEach(i,m){Te(this,k,"f").forEach(i,m)}get(i){return Te(this,k,"f").get(i)}has(i){return Te(this,k,"f").has(i)}entries(){return Te(this,k,"f").entries()}keys(){return Te(this,k,"f").keys()}values(){return Te(this,k,"f").values()}[(k=new WeakMap,Symbol.iterator)](){return Te(this,k,"f").entries()}}e.ReadonlyMapView=M}),define(Ee[103],ye([0,1,21,9]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function w(...q){return function(te,me){for(let Pe=0,Ne=q.length;Pe<Ne;Pe++){const He=q[Pe](te,me);if(He)return He}return null}}e.or=w,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(q,te,me){if(!me||me.length<te.length)return null;let Pe;return q?Pe=t.startsWithIgnoreCase(me,te):Pe=me.indexOf(te)===0,Pe?te.length>0?[{start:0,end:te.length}]:[]:null}function k(q,te){const me=te.toLowerCase().indexOf(q.toLowerCase());return me===-1?null:[{start:me,end:me+q.length}]}e.matchesContiguousSubString=k;function P(q,te){return C(q.toLowerCase(),te.toLowerCase(),0,0)}e.matchesSubString=P;function C(q,te,me,Pe){if(me===q.length)return[];if(Pe===te.length)return null;if(q[me]===te[Pe]){let Ne=null;return(Ne=C(q,te,me+1,Pe+1))?D({start:Pe,end:Pe+1},Ne):null}return C(q,te,me,Pe+1)}function R(q){return 97<=q&&q<=122}function F(q){return 65<=q&&q<=90}e.isUpper=F;function _(q){return 48<=q&&q<=57}function n(q){return q===32||q===9||q===10||q===13}const f=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(q=>f.add(q.charCodeAt(0)));function o(q){return n(q)||f.has(q)}function g(q,te){return q===te||o(q)&&o(te)}function c(q){return R(q)||F(q)||_(q)}function D(q,te){return te.length===0?te=[q]:q.end===te[0].start?te[0].start=q.start:te.unshift(q),te}function v(q,te){for(let me=te;me<q.length;me++){const Pe=q.charCodeAt(me);if(F(Pe)||_(Pe)||me>0&&!c(q.charCodeAt(me-1)))return me}return q.length}function h(q,te,me,Pe){if(me===q.length)return[];if(Pe===te.length)return null;if(q[me]!==te[Pe].toLowerCase())return null;{let Ne=null,He=Pe+1;for(Ne=h(q,te,me+1,Pe+1);!Ne&&(He=v(te,He))<te.length;)Ne=h(q,te,me+1,He),He++;return Ne===null?null:D({start:Pe,end:Pe+1},Ne)}}function p(q){let te=0,me=0,Pe=0,Ne=0,He=0;for(let nt=0;nt<q.length;nt++)He=q.charCodeAt(nt),F(He)&&te++,R(He)&&me++,c(He)&&Pe++,_(He)&&Ne++;const Ye=te/q.length,et=me/q.length,st=Pe/q.length,Je=Ne/q.length;return{upperPercent:Ye,lowerPercent:et,alphaPercent:st,numericPercent:Je}}function I(q){const{upperPercent:te,lowerPercent:me}=q;return me===0&&te>.6}function l(q){const{upperPercent:te,lowerPercent:me,alphaPercent:Pe,numericPercent:Ne}=q;return me>.2&&te<.8&&Pe>.6&&Ne<.2}function M(q){let te=0,me=0,Pe=0,Ne=0;for(let He=0;He<q.length;He++)Pe=q.charCodeAt(He),F(Pe)&&te++,R(Pe)&&me++,n(Pe)&&Ne++;return(te===0||me===0)&&Ne===0?q.length<=30:te<=5}function r(q,te){if(!te||(te=te.trim(),te.length===0)||!M(q)||te.length>60)return null;const me=p(te);if(!l(me)){if(!I(me))return null;te=te.toLowerCase()}let Pe=null,Ne=0;for(q=q.toLowerCase();Ne<te.length&&(Pe=h(q,te,0,Ne))===null;)Ne=v(te,Ne+1);return Pe}e.matchesCamelCase=r;function i(q,te,me=!1){if(!te||te.length===0)return null;let Pe=null,Ne=0;for(q=q.toLowerCase(),te=te.toLowerCase();Ne<te.length&&(Pe=m(q,te,0,Ne,me))===null;)Ne=d(te,Ne+1);return Pe}e.matchesWords=i;function m(q,te,me,Pe,Ne){if(me===q.length)return[];if(Pe===te.length)return null;if(g(q.charCodeAt(me),te.charCodeAt(Pe))){let He=null,Ye=Pe+1;if(He=m(q,te,me+1,Pe+1,Ne),!Ne)for(;!He&&(Ye=d(te,Ye))<te.length;)He=m(q,te,me+1,Ye,Ne),Ye++;return He===null?null:D({start:Pe,end:Pe+1},He)}else return null}function d(q,te){for(let me=te;me<q.length;me++)if(o(q.charCodeAt(me))||me>0&&o(q.charCodeAt(me-1)))return me;return q.length}const s=w(e.matchesPrefix,r,k),b=w(e.matchesPrefix,r,P),y=new a.LRUCache(1e4);function u(q,te,me=!1){if(typeof q!="string"||typeof te!="string")return null;let Pe=y.get(q);Pe||(Pe=new RegExp(t.convertSimple2RegExpPattern(q),"i"),y.set(q,Pe));const Ne=Pe.exec(te);return Ne?[{start:Ne.index,end:Ne.index+Ne[0].length}]:me?b(q,te):s(q,te)}e.matchesFuzzy=u;function S(q,te){const me=Qe(q,q.toLowerCase(),0,te,te.toLowerCase(),0,!0);return me?U(me):null}e.matchesFuzzy2=S;function A(q,te,me,Pe,Ne,He){const Ye=Math.min(13,q.length);for(;me<Ye;me++){const et=Qe(q,te,me,Pe,Ne,He,!1);if(et)return et}return[0,He]}e.anyScore=A;function U(q){if(typeof q=="undefined")return[];const te=[],me=q[1];for(let Pe=q.length-1;Pe>1;Pe--){const Ne=q[Pe]+me,He=te[te.length-1];He&&He.end===Ne?He.end=Ne+1:te.push({start:Ne,end:Ne+1})}return te}e.createMatches=U;const H=128;function E(){const q=[],te=[];for(let me=0;me<=H;me++)te[me]=0;for(let me=0;me<=H;me++)q.push(te.slice(0));return q}function L(q){const te=[];for(let me=0;me<=q;me++)te[me]=0;return te}const z=L(2*H),N=L(2*H),B=E(),j=E(),ce=E(),K=!1;function le(q,te,me,Pe,Ne){function He(et,st,Je=" "){for(;et.length<st;)et=Je+et;return et}let Ye=` |   |${Pe.split("").map(et=>He(et,3)).join("|")}
`;for(let et=0;et<=me;et++)et===0?Ye+=" |":Ye+=`${te[et-1]}|`,Ye+=q[et].slice(0,Ne+1).map(st=>He(st.toString(),3)).join("|")+`
`;return Ye}function ue(q,te,me,Pe){q=q.substr(te),me=me.substr(Pe),console.log(le(j,q,q.length,me,me.length)),console.log(le(ce,q,q.length,me,me.length)),console.log(le(B,q,q.length,me,me.length))}function Y(q,te){if(te<0||te>=q.length)return!1;const me=q.codePointAt(te);switch(me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(me)}}function ie(q,te){if(te<0||te>=q.length)return!1;switch(q.charCodeAt(te)){case 32:case 9:return!0;default:return!1}}function we(q,te,me){return te[q]!==me[q]}function Me(q,te,me,Pe,Ne,He,Ye=!1){for(;te<me&&Ne<He;)q[te]===Pe[Ne]&&(Ye&&(z[te]=Ne),te+=1),Ne+=1;return te===me}e.isPatternInWord=Me;var Re;(function(q){q[q.Diag=1]="Diag",q[q.Left=2]="Left",q[q.LeftLeft=3]="LeftLeft"})(Re||(Re={}));var Be;(function(q){q.Default=[-100,0];function te(me){return!me||me.length===2&&me[0]===-100&&me[1]===0}q.isDefault=te})(Be=e.FuzzyScore||(e.FuzzyScore={}));function Qe(q,te,me,Pe,Ne,He,Ye){const et=q.length>H?H:q.length,st=Pe.length>H?H:Pe.length;if(me>=et||He>=st||et-me>st-He||!Me(te,me,et,Ne,He,st,!0))return;Ke(et,st,me,He,te,Ne);let Je=1,nt=1,lt=me,pt=He;const Ft=[!1];for(Je=1,lt=me;lt<et;Je++,lt++){const he=z[lt],Le=N[lt],We=lt+1<et?N[lt+1]:st;for(nt=he-He+1,pt=he;pt<We;nt++,pt++){let ot=Number.MIN_SAFE_INTEGER,Ge=!1;pt<=Le&&(ot=Xe(q,te,lt,me,Pe,Ne,pt,st,He,B[Je-1][nt-1]===0,Ft));let yt=0;ot!==Number.MAX_SAFE_INTEGER&&(Ge=!0,yt=ot+j[Je-1][nt-1]);const Ie=pt>he,Ce=Ie?j[Je][nt-1]+(B[Je][nt-1]>0?-5:0):0,ve=pt>he+1&&B[Je][nt-1]>0,oe=ve?j[Je][nt-2]+(B[Je][nt-2]>0?-5:0):0;if(ve&&(!Ie||oe>=Ce)&&(!Ge||oe>=yt))j[Je][nt]=oe,ce[Je][nt]=3,B[Je][nt]=0;else if(Ie&&(!Ge||Ce>=yt))j[Je][nt]=Ce,ce[Je][nt]=2,B[Je][nt]=0;else if(Ge)j[Je][nt]=yt,ce[Je][nt]=1,B[Je][nt]=B[Je-1][nt-1]+1;else throw new Error("not possible")}}if(K&&ue(q,me,Pe,He),!Ft[0]&&!Ye)return;Je--,nt--;const Fe=[j[Je][nt],He];let Mt=0,V=0;for(;Je>=1;){let he=nt;do{const Le=ce[Je][he];if(Le===3)he=he-2;else if(Le===2)he=he-1;else break}while(he>=1);Mt>1&&te[me+Je-1]===Ne[He+nt-1]&&!we(he+He-1,Pe,Ne)&&Mt+1>B[Je][he]&&(he=nt),he===nt?Mt++:Mt=1,V||(V=he),Je--,nt=he-1,Fe.push(nt)}st===et&&(Fe[0]+=2);const Q=V-et;return Fe[0]-=Q,Fe}e.fuzzyScore=Qe;function Ke(q,te,me,Pe,Ne,He){let Ye=q-1,et=te-1;for(;Ye>=me&&et>=Pe;)Ne[Ye]===He[et]&&(N[Ye]=et,Ye--),et--}function Xe(q,te,me,Pe,Ne,He,Ye,et,st,Je,nt){if(te[me]!==He[Ye])return Number.MIN_SAFE_INTEGER;let lt=1,pt=!1;return Ye===me-Pe?lt=q[me]===Ne[Ye]?7:5:we(Ye,Ne,He)&&(Ye===0||!we(Ye-1,Ne,He))?(lt=q[me]===Ne[Ye]?7:5,pt=!0):Y(He,Ye)&&(Ye===0||!Y(He,Ye-1))?lt=5:(Y(He,Ye-1)||ie(He,Ye-1))&&(lt=5,pt=!0),lt>1&&me===Pe&&(nt[0]=!0),pt||(pt=we(Ye,Ne,He)||Y(He,Ye-1)||ie(He,Ye-1)),me===Pe?Ye>st&&(lt-=pt?3:5):Je?lt+=pt?2:0:lt+=pt?0:1,Ye+1===et&&(lt-=pt?3:5),lt}function $(q,te,me,Pe,Ne,He,Ye){return J(q,te,me,Pe,Ne,He,!0,Ye)}e.fuzzyScoreGracefulAggressive=$;function G(q,te,me,Pe,Ne,He,Ye){return J(q,te,me,Pe,Ne,He,!1,Ye)}e.fuzzyScoreGraceful=G;function J(q,te,me,Pe,Ne,He,Ye,et){let st=Qe(q,te,me,Pe,Ne,He,et);if(st&&!Ye)return st;if(q.length>=3){const Je=Math.min(7,q.length-1);for(let nt=me+1;nt<Je;nt++){const lt=ae(q,nt);if(lt){const pt=Qe(lt,lt.toLowerCase(),me,Pe,Ne,He,et);pt&&(pt[0]-=3,(!st||pt[0]>st[0])&&(st=pt))}}}return st}function ae(q,te){if(te+1>=q.length)return;const me=q[te],Pe=q[te+1];if(me!==Pe)return q.slice(0,te)+Pe+me+q.slice(te+2)}}),define(Ee[104],ye([0,1,51,103,9]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${a.CSSIcon.iconNameExpression}(?:${a.CSSIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(a.CSSIcon.iconNameCharacter),P=new RegExp(`(\\\\)?${T.source}`,"g");function C(c){return c.replace(P,(D,v)=>v?D:`\\${D}`)}e.escapeIcons=C;const R=new RegExp(`\\\\${T.source}`,"g");function F(c){return c.replace(R,D=>`\\${D}`)}e.markdownEscapeEscapedIcons=F;const _=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function n(c){return c.indexOf(e.iconStartMarker)===-1?c:c.replace(_,(D,v,h,p)=>h?D:v||p||"")}e.stripIcons=n;function f(c){const D=c.indexOf(e.iconStartMarker);return D===-1?{text:c}:o(c,D)}e.parseLabelWithIcons=f;function o(c,D){const v=[];let h="";function p(s){if(s){h+=s;for(const b of s)v.push(M)}}let I=-1,l="",M=0,r,i,m=D;const d=c.length;for(p(c.substr(0,D));m<d;)r=c[m],i=c[m+1],r===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(I=m,p(l),l=e.iconStartMarker,m++):r===")"&&I!==-1?(M+=m-I+1,I=-1,l=""):I!==-1?k.test(r)?l+=r:(p(l),I=-1,l=""):p(r),m++;return p(l),{text:h,iconOffsets:v}}function g(c,D,v=!1){const{text:h,iconOffsets:p}=D;if(!p||p.length===0)return(0,t.matchesFuzzy)(c,h,v);const I=(0,w.ltrim)(h," "),l=h.length-I.length,M=(0,t.matchesFuzzy)(c,I,v);if(M)for(const r of M){const i=p[r.start+l]+l;r.start+=i,r.end+=i}return M}e.matchesFuzzyIconAware=g}),define(Ee[76],ye([0,1,15,104]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var w;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(w=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class T{constructor(f="",o=!1){if(this.value=f,typeof this.value!="string")throw(0,a.illegalArgument)("value");typeof o=="boolean"?(this.isTrusted=o,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=o.isTrusted??void 0,this.supportThemeIcons=o.supportThemeIcons??!1,this.supportHtml=o.supportHtml??!1)}appendText(f,o=0){return this.value+=R(this.supportThemeIcons?(0,t.escapeIcons)(f):f).replace(/([ \t]+)/g,(g,c)=>"&nbsp;".repeat(c.length)).replace(/\>/gm,"\\>").replace(/\n/g,o===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,o){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=o,this.value+="\n```\n",this}}e.MarkdownString=T;function k(n){return P(n)?!n.value:Array.isArray(n)?n.every(k):!0}e.isEmptyMarkdownString=k;function P(n){return n instanceof T?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=P;function C(n,f){return n===f?!0:!n||!f?!1:n.value===f.value&&n.isTrusted===f.isTrusted&&n.supportThemeIcons===f.supportThemeIcons}e.markdownStringEqual=C;function R(n){return n.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=R;function F(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=F;function _(n){const f=[],o=n.split("|").map(c=>c.trim());n=o[0];const g=o[1];if(g){const c=/height=(\d+)/.exec(g),D=/width=(\d+)/.exec(g),v=c?c[1]:"",h=D?D[1]:"",p=isFinite(parseInt(h)),I=isFinite(parseInt(v));p&&f.push(`width="${h}"`),I&&f.push(`height="${v}"`)}return{href:n,dimensions:f}}e.parseHrefAndDimensions=_}),define(Ee[34],ye([0,1,9]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(w){w[w.Ignore=0]="Ignore",w[w.Info=1]="Info",w[w.Warning=2]="Warning",w[w.Error=3]="Error"})(t||(t={})),function(w){const T="error",k="warning",P="warn",C="info",R="ignore";function F(n){return n?a.equalsIgnoreCase(T,n)?w.Error:a.equalsIgnoreCase(k,n)||a.equalsIgnoreCase(P,n)?w.Warning:a.equalsIgnoreCase(C,n)?w.Info:w.Ignore:w.Ignore}w.fromValue=F;function _(n){switch(n){case w.Error:return T;case w.Warning:return k;case w.Info:return C;default:return R}}w.toString=_}(t||(t={})),e.default=t}),define(Ee[42],ye([0,1,17,23,9,11]),function(re,e,a,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(r){return r===47||r===92}e.isPathSeparator=k;function P(r){return r.replace(/[\\/]/g,a.posix.sep)}e.toSlashes=P;function C(r){return r.indexOf("/")===-1&&(r=P(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=C;function R(r,i=a.posix.sep){if(!r)return"";const m=r.length,d=r.charCodeAt(0);if(k(d)){if(k(r.charCodeAt(1))&&!k(r.charCodeAt(2))){let b=3;const y=b;for(;b<m&&!k(r.charCodeAt(b));b++);if(y!==b&&!k(r.charCodeAt(b+1))){for(b+=1;b<m;b++)if(k(r.charCodeAt(b)))return r.slice(0,b+1).replace(/[\\/]/g,i)}}return i}else if(D(d)&&r.charCodeAt(1)===58)return k(r.charCodeAt(2))?r.slice(0,2)+i:r.slice(0,2);let s=r.indexOf("://");if(s!==-1){for(s+=3;s<m;s++)if(k(r.charCodeAt(s)))return r.slice(0,s+1)}return""}e.getRoot=R;function F(r){if(!t.isWindows||!r||r.length<5)return!1;let i=r.charCodeAt(0);if(i!==92||(i=r.charCodeAt(1),i!==92))return!1;let m=2;const d=m;for(;m<r.length&&(i=r.charCodeAt(m),i!==92);m++);return!(d===m||(i=r.charCodeAt(m+1),isNaN(i)||i===92))}e.isUNC=F;const _=/[\\/:\*\?"<>\|]/g,n=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function o(r,i=t.isWindows){const m=i?_:n;return!(!r||r.length===0||/^\s+$/.test(r)||(m.lastIndex=0,m.test(r))||i&&f.test(r)||r==="."||r===".."||i&&r[r.length-1]==="."||i&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=o;function g(r,i,m){const d=r===i;return!m||d?d:!r||!i?!1:(0,w.equalsIgnoreCase)(r,i)}e.isEqual=g;function c(r,i,m,d=a.sep){if(r===i)return!0;if(!r||!i||i.length>r.length)return!1;if(m){if(!(0,w.startsWithIgnoreCase)(r,i))return!1;if(i.length===r.length)return!0;let b=i.length;return i.charAt(i.length-1)===d&&b--,r.charAt(b)===d}return i.charAt(i.length-1)!==d&&(i+=d),r.indexOf(i)===0}e.isEqualOrParent=c;function D(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=D;function v(r,i){return t.isWindows&&r.endsWith(":")&&(r+=a.sep),(0,a.isAbsolute)(r)||(r=(0,a.join)(i,r)),r=(0,a.normalize)(r),t.isWindows?(r=(0,w.rtrim)(r,a.sep),r.endsWith(":")&&(r+=a.sep)):(r=(0,w.rtrim)(r,a.sep),r||(r=a.sep)),r}e.sanitizeFilePath=v;function h(r){const i=(0,a.normalize)(r);return t.isWindows?r.length>3?!1:p(i)&&(r.length===2||i.charCodeAt(2)===92):i===a.posix.sep}e.isRootOrDriveLetter=h;function p(r,i){return(i!==void 0?i:t.isWindows)?D(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function I(r){return p(r)?r[0]:void 0}e.getDriveLetter=I;function l(r,i,m){return i.length>r.length?-1:r===i?0:(m&&(r=r.toLowerCase(),i=i.toLowerCase()),r.indexOf(i))}e.indexOfPath=l;function M(r){const i=r.split(":");let m,d,s;if(i.forEach(b=>{const y=Number(b);(0,T.isNumber)(y)?d===void 0?d=y:s===void 0&&(s=y):m=m?[m,b].join(":"):b}),!m)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:m,line:d!==void 0?d:void 0,column:s!==void 0?s:d!==void 0?1:void 0}}e.parseLineAndColumnAware=M}),define(Ee[54],ye([0,1,22,9,2]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function T(F){return JSON.stringify(F,C)}e.stringify=T;function k(F){let _=JSON.parse(F);return _=R(_),_}e.parse=k;var P;(function(F){F[F.Uri=1]="Uri",F[F.Regexp=2]="Regexp",F[F.ScmResource=3]="ScmResource",F[F.ScmResourceGroup=4]="ScmResourceGroup",F[F.ScmProvider=5]="ScmProvider",F[F.CommentController=6]="CommentController",F[F.CommentThread=7]="CommentThread",F[F.CommentThreadReply=8]="CommentThreadReply",F[F.CommentNode=9]="CommentNode",F[F.CommentThreadNode=10]="CommentThreadNode",F[F.TimelineActionContext=11]="TimelineActionContext",F[F.NotebookCellActionContext=12]="NotebookCellActionContext",F[F.TestItemContext=13]="TestItemContext"})(P=e.MarshalledId||(e.MarshalledId={}));function C(F,_){return _ instanceof RegExp?{$mid:2,source:_.source,flags:(0,t.regExpFlags)(_)}:_}function R(F,_=0){if(!F||_>200)return F;if(typeof F=="object"){switch(F.$mid){case 1:return w.URI.revive(F);case 2:return new RegExp(F.source,F.flags)}if(F instanceof a.VSBuffer||F instanceof Uint8Array)return F;if(Array.isArray(F))for(let n=0;n<F.length;++n)F[n]=R(F[n],_+1);else for(const n in F)Object.hasOwnProperty.call(F,n)&&(F[n]=R(F[n],_+1))}return F}e.revive=R}),define(Ee[10],ye([0,1,23,2]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var w;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp",P.vsls="vsls"})(w=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(C){this._preferredWebSchema=C}setDelegate(C){this._delegate=C}set(C,R,F){this._hosts[C]=R,this._ports[C]=F}setConnectionToken(C,R){this._connectionTokens[C]=R}rewrite(C){if(this._delegate)return this._delegate(C);const R=C.authority;let F=this._hosts[R];F&&F.indexOf(":")!==-1&&(F=`[${F}]`);const _=this._ports[R],n=this._connectionTokens[R];let f=`path=${encodeURIComponent(C.path)}`;return typeof n=="string"&&(f+=`&tkn=${encodeURIComponent(n)}`),t.URI.from({scheme:a.isWeb?this._preferredWebSchema:w.vscodeRemoteResource,authority:`${F}:${_}`,path:"/vscode-remote-resource",query:f})}}e.RemoteAuthorities=new T;class k{asBrowserUri(C,R){const F=this.toUri(C,R);return F.scheme===w.vscodeRemote?e.RemoteAuthorities.rewrite(F):F.scheme===w.file&&(a.isNative||typeof a.globals.importScripts=="function"&&a.globals.origin===`${w.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?F.with({scheme:w.vscodeFileResource,authority:F.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):F}asFileUri(C,R){const F=this.toUri(C,R);return F.scheme===w.vscodeFileResource?F.with({scheme:w.file,authority:F.authority!==k.FALLBACK_AUTHORITY?F.authority:null,query:null,fragment:null}):F}toUri(C,R){return t.URI.isUri(C)?C:t.URI.parse(R.toUrl(C))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k}),define(Ee[24],ye([0,1,42,10,17,23,9,2]),function(re,e,a,t,w,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function C(f){return(0,P.uriToFsPath)(f,!0)}e.originalFSPath=C;class R{constructor(o){this._ignorePathCasing=o}compare(o,g,c=!1){return o===g?0:(0,k.compare)(this.getComparisonKey(o,c),this.getComparisonKey(g,c))}isEqual(o,g,c=!1){return o===g?!0:!o||!g?!1:this.getComparisonKey(o,c)===this.getComparisonKey(g,c)}getComparisonKey(o,g=!1){return o.with({path:this._ignorePathCasing(o)?o.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(o){return this._ignorePathCasing(o)}isEqualOrParent(o,g,c=!1){if(o.scheme===g.scheme){if(o.scheme===t.Schemas.file)return a.isEqualOrParent(C(o),C(g),this._ignorePathCasing(o))&&o.query===g.query&&(c||o.fragment===g.fragment);if((0,e.isEqualAuthority)(o.authority,g.authority))return a.isEqualOrParent(o.path,g.path,this._ignorePathCasing(o),"/")&&o.query===g.query&&(c||o.fragment===g.fragment)}return!1}joinPath(o,...g){return P.URI.joinPath(o,...g)}basenameOrAuthority(o){return(0,e.basename)(o)||o.authority}basename(o){return w.posix.basename(o.path)}extname(o){return w.posix.extname(o.path)}dirname(o){if(o.path.length===0)return o;let g;return o.scheme===t.Schemas.file?g=P.URI.file(w.dirname(C(o))).path:(g=w.posix.dirname(o.path),o.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${o.toString})) resulted in a relative path`),g="/")),o.with({path:g})}normalizePath(o){if(!o.path.length)return o;let g;return o.scheme===t.Schemas.file?g=P.URI.file(w.normalize(C(o))).path:g=w.posix.normalize(o.path),o.with({path:g})}relativePath(o,g){if(o.scheme!==g.scheme||!(0,e.isEqualAuthority)(o.authority,g.authority))return;if(o.scheme===t.Schemas.file){const v=w.relative(C(o),C(g));return T.isWindows?a.toSlashes(v):v}let c=o.path||"/",D=g.path||"/";if(this._ignorePathCasing(o)){let v=0;for(const h=Math.min(c.length,D.length);v<h&&!(c.charCodeAt(v)!==D.charCodeAt(v)&&c.charAt(v).toLowerCase()!==D.charAt(v).toLowerCase());v++);c=D.substr(0,v)+c.substr(v)}return w.posix.relative(c,D)}resolvePath(o,g){if(o.scheme===t.Schemas.file){const c=P.URI.file(w.resolve(C(o),g));return o.with({authority:c.authority,path:c.path})}return g=a.toPosixPath(g),o.with({path:w.posix.resolve(o.path,g)})}isAbsolutePath(o){return!!o.path&&o.path[0]==="/"}isEqualAuthority(o,g){return o===g||o!==void 0&&g!==void 0&&(0,k.equalsIgnoreCase)(o,g)}hasTrailingPathSeparator(o,g=w.sep){if(o.scheme===t.Schemas.file){const c=C(o);return c.length>a.getRoot(c).length&&c[c.length-1]===g}else{const c=o.path;return c.length>1&&c.charCodeAt(c.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(o.fsPath)}}removeTrailingPathSeparator(o,g=w.sep){return(0,e.hasTrailingPathSeparator)(o,g)?o.with({path:o.path.substr(0,o.path.length-1)}):o}addTrailingPathSeparator(o,g=w.sep){let c=!1;if(o.scheme===t.Schemas.file){const D=C(o);c=D!==void 0&&D.length===a.getRoot(D).length&&D[D.length-1]===g}else{g="/";const D=o.path;c=D.length===1&&D.charCodeAt(D.length-1)===47}return!c&&!(0,e.hasTrailingPathSeparator)(o,g)?o.with({path:o.path+"/"}):o}}e.ExtUri=R,e.extUri=new R(()=>!1),e.extUriBiasedIgnorePathCase=new R(f=>f.scheme===t.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new R(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function F(f,o){const g=[];for(let c=0;c<f.length;c++){const D=o(f[c]);f.some((v,h)=>h===c?!1:(0,e.isEqualOrParent)(D,o(v)))||g.push(f[c])}return g}e.distinctParents=F;var _;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function o(g){const c=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(h=>{const[p,I]=h.split(":");p&&I&&c.set(p,I)});const v=g.path.substring(0,g.path.indexOf(";"));return v&&c.set(f.META_DATA_MIME,v),c}f.parseMetaData=o})(_=e.DataUri||(e.DataUri={}));function n(f,o,g){if(o){let c=f.path;return c&&c[0]!==w.posix.sep&&(c=w.posix.sep+c),f.with({scheme:g,authority:o,path:c})}return f.with({scheme:g})}e.toLocalResource=n}),define(Ee[14],ye([0,1,20,15,4,6,24,23]),function(re,e,a,t,w,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(ue){return!!ue&&typeof ue.then=="function"}e.isThenable=C;function R(ue){const Y=new a.CancellationTokenSource,ie=ue(Y.token),we=new Promise((Me,Re)=>{const Be=Y.token.onCancellationRequested(()=>{Be.dispose(),Y.dispose(),Re((0,t.canceled)())});Promise.resolve(ie).then(Qe=>{Be.dispose(),Y.dispose(),Me(Qe)},Qe=>{Be.dispose(),Y.dispose(),Re(Qe)})});return new class{cancel(){Y.cancel()}then(Me,Re){return we.then(Me,Re)}catch(Me){return this.then(void 0,Me)}finally(Me){return we.finally(Me)}}}e.createCancelablePromise=R;function F(ue,Y,ie){return Promise.race([ue,new Promise(we=>Y.onCancellationRequested(()=>we(ie)))])}e.raceCancellation=F;async function _(ue){let Y=-1;const ie=ue.map((Me,Re)=>Me.then(Be=>(Y=Re,Be))),we=await Promise.race(ie);return ue.forEach((Me,Re)=>{Re!==Y&&Me.cancel()}),we}e.raceCancellablePromises=_;function n(ue,Y,ie){let we;const Me=setTimeout(()=>{we?.(void 0),ie?.()},Y);return Promise.race([ue.finally(()=>clearTimeout(Me)),new Promise(Re=>we=Re)])}e.raceTimeout=n;function f(ue){return new Promise((Y,ie)=>{const we=ue();C(we)?we.then(Y,ie):Y(we)})}e.asPromise=f;class o{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Y){if(this.activePromise){if(this.queuedPromiseFactory=Y,!this.queuedPromise){const ie=()=>{this.queuedPromise=null;const we=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,we};this.queuedPromise=new Promise(we=>{this.activePromise.then(ie,ie).then(we)})}return new Promise((ie,we)=>{this.queuedPromise.then(ie,we)})}return this.activePromise=Y(),new Promise((ie,we)=>{this.activePromise.then(Me=>{this.activePromise=null,ie(Me)},Me=>{this.activePromise=null,we(Me)})})}}e.Throttler=o;class g{constructor(){this.current=Promise.resolve(null)}queue(Y){return this.current=this.current.then(()=>Y(),()=>Y())}}e.Sequencer=g;class c{constructor(){this.promiseMap=new Map}queue(Y,ie){const Me=(this.promiseMap.get(Y)??Promise.resolve()).catch(()=>{}).then(ie).finally(()=>{this.promiseMap.get(Y)===Me&&this.promiseMap.delete(Y)});return this.promiseMap.set(Y,Me),Me}}e.SequencerByKey=c;class D{constructor(Y){this.defaultDelay=Y,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Y,ie=this.defaultDelay){return this.task=Y,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((we,Me)=>{this.doResolve=we,this.doReject=Me}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const we=this.task;return this.task=null,we()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},ie),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,t.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=D;class v{constructor(Y){this.delayer=new D(Y),this.throttler=new o}trigger(Y,ie){return this.delayer.trigger(()=>this.throttler.queue(Y),ie)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=v;class h{constructor(){this._isOpen=!1,this._promise=new Promise((Y,ie)=>{this._completePromise=Y})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=h;class p extends h{constructor(Y){super();this._timeout=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=p;function I(ue,Y){return Y?new Promise((ie,we)=>{const Me=setTimeout(()=>{Re.dispose(),ie()},ue),Re=Y.onCancellationRequested(()=>{clearTimeout(Me),Re.dispose(),we((0,t.canceled)())})}):R(ie=>I(ue,ie))}e.timeout=I;function l(ue,Y=0){const ie=setTimeout(ue,Y);return(0,T.toDisposable)(()=>clearTimeout(ie))}e.disposableTimeout=l;function M(ue){const Y=[];let ie=0;const we=ue.length;function Me(){return ie<we?ue[ie++]():null}function Re(Be){Be!=null&&Y.push(Be);const Qe=Me();return Qe?Qe.then(Re):Promise.resolve(Y)}return Promise.resolve(null).then(Re)}e.sequence=M;function r(ue,Y=we=>!!we,ie=null){let we=0;const Me=ue.length,Re=()=>{if(we>=Me)return Promise.resolve(ie);const Be=ue[we++];return Promise.resolve(Be()).then(Ke=>Y(Ke)?Promise.resolve(Ke):Re())};return Re()}e.first=r;function i(ue,Y=we=>!!we,ie=null){if(ue.length===0)return Promise.resolve(ie);let we=ue.length;const Me=()=>{we=-1;for(const Re of ue)Re.cancel?.()};return new Promise((Re,Be)=>{for(const Qe of ue)Qe.then(Ke=>{--we>=0&&Y(Ke)?(Me(),Re(Ke)):we===0&&Re(ie)}).catch(Ke=>{--we>=0&&(Me(),Be(Ke))})})}e.firstParallel=i;class m{constructor(Y){this._size=0,this.maxDegreeOfParalellism=Y,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new w.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(Y){return this._size++,new Promise((ie,we)=>{this.outstandingPromises.push({factory:Y,c:ie,e:we}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Y=this.outstandingPromises.shift();this.runningPromises++;const ie=Y.factory();ie.then(Y.c,Y.e),ie.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=m;class d extends m{constructor(){super(1)}}e.Queue=d;class s{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const Y=new N;return this.drainers.add(Y),Y.p}isDrained(){for(const[,Y]of this.queues)if(Y.size>0)return!1;return!0}queueFor(Y,ie=k.extUri){const we=ie.getComparisonKey(Y);let Me=this.queues.get(we);return Me||(Me=new d,w.Event.once(Me.onFinished)(()=>{Me?.dispose(),this.queues.delete(we),this.onDidQueueFinish()}),this.queues.set(we,Me)),Me}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const Y of this.drainers)Y.complete();this.drainers.clear()}dispose(){for(const[,Y]of this.queues)Y.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=s;class b{constructor(Y,ie){this._token=-1,typeof Y=="function"&&typeof ie=="number"&&this.setIfNotSet(Y,ie)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Y,ie){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Y()},ie)}setIfNotSet(Y,ie){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Y()},ie))}}e.TimeoutTimer=b;class y{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Y,ie){this.cancel(),this._token=setInterval(()=>{Y()},ie)}}e.IntervalTimer=y;class u{constructor(Y,ie){this.timeoutToken=-1,this.runner=Y,this.timeout=ie,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Y=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Y)}get delay(){return this.timeout}set delay(Y){this.timeout=Y}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=u;class S{constructor(Y,ie){ie%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.runner=Y,this.timeout=ie,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Y=this.timeout){Y%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Y/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=S;class A extends u{constructor(Y,ie){super(Y,ie);this.units=[]}work(Y){this.units.push(Y),this.isScheduled()||this.schedule()}doRun(){const Y=this.units;this.units=[],this.runner&&this.runner(Y)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=A;class U extends T.Disposable{constructor(Y,ie,we,Me){super();this.maxWorkChunkSize=Y,this.maxPendingWork=ie,this.throttleDelay=we,this.handler=Me,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Y){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+Y.length>this.maxPendingWork)return!1}else if(this.pending+Y.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...Y),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new u(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ue=>{(0,P.setTimeout0)(()=>{if(Y)return;const ie=Date.now()+15;ue(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ie-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.runWhenIdle=(ue,Y)=>{const ie=requestIdleCallback(ue,typeof Y=="number"?{timeout:Y}:void 0);let we=!1;return{dispose(){we||(we=!0,cancelIdleCallback(ie))}}}}();class H{constructor(Y){this._didRun=!1,this._executor=()=>{try{this._value=Y()}catch(ie){this._error=ie}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=H;async function E(ue,Y,ie){let we;for(let Me=0;Me<ie;Me++)try{return await ue()}catch(Re){we=Re,await I(Y)}throw we}e.retry=E;class L{hasPending(Y){return this._pending?typeof Y=="number"?this._pending.taskId===Y:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(Y,ie,we){return this._pending={taskId:Y,cancel:()=>we?.(),promise:ie},ie.then(()=>this.donePending(Y),()=>this.donePending(Y)),ie}donePending(Y){this._pending&&Y===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Y=this._next;this._next=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}setNext(Y){if(this._next)this._next.run=Y;else{let ie,we;const Me=new Promise((Re,Be)=>{ie=Re,we=Be});this._next={run:Y,promise:Me,promiseResolve:ie,promiseReject:we}}return this._next.promise}}e.TaskSequentializer=L;class z{constructor(Y,ie=()=>Date.now()){this.interval=Y,this.nowFn=ie,this.lastIncrementTime=0,this.value=0}increment(){const Y=this.nowFn();return Y-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Y,this.value=0),this.value++,this.value}}e.IntervalCounter=z;class N{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Y,ie)=>{this.completeCallback=Y,this.errorCallback=ie})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(Y){return new Promise(ie=>{this.completeCallback(Y),this.resolved=!0,ie()})}error(Y){return new Promise(ie=>{this.errorCallback(Y),this.rejected=!0,ie()})}cancel(){new Promise(Y=>{this.errorCallback((0,t.canceled)()),this.rejected=!0,Y()})}}e.DeferredPromise=N;var B;(function(ue){async function Y(we){let Me;const Re=await Promise.all(we.map(Be=>Be.then(Qe=>Qe,Qe=>{Me||(Me=Qe)})));if(typeof Me!="undefined")throw Me;return Re}ue.settled=Y;function ie(we){return new Promise(async(Me,Re)=>{try{await we(Me,Re)}catch(Be){Re(Be)}})}ue.withAsyncBody=ie})(B=e.Promises||(e.Promises={}));var j;(function(ue){ue[ue.Initial=0]="Initial",ue[ue.DoneOK=1]="DoneOK",ue[ue.DoneError=2]="DoneError"})(j||(j={}));class ce{constructor(Y){this._state=0,this._results=[],this._error=null,this._onStateChanged=new w.Emitter,queueMicrotask(async()=>{const ie={emitOne:we=>this.emitOne(we),emitMany:we=>this.emitMany(we),reject:we=>this.reject(we)};try{await Promise.resolve(Y(ie)),this.resolve()}catch(we){this.reject(we)}finally{ie.emitOne=void 0,ie.emitMany=void 0,ie.reject=void 0}})}static fromArray(Y){return new ce(ie=>{ie.emitMany(Y)})}static fromPromise(Y){return new ce(async ie=>{ie.emitMany(await Y)})}static fromPromises(Y){return new ce(async ie=>{await Promise.all(Y.map(async we=>ie.emitOne(await we)))})}static merge(Y){return new ce(async ie=>{await Promise.all(Y.map(async we=>{for await(const Me of we)ie.emitOne(Me)}))})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Y<this._results.length)return{done:!1,value:this._results[Y++]};if(this._state===1)return{done:!0,value:void 0};await w.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Y,ie){return new ce(async we=>{for await(const Me of Y)we.emitOne(ie(Me))})}map(Y){return ce.map(this,Y)}static filter(Y,ie){return new ce(async we=>{for await(const Me of Y)ie(Me)&&we.emitOne(Me)})}filter(Y){return ce.filter(this,Y)}static coalesce(Y){return ce.filter(Y,ie=>!!ie)}coalesce(){return ce.coalesce(this)}static async toPromise(Y){const ie=[];for await(const we of Y)ie.push(we);return ie}toPromise(){return ce.toPromise(this)}emitOne(Y){this._state===0&&(this._results.push(Y),this._onStateChanged.fire())}emitMany(Y){this._state===0&&(this._results=this._results.concat(Y),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Y){this._state===0&&(this._state=2,this._error=Y,this._onStateChanged.fire())}}e.AsyncIterableObject=ce,ce.EMPTY=ce.fromArray([]);class K extends ce{constructor(Y,ie){super(ie);this._source=Y}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=K;function le(ue){const Y=new a.CancellationTokenSource,ie=ue(Y.token);return new K(Y,async we=>{const Me=Y.token.onCancellationRequested(()=>{Me.dispose(),Y.dispose(),we.reject((0,t.canceled)())});try{for await(const Re of ie){if(Y.token.isCancellationRequested)return;we.emitOne(Re)}Me.dispose(),Y.dispose()}catch(Re){Me.dispose(),Y.dispose(),we.reject(Re)}})}e.createCancelableAsyncIterable=le}),define(Ee[105],ye([0,1,14,17]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const w=new a.IdleValue(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),T=new a.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),k=new a.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(y,u,S=!1){const A=y||"",U=u||"",H=w.value.collator.compare(A,U);return w.value.collatorIsNumeric&&H===0&&A!==U?A<U?-1:1:H}e.compareFileNames=P;function C(y,u){const S=T.value.collator;return y=y||"",u=u||"",I(S,y,u)}e.compareFileNamesDefault=C;function R(y,u){const S=T.value.collator;return y=y||"",u=u||"",i(y,u)||I(S,y,u)}e.compareFileNamesUpper=R;function F(y,u){const S=T.value.collator;return y=y||"",u=u||"",r(y,u)||I(S,y,u)}e.compareFileNamesLower=F;function _(y,u){return y=y||"",u=u||"",y===u?0:y<u?-1:1}e.compareFileNamesUnicode=_;function n(y,u,S=!1){S||(y=y&&y.toLowerCase(),u=u&&u.toLowerCase());const[A,U]=h(y),[H,E]=h(u);return A!==H?A<H?-1:1:U===E?0:U<E?-1:1}e.noIntlCompareFileNames=n;function f(y,u){const[S,A]=h(y),[U,H]=h(u);let E=w.value.collator.compare(A,H);if(E===0){if(w.value.collatorIsNumeric&&A!==H)return A<H?-1:1;if(E=w.value.collator.compare(S,U),w.value.collatorIsNumeric&&E===0&&S!==U)return S<U?-1:1}return E}e.compareFileExtensions=f;function o(y,u){y=y||"",u=u||"";const S=p(y),A=p(u),U=T.value.collator,H=k.value.collator;return I(H,S,A)||I(U,y,u)}e.compareFileExtensionsDefault=o;function g(y,u){y=y||"",u=u||"";const S=p(y),A=p(u),U=T.value.collator,H=k.value.collator;return I(H,S,A)||i(y,u)||I(U,y,u)}e.compareFileExtensionsUpper=g;function c(y,u){y=y||"",u=u||"";const S=p(y),A=p(u),U=T.value.collator,H=k.value.collator;return I(H,S,A)||r(y,u)||I(U,y,u)}e.compareFileExtensionsLower=c;function D(y,u){y=y||"",u=u||"";const S=p(y).toLowerCase(),A=p(u).toLowerCase();return S!==A?S<A?-1:1:y!==u?y<u?-1:1:0}e.compareFileExtensionsUnicode=D;const v=/^(.*?)(\.([^.]*))?$/;function h(y,u=!1){const S=y?v.exec(y):[];let A=[S&&S[1]||"",S&&S[3]||""];return u&&(!A[0]&&A[1]||A[0]&&A[0].charAt(0)===".")&&(A=[A[0]+"."+A[1],""]),A}function p(y){const u=y?v.exec(y):[];return u&&u[1]&&u[1].charAt(0)!=="."&&u[3]||""}function I(y,u,S){let A=y.compare(u,S);return A!==0?A:u.length!==S.length?u.length<S.length?-1:1:0}function l(y){const u=y.charAt(0);return u.toLocaleUpperCase()!==u}function M(y){const u=y.charAt(0);return u.toLocaleLowerCase()!==u}function r(y,u){return l(y)&&M(u)?-1:M(y)&&l(u)?1:0}function i(y,u){return M(y)&&l(u)?-1:l(y)&&M(u)?1:0}function m(y,u,S=!1){return S||(y=y&&y.toLowerCase(),u=u&&u.toLowerCase()),y===u?0:y<u?-1:1}function d(y,u,S=!1){const A=y.split(t.sep),U=u.split(t.sep),H=A.length-1,E=U.length-1;let L,z;for(let N=0;;N++){if(L=H===N,z=E===N,L&&z)return P(A[N],U[N],S);if(L)return-1;if(z)return 1;const B=m(A[N],U[N],S);if(B!==0)return B}}e.comparePaths=d;function s(y,u,S){const A=y.toLowerCase(),U=u.toLowerCase(),H=b(y,u,S);if(H)return H;const E=A.endsWith(S),L=U.endsWith(S);if(E!==L)return E?-1:1;const z=P(A,U);return z!==0?z:A.localeCompare(U)}e.compareAnything=s;function b(y,u,S){const A=y.toLowerCase(),U=u.toLowerCase(),H=A.startsWith(S),E=U.startsWith(S);if(H!==E)return H?-1:1;if(H&&E){if(A.length<U.length)return-1;if(A.length>U.length)return 1}return 0}e.compareByPrefix=b}),define(Ee[29],ye([0,1,14,42,21,17,9]),function(re,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const C="**",R="/",F="[/\\\\]",_="[^/\\\\]",n=/\//g;function f(K){switch(K){case 0:return"";case 1:return`${_}*?`;default:return`(?:${F}|${_}+${F}|${F}${_}+)*?`}}function o(K,le){if(!K)return[];const ue=[];let Y=!1,ie=!1,we="";for(const Me of K){switch(Me){case le:if(!Y&&!ie){ue.push(we),we="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}we+=Me}return we&&ue.push(we),ue}e.splitGlobAware=o;function g(K){if(!K)return"";let le="";const ue=o(K,R);if(ue.every(Y=>Y===C))le=".*";else{let Y=!1;ue.forEach((ie,we)=>{if(ie===C){Y||(le+=f(2),Y=!0);return}let Me=!1,Re="",Be=!1,Qe="";for(const Ke of ie){if(Ke!=="}"&&Me){Re+=Ke;continue}if(Be&&(Ke!=="]"||!Qe)){let Xe;Ke==="-"?Xe=Ke:(Ke==="^"||Ke==="!")&&!Qe?Xe="^":Ke===R?Xe="":Xe=k.escapeRegExpCharacters(Ke),Qe+=Xe;continue}switch(Ke){case"{":Me=!0;continue;case"[":Be=!0;continue;case"}":{le+=`(?:${o(Re,",").map(G=>g(G)).join("|")})`,Me=!1,Re="";break}case"]":le+="["+Qe+"]",Be=!1,Qe="";break;case"?":le+=_;continue;case"*":le+=f(1);continue;default:le+=k.escapeRegExpCharacters(Ke)}}we<ue.length-1&&(ue[we+1]!==C||we+2<ue.length)&&(le+=F),Y=!1})}return le}const c=/^\*\*\/\*\.[\w\.-]+$/,D=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,h=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,p=/^\*\*((\/[\w\.-]+)+)\/?$/,I=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,l=new w.LRUCache(1e4),M=function(){return!1},r=function(){return null};function i(K,le){if(!K)return r;let ue;typeof K!="string"?ue=K.pattern:ue=K,ue=ue.trim();const Y=`${ue}_${!!le.trimForExclusions}`;let ie=l.get(Y);if(ie)return m(ie,K);let we;if(c.test(ue)){const Me=ue.substr(4);ie=function(Re,Be){return typeof Re=="string"&&Re.endsWith(Me)?ue:null}}else(we=D.exec(d(ue,le)))?ie=s(we[1],ue):(le.trimForExclusions?h:v).test(ue)?ie=b(ue,le):(we=p.exec(d(ue,le)))?ie=y(we[1].substr(1),ue,!0):(we=I.exec(d(ue,le)))?ie=y(we[1],ue,!1):ie=u(ue);return l.set(Y,ie),m(ie,K)}function m(K,le){return typeof le=="string"?K:function(ue,Y){return t.isEqualOrParent(ue,le.base)?K(T.relative(le.base,ue),Y):null}}function d(K,le){return le.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function s(K,le){const ue=`/${K}`,Y=`\\${K}`,ie=function(Me,Re){return typeof Me!="string"?null:Re?Re===K?le:null:Me===K||Me.endsWith(ue)||Me.endsWith(Y)?le:null},we=[K];return ie.basenames=we,ie.patterns=[le],ie.allBasenames=we,ie}function b(K,le){const ue=ce(K.slice(1,-1).split(",").map(Re=>i(Re,le)).filter(Re=>Re!==r),K),Y=ue.length;if(!Y)return r;if(Y===1)return ue[0];const ie=function(Re,Be){for(let Qe=0,Ke=ue.length;Qe<Ke;Qe++)if(ue[Qe](Re,Be))return K;return null},we=ue.find(Re=>!!Re.allBasenames);we&&(ie.allBasenames=we.allBasenames);const Me=ue.reduce((Re,Be)=>Be.allPaths?Re.concat(Be.allPaths):Re,[]);return Me.length&&(ie.allPaths=Me),ie}function y(K,le,ue){const Y=T.sep===T.posix.sep,ie=Y?K:K.replace(n,T.sep),we=T.sep+ie,Me=T.posix.sep+K,Re=ue?function(Be,Qe){return typeof Be=="string"&&(Be===ie||Be.endsWith(we)||!Y&&(Be===K||Be.endsWith(Me)))?le:null}:function(Be,Qe){return typeof Be=="string"&&(Be===ie||!Y&&Be===K)?le:null};return Re.allPaths=[(ue?"*/":"./")+K],Re}function u(K){try{const le=new RegExp(`^${g(K)}$`);return function(ue){return le.lastIndex=0,typeof ue=="string"&&le.test(ue)?K:null}}catch{return r}}function S(K,le,ue){return!K||typeof le!="string"?!1:A(K)(le,void 0,ue)}e.match=S;function A(K,le={}){if(!K)return M;if(typeof K=="string"||L(K)){const ue=i(K,le);if(ue===r)return M;const Y=function(ie,we){return!!ue(ie,we)};return ue.allBasenames&&(Y.allBasenames=ue.allBasenames),ue.allPaths&&(Y.allPaths=ue.allPaths),Y}return B(K,le)}e.parse=A;function U(K){if(!K)return;let le;return ue=>(le||(le=(K()||Promise.resolve([])).then(Y=>Y?E(Y):{})),le.then(Y=>!!Y[ue]))}e.hasSiblingPromiseFn=U;function H(K){if(!K)return;let le;return ue=>{if(!le){const Y=K();le=Y?E(Y):{}}return!!le[ue]}}e.hasSiblingFn=H;function E(K){const le={};for(const ue of K)le[ue]=!0;return le}function L(K){const le=K;return le&&typeof le.base=="string"&&typeof le.pattern=="string"}e.isRelativePattern=L;function z(K){return K.allBasenames||[]}e.getBasenameTerms=z;function N(K){return K.allPaths||[]}e.getPathTerms=N;function B(K,le){const ue=ce(Object.getOwnPropertyNames(K).map(Re=>j(Re,K[Re],le)).filter(Re=>Re!==r)),Y=ue.length;if(!Y)return r;if(!ue.some(Re=>!!Re.requiresSiblings)){if(Y===1)return ue[0];const Re=function(Ke,Xe){for(let $=0,G=ue.length;$<G;$++){const J=ue[$](Ke,Xe);if(J)return J}return null},Be=ue.find(Ke=>!!Ke.allBasenames);Be&&(Re.allBasenames=Be.allBasenames);const Qe=ue.reduce((Ke,Xe)=>Xe.allPaths?Ke.concat(Xe.allPaths):Ke,[]);return Qe.length&&(Re.allPaths=Qe),Re}const ie=function(Re,Be,Qe){let Ke;for(let Xe=0,$=ue.length;Xe<$;Xe++){const G=ue[Xe];G.requiresSiblings&&Qe&&(Be||(Be=T.basename(Re)),Ke||(Ke=Be.substr(0,Be.length-T.extname(Re).length)));const J=G(Re,Be,Ke,Qe);if(J)return J}return null},we=ue.find(Re=>!!Re.allBasenames);we&&(ie.allBasenames=we.allBasenames);const Me=ue.reduce((Re,Be)=>Be.allPaths?Re.concat(Be.allPaths):Re,[]);return Me.length&&(ie.allPaths=Me),ie}function j(K,le,ue){if(le===!1)return r;const Y=i(K,ue);if(Y===r)return r;if(typeof le=="boolean")return Y;if(le){const ie=le.when;if(typeof ie=="string"){const we=(Me,Re,Be,Qe)=>{if(!Qe||!Y(Me,Re))return null;const Ke=ie.replace("$(basename)",Be),Xe=Qe(Ke);return(0,a.isThenable)(Xe)?Xe.then($=>$?K:null):Xe?K:null};return we.requiresSiblings=!0,we}}return Y}function ce(K,le){const ue=K.filter(Re=>!!Re.basenames);if(ue.length<2)return K;const Y=ue.reduce((Re,Be)=>{const Qe=Be.basenames;return Qe?Re.concat(Qe):Re},[]);let ie;if(le){ie=[];for(let Re=0,Be=Y.length;Re<Be;Re++)ie.push(le)}else ie=ue.reduce((Re,Be)=>{const Qe=Be.patterns;return Qe?Re.concat(Qe):Re},[]);const we=function(Re,Be){if(typeof Re!="string")return null;if(!Be){let Ke;for(Ke=Re.length;Ke>0;Ke--){const Xe=Re.charCodeAt(Ke-1);if(Xe===47||Xe===92)break}Be=Re.substr(Ke)}const Qe=Y.indexOf(Be);return Qe!==-1?ie[Qe]:null};we.basenames=Y,we.patterns=ie,we.allBasenames=Y;const Me=K.filter(Re=>!Re.basenames);return Me.push(we),Me}}),define(Ee[77],ye([0,1,42,10,17,23,24,9,2]),function(re,e,a,t,w,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function R(i,m,d){if(typeof i=="string"&&(i=C.URI.file(i)),d){const b=d.getWorkspaceFolder(i);if(b){const y=d.getWorkspace().folders.length>1;let u;if((0,k.isEqual)(b.uri,i)?u="":u=(0,k.relativePath)(b.uri,i),y){const S=b.name?b.name:(0,k.basename)(b.uri);u=u?S+" \u2022 "+u:S}return u}}if(i.scheme!==t.Schemas.file&&i.scheme!==t.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,a.hasDriveLetter)(i.fsPath))return(0,w.normalize)(_(i.fsPath));let s=(0,w.normalize)(i.fsPath);return!T.isWindows&&m?.userHome&&(s=f(s,m.userHome.fsPath)),s}e.getPathLabel=R;function F(i){if(!i)return;typeof i=="string"&&(i=C.URI.file(i));const m=(0,k.basename)(i)||(i.scheme===t.Schemas.file?i.fsPath:i.path);return T.isWindows&&(0,a.isRootOrDriveLetter)(m)?_(m):m}e.getBaseLabel=F;function _(i,m){return(0,a.hasDriveLetter)(i,m)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=_;let n=Object.create(null);function f(i,m){if(T.isWindows||!i||!m)return i;let d=n.original===m?n.normalized:void 0;return d||(d=`${(0,P.rtrim)(m,w.posix.sep)}${w.posix.sep}`,n={original:m,normalized:d}),(T.isLinux?i.startsWith(d):(0,P.startsWithIgnoreCase)(i,d))&&(i=`~/${i.substr(d.length)}`),i}e.tildify=f;function o(i,m){return i.replace(/^~($|\/|\\)/,`${m}$1`)}e.untildify=o;const g="\u2026",c="\\\\",D="~";function v(i,m=w.sep){const d=new Array(i.length);let s=!1;for(let b=0;b<i.length;b++){let y=i[b];if(y===""){d[b]=`.${m}`;continue}if(!y){d[b]=y;continue}s=!0;let u="";y.indexOf(c)===0?(u=y.substr(0,y.indexOf(c)+c.length),y=y.substr(y.indexOf(c)+c.length)):y.indexOf(m)===0?(u=y.substr(0,y.indexOf(m)+m.length),y=y.substr(y.indexOf(m)+m.length)):y.indexOf(D)===0&&(u=y.substr(0,y.indexOf(D)+D.length),y=y.substr(y.indexOf(D)+D.length));const S=y.split(m);for(let A=1;s&&A<=S.length;A++)for(let U=S.length-A;s&&U>=0;U--){s=!1;let H=S.slice(U,U+A).join(m);for(let E=0;!s&&E<i.length;E++)if(E!==b&&i[E]&&i[E].indexOf(H)>-1){const L=U+A===S.length,z=U>0&&i[E].indexOf(m)>-1?m+H:H,N=i[E].endsWith(z);s=!L||N}if(!s){let E="";(S[0].endsWith(":")||u!=="")&&(U===1&&(U=0,A++,H=S[0]+m+H),U>0&&(E=S[0]+m),E=u+E),U>0&&(E=E+g+m),E=E+H,U+A<S.length&&(E=E+m+g),d[b]=E}}s&&(d[b]=y)}return d}e.shorten=v;var h;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function p(i,m=Object.create(null)){const d=[];let s=!1,b="";for(const y of i)if(y==="$"||s&&y==="{")b&&d.push({value:b,type:h.TEXT}),b="",s=!0;else if(y==="}"&&s){const u=m[b];if(typeof u=="string")u.length&&d.push({value:u,type:h.VARIABLE});else if(u){const S=d[d.length-1];(!S||S.type!==h.SEPARATOR)&&d.push({value:u.label,type:h.SEPARATOR})}b="",s=!1}else b+=y;return b&&!s&&d.push({value:b,type:h.TEXT}),d.filter((y,u)=>{if(y.type===h.SEPARATOR){const S=d[u-1],A=d[u+1];return[S,A].every(U=>U&&(U.type===h.VARIABLE||U.type===h.TEXT)&&U.value.length>0)}return!0}).map(y=>y.value).join("")}e.template=p;function I(i,m){return T.isMacintosh||m?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):i.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.mnemonicMenuLabel=I;function l(i,m){return T.isMacintosh||m?i.replace(/\(&&\w\)|&&/g,""):T.isWindows?i.replace(/&&|&/g,d=>d==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=l;function M(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=M;function r(i){const m=i.indexOf("/")!==-1?w.posix:w.win32,d=m.basename(i),s=m.dirname(i);return d.length?{name:d,parentPath:s}:{name:s,parentPath:""}}e.splitName=r}),define(Ee[78],ye([0,1,29,10,17,24,9]),function(re,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var P;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown",i.latex="text/latex"})(P=e.Mimes||(e.Mimes={}));let C=[],R=[],F=[];function _(i,m=!1){const d=n(i);C.push(d),d.userConfigured?F.push(d):R.push(d),m&&!d.userConfigured&&C.forEach(s=>{s.mime===d.mime||s.userConfigured||(d.extension&&s.extension===d.extension&&console.warn(`Overwriting extension <<${d.extension}>> to now point to mime <<${d.mime}>>`),d.filename&&s.filename===d.filename&&console.warn(`Overwriting filename <<${d.filename}>> to now point to mime <<${d.mime}>>`),d.filepattern&&s.filepattern===d.filepattern&&console.warn(`Overwriting filepattern <<${d.filepattern}>> to now point to mime <<${d.mime}>>`),d.firstline&&s.firstline===d.firstline&&console.warn(`Overwriting firstline <<${d.firstline}>> to now point to mime <<${d.mime}>>`))})}e.registerTextMime=_;function n(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?(0,a.parse)(i.filepattern.toLowerCase()):void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(w.posix.sep)>=0:!1}}function f(i){i?(C=C.filter(m=>!m.userConfigured),F=[]):(C=[],R=[],F=[])}e.clearTextMimes=f;function o(i,m){let d;if(i)switch(i.scheme){case t.Schemas.file:d=i.fsPath;break;case t.Schemas.data:{d=T.DataUri.parseMetaData(i).get(T.DataUri.META_DATA_LABEL);break}default:d=i.path}if(!d)return[P.unknown];d=d.toLowerCase();const s=(0,w.basename)(d),b=g(d,s,F);if(b)return[b,P.text];const y=g(d,s,R);if(y)return[y,P.text];if(m){const u=c(m);if(u)return[u,P.text]}return[P.unknown]}e.guessMimeTypes=o;function g(i,m,d){let s=null,b=null,y=null;for(let u=d.length-1;u>=0;u--){const S=d[u];if(m===S.filenameLowercase){s=S;break}if(S.filepattern&&(!b||S.filepattern.length>b.filepattern.length)){const A=S.filepatternOnPath?i:m;S.filepatternLowercase?.(A)&&(b=S)}S.extension&&(!y||S.extension.length>y.extension.length)&&m.endsWith(S.extensionLowercase)&&(y=S)}return s?s.mime:b?b.mime:y?y.mime:null}function c(i){if((0,k.startsWithUTF8BOM)(i)&&(i=i.substr(1)),i.length>0)for(let m=C.length-1;m>=0;m--){const d=C[m];if(!d.firstline)continue;const s=i.match(d.firstline);if(s&&s.length>0)return d.mime}return null}function D(i){return i?typeof i=="string"?i===P.binary||i===P.text||i===P.unknown:i.length===1&&D(i[0]):!0}e.isUnspecific=D;const v={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},h={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function p(i){const m=(0,w.extname)(i),d=v[m.toLowerCase()];return d!==void 0?d:I(i)}e.getMediaOrTextMime=p;function I(i){const m=(0,w.extname)(i);return h[m.toLowerCase()]}e.getMediaMime=I;function l(i){for(const m in h)if(h[m]===i)return m}e.getExtensionForMimeType=l;const M=/^(.+)\/(.+?)(;.+)?$/;function r(i,m){const d=M.exec(i);return d?`${d[1].toLowerCase()}/${d[2].toLowerCase()}${d[3]??""}`:m?void 0:i}e.normalizeMimeType=r}),define(Ee[106],ye([0,1,2]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(F){return F.toJSON()}class w{constructor(_){this._uriTransformer=_}transformIncoming(_){const n=this._uriTransformer.transformIncoming(_);return n===_?_:t(a.URI.from(n))}transformOutgoing(_){const n=this._uriTransformer.transformOutgoing(_);return n===_?_:t(a.URI.from(n))}transformOutgoingURI(_){const n=this._uriTransformer.transformOutgoing(_);return n===_?_:a.URI.from(n)}transformOutgoingScheme(_){return this._uriTransformer.transformOutgoingScheme(_)}}e.URITransformer=w,e.DefaultURITransformer=new class{transformIncoming(F){return F}transformOutgoing(F){return F}transformOutgoingURI(F){return F}transformOutgoingScheme(F){return F}};function T(F,_,n){if(!F||n>200)return null;if(typeof F=="object"){if(F instanceof a.URI)return _.transformOutgoing(F);for(let f in F)if(Object.hasOwnProperty.call(F,f)){const o=T(F[f],_,n+1);o!==null&&(F[f]=o)}}return null}function k(F,_){const n=T(F,_,0);return n===null?F:n}e.transformOutgoingURIs=k;function P(F,_,n,f){if(!F||f>200)return null;if(typeof F=="object"){if(F.$mid===1)return n?a.URI.revive(_.transformIncoming(F)):_.transformIncoming(F);for(let o in F)if(Object.hasOwnProperty.call(F,o)){const g=P(F[o],_,n,f+1);g!==null&&(F[o]=g)}}return null}function C(F,_){const n=P(F,_,!1,0);return n===null?F:n}e.transformIncomingURIs=C;function R(F,_){const n=P(F,_,!0,0);return n===null?F:n}e.transformAndReviveIncomingURIs=R}),define(Ee[35],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const a=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(C){return a.test(C)}e.isUUID=t;const w=new Uint8Array(16),T=[];for(let C=0;C<256;C++)T.push(C.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(C){for(let R=0;R<C.length;R++)C[R]=Math.floor(Math.random()*256);return C};function P(){k(w),w[6]=w[6]&15|64,w[8]=w[8]&63|128;let C=0,R="";return R+=T[w[C++]],R+=T[w[C++]],R+=T[w[C++]],R+=T[w[C++]],R+="-",R+=T[w[C++]],R+=T[w[C++]],R+="-",R+=T[w[C++]],R+=T[w[C++]],R+="-",R+=T[w[C++]],R+=T[w[C++]],R+="-",R+=T[w[C++]],R+=T[w[C++]],R+=T[w[C++]],R+=T[w[C++]],R+=T[w[C++]],R+=T[w[C++]],R}e.generateUuid=P}),define(Ee[107],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var a;(function(k){k[k.None=0]="None",k[k.Indent=1]="Indent",k[k.IndentOutdent=2]="IndentOutdent",k[k.Outdent=3]="Outdent"})(a=e.IndentAction||(e.IndentAction={}));class t{constructor(P){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=P.open,this.close=P.close,this._standardTokenMask=0,Array.isArray(P.notIn))for(let C=0,R=P.notIn.length;C<R;C++)switch(P.notIn[C]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(P){return(this._standardTokenMask&P)==0}shouldAutoClose(P,C){if(P.getTokenCount()===0)return!0;const R=P.findTokenIndexAtOffset(C-2),F=P.getStandardTokenType(R);return this.isOK(F)}_findNeutralCharacterInRange(P,C){for(let R=P;R<=C;R++){const F=String.fromCharCode(R);if(!this.open.includes(F)&&!this.close.includes(F))return F}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class w{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const C of P)T(this.autoClosingPairsOpenByStart,C.open.charAt(0),C),T(this.autoClosingPairsOpenByEnd,C.open.charAt(C.open.length-1),C),T(this.autoClosingPairsCloseByStart,C.close.charAt(0),C),T(this.autoClosingPairsCloseByEnd,C.close.charAt(C.close.length-1),C),C.close.length===1&&C.open.length===1&&T(this.autoClosingPairsCloseSingleChar,C.close,C)}}e.AutoClosingPairs=w;function T(k,P,C){k.has(P)?k.get(P).push(C):k.set(P,[C])}}),define(Ee[55],ye([0,1,29,17]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function w(T,k,P,C){if(Array.isArray(T)){let R=0;for(const F of T){const _=w(F,k,P,C);if(_===10)return _;_>R&&(R=_)}return R}else{if(typeof T=="string")return C?T==="*"?5:T===P?10:0:0;if(T){const{language:R,pattern:F,scheme:_,hasAccessToAllModels:n}=T;if(!C&&!n)return 0;let f=0;if(_)if(_===k.scheme)f=10;else if(_==="*")f=5;else return 0;if(R)if(R===P)f=10;else if(R==="*")f=Math.max(f,5);else return 0;if(F){let o;if(typeof F=="string"?o=F:o={...F,base:(0,t.normalize)(F.base)},o===k.fsPath||(0,a.match)(o,k.fsPath))f=10;else return 0}return f}else return 0}}e.score=w}),define(Ee[108],ye([0,1,4,6]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class w{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new a.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(k){this._onDidChange.fire({changedLanguages:k,changedColorMap:!1})}register(k,P){return this._map.set(k,P),this.fire([k]),(0,t.toDisposable)(()=>{this._map.get(k)===P&&(this._map.delete(k),this.fire([k]))})}registerPromise(k,P){let C=null,R=!1;return this._promises.set(k,P.then(F=>{this._promises.delete(k),!(R||!F)&&(C=this.register(k,F))})),(0,t.toDisposable)(()=>{R=!0,C&&C.dispose()})}getPromise(k){const P=this.get(k);if(P)return Promise.resolve(P);const C=this._promises.get(k);return C?C.then(R=>this.get(k)):null}get(k){return this._map.get(k)||null}setColorMap(k){this._colorMap=k,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=w}),define(Ee[79],ye([0,1,22,23]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var w;(function(_){_[_.Full=1]="Full",_[_.Delta=2]="Delta"})(w||(w={}));function T(_){for(let n=0,f=_.length;n<f;n+=4){const o=_[n+0],g=_[n+1],c=_[n+2],D=_[n+3];_[n+0]=D,_[n+1]=c,_[n+2]=g,_[n+3]=o}}function k(_){const n=new Uint8Array(_.buffer,_.byteOffset,_.length*4);return t.isLittleEndian()||T(n),a.VSBuffer.wrap(n)}function P(_){const n=_.buffer;if(t.isLittleEndian()||T(n),n.byteOffset%4==0)return new Uint32Array(n.buffer,n.byteOffset,n.length/4);{const f=new Uint8Array(n.byteLength);return f.set(n),new Uint32Array(f.buffer,f.byteOffset,f.length/4)}}function C(_){const n=new Uint32Array(R(_));let f=0;if(n[f++]=_.id,_.type==="full")n[f++]=1,n[f++]=_.data.length,n.set(_.data,f),f+=_.data.length;else{n[f++]=2,n[f++]=_.deltas.length;for(const o of _.deltas)n[f++]=o.start,n[f++]=o.deleteCount,o.data?(n[f++]=o.data.length,n.set(o.data,f),f+=o.data.length):n[f++]=0}return k(n)}e.encodeSemanticTokensDto=C;function R(_){let n=0;if(n+=1+1,_.type==="full")n+=1+_.data.length;else{n+=1,n+=(1+1+1)*_.deltas.length;for(const f of _.deltas)f.data&&(n+=f.data.length)}return n}function F(_){const n=P(_);let f=0;const o=n[f++];if(n[f++]===1){const v=n[f++],h=n.subarray(f,f+v);return f+=v,{id:o,type:"full",data:h}}const c=n[f++];let D=[];for(let v=0;v<c;v++){const h=n[f++],p=n[f++],I=n[f++];let l;I>0&&(l=n.subarray(f,f+I),f+=I),D[v]={start:h,deleteCount:p,data:l}}return{id:o,type:"delta",deltas:D}}e.decodeSemanticTokensDto=F}),define(Ee[109],ye([18,19]),function(re,e){return re.create("vs/base/common/date",e)}),define(Ee[110],ye([0,1,109]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,w=t*60,T=w*24,k=T*7,P=T*30,C=T*365;function R(_,n){typeof _!="number"&&(_=_.getTime());const f=Math.round((new Date().getTime()-_)/1e3);if(f<-30)return(0,a.localize)(0,null,R(new Date().getTime()+f*1e3,!1));if(f<30)return(0,a.localize)(1,null);let o;return f<t?(o=f,n?o===1?(0,a.localize)(2,null,o):(0,a.localize)(3,null,o):o===1?(0,a.localize)(4,null,o):(0,a.localize)(5,null,o)):f<w?(o=Math.floor(f/t),n?o===1?(0,a.localize)(6,null,o):(0,a.localize)(7,null,o):o===1?(0,a.localize)(8,null,o):(0,a.localize)(9,null,o)):f<T?(o=Math.floor(f/w),n?o===1?(0,a.localize)(10,null,o):(0,a.localize)(11,null,o):o===1?(0,a.localize)(12,null,o):(0,a.localize)(13,null,o)):f<k?(o=Math.floor(f/T),n?o===1?(0,a.localize)(14,null,o):(0,a.localize)(15,null,o):o===1?(0,a.localize)(16,null,o):(0,a.localize)(17,null,o)):f<P?(o=Math.floor(f/k),n?o===1?(0,a.localize)(18,null,o):(0,a.localize)(19,null,o):o===1?(0,a.localize)(20,null,o):(0,a.localize)(21,null,o)):f<C?(o=Math.floor(f/P),n?o===1?(0,a.localize)(22,null,o):(0,a.localize)(23,null,o):o===1?(0,a.localize)(24,null,o):(0,a.localize)(25,null,o)):(o=Math.floor(f/C),n?o===1?(0,a.localize)(26,null,o):(0,a.localize)(27,null,o):o===1?(0,a.localize)(28,null,o):(0,a.localize)(29,null,o))}e.fromNow=R;function F(_){return _.getFullYear()+"-"+String(_.getMonth()+1).padStart(2,"0")+"-"+String(_.getDate()).padStart(2,"0")+"T"+String(_.getHours()).padStart(2,"0")+":"+String(_.getMinutes()).padStart(2,"0")+":"+String(_.getSeconds()).padStart(2,"0")+"."+(_.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=F}),define(Ee[111],ye([18,19]),function(re,e){return re.create("vs/base/common/errorMessage",e)}),define(Ee[43],ye([0,1,16,11,111]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(R,F){return F&&(R.stack||R.stacktrace)?w.localize(0,null,P(R),k(R.stack)||k(R.stacktrace)):P(R)}function k(R){return Array.isArray(R)?R.join(`
`):R}function P(R){return typeof R.code=="string"&&typeof R.errno=="number"&&typeof R.syscall=="string"?w.localize(1,null,R.message):R.message||w.localize(2,null)}function C(R=null,F=!1){if(!R)return w.localize(3,null);if(Array.isArray(R)){const _=a.coalesce(R),n=C(_[0],F);return _.length>1?w.localize(4,null,n,_.length):n}if(t.isString(R))return R;if(R.detail){const _=R.detail;if(_.error)return T(_.error,F);if(_.exception)return T(_.exception,F)}return R.stack?T(R,F):R.message?R.message:w.localize(5,null)}e.toErrorMessage=C}),define(Ee[112],ye([18,19]),function(re,e){return re.create("vs/editor/common/config/editorOptions",e)}),define(Ee[113],ye([0,1,112,23,114,16,26]),function(re,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var P;(function(V){V[V.None=0]="None",V[V.Keep=1]="Keep",V[V.Brackets=2]="Brackets",V[V.Advanced=3]="Advanced",V[V.Full=4]="Full"})(P=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class C{constructor(Q){this._values=Q}hasChanged(Q){return this._values[Q]}}e.ConfigurationChangedEvent=C;class R{constructor(){this._values=[]}_read(Q){return this._values[Q]}get(Q){return this._values[Q]}_write(Q,he){this._values[Q]=he}}e.ValidatedEditorOptions=R;class F{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=F;class _{constructor(Q,he,Le,We){this.id=Q,this.name=he,this.defaultValue=Le,this.schema=We}applyUpdate(Q,he){return f(Q,he)}compute(Q,he,Le){return Le}}class n{constructor(Q,he){this.newValue=Q,this.didChange=he}}e.ApplyUpdateResult=n;function f(V,Q){if(typeof V!="object"||typeof Q!="object"||!V||!Q)return new n(Q,V!==Q);if(Array.isArray(V)||Array.isArray(Q)){const Le=Array.isArray(V)&&Array.isArray(Q)&&T.equals(V,Q);return new n(Q,Le)}let he=!1;for(let Le in Q)if(Q.hasOwnProperty(Le)){const We=f(V[Le],Q[Le]);We.didChange&&(V[Le]=We.newValue,he=!0)}return new n(V,he)}class o{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,he){return f(Q,he)}validate(Q){return this.defaultValue}}class g{constructor(Q,he,Le,We){this.id=Q,this.name=he,this.defaultValue=Le,this.schema=We}applyUpdate(Q,he){return f(Q,he)}validate(Q){return typeof Q=="undefined"?this.defaultValue:Q}compute(Q,he,Le){return Le}}function c(V,Q){return typeof V=="undefined"?Q:V==="false"?!1:Boolean(V)}e.boolean=c;class D extends g{constructor(Q,he,Le,We=void 0){typeof We!="undefined"&&(We.type="boolean",We.default=Le);super(Q,he,Le,We)}validate(Q){return c(Q,this.defaultValue)}}function v(V,Q,he,Le){if(typeof V=="undefined")return Q;let We=parseInt(V,10);return isNaN(We)?Q:(We=Math.max(he,We),We=Math.min(Le,We),We|0)}e.clampedInt=v;class h extends g{constructor(Q,he,Le,We,ot,Ge=void 0){typeof Ge!="undefined"&&(Ge.type="integer",Ge.default=Le,Ge.minimum=We,Ge.maximum=ot);super(Q,he,Le,Ge);this.minimum=We,this.maximum=ot}static clampedInt(Q,he,Le,We){return v(Q,he,Le,We)}validate(Q){return h.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class p extends g{constructor(Q,he,Le,We,ot){typeof ot!="undefined"&&(ot.type="number",ot.default=Le);super(Q,he,Le,ot);this.validationFn=We}static clamp(Q,he,Le){return Q<he?he:Q>Le?Le:Q}static float(Q,he){if(typeof Q=="number")return Q;if(typeof Q=="undefined")return he;const Le=parseFloat(Q);return isNaN(Le)?he:Le}validate(Q){return this.validationFn(p.float(Q,this.defaultValue))}}class I extends g{static string(Q,he){return typeof Q!="string"?he:Q}constructor(Q,he,Le,We=void 0){typeof We!="undefined"&&(We.type="string",We.default=Le);super(Q,he,Le,We)}validate(Q){return I.string(Q,this.defaultValue)}}function l(V,Q,he){return typeof V!="string"||he.indexOf(V)===-1?Q:V}e.stringSet=l;class M extends g{constructor(Q,he,Le,We,ot=void 0){typeof ot!="undefined"&&(ot.type="string",ot.enum=We,ot.default=Le);super(Q,he,Le,ot);this._allowedValues=We}validate(Q){return l(Q,this.defaultValue,this._allowedValues)}}class r extends _{constructor(Q,he,Le,We,ot,Ge,yt=void 0){typeof yt!="undefined"&&(yt.type="string",yt.enum=ot,yt.default=We);super(Q,he,Le,yt);this._allowedValues=ot,this._convert=Ge}validate(Q){return typeof Q!="string"?this.defaultValue:this._allowedValues.indexOf(Q)===-1?this.defaultValue:this._convert(Q)}}function i(V){switch(V){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class m extends _{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[a.localize(0,null),a.localize(1,null),a.localize(2,null)],default:"auto",description:a.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,he,Le){return Le===0?Q.accessibilitySupport:Le}}class d extends _{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:a.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:a.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{insertSpace:c(he.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:c(he.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var s;(function(V){V[V.Hidden=0]="Hidden",V[V.Blink=1]="Blink",V[V.Smooth=2]="Smooth",V[V.Phase=3]="Phase",V[V.Expand=4]="Expand",V[V.Solid=5]="Solid"})(s=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function b(V){switch(V){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var y;(function(V){V[V.Line=1]="Line",V[V.Block=2]="Block",V[V.Underline=3]="Underline",V[V.LineThin=4]="LineThin",V[V.BlockOutline=5]="BlockOutline",V[V.UnderlineThin=6]="UnderlineThin"})(y=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function u(V){switch(V){case y.Line:return"line";case y.Block:return"block";case y.Underline:return"underline";case y.LineThin:return"line-thin";case y.BlockOutline:return"block-outline";case y.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=u;function S(V){switch(V){case"line":return y.Line;case"block":return y.Block;case"underline":return y.Underline;case"line-thin":return y.LineThin;case"block-outline":return y.BlockOutline;case"underline-thin":return y.UnderlineThin}}class A extends o{constructor(){super(127)}compute(Q,he,Le){const We=["monaco-editor"];return he.get(33)&&We.push(he.get(33)),Q.extraEditorClassName&&We.push(Q.extraEditorClassName),he.get(65)==="default"?We.push("mouse-default"):he.get(65)==="copy"&&We.push("mouse-copy"),he.get(99)&&We.push("showUnused"),he.get(125)&&We.push("showDeprecated"),We.join(" ")}}class U extends D{constructor(){super(32,"emptySelectionClipboard",!0,{description:a.localize(6,null)})}compute(Q,he,Le){return Le&&Q.emptySelectionClipboard}}class H extends _{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:a.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[a.localize(8,null),a.localize(9,null),a.localize(10,null)],description:a.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[a.localize(12,null),a.localize(13,null),a.localize(14,null)],description:a.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:a.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:a.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:a.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{cursorMoveOnType:c(he.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":l(he.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":l(he.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:c(he.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:c(he.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:c(he.loop,this.defaultValue.loop)}}}class E extends _{constructor(){super(44,"fontLigatures",E.OFF,{anyOf:[{type:"boolean",description:a.localize(19,null)},{type:"string",description:a.localize(20,null)}],description:a.localize(21,null),default:!1})}validate(Q){return typeof Q=="undefined"?this.defaultValue:typeof Q=="string"?Q==="false"?E.OFF:Q==="true"?E.ON:Q:Boolean(Q)?E.ON:E.OFF}}e.EditorFontLigatures=E,E.OFF='"liga" off, "calt" off',E.ON='"liga" on, "calt" on';class L extends o{constructor(){super(43)}compute(Q,he,Le){return Q.fontInfo}}class z extends g{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:a.localize(22,null)})}validate(Q){let he=p.float(Q,this.defaultValue);return he===0?e.EDITOR_FONT_DEFAULTS.fontSize:p.clamp(he,6,100)}compute(Q,he,Le){return Q.fontInfo.fontSize}}class N extends _{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:N.MINIMUM_VALUE,maximum:N.MAXIMUM_VALUE,errorMessage:a.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:N.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:a.localize(24,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(h.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,N.MINIMUM_VALUE,N.MAXIMUM_VALUE))}}N.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],N.MINIMUM_VALUE=1,N.MAXIMUM_VALUE=1e3;class B extends _{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},he={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[a.localize(25,null),a.localize(26,null),a.localize(27,null)]},Le=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:a.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:a.localize(29,null),...he},"editor.gotoLocation.multipleTypeDefinitions":{description:a.localize(30,null),...he},"editor.gotoLocation.multipleDeclarations":{description:a.localize(31,null),...he},"editor.gotoLocation.multipleImplementations":{description:a.localize(32,null),...he},"editor.gotoLocation.multipleReferences":{description:a.localize(33,null),...he},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Le,description:a.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Le,description:a.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Le,description:a.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Le,description:a.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Le,description:a.localize(38,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{multiple:l(he.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:he.multipleDefinitions??l(he.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:he.multipleTypeDefinitions??l(he.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:he.multipleDeclarations??l(he.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:he.multipleImplementations??l(he.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:he.multipleReferences??l(he.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:I.string(he.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:I.string(he.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:I.string(he.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:I.string(he.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:I.string(he.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class j extends _{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:a.localize(39,null)},"editor.hover.delay":{type:"number",default:Q.delay,description:a.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:a.localize(41,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:a.localize(42,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:c(he.enabled,this.defaultValue.enabled),delay:h.clampedInt(he.delay,this.defaultValue.delay,0,1e4),sticky:c(he.sticky,this.defaultValue.sticky),above:c(he.above,this.defaultValue.above)}}}var ce;(function(V){V[V.None=0]="None",V[V.Text=1]="Text",V[V.Blocks=2]="Blocks"})(ce=e.RenderMinimap||(e.RenderMinimap={}));class K extends o{constructor(){super(130)}compute(Q,he,Le){return K.computeLayout(he,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const he=Q.height/Q.lineHeight,Le=Q.scrollBeyondLastLine?he-1:0,We=(Q.viewLineCount+Le)/(Q.pixelRatio*Q.height),ot=Math.floor(Q.viewLineCount/We);return{typicalViewportLineCount:he,extraLinesBeyondLastLine:Le,desiredRatio:We,minimapLineCount:ot}}static _computeMinimapLayout(Q,he){const Le=Q.outerWidth,We=Q.outerHeight,ot=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ot*We),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:We};const Ge=he.stableMinimapLayoutInput,yt=Ge&&Q.outerHeight===Ge.outerHeight&&Q.lineHeight===Ge.lineHeight&&Q.typicalHalfwidthCharacterWidth===Ge.typicalHalfwidthCharacterWidth&&Q.pixelRatio===Ge.pixelRatio&&Q.scrollBeyondLastLine===Ge.scrollBeyondLastLine&&Q.minimap.enabled===Ge.minimap.enabled&&Q.minimap.side===Ge.minimap.side&&Q.minimap.size===Ge.minimap.size&&Q.minimap.showSlider===Ge.minimap.showSlider&&Q.minimap.renderCharacters===Ge.minimap.renderCharacters&&Q.minimap.maxColumn===Ge.minimap.maxColumn&&Q.minimap.scale===Ge.minimap.scale&&Q.verticalScrollbarWidth===Ge.verticalScrollbarWidth&&Q.isViewportWrapping===Ge.isViewportWrapping,Ie=Q.lineHeight,Ce=Q.typicalHalfwidthCharacterWidth,ve=Q.scrollBeyondLastLine,oe=Q.minimap.renderCharacters;let se=ot>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const fe=Q.minimap.maxColumn,ge=Q.minimap.size,ke=Q.minimap.side,ze=Q.verticalScrollbarWidth,Oe=Q.viewLineCount,Ve=Q.remainingWidth,it=Q.isViewportWrapping,rt=oe?2:3;let ne=Math.floor(ot*We);const pe=ne/ot;let ee=!1,W=!1,be=rt*se,De=se/ot,qe=1;if(ge==="fill"||ge==="fit"){const{typicalViewportLineCount:gt,extraLinesBeyondLastLine:_t,desiredRatio:Lt,minimapLineCount:It}=K.computeContainedMinimapLineCount({viewLineCount:Oe,scrollBeyondLastLine:ve,height:We,lineHeight:Ie,pixelRatio:ot});if(Oe/It>1)ee=!0,W=!0,se=1,be=1,De=se/ot;else{let At=!1,Et=se+1;if(ge==="fit"){const Ot=Math.ceil((Oe+_t)*be);it&&yt&&Ve<=he.stableFitRemainingWidth?(At=!0,Et=he.stableFitMaxMinimapScale):At=Ot>ne}if(ge==="fill"||At){ee=!0;const Ot=se;be=Math.min(Ie*ot,Math.max(1,Math.floor(1/Lt))),it&&yt&&Ve<=he.stableFitRemainingWidth&&(Et=he.stableFitMaxMinimapScale),se=Math.min(Et,Math.max(1,Math.floor(be/rt))),se>Ot&&(qe=Math.min(2,se/Ot)),De=se/ot/qe,ne=Math.ceil(Math.max(gt,Oe+_t)*be),it?(he.stableMinimapLayoutInput=Q,he.stableFitRemainingWidth=Ve,he.stableFitMaxMinimapScale=se):(he.stableMinimapLayoutInput=null,he.stableFitRemainingWidth=0)}}}const xe=Math.floor(fe*De),ut=Math.min(xe,Math.max(0,Math.floor((Ve-ze-2)*De/(Ce+De)))+e.MINIMAP_GUTTER_WIDTH);let vt=Math.floor(ot*ut);const St=vt/ot;vt=Math.floor(vt*qe);const bt=oe?1:2,ht=ke==="left"?0:Le-ut-ze;return{renderMinimap:bt,minimapLeft:ht,minimapWidth:ut,minimapHeightIsEditorHeight:ee,minimapIsSampling:W,minimapScale:se,minimapLineHeight:be,minimapCanvasInnerWidth:vt,minimapCanvasInnerHeight:ne,minimapCanvasOuterWidth:St,minimapCanvasOuterHeight:pe}}static computeLayout(Q,he){const Le=he.outerWidth|0,We=he.outerHeight|0,ot=he.lineHeight|0,Ge=he.lineNumbersDigitCount|0,yt=he.typicalHalfwidthCharacterWidth,Ie=he.maxDigitWidth,Ce=he.pixelRatio,ve=he.viewLineCount,oe=Q.get(122),se=oe==="inherit"?Q.get(121):oe,fe=se==="inherit"?Q.get(117):se,ge=Q.get(120),ke=Q.get(2),ze=he.isDominatedByLongLines,Oe=Q.get(49),Ve=Q.get(59).renderType!==0,it=Q.get(60),rt=Q.get(93),ne=Q.get(64),pe=Q.get(91),ee=pe.verticalScrollbarSize,W=pe.verticalHasArrows,be=pe.arrowSize,De=pe.horizontalScrollbarSize,qe=Q.get(57),xe=Q.get(37);let ut;if(typeof qe=="string"&&/^\d+(\.\d+)?ch$/.test(qe)){const $t=parseFloat(qe.substr(0,qe.length-2));ut=h.clampedInt($t*yt,0,0,1e3)}else ut=h.clampedInt(qe,0,0,1e3);xe&&(ut+=16);let vt=0;if(Ve){const $t=Math.max(Ge,it);vt=Math.round($t*Ie)}let St=0;Oe&&(St=ot);let bt=0,ht=bt+St,gt=ht+vt,_t=gt+ut;const Lt=Le-St-vt-ut;let It=!1,Pt=!1,At=-1;ke!==2&&(se==="inherit"&&ze?(It=!0,Pt=!0):fe==="on"||fe==="bounded"?Pt=!0:fe==="wordWrapColumn"&&(At=ge));const Et=K._computeMinimapLayout({outerWidth:Le,outerHeight:We,lineHeight:ot,typicalHalfwidthCharacterWidth:yt,pixelRatio:Ce,scrollBeyondLastLine:rt,minimap:ne,verticalScrollbarWidth:ee,viewLineCount:ve,remainingWidth:Lt,isViewportWrapping:Pt},he.memory||new F);Et.renderMinimap!==0&&Et.minimapLeft===0&&(bt+=Et.minimapWidth,ht+=Et.minimapWidth,gt+=Et.minimapWidth,_t+=Et.minimapWidth);const Ot=Lt-Et.minimapWidth,Nt=Math.max(1,Math.floor((Ot-ee-2)/yt)),wt=W?be:0;return Pt&&(At=Math.max(1,Nt),fe==="bounded"&&(At=Math.min(At,ge))),{width:Le,height:We,glyphMarginLeft:bt,glyphMarginWidth:St,lineNumbersLeft:ht,lineNumbersWidth:vt,decorationsLeft:gt,decorationsWidth:ut,contentLeft:_t,contentWidth:Ot,minimap:Et,viewportColumn:Nt,isWordWrapMinified:It,isViewportWrapping:Pt,wrappingColumn:At,verticalScrollbarWidth:ee,horizontalScrollbarHeight:De,overviewRuler:{top:wt,width:ee,height:We-2*wt,right:0}}}}e.EditorLayoutInfoComputer=K;class le extends _{constructor(){const Q={enabled:!0};super(56,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:a.localize(43,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:c(Q.enabled,this.defaultValue.enabled)}}}class ue extends _{constructor(){const Q={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"boolean",default:Q.enabled,description:a.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:a.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:a.localize(46,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:c(he.enabled,this.defaultValue.enabled),fontSize:h.clampedInt(he.fontSize,this.defaultValue.fontSize,0,100),fontFamily:I.string(he.fontFamily,this.defaultValue.fontFamily)}}}class Y extends p{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>p.clamp(Q,0,150),{markdownDescription:a.localize(47,null)})}compute(Q,he,Le){return Q.fontInfo.lineHeight}}class ie extends _{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:a.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[a.localize(49,null),a.localize(50,null),a.localize(51,null)],default:Q.size,description:a.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:a.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:a.localize(54,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:a.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:a.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:a.localize(57,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:c(he.enabled,this.defaultValue.enabled),size:l(he.size,this.defaultValue.size,["proportional","fill","fit"]),side:l(he.side,this.defaultValue.side,["right","left"]),showSlider:l(he.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:c(he.renderCharacters,this.defaultValue.renderCharacters),scale:h.clampedInt(he.scale,1,1,3),maxColumn:h.clampedInt(he.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function we(V){return V==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Me extends _{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(59,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{top:h.clampedInt(he.top,0,0,1e3),bottom:h.clampedInt(he.bottom,0,0,1e3)}}}class Re extends _{constructor(){const Q={enabled:!0,cycle:!1};super(75,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:a.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:a.localize(61,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:c(he.enabled,this.defaultValue.enabled),cycle:c(he.cycle,this.defaultValue.cycle)}}}class Be extends o{constructor(){super(128)}compute(Q,he,Le){return Q.pixelRatio}}class Qe extends _{constructor(){const Q={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",Q,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Q.strings,description:a.localize(62,null)},comments:{type:"boolean",default:Q.comments,description:a.localize(63,null)},other:{type:"boolean",default:Q.other,description:a.localize(64,null)}}}],default:Q,description:a.localize(65,null)});this.defaultValue=Q}validate(Q){if(typeof Q=="boolean")return Q;if(Q&&typeof Q=="object"){const he=Q,Le={other:c(he.other,this.defaultValue.other),comments:c(he.comments,this.defaultValue.comments),strings:c(he.strings,this.defaultValue.strings)};return Le.other&&Le.comments&&Le.strings?!0:!Le.other&&!Le.comments&&!Le.strings?!1:Le}return this.defaultValue}}var Ke;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative",V[V.Interval=3]="Interval",V[V.Custom=4]="Custom"})(Ke=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Xe extends _{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[a.localize(66,null),a.localize(67,null),a.localize(68,null),a.localize(69,null)],default:"on",description:a.localize(70,null)})}validate(Q){let he=this.defaultValue.renderType,Le=this.defaultValue.renderFn;return typeof Q!="undefined"&&(typeof Q=="function"?(he=4,Le=Q):Q==="interval"?he=3:Q==="relative"?he=2:Q==="on"?he=1:he=0),{renderType:he,renderFn:Le}}}function $(V){const Q=V.get(86);return Q==="editable"?V.get(80):Q!=="on"}e.filterValidationDecorations=$;class G extends _{constructor(){const Q=[],he={type:"number",description:a.localize(71,null)};super(90,"rulers",Q,{type:"array",items:{anyOf:[he,{type:["object"],properties:{column:he,color:{type:"string",description:a.localize(72,null),format:"color-hex"}}}]},default:Q,description:a.localize(73,null)})}validate(Q){if(Array.isArray(Q)){let he=[];for(let Le of Q)if(typeof Le=="number")he.push({column:h.clampedInt(Le,0,0,1e4),color:null});else if(Le&&typeof Le=="object"){const We=Le;he.push({column:h.clampedInt(We.column,0,0,1e4),color:We.color})}return he.sort((Le,We)=>Le.column-We.column),he}return this.defaultValue}}function J(V,Q){if(typeof V!="string")return Q;switch(V){case"hidden":return 2;case"visible":return 3;default:return 1}}class ae extends _{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(74,null),a.localize(75,null),a.localize(76,null)],default:"auto",description:a.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(78,null),a.localize(79,null),a.localize(80,null)],default:"auto",description:a.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:a.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:a.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:a.localize(84,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q,Le=h.clampedInt(he.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),We=h.clampedInt(he.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:h.clampedInt(he.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:J(he.vertical,this.defaultValue.vertical),horizontal:J(he.horizontal,this.defaultValue.horizontal),useShadows:c(he.useShadows,this.defaultValue.useShadows),verticalHasArrows:c(he.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:c(he.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:c(he.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:c(he.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Le,horizontalSliderSize:h.clampedInt(he.horizontalSliderSize,Le,0,1e3),verticalScrollbarSize:We,verticalSliderSize:h.clampedInt(he.verticalSliderSize,We,0,1e3),scrollByPage:c(he.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings"};class q extends _{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{}};super(112,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:a.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:a.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:a.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:a.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:a.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:a.localize(90,null),additionalProperties:{type:"boolean"}}})}applyUpdate(Q,he){let Le=!1;he.allowedCharacters&&(k.equals(Q.allowedCharacters,he.allowedCharacters)||(Q={...Q,allowedCharacters:he.allowedCharacters},Le=!0));const We=super.applyUpdate(Q,he);return Le?new n(We.newValue,!0):We}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{nonBasicASCII:Ne(he.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:c(he.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:c(he.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ne(he.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ne(he.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateAllowedCharacters(Q.allowedCharacters,this.defaultValue.allowedCharacters)}}validateAllowedCharacters(Q,he){if(typeof Q!="object"||!Q)return he;const Le={};for(const[We,ot]of Object.entries(Q))ot===!0&&(Le[We]=!0);return Le}}class te extends _{constructor(){const Q={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:a.localize(91,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:c(he.enabled,this.defaultValue.enabled),mode:l(he.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class me extends _{constructor(){const Q={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,description:a.localize(92,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:c(Q.enabled,this.defaultValue.enabled)}}}class Pe extends _{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(93,null),a.localize(94,null),a.localize(95,null)],default:Q.bracketPairs,description:a.localize(96,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(97,null),a.localize(98,null),a.localize(99,null)],default:Q.bracketPairsHorizontal,description:a.localize(100,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:a.localize(101,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:a.localize(102,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:Q.highlightActiveIndentation,description:a.localize(103,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{bracketPairs:Ne(he.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ne(he.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:c(he.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:c(he.indentation,this.defaultValue.indentation),highlightActiveIndentation:c(he.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function Ne(V,Q,he){const Le=he.indexOf(V);return Le===-1?Q:he[Le]}class He extends _{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[a.localize(104,null),a.localize(105,null)],default:Q.insertMode,description:a.localize(106,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:a.localize(107,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:a.localize(108,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:a.localize(109,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:a.localize(110,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:a.localize(111,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:a.localize(112,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:a.localize(113,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:a.localize(114,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:a.localize(115,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:a.localize(116,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:a.localize(117,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:a.localize(118,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:a.localize(119,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:a.localize(120,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:a.localize(121,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:a.localize(122,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:a.localize(123,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:a.localize(124,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:a.localize(125,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:a.localize(126,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:a.localize(127,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:a.localize(128,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:a.localize(129,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:a.localize(130,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:a.localize(131,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:a.localize(132,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:a.localize(133,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:a.localize(134,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:a.localize(135,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:a.localize(136,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:a.localize(137,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:a.localize(138,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:a.localize(139,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:a.localize(140,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:a.localize(141,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:a.localize(142,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:a.localize(143,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:a.localize(144,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:a.localize(145,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{insertMode:l(he.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:c(he.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:c(he.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:c(he.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:c(he.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:c(he.showIcons,this.defaultValue.showIcons),showStatusBar:c(he.showStatusBar,this.defaultValue.showStatusBar),preview:c(he.preview,this.defaultValue.preview),previewMode:l(he.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:c(he.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:c(he.showMethods,this.defaultValue.showMethods),showFunctions:c(he.showFunctions,this.defaultValue.showFunctions),showConstructors:c(he.showConstructors,this.defaultValue.showConstructors),showDeprecated:c(he.showDeprecated,this.defaultValue.showDeprecated),showFields:c(he.showFields,this.defaultValue.showFields),showVariables:c(he.showVariables,this.defaultValue.showVariables),showClasses:c(he.showClasses,this.defaultValue.showClasses),showStructs:c(he.showStructs,this.defaultValue.showStructs),showInterfaces:c(he.showInterfaces,this.defaultValue.showInterfaces),showModules:c(he.showModules,this.defaultValue.showModules),showProperties:c(he.showProperties,this.defaultValue.showProperties),showEvents:c(he.showEvents,this.defaultValue.showEvents),showOperators:c(he.showOperators,this.defaultValue.showOperators),showUnits:c(he.showUnits,this.defaultValue.showUnits),showValues:c(he.showValues,this.defaultValue.showValues),showConstants:c(he.showConstants,this.defaultValue.showConstants),showEnums:c(he.showEnums,this.defaultValue.showEnums),showEnumMembers:c(he.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:c(he.showKeywords,this.defaultValue.showKeywords),showWords:c(he.showWords,this.defaultValue.showWords),showColors:c(he.showColors,this.defaultValue.showColors),showFiles:c(he.showFiles,this.defaultValue.showFiles),showReferences:c(he.showReferences,this.defaultValue.showReferences),showFolders:c(he.showFolders,this.defaultValue.showFolders),showTypeParameters:c(he.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:c(he.showSnippets,this.defaultValue.showSnippets),showUsers:c(he.showUsers,this.defaultValue.showUsers),showIssues:c(he.showIssues,this.defaultValue.showIssues)}}}class Ye extends _{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:a.localize(146,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:c(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class et extends o{constructor(){super(129)}compute(Q,he,Le){return he.get(80)?!0:Q.tabFocusMode}}var st;(function(V){V[V.None=0]="None",V[V.Same=1]="Same",V[V.Indent=2]="Indent",V[V.DeepIndent=3]="DeepIndent"})(st=e.WrappingIndent||(e.WrappingIndent={}));function Je(V){switch(V){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class nt extends o{constructor(){super(131)}compute(Q,he,Le){const We=he.get(130);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:We.isWordWrapMinified,isViewportWrapping:We.isViewportWrapping,wrappingColumn:We.wrappingColumn}}}const lt="Consolas, 'Courier New', monospace",pt="Menlo, Monaco, 'Courier New', monospace",Ft="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?pt:t.isLinux?Ft:lt,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function Fe(V){return e.editorOptionsRegistry[V.id]=V,V}var Mt;(function(V){V[V.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",V[V.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",V[V.accessibilitySupport=2]="accessibilitySupport",V[V.accessibilityPageSize=3]="accessibilityPageSize",V[V.ariaLabel=4]="ariaLabel",V[V.autoClosingBrackets=5]="autoClosingBrackets",V[V.autoClosingDelete=6]="autoClosingDelete",V[V.autoClosingOvertype=7]="autoClosingOvertype",V[V.autoClosingQuotes=8]="autoClosingQuotes",V[V.autoIndent=9]="autoIndent",V[V.automaticLayout=10]="automaticLayout",V[V.autoSurround=11]="autoSurround",V[V.bracketPairColorization=12]="bracketPairColorization",V[V.guides=13]="guides",V[V.codeLens=14]="codeLens",V[V.codeLensFontFamily=15]="codeLensFontFamily",V[V.codeLensFontSize=16]="codeLensFontSize",V[V.colorDecorators=17]="colorDecorators",V[V.columnSelection=18]="columnSelection",V[V.comments=19]="comments",V[V.contextmenu=20]="contextmenu",V[V.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",V[V.cursorBlinking=22]="cursorBlinking",V[V.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",V[V.cursorStyle=24]="cursorStyle",V[V.cursorSurroundingLines=25]="cursorSurroundingLines",V[V.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",V[V.cursorWidth=27]="cursorWidth",V[V.disableLayerHinting=28]="disableLayerHinting",V[V.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",V[V.domReadOnly=30]="domReadOnly",V[V.dragAndDrop=31]="dragAndDrop",V[V.emptySelectionClipboard=32]="emptySelectionClipboard",V[V.extraEditorClassName=33]="extraEditorClassName",V[V.fastScrollSensitivity=34]="fastScrollSensitivity",V[V.find=35]="find",V[V.fixedOverflowWidgets=36]="fixedOverflowWidgets",V[V.folding=37]="folding",V[V.foldingStrategy=38]="foldingStrategy",V[V.foldingHighlight=39]="foldingHighlight",V[V.foldingImportsByDefault=40]="foldingImportsByDefault",V[V.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",V[V.fontFamily=42]="fontFamily",V[V.fontInfo=43]="fontInfo",V[V.fontLigatures=44]="fontLigatures",V[V.fontSize=45]="fontSize",V[V.fontWeight=46]="fontWeight",V[V.formatOnPaste=47]="formatOnPaste",V[V.formatOnType=48]="formatOnType",V[V.glyphMargin=49]="glyphMargin",V[V.gotoLocation=50]="gotoLocation",V[V.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",V[V.hover=52]="hover",V[V.inDiffEditor=53]="inDiffEditor",V[V.inlineSuggest=54]="inlineSuggest",V[V.letterSpacing=55]="letterSpacing",V[V.lightbulb=56]="lightbulb",V[V.lineDecorationsWidth=57]="lineDecorationsWidth",V[V.lineHeight=58]="lineHeight",V[V.lineNumbers=59]="lineNumbers",V[V.lineNumbersMinChars=60]="lineNumbersMinChars",V[V.linkedEditing=61]="linkedEditing",V[V.links=62]="links",V[V.matchBrackets=63]="matchBrackets",V[V.minimap=64]="minimap",V[V.mouseStyle=65]="mouseStyle",V[V.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",V[V.mouseWheelZoom=67]="mouseWheelZoom",V[V.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",V[V.multiCursorModifier=69]="multiCursorModifier",V[V.multiCursorPaste=70]="multiCursorPaste",V[V.occurrencesHighlight=71]="occurrencesHighlight",V[V.overviewRulerBorder=72]="overviewRulerBorder",V[V.overviewRulerLanes=73]="overviewRulerLanes",V[V.padding=74]="padding",V[V.parameterHints=75]="parameterHints",V[V.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",V[V.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",V[V.quickSuggestions=78]="quickSuggestions",V[V.quickSuggestionsDelay=79]="quickSuggestionsDelay",V[V.readOnly=80]="readOnly",V[V.renameOnType=81]="renameOnType",V[V.renderControlCharacters=82]="renderControlCharacters",V[V.renderFinalNewline=83]="renderFinalNewline",V[V.renderLineHighlight=84]="renderLineHighlight",V[V.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",V[V.renderValidationDecorations=86]="renderValidationDecorations",V[V.renderWhitespace=87]="renderWhitespace",V[V.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",V[V.roundedSelection=89]="roundedSelection",V[V.rulers=90]="rulers",V[V.scrollbar=91]="scrollbar",V[V.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",V[V.scrollBeyondLastLine=93]="scrollBeyondLastLine",V[V.scrollPredominantAxis=94]="scrollPredominantAxis",V[V.selectionClipboard=95]="selectionClipboard",V[V.selectionHighlight=96]="selectionHighlight",V[V.selectOnLineNumbers=97]="selectOnLineNumbers",V[V.showFoldingControls=98]="showFoldingControls",V[V.showUnused=99]="showUnused",V[V.snippetSuggestions=100]="snippetSuggestions",V[V.smartSelect=101]="smartSelect",V[V.smoothScrolling=102]="smoothScrolling",V[V.stickyTabStops=103]="stickyTabStops",V[V.stopRenderingLineAfter=104]="stopRenderingLineAfter",V[V.suggest=105]="suggest",V[V.suggestFontSize=106]="suggestFontSize",V[V.suggestLineHeight=107]="suggestLineHeight",V[V.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",V[V.suggestSelection=109]="suggestSelection",V[V.tabCompletion=110]="tabCompletion",V[V.tabIndex=111]="tabIndex",V[V.unicodeHighlighting=112]="unicodeHighlighting",V[V.unusualLineTerminators=113]="unusualLineTerminators",V[V.useShadowDOM=114]="useShadowDOM",V[V.useTabStops=115]="useTabStops",V[V.wordSeparators=116]="wordSeparators",V[V.wordWrap=117]="wordWrap",V[V.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",V[V.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",V[V.wordWrapColumn=120]="wordWrapColumn",V[V.wordWrapOverride1=121]="wordWrapOverride1",V[V.wordWrapOverride2=122]="wordWrapOverride2",V[V.wrappingIndent=123]="wrappingIndent",V[V.wrappingStrategy=124]="wrappingStrategy",V[V.showDeprecated=125]="showDeprecated",V[V.inlayHints=126]="inlayHints",V[V.editorClassName=127]="editorClassName",V[V.pixelRatio=128]="pixelRatio",V[V.tabFocusMode=129]="tabFocusMode",V[V.layoutInfo=130]="layoutInfo",V[V.wrappingInfo=131]="wrappingInfo"})(Mt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Fe(new D(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:a.localize(147,null)})),acceptSuggestionOnEnter:Fe(new M(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",a.localize(148,null),""],markdownDescription:a.localize(149,null)})),accessibilitySupport:Fe(new m),accessibilityPageSize:Fe(new h(3,"accessibilityPageSize",10,1,1073741824,{description:a.localize(150,null)})),ariaLabel:Fe(new I(4,"ariaLabel",a.localize(151,null))),autoClosingBrackets:Fe(new M(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(152,null),a.localize(153,null),""],description:a.localize(154,null)})),autoClosingDelete:Fe(new M(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",a.localize(155,null),""],description:a.localize(156,null)})),autoClosingOvertype:Fe(new M(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",a.localize(157,null),""],description:a.localize(158,null)})),autoClosingQuotes:Fe(new M(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(159,null),a.localize(160,null),""],description:a.localize(161,null)})),autoIndent:Fe(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],i,{enumDescriptions:[a.localize(162,null),a.localize(163,null),a.localize(164,null),a.localize(165,null),a.localize(166,null)],description:a.localize(167,null)})),automaticLayout:Fe(new D(10,"automaticLayout",!1)),autoSurround:Fe(new M(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[a.localize(168,null),a.localize(169,null),a.localize(170,null),""],description:a.localize(171,null)})),bracketPairColorization:Fe(new me),bracketPairGuides:Fe(new Pe),stickyTabStops:Fe(new D(103,"stickyTabStops",!1,{description:a.localize(172,null)})),codeLens:Fe(new D(14,"codeLens",!0,{description:a.localize(173,null)})),codeLensFontFamily:Fe(new I(15,"codeLensFontFamily","",{description:a.localize(174,null)})),codeLensFontSize:Fe(new h(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:a.localize(175,null)})),colorDecorators:Fe(new D(17,"colorDecorators",!0,{description:a.localize(176,null)})),columnSelection:Fe(new D(18,"columnSelection",!1,{description:a.localize(177,null)})),comments:Fe(new d),contextmenu:Fe(new D(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Fe(new D(21,"copyWithSyntaxHighlighting",!0,{description:a.localize(178,null)})),cursorBlinking:Fe(new r(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],b,{description:a.localize(179,null)})),cursorSmoothCaretAnimation:Fe(new D(23,"cursorSmoothCaretAnimation",!1,{description:a.localize(180,null)})),cursorStyle:Fe(new r(24,"cursorStyle",y.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],S,{description:a.localize(181,null)})),cursorSurroundingLines:Fe(new h(25,"cursorSurroundingLines",0,0,1073741824,{description:a.localize(182,null)})),cursorSurroundingLinesStyle:Fe(new M(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[a.localize(183,null),a.localize(184,null)],description:a.localize(185,null)})),cursorWidth:Fe(new h(27,"cursorWidth",0,0,1073741824,{markdownDescription:a.localize(186,null)})),disableLayerHinting:Fe(new D(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Fe(new D(29,"disableMonospaceOptimizations",!1)),domReadOnly:Fe(new D(30,"domReadOnly",!1)),dragAndDrop:Fe(new D(31,"dragAndDrop",!0,{description:a.localize(187,null)})),emptySelectionClipboard:Fe(new U),extraEditorClassName:Fe(new I(33,"extraEditorClassName","")),fastScrollSensitivity:Fe(new p(34,"fastScrollSensitivity",5,V=>V<=0?5:V,{markdownDescription:a.localize(188,null)})),find:Fe(new H),fixedOverflowWidgets:Fe(new D(36,"fixedOverflowWidgets",!1)),folding:Fe(new D(37,"folding",!0,{description:a.localize(189,null)})),foldingStrategy:Fe(new M(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[a.localize(190,null),a.localize(191,null)],description:a.localize(192,null)})),foldingHighlight:Fe(new D(39,"foldingHighlight",!0,{description:a.localize(193,null)})),foldingImportsByDefault:Fe(new D(40,"foldingImportsByDefault",!1,{description:a.localize(194,null)})),unfoldOnClickAfterEndOfLine:Fe(new D(41,"unfoldOnClickAfterEndOfLine",!1,{description:a.localize(195,null)})),fontFamily:Fe(new I(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:a.localize(196,null)})),fontInfo:Fe(new L),fontLigatures2:Fe(new E),fontSize:Fe(new z),fontWeight:Fe(new N),formatOnPaste:Fe(new D(47,"formatOnPaste",!1,{description:a.localize(197,null)})),formatOnType:Fe(new D(48,"formatOnType",!1,{description:a.localize(198,null)})),glyphMargin:Fe(new D(49,"glyphMargin",!0,{description:a.localize(199,null)})),gotoLocation:Fe(new B),hideCursorInOverviewRuler:Fe(new D(51,"hideCursorInOverviewRuler",!1,{description:a.localize(200,null)})),hover:Fe(new j),inDiffEditor:Fe(new D(53,"inDiffEditor",!1)),letterSpacing:Fe(new p(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,V=>p.clamp(V,-5,20),{description:a.localize(201,null)})),lightbulb:Fe(new le),lineDecorationsWidth:Fe(new g(57,"lineDecorationsWidth",10)),lineHeight:Fe(new Y),lineNumbers:Fe(new Xe),lineNumbersMinChars:Fe(new h(60,"lineNumbersMinChars",5,1,300)),linkedEditing:Fe(new D(61,"linkedEditing",!1,{description:a.localize(202,null)})),links:Fe(new D(62,"links",!0,{description:a.localize(203,null)})),matchBrackets:Fe(new M(63,"matchBrackets","always",["always","near","never"],{description:a.localize(204,null)})),minimap:Fe(new ie),mouseStyle:Fe(new M(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Fe(new p(66,"mouseWheelScrollSensitivity",1,V=>V===0?1:V,{markdownDescription:a.localize(205,null)})),mouseWheelZoom:Fe(new D(67,"mouseWheelZoom",!1,{markdownDescription:a.localize(206,null)})),multiCursorMergeOverlapping:Fe(new D(68,"multiCursorMergeOverlapping",!0,{description:a.localize(207,null)})),multiCursorModifier:Fe(new r(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],we,{markdownEnumDescriptions:[a.localize(208,null),a.localize(209,null)],markdownDescription:a.localize(210,null)})),multiCursorPaste:Fe(new M(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[a.localize(211,null),a.localize(212,null)],markdownDescription:a.localize(213,null)})),occurrencesHighlight:Fe(new D(71,"occurrencesHighlight",!0,{description:a.localize(214,null)})),overviewRulerBorder:Fe(new D(72,"overviewRulerBorder",!0,{description:a.localize(215,null)})),overviewRulerLanes:Fe(new h(73,"overviewRulerLanes",3,0,3)),padding:Fe(new Me),parameterHints:Fe(new Re),peekWidgetDefaultFocus:Fe(new M(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[a.localize(216,null),a.localize(217,null)],description:a.localize(218,null)})),definitionLinkOpensInPeek:Fe(new D(77,"definitionLinkOpensInPeek",!1,{description:a.localize(219,null)})),quickSuggestions:Fe(new Qe),quickSuggestionsDelay:Fe(new h(79,"quickSuggestionsDelay",10,0,1073741824,{description:a.localize(220,null)})),readOnly:Fe(new D(80,"readOnly",!1)),renameOnType:Fe(new D(81,"renameOnType",!1,{description:a.localize(221,null),markdownDeprecationMessage:a.localize(222,null)})),renderControlCharacters:Fe(new D(82,"renderControlCharacters",!0,{description:a.localize(223,null),restricted:!0})),renderFinalNewline:Fe(new D(83,"renderFinalNewline",!0,{description:a.localize(224,null)})),renderLineHighlight:Fe(new M(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",a.localize(225,null)],description:a.localize(226,null)})),renderLineHighlightOnlyWhenFocus:Fe(new D(85,"renderLineHighlightOnlyWhenFocus",!1,{description:a.localize(227,null)})),renderValidationDecorations:Fe(new M(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Fe(new M(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",a.localize(228,null),a.localize(229,null),a.localize(230,null),""],description:a.localize(231,null)})),revealHorizontalRightPadding:Fe(new h(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Fe(new D(89,"roundedSelection",!0,{description:a.localize(232,null)})),rulers:Fe(new G),scrollbar:Fe(new ae),scrollBeyondLastColumn:Fe(new h(92,"scrollBeyondLastColumn",5,0,1073741824,{description:a.localize(233,null)})),scrollBeyondLastLine:Fe(new D(93,"scrollBeyondLastLine",!0,{description:a.localize(234,null)})),scrollPredominantAxis:Fe(new D(94,"scrollPredominantAxis",!0,{description:a.localize(235,null)})),selectionClipboard:Fe(new D(95,"selectionClipboard",!0,{description:a.localize(236,null),included:t.isLinux})),selectionHighlight:Fe(new D(96,"selectionHighlight",!0,{description:a.localize(237,null)})),selectOnLineNumbers:Fe(new D(97,"selectOnLineNumbers",!0)),showFoldingControls:Fe(new M(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[a.localize(238,null),a.localize(239,null)],description:a.localize(240,null)})),showUnused:Fe(new D(99,"showUnused",!0,{description:a.localize(241,null)})),showDeprecated:Fe(new D(125,"showDeprecated",!0,{description:a.localize(242,null)})),inlayHints:Fe(new ue),snippetSuggestions:Fe(new M(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[a.localize(243,null),a.localize(244,null),a.localize(245,null),a.localize(246,null)],description:a.localize(247,null)})),smartSelect:Fe(new Ye),smoothScrolling:Fe(new D(102,"smoothScrolling",!1,{description:a.localize(248,null)})),stopRenderingLineAfter:Fe(new h(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Fe(new He),inlineSuggest:Fe(new te),suggestFontSize:Fe(new h(106,"suggestFontSize",0,0,1e3,{markdownDescription:a.localize(249,null)})),suggestLineHeight:Fe(new h(107,"suggestLineHeight",0,0,1e3,{markdownDescription:a.localize(250,null)})),suggestOnTriggerCharacters:Fe(new D(108,"suggestOnTriggerCharacters",!0,{description:a.localize(251,null)})),suggestSelection:Fe(new M(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[a.localize(252,null),a.localize(253,null),a.localize(254,null)],description:a.localize(255,null)})),tabCompletion:Fe(new M(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[a.localize(256,null),a.localize(257,null),a.localize(258,null)],description:a.localize(259,null)})),tabIndex:Fe(new h(111,"tabIndex",0,-1,1073741824)),unicodeHighlight:Fe(new q),unusualLineTerminators:Fe(new M(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[a.localize(260,null),a.localize(261,null),a.localize(262,null)],description:a.localize(263,null)})),useShadowDOM:Fe(new D(114,"useShadowDOM",!0)),useTabStops:Fe(new D(115,"useTabStops",!0,{description:a.localize(264,null)})),wordSeparators:Fe(new I(116,"wordSeparators",w.USUAL_WORD_SEPARATORS,{description:a.localize(265,null)})),wordWrap:Fe(new M(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[a.localize(266,null),a.localize(267,null),a.localize(268,null),a.localize(269,null)],description:a.localize(270,null)})),wordWrapBreakAfterCharacters:Fe(new I(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Fe(new I(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Fe(new h(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:a.localize(271,null)})),wordWrapOverride1:Fe(new M(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Fe(new M(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Fe(new r(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Je,{enumDescriptions:[a.localize(272,null),a.localize(273,null),a.localize(274,null),a.localize(275,null)],description:a.localize(276,null)})),wrappingStrategy:Fe(new M(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[a.localize(277,null),a.localize(278,null)],description:a.localize(279,null)})),editorClassName:Fe(new A),pixelRatio:Fe(new Be),tabFocusMode:Fe(new et),layoutInfo:Fe(new K),wrappingInfo:Fe(new nt)}}),define(Ee[115],ye([18,19]),function(re,e){return re.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ee[116],ye([18,19]),function(re,e){return re.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ee[117],ye([18,19]),function(re,e){return re.create("vs/platform/files/common/files",e)}),define(Ee[118],ye([18,19]),function(re,e){return re.create("vs/platform/markers/common/markers",e)}),define(Ee[119],ye([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ee[120],ye([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ee[121],ye([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostProgress",e)}),define(Ee[122],ye([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ee[123],ye([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ee[124],ye([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ee[125],ye([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ee[126],ye([18,19]),function(re,e){return re.create("vs/workbench/common/editor",e)}),define(Ee[127],ye([18,19]),function(re,e){return re.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ee[128],ye([18,19]),function(re,e){return re.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(Ee[129],ye([18,19]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(Ee[130],ye([18,19]),function(re,e){return re.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ee[131],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var a;(function(k){k[k.ACTIVATE=1]="ACTIVATE",k[k.RESTORE=2]="RESTORE",k[k.PRESERVE=3]="PRESERVE"})(a=e.EditorActivation||(e.EditorActivation={}));var t;(function(k){k[k.PICK=0]="PICK",k[k.DISABLED=1]="DISABLED",k[k.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(t=e.EditorResolution||(e.EditorResolution={}));var w;(function(k){k[k.API=0]="API",k[k.USER=1]="USER"})(w=e.EditorOpenContext||(e.EditorOpenContext={}));var T;(function(k){k[k.Center=0]="Center",k[k.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",k[k.NearTop=2]="NearTop",k[k.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(Ee[132],ye([0,1,116]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const t=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function T(n){return n=n.trim(),n==="*"||t.test(n)}e.isValidVersionStr=T;function k(n){if(!T(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let f=n.match(t);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=k;function P(n){if(!n)return null;let f=n.majorBase,o=n.majorMustEqual,g=n.minorBase,c=n.minorMustEqual,D=n.patchBase,v=n.patchMustEqual;n.hasCaret&&(f===0||(c=!1),v=!1);let h=0;if(n.preRelease){const p=w.exec(n.preRelease);if(p){const[,I,l,M]=p;h=Date.UTC(Number(I),Number(l)-1,Number(M))}}return{majorBase:f,majorMustEqual:o,minorBase:g,minorMustEqual:c,patchBase:D,patchMustEqual:v,isMinimum:n.hasGreaterEquals,notBefore:h}}e.normalizeVersion=P;function C(n,f,o){let g;typeof n=="string"?g=P(k(n)):g=n;let c;f instanceof Date?c=f.getTime():typeof f=="string"&&(c=new Date(f).getTime());let D;if(typeof o=="string"?D=P(k(o)):D=o,!g||!D)return!1;let v=g.majorBase,h=g.minorBase,p=g.patchBase,I=D.majorBase,l=D.minorBase,M=D.patchBase,r=D.notBefore,i=D.majorMustEqual,m=D.minorMustEqual,d=D.patchMustEqual;return D.isMinimum?v>I?!0:v<I?!1:h>l?!0:h<l||c&&c<r?!1:p>=M:(v===1&&I===0&&(!i||!m||!d)&&(I=1,l=0,M=0,i=!0,m=!1,d=!1),v<I?!1:v>I?!i:h<l?!1:h>l?!m:p<M?!1:p>M?!d:!(c&&c<r))}e.isValidVersion=C;function R(n,f,o,g){return o.isBuiltin||typeof o.main=="undefined"?!0:_(n,f,o.engines.vscode,g)}e.isValidExtensionVersion=R;function F(n,f,o){return n==="*"||_(f,o,n)}e.isEngineValid=F;function _(n,f,o,g=[]){let c=P(k(o));if(!c)return g.push(a.localize(0,null,o)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return g.push(a.localize(1,null,o)),!1}else if(!c.majorMustEqual)return g.push(a.localize(2,null,o)),!1;return C(n,f,c)?!0:(g.push(a.localize(3,null,n,o)),!1)}}),define(Ee[80],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class a{constructor(w,T=[],k=!1){this.ctor=w,this.staticArguments=T,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=a}),define(Ee[56],ye([0,1,80]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function w(k,P,C){P instanceof a.SyncDescriptor||(P=new a.SyncDescriptor(P,[],C)),t.push([k,P])}e.registerSingleton=w;function T(){return t}e.getSingletonServiceDescriptors=T}),define(Ee[133],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class a{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=a;class t{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let k of this._nodes.values())k.outgoing.size===0&&T.push(k);return T}insertEdge(T,k){const P=this.lookupOrInsertNode(T),C=this.lookupOrInsertNode(k);P.outgoing.set(this._hashFn(k),C),C.incoming.set(this._hashFn(T),P)}removeNode(T){const k=this._hashFn(T);this._nodes.delete(k);for(let P of this._nodes.values())P.outgoing.delete(k),P.incoming.delete(k)}lookupOrInsertNode(T){const k=this._hashFn(T);let P=this._nodes.get(k);return P||(P=new a(T),this._nodes.set(k,P)),P}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[k,P]of this._nodes)T.push(`${k}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,k]of this._nodes){const P=new Set([T]),C=this._findCycle(k,P);if(C)return C}}_findCycle(T,k){for(let[P,C]of T.outgoing){if(k.has(P))return[...k,P].join(" -> ");k.add(P);const R=this._findCycle(C,k);if(R)return R;k.delete(P)}}}e.Graph=t}),define(Ee[3],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var a;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function P(C){return C[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=P})(a=e._util||(e._util={})),e.IInstantiationService=w("instantiationService");function t(k,P,C,R){P[a.DI_TARGET]===P?P[a.DI_DEPENDENCIES].push({id:k,index:C,optional:R}):(P[a.DI_DEPENDENCIES]=[{id:k,index:C,optional:R}],P[a.DI_TARGET]=P)}function w(k){if(a.serviceIds.has(k))return a.serviceIds.get(k);const P=function(C,R,F){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(P,C,F,!1)};return P.toString=()=>k,a.serviceIds.set(k,P),P}e.createDecorator=w;function T(k){return k}e.refineServiceDecorator=T}),define(Ee[134],ye([0,1,3]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,a.createDecorator)("modelService");function t(w){return!w.isTooLargeForSyncing()&&!w.isForSimpleWidget}e.shouldSynchronizeModel=t}),define(Ee[135],ye([0,1,4,57,6,21,75,55,134]),function(re,e,a,t,w,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function R(g){return typeof g=="string"?!1:Array.isArray(g)?g.every(R):!!g.exclusive}class F{constructor(){this._clock=0,this._entries=[],this._onDidChange=new a.Emitter}get onDidChange(){return this._onDidChange.event}register(c,D){let v={selector:c,provider:D,_score:-1,_time:this._clock++};return this._entries.push(v),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,w.toDisposable)(()=>{if(v){let h=this._entries.indexOf(v);h>=0&&(this._entries.splice(h,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),v=void 0)}})}has(c){return this.all(c).length>0}all(c){if(!c)return[];this._updateScores(c);const D=[];for(let v of this._entries)v._score>0&&D.push(v.provider);return D}ordered(c){const D=[];return this._orderedForEach(c,v=>D.push(v.provider)),D}orderedGroups(c){const D=[];let v,h;return this._orderedForEach(c,p=>{v&&h===p._score?v.push(p.provider):(h=p._score,v=[p.provider],D.push(v))}),D}_orderedForEach(c,D){if(!!c){this._updateScores(c);for(const v of this._entries)v._score>0&&D(v)}}_updateScores(c){let D={uri:c.uri.toString(),language:c.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===D.language&&this._lastCandidate.uri===D.uri)){this._lastCandidate=D;for(let v of this._entries)if(v._score=(0,P.score)(v.selector,c.uri,c.getLanguageId(),(0,C.shouldSynchronizeModel)(c)),R(v.selector)&&v._score>0){for(let h of this._entries)h._score=0;v._score=1e3;break}this._entries.sort(F._compareByScoreAndTime)}}static _compareByScoreAndTime(c,D){return c._score<D._score?1:c._score>D._score?-1:c._time<D._time?1:c._time>D._time?-1:0}}e.LanguageFeatureRegistry=F;const _=new WeakMap;let n=0;function f(g){let c=_.get(g);return c===void 0&&(c=++n,_.set(g,c)),c}class o{constructor(c,D,v=Number.MAX_SAFE_INTEGER){this._registry=c,this.min=D,this.max=v,this._cache=new T.LRUCache(50,.7)}_key(c){return c.id+this._registry.all(c).reduce((D,v)=>(0,t.doHash)(f(v),D),0)}_clamp(c){return c===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(c*1.3)))}get(c){const D=this._key(c),v=this._cache.get(D);return this._clamp(v?.value)}update(c,D){const v=this._key(c);let h=this._cache.get(v);return h||(h=new k.MovingAverage,this._cache.set(v,h)),h.update(D),this.get(c)}}e.LanguageFeatureRequestDelays=o}),define(Ee[58],ye([0,1,2,59,135,108,51]),function(re,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var P;(function(u){u[u.Null=0]="Null",u[u.PlainText=1]="PlainText"})(P=e.LanguageId||(e.LanguageId={}));var C;(function(u){u[u.NotSet=-1]="NotSet",u[u.None=0]="None",u[u.Italic=1]="Italic",u[u.Bold=2]="Bold",u[u.Underline=4]="Underline"})(C=e.FontStyle||(e.FontStyle={}));var R;(function(u){u[u.None=0]="None",u[u.DefaultForeground=1]="DefaultForeground",u[u.DefaultBackground=2]="DefaultBackground"})(R=e.ColorId||(e.ColorId={}));var F;(function(u){u[u.Other=0]="Other",u[u.Comment=1]="Comment",u[u.String=2]="String",u[u.RegEx=4]="RegEx"})(F=e.StandardTokenType||(e.StandardTokenType={}));var _;(function(u){u[u.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",u[u.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",u[u.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",u[u.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",u[u.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",u[u.ITALIC_MASK=2048]="ITALIC_MASK",u[u.BOLD_MASK=4096]="BOLD_MASK",u[u.UNDERLINE_MASK=8192]="UNDERLINE_MASK",u[u.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",u[u.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",u[u.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",u[u.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",u[u.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",u[u.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",u[u.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",u[u.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",u[u.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",u[u.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(_=e.MetadataConsts||(e.MetadataConsts={}));class n{static getLanguageId(S){return(S&255)>>>0}static getTokenType(S){return(S&1792)>>>8}static getFontStyle(S){return(S&14336)>>>11}static getForeground(S){return(S&8372224)>>>14}static getBackground(S){return(S&4286578688)>>>23}static getClassNameFromMetadata(S){let A=this.getForeground(S),U="mtk"+A,H=this.getFontStyle(S);return H&1&&(U+=" mtki"),H&2&&(U+=" mtkb"),H&4&&(U+=" mtku"),U}static getInlineStyleFromMetadata(S,A){const U=this.getForeground(S),H=this.getFontStyle(S);let E=`color: ${A[U]};`;return H&1&&(E+="font-style: italic;"),H&2&&(E+="font-weight: bold;"),H&4&&(E+="text-decoration: underline;"),E}}e.TokenMetadata=n;var f;(function(u){u[u.Method=0]="Method",u[u.Function=1]="Function",u[u.Constructor=2]="Constructor",u[u.Field=3]="Field",u[u.Variable=4]="Variable",u[u.Class=5]="Class",u[u.Struct=6]="Struct",u[u.Interface=7]="Interface",u[u.Module=8]="Module",u[u.Property=9]="Property",u[u.Event=10]="Event",u[u.Operator=11]="Operator",u[u.Unit=12]="Unit",u[u.Value=13]="Value",u[u.Constant=14]="Constant",u[u.Enum=15]="Enum",u[u.EnumMember=16]="EnumMember",u[u.Keyword=17]="Keyword",u[u.Text=18]="Text",u[u.Color=19]="Color",u[u.File=20]="File",u[u.Reference=21]="Reference",u[u.Customcolor=22]="Customcolor",u[u.Folder=23]="Folder",u[u.TypeParameter=24]="TypeParameter",u[u.User=25]="User",u[u.Issue=26]="Issue",u[u.Snippet=27]="Snippet"})(f=e.CompletionItemKind||(e.CompletionItemKind={}));var o;(function(u){const S=new Map;S.set(0,k.Codicon.symbolMethod),S.set(1,k.Codicon.symbolFunction),S.set(2,k.Codicon.symbolConstructor),S.set(3,k.Codicon.symbolField),S.set(4,k.Codicon.symbolVariable),S.set(5,k.Codicon.symbolClass),S.set(6,k.Codicon.symbolStruct),S.set(7,k.Codicon.symbolInterface),S.set(8,k.Codicon.symbolModule),S.set(9,k.Codicon.symbolProperty),S.set(10,k.Codicon.symbolEvent),S.set(11,k.Codicon.symbolOperator),S.set(12,k.Codicon.symbolUnit),S.set(13,k.Codicon.symbolValue),S.set(15,k.Codicon.symbolEnum),S.set(14,k.Codicon.symbolConstant),S.set(15,k.Codicon.symbolEnum),S.set(16,k.Codicon.symbolEnumMember),S.set(17,k.Codicon.symbolKeyword),S.set(27,k.Codicon.symbolSnippet),S.set(18,k.Codicon.symbolText),S.set(19,k.Codicon.symbolColor),S.set(20,k.Codicon.symbolFile),S.set(21,k.Codicon.symbolReference),S.set(22,k.Codicon.symbolCustomColor),S.set(23,k.Codicon.symbolFolder),S.set(24,k.Codicon.symbolTypeParameter),S.set(25,k.Codicon.account),S.set(26,k.Codicon.issues);function A(E){let L=S.get(E);return L||(console.info("No codicon found for CompletionItemKind "+E),L=k.Codicon.symbolProperty),L}u.toIcon=A;const U=new Map;U.set("method",0),U.set("function",1),U.set("constructor",2),U.set("field",3),U.set("variable",4),U.set("class",5),U.set("struct",6),U.set("interface",7),U.set("module",8),U.set("property",9),U.set("event",10),U.set("operator",11),U.set("unit",12),U.set("value",13),U.set("constant",14),U.set("enum",15),U.set("enum-member",16),U.set("enumMember",16),U.set("keyword",17),U.set("snippet",27),U.set("text",18),U.set("color",19),U.set("file",20),U.set("reference",21),U.set("customcolor",22),U.set("folder",23),U.set("type-parameter",24),U.set("typeParameter",24),U.set("account",25),U.set("issue",26);function H(E,L){let z=U.get(E);return typeof z=="undefined"&&!L&&(z=9),z}u.fromString=H})(o=e.CompletionItemKinds||(e.CompletionItemKinds={}));var g;(function(u){u[u.Deprecated=1]="Deprecated"})(g=e.CompletionItemTag||(e.CompletionItemTag={}));var c;(function(u){u[u.KeepWhitespace=1]="KeepWhitespace",u[u.InsertAsSnippet=4]="InsertAsSnippet"})(c=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var D;(function(u){u[u.Invoke=0]="Invoke",u[u.TriggerCharacter=1]="TriggerCharacter",u[u.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(D=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var v;(function(u){u[u.Automatic=0]="Automatic",u[u.Explicit=1]="Explicit"})(v=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var h;(function(u){u[u.Invoke=1]="Invoke",u[u.Auto=2]="Auto"})(h=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var p;(function(u){u[u.Invoke=1]="Invoke",u[u.TriggerCharacter=2]="TriggerCharacter",u[u.ContentChange=3]="ContentChange"})(p=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var I;(function(u){u[u.Text=0]="Text",u[u.Read=1]="Read",u[u.Write=2]="Write"})(I=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function l(u){return u&&a.URI.isUri(u.uri)&&t.Range.isIRange(u.range)&&(t.Range.isIRange(u.originSelectionRange)||t.Range.isIRange(u.targetSelectionRange))}e.isLocationLink=l;var M;(function(u){u[u.File=0]="File",u[u.Module=1]="Module",u[u.Namespace=2]="Namespace",u[u.Package=3]="Package",u[u.Class=4]="Class",u[u.Method=5]="Method",u[u.Property=6]="Property",u[u.Field=7]="Field",u[u.Constructor=8]="Constructor",u[u.Enum=9]="Enum",u[u.Interface=10]="Interface",u[u.Function=11]="Function",u[u.Variable=12]="Variable",u[u.Constant=13]="Constant",u[u.String=14]="String",u[u.Number=15]="Number",u[u.Boolean=16]="Boolean",u[u.Array=17]="Array",u[u.Object=18]="Object",u[u.Key=19]="Key",u[u.Null=20]="Null",u[u.EnumMember=21]="EnumMember",u[u.Struct=22]="Struct",u[u.Event=23]="Event",u[u.Operator=24]="Operator",u[u.TypeParameter=25]="TypeParameter"})(M=e.SymbolKind||(e.SymbolKind={}));var r;(function(u){u[u.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var i;(function(u){const S=new Map;S.set(0,k.Codicon.symbolFile),S.set(1,k.Codicon.symbolModule),S.set(2,k.Codicon.symbolNamespace),S.set(3,k.Codicon.symbolPackage),S.set(4,k.Codicon.symbolClass),S.set(5,k.Codicon.symbolMethod),S.set(6,k.Codicon.symbolProperty),S.set(7,k.Codicon.symbolField),S.set(8,k.Codicon.symbolConstructor),S.set(9,k.Codicon.symbolEnum),S.set(10,k.Codicon.symbolInterface),S.set(11,k.Codicon.symbolFunction),S.set(12,k.Codicon.symbolVariable),S.set(13,k.Codicon.symbolConstant),S.set(14,k.Codicon.symbolString),S.set(15,k.Codicon.symbolNumber),S.set(16,k.Codicon.symbolBoolean),S.set(17,k.Codicon.symbolArray),S.set(18,k.Codicon.symbolObject),S.set(19,k.Codicon.symbolKey),S.set(20,k.Codicon.symbolNull),S.set(21,k.Codicon.symbolEnumMember),S.set(22,k.Codicon.symbolStruct),S.set(23,k.Codicon.symbolEvent),S.set(24,k.Codicon.symbolOperator),S.set(25,k.Codicon.symbolTypeParameter);function A(U){let H=S.get(U);return H||(console.info("No codicon found for SymbolKind "+U),H=k.Codicon.symbolProperty),H}u.toIcon=A})(i=e.SymbolKinds||(e.SymbolKinds={}));class m{constructor(S){this.value=S}}e.FoldingRangeKind=m,m.Comment=new m("comment"),m.Imports=new m("imports"),m.Region=new m("region");var d;(function(u){u[u.Collapsed=0]="Collapsed",u[u.Expanded=1]="Expanded"})(d=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var s;(function(u){u[u.Editing=0]="Editing",u[u.Preview=1]="Preview"})(s=e.CommentMode||(e.CommentMode={}));var b;(function(u){u[u.Other=0]="Other",u[u.Type=1]="Type",u[u.Parameter=2]="Parameter"})(b=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new w.LanguageFeatureRegistry,e.RenameProviderRegistry=new w.LanguageFeatureRegistry,e.CompletionProviderRegistry=new w.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new w.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new w.LanguageFeatureRegistry,e.HoverProviderRegistry=new w.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new w.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new w.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new w.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new w.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new w.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new w.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new w.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new w.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new w.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new w.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new w.LanguageFeatureRegistry,e.LinkProviderRegistry=new w.LanguageFeatureRegistry,e.ColorProviderRegistry=new w.LanguageFeatureRegistry,e.SelectionRangeRegistry=new w.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new w.LanguageFeatureRegistry,e.TokenizationRegistry=new T.TokenizationRegistryImpl;var y;(function(u){u[u.None=0]="None",u[u.Option=1]="Option",u[u.Default=2]="Default",u[u.Preferred=3]="Preferred"})(y=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(Ee[81],ye([0,1,11,2,3]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,w.createDecorator)("configurationService");function T(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof t.URI)}e.isConfigurationOverrides=T;function k(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||a.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=k;var P;(function(c){c[c.USER=1]="USER",c[c.USER_LOCAL=2]="USER_LOCAL",c[c.USER_REMOTE=3]="USER_REMOTE",c[c.WORKSPACE=4]="WORKSPACE",c[c.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",c[c.DEFAULT=6]="DEFAULT",c[c.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function C(c){switch(c){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=C;function R(c,D){const v=Object.create(null);for(let h in c)F(v,h,c[h],D);return v}e.toValuesTree=R;function F(c,D,v,h){const p=D.split("."),I=p.pop();let l=c;for(let M=0;M<p.length;M++){let r=p[M],i=l[r];switch(typeof i){case"undefined":i=l[r]=Object.create(null);break;case"object":break;default:h(`Ignoring ${D} as ${p.slice(0,M+1).join(".")} is ${JSON.stringify(i)}`);return}l=i}if(typeof l=="object"&&l!==null)try{l[I]=v}catch{h(`Ignoring ${D} as ${p.join(".")} is ${JSON.stringify(l)}`)}else h(`Ignoring ${D} as ${p.join(".")} is ${JSON.stringify(l)}`)}e.addToValueTree=F;function _(c,D){const v=D.split(".");n(c,v)}e.removeFromValueTree=_;function n(c,D){const v=D.shift();if(D.length===0){delete c[v];return}if(Object.keys(c).indexOf(v)!==-1){const h=c[v];typeof h=="object"&&!Array.isArray(h)&&(n(h,D),Object.keys(h).length===0&&delete c[v])}}function f(c,D,v){function h(l,M){let r=l;for(const i of M){if(typeof r!="object"||r===null)return;r=r[i]}return r}const p=D.split("."),I=h(c,p);return typeof I=="undefined"?v:I}e.getConfigurationValue=f;function o(c,D,v){Object.keys(D).forEach(h=>{h!=="__proto__"&&(h in c?a.isObject(c[h])&&a.isObject(D[h])?o(c[h],D[h],v):v&&(c[h]=D[h]):c[h]=D[h])})}e.merge=o;function g(c,D,v){const h=c.inspect(D),p=c.inspect(v);return typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:typeof p.userValue!="undefined"||typeof p.workspaceValue!="undefined"||typeof p.workspaceFolderValue!="undefined"?p.value:h.defaultValue}e.getMigratedSettingValue=g}),define(Ee[44],ye([0,1,23,9,3]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=a.userAgent||"";const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",a.isMacintosh),k.set("isLinux",a.isLinux),k.set("isWindows",a.isWindows),k.set("isWeb",a.isWeb),k.set("isMacNative",a.isMacintosh&&!a.isWeb),k.set("isEdge",T.indexOf("Edg/")>=0),k.set("isFirefox",T.indexOf("Firefox")>=0),k.set("isChrome",T.indexOf("Chrome")>=0),k.set("isSafari",T.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var C;(function(H){H[H.False=0]="False",H[H.True=1]="True",H[H.Defined=2]="Defined",H[H.Not=3]="Not",H[H.Equals=4]="Equals",H[H.NotEquals=5]="NotEquals",H[H.And=6]="And",H[H.Regex=7]="Regex",H[H.NotRegex=8]="NotRegex",H[H.Or=9]="Or",H[H.In=10]="In",H[H.NotIn=11]="NotIn",H[H.Greater=12]="Greater",H[H.GreaterEquals=13]="GreaterEquals",H[H.Smaller=14]="Smaller",H[H.SmallerEquals=15]="SmallerEquals"})(C=e.ContextKeyExprType||(e.ContextKeyExprType={}));class R{static false(){return n.INSTANCE}static true(){return f.INSTANCE}static has(E){return o.create(E)}static equals(E,L){return g.create(E,L)}static notEquals(E,L){return v.create(E,L)}static regex(E,L){return i.create(E,L)}static in(E,L){return c.create(E,L)}static not(E){return h.create(E)}static and(...E){return s.create(E,null)}static or(...E){return b.create(E,null,!0)}static greater(E,L){return I.create(E,L)}static greaterEquals(E,L){return l.create(E,L)}static smaller(E,L){return M.create(E,L)}static smallerEquals(E,L){return r.create(E,L)}static deserialize(E,L=!1){if(!!E)return this._deserializeOrExpression(E,L)}static _deserializeOrExpression(E,L){let z=E.split("||");return b.create(z.map(N=>this._deserializeAndExpression(N,L)),null,!0)}static _deserializeAndExpression(E,L){let z=E.split("&&");return s.create(z.map(N=>this._deserializeOne(N,L)),null)}static _deserializeOne(E,L){if(E=E.trim(),E.indexOf("!=")>=0){let z=E.split("!=");return v.create(z[0].trim(),this._deserializeValue(z[1],L))}if(E.indexOf("==")>=0){let z=E.split("==");return g.create(z[0].trim(),this._deserializeValue(z[1],L))}if(E.indexOf("=~")>=0){let z=E.split("=~");return i.create(z[0].trim(),this._deserializeRegexValue(z[1],L))}if(E.indexOf(" in ")>=0){let z=E.split(" in ");return c.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(E)){const z=E.split(">=");return l.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(E)){const z=E.split(">");return I.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(E)){const z=E.split("<=");return r.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(E)){const z=E.split("<");return M.create(z[0].trim(),z[1].trim())}return/^\!\s*/.test(E)?h.create(E.substr(1).trim()):o.create(E)}static _deserializeValue(E,L){if(E=E.trim(),E==="true")return!0;if(E==="false")return!1;let z=/^'([^']*)'$/.exec(E);return z?z[1].trim():E}static _deserializeRegexValue(E,L){if((0,t.isFalsyOrWhitespace)(E)){if(L)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let z=E.indexOf("/"),N=E.lastIndexOf("/");if(z===N||z<0){if(L)throw new Error(`bad regexp-value '${E}', missing /-enclosure`);return console.warn(`bad regexp-value '${E}', missing /-enclosure`),null}let B=E.slice(z+1,N),j=E[N+1]==="i"?"i":"";try{return new RegExp(B,j)}catch(ce){if(L)throw new Error(`bad regexp-value '${E}', parse error: ${ce}`);return console.warn(`bad regexp-value '${E}', parse error: ${ce}`),null}}}e.ContextKeyExpr=R;function F(H,E){const L=H?H.substituteConstants():void 0,z=E?E.substituteConstants():void 0;return!L&&!z?!0:!L||!z?!1:L.equals(z)}e.expressionsAreEqualWithConstantSubstitution=F;function _(H,E){return H.cmp(E)}class n{constructor(){this.type=0}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!1}serialize(){return"false"}keys(){return[]}map(E){return this}negate(){return f.INSTANCE}}e.ContextKeyFalseExpr=n,n.INSTANCE=new n;class f{constructor(){this.type=1}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!0}serialize(){return"true"}keys(){return[]}map(E){return this}negate(){return n.INSTANCE}}e.ContextKeyTrueExpr=f,f.INSTANCE=new f;class o{constructor(E,L){this.key=E,this.negated=L,this.type=2}static create(E,L=null){const z=k.get(E);return typeof z=="boolean"?z?f.INSTANCE:n.INSTANCE:new o(E,L)}cmp(E){return E.type!==this.type?this.type-E.type:u(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}substituteConstants(){const E=k.get(this.key);return typeof E=="boolean"?E?f.INSTANCE:n.INSTANCE:this}evaluate(E){return!!E.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(E){return E.mapDefined(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=o;class g{constructor(E,L,z){this.key=E,this.value=L,this.negated=z,this.type=4}static create(E,L,z=null){if(typeof L=="boolean")return L?o.create(E,z):h.create(E,z);const N=k.get(E);return typeof N=="boolean"?L===(N?"true":"false")?f.INSTANCE:n.INSTANCE:new g(E,L,z)}cmp(E){return E.type!==this.type?this.type-E.type:S(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){const E=k.get(this.key);if(typeof E=="boolean"){const L=E?"true":"false";return this.value===L?f.INSTANCE:n.INSTANCE}return this}evaluate(E){return E.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(E){return E.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=g;class c{constructor(E,L){this.key=E,this.valueKey=L,this.type=10,this.negated=null}static create(E,L){return new c(E,L)}cmp(E){return E.type!==this.type?this.type-E.type:S(this.key,this.valueKey,E.key,E.valueKey)}equals(E){return E.type===this.type?this.key===E.key&&this.valueKey===E.valueKey:!1}substituteConstants(){return this}evaluate(E){const L=E.getValue(this.valueKey),z=E.getValue(this.key);return Array.isArray(L)?L.indexOf(z)>=0:typeof z=="string"&&typeof L=="object"&&L!==null?P.call(L,z):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(E){return E.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=D.create(this)),this.negated}}e.ContextKeyInExpr=c;class D{constructor(E){this._actual=E,this.type=11}static create(E){return new D(E)}cmp(E){return E.type!==this.type?this.type-E.type:this._actual.cmp(E._actual)}equals(E){return E.type===this.type?this._actual.equals(E._actual):!1}substituteConstants(){return this}evaluate(E){return!this._actual.evaluate(E)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(E){return new D(this._actual.map(E))}negate(){return this._actual}}e.ContextKeyNotInExpr=D;class v{constructor(E,L,z){this.key=E,this.value=L,this.negated=z,this.type=5}static create(E,L,z=null){if(typeof L=="boolean")return L?h.create(E,z):o.create(E,z);const N=k.get(E);return typeof N=="boolean"?L===(N?"true":"false")?n.INSTANCE:f.INSTANCE:new v(E,L,z)}cmp(E){return E.type!==this.type?this.type-E.type:S(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){const E=k.get(this.key);if(typeof E=="boolean"){const L=E?"true":"false";return this.value===L?n.INSTANCE:f.INSTANCE}return this}evaluate(E){return E.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(E){return E.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=v;class h{constructor(E,L){this.key=E,this.negated=L,this.type=3}static create(E,L=null){const z=k.get(E);return typeof z=="boolean"?z?n.INSTANCE:f.INSTANCE:new h(E,L)}cmp(E){return E.type!==this.type?this.type-E.type:u(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}substituteConstants(){const E=k.get(this.key);return typeof E=="boolean"?E?n.INSTANCE:f.INSTANCE:this}evaluate(E){return!E.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(E){return E.mapNot(this.key)}negate(){return this.negated||(this.negated=o.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=h;function p(H,E){if(typeof H=="string"){const L=parseFloat(H);isNaN(L)||(H=L)}return typeof H=="string"||typeof H=="number"?E(H):n.INSTANCE}class I{constructor(E,L,z){this.key=E,this.value=L,this.negated=z,this.type=12}static create(E,L,z=null){return p(L,N=>new I(E,N,z))}cmp(E){return E.type!==this.type?this.type-E.type:S(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(E){return E.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=I;class l{constructor(E,L,z){this.key=E,this.value=L,this.negated=z,this.type=13}static create(E,L,z=null){return p(L,N=>new l(E,N,z))}cmp(E){return E.type!==this.type?this.type-E.type:S(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(E){return E.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=M.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=l;class M{constructor(E,L,z){this.key=E,this.value=L,this.negated=z,this.type=14}static create(E,L,z=null){return p(L,N=>new M(E,N,z))}cmp(E){return E.type!==this.type?this.type-E.type:S(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(E){return E.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=M;class r{constructor(E,L,z){this.key=E,this.value=L,this.negated=z,this.type=15}static create(E,L,z=null){return p(L,N=>new r(E,N,z))}cmp(E){return E.type!==this.type?this.type-E.type:S(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(E){return E.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=I.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=r;class i{constructor(E,L){this.key=E,this.regexp=L,this.type=7,this.negated=null}static create(E,L){return new i(E,L)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.key<E.key)return-1;if(this.key>E.key)return 1;const L=this.regexp?this.regexp.source:"",z=E.regexp?E.regexp.source:"";return L<z?-1:L>z?1:0}equals(E){if(E.type===this.type){const L=this.regexp?this.regexp.source:"",z=E.regexp?E.regexp.source:"";return this.key===E.key&&L===z}return!1}substituteConstants(){return this}evaluate(E){let L=E.getValue(this.key);return this.regexp?this.regexp.test(L):!1}serialize(){const E=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${E}`}keys(){return[this.key]}map(E){return E.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=m.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class m{constructor(E){this._actual=E,this.type=8}static create(E){return new m(E)}cmp(E){return E.type!==this.type?this.type-E.type:this._actual.cmp(E._actual)}equals(E){return E.type===this.type?this._actual.equals(E._actual):!1}substituteConstants(){return this}evaluate(E){return!this._actual.evaluate(E)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(E){return new m(this._actual.map(E))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=m;function d(H){let E=null;for(let L=0,z=H.length;L<z;L++){const N=H[L].substituteConstants();if(H[L]!==N&&E===null){E=[];for(let B=0;B<L;B++)E[B]=H[B]}E!==null&&(E[L]=N)}return E===null?H:E}class s{constructor(E,L){this.expr=E,this.negated=L,this.type=6}static create(E,L){return s._normalizeArr(E,L)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let L=0,z=this.expr.length;L<z;L++){const N=_(this.expr[L],E.expr[L]);if(N!==0)return N}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let L=0,z=this.expr.length;L<z;L++)if(!this.expr[L].equals(E.expr[L]))return!1;return!0}return!1}substituteConstants(){const E=d(this.expr);return E===this.expr?this:s.create(E,this.negated)}evaluate(E){for(let L=0,z=this.expr.length;L<z;L++)if(!this.expr[L].evaluate(E))return!1;return!0}static _normalizeArr(E,L){const z=[];let N=!1;for(const B of E)if(!!B){if(B.type===1){N=!0;continue}if(B.type===0)return n.INSTANCE;if(B.type===6){z.push(...B.expr);continue}z.push(B)}if(z.length===0&&N)return f.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(_);for(let B=1;B<z.length;B++)z[B-1].equals(z[B])&&(z.splice(B,1),B--);if(z.length===1)return z[0];for(;z.length>1;){const B=z[z.length-1];if(B.type!==9)break;z.pop();const j=z.pop(),ce=z.length===0,K=b.create(B.expr.map(le=>s.create([le,j],null)),null,ce);K&&(z.push(K),z.sort(_))}return z.length===1?z[0]:new s(z,L)}}serialize(){return this.expr.map(E=>E.serialize()).join(" && ")}keys(){const E=[];for(let L of this.expr)E.push(...L.keys());return E}map(E){return new s(this.expr.map(L=>L.map(E)),null)}negate(){if(!this.negated){const E=[];for(let L of this.expr)E.push(L.negate());this.negated=b.create(E,this,!0)}return this.negated}}class b{constructor(E,L){this.expr=E,this.negated=L,this.type=9}static create(E,L,z){return b._normalizeArr(E,L,z)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let L=0,z=this.expr.length;L<z;L++){const N=_(this.expr[L],E.expr[L]);if(N!==0)return N}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let L=0,z=this.expr.length;L<z;L++)if(!this.expr[L].equals(E.expr[L]))return!1;return!0}return!1}substituteConstants(){const E=d(this.expr);return E===this.expr?this:b.create(E,this.negated,!1)}evaluate(E){for(let L=0,z=this.expr.length;L<z;L++)if(this.expr[L].evaluate(E))return!0;return!1}static _normalizeArr(E,L,z){let N=[],B=!1;if(E){for(let j=0,ce=E.length;j<ce;j++){const K=E[j];if(!!K){if(K.type===0){B=!0;continue}if(K.type===1)return f.INSTANCE;if(K.type===9){N=N.concat(K.expr);continue}N.push(K)}}if(N.length===0&&B)return n.INSTANCE;N.sort(_)}if(N.length!==0){if(N.length===1)return N[0];for(let j=1;j<N.length;j++)N[j-1].equals(N[j])&&(N.splice(j,1),j--);if(N.length===1)return N[0];if(z){for(let j=0;j<N.length;j++)for(let ce=j+1;ce<N.length;ce++)A(N[j],N[ce])&&(N.splice(ce,1),ce--);if(N.length===1)return N[0]}return new b(N,L)}}serialize(){return this.expr.map(E=>E.serialize()).join(" || ")}keys(){const E=[];for(let L of this.expr)E.push(...L.keys());return E}map(E){return new b(this.expr.map(L=>L.map(E)),null)}negate(){if(!this.negated){let E=[];for(let L of this.expr)E.push(L.negate());for(;E.length>1;){const L=E.shift(),z=E.shift(),N=[];for(const j of U(L))for(const ce of U(z))N.push(s.create([j,ce],null));const B=E.length===0;E.unshift(b.create(N,null,B))}this.negated=E[0]}return this.negated}}class y extends o{constructor(E,L,z){super(E,null);this._defaultValue=L,typeof z=="object"?y._info.push({...z,key:E}):z!==!0&&y._info.push({key:E,description:z,type:L!=null?typeof L:void 0})}static all(){return y._info.values()}bindTo(E){return E.createKey(this.key,this._defaultValue)}getValue(E){return E.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(E){return g.create(this.key,E)}notEqualsTo(E){return v.create(this.key,E)}}e.RawContextKey=y,y._info=[],e.IContextKeyService=(0,w.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function u(H,E){return H<E?-1:H>E?1:0}function S(H,E,L,z){return H<L?-1:H>L?1:E<z?-1:E>z?1:0}function A(H,E){if(E.type===6&&H.type!==9&&H.type!==6){for(const N of E.expr)if(H.equals(N))return!0}const L=H.negate(),z=U(L).concat(U(E));z.sort(_);for(let N=0;N<z.length;N++){const j=z[N].negate();for(let ce=N+1;ce<z.length;ce++){const K=z[ce];if(j.equals(K))return!0}}return!1}e.implies=A;function U(H){return H.type===9?H.expr:[H]}}),define(Ee[136],ye([0,1,3]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,a.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,a.refineServiceDecorator)(e.IEnvironmentService)}),define(Ee[45],ye([0,1,21,17,9,11,2,117,3]),function(re,e,a,t,w,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function R(N){return N.create===!0}e.isFileOpenForWriteOptions=R;var F;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(F=e.FileType||(e.FileType={}));var _;(function(N){N[N.Readonly=1]="Readonly"})(_=e.FilePermission||(e.FilePermission={}));var n;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock",N[N.FileAtomicRead=16384]="FileAtomicRead"})(n=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=f;function o(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=o;function g(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function c(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=c;function D(N){return f(N)?!!(N.capabilities&16384):!1}e.hasFileAtomicReadCapability=D;var v;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(v=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class h extends Error{constructor(B,j){super(B);this.code=j}}e.FileSystemProviderError=h;function p(N,B){const j=new h(N.toString(),B);return l(j,B),j}e.createFileSystemProviderError=p;function I(N){return N||p((0,P.localize)(0,null),v.Unknown)}e.ensureFileSystemProviderError=I;function l(N,B){return N.name=B?`${B} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=l;function M(N){if(!N)return v.Unknown;if(N instanceof h)return N.code;const B=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!B)return v.Unknown;switch(B[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileExceedsMemoryLimit:return v.FileExceedsMemoryLimit;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.toFileSystemProviderErrorCode=M;function r(N){if(N instanceof y)return N.fileOperationResult;switch(M(N)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 10;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileExceedsMemoryLimit:return 9;case v.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var i;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class m{constructor(B,j,ce){this.resource=B,this.operation=j,this.target=ce}isOperation(B){return this.operation===B}}e.FileOperationEvent=m;var d;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(d=e.FileChangeType||(e.FileChangeType={}));class s{constructor(B,j){this.added=void 0,this.updated=void 0,this.deleted=void 0;const ce=new Map;for(const K of B){const le=ce.get(K.type);le?le.push([K.resource,K]):ce.set(K.type,[[K.resource,K]])}for(const[K,le]of ce)switch(K){case 1:this.added=a.TernarySearchTree.forUris(()=>j),this.added.fill(le);break;case 0:this.updated=a.TernarySearchTree.forUris(()=>j),this.updated.fill(le);break;case 2:this.deleted=a.TernarySearchTree.forUris(()=>j),this.deleted.fill(le);break}}contains(B,...j){return this.doContains(B,{includeChildren:!1},...j)}affects(B,...j){return this.doContains(B,{includeChildren:!0},...j)}doContains(B,j,...ce){if(!B)return!1;const K=ce.length>0;return!!((!K||ce.includes(1))&&(this.added?.get(B)||j.includeChildren&&this.added?.findSuperstr(B))||(!K||ce.includes(0))&&(this.updated?.get(B)||j.includeChildren&&this.updated?.findSuperstr(B))||(!K||ce.includes(2))&&(this.deleted?.findSubstr(B)||j.includeChildren&&this.deleted?.findSuperstr(B)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=s;function b(N,B,j){return!N||!B||N===B||B.length>N.length?!1:(B.charAt(B.length-1)!==t.sep&&(B+=t.sep),j?(0,w.startsWithIgnoreCase)(N,B):N.indexOf(B)===0)}e.isParent=b;class y extends Error{constructor(B,j,ce){super(B);this.fileOperationResult=j,this.options=ce}}e.FileOperationError=y;class u extends y{constructor(B,j,ce){super(B,2,ce);this.stat=j}}e.NotModifiedSinceFileOperationError=u;var S;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(S=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var A;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(A=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function U(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=U;async function H(N,B){if(!B.hasProvider(k.URI.from({scheme:N.scheme})))return new Promise(j=>{const ce=B.onDidChangeFileSystemProviderRegistrations(K=>{K.scheme===N.scheme&&K.added&&(ce.dispose(),j())})})}e.whenProviderRegistered=H,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class E{static formatSize(B){return(0,T.isNumber)(B)||(B=0),B<E.KB?(0,P.localize)(1,null,B.toFixed(0)):B<E.MB?(0,P.localize)(2,null,(B/E.KB).toFixed(2)):B<E.GB?(0,P.localize)(3,null,(B/E.MB).toFixed(2)):B<E.TB?(0,P.localize)(4,null,(B/E.GB).toFixed(2)):(0,P.localize)(5,null,(B/E.TB).toFixed(2))}}e.ByteSize=E,E.KB=1024,E.MB=E.KB*E.KB,E.GB=E.MB*E.KB,E.TB=E.GB*E.KB;var L;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(L=e.Arch||(e.Arch={}));function z(N){return{maxFileSize:N===0?300*E.MB:16*E.GB,maxHeapSize:N===0?700*E.MB:2*700*E.MB}}e.getPlatformLimits=z}),define(Ee[60],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class a{constructor(...w){this._entries=new Map;for(let[T,k]of w)this.set(T,k)}set(w,T){const k=this._entries.get(w);return this._entries.set(w,T),k}has(w){return this._entries.has(w)}get(w){return this._entries.get(w)}}e.ServiceCollection=a}),define(Ee[137],ye([0,1,14,15,80,133,3,60]),function(re,e,a,t,w,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const C=!1;class R extends Error{constructor(o){super("cyclic dependency between services");this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class F{constructor(o=new P.ServiceCollection,g=!1,c){this._activeInstantiations=new Set,this._services=o,this._strict=g,this._parent=c,this._services.set(k.IInstantiationService,this)}createChild(o){return new F(o,this._strict,this)}invokeFunction(o,...g){let c=n.traceInvocation(o),D=!1;try{return o({get:h=>{if(D)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const p=this._getOrCreateServiceInstance(h,c);if(!p)throw new Error(`[invokeFunction] unknown service '${h}'`);return p}},...g)}finally{D=!0,c.stop()}}createInstance(o,...g){let c,D;return o instanceof w.SyncDescriptor?(c=n.traceCreation(o.ctor),D=this._createInstance(o.ctor,o.staticArguments.concat(g),c)):(c=n.traceCreation(o),D=this._createInstance(o,g,c)),c.stop(),D}_createInstance(o,g=[],c){let D=k._util.getServiceDependencies(o).sort((p,I)=>p.index-I.index),v=[];for(const p of D){let I=this._getOrCreateServiceInstance(p.id,c);if(!I&&this._strict&&!p.optional)throw new Error(`[createInstance] ${o.name} depends on UNKNOWN service ${p.id}.`);v.push(I)}let h=D.length>0?D[0].index:g.length;if(g.length!==h){console.warn(`[createInstance] First service dependency of ${o.name} at position ${h+1} conflicts with ${g.length} static arguments`);let p=h-g.length;p>0?g=g.concat(new Array(p)):g=g.slice(0,h)}return new o(...[...g,...v])}_setServiceInstance(o,g){if(this._services.get(o)instanceof w.SyncDescriptor)this._services.set(o,g);else if(this._parent)this._parent._setServiceInstance(o,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){let g=this._services.get(o);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):g}_getOrCreateServiceInstance(o,g){let c=this._getServiceInstanceOrDescriptor(o);return c instanceof w.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,c,g.branch(o,!0)):(g.branch(o,!1),c)}_safeCreateAndCacheServiceInstance(o,g,c){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,g,c)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,g,c){const D=new T.Graph(p=>p.id.toString());let v=0;const h=[{id:o,desc:g,_trace:c}];for(;h.length;){const p=h.pop();if(D.lookupOrInsertNode(p),v++>1e3)throw new R(D);for(let I of k._util.getServiceDependencies(p.desc.ctor)){let l=this._getServiceInstanceOrDescriptor(I.id);if(!l&&!I.optional&&console.warn(`[createInstance] ${o} depends on ${I.id} which is NOT registered.`),l instanceof w.SyncDescriptor){const M={id:I.id,desc:l,_trace:p._trace.branch(I.id,!0)};D.insertEdge(p,M),h.push(M)}}}for(;;){const p=D.roots();if(p.length===0){if(!D.isEmpty())throw new R(D);break}for(const{data:I}of p){if(this._getServiceInstanceOrDescriptor(I.id)instanceof w.SyncDescriptor){const M=this._createServiceInstanceWithOwner(I.id,I.desc.ctor,I.desc.staticArguments,I.desc.supportsDelayedInstantiation,I._trace);this._setServiceInstance(I.id,M)}D.removeNode(I)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,g,c=[],D,v){if(this._services.get(o)instanceof w.SyncDescriptor)return this._createServiceInstance(g,c,D,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,g,c,D,v);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(o,g=[],c,D){if(c){const v=new a.IdleValue(()=>this._createInstance(o,g,D));return new Proxy(Object.create(null),{get(h,p){if(p in h)return h[p];let I=v.value,l=I[p];return typeof l!="function"||(l=l.bind(I),h[p]=l),l},set(h,p,I){return v.value[p]=I,!0}})}else return this._createInstance(o,g,D)}}e.InstantiationService=F;var _;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(_||(_={}));class n{constructor(o,g){this.type=o,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(o){return C?new n(1,o.name||o.toString().substring(0,42).replace(/\n/g,"")):n._None}static traceCreation(o){return C?new n(0,o.name):n._None}branch(o,g){let c=new n(2,o.toString());return this._dep.push([o,g,c]),c}stop(){let o=Date.now()-this._start;n._totals+=o;let g=!1;function c(v,h){let p=[],I=new Array(v+1).join("	");for(const[l,M,r]of h._dep)if(M&&r){g=!0,p.push(`${I}CREATES -> ${l}`);let i=c(v+1,r);i&&p.push(i)}else p.push(`${I}uses -> ${l}`);return p.join(`
`)}let D=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${n._totals.toFixed(2)}ms)`];(o>2||g)&&console.log(D.join(`
`))}}n._None=new class extends n{constructor(){super(-1,null)}stop(){}branch(){return this}},n._totals=0}),define(Ee[12],ye([0,1,43,4,6,23,3]),function(re,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function P(){return new Date().toISOString()}var C;(function(M){M[M.Trace=0]="Trace",M[M.Debug=1]="Debug",M[M.Info=2]="Info",M[M.Warning=3]="Warning",M[M.Error=4]="Error",M[M.Critical=5]="Critical",M[M.Off=6]="Off"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;function R(M,r,i){switch(r){case C.Trace:M.trace(i);break;case C.Debug:M.debug(i);break;case C.Info:M.info(i);break;case C.Warning:M.warn(i);break;case C.Error:M.error(i);break;case C.Critical:M.critical(i);break;default:throw new Error("Invalid log level")}}e.log=R;function F(M){let r="";for(let i=0;i<M.length;i++){let m=M[i];if(typeof m=="object")try{m=JSON.stringify(m)}catch{}r+=(i>0?" ":"")+m}return r}e.format=F;class _ extends w.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=_;class n extends _{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...i){this.checkLogLevel(C.Trace)&&this.log(C.Trace,F([r,...i]))}debug(r,...i){this.checkLogLevel(C.Debug)&&this.log(C.Debug,F([r,...i]))}info(r,...i){this.checkLogLevel(C.Info)&&this.log(C.Info,F([r,...i]))}warn(r,...i){this.checkLogLevel(C.Warning)&&this.log(C.Warning,F([r,...i]))}error(r,...i){if(this.checkLogLevel(C.Error))if(r instanceof Error){const m=Array.prototype.slice.call(arguments);m[0]=r.stack,this.log(C.Error,F(m))}else this.log(C.Error,F([r,...i]))}critical(r,...i){this.checkLogLevel(C.Critical)&&this.log(C.Critical,F([r,...i]))}flush(){}}e.AbstractMessageLogger=n;class f extends _{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!T.isWindows}trace(r,...i){this.getLevel()<=C.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,r,...i):console.log(`[main ${P()}]`,r,...i))}debug(r,...i){this.getLevel()<=C.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,r,...i):console.log(`[main ${P()}]`,r,...i))}info(r,...i){this.getLevel()<=C.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,r,...i):console.log(`[main ${P()}]`,r,...i))}warn(r,...i){this.getLevel()<=C.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,r,...i):console.warn(`[main ${P()}]`,r,...i))}error(r,...i){this.getLevel()<=C.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,r,...i):console.error(`[main ${P()}]`,r,...i))}critical(r,...i){this.getLevel()<=C.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,r,...i):console.error(`[main ${P()}]`,r,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=f;class o extends _{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...i){this.getLevel()<=C.Trace&&console.log("%cTRACE","color: #888",r,...i)}debug(r,...i){this.getLevel()<=C.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...i)}info(r,...i){this.getLevel()<=C.Info&&console.log("%c INFO","color: #33f",r,...i)}warn(r,...i){this.getLevel()<=C.Warning&&console.log("%c WARN","color: #993",r,...i)}error(r,...i){this.getLevel()<=C.Error&&console.log("%c  ERR","color: #f33",r,...i)}critical(r,...i){this.getLevel()<=C.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...i)}dispose(){}flush(){}}e.ConsoleLogger=o;class g extends _{constructor(r,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(i)}trace(r,...i){this.getLevel()<=C.Trace&&this.adapter.log(C.Trace,[this.extractMessage(r),...i])}debug(r,...i){this.getLevel()<=C.Debug&&this.adapter.log(C.Debug,[this.extractMessage(r),...i])}info(r,...i){this.getLevel()<=C.Info&&this.adapter.log(C.Info,[this.extractMessage(r),...i])}warn(r,...i){this.getLevel()<=C.Warning&&this.adapter.log(C.Warning,[this.extractMessage(r),...i])}error(r,...i){this.getLevel()<=C.Error&&this.adapter.log(C.Error,[this.extractMessage(r),...i])}critical(r,...i){this.getLevel()<=C.Critical&&this.adapter.log(C.Critical,[this.extractMessage(r),...i])}extractMessage(r){return typeof r=="string"?r:(0,a.toErrorMessage)(r,this.getLevel()<=C.Trace)}dispose(){}flush(){}}e.AdapterLogger=g;class c extends _{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const i of this.logServices)i.setLevel(r);super.setLevel(r)}trace(r,...i){for(const m of this.logServices)m.trace(r,...i)}debug(r,...i){for(const m of this.logServices)m.debug(r,...i)}info(r,...i){for(const m of this.logServices)m.info(r,...i)}warn(r,...i){for(const m of this.logServices)m.warn(r,...i)}error(r,...i){for(const m of this.logServices)m.error(r,...i)}critical(r,...i){for(const m of this.logServices)m.critical(r,...i)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=c;class D extends w.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...i){this.logger.trace(r,...i)}debug(r,...i){this.logger.debug(r,...i)}info(r,...i){this.logger.info(r,...i)}warn(r,...i){this.logger.warn(r,...i)}error(r,...i){this.logger.error(r,...i)}critical(r,...i){this.logger.critical(r,...i)}flush(){this.logger.flush()}}e.LogService=D;class v extends w.Disposable{constructor(r,i){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(m=>{this.logLevel=m,this.logLevelChangeableLoggers.forEach(d=>d.setLevel(m))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,i){let m=this.loggers.get(r.toString());return m||(m=this.doCreateLogger(r,i?.always?C.Trace:this.logLevel,i),this.loggers.set(r.toString(),m),i?.always||this.logLevelChangeableLoggers.push(m)),m}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class h{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(r){}getLevel(){return C.Info}trace(r,...i){}debug(r,...i){}info(r,...i){}warn(r,...i){}error(r,...i){}critical(r,...i){}dispose(){}flush(){}}e.NullLogService=h;function p(M){if(M.verbose)return C.Trace;if(typeof M.logLevel=="string"){const r=I(M.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=p;function I(M){switch(M){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Critical;case"off":return C.Off}}e.parseLogLevel=I;function l(M){switch(M){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Critical:return"critical";case C.Off:return"off"}}e.LogLevelToString=l}),define(Ee[82],ye([0,1,34,118,3]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(C){C[C.Unnecessary=1]="Unnecessary",C[C.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var k;(function(C){C[C.Hint=1]="Hint",C[C.Info=2]="Info",C[C.Warning=4]="Warning",C[C.Error=8]="Error"})(k=e.MarkerSeverity||(e.MarkerSeverity={})),function(C){function R(o,g){return g-o}C.compare=R;const F=Object.create(null);F[C.Error]=(0,t.localize)(0,null),F[C.Warning]=(0,t.localize)(1,null),F[C.Info]=(0,t.localize)(2,null);function _(o){return F[o]||""}C.toString=_;function n(o){switch(o){case a.default.Error:return C.Error;case a.default.Warning:return C.Warning;case a.default.Info:return C.Info;case a.default.Ignore:return C.Hint}}C.fromSeverity=n;function f(o){switch(o){case C.Error:return a.default.Error;case C.Warning:return a.default.Warning;case C.Info:return a.default.Info;case C.Hint:return a.default.Ignore}}C.toSeverity=f}(k=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(C){const R="";function F(n){return _(n,!0)}C.makeKey=F;function _(n,f){let o=[R];return n.source?o.push(n.source.replace("\xA6","\\\xA6")):o.push(R),n.code?typeof n.code=="string"?o.push(n.code.replace("\xA6","\\\xA6")):o.push(n.code.value.replace("\xA6","\\\xA6")):o.push(R),n.severity!==void 0&&n.severity!==null?o.push(k.toString(n.severity)):o.push(R),n.message&&f?o.push(n.message.replace("\xA6","\\\xA6")):o.push(R),n.startLineNumber!==void 0&&n.startLineNumber!==null?o.push(n.startLineNumber.toString()):o.push(R),n.startColumn!==void 0&&n.startColumn!==null?o.push(n.startColumn.toString()):o.push(R),n.endLineNumber!==void 0&&n.endLineNumber!==null?o.push(n.endLineNumber.toString()):o.push(R),n.endColumn!==void 0&&n.endColumn!==null?o.push(n.endColumn.toString()):o.push(R),o.push(R),o.join("\xA6")}C.makeKeyOptionalMessage=_})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,w.createDecorator)("markerService")}),define(Ee[138],ye([0,1,4,34,3]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,w.createDecorator)("notificationService");var T;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var k;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(k=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new C,this.onDidClose=a.Event.None,this.onDidChangeVisibility=a.Event.None}updateSeverity(F){}updateMessage(F){}updateActions(F){}close(){}}e.NoOpNotification=P;class C{infinite(){}done(){}total(F){}worked(F){}}e.NoOpProgress=C}),define(Ee[139],ye([0,1,6,9,2,3]),function(re,e,a,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,T.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return a.Disposable.None},registerValidator(){return a.Disposable.None},registerExternalUriResolver(){return a.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return a.Disposable.None},async open(){return!1},async resolveExternalUri(C){return{resolved:C,dispose(){}}}});function k(C,R){return w.URI.isUri(C)?(0,t.equalsIgnoreCase)(C.scheme,R):(0,t.startsWithIgnoreCase)(C,R+":")}e.matchesScheme=k;function P(C,...R){return R.some(F=>k(C,F))}e.matchesSomeScheme=P});var Ue=this&&this.__decorate||function(re,e,a,t){var w=arguments.length,T=w<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,a):t,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(re,e,a,t);else for(var P=re.length-1;P>=0;P--)(k=re[P])&&(T=(w<3?k(T):w>3?k(e,a,T):k(e,a))||T);return w>3&&T&&Object.defineProperty(e,a,T),T},$e=this&&this.__param||function(re,e){return function(a,t){e(a,t,re)}};define(Ee[140],ye([0,1,14,20,6,3]),function(re,e,a,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,T.createDecorator)("progressService");var k;(function(F){F[F.Explorer=1]="Explorer",F[F.Scm=3]="Scm",F[F.Extensions=5]="Extensions",F[F.Window=10]="Window",F[F.Notification=15]="Notification",F[F.Dialog=20]="Dialog"})(k=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{constructor(_){this.callback=_}get value(){return this._value}report(_){this._value=_,this.callback(this._value)}}e.Progress=P,P.None=Object.freeze({report(){}});let C=class extends w.Disposable{constructor(_,n){super();this.deferred=new a.DeferredPromise,n.withProgress(_,f=>(this.reporter=f,this.lastStep&&f.report(this.lastStep),this.deferred.p)),this._register((0,w.toDisposable)(()=>this.deferred.complete()))}report(_){this.reporter?this.reporter.report(_):this.lastStep=_}};C=Ue([$e(1,e.IProgressService)],C),e.UnmanagedProgress=C;class R extends w.Disposable{constructor(_){super();this.progressIndicator=_,this.currentOperationId=0,this.currentOperationDisposables=this._register(new w.DisposableStore)}start(_){this.stop();const n=++this.currentOperationId,f=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{n===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},_),this.currentOperationDisposables.add((0,w.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,w.toDisposable)(()=>f.cancel())),this.currentOperationDisposables.add((0,w.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:n,token:f.token,stop:()=>this.doStop(n),isCurrent:()=>this.currentOperationId===n}}stop(){this.doStop(this.currentOperationId)}doStop(_){this.currentOperationId===_&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=R,e.IEditorProgressService=(0,T.createDecorator)("editorProgressService")}),define(Ee[36],ye([0,1,41,11]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class w{constructor(){this.data=new Map}add(k,P){a.ok(t.isString(k)),a.ok(t.isObject(P)),a.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,P)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new w}),define(Ee[141],ye([0,1,4,36]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function w(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class T{constructor(){this._onDidChangeSchema=new a.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(C,R){this.schemasById[w(C)]=R,this._onDidChangeSchema.fire(C)}notifySchemaChanged(C){this._onDidChangeSchema.fire(C)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new T;t.Registry.add(e.Extensions.JSONContribution,k)}),define(Ee[83],ye([0,1,16,4,11,115,141,36]),function(re,e,a,t,w,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const F=P.Registry.as(k.Extensions.JSONContribution);class _{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(I,l=!0){this.registerConfigurations([I],l)}registerConfigurations(I,l=!0){const M=this.doRegisterConfigurations(I,l);F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:M})}deregisterConfigurations(I){const l=this.doDeregisterConfigurations(I);F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}updateConfigurations({add:I,remove:l}){const M=[];M.push(...this.doDeregisterConfigurations(l)),M.push(...this.doRegisterConfigurations(I,!1)),F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,a.distinct)(M)})}registerDefaultConfigurations(I){const l=[],M=[];for(const{overrides:r,source:i}of I)for(const m in r)if(l.push(m),e.OVERRIDE_PROPERTY_REGEX.test(m)){const d={...this.configurationDefaultsOverrides.get(m)?.value||{},...r[m]};this.configurationDefaultsOverrides.set(m,{source:i,value:d});const s={type:"object",default:d,description:T.localize(1,null,m),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:d,source:w.isString(i)?void 0:i};M.push(...o(m)),this.configurationProperties[m]=s,this.defaultLanguageConfigurationOverridesNode.properties[m]=s}else{this.configurationDefaultsOverrides.set(m,{value:r[m],source:i});const d=this.configurationProperties[m];d&&(this.updatePropertyDefaultValue(m,d),this.updateSchema(m,d))}this.registerOverrideIdentifiers(M),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}deregisterDefaultConfigurations(I){const l=[];for(const{overrides:M,source:r}of I)for(const i in M){const m=this.configurationDefaultsOverrides.get(i),d=w.isString(r)?r:r?.id,s=w.isString(m?.source)?m?.source:m?.source?.id;if(d===s)if(l.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const b=this.configurationProperties[i];b&&(this.updatePropertyDefaultValue(i,b),this.updateSchema(i,b))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...I){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(I){for(const l of I)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(I,l){const M=[];return I.forEach(r=>{M.push(...this.validateAndRegisterProperties(r,l,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),M}doDeregisterConfigurations(I){const l=[],M=r=>{if(r.properties)for(const i in r.properties)l.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,r.properties[i]);r.allOf&&r.allOf.forEach(i=>M(i))};for(const r of I){M(r);const i=this.configurationContributors.indexOf(r);i!==-1&&this.configurationContributors.splice(i,1)}return l}validateAndRegisterProperties(I,l=!0,M,r,i=3){i=w.isUndefinedOrNull(I.scope)?i:I.scope;let m=[],d=I.properties;if(d)for(let b in d){if(l&&v(b)){delete d[b];continue}const y=d[b];if(y.source=M,y.defaultDefaultValue=d[b].default,this.updatePropertyDefaultValue(b,y),e.OVERRIDE_PROPERTY_REGEX.test(b)?y.scope=void 0:(y.scope=w.isUndefinedOrNull(y.scope)?i:y.scope,y.restricted=w.isUndefinedOrNull(y.restricted)?!!r?.includes(b):y.restricted),d[b].hasOwnProperty("included")&&!d[b].included){this.excludedConfigurationProperties[b]=d[b],delete d[b];continue}else this.configurationProperties[b]=d[b];!d[b].deprecationMessage&&d[b].markdownDeprecationMessage&&(d[b].deprecationMessage=d[b].markdownDeprecationMessage),m.push(b)}let s=I.allOf;if(s)for(let b of s)m.push(...this.validateAndRegisterProperties(b,l,M,r,i));return m}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(I){const l=M=>{let r=M.properties;if(r)for(const m in r)this.updateSchema(m,r[m]);let i=M.allOf;i&&i.forEach(l)};l(I)}updateSchema(I,l){switch(e.allSettings.properties[I]=l,l.scope){case 1:e.applicationSettings.properties[I]=l;break;case 2:e.machineSettings.properties[I]=l;break;case 6:e.machineOverridableSettings.properties[I]=l;break;case 3:e.windowSettings.properties[I]=l;break;case 4:e.resourceSettings.properties[I]=l;break;case 5:e.resourceSettings.properties[I]=l,this.resourceLanguageSettingsSchema.properties[I]=l;break}}removeFromSchema(I,l){switch(delete e.allSettings.properties[I],l.scope){case 1:delete e.applicationSettings.properties[I];break;case 2:delete e.machineSettings.properties[I];break;case 6:delete e.machineOverridableSettings.properties[I];break;case 3:delete e.windowSettings.properties[I];break;case 4:case 5:delete e.resourceSettings.properties[I],delete this.resourceLanguageSettingsSchema.properties[I];break}}updateOverridePropertyPatternKey(){for(const I of this.overrideIdentifiers.values()){const l=`[${I}]`,M={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,M),e.allSettings.properties[l]=M,e.applicationSettings.properties[l]=M,e.machineSettings.properties[l]=M,e.machineOverridableSettings.properties[l]=M,e.windowSettings.properties[l]=M,e.resourceSettings.properties[l]=M}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const I={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=I,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=I,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=I,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=I,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=I,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=I,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(I,l){const M=this.configurationDefaultsOverrides.get(I);let r=M?.value,i=M?.source;w.isUndefined(r)&&(r=l.defaultDefaultValue,i=void 0),w.isUndefined(r)&&(r=c(l.type)),l.default=r,l.defaultValueSource=i}}const n="\\[([^\\]]+)\\]",f=new RegExp(n,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${n})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function o(p){const I=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let l=f.exec(p);for(;l?.length;){const M=l[1].trim();M&&I.push(M),l=f.exec(p)}}return(0,a.distinct)(I)}e.overrideIdentifiersFromKey=o;function g(p){return p.reduce((I,l)=>`${I}[${l}]`,"")}e.keyFromOverrideIdentifiers=g;function c(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=c;const D=new _;P.Registry.add(e.Extensions.Configuration,D);function v(p){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?T.localize(7,null,p):D.getConfigurationProperties()[p]!==void 0?T.localize(8,null,p):null:T.localize(6,null)}e.validateProperty=v;function h(){const p=[],I=D.getConfigurationProperties();for(const l of Object.keys(I))p.push([l,I[l].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=h}),define(Ee[142],ye([0,1,16,4,100,6,21,26,11,2,81,83,36]),function(re,e,a,t,w,T,k,P,C,R,F,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(r={},i=[],m=[]){this._contents=r,this._keys=i,this._overrides=m,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,F.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,i){const m=this.getContentsForOverrideIdentifer(i);return m?r?(0,F.getConfigurationValue)(m,r):m:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const m of this.overrides)m.identifiers.includes(r)&&i.push(...m.keys);return a.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return a.distinct(r)}override(r){let i=this.overrideConfigurations.get(r);return i||(i=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,i)),i}merge(...r){const i=P.deepClone(this.contents),m=P.deepClone(this.overrides),d=[...this.keys];for(const s of r){this.mergeContents(i,s.contents);for(const b of s.overrides){const[y]=m.filter(u=>a.equals(u.identifiers,b.identifiers));y?(this.mergeContents(y.contents,b.contents),y.keys.push(...b.keys),y.keys=a.distinct(y.keys)):m.push(P.deepClone(b))}for(const b of s.keys)d.indexOf(b)===-1&&d.push(b)}return new f(i,d,m)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const i=this.getContentsForOverrideIdentifer(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let m={};for(const d of a.distinct([...Object.keys(this.contents),...Object.keys(i)])){let s=this.contents[d],b=i[d];b&&(typeof s=="object"&&typeof b=="object"?(s=P.deepClone(s),this.mergeContents(s,b)):s=b),m[d]=s}return new f(m,this.keys,this.overrides)}mergeContents(r,i){for(const m of Object.keys(i)){if(m in r&&C.isObject(r[m])&&C.isObject(i[m])){this.mergeContents(r[m],i[m]);continue}r[m]=P.deepClone(i[m])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?P.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let i=null,m=null;const d=s=>{s&&(m?this.mergeContents(m,s):m=P.deepClone(s))};for(const s of this.overrides)a.equals(s.identifiers,[r])?i=s.contents:s.identifiers.includes(r)&&d(s.contents);return d(i),m}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.addKey(r),(0,F.addToValueTree)(this.contents,r,i,m=>{throw new Error(m)})}removeValue(r){this.removeKey(r)&&(0,F.removeFromValueTree)(this.contents,r)}addKey(r){let i=this.keys.length;for(let m=0;m<i;m++)r.indexOf(this.keys[m])===0&&(i=m);this.keys.splice(i,1,r)}removeKey(r){let i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=f;class o extends f{constructor(r={}){const i=n.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),m=Object.keys(i),d=Object.create(null),s=[];for(const b in i){const y=r[b],u=y!==void 0?y:i[b].default;(0,F.addToValueTree)(d,b,u,S=>console.error(`Conflict in default settings: ${S}`))}for(const b of Object.keys(d))_.OVERRIDE_PROPERTY_REGEX.test(b)&&s.push({identifiers:(0,_.overrideIdentifiersFromKey)(b),keys:Object.keys(d[b]),contents:(0,F.toValuesTree)(d[b],y=>console.error(`Conflict in default settings file: ${y}`))});super(d,m,s)}}e.DefaultConfigurationModel=o;class g{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,i){if(!C.isUndefinedOrNull(r)){const m=this.doParseContent(r);this.parseRaw(m,i)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,i){this._raw=r;const{contents:m,keys:d,overrides:s,restricted:b}=this.doParseRaw(r,i);this._configurationModel=new f(m,d,s),this._restrictedConfigurations=b||[]}doParseContent(r){let i={},m=null,d=[],s=[],b=[];function y(S){Array.isArray(d)?d.push(S):m!==null&&(d[m]=S)}let u={onObjectBegin:()=>{let S={};y(S),s.push(d),d=S,m=null},onObjectProperty:S=>{m=S},onObjectEnd:()=>{d=s.pop()},onArrayBegin:()=>{let S=[];y(S),s.push(d),d=S,m=null},onArrayEnd:()=>{d=s.pop()},onLiteralValue:y,onError:(S,A,U)=>{b.push({error:S,offset:A,length:U})}};if(r)try{w.visit(r,u),i=d[0]||{}}catch(S){console.error(`Error while parsing settings file ${this._name}: ${S}`),this._parseErrors=[S]}return i}doParseRaw(r,i){const m=n.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),d=this.filter(r,m,!0,i);r=d.raw;const s=(0,F.toValuesTree)(r,u=>console.error(`Conflict in settings file ${this._name}: ${u}`)),b=Object.keys(r),y=this.toOverrides(r,u=>console.error(`Conflict in settings file ${this._name}: ${u}`));return{contents:s,keys:b,overrides:y,restricted:d.restricted}}filter(r,i,m,d){if(!d?.scopes&&!d?.skipRestricted)return{raw:r,restricted:[]};const s={},b=[];for(let y in r)if(_.OVERRIDE_PROPERTY_REGEX.test(y)&&m){const u=this.filter(r[y],i,!1,d);s[y]=u.raw,b.push(...u.restricted)}else{const u=i[y],S=u?typeof u.scope!="undefined"?u.scope:3:void 0;u?.restricted&&b.push(y),(S===void 0||d.scopes===void 0||d.scopes.includes(S))&&(d.skipRestricted&&u?.restricted||(s[y]=r[y]))}return{raw:s,restricted:b}}toOverrides(r,i){const m=[];for(const d of Object.keys(r))if(_.OVERRIDE_PROPERTY_REGEX.test(d)){const s={};for(const b in r[d])s[b]=r[d][b];m.push({identifiers:(0,_.overrideIdentifiersFromKey)(d),keys:Object.keys(s),contents:(0,F.toValuesTree)(s,i)})}return m}}e.ConfigurationModelParser=g;class c extends T.Disposable{constructor(r,i,m,d){super();this.userSettingsResource=r,this.scopes=i,this.fileService=d,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(m.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new f}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=c;class D{constructor(r,i,m=new f,d=new f,s=new k.ResourceMap,b=new f,y=new k.ResourceMap,u=!0){this._defaultConfiguration=r,this._localUserConfiguration=i,this._remoteUserConfiguration=m,this._workspaceConfiguration=d,this._folderConfigurations=s,this._memoryConfiguration=b,this._memoryConfigurationByResource=y,this._freeze=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(r,i,m){return this.getConsolidateConfigurationModel(i,m).getValue(r)}updateValue(r,i,m={}){let d;m.resource?(d=this._memoryConfigurationByResource.get(m.resource),d||(d=new f,this._memoryConfigurationByResource.set(m.resource,d))):d=this._memoryConfiguration,i===void 0?d.removeValue(r):d.setValue(r,i),m.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,i,m){const d=this.getConsolidateConfigurationModel(i,m),s=this.getFolderConfigurationModelForResource(i.resource,m),b=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,y=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),u=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),S=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),A=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),U=m?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,H=s?i.overrideIdentifier?s.freeze().override(i.overrideIdentifier).getValue(r):s.freeze().getValue(r):void 0,E=i.overrideIdentifier?b.override(i.overrideIdentifier).getValue(r):b.getValue(r),L=d.getValue(r),z=a.distinct(a.flatten(d.overrides.map(N=>N.identifiers))).filter(N=>d.getOverrideValue(r,N)!==void 0);return{defaultValue:y,userValue:u,userLocalValue:S,userRemoteValue:A,workspaceValue:U,workspaceFolderValue:H,memoryValue:E,value:L,default:y!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,user:u!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userLocal:S!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspace:U!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspaceFolder:H!==void 0?{value:s?.freeze().getValue(r),override:i.overrideIdentifier?s?.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,memory:E!==void 0?{value:b.getValue(r),override:i.overrideIdentifier?b.getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:z.length?z:void 0}}keys(r){const i=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,i){this._folderConfigurations.set(r,i),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const m=[];if(!i){const{added:d,updated:s,removed:b}=I(this._defaultConfiguration,r);i=[...d,...s,...b]}for(const d of i)for(const s of(0,_.overrideIdentifiersFromKey)(d)){const b=this._defaultConfiguration.getKeysForOverrideIdentifier(s),y=r.getKeysForOverrideIdentifier(s),u=[...y.filter(S=>b.indexOf(S)===-1),...b.filter(S=>y.indexOf(S)===-1),...b.filter(S=>!P.equals(this._defaultConfiguration.override(s).getValue(S),r.override(s).getValue(S)))];m.push([s,u])}return this.updateDefaultConfiguration(r),{keys:i,overrides:m}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:m,removed:d,overrides:s}=I(this.localUserConfiguration,r),b=[...i,...m,...d];return b.length&&this.updateLocalUserConfiguration(r),{keys:b,overrides:s}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:m,removed:d,overrides:s}=I(this.remoteUserConfiguration,r);let b=[...i,...m,...d];return b.length&&this.updateRemoteUserConfiguration(r),{keys:b,overrides:s}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:m,removed:d,overrides:s}=I(this.workspaceConfiguration,r);let b=[...i,...m,...d];return b.length&&this.updateWorkspaceConfiguration(r),{keys:b,overrides:s}}compareAndUpdateFolderConfiguration(r,i){const m=this.folderConfigurations.get(r),{added:d,updated:s,removed:b,overrides:y}=I(m,i);let u=[...d,...s,...b];return(u.length||!m)&&this.updateFolderConfiguration(r,i),{keys:u,overrides:y}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:m,updated:d,removed:s,overrides:b}=I(i,void 0);return{keys:[...m,...d,...s],overrides:b}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,i){let m=this.getConsolidatedConfigurationModelForResource(r,i);return r.overrideIdentifier?m.override(r.overrideIdentifier):m}getConsolidatedConfigurationModelForResource({resource:r},i){let m=this.getWorkspaceConsolidatedConfiguration();if(i&&r){const d=i.getFolder(r);d&&(m=this.getFolderConsolidatedConfiguration(d.uri)||m);const s=this._memoryConfigurationByResource.get(r);s&&(m=m.merge(s))}return m}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let i=this._foldersConsolidatedConfigurations.get(r);if(!i){const m=this.getWorkspaceConsolidatedConfiguration(),d=this._folderConfigurations.get(r);d?(i=m.merge(d),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(r,i)):i=m}return i}getFolderConfigurationModelForResource(r,i){if(i&&r){const m=i.getFolder(r);if(m)return this._folderConfigurations.get(m.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,i)=>{const{contents:m,overrides:d,keys:s}=this._folderConfigurations.get(i);return r.push([i,{contents:m,overrides:d,keys:s}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(m=>r.add(m))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(m=>r.add(m))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(m=>i.add(m)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(m=>i.add(m)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(m=>i.add(m)),this._folderConfigurations.forEach(m=>m.getKeysForOverrideIdentifier(r).forEach(d=>i.add(d))),[...i.values()]}static parse(r){const i=this.parseConfigurationModel(r.defaults),m=this.parseConfigurationModel(r.user),d=this.parseConfigurationModel(r.workspace),s=r.folders.reduce((b,y)=>(b.set(R.URI.revive(y[0]),this.parseConfigurationModel(y[1])),b),new k.ResourceMap);return new D(i,m,new f,d,s,new f,new k.ResourceMap,!1)}static parseConfigurationModel(r){return new f(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=D;function v(...M){if(M.length===0)return{keys:[],overrides:[]};if(M.length===1)return M[0];const r=new Set,i=new Map;for(const d of M)d.keys.forEach(s=>r.add(s)),d.overrides.forEach(([s,b])=>{const y=(0,k.getOrSet)(i,s,new Set);b.forEach(u=>y.add(u))});const m=[];return i.forEach((d,s)=>m.push([s,[...d.values()]])),{keys:[...r.values()],overrides:m}}e.mergeChanges=v;class h{constructor(r,i,m,d){this.change=r,this.previous=i,this.currentConfiguraiton=m,this.currentWorkspace=d,this._previousConfiguration=void 0;const s=new Set;r.keys.forEach(y=>s.add(y)),r.overrides.forEach(([,y])=>y.forEach(u=>s.add(u))),this.affectedKeys=[...s.values()];const b=new f;this.affectedKeys.forEach(y=>b.setValue(y,{})),this.affectedKeysTree=b.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=D.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(i){const m=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.previous?.workspace):void 0,d=this.currentConfiguraiton.getValue(r,i,this.currentWorkspace);return!P.equals(m,d)}return!0}return!1}doesAffectedKeysTreeContains(r,i){let m=(0,F.toValuesTree)({[i]:!0},()=>{}),d;for(;typeof m=="object"&&(d=Object.keys(m)[0]);){if(r=r[d],!r)return!1;m=m[d]}return!0}}e.ConfigurationChangeEvent=h;class p extends h{constructor(r,i,m,d){super({keys:r.allKeys(),overrides:[]},void 0,r,i);this.source=m,this.sourceConfig=d}}e.AllKeysConfigurationChangeEvent=p;function I(M,r){const{added:i,removed:m,updated:d}=l(r,M),s=[],b=M?.getAllOverrideIdentifiers()||[],y=r?.getAllOverrideIdentifiers()||[];if(r){const u=y.filter(S=>!b.includes(S));for(const S of u)s.push([S,r.getKeysForOverrideIdentifier(S)])}if(M){const u=b.filter(S=>!y.includes(S));for(const S of u)s.push([S,M.getKeysForOverrideIdentifier(S)])}if(r&&M){for(const u of b)if(y.includes(u)){const S=l({contents:M.getOverrideValue(void 0,u)||{},keys:M.getKeysForOverrideIdentifier(u)},{contents:r.getOverrideValue(void 0,u)||{},keys:r.getKeysForOverrideIdentifier(u)});s.push([u,[...S.added,...S.removed,...S.updated]])}}return{added:i,removed:m,updated:d,overrides:s}}function l(M,r){const i=M?r?M.keys.filter(s=>r.keys.indexOf(s)===-1):[...M.keys]:[],m=r?M?r.keys.filter(s=>M.keys.indexOf(s)===-1):[...r.keys]:[],d=[];if(M&&r){for(const s of r.keys)if(M.keys.indexOf(s)!==-1){const b=(0,F.getConfigurationValue)(r.contents,s),y=(0,F.getConfigurationValue)(M.contents,s);P.equals(b,y)||d.push(s)}}return{added:i,removed:m,updated:d}}}),define(Ee[84],ye([0,1,3]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,a.createDecorator)("remoteAuthorityResolverService");var t;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(t=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class w extends Error{constructor(k,P=t.Unknown,C){super(k);this._message=k,this._code=P,this._detail=C,this.isHandled=P===t.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,w.prototype)}static isTemporarilyNotAvailable(k){return k instanceof w&&k._code===t.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof w&&k._code===t.NoResolverFound}static isHandled(k){return k instanceof w&&k.isHandled}}e.RemoteAuthorityResolverError=w}),define(Ee[61],ye([0,1,10]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function t(R){return R.scheme===a.Schemas.vscodeRemote?R.authority:void 0}e.getRemoteAuthority=t;function w(R){if(!R)return;const F=R.indexOf("+");return F<0?R:R.substr(0,F)}e.getRemoteName=w;function T(R){return R.scheme!==a.Schemas.file&&R.scheme!==a.Schemas.vscodeRemote}e.isVirtualResource=T;function k(R){if(R.folders.length)return R.folders.every(F=>T(F.uri))?R.folders[0].uri:void 0;if(R.configuration&&T(R.configuration))return R.configuration}e.getVirtualWorkspaceLocation=k;function P(R){return k(R)?.scheme}e.getVirtualWorkspaceScheme=P;function C(R){return k(R)!==void 0}e.isVirtualWorkspace=C}),define(Ee[25],ye([0,1,9,3,61]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=T;function k(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));class C{constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,o){if(typeof f=="undefined"||f===null)return typeof o=="undefined"||o===null;if(typeof o=="undefined"||o===null)return!1;if(typeof f=="string"||typeof o=="string"){let g=typeof f=="string"?f:f.value,c=typeof o=="string"?o:o.value;return a.equalsIgnoreCase(g,c)}return f._lower===o._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.ExtensionIdentifier=C;function R(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=R;function F(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=F;function _(n,f){if(f){const o=`onResolveRemoteAuthority:${(0,w.getRemoteName)(f)}`;return n.activationEvents?.indexOf(o)!==-1}return!1}e.isResolverExtension=_,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ee[143],ye([0,1,9,25]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function w(o,g){return o.uuid&&g.uuid?o.uuid===g.uuid:o.id===g.id?!0:(0,a.compareIgnoreCase)(o.id,g.id)===0}e.areSameExtensions=w;class T{constructor(g,c){this.version=c,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof T?w(this,g)&&this.version===g.version:!1}}e.ExtensionIdentifierWithVersion=T;function k(o,g){return`${o}.${g}`}e.getExtensionId=k;function P(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function C(o,g){return P(k(o,g))}e.getGalleryExtensionId=C;function R(o,g){const c=[],D=v=>{for(const h of c)if(h.some(p=>w(g(p),g(v))))return h;return null};for(const v of o){const h=D(v);h?h.push(v):c.push([v])}return c}e.groupByExtension=R;function F(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=F;function _(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),...o.telemetryData}}e.getGalleryExtensionTelemetryData=_,e.BetterMergeId=new t.ExtensionIdentifier("pprice.better-merge");function n(o){const g=new Set;if(o.malicious)for(const c of o.malicious)g.add(c.id);return g}e.getMaliciousExtensionsSet=n;function f(o,g){const c=[],D=g.manifest.extensionDependencies?.slice(0)??[];for(;D.length;){const v=D.shift();if(v&&c.every(h=>!w(h.identifier,{id:v}))){const h=o.filter(p=>w(p.identifier,{id:v}));h.length===1&&(c.push(h[0]),D.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}e.getExtensionDependencies=f}),define(Ee[144],ye([0,1,4,23,3,12]),function(re,e,a,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,w.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,w.createDecorator)("sharedTunnelsService");var k;(function(o){o.Http="http",o.Https="https"})(k=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var C;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function R(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(!!g)return{address:g[1],port:+g[2]}}e.extractLocalHostUriMetaDataForPortMapping=R,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function F(o){return e.LOCALHOST_ADDRESSES.indexOf(o)>=0}e.isLocalhost=F,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function _(o){return e.ALL_INTERFACES_ADDRESSES.indexOf(o)>=0}e.isAllInterfaces=_;function n(o,g){return g?g!==1&&o<1024:!t.isWindows&&o<1024}e.isPortPrivileged=n;let f=class{constructor(g){this.logService=g,this._onTunnelOpened=new a.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new a.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new a.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(g,c){return this._tunnelProvider=g,g?(this._canElevate=c.elevation,this._privacyOptions=c.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const g=[],c=Array.from(this._tunnels.values());for(let D of c){const v=Array.from(D.values());for(let h of v){const p=await h.value;p&&g.push(p)}}return g}async dispose(){for(const g of this._tunnels.values()){for(const{value:c}of g.values())await c.then(D=>D?.dispose());g.clear()}this._tunnels.clear()}openTunnel(g,c,D,v,h=!1,p=P.Private,I){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${D} on local port ${v}.`),!g)return;c||(c="localhost");const l=this.retainOrCreateTunnel(g,c,D,v,h,p,I);return l?l.then(M=>{if(!M){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(c,D);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(M);return(M.tunnelRemoteHost!==c||M.tunnelRemotePort!==D)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}makeTunnel(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const c=this._tunnels.get(g.tunnelRemoteHost);if(c){const D=c.get(g.tunnelRemotePort);D&&(D.refcount--,await this.tryDisposeTunnel(g.tunnelRemoteHost,g.tunnelRemotePort,D))}}}}async tryDisposeTunnel(g,c,D){if(D.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${c}.`);const v=D.value.then(async h=>{h&&(await h.dispose(!0),this._onTunnelClosed.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this._tunnels.has(g)&&this._tunnels.get(g).delete(c),v}}async closeTunnel(g,c){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${c} `);const D=this._tunnels.get(g);if(D&&D.has(c)){const v=D.get(c);v.refcount=0,await this.tryDisposeTunnel(g,c,v)}}addTunnelToMap(g,c,D){this._tunnels.has(g)||this._tunnels.set(g,new Map),this._tunnels.get(g).set(c,{refcount:1,value:D})}async removeEmptyTunnelFromMap(g,c){const D=this._tunnels.get(g);D&&(await D.get(c)||D.delete(c),D.size===0&&this._tunnels.delete(g))}getTunnelFromMap(g,c){let D=[g];F(g)?(D.push(...e.LOCALHOST_ADDRESSES),D.push(...e.ALL_INTERFACES_ADDRESSES)):_(g)&&D.push(...e.ALL_INTERFACES_ADDRESSES);const v=D.map(h=>this._tunnels.get(h));for(const h of v){const p=h?.get(c);if(p)return p}}canTunnel(g){return!!R(g)}createWithProvider(g,c,D,v,h,p,I){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${D} on local port ${v}.`);const M={elevationRequired:h?n(v===void 0?D:v):!1},r={remoteAddress:{host:c,port:D},localAddressPort:v,privacy:p,public:p!==P.Private,protocol:I},i=g.forwardPort(r,M);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(c,D,i),i}};f=Ue([$e(0,T.ILogService)],f),e.AbstractTunnelService=f}),define(Ee[145],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class a{constructor(w){this._callback=w,this._terminalBufferMap=new Map}dispose(){for(const w of this._terminalBufferMap.values())w.dispose()}startBuffering(w,T,k=5){let P;return P=T(C=>{const R=typeof C=="string"?C:C.data;let F=this._terminalBufferMap.get(w);if(F){F.data.push(R);return}const _=setTimeout(()=>this.flushBuffer(w),k);F={data:[R],timeoutId:_,dispose:()=>{clearTimeout(_),this.flushBuffer(w),P.dispose()}},this._terminalBufferMap.set(w,F)}),P}stopBuffering(w){const T=this._terminalBufferMap.get(w);T&&T.dispose()}flushBuffer(w){const T=this._terminalBufferMap.get(w);T&&(this._terminalBufferMap.delete(w),this._callback(w,T.data.join("")))}}e.TerminalDataBufferer=a}),define(Ee[146],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var a;(function(t){t.DARK="dark",t.LIGHT="light",t.HIGH_CONTRAST="hc"})(a=e.ColorScheme||(e.ColorScheme={}))}),define(Ee[62],ye([0,1,51,4,6,3,36,146]),function(re,e,a,t,w,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var C;(function(c){function D(v){return v&&typeof v=="object"&&typeof v.id=="string"}c.isThemeColor=D})(C=e.ThemeColor||(e.ThemeColor={}));function R(c){return{id:c}}e.themeColorFromId=R;var F;(function(c){function D(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||C.isThemeColor(i.color))}c.isThemeIcon=D;const v=new RegExp(`^\\$\\((${a.CSSIcon.iconNameExpression}(?:${a.CSSIcon.iconModifierExpression})?)\\)$`);function h(i){const m=v.exec(i);if(!m)return;let[,d]=m;return{id:d}}c.fromString=h;function p(i){return{id:i}}c.fromId=p;function I(i,m){let d=i.id;const s=d.lastIndexOf("~");return s!==-1&&(d=d.substring(0,s)),m&&(d=`${d}~${m}`),{id:d}}c.modify=I;function l(i){const m=i.id.lastIndexOf("~");if(m!==-1)return i.id.substring(m+1)}c.getModifier=l;function M(i,m){return i.id===m.id&&i.color?.id===m.color?.id}c.isEqual=M;function r(i,m){return{id:i.id,color:m?R(m):void 0}}c.asThemeIcon=r,c.asClassNameArray=a.CSSIcon.asClassNameArray,c.asClassName=a.CSSIcon.asClassName,c.asCSSSelector=a.CSSIcon.asCSSSelector})(F=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=a.Codicon.file,e.FolderThemeIcon=a.Codicon.folder;function _(c){switch(c){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=_,e.Extensions={ThemingContribution:"base.contributions.theming"};class n{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(D){return this.themingParticipants.push(D),this.onThemingParticipantAddedEmitter.fire(D),(0,w.toDisposable)(()=>{const v=this.themingParticipants.indexOf(D);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let f=new n;k.Registry.add(e.Extensions.ThemingContribution,f);function o(c){return f.onColorThemeChange(c)}e.registerThemingParticipant=o;class g extends w.Disposable{constructor(D){super();this.themeService=D,this.theme=D.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(D){this.theme=D,this.updateStyles()}updateStyles(){}getColor(D,v){let h=this.theme.getColor(D);return h&&v&&(h=v(h,this.theme)),h?h.toString():null}}e.Themable=g}),define(Ee[46],ye([0,1,21,24,2,3]),function(re,e,a,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");var k;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(k=e.WorkbenchState||(e.WorkbenchState={}));function P(n){const f=n;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=P;function C(n){const f=n;return!!(f&&typeof f=="object"&&w.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=C;class R{constructor(f,o,g,c,D){this._id=f,this._transient=g,this._configuration=c,this._ignorePathCasing=D,this._foldersMap=a.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=o}update(f){this._id=f.id,this._configuration=f.configuration,this._transient=f.transient,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=a.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=R;class F{constructor(f,o){this.raw=o,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,t.joinPath)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=F;function _(n){return new F({uri:n,index:0,name:(0,t.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=_}),define(Ee[63],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class a{constructor(w){this.id=w,this._data=new Map,this._idPool=1}add(w){const T=this._idPool++;return this._data.set(T,w),this.logDebugInfo(),T}get(w,T){return this._data.has(w)?this._data.get(w)[T]:void 0}delete(w){this._data.delete(w),this.logDebugInfo()}logDebugInfo(){!a.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=a,a.enableDebugLogging=!1}),define(Ee[30],ye([0,1,10,24,3]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class T{constructor(){this._systemSchemes=new Set(Object.keys(a.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(P=>{const C=this._providerInfo.get(P.scheme);return!(C===void 0||C&1024)})}$acceptProviderInfos(P,C){C===null?this._providerInfo.delete(P.scheme):this._providerInfo.set(P.scheme,C)}isFreeScheme(P){return!this._providerInfo.has(P)&&!this._systemSchemes.has(P)}getCapabilities(P){return this._providerInfo.get(P)}}e.ExtHostFileSystemInfo=T,e.IExtHostFileSystemInfo=(0,w.createDecorator)("IExtHostFileSystemInfo")}),define(Ee[28],ye([0,1,3]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,a.createDecorator)("IExtHostInitDataService")}),define(Ee[147],ye([0,1,14]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(k,P,C){this._deferredPromises=new Map,this._id=k,this._shared=P,this._storage=C,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(R=>(this._value=R,this)),this._storageListener=this._storage.onDidChangeStorage(R=>{R.shared===this._shared&&R.key===this._id&&(this._value=R.value)}),this._scheduler=new a.RunOnceScheduler(()=>{const R=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const F of R.values())F.complete()}catch(F){for(const _ of R.values())_.error(F)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,k])=>k!==void 0).map(([k])=>k)}get whenReady(){return this._init}get(k,P){let C=this._value[k];return typeof C=="undefined"&&(C=P),C}update(k,P){this._value[k]=P;let C=this._deferredPromises.get(k);if(C!==void 0)return C.p;const R=new a.DeferredPromise;return this._deferredPromises.set(k,R),this._scheduler.isScheduled()||this._scheduler.schedule(),R.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class w extends t{constructor(k,P){super(k.identifier.value,!0,P);this._extension=k}setKeysForSync(k){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},k)}}e.ExtensionGlobalMemento=w}),define(Ee[148],ye([0,1,4,2,12]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let T=class{constructor(P,C){this._logService=P,this._notebooksAndEditors=C,this._onDidChangeNotebookDocumentMetadata=new a.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new a.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(P,C,R){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(P)).acceptModelChanged(C.value,R)}$acceptDirtyStateChanged(P,C){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(P)).acceptDirty(C)}$acceptModelSaved(P){const C=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(P));this._onDidSaveNotebookDocument.fire(C.apiNotebook)}$acceptDocumentPropertiesChanged(P,C){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",P.path,C);const R=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(P));R.acceptDocumentPropertiesChanged(C),C.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:R.apiNotebook})}};T=Ue([$e(0,w.ILogService)],T),e.ExtHostNotebookDocuments=T}),define(Ee[13],ye([0,1,3]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,a.createDecorator)("IExtHostRpcService");class t{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=t});var Ze=this&&this.__classPrivateFieldSet||function(re,e,a,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(re,a):w?w.value=a:e.set(re,a),a},Te=this&&this.__classPrivateFieldGet||function(re,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!t:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(re):t?t.value:e.get(re)};define(Ee[149],ye([0,1,25,4]),function(re,e,a,t){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(P,C){w.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=a.ExtensionIdentifier.toKey(P.identifier),Ze(this,w,C,"f"),Te(this,w,"f").onDidChangePassword(R=>{R.extensionId===this._id&&this._onDidChange.fire({key:R.key})})}get(P){return Te(this,w,"f").get(this._id,P)}store(P,C){return Te(this,w,"f").store(this._id,P,C)}delete(P){return Te(this,w,"f").delete(this._id,P)}}e.ExtensionSecrets=T,w=new WeakMap}),define(Ee[85],ye([0,1,3,4]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class w{constructor(){this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(k){this._enabled=k}$onDidChangeTelemetryEnabled(k){this._enabled=k,this._onDidChangeTelemetryEnabled.fire(k)}}e.ExtHostTelemetry=w,e.IExtHostTelemetry=(0,a.createDecorator)("IExtHostTelemetry")}),define(Ee[47],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var a;(function(v){v[v.Upsert=0]="Upsert",v[v.RemoveChild=1]="RemoveChild",v[v.Invalidated=2]="Invalidated",v[v.SetProp=3]="SetProp",v[v.Bulk=4]="Bulk"})(a=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const t=new WeakMap,w=(v,h)=>{const p={controllerId:h};return t.set(v,p),p};e.createPrivateApiFor=w;const T=v=>t.get(v);e.getPrivateApiFor=T;const k=(v,h,p,I)=>{let l=p;return{enumerable:!0,configurable:!1,get(){return l},set(M){if(!I(l,M)){const r=l;l=M,v.listener?.({op:3,key:h,value:M,previous:r})}}}},P=(v,h)=>v===h,C={range:(v,h)=>v===h?!0:!v||!h?!1:v.isEqual(h),label:P,description:P,busy:P,error:P,canResolveChildren:P,tags:(v,h)=>!(v.length!==h.length||v.some(p=>!h.find(I=>p.id===I.id)))},R=Object.keys(C),F=(v,h)=>({range:k(v,"range",void 0,C.range),label:k(v,"label",h,C.label),description:k(v,"description",void 0,C.description),canResolveChildren:k(v,"canResolveChildren",!1,C.canResolveChildren),busy:k(v,"busy",!1,C.busy),error:k(v,"error",void 0,C.error),tags:k(v,"tags",[],C.tags)}),_=(v,h)=>{const p=new Map;for(const I of R)C[I](v[I],h[I])||p.set(I,h[I]);return p};e.diffTestItems=_;class n extends Error{constructor(h){super(`Attempted to insert a duplicate test item ID ${h}`)}}e.DuplicateTestItemError=n;class f extends Error{constructor(h){super(`TestItem with ID "${h}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class o extends Error{constructor(h,p,I){super(`TestItem with ID "${h}" is from controller "${p}" and cannot be added as a child of an item from controller "${I}".`)}}e.MixedTestItemController=o;const g=v=>{const h=(0,e.getPrivateApiFor)(v);let p=new Map;return{get size(){return p.size},forEach(I,l){for(const M of p.values())I.call(l,M,this)},replace(I){const l=new Map,M=new Set(p.keys()),r={op:4,ops:[]};for(const i of I){if(!(i instanceof c))throw new f(i.id);const m=(0,e.getPrivateApiFor)(i).controllerId;if(m!==h.controllerId)throw new o(i.id,m,h.controllerId);if(l.has(i.id))throw new n(i.id);l.set(i.id,i),M.delete(i.id),r.ops.push({op:0,item:i})}for(const i of M.keys())r.ops.push({op:1,id:i});h.listener?.(r),p=l},add(I){if(!(I instanceof c))throw new f(I.id);p.set(I.id,I),h.listener?.({op:0,item:I})},delete(I){p.delete(I)&&h.listener?.({op:1,id:I})},get(I){return p.get(I)},toJSON(){return Array.from(p.values())},[Symbol.iterator](){return p.values()}}};class c{constructor(h,p,I,l){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const M=(0,e.createPrivateApiFor)(this,h);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return M.parent instanceof D?void 0:M.parent}},children:{value:g(this),enumerable:!0,writable:!1},...F(M,I)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=c;class D extends c{constructor(h,p){super(h,h,p,void 0)}}e.TestItemRootImpl=D}),define(Ee[64],ye([0,1,3,144,4,13]),function(re,e,a,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var k;(function(C){function R(_){return{remoteAddress:_.remoteAddress,localAddress:_.localAddress,public:!!_.public,privacy:_.privacy??(_.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:_.protocol}}C.fromApiTunnel=R;function F(_){return{remoteAddress:{host:_.tunnelRemoteHost,port:_.tunnelRemotePort},localAddress:_.localAddress,public:_.privacy!==t.TunnelPrivacyId.ConstantPrivate&&_.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:_.privacy,protocol:_.protocol}}C.fromServiceTunnel=F})(k=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,a.createDecorator)("IExtHostTunnelService");let P=class{constructor(R){this.onDidChangeTunnels=new w.Emitter().event}async $applyCandidateFilter(R){return R}async openTunnel(R,F){}async getTunnels(){return[]}async setTunnelExtensionFunctions(R){return{dispose:()=>{}}}registerPortsAttributesProvider(R,F){return{dispose:()=>{}}}async $providePortAttributes(R,F,_,n,f){return[]}async $forwardPort(R,F){}async $closeTunnel(R){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};P=Ue([$e(0,T.IExtHostRpcService)],P),e.ExtHostTunnelService=P});var Ze=this&&this.__classPrivateFieldSet||function(re,e,a,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(re,a):w?w.value=a:e.set(re,a),a},Te=this&&this.__classPrivateFieldGet||function(re,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!t:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(re):t?t.value:e.get(re)};define(Ee[7],ye([0,1,16,15,76,21,78,9,11,2,35,45,84]),function(re,e,a,t,w,T,k,P,C,R,F,_,n){"use strict";var f,o,g,c,D,v,h,p,I,l,M,r,i,m,d,s,b,y,u,S;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function A(x){function O(){return Reflect.construct(x,arguments,this.constructor)}return Object.defineProperty(O,"name",Object.getOwnPropertyDescriptor(x,"name")),Object.setPrototypeOf(O,x),Object.setPrototypeOf(O.prototype,x.prototype),O}let U=D=class{constructor(O){f.set(this,void 0),Ze(this,f,O,"f")}static from(...O){let Z=O;return new D(function(){if(Z){for(const _e of Z)_e&&typeof _e.dispose=="function"&&_e.dispose();Z=void 0}})}dispose(){typeof Te(this,f,"f")=="function"&&(Te(this,f,"f").call(this),Ze(this,f,void 0,"f"))}};f=new WeakMap,U=D=Ue([A],U),e.Disposable=U;let H=v=class{constructor(O,Z){if(O<0)throw(0,t.illegalArgument)("line must be non-negative");if(Z<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=O,this._character=Z}static Min(...O){if(O.length===0)throw new TypeError;let Z=O[0];for(let _e=1;_e<O.length;_e++){const je=O[_e];je.isBefore(Z)&&(Z=je)}return Z}static Max(...O){if(O.length===0)throw new TypeError;let Z=O[0];for(let _e=1;_e<O.length;_e++){const je=O[_e];je.isAfter(Z)&&(Z=je)}return Z}static isPosition(O){if(!O)return!1;if(O instanceof v)return!0;let{line:Z,character:_e}=O;return typeof Z=="number"&&typeof _e=="number"}get line(){return this._line}get character(){return this._character}isBefore(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<O._character}isBeforeOrEqual(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<=O._character}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this._line===O._line&&this._character===O._character}compareTo(O){return this._line<O._line?-1:this._line>O.line?1:this._character<O._character?-1:this._character>O._character?1:0}translate(O,Z=0){if(O===null||Z===null)throw(0,t.illegalArgument)();let _e;return typeof O=="undefined"?_e=0:typeof O=="number"?_e=O:(_e=typeof O.lineDelta=="number"?O.lineDelta:0,Z=typeof O.characterDelta=="number"?O.characterDelta:0),_e===0&&Z===0?this:new v(this.line+_e,this.character+Z)}with(O,Z=this.character){if(O===null||Z===null)throw(0,t.illegalArgument)();let _e;return typeof O=="undefined"?_e=this.line:typeof O=="number"?_e=O:(_e=typeof O.line=="number"?O.line:this.line,Z=typeof O.character=="number"?O.character:this.character),_e===this.line&&Z===this.character?this:new v(_e,Z)}toJSON(){return{line:this.line,character:this.character}}};H=v=Ue([A],H),e.Position=H;let E=h=class{constructor(O,Z,_e,je){let tt,at;if(typeof O=="number"&&typeof Z=="number"&&typeof _e=="number"&&typeof je=="number"?(tt=new H(O,Z),at=new H(_e,je)):O instanceof H&&Z instanceof H&&(tt=O,at=Z),!tt||!at)throw new Error("Invalid arguments");tt.isBefore(at)?(this._start=tt,this._end=at):(this._start=at,this._end=tt)}static isRange(O){return O instanceof h?!0:O?H.isPosition(O.start)&&H.isPosition(O.end):!1}get start(){return this._start}get end(){return this._end}contains(O){return O instanceof h?this.contains(O._start)&&this.contains(O._end):O instanceof H?!(O.isBefore(this._start)||this._end.isBefore(O)):!1}isEqual(O){return this._start.isEqual(O._start)&&this._end.isEqual(O._end)}intersection(O){const Z=H.Max(O.start,this._start),_e=H.Min(O.end,this._end);if(!Z.isAfter(_e))return new h(Z,_e)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const Z=H.Min(O.start,this._start),_e=H.Max(O.end,this.end);return new h(Z,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(O,Z=this.end){if(O===null||Z===null)throw(0,t.illegalArgument)();let _e;return O?H.isPosition(O)?_e=O:(_e=O.start||this.start,Z=O.end||this.end):_e=this.start,_e.isEqual(this._start)&&Z.isEqual(this.end)?this:new h(_e,Z)}toJSON(){return[this.start,this.end]}};E=h=Ue([A],E),e.Range=E;let L=p=class extends E{constructor(O,Z,_e,je){let tt,at;if(typeof O=="number"&&typeof Z=="number"&&typeof _e=="number"&&typeof je=="number"?(tt=new H(O,Z),at=new H(_e,je)):O instanceof H&&Z instanceof H&&(tt=O,at=Z),!tt||!at)throw new Error("Invalid arguments");super(tt,at);this._anchor=tt,this._active=at}static isSelection(O){return O instanceof p?!0:O?E.isRange(O)&&H.isPosition(O.anchor)&&H.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};L=p=Ue([A],L),e.Selection=L;class z{constructor(O,Z,_e){if(typeof O!="string"||O.length===0)throw(0,t.illegalArgument)("host");if(typeof Z!="number"||Z===0||Math.round(Z)!==Z)throw(0,t.illegalArgument)("port");if(typeof _e!="undefined"&&(typeof _e!="string"||_e.length===0||!/^[0-9A-Za-z\-]+$/.test(_e)))throw(0,t.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(Z),this.connectionToken=_e}}e.ResolvedAuthority=z;class N extends Error{constructor(O,Z=n.RemoteAuthorityResolverErrorCode.Unknown,_e){super(O);this._message=O,this._code=Z,this._detail=_e,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,N.prototype)}static NotAvailable(O,Z){return new N(O,n.RemoteAuthorityResolverErrorCode.NotAvailable,Z)}static TemporarilyNotAvailable(O){return new N(O,n.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=N;var B;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})(B=e.EndOfLine||(e.EndOfLine={}));var j;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(j=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ce=I=class{constructor(O,Z){this._range=O,this._newText=Z}static isTextEdit(O){return O instanceof I?!0:O?E.isRange(O)&&typeof O.newText=="string":!1}static replace(O,Z){return new I(O,Z)}static insert(O,Z){return I.replace(new E(O,O),Z)}static delete(O){return I.replace(O,"")}static setEndOfLine(O){const Z=new I(new E(new H(0,0),new H(0,0)),"");return Z.newEol=O,Z}get range(){return this._range}set range(O){if(O&&!E.isRange(O))throw(0,t.illegalArgument)("range");this._range=O}get newText(){return this._newText||""}set newText(O){if(O&&typeof O!="string")throw(0,t.illegalArgument)("newText");this._newText=O}get newEol(){return this._newEol}set newEol(O){if(O&&typeof O!="number")throw(0,t.illegalArgument)("newEol");this._newEol=O}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ce=I=Ue([A],ce),e.TextEdit=ce;var K;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellReplace=5]="CellReplace"})(K=e.FileEditType||(e.FileEditType={}));let le=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(O,Z,_e,je){this._edits.push({_type:1,from:O,to:Z,options:_e,metadata:je})}createFile(O,Z,_e){this._edits.push({_type:1,from:void 0,to:O,options:Z,metadata:_e})}deleteFile(O,Z,_e){this._edits.push({_type:1,from:O,to:void 0,options:Z,metadata:_e})}replaceNotebookMetadata(O,Z,_e){this._edits.push({_type:3,metadata:_e,uri:O,edit:{editType:5,metadata:Z},notebookMetadata:Z})}replaceNotebookCells(O,Z,_e,je,tt){let at,dt,kt=[],Rt;if(Ae.isNotebookRange(Z)&&Ut.isNotebookCellDataArray(_e)&&!Ut.isNotebookCellDataArray(je)?(at=Z.start,dt=Z.end,kt=_e,Rt=je):typeof Z=="number"&&typeof _e=="number"&&Ut.isNotebookCellDataArray(je)&&(at=Z,dt=_e,kt=je,Rt=tt),at===void 0||dt===void 0)throw new Error("Invalid arguments");(at!==dt||kt.length>0)&&this._edits.push({_type:5,uri:O,index:at,count:dt-at,cells:kt,metadata:Rt})}replaceNotebookCellMetadata(O,Z,_e,je){this._edits.push({_type:3,metadata:je,uri:O,edit:{editType:8,index:Z,metadata:_e}})}replace(O,Z,_e,je){this._edits.push({_type:2,uri:O,edit:new ce(Z,_e),metadata:je})}insert(O,Z,_e,je){this.replace(O,new E(Z,Z),_e,je)}delete(O,Z,_e){this.replace(O,Z,"",_e)}has(O){return this._edits.some(Z=>Z._type===2&&Z.uri.toString()===O.toString())}set(O,Z){if(Z)for(const _e of Z)_e&&this._edits.push({_type:2,uri:O,edit:_e});else{for(let _e=0;_e<this._edits.length;_e++){const je=this._edits[_e];je._type===2&&je.uri.toString()===O.toString()&&(this._edits[_e]=void 0)}(0,a.coalesceInPlace)(this._edits)}}get(O){const Z=[];for(let _e of this._edits)_e._type===2&&_e.uri.toString()===O.toString()&&Z.push(_e.edit);return Z}entries(){const O=new T.ResourceMap;for(let Z of this._edits)if(Z._type===2){let _e=O.get(Z.uri);_e||(_e=[Z.uri,[]],O.set(Z.uri,_e)),_e[1].push(Z.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};le=Ue([A],le),e.WorkspaceEdit=le;let ue=l=class{constructor(O){this._tabstop=1,this.value=O||""}static isSnippetString(O){return O instanceof l?!0:O?typeof O.value=="string":!1}static _escape(O){return O.replace(/\$|}|\\/g,"\\$&")}appendText(O){return this.value+=l._escape(O),this}appendTabstop(O=this._tabstop++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,Z=this._tabstop++){if(typeof O=="function"){const _e=new l;_e._tabstop=this._tabstop,O(_e),this._tabstop=_e._tabstop,O=_e.value}else O=l._escape(O);return this.value+="${",this.value+=Z,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,Z=this._tabstop++){const _e=O.map(je=>je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=Z,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(O,Z){if(typeof Z=="function"){const _e=new l;_e._tabstop=this._tabstop,Z(_e),this._tabstop=_e._tabstop,Z=_e.value}else typeof Z=="string"&&(Z=Z.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,Z&&(this.value+=":",this.value+=Z),this.value+="}",this}};ue=l=Ue([A],ue),e.SnippetString=ue;var Y;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(Y=e.DiagnosticTag||(e.DiagnosticTag={}));var ie;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(ie=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let we=M=class{constructor(O,Z){if(this.uri=O,Z)if(Z instanceof E)this.range=Z;else if(Z instanceof H)this.range=new E(Z,Z);else throw new Error("Illegal argument")}static isLocation(O){return O instanceof M?!0:O?E.isRange(O.range)&&R.URI.isUri(O.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};we=M=Ue([A],we),e.Location=we;let Me=class{constructor(O,Z){this.location=O,this.message=Z}static is(O){return O?typeof O.message=="string"&&O.location&&E.isRange(O.location.range)&&R.URI.isUri(O.location.uri):!1}static isEqual(O,Z){return O===Z?!0:!O||!Z?!1:O.message===Z.message&&O.location.range.isEqual(Z.location.range)&&O.location.uri.toString()===Z.location.uri.toString()}};Me=Ue([A],Me),e.DiagnosticRelatedInformation=Me;let Re=class{constructor(O,Z,_e=ie.Error){if(!E.isRange(O))throw new TypeError("range must be set");if(!Z)throw new TypeError("message must be set");this.range=O,this.message=Z,this.severity=_e}toJSON(){return{severity:ie[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,Z){return O===Z?!0:!O||!Z?!1:O.message===Z.message&&O.severity===Z.severity&&O.code===Z.code&&O.severity===Z.severity&&O.source===Z.source&&O.range.isEqual(Z.range)&&(0,a.equals)(O.tags,Z.tags)&&(0,a.equals)(O.relatedInformation,Z.relatedInformation,Me.isEqual)}};Re=Ue([A],Re),e.Diagnostic=Re;let Be=class{constructor(O,Z){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:this.contents=[O],this.range=Z}};Be=Ue([A],Be),e.Hover=Be;var Qe;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(Qe=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ke=class{constructor(O,Z=Qe.Text){this.range=O,this.kind=Z}toJSON(){return{range:this.range,kind:Qe[this.kind]}}};Ke=Ue([A],Ke),e.DocumentHighlight=Ke;var Xe;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(Xe=e.SymbolKind||(e.SymbolKind={}));var $;(function(x){x[x.Deprecated=1]="Deprecated"})($=e.SymbolTag||(e.SymbolTag={}));let G=r=class{constructor(O,Z,_e,je,tt){this.name=O,this.kind=Z,this.containerName=tt,typeof _e=="string"&&(this.containerName=_e),je instanceof we?this.location=je:_e instanceof E&&(this.location=new we(je,_e)),r.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Xe[this.kind],location:this.location,containerName:this.containerName}}};G=r=Ue([A],G),e.SymbolInformation=G;let J=i=class{constructor(O,Z,_e,je,tt){this.name=O,this.detail=Z,this.kind=_e,this.range=je,this.selectionRange=tt,this.children=[],i.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children&&O.children.forEach(i.validate)}};J=i=Ue([A],J),e.DocumentSymbol=J;var ae;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(ae=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let q=class{constructor(O,Z){this.title=O,this.kind=Z}};q=Ue([A],q),e.CodeAction=q;let te=m=class{constructor(O){this.value=O}append(O){return new m(this.value?this.value+m.sep+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+m.sep)}};te.sep=".",te=m=Ue([A],te),e.CodeActionKind=te,te.Empty=new te(""),te.QuickFix=te.Empty.append("quickfix"),te.Refactor=te.Empty.append("refactor"),te.RefactorExtract=te.Refactor.append("extract"),te.RefactorInline=te.Refactor.append("inline"),te.RefactorRewrite=te.Refactor.append("rewrite"),te.Source=te.Empty.append("source"),te.SourceOrganizeImports=te.Source.append("organizeImports"),te.SourceFixAll=te.Source.append("fixAll");let me=class{constructor(O,Z){if(this.range=O,this.parent=Z,Z&&!Z.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};me=Ue([A],me),e.SelectionRange=me;class Pe{constructor(O,Z,_e,je,tt,at){this.kind=O,this.name=Z,this.detail=_e,this.uri=je,this.range=tt,this.selectionRange=at}}e.CallHierarchyItem=Pe;class Ne{constructor(O,Z){this.fromRanges=Z,this.from=O}}e.CallHierarchyIncomingCall=Ne;class He{constructor(O,Z){this.fromRanges=Z,this.to=O}}e.CallHierarchyOutgoingCall=He;var Ye;(function(x){x[x.Information=0]="Information",x[x.Warning=1]="Warning",x[x.Error=2]="Error"})(Ye=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(O,Z){this.range=O,this.command=Z}get isResolved(){return!!this.command}};et=Ue([A],et),e.CodeLens=et;let st=d=class{constructor(O,Z=!1){o.set(this,void 0),Ze(this,o,new w.MarkdownString(O,{supportThemeIcons:Z}),"f")}static isMarkdownString(O){return O instanceof d?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}get value(){return Te(this,o,"f").value}set value(O){Te(this,o,"f").value=O}get isTrusted(){return Te(this,o,"f").isTrusted}set isTrusted(O){Te(this,o,"f").isTrusted=O}get supportThemeIcons(){return Te(this,o,"f").supportThemeIcons}set supportThemeIcons(O){Te(this,o,"f").supportThemeIcons=O}get supportHtml(){return Te(this,o,"f").supportHtml}set supportHtml(O){Te(this,o,"f").supportHtml=O}appendText(O){return Te(this,o,"f").appendText(O),this}appendMarkdown(O){return Te(this,o,"f").appendMarkdown(O),this}appendCodeblock(O,Z){return Te(this,o,"f").appendCodeblock(Z??"",O),this}};o=new WeakMap,st=d=Ue([A],st),e.MarkdownString=st;let Je=class{constructor(O,Z){this.label=O,this.documentation=Z}};Je=Ue([A],Je),e.ParameterInformation=Je;let nt=class{constructor(O,Z){this.label=O,this.documentation=Z,this.parameters=[]}};nt=Ue([A],nt),e.SignatureInformation=nt;let lt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};lt=Ue([A],lt),e.SignatureHelp=lt;var pt;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(pt=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ft;(function(x){x[x.Other=0]="Other",x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(Ft=e.InlayHintKind||(e.InlayHintKind={}));let Fe=class{constructor(O,Z,_e){this.text=O,this.position=Z,this.kind=_e}};Fe=Ue([A],Fe),e.InlayHint=Fe;var Mt;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Mt=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var V;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(V=e.CompletionItemKind||(e.CompletionItemKind={}));var Q;(function(x){x[x.Deprecated=1]="Deprecated"})(Q=e.CompletionItemTag||(e.CompletionItemTag={}));let he=class{constructor(O,Z){this.label=O,this.kind=Z}toJSON(){return{label:this.label,kind:this.kind&&V[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};he=Ue([A],he),e.CompletionItem=he;let Le=class{constructor(O=[],Z=!1){this.items=O,this.isIncomplete=Z}};Le=Ue([A],Le),e.CompletionList=Le;let We=class{constructor(O,Z,_e){this.text=O,this.range=Z,this.command=_e}};We=Ue([A],We),e.InlineSuggestion=We;let ot=class{constructor(O){this.items=O}};ot=Ue([A],ot),e.InlineSuggestions=ot;var Ge;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(Ge=e.ViewColumn||(e.ViewColumn={}));var yt;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(yt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ie;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(Ie=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ce;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(Ce=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ve;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(ve=e.TextEditorRevealType||(e.TextEditorRevealType={}));var oe;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(oe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var se;(function(x){x[x.Undo=1]="Undo",x[x.Redo=2]="Redo"})(se=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var fe;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(fe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function O(Z){switch(Z){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=O}(oe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ge=class{constructor(O,Z){if(Z&&!R.URI.isUri(Z))throw(0,t.illegalArgument)("target");if(!E.isRange(O)||O.isEmpty)throw(0,t.illegalArgument)("range");this.range=O,this.target=Z}};ge=Ue([A],ge),e.DocumentLink=ge;let ke=class{constructor(O,Z,_e,je){this.red=O,this.green=Z,this.blue=_e,this.alpha=je}};ke=Ue([A],ke),e.Color=ke;let ze=class{constructor(O,Z){if(Z&&!(Z instanceof ke))throw(0,t.illegalArgument)("color");if(!E.isRange(O)||O.isEmpty)throw(0,t.illegalArgument)("range");this.range=O,this.color=Z}};ze=Ue([A],ze),e.ColorInformation=ze;let Oe=class{constructor(O){if(!O||typeof O!="string")throw(0,t.illegalArgument)("label");this.label=O}};Oe=Ue([A],Oe),e.ColorPresentation=Oe;var Ve;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(Ve=e.ColorFormat||(e.ColorFormat={}));var it;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(it=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class rt{constructor(O,Z,_e){if(this.startIndex=O,this.length=Z,this.tooltip=_e,typeof O!="number"||O<0)throw(0,t.illegalArgument)("startIndex");if(typeof Z!="number"||Z<1)throw(0,t.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=rt;var ne;(function(x){x[x.Panel=1]="Panel",x[x.Editor=2]="Editor"})(ne=e.TerminalLocation||(e.TerminalLocation={}));class pe{constructor(O){this.options=O,typeof O!="object"&&(0,t.illegalArgument)("options")}}e.TerminalProfile=pe;var ee;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(ee=e.TaskRevealKind||(e.TaskRevealKind={}));var W;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(W=e.TaskPanelKind||(e.TaskPanelKind={}));let be=s=class{constructor(O,Z){if(this.label=Z,typeof O!="string"||typeof Z!="string")throw(0,t.illegalArgument)("name");this._id=O}static from(O){switch(O){case"clean":return s.Clean;case"build":return s.Build;case"rebuild":return s.Rebuild;case"test":return s.Test;default:return}}get id(){return this._id}};be.Clean=new s("clean","Clean"),be.Build=new s("build","Build"),be.Rebuild=new s("rebuild","Rebuild"),be.Test=new s("test","Test"),be=s=Ue([A],be),e.TaskGroup=be;function De(x){let O="";for(let Z=0;Z<x.length;Z++)O+=x[Z].replace(/,/g,",,")+",";return O}let qe=class{constructor(O,Z,_e){if(typeof O!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=O,Z!==void 0&&(Array.isArray(Z)?(this._args=Z,this._options=_e):this._options=Z)}get process(){return this._process}set process(O){if(typeof O!="string")throw(0,t.illegalArgument)("process");this._process=O}get args(){return this._args}set args(O){Array.isArray(O)||(O=[]),this._args=O}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("process"),this._process!==void 0&&O.push(this._process),this._args&&this._args.length>0)for(let Z of this._args)O.push(Z);return De(O)}};qe=Ue([A],qe),e.ProcessExecution=qe;let xe=class{constructor(O,Z,_e){if(this._args=[],Array.isArray(Z)){if(!O)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,t.illegalArgument)("command");this._command=O,this._args=Z,this._options=_e}else{if(typeof O!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=O,this._options=Z}}get commandLine(){return this._commandLine}set commandLine(O){if(typeof O!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=O}get command(){return this._command?this._command:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,t.illegalArgument)("command");this._command=O}get args(){return this._args}set args(O){this._args=O||[]}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("shell"),this._commandLine!==void 0&&O.push(this._commandLine),this._command!==void 0&&O.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let Z of this._args)O.push(typeof Z=="string"?Z:Z.value);return De(O)}};xe=Ue([A],xe),e.ShellExecution=xe;var ut;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(ut=e.ShellQuoting||(e.ShellQuoting={}));var vt;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(vt=e.TaskScope||(e.TaskScope={}));class St{constructor(O){this._callback=O}computeId(){return"customExecution"+(0,F.generateUuid)()}set callback(O){this._callback=O}get callback(){return this._callback}}e.CustomExecution=St;let bt=b=class{constructor(O,Z,_e,je,tt,at){this.__deprecated=!1,this._definition=this.definition=O;let dt;typeof Z=="string"?(this._name=this.name=Z,this._source=this.source=_e,this.execution=je,dt=tt,this.__deprecated=!0):Z===vt.Global||Z===vt.Workspace?(this.target=Z,this._name=this.name=_e,this._source=this.source=je,this.execution=tt,dt=at):(this.target=Z,this._name=this.name=_e,this._source=this.source=je,this.execution=tt,dt=at),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(O){this.__id=O}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof qe?this._definition={type:b.ProcessType,id:this._execution.computeId()}:this._execution instanceof xe?this._definition={type:b.ShellType,id:this._execution.computeId()}:this._execution instanceof St?this._definition={type:b.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:b.EmptyType,id:(0,F.generateUuid)()}}get definition(){return this._definition}set definition(O){if(O==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=O}get scope(){return this._scope}set target(O){this.clear(),this._scope=O}get name(){return this._name}set name(O){if(typeof O!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=O}get execution(){return this._execution}set execution(O){O===null&&(O=void 0),this.clear(),this._execution=O;const Z=this._definition.type;(b.EmptyType===Z||b.ProcessType===Z||b.ShellType===Z||b.ExtensionCallbackType===Z)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(O){if(Array.isArray(O))this.clear(),this._problemMatchers=O,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.clear(),this._isBackground=O}get source(){return this._source}set source(O){if(typeof O!="string"||O.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=O}get group(){return this._group}set group(O){O===null&&(O=void 0),this.clear(),this._group=O}get detail(){return this._detail}set detail(O){O===null&&(O=void 0),this._detail=O}get presentationOptions(){return this._presentationOptions}set presentationOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._presentationOptions=O}get runOptions(){return this._runOptions}set runOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._runOptions=O}};bt.ExtensionCallbackType="customExecution",bt.ProcessType="process",bt.ShellType="shell",bt.EmptyType="$empty",bt=b=Ue([A],bt),e.Task=bt;var ht;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(ht=e.ProgressLocation||(e.ProgressLocation={}));let gt=class{constructor(O,Z=_t.None){this.collapsibleState=Z,R.URI.isUri(O)?this.resourceUri=O:this.label=O}};gt=Ue([A],gt),e.TreeItem=gt;var _t;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(_t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Lt=class{constructor(O){this._value=O}async asString(){return JSON.stringify(this._value)}};Lt=Ue([A],Lt),e.TreeDataTransferItem=Lt;let It=class{constructor(){this._items=new Map}get(O){return this._items.get(O)}set(O,Z){this._items.set(O,Z)}forEach(O){this._items.forEach(O)}};It=Ue([A],It),e.TreeDataTransfer=It;let Pt=class{constructor(O,Z){this.id=O,this.color=Z}};Pt=Ue([A],Pt),e.ThemeIcon=Pt,Pt.File=new Pt("file"),Pt.Folder=new Pt("folder");let At=class{constructor(O){this.id=O}};At=Ue([A],At),e.ThemeColor=At;var Et;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(Et=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ot=class{constructor(O,Z){if(typeof O!="string"&&(!O||!R.URI.isUri(O)&&!R.URI.isUri(O.uri)))throw(0,t.illegalArgument)("base");if(typeof Z!="string")throw(0,t.illegalArgument)("pattern");typeof O=="string"?(this.baseFolder=R.URI.file(O),this.base=O):R.URI.isUri(O)?(this.baseFolder=O,this.base=O.fsPath):(this.baseFolder=O.uri,this.base=O.uri.fsPath),this.pattern=Z}};Ot=Ue([A],Ot),e.RelativePattern=Ot;let Nt=class{constructor(O,Z,_e,je){this.enabled=typeof O=="boolean"?O:!0,typeof Z=="string"&&(this.condition=Z),typeof _e=="string"&&(this.hitCondition=_e),typeof je=="string"&&(this.logMessage=je)}get id(){return this._id||(this._id=(0,F.generateUuid)()),this._id}};Nt=Ue([A],Nt),e.Breakpoint=Nt;let wt=class extends Nt{constructor(O,Z,_e,je,tt){super(Z,_e,je,tt);if(O===null)throw(0,t.illegalArgument)("location");this.location=O}};wt=Ue([A],wt),e.SourceBreakpoint=wt;let $t=class extends Nt{constructor(O,Z,_e,je,tt){super(Z,_e,je,tt);this.functionName=O}};$t=Ue([A],$t),e.FunctionBreakpoint=$t;let jt=class extends Nt{constructor(O,Z,_e,je,tt,at,dt){super(je,tt,at,dt);if(!Z)throw(0,t.illegalArgument)("dataId");this.label=O,this.dataId=Z,this.canPersist=_e}};jt=Ue([A],jt),e.DataBreakpoint=jt;let oi=class{constructor(O,Z,_e){this.command=O,this.args=Z||[],this.options=_e}};oi=Ue([A],oi),e.DebugAdapterExecutable=oi;let si=class{constructor(O,Z){this.port=O,this.host=Z}};si=Ue([A],si),e.DebugAdapterServer=si;let Tt=class{constructor(O){this.path=O}};Tt=Ue([A],Tt),e.DebugAdapterNamedPipeServer=Tt;let Yt=class{constructor(O){this.implementation=O}};Yt=Ue([A],Yt),e.DebugAdapterInlineImplementation=Yt;let ai=class{constructor(O,Z){this.range=O,this.expression=Z}};ai=Ue([A],ai),e.EvaluatableExpression=ai;var Xt;(function(x){x[x.Automatic=0]="Automatic",x[x.Explicit=1]="Explicit"})(Xt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Vt=class{constructor(O,Z){this.range=O,this.text=Z}};Vt=Ue([A],Vt),e.InlineValueText=Vt;let mt=class{constructor(O,Z,_e=!0){this.range=O,this.variableName=Z,this.caseSensitiveLookup=_e}};mt=Ue([A],mt),e.InlineValueVariableLookup=mt;let li=class{constructor(O,Z){this.range=O,this.expression=Z}};li=Ue([A],li),e.InlineValueEvaluatableExpression=li;let xt=class{constructor(O,Z){this.frameId=O,this.stoppedLocation=Z}};xt=Ue([A],xt),e.InlineValueContext=xt;var qt;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(qt=e.FileChangeType||(e.FileChangeType={}));let Jt=y=class extends Error{constructor(O,Z=_.FileSystemProviderErrorCode.Unknown,_e){super(R.URI.isUri(O)?O.toString(!0):O);this.code=_e?.name??"Unknown",(0,_.markAsFileSystemProviderError)(this,Z),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,y.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}static FileExists(O){return new y(O,_.FileSystemProviderErrorCode.FileExists,y.FileExists)}static FileNotFound(O){return new y(O,_.FileSystemProviderErrorCode.FileNotFound,y.FileNotFound)}static FileNotADirectory(O){return new y(O,_.FileSystemProviderErrorCode.FileNotADirectory,y.FileNotADirectory)}static FileIsADirectory(O){return new y(O,_.FileSystemProviderErrorCode.FileIsADirectory,y.FileIsADirectory)}static NoPermissions(O){return new y(O,_.FileSystemProviderErrorCode.NoPermissions,y.NoPermissions)}static Unavailable(O){return new y(O,_.FileSystemProviderErrorCode.Unavailable,y.Unavailable)}};Jt=y=Ue([A],Jt),e.FileSystemError=Jt;let ci=class{constructor(O,Z,_e){this.start=O,this.end=Z,this.kind=_e}};ci=Ue([A],ci),e.FoldingRange=ci;var fi;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(fi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ei;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(Ei=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var mi;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(mi=e.CommentMode||(e.CommentMode={}));class Zt{constructor(O,Z=[]){this.tokenTypes=O,this.tokenModifiers=Z}}e.SemanticTokensLegend=Zt;function yi(x){return typeof x=="undefined"||(0,C.isStringArray)(x)}class Kt{constructor(O){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,O){this._hasLegend=!0;for(let Z=0,_e=O.tokenTypes.length;Z<_e;Z++)this._tokenTypeStrToInt.set(O.tokenTypes[Z],Z);for(let Z=0,_e=O.tokenModifiers.length;Z<_e;Z++)this._tokenModifierStrToInt.set(O.tokenModifiers[Z],Z)}}push(O,Z,_e,je,tt){if(typeof O=="number"&&typeof Z=="number"&&typeof _e=="number"&&typeof je=="number"&&(typeof tt=="number"||typeof tt=="undefined"))return typeof tt=="undefined"&&(tt=0),this._pushEncoded(O,Z,_e,je,tt);if(E.isRange(O)&&typeof Z=="string"&&yi(_e))return this._push(O,Z,_e);throw(0,t.illegalArgument)()}_push(O,Z,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(Z))throw new Error("`tokenType` is not in the provided legend");const je=O.start.line,tt=O.start.character,at=O.end.character-O.start.character,dt=this._tokenTypeStrToInt.get(Z);let kt=0;if(_e)for(const Rt of _e){if(!this._tokenModifierStrToInt.has(Rt))throw new Error("`tokenModifier` is not in the provided legend");const Bt=this._tokenModifierStrToInt.get(Rt);kt|=1<<Bt>>>0}this._pushEncoded(je,tt,at,dt,kt)}_pushEncoded(O,Z,_e,je,tt){if(this._dataIsSortedAndDeltaEncoded&&(O<this._prevLine||O===this._prevLine&&Z<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const kt=this._data.length/5|0;let Rt=0,Bt=0;for(let Ht=0;Ht<kt;Ht++){let zt=this._data[5*Ht],di=this._data[5*Ht+1];zt===0?(zt=Rt,di+=Bt):zt+=Rt,this._data[5*Ht]=zt,this._data[5*Ht+1]=di,Rt=zt,Bt=di}}let at=O,dt=Z;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=je,this._data[this._dataLen++]=tt,this._prevLine=O,this._prevChar=Z}static _sortAndDeltaEncode(O){let Z=[];const _e=O.length/5|0;for(let dt=0;dt<_e;dt++)Z[dt]=dt;Z.sort((dt,kt)=>{const Rt=O[5*dt],Bt=O[5*kt];if(Rt===Bt){const Ht=O[5*dt+1],zt=O[5*kt+1];return Ht-zt}return Rt-Bt});const je=new Uint32Array(O.length);let tt=0,at=0;for(let dt=0;dt<_e;dt++){const kt=5*Z[dt],Rt=O[kt+0],Bt=O[kt+1],Ht=O[kt+2],zt=O[kt+3],di=O[kt+4],Hi=Rt-tt,Yi=Hi===0?Bt-at:Bt,hi=5*dt;je[hi+0]=Hi,je[hi+1]=Yi,je[hi+2]=Ht,je[hi+3]=zt,je[hi+4]=di,tt=Rt,at=Bt}return je}build(O){return this._dataIsSortedAndDeltaEncoded?new Gt(new Uint32Array(this._data),O):new Gt(Kt._sortAndDeltaEncode(this._data),O)}}e.SemanticTokensBuilder=Kt;class Gt{constructor(O,Z){this.resultId=Z,this.data=O}}e.SemanticTokens=Gt;class _i{constructor(O,Z,_e){this.start=O,this.deleteCount=Z,this.data=_e}}e.SemanticTokensEdit=_i;class Ci{constructor(O,Z){this.resultId=Z,this.edits=O}}e.SemanticTokensEdits=Ci;var Qt;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(Qt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Si;(function(x){x[x.Initial=1]="Initial",x[x.Dynamic=2]="Dynamic"})(Si=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ei=class{constructor(){}};ei.Back={iconPath:new Pt("arrow-left")},ei=Ue([A],ei),e.QuickInputButtons=ei;var Di;(function(x){x[x.Default=1]="Default",x[x.Separator=2]="Separator"})(Di=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ki;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(ki=e.ExtensionKind||(e.ExtensionKind={}));class ui{constructor(O,Z,_e){this.badge=O,this.tooltip=Z,this.color=_e}static validate(O){if(O.badge){let Z=(0,P.nextCharLength)(O.badge,0);if(Z<O.badge.length&&(Z+=(0,P.nextCharLength)(O.badge,Z)),O.badge.length>Z)throw new Error("The 'badge'-property must be undefined or a short character")}if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=ui;let ti=class{constructor(O){this.kind=O}};ti=Ue([A],ti),e.ColorTheme=ti;var gi;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast"})(gi=e.ColorThemeKind||(e.ColorThemeKind={}));class Ae{constructor(O,Z){if(O<0)throw(0,t.illegalArgument)("start must be positive");if(Z<0)throw(0,t.illegalArgument)("end must be positive");O<=Z?(this._start=O,this._end=Z):(this._start=Z,this._end=O)}static isNotebookRange(O){return O instanceof Ae?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(O){let Z=this._start,_e=this._end;return O.start!==void 0&&(Z=O.start),O.end!==void 0&&(_e=O.end),Z===this._start&&_e===this._end?this:new Ae(Z,_e)}}e.NotebookRange=Ae;class Ut{constructor(O,Z,_e,je,tt,at,dt){this.kind=O,this.value=Z,this.languageId=_e,this.mime=je,this.outputs=tt??[],this.metadata=at,this.executionSummary=dt,Ut.validate(this)}static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(Z=>Ut.isNotebookCellData(Z))}static isNotebookCellData(O){return!0}}e.NotebookCellData=Ut;class pi{constructor(O){this.cells=O}}e.NotebookData=pi;class ft{constructor(O,Z){this.data=O,this.mime=Z;const _e=(0,k.normalizeMimeType)(Z,!0);if(!_e)throw new Error(`INVALID mime type: ${Z}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}static isNotebookCellOutputItem(O){return O instanceof ft?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const Z={name:O.name,message:O.message,stack:O.stack};return ft.json(Z,"application/vnd.code.notebook.error")}static stdout(O){return ft.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return ft.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,Z="application/octet-stream"){return new ft(O,Z)}static text(O,Z=k.Mimes.text){const _e=Te(ft,g,"f",c).encode(String(O));return new ft(_e,Z)}static json(O,Z="application/json"){const _e=JSON.stringify(O,void 0,"	");return ft.text(_e,Z)}}e.NotebookCellOutputItem=ft,g=ft,c={value:new TextEncoder};class ii{constructor(O,Z,_e){this.items=ii.ensureUniqueMimeTypes(O,!0),typeof Z=="string"?(this.id=Z,this.metadata=_e):(this.id=(0,F.generateUuid)(),this.metadata=Z??_e)}static isNotebookCellOutput(O){return O instanceof ii?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&(0,C.isArray)(O.items)}static ensureUniqueMimeTypes(O,Z=!1){const _e=new Set,je=new Set;for(let tt=0;tt<O.length;tt++){const at=O[tt],dt=(0,k.normalizeMimeType)(at.mime);if(!_e.has(dt)){_e.add(dt);continue}je.add(tt),Z&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return je.size===0?O:O.filter((tt,at)=>!je.has(at))}}e.NotebookCellOutput=ii;var Ii;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(Ii=e.NotebookCellKind||(e.NotebookCellKind={}));var vi;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(vi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var bi;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(bi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Pi;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Pi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ti{constructor(O,Z){this.text=O,this.alignment=Z}}e.NotebookCellStatusBarItem=Ti;var Ai;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(Ai=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ri{constructor(O,Z=[]){this.uri=O,this.provides=(0,a.asArray)(Z)}}e.NotebookRendererScript=Ri;let ni=class{constructor(O,Z){this.label=O,this.timestamp=Z}};ni=Ue([A],ni),e.TimelineItem=ni;var Fi;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(Fi=e.ExtensionMode||(e.ExtensionMode={}));var Mi;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(Mi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Oi;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=4]="RegEx"})(Oi=e.StandardTokenType||(e.StandardTokenType={}));class Li{constructor(O,Z){this.ranges=O,this.wordPattern=Z}}e.LinkedEditingRanges=Li;class Ni{constructor(O,Z){this._port=O,this._autoForwardAction=Z}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ni;var X;(function(x){x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(X=e.TestResultState||(e.TestResultState={}));var de;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(de=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Se=class{constructor(O=void 0,Z=void 0,_e=void 0){this.include=O,this.exclude=Z,this.profile=_e}};Se=Ue([A],Se),e.TestRunRequest=Se;let ct=u=class{constructor(O){this.message=O}static diff(O,Z,_e){const je=new u(O);return je.expectedOutput=Z,je.actualOutput=_e,je}};ct=u=Ue([A],ct),e.TestMessage=ct;let Ct=class{constructor(O){this.id=O}};Ct=Ue([A],Ct),e.TestTag=Ct;let Dt=class{constructor(O,Z){this.covered=O,this.total=Z}};Dt=Ue([A],Dt),e.CoveredCount=Dt;let xi=S=class{constructor(O,Z,_e,je){this.uri=O,this.statementCoverage=Z,this.branchCoverage=_e,this.functionCoverage=je}static fromDetails(O,Z){const _e=new Dt(0,0),je=new Dt(0,0),tt=new Dt(0,0);for(const dt of Z)if("branches"in dt){_e.total+=1,_e.covered+=dt.executionCount>0?1:0;for(const kt of dt.branches)je.total+=1,je.covered+=kt.executionCount>0?1:0}else tt.total+=1,tt.covered+=dt.executionCount>0?1:0;const at=new S(O,_e,je.total>0?je:void 0,tt.total>0?tt:void 0);return at.detailedCoverage=Z,at}};xi=S=Ue([A],xi),e.FileCoverage=xi;let Ui=class{constructor(O,Z,_e=[]){this.executionCount=O,this.location=Z,this.branches=_e}};Ui=Ue([A],Ui),e.StatementCoverage=Ui;let Bi=class{constructor(O,Z){this.executionCount=O,this.location=Z}};Bi=Ue([A],Bi),e.BranchCoverage=Bi;let $i=class{constructor(O,Z){this.executionCount=O,this.location=Z}};$i=Ue([A],$i),e.FunctionCoverage=$i;var qi;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(qi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Ki;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(Ki=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Gi;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore",x[x.OpenBrowserOnce=6]="OpenBrowserOnce"})(Gi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Qi{constructor(O,Z,_e,je,tt,at){this.kind=O,this.name=Z,this.detail=_e,this.uri=je,this.range=tt,this.selectionRange=at}}e.TypeHierarchyItem=Qi}),define(Ee[86],ye([0,1,41,10,9,223,114,7,16]),function(re,e,a,t,w,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const R=new Map;function F(o,g){g?R.set(o,g):R.delete(o)}e.setWordDefinitionFor=F;function _(o){return R.get(o)}e.getWordDefinitionFor=_;class n extends T.MirrorTextModel{constructor(g,c,D,v,h,p,I,l){super(c,D,v,h);this._proxy=g,this._languageId=p,this._isDirty=I,this._notebook=l,this._isDisposed=!1}dispose(){(0,a.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(g){return(0,C.equals)(this._lines,g)}get document(){if(!this._document){const g=this;this._document={get uri(){return g._uri},get fileName(){return g._uri.fsPath},get isUntitled(){return g._uri.scheme===t.Schemas.untitled},get languageId(){return g._languageId},get version(){return g._versionId},get isClosed(){return g._isDisposed},get isDirty(){return g._isDirty},get notebook(){return g._notebook},save(){return g._save()},getText(c){return c?g._getTextInRange(c):g.getText()},get eol(){return g._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return g._lines.length},lineAt(c){return g._lineAt(c)},offsetAt(c){return g._offsetAt(c)},positionAt(c){return g._positionAt(c)},validateRange(c){return g._validateRange(c)},validatePosition(c){return g._validatePosition(c)},getWordRangeAtPosition(c,D){return g._getWordRangeAtPosition(c,D)}}}return Object.freeze(this._document)}_acceptLanguageId(g){(0,a.ok)(!this._isDisposed),this._languageId=g}_acceptIsDirty(g){(0,a.ok)(!this._isDisposed),this._isDirty=g}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(g){const c=this._validateRange(g);if(c.isEmpty)return"";if(c.isSingleLine)return this._lines[c.start.line].substring(c.start.character,c.end.character);const D=this._eol,v=c.start.line,h=c.end.line,p=[];p.push(this._lines[v].substring(c.start.character));for(let I=v+1;I<h;I++)p.push(this._lines[I]);return p.push(this._lines[h].substring(0,c.end.character)),p.join(D)}_lineAt(g){let c;if(g instanceof P.Position?c=g.line:typeof g=="number"&&(c=g),typeof c!="number"||c<0||c>=this._lines.length||Math.floor(c)!==c)throw new Error("Illegal value for `line`");return new f(c,this._lines[c],c===this._lines.length-1)}_offsetAt(g){return g=this._validatePosition(g),this._ensureLineStarts(),this._lineStarts.getPrefixSum(g.line-1)+g.character}_positionAt(g){g=Math.floor(g),g=Math.max(0,g),this._ensureLineStarts();const c=this._lineStarts.getIndexOf(g),D=this._lines[c.index].length;return new P.Position(c.index,Math.min(c.remainder,D))}_validateRange(g){if(!(g instanceof P.Range))throw new Error("Invalid argument");const c=this._validatePosition(g.start),D=this._validatePosition(g.end);return c===g.start&&D===g.end?g:new P.Range(c.line,c.character,D.line,D.character)}_validatePosition(g){if(!(g instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return g.with(0,0);let{line:c,character:D}=g,v=!1;if(c<0)c=0,D=0,v=!0;else if(c>=this._lines.length)c=this._lines.length-1,D=this._lines[c].length,v=!0;else{const h=this._lines[c].length;D<0?(D=0,v=!0):D>h&&(D=h,v=!0)}return v?new P.Position(c,D):g}_getWordRangeAtPosition(g,c){const D=this._validatePosition(g);if(!c)c=_(this._languageId);else if((0,w.regExpLeadsToEndlessLoop)(c))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${c.source}' because it matches the empty string.`);const v=(0,k.getWordAtText)(D.character+1,(0,k.ensureValidWordDefinition)(c),this._lines[D.line],0);if(v)return new P.Range(D.line,v.startColumn-1,D.line,v.endColumn-1)}}e.ExtHostDocumentData=n;class f{constructor(g,c,D){this._line=g,this._text=c,this._isLastLine=D}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=f}),define(Ee[150],ye([0,1,7,4,224,6,55,21,2,35]),function(re,e,a,t,w,T,k,P,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class F{constructor(n,f,o,g){this._notebook=o,this._selector=g,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this.uri=C.URI.from({scheme:"vscode-concat-doc",path:(0,R.generateUuid)()}),this._init(),this._disposables.add(f.onDidChangeDocument(D=>{const v=this._cellUris.get(D.document.uri);v!==void 0&&(this._cellLengths.setValue(v,this._cells[v].document.getText().length+1),this._cellLines.setValue(v,this._cells[v].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const c=D=>{D===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(n.onDidChangeNotebookCells(D=>c(D.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new P.ResourceMap;const n=[],f=[];for(const o of this._notebook.getCells())o.kind===a.NotebookCellKind.Code&&(!this._selector||(0,k.score)(this._selector,o.document.uri,o.document.languageId,!0))&&(this._cellUris.set(o.document.uri,this._cells.length),this._cells.push(o),n.push(o.document.getText().length+1),f.push(o.document.lineCount));this._cellLengths=new w.PrefixSumComputer(new Uint32Array(n)),this._cellLines=new w.PrefixSumComputer(new Uint32Array(f))}get version(){return this._versionId}getText(n){if(!n){let v="";for(const h of this._cells)v+=h.document.getText()+`
`;return v=v.slice(0,-1),v}if(n.isEmpty)return"";const f=this.locationAt(n.start),o=this.locationAt(n.end),g=this._cellUris.get(f.uri),c=this._cellUris.get(o.uri);if(g===void 0||c===void 0)return"";if(g===c)return this._cells[g].document.getText(new a.Range(f.range.start,o.range.end));const D=[this._cells[g].document.getText(new a.Range(f.range.start,new a.Position(this._cells[g].document.lineCount,0)))];for(let v=g+1;v<c;v++)D.push(this._cells[v].document.getText());return D.push(this._cells[c].document.getText(new a.Range(new a.Position(0,0),o.range.end))),D.join(`
`)}offsetAt(n){const f=this._cellLines.getIndexOf(n.line),o=this._cellLengths.getPrefixSum(f.index-1),g=this._cells[f.index].document.offsetAt(n.with(f.remainder));return o+g}positionAt(n){if(typeof n=="number"){const o=this._cellLengths.getIndexOf(n),g=this._cellLines.getPrefixSum(o.index-1);return this._cells[o.index].document.positionAt(o.remainder).translate(g)}const f=this._cellUris.get(n.uri);if(f!==void 0){const o=this._cellLines.getPrefixSum(f-1);return new a.Position(o+n.range.start.line,n.range.start.character)}return new a.Position(0,0)}locationAt(n){a.Range.isRange(n)||(n=new a.Range(n,n));const f=this._cellLines.getIndexOf(n.start.line);let o=f;n.isEmpty||(o=this._cellLines.getIndexOf(n.end.line));const g=new a.Position(f.remainder,n.start.character),c=new a.Position(o.remainder,n.end.character),D=new a.Range(g,c),v=this._cells[f.index];return new a.Location(v.document.uri,v.document.validateRange(D))}contains(n){return this._cellUris.has(n)}validateRange(n){const f=this.validatePosition(n.start),o=this.validatePosition(n.end);return n.with(f,o)}validatePosition(n){const f=this._cellLines.getIndexOf(n.line),o=new a.Position(f.remainder,n.character),g=this._cells[f.index].document.validatePosition(o),c=this._cellLines.getPrefixSum(f.index-1);return new a.Position(c+g.line,g.character)}}e.ExtHostNotebookConcatDocument=F}),define(Ee[151],ye([0,1,7,13,4]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(P){this._actual=new a.ColorTheme(a.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new w.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let C=P==="light"?a.ColorThemeKind.Light:P==="dark"?a.ColorThemeKind.Dark:a.ColorThemeKind.HighContrast;this._actual=new a.ColorTheme(C),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=Ue([$e(0,t.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(Ee[65],ye([0,1,3]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,a.createDecorator)("IURITransformerService");class t{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=k=>k,this.transformOutgoing=k=>k,this.transformOutgoingURI=k=>k,this.transformOutgoingScheme=k=>k)}}e.URITransformerService=t}),define(Ee[152],ye([0,1,22]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(C){let R=this.buffers.indexOf(C);return R<0&&(R=this.buffers.length,this.buffers.push(C)),R}}function w(P,C){if(C.serializeBuffersForPostMessage){const R=new t,F=(f,o)=>{if(o instanceof ArrayBuffer){const g=R.add(o);return{$$vscode_array_buffer_reference$$:!0,index:g}}else if(ArrayBuffer.isView(o)){const g=T(o);if(g){const c=R.add(o.buffer);return{$$vscode_array_buffer_reference$$:!0,index:c,view:{type:g,byteLength:o.byteLength,byteOffset:o.byteOffset}}}}return o},_=JSON.stringify(P,F),n=R.buffers.map(f=>{const o=new Uint8Array(f);return a.VSBuffer.wrap(o)});return{message:_,buffers:n}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=w;function T(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function k(P,C){const R=C.map(n=>{const f=new ArrayBuffer(n.byteLength);return new Uint8Array(f).set(n.buffer),f}),F=C.length?(n,f)=>{if(typeof f=="object"&&f.$$vscode_array_buffer_reference$$){const o=f,{index:g}=o,c=R[g];if(o.view)switch(o.view.type){case 1:return new Int8Array(c,o.view.byteOffset,o.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(c,o.view.byteOffset,o.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(c,o.view.byteOffset,o.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(c,o.view.byteOffset,o.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(c,o.view.byteOffset,o.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(c,o.view.byteOffset,o.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(c,o.view.byteOffset,o.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(c,o.view.byteOffset,o.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(c,o.view.byteOffset,o.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(c,o.view.byteOffset,o.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(c,o.view.byteOffset,o.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return c}return f}:void 0;return{message:JSON.parse(P,F),arrayBuffers:R}}e.deserializeWebviewMessage=k}),define(Ee[153],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var a;(function(t){function w(k){const P=new Map;return k.types.forEach((C,R)=>{P.set(C,{asString:async()=>k.items[R].asString})}),P}t.toITreeDataTransfer=w;async function T(k){const P={types:[],items:[]},C=Array.from(k.entries());for(const R of C)P.types.push(R[0]),P.items.push({asString:await R[1].asString()});return P}t.toTreeDataTransferDTO=T})(a=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(Ee[66],ye([0,1,10,2]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function w(P,C){return P.scheme===a.Schemas.http||P.scheme===a.Schemas.https?P:(C&&C.authority&&C.isRemote&&P.scheme===a.Schemas.file&&(P=t.URI.from({scheme:a.Schemas.vscodeRemote,authority:C.authority,path:P.path})),t.URI.from({scheme:a.Schemas.https,authority:`${P.scheme}+${T(P.authority)}.${e.webviewRootResourceAuthority}`,path:P.path,fragment:P.fragment,query:P.query}))}e.asWebviewUri=w;function T(P){return P.replace(/./g,C=>{const R=C.charCodeAt(0);return R>=97&&R<=122||R>=65&&R<=90||R>=48&&R<=57?C:"-"+R.toString(16).padStart(4,"0")})}function k(P){return P.replace(/-([0-9a-f]{4})/g,(C,R)=>String.fromCharCode(parseInt(R,16)))}e.decodeAuthority=k}),define(Ee[154],ye([0,1,4,6,66]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class T{constructor(P,C,R){this._proxy=P,this._editors=C,this._initData=R,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(C.onDidChangeVisibleTextEditors(()=>{const F=C.getVisibleTextEditors();for(const _ of this._insets.values())F.indexOf(_.editor)<0&&_.inset.dispose()}))}dispose(){this._insets.forEach(P=>P.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(P,C,R,F,_){let n;for(const h of this._editors.getVisibleTextEditors(!0))if(h.value===P){n=h;break}if(!n)throw new Error("not a visible editor");const f=this,o=this._handlePool++,g=new a.Emitter,c=new a.Emitter,D=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(h){return(0,w.asWebviewUri)(h,f._initData.remote)}get cspSource(){return w.webviewGenericCspSource}set options(h){this._options=h,f._proxy.$setOptions(o,h)}get options(){return this._options}set html(h){this._html=h,f._proxy.$setHtml(o,h)}get html(){return this._html}get onDidReceiveMessage(){return g.event}postMessage(h){return f._proxy.$postMessage(o,h)}},v=new class{constructor(){this.editor=P,this.line=C,this.height=R,this.webview=D,this.onDidDispose=c.event}dispose(){f._insets.has(o)&&(f._insets.delete(o),f._proxy.$disposeEditorInset(o),c.fire(),c.dispose(),g.dispose())}};return this._proxy.$createEditorInset(o,n.id,n.value.document.uri,C+1,R,F||{},_.identifier,_.extensionLocation),this._insets.set(o,{editor:P,inset:v,onDidReceiveMessage:g}),v}$onDidDispose(P){const C=this._insets.get(P);C&&C.inset.dispose()}$onDidReceiveMessage(P,C){const R=this._insets.get(P);R&&R.onDidReceiveMessage.fire(C)}}e.ExtHostEditorInsets=T}),define(Ee[155],ye([0,1,126,11,2,6,3,44,36,45,16,10]),function(re,e,a,t,w,T,k,P,C,R,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,a.localize)(0,null),providerDisplayName:(0,a.localize)(1,null)},e.ActiveEditorDirtyContext=new P.RawContextKey("activeEditorIsDirty",!1,(0,a.localize)(2,null)),e.ActiveEditorPinnedContext=new P.RawContextKey("activeEditorIsNotPreview",!1,(0,a.localize)(3,null)),e.ActiveEditorStickyContext=new P.RawContextKey("activeEditorIsPinned",!1,(0,a.localize)(4,null)),e.ActiveEditorReadonlyContext=new P.RawContextKey("activeEditorIsReadonly",!1,(0,a.localize)(5,null)),e.ActiveEditorCanRevertContext=new P.RawContextKey("activeEditorCanRevert",!1,(0,a.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new P.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new P.RawContextKey("activeEditor",null,{type:"string",description:(0,a.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new P.RawContextKey("activeEditorAvailableEditorIds","",(0,a.localize)(8,null)),e.TextCompareEditorVisibleContext=new P.RawContextKey("textCompareEditorVisible",!1,(0,a.localize)(9,null)),e.TextCompareEditorActiveContext=new P.RawContextKey("textCompareEditorActive",!1,(0,a.localize)(10,null)),e.SideBySideEditorActiveContext=new P.RawContextKey("sideBySideEditorActive",!1,(0,a.localize)(11,null)),e.EditorGroupEditorsCountContext=new P.RawContextKey("groupEditorsCount",0,(0,a.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new P.RawContextKey("activeEditorGroupEmpty",!1,(0,a.localize)(13,null)),e.ActiveEditorGroupIndexContext=new P.RawContextKey("activeEditorGroupIndex",0,(0,a.localize)(14,null)),e.ActiveEditorGroupLastContext=new P.RawContextKey("activeEditorGroupLast",!1,(0,a.localize)(15,null)),e.ActiveEditorGroupLockedContext=new P.RawContextKey("activeEditorGroupLocked",!1,(0,a.localize)(16,null)),e.MultipleEditorGroupsContext=new P.RawContextKey("multipleEditorGroups",!1,(0,a.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new P.RawContextKey("editorIsOpen",!1,(0,a.localize)(18,null)),e.InEditorZenModeContext=new P.RawContextKey("inZenMode",!1,(0,a.localize)(19,null)),e.IsCenteredLayoutContext=new P.RawContextKey("isCenteredLayout",!1,(0,a.localize)(20,null)),e.SplitEditorsVertically=new P.RawContextKey("splitEditorsVertically",!1,(0,a.localize)(21,null)),e.EditorAreaVisibleContext=new P.RawContextKey("editorAreaVisible",!0,(0,a.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function n(E,L,z){for(const N of z.visibleEditorPanes)if(N.group.id===L&&E.matches(N.input))return N.getViewState()}e.findViewStateForEditor=n;function f(E){if(I(E))return!1;const L=E;return w.URI.isUri(L?.resource)}e.isResourceEditorInput=f;function o(E){if(I(E))return!1;const L=E;return L?.original!==void 0&&L.modified!==void 0}e.isResourceDiffEditorInput=o;function g(E){if(I(E)||o(E))return!1;const L=E;return L?.primary!==void 0&&L.secondary!==void 0}e.isResourceSideBySideEditorInput=g;function c(E){if(I(E))return!1;const L=E;return L?L.resource===void 0||L.resource.scheme===_.Schemas.untitled||L.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=c;var D;(function(E){E[E.SHORT=0]="SHORT",E[E.MEDIUM=1]="MEDIUM",E[E.LONG=2]="LONG"})(D=e.Verbosity||(e.Verbosity={}));var v;(function(E){E[E.EXPLICIT=1]="EXPLICIT",E[E.AUTO=2]="AUTO",E[E.FOCUS_CHANGE=3]="FOCUS_CHANGE",E[E.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(v=e.SaveReason||(e.SaveReason={}));var h;(function(E){E[E.None=0]="None",E[E.Readonly=2]="Readonly",E[E.Untitled=4]="Untitled",E[E.Singleton=8]="Singleton",E[E.RequiresTrust=16]="RequiresTrust",E[E.CanSplitInGroup=32]="CanSplitInGroup",E[E.ForceDescription=64]="ForceDescription"})(h=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class p extends T.Disposable{}e.AbstractEditorInput=p;function I(E){return E instanceof p}e.isEditorInput=I;function l(E){const L=E;return w.URI.isUri(L?.preferredResource)}function M(E){const L=E;return I(L?.primary)&&I(L?.secondary)}e.isSideBySideEditorInput=M;function r(E){const L=E;return I(L?.modified)&&I(L?.original)}e.isDiffEditorInput=r;function i(E){return I(E?.editor)}e.isEditorInputWithOptions=i;function m(E){const L=E;return i(E)&&L?.group!==void 0}e.isEditorInputWithOptionsAndGroup=m;function d(E){const L=E;return typeof L?.groupId=="number"&&I(L.editor)}e.isEditorIdentifier=d;var s;(function(E){E[E.UNKNOWN=0]="UNKNOWN",E[E.REPLACE=1]="REPLACE",E[E.MOVE=2]="MOVE",E[E.UNPIN=3]="UNPIN"})(s=e.EditorCloseContext||(e.EditorCloseContext={}));var b;(function(E){E[E.GROUP_ACTIVE=0]="GROUP_ACTIVE",E[E.GROUP_INDEX=1]="GROUP_INDEX",E[E.GROUP_LOCKED=2]="GROUP_LOCKED",E[E.EDITOR_OPEN=3]="EDITOR_OPEN",E[E.EDITOR_CLOSE=4]="EDITOR_CLOSE",E[E.EDITOR_MOVE=5]="EDITOR_MOVE",E[E.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",E[E.EDITOR_LABEL=7]="EDITOR_LABEL",E[E.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",E[E.EDITOR_PIN=9]="EDITOR_PIN",E[E.EDITOR_STICKY=10]="EDITOR_STICKY",E[E.EDITOR_DIRTY=11]="EDITOR_DIRTY",E[E.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(b=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var y;(function(E){E[E.PRIMARY=1]="PRIMARY",E[E.SECONDARY=2]="SECONDARY",E[E.BOTH=3]="BOTH",E[E.ANY=4]="ANY"})(y=e.SideBySideEditor||(e.SideBySideEditor={}));class u{getOriginalUri(L,z){if(!L)return;if(z?.supportSideBySide){const{primary:B,secondary:j}=this.getSideEditors(L);if(B&&j){if(z?.supportSideBySide===y.BOTH)return{primary:this.getOriginalUri(B,{filterByScheme:z.filterByScheme}),secondary:this.getOriginalUri(j,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===y.ANY)return this.getOriginalUri(B,{filterByScheme:z.filterByScheme})??this.getOriginalUri(j,{filterByScheme:z.filterByScheme});L=z.supportSideBySide===y.PRIMARY?B:j}}if(o(L)||g(L))return;const N=l(L)?L.preferredResource:L.resource;return!N||!z||!z.filterByScheme?N:this.filterUri(N,z.filterByScheme)}getSideEditors(L){return M(L)||g(L)?{primary:L.primary,secondary:L.secondary}:r(L)||o(L)?{primary:L.modified,secondary:L.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(L,z){if(!L)return;if(z?.supportSideBySide){const{primary:B,secondary:j}=this.getSideEditors(L);if(B&&j){if(z?.supportSideBySide===y.BOTH)return{primary:this.getCanonicalUri(B,{filterByScheme:z.filterByScheme}),secondary:this.getCanonicalUri(j,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===y.ANY)return this.getCanonicalUri(B,{filterByScheme:z.filterByScheme})??this.getCanonicalUri(j,{filterByScheme:z.filterByScheme});L=z.supportSideBySide===y.PRIMARY?B:j}}if(o(L)||g(L))return;const N=L.resource;return!N||!z||!z.filterByScheme?N:this.filterUri(N,z.filterByScheme)}filterUri(L,z){if(Array.isArray(z)){if(z.some(N=>L.scheme===N))return L}else if(z===L.scheme)return L}}e.EditorResourceAccessor=new u;var S;(function(E){E[E.LEFT=0]="LEFT",E[E.RIGHT=1]="RIGHT"})(S=e.CloseDirection||(e.CloseDirection={}));class A{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(L){const z=this.instantiationService=L.get(k.IInstantiationService);for(const[N,B]of this.editorSerializerConstructors)this.createEditorSerializer(N,B,z);this.editorSerializerConstructors.clear()}createEditorSerializer(L,z,N){const B=N.createInstance(z);this.editorSerializerInstances.set(L,B)}registerFileEditorFactory(L){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=L}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(L,z){if(this.editorSerializerConstructors.has(L)||this.editorSerializerInstances.has(L))throw new Error(`A editor serializer with type ID '${L}' was already registered.`);return this.instantiationService?this.createEditorSerializer(L,z,this.instantiationService):this.editorSerializerConstructors.set(L,z),(0,T.toDisposable)(()=>{this.editorSerializerConstructors.delete(L),this.editorSerializerInstances.delete(L)})}getEditorSerializer(L){return this.editorSerializerInstances.get(typeof L=="string"?L:L.typeId)}}C.Registry.add(e.EditorExtensions.EditorFactory,new A);async function U(E,L){if(!E||!E.length)return[];const z=await Promise.all(E.map(async N=>{const B=w.URI.revive(N.fileUri);if(!B||!await L.canHandleResource(B))return;let ce=N.exists,K=N.type;if(typeof ce!="boolean"||typeof K!="number")try{K=(await L.resolve(B)).isDirectory?R.FileType.Directory:R.FileType.Unknown,ce=!0}catch{ce=!1}if(!ce&&N.openOnlyIfExists||K===R.FileType.Directory)return;const le={selection:ce?N.selection:void 0,pinned:!0,override:N.editorOverrideId};let ue;return ce?ue={resource:B,options:le}:ue={resource:B,options:le,forceUntitled:!0},ue}));return(0,F.coalesce)(z)}e.pathsToEditors=U;var H;(function(E){E[E.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",E[E.SEQUENTIAL=1]="SEQUENTIAL"})(H=e.EditorsOrder||(e.EditorsOrder={}))}),define(Ee[156],ye([0,1,4,14,127]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new a.Emitter,this._onExit=new a.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,C,R,F){const _={command:P};if(C&&Object.keys(C).length>0&&(_.arguments=C),this.internalSend("request",_),typeof F=="number"){const n=setTimeout(()=>{clearTimeout(n);const f=this.pendingRequests.get(_.seq);if(f){this.pendingRequests.delete(_.seq);const o={type:"response",seq:0,request_seq:_.seq,success:!1,command:P,message:(0,w.localize)(0,null,F,P)};f(o)}},F)}return R&&this.pendingRequests.set(_.seq,R),_.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,C){return P.type!=="event"||C.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await(0,t.timeout)(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback&&this.eventCallback(P);break;case"request":this.requestCallback&&this.requestCallback(P);break;case"response":{const C=P,R=this.pendingRequests.get(C.request_seq);R&&(this.pendingRequests.delete(C.request_seq),R(C));break}}}}internalSend(P,C){C.type=P,C.seq=this.sequence++,this.sendMessage(C)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((C,R)=>P.set(R,C)),await(0,t.timeout)(500),P.forEach((C,R)=>{C({type:"response",seq:0,request_seq:R,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(R)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(Ee[157],ye([0,1,9,2,17,26,10]),function(re,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function C(r,i,m){return r.replace(P,function(d,s){return i&&s.length>0&&s[0]!=="_"?d:m&&m.hasOwnProperty(s)?m[s]:d})}e.formatPII=C;function R(r){const i={};for(const m of Object.keys(r))m.startsWith("!")||(i[m]=r[m]);return i}e.filterExceptionsFromTelemetry=R;function F(r){return r.configuration.request==="attach"&&!_(r)&&(!r.parentSession||F(r.parentSession))}e.isSessionAttach=F;function _(r){let i=r.configuration.type;if(!!i)return i==="vslsShare"&&(i=r.configuration.adapterProxy.configuration.type),(0,a.equalsIgnoreCase)(i,"extensionhost")||(0,a.equalsIgnoreCase)(i,"pwa-extensionhost")?r:r.parentSession?_(r.parentSession):void 0}e.getExtensionHostDebugSession=_;function n(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=n;function f(r,i,m){let d,s=0,b=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,y=null;for(;y=b.exec(r);){let u=y.index+1,S=u+y[0].length;if(u<=i&&S>=m){d=y[0],s=u;break}}if(d){let u=/\w+/g,S=null;for(;(S=u.exec(d))&&!(S.index+1+s+S[0].length>=m););S&&(d=d.substring(0,u.lastIndex))}return d?{start:s,end:s+d.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=f;const o=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function g(r){return!!(r&&r.match(o))}e.isUri=g;function c(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(g(r.path))return t.URI.parse(r.path);if((0,w.isAbsolute)(r.path))return t.URI.file(r.path)}return r.path}function D(r){if(typeof r.path=="object"){const i=t.URI.revive(r.path);if(i)return i.scheme===k.Schemas.file?i.fsPath:i.toString()}return r.path}function v(r,i){const m=i?c:D,d=(0,T.deepClone)(r);return p(d,(s,b)=>{s&&b&&(b.path=m(b))}),d}e.convertToDAPaths=v;function h(r,i){const m=i?c:D,d=(0,T.deepClone)(r);return p(d,(s,b)=>{!s&&b&&(b.path=m(b))}),d}e.convertToVSCPaths=h;function p(r,i){switch(r.type){case"event":{const m=r;switch(m.event){case"output":i(!1,m.body.source);break;case"loadedSource":i(!1,m.body.source);break;case"breakpoint":i(!1,m.body.breakpoint.source);break;default:break}break}case"request":{const m=r;switch(m.command){case"setBreakpoints":i(!0,m.arguments.source);break;case"breakpointLocations":i(!0,m.arguments.source);break;case"source":i(!0,m.arguments.source);break;case"gotoTargets":i(!0,m.arguments.source);break;case"launchVSCode":m.arguments.args.forEach(d=>i(!1,d));break;default:break}break}case"response":{const m=r;if(m.success&&m.body)switch(m.command){case"stackTrace":m.body.stackFrames.forEach(d=>i(!1,d.source));break;case"loadedSources":m.body.sources.forEach(d=>i(!1,d));break;case"scopes":m.body.scopes.forEach(d=>i(!1,d.source));break;case"setFunctionBreakpoints":m.body.breakpoints.forEach(d=>i(!1,d.source));break;case"setBreakpoints":m.body.breakpoints.forEach(d=>i(!1,d.source));break;default:break}break}}}function I(r){return r.filter(i=>!i.presentation?.hidden).sort((i,m)=>i.presentation?m.presentation?i.presentation.group?m.presentation.group?i.presentation.group!==m.presentation.group?i.presentation.group.localeCompare(m.presentation.group):l(i.presentation.order,m.presentation.order):-1:m.presentation.group?1:l(i.presentation.order,m.presentation.order):-1:m.presentation?1:0)}e.getVisibleAndSorted=I;function l(r,i){return typeof r!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:r-i}async function M(r,i){const m=r.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorMode});if(m!=="none"&&(await i.saveAll(),m==="allEditorsInActiveGroup")){const d=i.activeEditorPane;d&&await i.save({editor:d.input,groupId:d.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=M}),define(Ee[87],ye([0,1,29,158,78,10,17,23,44]),function(re,e,a,t,w,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var R;(function(u){u[u.Markup=1]="Markup",u[u.Code=2]="Code"})(R=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",w.Mimes.latex,w.Mimes.markdown,"image/png","image/jpeg",w.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[w.Mimes.latex,w.Mimes.markdown,"application/json",w.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var F;(function(u){u[u.Running=1]="Running",u[u.Idle=2]="Idle"})(F=e.NotebookRunState||(e.NotebookRunState={}));var _;(function(u){u[u.Pending=2]="Pending",u[u.Executing=3]="Executing"})(_=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var n;(function(u){u[u.WithHardKernelDependency=0]="WithHardKernelDependency",u[u.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",u[u.Pure=2]="Pure",u[u.Never=3]="Never"})(n=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var f;(function(u){u.Always="always",u.Never="never",u.Optional="optional"})(f=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var o;(function(u){u[u.ModelChange=1]="ModelChange",u[u.Move=2]="Move",u[u.ChangeLanguage=5]="ChangeLanguage",u[u.Initialize=6]="Initialize",u[u.ChangeCellMetadata=7]="ChangeCellMetadata",u[u.Output=8]="Output",u[u.OutputItem=9]="OutputItem",u[u.ChangeCellContent=10]="ChangeCellContent",u[u.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",u[u.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",u[u.ChangeCellMime=13]="ChangeCellMime",u[u.Unknown=100]="Unknown"})(o=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var g;(function(u){u[u.Handle=0]="Handle",u[u.Index=1]="Index"})(g=e.SelectionStateType||(e.SelectionStateType={}));var c;(function(u){u[u.Replace=1]="Replace",u[u.Output=2]="Output",u[u.Metadata=3]="Metadata",u[u.CellLanguage=4]="CellLanguage",u[u.DocumentMetadata=5]="DocumentMetadata",u[u.Move=6]="Move",u[u.OutputItems=7]="OutputItems",u[u.PartialMetadata=8]="PartialMetadata",u[u.PartialInternalMetadata=9]="PartialInternalMetadata"})(c=e.CellEditType||(e.CellEditType={}));var D;(function(u){u.scheme=T.Schemas.vscodeNotebookCell;const S=/^ch(\d{7,})/;function A(N,B){return N.with({scheme:u.scheme,fragment:`ch${B.toString().padStart(7,"0")}${N.scheme!==T.Schemas.file?N.scheme:""}`})}u.generate=A;function U(N){if(N.scheme!==u.scheme)return;const B=S.exec(N.fragment);return B?{handle:Number(B[1]),notebook:N.with({scheme:N.fragment.substr(B[0].length)||T.Schemas.file,fragment:null})}:void 0}u.parse=U;function H(N,B,j){return N.with({scheme:T.Schemas.vscodeNotebookCellOutput,fragment:`ch${B.toString().padStart(7,"0")},${j??""},${N.scheme!==T.Schemas.file?N.scheme:""}`})}u.generateCellOutputUri=H;function E(N){if(N.scheme!==T.Schemas.vscodeNotebookCellOutput)return;const B=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(N.fragment);if(!B)return;const j=Number(B[1]),ce=B[2]&&B[2]!==""?B[2]:void 0,K=B[3];return{handle:j,outputId:ce,notebook:N.with({scheme:K||T.Schemas.file,fragment:null})}}u.parseCellOutputUri=E;function L(N,B,j){return N.with({scheme:j,fragment:`ch${B.toString().padStart(7,"0")}${N.scheme!==T.Schemas.file?N.scheme:""}`})}u.generateCellUri=L;function z(N,B){if(N.scheme!==B)return;const j=S.exec(N.fragment);return j?{handle:Number(j[1]),notebook:N.with({scheme:N.fragment.substr(j[0].length)||T.Schemas.file,fragment:null})}:void 0}u.parseCellUri=z})(D=e.CellUri||(e.CellUri={}));const v=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[w.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[w.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function h(u){return v.get(u)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=h;function p(u){return v.get(u)?.supportedByCore??!1}e.mimeTypeSupportedByCore=p;function I(u){return v.get(u)?.mergeable??!1}e.mimeTypeIsMergeable=I;const l=u=>P.isWindows?u.replace(/\//g,"\\"):u;class M{constructor(S=[],A=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=A,this.order=[...new Set(S)].map(U=>({pattern:U,matches:a.parse(l(U))}))}sort(S){const A=new Map(t.Iterable.map(S,H=>[H,l(H)]));let U=[];for(const{matches:H}of this.order)for(const[E,L]of A)if(H(L)){U.push(E),A.delete(E);break}return A.size&&(U=U.concat([...A.keys()].sort((H,E)=>this.defaultOrder.indexOf(H)-this.defaultOrder.indexOf(E)))),U}prioritize(S,A){const U=this.findIndex(S);if(U===-1){this.order.unshift({pattern:S,matches:a.parse(l(S))});return}const H=new Set(A.map(L=>this.findIndex(L,U)));H.delete(-1);const E=Array.from(H).sort();this.order.splice(U+1,0,...E.map(L=>this.order[L]));for(let L=E.length-1;L>=0;L--)this.order.splice(E[L],1)}toArray(){return this.order.map(S=>S.pattern)}findIndex(S,A=this.order.length){const U=l(S);for(let H=0;H<A;H++)if(this.order[H].matches(U))return H;return-1}}e.MimeTypeDisplayOrder=M;function r(u,S,A,U=(H,E)=>H===E){const H=[];function E(N,B,j){if(B===0&&j.length===0)return;const ce=H[H.length-1];ce&&ce.start+ce.deleteCount===N?(ce.deleteCount+=B,ce.toInsert.push(...j)):H.push({start:N,deleteCount:B,toInsert:j})}let L=0,z=0;for(;;){if(L===u.length){E(L,0,S.slice(z));break}if(z===S.length){E(L,u.length-L,[]);break}const N=u[L],B=S[z];if(U(N,B)){L+=1,z+=1;continue}A(B)?(E(L,1,[]),L+=1):(E(L,0,[B]),z+=1)}return H}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(u){u.default="default",u.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function m(u){const S=u;return!!((typeof S.include=="string"||a.isRelativePattern(S.include))&&(typeof S.exclude=="string"||a.isRelativePattern(S.exclude)))}e.isDocumentExcludePattern=m;function d(u,S,A){if(Array.isArray(u.viewType)&&u.viewType.indexOf(S)>=0||u.viewType===S)return!0;if(u.filenamePattern){let U=m(u.filenamePattern)?u.filenamePattern.include:u.filenamePattern,H=m(u.filenamePattern)?u.filenamePattern.exclude:void 0;if(a.match(U,(0,k.basename)(A.fsPath).toLowerCase()))return!(H&&a.match(H,(0,k.basename)(A.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=d;class s{constructor(S){this.textModel=S}getElements(){const S=new Int32Array(this.textModel.cells.length);for(let A=0;A<this.textModel.cells.length;A++)S[A]=this.textModel.cells[A].getHashValue();return S}}e.CellSequence=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize"};var b;(function(u){u[u.Left=1]="Left",u[u.Right=2]="Right"})(b=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class y{static create(S){return`${y._prefix}${S}`}static parse(S){if(S.startsWith(y._prefix))return S.substr(y._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=y,y._prefix="notebook/"}),define(Ee[159],ye([0,1,3]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(w){w[w.Output=1]="Output",w[w.OutputItems=2]="OutputItems",w[w.ExecutionState=3]="ExecutionState",w[w.Complete=4]="Complete"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,a.createDecorator)("INotebookExecutionService")}),define(Ee[160],ye([0,1,3,44]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new t.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new t.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new t.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,a.createDecorator)(e.OUTPUT_SERVICE_ID);var w;(function(T){T[T.Append=1]="Append",T[T.Replace=2]="Replace",T[T.Clear=3]="Clear"})(w=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(Ee[161],ye([0,1,129,3,44]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new w.RawContextKey("customExecutionSupported",!0,a.localize(0,null)),e.ShellExecutionSupportedContext=new w.RawContextKey("shellExecutionSupported",!1,a.localize(1,null)),e.ProcessExecutionSupportedContext=new w.RawContextKey("processExecutionSupported",!1,a.localize(2,null)),e.ITaskService=(0,t.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(Ee[162],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function a(w){return[...w.entries()]}e.serializeEnvironmentVariableCollection=a;function t(w){return new Map(w)}e.deserializeEnvironmentVariableCollection=t}),define(Ee[88],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var a;(function(_){_[_.Unset=0]="Unset",_[_.Queued=1]="Queued",_[_.Running=2]="Running",_[_.Passed=3]="Passed",_[_.Failed=4]="Failed",_[_.Skipped=5]="Skipped",_[_.Errored=6]="Errored"})(a=e.TestResultState||(e.TestResultState={}));var t;(function(_){_[_.Run=2]="Run",_[_.Debug=4]="Debug",_[_.Coverage=8]="Coverage",_[_.HasNonDefaultProfile=16]="HasNonDefaultProfile",_[_.HasConfigurable=32]="HasConfigurable"})(t=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var w;(function(_){_[_.Error=0]="Error",_[_.Info=1]="Info"})(w=e.TestMessageType||(e.TestMessageType={}));var T;(function(_){_[_.NotExpandable=0]="NotExpandable",_[_.Expandable=1]="Expandable",_[_.BusyExpanding=2]="BusyExpanding",_[_.Expanded=3]="Expanded"})(T=e.TestItemExpandState||(e.TestItemExpandState={}));const k=(_,n)=>{n.expand!==void 0&&(_.expand=n.expand),n.item!==void 0&&(_.item=_.item?Object.assign(_.item,n.item):n.item)};e.applyTestItemUpdate=k;var P;(function(_){_[_.Function=0]="Function",_[_.Statement=1]="Statement"})(P=e.DetailType||(e.DetailType={}));var C;(function(_){_[_.Add=0]="Add",_[_.Update=1]="Update",_[_.Remove=2]="Remove",_[_.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",_[_.Retire=4]="Retire",_[_.AddTag=5]="AddTag",_[_.RemoveTag=6]="RemoveTag"})(C=e.TestDiffOpType||(e.TestDiffOpType={}));class R{add(n){}update(n){}remove(n,f){}complete(){}}e.IncrementalChangeCollector=R;class F{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const f=this.createChangeCollector();for(const o of n)switch(o[0]){case 0:{const g=o[1];if(g.parent){if(this.items.has(g.parent)){const c=this.items.get(g.parent);c.children.add(g.item.extId);const D=this.createItem(g,c);this.items.set(g.item.extId,D),f.add(D)}}else{const c=this.createItem(g);this.roots.add(c),this.items.set(g.item.extId,c),f.add(c)}g.expand===2&&this.busyControllerCount++;break}case 1:{const g=o[1],c=this.items.get(g.extId);if(!c)break;g.expand!==void 0&&(c.expand===2&&this.busyControllerCount--,g.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(c,g),f.update(c);break}case 2:{const g=this.items.get(o[1]);if(!g)break;g.parent?this.items.get(g.parent).children.delete(g.item.extId):this.roots.delete(g);const c=[[o[1]]];for(;c.length;)for(const D of c.pop()){const v=this.items.get(D);v&&(c.push(v.children),this.items.delete(D),f.remove(v,v!==g),v.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(o[1]);break;case 3:this.updatePendingRoots(o[1]);break;case 5:this._tags.set(o[1].id,o[1]);break;case 6:this._tags.delete(o[1]);break}f.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new R}}e.AbstractIncrementalTestCollection=F}),define(Ee[67],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var a;(function(T){T.Delimiter="\0"})(a=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(T){T[T.IsSame=0]="IsSame",T[T.Disconnected=1]="Disconnected",T[T.IsChild=2]="IsChild",T[T.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class w{constructor(k,P=k.length){if(this.path=k,this.viewEnd=P,k.length===0||P<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(k,P,C=k.parent){if(k.id===P)return new w([P]);let R=[k.id];for(let F=C;F&&F.id!==P;F=F.parent)R.push(F.id);return R.push(P),new w(R.reverse())}static isRoot(k){return!k.includes("\0")}static fromString(k){return new w(k.split("\0"))}static join(k,P){return new w([...k.path,P])}static joinToString(k,P){return k.toString()+"\0"+P}static compare(k,P){return k===P?0:P.startsWith(k+"\0")?2:k.startsWith(P+"\0")?3:1}get parentId(){return this.viewEnd>1?new w(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let k=1;k<=this.viewEnd;k++)yield new w(this.path,k)}compare(k){if(typeof k=="string")return w.compare(this.toString(),k);for(let P=0;P<k.viewEnd&&P<this.viewEnd;P++)if(k.path[P]!==this.path[P])return 1;return k.viewEnd>this.viewEnd?2:k.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let k=1;k<this.viewEnd;k++)this.stringifed+="\0",this.stringifed+=this.path[k]}return this.stringifed}}e.TestId=w}),define(Ee[163],ye([0,1,17,89,11,26,23,77,130]),function(re,e,a,t,w,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class R{constructor(_,n,f){this._contributedVariables=new Map,this._context=_,this._labelService=n,f&&(this._envVariablesPromise=f.then(o=>this.prepareEnv(o)))}prepareEnv(_){if(k.isWindows){const n=Object.create(null);return Object.keys(_).forEach(f=>{n[f.toLowerCase()]=_[f]}),n}return _}resolveWithEnvironment(_,n,f){return this.recursiveResolve(this.prepareEnv(_),n?n.uri:void 0,f)}async resolveAsync(_,n){return this.recursiveResolve(await this._envVariablesPromise,_?_.uri:void 0,n)}async resolveAnyBase(_,n,f,o){const g=T.deepClone(n);return k.isWindows&&g.windows?Object.keys(g.windows).forEach(c=>g[c]=g.windows[c]):k.isMacintosh&&g.osx?Object.keys(g.osx).forEach(c=>g[c]=g.osx[c]):k.isLinux&&g.linux&&Object.keys(g.linux).forEach(c=>g[c]=g.linux[c]),delete g.windows,delete g.osx,delete g.linux,this.recursiveResolve(await this._envVariablesPromise,_?_.uri:void 0,g,f,o)}async resolveAnyAsync(_,n,f){return this.resolveAnyBase(_,n,f)}async resolveAnyMap(_,n,f){const o=new Map;return{newConfig:await this.resolveAnyBase(_,n,f,o),resolvedVariables:o}}resolveWithInteractionReplace(_,n,f,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(_,n,f,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(_,n){if(this._contributedVariables.has(_))throw new Error("Variable "+_+" is contributed twice.");this._contributedVariables.set(_,n)}recursiveResolve(_,n,f,o,g){if(w.isString(f))return this.resolveString(_,n,f,o,g);if(w.isArray(f))return f.map(c=>this.recursiveResolve(_,n,c,o,g));if(w.isObject(f)){let c=Object.create(null);return Object.keys(f).forEach(D=>{const v=this.resolveString(_,n,D,o,g);c[v]=this.recursiveResolve(_,n,f[D],o,g)}),c}return f}resolveString(_,n,f,o,g){return f.replace(R.VARIABLE_REGEXP,(D,v)=>{if(v.includes(R.VARIABLE_LHS))return D;let h=this.evaluateSingleVariable(_,D,v,n,o);return g&&g.set(v,h),h!==D&&w.isString(h)&&h.match(R.VARIABLE_REGEXP)&&(h=this.resolveString(_,n,h,o,g)),h})}fsPath(_){return this._labelService?this._labelService.getUriLabel(_,{noPrefix:!0}):_.fsPath}evaluateSingleVariable(_,n,f,o,g){let c;const D=f.split(":");D.length>1&&(f=D[0],c=D[1]);const v=()=>{const I=this._context.getFilePath();if(I)return I;throw new Error((0,C.localize)(0,null,n))},h=()=>{const I=v();if(this._context.getWorkspaceFolderPathForFile){const l=this._context.getWorkspaceFolderPathForFile();if(l)return l}throw new Error((0,C.localize)(1,null,n,a.basename(I)))},p=()=>{if(c){const I=this._context.getFolderUri(c);if(I)return I;throw new Error((0,C.localize)(2,null,n,c))}if(o)return o;throw this._context.getWorkspaceFolderCount()>1?new Error((0,C.localize)(3,null,n)):new Error((0,C.localize)(4,null,n))};switch(f){case"env":if(c){if(_){const I=_[k.isWindows?c.toLowerCase():c];if(w.isString(I))return I}return""}throw new Error((0,C.localize)(5,null,n));case"config":if(c){const I=this._context.getConfigurationValue(o,c);if(w.isUndefinedOrNull(I))throw new Error((0,C.localize)(6,null,n,c));if(w.isObject(I))throw new Error((0,C.localize)(7,null,n,c));return I}throw new Error((0,C.localize)(8,null,n));case"command":return this.resolveFromMap(n,c,g,"command");case"input":return this.resolveFromMap(n,c,g,"input");default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.fsPath(p()));case"cwd":return o||c?(0,P.normalizeDriveLetter)(this.fsPath(p())):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return a.basename(this.fsPath(p()));case"lineNumber":{const I=this._context.getLineNumber();if(I)return I;throw new Error((0,C.localize)(9,null,n))}case"selectedText":{const I=this._context.getSelectedText();if(I)return I;throw new Error((0,C.localize)(10,null,n))}case"file":return v();case"fileWorkspaceFolder":return h();case"relativeFile":return o||c?a.relative(this.fsPath(p()),v()):v();case"relativeFileDirname":{const I=a.dirname(v());if(o||c){const l=a.relative(this.fsPath(p()),I);return l.length===0?".":l}return I}case"fileDirname":return a.dirname(v());case"fileExtname":return a.extname(v());case"fileBasename":return a.basename(v());case"fileBasenameNoExtension":{const I=a.basename(v());return I.slice(0,I.length-a.extname(I).length)}case"fileDirnameBasename":return a.basename(a.dirname(v()));case"execPath":{const I=this._context.getExecPath();return I||n}case"execInstallFolder":{const I=this._context.getAppRoot();return I||n}case"pathSeparator":return a.sep;default:try{const I=c?`${f}:${c}`:f;return this.resolveFromMap(n,I,g,void 0)}catch{return n}}}}resolveFromMap(_,n,f,o){if(n&&f){const g=o===void 0?f[n]:f[o+":"+n];if(typeof g=="string")return g;throw new Error((0,C.localize)(11,null,_))}return _}}e.AbstractVariableResolverService=R,R.VARIABLE_LHS="${",R.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ee[90],ye([0,1,3,155]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,a.createDecorator)("editorGroupsService");var w;(function(o){o[o.UP=0]="UP",o[o.DOWN=1]="DOWN",o[o.LEFT=2]="LEFT",o[o.RIGHT=3]="RIGHT"})(w=e.GroupDirection||(e.GroupDirection={}));var T;(function(o){o[o.HORIZONTAL=0]="HORIZONTAL",o[o.VERTICAL=1]="VERTICAL"})(T=e.GroupOrientation||(e.GroupOrientation={}));var k;(function(o){o[o.FIRST=0]="FIRST",o[o.LAST=1]="LAST",o[o.NEXT=2]="NEXT",o[o.PREVIOUS=3]="PREVIOUS"})(k=e.GroupLocation||(e.GroupLocation={}));var P;(function(o){o[o.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",o[o.EVEN=1]="EVEN",o[o.TOGGLE=2]="TOGGLE"})(P=e.GroupsArrangement||(e.GroupsArrangement={}));var C;(function(o){o[o.COPY_EDITORS=0]="COPY_EDITORS",o[o.MOVE_EDITORS=1]="MOVE_EDITORS"})(C=e.MergeGroupMode||(e.MergeGroupMode={}));function R(o){const g=o;return(0,t.isEditorInput)(g?.editor)&&(0,t.isEditorInput)(g?.replacement)}e.isEditorReplacement=R;var F;(function(o){o[o.CREATION_TIME=0]="CREATION_TIME",o[o.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",o[o.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(F=e.GroupsOrder||(e.GroupsOrder={}));var _;(function(o){o[o.NEW_EDITOR=1]="NEW_EDITOR",o[o.MOVE_EDITOR=2]="MOVE_EDITOR",o[o.COPY_EDITOR=3]="COPY_EDITOR"})(_=e.OpenEditorContext||(e.OpenEditorContext={}));function n(o){const g=o;return!!g&&typeof g.id=="number"&&Array.isArray(g.editors)}e.isEditorGroup=n;function f(o){return o.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=f}),define(Ee[164],ye([0,1,3,90]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,a.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function w(T){const k=T;return typeof T=="number"||(0,t.isEditorGroup)(k)}e.isPreferredGroup=w}),define(Ee[8],ye([0,1,16,22,76,225,54,26,11,2,59,58,131,82,47,87,67,164,7]),function(re,e,a,t,w,T,k,P,C,R,F,_,n,f,o,g,c,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var h;(function(ne){function pe(W){const{selectionStartLineNumber:be,selectionStartColumn:De,positionLineNumber:qe,positionColumn:xe}=W,ut=new v.Position(be-1,De-1),vt=new v.Position(qe-1,xe-1);return new v.Selection(ut,vt)}ne.to=pe;function ee(W){const{anchor:be,active:De}=W;return{selectionStartLineNumber:be.line+1,selectionStartColumn:be.character+1,positionLineNumber:De.line+1,positionColumn:De.character+1}}ne.from=ee})(h=e.Selection||(e.Selection={}));var p;(function(ne){function pe(W){if(!W)return;const{start:be,end:De}=W;return{startLineNumber:be.line+1,startColumn:be.character+1,endLineNumber:De.line+1,endColumn:De.character+1}}ne.from=pe;function ee(W){if(!W)return;const{startLineNumber:be,startColumn:De,endLineNumber:qe,endColumn:xe}=W;return new v.Range(be-1,De-1,qe-1,xe-1)}ne.to=ee})(p=e.Range||(e.Range={}));var I;(function(ne){function pe(ee){switch(ee){case 1:return v.StandardTokenType.Comment;case 0:return v.StandardTokenType.Other;case 4:return v.StandardTokenType.RegEx;case 2:return v.StandardTokenType.String}}ne.to=pe})(I=e.TokenType||(e.TokenType={}));var l;(function(ne){function pe(W){return new v.Position(W.lineNumber-1,W.column-1)}ne.to=pe;function ee(W){return{lineNumber:W.line+1,column:W.character+1}}ne.from=ee})(l=e.Position||(e.Position={}));var M;(function(ne){function pe(be,De){return(0,a.coalesce)((0,a.asArray)(be).map(qe=>ee(qe,De)))}ne.from=pe;function ee(be,De){if(typeof be=="string")return{$serialized:!0,language:be};if(be)return{$serialized:!0,language:be.language,scheme:W(be.scheme,De),pattern:typeof be.pattern=="undefined"?void 0:V.from(be.pattern),exclusive:be.exclusive}}function W(be,De){return De&&typeof be=="string"?De.transformOutgoingScheme(be):be}})(M=e.DocumentSelector||(e.DocumentSelector={}));var r;(function(ne){function pe(W){switch(W){case v.DiagnosticTag.Unnecessary:return 1;case v.DiagnosticTag.Deprecated:return 2}}ne.from=pe;function ee(W){switch(W){case 1:return v.DiagnosticTag.Unnecessary;case 2:return v.DiagnosticTag.Deprecated;default:return}}ne.to=ee})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var i;(function(ne){function pe(W){let be;return W.code&&((0,C.isString)(W.code)||(0,C.isNumber)(W.code)?be=String(W.code):be={value:String(W.code.value),target:W.code.target}),{...p.from(W.range),message:W.message,source:W.source,code:be,severity:d.from(W.severity),relatedInformation:W.relatedInformation&&W.relatedInformation.map(m.from),tags:Array.isArray(W.tags)?(0,a.coalesce)(W.tags.map(r.from)):void 0}}ne.from=pe;function ee(W){const be=new v.Diagnostic(p.to(W),W.message,d.to(W.severity));return be.source=W.source,be.code=(0,C.isString)(W.code)?W.code:W.code?.value,be.relatedInformation=W.relatedInformation&&W.relatedInformation.map(m.to),be.tags=W.tags&&(0,a.coalesce)(W.tags.map(r.to)),be}ne.to=ee})(i=e.Diagnostic||(e.Diagnostic={}));var m;(function(ne){function pe(W){return{...p.from(W.location.range),message:W.message,resource:W.location.uri}}ne.from=pe;function ee(W){return new v.DiagnosticRelatedInformation(new v.Location(W.resource,p.to(W)),W.message)}ne.to=ee})(m=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var d;(function(ne){function pe(W){switch(W){case v.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case v.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case v.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case v.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}ne.from=pe;function ee(W){switch(W){case f.MarkerSeverity.Info:return v.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return v.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return v.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return v.DiagnosticSeverity.Hint;default:return v.DiagnosticSeverity.Error}}ne.to=ee})(d=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var s;(function(ne){function pe(W){return typeof W=="number"&&W>=v.ViewColumn.One?W-1:W===v.ViewColumn.Beside?D.SIDE_GROUP:D.ACTIVE_GROUP}ne.from=pe;function ee(W){if(typeof W=="number"&&W>=0)return W+1;throw new Error("invalid 'EditorGroupColumn'")}ne.to=ee})(s=e.ViewColumn||(e.ViewColumn={}));function b(ne){return typeof ne.range!="undefined"}function y(ne){return ne.length===0?!0:!!b(ne[0])}e.isDecorationOptionsArr=y;var u;(function(ne){function pe(xe){return xe.map(ne.from)}ne.fromMany=pe;function ee(xe){return xe&&typeof xe=="object"&&typeof xe.language=="string"&&typeof xe.value=="string"}function W(xe){let ut;if(ee(xe)){const{language:ht,value:gt}=xe;ut={value:"```"+ht+`
`+gt+"\n```\n"}}else v.MarkdownString.isMarkdownString(xe)?ut={value:xe.value,isTrusted:xe.isTrusted,supportThemeIcons:xe.supportThemeIcons,supportHtml:xe.supportHtml}:typeof xe=="string"?ut={value:xe}:ut={value:""};const vt=Object.create(null);ut.uris=vt;const St=ht=>{try{let gt=R.URI.parse(ht,!0);gt=gt.with({query:be(gt.query,vt)}),vt[ht]=gt}catch{}return""},bt=new T.Renderer;return bt.link=St,bt.image=ht=>St(w.parseHrefAndDimensions(ht).href),T(ut.value,{renderer:bt}),ut}ne.from=W;function be(xe,ut){if(!xe)return xe;let vt;try{vt=(0,k.parse)(xe)}catch{}if(!vt)return xe;let St=!1;return vt=(0,P.cloneAndChange)(vt,bt=>{if(R.URI.isUri(bt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[ht]=bt,St=!0,ht}else return}),St?JSON.stringify(vt):xe}function De(xe){const ut=new v.MarkdownString(xe.value,xe.supportThemeIcons);return ut.isTrusted=xe.isTrusted,ut.supportHtml=xe.supportHtml,ut}ne.to=De;function qe(xe){if(!!xe)return typeof xe=="string"?xe:ne.from(xe)}ne.fromStrict=qe})(u=e.MarkdownString||(e.MarkdownString={}));function S(ne){return y(ne)?ne.map(pe=>({range:p.from(pe.range),hoverMessage:Array.isArray(pe.hoverMessage)?u.fromMany(pe.hoverMessage):pe.hoverMessage?u.from(pe.hoverMessage):void 0,renderOptions:pe.renderOptions})):ne.map(pe=>({range:p.from(pe)}))}e.fromRangeOrRangeWithMessage=S;function A(ne){return typeof ne=="undefined"?ne:typeof ne=="string"?R.URI.file(ne):ne}e.pathOrURIToURI=A;var U;(function(ne){function pe(ee){return typeof ee=="undefined"?ee:{contentText:ee.contentText,contentIconPath:ee.contentIconPath?A(ee.contentIconPath):void 0,border:ee.border,borderColor:ee.borderColor,fontStyle:ee.fontStyle,fontWeight:ee.fontWeight,textDecoration:ee.textDecoration,color:ee.color,backgroundColor:ee.backgroundColor,margin:ee.margin,width:ee.width,height:ee.height}}ne.from=pe})(U=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var H;(function(ne){function pe(ee){return typeof ee=="undefined"?ee:{backgroundColor:ee.backgroundColor,outline:ee.outline,outlineColor:ee.outlineColor,outlineStyle:ee.outlineStyle,outlineWidth:ee.outlineWidth,border:ee.border,borderColor:ee.borderColor,borderRadius:ee.borderRadius,borderSpacing:ee.borderSpacing,borderStyle:ee.borderStyle,borderWidth:ee.borderWidth,fontStyle:ee.fontStyle,fontWeight:ee.fontWeight,textDecoration:ee.textDecoration,cursor:ee.cursor,color:ee.color,opacity:ee.opacity,letterSpacing:ee.letterSpacing,gutterIconPath:ee.gutterIconPath?A(ee.gutterIconPath):void 0,gutterIconSize:ee.gutterIconSize,overviewRulerColor:ee.overviewRulerColor,before:ee.before?U.from(ee.before):void 0,after:ee.after?U.from(ee.after):void 0}}ne.from=pe})(H=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var E;(function(ne){function pe(ee){if(typeof ee=="undefined")return ee;switch(ee){case v.DecorationRangeBehavior.OpenOpen:return 0;case v.DecorationRangeBehavior.ClosedClosed:return 1;case v.DecorationRangeBehavior.OpenClosed:return 2;case v.DecorationRangeBehavior.ClosedOpen:return 3}}ne.from=pe})(E=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var L;(function(ne){function pe(ee){return{isWholeLine:ee.isWholeLine,rangeBehavior:ee.rangeBehavior?E.from(ee.rangeBehavior):void 0,overviewRulerLane:ee.overviewRulerLane,light:ee.light?H.from(ee.light):void 0,dark:ee.dark?H.from(ee.dark):void 0,backgroundColor:ee.backgroundColor,outline:ee.outline,outlineColor:ee.outlineColor,outlineStyle:ee.outlineStyle,outlineWidth:ee.outlineWidth,border:ee.border,borderColor:ee.borderColor,borderRadius:ee.borderRadius,borderSpacing:ee.borderSpacing,borderStyle:ee.borderStyle,borderWidth:ee.borderWidth,fontStyle:ee.fontStyle,fontWeight:ee.fontWeight,textDecoration:ee.textDecoration,cursor:ee.cursor,color:ee.color,opacity:ee.opacity,letterSpacing:ee.letterSpacing,gutterIconPath:ee.gutterIconPath?A(ee.gutterIconPath):void 0,gutterIconSize:ee.gutterIconSize,overviewRulerColor:ee.overviewRulerColor,before:ee.before?U.from(ee.before):void 0,after:ee.after?U.from(ee.after):void 0}}ne.from=pe})(L=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var z;(function(ne){function pe(W){return{text:W.newText,eol:W.newEol&&lt.from(W.newEol),range:p.from(W.range)}}ne.from=pe;function ee(W){const be=new v.TextEdit(p.to(W.range),W.text);return be.newEol=typeof W.eol=="undefined"?void 0:lt.to(W.eol),be}ne.to=ee})(z=e.TextEdit||(e.TextEdit={}));var N;(function(ne){function pe(W,be,De){const qe={edits:[]};if(W instanceof v.WorkspaceEdit)for(let xe of W._allEntries())if(xe._type===1)qe.edits.push({_type:1,oldUri:xe.from,newUri:xe.to,options:xe.options,metadata:xe.metadata});else if(xe._type===2){const ut=be?.getDocument(xe.uri);qe.edits.push({_type:2,resource:xe.uri,edit:z.from(xe.edit),modelVersionId:ut?.version,metadata:xe.metadata})}else xe._type===3?qe.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,edit:xe.edit,notebookMetadata:xe.notebookMetadata,notebookVersionId:De?.getNotebookDocument(xe.uri,!0)?.apiNotebook.version}):xe._type===5&&qe.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,notebookVersionId:De?.getNotebookDocument(xe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:xe.index,count:xe.count,cells:xe.cells.map(Ge.from)}});return qe}ne.from=pe;function ee(W){const be=new v.WorkspaceEdit;for(const De of W.edits)De.edit?be.replace(R.URI.revive(De.resource),p.to(De.edit.range),De.edit.text):be.renameFile(R.URI.revive(De.oldUri),R.URI.revive(De.newUri),De.options);return be}ne.to=ee})(N=e.WorkspaceEdit||(e.WorkspaceEdit={}));var B;(function(ne){const pe=Object.create(null);pe[v.SymbolKind.File]=0,pe[v.SymbolKind.Module]=1,pe[v.SymbolKind.Namespace]=2,pe[v.SymbolKind.Package]=3,pe[v.SymbolKind.Class]=4,pe[v.SymbolKind.Method]=5,pe[v.SymbolKind.Property]=6,pe[v.SymbolKind.Field]=7,pe[v.SymbolKind.Constructor]=8,pe[v.SymbolKind.Enum]=9,pe[v.SymbolKind.Interface]=10,pe[v.SymbolKind.Function]=11,pe[v.SymbolKind.Variable]=12,pe[v.SymbolKind.Constant]=13,pe[v.SymbolKind.String]=14,pe[v.SymbolKind.Number]=15,pe[v.SymbolKind.Boolean]=16,pe[v.SymbolKind.Array]=17,pe[v.SymbolKind.Object]=18,pe[v.SymbolKind.Key]=19,pe[v.SymbolKind.Null]=20,pe[v.SymbolKind.EnumMember]=21,pe[v.SymbolKind.Struct]=22,pe[v.SymbolKind.Event]=23,pe[v.SymbolKind.Operator]=24,pe[v.SymbolKind.TypeParameter]=25;function ee(be){return typeof pe[be]=="number"?pe[be]:6}ne.from=ee;function W(be){for(const De in pe)if(pe[De]===be)return Number(De);return v.SymbolKind.Property}ne.to=W})(B=e.SymbolKind||(e.SymbolKind={}));var j;(function(ne){function pe(W){switch(W){case v.SymbolTag.Deprecated:return 1}}ne.from=pe;function ee(W){switch(W){case 1:return v.SymbolTag.Deprecated}}ne.to=ee})(j=e.SymbolTag||(e.SymbolTag={}));var ce;(function(ne){function pe(W){return{name:W.name,kind:B.from(W.kind),tags:W.tags&&W.tags.map(j.from),containerName:W.containerName,location:ie.from(W.location)}}ne.from=pe;function ee(W){const be=new v.SymbolInformation(W.name,B.to(W.kind),W.containerName,ie.to(W.location));return be.tags=W.tags&&W.tags.map(j.to),be}ne.to=ee})(ce=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var K;(function(ne){function pe(W){const be={name:W.name||"!!MISSING: name!!",detail:W.detail,range:p.from(W.range),selectionRange:p.from(W.selectionRange),kind:B.from(W.kind),tags:W.tags?.map(j.from)??[]};return W.children&&(be.children=W.children.map(pe)),be}ne.from=pe;function ee(W){const be=new v.DocumentSymbol(W.name,W.detail,B.to(W.kind),p.to(W.range),p.to(W.selectionRange));return(0,a.isNonEmptyArray)(W.tags)&&(be.tags=W.tags.map(j.to)),W.children&&(be.children=W.children.map(ee)),be}ne.to=ee})(K=e.DocumentSymbol||(e.DocumentSymbol={}));var le;(function(ne){function pe(W){const be=new v.CallHierarchyItem(B.to(W.kind),W.name,W.detail||"",R.URI.revive(W.uri),p.to(W.range),p.to(W.selectionRange));return be._sessionId=W._sessionId,be._itemId=W._itemId,be}ne.to=pe;function ee(W,be,De){if(be=be??W._sessionId,De=De??W._itemId,be===void 0||De===void 0)throw new Error("invalid item");return{_sessionId:be,_itemId:De,name:W.name,detail:W.detail,kind:B.from(W.kind),uri:W.uri,range:p.from(W.range),selectionRange:p.from(W.selectionRange),tags:W.tags?.map(j.from)}}ne.from=ee})(le=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ue;(function(ne){function pe(ee){return new v.CallHierarchyIncomingCall(le.to(ee.from),ee.fromRanges.map(W=>p.to(W)))}ne.to=pe})(ue=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Y;(function(ne){function pe(ee){return new v.CallHierarchyOutgoingCall(le.to(ee.to),ee.fromRanges.map(W=>p.to(W)))}ne.to=pe})(Y=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ie;(function(ne){function pe(W){return{range:W.range&&p.from(W.range),uri:W.uri}}ne.from=pe;function ee(W){return new v.Location(R.URI.revive(W.uri),p.to(W.range))}ne.to=ee})(ie=e.location||(e.location={}));var we;(function(ne){function pe(W){const be=W,De=W;return{originSelectionRange:be.originSelectionRange?p.from(be.originSelectionRange):void 0,uri:be.targetUri?be.targetUri:De.uri,range:p.from(be.targetRange?be.targetRange:De.range),targetSelectionRange:be.targetSelectionRange?p.from(be.targetSelectionRange):void 0}}ne.from=pe;function ee(W){return{targetUri:R.URI.revive(W.uri),targetRange:p.to(W.range),targetSelectionRange:W.targetSelectionRange?p.to(W.targetSelectionRange):void 0,originSelectionRange:W.originSelectionRange?p.to(W.originSelectionRange):void 0}}ne.to=ee})(we=e.DefinitionLink||(e.DefinitionLink={}));var Me;(function(ne){function pe(W){return{range:p.from(W.range),contents:u.fromMany(W.contents)}}ne.from=pe;function ee(W){return new v.Hover(W.contents.map(u.to),p.to(W.range))}ne.to=ee})(Me=e.Hover||(e.Hover={}));var Re;(function(ne){function pe(W){return{range:p.from(W.range),expression:W.expression}}ne.from=pe;function ee(W){return new v.EvaluatableExpression(p.to(W.range),W.expression)}ne.to=ee})(Re=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Be;(function(ne){function pe(W){if(W instanceof v.InlineValueText)return{type:"text",range:p.from(W.range),text:W.text};if(W instanceof v.InlineValueVariableLookup)return{type:"variable",range:p.from(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};if(W instanceof v.InlineValueEvaluatableExpression)return{type:"expression",range:p.from(W.range),expression:W.expression};throw new Error("Unknown 'InlineValue' type")}ne.from=pe;function ee(W){switch(W.type){case"text":return{range:p.to(W.range),text:W.text};case"variable":return{range:p.to(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};case"expression":return{range:p.to(W.range),expression:W.expression}}}ne.to=ee})(Be=e.InlineValue||(e.InlineValue={}));var Qe;(function(ne){function pe(W){return{frameId:W.frameId,stoppedLocation:p.from(W.stoppedLocation)}}ne.from=pe;function ee(W){return new v.InlineValueContext(W.frameId,p.to(W.stoppedLocation))}ne.to=ee})(Qe=e.InlineValueContext||(e.InlineValueContext={}));var Ke;(function(ne){function pe(W){return{range:p.from(W.range),kind:W.kind}}ne.from=pe;function ee(W){return new v.DocumentHighlight(p.to(W.range),W.kind)}ne.to=ee})(Ke=e.DocumentHighlight||(e.DocumentHighlight={}));var Xe;(function(ne){function pe(ee){switch(ee){case 1:return v.CompletionTriggerKind.TriggerCharacter;case 2:return v.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return v.CompletionTriggerKind.Invoke}}ne.to=pe})(Xe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var $;(function(ne){function pe(ee){return{triggerKind:Xe.to(ee.triggerKind),triggerCharacter:ee.triggerCharacter}}ne.to=pe})($=e.CompletionContext||(e.CompletionContext={}));var G;(function(ne){function pe(W){switch(W){case v.CompletionItemTag.Deprecated:return 1}}ne.from=pe;function ee(W){switch(W){case 1:return v.CompletionItemTag.Deprecated}}ne.to=ee})(G=e.CompletionItemTag||(e.CompletionItemTag={}));var J;(function(ne){const pe=new Map([[v.CompletionItemKind.Method,0],[v.CompletionItemKind.Function,1],[v.CompletionItemKind.Constructor,2],[v.CompletionItemKind.Field,3],[v.CompletionItemKind.Variable,4],[v.CompletionItemKind.Class,5],[v.CompletionItemKind.Interface,7],[v.CompletionItemKind.Struct,6],[v.CompletionItemKind.Module,8],[v.CompletionItemKind.Property,9],[v.CompletionItemKind.Unit,12],[v.CompletionItemKind.Value,13],[v.CompletionItemKind.Constant,14],[v.CompletionItemKind.Enum,15],[v.CompletionItemKind.EnumMember,16],[v.CompletionItemKind.Keyword,17],[v.CompletionItemKind.Snippet,27],[v.CompletionItemKind.Text,18],[v.CompletionItemKind.Color,19],[v.CompletionItemKind.File,20],[v.CompletionItemKind.Reference,21],[v.CompletionItemKind.Folder,23],[v.CompletionItemKind.Event,10],[v.CompletionItemKind.Operator,11],[v.CompletionItemKind.TypeParameter,24],[v.CompletionItemKind.Issue,26],[v.CompletionItemKind.User,25]]);function ee(De){return pe.get(De)??9}ne.from=ee;const W=new Map([[0,v.CompletionItemKind.Method],[1,v.CompletionItemKind.Function],[2,v.CompletionItemKind.Constructor],[3,v.CompletionItemKind.Field],[4,v.CompletionItemKind.Variable],[5,v.CompletionItemKind.Class],[7,v.CompletionItemKind.Interface],[6,v.CompletionItemKind.Struct],[8,v.CompletionItemKind.Module],[9,v.CompletionItemKind.Property],[12,v.CompletionItemKind.Unit],[13,v.CompletionItemKind.Value],[14,v.CompletionItemKind.Constant],[15,v.CompletionItemKind.Enum],[16,v.CompletionItemKind.EnumMember],[17,v.CompletionItemKind.Keyword],[27,v.CompletionItemKind.Snippet],[18,v.CompletionItemKind.Text],[19,v.CompletionItemKind.Color],[20,v.CompletionItemKind.File],[21,v.CompletionItemKind.Reference],[23,v.CompletionItemKind.Folder],[10,v.CompletionItemKind.Event],[11,v.CompletionItemKind.Operator],[24,v.CompletionItemKind.TypeParameter],[25,v.CompletionItemKind.User],[26,v.CompletionItemKind.Issue]]);function be(De){return W.get(De)??v.CompletionItemKind.Property}ne.to=be})(J=e.CompletionItemKind||(e.CompletionItemKind={}));var ae;(function(ne){function pe(ee,W){const be=new v.CompletionItem(ee.label);return be.insertText=ee.insertText,be.kind=J.to(ee.kind),be.tags=ee.tags?.map(G.to),be.detail=ee.detail,be.documentation=w.isMarkdownString(ee.documentation)?u.to(ee.documentation):ee.documentation,be.sortText=ee.sortText,be.filterText=ee.filterText,be.preselect=ee.preselect,be.commitCharacters=ee.commitCharacters,F.Range.isIRange(ee.range)?be.range=p.to(ee.range):typeof ee.range=="object"&&(be.range={inserting:p.to(ee.range.insert),replacing:p.to(ee.range.replace)}),be.keepWhitespace=typeof ee.insertTextRules=="undefined"?!1:Boolean(ee.insertTextRules&1),typeof ee.insertTextRules!="undefined"&&ee.insertTextRules&4?be.insertText=new v.SnippetString(ee.insertText):(be.insertText=ee.insertText,be.textEdit=be.range instanceof v.Range?new v.TextEdit(be.range,be.insertText):void 0),ee.additionalTextEdits&&ee.additionalTextEdits.length>0&&(be.additionalTextEdits=ee.additionalTextEdits.map(De=>z.to(De))),be.command=W&&ee.command?W.fromInternal(ee.command):void 0,be}ne.to=pe})(ae=e.CompletionItem||(e.CompletionItem={}));var q;(function(ne){function pe(W){return{label:W.label,documentation:W.documentation?u.fromStrict(W.documentation):void 0}}ne.from=pe;function ee(W){return{label:W.label,documentation:w.isMarkdownString(W.documentation)?u.to(W.documentation):W.documentation}}ne.to=ee})(q=e.ParameterInformation||(e.ParameterInformation={}));var te;(function(ne){function pe(W){return{label:W.label,documentation:W.documentation?u.fromStrict(W.documentation):void 0,parameters:Array.isArray(W.parameters)?W.parameters.map(q.from):[],activeParameter:W.activeParameter}}ne.from=pe;function ee(W){return{label:W.label,documentation:w.isMarkdownString(W.documentation)?u.to(W.documentation):W.documentation,parameters:Array.isArray(W.parameters)?W.parameters.map(q.to):[],activeParameter:W.activeParameter}}ne.to=ee})(te=e.SignatureInformation||(e.SignatureInformation={}));var me;(function(ne){function pe(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(te.from):[]}}ne.from=pe;function ee(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(te.to):[]}}ne.to=ee})(me=e.SignatureHelp||(e.SignatureHelp={}));var Pe;(function(ne){function pe(W){return{text:W.text,position:l.from(W.position),kind:Ne.from(W.kind??v.InlayHintKind.Other),whitespaceBefore:W.whitespaceBefore,whitespaceAfter:W.whitespaceAfter}}ne.from=pe;function ee(W){const be=new v.InlayHint(W.text,l.to(W.position),Ne.to(W.kind));return be.whitespaceAfter=W.whitespaceAfter,be.whitespaceBefore=W.whitespaceBefore,be}ne.to=ee})(Pe=e.InlayHint||(e.InlayHint={}));var Ne;(function(ne){function pe(W){return W}ne.from=pe;function ee(W){return W}ne.to=ee})(Ne=e.InlayHintKind||(e.InlayHintKind={}));var He;(function(ne){function pe(W){return{range:p.from(W.range),url:W.target,tooltip:W.tooltip}}ne.from=pe;function ee(W){let be;if(W.url)try{be=typeof W.url=="string"?R.URI.parse(W.url,!0):R.URI.revive(W.url)}catch{}return new v.DocumentLink(p.to(W.range),be)}ne.to=ee})(He=e.DocumentLink||(e.DocumentLink={}));var Ye;(function(ne){function pe(W){const be=new v.ColorPresentation(W.label);return W.textEdit&&(be.textEdit=z.to(W.textEdit)),W.additionalTextEdits&&(be.additionalTextEdits=W.additionalTextEdits.map(De=>z.to(De))),be}ne.to=pe;function ee(W){return{label:W.label,textEdit:W.textEdit?z.from(W.textEdit):void 0,additionalTextEdits:W.additionalTextEdits?W.additionalTextEdits.map(be=>z.from(be)):void 0}}ne.from=ee})(Ye=e.ColorPresentation||(e.ColorPresentation={}));var et;(function(ne){function pe(W){return new v.Color(W[0],W[1],W[2],W[3])}ne.to=pe;function ee(W){return[W.red,W.green,W.blue,W.alpha]}ne.from=ee})(et=e.Color||(e.Color={}));var st;(function(ne){function pe(W){return{range:p.from(W.range)}}ne.from=pe;function ee(W){return new v.SelectionRange(p.to(W.range))}ne.to=ee})(st=e.SelectionRange||(e.SelectionRange={}));var Je;(function(ne){function pe(ee){switch(ee){case 2:return v.TextDocumentSaveReason.AfterDelay;case 1:return v.TextDocumentSaveReason.Manual;case 3:case 4:return v.TextDocumentSaveReason.FocusOut}}ne.to=pe})(Je=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(ne){function pe(W){switch(W){case v.TextEditorLineNumbersStyle.Off:return 0;case v.TextEditorLineNumbersStyle.Relative:return 2;case v.TextEditorLineNumbersStyle.On:default:return 1}}ne.from=pe;function ee(W){switch(W){case 0:return v.TextEditorLineNumbersStyle.Off;case 2:return v.TextEditorLineNumbersStyle.Relative;case 1:default:return v.TextEditorLineNumbersStyle.On}}ne.to=ee})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var lt;(function(ne){function pe(W){if(W===v.EndOfLine.CRLF)return 1;if(W===v.EndOfLine.LF)return 0}ne.from=pe;function ee(W){if(W===1)return v.EndOfLine.CRLF;if(W===0)return v.EndOfLine.LF}ne.to=ee})(lt=e.EndOfLine||(e.EndOfLine={}));var pt;(function(ne){function pe(ee){if(typeof ee=="object")return ee.viewId;switch(ee){case v.ProgressLocation.SourceControl:return 3;case v.ProgressLocation.Window:return 10;case v.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ne.from=pe})(pt=e.ProgressLocation||(e.ProgressLocation={}));var Ft;(function(ne){function pe(ee){const W={start:ee.start+1,end:ee.end+1};return ee.kind&&(W.kind=Fe.from(ee.kind)),W}ne.from=pe})(Ft=e.FoldingRange||(e.FoldingRange={}));var Fe;(function(ne){function pe(ee){if(ee)switch(ee){case v.FoldingRangeKind.Comment:return _.FoldingRangeKind.Comment;case v.FoldingRangeKind.Imports:return _.FoldingRangeKind.Imports;case v.FoldingRangeKind.Region:return _.FoldingRangeKind.Region}}ne.from=pe})(Fe=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Mt;(function(ne){function pe(ee){if(ee)return{pinned:typeof ee.preview=="boolean"?!ee.preview:void 0,inactive:ee.background,preserveFocus:ee.preserveFocus,selection:typeof ee.selection=="object"?p.from(ee.selection):void 0,override:typeof ee.override=="boolean"?n.EditorResolution.DISABLED:void 0}}ne.from=pe})(Mt=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var V;(function(ne){function pe(W){return W instanceof v.RelativePattern||typeof W=="string"?W:ee(W)?new v.RelativePattern(W.base,W.pattern):W}ne.from=pe;function ee(W){const be=W;return be&&typeof be.base=="string"&&typeof be.pattern=="string"}})(V=e.GlobPattern||(e.GlobPattern={}));var Q;(function(ne){function pe(ee){if(ee){if(Array.isArray(ee))return ee.map(pe);if(typeof ee=="string")return ee;{const W=ee;return{language:W.language,scheme:W.scheme,pattern:typeof W.pattern=="undefined"?void 0:V.from(W.pattern),exclusive:W.exclusive}}}else return}ne.from=pe})(Q=e.LanguageSelector||(e.LanguageSelector={}));var he;(function(ne){function pe(W){return{start:W.start,end:W.end}}ne.from=pe;function ee(W){return new v.NotebookRange(W.start,W.end)}ne.to=ee})(he=e.NotebookRange||(e.NotebookRange={}));var Le;(function(ne){function pe(W){return{timing:typeof W.runStartTime=="number"&&typeof W.runEndTime=="number"?{startTime:W.runStartTime,endTime:W.runEndTime}:void 0,executionOrder:W.executionOrder,success:W.lastRunSuccess}}ne.to=pe;function ee(W){return{lastRunSuccess:W.success,runStartTime:W.timing?.startTime,runEndTime:W.timing?.endTime,executionOrder:W.executionOrder}}ne.from=ee})(Le=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var We;(function(ne){function pe(W){switch(W){case v.NotebookCellKind.Markup:return g.CellKind.Markup;case v.NotebookCellKind.Code:default:return g.CellKind.Code}}ne.from=pe;function ee(W){switch(W){case g.CellKind.Markup:return v.NotebookCellKind.Markup;case g.CellKind.Code:default:return v.NotebookCellKind.Code}}ne.to=ee})(We=e.NotebookCellKind||(e.NotebookCellKind={}));var ot;(function(ne){function pe(W){const be={metadata:W.metadata??Object.create(null),cells:[]};for(let De of W.cells)v.NotebookCellData.validate(De),be.cells.push(Ge.from(De));return be}ne.from=pe;function ee(W){const be=new v.NotebookData(W.cells.map(Ge.to));return(0,C.isEmptyObject)(W.metadata)||(be.metadata=W.metadata),be}ne.to=ee})(ot=e.NotebookData||(e.NotebookData={}));var Ge;(function(ne){function pe(W){return{cellKind:We.from(W.kind),language:W.languageId,mime:W.mime,source:W.value,metadata:W.metadata,internalMetadata:Le.from(W.executionSummary??{}),outputs:W.outputs?W.outputs.map(Ie.from):[]}}ne.from=pe;function ee(W){return new v.NotebookCellData(We.to(W.cellKind),W.source,W.language,W.mime,W.outputs?W.outputs.map(Ie.to):void 0,W.metadata,W.internalMetadata?Le.to(W.internalMetadata):void 0)}ne.to=ee})(Ge=e.NotebookCellData||(e.NotebookCellData={}));var yt;(function(ne){function pe(W){return{mime:W.mime,valueBytes:t.VSBuffer.wrap(W.data)}}ne.from=pe;function ee(W){return new v.NotebookCellOutputItem(W.valueBytes.buffer,W.mime)}ne.to=ee})(yt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ie;(function(ne){function pe(W){return{outputId:W.id,items:W.items.map(yt.from),metadata:W.metadata}}ne.from=pe;function ee(W){const be=W.items.map(yt.to);return new v.NotebookCellOutput(be,W.outputId,W.metadata)}ne.to=ee})(Ie=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ce;(function(ne){function pe(De){if(De!=null){if(De instanceof v.RelativePattern||typeof De=="string")return De;if(be(De))return new v.RelativePattern(De.base,De.pattern);if(W(De))return{include:V.from(De.include)||void 0,exclude:V.from(De.exclude)||void 0}}}ne.from=pe;function ee(De){return typeof De=="string"?De:be(De)?{base:De.base,pattern:De.pattern}:{include:De.include,exclude:De.exclude}}ne.to=ee;function W(De){const qe=De,xe=V.from(qe.include);if(!(xe&&xe instanceof v.RelativePattern||typeof xe=="string"))return!1;const ut=V.from(qe.exclude);return!!(ut&&ut instanceof v.RelativePattern||typeof ut=="string")}function be(De){const qe=De;return qe&&typeof qe.base=="string"&&typeof qe.pattern=="string"}})(Ce=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ve;(function(ne){function pe(ee){return{backgroundColor:ee.backgroundColor,borderColor:ee.borderColor,top:ee.top?U.from(ee.top):void 0}}ne.from=pe})(ve=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var oe;(function(ne){function pe(ee,W,be){const De=typeof ee.command=="string"?{title:"",command:ee.command}:ee.command;return{alignment:ee.alignment===v.NotebookCellStatusBarAlignment.Left?1:2,command:W.toInternal(De,be),text:ee.text,tooltip:ee.tooltip,accessibilityInformation:ee.accessibilityInformation,priority:ee.priority}}ne.from=pe})(oe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var se;(function(ne){function pe(ee){return{transientOutputs:ee?.transientOutputs??!1,transientCellMetadata:ee?.transientCellMetadata??{},transientDocumentMetadata:ee?.transientDocumentMetadata??{}}}ne.from=pe})(se=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var fe;(function(ne){function pe(W){return{uri:W.uri,provides:W.provides}}ne.from=pe;function ee(W){return new v.NotebookRendererScript(R.URI.revive(W.uri),W.provides)}ne.to=ee})(fe=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ge;(function(ne){function pe(W){return{message:u.fromStrict(W.message)||"",type:0,expected:W.expectedOutput,actual:W.actualOutput,location:W.location?ie.from(W.location):void 0}}ne.from=pe;function ee(W){const be=new v.TestMessage(typeof W.message=="string"?W.message:u.to(W.message));return be.actualOutput=W.actual,be.expectedOutput=W.expected,be.location=W.location?ie.to(W.location):void 0,be}ne.to=ee})(ge=e.TestMessage||(e.TestMessage={}));var ke;(function(ne){let pe;(function(ee){ee.Delimiter="\0"})(pe||(pe={})),ne.namespace=(ee,W)=>ee+"\0"+W,ne.denamespace=ee=>{const W=ee.indexOf("\0");return{ctrlId:ee.slice(0,W),tagId:ee.slice(W+1)}}})(ke=e.TestTag||(e.TestTag={}));var ze;(function(ne){function pe(De){const qe=(0,o.getPrivateApiFor)(De).controllerId;return{extId:c.TestId.fromExtHostTestItem(De,qe).toString(),label:De.label,uri:De.uri,tags:De.tags.map(xe=>ke.namespace(qe,xe.id)),range:p.from(De.range)||null,description:De.description||null,error:De.error&&u.fromStrict(De.error)||null}}ne.from=pe;function ee(De){return{parent:void 0,error:void 0,id:c.TestId.fromString(De.extId).localId,label:De.label,uri:R.URI.revive(De.uri),tags:(De.tags||[]).map(qe=>{const{tagId:xe}=ke.denamespace(qe);return new v.TestTag(xe)}),range:p.to(De.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:De.description||void 0}}ne.toPlain=ee;function W(De){const qe=c.TestId.fromString(De.extId),xe=new o.TestItemImpl(qe.controllerId,qe.localId,De.label,R.URI.revive(De.uri));return xe.range=p.to(De.range||void 0),xe.description=De.description||void 0,xe}function be(De){let qe;for(const xe of De.tests){const ut=W(xe.item);(0,o.getPrivateApiFor)(ut).parent=qe,qe=ut}return qe}ne.toItemFromContext=be})(ze=e.TestItem||(e.TestItem={})),function(ne){function pe(W){return{id:W.id}}ne.from=pe;function ee(W){return new v.TestTag(W.id)}ne.to=ee}(ke=e.TestTag||(e.TestTag={}));var Oe;(function(ne){const pe=(W,be)=>{const De={...ze.toPlain(W.item),parent:void 0,taskStates:W.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(xe=>xe.type===0).map(ge.to)})),children:W.children.map(qe=>be.get(qe)).filter(C.isDefined).map(qe=>pe(qe,be))};for(const qe of De.children)qe.parent=De;return De};function ee(W){const be=[],De=new Map;for(const qe of W.items)De.set(qe.item.extId,qe),W.request.targets.some(xe=>xe.controllerId===qe.controllerId&&xe.testIds.includes(qe.item.extId))&&be.push(qe);return{completedAt:W.completedAt,results:be.map(qe=>pe(qe,De))}}ne.to=ee})(Oe=e.TestResults||(e.TestResults={}));var Ve;(function(ne){function pe(De){return{covered:De.covered,total:De.covered}}function ee(De){return"line"in De?l.from(De):p.from(De)}function W(De){return"branches"in De?{count:De.executionCount,location:ee(De.location),type:1,branches:De.branches.length?De.branches.map(qe=>({count:qe.executionCount,location:qe.location&&ee(qe.location)})):void 0}:{type:0,count:De.executionCount,location:ee(De.location)}}ne.fromDetailed=W;function be(De){return{uri:De.uri,statement:pe(De.statementCoverage),branch:De.branchCoverage&&pe(De.branchCoverage),function:De.functionCoverage&&pe(De.functionCoverage),details:De.detailedCoverage?.map(W)}}ne.fromFile=be})(Ve=e.TestCoverage||(e.TestCoverage={}));var it;(function(ne){function pe(ee){switch(ee){case 1:return v.CodeActionTriggerKind.Invoke;case 2:return v.CodeActionTriggerKind.Automatic}}ne.to=pe})(it=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var rt;(function(ne){function pe(W){const be=new v.TypeHierarchyItem(B.to(W.kind),W.name,W.detail||"",R.URI.revive(W.uri),p.to(W.range),p.to(W.selectionRange));return be._sessionId=W._sessionId,be._itemId=W._itemId,be}ne.to=pe;function ee(W,be,De){if(be=be??W._sessionId,De=De??W._itemId,be===void 0||De===void 0)throw new Error("invalid item");return{_sessionId:be,_itemId:De,kind:B.from(W.kind),name:W.name,detail:W.detail??"",uri:W.uri,range:p.from(W.range),selectionRange:p.from(W.selectionRange),tags:W.tags?.map(j.from)}}ne.from=ee})(rt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(Ee[165],ye([0,1,2,15,7,8,226]),function(re,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(R,F,_,n={timeout:1500,errors:3}){this._logService=R,this._documents=F,this._mainThreadBulkEdits=_,this._thresholds=n,this._callbacks=new k.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(R){return(F,_,n)=>{const o={dispose:this._callbacks.push([F,_,R])};return Array.isArray(n)&&n.push(o),o}}async $participateInSave(R,F){const _=a.URI.revive(R);let n=!1;const f=setTimeout(()=>n=!0,this._thresholds.timeout),o=[];try{for(let g of[...this._callbacks]){if(n)break;const c=this._documents.getDocument(_),D=await this._deliverEventAsyncAndBlameBadListeners(g,{document:c,reason:T.TextDocumentSaveReason.to(F)});o.push(D)}}finally{clearTimeout(f)}return o}_deliverEventAsyncAndBlameBadListeners([R,F,_],n){const f=this._badListeners.get(R);return typeof f=="number"&&f>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(_,R,F,n).then(()=>!0,o=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' threw ERROR`),this._logService.error(o),!(o instanceof Error)||o.message!=="concurrent_edits"){const g=this._badListeners.get(R);this._badListeners.set(R,g?g+1:1),typeof g=="number"&&g>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(R,F,_,n){const f=[],o=Date.now(),{document:g,reason:c}=n,{version:D}=g,v=Object.freeze({document:g,reason:c,waitUntil(h){if(Object.isFrozen(f))throw(0,t.illegalState)("waitUntil can not be called async");f.push(Promise.resolve(h))}});try{F.apply(_,[v])}catch(h){return Promise.reject(h)}return Object.freeze(f),new Promise((h,p)=>{const I=setTimeout(()=>p(new Error("timeout")),this._thresholds.timeout);return Promise.all(f).then(l=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${R.identifier.value}' finished after ${Date.now()-o}ms`),clearTimeout(I),h(l)}).catch(l=>{clearTimeout(I),p(l)})}).then(h=>{const p={edits:[]};for(const I of h)if(Array.isArray(I)&&I.every(l=>l instanceof w.TextEdit))for(const{newText:l,newEol:M,range:r}of I)p.edits.push({_type:2,resource:g.uri,edit:{range:r&&T.Range.from(r),text:l,eol:M&&T.EndOfLine.from(M)}});if(p.edits.length!==0)return D===g.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(p):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(Ee[166],ye([0,1,4,29,2,8,7]),function(re,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class P{constructor(F,_,n,f,o){this._onDidCreate=new a.Emitter,this._onDidChange=new a.Emitter,this._onDidDelete=new a.Emitter,this._config=0,n&&(this._config+=1),f&&(this._config+=2),o&&(this._config+=4);const g=(0,t.parse)(_),c=F(D=>{if(!n)for(let v of D.created){const h=w.URI.revive(v);g(h.fsPath)&&this._onDidCreate.fire(h)}if(!f)for(let v of D.changed){const h=w.URI.revive(v);g(h.fsPath)&&this._onDidChange.fire(h)}if(!o)for(let v of D.deleted){const h=w.URI.revive(v);g(h.fsPath)&&this._onDidDelete.fire(h)}});this._disposable=k.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,c)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class C{constructor(F,_,n){this._logService=_,this._extHostDocumentsAndEditors=n,this._onFileSystemEvent=new a.Emitter,this._onDidRenameFile=new a.Emitter,this._onDidCreateFile=new a.Emitter,this._onDidDeleteFile=new a.Emitter,this._onWillRenameFile=new a.AsyncEmitter,this._onWillCreateFile=new a.AsyncEmitter,this._onWillDeleteFile=new a.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(F,_,n,f){return new P(this._onFileSystemEvent.event,F,_,n,f)}$onFileEvent(F){this._onFileSystemEvent.fire(F)}$onDidRunFileOperation(F,_){switch(F){case 2:this._onDidRenameFile.fire(Object.freeze({files:_.map(n=>({oldUri:w.URI.revive(n.source),newUri:w.URI.revive(n.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:_.map(n=>w.URI.revive(n.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:_.map(n=>w.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(F){return this._createWillExecuteEvent(F,this._onWillRenameFile)}getOnWillCreateFileEvent(F){return this._createWillExecuteEvent(F,this._onWillCreateFile)}getOnWillDeleteFileEvent(F){return this._createWillExecuteEvent(F,this._onWillDeleteFile)}_createWillExecuteEvent(F,_){return(n,f,o)=>{const g=function(D){n.call(f,D)};return g.extension=F,_.event(g,void 0,o)}}async $onWillRunFileOperation(F,_,n,f){switch(F){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:_.map(o=>({oldUri:w.URI.revive(o.source),newUri:w.URI.revive(o.target)}))},n,f);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:_.map(o=>w.URI.revive(o.target))},n,f);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:_.map(o=>w.URI.revive(o.target))},n,f)}}async _fireWillEvent(F,_,n,f){const o=new Set,g=[];if(await F.fireAsync(_,f,async(D,v)=>{const h=Date.now(),p=await Promise.resolve(D);p instanceof k.WorkspaceEdit&&(g.push(p),o.add(v.extension.displayName??v.extension.identifier.value)),Date.now()-h>n&&this._logService.warn("SLOW file-participant",v.extension.identifier)}),f.isCancellationRequested||g.length===0)return;const c={edits:[]};for(let D of g){let{edits:v}=T.WorkspaceEdit.from(D,this._extHostDocumentsAndEditors);c.edits=c.edits.concat(v)}return{edit:c,extensionNames:Array.from(o)}}}e.ExtHostFileSystemEventService=C}),define(Ee[167],ye([0,1,10,26,2,8,7,87]),function(re,e,a,t,w,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class C{constructor(n,f,o,g){this.start=n,this.deletedCount=f,this.deletedItems=o,this.items=g}static asApiEvents(n){return n.map(f=>({start:f.start,deletedCount:f.deletedCount,deletedItems:f.deletedItems,items:f.items.map(o=>o.apiCell)}))}}class R{constructor(n,f,o){this.notebook=n,this._extHostDocument=f,this._cellData=o,this.handle=o.handle,this.uri=w.URI.revive(o.uri),this.cellKind=o.cellKind,this._outputs=o.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=o.internalMetadata??{},this._metadata=Object.freeze(o.metadata??{}),this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(o.internalMetadata??{}))}static asModelAddData(n,f){return{EOL:f.eol,lines:f.source,languageId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:n}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const n=this,f=this._extHostDocument.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return n.notebook.getCellIndex(n)},notebook:n.notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:f.document,get mime(){return n._mime},set mime(o){n._mime=o},get outputs(){return n._outputs.slice(0)},get metadata(){return n._metadata},get executionSummary(){return n._previousResult}})}return this._apiCell}setOutputs(n){this._outputs=n.map(T.NotebookCellOutput.to)}setOutputItems(n,f,o){const g=o.map(T.NotebookCellOutputItem.to),c=this._outputs.find(D=>D.id===n);c&&(f||(c.items.length=0),c.items.push(...g))}setMetadata(n){this._metadata=Object.freeze(n)}setInternalMetadata(n){this._internalMetadata=n,this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(n))}setMime(n){}}e.ExtHostCell=R;class F{constructor(n,f,o,g,c,D){this._proxy=n,this._textDocumentsAndEditors=f,this._textDocuments=o,this._emitter=g,this.uri=c,this.handle=F._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=D.viewType,this._metadata=Object.freeze(D.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,D.cells]],!0),this._versionId=D.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const n=this;this._notebook={get uri(){return n.uri},get version(){return n._versionId},get notebookType(){return n._notebookType},get isDirty(){return n._isDirty},get isUntitled(){return n.uri.scheme===a.Schemas.untitled},get isClosed(){return n._disposed},get metadata(){return n._metadata},get cellCount(){return n._cells.length},cellAt(f){return f=n._validateIndex(f),n._cells[f].apiCell},getCells(f){return(f?n._getCells(f):n._cells).map(g=>g.apiCell)},save(){return n._save()}}}return this._notebook}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(n){n.metadata&&(this._metadata=Object.freeze({...this._metadata,...n.metadata}))}acceptDirty(n){this._isDirty=n}acceptModelChanged(n,f){this._versionId=n.versionId,this._isDirty=f;for(const o of n.rawEvents)o.kind===P.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(o.changes,!1):o.kind===P.NotebookCellsChangeType.Move?this._moveCell(o.index,o.newIdx):o.kind===P.NotebookCellsChangeType.Output?this._setCellOutputs(o.index,o.outputs):o.kind===P.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(o.index,o.outputId,o.append,o.outputItems):o.kind===P.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(o.index,o.language):o.kind===P.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(o.index,o.mime):o.kind===P.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(o.index,o.metadata):o.kind===P.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(o.index,o.internalMetadata)}_validateIndex(n){return n=n|0,n<0?0:n>=this._cells.length?this._cells.length-1:n}_validateRange(n){let f=n.start|0,o=n.end|0;return f<0&&(f=0),o>this._cells.length&&(o=this._cells.length),n.with({start:f,end:o})}_getCells(n){n=this._validateRange(n);const f=[];for(let o=n.start;o<n.end;o++)f.push(this._cells[o]);return f}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(n,f){if(this._disposed)return;const o=[],g=[],c=[];n.reverse().forEach(D=>{const h=D[2].map(l=>{const M=new R(this,this._textDocumentsAndEditors,l);return f||g.push(R.asModelAddData(this.apiNotebook,l)),M}),p=new C(D[0],D[1],[],h),I=this._cells.splice(D[0],D[1],...h);for(const l of I)c.push(l.uri),p.deletedItems.push(l.apiCell);o.push(p)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:g,removedDocuments:c}),f||this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:C.asApiEvents(o)}))}_moveCell(n,f){const o=this._cells.splice(n,1);this._cells.splice(f,0,...o);const g=[new C(n,1,o.map(c=>c.apiCell),[]),new C(f,0,[],o)];this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:C.asApiEvents(g)}))}_setCellOutputs(n,f){const o=this._cells[n];o.setOutputs(f),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[o.apiCell]}))}_setCellOutputItems(n,f,o,g){const c=this._cells[n];c.setOutputItems(f,o,g),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[c.apiCell]}))}_changeCellLanguage(n,f){const o=this._cells[n];o.apiCell.document.languageId!==f&&this._textDocuments.$acceptModelModeChanged(o.uri,f)}_changeCellMime(n,f){const o=this._cells[n];o.apiCell.mime=f}_changeCellMetadata(n,f){const o=this._cells[n],g=o.apiCell.metadata;o.setMetadata(f);const c=o.apiCell.metadata;(0,t.equals)(g,c)||this._emitter.emitCellMetadataChange((0,t.deepFreeze)({document:this.apiNotebook,cell:o.apiCell}))}_changeCellInternalMetadata(n,f){const o=this._cells[n],g=o.internalMetadata;if(o.setInternalMetadata(f),g.runState!==f.runState){const c=f.runState??k.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,t.deepFreeze)({document:this.apiNotebook,cell:o.apiCell,state:c}))}}getCellFromApiCell(n){return this._cells.find(f=>f.apiCell===n)}getCellFromIndex(n){return this._cells[n]}getCell(n){return this._cells.find(f=>f.handle===n)}getCellIndex(n){return this._cells.indexOf(n)}}e.ExtHostNotebookDocument=F,F._handlePool=0}),define(Ee[91],ye([0,1,7,8,15]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class T{constructor(C){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=C}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(C){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:C})}replaceCellMetadata(C,R){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:C,metadata:R})}replaceCells(C,R,F){this._throwIfFinalized(),!(C===R&&F.length===0)&&this._collectedEdits.push({editType:1,index:C,count:R-C,cells:F.map(t.NotebookCellData.from)})}}class k{constructor(C,R,F,_,n,f){this.id=C,this._proxy=R,this.notebookData=F,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=n,this._visibleRanges=_,this._viewColumn=f}get apiEditor(){if(!this._editor){const C=this;this._editor={get document(){return C.notebookData.apiNotebook},get selections(){return C._selections},set selections(R){if(!Array.isArray(R)||!R.every(a.NotebookRange.isNotebookRange))throw(0,w.illegalArgument)("selections");C._selections=R,C._trySetSelections(R)},get visibleRanges(){return C._visibleRanges},revealRange(R,F){C._proxy.$tryRevealRange(C.id,t.NotebookRange.from(R),F??a.NotebookEditorRevealType.Default)},get viewColumn(){return C._viewColumn},edit(R){const F=new T(this.document.version);return R(F),C._applyEdit(F.finalize())},setDecorations(R,F){return C.setDecorations(R,F)}},k.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(C){this._visible=C}_acceptVisibleRanges(C){this._visibleRanges=C}_acceptSelections(C){this._selections=C}_trySetSelections(C){this._proxy.$trySetSelections(this.id,C.map(t.NotebookRange.from))}_acceptViewColumn(C){this._viewColumn=C}_applyEdit(C){if(C.cellEdits.length===0)return Promise.resolve(!0);const R=[];let F=-1;for(let _=0;_<C.cellEdits.length;_++){if(F<0){R.push(C.cellEdits[_]),F++;continue}const f=R[F],o=C.cellEdits[_];if(f.editType===1&&o.editType===1&&f.index===o.index){f.cells.push(...C.cellEdits[_].cells),f.count+=C.cellEdits[_].count;continue}R.push(C.cellEdits[_]),F++}return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,R)}setDecorations(C,R){if(!(R.isEmpty&&!this._hasDecorationsForKey.has(C.key)))return R.isEmpty?this._hasDecorationsForKey.delete(C.key):this._hasDecorationsForKey.add(C.key),this._proxy.$trySetDecorations(this.id,t.NotebookRange.from(R),C.key)}}e.ExtHostNotebookEditor=k,k.apiEditorsToExtHost=new WeakMap}),define(Ee[168],ye([0,1,8,140,121,20,52,15]),function(re,e,a,t,w,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(n){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=n}async withProgress(n,f,o){const g=this._handles++,{title:c,location:D,cancellable:v}=f,h={label:(0,w.localize)(0,null,n.displayName||n.name),id:n.identifier.value};return this._proxy.$startProgress(g,{location:a.ProgressLocation.from(D),title:c,source:h,cancellable:v},n).catch(P.onUnexpectedExternalError),this._withProgress(g,o,!!v)}_withProgress(n,f,o){let g;o&&(g=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(n,g));const c=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),g&&g.dispose()};let D;try{D=f(new F(this._proxy,n),o&&g?g.token:T.CancellationToken.None)}catch(v){throw c(n),v}return D.then(v=>c(n),v=>c(n)),D}$acceptProgressCanceled(n){const f=this._mapHandleToCancellationSource.get(n);f&&(f.cancel(),this._mapHandleToCancellationSource.delete(n))}}e.ExtHostProgress=C;function R(_,n){return _.message=n.message,typeof n.increment=="number"&&(typeof _.increment=="number"?_.increment+=n.increment:_.increment=n.increment),_}class F extends t.Progress{constructor(n,f){super(o=>this.throttledReport(o));this._proxy=n,this._handle=f}throttledReport(n){this._proxy.$progressReport(this._handle,n)}}Ue([(0,k.throttle)(100,(_,n)=>R(_,n),()=>Object.create(null))],F.prototype,"throttledReport",null)}),define(Ee[92],ye([0,1,41,15,53,8,7]),function(re,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class P{constructor(n,f,o){const g=P._Keys.nextId();n.$registerTextEditorDecorationType(f.identifier,g,T.DecorationRenderOptions.from(o)),this.value=Object.freeze({key:g,dispose(){n.$removeTextEditorDecorationType(g)}})}}e.TextEditorDecorationType=P,P._Keys=new w.IdGenerator("TextEditorDecorationType");class C{constructor(n,f){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=n,this._documentVersionId=n.version,this._undoStopBefore=f.undoStopBefore,this._undoStopAfter=f.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(n,f){this._throwIfFinalized();let o=null;if(n instanceof k.Position)o=new k.Range(n,n);else if(n instanceof k.Range)o=n;else throw new Error("Unrecognized location");this._pushEdit(o,f,!1)}insert(n,f){this._throwIfFinalized(),this._pushEdit(new k.Range(n,n),f,!0)}delete(n){this._throwIfFinalized();let f=null;if(n instanceof k.Range)f=n;else throw new Error("Unrecognized location");this._pushEdit(f,null,!0)}_pushEdit(n,f,o){const g=this._document.validateRange(n);this._collectedEdits.push({range:g,text:f,forceMoveMarkers:o})}setEndOfLine(n){if(this._throwIfFinalized(),n!==k.EndOfLine.LF&&n!==k.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=n}}e.TextEditorEdit=C;class R{constructor(n,f,o,g){this._proxy=n,this._id=f,this._accept(o),this._logService=g;const c=this;this.value={get tabSize(){return c._tabSize},set tabSize(D){c._setTabSize(D)},get insertSpaces(){return c._insertSpaces},set insertSpaces(D){c._setInsertSpaces(D)},get cursorStyle(){return c._cursorStyle},set cursorStyle(D){c._setCursorStyle(D)},get lineNumbers(){return c._lineNumbers},set lineNumbers(D){c._setLineNumbers(D)}}}_accept(n){this._tabSize=n.tabSize,this._insertSpaces=n.insertSpaces,this._cursorStyle=n.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(n.lineNumbers)}_validateTabSize(n){if(n==="auto")return"auto";if(typeof n=="number"){const f=Math.floor(n);return f>0?f:null}if(typeof n=="string"){const f=parseInt(n,10);return isNaN(f)?null:f>0?f:null}return null}_setTabSize(n){const f=this._validateTabSize(n);if(f!==null){if(typeof f=="number"){if(this._tabSize===f)return;this._tabSize=f}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:f}))}}_validateInsertSpaces(n){return n==="auto"?"auto":n==="false"?!1:Boolean(n)}_setInsertSpaces(n){const f=this._validateInsertSpaces(n);if(typeof f=="boolean"){if(this._insertSpaces===f)return;this._insertSpaces=f}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:f}))}_setCursorStyle(n){this._cursorStyle!==n&&(this._cursorStyle=n,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:n})))}_setLineNumbers(n){this._lineNumbers!==n&&(this._lineNumbers=n,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(n)})))}assign(n){const f={};let o=!1;if(typeof n.tabSize!="undefined"){const g=this._validateTabSize(n.tabSize);g==="auto"?(o=!0,f.tabSize=g):typeof g=="number"&&this._tabSize!==g&&(this._tabSize=g,o=!0,f.tabSize=g)}if(typeof n.insertSpaces!="undefined"){const g=this._validateInsertSpaces(n.insertSpaces);g==="auto"?(o=!0,f.insertSpaces=g):this._insertSpaces!==g&&(this._insertSpaces=g,o=!0,f.insertSpaces=g)}typeof n.cursorStyle!="undefined"&&this._cursorStyle!==n.cursorStyle&&(this._cursorStyle=n.cursorStyle,o=!0,f.cursorStyle=n.cursorStyle),typeof n.lineNumbers!="undefined"&&this._lineNumbers!==n.lineNumbers&&(this._lineNumbers=n.lineNumbers,o=!0,f.lineNumbers=T.TextEditorLineNumbersStyle.from(n.lineNumbers)),o&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,f))}_warnOnError(n,f){f.catch(o=>{this._logService.warn(`ExtHostTextEditorOptions '${n}' failed:'`),this._logService.warn(o)})}}e.ExtHostTextEditorOptions=R;class F{constructor(n,f,o,g,c,D,v,h){this.id=n,this._proxy=f,this._logService=o,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=c,this._options=new R(this._proxy,this.id,D,o),this._visibleRanges=v,this._viewColumn=h;const p=this;this.value=Object.freeze({get document(){return g.getValue()},set document(I){throw(0,t.readonly)("document")},get selection(){return p._selections&&p._selections[0]},set selection(I){if(!(I instanceof k.Selection))throw(0,t.illegalArgument)("selection");p._selections=[I],p._trySetSelection()},get selections(){return p._selections},set selections(I){if(!Array.isArray(I)||I.some(l=>!(l instanceof k.Selection)))throw(0,t.illegalArgument)("selections");p._selections=I,p._trySetSelection()},get visibleRanges(){return p._visibleRanges},set visibleRanges(I){throw(0,t.readonly)("visibleRanges")},get options(){return p._options.value},set options(I){p._disposed||p._options.assign(I)},get viewColumn(){return p._viewColumn},set viewColumn(I){throw(0,t.readonly)("viewColumn")},edit(I,l={undoStopBefore:!0,undoStopAfter:!0}){if(p._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const M=new C(g.getValue(),l);return I(M),p._applyEdit(M)},insertSnippet(I,l,M={undoStopBefore:!0,undoStopAfter:!0}){if(p._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!l||Array.isArray(l)&&l.length===0)r=p._selections.map(i=>T.Range.from(i));else if(l instanceof k.Position){const{lineNumber:i,column:m}=T.Position.from(l);r=[{startLineNumber:i,startColumn:m,endLineNumber:i,endColumn:m}]}else if(l instanceof k.Range)r=[T.Range.from(l)];else{r=[];for(const i of l)if(i instanceof k.Range)r.push(T.Range.from(i));else{const{lineNumber:m,column:d}=T.Position.from(i);r.push({startLineNumber:m,startColumn:d,endLineNumber:m,endColumn:d})}}return f.$tryInsertSnippet(n,I.value,r,M)},setDecorations(I,l){const M=l.length===0;M&&!p._hasDecorationsForKey.has(I.key)||(M?p._hasDecorationsForKey.delete(I.key):p._hasDecorationsForKey.add(I.key),p._runOnProxy(()=>{if(T.isDecorationOptionsArr(l))return f.$trySetDecorations(n,I.key,T.fromRangeOrRangeWithMessage(l));{const r=new Array(4*l.length);for(let i=0,m=l.length;i<m;i++){const d=l[i];r[4*i]=d.start.line+1,r[4*i+1]=d.start.character+1,r[4*i+2]=d.end.line+1,r[4*i+3]=d.end.character+1}return f.$trySetDecorationsFast(n,I.key,r)}}))},revealRange(I,l){p._runOnProxy(()=>f.$tryRevealRange(n,T.Range.from(I),l||k.TextEditorRevealType.Default))},show(I){f.$tryShowEditor(n,T.ViewColumn.from(I))},hide(){f.$tryHideEditor(n)}})}dispose(){(0,a.ok)(!this._disposed),this._disposed=!0}_acceptOptions(n){(0,a.ok)(!this._disposed),this._options._accept(n)}_acceptVisibleRanges(n){(0,a.ok)(!this._disposed),this._visibleRanges=n}_acceptViewColumn(n){(0,a.ok)(!this._disposed),this._viewColumn=n}_acceptSelections(n){(0,a.ok)(!this._disposed),this._selections=n}async _trySetSelection(){const n=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,n)),this.value}_applyEdit(n){const f=n.finalize();if(f.edits.length===0&&!f.setEndOfLine)return Promise.resolve(!0);const o=f.edits.map(c=>c.range);o.sort((c,D)=>c.end.line===D.end.line?c.end.character===D.end.character?c.start.line===D.start.line?c.start.character-D.start.character:c.start.line-D.start.line:c.end.character-D.end.character:c.end.line-D.end.line);for(let c=0,D=o.length-1;c<D;c++){const v=o[c].end;if(o[c+1].start.isBefore(v))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const g=f.edits.map(c=>({range:T.Range.from(c.range),text:c.text,forceMoveMarkers:c.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,f.documentVersionId,g,{setEndOfLine:typeof f.setEndOfLine=="number"?T.EndOfLine.from(f.setEndOfLine):void 0,undoStopBefore:f.undoStopBefore,undoStopAfter:f.undoStopAfter})}_runOnProxy(n){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):n().then(()=>this,f=>(f instanceof Error&&f.name==="DISPOSED"||this._logService.warn(f),null))}}e.ExtHostTextEditor=F}),define(Ee[169],ye([0,1,124,24,2,4,6,14,7,11,16,8,20,153]),function(re,e,a,t,w,T,k,P,C,R,F,_,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function o(D,v){if((0,R.isString)(D))return{label:D};if(D&&typeof D=="object"&&typeof D.label=="string"){let h;return Array.isArray(D.highlights)&&(h=D.highlights.filter(p=>p.length===2&&typeof p[0]=="number"&&typeof p[1]=="number"),h=h.length?h:void 0),{label:D.label,highlights:h}}}class g{constructor(v,h,p){this._proxy=v,this.commands=h,this.logService=p,this.treeViews=new Map;function I(l){return l&&l.$treeViewId&&l.$treeItemHandle}h.registerArgumentProcessor({processArgument:l=>I(l)?this.convertArgument(l):Array.isArray(l)&&l.length>0?l.map(M=>I(M)?this.convertArgument(M):M):l})}registerTreeDataProvider(v,h,p){const I=this.createTreeView(v,{treeDataProvider:h},p);return{dispose:()=>I.dispose()}}createTreeView(v,h,p){if(!h||!h.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const I=h.dragAndDropController?.supportedMimeTypes,l=this._proxy.$registerTreeViewDataProvider(v,{showCollapseAll:!!h.showCollapseAll,canSelectMany:!!h.canSelectMany,dragAndDropMimeTypes:I}),M=this.createExtHostTreeView(v,h,p);return{get onDidCollapseElement(){return M.onDidCollapseElement},get onDidExpandElement(){return M.onDidExpandElement},get selection(){return M.selectedElements},get onDidChangeSelection(){return M.onDidChangeSelection},get visible(){return M.visible},get onDidChangeVisibility(){return M.onDidChangeVisibility},get message(){return M.message},set message(r){M.message=r},get title(){return M.title},set title(r){M.title=r},get description(){return M.description},set description(r){M.description=r},reveal:(r,i)=>M.reveal(r,i),dispose:async()=>{await l,this.treeViews.delete(v),M.dispose()}}}$getChildren(v,h){const p=this.treeViews.get(v);return p?p.getChildren(h):Promise.reject(new Error((0,a.localize)(0,null,v)))}async $onDrop(v,h,p,I,l){const M=this.treeViews.get(v);if(!M)return Promise.reject(new Error((0,a.localize)(1,null,v)));const r=f.TreeDataTransferConverter.toITreeDataTransfer(h);if(I===v&&l){const i=await M.onWillDrop(l);i&&i.forEach((m,d)=>{m&&r.set(d,m)})}return M.onDrop(r,p)}async $hasResolve(v){const h=this.treeViews.get(v);if(!h)throw new Error((0,a.localize)(2,null,v));return h.hasResolve}$resolve(v,h,p){const I=this.treeViews.get(v);if(!I)throw new Error((0,a.localize)(3,null,v));return I.resolveTreeItem(h,p)}$setExpanded(v,h,p){const I=this.treeViews.get(v);if(!I)throw new Error((0,a.localize)(4,null,v));I.setExpanded(h,p)}$setSelection(v,h){const p=this.treeViews.get(v);if(!p)throw new Error((0,a.localize)(5,null,v));p.setSelection(h)}$setVisible(v,h){const p=this.treeViews.get(v);if(!p)throw new Error((0,a.localize)(6,null,v));p.setVisible(h)}createExtHostTreeView(v,h,p){const I=new c(v,h,this._proxy,this.commands.converter,this.logService,p);return this.treeViews.set(v,I),I}convertArgument(v){const h=this.treeViews.get(v.$treeViewId);return h?h.getExtensionElement(v.$treeItemHandle):null}}e.ExtHostTreeViews=g;class c extends k.Disposable{constructor(v,h,p,I,l,M){super();if(this.viewId=v,this.proxy=p,this.commands=I,this.logService=l,this.extension=M,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new n.CancellationTokenSource,M.contributes&&M.contributes.views)for(const m in M.contributes.views)for(const d of M.contributes.views[m])d.id===v&&(this._title=d.name);this.dataProvider=h.treeDataProvider,this.dndController=h.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(m=>this._onDidChangeData.fire({message:!1,element:m}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(m=>this._onDidChangeData.fire({message:!1,element:m})));let r,i;this._register(T.Event.debounce(this._onDidChangeData.event,(m,d)=>(m||(m={message:!1,elements:[]}),d.element!==!1&&(r||(r=new Promise(s=>i=s),this.refreshPromise=this.refreshPromise.then(()=>r)),Array.isArray(d.element)?m.elements.push(...d.element):m.elements.push(d.element)),d.message&&(m.message=!0),m),200,!0)(({message:m,elements:d})=>{d.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const s=i;return r=null,this.refresh(d).then(()=>s())})),m&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(v=>this.getExtensionElement(v)).filter(v=>!(0,R.isUndefinedOrNull)(v))}async getChildren(v){const h=v?this.getExtensionElement(v):void 0;if(v&&!h)return this.logService.error(`No tree item with id '${v}' found.`),Promise.resolve([]);let p=this.getChildrenNodes(v);return p||(p=await this.fetchChildrenNodes(h)),p?p.map(I=>I.item):void 0}getExtensionElement(v){return this.elements.get(v)}reveal(v,h){h=h||{select:!0,focus:!1};const p=(0,R.isUndefinedOrNull)(h.select)?!0:h.select,I=(0,R.isUndefinedOrNull)(h.focus)?!1:h.focus,l=(0,R.isUndefinedOrNull)(h.expand)?!1:h.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.refreshPromise.then(()=>this.resolveUnknownParentChain(v)).then(M=>this.resolveTreeNode(v,M[M.length-1]).then(r=>this.proxy.$reveal(this.viewId,{item:r.item,parentChain:M.map(i=>i.item)},{select:p,focus:I,expand:l})),M=>this.logService.error(M)):this.proxy.$reveal(this.viewId,void 0,{select:p,focus:I,expand:l})}get message(){return this._message}set message(v){this._message=v,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(v){this._title=v,this.proxy.$setTitle(this.viewId,v,this._description)}get description(){return this._description}set description(v){this._description=v,this.proxy.$setTitle(this.viewId,this._title,v)}setExpanded(v,h){const p=this.getExtensionElement(v);p&&(h?this._onDidExpandElement.fire(Object.freeze({element:p})):this._onDidCollapseElement.fire(Object.freeze({element:p})))}setSelection(v){(0,F.equals)(this._selectedHandles,v)||(this._selectedHandles=v,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(v){v!==this._visible&&(this._visible=v,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onWillDrop(v){const h=[];for(const p of v){const I=this.getExtensionElement(p);I&&h.push(I)}if(!(!this.dndController?.onWillDrop||h.length===0))return this.dndController.onWillDrop(h)}async onDrop(v,h){const p=this.getExtensionElement(h);if(!!p)return(0,P.asPromise)(()=>this.dndController?.onDrop(v,p))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(v,h){if(!this.dataProvider.resolveTreeItem)return;const p=this.elements.get(v);if(p){const I=this.nodes.get(p);if(I){const l=await this.dataProvider.resolveTreeItem(I.extensionItem,p,h)??I.extensionItem;return I.item.tooltip=this.getTooltip(l.tooltip),I.item.command=this.getCommand(I.disposableStore,l.command),I.item}}}resolveUnknownParentChain(v){return this.resolveParent(v).then(h=>h?this.resolveUnknownParentChain(h).then(p=>this.resolveTreeNode(h,p[p.length-1]).then(I=>(p.push(I),p))):Promise.resolve([]))}resolveParent(v){const h=this.nodes.get(v);return h?Promise.resolve(h.parent?this.elements.get(h.parent.item.handle):void 0):(0,P.asPromise)(()=>this.dataProvider.getParent(v))}resolveTreeNode(v,h){const p=this.nodes.get(v);return p?Promise.resolve(p):(0,P.asPromise)(()=>this.dataProvider.getTreeItem(v)).then(I=>this.createHandle(v,I,h,!0)).then(I=>this.getChildren(h?h.item.handle:void 0).then(()=>{const l=this.getExtensionElement(I);if(l){const M=this.nodes.get(l);if(M)return Promise.resolve(M)}throw new Error(`Cannot resolve tree item for element ${I}`)}))}getChildrenNodes(v){if(v){let h;if(typeof v=="string"){const p=this.getExtensionElement(v);h=p?this.nodes.get(p):void 0}else h=v;return h&&h.children||void 0}return this.roots}async fetchChildrenNodes(v){this.clearChildren(v);const h=new n.CancellationTokenSource(this._refreshCancellationSource.token);try{const p=v?this.nodes.get(v):void 0,I=await this.dataProvider.getChildren(v);if(h.token.isCancellationRequested)return;const l=await Promise.all((0,F.coalesce)(I||[]).map(async M=>{const r=await this.dataProvider.getTreeItem(M);return r&&!h.token.isCancellationRequested?this.createAndRegisterTreeNode(M,r,p):null}));return h.token.isCancellationRequested?void 0:(0,F.coalesce)(l)}finally{h.dispose()}}refresh(v){if(v.some(p=>!p))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new n.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const p=this.getHandlesToRefresh(v);if(p.length)return this.refreshHandles(p)}return Promise.resolve(void 0)}getHandlesToRefresh(v){const h=new Set,p=v.map(l=>this.nodes.get(l));for(const l of p)if(l&&!h.has(l.item.handle)){let M=l;for(;M&&M.parent&&p.findIndex(r=>M&&M.parent&&r&&r.item.handle===M.parent.item.handle)===-1;){const r=this.elements.get(M.parent.item.handle);M=r?this.nodes.get(r):void 0}M&&!M.parent&&h.add(l.item.handle)}const I=[];return h.forEach(l=>{const M=this.elements.get(l);if(M){const r=this.nodes.get(M);r&&(!r.parent||!h.has(r.parent.item.handle))&&I.push(l)}}),I}refreshHandles(v){const h={};return Promise.all(v.map(p=>this.refreshNode(p).then(I=>{I&&(h[p]=I.item)}))).then(()=>Object.keys(h).length?this.proxy.$refresh(this.viewId,h):void 0)}refreshNode(v){const h=this.getExtensionElement(v);if(h){const p=this.nodes.get(h);if(p)return this.clearChildren(h),(0,P.asPromise)(()=>this.dataProvider.getTreeItem(h)).then(I=>{if(I){const l=this.createTreeNode(h,I,p.parent);return this.updateNodeCache(h,l,p,p.parent),p.dispose(),l}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(v,h,p){const I=this.createTreeNode(v,h,p);if(h.id&&this.elements.has(I.item.handle))throw new Error((0,a.localize)(7,null,h.id));return this.addNodeToCache(v,I),this.addNodeToParentCache(I,p),I}getTooltip(v){return C.MarkdownString.isMarkdownString(v)?_.MarkdownString.from(v):v}getCommand(v,h){return h?this.commands.toInternal(h,v):void 0}createTreeNode(v,h,p){const I=new k.DisposableStore,l=this.createHandle(v,h,p),M=this.getLightIconPath(h);return{item:{handle:l,parentHandle:p?p.item.handle:void 0,label:o(h.label,this.extension),description:h.description,resourceUri:h.resourceUri,tooltip:this.getTooltip(h.tooltip),command:this.getCommand(I,h.command),contextValue:h.contextValue,icon:M,iconDark:this.getDarkIconPath(h)||M,themeIcon:this.getThemeIcon(h),collapsibleState:(0,R.isUndefinedOrNull)(h.collapsibleState)?C.TreeItemCollapsibleState.None:h.collapsibleState,accessibilityInformation:h.accessibilityInformation},extensionItem:h,parent:p,children:void 0,disposableStore:I,dispose(){I.dispose()}}}getThemeIcon(v){return v.iconPath instanceof C.ThemeIcon?v.iconPath:void 0}createHandle(v,{id:h,label:p,resourceUri:I},l,M){if(h)return`${c.ID_HANDLE_PREFIX}/${h}`;const r=o(p,this.extension),i=l?l.item.handle:c.LABEL_HANDLE_PREFIX;let m=r?r.label:I?(0,t.basename)(I):"";m=m.indexOf("/")!==-1?m.replace("/","//"):m;const d=this.nodes.has(v)?this.nodes.get(v).item.handle:void 0,s=this.getChildrenNodes(l)||[];let b,y=0;do{if(b=`${i}/${y}:${m}`,M||!this.elements.has(b)||d===b)break;y++}while(y<=s.length);return b}getLightIconPath(v){if(v.iconPath&&!(v.iconPath instanceof C.ThemeIcon))return typeof v.iconPath=="string"||w.URI.isUri(v.iconPath)?this.getIconPath(v.iconPath):this.getIconPath(v.iconPath.light)}getDarkIconPath(v){if(v.iconPath&&!(v.iconPath instanceof C.ThemeIcon)&&v.iconPath.dark)return this.getIconPath(v.iconPath.dark)}getIconPath(v){return w.URI.isUri(v)?v:w.URI.file(v)}addNodeToCache(v,h){this.elements.set(h.item.handle,v),this.nodes.set(v,h)}updateNodeCache(v,h,p,I){this.elements.delete(h.item.handle),this.nodes.delete(v),h.item.handle!==p.item.handle&&this.elements.delete(p.item.handle),this.addNodeToCache(v,h);const l=this.getChildrenNodes(I)||[],M=l.filter(r=>r.item.handle===p.item.handle)[0];M&&l.splice(l.indexOf(M),1,h)}addNodeToParentCache(v,h){h?(h.children||(h.children=[]),h.children.push(v)):(this.roots||(this.roots=[]),this.roots.push(v))}clearChildren(v){if(v){const h=this.nodes.get(v);if(h){if(h.children)for(const p of h.children){const I=this.elements.get(p.item.handle);I&&this.clear(I)}h.children=void 0}}else this.clearAll()}clear(v){const h=this.nodes.get(v);if(h){if(h.children)for(const p of h.children){const I=this.elements.get(p.item.handle);I&&this.clear(I)}this.nodes.delete(v),this.elements.delete(h.item.handle),h.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(v=>v.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}c.LABEL_HANDLE_PREFIX="0",c.ID_HANDLE_PREFIX="1"}),define(Ee[170],ye([0,1,14,4,6,11,47,8,88,67]),function(re,e,a,t,w,T,k,P,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class F extends w.Disposable{constructor(n){super();this.controllerId=n,this.debounceSendDiff=this._register(new a.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.root=new k.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const f of this.tree.values())this.updateExpandability(f)}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){const f=this.diff[this.diff.length-1];if(f&&n[0]===1){if(f[0]===1&&f[1].extId===n[1].extId){(0,C.applyTestItemUpdate)(f[1],n[1]);return}if(f[0]===0&&f[1].item.extId===n[1].extId){(0,C.applyTestItemUpdate)(f[1],n[1]);return}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,f){const o=this.tree.get(n);if(!!o){if((o.expandLevels===void 0||f>o.expandLevels)&&(o.expandLevels=f),o.expand===1){const g=this.resolveChildren(o);return g.isOpen()?this.expandChildren(o,f-1):g.wait().then(()=>this.expandChildren(o,f-1))}else if(o.expand===3)return o.resolveBarrier?.isOpen()===!1?o.resolveBarrier.wait().then(()=>this.expandChildren(o,f-1)):this.expandChildren(o,f-1)}}dispose(){for(const n of this.tree.values())(0,k.getPrivateApiFor)(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,f){switch(f.op){case 2:this.pushDiff([4,n.fullId.toString()]);break;case 1:this.removeItem(R.TestId.joinToString(n.fullId,f.id));break;case 0:this.upsertItem(f.item,n);break;case 4:for(const o of f.ops)this.onTestItemEvent(n,o);break;case 3:{const{key:o,value:g,previous:c}=f,D=n.fullId.toString();switch(o){case"canResolveChildren":this.updateExpandability(n);break;case"tags":this.diffTagRefs(g,c,D);break;case"range":this.pushDiff([1,{extId:D,item:{range:P.Range.from(g)}}]);break;case"error":this.pushDiff([1,{extId:D,item:{error:P.MarkdownString.fromStrict(g)||null}}]);break;default:this.pushDiff([1,{extId:D,item:{[o]:g??null}}]);break}break}default:(0,T.assertNever)(f)}}upsertItem(n,f){if(!(n instanceof k.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${n.id} did not`);const o=R.TestId.fromExtHostTestItem(n,this.root.id,f?.actual),g=(0,k.getPrivateApiFor)(n);g.parent&&g.parent!==f?.actual&&g.parent.children.delete(n.id);let c=this.tree.get(o.toString());if(!c){c={fullId:o,actual:n,parent:f?o.parentId:null,expandLevels:f?.expandLevels?f.expandLevels-1:void 0,expand:0},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(c.fullId.toString(),c),this.setItemParent(n,f),this.pushDiff([0,{parent:c.parent&&c.parent.toString(),controllerId:this.controllerId,expand:c.expand,item:P.TestItem.from(n)}]),this.connectItemAndChildren(n,c,f);return}if(c.actual===n){this.connectItem(n,c,f);return}const D=c.actual.children,v=c.actual,h=(0,k.diffTestItems)(v,n);(0,k.getPrivateApiFor)(v).listener=void 0,c.actual=n,c.expand=0;for(const[p,I]of h)this.onTestItemEvent(c,{op:3,key:p,value:I,previous:v[p]});this.connectItemAndChildren(n,c,f);for(const p of D)n.children.get(p.id)||this.removeItem(R.TestId.joinToString(o,p.id))}diffTagRefs(n,f,o){const g=new Set(f.map(c=>c.id));for(const c of n)g.delete(c.id)||this.incrementTagRefs(c);this.pushDiff([1,{extId:o,item:{tags:n.map(c=>P.TestTag.namespace(this.controllerId,c.id))}}]),g.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const f=this.tags.get(n.id);f?f.refCount++:(this.tags.set(n.id,{refCount:1}),this.pushDiff([5,{id:P.TestTag.namespace(this.controllerId,n.id),ctrlLabel:this.root.label}]))}decrementTagRefs(n){const f=this.tags.get(n);f&&!--f.refCount&&(this.tags.delete(n),this.pushDiff([6,P.TestTag.namespace(this.controllerId,n)]))}setItemParent(n,f){(0,k.getPrivateApiFor)(n).parent=f&&f.actual!==this.root?f.actual:void 0}connectItem(n,f,o){this.setItemParent(n,o);const g=(0,k.getPrivateApiFor)(n);g.parent=o?.actual,g.listener=c=>this.onTestItemEvent(f,c),this.updateExpandability(f)}connectItemAndChildren(n,f,o){this.connectItem(n,f,o);for(const g of n.children)this.upsertItem(g,f)}updateExpandability(n){let f;this._resolveHandler?n.resolveBarrier?f=n.resolveBarrier.isOpen()?3:2:f=n.actual.canResolveChildren?1:0:f=0,f!==n.expand&&(n.expand=f,this.pushDiff([1,{extId:n.fullId.toString(),expand:f}]),f===1&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,f){if(f<0)return;const o=[];for(const g of n.actual.children){const c=this.expand(R.TestId.joinToString(n.fullId,g.id),f);(0,a.isThenable)(c)&&o.push(c)}if(o.length)return Promise.all(o).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const c=new a.Barrier;return c.open(),c}n.expand=2,this.pushExpandStateUpdate(n);const f=n.resolveBarrier=new a.Barrier,o=c=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),n.actual!==this.root&&(n.actual.error=c.stack||c.message||String(c))};let g;try{g=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(c){o(c)}return(0,a.isThenable)(g)?g.catch(o).then(()=>{f.open(),this.updateExpandability(n)}):(f.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff([1,{extId:n.fullId.toString(),expand:n.expand}])}removeItem(n){const f=this.tree.get(n);if(!f)throw new Error("attempting to remove non-existent child");this.pushDiff([2,n]);const o=[f];for(;o.length;){const g=o.pop();if(!!g){(0,k.getPrivateApiFor)(g.actual).listener=void 0;for(const c of g.actual.tags)this.decrementTagRefs(c.id);this.tree.delete(g.fullId.toString());for(const c of g.actual.children)o.push(this.tree.get(R.TestId.joinToString(g.fullId,c.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.SingleUseTestCollection=F}),define(Ee[171],ye([0,1,3,136]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,a.refineServiceDecorator)(t.IEnvironmentService)}),define(Ee[172],ye([0,1,25,4,17]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(F){this.removedDueToLooping=F}}e.DeltaExtensionsResult=T;class k{constructor(F){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=F,this._initialize()}_initialize(){this._extensionDescriptions.sort(C),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const F of this._extensionDescriptions){if(this._extensionsMap.has(a.ExtensionIdentifier.toKey(F.identifier))){console.error("Extension `"+F.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(a.ExtensionIdentifier.toKey(F.identifier),F),this._extensionsArr.push(F),Array.isArray(F.activationEvents))for(let _ of F.activationEvents)_==="onUri"&&(_=`onUri:${a.ExtensionIdentifier.toKey(F.identifier)}`),this._activationMap.has(_)||this._activationMap.set(_,[]),this._activationMap.get(_).push(F)}}keepOnly(F){const _=new Set;F.forEach(n=>_.add(a.ExtensionIdentifier.toKey(n))),this._extensionDescriptions=this._extensionDescriptions.filter(n=>_.has(a.ExtensionIdentifier.toKey(n.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(F,_){F.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(F));const n=k._findLoopingExtensions(this._extensionDescriptions);if(_=_.concat(n.map(f=>f.identifier)),_.length>0){const f=new Set;_.forEach(o=>f.add(a.ExtensionIdentifier.toKey(o))),this._extensionDescriptions=this._extensionDescriptions.filter(o=>!f.has(a.ExtensionIdentifier.toKey(o.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(n)}static _findLoopingExtensions(F){const _=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(c){this._nodesSet.has(c)||(this._nodesSet.add(c),this._nodesArr.push(c))}addArc(c,D){this.addNode(c),this.addNode(D),this._arcs.has(c)?this._arcs.get(c).push(D):this._arcs.set(c,[D])}getArcs(c){return this._arcs.has(c)?this._arcs.get(c):[]}hasOnlyGoodArcs(c,D){const v=_.getArcs(c);for(let h=0;h<v.length;h++)if(!D.has(v[h]))return!1;return!0}getNodes(){return this._nodesArr}};let n=new Map;for(let c of F){const D=a.ExtensionIdentifier.toKey(c.identifier);if(n.set(D,c),c.extensionDependencies)for(let v of c.extensionDependencies){const h=a.ExtensionIdentifier.toKey(v);_.addArc(D,h)}}let f=new Set;_.getNodes().filter(c=>_.getArcs(c).length===0).forEach(c=>f.add(c));let o=_.getNodes().filter(c=>!f.has(c)),g;do{g=!1;for(let c=0;c<o.length;c++){const D=o[c];_.hasOnlyGoodArcs(D,f)&&(o.splice(c,1),c--,f.add(D),g=!0)}}while(g);return o.map(c=>n.get(c))}containsActivationEvent(F){return this._activationMap.has(F)}containsExtension(F){return this._extensionsMap.has(a.ExtensionIdentifier.toKey(F))}getExtensionDescriptionsForActivationEvent(F){const _=this._activationMap.get(F);return _?_.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(F){const _=this._extensionsMap.get(a.ExtensionIdentifier.toKey(F));return _||void 0}}e.ExtensionDescriptionRegistry=k;var P;(function(R){R[R.Builtin=0]="Builtin",R[R.User=1]="User",R[R.Dev=2]="Dev"})(P||(P={}));function C(R,F){const _=R.isBuiltin?0:R.isUnderDevelopment?2:1,n=F.isBuiltin?0:F.isUnderDevelopment?2:1;if(_!==n)return _-n;const f=w.posix.basename(R.extensionLocation.path),o=w.posix.basename(F.extensionLocation.path);return f<o?-1:f>o?1:0}}),define(Ee[173],ye([0,1,22]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var t;(function(P){P[P.VersionMismatch=55]="VersionMismatch",P[P.UnexpectedError=81]="UnexpectedError"})(t=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var w;(function(P){P[P.Initialized=0]="Initialized",P[P.Ready=1]="Ready",P[P.Terminate=2]="Terminate"})(w=e.MessageType||(e.MessageType={}));function T(P){const C=a.VSBuffer.alloc(1);switch(P){case 0:C.writeUInt8(1,0);break;case 1:C.writeUInt8(2,0);break;case 2:C.writeUInt8(3,0);break}return C}e.createMessageOfType=T;function k(P,C){if(P.byteLength!==1)return!1;switch(P.readUInt8(0)){case 1:return C===0;case 2:return C===1;case 3:return C===2;default:return!1}}e.isMessageOfType=k}),define(Ee[27],ye([0,1,4,2,3,25,143]),function(re,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,w.createDecorator)("extensionService");var P;(function(p){p[p.None=0]="None",p[p.LocalProcess=1]="LocalProcess",p[p.LocalWebWorker=2]="LocalWebWorker",p[p.Remote=3]="Remote"})(P=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function C(p){switch(p){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=C;class R{constructor(I){this.dependency=I}}e.MissingExtensionDependency=R;var F;(function(p){p[p.LocalProcess=0]="LocalProcess",p[p.LocalWebWorker=1]="LocalWebWorker",p[p.Remote=2]="Remote"})(F=e.ExtensionHostKind||(e.ExtensionHostKind={}));function _(p){switch(p){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=_;function n(p,I){return p.enabledApiProposals?p.enabledApiProposals.includes(I):!1}e.isProposedApiEnabled=n;function f(p,I){if(!n(p,I))throw new Error(`Extension '${p.identifier.value}' CANNOT use API proposal: ${I}.
Its package.json#enabledApiProposals-property declares: ${p.enabledApiProposals?.join(", ")??"[]"} but NOT ${I}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${p.identifier.value}`)}e.checkProposedApiEnabled=f;class o{constructor(I,l,M,r){this.codeLoadingTime=I,this.activateCallTime=l,this.activateResolvedTime=M,this.activationReason=r}}e.ActivationTimes=o;class g{constructor(I,l){this.description=I,this.value=l}}e.ExtensionPointContribution=g,e.ExtensionHostLogFileName="exthost";var c;(function(p){p[p.Normal=0]="Normal",p[p.Immediate=1]="Immediate"})(c=e.ActivationKind||(e.ActivationKind={}));function D(p){return{type:p.isBuiltin?0:1,isBuiltin:p.isBuiltin||p.isUserBuiltin,identifier:{id:(0,k.getGalleryExtensionId)(p.publisher,p.name),uuid:p.uuid},manifest:p,location:p.extensionLocation}}e.toExtension=D;function v(p,I){return{identifier:new T.ExtensionIdentifier(p.identifier.id),isBuiltin:p.type===0,isUserBuiltin:p.type===1&&p.isBuiltin,isUnderDevelopment:!!I,extensionLocation:p.location,...p.manifest,uuid:p.identifier.uuid}}e.toExtensionDescription=v;class h{constructor(){this.onDidRegisterExtensions=a.Event.None,this.onDidChangeExtensionsStatus=a.Event.None,this.onDidChangeExtensions=a.Event.None,this.onWillActivateByEvent=a.Event.None,this.onDidChangeResponsiveChange=a.Event.None}activateByEvent(I){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(I){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(I){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(I){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(I,l){return Promise.resolve()}_onWillActivateExtension(I){}_onDidActivateExtension(I,l,M,r,i){}_onDidActivateExtensionError(I,l){}_onExtensionRuntimeError(I,l){}_onExtensionHostExit(I){}}e.NullExtensionService=h}),define(Ee[174],ye([0,1,15,25,27,12]),function(re,e,a,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const k=Promise.resolve(void 0);class P{constructor(g,c,D,v){this.startup=g,this.codeLoadingTime=c,this.activateCallTime=D,this.activateResolvedTime=v}}e.ExtensionActivationTimes=P,P.NONE=new P(!1,-1,-1,-1);class C{constructor(g){this._startup=g,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(g,c){return g===-1||c===-1?-1:c-g}build(){return new P(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class R{constructor(g,c,D,v,h,p){this.activationFailed=g,this.activationFailedError=c,this.activationTimes=D,this.module=v,this.exports=h,this.subscriptions=p}}e.ActivatedExtension=R;class F extends R{constructor(g){super(!1,null,g,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=F;class _ extends R{constructor(){super(!1,null,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=_;class n extends R{constructor(g){super(!0,g,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=n;let f=class{constructor(g,c,D,v,h){this._logService=h,this._isDisposed=!1,this._registry=g,this._resolvedExtensionsSet=new Set,c.forEach(p=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(p))),this._hostExtensionsMap=new Map,D.forEach(p=>this._hostExtensionsMap.set(t.ExtensionIdentifier.toKey(p),p)),this._host=v,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(g){const c=t.ExtensionIdentifier.toKey(g);return this._activatedExtensions.has(c)}getActivatedExtension(g){const c=t.ExtensionIdentifier.toKey(g),D=this._activatedExtensions.get(c);if(!D)throw new Error("Extension `"+g.value+"` is not known or not activated");return D}activateByEvent(g,c){if(this._alreadyActivatedEvents[g])return k;const D=this._registry.getExtensionDescriptionsForActivationEvent(g);return this._activateExtensions(D.map(v=>({id:v.identifier,reason:{startup:c,extensionId:v.identifier,activationEvent:g}}))).then(()=>{this._alreadyActivatedEvents[g]=!0})}activateById(g,c){const D=this._registry.getExtensionDescription(g);if(!D)throw new Error("Extension `"+g+"` is not known");return this._activateExtensions([{id:D.identifier,reason:c}])}_handleActivateRequest(g,c,D){if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(g.id))){c[t.ExtensionIdentifier.toKey(g.id)]=g;return}const v=this._registry.getExtensionDescription(g.id);if(!v){const I=new Error(`Cannot activate unknown extension '${g.id.value}'`);this._host.onExtensionActivationError(g.id,I,new w.MissingExtensionDependency(g.id.value)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(g.id),new n(I));return}const h=typeof v.extensionDependencies=="undefined"?[]:v.extensionDependencies;let p=!0;for(let I=0,l=h.length;I<l;I++){const M=h[I];if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(M)))continue;const r=this._activatedExtensions.get(t.ExtensionIdentifier.toKey(M));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const s=v.displayName||v.identifier.value,b=this._registry.getExtensionDescription(M),y=b&&b.displayName||M,u=new Error(`Cannot activate the '${s}' extension because its dependency '${y}' failed to activate`);u.detail=r.activationFailedError,this._host.onExtensionActivationError(v.identifier,u,null),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(v.identifier),new n(u));return}if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(M))){p=!1,c[t.ExtensionIdentifier.toKey(M)]={id:this._hostExtensionsMap.get(t.ExtensionIdentifier.toKey(M)),reason:g.reason};continue}const i=this._registry.getExtensionDescription(M);if(i){if(!i.main&&!i.browser)continue;p=!1,c[t.ExtensionIdentifier.toKey(M)]={id:i.identifier,reason:g.reason};continue}const m=v.displayName||v.identifier.value,d=new Error(`Cannot activate the '${m}' extension because it depends on unknown extension '${M}'`);this._host.onExtensionActivationError(v.identifier,d,new w.MissingExtensionDependency(M)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(v.identifier),new n(d));return}p?c[t.ExtensionIdentifier.toKey(v.identifier)]=g:D.push(g)}_activateExtensions(g){if(g.length===0||(g=g.filter(h=>!this._activatedExtensions.has(t.ExtensionIdentifier.toKey(h.id))),g.length===0))return Promise.resolve(void 0);const c=Object.create(null),D=[];for(let h=0,p=g.length;h<p;h++)this._handleActivateRequest(g[h],c,D);for(let h=0,p=D.length;h<p;h++){const I=t.ExtensionIdentifier.toKey(D[h].id);c[I]&&delete c[I]}const v=Object.keys(c).map(h=>c[h]);return D.length===0?Promise.all(v.map(h=>this._activateExtension(h.id,h.reason))).then(h=>{}):this._activateExtensions(v).then(h=>this._activateExtensions(D))}_activateExtension(g,c){const D=t.ExtensionIdentifier.toKey(g);if(this._activatedExtensions.has(D))return Promise.resolve(void 0);const v=this._activatingExtensions.get(D);if(v)return v;const h=this._host.actualActivateExtension(g,c).then(void 0,p=>{const I=new Error;return p&&p.name&&(I.name=p.name),p&&p.message?I.message=`Activating extension '${g.value}' failed: ${p.message}.`:I.message=`Activating extension '${g.value}' failed: ${p}.`,p&&p.stack&&(I.stack=p.stack),this._isDisposed&&a.isPromiseCanceledError(p)?new n(p):(this._host.onExtensionActivationError(g,I,null),this._logService.error(`Activating extension ${g.value} failed due to an error:`),this._logService.error(p),new n(p))}).then(p=>{this._activatedExtensions.set(D,p),this._activatingExtensions.delete(D)});return this._activatingExtensions.set(D,h),h}};f=Ue([$e(4,T.ILogService)],f),e.ExtensionsActivator=f}),define(Ee[175],ye([0,1,12,28,27]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let T=class extends a.LogService{constructor(P,C){super(P.createLogger(C.logFile,{name:w.ExtensionHostLogFileName}))}};T=Ue([$e(0,a.ILoggerService),$e(1,t.IExtHostInitDataService)],T),e.ExtHostLogService=T}),define(Ee[176],ye([0,1,15]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,k)=>{this._actualOk=T,this._actualErr=k,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,a.onUnexpectedError)(T))}then(T,k){return this._ensureActual().then(T,k)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=t}),define(Ee[37],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class a{constructor(R,F){this._proxyIdentifierBrand=void 0,this.isMain=R,this.sid=F,this.nid=++a.count}}e.ProxyIdentifier=a,a.count=0;const t=[];function w(C){const R=new a(!0,C);return t[R.nid]=R,R}e.createMainContextProxyIdentifier=w;function T(C){const R=new a(!1,C);return t[R.nid]=R,R}e.createExtHostContextProxyIdentifier=T;function k(C){return t[C].sid}e.getStringIdentifierForProxy=k;class P{constructor(R){this.value=R}}e.SerializableObjectWithBuffers=P}),define(Ee[5],ye([0,1,54,2,37]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var T;(function(h){h[h.Desktop=1]="Desktop",h[h.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var k;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(k=e.TextEditorRevealType||(e.TextEditorRevealType={}));var P;(function(h){h[h.Editable=0]="Editable",h[h.SupportsHotExit=1]="SupportsHotExit"})(P=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var C;(function(h){h[h.Int8Array=1]="Int8Array",h[h.Uint8Array=2]="Uint8Array",h[h.Uint8ClampedArray=3]="Uint8ClampedArray",h[h.Int16Array=4]="Int16Array",h[h.Uint16Array=5]="Uint16Array",h[h.Int32Array=6]="Int32Array",h[h.Uint32Array=7]="Uint32Array",h[h.Float32Array=8]="Float32Array",h[h.Float64Array=9]="Float64Array",h[h.BigInt64Array=10]="BigInt64Array",h[h.BigUint64Array=11]="BigUint64Array"})(C=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var R;(function(h){h[h.Text=1]="Text",h[h.Error=2]="Error",h[h.Rich=3]="Rich"})(R=e.CellOutputKind||(e.CellOutputKind={}));var F;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(F=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var _;(function(h){h[h.None=0]="None",h[h.Process=1]="Process",h[h.Output=2]="Output"})(_=e.CandidatePortSource||(e.CandidatePortSource={}));var n;(function(h){h.name="$ident";function p(l,M){return Object.defineProperty(l,h.name,{value:M,enumerable:!0}),l}h.mixin=p;function I(l){return l[h.name]}h.of=I})(n=e.ObjectIdentifier||(e.ObjectIdentifier={}));class f{static mixin(p){return p._id=f._n++,p}}e.IdObject=f,f._n=0;var o;(function(h){h.label="a",h.kind="b",h.detail="c",h.documentation="d",h.sortText="e",h.filterText="f",h.preselect="g",h.insertText="h",h.insertTextRules="i",h.range="j",h.commitCharacters="k",h.additionalTextEdits="l",h.command="m",h.kindModifier="n"})(o=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var g;(function(h){h.defaultRanges="a",h.completions="b",h.isIncomplete="c",h.duration="d"})(g=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var c;(function(h){h[h.File=1]="File",h[h.Text=2]="Text",h[h.Cell=3]="Cell"})(c=e.WorkspaceEditType||(e.WorkspaceEditType={}));function D(h){if(h&&h.edits)for(const p of h.edits)typeof p.resource=="object"?p.resource=t.URI.revive(p.resource):(p.newUri=t.URI.revive(p.newUri),p.oldUri=t.URI.revive(p.oldUri)),p.metadata&&p.metadata.iconPath&&(p.metadata=(0,a.revive)(p.metadata));return h}e.reviveWorkspaceEditDto=D;var v;(function(h){h[h.Workspace=0]="Workspace",h[h.TextDocument=1]="TextDocument"})(v=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,w.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,w.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,w.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,w.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,w.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,w.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,w.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,w.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,w.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,w.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,w.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,w.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,w.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,w.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,w.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,w.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,w.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,w.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,w.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,w.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,w.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,w.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,w.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,w.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,w.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,w.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,w.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,w.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,w.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,w.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,w.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,w.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,w.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,w.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,w.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,w.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,w.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,w.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,w.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,w.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,w.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,w.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,w.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,w.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,w.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,w.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,w.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,w.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,w.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,w.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,w.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,w.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,w.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,w.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,w.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,w.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,w.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,w.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,w.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,w.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,w.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,w.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(Ee[68],ye([0,1,5,4,3]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(P){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(a.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,C){return this._proxy.$getPassword(P,C)}store(P,C,R){return this._proxy.$setPassword(P,C,R)}delete(P,C){return this._proxy.$deletePassword(P,C)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,w.createDecorator)("IExtHostSecretState")}),define(Ee[69],ye([0,1,3,12,5,13]),function(re,e,a,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,a.createDecorator)("IExtHostApiDeprecationService");let k=class{constructor(C,R){this._extHostLogService=R,this._reportedUsages=new Set,this._telemetryShape=C.getProxy(w.MainContext.MainThreadTelemetry)}report(C,R,F){const _=this.getUsageKey(C,R);this._reportedUsages.has(_)||(this._reportedUsages.add(_),R.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${C}' is deprecated. ${F}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:R.identifier.value,apiId:C}))}getUsageKey(C,R){return`${C}-${R.identifier.value}`}};k=Ue([$e(0,T.IExtHostRpcService),$e(1,t.ILogService)],k),e.ExtHostApiDeprecationService=k,e.NullApiDeprecationService=Object.freeze(new class{report(P,C,R){}})}),define(Ee[177],ye([0,1,4,5,7,25]),function(re,e,a,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class k{constructor(C){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new a.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=C.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(C){return this._providers=C,Promise.resolve()}async getSession(C,R,F,_={}){const n=T.ExtensionIdentifier.toKey(C.identifier),f=this._inFlightRequests.get(n)||[],o=[...F].sort().join(" ");let g=f.find(c=>c.scopes===o);if(g)return g.result;{const c=this._getSession(C,n,R,F,_);g={scopes:o,result:c},f.push(g),this._inFlightRequests.set(n,f);try{await c}finally{const D=f.findIndex(v=>v.scopes===o);D>-1&&(f.splice(D),this._inFlightRequests.set(n,f))}return c}}async _getSession(C,R,F,_,n={}){await this._proxy.$ensureProvider(F);const f=C.displayName||C.name;return this._proxy.$getSession(F,_,R,f,n)}async removeSession(C,R){const F=this._authenticationProviders.get(C);return F?F.provider.removeSession(R):this._proxy.$removeSession(C,R)}registerAuthenticationProvider(C,R,F,_){if(this._authenticationProviders.get(C))throw new Error(`An authentication provider with id '${C}' is already registered.`);this._authenticationProviders.set(C,{label:R,provider:F,options:_??{supportsMultipleAccounts:!1}}),this._providers.find(f=>f.id===C)||this._providers.push({id:C,label:R});const n=F.onDidChangeSessions(f=>{this._proxy.$sendDidChangeSessions(C,{added:f.added??[],changed:f.changed??[],removed:f.removed??[]})});return this._proxy.$registerAuthenticationProvider(C,R,_?.supportsMultipleAccounts??!1),new w.Disposable(()=>{n.dispose(),this._authenticationProviders.delete(C);const f=this._providers.findIndex(o=>o.id===C);f>-1&&this._providers.splice(f),this._proxy.$unregisterAuthenticationProvider(C)})}$createSession(C,R){const F=this._authenticationProviders.get(C);if(F)return Promise.resolve(F.provider.createSession(R));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$removeSession(C,R){const F=this._authenticationProviders.get(C);if(F)return Promise.resolve(F.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$getSessions(C,R){const F=this._authenticationProviders.get(C);if(F)return Promise.resolve(F.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$onDidChangeAuthenticationSessions(C,R){return this._onDidChangeSessions.fire({provider:{id:C,label:R}}),Promise.resolve()}}e.ExtHostAuthentication=k}),define(Ee[178],ye([0,1,5,13,8]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(P,C){this._extHostDocumentsAndEditors=C,this._proxy=P.getProxy(a.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(P){const C=w.WorkspaceEdit.from(P,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(C)}};T=Ue([$e(0,t.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(Ee[179],ye([0,1,5]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(T){const k=T.getProxy(a.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return k.$readText()},writeText(P){return k.$writeText(P)}})}}e.ExtHostClipboard=t}),define(Ee[38],ye([0,1,11,7,8,26,5,16,12,54,59,227,2,6,3,13,47,22,37,43]),function(re,e,a,t,w,T,k,P,C,R,F,_,n,f,o,g,c,D,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let p=class{constructor(m,d){this._commands=new Map,this._apiCommands=new Map,this._proxy=m.getProxy(k.MainContext.MainThreadCommands),this._logService=d,this.converter=new I(this,s=>{const b=this._apiCommands.get(s);return b?.result===M.Void?b:void 0},d),this._argumentProcessors=[{processArgument(s){return(0,R.revive)(s)}},{processArgument(s){return(0,T.cloneAndChange)(s,function(b){if(F.Range.isIRange(b))return w.Range.to(b);if(_.Position.isIPosition(b))return w.Position.to(b);if(F.Range.isIRange(b.range)&&n.URI.isUri(b.uri))return w.location.to(b);if(b instanceof D.VSBuffer)return b.buffer.buffer;if(!Array.isArray(b))return b})}}]}registerArgumentProcessor(m){this._argumentProcessors.push(m)}registerApiCommand(m){const d=this.registerCommand(!1,m.id,async(...s)=>{const b=m.args.map((u,S)=>{if(!u.validate(s[S]))throw new Error(`Invalid argument '${u.name}' when running '${m.id}', received: ${s[S]}`);return u.convert(s[S])}),y=await this.executeCommand(m.internalId,...b);return m.result.convert(y,s,this.converter)},void 0,{description:m.description,args:m.args,returns:m.result.description});return this._apiCommands.set(m.id,m),new t.Disposable(()=>{d.dispose(),this._apiCommands.delete(m.id)})}registerCommand(m,d,s,b,y,u){if(this._logService.trace("ExtHostCommands#registerCommand",d),!d.trim().length)throw new Error("invalid id");if(this._commands.has(d))throw new Error(`command '${d}' already exists`);return this._commands.set(d,{callback:s,thisArg:b,description:y,extension:u}),m&&this._proxy.$registerCommand(d),new t.Disposable(()=>{this._commands.delete(d)&&m&&this._proxy.$unregisterCommand(d)})}executeCommand(m,...d){return this._logService.trace("ExtHostCommands#executeCommand",m),this._doExecuteCommand(m,d,!0)}async _doExecuteCommand(m,d,s){if(this._commands.has(m))return this._executeContributedCommand(m,d,!1);{let b=!1;const y=(0,T.cloneAndChange)(d,function(u){if(u instanceof t.Position)return w.Position.from(u);if(u instanceof t.Range)return w.Range.from(u);if(u instanceof t.Location)return w.location.from(u);if(t.NotebookRange.isNotebookRange(u))return w.NotebookRange.from(u);if(u instanceof ArrayBuffer)return b=!0,D.VSBuffer.wrap(new Uint8Array(u));if(u instanceof Uint8Array)return b=!0,D.VSBuffer.wrap(u);if(!Array.isArray(u))return u});try{const u=await this._proxy.$executeCommand(m,b?new v.SerializableObjectWithBuffers(y):y,s);return(0,R.revive)(u)}catch(u){if(u instanceof Error&&u.message==="$executeCommand:retry")return this._doExecuteCommand(m,d,!1);throw u}}}async _executeContributedCommand(m,d,s){const b=this._commands.get(m);if(!b)throw new Error("Unknown command");let{callback:y,thisArg:u,description:S}=b;if(S)for(let A=0;A<S.args.length;A++)try{(0,a.validateConstraint)(d[A],S.args[A].constraint)}catch{throw new Error(`Running the contributed command: '${m}' failed. Illegal argument '${S.args[A].name}' - ${S.args[A].description}`)}try{return await y.apply(u,d)}catch(A){if(m===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...d);U&&(m=U.command)}throw this._logService.error(A,m,b.extension?.identifier),s?new class extends Error{constructor(){super((0,h.toErrorMessage)(A));this.id=m,this.source=b.extension?.displayName??b.extension?.name}}:A}}$executeContributedCommand(m,...d){return this._logService.trace("ExtHostCommands#$executeContributedCommand",m),this._commands.has(m)?(d=d.map(s=>this._argumentProcessors.reduce((b,y)=>y.processArgument(b),s)),this._executeContributedCommand(m,d,!0)):Promise.reject(new Error(`Contributed command '${m}' does not exist.`))}getCommands(m=!1){return this._logService.trace("ExtHostCommands#getCommands",m),this._proxy.$getCommands().then(d=>(m&&(d=d.filter(s=>s[0]!=="_")),d))}$getContributedCommandHandlerDescriptions(){const m=Object.create(null);for(let[d,s]of this._commands){let{description:b}=s;b&&(m[d]=b)}return Promise.resolve(m)}};p=Ue([$e(0,g.IExtHostRpcService),$e(1,C.ILogService)],p),e.ExtHostCommands=p,e.IExtHostCommands=(0,o.createDecorator)("IExtHostCommands");class I{constructor(m,d,s){this._commands=m,this._lookupApiCommand=d,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(m,d){if(!m)return;const s={$ident:void 0,id:m.command,title:m.title,tooltip:m.tooltip};if(!m.command)return s;const b=this._lookupApiCommand(m.command);if(b)s.id=b.internalId,s.arguments=b.args.map((y,u)=>y.convert(m.arguments&&m.arguments[u]));else if((0,P.isNonEmptyArray)(m.arguments)){const y=++this._cachIdPool;this._cache.set(y,m),d.add((0,f.toDisposable)(()=>{this._cache.delete(y),this._logService.trace("CommandsConverter#DISPOSE",y)})),s.$ident=y,s.id=this.delegatingCommandId,s.arguments=[y],this._logService.trace("CommandsConverter#CREATE",m.command,y)}return s}fromInternal(m){const d=k.ObjectIdentifier.of(m);return typeof d=="number"?this._cache.get(d):{command:m.id,title:m.title,arguments:m.arguments}}getActualCommand(...m){return this._cache.get(m[0])}_executeConvertedCommand(...m){const d=this.getActualCommand(...m);return this._logService.trace("CommandsConverter#EXECUTE",m[0],d?d.command:"MISSING"),d?this._commands.executeCommand(d.command,...d.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=I;class l{constructor(m,d,s,b){this.name=m,this.description=d,this.validate=s,this.convert=b}optional(){return new l(this.name,`(optional) ${this.description}`,m=>m==null||this.validate(m),m=>m===void 0?void 0:m===null?null:this.convert(m))}with(m,d){return new l(m??this.name,d??this.description,this.validate,this.convert)}}e.ApiCommandArgument=l,l.Uri=new l("uri","Uri of a text document",i=>n.URI.isUri(i),i=>i),l.Position=new l("position","A position in a text document",i=>t.Position.isPosition(i),w.Position.from),l.Range=new l("range","A range in a text document",i=>t.Range.isRange(i),w.Range.from),l.Selection=new l("selection","A selection in a text document",i=>t.Selection.isSelection(i),w.Selection.from),l.Number=new l("number","",i=>typeof i=="number",i=>i),l.String=new l("string","",i=>typeof i=="string",i=>i),l.CallHierarchyItem=new l("item","A call hierarchy item",i=>i instanceof t.CallHierarchyItem,w.CallHierarchyItem.from),l.TypeHierarchyItem=new l("item","A type hierarchy item",i=>i instanceof t.TypeHierarchyItem,w.TypeHierarchyItem.from),l.TestItem=new l("testItem","A VS Code TestItem",i=>i instanceof c.TestItemImpl,w.TestItem.from);class M{constructor(m,d){this.description=m,this.convert=d}}e.ApiCommandResult=M,M.Void=new M("no result",i=>i);class r{constructor(m,d,s,b,y){this.id=m,this.internalId=d,this.description=s,this.args=b,this.result=y}}e.ApiCommand=r}),define(Ee[180],ye([0,1,8,7,58,38,16,79]),function(re,e,a,t,w,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const C=[new T.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",F(a.DocumentHighlight.to))),new T.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,f)=>{if((0,k.isFalsyOrEmpty)(n))return;class o extends t.SymbolInformation{static to(c){const D=new o(c.name,a.SymbolKind.to(c.kind),c.containerName||"",new t.Location(f[0],a.Range.to(c.range)));return D.detail=c.detail,D.range=D.location.range,D.selectionRange=a.Range.to(c.selectionRange),D.children=c.children?c.children.map(o.to):[],D}}return n.map(o.to)})),new T.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",F(a.TextEdit.to))),new T.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range,new T.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",F(a.TextEdit.to))),new T.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,new T.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new T.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",F(a.TextEdit.to))),new T.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new T.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new T.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new T.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new T.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location-instances.",F(a.location.to))),new T.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Hover-instances.",F(a.Hover.to))),new T.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(f=>t.Position.isPosition(f)),n=>n.map(a.Position.from))],new T.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(f=>{let o;for(const g of f.reverse())o=new t.SelectionRange(a.Range.to(g),o);return o}))),new T.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[T.ApiCommandArgument.String.with("query","Search string")],new T.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(a.WorkspaceSymbol.to))),new T.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(a.CallHierarchyItem.to))),new T.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[T.ApiCommandArgument.CallHierarchyItem],new T.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(a.CallHierarchyIncomingCall.to))),new T.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[T.ApiCommandArgument.CallHierarchyItem],new T.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(a.CallHierarchyOutgoingCall.to))),new T.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to a range and placeholder text.",n=>{if(!!n)return{range:a.Range.to(n.range),placeholder:n.text}})),new T.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("newName","The new symbol name")],new T.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return a.WorkspaceEdit.to(n)}})),new T.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new T.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(a.DocumentLink.to))),new T.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new t.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new T.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const f=(0,P.decodeSemanticTokensDto)(n);if(f.type==="full")return new t.SemanticTokens(f.data,void 0)})),new T.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range.optional()],new T.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new t.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new T.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const f=(0,P.decodeSemanticTokensDto)(n);if(f.type==="full")return new t.SemanticTokens(f.data,void 0)})),new T.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),T.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new T.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,f,o)=>{if(!n)return new t.CompletionList([]);const g=n.suggestions.map(c=>a.CompletionItem.to(c,o));return new t.CompletionList(g,n.incomplete)})),new T.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new T.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return a.SignatureHelp.to(n)})),new T.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new T.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,f,o)=>F(g=>new t.CodeLens(a.Range.to(g.range),g.command&&o.fromInternal(g.command)))(n))),new T.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>t.Range.isRange(n),n=>t.Selection.isSelection(n)?a.Selection.from(n):a.Range.from(n)),T.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),T.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new T.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,f,o)=>F(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(g.command)}else{const c=new t.CodeAction(g.title,g.kind?new t.CodeActionKind(g.kind):void 0);return g.edit&&(c.edit=a.WorkspaceEdit.to(g.edit)),g.command&&(c.command=o.fromInternal(g.command)),c.isPreferred=g.isPreferred,c}})(n))),new T.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(f=>new t.ColorInformation(a.Range.to(f.range),a.Color.to(f.color))):[])),new T.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new T.ApiCommandArgument("color","The color to show and insert",n=>n instanceof t.Color,a.Color.from),new T.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:a.Range.from(n.range)}))],new T.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(a.ColorPresentation.to):[])),new T.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to an array of Inlay objects",n=>n.map(a.InlayHint.to))),new T.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new T.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",F(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(f=>a.NotebookExclusiveDocumentPattern.to(f))})))),new T.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(a.InlineValue.to))),new T.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[a.ViewColumn.from(n.viewColumn),a.TextEditorOpenOptions.from(n)])).optional(),T.ApiCommandArgument.String.with("label","").optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[T.ApiCommandArgument.Uri.with("resource","Resource to open"),T.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[a.ViewColumn.from(n.viewColumn),a.TextEditorOpenOptions.from(n)])).optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[T.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),T.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),T.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[a.ViewColumn.from(n.viewColumn),a.TextEditorOpenOptions.from(n)]).optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(a.TypeHierarchyItem.to))),new T.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[T.ApiCommandArgument.TypeHierarchyItem],new T.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(a.TypeHierarchyItem.to))),new T.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[T.ApiCommandArgument.TypeHierarchyItem],new T.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(a.TypeHierarchyItem.to))),new T.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[T.ApiCommandArgument.TestItem],T.ApiCommandResult.Void)];class R{static register(f){C.forEach(f.registerApiCommand,f)}}e.ExtHostApiCommands=R;function F(n){return f=>{if(Array.isArray(f))return f.map(n)}}function _(n){if(!Array.isArray(n))return;const f=[];for(const o of n)w.isLocationLink(o)?f.push(a.DefinitionLink.to(o)):f.push(a.location.to(o));return f}}),define(Ee[181],ye([0,1,14,52,4,6,2,58,25,8,7,5]),function(re,e,a,t,w,T,k,P,C,R,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function n(f,o,g){const c=f.getProxy(_.MainContext.MainThreadComments);class D{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,o.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const m=this._commentControllers.get(i.handle);return m||i}else if(i&&i.$mid===7){const m=this._commentControllers.get(i.commentControlHandle);if(!m)return i;const d=m.getCommentThread(i.commentThreadHandle);return d||i}else if(i&&i.$mid===8){const m=this._commentControllers.get(i.thread.commentControlHandle);if(!m)return i;const d=m.getCommentThread(i.thread.commentThreadHandle);return d?{thread:d,text:i.text}:i}else if(i&&i.$mid===9){const m=this._commentControllers.get(i.thread.commentControlHandle);if(!m)return i;const d=m.getCommentThread(i.thread.commentThreadHandle);if(!d)return i;let s=i.commentUniqueId,b=d.getCommentByUniqueId(s);return b||i}else if(i&&i.$mid===10){const m=this._commentControllers.get(i.thread.commentControlHandle);if(!m)return i;const d=m.getCommentThread(i.thread.commentThreadHandle);if(!d)return i;let s=i.text,b=i.commentUniqueId,y=d.getCommentByUniqueId(b);return y?(y.body=s,y):i}return i}})}createCommentController(i,m,d){const s=D.handlePool++,b=new h(i,s,m,d);this._commentControllers.set(b.handle,b);const y=this._commentControllersByExtension.get(C.ExtensionIdentifier.toKey(i.identifier))||[];return y.push(b),this._commentControllersByExtension.set(C.ExtensionIdentifier.toKey(i.identifier),y),b.value}$createCommentThreadTemplate(i,m,d){const s=this._commentControllers.get(i);!s||s.$createCommentThreadTemplate(m,d)}async $updateCommentThreadTemplate(i,m,d){const s=this._commentControllers.get(i);!s||s.$updateCommentThreadTemplate(m,d)}$deleteCommentThread(i,m){const d=this._commentControllers.get(i);d&&d.$deleteCommentThread(m)}$provideCommentingRanges(i,m,d){const s=this._commentControllers.get(i);if(!s||!s.commentingRangeProvider)return Promise.resolve(void 0);const b=g.getDocument(k.URI.revive(m));return(0,a.asPromise)(()=>s.commentingRangeProvider.provideCommentingRanges(b,d)).then(y=>y?y.map(u=>R.Range.from(u)):void 0)}$toggleReaction(i,m,d,s,b){const y=this._commentControllers.get(i);return!y||!y.reactionHandler?Promise.resolve(void 0):(0,a.asPromise)(()=>{const u=y.getCommentThread(m);if(u){const S=u.getCommentByUniqueId(s.uniqueIdInThread);if(y!==void 0&&S&&y.reactionHandler)return y.reactionHandler(S,l(b))}return Promise.resolve(void 0)})}dispose(){}}D.handlePool=0;class v{constructor(i,m,d,s,b,y,u){this._commentControllerHandle=m,this._id=d,this._uri=s,this._range=b,this._comments=y,this.handle=v._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new w.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),c.$createCommentThread(m,this.handle,this._id,this._uri,R.Range.from(this._range),u),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=y,this._localDisposables.push({dispose:()=>{c.$deleteCommentThread(m,this.handle)}});const S=this;this.value={get uri(){return S.uri},get range(){return S.range},set range(A){S.range=A},get comments(){return S.comments},set comments(A){S.comments=A},get collapsibleState(){return S.collapsibleState},set collapsibleState(A){S.collapsibleState=A},get canReply(){return S.canReply},set canReply(A){S.canReply=A},get contextValue(){return S.contextValue},set contextValue(A){S.contextValue=A},get label(){return S.label},set label(A){S.label=A},dispose:()=>{S.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const i=d=>Object.prototype.hasOwnProperty.call(this.modifications,d),m={};i("range")&&(m.range=R.Range.from(this._range)),i("label")&&(m.label=this.label),i("contextValue")&&(m.contextValue=this.contextValue??null),i("comments")&&(m.comments=this._comments.map(d=>p(this,d,this._commentsMap))),i("collapsibleState")&&(m.collapseState=M(this._collapseState)),i("canReply")&&(m.canReply=this.canReply),this.modifications={},c.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,m)}getCommentByUniqueId(i){for(let m of this._commentsMap){let d=m[0],s=m[1];if(i===s)return d}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}v._handlePool=0,Ue([(0,t.debounce)(100)],v.prototype,"eventuallyUpdateCommentThread",null);class h{constructor(i,m,d,s){this._extension=i,this._handle=m,this._id=d,this._label=s,this._threads=new Map,c.$registerCommentController(this.handle,d,s);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(y){b.options=y},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(y){b.commentingRangeProvider=y},get reactionHandler(){return b.reactionHandler},set reactionHandler(y){b.reactionHandler=y},createCommentThread(y,u,S){return b.createCommentThread(y,u,S).value},dispose:()=>{b.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{c.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(i){this._commentingRangeProvider=i,c.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,c.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,c.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,m,d,s){if(typeof i=="string"){const b=new v(this.id,this.handle,i,m,d,s,this._extension.identifier);return this._threads.set(b.handle,b),b}else{const b=new v(this.id,this.handle,void 0,i,m,d,this._extension.identifier);return this._threads.set(b.handle,b),b}}$createCommentThreadTemplate(i,m){const d=new v(this.id,this.handle,void 0,k.URI.revive(i),R.Range.to(m),[],this._extension.identifier);return d.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(d.handle,d),d}$updateCommentThreadTemplate(i,m){let d=this._threads.get(i);d&&(d.range=R.Range.to(m))}$deleteCommentThread(i){let m=this._threads.get(i);m&&m.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function p(r,i,m){let d=m.get(i);d||(d=++r.commentHandle,m.set(i,d));const s=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:d,body:R.MarkdownString.from(i.body),userName:i.author.name,userIconPath:s,label:i.label,commentReactions:i.reactions?i.reactions.map(b=>I(b)):void 0}}function I(r){return{label:r.label,iconPath:r.iconPath?R.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function l(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?k.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function M(r){if(r!==void 0)switch(r){case F.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case F.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}return new D}e.createExtHostComments=n}),define(Ee[93],ye([0,1,2,5,7,3,13,12,16,9,17]),function(re,e,a,t,w,T,k,P,C,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let _=class wi{constructor(f,o){this._logService=o,this._provider=new Map,this._proxy=f.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,o){const g=wi._handlePool++;this._provider.set(g,{provider:f,extensionId:o}),this._proxy.$registerDecorationProvider(g,o.value);const c=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(D=>{if(!D){this._proxy.$onDidChange(g,null);return}let v=(0,C.asArray)(D);if(v.length<=wi._maxEventSize){this._proxy.$onDidChange(g,v);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",o.value,v.length);const h=v.map(l=>({uri:l,rank:(0,R.count)(l.path,"/")})),p=(0,C.groupBy)(h,(l,M)=>l.rank-M.rank||(0,R.compare)(l.uri.path,M.uri.path));let I=[];e:for(let l of p){let M;for(let r of l){let i=(0,F.dirname)(r.uri.path);if(M!==i&&(M=i,I.push(r.uri)>=wi._maxEventSize))break e}}this._proxy.$onDidChange(g,I)});return new w.Disposable(()=>{c?.dispose(),this._proxy.$unregisterDecorationProvider(g),this._provider.delete(g)})}async $provideDecorations(f,o,g){if(!this._provider.has(f))return Object.create(null);const c=Object.create(null),{provider:D,extensionId:v}=this._provider.get(f);return await Promise.all(o.map(async h=>{try{const{uri:p,id:I}=h,l=await Promise.resolve(D.provideFileDecoration(a.URI.revive(p),g));if(!l)return;try{w.FileDecoration.validate(l),c[I]=[l.propagate,l.tooltip,l.badge,l.color]}catch(M){this._logService.warn(`INVALID decoration from extension '${v.value}': ${M}`)}}catch(p){this._logService.error(p)}})),c}};_._handlePool=0,_._maxEventSize=250,_=Ue([$e(0,k.IExtHostRpcService),$e(1,P.ILogService)],_),e.ExtHostDecorations=_,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")});var Ze=this&&this.__classPrivateFieldSet||function(re,e,a,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(re,a):w?w.value=a:e.set(re,a),a},Te=this&&this.__classPrivateFieldGet||function(re,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!t:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(re):t?t.value:e.get(re)};define(Ee[182],ye([0,1,119,82,2,5,7,8,4,12,21,30]),function(re,e,a,t,w,T,k,P,C,R,F,_){"use strict";var n,f,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class g{constructor(v,h,p,I,l,M){this._name=v,this._owner=h,this._maxDiagnosticsPerFile=p,n.set(this,void 0),f.set(this,void 0),o.set(this,void 0),this._isDisposed=!1,Ze(this,o,new F.ResourceMap(r=>I.getComparisonKey(r)),"f"),Ze(this,n,l,"f"),Ze(this,f,M,"f")}dispose(){this._isDisposed||(Te(this,f,"f").fire([...Te(this,o,"f").keys()]),Te(this,n,"f")&&Te(this,n,"f").$clear(this._owner),Te(this,o,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(v,h){if(!v){this.clear();return}this._checkDisposed();let p=[];if(w.URI.isUri(v)){if(!h){this.delete(v);return}Te(this,o,"f").set(v,h.slice()),p=[v]}else if(Array.isArray(v)){p=[];let l;v=[...v].sort(g._compareIndexedTuplesByUri);for(const M of v){const[r,i]=M;if((!l||r.toString()!==l.toString())&&(l&&Te(this,o,"f").get(l).length===0&&Te(this,o,"f").delete(l),l=r,p.push(r),Te(this,o,"f").set(r,[])),i){const m=Te(this,o,"f").get(r);m&&m.push(...i)}else{const m=Te(this,o,"f").get(r);m&&(m.length=0)}}}if(Te(this,f,"f").fire(p),!Te(this,n,"f"))return;const I=[];for(let l of p){let M=[];const r=Te(this,o,"f").get(l);if(r)if(r.length>this._maxDiagnosticsPerFile){M=[];const i=[k.DiagnosticSeverity.Error,k.DiagnosticSeverity.Warning,k.DiagnosticSeverity.Information,k.DiagnosticSeverity.Hint];e:for(let m=0;m<4;m++)for(let d of r)if(d.severity===i[m]&&M.push(P.Diagnostic.from(d))===this._maxDiagnosticsPerFile)break e;M.push({severity:t.MarkerSeverity.Info,message:(0,a.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:M[M.length-1].startLineNumber,startColumn:M[M.length-1].startColumn,endLineNumber:M[M.length-1].endLineNumber,endColumn:M[M.length-1].endColumn})}else M=r.map(i=>P.Diagnostic.from(i));I.push([l,M])}Te(this,n,"f").$changeMany(this._owner,I)}delete(v){this._checkDisposed(),Te(this,f,"f").fire([v]),Te(this,o,"f").delete(v),Te(this,n,"f")&&Te(this,n,"f").$changeMany(this._owner,[[v,void 0]])}clear(){this._checkDisposed(),Te(this,f,"f").fire([...Te(this,o,"f").keys()]),Te(this,o,"f").clear(),Te(this,n,"f")&&Te(this,n,"f").$clear(this._owner)}forEach(v,h){this._checkDisposed();for(let p of Te(this,o,"f").keys())v.apply(h,[p,this.get(p),this])}get(v){this._checkDisposed();const h=Te(this,o,"f").get(v);return Array.isArray(h)?Object.freeze(h.slice(0)):[]}has(v){return this._checkDisposed(),Array.isArray(Te(this,o,"f").get(v))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(v,h){return v[0].toString()<h[0].toString()?-1:v[0].toString()>h[0].toString()?1:0}}e.DiagnosticCollection=g,n=new WeakMap,f=new WeakMap,o=new WeakMap;let c=class ri{constructor(v,h,p){this._logService=h,this._fileSystemInfoService=p,this._collections=new Map,this._onDidChangeDiagnostics=new C.DebounceEmitter({merge:I=>I.flat(),delay:50}),this.onDidChangeDiagnostics=C.Event.map(this._onDidChangeDiagnostics.event,ri._mapper),this._proxy=v.getProxy(T.MainContext.MainThreadDiagnostics)}static _mapper(v){const h=new F.ResourceMap;for(const p of v)h.set(p,p);return{uris:Object.freeze(Array.from(h.values()))}}createDiagnosticCollection(v,h){const{_collections:p,_proxy:I,_onDidChangeDiagnostics:l,_logService:M,_fileSystemInfoService:r}=this,i=new class{$changeMany(s,b){I.$changeMany(s,b),M.trace("[DiagnosticCollection] change many (extension, owner, uris)",v.value,s,b.length===0?"CLEARING":b)}$clear(s){I.$clear(s),M.trace("[DiagnosticCollection] remove all (extension, owner)",v.value,s)}dispose(){I.dispose()}};let m;if(!h)h="_generated_diagnostic_collection_name_#"+ri._idPool++,m=h;else if(!p.has(h))m=h;else{this._logService.warn(`DiagnosticCollection with name '${h}' does already exist.`);do m=h+ri._idPool++;while(p.has(m))}return new class extends g{constructor(){super(h,m,ri._maxDiagnosticsPerFile,r.extUri,i,l);p.set(m,this)}dispose(){super.dispose(),p.delete(m)}}}getDiagnostics(v){if(v)return this._getDiagnostics(v);{const h=new Map,p=[];for(const I of this._collections.values())I.forEach((l,M)=>{let r=h.get(l.toString());typeof r=="undefined"&&(r=p.length,h.set(l.toString(),r),p.push([l,[]])),p[r][1]=p[r][1].concat(...M)});return p}}_getDiagnostics(v){let h=[];for(let p of this._collections.values())p.has(v)&&(h=h.concat(p.get(v)));return h}$acceptMarkersChange(v){if(!this._mirrorCollection){const h="_generated_mirror",p=new g(h,h,ri._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(h,p),this._mirrorCollection=p}for(const[h,p]of v)this._mirrorCollection.set(w.URI.revive(h),p.map(P.Diagnostic.to))}};c._idPool=0,c._maxDiagnosticsPerFile=1e3,c=Ue([$e(1,R.ILogService),$e(2,_.IExtHostFileSystemInfo)],c),e.ExtHostDiagnostics=c}),define(Ee[183],ye([0,1,2,5]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class w{constructor(k){this._proxy=k.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(k){return this._proxy.$showOpenDialog(k).then(P=>P?P.map(C=>a.URI.revive(C)):void 0)}showSaveDialog(k){return this._proxy.$showSaveDialog(k).then(P=>P?a.URI.revive(P):void 0)}}e.ExtHostDialogs=w}),define(Ee[184],ye([0,1,15,2,7,5,10,20,9]),function(re,e,a,t,w,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class R{constructor(_,n,f){this._documentsAndEditors=n,this._logService=f,this._documentContentProviders=new Map,this._proxy=_.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(_,n){if(Object.keys(k.Schemas).indexOf(_)>=0)throw new Error(`scheme '${_}' already registered`);const f=R._handlePool++;this._documentContentProviders.set(f,n),this._proxy.$registerTextContentProvider(f,_);let o;return typeof n.onDidChange=="function"&&(o=n.onDidChange(g=>{if(g.scheme!==_){this._logService.warn(`Provider for scheme '${_}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(g)&&this.$provideTextDocumentContent(f,g).then(c=>{if(!c&&typeof c!="string")return;const D=this._documentsAndEditors.getDocument(g);if(!D)return;const v=(0,C.splitLines)(c);if(!D.equalLines(v))return this._proxy.$onVirtualDocumentChange(g,c)},a.onUnexpectedError)})),new w.Disposable(()=>{this._documentContentProviders.delete(f)&&this._proxy.$unregisterTextContentProvider(f),o&&(o.dispose(),o=void 0)})}$provideTextDocumentContent(_,n){const f=this._documentContentProviders.get(_);return f?Promise.resolve(f.provideTextDocumentContent(t.URI.revive(n),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${n.scheme}`))}}e.ExtHostDocumentContentProvider=R,R._handlePool=0}),define(Ee[185],ye([0,1,4,6,2,5,86,8,11,26,7]),function(re,e,a,t,w,T,k,P,C,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class _{constructor(f,o){this._onDidAddDocument=new a.Emitter,this._onDidRemoveDocument=new a.Emitter,this._onDidChangeDocument=new a.Emitter,this._onDidSaveDocument=new a.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=f.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=o,this._documentsAndEditors.onDidRemoveDocuments(g=>{for(const c of g)this._onDidRemoveDocument.fire(c.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(g=>{for(const c of g)this._onDidAddDocument.fire(c.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(f){if(!f)return;const o=this._documentsAndEditors.getDocument(f);if(o)return o}getDocument(f){const o=this.getDocumentData(f);if(!o?.document)throw new Error(`Unable to retrieve document from URI '${f}'`);return o.document}ensureDocumentData(f){const o=this._documentsAndEditors.getDocument(f);if(o)return Promise.resolve(o);let g=this._documentLoader.get(f.toString());return g||(g=this._proxy.$tryOpenDocument(f).then(c=>{this._documentLoader.delete(f.toString());const D=w.URI.revive(c);return(0,C.assertIsDefined)(this._documentsAndEditors.getDocument(D))},c=>(this._documentLoader.delete(f.toString()),Promise.reject(c))),this._documentLoader.set(f.toString(),g)),g}createDocumentData(f){return this._proxy.$tryCreateDocument(f).then(o=>w.URI.revive(o))}$acceptModelModeChanged(f,o){const g=w.URI.revive(f),c=this._documentsAndEditors.getDocument(g);if(!c)throw new Error("unknown document");this._onDidRemoveDocument.fire(c.document),c._acceptLanguageId(o),this._onDidAddDocument.fire(c.document)}$acceptModelSaved(f){const o=w.URI.revive(f),g=this._documentsAndEditors.getDocument(o);if(!g)throw new Error("unknown document");this.$acceptDirtyStateChanged(f,!1),this._onDidSaveDocument.fire(g.document)}$acceptDirtyStateChanged(f,o){const g=w.URI.revive(f),c=this._documentsAndEditors.getDocument(g);if(!c)throw new Error("unknown document");c._acceptIsDirty(o),this._onDidChangeDocument.fire({document:c.document,contentChanges:[],reason:void 0})}$acceptModelChanged(f,o,g){const c=w.URI.revive(f),D=this._documentsAndEditors.getDocument(c);if(!D)throw new Error("unknown document");D._acceptIsDirty(g),D.onEvents(o);let v;o.isUndoing?v=F.TextDocumentChangeReason.Undo:o.isRedoing&&(v=F.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,R.deepFreeze)({document:D.document,contentChanges:o.changes.map(h=>({range:P.Range.to(h.range),rangeOffset:h.rangeOffset,rangeLength:h.rangeLength,text:h.text})),reason:v}))}setWordDefinitionFor(f,o){(0,k.setWordDefinitionFor)(f,o)}}e.ExtHostDocuments=_}),define(Ee[48],ye([0,1,41,4,6,2,3,5,86,13,92,8,12,21,10,158,101]),function(re,e,a,t,w,T,k,P,C,R,F,_,n,f,o,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class D{constructor(p){this.value=p,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let v=class{constructor(p,I){this._extHostRpc=p,this._logService=I,this._activeEditorId=null,this._editors=new Map,this._documents=new f.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(p){this.acceptDocumentsAndEditorsDelta(p)}acceptDocumentsAndEditorsDelta(p){const I=[],l=[],M=[];if(p.removedDocuments)for(const r of p.removedDocuments){const i=T.URI.revive(r),m=this._documents.get(i);m?.unref()&&(this._documents.delete(i),I.push(m.value))}if(p.addedDocuments)for(const r of p.addedDocuments){const i=T.URI.revive(r.uri);let m=this._documents.get(i);if(m&&i.scheme!==o.Schemas.vscodeNotebookCell&&i.scheme!==o.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);m||(m=new D(new C.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),i,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(i,m),l.push(m.value)),m.ref()}if(p.removedEditors)for(const r of p.removedEditors){const i=this._editors.get(r);this._editors.delete(r),i&&M.push(i)}if(p.addedEditors)for(const r of p.addedEditors){const i=T.URI.revive(r.documentUri);a.ok(this._documents.has(i),`document '${i}' does not exist`),a.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const m=this._documents.get(i).value,d=new F.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new c.Lazy(()=>m.document),r.selections.map(_.Selection.to),r.options,r.visibleRanges.map(s=>_.Range.to(s)),typeof r.editorPosition=="number"?_.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,d)}p.newActiveEditor!==void 0&&(a.ok(p.newActiveEditor===null||this._editors.has(p.newActiveEditor),`active editor '${p.newActiveEditor}' does not exist`),this._activeEditorId=p.newActiveEditor),(0,w.dispose)(I),(0,w.dispose)(M),p.removedDocuments&&this._onDidRemoveDocuments.fire(I),p.addedDocuments&&this._onDidAddDocuments.fire(l),(p.removedEditors||p.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),p.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(p){return this._documents.get(p)?.value}allDocuments(){return g.Iterable.map(this._documents.values(),p=>p.value)}getEditor(p){return this._editors.get(p)}activeEditor(p){if(!this._activeEditorId)return;const I=this._editors.get(this._activeEditorId);return p?I:I?.value}allEditors(){return[...this._editors.values()]}};v=Ue([$e(0,R.IExtHostRpcService),$e(1,n.ILogService)],v),e.ExtHostDocumentsAndEditors=v,e.IExtHostDocumentsAndEditors=(0,k.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ee[70],ye([0,1,8,5,2,4,3,13,14]),function(re,e,a,t,w,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,k.createDecorator)("IExtHostEditorTabs");let R=class{constructor(_){this._onDidChangeTabs=new T.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new T.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=_.getProxy(t.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(_){let n=-1;this._tabs=_.map((o,g)=>(o.isActive&&(n=g),Object.freeze({label:o.label,viewColumn:a.ViewColumn.to(o.viewColumn),index:g,resource:w.URI.revive(o.resource),additionalResourcesAndViewIds:o.additionalResourcesAndViewIds.map(({resource:c,viewId:D})=>({resource:w.URI.revive(c),viewId:D})),viewId:o.editorId,isActive:o.isActive,move:async(c,D)=>{this._proxy.$moveTab(o,c,a.ViewColumn.from(D)),await(0,C.raceTimeout)(T.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(o),await(0,C.raceTimeout)(T.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((o,g)=>o.viewColumn===g.viewColumn?o.index-g.index:o.viewColumn-g.viewColumn);const f=this._activeTab;this._activeTab=n===-1?void 0:this._tabs[n],this._activeTab!==f&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};R=Ue([$e(0,P.IExtHostRpcService)],R),e.ExtHostEditorTabs=R}),define(Ee[186],ye([0,1,2,5,6,7,8,228,9,22,27]),function(re,e,a,t,w,T,k,P,C,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class _{constructor(){this._schemes=[]}add(o){this._stateMachine=void 0,this._schemes.push(o)}delete(o){const g=this._schemes.indexOf(o);g>=0&&(this._schemes.splice(g,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const o=this._schemes.sort(),g=[];let c,D,v=14,h=14;for(const p of o){let I=c?(0,C.commonPrefixLength)(c,p):0;for(I===0?D=1:D=h;I<p.length;I++)I+1===p.length?(v=h,h=9):h+=1,g.push([D,p.toUpperCase().charCodeAt(I),h]),g.push([D,p.toLowerCase().charCodeAt(I),h]),D=h;c=p,h=v}g.push([9,58,10]),g.push([10,47,12]),this._stateMachine=new P.StateMachine(g)}}provideDocumentLinks(o){this._initStateMachine();const g=[],c=P.LinkComputer.computeLinks({getLineContent(D){return o.lineAt(D-1).text},getLineCount(){return o.lineCount}},this._stateMachine);for(const D of c){const v=k.DocumentLink.to(D);v.target&&g.push(v)}return g}}class n{constructor(o,g){this._extHostLanguageFeatures=g,this._linkProvider=new _,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=o.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(o,g,c,D={}){if(this._registeredSchemes.has(g))throw new Error(`a provider for the scheme '${g}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const v=this._handlePool++;this._linkProvider.add(g),this._registeredSchemes.add(g),this._fsProvider.set(v,c);let h=2;D.isCaseSensitive&&(h+=1024),D.isReadonly&&(h+=2048),typeof c.copy=="function"&&(h+=8),typeof c.open=="function"&&typeof c.close=="function"&&typeof c.read=="function"&&typeof c.write=="function"&&((0,F.checkProposedApiEnabled)(o,"fsChunks"),h+=4),this._proxy.$registerFileSystemProvider(v,g,h).catch(I=>{console.error(`FAILED to register filesystem provider of ${o.identifier.value}-extension for the scheme ${g}`),console.error(I)});const p=c.onDidChangeFile(I=>{const l=[];for(const M of I){let{uri:r,type:i}=M;if(r.scheme!==g)continue;let m;switch(i){case T.FileChangeType.Changed:m=0;break;case T.FileChangeType.Created:m=1;break;case T.FileChangeType.Deleted:m=2;break;default:throw new Error("Unknown FileChangeType")}l.push({resource:r,type:m})}this._proxy.$onFileSystemChange(v,l)});return(0,w.toDisposable)(()=>{p.dispose(),this._linkProvider.delete(g),this._registeredSchemes.delete(g),this._fsProvider.delete(v),this._proxy.$unregisterProvider(v)})}static _asIStat(o){const{type:g,ctime:c,mtime:D,size:v,permissions:h}=o;return{type:g,ctime:c,mtime:D,size:v,permissions:h}}$stat(o,g){return Promise.resolve(this._getFsProvider(o).stat(a.URI.revive(g))).then(c=>n._asIStat(c))}$readdir(o,g){return Promise.resolve(this._getFsProvider(o).readDirectory(a.URI.revive(g)))}$readFile(o,g){return Promise.resolve(this._getFsProvider(o).readFile(a.URI.revive(g))).then(c=>R.VSBuffer.wrap(c))}$writeFile(o,g,c,D){return Promise.resolve(this._getFsProvider(o).writeFile(a.URI.revive(g),c.buffer,D))}$delete(o,g,c){return Promise.resolve(this._getFsProvider(o).delete(a.URI.revive(g),c))}$rename(o,g,c,D){return Promise.resolve(this._getFsProvider(o).rename(a.URI.revive(g),a.URI.revive(c),D))}$copy(o,g,c,D){const v=this._getFsProvider(o);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(a.URI.revive(g),a.URI.revive(c),D))}$mkdir(o,g){return Promise.resolve(this._getFsProvider(o).createDirectory(a.URI.revive(g)))}$watch(o,g,c,D){const v=this._getFsProvider(o).watch(a.URI.revive(c),D);this._watches.set(g,v)}$unwatch(o,g){const c=this._watches.get(g);c&&(c.dispose(),this._watches.delete(g))}$open(o,g,c){const D=this._getFsProvider(o);if(!D.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(D.open(a.URI.revive(g),c))}$close(o,g){const c=this._getFsProvider(o);if(!c.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(c.close(g))}$read(o,g,c,D){const v=this._getFsProvider(o);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const h=R.VSBuffer.alloc(D);return Promise.resolve(v.read(g,c,h.buffer,0,D)).then(p=>h.slice(0,p))}$write(o,g,c,D){const v=this._getFsProvider(o);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(g,c,D.buffer,0,D.byteLength))}_getFsProvider(o){const g=this._fsProvider.get(o);if(!g){const c=new Error;throw c.name="ENOPRO",c.message="no provider",c}return g}}e.ExtHostFileSystem=n}),define(Ee[49],ye([0,1,5,45,7,22,3,13,30,6]),function(re,e,a,t,w,T,k,P,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let F=class Wt{constructor(n,f){this._fileSystemProvider=new Map,this._proxy=n.getProxy(a.MainContext.MainThreadFileSystem);const o=this;this.value=Object.freeze({async stat(g){try{const c=o._fileSystemProvider.get(g.scheme);if(!c)return await o._proxy.$stat(g);await o._proxy.$ensureActivation(g.scheme);const D=await c.stat(g);return{type:D.type,ctime:D.ctime,mtime:D.mtime,size:D.size,permissions:D.permissions}}catch(c){Wt._handleError(c)}},async readDirectory(g){try{const c=o._fileSystemProvider.get(g.scheme);return c?(await o._proxy.$ensureActivation(g.scheme),(await c.readDirectory(g)).slice()):await o._proxy.$readdir(g)}catch(c){return Wt._handleError(c)}},async createDirectory(g){try{return await o._proxy.$mkdir(g)}catch(c){return Wt._handleError(c)}},async readFile(g){try{const c=o._fileSystemProvider.get(g.scheme);return c?(await o._proxy.$ensureActivation(g.scheme),(await c.readFile(g)).slice()):(await o._proxy.$readFile(g)).buffer}catch(c){return Wt._handleError(c)}},async writeFile(g,c){try{return await o._proxy.$writeFile(g,T.VSBuffer.wrap(c))}catch(D){return Wt._handleError(D)}},async delete(g,c){try{const D=o._fileSystemProvider.get(g.scheme);return D?(await o._proxy.$ensureActivation(g.scheme),await D.delete(g,{recursive:!1,...c})):await o._proxy.$delete(g,{recursive:!1,useTrash:!1,...c})}catch(D){return Wt._handleError(D)}},async rename(g,c,D){try{return await o._proxy.$rename(g,c,{overwrite:!1,...D})}catch(v){return Wt._handleError(v)}},async copy(g,c,D){try{return await o._proxy.$copy(g,c,{overwrite:!1,...D})}catch(v){return Wt._handleError(v)}},isWritableFileSystem(g){const c=f.getCapabilities(g);if(typeof c=="number")return!(c&2048)}})}static _handleError(n){if(n instanceof w.FileSystemError)throw n;if(!(n instanceof Error))throw new w.FileSystemError(String(n));if(n.name==="ENOPRO")throw w.FileSystemError.Unavailable(n.message);switch(n.name){case t.FileSystemProviderErrorCode.FileExists:throw w.FileSystemError.FileExists(n.message);case t.FileSystemProviderErrorCode.FileNotFound:throw w.FileSystemError.FileNotFound(n.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw w.FileSystemError.FileNotADirectory(n.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw w.FileSystemError.FileIsADirectory(n.message);case t.FileSystemProviderErrorCode.NoPermissions:throw w.FileSystemError.NoPermissions(n.message);case t.FileSystemProviderErrorCode.Unavailable:throw w.FileSystemError.Unavailable(n.message);default:throw new w.FileSystemError(n.message,n.name)}}addFileSystemProvider(n,f){return this._fileSystemProvider.set(n,f),(0,R.toDisposable)(()=>this._fileSystemProvider.delete(n))}};F=Ue([$e(0,P.IExtHostRpcService),$e(1,C.IExtHostFileSystemInfo)],F),e.ExtHostConsumerFileSystem=F,e.IExtHostConsumerFileSystem=(0,k.createDecorator)("IExtHostConsumerFileSystem")}),define(Ee[187],ye([0,1,2,38]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class w{constructor(k,P,C,R){this._extHostNotebooks=P,this._textDocumentsAndEditors=C,this._commands=R;const F=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",_=>!0,_=>_),new t.ApiCommandArgument("resource","Interactive resource Uri",_=>!0,_=>_),new t.ApiCommandArgument("controllerId","Notebook controller Id",_=>!0,_=>_),new t.ApiCommandArgument("title","Interactive editor title",_=>!0,_=>_)],new t.ApiCommandResult("Notebook and input URI",_=>{if(_.notebookEditorId!==void 0){const n=this._extHostNotebooks.getEditorById(_.notebookEditorId);return{notebookUri:a.URI.revive(_.notebookUri),inputUri:a.URI.revive(_.inputUri),notebookEditor:n.apiEditor}}return{notebookUri:a.URI.revive(_.notebookUri),inputUri:a.URI.revive(_.inputUri)}}));this._commands.registerApiCommand(F)}$willAddInteractiveDocument(k,P,C,R){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:P,lines:[""],languageId:C,uri:k,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(a.URI.revive(R))?.apiNotebook}]})}$willRemoveInteractiveDocument(k,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[k]})}}e.ExtHostInteractive=w}),define(Ee[188],ye([0,1,6,5]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class w{constructor(k){this._handlePool=0,this._proxy=k.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(k){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,k),(0,a.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=w}),define(Ee[189],ye([0,1,2,26,8,7,5,9,59,16,11,229,6,79,53,63,190,15,4]),function(re,e,a,t,w,T,k,P,C,R,F,_,n,f,o,g,c,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class h{constructor($,G){this._documents=$,this._provider=G}async provideDocumentSymbols($,G){const J=this._documents.getDocument($),ae=await this._provider.provideDocumentSymbols(J,G);if(!(0,R.isFalsyOrEmpty)(ae))return ae[0]instanceof T.DocumentSymbol?ae.map(w.DocumentSymbol.from):h._asDocumentSymbolTree(ae)}static _asDocumentSymbolTree($){$=$.slice(0).sort((ae,q)=>{let te=ae.location.range.start.compareTo(q.location.range.start);return te===0&&(te=q.location.range.end.compareTo(ae.location.range.end)),te});const G=[],J=[];for(const ae of $){const q={name:ae.name||"!!MISSING: name!!",kind:w.SymbolKind.from(ae.kind),tags:ae.tags?.map(w.SymbolTag.from)||[],detail:"",containerName:ae.containerName,range:w.Range.from(ae.location.range),selectionRange:w.Range.from(ae.location.range),children:[]};for(;;){if(J.length===0){J.push(q),G.push(q);break}const te=J[J.length-1];if(C.Range.containsRange(te.range,q.range)&&!C.Range.equalsRange(te.range,q.range)){te.children&&te.children.push(q),J.push(q);break}J.pop()}}return G}}class p{constructor($,G,J){this._documents=$,this._commands=G,this._provider=J,this._cache=new g.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses($,G){const J=this._documents.getDocument($),ae=await this._provider.provideCodeLenses(J,G);if(!ae||G.isCancellationRequested)return;const q=this._cache.add(ae),te=new n.DisposableStore;this._disposables.set(q,te);const me={cacheId:q,lenses:[]};for(let Pe=0;Pe<ae.length;Pe++)me.lenses.push({cacheId:[q,Pe],range:w.Range.from(ae[Pe].range),command:this._commands.toInternal(ae[Pe].command,te)});return me}async resolveCodeLens($,G){const J=$.cacheId&&this._cache.get(...$.cacheId);if(!J)return;let ae;if(typeof this._provider.resolveCodeLens!="function"||J.isResolved?ae=J:ae=await this._provider.resolveCodeLens(J,G),ae||(ae=J),G.isCancellationRequested)return;const q=$.cacheId&&this._disposables.get($.cacheId[0]);if(!!q)return $.command=this._commands.toInternal(ae.command??p._badCmd,q),$}releaseCodeLenses($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}}p._badCmd={command:"missing",title:"!!MISSING: command!!"};function I(Xe){return Array.isArray(Xe)?Xe.map(w.DefinitionLink.from):Xe?[w.DefinitionLink.from(Xe)]:[]}class l{constructor($,G){this._documents=$,this._provider=G}async provideDefinition($,G,J){const ae=this._documents.getDocument($),q=w.Position.to(G),te=await this._provider.provideDefinition(ae,q,J);return I(te)}}class M{constructor($,G){this._documents=$,this._provider=G}async provideDeclaration($,G,J){const ae=this._documents.getDocument($),q=w.Position.to(G),te=await this._provider.provideDeclaration(ae,q,J);return I(te)}}class r{constructor($,G){this._documents=$,this._provider=G}async provideImplementation($,G,J){const ae=this._documents.getDocument($),q=w.Position.to(G),te=await this._provider.provideImplementation(ae,q,J);return I(te)}}class i{constructor($,G){this._documents=$,this._provider=G}async provideTypeDefinition($,G,J){const ae=this._documents.getDocument($),q=w.Position.to(G),te=await this._provider.provideTypeDefinition(ae,q,J);return I(te)}}class m{constructor($,G){this._documents=$,this._provider=G}async provideHover($,G,J){const ae=this._documents.getDocument($),q=w.Position.to(G),te=await this._provider.provideHover(ae,q,J);if(!(!te||(0,R.isFalsyOrEmpty)(te.contents)))return te.range||(te.range=ae.getWordRangeAtPosition(q)),te.range||(te.range=new T.Range(q,q)),w.Hover.from(te)}}class d{constructor($,G){this._documents=$,this._provider=G}async provideEvaluatableExpression($,G,J){const ae=this._documents.getDocument($),q=w.Position.to(G),te=await this._provider.provideEvaluatableExpression(ae,q,J);if(te)return w.EvaluatableExpression.from(te)}}class s{constructor($,G){this._documents=$,this._provider=G}async provideInlineValues($,G,J,ae){const q=this._documents.getDocument($),te=await this._provider.provideInlineValues(q,w.Range.to(G),w.InlineValueContext.to(J),ae);if(Array.isArray(te))return te.map(me=>w.InlineValue.from(me))}}class b{constructor($,G){this._documents=$,this._provider=G}async provideDocumentHighlights($,G,J){const ae=this._documents.getDocument($),q=w.Position.to(G),te=await this._provider.provideDocumentHighlights(ae,q,J);if(Array.isArray(te))return te.map(w.DocumentHighlight.from)}}class y{constructor($,G){this._documents=$,this._provider=G}async provideLinkedEditingRanges($,G,J){const ae=this._documents.getDocument($),q=w.Position.to(G),te=await this._provider.provideLinkedEditingRanges(ae,q,J);if(te&&Array.isArray(te.ranges))return{ranges:(0,R.coalesce)(te.ranges.map(w.Range.from)),wordPattern:te.wordPattern}}}class u{constructor($,G){this._documents=$,this._provider=G}async provideReferences($,G,J,ae){const q=this._documents.getDocument($),te=w.Position.to(G),me=await this._provider.provideReferences(q,te,J,ae);if(Array.isArray(me))return me.map(w.location.from)}}class S{constructor($,G,J,ae,q,te,me){this._documents=$,this._commands=G,this._diagnostics=J,this._provider=ae,this._logService=q,this._extension=te,this._apiDeprecation=me,this._cache=new g.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions($,G,J,ae){const q=this._documents.getDocument($),te=_.Selection.isISelection(G)?w.Selection.to(G):w.Range.to(G),me=[];for(const st of this._diagnostics.getDiagnostics($))if(te.intersection(st.range)&&me.push(st)>S._maxCodeActionsPerFile)break;const Pe={diagnostics:me,only:J.only?new T.CodeActionKind(J.only):void 0,triggerKind:w.CodeActionTriggerKind.to(J.trigger)},Ne=await this._provider.provideCodeActions(q,te,Pe,ae);if(!(0,R.isNonEmptyArray)(Ne)||ae.isCancellationRequested)return;const He=this._cache.add(Ne),Ye=new n.DisposableStore;this._disposables.set(He,Ye);const et=[];for(let st=0;st<Ne.length;st++){const Je=Ne[st];!Je||(S._isCommand(Je)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:Je.title,command:this._commands.toInternal(Je,Ye)})):(Pe.only&&(Je.kind?Pe.only.contains(Je.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Pe.only.value} 'requested but returned code action is of kind '${Je.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),et.push({cacheId:[He,st],title:Je.title,command:Je.command&&this._commands.toInternal(Je.command,Ye),diagnostics:Je.diagnostics&&Je.diagnostics.map(w.Diagnostic.from),edit:Je.edit&&w.WorkspaceEdit.from(Je.edit),kind:Je.kind&&Je.kind.value,isPreferred:Je.isPreferred,disabled:Je.disabled?.reason})))}return{cacheId:He,actions:et}}async resolveCodeAction($,G){const[J,ae]=$,q=this._cache.get(J,ae);if(!q||S._isCommand(q)||!this._provider.resolveCodeAction)return;const te=await this._provider.resolveCodeAction(q,G)??q;return te?.edit?w.WorkspaceEdit.from(te.edit):void 0}releaseCodeActions($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}static _isCommand($){return typeof $.command=="string"&&typeof $.title=="string"}}S._maxCodeActionsPerFile=1e3;class A{constructor($,G){this._documents=$,this._provider=G}async provideDocumentFormattingEdits($,G,J){const ae=this._documents.getDocument($),q=await this._provider.provideDocumentFormattingEdits(ae,G,J);if(Array.isArray(q))return q.map(w.TextEdit.from)}}class U{constructor($,G){this._documents=$,this._provider=G}async provideDocumentRangeFormattingEdits($,G,J,ae){const q=this._documents.getDocument($),te=w.Range.to(G),me=await this._provider.provideDocumentRangeFormattingEdits(q,te,J,ae);if(Array.isArray(me))return me.map(w.TextEdit.from)}}class H{constructor($,G){this._documents=$,this._provider=G,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits($,G,J,ae,q){const te=this._documents.getDocument($),me=w.Position.to(G),Pe=await this._provider.provideOnTypeFormattingEdits(te,me,J,ae,q);if(Array.isArray(Pe))return Pe.map(w.TextEdit.from)}}class E{constructor($,G){this._provider=$,this._logService=G,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols($,G){const J=k.IdObject.mixin({symbols:[]}),ae=await this._provider.provideWorkspaceSymbols($,G);if((0,R.isNonEmptyArray)(ae))for(const q of ae){if(!q)continue;if(!q.name){this._logService.warn("INVALID SymbolInformation, lacks name",q);continue}const te=k.IdObject.mixin(w.WorkspaceSymbol.from(q));this._symbolCache.set(te._id,q),J.symbols.push(te)}return J.symbols.length>0&&this._resultCache.set(J._id,[J.symbols[0]._id,J.symbols[J.symbols.length-1]._id]),J}async resolveWorkspaceSymbol($,G){if(typeof this._provider.resolveWorkspaceSymbol!="function")return $;const J=this._symbolCache.get($._id);if(J){const ae=await this._provider.resolveWorkspaceSymbol(J,G);return ae&&(0,t.mixin)($,w.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols($){const G=this._resultCache.get($);if(G){for(let[J,ae]=G;J<=ae;J++)this._symbolCache.delete(J);this._resultCache.delete($)}}}class L{constructor($,G,J){this._documents=$,this._provider=G,this._logService=J}static supportsResolving($){return typeof $.prepareRename=="function"}async provideRenameEdits($,G,J,ae){const q=this._documents.getDocument($),te=w.Position.to(G);try{const me=await this._provider.provideRenameEdits(q,te,J,ae);return me?w.WorkspaceEdit.from(me):void 0}catch(me){const Pe=L._asMessage(me);return Pe?{rejectReason:Pe,edits:void 0}:Promise.reject(me)}}async resolveRenameLocation($,G,J){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument($),q=w.Position.to(G);try{const te=await this._provider.prepareRename(ae,q,J);let me,Pe;if(T.Range.isRange(te)?(me=te,Pe=ae.getText(te)):(0,F.isObject)(te)&&(me=te.range,Pe=te.placeholder),!me||!Pe)return;if(me.start.line>q.line||me.end.line<q.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:w.Range.from(me),text:Pe}}catch(te){const me=L._asMessage(te);return me?{rejectReason:me,range:void 0,text:void 0}:Promise.reject(te)}}static _asMessage($){return typeof $=="string"?$:$ instanceof Error&&typeof $.message=="string"?$.message:void 0}}class z{constructor($,G){this.resultId=$,this.tokens=G}}class N{constructor($,G){this._documents=$,this._provider=G,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens($,G,J){const ae=this._documents.getDocument($),q=G!==0?this._previousResults.get(G):null;let te=typeof q?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ae,q.resultId,J):await this._provider.provideDocumentSemanticTokens(ae,J);return q&&this._previousResults.delete(G),te?(te=N._fixProvidedSemanticTokens(te),this._send(N._convertToEdits(q,te),te)):null}async releaseDocumentSemanticColoring($){this._previousResults.delete($)}static _fixProvidedSemanticTokens($){return N._isSemanticTokens($)?N._isCorrectSemanticTokens($)?$:new T.SemanticTokens(new Uint32Array($.data),$.resultId):N._isSemanticTokensEdits($)?N._isCorrectSemanticTokensEdits($)?$:new T.SemanticTokensEdits($.edits.map(G=>new T.SemanticTokensEdit(G.start,G.deleteCount,G.data?new Uint32Array(G.data):G.data)),$.resultId):$}static _isSemanticTokens($){return $&&!!$.data}static _isCorrectSemanticTokens($){return $.data instanceof Uint32Array}static _isSemanticTokensEdits($){return $&&Array.isArray($.edits)}static _isCorrectSemanticTokensEdits($){for(const G of $.edits)if(!(G.data instanceof Uint32Array))return!1;return!0}static _convertToEdits($,G){if(!N._isSemanticTokens(G)||!$||!$.tokens)return G;const J=$.tokens,ae=J.length,q=G.data,te=q.length;let me=0;const Pe=Math.min(ae,te);for(;me<Pe&&J[me]===q[me];)me++;if(me===ae&&me===te)return new T.SemanticTokensEdits([],G.resultId);let Ne=0;const He=Pe-me;for(;Ne<He&&J[ae-Ne-1]===q[te-Ne-1];)Ne++;return new T.SemanticTokensEdits([{start:me,deleteCount:ae-me-Ne,data:q.subarray(me,te-Ne)}],G.resultId)}_send($,G){if(N._isSemanticTokens($)){const J=this._nextResultId++;return this._previousResults.set(J,new z($.resultId,$.data)),(0,f.encodeSemanticTokensDto)({id:J,type:"full",data:$.data})}if(N._isSemanticTokensEdits($)){const J=this._nextResultId++;return N._isSemanticTokens(G)?this._previousResults.set(J,new z(G.resultId,G.data)):this._previousResults.set(J,new z($.resultId)),(0,f.encodeSemanticTokensDto)({id:J,type:"delta",deltas:($.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=N;class B{constructor($,G){this._documents=$,this._provider=G}async provideDocumentRangeSemanticTokens($,G,J){const ae=this._documents.getDocument($),q=await this._provider.provideDocumentRangeSemanticTokens(ae,w.Range.to(G),J);return q?this._send(q):null}_send($){return(0,f.encodeSemanticTokensDto)({id:0,type:"full",data:$.data})}}e.DocumentRangeSemanticTokensAdapter=B;class j{constructor($,G,J,ae,q){this._documents=$,this._commands=G,this._provider=J,this._apiDeprecation=ae,this._extension=q,this._cache=new g.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving($){return typeof $.resolveCompletionItem=="function"}async provideCompletionItems($,G,J,ae){const q=this._documents.getDocument($),te=w.Position.to(G),me=q.getWordRangeAtPosition(te)||new T.Range(te,te),Pe=me.with({end:te}),Ne=new c.StopWatch(!0),He=await this._provider.provideCompletionItems(q,te,ae,w.CompletionContext.to(J));if(!He||ae.isCancellationRequested)return;const Ye=Array.isArray(He)?new T.CompletionList(He):He,et=j.supportsResolving(this._provider)?this._cache.add(Ye.items):this._cache.add([]),st=new n.DisposableStore;this._disposables.set(et,st);const Je=[],nt={x:et,b:Je,a:{replace:w.Range.from(me),insert:w.Range.from(Pe)},c:Ye.isIncomplete||void 0,d:Ne.elapsed()};for(let lt=0;lt<Ye.items.length;lt++){const pt=Ye.items[lt],Ft=this._convertCompletionItem(pt,[et,lt],Pe,me);Je.push(Ft)}return nt}async resolveCompletionItem($,G){if(typeof this._provider.resolveCompletionItem!="function")return;const J=this._cache.get(...$);if(!J)return;const ae=await this._provider.resolveCompletionItem(J,G);if(!!ae)return this._convertCompletionItem(ae,$)}releaseCompletionItems($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}_convertCompletionItem($,G,J,ae){const q=this._disposables.get(G[0]);if(!q)throw Error("DisposableStore is missing...");const te={x:G,a:$.label,b:$.kind!==void 0?w.CompletionItemKind.from($.kind):void 0,n:$.tags&&$.tags.map(w.CompletionItemTag.from),c:$.detail,d:typeof $.documentation=="undefined"?void 0:w.MarkdownString.fromStrict($.documentation),e:$.sortText!==$.label?$.sortText:void 0,f:$.filterText!==$.label?$.filterText:void 0,g:$.preselect||void 0,i:$.keepWhitespace?1:0,k:$.commitCharacters,l:$.additionalTextEdits&&$.additionalTextEdits.map(w.TextEdit.from),m:this._commands.toInternal($.command,q)};$.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),te.h=$.textEdit.newText):typeof $.insertText=="string"?te.h=$.insertText:$.insertText instanceof T.SnippetString&&(te.h=$.insertText.value,te.i|=4);let me;return $.textEdit?me=$.textEdit.range:$.range&&(me=$.range),T.Range.isRange(me)?te.j=w.Range.from(me):me&&(!J?.isEqual(me.inserting)||!ae?.isEqual(me.replacing))&&(te.j={insert:w.Range.from(me.inserting),replace:w.Range.from(me.replacing)}),te}}class ce{constructor($,G,J){this._documents=$,this._provider=G,this._commands=J,this._cache=new g.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions($,G,J,ae){const q=this._documents.getDocument($),te=w.Position.to(G),me=await this._provider.provideInlineCompletionItems(q,te,{selectedCompletionInfo:J.selectedSuggestionInfo?{range:w.Range.to(J.selectedSuggestionInfo.range),text:J.selectedSuggestionInfo.text,isSnippetText:J.selectedSuggestionInfo.isSnippetText,completionKind:w.CompletionItemKind.to(J.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:J.triggerKind},ae);if(!me||ae.isCancellationRequested)return;const Pe=(0,F.isArray)(me)?{items:me}:me,Ne=this._cache.add(Pe.items);let He;return{pid:Ne,items:Pe.items.map((Ye,et)=>{let st;return Ye.command&&(He||(He=new n.DisposableStore,this._disposables.set(Ne,He)),st=this._commands.toInternal(Ye.command,He)),{text:Ye.text,range:Ye.range?w.Range.from(Ye.range):void 0,command:st,idx:et}})}}disposeCompletions($){this._cache.delete($);const G=this._disposables.get($);G&&G.clear(),this._disposables.delete($)}handleDidShowCompletionItem($,G){const J=this._cache.get($,G);J&&K.get(this._provider).fireOnDidShowCompletionItem({completionItem:J})}}class K{constructor(){this._onDidShowCompletionItemEmitter=new v.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get($){let G=K.map.get($);return G||(G=new K,K.map.set($,G)),G}fireOnDidShowCompletionItem($){this._onDidShowCompletionItemEmitter.fire($)}}e.InlineCompletionController=K,K.map=new WeakMap;class le{constructor($,G){this._documents=$,this._provider=G,this._cache=new g.Cache("SignatureHelp")}async provideSignatureHelp($,G,J,ae){const q=this._documents.getDocument($),te=w.Position.to(G),me=this.reviveContext(J),Pe=await this._provider.provideSignatureHelp(q,te,ae,me);if(Pe){const Ne=this._cache.add([Pe]);return{...w.SignatureHelp.from(Pe),id:Ne}}}reviveContext($){let G;if($.activeSignatureHelp){const J=w.SignatureHelp.to($.activeSignatureHelp),ae=this._cache.get($.activeSignatureHelp.id,0);ae?(G=ae,G.activeSignature=J.activeSignature,G.activeParameter=J.activeParameter):G=J}return{...$,activeSignatureHelp:G}}releaseSignatureHelp($){this._cache.delete($)}}class ue{constructor($,G){this._documents=$,this._provider=G}async provideInlayHints($,G,J){const ae=this._documents.getDocument($),q=await this._provider.provideInlayHints(ae,w.Range.to(G),J);return q?{hints:q.map(w.InlayHint.from)}:void 0}}class Y{constructor($,G){this._documents=$,this._provider=G,this._cache=new g.Cache("DocumentLink")}async provideLinks($,G){const J=this._documents.getDocument($),ae=await this._provider.provideDocumentLinks(J,G);if(!(!Array.isArray(ae)||ae.length===0)&&!G.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.filter(Y._validateLink).map(w.DocumentLink.from)};{const q=this._cache.add(ae),te={links:[],id:q};for(let me=0;me<ae.length;me++){if(!Y._validateLink(ae[me]))continue;const Pe=w.DocumentLink.from(ae[me]);Pe.cacheId=[q,me],te.links.push(Pe)}return te}}}static _validateLink($){return $.target&&$.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink($,G){if(typeof this._provider.resolveDocumentLink!="function")return;const J=this._cache.get(...$);if(!J)return;const ae=await this._provider.resolveDocumentLink(J,G);if(!(!ae||!Y._validateLink(ae)))return w.DocumentLink.from(ae)}releaseLinks($){this._cache.delete($)}}class ie{constructor($,G){this._documents=$,this._provider=G}async provideColors($,G){const J=this._documents.getDocument($),ae=await this._provider.provideDocumentColors(J,G);return Array.isArray(ae)?ae.map(te=>({color:w.Color.from(te.color),range:w.Range.from(te.range)})):[]}async provideColorPresentations($,G,J){const ae=this._documents.getDocument($),q=w.Range.to(G.range),te=w.Color.to(G.color),me=await this._provider.provideColorPresentations(te,{document:ae,range:q},J);if(!!Array.isArray(me))return me.map(w.ColorPresentation.from)}}class we{constructor($,G){this._documents=$,this._provider=G}async provideFoldingRanges($,G,J){const ae=this._documents.getDocument($),q=await this._provider.provideFoldingRanges(ae,G,J);if(!!Array.isArray(q))return q.map(w.FoldingRange.from)}}class Me{constructor($,G,J){this._documents=$,this._provider=G,this._logService=J}async provideSelectionRanges($,G,J){const ae=this._documents.getDocument($),q=G.map(w.Position.to),te=await this._provider.provideSelectionRanges(ae,q,J);if(!(0,R.isNonEmptyArray)(te))return[];if(te.length!==q.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const me=[];for(let Pe=0;Pe<q.length;Pe++){const Ne=[];me.push(Ne);let He=q[Pe],Ye=te[Pe];for(;;){if(!Ye.range.contains(He))throw new Error("INVALID selection range, must contain the previous range");if(Ne.push(w.SelectionRange.from(Ye)),!Ye.parent)break;He=Ye.range,Ye=Ye.parent}}return me}}class Re{constructor($,G){this._documents=$,this._provider=G,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession($,G,J){const ae=this._documents.getDocument($),q=w.Position.to(G),te=await this._provider.prepareCallHierarchy(ae,q,J);if(!te)return;const me=this._idPool.nextId();return this._cache.set(me,new Map),Array.isArray(te)?te.map(Pe=>this._cacheAndConvertItem(me,Pe)):[this._cacheAndConvertItem(me,te)]}async provideCallsTo($,G,J){const ae=this._itemFromCache($,G);if(!ae)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyIncomingCalls(ae,J);if(!!q)return q.map(te=>({from:this._cacheAndConvertItem($,te.from),fromRanges:te.fromRanges.map(me=>w.Range.from(me))}))}async provideCallsFrom($,G,J){const ae=this._itemFromCache($,G);if(!ae)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyOutgoingCalls(ae,J);if(!!q)return q.map(te=>({to:this._cacheAndConvertItem($,te.to),fromRanges:te.fromRanges.map(me=>w.Range.from(me))}))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,G){const J=this._cache.get($),ae=w.CallHierarchyItem.from(G,$,J.size.toString(36));return J.set(ae._itemId,G),ae}_itemFromCache($,G){return this._cache.get($)?.get(G)}}class Be{constructor($,G){this._documents=$,this._provider=G,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession($,G,J){const ae=this._documents.getDocument($),q=w.Position.to(G),te=await this._provider.prepareTypeHierarchy(ae,q,J);if(!te)return;const me=this._idPool.nextId();return this._cache.set(me,new Map),Array.isArray(te)?te.map(Pe=>this._cacheAndConvertItem(me,Pe)):[this._cacheAndConvertItem(me,te)]}async provideSupertypes($,G,J){const ae=this._itemFromCache($,G);if(!ae)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySupertypes(ae,J);if(!!q)return q.map(te=>this._cacheAndConvertItem($,te))}async provideSubtypes($,G,J){const ae=this._itemFromCache($,G);if(!ae)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySubtypes(ae,J);if(!!q)return q.map(te=>this._cacheAndConvertItem($,te))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,G){const J=this._cache.get($),ae=w.TypeHierarchyItem.from(G,$,J.size.toString(36));return J.set(ae._itemId,G),ae}_itemFromCache($,G){return this._cache.get($)?.get(G)}}class Qe{constructor($,G){this.adapter=$,this.extension=G}}class Ke{constructor($,G,J,ae,q,te,me){this._adapter=new Map,this._uriTransformer=G,this._proxy=$.getProxy(k.MainContext.MainThreadLanguageFeatures),this._documents=J,this._commands=ae,this._diagnostics=q,this._logService=te,this._apiDeprecation=me}_transformDocumentSelector($){return w.DocumentSelector.from($,this._uriTransformer)}_createDisposable($){return new T.Disposable(()=>{this._adapter.delete($),this._proxy.$unregister($)})}_nextHandle(){return Ke._handlePool++}_withAdapter($,G,J,ae,q=!1){const te=this._adapter.get($);if(!te)return Promise.resolve(ae);if(te.adapter instanceof G){let me;te.extension&&(me=Date.now(),this._logService.trace(`[${te.extension.identifier.value}] INVOKE provider '${G.name}'`));const Pe=J(te.adapter,te.extension),Ne=te.extension;return Ne&&Promise.resolve(Pe).then(()=>this._logService.trace(`[${Ne.identifier.value}] provider DONE after ${Date.now()-me}ms`),He=>{q&&He instanceof D.CancellationError||(this._logService.error(`[${Ne.identifier.value}] provider FAILED`),this._logService.error(He))}),Pe}return Promise.reject(new Error("no adapter found"))}_addNewAdapter($,G){const J=this._nextHandle();return this._adapter.set(J,new Qe($,G)),J}static _extLabel($){return $.displayName||$.name}registerDocumentSymbolProvider($,G,J,ae){const q=this._addNewAdapter(new h(this._documents,J),$),te=ae&&ae.label||Ke._extLabel($);return this._proxy.$registerDocumentSymbolProvider(q,this._transformDocumentSelector(G),te),this._createDisposable(q)}$provideDocumentSymbols($,G,J){return this._withAdapter($,h,ae=>ae.provideDocumentSymbols(a.URI.revive(G),J),void 0)}registerCodeLensProvider($,G,J){const ae=this._nextHandle(),q=typeof J.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Qe(new p(this._documents,this._commands.converter,J),$)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(G),q);let te=this._createDisposable(ae);if(q!==void 0){const me=J.onDidChangeCodeLenses(Pe=>this._proxy.$emitCodeLensEvent(q));te=T.Disposable.from(te,me)}return te}$provideCodeLenses($,G,J){return this._withAdapter($,p,ae=>ae.provideCodeLenses(a.URI.revive(G),J),void 0)}$resolveCodeLens($,G,J){return this._withAdapter($,p,ae=>ae.resolveCodeLens(G,J),void 0)}$releaseCodeLenses($,G){this._withAdapter($,p,J=>Promise.resolve(J.releaseCodeLenses(G)),void 0)}registerDefinitionProvider($,G,J){const ae=this._addNewAdapter(new l(this._documents,J),$);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideDefinition($,G,J,ae){return this._withAdapter($,l,q=>q.provideDefinition(a.URI.revive(G),J,ae),[])}registerDeclarationProvider($,G,J){const ae=this._addNewAdapter(new M(this._documents,J),$);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideDeclaration($,G,J,ae){return this._withAdapter($,M,q=>q.provideDeclaration(a.URI.revive(G),J,ae),[])}registerImplementationProvider($,G,J){const ae=this._addNewAdapter(new r(this._documents,J),$);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideImplementation($,G,J,ae){return this._withAdapter($,r,q=>q.provideImplementation(a.URI.revive(G),J,ae),[])}registerTypeDefinitionProvider($,G,J){const ae=this._addNewAdapter(new i(this._documents,J),$);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideTypeDefinition($,G,J,ae){return this._withAdapter($,i,q=>q.provideTypeDefinition(a.URI.revive(G),J,ae),[])}registerHoverProvider($,G,J,ae){const q=this._addNewAdapter(new m(this._documents,J),$);return this._proxy.$registerHoverProvider(q,this._transformDocumentSelector(G)),this._createDisposable(q)}$provideHover($,G,J,ae){return this._withAdapter($,m,q=>q.provideHover(a.URI.revive(G),J,ae),void 0)}registerEvaluatableExpressionProvider($,G,J,ae){const q=this._addNewAdapter(new d(this._documents,J),$);return this._proxy.$registerEvaluatableExpressionProvider(q,this._transformDocumentSelector(G)),this._createDisposable(q)}$provideEvaluatableExpression($,G,J,ae){return this._withAdapter($,d,q=>q.provideEvaluatableExpression(a.URI.revive(G),J,ae),void 0)}registerInlineValuesProvider($,G,J,ae){const q=typeof J.onDidChangeInlineValues=="function"?this._nextHandle():void 0,te=this._addNewAdapter(new s(this._documents,J),$);this._proxy.$registerInlineValuesProvider(te,this._transformDocumentSelector(G),q);let me=this._createDisposable(te);if(q!==void 0){const Pe=J.onDidChangeInlineValues(Ne=>this._proxy.$emitInlineValuesEvent(q));me=T.Disposable.from(me,Pe)}return me}$provideInlineValues($,G,J,ae,q){return this._withAdapter($,s,te=>te.provideInlineValues(a.URI.revive(G),J,ae,q),void 0)}registerDocumentHighlightProvider($,G,J){const ae=this._addNewAdapter(new b(this._documents,J),$);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideDocumentHighlights($,G,J,ae){return this._withAdapter($,b,q=>q.provideDocumentHighlights(a.URI.revive(G),J,ae),void 0)}registerLinkedEditingRangeProvider($,G,J){const ae=this._addNewAdapter(new y(this._documents,J),$);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideLinkedEditingRanges($,G,J,ae){return this._withAdapter($,y,async q=>{const te=await q.provideLinkedEditingRanges(a.URI.revive(G),J,ae);if(te)return{ranges:te.ranges,wordPattern:te.wordPattern?Ke._serializeRegExp(te.wordPattern):void 0}},void 0)}registerReferenceProvider($,G,J){const ae=this._addNewAdapter(new u(this._documents,J),$);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideReferences($,G,J,ae,q){return this._withAdapter($,u,te=>te.provideReferences(a.URI.revive(G),J,ae,q),void 0)}registerCodeActionProvider($,G,J,ae){const q=new n.DisposableStore,te=this._addNewAdapter(new S(this._documents,this._commands.converter,this._diagnostics,J,this._logService,$,this._apiDeprecation),$);return this._proxy.$registerQuickFixSupport(te,this._transformDocumentSelector(G),{providedKinds:ae?.providedCodeActionKinds?.map(me=>me.value),documentation:ae?.documentation?.map(me=>({kind:me.kind.value,command:this._commands.converter.toInternal(me.command,q)}))},Ke._extLabel($),Boolean(J.resolveCodeAction)),q.add(this._createDisposable(te)),q}$provideCodeActions($,G,J,ae,q){return this._withAdapter($,S,te=>te.provideCodeActions(a.URI.revive(G),J,ae,q),void 0)}$resolveCodeAction($,G,J){return this._withAdapter($,S,ae=>ae.resolveCodeAction(G,J),void 0)}$releaseCodeActions($,G){this._withAdapter($,S,J=>Promise.resolve(J.releaseCodeActions(G)),void 0)}registerDocumentFormattingEditProvider($,G,J){const ae=this._addNewAdapter(new A(this._documents,J),$);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(G),$.identifier,$.displayName||$.name),this._createDisposable(ae)}$provideDocumentFormattingEdits($,G,J,ae){return this._withAdapter($,A,q=>q.provideDocumentFormattingEdits(a.URI.revive(G),J,ae),void 0)}registerDocumentRangeFormattingEditProvider($,G,J){const ae=this._addNewAdapter(new U(this._documents,J),$);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(G),$.identifier,$.displayName||$.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits($,G,J,ae,q){return this._withAdapter($,U,te=>te.provideDocumentRangeFormattingEdits(a.URI.revive(G),J,ae,q),void 0)}registerOnTypeFormattingEditProvider($,G,J,ae){const q=this._addNewAdapter(new H(this._documents,J),$);return this._proxy.$registerOnTypeFormattingSupport(q,this._transformDocumentSelector(G),ae,$.identifier),this._createDisposable(q)}$provideOnTypeFormattingEdits($,G,J,ae,q,te){return this._withAdapter($,H,me=>me.provideOnTypeFormattingEdits(a.URI.revive(G),J,ae,q,te),void 0)}registerWorkspaceSymbolProvider($,G){const J=this._addNewAdapter(new E(G,this._logService),$);return this._proxy.$registerNavigateTypeSupport(J,typeof G.resolveWorkspaceSymbol=="function"),this._createDisposable(J)}$provideWorkspaceSymbols($,G,J){return this._withAdapter($,E,ae=>ae.provideWorkspaceSymbols(G,J),{symbols:[]})}$resolveWorkspaceSymbol($,G,J){return this._withAdapter($,E,ae=>ae.resolveWorkspaceSymbol(G,J),void 0)}$releaseWorkspaceSymbols($,G){this._withAdapter($,E,J=>J.releaseWorkspaceSymbols(G),void 0)}registerRenameProvider($,G,J){const ae=this._addNewAdapter(new L(this._documents,J,this._logService),$);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(G),L.supportsResolving(J)),this._createDisposable(ae)}$provideRenameEdits($,G,J,ae,q){return this._withAdapter($,L,te=>te.provideRenameEdits(a.URI.revive(G),J,ae,q),void 0)}$resolveRenameLocation($,G,J,ae){return this._withAdapter($,L,q=>q.resolveRenameLocation(a.URI.revive(G),J,ae),void 0)}registerDocumentSemanticTokensProvider($,G,J,ae){const q=this._nextHandle(),te=typeof J.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(q,new Qe(new N(this._documents,J),$)),this._proxy.$registerDocumentSemanticTokensProvider(q,this._transformDocumentSelector(G),ae,te);let me=this._createDisposable(q);if(te){const Pe=J.onDidChangeSemanticTokens(Ne=>this._proxy.$emitDocumentSemanticTokensEvent(te));me=T.Disposable.from(me,Pe)}return me}$provideDocumentSemanticTokens($,G,J,ae){return this._withAdapter($,N,q=>q.provideDocumentSemanticTokens(a.URI.revive(G),J,ae),null,!0)}$releaseDocumentSemanticTokens($,G){this._withAdapter($,N,J=>J.releaseDocumentSemanticColoring(G),void 0)}registerDocumentRangeSemanticTokensProvider($,G,J,ae){const q=this._addNewAdapter(new B(this._documents,J),$);return this._proxy.$registerDocumentRangeSemanticTokensProvider(q,this._transformDocumentSelector(G),ae),this._createDisposable(q)}$provideDocumentRangeSemanticTokens($,G,J,ae){return this._withAdapter($,B,q=>q.provideDocumentRangeSemanticTokens(a.URI.revive(G),J,ae),null,!0)}registerCompletionItemProvider($,G,J,ae){const q=this._addNewAdapter(new j(this._documents,this._commands.converter,J,this._apiDeprecation,$),$);return this._proxy.$registerSuggestSupport(q,this._transformDocumentSelector(G),ae,j.supportsResolving(J),`${$.identifier.value}(${ae.join("")})`),this._createDisposable(q)}$provideCompletionItems($,G,J,ae,q){return this._withAdapter($,j,te=>te.provideCompletionItems(a.URI.revive(G),J,ae,q),void 0)}$resolveCompletionItem($,G,J){return this._withAdapter($,j,ae=>ae.resolveCompletionItem(G,J),void 0)}$releaseCompletionItems($,G){this._withAdapter($,j,J=>J.releaseCompletionItems(G),void 0)}registerInlineCompletionsProvider($,G,J){const ae=this._addNewAdapter(new ce(this._documents,J,this._commands.converter),$);return this._proxy.$registerInlineCompletionsSupport(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideInlineCompletions($,G,J,ae,q){return this._withAdapter($,ce,te=>te.provideInlineCompletions(a.URI.revive(G),J,ae,q),void 0)}$handleInlineCompletionDidShow($,G,J){this._withAdapter($,ce,async ae=>{ae.handleDidShowCompletionItem(G,J)},void 0)}$freeInlineCompletionsList($,G){this._withAdapter($,ce,async J=>{J.disposeCompletions(G)},void 0)}registerSignatureHelpProvider($,G,J,ae){const q=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,te=this._addNewAdapter(new le(this._documents,J),$);return this._proxy.$registerSignatureHelpProvider(te,this._transformDocumentSelector(G),q),this._createDisposable(te)}$provideSignatureHelp($,G,J,ae,q){return this._withAdapter($,le,te=>te.provideSignatureHelp(a.URI.revive(G),J,ae,q),void 0)}$releaseSignatureHelp($,G){this._withAdapter($,le,J=>J.releaseSignatureHelp(G),void 0)}registerInlayHintsProvider($,G,J){const ae=typeof J.onDidChangeInlayHints=="function"?this._nextHandle():void 0,q=this._addNewAdapter(new ue(this._documents,J),$);this._proxy.$registerInlayHintsProvider(q,this._transformDocumentSelector(G),ae);let te=this._createDisposable(q);if(ae!==void 0){const me=J.onDidChangeInlayHints(Pe=>this._proxy.$emitInlayHintsEvent(ae));te=T.Disposable.from(te,me)}return te}$provideInlayHints($,G,J,ae){return this._withAdapter($,ue,q=>q.provideInlayHints(a.URI.revive(G),J,ae),void 0)}registerDocumentLinkProvider($,G,J){const ae=this._addNewAdapter(new Y(this._documents,J),$);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(G),typeof J.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks($,G,J){return this._withAdapter($,Y,ae=>ae.provideLinks(a.URI.revive(G),J),void 0)}$resolveDocumentLink($,G,J){return this._withAdapter($,Y,ae=>ae.resolveLink(G,J),void 0)}$releaseDocumentLinks($,G){this._withAdapter($,Y,J=>J.releaseLinks(G),void 0)}registerColorProvider($,G,J){const ae=this._addNewAdapter(new ie(this._documents,J),$);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideDocumentColors($,G,J){return this._withAdapter($,ie,ae=>ae.provideColors(a.URI.revive(G),J),[])}$provideColorPresentations($,G,J,ae){return this._withAdapter($,ie,q=>q.provideColorPresentations(a.URI.revive(G),J,ae),void 0)}registerFoldingRangeProvider($,G,J){const ae=this._nextHandle(),q=typeof J.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Qe(new we(this._documents,J),$)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(G),q);let te=this._createDisposable(ae);if(q!==void 0){const me=J.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(q));te=T.Disposable.from(te,me)}return te}$provideFoldingRanges($,G,J,ae){return this._withAdapter($,we,q=>q.provideFoldingRanges(a.URI.revive(G),J,ae),void 0)}registerSelectionRangeProvider($,G,J){const ae=this._addNewAdapter(new Me(this._documents,J,this._logService),$);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideSelectionRanges($,G,J,ae){return this._withAdapter($,Me,q=>q.provideSelectionRanges(a.URI.revive(G),J,ae),[])}registerCallHierarchyProvider($,G,J){const ae=this._addNewAdapter(new Re(this._documents,J),$);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$prepareCallHierarchy($,G,J,ae){return this._withAdapter($,Re,q=>Promise.resolve(q.prepareSession(a.URI.revive(G),J,ae)),void 0)}$provideCallHierarchyIncomingCalls($,G,J,ae){return this._withAdapter($,Re,q=>q.provideCallsTo(G,J,ae),void 0)}$provideCallHierarchyOutgoingCalls($,G,J,ae){return this._withAdapter($,Re,q=>q.provideCallsFrom(G,J,ae),void 0)}$releaseCallHierarchy($,G){this._withAdapter($,Re,J=>Promise.resolve(J.releaseSession(G)),void 0)}registerTypeHierarchyProvider($,G,J){const ae=this._addNewAdapter(new Be(this._documents,J),$);return this._proxy.$registerTypeHierarchyProvider(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$prepareTypeHierarchy($,G,J,ae){return this._withAdapter($,Be,q=>Promise.resolve(q.prepareSession(a.URI.revive(G),J,ae)),void 0)}$provideTypeHierarchySupertypes($,G,J,ae){return this._withAdapter($,Be,q=>q.provideSupertypes(G,J,ae),void 0)}$provideTypeHierarchySubtypes($,G,J,ae){return this._withAdapter($,Be,q=>q.provideSubtypes(G,J,ae),void 0)}$releaseTypeHierarchy($,G){this._withAdapter($,Be,J=>Promise.resolve(J.releaseSession(G)),void 0)}static _serializeRegExp($){return{pattern:$.source,flags:(0,P.regExpFlags)($)}}static _serializeIndentationRule($){return{decreaseIndentPattern:Ke._serializeRegExp($.decreaseIndentPattern),increaseIndentPattern:Ke._serializeRegExp($.increaseIndentPattern),indentNextLinePattern:$.indentNextLinePattern?Ke._serializeRegExp($.indentNextLinePattern):void 0,unIndentedLinePattern:$.unIndentedLinePattern?Ke._serializeRegExp($.unIndentedLinePattern):void 0}}static _serializeOnEnterRule($){return{beforeText:Ke._serializeRegExp($.beforeText),afterText:$.afterText?Ke._serializeRegExp($.afterText):void 0,previousLineText:$.previousLineText?Ke._serializeRegExp($.previousLineText):void 0,action:$.action}}static _serializeOnEnterRules($){return $.map(Ke._serializeOnEnterRule)}setLanguageConfiguration($,G,J){let{wordPattern:ae}=J;if(ae&&(0,P.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(G,ae):this._documents.setWordDefinitionFor(G,void 0),J.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",$,"Do not use."),J.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",$,"Do not use.");const q=this._nextHandle(),te={comments:J.comments,brackets:J.brackets,wordPattern:J.wordPattern?Ke._serializeRegExp(J.wordPattern):void 0,indentationRules:J.indentationRules?Ke._serializeIndentationRule(J.indentationRules):void 0,onEnterRules:J.onEnterRules?Ke._serializeOnEnterRules(J.onEnterRules):void 0,__electricCharacterSupport:J.__electricCharacterSupport,__characterPairSupport:J.__characterPairSupport};return this._proxy.$setLanguageConfiguration(q,G,te),this._createDisposable(q)}$setWordDefinitions($){for(const G of $)this._documents.setWordDefinitionFor(G.languageId,new RegExp(G.regexSource,G.regexFlags))}}e.ExtHostLanguageFeatures=Ke,Ke._handlePool=0}),define(Ee[191],ye([0,1,5,8,7,34,14,6]),function(re,e,a,t,w,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class C{constructor(F,_,n,f){this._documents=_,this._commands=n,this._uriTransformer=f,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=F.getProxy(a.MainContext.MainThreadLanguages)}$acceptLanguageIds(F){this._languageIds=F}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(F,_){await this._proxy.$changeLanguage(F,_);const n=this._documents.getDocumentData(F);if(!n)throw new Error(`document '${F.toString}' NOT found`);return n.document}async tokenAtPosition(F,_){const n=F.version,f=t.Position.from(_),o=await this._proxy.$tokensAtPosition(F.uri,f),g={type:w.StandardTokenType.Other,range:F.getWordRangeAtPosition(_)??new w.Range(_.line,_.character,_.line,_.character)};if(!o)return g;const c={range:t.Range.to(o.range),type:t.TokenType.to(o.type)};return!c.range.contains(_)||n!==F.version?g:c}createLanguageStatusItem(F,_,n){const f=this._handlePool++,o=this._proxy,g=this._ids,c=`${F.identifier.value}/${_}`;if(g.has(c))throw new Error(`LanguageStatusItem with id '${_}' ALREADY exists`);g.add(c);const D={selector:n,id:_,name:F.displayName??F.name,severity:w.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let v,h=new P.DisposableStore;const p=()=>{v?.dispose(),v=(0,k.disposableTimeout)(()=>{h.clear(),this._proxy.$setLanguageStatus(f,{id:c,name:D.name??F.displayName??F.name,source:F.displayName??F.name,selector:t.DocumentSelector.from(D.selector,this._uriTransformer),label:D.text,detail:D.detail??"",severity:D.severity===w.LanguageStatusSeverity.Error?T.default.Error:D.severity===w.LanguageStatusSeverity.Warning?T.default.Warning:T.default.Info,command:D.command&&this._commands.toInternal(D.command,h),accessibilityInfo:D.accessibilityInformation,busy:D.busy})},0)},I={dispose(){h.dispose(),v?.dispose(),o.$removeLanguageStatus(f),g.delete(c)},get id(){return D.id},get name(){return D.name},set name(l){D.name=l,p()},get selector(){return D.selector},set selector(l){D.selector=l,p()},get text(){return D.text},set text(l){D.text=l,p()},get detail(){return D.detail},set detail(l){D.detail=l,p()},get severity(){return D.severity},set severity(l){D.severity=l,p()},get accessibilityInformation(){return D.accessibilityInformation},set accessibilityInformation(l){D.accessibilityInformation=l,p()},get command(){return D.command},set command(l){D.command=l,p()},get busy(){return D.busy},set busy(l){D.busy=l,p()}};return p(),I}}e.ExtHostLanguages=C}),define(Ee[192],ye([0,1,12,5,28,13,4]),function(re,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let P=class extends a.AbstractLoggerService{constructor(F,_){const n=new k.Emitter;super(_.logLevel,n.event);this._proxy=F.getProxy(t.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(n)}$setLevel(F){this._onDidChangeLogLevel.fire(F)}doCreateLogger(F,_,n){return new C(this._proxy,F,_,n)}};P=Ue([$e(0,T.IExtHostRpcService),$e(1,w.IExtHostInitDataService)],P),e.ExtHostLoggerService=P;class C extends a.AbstractMessageLogger{constructor(F,_,n,f){super(f?.always);this.proxy=F,this.file=_,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(n),this.proxy.$createLogger(_,f).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(F,_){const n=[[F,_]];this.isLoggerCreated?this.doLog(n):this.buffer.push(...n)}doLog(F){this.proxy.$log(this.file,F)}}}),define(Ee[193],ye([0,1,5,12,27]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(P){return P&&P.title}let k=class{constructor(C,R){this._logService=R,this._proxy=C.getProxy(a.MainContext.MainThreadMessageService)}showMessage(C,R,F,_,n){const f={extension:C};let o;typeof _=="string"||T(_)?o=[_,...n]:(f.modal=_?.modal,f.useCustom=_?.useCustom,f.detail=_?.detail,o=n),f.useCustom&&(0,w.checkProposedApiEnabled)(C,"resolvers");const g=[];for(let c=0;c<o.length;c++){const D=o[c];if(typeof D=="string")g.push({title:D,handle:c,isCloseAffordance:!1});else if(typeof D=="object"){let{title:v,isCloseAffordance:h}=D;g.push({title:v,isCloseAffordance:!!h,handle:c})}else this._logService.warn("Invalid message item:",D)}return this._proxy.$showMessage(R,F,f,g).then(c=>{if(typeof c=="number")return o[c]})}};k=Ue([$e(1,t.ILogService)],k),e.ExtHostMessageService=k}),define(Ee[194],ye([0,1,22,4,57,6,21,9,11,2,63,5,8,7,37,167,91]),function(re,e,a,t,w,T,k,P,C,R,F,_,n,f,o,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class D{constructor(h,p,I,l,M){this._textDocumentsAndEditors=I,this._textDocuments=l,this._extensionStoragePaths=M,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new k.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new t.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new t.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new t.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new t.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new F.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=h.getProxy(_.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=h.getProxy(_.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=h.getProxy(_.MainContext.MainThreadNotebookEditors),this._commandsConverter=p.converter,p.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const i=r.notebookEditor?.notebookUri,m=r.cell.handle,s=this._documents.get(i)?.getCell(m);if(s)return s.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(h=>h.apiEditor)}getEditorById(h){const p=this._editors.get(h);if(!p)throw new Error(`unknown text editor: ${h}. known editors: ${[...this._editors.keys()]} `);return p}getIdByEditor(h){for(const[p,I]of this._editors)if(I.apiEditor===h)return p}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(h,p){const I=this._documents.get(h);if(!I&&!p)throw new Error(`NO notebook document for '${h}'`);return I}_getProviderData(h){const p=this._notebookContentProviders.get(h);if(!p)throw new Error(`NO provider for '${h}'`);return p}registerNotebookContentProvider(h,p,I,l,M){if((0,P.isFalsyOrWhitespace)(p))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(p))throw new Error(`Notebook provider for '${p}' already registered`);this._notebookContentProviders.set(p,{extension:h,provider:I});let r;return I.onDidChangeNotebookContentOptions&&(r=I.onDidChangeNotebookContentOptions(()=>{const i=n.NotebookDocumentContentOptions.from(I.options);this._notebookProxy.$updateNotebookProviderOptions(p,i)})),this._notebookProxy.$registerNotebookProvider({id:h.identifier,location:h.extensionLocation},p,n.NotebookDocumentContentOptions.from(l),D._convertNotebookRegistrationData(h,M)),new f.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(p),this._notebookProxy.$unregisterNotebookProvider(p)})}static _convertNotebookRegistrationData(h,p){if(!p)return;const I=p.filenamePattern.map(l=>n.NotebookExclusiveDocumentPattern.from(l)).filter(l=>l!==void 0);if(p.filenamePattern&&!I){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:h.identifier,providerDisplayName:h.displayName||h.name,displayName:p.displayName,filenamePattern:I,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider(h,p,I){const l=D._notebookStatusBarItemProviderHandlePool++,M=typeof I.onDidChangeCellStatusBarItems=="function"?D._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(l,I),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(l,M,p);let r;return M!==void 0&&(r=I.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(M))),new f.Disposable(()=>{this._notebookStatusBarItemProviders.delete(l),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(l,M),r&&r.dispose()})}async createNotebookDocument(h){const p=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:h.viewType,content:h.content&&n.NotebookData.from(h.content)});return R.URI.revive(p)}async openNotebookDocument(h){const p=this._documents.get(h);if(p)return p.apiNotebook;const I=await this._notebookDocumentsProxy.$tryOpenNotebook(h),l=this._documents.get(R.URI.revive(I));return(0,C.assertIsDefined)(l?.apiNotebook)}async showNotebookDocument(h,p){R.URI.isUri(h)&&(h=await this.openNotebookDocument(h));let I;typeof p=="object"?I={position:n.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(n.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:I={preserveFocus:!1};const l=await this._notebookEditorsProxy.$tryShowNotebookDocument(h.uri,h.notebookType,I),M=l&&this._editors.get(l)?.apiEditor;if(M)return M;throw l?new Error(`Could NOT open editor for "${h.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${h.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(h,p,I,l){const M=this._notebookStatusBarItemProviders.get(h),r=R.URI.revive(p),i=this._documents.get(r);if(!i||!M)return;const m=i.getCellFromIndex(I);if(!m)return;const d=await M.provideCellStatusBarItems(m.apiCell,l);if(!d)return;const s=new T.DisposableStore,b=this._statusBarCache.add([s]),u=(Array.isArray(d)?d:[d]).map(S=>n.NotebookStatusBarItem.from(S,this._commandsConverter,s));return{cacheId:b,items:u}}$releaseNotebookCellStatusBarItems(h){this._statusBarCache.delete(h)}registerNotebookSerializer(h,p,I,l,M){if((0,P.isFalsyOrWhitespace)(p))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,I),this._notebookProxy.$registerNotebookSerializer(r,{id:h.identifier,location:h.extensionLocation},p,n.NotebookDocumentContentOptions.from(l),D._convertNotebookRegistrationData(h,M)),(0,T.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(h,p,I){const l=this._notebookSerializer.get(h);if(!l)throw new Error("NO serializer found");const M=await l.deserializeNotebook(p.buffer,I);return new o.SerializableObjectWithBuffers(n.NotebookData.from(M))}async $notebookToData(h,p,I){const l=this._notebookSerializer.get(h);if(!l)throw new Error("NO serializer found");const M=await l.serializeNotebook(n.NotebookData.to(p.value),I);return a.VSBuffer.wrap(M)}async $openNotebook(h,p,I,l,M){const{provider:r}=this._getProviderData(h),i=await r.openNotebook(R.URI.revive(p),{backupId:I,untitledDocumentData:l?.buffer},M);return new o.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(n.NotebookCellData.from)})}async $saveNotebook(h,p,I){const l=this.getNotebookDocument(R.URI.revive(p)),{provider:M}=this._getProviderData(h);return await M.saveNotebook(l.apiNotebook,I),!0}async $saveNotebookAs(h,p,I,l){const M=this.getNotebookDocument(R.URI.revive(p)),{provider:r}=this._getProviderData(h);return await r.saveNotebookAs(R.URI.revive(I),M.apiNotebook,l),!0}async $backupNotebook(h,p,I){const l=this.getNotebookDocument(R.URI.revive(p)),M=this._getProviderData(h),r=this._extensionStoragePaths.workspaceValue(M.extension)??this._extensionStoragePaths.globalValue(M.extension),i=String((0,w.hash)([l.uri.toString(),this._backupIdPool++])),m=R.URI.joinPath(r,i),d=await M.provider.backupNotebook(l.apiNotebook,{destination:m},I);return l.updateBackup(d),d.id}_createExtHostEditor(h,p,I){if(this._editors.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const l=new c.ExtHostNotebookEditor(p,this._notebookEditorsProxy,h,I.visibleRanges.map(n.NotebookRange.to),I.selections.map(n.NotebookRange.to),typeof I.viewColumn=="number"?n.ViewColumn.to(I.viewColumn):void 0);this._editors.set(p,l)}$acceptDocumentAndEditorsDelta(h){if(h.value.removedDocuments)for(const I of h.value.removedDocuments){const l=R.URI.revive(I),M=this._documents.get(l);M&&(M.dispose(),this._documents.delete(l),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:M.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(M.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===l.toString()&&this._editors.delete(r.id)}if(h.value.addedDocuments){const I=[];for(const l of h.value.addedDocuments){const M=R.URI.revive(l.uri);if(this._documents.has(M))throw new Error(`adding EXISTING notebook ${M} `);const r=this,i=new g.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(m){r._onDidChangeNotebookCells.fire(m)},emitCellOutputsChange(m){r._onDidChangeCellOutputs.fire(m)},emitCellMetadataChange(m){r._onDidChangeCellMetadata.fire(m)},emitCellExecutionStateChange(m){r._onDidChangeCellExecutionState.fire(m)}},M,l);I.push(...l.cells.map(m=>g.ExtHostCell.asModelAddData(i.apiNotebook,m))),this._documents.get(M)?.dispose(),this._documents.set(M,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:I}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(h.value.addedEditors)for(const I of h.value.addedEditors){if(this._editors.has(I.id))return;const l=R.URI.revive(I.documentUri),M=this._documents.get(l);M&&this._createExtHostEditor(M,I.id,I)}const p=[];if(h.value.removedEditors)for(const I of h.value.removedEditors){const l=this._editors.get(I);l&&(this._editors.delete(I),this._activeNotebookEditor?.id===l.id&&(this._activeNotebookEditor=void 0),p.push(l))}if(h.value.visibleEditors){this._visibleNotebookEditors=h.value.visibleEditors.map(l=>this._editors.get(l)).filter(l=>!!l);const I=new Set;this._visibleNotebookEditors.forEach(l=>I.add(l.id));for(const l of this._editors.values()){const M=I.has(l.id);l._acceptVisibility(M)}this._visibleNotebookEditors=[...this._editors.values()].map(l=>l).filter(l=>l.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}h.value.newActiveEditor===null?this._activeNotebookEditor=void 0:h.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(h.value.newActiveEditor)),h.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=D,D._notebookStatusBarItemProviderHandlePool=0}),define(Ee[195],ye([0,1,4,53,12,5,13,8]),function(re,e,a,t,w,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class C{constructor(_,n){const f=C._Keys.nextId();_.$registerNotebookEditorDecorationType(f,P.NotebookDecorationRenderOptions.from(n)),this.value={key:f,dispose(){_.$removeNotebookEditorDecorationType(f)}}}}C._Keys=new t.IdGenerator("NotebookEditorDecorationType");let R=class{constructor(_,n,f){this._logService=_,this._extHostRpc=n,this._notebooksAndEditors=f,this._onDidChangeNotebookEditorSelection=new a.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new a.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(_){return new C(this._extHostRpc.getProxy(T.MainContext.MainThreadNotebookEditors),_).value}$acceptEditorPropertiesChanged(_,n){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",_,n);const f=this._notebooksAndEditors.getEditorById(_);n.visibleRanges&&f._acceptVisibleRanges(n.visibleRanges.ranges.map(P.NotebookRange.to)),n.selections&&f._acceptSelections(n.selections.selections.map(P.NotebookRange.to)),n.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:f.apiEditor,visibleRanges:f.apiEditor.visibleRanges}),n.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:f.apiEditor,selections:f.apiEditor.selections}))}$acceptEditorViewColumns(_){for(const n in _)this._notebooksAndEditors.getEditorById(n)._acceptViewColumn(P.ViewColumn.to(_[n]))}};R=Ue([$e(0,w.ILogService),$e(1,k.IExtHostRpcService)],R),e.ExtHostNotebookEditors=R}),define(Ee[196],ye([0,1,16,14,20,4,6,21,2,25,12,5,38,8,7,66,159,27,37]),function(re,e,a,t,w,T,k,P,C,R,F,_,n,f,o,g,c,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let h=class{constructor(r,i,m,d,s){this._initData=i,this._extHostNotebook=m,this._commands=d,this._logService=s,this._activeExecutions=new P.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=r.getProxy(_.MainContext.MainThreadNotebookKernels);const b=new n.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new n.ApiCommandArgument("options","Select kernel options",y=>!0,y=>{if(y&&"notebookEditor"in y&&"id"in y){const u=this._extHostNotebook.getIdByEditor(y.notebookEditor);return{id:y.id,extension:y.extension,notebookEditorId:u}}else if(y&&"notebookEditor"in y){const u=this._extHostNotebook.getIdByEditor(y.notebookEditor);if(u===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${y.notebookEditor.document.uri.toString()}`);return{notebookEditorId:u}}return y})],n.ApiCommandResult.Void);this._commands.registerApiCommand(b)}createNotebookController(r,i,m,d,s,b){for(let le of this._kernelData.values())if(le.controller.id===i&&R.ExtensionIdentifier.equals(r.identifier,le.extensionId))throw new Error(`notebook controller with id '${i}' ALREADY exist`);const y=this._handlePool++,u=this;this._logService.trace(`NotebookController[${y}], CREATED by ${r.identifier.value}, ${i}`);const S=()=>console.warn(`NO execute handler from notebook controller '${L.id}' of extension: '${r.identifier}'`);let A=!1;const U=new k.DisposableStore,H=new T.Emitter,E=new T.Emitter,L={id:`${r.identifier.value}/${i}`,notebookType:m,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:d||r.identifier.value,preloads:b?b.map(f.NotebookRendererScript.from):[]};let z=s??S,N;this._proxy.$addKernel(y,L).catch(le=>{console.log(le),A=!0});let B=0;const j=()=>{if(A)return;const le=++B;Promise.resolve().then(()=>{le===B&&this._proxy.$updateKernel(y,L)})},ce=new P.ResourceMap,K={get id(){return i},get notebookType(){return L.notebookType},onDidChangeSelectedNotebooks:H.event,get label(){return L.label},set label(le){L.label=le??r.displayName??r.name,j()},get detail(){return L.detail??""},set detail(le){L.detail=le,j()},get description(){return L.description??""},set description(le){L.description=le,j()},get kind(){return(0,D.checkProposedApiEnabled)(r,"notebookControllerKind"),L.kind??""},set kind(le){(0,D.checkProposedApiEnabled)(r,"notebookControllerKind"),L.kind=le,j()},get supportedLanguages(){return L.supportedLanguages},set supportedLanguages(le){L.supportedLanguages=le,j()},get supportsExecutionOrder(){return L.supportsExecutionOrder??!1},set supportsExecutionOrder(le){L.supportsExecutionOrder=le,j()},get rendererScripts(){return L.preloads?L.preloads.map(f.NotebookRendererScript.to):[]},get executeHandler(){return z},set executeHandler(le){z=le??S},get interruptHandler(){return N},set interruptHandler(le){N=le,L.supportsInterrupt=Boolean(le),j()},createNotebookCellExecution(le){if(A)throw new Error("notebook controller is DISPOSED");if(!ce.has(le.notebook.uri))throw u._logService.trace(`NotebookController[${y}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${le.notebook.uri.toString()}`);return u._createNotebookCellExecution(le)},dispose:()=>{A||(this._logService.trace(`NotebookController[${y}], DISPOSED`),A=!0,this._kernelData.delete(y),U.dispose(),H.dispose(),E.dispose(),this._proxy.$removeKernel(y))},updateNotebookAffinity(le,ue){u._proxy.$updateNotebookPriority(y,le.uri,ue)},onDidReceiveMessage:E.event,postMessage(le,ue){return(0,D.checkProposedApiEnabled)(r,"notebookMessaging"),u._proxy.$postMessage(y,ue&&u._extHostNotebook.getIdByEditor(ue),le)},asWebviewUri(le){return(0,D.checkProposedApiEnabled)(r,"notebookMessaging"),(0,g.asWebviewUri)(le,u._initData.remote)}};return this._kernelData.set(y,{extensionId:r.identifier,controller:K,onDidReceiveMessage:E,onDidChangeSelection:H,associatedNotebooks:ce}),K}$acceptNotebookAssociation(r,i,m){const d=this._kernelData.get(r);if(d){const s=this._extHostNotebook.getNotebookDocument(C.URI.revive(i));m?d.associatedNotebooks.set(s.uri,!0):d.associatedNotebooks.delete(s.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,s.uri.toString(),m),d.onDidChangeSelection.fire({selected:m,notebook:s.apiNotebook})}}async $executeCells(r,i,m){const d=this._kernelData.get(r);if(!d)return;const s=this._extHostNotebook.getNotebookDocument(C.URI.revive(i)),b=[];for(let y of m){const u=s.getCell(y);u&&b.push(u.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,s.uri.toString(),b.length),await d.controller.executeHandler.call(d.controller,b,s.apiNotebook,d.controller)}catch(y){this._logService.error(`NotebookController[${r}] execute cells FAILED`,y),console.error(y)}}async $cancelCells(r,i,m){const d=this._kernelData.get(r);if(!d)return;const s=this._extHostNotebook.getNotebookDocument(C.URI.revive(i));if(d.controller.interruptHandler)await d.controller.interruptHandler.call(d.controller,s.apiNotebook);else for(let b of m){const y=s.getCell(b);y&&this._activeExecutions.get(y.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,i,m){const d=this._kernelData.get(r);if(!d)return;const s=this._extHostNotebook.getEditorById(i);d.onDidReceiveMessage.fire(Object.freeze({editor:s.apiEditor,message:m}))}_createNotebookCellExecution(r){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const m=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!m)throw new Error("invalid cell");if(this._activeExecutions.has(m.uri))throw new Error(`duplicate execution for ${m.uri}`);const d=new I(m.notebook,m,this._proxy);this._activeExecutions.set(m.uri,d);const s=d.onDidChangeState(()=>{d.state===p.Resolved&&(d.dispose(),s.dispose(),this._activeExecutions.delete(m.uri))});return d.asApiObject()}};h=Ue([$e(4,F.ILogService)],h),e.ExtHostNotebookKernels=h;var p;(function(M){M[M.Init=0]="Init",M[M.Started=1]="Started",M[M.Resolved=2]="Resolved"})(p||(p={}));class I extends k.Disposable{constructor(r,i,m){super();this._document=r,this._cell=i,this._proxy=m,this._handle=I.HANDLE++,this._onDidChangeState=new T.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=p.Init,this._tokenSource=this._register(new w.CancellationTokenSource),this._collector=new l(10,d=>this.update(d)),this._executionOrder=i.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const i=Array.isArray(r)?r:[r];return this._proxy.$updateExecutions(new v.SerializableObjectWithBuffers(i))}verifyStateForOutput(){if(this._state===p.Init)throw new Error("Must call start before modifying cell output");if(this._state===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let i=this._cell;if(r&&(i=this._document.getCellFromApiCell(r)),!i)throw new Error("INVALID cell");return i.handle}validateAndConvertOutputs(r){return r.map(i=>{const m=o.NotebookCellOutput.ensureUniqueMimeTypes(i.items,!0);return m===i.items?f.NotebookCellOutput.from(i):f.NotebookCellOutput.from({items:m,id:i.id,metadata:i.metadata})})}async updateOutputs(r,i,m){const d=this.cellIndexToHandle(i),s=this.validateAndConvertOutputs((0,a.asArray)(r));return this.updateSoon({editType:c.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:d,append:m,outputs:s})}async updateOutputItems(r,i,m){return r=o.NotebookCellOutput.ensureUniqueMimeTypes((0,a.asArray)(r),!0),this.updateSoon({editType:c.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:r.map(f.NotebookCellOutputItem.from),outputId:i.id,append:m})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(m){r._executionOrder=m,r.update([{editType:c.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,executionOrder:r._executionOrder}])},start(m){if(r._state===p.Resolved||r._state===p.Started)throw new Error("Cannot call start again");r._state=p.Started,r._onDidChangeState.fire(),r.update({editType:c.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,runStartTime:m})},end(m,d){if(r._state===p.Resolved)throw new Error("Cannot call resolve twice");r._state=p.Resolved,r._onDidChangeState.fire(),r.updateSoon({editType:c.CellExecutionUpdateType.Complete,executionHandle:r._handle,runEndTime:d,lastRunSuccess:m}),r._collector.flush(),r._proxy.$removeExecution(r._handle)},clearOutput(m){return r.verifyStateForOutput(),r.updateOutputs([],m,!1)},appendOutput(m,d){return r.verifyStateForOutput(),r.updateOutputs(m,d,!0)},replaceOutput(m,d){return r.verifyStateForOutput(),r.updateOutputs(m,d,!1)},appendOutputItems(m,d){return r.verifyStateForOutput(),r.updateOutputItems(m,d,!0)},replaceOutputItems(m,d){return r.verifyStateForOutput(),r.updateOutputItems(m,d,!1)}})}}I.HANDLE=0;class l{constructor(r,i){this.delay=r,this.callback=i,this.batch=[],this.startedTimer=Date.now()}addItem(r){return this.batch.push(r),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const r=this.currentDeferred;this.currentDeferred=void 0;const i=this.batch;return this.batch=[],this.callback(i).finally(()=>r.complete())}}}),define(Ee[197],ye([0,1,4,5,91,27]),function(re,e,a,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class k{constructor(C,R){this._extHostNotebook=R,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,R,F){const _=this._extHostNotebook.getEditorById(C);this._rendererMessageEmitters.get(R)?.fire({editor:_.apiEditor,message:F})}createRendererMessaging(C,R){if(!C.contributes?.notebookRenderer?.some(f=>f.id===R))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${R})`);const F=(0,T.isProposedApiEnabled)(C,"notebookEditor"),_=new WeakMap;return{onDidReceiveMessage:(f,o,g)=>{const c=F?f:D=>{const v={};_.set(v,D.editor),f({editor:v,message:D.message})};return this.getOrCreateEmitterFor(R).event(c,o,g)},postMessage:(f,o)=>{w.ExtHostNotebookEditor.apiEditorsToExtHost.has(f)&&([f,o]=[o,f]);const g=F?o:_.get(o),c=g&&w.ExtHostNotebookEditor.apiEditorsToExtHost.get(g);return this.proxy.$postMessage(c?.id,R,f)}}}getOrCreateEmitterFor(C){let R=this._rendererMessageEmitters.get(C);return R||(R=new a.Emitter({onLastListenerRemove:()=>{R?.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,R),R)}}e.ExtHostNotebookRenderers=k}),define(Ee[94],ye([0,1,5,6,3,13,12,160,49,28,30,110,22]),function(re,e,a,t,w,T,k,P,C,R,F,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class f extends t.Disposable{constructor(c,D,v,h){super();this.id=c,this.name=D,this.logger=v,this.proxy=h,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(c){this.append(c+`
`)}append(c){this.write(c),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Append))}clear(){const c=this.offset;this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Clear,c)}replace(c){const D=this.offset;this.write(c),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Replace,D),this.visible&&this.logger.flush()}show(c,D){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof c=="boolean"?c:D))}hide(){this.proxy.$close(this.id)}write(c){this.offset+=n.VSBuffer.fromString(c).byteLength,this.logger.info(c)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=f;let o=class{constructor(c,D,v,h,p){this.extHostFileSystem=v,this.extHostFileSystemInfo=h,this.loggerService=p,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=c.getProxy(a.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(D.logsLocation,`output_logging_${(0,_.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(c){this.visibleChannelId=c;for(const[D,v]of this.channels)v.visible=D===this.visibleChannelId}createOutputChannel(c,D){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");const v=this.doCreateOutputChannel(c,D);return v.then(h=>{this.channels.set(h.id,h),h.visible=h.id===this.visibleChannelId}),this.createExtHostOutputChannel(c,v)}async doCreateOutputChannel(c,D){const v=await this.createOutputDirectory(),h=this.extHostFileSystemInfo.extUri.joinPath(v,`${this.namePool++}-${c.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),p=this.loggerService.createLogger(h,{always:!0,donotRotate:!0,donotUseFormatters:!0}),I=await this.proxy.$register(c,!1,h,D.identifier.value);return new f(I,c,p,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(c,D){let v=!1;const h=()=>{if(v)throw new Error("Channel has been closed")};return{get name(){return c},append(p){h(),D.then(I=>I.append(p))},appendLine(p){h(),D.then(I=>I.appendLine(p))},clear(){h(),D.then(p=>p.clear())},replace(p){h(),D.then(I=>I.replace(p))},show(p,I){h(),D.then(l=>l.show(p,I))},hide(){h(),D.then(p=>p.hide())},dispose(){v=!0,D.then(p=>p.dispose())}}}};o=Ue([$e(0,T.IExtHostRpcService),$e(1,R.IExtHostInitDataService),$e(2,C.IExtHostConsumerFileSystem),$e(3,F.IExtHostFileSystemInfo),$e(4,k.ILoggerService)],o),e.ExtHostOutputService=o,e.IExtHostOutputService=(0,w.createDecorator)("IExtHostOutputService")}),define(Ee[198],ye([0,1,14,20,4,6,5,2,7,15,16,34,62,27]),function(re,e,a,t,w,T,k,P,C,R,F,_,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function o(g,c,D){const v=g.getProxy(k.MainContext.MainThreadQuickOpen);class h{constructor(s,b){this._sessions=new Map,this._instances=0,this._workspace=s,this._commands=b}showQuickPick(s,b,y=t.CancellationToken.None){this._onDidSelectItem=void 0;const u=Promise.resolve(s),S=++this._instances,A=v.$show(S,{title:b?.title,placeHolder:b?.placeHolder,matchOnDescription:b?.matchOnDescription,matchOnDetail:b?.matchOnDetail,ignoreFocusLost:b?.ignoreFocusOut,canPickMany:b?.canPickMany},y),U={},H=A.then(()=>U);return Promise.race([H,u]).then(E=>{if(E!==U)return u.then(L=>{const z=[];for(let N=0;N<L.length;N++){const B=L[N];typeof B=="string"?z.push({label:B,handle:N}):B.kind===C.QuickPickItemKind.Separator?z.push({type:"separator",label:B.label}):z.push({label:B.label,description:B.description,detail:B.detail,picked:B.picked,alwaysShow:B.alwaysShow,handle:N})}return b&&typeof b.onDidSelectItem=="function"&&(this._onDidSelectItem=N=>{b.onDidSelectItem(L[N])}),v.$setItems(S,z),A.then(N=>{if(typeof N=="number")return L[N];if(Array.isArray(N))return N.map(B=>L[B])})})}).then(void 0,E=>{if(!(0,R.isPromiseCanceledError)(E))return v.$setError(S,E),Promise.reject(E)})}$onItemSelected(s){this._onDidSelectItem&&this._onDidSelectItem(s)}showInput(s,b=t.CancellationToken.None){return this._validateInput=s?s.validateInput:void 0,v.$input(s,typeof this._validateInput=="function",b).then(void 0,y=>{if(!(0,R.isPromiseCanceledError)(y))return Promise.reject(y)})}$validateInput(s){return this._validateInput?(0,a.asPromise)(()=>this._validateInput(s)):Promise.resolve(void 0)}async showWorkspaceFolderPick(s,b=t.CancellationToken.None){const y=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!y)return;const u=await this._workspace.getWorkspaceFolders2();if(!!u)return u.find(S=>S.uri.toString()===y.uri.toString())}createQuickPick(s){const b=new i(s,()=>this._sessions.delete(b._id));return this._sessions.set(b._id,b),b}createInputBox(s){const b=new m(s,()=>this._sessions.delete(b._id));return this._sessions.set(b._id,b),b}$onDidChangeValue(s,b){const y=this._sessions.get(s);y&&y._fireDidChangeValue(b)}$onDidAccept(s){const b=this._sessions.get(s);b&&b._fireDidAccept()}$onDidChangeActive(s,b){const y=this._sessions.get(s);y instanceof i&&y._fireDidChangeActive(b)}$onDidChangeSelection(s,b){const y=this._sessions.get(s);y instanceof i&&y._fireDidChangeSelection(b)}$onDidTriggerButton(s,b){const y=this._sessions.get(s);y&&y._fireDidTriggerButton(b)}$onDidTriggerItemButton(s,b,y){const u=this._sessions.get(s);u instanceof i&&u._fireDidTriggerItemButton(b,y)}$onDidHide(s){const b=this._sessions.get(s);b&&b._fireDidHide()}}class p{constructor(s,b){this._extensionId=s,this._onDidDispose=b,this._id=i._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new w.Emitter,this._onDidChangeValueEmitter=new w.Emitter,this._onDidTriggerButtonEmitter=new w.Emitter,this._onDidHideEmitter=new w.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(s){this._title=s,this.update({title:s})}get step(){return this._steps}set step(s){this._steps=s,this.update({step:s})}get totalSteps(){return this._totalSteps}set totalSteps(s){this._totalSteps=s,this.update({totalSteps:s})}get enabled(){return this._enabled}set enabled(s){this._enabled=s,this.update({enabled:s})}get busy(){return this._busy}set busy(s){this._busy=s,this.update({busy:s})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(s){this._ignoreFocusOut=s,this.update({ignoreFocusOut:s})}get value(){return this._value}set value(s){this._value=s,this.update({value:s})}get placeholder(){return this._placeholder}set placeholder(s){this._placeholder=s,this.update({placeholder:s})}get buttons(){return this._buttons}set buttons(s){this._buttons=s.slice(),this._handlesToButtons.clear(),s.forEach((b,y)=>{const u=b===C.QuickInputButtons.Back?-1:y;this._handlesToButtons.set(u,b)}),this.update({buttons:s.map((b,y)=>({...r(b),tooltip:b.tooltip,handle:b===C.QuickInputButtons.Back?-1:y}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(s){this._value=s,this._onDidChangeValueEmitter.fire(s)}_fireDidTriggerButton(s){const b=this._handlesToButtons.get(s);b&&this._onDidTriggerButtonEmitter.fire(b)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),v.$dispose(this._id))}update(s){if(!this._disposed){for(const b of Object.keys(s)){const y=s[b];this._pendingUpdate[b]=y===void 0?null:y}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){v.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}p._nextId=1;function I(d){if(d instanceof C.ThemeIcon)return{id:d.id};const s=M(d),b=l(d);return{dark:typeof s=="string"?P.URI.file(s):s,light:typeof b=="string"?P.URI.file(b):b}}function l(d){return typeof d=="object"&&"light"in d?d.light:d}function M(d){return typeof d=="object"&&"dark"in d?d.dark:d}function r(d){const s=I(d.iconPath);let b,y;return"id"in s?y=n.ThemeIcon.asClassName(s):b=s,{iconPath:b,iconClass:y}}class i extends p{constructor(s,b){super(s.identifier,b);this.extension=s,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new w.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new w.Emitter,this._onDidTriggerItemButtonEmitter=new w.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(s){s.some(y=>y.kind!==void 0)&&(0,f.checkProposedApiEnabled)(this.extension,"quickPickSeparators"),this._items=s.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),s.forEach((y,u)=>{this._handlesToItems.set(u,y),this._itemsToHandles.set(y,u)});const b=[];for(let y=0;y<s.length;y++){const u=s[y];u.kind===C.QuickPickItemKind.Separator?b.push({type:"separator",label:u.label}):b.push({handle:y,label:u.label,description:u.description,detail:u.detail,picked:u.picked,alwaysShow:u.alwaysShow,buttons:u.buttons?.map((S,A)=>({...r(S),tooltip:S.tooltip,handle:A}))})}this.update({items:b})}get canSelectMany(){return this._canSelectMany}set canSelectMany(s){this._canSelectMany=s,this.update({canSelectMany:s})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(s){this._matchOnDescription=s,this.update({matchOnDescription:s})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(s){this._matchOnDetail=s,this.update({matchOnDetail:s})}get sortByLabel(){return this._sortByLabel}set sortByLabel(s){this._sortByLabel=s,this.update({sortByLabel:s})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(s){this._keepScrollPosition=s,this.update({keepScrollPosition:s})}get activeItems(){return this._activeItems}set activeItems(s){this._activeItems=s.filter(b=>this._itemsToHandles.has(b)),this.update({activeItems:this._activeItems.map(b=>this._itemsToHandles.get(b))})}get selectedItems(){return this._selectedItems}set selectedItems(s){this._selectedItems=s.filter(b=>this._itemsToHandles.has(b)),this.update({selectedItems:this._selectedItems.map(b=>this._itemsToHandles.get(b))})}_fireDidChangeActive(s){const b=(0,F.coalesce)(s.map(y=>this._handlesToItems.get(y)));this._activeItems=b,this._onDidChangeActiveEmitter.fire(b)}_fireDidChangeSelection(s){const b=(0,F.coalesce)(s.map(y=>this._handlesToItems.get(y)));this._selectedItems=b,this._onDidChangeSelectionEmitter.fire(b)}_fireDidTriggerItemButton(s,b){const y=this._handlesToItems.get(s);if(!y||!y.buttons||!y.buttons.length)return;const u=y.buttons[b];u&&this._onDidTriggerItemButtonEmitter.fire({button:u,item:y})}}class m extends p{constructor(s,b){super(s,b);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(s){this._password=s,this.update({password:s})}get prompt(){return this._prompt}set prompt(s){this._prompt=s,this.update({prompt:s})}get validationMessage(){return this._validationMessage}set validationMessage(s){this._validationMessage=s,this.update({validationMessage:s,severity:s?_.default.Error:_.default.Ignore})}}return new h(c,D)}e.createExtHostQuickOpen=o}),define(Ee[199],ye([0,1,2,4,52,6,14,5,16,105,12,25,62,8,27]),function(re,e,a,t,w,T,k,P,C,R,F,_,n,f,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function g(d){if(d)return typeof d.iconPath=="string"?a.URI.file(d.iconPath):a.URI.isUri(d.iconPath)||n.ThemeIcon.isThemeIcon(d.iconPath)?d.iconPath:void 0}function c(d,s){if(!d.iconPath&&!s.iconPath)return 0;if(d.iconPath){if(!s.iconPath)return 1}else return-1;const b=typeof d.iconPath=="string"?d.iconPath:a.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id,y=typeof s.iconPath=="string"?s.iconPath:a.URI.isUri(s.iconPath)?s.iconPath.fsPath:s.iconPath.id;return(0,R.comparePaths)(b,y)}function D(d,s){let b=0;if(d.strikeThrough!==s.strikeThrough)return d.strikeThrough?1:-1;if(d.faded!==s.faded)return d.faded?1:-1;if(d.tooltip!==s.tooltip)return(d.tooltip||"").localeCompare(s.tooltip||"");if(b=c(d,s),b!==0)return b;if(d.light&&s.light)b=c(d.light,s.light);else{if(d.light)return 1;if(s.light)return-1}if(b!==0)return b;if(d.dark&&s.dark)b=c(d.dark,s.dark);else{if(d.dark)return 1;if(s.dark)return-1}return b}function v(d,s){if(d.command!==s.command)return d.command<s.command?-1:1;if(d.title!==s.title)return d.title<s.title?-1:1;if(d.tooltip!==s.tooltip){if(d.tooltip!==void 0&&s.tooltip!==void 0)return d.tooltip<s.tooltip?-1:1;if(d.tooltip!==void 0)return 1;if(s.tooltip!==void 0)return-1}if(d.arguments===s.arguments)return 0;if(d.arguments)if(s.arguments){if(d.arguments.length!==s.arguments.length)return d.arguments.length-s.arguments.length}else return 1;else return-1;for(let b=0;b<d.arguments.length;b++){const y=d.arguments[b],u=s.arguments[b];if(y!==u)return y<u?-1:1}return 0}function h(d,s){let b=(0,R.comparePaths)(d.resourceUri.fsPath,s.resourceUri.fsPath,!0);if(b!==0)return b;if(d.command&&s.command)b=v(d.command,s.command);else{if(d.command)return 1;if(s.command)return-1}if(b!==0)return b;if(d.decorations&&s.decorations)b=D(d.decorations,s.decorations);else{if(d.decorations)return 1;if(s.decorations)return-1}return b}function p(d,s){for(let b=0;b<d.length;b++)if(d[b]!==s[b])return!1;return!0}function I(d,s){return d.command===s.command&&d.title===s.title&&d.tooltip===s.tooltip&&(d.arguments&&s.arguments?p(d.arguments,s.arguments):d.arguments===s.arguments)}function l(d,s){return(0,C.equals)(d,s,I)}class M{constructor(s,b,y){this._extension=s,this._proxy=b,this._sourceControlHandle=y,this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(s){s=s??"",this._proxy.$setInputBoxValue(this._sourceControlHandle,s),this.updateValue(s)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(s){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,s),this._placeholder=s}get validateInput(){return(0,o.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(s){if((0,o.checkProposedApiEnabled)(this._extension,"scmValidation"),s&&typeof s!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=s,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!s)}get visible(){return this._visible}set visible(s){s=!!s,this._visible!==s&&(this._visible=s,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,s))}showValidationMessage(s,b){(0,o.checkProposedApiEnabled)(this._extension,"scmValidation"),this._proxy.$showValidationMessage(this._sourceControlHandle,s,b)}$onInputBoxValueChange(s){this.updateValue(s)}updateValue(s){this._value=s,this._onDidChange.fire(s)}}e.ExtHostSCMInputBox=M;class r{constructor(s,b,y,u,S){this._proxy=s,this._commands=b,this._sourceControlHandle=y,this._id=u,this._label=S,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(s){this._label=s,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,s)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(s){this._hideWhenEmpty=s,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(s){this._resourceStates=[...s],this._onDidUpdateResourceStates.fire()}getResourceState(s){return this._resourceStatesMap.get(s)}$executeResourceCommand(s,b){const y=this._resourceStatesCommandsMap.get(s);return y?(0,k.asPromise)(()=>this._commands.executeCommand(y.command,...y.arguments||[],b)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const s=[...this._resourceStates].sort(h),y=(0,C.sortedDiff)(this._resourceSnapshot,s,h).map(A=>{const U=A.toInsert.map(H=>{const E=this._resourceHandlePool++;this._resourceStatesMap.set(E,H);const L=H.resourceUri;let z;if(H.command)if(H.command.command==="vscode.open"||H.command.command==="vscode.diff"){const we=new T.DisposableStore;z=this._commands.converter.toInternal(H.command,we),this._resourceStatesDisposablesMap.set(E,we)}else this._resourceStatesCommandsMap.set(E,H.command);const N=g(H.decorations),B=H.decorations&&g(H.decorations.light)||N,j=H.decorations&&g(H.decorations.dark)||N,ce=[B,j],K=H.decorations&&H.decorations.tooltip||"",le=H.decorations&&!!H.decorations.strikeThrough,ue=H.decorations&&!!H.decorations.faded,Y=H.contextValue||"";return{rawResource:[E,L,ce,K,le,ue,Y,z],handle:E}});return{start:A.start,deleteCount:A.deleteCount,toInsert:U}}),u=y.map(({start:A,deleteCount:U,toInsert:H})=>[A,U,H.map(E=>E.rawResource)]),S=y.reverse();for(const{start:A,deleteCount:U,toInsert:H}of S){const E=H.map(z=>z.handle),L=this._handlesSnapshot.splice(A,U,...E);for(const z of L)this._resourceStatesMap.delete(z),this._resourceStatesCommandsMap.delete(z),this._resourceStatesDisposablesMap.get(z)?.dispose(),this._resourceStatesDisposablesMap.delete(z)}return this._resourceSnapshot=s,u}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class i{constructor(s,b,y,u,S,A){this._extension=s,this._proxy=b,this._commands=y,this._id=u,this._label=S,this._rootUri=A,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new T.MutableDisposable,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new M(s,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,u,S,A)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(s){this._count!==s&&(this._count=s,this._proxy.$updateSourceControl(this.handle,{count:s}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(s){this._quickDiffProvider=s,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!s})}get commitTemplate(){return this._commitTemplate}set commitTemplate(s){s!==this._commitTemplate&&(this._commitTemplate=s,this._proxy.$updateSourceControl(this.handle,{commitTemplate:s}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(s){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=s;const b=this._commands.converter.toInternal(s,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:b})}get actionButton(){return(0,o.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(s){(0,o.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new T.DisposableStore,this._actionButton=s;const b=s!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:b??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(s){if(this._statusBarCommands&&s&&l(this._statusBarCommands,s))return;this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=s;const b=(s||[]).map(y=>this._commands.converter.toInternal(y,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:b})}get selected(){return this._selected}createResourceGroup(s,b){const y=new r(this._proxy,this._commands,this.handle,s,b),u=t.Event.once(y.onDidDispose)(()=>this.createdResourceGroups.delete(y));return this.createdResourceGroups.set(y,u),this.eventuallyAddResourceGroups(),y}eventuallyAddResourceGroups(){const s=[],b=[];for(const[y,u]of this.createdResourceGroups){u.dispose();const S=y.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(y),this.eventuallyUpdateResourceStates()});t.Event.once(y.onDidDispose)(()=>{this.updatedResourceGroups.delete(y),S.dispose(),this._groups.delete(y.handle),this._proxy.$unregisterGroup(this.handle,y.handle)}),s.push([y.handle,y.id,y.label,y.features]);const A=y._takeResourceStateSnapshot();A.length>0&&b.push([y.handle,A]),this._groups.set(y.handle,y)}this._proxy.$registerGroups(this.handle,s,b),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const s=[];this.updatedResourceGroups.forEach(b=>{const y=b._takeResourceStateSnapshot();y.length!==0&&s.push([b.handle,y])}),s.length>0&&this._proxy.$spliceResourceStates(this.handle,s),this.updatedResourceGroups.clear()}getResourceGroup(s){return this._groups.get(s)}setSelectionState(s){this._selected=s,this._onDidChangeSelection.fire(s)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(s=>s.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,Ue([(0,w.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),Ue([(0,w.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let m=class zi{constructor(s,b,y){this._commands=b,this.logService=y,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=s.getProxy(P.MainContext.MainThreadSCM),this._telemetry=s.getProxy(P.MainContext.MainThreadTelemetry),b.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===3){const S=this._sourceControls.get(u.sourceControlHandle);if(!S)return u;const A=S.getResourceGroup(u.groupHandle);return A?A.getResourceState(u.handle):u}else if(u&&u.$mid===4){const S=this._sourceControls.get(u.sourceControlHandle);return S?S.getResourceGroup(u.groupHandle):u}else if(u&&u.$mid===5){const S=this._sourceControls.get(u.handle);return S||u}return u}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(s,b,y,u){this.logService.trace("ExtHostSCM#createSourceControl",s.identifier.value,b,y,u),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:s.identifier.value});const S=zi._handlePool++,A=new i(s,this._proxy,this._commands,b,y,u);this._sourceControls.set(S,A);const U=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(s.identifier))||[];return U.push(A),this._sourceControlsByExtension.set(_.ExtensionIdentifier.toKey(s.identifier),U),A}getLastInputBox(s){this.logService.trace("ExtHostSCM#getLastInputBox",s.identifier.value);const b=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(s.identifier)),y=b&&b[b.length-1];return y&&y.inputBox}$provideOriginalResource(s,b,y){const u=a.URI.revive(b);this.logService.trace("ExtHostSCM#$provideOriginalResource",s,u.toString());const S=this._sourceControls.get(s);return!S||!S.quickDiffProvider||!S.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,k.asPromise)(()=>S.quickDiffProvider.provideOriginalResource(u,y)).then(A=>A||null)}$onInputBoxValueChange(s,b){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",s);const y=this._sourceControls.get(s);return y&&y.inputBox.$onInputBoxValueChange(b),Promise.resolve(void 0)}$executeResourceCommand(s,b,y,u){this.logService.trace("ExtHostSCM#$executeResourceCommand",s,b,y);const S=this._sourceControls.get(s);if(!S)return Promise.resolve(void 0);const A=S.getResourceGroup(b);return A?A.$executeResourceCommand(y,u):Promise.resolve(void 0)}$validateInput(s,b,y){this.logService.trace("ExtHostSCM#$validateInput",s);const u=this._sourceControls.get(s);return!u||!u.inputBox.validateInput?Promise.resolve(void 0):(0,k.asPromise)(()=>u.inputBox.validateInput(b,y)).then(S=>{if(!S)return Promise.resolve(void 0);const A=f.MarkdownString.fromStrict(S.message);return A?Promise.resolve([A,S.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(s){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",s),s!==void 0&&this._sourceControls.get(s)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=s,Promise.resolve(void 0)}};m._handlePool=0,m=Ue([$e(2,F.ILogService)],m),e.ExtHostSCM=m});var Ze=this&&this.__classPrivateFieldSet||function(re,e,a,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(re,a):w?w.value=a:e.set(re,a),a},Te=this&&this.__classPrivateFieldGet||function(re,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!t:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(re):t?t.value:e.get(re)};define(Ee[200],ye([0,1,7,5,122,6,8,11]),function(re,e,a,t,w,T,k,P){"use strict";var C,R;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class F{constructor(o,g,c,D,v=a.StatusBarAlignment.Left,h){C.set(this,void 0),R.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,Ze(this,C,o,"f"),Ze(this,R,g,"f"),this._entryId=F.ID_GEN++,this._extension=c,this._id=D,this._alignment=v,this._priority=this.validatePriority(h)}validatePriority(o){if(!!(0,P.isNumber)(o))return o===Number.POSITIVE_INFINITY?Number.MAX_VALUE:o===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:o}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(o){this._text=o,this.update()}set name(o){this._name=o,this.update()}set tooltip(o){this._tooltip=o,this.update()}set color(o){this._color=o,this.update()}set backgroundColor(o){o&&!F.ALLOWED_BACKGROUND_COLORS.has(o.id)&&(o=void 0),this._backgroundColor=o,this.update()}set command(o){this._command?.fromApi!==o&&(this._internalCommandRegistration.clear(),typeof o=="string"?this._command={fromApi:o,internal:Te(this,R,"f").toInternal({title:"",command:o},this._internalCommandRegistration)}:o?this._command={fromApi:o,internal:Te(this,R,"f").toInternal(o,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(o){this._accessibilityInformation=o,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Te(this,C,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let o;this._extension?this._id?o=`${this._extension.identifier.value}.${this._id}`:o=this._extension.identifier.value:o=this._id;let g;this._name?g=this._name:g=(0,w.localize)(0,null,this._extension.displayName||this._extension.name);let c=this._color;this._backgroundColor&&(c=F.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const D=this._tooltip?k.MarkdownString.fromStrict(this._tooltip):void 0;Te(this,C,"f").$setEntry(this._entryId,o,g,this._text,D,this._command?.internal,c,this._backgroundColor,this._alignment===a.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=F,C=new WeakMap,R=new WeakMap,F.ID_GEN=0,F.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new a.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new a.ThemeColor("statusBarItem.warningForeground")]]);class _{constructor(o){this._messages=[],this._item=o.createStatusBarEntry(void 0,"status.extensionMessage",a.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,w.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(o){const g={message:o};return this._messages.unshift(g),this._update(),new a.Disposable(()=>{const c=this._messages.indexOf(g);c>=0&&(this._messages.splice(c,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class n{constructor(o,g){this._proxy=o.getProxy(t.MainContext.MainThreadStatusBar),this._commands=g,this._statusMessage=new _(this)}createStatusBarEntry(o,g,c,D){return new F(this._proxy,this._commands,o,g,c,D)}setStatusBarMessage(o,g){const c=this._statusMessage.setMessage(o);let D;return typeof g=="number"?D=setTimeout(()=>c.dispose(),g):typeof g!="undefined"&&g.then(()=>c.dispose(),()=>c.dispose()),new a.Disposable(()=>{c.dispose(),clearTimeout(D)})}}e.ExtHostStatusBar=n}),define(Ee[71],ye([0,1,5,4,3]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(P){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(a.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,C){this._proxy.$registerExtensionStorageKeysToSync(P,C)}getValue(P,C,R){return this._proxy.$getValue(P,C).then(F=>F||R)}setValue(P,C,R){return this._proxy.$setValue(P,C,R)}$acceptValue(P,C,R){this._onDidChangeStorage.fire({shared:P,key:C,value:R})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,w.createDecorator)("IExtHostStorage")}),define(Ee[72],ye([0,1,3,28,12,49,2]),function(re,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,a.createDecorator)("IExtensionStoragePaths");let P=class{constructor(R,F,_){this._logService=F,this._extHostFileSystem=_,this._workspace=R.workspace??void 0,this._environment=R.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(n=>this._value=n)}async _getWorkspaceStorageURI(R){return k.URI.joinPath(this._environment.workspaceStorageHome,R)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const R=this._workspace.id,F=await this._getWorkspaceStorageURI(R);try{return await this._extHostFileSystem.value.stat(F),this._logService.trace("[ExtHostStorage] storage dir already exists",F),F}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",F),await this._extHostFileSystem.value.createDirectory(F),await this._extHostFileSystem.value.writeFile(k.URI.joinPath(F,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:k.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),F}catch(_){this._logService.error("[ExtHostStorage]",_);return}}workspaceValue(R){if(this._value)return k.URI.joinPath(this._value,R.identifier.value)}globalValue(R){return k.URI.joinPath(this._environment.globalStorageHome,R.identifier.value.toLowerCase())}onWillDeactivateAll(){}};P=Ue([$e(0,t.IExtHostInitDataService),$e(1,w.ILogService),$e(2,T.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(Ee[39],ye([0,1,4,5,3,2,13,6,7,123,15,162,20,35,145,62,11,14]),function(re,e,a,t,w,T,k,P,C,R,F,_,n,f,o,g,c,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,w.createDecorator)("IExtHostTerminalService");class v{constructor(d,s,b,y){this._proxy=d,this._id=s,this._creationOptions=b,this._name=y,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(S=>this._pidPromiseComplete=S);const u=this;this.value={get name(){return u._name||""},get processId(){return u._pidPromise},get creationOptions(){return u._creationOptions},get exitStatus(){return u._exitStatus},get state(){return u._state},sendText(S,A=!0){u._checkDisposed(),u._proxy.$sendText(u._id,S,A)},show(S){u._checkDisposed(),u._proxy.$show(u._id,S)},hide(){u._checkDisposed(),u._proxy.$hide(u._id)},dispose(){u._disposed||(u._disposed=!0,u._proxy.$dispose(u._id))},get dimensions(){if(!(u._cols===void 0||u._rows===void 0))return{columns:u._cols,rows:u._rows}}}}async create(d,s){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:d.name,shellPath:(0,c.withNullAsUndefined)(d.shellPath),shellArgs:(0,c.withNullAsUndefined)(d.shellArgs),cwd:(0,c.withNullAsUndefined)(d.cwd),env:(0,c.withNullAsUndefined)(d.env),icon:(0,c.withNullAsUndefined)(r(d.iconPath)),color:g.ThemeColor.isThemeColor(d.color)?d.color.id:void 0,initialText:(0,c.withNullAsUndefined)(d.message),strictEnv:(0,c.withNullAsUndefined)(d.strictEnv),hideFromUser:(0,c.withNullAsUndefined)(d.hideFromUser),isFeatureTerminal:(0,c.withNullAsUndefined)(s?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,c.withNullAsUndefined)(s?.useShellEnvironment),location:s?.location||this._serializeParentTerminal(d.location,s?.resolvedExtHostIdentifier),disablePersistence:(0,c.withNullAsUndefined)(d.disablePersistence)})}async createExtensionTerminal(d,s,b,y){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:b,color:g.ThemeColor.isThemeColor(y)?y.id:void 0,location:this._serializeParentTerminal(d,s),disablePersistence:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(d,s){return typeof d=="object"?"parentTerminal"in d&&d.parentTerminal&&s?{parentTerminal:s}:"viewColumn"in d?{viewColumn:d.viewColumn,preserveFocus:d.preserveFocus}:void 0:d}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(d){this._name=d}setExitCode(d){this._exitStatus=Object.freeze({code:d})}setDimensions(d,s){return d===this._cols&&s===this._rows||d===0||s===0?!1:(this._cols=d,this._rows=s,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(d){this._pidPromiseComplete?(this._pidPromiseComplete(d),this._pidPromiseComplete=void 0):this._pidPromise.then(s=>{s!==d&&(this._pidPromise=Promise.resolve(d))})}}e.ExtHostTerminal=v;class h{constructor(d){this._pty=d,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new a.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new a.Emitter,this._onDidChangeProperty=new a.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new a.Emitter,this.onProcessExit=this._onProcessExit.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}refreshProperty(d){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${d}`)}updateProperty(d,s){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${d}, value: ${s}`)}async start(){}shutdown(){this._pty.close()}input(d){this._pty.handleInput?.(d)}resize(d,s){this._pty.setDimensions?.({columns:d,rows:s})}async processBinary(d){}acknowledgeDataEvent(d){}async setUnicodeVersion(d){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(d){this._pty.onDidWrite(s=>this._onProcessData.fire(s)),this._pty.onDidClose?.((s=void 0)=>{this._onProcessExit.fire(s===void 0?void 0:s)}),this._pty.onDidOverrideDimensions?.(s=>{s&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:s.columns,rows:s.rows}})}),this._pty.onDidChangeName?.(s=>{this._onDidChangeProperty.fire({type:"title",value:s})}),this._pty.open(d||void 0),d&&this._pty.setDimensions?.(d),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=h;let p=1,I=class extends P.Disposable{constructor(d,s){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new a.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new a.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new a.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new a.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new a.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=s.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new o.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new a.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(d),this._register({dispose:()=>{for(const[b,y]of this._terminalProcesses)y.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(d=>d.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(d){return(d?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(d){return(d?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(d,s){const b=new v(this._proxy,(0,f.generateUuid)(),d,d.name),y=new h(d.pty);return b.createExtensionTerminal(d.location,this._serializeParentTerminal(d,s).resolvedExtHostIdentifier,r(d.iconPath),i(d.color)).then(u=>{const S=this._setupExtHostProcessListeners(u,y);this._terminalProcessDisposables[u]=S}),this._terminals.push(b),b.value}_serializeParentTerminal(d,s){if(s=s||{},d.location&&typeof d.location=="object"&&"parentTerminal"in d.location){const b=d.location.parentTerminal;if(b){const y=this._terminals.find(u=>u.value===b);y&&(s.resolvedExtHostIdentifier=y._id)}}else d.location&&typeof d.location!="object"?s.location=d.location:s.location&&typeof s.location=="object"&&"splitActiveTerminal"in s.location&&(s.location={splitActiveTerminal:!0});return s}attachPtyToTerminal(d,s){if(!this._getTerminalById(d))throw new Error(`Cannot resolve terminal with id ${d} for virtual process`);const y=new h(s),u=this._setupExtHostProcessListeners(d,y);this._terminalProcessDisposables[d]=u}async $acceptActiveTerminalChanged(d){const s=this._activeTerminal;if(d===null){this._activeTerminal=void 0,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const b=this._getTerminalById(d);b&&(this._activeTerminal=b,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(d,s){const b=this._getTerminalById(d);b&&this._onDidWriteTerminalData.fire({terminal:b.value,data:s})}async $acceptTerminalDimensions(d,s,b){const y=this._getTerminalById(d);y&&y.setDimensions(s,b)&&this._onDidChangeTerminalDimensions.fire({terminal:y.value,dimensions:y.value.dimensions})}async $acceptTerminalMaximumDimensions(d,s,b){this._terminalProcesses.get(d)?.resize(s,b)}async $acceptTerminalTitleChange(d,s){const b=this._getTerminalById(d);b&&(b.name=s)}async $acceptTerminalClosed(d,s){const b=this._getTerminalObjectIndexById(this._terminals,d);if(b!==null){const y=this._terminals.splice(b,1)[0];y.setExitCode(s),this._onDidCloseTerminal.fire(y.value)}}$acceptTerminalOpened(d,s,b,y){if(s){const A=this._getTerminalObjectIndexById(this._terminals,s);if(A!==null){this._terminals[A]._id=d,this._onDidOpenTerminal.fire(this.terminals[A]),this._terminals[A].isOpen=!0;return}}const u={name:y.name,shellPath:y.executable,shellArgs:y.args,cwd:typeof y.cwd=="string"?y.cwd:T.URI.revive(y.cwd),env:y.env,hideFromUser:y.hideFromUser},S=new v(this._proxy,d,u,b);this._terminals.push(S),this._onDidOpenTerminal.fire(S.value),S.isOpen=!0}async $acceptTerminalProcessId(d,s){const b=this._getTerminalById(d);b&&b._setProcessId(s)}async $startExtensionTerminal(d,s){const b=this._getTerminalById(d);if(!b)return{message:(0,R.localize)(0,null,d)};b.isOpen||await new Promise(u=>{const S=this.onDidOpenTerminal(async A=>{A===b.value&&(S.dispose(),u())})});const y=this._terminalProcesses.get(d);y?y.startSendingEvents(s):this._extensionTerminalAwaitingStart[d]={initialDimensions:s}}_setupExtHostProcessListeners(d,s){const b=new P.DisposableStore;b.add(s.onProcessReady(u=>this._proxy.$sendProcessReady(d,u.pid,u.cwd))),b.add(s.onDidChangeProperty(u=>this._proxy.$sendProcessProperty(d,u))),this._bufferer.startBuffering(d,s.onProcessData),b.add(s.onProcessExit(u=>this._onProcessExit(d,u))),this._terminalProcesses.set(d,s);const y=this._extensionTerminalAwaitingStart[d];return y&&s instanceof h&&(s.startSendingEvents(y.initialDimensions),delete this._extensionTerminalAwaitingStart[d]),b}$acceptProcessAckDataEvent(d,s){this._terminalProcesses.get(d)?.acknowledgeDataEvent(s)}$acceptProcessInput(d,s){this._terminalProcesses.get(d)?.input(s)}$acceptTerminalInteraction(d){const s=this._getTerminalById(d);s?.setInteractedWith()&&this._onDidChangeTerminalState.fire(s.value)}$acceptProcessResize(d,s,b){try{this._terminalProcesses.get(d)?.resize(s,b)}catch(y){if(y.code!=="EPIPE"&&y.code!=="ERR_IPC_CHANNEL_CLOSED")throw y}}$acceptProcessShutdown(d,s){this._terminalProcesses.get(d)?.shutdown(s)}$acceptProcessRequestInitialCwd(d){this._terminalProcesses.get(d)?.getInitialCwd().then(s=>this._proxy.$sendProcessProperty(d,{type:"initialCwd",value:s}))}$acceptProcessRequestCwd(d){this._terminalProcesses.get(d)?.getCwd().then(s=>this._proxy.$sendProcessProperty(d,{type:"cwd",value:s}))}$acceptProcessRequestLatency(d){return d}registerLinkProvider(d){return this._linkProviders.add(d),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new C.Disposable(()=>{this._linkProviders.delete(d),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(d,s,b){if(this._profileProviders.has(s))throw new Error(`Terminal profile provider "${s}" already registered`);return this._profileProviders.set(s,b),this._proxy.$registerProfileProvider(s,d.identifier.value),new C.Disposable(()=>{this._profileProviders.delete(s),this._proxy.$unregisterProfileProvider(s)})}async $createContributedProfileTerminal(d,s){const b=new n.CancellationTokenSource().token;let y=await this._profileProviders.get(d)?.provideTerminalProfile(b);if(!b.isCancellationRequested){if(y&&!("options"in y)&&(y={options:y}),!y||!("options"in y))throw new Error(`No terminal profile options provided for id "${d}"`);if("pty"in y.options){this.createExtensionTerminal(y.options,s);return}this.createTerminalFromOptions(y.options,s)}}async $provideLinks(d,s){const b=this._getTerminalById(d);if(!b)return[];this._terminalLinkCache.delete(d);const y=this._terminalLinkCancellationSource.get(d);y&&y.dispose(!0);const u=new n.CancellationTokenSource;this._terminalLinkCancellationSource.set(d,u);const S=[],A={terminal:b.value,line:s},U=[];for(const L of this._linkProviders)U.push(D.Promises.withAsyncBody(async z=>{u.token.onCancellationRequested(()=>z({provider:L,links:[]}));const N=await L.provideTerminalLinks(A,u.token)||[];u.token.isCancellationRequested||z({provider:L,links:N})}));const H=await Promise.all(U);if(u.token.isCancellationRequested)return[];const E=new Map;for(const L of H)L&&L.links.length>0&&S.push(...L.links.map(z=>{const N={id:p++,startIndex:z.startIndex,length:z.length,label:z.tooltip};return E.set(N.id,{provider:L.provider,link:z}),N}));return this._terminalLinkCache.set(d,E),S}$activateLink(d,s){const b=this._terminalLinkCache.get(d)?.get(s);!b||b.provider.handleTerminalLink(b.link)}_onProcessExit(d,s){this._bufferer.stopBuffering(d),this._terminalProcesses.delete(d),delete this._extensionTerminalAwaitingStart[d];const b=this._terminalProcessDisposables[d];b&&(b.dispose(),delete this._terminalProcessDisposables[d]),this._proxy.$sendProcessExit(d,s)}_getTerminalById(d){return this._getTerminalObjectById(this._terminals,d)}_getTerminalObjectById(d,s){const b=this._getTerminalObjectIndexById(d,s);return b!==null?d[b]:null}_getTerminalObjectIndexById(d,s){let b=null;return d.some((y,u)=>y._id===s?(b=u,!0):!1),b}getEnvironmentVariableCollection(d){let s=this._environmentVariableCollections.get(d.identifier.value);return s||(s=new l,this._setEnvironmentVariableCollection(d.identifier.value,s)),s}_syncEnvironmentVariableCollection(d,s){const b=(0,_.serializeEnvironmentVariableCollection)(s.map);this._proxy.$setEnvironmentVariableCollection(d,s.persistent,b.length===0?void 0:b)}$initEnvironmentVariableCollections(d){d.forEach(s=>{const b=s[0],y=new l(s[1]);this._setEnvironmentVariableCollection(b,y)})}$acceptDefaultProfile(d,s){this._defaultProfile=d,this._defaultAutomationProfile=s}_setEnvironmentVariableCollection(d,s){this._environmentVariableCollections.set(d,s),s.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(d,s)})}};I=Ue([$e(1,k.IExtHostRpcService)],I),e.BaseExtHostTerminalService=I;class l{constructor(d){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new a.Emitter,this.map=new Map(d)}get persistent(){return this._persistent}set persistent(d){this._persistent=d,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(d,s){this._setIfDiffers(d,{value:s,type:C.EnvironmentVariableMutatorType.Replace})}append(d,s){this._setIfDiffers(d,{value:s,type:C.EnvironmentVariableMutatorType.Append})}prepend(d,s){this._setIfDiffers(d,{value:s,type:C.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(d,s){const b=this.map.get(d);(!b||b.value!==s.value||b.type!==s.type)&&(this.map.set(d,s),this._onDidChangeCollection.fire())}get(d){return this.map.get(d)}forEach(d,s){this.map.forEach((b,y)=>d.call(s,y,b,this))}delete(d){this.map.delete(d),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=l;let M=class extends I{constructor(d){super(!1,d)}createTerminal(d,s,b){throw new F.NotSupportedError}createTerminalFromOptions(d,s){throw new F.NotSupportedError}};M=Ue([$e(0,k.IExtHostRpcService)],M),e.WorkerExtHostTerminalService=M;function r(m){if(!(!m||typeof m=="string"))return"id"in m?{id:m.id,color:m.color}:m}function i(m){return g.ThemeColor.isThemeColor(m)?m:void 0}});var Ze=this&&this.__classPrivateFieldSet||function(re,e,a,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(re,a):w?w.value=a:e.set(re,a),a},Te=this&&this.__classPrivateFieldGet||function(re,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!t:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(re):t?t.value:e.get(re)};define(Ee[201],ye([0,1,16,22,20,4,230,57,6,26,11,35,5,13,47,8,7,170,88,67]),function(re,e,a,t,w,T,k,P,C,R,F,_,n,f,o,g,c,D,v,h){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let I=class{constructor(A,U){this.resultsChangedEmitter=new T.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=A.getProxy(n.MainContext.MainThreadTesting),this.observer=new b(this.proxy),this.runTracker=new M(this.proxy),U.registerArgumentProcessor({processArgument:H=>H?.$mid===13?g.TestItem.toItemFromContext(H):H})}createTestController(A,U){if(this.controllers.has(A))throw new Error(`Attempt to insert a duplicate controller with ID "${A}"`);const H=new C.DisposableStore,E=H.add(new D.SingleUseTestCollection(A));E.root.label=U;const L=new Map,z=this.proxy,N={items:E.root.children,get label(){return U},set label(j){U=j,E.root.label=j,z.$updateControllerLabel(A,U)},get id(){return A},createRunProfile:(j,ce,K,le,ue)=>{let Y=(0,P.hash)(j);for(;L.has(Y);)Y++;const ie=new y(this.proxy,A,Y,j,ce,K,le,ue);return L.set(Y,ie),ie},createTestItem(j,ce,K){return new o.TestItemImpl(A,j,ce,K)},createTestRun:(j,ce,K=!0)=>this.runTracker.createTestRun(A,E,j,ce,K),set resolveHandler(j){E.resolveHandler=j},get resolveHandler(){return E.resolveHandler},dispose:()=>{H.dispose()}};N.createRunConfiguration=N.createRunProfile,z.$registerTestController(A,U),H.add((0,C.toDisposable)(()=>z.$unregisterTestController(A)));const B={controller:N,collection:E,profiles:L};return this.controllers.set(A,B),H.add((0,C.toDisposable)(()=>this.controllers.delete(A))),H.add(E.onDidGenerateDiff(j=>z.$publishDiff(A,j))),N}createTestObserver(){return this.observer.checkout()}async runTests(A,U=w.CancellationToken.None){const H=r(A);if(!H)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const E=this.controllers.get(H.controllerId);if(!E)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:A.include?.map(L=>L.id)??[E.collection.root.id],profileGroup:u[H.kind],profileId:H.profileId,controllerId:H.controllerId}],exclude:A.exclude?.map(L=>L.id)},U)}$provideFileCoverage(A,U,H){return(0,a.mapFind)(this.runTracker.trackers,L=>L.id===A?L.getCoverage(U):void 0)?.provideFileCoverage(H)??Promise.resolve([])}$resolveFileCoverage(A,U,H,E){return(0,a.mapFind)(this.runTracker.trackers,z=>z.id===A?z.getCoverage(U):void 0)?.resolveFileCoverage(H,E)??Promise.resolve([])}$configureRunProfile(A,U){this.controllers.get(A)?.profiles.get(U)?.configureHandler?.()}$publishTestResults(A){this.results=Object.freeze(A.map(U=>(0,R.deepFreeze)(g.TestResults.to(U))).concat(this.results).sort((U,H)=>H.completedAt-U.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(A,U){const H=this.controllers.get(h.TestId.fromString(A).controllerId)?.collection;H&&(await H.expand(A,U<0?1/0:U),H.flushDiff())}$acceptDiff(A){this.observer.applyDiff(A)}async $runControllerTests(A,U){const H=this.controllers.get(A.controllerId);if(!H)return;const{collection:E,profiles:L}=H,z=L.get(A.profileId);if(!z)return;const N=A.testIds.map(K=>E.tree.get(K)).filter(F.isDefined),B=A.excludeExtIds.map(K=>H.collection.tree.get(K)).filter(F.isDefined).filter(K=>N.some(le=>le.fullId.compare(K.fullId)===2));if(!N.length)return;const j=new c.TestRunRequest(N.some(K=>K.actual instanceof o.TestItemRootImpl)?void 0:N.map(K=>K.actual),B.map(K=>K.actual),z),ce=this.runTracker.prepareForMainThreadTestRun(j,i.fromInternal(A,H.collection),U);try{await z.runHandler(j,U)}finally{ce.isRunning&&!U.isCancellationRequested&&await T.Event.toPromise(ce.onEnd),ce.dispose()}}$cancelExtensionTestRun(A){A===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(A)}};I=Ue([$e(0,f.IExtHostRpcService)],I),e.ExtHostTesting=I;class l extends C.Disposable{constructor(A,U,H){super();this.dto=A,this.proxy=U,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new T.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new w.CancellationTokenSource(H)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:E}of this.tasks.values())E.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(A){return this.tasks.get(A)?.coverage}createRun(A){const U=this.dto.id,H=this.dto.controllerId,E=(0,_.generateUuid)(),L=new m(this.proxy,U,E),z=ce=>(K,...le)=>{if(B){console.warn(`Setting the state of test "${K.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(K)||(this.ensureTestIsKnown(K),ce(K,...le))},N=(ce,K)=>{const le=K instanceof Array?K.map(g.TestMessage.from):[g.TestMessage.from(K)];if(ce.uri&&ce.range){const ue={range:g.Range.from(ce.range),uri:ce.uri};for(const Y of le)Y.location=Y.location||ue}this.proxy.$appendTestMessagesInRun(U,E,h.TestId.fromExtHostTestItem(ce,H).toString(),le)};let B=!1;const j={isPersisted:this.dto.isPersisted,token:this.cts.token,name:A,get coverageProvider(){return L.coverageProvider},set coverageProvider(ce){L.coverageProvider=ce},enqueued:z(ce=>{this.proxy.$updateTestStateInRun(U,E,h.TestId.fromExtHostTestItem(ce,H).toString(),1)}),skipped:z(ce=>{this.proxy.$updateTestStateInRun(U,E,h.TestId.fromExtHostTestItem(ce,H).toString(),5)}),started:z(ce=>{this.proxy.$updateTestStateInRun(U,E,h.TestId.fromExtHostTestItem(ce,H).toString(),2)}),errored:z((ce,K,le)=>{N(ce,K),this.proxy.$updateTestStateInRun(U,E,h.TestId.fromExtHostTestItem(ce,H).toString(),6,le)}),failed:z((ce,K,le)=>{N(ce,K),this.proxy.$updateTestStateInRun(U,E,h.TestId.fromExtHostTestItem(ce,H).toString(),4,le)}),passed:z((ce,K)=>{this.proxy.$updateTestStateInRun(U,E,h.TestId.fromExtHostTestItem(ce,this.dto.controllerId).toString(),3,K)}),appendOutput:(ce,K,le)=>{B||(le&&(this.dto.isIncluded(le)?this.ensureTestIsKnown(le):le=void 0),this.proxy.$appendOutputToRun(U,E,t.VSBuffer.fromString(ce),K&&g.location.from(K),le&&h.TestId.fromExtHostTestItem(le,H).toString()))},end:()=>{B||(B=!0,this.proxy.$finishedTestRunTask(U,E),this.tasks.delete(E),this.isRunning||this.dispose())}};return this.tasks.set(E,{run:j,coverage:L}),this.proxy.$startedTestRunTask(U,{id:E,name:A,running:!0}),j}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(A){if(!(A instanceof o.TestItemImpl))throw new o.InvalidTestItemError(A.id);if(this.sharedTestIds.has(h.TestId.fromExtHostTestItem(A,this.dto.controllerId).toString()))return;const U=[],H=this.dto.colllection.root;for(;;){const E=g.TestItem.from(A);if(U.unshift(E),this.sharedTestIds.has(E.extId)||(this.sharedTestIds.add(E.extId),A===H))break;A=A.parent||H}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,U)}}class M{constructor(A){this.proxy=A,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(A,U,H){return this.getTracker(A,U,H)}cancelRunById(A){for(const U of this.tracked.values())if(U.id===A){U.dispose();return}}cancelAllRuns(){for(const A of this.tracked.values())A.dispose()}createTestRun(A,U,H,E,L){const z=this.tracked.get(H);if(z)return z.createRun(E);const N=i.fromPublic(A,U,H,L),B=r(H);this.proxy.$startedExtensionTestRun({controllerId:A,profile:B&&{group:u[B.kind],id:B.profileId},exclude:H.exclude?.map(ce=>ce.id)??[],id:N.id,include:H.include?.map(ce=>ce.id)??[U.root.id],persist:L});const j=this.getTracker(H,N);return j.onEnd(()=>this.proxy.$finishedExtensionTestRun(N.id)),j.createRun(E)}getTracker(A,U,H){const E=new l(U,this.proxy,H);return this.tracked.set(A,E),E.onEnd(()=>this.tracked.delete(A)),E}}e.TestRunCoordinator=M;const r=S=>{if(!!S.profile){if(!(S.profile instanceof y))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return S.profile}};class i{constructor(A,U,H,E,L,z){this.controllerId=A,this.id=U,this.isPersisted=L,this.colllection=z,this.includePrefix=H.map(N=>N+"\0"),this.excludePrefix=E.map(N=>N+"\0")}static fromPublic(A,U,H,E){return new i(A,(0,_.generateUuid)(),H.include?.map(L=>h.TestId.fromExtHostTestItem(L,A).toString())??[A],H.exclude?.map(L=>h.TestId.fromExtHostTestItem(L,A).toString())??[],E,U)}static fromInternal(A,U){return new i(A.controllerId,A.runId,A.testIds,A.excludeExtIds,!0,U)}isIncluded(A){const U=h.TestId.fromExtHostTestItem(A,this.controllerId).toString()+"\0";for(const H of this.excludePrefix)if(U===H||U.startsWith(H))return!1;for(const H of this.includePrefix)if(U===H||U.startsWith(H))return!0;return!1}}e.TestRunDto=i;class m{constructor(A,U,H){this.proxy=A,this.runId=U,this.taskId=H}set coverageProvider(A){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!A||(this._coverageProvider=A,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(A){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(A))());try{return(await this.fileCoverage)?.map(g.TestCoverage.fromFile)??[]}catch(U){throw this.fileCoverage=void 0,U}}async resolveFileCoverage(A,U){const H=await this.fileCoverage;let E=H?.[A];return!this._coverageProvider||!H||!E?[]:(E.detailedCoverage||(E=H[A]=await this._coverageProvider.resolveFileCoverage?.(E,U)??E),E.detailedCoverage?.map(g.TestCoverage.fromDetailed)??[])}}class d extends v.IncrementalChangeCollector{constructor(A){super();this.emitter=A,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(A){this.added.add(A)}update(A){Object.assign(A.revived,g.TestItem.toPlain(A.item)),this.added.has(A)||this.updated.add(A)}remove(A){if(this.added.has(A)){this.added.delete(A);return}if(this.updated.delete(A),A.parent&&this.alreadyRemoved.has(A.parent)){this.alreadyRemoved.add(A.item.extId);return}this.removed.add(A)}getChangeEvent(){const{added:A,updated:U,removed:H}=this;return{get added(){return[...A].map(E=>E.revived)},get updated(){return[...U].map(E=>E.revived)},get removed(){return[...H].map(E=>E.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class s extends v.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new T.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(A){return this.items.get(A)}getMirroredTestDataByReference(A){return this.items.get(A.id)}createItem(A,U){return{...A,revived:g.TestItem.toPlain(A.item),depth:U?U.depth+1:0,children:new Set}}createChangeCollector(){return new d(this.changeEmitter)}}e.MirroredTestCollection=s;class b{constructor(A){this.proxy=A}checkout(){this.current||(this.current=this.createObserverData());const A=this.current;return A.observers++,{onDidChangeTest:A.tests.onDidChangeTests,get tests(){return[...A.tests.rootTests].map(U=>U.revived)},dispose:(0,k.once)(()=>{--A.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(A){return this.current?.tests.getMirroredTestDataByReference(A)}applyDiff(A){this.current?.tests.apply(A)}createObserverData(){const A=new s;return this.proxy.$subscribeToDiffs(),{observers:0,tests:A}}}class y{constructor(A,U,H,E,L,z,N=!1,B=void 0){this.controllerId=U,this.profileId=H,this._label=E,this.kind=L,this.runHandler=z,this._isDefault=N,this._tag=B,p.set(this,void 0),Ze(this,p,A,"f");const j=u[L];if(typeof j!="number")throw new Error(`Unknown TestRunProfile.group ${L}`);Te(this,p,"f").$publishTestRunProfile({profileId:H,controllerId:U,tag:B?g.TestTag.namespace(this.controllerId,B.id):null,label:E,group:j,isDefault:N,hasConfigurationHandler:!1})}get label(){return this._label}set label(A){A!==this._label&&(this._label=A,Te(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:A}))}get isDefault(){return this._isDefault}set isDefault(A){A!==this._isDefault&&(this._isDefault=A,Te(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:A}))}get tag(){return this._tag}set tag(A){A?.id!==this._tag?.id&&(this._tag=A,Te(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:A?g.TestTag.namespace(this.controllerId,A.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(A){A!==this._configureHandler&&(this._configureHandler=A,Te(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!A}))}dispose(){Te(this,p,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=y,p=new WeakMap;const u={[c.TestRunProfileKind.Coverage]:8,[c.TestRunProfileKind.Debug]:4,[c.TestRunProfileKind.Run]:2}}),define(Ee[202],ye([0,1,4,16,5,92,8,7]),function(re,e,a,t,w,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class C{constructor(F,_){this._extHostDocumentsAndEditors=_,this._onDidChangeTextEditorSelection=new a.Emitter,this._onDidChangeTextEditorOptions=new a.Emitter,this._onDidChangeTextEditorVisibleRanges=new a.Emitter,this._onDidChangeTextEditorViewColumn=new a.Emitter,this._onDidChangeActiveTextEditor=new a.Emitter,this._onDidChangeVisibleTextEditors=new a.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=F.getProxy(w.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(n=>this._onDidChangeVisibleTextEditors.fire(n)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(n=>this._onDidChangeActiveTextEditor.fire(n))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(F){const _=this._extHostDocumentsAndEditors.allEditors();return F?_:_.map(n=>n.value)}async showTextDocument(F,_,n){let f;typeof _=="number"?f={position:k.ViewColumn.from(_),preserveFocus:n}:typeof _=="object"?f={position:k.ViewColumn.from(_.viewColumn),preserveFocus:_.preserveFocus,selection:typeof _.selection=="object"?k.Range.from(_.selection):void 0,pinned:typeof _.preview=="boolean"?!_.preview:void 0}:f={preserveFocus:!1};const o=await this._proxy.$tryShowTextDocument(F.uri,f),g=o&&this._extHostDocumentsAndEditors.getEditor(o);if(g)return g.value;throw o?new Error(`Could NOT open editor for "${F.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${F.uri.toString()}".`)}createTextEditorDecorationType(F,_){return new T.TextEditorDecorationType(this._proxy,F,_).value}$acceptEditorPropertiesChanged(F,_){const n=this._extHostDocumentsAndEditors.getEditor(F);if(!n)throw new Error("unknown text editor");if(_.options&&n._acceptOptions(_.options),_.selections){const f=_.selections.selections.map(k.Selection.to);n._acceptSelections(f)}if(_.visibleRanges){const f=t.coalesce(_.visibleRanges.map(k.Range.to));n._acceptVisibleRanges(f)}if(_.options&&this._onDidChangeTextEditorOptions.fire({textEditor:n.value,options:{..._.options,lineNumbers:k.TextEditorLineNumbersStyle.to(_.options.lineNumbers)}}),_.selections){const f=P.TextEditorSelectionChangeKind.fromValue(_.selections.source),o=_.selections.selections.map(k.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:n.value,selections:o,kind:f})}if(_.visibleRanges){const f=t.coalesce(_.visibleRanges.map(k.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:n.value,visibleRanges:f})}}$acceptEditorPositionData(F){for(const _ in F){const n=this._extHostDocumentsAndEditors.getEditor(_);if(!n)throw new Error("Unknown text editor");const f=k.ViewColumn.to(F[_]);n.value.viewColumn!==f&&(n._acceptViewColumn(f),this._onDidChangeTextEditorViewColumn.fire({textEditor:n.value,viewColumn:f}))}}getDiffInformation(F){return Promise.resolve(this._proxy.$getDiffInformation(F))}}e.ExtHostEditors=C}),define(Ee[203],ye([0,1,2,3,5,6,7]),function(re,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class P{constructor(F,_){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=F.getProxy(w.MainContext.MainThreadTimeline),_.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===11){const f=n.uri===void 0?void 0:a.URI.revive(n.uri);return this._itemsBySourceAndUriMap.get(n.source)?.get(C(f))?.get(n.handle)}return n}})}async $getTimeline(F,_,n,f,o){return this._providers.get(F)?.provideTimeline(a.URI.revive(_),n,f,o)}registerTimelineProvider(F,_,n,f){const o=new T.DisposableStore,g=this.convertTimelineItem(_.id,f,o).bind(this);let c;_.onDidChange&&(c=_.onDidChange(v=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...v,id:_.id}),this));const D=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({..._,scheme:F,onDidChange:void 0,async provideTimeline(v,h,p,I){I?.resetCache&&(o.clear(),D.get(_.id)?.clear());const l=await _.provideTimeline(v,h,p);if(l==null)return;const M=g(v,I);return{...l,source:_.id,items:l.items.map(M)}},dispose(){for(const v of D.values())v.get(_.id)?.clear();c?.dispose(),o.dispose()}})}convertTimelineItem(F,_,n){return(f,o)=>{let g;if(o?.cacheResults){let c=this._itemsBySourceAndUriMap.get(F);c===void 0&&(c=new Map,this._itemsBySourceAndUriMap.set(F,c));const D=C(f);g=c.get(D),g===void 0&&(g=new Map,c.set(D,g))}return c=>{const{iconPath:D,...v}=c,h=`${F}|${c.id??c.timestamp}`;g?.set(h,c);let p,I,l;return c.iconPath&&(D instanceof k.ThemeIcon?l={id:D.id,color:D.color}:a.URI.isUri(D)?(p=D,I=D):{light:p,dark:I}=D),{...v,id:v.id??void 0,handle:h,source:F,command:c.command?_.toInternal(c.command,n):void 0,icon:p,iconDark:I,themeIcon:l,accessibilityInformation:c.accessibilityInformation}}}}registerTimelineProviderCore(F){if(this._providers.get(F.id))throw new Error(`Timeline Provider ${F.id} already exists.`);return this._proxy.$registerTimelineProvider({id:F.id,label:F.label,scheme:F.scheme}),this._providers.set(F.id,F),(0,T.toDisposable)(()=>{for(const n of this._itemsBySourceAndUriMap.values())n.get(F.id)?.clear();this._providers.delete(F.id),this._proxy.$unregisterTimelineProvider(F.id),F.dispose()})}}e.ExtHostTimeline=P;function C(R){return R?.toString()}}),define(Ee[204],ye([0,1,6,10,2,5]),function(re,e,a,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class k{constructor(C){this._openers=new Map,this._proxy=C.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(C,R,F,_){if(this._openers.has(R))throw new Error(`Opener with id '${R}' already registered`);const n=_.schemes.find(f=>!k.supportedSchemes.has(f));if(n)throw new Error(`Scheme '${n}' is not supported. Only http and https are currently supported.`);return this._openers.set(R,F),this._proxy.$registerUriOpener(R,_.schemes,C,_.label),(0,a.toDisposable)(()=>{this._openers.delete(R),this._proxy.$unregisterUriOpener(R)})}async $canOpenUri(C,R,F){const _=this._openers.get(C);if(!_)throw new Error(`Unknown opener with id: ${C}`);const n=w.URI.revive(R);return _.canOpenExternalUri(n,F)}async $openUri(C,R,F){const _=this._openers.get(C);if(!_)throw new Error(`Unknown opener id: '${C}'`);return _.openExternalUri(w.URI.revive(R.resolvedUri),{sourceUri:w.URI.revive(R.sourceUri)},F)}}e.ExtHostUriOpeners=k,k.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(Ee[205],ye([0,1,5,2,6,15,25]),function(re,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(R){this.handles=new Set,this.handlers=new Map,this._proxy=R.getProxy(a.MainContext.MainThreadUrls)}registerUriHandler(R,F){if(this.handles.has(k.ExtensionIdentifier.toKey(R)))throw new Error(`Protocol handler already registered for extension ${R}`);const _=P.HandlePool++;return this.handles.add(k.ExtensionIdentifier.toKey(R)),this.handlers.set(_,F),this._proxy.$registerUriHandler(_,R),(0,w.toDisposable)(()=>{this.handles.delete(k.ExtensionIdentifier.toKey(R)),this.handlers.delete(_),this._proxy.$unregisterUriHandler(_)})}$handleExternalUri(R,F){const _=this.handlers.get(R);if(!_)return Promise.resolve(void 0);try{_.handleUri(t.URI.revive(F))}catch(n){(0,T.onUnexpectedError)(n)}return Promise.resolve(void 0)}async createAppUri(R){return t.URI.revive(await this._proxy.$createAppUri(R))}}e.ExtHostUrls=P,P.HandlePool=0});var Ze=this&&this.__classPrivateFieldSet||function(re,e,a,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(re,a):w?w.value=a:e.set(re,a),a},Te=this&&this.__classPrivateFieldGet||function(re,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!t:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(re):t?t.value:e.get(re)};define(Ee[50],ye([0,1,4,10,2,132,152,66,5]),function(re,e,a,t,w,T,k,P,C){"use strict";var R,F,_,n,f,o,g,c,D,v,h,p;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class I{constructor(b,y,u,S,A,U,H){R.set(this,void 0),F.set(this,void 0),_.set(this,void 0),n.set(this,void 0),f.set(this,void 0),o.set(this,void 0),g.set(this,""),c.set(this,void 0),D.set(this,!1),v.set(this,!1),h.set(this,!1),this._onMessageEmitter=new a.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,p.set(this,new a.Emitter),this._onDidDispose=Te(this,p,"f").event,Ze(this,R,b,"f"),Ze(this,F,y,"f"),Ze(this,c,u,"f"),Ze(this,n,S,"f"),Ze(this,f,A,"f"),Ze(this,o,U,"f"),Ze(this,h,l(U),"f"),Ze(this,_,H,"f")}dispose(){Ze(this,D,!0,"f"),Te(this,p,"f").fire(),Te(this,p,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(b){return Ze(this,v,!0,"f"),(0,P.asWebviewUri)(b,Te(this,n,"f").remote)}get cspSource(){const b=Te(this,o,"f").extensionLocation;if(b.scheme===t.Schemas.https||b.scheme===t.Schemas.http){let y=b.toString();return y.endsWith("/")||(y+="/"),y+" "+P.webviewGenericCspSource}return P.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Te(this,g,"f")}set html(b){this.assertNotDisposed(),Te(this,g,"f")!==b&&(Ze(this,g,b,"f"),!Te(this,v,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(b)&&(Ze(this,v,!0,"f"),Te(this,_,"f").report("Webview vscode-resource: uris",Te(this,o,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Te(this,F,"f").$setHtml(Te(this,R,"f"),b))}get options(){return this.assertNotDisposed(),Te(this,c,"f")}set options(b){this.assertNotDisposed(),Te(this,F,"f").$setOptions(Te(this,R,"f"),i(Te(this,o,"f"),Te(this,f,"f"),b)),Ze(this,c,b,"f")}async postMessage(b){if(Te(this,D,"f"))return!1;const y=(0,k.serializeWebviewMessage)(b,{serializeBuffersForPostMessage:Te(this,h,"f")});return Te(this,F,"f").$postMessage(Te(this,R,"f"),y.message,...y.buffers)}assertNotDisposed(){if(Te(this,D,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=I,R=new WeakMap,F=new WeakMap,_=new WeakMap,n=new WeakMap,f=new WeakMap,o=new WeakMap,g=new WeakMap,c=new WeakMap,D=new WeakMap,v=new WeakMap,h=new WeakMap,p=new WeakMap;function l(s){try{const b=(0,T.normalizeVersion)((0,T.parseVersion)(s.engines.vscode));return!!b&&b.majorBase>=1&&b.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=l;class M{constructor(b,y,u,S,A){this.initData=y,this.workspace=u,this._logService=S,this._deprecationService=A,this._webviews=new Map,this._webviewProxy=b.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(b,y,u){const S=this.getWebview(b);if(S){const{message:A}=(0,k.deserializeWebviewMessage)(y,u.value);S._onMessageEmitter.fire(A)}}$onMissingCsp(b,y){this._logService.warn(`${y} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(b,y,u){const S=new I(b,this._webviewProxy,m(y),this.initData,this.workspace,u,this._deprecationService);return this._webviews.set(b,S),S._onDidDispose(()=>{this._webviews.delete(b)}),S}deleteWebview(b){this._webviews.delete(b)}getWebview(b){return this._webviews.get(b)}}e.ExtHostWebviews=M;function r(s){return{id:s.identifier,location:s.extensionLocation}}e.toExtensionData=r;function i(s,b,y){return{enableCommandUris:y.enableCommandUris,enableScripts:y.enableScripts,enableForms:y.enableForms,portMapping:y.portMapping,localResourceRoots:y.localResourceRoots||d(s,b)}}e.serializeWebviewOptions=i;function m(s){return{enableCommandUris:s.enableCommandUris,enableScripts:s.enableScripts,enableForms:s.enableForms,portMapping:s.portMapping,localResourceRoots:s.localResourceRoots?.map(b=>w.URI.from(b))}}e.reviveOptions=m;function d(s,b){return[...(b?.getWorkspaceFolders()||[]).map(y=>y.uri),s.extensionLocation]}}),define(Ee[206],ye([0,1,20,57,6,10,24,2,8,50,63,5,7]),function(re,e,a,t,w,T,k,P,C,R,F,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class f{constructor(l,M){this.document=l,this._storagePath=M,this._backupCounter=1,this._edits=new F.Cache("custom documents")}addEdit(l){return this._edits.add([l])}async undo(l,M){await this.getEdit(l).undo(),M||this.disposeBackup()}async redo(l,M){await this.getEdit(l).redo(),M||this.disposeBackup()}disposeEdits(l){for(const M of l)this._edits.delete(M)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const l=p(this.document.uri)+this._backupCounter++;return(0,k.joinPath)(this._storagePath,l)}updateBackup(l){this._backup?.delete(),this._backup=l}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(l){const M=this._edits.get(l,0);if(!M)throw new Error("No edit found");return M}}class o{constructor(){this._documents=new Map}get(l,M){return this._documents.get(this.key(l,M))}add(l,M,r){const i=this.key(l,M.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${l} resource:${M.uri}`);const m=new f(M,r);return this._documents.set(i,m),m}delete(l,M){const r=this.key(l,M.uri);this._documents.delete(r)}key(l,M){return`${l}@@@${M}`}}var g;(function(I){I[I.Text=0]="Text",I[I.Custom=1]="Custom"})(g||(g={}));class c{constructor(){this._providers=new Map}addTextProvider(l,M,r){return this.add(0,l,M,r)}addCustomProvider(l,M,r){return this.add(1,l,M,r)}get(l){return this._providers.get(l)}add(l,M,r,i){if(this._providers.has(M))throw new Error(`Provider for viewType:${M} already registered`);return this._providers.set(M,{type:l,extension:r,provider:i}),new n.Disposable(()=>this._providers.delete(M))}}class D{constructor(l,M,r,i,m){this._extHostDocuments=M,this._extensionStoragePaths=r,this._extHostWebview=i,this._extHostWebviewPanels=m,this._editorProviders=new c,this._documents=new o,this._proxy=l.getProxy(_.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(l,M,r,i){const m=new w.DisposableStore;return v(r)?(m.add(this._editorProviders.addTextProvider(M,l,r)),this._proxy.$registerTextEditorProvider((0,R.toExtensionData)(l),M,i.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,R.shouldSerializeBuffersForPostMessage)(l))):(m.add(this._editorProviders.addCustomProvider(M,l,r)),this.supportEditing(r)&&m.add(r.onDidChangeCustomDocument(d=>{const s=this.getCustomDocumentEntry(M,d.document.uri);if(h(d)){const b=s.addEdit(d);this._proxy.$onDidEdit(d.document.uri,M,b,d.label)}else this._proxy.$onContentChange(d.document.uri,M)})),this._proxy.$registerCustomEditorProvider((0,R.toExtensionData)(l),M,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,R.shouldSerializeBuffersForPostMessage)(l))),n.Disposable.from(m,new n.Disposable(()=>{this._proxy.$unregisterEditorProvider(M)}))}async $createCustomDocument(l,M,r,i,m){const d=this._editorProviders.get(M);if(!d)throw new Error(`No provider found for '${M}'`);if(d.type!==1)throw new Error(`Invalid provide type for '${M}'`);const s=P.URI.revive(l),b=await d.provider.openCustomDocument(s,{backupId:r,untitledDocumentData:i?.buffer},m);let y;return this.supportEditing(d.provider)&&this._extensionStoragePaths&&(y=this._extensionStoragePaths.workspaceValue(d.extension)??this._extensionStoragePaths.globalValue(d.extension)),this._documents.add(M,b,y),{editable:this.supportEditing(d.provider)}}async $disposeCustomDocument(l,M){const r=this._editorProviders.get(M);if(!r)throw new Error(`No provider found for '${M}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${M}'`);const i=P.URI.revive(l),{document:m}=this.getCustomDocumentEntry(M,i);this._documents.delete(M,m),m.dispose()}async $resolveWebviewEditor(l,M,r,i,m,d){const s=this._editorProviders.get(r);if(!s)throw new Error(`No provider found for '${r}'`);const b=C.ViewColumn.to(m),y=this._extHostWebview.createNewWebview(M,i.webviewOptions,s.extension),u=this._extHostWebviewPanels.createNewWebviewPanel(M,r,i.title,b,i.panelOptions,y),S=P.URI.revive(l);switch(s.type){case 1:{const{document:A}=this.getCustomDocumentEntry(r,S);return s.provider.resolveCustomEditor(A,u,d)}case 0:{const A=this._extHostDocuments.getDocument(S);return s.provider.resolveCustomTextEditor(A,u,d)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(l,M,r){this.getCustomDocumentEntry(M,l).disposeEdits(r)}async $onMoveCustomEditor(l,M,r){const i=this._editorProviders.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const m=this._extHostWebviewPanels.getWebviewPanel(l);if(!m)throw new Error("No webview found");const d=P.URI.revive(M),s=this._extHostDocuments.getDocument(d);await i.provider.moveCustomTextEditor(s,m,a.CancellationToken.None)}async $undo(l,M,r,i){return this.getCustomDocumentEntry(M,l).undo(r,i)}async $redo(l,M,r,i){return this.getCustomDocumentEntry(M,l).redo(r,i)}async $revert(l,M,r){const i=this.getCustomDocumentEntry(M,l);await this.getCustomEditorProvider(M).revertCustomDocument(i.document,r),i.disposeBackup()}async $onSave(l,M,r){const i=this.getCustomDocumentEntry(M,l);await this.getCustomEditorProvider(M).saveCustomDocument(i.document,r),i.disposeBackup()}async $onSaveAs(l,M,r,i){const m=this.getCustomDocumentEntry(M,l);return this.getCustomEditorProvider(M).saveCustomDocumentAs(m.document,P.URI.revive(r),i)}async $backup(l,M,r){const i=this.getCustomDocumentEntry(M,l),d=await this.getCustomEditorProvider(M).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},r);return i.updateBackup(d),d.id}getCustomDocumentEntry(l,M){const r=this._documents.get(l,P.URI.revive(M));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(l){const r=this._editorProviders.get(l)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(l){return!!l.onDidChangeCustomDocument}}e.ExtHostCustomEditors=D;function v(I){return typeof I.resolveCustomTextEditor=="function"}function h(I){return typeof I.undo=="function"&&typeof I.redo=="function"}function p(I){const l=I.scheme===T.Schemas.file||I.scheme===T.Schemas.untitled?I.fsPath:I.toString();return(0,t.hash)(l)+""}});var Ze=this&&this.__classPrivateFieldSet||function(re,e,a,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(re,a):w?w.value=a:e.set(re,a),a},Te=this&&this.__classPrivateFieldGet||function(re,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!t:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(re):t?t.value:e.get(re)};define(Ee[207],ye([0,1,4,6,2,35,8,50,5,7]),function(re,e,a,t,w,T,k,P,C,R){"use strict";var F,_,n,f,o,g,c,D,v,h,p,I,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class M extends t.Disposable{constructor(d,s,b,y,u,S,A){super();F.set(this,void 0),_.set(this,void 0),n.set(this,void 0),f.set(this,void 0),o.set(this,void 0),g.set(this,void 0),c.set(this,void 0),D.set(this,void 0),v.set(this,!0),h.set(this,!0),p.set(this,!1),I.set(this,this._register(new a.Emitter)),this.onDidDispose=Te(this,I,"f").event,l.set(this,this._register(new a.Emitter)),this.onDidChangeViewState=Te(this,l,"f").event,Ze(this,F,d,"f"),Ze(this,_,s,"f"),Ze(this,n,b,"f"),Ze(this,o,S,"f"),Ze(this,D,u,"f"),Ze(this,g,y,"f"),Ze(this,f,A,"f")}dispose(){Te(this,p,"f")||(Ze(this,p,!0,"f"),Te(this,I,"f").fire(),Te(this,_,"f").$disposeWebview(Te(this,F,"f")),Te(this,f,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Te(this,f,"f")}get viewType(){return this.assertNotDisposed(),Te(this,n,"f")}get title(){return this.assertNotDisposed(),Te(this,g,"f")}set title(d){this.assertNotDisposed(),Te(this,g,"f")!==d&&(Ze(this,g,d,"f"),Te(this,_,"f").$setTitle(Te(this,F,"f"),d))}get iconPath(){return this.assertNotDisposed(),Te(this,c,"f")}set iconPath(d){this.assertNotDisposed(),Te(this,c,"f")!==d&&(Ze(this,c,d,"f"),Te(this,_,"f").$setIconPath(Te(this,F,"f"),w.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return Te(this,o,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Te(this,D,"f")=="number"&&Te(this,D,"f")<0))return Te(this,D,"f")}get active(){return this.assertNotDisposed(),Te(this,h,"f")}get visible(){return this.assertNotDisposed(),Te(this,v,"f")}_updateViewState(d){Te(this,p,"f")||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(Ze(this,h,d.active,"f"),Ze(this,v,d.visible,"f"),Ze(this,D,d.viewColumn,"f"),Te(this,l,"f").fire({webviewPanel:this}))}reveal(d,s){this.assertNotDisposed(),Te(this,_,"f").$reveal(Te(this,F,"f"),{viewColumn:d?k.ViewColumn.from(d):void 0,preserveFocus:!!s})}assertNotDisposed(){if(Te(this,p,"f"))throw new Error("Webview is disposed")}}F=new WeakMap,_=new WeakMap,n=new WeakMap,f=new WeakMap,o=new WeakMap,g=new WeakMap,c=new WeakMap,D=new WeakMap,v=new WeakMap,h=new WeakMap,p=new WeakMap,I=new WeakMap,l=new WeakMap;class r{constructor(d,s,b){this.webviews=s,this.workspace=b,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=d.getProxy(C.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(d,s,b,y,u={}){const S=typeof y=="object"?y.viewColumn:y,A={viewColumn:k.ViewColumn.from(S),preserveFocus:typeof y=="object"&&!!y.preserveFocus},U=(0,P.shouldSerializeBuffersForPostMessage)(d),H=r.newHandle();this._proxy.$createWebviewPanel((0,P.toExtensionData)(d),H,s,{title:b,panelOptions:i(u),webviewOptions:(0,P.serializeWebviewOptions)(d,this.workspace,u),serializeBuffersForPostMessage:U},A);const E=this.webviews.createNewWebview(H,u,d);return this.createNewWebviewPanel(H,s,b,S,u,E)}$onDidChangeWebviewPanelViewStates(d){const s=Object.keys(d);s.sort((b,y)=>{const u=d[b],S=d[y];return u.active?1:S.active?-1:+u.visible-+S.visible});for(const b of s){const y=this.getWebviewPanel(b);if(!y)continue;const u=d[b];y._updateViewState({active:u.active,visible:u.visible,viewColumn:k.ViewColumn.to(u.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this._webviewPanels.delete(d),this.webviews.deleteWebview(d)}registerWebviewPanelSerializer(d,s,b){if(this._serializers.has(s))throw new Error(`Serializer for '${s}' already registered`);return this._serializers.set(s,{serializer:b,extension:d}),this._proxy.$registerSerializer(s,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(d)}),new R.Disposable(()=>{this._serializers.delete(s),this._proxy.$unregisterSerializer(s)})}async $deserializeWebviewPanel(d,s,b,y){const u=this._serializers.get(s);if(!u)throw new Error(`No serializer found for '${s}'`);const{serializer:S,extension:A}=u,U=this.webviews.createNewWebview(d,b.webviewOptions,A),H=this.createNewWebviewPanel(d,s,b.title,y,b.panelOptions,U);await S.deserializeWebviewPanel(H,b.state)}createNewWebviewPanel(d,s,b,y,u,S){const A=new M(d,this._proxy,s,b,y,u,S);return this._webviewPanels.set(d,A),A}getWebviewPanel(d){return this._webviewPanels.get(d)}}e.ExtHostWebviewPanels=r;function i(m){return{enableFindWidget:m.enableFindWidget,retainContextWhenHidden:m.retainContextWhenHidden}}});var Ze=this&&this.__classPrivateFieldSet||function(re,e,a,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(re,a):w?w.value=a:e.set(re,a),a},Te=this&&this.__classPrivateFieldGet||function(re,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!t:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(re):t?t.value:e.get(re)};define(Ee[208],ye([0,1,4,6,50,5,7]),function(re,e,a,t,w,T,k){"use strict";var P,C,R,F,_,n,f,o,g,c;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class D extends t.Disposable{constructor(p,I,l,M,r,i){super();P.set(this,void 0),C.set(this,void 0),R.set(this,void 0),F.set(this,void 0),_.set(this,!1),n.set(this,void 0),f.set(this,void 0),o.set(this,void 0),g.set(this,this._register(new a.Emitter)),this.onDidChangeVisibility=Te(this,g,"f").event,c.set(this,this._register(new a.Emitter)),this.onDidDispose=Te(this,c,"f").event,Ze(this,R,l,"f"),Ze(this,f,M,"f"),Ze(this,P,p,"f"),Ze(this,C,I,"f"),Ze(this,F,r,"f"),Ze(this,n,i,"f")}dispose(){Te(this,_,"f")||(Ze(this,_,!0,"f"),Te(this,c,"f").fire(),Te(this,F,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Te(this,f,"f")}set title(p){this.assertNotDisposed(),Te(this,f,"f")!==p&&(Ze(this,f,p,"f"),Te(this,C,"f").$setWebviewViewTitle(Te(this,P,"f"),p))}get description(){return this.assertNotDisposed(),Te(this,o,"f")}set description(p){this.assertNotDisposed(),Te(this,o,"f")!==p&&(Ze(this,o,p,"f"),Te(this,C,"f").$setWebviewViewDescription(Te(this,P,"f"),p))}get visible(){return Te(this,n,"f")}get webview(){return Te(this,F,"f")}get viewType(){return Te(this,R,"f")}_setVisible(p){p===Te(this,n,"f")||Te(this,_,"f")||(Ze(this,n,p,"f"),Te(this,g,"f").fire())}show(p){this.assertNotDisposed(),Te(this,C,"f").$show(Te(this,P,"f"),!!p)}assertNotDisposed(){if(Te(this,_,"f"))throw new Error("Webview is disposed")}}P=new WeakMap,C=new WeakMap,R=new WeakMap,F=new WeakMap,_=new WeakMap,n=new WeakMap,f=new WeakMap,o=new WeakMap,g=new WeakMap,c=new WeakMap;class v{constructor(p,I){this._extHostWebview=I,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=p.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(p,I,l,M){if(this._viewProviders.has(I))throw new Error(`View provider for '${I}' already registered`);return this._viewProviders.set(I,{provider:l,extension:p}),this._proxy.$registerWebviewViewProvider((0,w.toExtensionData)(p),I,{retainContextWhenHidden:M?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new k.Disposable(()=>{this._viewProviders.delete(I),this._proxy.$unregisterWebviewViewProvider(I)})}async $resolveWebviewView(p,I,l,M,r){const i=this._viewProviders.get(I);if(!i)throw new Error(`No view provider found for '${I}'`);const{provider:m,extension:d}=i,s=this._extHostWebview.createNewWebview(p,{},d),b=new D(p,this._proxy,I,l,s,!0);this._webviewViews.set(p,b),await m.resolveWebviewView(b,{state:M},r)}async $onDidChangeWebviewViewVisibility(p,I){this.getWebviewView(p)._setVisible(I)}async $disposeWebviewView(p){const I=this.getWebviewView(p);this._webviewViews.delete(p),I.dispose(),this._extHostWebview.deleteWebview(p)}getWebviewView(p){const I=this._webviewViews.get(p);if(!I)throw new Error("No webview found");return I}}e.ExtHostWebviewViews=v}),define(Ee[95],ye([0,1,4,5,2,10,9,3,13]),function(re,e,a,t,w,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let R=class Wi{constructor(_){this._onDidChangeWindowState=new a.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Wi.InitialState,this._proxy=_.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(n=>this.$onDidChangeWindowFocus(n))}get state(){return this._state}$onDidChangeWindowFocus(_){_!==this._state.focused&&(this._state={...this._state,focused:_},this._onDidChangeWindowState.fire(this._state))}openUri(_,n){let f;if(typeof _=="string"){f=_;try{_=w.URI.parse(_)}catch{return Promise.reject(`Invalid uri - '${_}'`)}}return(0,k.isFalsyOrWhitespace)(_.scheme)?Promise.reject("Invalid scheme - cannot be empty"):_.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${_.scheme}'`):this._proxy.$openUri(_,f,n)}async asExternalUri(_,n){if((0,k.isFalsyOrWhitespace)(_.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this._proxy.$asExternalUri(_,n);return w.URI.from(f)}};R.InitialState={focused:!0},R=Ue([$e(0,C.IExtHostRpcService)],R),e.ExtHostWindow=R,e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(Ee[209],ye([0,1,14,22,20,15,4,6,106,176,37]),function(re,e,a,t,w,T,k,P,C,R,F){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function n(u,S){try{return JSON.stringify(u,S)}catch{return"null"}}const f="$$ref$$",o={[f]:-1};class g{constructor(S,A){this.jsonString=S,this.referencedBuffers=A}}function c(u,S=null,A=!1){const U=[];return{jsonString:(A?n:JSON.stringify)(u,(E,L)=>{if(typeof L=="undefined")return o;if(typeof L=="object"){if(L instanceof t.VSBuffer){const z=U.push(L)-1;return{[f]:z}}if(S)return S(E,L)}return L}),referencedBuffers:U}}e.stringifyJsonWithBufferRefs=c;function D(u,S,A){return JSON.parse(u,(U,H)=>{if(H){const E=H[f];if(typeof E=="number")return S[E];if(A&&H.$mid===1)return A.transformIncoming(H)}return H})}e.parseJsonAndRestoreBufferRefs=D;function v(u,S){return JSON.stringify(u,S)}function h(u){return u?(S,A)=>A&&A.$mid===1?u.transformOutgoing(A):A:null}var p;(function(u){u[u.LocalSide=0]="LocalSide",u[u.OtherSide=1]="OtherSide"})(p=e.RequestInitiator||(e.RequestInitiator={}));var I;(function(u){u[u.Responsive=0]="Responsive",u[u.Unresponsive=1]="Unresponsive"})(I=e.ResponsiveState||(e.ResponsiveState={}));const l=()=>{},M=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class i extends P.Disposable{constructor(S,A=null,U=null){super();this[_]=!0,this._onDidChangeResponsiveState=this._register(new k.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=S,this._logger=A,this._uriTransformer=U,this._uriReplacer=h(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let H=0,E=F.ProxyIdentifier.count;H<E;H++)this._locals[H]=null,this._proxies[H]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new a.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(H=>this._receiveOneMessage(H))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(S=>{this._pendingRPCReplies[S].resolveErr(T.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(S){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(S){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(S){this._responsiveState!==S&&(this._responsiveState=S,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(S){return this._uriTransformer?(0,C.transformIncomingURIs)(S,this._uriTransformer):S}getProxy(S){const{nid:A,sid:U}=S;return this._proxies[A]||(this._proxies[A]=this._createProxy(A,U)),this._proxies[A]}_createProxy(S,A){let U={get:(H,E)=>(typeof E=="string"&&!H[E]&&E.charCodeAt(0)===36&&(H[E]=(...L)=>this._remoteCall(S,E,L)),E===r?A:H[E])};return new Proxy(Object.create(null),U)}set(S,A){return this._locals[S.nid]=A,A}assertRegistered(S){for(let A=0,U=S.length;A<U;A++){const H=S[A];if(!this._locals[H.nid])throw new Error(`Missing actor ${H.sid} (isMain: ${H.isMain})`)}}_receiveOneMessage(S){if(this._isDisposed)return;const A=S.byteLength,U=m.read(S,0),H=U.readUInt8(),E=U.readUInt32();switch(H){case 1:case 2:{let{rpcId:L,method:z,args:N}=s.deserializeRequestJSONArgs(U);this._uriTransformer&&(N=(0,C.transformIncomingURIs)(N,this._uriTransformer)),this._receiveRequest(A,E,L,z,N,H===2);break}case 3:case 4:{let{rpcId:L,method:z,args:N}=s.deserializeRequestMixedArgs(U);this._uriTransformer&&(N=(0,C.transformIncomingURIs)(N,this._uriTransformer)),this._receiveRequest(A,E,L,z,N,H===4);break}case 5:{this._logger&&this._logger.logIncoming(A,E,0,"ack"),this._onDidReceiveAcknowledge(E);break}case 6:{this._receiveCancel(A,E);break}case 7:{this._receiveReply(A,E,void 0);break}case 9:{let L=s.deserializeReplyOKJSON(U);this._uriTransformer&&(L=(0,C.transformIncomingURIs)(L,this._uriTransformer)),this._receiveReply(A,E,L);break}case 10:{const L=s.deserializeReplyOKJSONWithBuffers(U,this._uriTransformer);this._receiveReply(A,E,L);break}case 8:{let L=s.deserializeReplyOKVSBuffer(U);this._receiveReply(A,E,L);break}case 11:{let L=s.deserializeReplyErrError(U);this._uriTransformer&&(L=(0,C.transformIncomingURIs)(L,this._uriTransformer)),this._receiveReplyErr(A,E,L);break}case 12:{this._receiveReplyErr(A,E,void 0);break}default:console.error("received unexpected message"),console.error(S)}}_receiveRequest(S,A,U,H,E,L){this._logger&&this._logger.logIncoming(S,A,1,`receiveRequest ${(0,F.getStringIdentifierForProxy)(U)}.${H}(`,E);const z=String(A);let N,B;if(L){const ce=new w.CancellationTokenSource;E.push(ce.token),N=this._invokeHandler(U,H,E),B=()=>ce.cancel()}else N=this._invokeHandler(U,H,E),B=l;this._cancelInvokedHandlers[z]=B;const j=s.serializeAcknowledged(A);this._logger&&this._logger.logOutgoing(j.byteLength,A,1,"ack"),this._protocol.send(j),N.then(ce=>{delete this._cancelInvokedHandlers[z];const K=s.serializeReplyOK(A,ce,this._uriReplacer);this._logger&&this._logger.logOutgoing(K.byteLength,A,1,"reply:",ce),this._protocol.send(K)},ce=>{delete this._cancelInvokedHandlers[z];const K=s.serializeReplyErr(A,ce);this._logger&&this._logger.logOutgoing(K.byteLength,A,1,"replyErr:",ce),this._protocol.send(K)})}_receiveCancel(S,A){this._logger&&this._logger.logIncoming(S,A,1,"receiveCancel");const U=String(A);this._cancelInvokedHandlers[U]&&this._cancelInvokedHandlers[U]()}_receiveReply(S,A,U){this._logger&&this._logger.logIncoming(S,A,0,"receiveReply:",U);const H=String(A);if(!this._pendingRPCReplies.hasOwnProperty(H))return;const E=this._pendingRPCReplies[H];delete this._pendingRPCReplies[H],E.resolveOk(U)}_receiveReplyErr(S,A,U){this._logger&&this._logger.logIncoming(S,A,0,"receiveReplyErr:",U);const H=String(A);if(!this._pendingRPCReplies.hasOwnProperty(H))return;const E=this._pendingRPCReplies[H];delete this._pendingRPCReplies[H];let L;U&&(U.$isError?(L=new Error,L.name=U.name,L.message=U.message,L.stack=U.stack):L=U),E.resolveErr(L)}_invokeHandler(S,A,U){try{return Promise.resolve(this._doInvokeHandler(S,A,U))}catch(H){return Promise.reject(H)}}_doInvokeHandler(S,A,U){const H=this._locals[S];if(!H)throw new Error("Unknown actor "+(0,F.getStringIdentifierForProxy)(S));let E=H[A];if(typeof E!="function")throw new Error("Unknown method "+A+" on actor "+(0,F.getStringIdentifierForProxy)(S));return E.apply(H,U)}_remoteCall(S,A,U){if(this._isDisposed)return Promise.reject(T.canceled());let H=null;if(U.length>0&&w.CancellationToken.isCancellationToken(U[U.length-1])&&(H=U.pop()),H&&H.isCancellationRequested)return Promise.reject(T.canceled());const E=s.serializeRequestArguments(U,this._uriReplacer),L=++this._lastMessageId,z=String(L),N=new R.LazyPromise;H&&H.onCancellationRequested(()=>{const j=s.serializeCancel(L);this._logger&&this._logger.logOutgoing(j.byteLength,L,0,"cancel"),this._protocol.send(s.serializeCancel(L))}),this._pendingRPCReplies[z]=N,this._onWillSendRequest(L);const B=s.serializeRequest(L,S,A,E,!!H);return this._logger&&this._logger.logOutgoing(B.byteLength,L,0,`request: ${(0,F.getStringIdentifierForProxy)(S)}.${A}(`,U),this._protocol.send(B),N}}e.RPCProtocol=i,_=M,i.UNRESPONSIVE_TIME=3*1e3;class m{constructor(S,A){this._buff=S,this._offset=A}static alloc(S,A,U){let H=new m(t.VSBuffer.alloc(U+1+4),0);return H.writeUInt8(S),H.writeUInt32(A),H}static read(S,A){return new m(S,A)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(S){this._buff.writeUInt8(S,this._offset),this._offset+=1}readUInt8(){const S=this._buff.readUInt8(this._offset);return this._offset+=1,S}writeUInt32(S){this._buff.writeUInt32BE(S,this._offset),this._offset+=4}readUInt32(){const S=this._buff.readUInt32BE(this._offset);return this._offset+=4,S}static sizeShortString(S){return 1+S.byteLength}writeShortString(S){this._buff.writeUInt8(S.byteLength,this._offset),this._offset+=1,this._buff.set(S,this._offset),this._offset+=S.byteLength}readShortString(){const S=this._buff.readUInt8(this._offset);this._offset+=1;const U=this._buff.slice(this._offset,this._offset+S).toString();return this._offset+=S,U}static sizeLongString(S){return 4+S.byteLength}writeLongString(S){this._buff.writeUInt32BE(S.byteLength,this._offset),this._offset+=4,this._buff.set(S,this._offset),this._offset+=S.byteLength}readLongString(){const S=this._buff.readUInt32BE(this._offset);this._offset+=4;const U=this._buff.slice(this._offset,this._offset+S).toString();return this._offset+=S,U}writeBuffer(S){this._buff.writeUInt32BE(S.byteLength,this._offset),this._offset+=4,this._buff.set(S,this._offset),this._offset+=S.byteLength}static sizeVSBuffer(S){return 4+S.byteLength}writeVSBuffer(S){this._buff.writeUInt32BE(S.byteLength,this._offset),this._offset+=4,this._buff.set(S,this._offset),this._offset+=S.byteLength}readVSBuffer(){const S=this._buff.readUInt32BE(this._offset);this._offset+=4;const A=this._buff.slice(this._offset,this._offset+S);return this._offset+=S,A}static sizeMixedArray(S){let A=0;A+=1;for(let U=0,H=S.length;U<H;U++){const E=S[U];switch(A+=1,E.type){case 1:A+=this.sizeLongString(E.value);break;case 2:A+=this.sizeVSBuffer(E.value);break;case 3:A+=this.sizeUInt32,A+=this.sizeLongString(E.value);for(let L=0;L<E.buffers.length;++L)A+=this.sizeVSBuffer(E.buffers[L]);break;case 4:break}}return A}writeMixedArray(S){this._buff.writeUInt8(S.length,this._offset),this._offset+=1;for(let A=0,U=S.length;A<U;A++){const H=S[A];switch(H.type){case 1:this.writeUInt8(1),this.writeLongString(H.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(H.value);break;case 3:this.writeUInt8(3),this.writeUInt32(H.buffers.length),this.writeLongString(H.value);for(let E=0;E<H.buffers.length;++E)this.writeBuffer(H.buffers[E]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const S=this._buff.readUInt8(this._offset);this._offset+=1;let A=new Array(S);for(let U=0;U<S;U++)switch(this.readUInt8()){case 1:A[U]=this.readLongString();break;case 2:A[U]=this.readVSBuffer();break;case 3:{const E=this.readUInt32(),L=this.readLongString(),z=[];for(let N=0;N<E;++N)z.push(this.readVSBuffer());A[U]=new F.SerializableObjectWithBuffers(D(L,z,null));break}case 4:A[U]=void 0;break}return A}}m.sizeUInt32=4;var d;(function(u){u[u.Simple=0]="Simple",u[u.Mixed=1]="Mixed"})(d||(d={}));class s{static _useMixedArgSerialization(S){for(let A=0,U=S.length;A<U;A++)if(S[A]instanceof t.VSBuffer||S[A]instanceof F.SerializableObjectWithBuffers||typeof S[A]=="undefined")return!0;return!1}static serializeRequestArguments(S,A){if(this._useMixedArgSerialization(S)){const U=[];for(let H=0,E=S.length;H<E;H++){const L=S[H];if(L instanceof t.VSBuffer)U[H]={type:2,value:L};else if(typeof L=="undefined")U[H]={type:4};else if(L instanceof F.SerializableObjectWithBuffers){const{jsonString:z,referencedBuffers:N}=c(L.value,A);U[H]={type:3,value:t.VSBuffer.fromString(z),buffers:N}}else U[H]={type:1,value:t.VSBuffer.fromString(v(L,A))}}return{type:1,args:U}}return{type:0,args:v(S,A)}}static serializeRequest(S,A,U,H,E){switch(H.type){case 0:return this._requestJSONArgs(S,A,U,H.args,E);case 1:return this._requestMixedArgs(S,A,U,H.args,E)}}static _requestJSONArgs(S,A,U,H,E){const L=t.VSBuffer.fromString(U),z=t.VSBuffer.fromString(H);let N=0;N+=m.sizeUInt8(),N+=m.sizeShortString(L),N+=m.sizeLongString(z);let B=m.alloc(E?2:1,S,N);return B.writeUInt8(A),B.writeShortString(L),B.writeLongString(z),B.buffer}static deserializeRequestJSONArgs(S){const A=S.readUInt8(),U=S.readShortString(),H=S.readLongString();return{rpcId:A,method:U,args:JSON.parse(H)}}static _requestMixedArgs(S,A,U,H,E){const L=t.VSBuffer.fromString(U);let z=0;z+=m.sizeUInt8(),z+=m.sizeShortString(L),z+=m.sizeMixedArray(H);let N=m.alloc(E?4:3,S,z);return N.writeUInt8(A),N.writeShortString(L),N.writeMixedArray(H),N.buffer}static deserializeRequestMixedArgs(S){const A=S.readUInt8(),U=S.readShortString(),H=S.readMixedArray(),E=new Array(H.length);for(let L=0,z=H.length;L<z;L++){const N=H[L];typeof N=="string"?E[L]=JSON.parse(N):E[L]=N}return{rpcId:A,method:U,args:E}}static serializeAcknowledged(S){return m.alloc(5,S,0).buffer}static serializeCancel(S){return m.alloc(6,S,0).buffer}static serializeReplyOK(S,A,U){if(typeof A=="undefined")return this._serializeReplyOKEmpty(S);if(A instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(S,A);if(A instanceof F.SerializableObjectWithBuffers){const{jsonString:H,referencedBuffers:E}=c(A.value,U,!0);return this._serializeReplyOKJSONWithBuffers(S,H,E)}else return this._serializeReplyOKJSON(S,n(A,U))}static _serializeReplyOKEmpty(S){return m.alloc(7,S,0).buffer}static _serializeReplyOKVSBuffer(S,A){let U=0;U+=m.sizeVSBuffer(A);let H=m.alloc(8,S,U);return H.writeVSBuffer(A),H.buffer}static deserializeReplyOKVSBuffer(S){return S.readVSBuffer()}static _serializeReplyOKJSON(S,A){const U=t.VSBuffer.fromString(A);let H=0;H+=m.sizeLongString(U);let E=m.alloc(9,S,H);return E.writeLongString(U),E.buffer}static _serializeReplyOKJSONWithBuffers(S,A,U){const H=t.VSBuffer.fromString(A);let E=0;E+=m.sizeUInt32,E+=m.sizeLongString(H);for(const z of U)E+=m.sizeVSBuffer(z);let L=m.alloc(10,S,E);L.writeUInt32(U.length),L.writeLongString(H);for(const z of U)L.writeBuffer(z);return L.buffer}static deserializeReplyOKJSON(S){const A=S.readLongString();return JSON.parse(A)}static deserializeReplyOKJSONWithBuffers(S,A){const U=S.readUInt32(),H=S.readLongString(),E=[];for(let L=0;L<U;++L)E.push(S.readVSBuffer());return new F.SerializableObjectWithBuffers(D(H,E,A))}static serializeReplyErr(S,A){return A?this._serializeReplyErrEror(S,A):this._serializeReplyErrEmpty(S)}static _serializeReplyErrEror(S,A){const U=t.VSBuffer.fromString(n(T.transformErrorForSerialization(A),null));let H=0;H+=m.sizeLongString(U);let E=m.alloc(11,S,H);return E.writeLongString(U),E.buffer}static deserializeReplyErrError(S){const A=S.readLongString();return JSON.parse(A)}static _serializeReplyErrEmpty(S){return m.alloc(12,S,0).buffer}}var b;(function(u){u[u.RequestJSONArgs=1]="RequestJSONArgs",u[u.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",u[u.RequestMixedArgs=3]="RequestMixedArgs",u[u.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",u[u.Acknowledged=5]="Acknowledged",u[u.Cancel=6]="Cancel",u[u.ReplyOKEmpty=7]="ReplyOKEmpty",u[u.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",u[u.ReplyOKJSON=9]="ReplyOKJSON",u[u.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",u[u.ReplyErrError=11]="ReplyErrError",u[u.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var y;(function(u){u[u.String=1]="String",u[u.VSBuffer=2]="VSBuffer",u[u.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",u[u.Undefined=4]="Undefined"})(y||(y={}))}),define(Ee[210],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const a=function(T){const k=P=>{self.removeEventListener("message",k);const C=P.data;Object.defineProperties(self,{postMessage:{value(R,F){C.postMessage(R,F)}},onmessage:{get(){return C.onmessage},set(R){C.onmessage=R}}}),C.addEventListener("message",R=>{self.dispatchEvent(new MessageEvent("message",{data:R.data}))}),C.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};self.addEventListener("message",k)}.toString();class t extends EventTarget{constructor(T,k,P){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const C=`((${a})('${k}'))`,R=new Blob([C],{type:"application/javascript"}),F=URL.createObjectURL(R),_=new MessageChannel,n=F,f={type:"_newWorker",id:n,port:_.port2,url:F,options:P};T(f,[_.port2]),this.postMessage=_.port1.postMessage.bind(_.port1),this.terminate=()=>{const o={type:"_terminateWorker",id:n};_.port1.postMessage(o),URL.revokeObjectURL(F),_.port1.close(),_.port2.close()},Object.defineProperties(this,{onmessage:{get(){return _.port1.onmessage},set(o){_.port1.onmessage=o}},onmessageerror:{get(){return _.port1.onmessageerror},set(o){_.port1.onmessageerror=o}}}),_.port1.addEventListener("messageerror",o=>{const g=new MessageEvent("messageerror",{data:o.data});this.dispatchEvent(g)}),_.port1.addEventListener("message",o=>{const g=new MessageEvent("message",{data:o.data});this.dispatchEvent(g)}),_.port1.start()}}e.NestedWorker=t}),define(Ee[211],ye([0,1,3]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,a.createDecorator)("remoteAgentService")}),define(Ee[212],ye([0,1,10,17,23,2,3,61,46,171,211]),function(re,e,a,t,w,T,k,P,C,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,k.createDecorator)("pathService");let _=class Vi{constructor(f,o,g,c){this.localUserHome=f,this.remoteAgentService=o,this.environmentService=g,this.contextService=c,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||w.OS)(),this.resolveUserHome=(async()=>{const D=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=D?.userHome||f})()}get defaultUriScheme(){return Vi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(f,o){if(f.remoteAuthority)return a.Schemas.vscodeRemote;const g=(0,P.getVirtualWorkspaceScheme)(o.getWorkspace());if(g)return g;const c=o.getWorkspace().folders[0];if(c)return c.uri.scheme;const D=o.getWorkspace().configuration;return D?D.scheme:a.Schemas.file}async userHome(f){return f?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(f=>f===1?t.win32:t.posix)}async fileURI(f){let o="";if(await this.resolveOS===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const c=f.indexOf("/",2);c===-1?(o=f.substring(2),f="/"):(o=f.substring(2,c),f=f.substring(c)||"/")}return T.URI.from({scheme:a.Schemas.file,authority:o,path:f,query:"",fragment:""})}};_=Ue([$e(1,F.IRemoteAgentService),$e(2,R.IWorkbenchEnvironmentService),$e(3,C.IWorkspaceContextService)],_),e.AbstractPathService=_}),define(Ee[96],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class a{constructor(k,P){this.line=k,this.character=P}isBefore(k){return!1}isBeforeOrEqual(k){return!1}isAfter(k){return!1}isAfterOrEqual(k){return!1}isEqual(k){return!1}compareTo(k){return 0}translate(k,P){return new a(0,0)}with(k){return new a(0,0)}}e.Position=a;class t{constructor(k,P,C,R){this.isEmpty=!1,this.isSingleLine=!1,this.start=new a(k,P),this.end=new a(C,R)}contains(k){return!1}isEqual(k){return!1}intersection(k){}union(k){return new t(0,0,0,0)}with(k){return new t(0,0,0,0)}}e.Range=t;var w;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(w=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ee[40],ye([0,1,16,29,26,42,9,3,17,15,96,11]),function(re,e,a,t,w,T,k,P,C,R,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return F.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const n="\u27EA ",f=" characters skipped \u27EB",o=(n.length+f.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var g;(function(j){j[j.file=0]="file",j[j.text=1]="text"})(g=e.SearchProviderType||(e.SearchProviderType={}));var c;(function(j){j[j.File=1]="File",j[j.Text=2]="Text"})(c=e.QueryType||(e.QueryType={}));function D(j){return!!j.preview}e.resultIsMatch=D;function v(j){return!!j.resource}e.isFileMatch=v;function h(j){return!!j.message}e.isProgressMessage=h;var p;(function(j){j[j.Normal=0]="Normal",j[j.NewSearchStarted=1]="NewSearchStarted"})(p=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class I{constructor(ce){this.resource=ce,this.results=[]}}e.FileMatch=I;class l{constructor(ce,K,le){this.ranges=K;const ue=Array.isArray(K)?K:[K];if(le&&le.matchLines===1&&M(ue)){ce=(0,k.getNLines)(ce,le.matchLines);let Y="",ie=0,we=0;const Me=Math.floor(le.charsPerLine/5),Re=[];for(const Be of ue){const Qe=Math.max(Be.startColumn-Me,0),Ke=Be.startColumn+le.charsPerLine;if(Qe>we+Me+o){const Xe=n+(Qe-we)+f;Y+=Xe+ce.slice(Qe,Ke),ie+=Qe-(we+Xe.length)}else Y+=ce.slice(we,Ke);Re.push(new i(0,Be.startColumn-ie,Be.endColumn-ie)),we=Ke}this.preview={text:Y,matches:Array.isArray(this.ranges)?Re:Re[0]}}else{const Y=Array.isArray(K)?K[0].startLineNumber:K.startLineNumber;this.preview={text:ce,matches:(0,a.mapArrayOrNot)(K,ie=>new r(ie.startLineNumber-Y,ie.startColumn,ie.endLineNumber-Y,ie.endColumn))}}}}e.TextSearchMatch=l;function M(j){const ce=j[0].startLineNumber;for(const K of j)if(K.startLineNumber!==ce||K.endLineNumber!==ce)return!1;return!0}class r{constructor(ce,K,le,ue){this.startLineNumber=ce,this.startColumn=K,this.endLineNumber=le,this.endColumn=ue}}e.SearchRange=r;class i extends r{constructor(ce,K,le){super(ce,K,ce,le)}}e.OneLineRange=i;var m;(function(j){j.Default="default",j.FileNames="fileNames",j.Type="type",j.Modified="modified",j.CountDescending="countDescending",j.CountAscending="countAscending"})(m=e.SearchSortOrder||(e.SearchSortOrder={}));function d(j,ce=!0){const K=j&&j.files&&j.files.exclude,le=ce&&j&&j.search&&j.search.exclude;if(!K&&!le)return;if(!K||!le)return K||le;let ue=Object.create(null);return ue=w.mixin(ue,w.deepClone(K)),ue=w.mixin(ue,w.deepClone(le),!0),ue}e.getExcludes=d;function s(j,ce){return j.excludePattern&&t.match(j.excludePattern,ce)?!1:j.includePattern||j.usingSearchPaths?j.includePattern&&t.match(j.includePattern,ce)?!0:j.usingSearchPaths?!!j.folderQueries&&j.folderQueries.some(K=>{const le=K.folder.fsPath;if(T.isEqualOrParent(ce,le)){const ue=C.relative(le,ce);return!K.includePattern||!!t.match(K.includePattern,ue)}else return!1}):!1:!0}e.pathIncludedInQuery=s;var b;(function(j){j[j.unknownEncoding=1]="unknownEncoding",j[j.regexParseError=2]="regexParseError",j[j.globParseError=3]="globParseError",j[j.invalidLiteral=4]="invalidLiteral",j[j.rgProcessError=5]="rgProcessError",j[j.other=6]="other",j[j.canceled=7]="canceled"})(b=e.SearchErrorCode||(e.SearchErrorCode={}));class y extends Error{constructor(ce,K){super(ce);this.code=K}}e.SearchError=y;function u(j){const ce=j.message;if((0,R.isPromiseCanceledError)(j))return new y(ce,b.canceled);try{const K=JSON.parse(ce);return new y(K.message,K.code)}catch{return new y(ce,b.other)}}e.deserializeSearchError=u;function S(j){const ce={message:j.message,code:j.code};return new Error(JSON.stringify(ce))}e.serializeSearchError=S;function A(j){return j.type==="error"?!0:j.type==="success"}e.isSerializedSearchComplete=A;function U(j){return j.type==="success"}e.isSerializedSearchSuccess=U;function H(j){return!!j.path}e.isSerializedFileMatch=H;function E(j,ce){const K=j.searchPath?j.searchPath:j.relativePath;return(0,k.fuzzyContains)(K,ce)}e.isFilePatternMatch=E;class L{constructor(ce){this.path=ce,this.results=[]}addMatch(ce){this.results.push(ce)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=L;function z(j,ce){const K={...j||{},...ce||{}};return Object.keys(K).filter(le=>{const ue=K[le];return typeof ue=="boolean"&&ue})}e.resolvePatternsForProvider=z;class N{constructor(ce,K){this._parsedIncludeExpression=null,this._excludeExpression={...ce.excludePattern||{},...K.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let le=ce.includePattern;K.includePattern&&(le?le={...le,...K.includePattern}:le=K.includePattern),le&&(this._parsedIncludeExpression=t.parse(le))}matchesExcludesSync(ce,K,le){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ce,K,le))}includedInQuerySync(ce,K,le){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ce,K,le)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ce,K,le))}includedInQuery(ce,K,le){const ue=this._parsedExcludeExpression(ce,K,le),Y=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ce,K,le):!0;return(0,_.isPromise)(ue)?ue.then(ie=>ie?!1:Y()):Y()}hasSiblingExcludeClauses(){return B(this._excludeExpression)}}e.QueryGlobTester=N;function B(j){for(const ce in j)if(typeof j[ce]!="boolean")return!0;return!1}}),define(Ee[31],ye([0,1,16,14,20,4,21,10,75,24,9,11,2,125,3,12,138,46,30,28,13,7,40,5]),function(re,e,a,t,w,T,k,P,C,R,F,_,n,f,o,g,c,D,v,h,p,I,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(S,A,U){return new R.ExtUri(H=>s(H,U)).isEqual(S,A)}function i(S,A,U){return r(S.uri,A.uri,U)?0:(0,F.compare)(S.uri.toString(),A.uri.toString())}function m(S,A,U){return S.index!==A.index?S.index<A.index?-1:1:r(S.uri,A.uri,U)?(0,F.compare)(S.name,A.name):(0,F.compare)(S.uri.toString(),A.uri.toString())}function d(S,A,U,H){const E=S.slice(0).sort((z,N)=>U(z,N,H)),L=A.slice(0).sort((z,N)=>U(z,N,H));return(0,a.delta)(E,L,(z,N)=>U(z,N,H))}function s(S,A){const U=A.getCapabilities(S.scheme);return!(U&&U&1024)}class b extends D.Workspace{constructor(A,U,H,E,L,z,N){super(A,H.map(B=>new D.WorkspaceFolder(B)),E,L,N);this._name=U,this._isUntitled=z,this._workspaceFolders=[],this._structure=k.TernarySearchTree.forUris(N),H.forEach(B=>{this._workspaceFolders.push(B),this._structure.set(B.uri,B)})}static toExtHostWorkspace(A,U,H,E){if(!A)return{workspace:null,added:[],removed:[]};const{id:L,name:z,folders:N,configuration:B,transient:j,isUntitled:ce}=A,K=[],le=U;U?N.forEach((we,Me)=>{const Re=n.URI.revive(we.uri),Be=b._findFolder(H||U,Re,E);Be?(Be.name=we.name,Be.index=we.index,K.push(Be)):K.push({uri:Re,name:we.name,index:Me})}):K.push(...N.map(({uri:we,name:Me,index:Re})=>({uri:n.URI.revive(we),name:Me,index:Re}))),K.sort((we,Me)=>we.index<Me.index?-1:1);const ue=new b(L,z,K,!!j,B?n.URI.revive(B):null,!!ce,we=>s(we,E)),{added:Y,removed:ie}=d(le?le.workspaceFolders:[],ue.workspaceFolders,i,E);return{workspace:ue,added:Y,removed:ie}}static _findFolder(A,U,H){for(let E=0;E<A.folders.length;E++){const L=A.workspaceFolders[E];if(r(L.uri,U,H))return L}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(A,U){return U&&this._structure.get(A)&&(A=(0,R.dirname)(A)),this._structure.findSubstr(A)}resolveWorkspaceFolder(A){return this._structure.get(A)}}let y=class{constructor(A,U,H,E){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new T.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=E,this._extHostFileSystemInfo=H,this._requestIdProvider=new C.Counter,this._barrier=new t.Barrier,this._proxy=A.getProxy(M.MainContext.MainThreadWorkspace),this._messageService=A.getProxy(M.MainContext.MainThreadMessageService);const L=U.workspace;this._confirmedWorkspace=L?new b(L.id,L.name,[],!!L.transient,L.configuration?n.URI.revive(L.configuration):null,!!L.isUntitled,z=>s(z,H)):void 0}$initializeWorkspace(A,U){this._trusted=U,this.$acceptWorkspaceData(A),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?n.URI.from({scheme:P.Schemas.untitled,path:(0,R.basename)((0,R.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(A,U,H,...E){const L=[];if(Array.isArray(E)&&E.forEach(ce=>{n.URI.isUri(ce.uri)&&!L.some(K=>r(K.uri,ce.uri,this._extHostFileSystemInfo))&&L.push({uri:ce.uri,name:ce.name||(0,R.basenameOrAuthority)(ce.uri)})}),this._unconfirmedWorkspace||[U,H].some(ce=>typeof ce!="number"||ce<0)||H===0&&L.length===0)return!1;const z=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(U+H>z.length)return!1;const N=z.slice(0);N.splice(U,H,...L.map(ce=>({uri:ce.uri,name:ce.name||(0,R.basenameOrAuthority)(ce.uri),index:void 0})));for(let ce=0;ce<N.length;ce++){const K=N[ce];if(N.some((le,ue)=>ue!==ce&&r(K.uri,le.uri,this._extHostFileSystemInfo)))return!1}N.forEach((ce,K)=>ce.index=K);const{added:B,removed:j}=d(z,N,m,this._extHostFileSystemInfo);if(B.length===0&&j.length===0)return!1;if(this._proxy){const ce=A.displayName||A.name;this._proxy.$updateWorkspaceFolders(ce,U,H,L).then(void 0,K=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(c.Severity.Error,(0,f.localize)(0,null,ce,K.toString()),{extension:A},[])})}return this.trySetWorkspaceFolders(N),!0}getWorkspaceFolder(A,U){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(A,U)}async getWorkspaceFolder2(A,U){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(A,U)}async resolveWorkspaceFolder(A){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(A)}getPath(){if(!this._actualWorkspace)return;const{folders:A}=this._actualWorkspace;if(A.length!==0)return A[0].uri.fsPath}getRelativePath(A,U){let H,E="";if(typeof A=="string"?(H=n.URI.file(A),E=A):typeof A!="undefined"&&(H=A,E=A.fsPath),!H)return E;const L=this.getWorkspaceFolder(H,!0);if(!L)return E;typeof U=="undefined"&&this._actualWorkspace&&(U=this._actualWorkspace.folders.length>1);let z=(0,R.relativePath)(L.uri,H);return U&&L.name&&(z=`${L.name}/${z}`),z}trySetWorkspaceFolders(A){this._actualWorkspace&&(this._unconfirmedWorkspace=b.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:A,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(A){const{workspace:U,added:H,removed:E}=b.toExtHostWorkspace(A,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=U||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:H,removed:E}))}findFiles(A,U,H,E,L=w.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${E.value}, entryPoint: findFiles`);let z;if(U===null?z=!1:U&&(typeof U=="string"?z=U:z=U.pattern),L&&L.isCancellationRequested)return Promise.resolve([]);const{includePattern:N,folder:B}=u(A);return this._proxy.$startFileSearch((0,_.withUndefinedAsNull)(N),(0,_.withUndefinedAsNull)(B),(0,_.withUndefinedAsNull)(z),(0,_.withUndefinedAsNull)(H),L).then(j=>Array.isArray(j)?j.map(ce=>n.URI.revive(ce)):[])}async findTextInFiles(A,U,H,E,L=w.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${E.value}, entryPoint: findTextInFiles`);const z=this._requestIdProvider.getNext(),N=typeof U.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:B,folder:j}=u(U.include),ce=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,K={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:N,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:B,excludePattern:ce},le=!1;if(this._activeSearchCallbacks[z]=ue=>{if(le)return;const Y=n.URI.revive(ue.resource);ue.results.forEach(ie=>{(0,l.resultIsMatch)(ie)?H({uri:Y,preview:{text:ie.preview.text,matches:(0,a.mapArrayOrNot)(ie.preview.matches,we=>new I.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))},ranges:(0,a.mapArrayOrNot)(ie.ranges,we=>new I.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))}):H({uri:Y,text:ie.text,lineNumber:ie.lineNumber})})},L.isCancellationRequested)return{};try{const ue=await this._proxy.$startTextSearch(A,(0,_.withUndefinedAsNull)(j),K,z,L);return delete this._activeSearchCallbacks[z],ue||{}}catch(ue){throw delete this._activeSearchCallbacks[z],ue}}$handleTextSearchResult(A,U){this._activeSearchCallbacks[U]&&this._activeSearchCallbacks[U](A)}saveAll(A){return this._proxy.$saveAll(A)}resolveProxy(A){return this._proxy.$resolveProxy(A)}get trusted(){return this._trusted}requestWorkspaceTrust(A){return this._proxy.$requestWorkspaceTrust(A)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};y=Ue([$e(0,p.IExtHostRpcService),$e(1,h.IExtHostInitDataService),$e(2,v.IExtHostFileSystemInfo),$e(3,g.ILogService)],y),e.ExtHostWorkspace=y,e.IExtHostWorkspace=(0,o.createDecorator)("IExtHostWorkspace");function u(S){let A,U;return S&&(typeof S=="string"?A=S:(A=S.pattern,U=S.baseFolder||n.URI.file(S.base))),{includePattern:A,folder:U}}}),define(Ee[32],ye([0,1,26,4,31,5,7,142,83,11,14,3,13,12,2]),function(re,e,a,t,w,T,k,P,C,R,F,_,n,f,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function g(M,r){if(r){const i=r.split(".");let m=M;for(let d=0;m&&d<i.length;d++)m=m[i[d]];return m}}function c(M){return M instanceof o.URI}function D(M){return M&&M.uri instanceof o.URI&&M.languageId&&typeof M.languageId=="string"}function v(M){return M&&!M.uri&&M.languageId&&typeof M.languageId=="string"}function h(M){return M&&M.uri instanceof o.URI&&(!M.name||typeof M.name=="string")&&(!M.index||typeof M.index=="number")}function p(M){if(c(M))return{resource:M};if(D(M))return{resource:M.uri,overrideIdentifier:M.languageId};if(v(M))return{overrideIdentifier:M.languageId};if(h(M))return{resource:M.uri};if(M===null)return{resource:null}}let I=class{constructor(r,i,m){this._proxy=r.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=m,this._barrier=new F.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new l(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,i){this.getConfigProvider().then(m=>m.$acceptConfigurationChanged(r,i))}};I=Ue([$e(0,n.IExtHostRpcService),$e(1,w.IExtHostWorkspace),$e(2,f.ILogService)],I),e.ExtHostConfiguration=I;class l{constructor(r,i,m,d){this._onDidChangeConfiguration=new t.Emitter,this._proxy=r,this._logService=d,this._extHostWorkspace=i,this._configuration=P.Configuration.parse(m),this._configurationScopes=this._toMap(m.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,i){const m={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,m))}getConfiguration(r,i,m){const d=p(i)||{},s=this._toReadonlyValue(r?g(this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,d,m?.identifier);function b(u){if(u==null)return null;if(typeof u=="boolean")return u?1:4;switch(u){case k.ConfigurationTarget.Global:return 1;case k.ConfigurationTarget.Workspace:return 4;case k.ConfigurationTarget.WorkspaceFolder:return 5}}const y={has(u){return typeof g(s,u)!="undefined"},get:(u,S)=>{this._validateConfigurationAccess(r?`${r}.${u}`:u,d,m?.identifier);let A=g(s,u);if(typeof A=="undefined")A=S;else{let U;const H=(E,L)=>{let z;const N=()=>{U=U||(0,a.deepClone)(s),z=z||g(U,L)};return(0,R.isObject)(E)?new Proxy(E,{get:(B,j)=>{if(typeof j=="string"&&j.toLowerCase()==="tojson")return N(),()=>z;if(U)return z=z||g(U,L),z[j];const ce=B[j];return typeof j=="string"?H(ce,`${L}.${j}`):ce},set:(B,j,ce)=>(N(),z&&(z[j]=ce),!0),deleteProperty:(B,j)=>(N(),z&&delete z[j],!0),defineProperty:(B,j,ce)=>(N(),z&&Object.defineProperty(z,j,ce),!0)}):E};A=H(A,u)}return A},update:(u,S,A,U)=>{u=r?`${r}.${u}`:u;const H=b(A);return S!==void 0?this._proxy.$updateConfigurationOption(H,u,S,d,U):this._proxy.$removeConfigurationOption(H,u,d,U)},inspect:u=>{u=r?`${r}.${u}`:u;const S=(0,a.deepClone)(this._configuration.inspect(u,d,this._extHostWorkspace.workspace));if(S)return{key:u,defaultValue:S.default?.value,globalValue:S.user?.value,workspaceValue:S.workspace?.value,workspaceFolderValue:S.workspaceFolder?.value,defaultLanguageValue:S.default?.override,globalLanguageValue:S.user?.override,workspaceLanguageValue:S.workspace?.override,workspaceFolderLanguageValue:S.workspaceFolder?.override,languageIds:S.overrideIdentifiers}}};return typeof s=="object"&&(0,a.mixin)(y,s,!1),Object.freeze(y)}_toReadonlyValue(r){const i=m=>(0,R.isObject)(m)?new Proxy(m,{get:(d,s)=>i(d[s]),set:(d,s,b)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(s)}' of object`)},deleteProperty:(d,s)=>{throw new Error(`TypeError: Cannot delete read only property '${String(s)}' of object`)},defineProperty:(d,s)=>{throw new Error(`TypeError: Cannot define property '${String(s)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):m;return i(r)}_validateConfigurationAccess(r,i,m){const d=C.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),s=m?`[${m.value}] `:"";if(d===4){typeof i?.resource=="undefined"&&this._logService.warn(`${s}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){i?.resource&&this._logService.warn(`${s}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,i){const m=new P.ConfigurationChangeEvent(r,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(d,s)=>m.affectsConfiguration(d,p(s))})}_toMap(r){return r.reduce((i,m)=>(i.set(m[0],m[1]),i),new Map)}}e.ExtHostConfigProvider=l,e.IExtHostConfiguration=(0,_.createDecorator)("IExtHostConfiguration")});var Ze=this&&this.__classPrivateFieldSet||function(re,e,a,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(re,a):w?w.value=a:e.set(re,a),a},Te=this&&this.__classPrivateFieldGet||function(re,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!t:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(re):t?t.value:e.get(re)};define(Ee[97],ye([0,1,2,14,4,5,7,31,48,32,20,39,13,28,3,10,23,12,69,161,15]),function(re,e,a,t,w,T,k,P,C,R,F,_,n,f,o,g,c,D,v,h,p){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var l;(function(L){function z(B){if(B!=null)return B}L.from=z;function N(B){if(B!=null)return B}L.to=N})(l=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var M;(function(L){function z(B){if(B!=null)return B}L.from=z;function N(B){if(B!=null)return B}L.to=N})(M=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(L){function z(B){if(B!=null)return B}L.from=z;function N(B){if(B!=null)return B}L.to=N})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(L){function z(j){if(j){const ce=j;return ce&&!!ce.process}else return!1}L.is=z;function N(j){if(j==null)return;const ce={process:j.process,args:j.args};return j.options&&(ce.options=r.from(j.options)),ce}L.from=N;function B(j){if(j!=null)return new k.ProcessExecution(j.process,j.args,j.options)}L.to=B})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var m;(function(L){function z(B){if(B!=null)return B}L.from=z;function N(B){if(B!=null)return B}L.to=N})(m=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var d;(function(L){function z(j){if(j){const ce=j;return ce&&(!!ce.commandLine||!!ce.command)}else return!1}L.is=z;function N(j){if(j==null)return;const ce={};return j.commandLine!==void 0?ce.commandLine=j.commandLine:(ce.command=j.command,ce.args=j.args),j.options&&(ce.options=m.from(j.options)),ce}L.from=N;function B(j){if(!(j==null||j.command===void 0&&j.commandLine===void 0))return j.commandLine?new k.ShellExecution(j.commandLine,j.options):new k.ShellExecution(j.command,j.args?j.args:[],j.options)}L.to=B})(d=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var s;(function(L){function z(j){if(j){let ce=j;return ce&&ce.customExecution==="customExecution"}else return!1}L.is=z;function N(j){return{customExecution:"customExecution"}}L.from=N;function B(j,ce){return ce.get(j)}L.to=B})(s=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var b;(function(L){function z(N,B){let j;return N.scope!==void 0&&typeof N.scope!="number"?j=N.scope.uri:N.scope!==void 0&&typeof N.scope=="number"&&(N.scope===k.TaskScope.Workspace&&B&&B.workspaceFile?j=B.workspaceFile:j=h.USER_TASKS_GROUP_KEY),{id:N._id,workspaceFolder:j}}L.from=z})(b=e.TaskHandleDTO||(e.TaskHandleDTO={}));var y;(function(L){function z(N){if(N!=null)return{_id:N.id,isDefault:N.isDefault}}L.from=z})(y=e.TaskGroupDTO||(e.TaskGroupDTO={}));var u;(function(L){function z(j,ce){if(j==null)return[];const K=[];for(let le of j){const ue=N(le,ce);ue&&K.push(ue)}return K}L.fromMany=z;function N(j,ce){if(j==null)return;let K;j.execution instanceof k.ProcessExecution?K=i.from(j.execution):j.execution instanceof k.ShellExecution?K=d.from(j.execution):j.execution&&j.execution instanceof k.CustomExecution&&(K=s.from(j.execution));const le=l.from(j.definition);let ue;return j.scope?typeof j.scope=="number"?ue=j.scope:ue=j.scope.uri:ue=k.TaskScope.Workspace,!le||!ue?void 0:{_id:j._id,definition:le,name:j.name,source:{extensionId:ce.identifier.value,label:j.source,scope:ue},execution:K,isBackground:j.isBackground,group:y.from(j.group),presentationOptions:M.from(j.presentationOptions),problemMatchers:j.problemMatchers,hasDefinedMatchers:j.hasDefinedMatchers,runOptions:j.runOptions?j.runOptions:{reevaluateOnRerun:!0},detail:j.detail}}L.from=N;async function B(j,ce,K){if(j==null)return;let le;i.is(j.execution)?le=i.to(j.execution):d.is(j.execution)?le=d.to(j.execution):s.is(j.execution)&&(le=s.to(j._id,K));const ue=l.to(j.definition);let Y;if(j.source&&(j.source.scope!==void 0?typeof j.source.scope=="number"?Y=j.source.scope:Y=await ce.resolveWorkspaceFolder(a.URI.revive(j.source.scope)):Y=k.TaskScope.Workspace),!ue||!Y)return;const ie=new k.Task(ue,Y,j.name,j.source.label,le,j.problemMatchers);return j.isBackground!==void 0&&(ie.isBackground=j.isBackground),j.group!==void 0&&(ie.group=k.TaskGroup.from(j.group._id),ie.group&&j.group.isDefault&&(ie.group=new k.TaskGroup(ie.group.id,ie.group.label),j.group.isDefault&&(ie.group.isDefault=j.group.isDefault))),j.presentationOptions&&(ie.presentationOptions=M.to(j.presentationOptions)),j._id&&(ie._id=j._id),j.detail&&(ie.detail=j.detail),ie}L.to=B})(u=e.TaskDTO||(e.TaskDTO={}));var S;(function(L){function z(B){return B}L.from=z;function N(B){if(!!B)return Object.assign(Object.create(null),B)}L.to=N})(S=e.TaskFilterDTO||(e.TaskFilterDTO={}));class A{constructor(z,N,B){this._id=N,this._task=B,I.set(this,void 0),Ze(this,I,z,"f")}get task(){return this._task}terminate(){Te(this,I,"f").terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}I=new WeakMap;var U;(function(L){function z(N){return{id:N._id,task:void 0}}L.from=z})(U=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let H=class{constructor(z,N,B,j,ce,K,le,ue){this._onDidExecuteTask=new w.Emitter,this._onDidTerminateTask=new w.Emitter,this._onDidTaskProcessStarted=new w.Emitter,this._onDidTaskProcessEnded=new w.Emitter,this._proxy=z.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=B,this._editorService=j,this._configurationService=ce,this._terminalService=K,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=le,this._deprecationService=ue,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(z,N,B){if(!B)return new k.Disposable(()=>{});const j=this.nextHandle();return this._handlers.set(j,{type:N,provider:B,extension:z}),this._proxy.$registerTaskProvider(j,N),new k.Disposable(()=>{this._handlers.delete(j),this._proxy.$unregisterTaskProvider(j)})}registerTaskSystem(z,N){this._proxy.$registerTaskSystem(z,N)}fetchTasks(z){return this._proxy.$fetchTasks(S.from(z)).then(async N=>{const B=[];for(let j of N){const ce=await u.to(j,this._workspaceProvider,this._providedCustomExecutions2);ce&&B.push(ce)}return B})}get taskExecutions(){const z=[];return this._taskExecutions.forEach(N=>z.push(N)),z}terminateTask(z){if(!(z instanceof A))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(z._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(z,N,B){const j=this._providedCustomExecutions2.get(z.id);j&&(this._activeCustomExecutions2.set(z.id,j),this._terminalService.attachPtyToTerminal(N,await j.callback(B))),this._lastStartedTask=z.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(z)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(z){const N=await this.getTaskExecution(z);this._taskExecutionPromises.delete(z.id),this._taskExecutions.delete(z.id),this.customExecutionComplete(z),this._onDidTerminateTask.fire({execution:N})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(z){const N=await this.getTaskExecution(z.id);this._onDidTaskProcessStarted.fire({execution:N,processId:z.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(z){const N=await this.getTaskExecution(z.id);this._onDidTaskProcessEnded.fire({execution:N,exitCode:z.exitCode})}$provideTasks(z,N){const B=this._handlers.get(z);if(!B)return Promise.reject(new Error("no handler found"));const j=[],ce=(0,t.asPromise)(()=>B.provider.provideTasks(F.CancellationToken.None)).then(K=>this.provideTasksInternal(N,j,B,K));return new Promise(K=>{ce.then(le=>{Promise.all(j).then(()=>{K(le)})})})}async $resolveTask(z,N){const B=this._handlers.get(z);if(!B)return Promise.reject(new Error("no handler found"));if(N.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${N.definition.type}] cannot be resolved by provider of type [${B.type}].`);const j=await u.to(N,this._workspaceProvider,this._providedCustomExecutions2);if(!j)throw new Error("Unexpected: Task cannot be resolved.");const ce=await B.provider.resolveTask(j,F.CancellationToken.None);if(!ce)return;this.checkDeprecation(ce,B);const K=u.from(ce,B.extension);if(!K)throw new Error("Unexpected: Task cannot be resolved.");if(ce.definition!==j.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return s.is(K.execution)&&await this.addCustomExecution(K,ce,!0),await this.resolveTaskInternal(K)}nextHandle(){return this._handleCounter++}async addCustomExecution(z,N,B){const j=await this._proxy.$createTaskId(z);!B&&!this._providedCustomExecutions2.has(j)&&(this._notProvidedCustomExecutions.add(j),this._activeCustomExecutions2.set(j,N.execution)),this._providedCustomExecutions2.set(j,N.execution)}async getTaskExecution(z,N){if(typeof z=="string"){const ce=this._taskExecutionPromises.get(z);if(!ce)throw new Error("Unexpected: The specified task is missing an execution");return ce}let B=this._taskExecutionPromises.get(z.id);if(B)return B;const j=new Promise((ce,K)=>{function le(ue,Y,ie){ie?ce(new A(ue,Y.id,ie)):K("Unexpected: Task does not exist.")}N?le(this,z,N):u.to(z.task,this._workspaceProvider,this._providedCustomExecutions2).then(ue=>le(this,z,ue))});return this._taskExecutionPromises.set(z.id,j),j.then(ce=>(this._taskExecutions.set(z.id,ce),ce),ce=>Promise.reject(ce))}checkDeprecation(z,N){z._deprecated&&this._deprecationService.report("Task.constructor",N.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(z){this._activeCustomExecutions2.get(z.id)&&this._activeCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.has(z.id)&&this._lastStartedTask!==z.id&&(this._providedCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.delete(z.id));let B=this._notProvidedCustomExecutions.values(),j=B.next();for(;!j.done;)!this._activeCustomExecutions2.has(j.value)&&this._lastStartedTask!==j.value&&(this._providedCustomExecutions2.delete(j.value),this._notProvidedCustomExecutions.delete(j.value)),j=B.next()}};H=Ue([$e(0,n.IExtHostRpcService),$e(1,f.IExtHostInitDataService),$e(2,P.IExtHostWorkspace),$e(3,C.IExtHostDocumentsAndEditors),$e(4,R.IExtHostConfiguration),$e(5,_.IExtHostTerminalService),$e(6,D.ILogService),$e(7,v.IExtHostApiDeprecationService)],H),e.ExtHostTaskBase=H;let E=class extends H{constructor(z,N,B,j,ce,K,le,ue){super(z,N,B,j,ce,K,le,ue);this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:"",platform:c.PlatformToString(0)})}async executeTask(z,N){if(!N.execution)throw new Error("Tasks to execute must include an execution");const B=u.from(N,z);if(B===void 0)throw new Error("Task is not valid");if(s.is(B.execution))await this.addCustomExecution(B,N,!1);else throw new p.NotSupportedError;const j=await this.getTaskExecution(await this._proxy.$getTaskExecution(B),N);return this._proxy.$executeTask(B).catch(ce=>{throw new Error(ce)}),j}provideTasksInternal(z,N,B,j){const ce=[];if(j)for(let K of j){this.checkDeprecation(K,B),(!K.definition||!z[K.definition.type])&&this._logService.warn(`The task [${K.source}, ${K.name}] uses an undefined task type. The task will be ignored in the future.`);const le=u.from(K,B.extension);le&&s.is(le.execution)?(ce.push(le),N.push(this.addCustomExecution(le,K,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ce,extension:B.extension}}async resolveTaskInternal(z){if(s.is(z.execution))return z;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(z,N){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(z,N,B){}};E=Ue([$e(0,n.IExtHostRpcService),$e(1,f.IExtHostInitDataService),$e(2,P.IExtHostWorkspace),$e(3,C.IExtHostDocumentsAndEditors),$e(4,R.IExtHostConfiguration),$e(5,_.IExtHostTerminalService),$e(6,D.ILogService),$e(7,v.IExtHostApiDeprecationService)],E),e.WorkerExtHostTask=E,e.IExtHostTask=(0,o.createDecorator)("IExtHostTask")}),define(Ee[213],ye([0,1,16,74,29,77,21,10,17,24,9,11,2,231,128,81,46,90,212,40]),function(re,e,a,t,w,T,k,P,C,R,F,_,n,f,o,g,c,D,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let p=class{constructor(b,y,u,S){this.configurationService=b,this.workspaceContextService=y,this.editorGroupsService=u,this.pathService=S}text(b,y,u={}){b=this.getContentPattern(b,u);const S=this.configurationService.getValue(),A=y&&y.some(H=>!this.configurationService.getValue({resource:H}).search.useRipgrep);return{...this.commonQuery(y?.map(c.toWorkspaceFolder),u),type:2,contentPattern:b,previewOptions:u.previewOptions,maxFileSize:u.maxFileSize,usePCRE2:S.search.usePCRE2||A||!1,beforeContext:u.beforeContext,afterContext:u.afterContext,userDisabledExcludesAndIgnoreFiles:u.disregardExcludeSettings&&u.disregardIgnoreFiles}}getContentPattern(b,y){const u=this.configurationService.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const S={...b,wordSeparators:u.editor.wordSeparators};return this.isCaseSensitive(b,y)&&(S.isCaseSensitive=!0),this.isMultiline(b)&&(S.isMultiline=!0),S}file(b,y={}){return{...this.commonQuery(b,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey}}handleIncludeExclude(b,y){return b?(b=Array.isArray(b)?b.map(i):i(b),y?this.parseSearchPaths(b):{pattern:l(...Array.isArray(b)?b:[b])}):{}}commonQuery(b=[],y={}){const u=this.handleIncludeExclude(y.includePattern,y.expandPatterns),S=this.handleIncludeExclude(y.excludePattern,y.expandPatterns),A=b.length>1,U=(u.searchPaths&&u.searchPaths.length?u.searchPaths.map(L=>this.getFolderQueryForSearchPath(L,y,S)):b.map(L=>this.getFolderQueryForRoot(L,y,S,A))).filter(L=>!!L),H={_reason:y._reason,folderQueries:U,usingSearchPaths:!!(u.searchPaths&&u.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:S.pattern,includePattern:u.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const z=a.coalesce(a.flatten(this.editorGroupsService.groups.map(B=>B.editors.map(j=>j.resource)))).filter(B=>(0,h.pathIncludedInQuery)(H,B.fsPath)),N=this.commonQueryFromFileList(z);return{...H,...N}}const E=y.extraFileResources&&y.extraFileResources.filter(L=>(0,h.pathIncludedInQuery)(H,L.fsPath));return H.extraFileResources=E&&E.length?E:void 0,H}commonQueryFromFileList(b){const y=[],u=new k.ResourceMap,S={};let A=!1;return b.forEach(U=>{if(U.scheme===P.Schemas.walkThrough)return;if((0,R.isAbsolutePath)(U)){const E=this.workspaceContextService.getWorkspaceFolder(U)?.uri??U.with({path:C.dirname(U.fsPath)});let L=u.get(E);L||(A=!0,L={folder:E,includePattern:{}},y.push(L),u.set(E,L));const z=C.relative(E.fsPath,U.fsPath);(0,_.assertIsDefined)(L.includePattern)[z.replace(/\\/g,"/")]=!0}else U.fsPath&&(A=!0,S[U.fsPath]=!0)}),{folderQueries:y,includePattern:S,usingSearchPaths:!0,excludePattern:A?void 0:{"**/*":!0}}}isCaseSensitive(b,y){if(y.isSmartCase){if(b.isRegExp){if(F.containsUppercaseCharacter(b.pattern,!0))return!0}else if(F.containsUppercaseCharacter(b.pattern))return!0}return!!b.isCaseSensitive}isMultiline(b){return b.isMultiline||b.isRegExp&&(0,f.isMultilineRegexSource)(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const y=N=>C.isAbsolute(N)||/^\.\.?([\/\\]|$)/.test(N),S=(Array.isArray(b)?b:M(b)).map(N=>{const B=this.pathService.resolvedUserHome;return B?(0,T.untildify)(N,B.scheme===P.Schemas.file?B.fsPath:B.path):N}),A=t.groupBy(S,N=>y(N)?"searchPaths":"exprSegments"),U=(A.exprSegments||[]).map(N=>F.rtrim(N,"/")).map(N=>F.rtrim(N,"\\")).map(N=>(N[0]==="."&&(N="*"+N),r(N))),H={},E=this.expandSearchPathPatterns(A.searchPaths||[]);E&&E.length&&(H.searchPaths=E);const L=a.flatten(U),z=l(...L);return z&&(H.pattern=z),H}getExcludesForFolder(b,y){return y.disregardExcludeSettings?void 0:(0,h.getExcludes)(b,!y.disregardSearchExcludeSettings)}expandSearchPathPatterns(b){if(!b||!b.length)return[];const y=a.flatten(b.map(S=>{let{pathPortion:A,globPortion:U}=I(S);U&&(U=m(U));const H=this.expandOneSearchPath(A);return a.flatten(H.map(E=>this.resolveOneSearchPathPattern(E,U)))})),u=new Map;return y.forEach(S=>{const A=S.searchPath.toString(),U=u.get(A);U?S.pattern&&(U.pattern=U.pattern||{},U.pattern[S.pattern]=!0):u.set(A,{searchPath:S.searchPath,pattern:S.pattern?l(S.pattern):void 0})}),Array.from(u.values())}expandOneSearchPath(b){if(C.isAbsolute(b)){const y=this.workspaceContextService.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==P.Schemas.file?[{searchPath:y[0].uri.with({path:b})}]:[{searchPath:n.URI.file(C.normalize(b))}]}if(this.workspaceContextService.getWorkbenchState()===2){const y=this.workspaceContextService.getWorkspace().folders[0].uri;if(b=i(b),b.startsWith("../")||b===".."){const S=C.posix.resolve(y.path,b);return[{searchPath:y.with({path:S})}]}const u=m(b);return[{searchPath:y,pattern:u}]}else{if(b==="./"||b===".\\")return[];{const y=b.replace(/^\.[\/\\]/,""),S=this.workspaceContextService.getWorkspace().folders.map(A=>{const U=y.match(new RegExp(`^${F.escapeRegExpCharacters(A.name)}(?:/(.*)|$)`));return U?{match:U,folder:A}:null}).filter(_.isDefined);if(S.length)return S.map(A=>{const U=A.match[1];return{searchPath:A.folder.uri,pattern:U&&m(U)}});{const A=b.match(/\.[\/\\](.+)[\/\\]?/),U=A?A[1]:b,H=o.localize(0,null,U);throw new Error(H)}}}}resolveOneSearchPathPattern(b,y){const u=b.pattern&&y?`${b.pattern}/${y}`:b.pattern||y,S=[{searchPath:b.searchPath,pattern:u}];return u&&!u.endsWith("**")&&S.push({searchPath:b.searchPath,pattern:u+"/**"}),S}getFolderQueryForSearchPath(b,y,u){const S=this.getFolderQueryForRoot((0,c.toWorkspaceFolder)(b.searchPath),y,u,!1);return S?{...S,includePattern:b.pattern}:null}getFolderQueryForRoot(b,y,u,S){let A;const U=n.URI.isUri(b)?b:b.uri;if(u.searchPaths){const N=u.searchPaths.filter(B=>(0,R.isEqual)(B.searchPath,U))[0];if(N&&!N.pattern)return null;N&&(A=N.pattern)}const H=this.configurationService.getValue({resource:U}),L={...this.getExcludesForFolder(H,y)||{},...A||{}},z=n.URI.isUri(b)?(0,R.basename)(b):b.name;return{folder:U,folderName:S?z:void 0,excludePattern:Object.keys(L).length>0?L:void 0,fileEncoding:H.files&&H.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!H.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!H.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!H.search.followSymlinks}}};p=Ue([$e(0,g.IConfigurationService),$e(1,c.IWorkspaceContextService),$e(2,D.IEditorGroupsService),$e(3,v.IPathService)],p),e.QueryBuilder=p;function I(s){const b=s.match(/[\*\{\}\(\)\[\]\?]/);if(b){const y=b.index,u=s.substr(0,y).match(/[/|\\][^/\\]*$/);if(u){let S=s.substr(0,u.index);return S.match(/[/\\]/)||(S+="/"),{pathPortion:S,globPortion:s.substr((u.index||0)+1)}}}return{pathPortion:s}}function l(...s){return s.length?s.reduce((b,y)=>(b[y]=!0,b),Object.create(null)):void 0}function M(s){return w.splitGlobAware(s,",").map(b=>b.trim()).filter(b=>!!b.length)}function r(s){return[`**/${s}/**`,`**/${s}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function i(s){return s.replace(/\\/g,"/")}function m(s){return i(s).replace(/^\.\//,"").replace(/\/+$/g,"")}function d(s,b){s=a.distinct(s,S=>S.toString());const y=[],u=b.getWorkspace();return s&&s.forEach(S=>{let A;if(b.getWorkbenchState()===2)A=(0,R.relativePath)(u.folders[0].uri,S),A&&A!=="."&&(A="./"+A);else{const U=b.getWorkspaceFolder(S);if(U){const H=U.name;if(u.folders.filter(L=>L.name===H).length===1){const L=(0,R.relativePath)(U.uri,S);L===""?A=`./${U.name}`:A=`./${U.name}/${L}`}else A=S.fsPath}}A&&y.push(A)}),y}e.resolveResourcesForSearchIncludes=d}),define(Ee[214],ye([0,1,24,2,20,15,3,213,40,46]),function(re,e,a,t,w,T,k,P,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const F=7e3;function _(g,c){const D=c.activationEvents;if(!D)return Promise.resolve(void 0);const v=[],h=[];for(const i of D)if(/^workspaceContains:/.test(i)){const m=i.substr("workspaceContains:".length);m.indexOf("*")>=0||m.indexOf("?")>=0||g.forceUsingSearch?h.push(m):v.push(m)}if(v.length===0&&h.length===0)return Promise.resolve(void 0);let p;const I=new Promise((i,m)=>{p=i}),l=i=>p({activationEvent:i}),M=Promise.all(v.map(i=>n(g,i,l))).then(()=>{}),r=f(g,c.identifier,h,l);return Promise.all([M,r]).then(()=>{p(void 0)}),I}e.checkActivateWorkspaceContainsExtension=_;async function n(g,c,D){for(const v of g.folders)if(await g.exists(a.joinPath(t.URI.revive(v),c))){D(`workspaceContains:${c}`);return}}async function f(g,c,D,v){if(D.length===0)return Promise.resolve(void 0);const h=new w.CancellationTokenSource,p=g.checkExists(g.folders,D,h.token),I=setTimeout(async()=>{h.cancel(),g.logService.info(`Not activating extension '${c.value}': Timed out while searching for 'workspaceContains' pattern ${D.join(",")}`)},F);let l=!1;try{l=await p}catch(M){T.isPromiseCanceledError(M)||T.onUnexpectedError(M)}h.dispose(),clearTimeout(I),l&&v(`workspaceContains:${D.join(",")}`)}function o(g,c,D,v){const h=g.get(k.IInstantiationService),p=g.get(C.ISearchService),l=h.createInstance(P.QueryBuilder).file(c.map(M=>(0,R.toWorkspaceFolder)(t.URI.revive(M))),{_reason:"checkExists",includePattern:D,exists:!0});return p.fileSearch(l,v).then(M=>!!M.limitHit,M=>T.isPromiseCanceledError(M)?!1:Promise.reject(M))}e.checkGlobFileExists=o});var Ze=this&&this.__classPrivateFieldSet||function(re,e,a,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(re,a):w?w.value=a:e.set(re,a),a},Te=this&&this.__classPrivateFieldGet||function(re,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!t:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(re):t?t.value:e.get(re)};define(Ee[33],ye([0,1,120,17,73,24,14,6,21,2,12,5,32,174,71,31,27,172,15,25,22,147,7,84,3,28,72,13,60,64,39,4,214,68,149,10]),function(re,e,a,t,w,T,k,P,C,R,F,_,n,f,o,g,c,D,v,h,p,I,l,M,r,i,m,d,s,b,y,u,S,A,U,H){"use strict";var E,L,z;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let N=class ji extends P.Disposable{constructor(K,le,ue,Y,ie,we,Me,Re,Be,Qe){super();this._onDidChangeRemoteConnectionData=this._register(new u.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=le,this._extHostContext=ue,this._initData=Me,this._extHostWorkspace=Y,this._extHostConfiguration=ie,this._logService=we,this._extHostTunnelService=Be,this._extHostTerminalService=Qe,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(_.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(_.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(_.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new k.Barrier,this._readyToStartExtensionHost=new k.Barrier,this._readyToRunExtensions=new k.Barrier,this._eagerExtensionsActivated=new k.Barrier,this._registry=new D.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new o.ExtHostStorage(this._extHostContext),this._secretState=new A.ExtHostSecretState(this._extHostContext),this._storagePath=Re,this._instaService=K.createChild(new s.ServiceCollection([o.IExtHostStorage,this._storage],[A.IExtHostSecretState,this._secretState]));const Ke=new Set;this._initData.hostExtensions.forEach(Xe=>Ke.add(h.ExtensionIdentifier.toKey(Xe))),this._activator=this._register(new f.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Xe,$,G)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Xe,v.transformErrorForSerialization($),G)},actualActivateExtension:async(Xe,$)=>{if(Ke.has(h.ExtensionIdentifier.toKey(Xe)))return await this._mainThreadExtensionsProxy.$activateExtension(Xe,$),new f.HostExtension;const G=this._registry.getExtensionDescription(Xe);return this._activateExtension(G,$)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),w.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(K){v.onUnexpectedError(K)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let K=[];try{K=this._registry.getAllExtensionDescriptions().map(ie=>ie.identifier).filter(ie=>this.isActivated(ie)).map(ie=>this._deactivate(ie))}catch{}await Promise.all(K)}isActivated(K){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(K):!1}_activateByEvent(K,le){return this._activator.activateByEvent(K,le)}_activateById(K,le){return this._activator.activateById(K,le)}activateByIdWithErrors(K,le){return this._activateById(K,le).then(()=>{const ue=this._activator.getActivatedExtension(K);if(ue.activationFailed)return Promise.reject(ue.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(K=>this._registry)}getExtensionExports(K){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(K).exports:null}async _realPathExtensionUri(K){if(K.scheme!==H.Schemas.file)return K;const le=await this._hostUtils.realpath(K.fsPath);return R.URI.file(le)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const K=C.TernarySearchTree.forUris(le=>T.extUriBiasedIgnorePathCase.ignorePathCasing(le));for(const le of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(le)){const ue=await this._realPathExtensionUri(le.extensionLocation);K.set(ue,le)}return K})()),this._extensionPathIndex}_deactivate(K){let le=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(K))return le;const ue=this._activator.getActivatedExtension(K);if(!ue)return le;try{typeof ue.module.deactivate=="function"&&(le=Promise.resolve(ue.module.deactivate()).then(void 0,Y=>(this._logService.error(Y),Promise.resolve(void 0))))}catch(Y){this._logService.error(`An error occurred when deactivating the extension '${K.value}':`),this._logService.error(Y)}try{(0,P.dispose)(ue.subscriptions)}catch(Y){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${K.value}':`),this._logService.error(Y)}return le}async _activateExtension(K,le){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(K.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(K.identifier),this._doActivateExtension(K,le).then(ue=>{const Y=ue.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(K.identifier,Y.codeLoadingTime,Y.activateCallTime,Y.activateResolvedTime,le),this._logExtensionActivationTimes(K,le,"success",Y),ue},ue=>{throw this._logExtensionActivationTimes(K,le,"failure"),ue})}_logExtensionActivationTimes(K,le,ue,Y){const ie=B(K,le);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ie,...Y||{},outcome:ue})}_doActivateExtension(K,le){const ue=B(K,le);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ue);const Y=this._getEntryPoint(K);if(!Y)return Promise.resolve(new f.EmptyExtension(f.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${K.identifier.value}, startup: ${le.startup}, activationEvent: '${le.activationEvent}'${K.identifier.value!==le.extensionId.value?`, root cause: ${le.extensionId.value}`:""}`),this._logService.flush();const ie=new f.ExtensionActivationTimesBuilder(le.startup);return Promise.all([this._loadCommonJSModule(K.identifier,(0,T.joinPath)(K.extensionLocation,Y),ie),this._loadExtensionContext(K)]).then(we=>(w.mark(`code/extHost/willActivateExtension/${K.identifier.value}`),ji._callActivate(this._logService,K.identifier,we[0],we[1],ie))).then(we=>(w.mark(`code/extHost/didActivateExtension/${K.identifier.value}`),we))}_loadExtensionContext(K){const le=new I.ExtensionGlobalMemento(K,this._storage),ue=new I.ExtensionMemento(K.identifier.value,!1,this._storage),Y=new U.ExtensionSecrets(K,this._secretState),ie=K.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?l.ExtensionMode.Test:l.ExtensionMode.Development:l.ExtensionMode.Production,we=this._initData.remote.isRemote?l.ExtensionKind.Workspace:l.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${K.identifier.value}`),Promise.all([le.whenReady,ue.whenReady,this._storagePath.whenReady]).then(()=>{const Me=this;let Re;return Object.freeze({globalState:le,workspaceState:ue,secrets:Y,subscriptions:[],get extensionUri(){return K.extensionLocation},get extensionPath(){return K.extensionLocation.fsPath},asAbsolutePath(Be){return t.join(K.extensionLocation.fsPath,Be)},get storagePath(){return Me._storagePath.workspaceValue(K)?.fsPath},get globalStoragePath(){return Me._storagePath.globalValue(K).fsPath},get logPath(){return t.join(Me._initData.logsLocation.fsPath,K.identifier.value)},get logUri(){return R.URI.joinPath(Me._initData.logsLocation,K.identifier.value)},get storageUri(){return Me._storagePath.workspaceValue(K)},get globalStorageUri(){return Me._storagePath.globalValue(K)},get extensionMode(){return ie},get extension(){return Re===void 0&&(Re=new j(Me,K.identifier,K,we)),Re},get extensionRuntime(){return(0,c.checkProposedApiEnabled)(K,"extensionRuntime"),Me.extensionRuntime},get environmentVariableCollection(){return Me._extHostTerminalService.getEnvironmentVariableCollection(K)}})})}static _callActivate(K,le,ue,Y,ie){return ue=ue||{activate:void 0,deactivate:void 0},this._callActivateOptional(K,le,ue,Y,ie).then(we=>new f.ActivatedExtension(!1,null,ie.build(),ue,we,Y.subscriptions))}static _callActivateOptional(K,le,ue,Y,ie){if(typeof ue.activate=="function")try{ie.activateCallStart(),K.trace(`ExtensionService#_callActivateOptional ${le.value}`);const we=typeof global=="object"?global:self,Me=ue.activate.apply(we,[Y]);return ie.activateCallStop(),ie.activateResolveStart(),Promise.resolve(Me).then(Re=>(ie.activateResolveStop(),Re))}catch(we){return Promise.reject(we)}else return Promise.resolve(ue)}_activateOneStartupFinished(K,le){this._activateById(K.identifier,{startup:!1,extensionId:K.identifier,activationEvent:le}).then(void 0,ue=>{this._logService.error(ue)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(w.getMarks());for(const K of this._registry.getAllExtensionDescriptions())if(K.activationEvents)for(const le of K.activationEvents)le==="onStartupFinished"&&this._activateOneStartupFinished(K,le)}_handleEagerExtensions(){const K=this._activateByEvent("*",!0).then(void 0,ie=>{this._logService.error(ie)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ie=>this._handleWorkspaceContainsEagerExtensions(ie.added)));const le=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ue=this._handleWorkspaceContainsEagerExtensions(le),Y=Promise.all([K,ue]).then(()=>{});return Promise.race([Y,(0,k.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),Y}_handleWorkspaceContainsEagerExtensions(K){return K.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(le=>this._handleWorkspaceContainsEagerExtension(K,le))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(K,le){if(this.isActivated(le.identifier))return;const ue=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Y={logService:this._logService,folders:K.map(we=>we.uri),forceUsingSearch:ue,exists:we=>this._hostUtils.exists(we.fsPath),checkExists:(we,Me,Re)=>this._mainThreadWorkspaceProxy.$checkExists(we,Me,Re)},ie=await(0,S.checkActivateWorkspaceContainsExtension)(Y,le);if(!!ie)return this._activateById(le.identifier,{startup:!0,extensionId:le.identifier,activationEvent:ie.activationEvent}).then(void 0,we=>this._logService.error(we))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(K){throw console.error(K),K}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:K,extensionTestsLocationURI:le}=this._initData.environment;if(!K||!le)throw new Error(a.localize(0,null));const ue=await this._loadCommonJSModule(null,le,new f.ExtensionActivationTimesBuilder(!1));if(!ue||typeof ue.run!="function")throw new Error(a.localize(1,null,le.toString()));return new Promise((Y,ie)=>{const we=(Be,Qe)=>{Be?ie(Be):Y(typeof Qe=="number"&&Qe>0?1:0)},Me=(0,T.originalFSPath)(le),Re=ue.run(Me,we);Re&&Re.then&&Re.then(()=>{Y(0)}).catch(Be=>{ie(Be.toString())})})}async $extensionTestsExit(K){this._logService.info(`Extension host terminating: test runner requested exit with code ${K}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${K}`),this._logService.flush(),this._hostUtils.exit(K)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(K,le){return this._resolvers[K]=le,(0,P.toDisposable)(()=>{delete this._resolvers[K]})}async _activateAndGetResolver(K){const le=K.indexOf("+");if(le===-1)throw new Error("Not an authority that can be resolved!");const ue=K.substr(0,le);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ue}`,!1),{authorityPrefix:ue,resolver:this._resolvers[ue]}}async $resolveAuthority(K,le){const{authorityPrefix:ue,resolver:Y}=await this._activateAndGetResolver(K);if(!Y)return{type:"error",error:{code:M.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ue}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelExtensionFunctions(Y)),w.mark(`code/extHost/willResolveAuthority/${ue}`);const ie=await Y.resolve(K,{resolveAttempt:le});w.mark(`code/extHost/didResolveAuthorityOK/${ue}`);const we={authority:K,host:ie.host,port:ie.port,connectionToken:ie.connectionToken},Me={extensionHostEnv:ie.extensionHostEnv,isTrusted:ie.isTrusted,authenticationSession:ie.authenticationSessionForInitializingExtensions?{id:ie.authenticationSessionForInitializingExtensions.id,providerId:ie.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:we,options:Me,tunnelInformation:{environmentTunnels:ie.environmentTunnels}}}}catch(ie){if(w.mark(`code/extHost/didResolveAuthorityError/${ue}`),ie instanceof l.RemoteAuthorityResolverError)return{type:"error",error:{code:ie._code,message:ie._message,detail:ie._detail}};throw ie}}async $getCanonicalURI(K,le){const{authorityPrefix:ue,resolver:Y}=await this._activateAndGetResolver(K);if(!Y)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${ue}`);const ie=R.URI.revive(le);if(typeof Y.getCanonicalURI=="undefined")return ie;const we=await(0,k.asPromise)(()=>Y.getCanonicalURI(ie));return we||ie}$startExtensionHost(K){return this._registry.keepOnly(K),this._startExtensionHost()}$activateByEvent(K,le){return le===1?this._activateByEvent(K,!1):this._readyToRunExtensions.wait().then(ue=>this._activateByEvent(K,!1))}async $activate(K,le){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(K)?(await this._activateById(K,le),!0):!1}async $deltaExtensions(K,le){K.forEach(Y=>Y.extensionLocation=R.URI.revive(Y.extensionLocation));const ue=await this.getExtensionPathIndex();return await Promise.all(le.map(async Y=>{const ie=this._registry.getExtensionDescription(Y);ie&&ue.delete(await this._realPathExtensionUri(ie.extensionLocation))})),await Promise.all(K.map(async Y=>{const ie=await this._realPathExtensionUri(Y.extensionLocation);ue.set(ie,Y)})),this._registry.deltaExtensions(K,le),Promise.resolve(void 0)}async $test_latency(K){return K}async $test_up(K){return K.byteLength}async $test_down(K){let le=p.VSBuffer.alloc(K),ue=Math.random()%256;for(let Y=0;Y<K;Y++)le.writeUInt8(ue,Y);return le}async $updateRemoteConnectionData(K){this._remoteConnectionData=K,this._onDidChangeRemoteConnectionData.fire()}};N=Ue([$e(0,r.IInstantiationService),$e(1,e.IHostUtils),$e(2,d.IExtHostRpcService),$e(3,g.IExtHostWorkspace),$e(4,n.IExtHostConfiguration),$e(5,F.ILogService),$e(6,i.IExtHostInitDataService),$e(7,m.IExtensionStoragePaths),$e(8,b.IExtHostTunnelService),$e(9,y.IExtHostTerminalService)],N),e.AbstractExtHostExtensionService=N;function B(ce,K){return{id:ce.identifier.value,name:ce.name,extensionVersion:ce.version,publisherDisplayName:ce.publisher,activationEvents:ce.activationEvents?ce.activationEvents.join(","):null,isBuiltin:ce.isBuiltin,reason:K.activationEvent,reasonId:K.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class j{constructor(K,le,ue,Y){E.set(this,void 0),L.set(this,void 0),z.set(this,void 0),Ze(this,E,K,"f"),Ze(this,L,le,"f"),Ze(this,z,ue.identifier,"f"),this.id=ue.identifier.value,this.extensionUri=ue.extensionLocation,this.extensionPath=t.normalize((0,T.originalFSPath)(ue.extensionLocation)),this.packageJSON=ue,this.extensionKind=Y}get isActive(){return Te(this,E,"f").isActivated(Te(this,z,"f"))}get exports(){if(this.packageJSON.api!=="none")return Te(this,E,"f").getExtensionExports(Te(this,z,"f"))}activate(){return Te(this,E,"f").activateByIdWithErrors(Te(this,z,"f"),{startup:!1,extensionId:Te(this,L,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=j,E=new WeakMap,L=new WeakMap,z=new WeakMap}),define(Ee[98],ye([0,1,17,2,4,14,5,7,156,31,33,48,163,32,157,13,3,11,89,70]),function(re,e,a,t,w,T,k,P,C,R,F,_,n,f,o,g,c,D,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,c.createDecorator)("IExtHostDebugService");let p=class{constructor(s,b,y,u,S,A){this._workspaceService=b,this._extensionService=y,this._editorsService=u,this._configurationService=S,this._editorTabs=A,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new w.Emitter,this._onDidTerminateDebugSession=new w.Emitter,this._onDidChangeActiveDebugSession=new w.Emitter,this._onDidReceiveDebugSessionCustomEvent=new w.Emitter,this._debugServiceProxy=s.getProxy(k.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new w.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new l(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(U=>{U.onDidChange(H=>{this.registerAllDebugTypes(U)}),this.registerAllDebugTypes(U)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(s,b){const y=s;if(typeof y.sourceReference=="number"&&y.sourceReference>0){let u=`debug:${encodeURIComponent(y.path||"")}`,S="?";return b&&(u+=`${S}session=${encodeURIComponent(b.id)}`,S="&"),u+=`${S}ref=${y.sourceReference}`,t.URI.parse(u)}else{if(y.path)return t.URI.file(y.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(s){const b=[];for(const y of s.getAllExtensionDescriptions())if(y.contributes){const u=y.contributes.debuggers;if(u&&u.length>0)for(const S of u)(0,o.isDebuggerMainContribution)(S)&&b.push(S.type)}this._debugServiceProxy.$registerDebugTypes(b)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const s=[];return this._breakpoints.forEach(b=>s.push(b)),s}addBreakpoints(s){this.startBreakpoints();const b=s.filter(S=>{const A=S.id;return this._breakpoints.has(A)?!1:(this._breakpoints.set(A,S),!0)});this.fireBreakpointChanges(b,[],[]);const y=[],u=new Map;for(const S of b)if(S instanceof P.SourceBreakpoint){let A=u.get(S.location.uri.toString());A||(A={type:"sourceMulti",uri:S.location.uri,lines:[]},u.set(S.location.uri.toString(),A),y.push(A)),A.lines.push({id:S.id,enabled:S.enabled,condition:S.condition,hitCondition:S.hitCondition,logMessage:S.logMessage,line:S.location.range.start.line,character:S.location.range.start.character})}else S instanceof P.FunctionBreakpoint&&y.push({type:"function",id:S.id,enabled:S.enabled,hitCondition:S.hitCondition,logMessage:S.logMessage,condition:S.condition,functionName:S.functionName});return this._debugServiceProxy.$registerBreakpoints(y)}removeBreakpoints(s){this.startBreakpoints();const b=s.filter(A=>this._breakpoints.delete(A.id));this.fireBreakpointChanges([],b,[]);const y=b.filter(A=>A instanceof P.SourceBreakpoint).map(A=>A.id),u=b.filter(A=>A instanceof P.FunctionBreakpoint).map(A=>A.id),S=b.filter(A=>A instanceof P.DataBreakpoint).map(A=>A.id);return this._debugServiceProxy.$unregisterBreakpoints(y,u,S)}startDebugging(s,b,y){return this._debugServiceProxy.$startDebugging(s?s.uri:void 0,b,{parentSessionID:y.parentSession?y.parentSession.id:void 0,lifecycleManagedByParent:y.lifecycleManagedByParent,repl:y.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:y.noDebug,compact:y.compact,debugUI:y.debugUI,suppressSaveBeforeStart:y.suppressSaveBeforeStart})}stopDebugging(s){return this._debugServiceProxy.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,b,y){if(!b)return new P.Disposable(()=>{});const u=this._configProviderHandleCounter++;return this._configProviders.push({type:s,handle:u,provider:b}),this._debugServiceProxy.$registerDebugConfigurationProvider(s,y,!!b.provideDebugConfigurations,!!b.resolveDebugConfiguration,!!b.resolveDebugConfigurationWithSubstitutedVariables,u),new P.Disposable(()=>{this._configProviders=this._configProviders.filter(S=>S.provider!==b),this._debugServiceProxy.$unregisterDebugConfigurationProvider(u)})}registerDebugAdapterDescriptorFactory(s,b,y){if(!y)return new P.Disposable(()=>{});if(!this.definesDebugType(s,b))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${b}' debugger.`);if(this.getAdapterDescriptorFactoryByType(b))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const u=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:b,handle:u,factory:y}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(b,u),new P.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(S=>S.factory!==y),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(u)})}registerDebugAdapterTrackerFactory(s,b){if(!b)return new P.Disposable(()=>{});const y=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:s,handle:y,factory:b}),new P.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(u=>u.factory!==b)})}async $runInTerminal(s,b){return Promise.resolve(void 0)}async $substituteVariables(s,b){if(!this._variableResolver){const[S,A]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(S||[],this._editorsService,A)}let y;const u=await this.getFolder(s);return u&&(y={uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(y,b)}createDebugAdapter(s,b){if(s.type==="implementation")return new i(s.implementation)}createSignService(){}async $startDASession(s,b){const y=this,u=await this.getSession(b);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(u.type),u).then(S=>{if(!S)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}' (extension might have failed to activate)`);const A=this.convertToDto(S),U=this.createDebugAdapter(A,u);if(!U)throw new Error(`Couldn't create a debug adapter for type '${u.type}'.`);const H=U;return this._debugAdapters.set(s,H),this.getDebugAdapterTrackers(u).then(E=>(E&&this._debugAdaptersTrackers.set(s,E),H.onMessage(async L=>{if(L.type==="request"&&L.command==="handshake"){const z=L,N={type:"response",seq:0,command:z.command,request_seq:z.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const B=await this._signService.sign(z.arguments.value);N.body={signature:B},H.sendResponse(N)}else throw new Error("no signer")}catch(B){N.success=!1,N.message=B.message,H.sendResponse(N)}}else E&&E.onDidSendMessage&&E.onDidSendMessage(L),L=(0,o.convertToVSCPaths)(L,!0),y._debugServiceProxy.$acceptDAMessage(s,L)}),H.onError(L=>{E&&E.onError&&E.onError(L),this._debugServiceProxy.$acceptDAError(s,L.name,L.message,L.stack)}),H.onExit(L=>{E&&E.onExit&&E.onExit((0,D.withNullAsUndefined)(L),void 0),this._debugServiceProxy.$acceptDAExit(s,(0,D.withNullAsUndefined)(L),void 0)}),E&&E.onWillStartSession&&E.onWillStartSession(),H.startSession()))})}$sendDAMessage(s,b){b=(0,o.convertToDAPaths)(b,!1);const y=this._debugAdaptersTrackers.get(s);y&&y.onWillReceiveMessage&&y.onWillReceiveMessage(b);const u=this._debugAdapters.get(s);u&&u.sendMessage(b)}$stopDASession(s){const b=this._debugAdaptersTrackers.get(s);this._debugAdaptersTrackers.delete(s),b&&b.onWillStopSession&&b.onWillStopSession();const y=this._debugAdapters.get(s);return this._debugAdapters.delete(s),y?y.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const b=[],y=[],u=[];if(s.added)for(const S of s.added){const A=S.id;if(A&&!this._breakpoints.has(A)){let U;if(S.type==="function")U=new P.FunctionBreakpoint(S.functionName,S.enabled,S.condition,S.hitCondition,S.logMessage);else if(S.type==="data")U=new P.DataBreakpoint(S.label,S.dataId,S.canPersist,S.enabled,S.hitCondition,S.condition,S.logMessage);else{const H=t.URI.revive(S.uri);U=new P.SourceBreakpoint(new P.Location(H,new P.Position(S.line,S.character)),S.enabled,S.condition,S.hitCondition,S.logMessage)}U._id=A,this._breakpoints.set(A,U),b.push(U)}}if(s.removed)for(const S of s.removed){const A=this._breakpoints.get(S);A&&(this._breakpoints.delete(S),y.push(A))}if(s.changed){for(const S of s.changed)if(S.id){const A=this._breakpoints.get(S.id);if(A){if(A instanceof P.FunctionBreakpoint&&S.type==="function"){const U=A;U.enabled=S.enabled,U.condition=S.condition,U.hitCondition=S.hitCondition,U.logMessage=S.logMessage,U.functionName=S.functionName}else if(A instanceof P.SourceBreakpoint&&S.type==="source"){const U=A;U.enabled=S.enabled,U.condition=S.condition,U.hitCondition=S.hitCondition,U.logMessage=S.logMessage,U.location=new P.Location(t.URI.revive(S.uri),new P.Position(S.line,S.character))}u.push(A)}}}this.fireBreakpointChanges(b,y,u)}$provideDebugConfigurations(s,b,y){return(0,T.asPromise)(async()=>{const u=this.getConfigProviderByHandle(s);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const S=await this.getFolder(b);return u.provideDebugConfigurations(S,y)}).then(u=>{if(!u)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return u})}$resolveDebugConfiguration(s,b,y,u){return(0,T.asPromise)(async()=>{const S=this.getConfigProviderByHandle(s);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const A=await this.getFolder(b);return S.resolveDebugConfiguration(A,y,u)})}$resolveDebugConfigurationWithSubstitutedVariables(s,b,y,u){return(0,T.asPromise)(async()=>{const S=this.getConfigProviderByHandle(s);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const A=await this.getFolder(b);return S.resolveDebugConfigurationWithSubstitutedVariables(A,y,u)})}async $provideDebugAdapter(s,b){const y=this.getAdapterDescriptorFactoryByHandle(s);if(!y)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const u=await this.getSession(b);return this.getAdapterDescriptor(y,u).then(S=>{if(!S)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}'`);return this.convertToDto(S)})}async $acceptDebugSessionStarted(s){const b=await this.getSession(s);this._onDidStartDebugSession.fire(b)}async $acceptDebugSessionTerminated(s){const b=await this.getSession(s);b&&(this._onDidTerminateDebugSession.fire(b),this._debugSessions.delete(b.id))}async $acceptDebugSessionActiveChanged(s){this._activeDebugSession=s?await this.getSession(s):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(s,b){const y=await this.getSession(s);y&&y._acceptNameChanged(b)}async $acceptDebugSessionCustomEvent(s,b){const u={session:await this.getSession(s),event:b.event,body:b.body};this._onDidReceiveDebugSessionCustomEvent.fire(u)}convertToDto(s){if(s instanceof P.DebugAdapterExecutable)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof P.DebugAdapterServer)return{type:"server",port:s.port,host:s.host};if(s instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:s.path};if(s instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(s){const b=this._adapterFactories.filter(y=>y.type===s);if(b.length>0)return b[0].factory}getAdapterDescriptorFactoryByHandle(s){const b=this._adapterFactories.filter(y=>y.handle===s);if(b.length>0)return b[0].factory}getConfigProviderByHandle(s){const b=this._configProviders.filter(y=>y.handle===s);if(b.length>0)return b[0].provider}definesDebugType(s,b){if(s.contributes){const y=s.contributes.debuggers;if(y&&y.length>0){for(const u of y)if(u.label&&u.type&&u.type===b)return!0}}return!1}getDebugAdapterTrackers(s){const y=s.configuration.type,u=this._trackerFactories.filter(S=>S.type===y||S.type==="*").map(S=>(0,T.asPromise)(()=>S.factory.createDebugAdapterTracker(s)).then(A=>A,A=>null));return Promise.race([Promise.all(u).then(S=>{const A=S.filter(U=>!!U);if(A.length>0)return new r(A)}),new Promise((S,A)=>{const U=setTimeout(()=>{clearTimeout(U),A(new Error("timeout"))},1e3)})]).catch(S=>{})}async getAdapterDescriptor(s,b){const y=b.configuration.debugServer;if(typeof y=="number")return Promise.resolve(new P.DebugAdapterServer(y));if(s){const S=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>s.createDebugAdapterDescriptor(b,this.daExecutableFromPackage(b,S))).then(A=>{if(A)return A})}const u=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(b,u))}daExecutableFromPackage(s,b){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(s,b,y){(s.length>0||b.length>0||y.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:s,removed:b,changed:y}))}async getSession(s){if(s)if(typeof s=="string"){const b=this._debugSessions.get(s);if(b)return b}else{let b=this._debugSessions.get(s.id);if(!b){const y=await this.getFolder(s.folderUri),u=s.parent?this._debugSessions.get(s.parent):void 0;b=new I(this._debugServiceProxy,s.id,s.type,s.name,y,s.configuration,u),this._debugSessions.set(b.id,b),this._debugServiceProxy.$sessionCached(b.id)}return b}throw new Error("cannot find session")}getFolder(s){if(s){const b=t.URI.revive(s);return this._workspaceService.resolveWorkspaceFolder(b)}return Promise.resolve(void 0)}};p=Ue([$e(0,g.IExtHostRpcService),$e(1,R.IExtHostWorkspace),$e(2,F.IExtHostExtensionService),$e(3,_.IExtHostDocumentsAndEditors),$e(4,f.IExtHostConfiguration),$e(5,h.IExtHostEditorTabs)],p),e.ExtHostDebugServiceBase=p;class I{constructor(s,b,y,u,S,A,U){this._debugServiceProxy=s,this._id=b,this._type=y,this._name=u,this._workspaceFolder=S,this._configuration=A,this._parentSession=U}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(s){this._name=s,this._debugServiceProxy.$setDebugSessionName(this._id,s)}get parentSession(){return this._parentSession}_acceptNameChanged(s){this._name=s}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(s,b){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,s,b)}getDebugProtocolBreakpoint(s){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,s.id)}}e.ExtHostDebugSession=I;class l{constructor(s){this.value=Object.freeze({append(b){s.$appendDebugConsole(b)},appendLine(b){this.append(b+`
`)}})}}e.ExtHostDebugConsole=l;class M extends n.AbstractVariableResolverService{constructor(s,b,y,u,S){function A(){if(b){const U=b.activeEditor();if(U)return U.document.uri;const H=u.tabs.filter(E=>E.isActive);if(H.length>0){const E=H[0].resource;return E&&(E.primary||E.secondary)?E.primary??E.secondary:H[0].resource}}}super({getFolderUri:U=>{const H=s.filter(E=>E.name===U);if(H&&H.length>0)return H[0].uri},getWorkspaceFolderCount:()=>s.length,getConfigurationValue:(U,H)=>y.getConfiguration(void 0,U).get(H),getAppRoot:()=>v.cwd(),getExecPath:()=>v.env.VSCODE_EXEC_PATH,getFilePath:()=>{const U=A();if(U)return a.normalize(U.fsPath)},getWorkspaceFolderPathForFile:()=>{if(S){const U=A();if(U){const H=S.getWorkspaceFolder(U);if(H)return a.normalize(H.uri.fsPath)}}},getSelectedText:()=>{if(b){const U=b.activeEditor();if(U&&!U.selection.isEmpty)return U.document.getText(U.selection)}},getLineNumber:()=>{if(b){const U=b.activeEditor();if(U)return String(U.selection.end.line+1)}}},void 0,Promise.resolve(v.env))}}e.ExtHostVariableResolverService=M;class r{constructor(s){this.trackers=s}onWillStartSession(){this.trackers.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.trackers.forEach(b=>b.onWillReceiveMessage?b.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.trackers.forEach(b=>b.onDidSendMessage?b.onDidSendMessage(s):void 0)}onWillStopSession(){this.trackers.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.trackers.forEach(b=>b.onError?b.onError(s):void 0)}onExit(s,b){this.trackers.forEach(y=>y.onExit?y.onExit(s,b):void 0)}}class i extends C.AbstractDebugAdapter{constructor(s){super();this.implementation=s,s.onDidSendMessage(b=>{this.acceptMessage(b)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.implementation.handleMessage(s)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let m=class extends p{constructor(s,b,y,u,S,A){super(s,b,y,u,S,A)}createVariableResolver(s,b,y){return new M(s,b,y,this._editorTabs)}};m=Ue([$e(0,g.IExtHostRpcService),$e(1,R.IExtHostWorkspace),$e(2,F.IExtHostExtensionService),$e(3,_.IExtHostDocumentsAndEditors),$e(4,f.IExtHostConfiguration),$e(5,h.IExtHostEditorTabs)],m),e.WorkerExtHostDebugService=m}),define(Ee[215],ye([0,1,73,2,5,32,27,25,13,28,3,33,89,12]),function(re,e,a,t,w,T,k,P,C,R,F,_,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let o=class{constructor(h,p,I,l,M,r,i){this._apiFactory=h,this._extensionRegistry=p,this._instaService=I,this._extHostConfiguration=l,this._extHostExtensionService=M,this._initData=r,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),a.mark("code/extHost/willWaitForConfig");const h=await this._extHostConfiguration.getConfigProvider();a.mark("code/extHost/didWaitForConfig");const p=await this._extHostExtensionService.getExtensionPathIndex();this.register(new g(this._apiFactory,p,this._extensionRegistry,h,this._logService)),this.register(this._instaService.createInstance(c,p)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(D,p,this._initData.environment.appUriScheme))}register(h){if(Array.isArray(h.nodeModuleName))for(let p of h.nodeModuleName)this._factories.set(p,h);else this._factories.set(h.nodeModuleName,h);typeof h.alternativeModuleName=="function"&&this._alternatives.push(p=>h.alternativeModuleName(p))}};o=Ue([$e(2,F.IInstantiationService),$e(3,T.IExtHostConfiguration),$e(4,_.IExtHostExtensionService),$e(5,R.IExtHostInitDataService),$e(6,f.ILogService)],o),e.RequireInterceptor=o;class g{constructor(h,p,I,l,M){this._apiFactory=h,this._extensionPaths=p,this._extensionRegistry=I,this._configProvider=l,this._logService=M,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(h,p){const I=this._extensionPaths.findSubstr(p);if(I){let l=this._extApiImpl.get(P.ExtensionIdentifier.toKey(I.identifier));return l||(l=this._apiFactory(I,this._extensionRegistry,this._configProvider),this._extApiImpl.set(P.ExtensionIdentifier.toKey(I.identifier),l)),l}if(!this._defaultApiImpl){let l="";this._extensionPaths.forEach((M,r)=>l+=`	${r} -> ${M.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${p}. These are the extension path mappings: 
${l}`),this._defaultApiImpl=this._apiFactory(k.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let c=class{constructor(h,p,I){this._extensionPaths=h,this.nodeModuleName="keytar",this._mainThreadTelemetry=p.getProxy(w.MainContext.MainThreadTelemetry);const{environment:l}=I,M=p.getProxy(w.MainContext.MainThreadKeytar);if(l.appRoot){let r=l.appRoot.fsPath;n.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,i)=>M.$getPassword(r,i),setPassword:(r,i,m)=>M.$setPassword(r,i,m),deletePassword:(r,i)=>M.$deletePassword(r,i),findPassword:r=>M.$findPassword(r),findCredentials(r){return M.$findCredentials(r)}}}load(h,p){const I=this._extensionPaths.findSubstr(p);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:I?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(h){const p=h.length;if(p<=7||!this.alternativeNames)return;const I=p-7;if((h.charAt(I)==="/"||h.charAt(I)==="\\")&&h.endsWith("keytar")&&(h=h.replace(/\\/g,"/"),this.alternativeNames.has(h)))return"keytar"}};c=Ue([$e(1,C.IExtHostRpcService),$e(2,R.IExtHostInitDataService)],c);let D=class{constructor(h,p,I){this._extensionPaths=h,this._appUriScheme=p,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=I.getProxy(w.MainContext.MainThreadTelemetry);const l=I.getProxy(w.MainContext.MainThreadWindow);this._impl=(M,r)=>{const i=t.URI.parse(M);return r?this.callOriginal(M,r):i.scheme==="http"||i.scheme==="https"?l.$openUri(i,M,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?l.$openUri(i,M,{}):this.callOriginal(M,r)}}load(h,p,I){const l=this._extensionPaths.findSubstr(p);return l&&(this._extensionId=l.identifier.value,this.sendShimmingTelemetry()),this._original=I(h),this._impl}callOriginal(h,p){return this.sendNoForwardTelemetry(),this._original(h,p)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};D=Ue([$e(2,C.IExtHostRpcService)],D)}),define(Ee[216],ye([0,1,14,15,73,6,2,5,209,12,56,60,28,137,13,65,33,39]),function(re,e,a,t,w,T,k,P,C,R,F,_,n,f,o,g,c,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class v{constructor(p,I,l,M){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=l,this._rpcProtocol=new C.RPCProtocol(p,null,M),I=v._transform(I,this._rpcProtocol);const r=new _.ServiceCollection(...(0,F.getSingletonServiceDescriptors)());r.set(n.IExtHostInitDataService,{_serviceBrand:void 0,...I}),r.set(o.IExtHostRpcService,new o.ExtHostRpcService(this._rpcProtocol)),r.set(g.IURITransformerService,new g.URITransformerService(M)),r.set(c.IHostUtils,l);const i=new f.InstantiationService(r,!0);this._disposables.add(i.invokeFunction(b=>b.get(D.IExtHostTerminalService))),this._disposables.add(i.invokeFunction(b=>b.get(c.IExtHostExtensionService))),this._logService=i.invokeFunction(b=>b.get(R.ILogService)),w.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",I),this._extensionService=i.invokeFunction(b=>b.get(c.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const m=new WeakMap;this._extensionService.getExtensionPathIndex().then(b=>{Error.prepareStackTrace=(y,u)=>{let S="",A,U;for(const H of u)S+=`
	at ${H.toString()}`,U=H.getFileName(),!A&&U&&(A=b.findSubstr(k.URI.file(U)));return m.set(y,A),`${y.name||"Error"}: ${y.message||""}${S}`}});const d=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService),s=this._rpcProtocol.getProxy(P.MainContext.MainThreadErrors);t.setUnexpectedErrorHandler(b=>{const y=t.transformErrorForSerialization(b),u=m.get(b);u?d.$onExtensionRuntimeError(u.identifier,y):s.$onUnexpectedError(y)})}terminate(p){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${p}`),this._logService.flush(),this._disposables.dispose(),t.setUnexpectedErrorHandler(l=>{this._logService.error(l)}),this._rpcProtocol.dispose();const I=this._extensionService.deactivateAll();Promise.race([(0,a.timeout)(5e3),I]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(p,I){p.extensions.forEach(M=>M.extensionLocation=k.URI.revive(I.transformIncomingURIs(M.extensionLocation))),p.environment.appRoot=k.URI.revive(I.transformIncomingURIs(p.environment.appRoot));const l=p.environment.extensionDevelopmentLocationURI;return l&&(p.environment.extensionDevelopmentLocationURI=l.map(M=>k.URI.revive(I.transformIncomingURIs(M)))),p.environment.extensionTestsLocationURI=k.URI.revive(I.transformIncomingURIs(p.environment.extensionTestsLocationURI)),p.environment.globalStorageHome=k.URI.revive(I.transformIncomingURIs(p.environment.globalStorageHome)),p.environment.workspaceStorageHome=k.URI.revive(I.transformIncomingURIs(p.environment.workspaceStorageHome)),p.logsLocation=k.URI.revive(I.transformIncomingURIs(p.logsLocation)),p.logFile=k.URI.revive(I.transformIncomingURIs(p.logFile)),p.workspace=I.transformIncomingURIs(p.workspace),p}}e.ExtensionHostMain=v}),define(Ee[217],ye([0,1,17,20,43,29,24,190,40]),function(re,e,a,t,w,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class R{constructor(n,f,o){this.config=n,this.provider=f,this.sessionToken=o,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=n.filePattern,this.includePattern=n.includePattern&&T.parse(n.includePattern),this.maxResults=n.maxResults||void 0,this.exists=n.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=n.excludePattern&&T.parse(n.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(n=>n.cancel()),this.activeCancellationTokens=new Set}search(n){const f=this.config.folderQueries||[];return new Promise((o,g)=>{const c=D=>{this.resultCount++,n(D)};if(this.isCanceled)return o({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(D=>{const v=D.toString(),h=a.basename(v);this.globalExcludePattern&&this.globalExcludePattern(v,h)||this.matchFile(c,{base:D,basename:h})}),Promise.all(f.map(D=>this.searchInFolder(D,c))).then(D=>{o({limitHit:this.isLimitHit,stats:D[0]||void 0})},D=>{g(new Error((0,w.toErrorMessage)(D)))})})}async searchInFolder(n,f){const o=new t.CancellationTokenSource,g=this.getSearchOptionsForFolder(n),c=this.initDirectoryTree(),D=new C.QueryGlobTester(this.config,n),v=!D.hasSiblingExcludeClauses();let h;try{this.activeCancellationTokens.add(o),h=P.StopWatch.create();const p=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},g,o.token),I=h.elapsed(),l=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(p&&p.forEach(M=>{const r=a.posix.relative(n.folder.path,M.path);if(v){const i=a.basename(M.path);this.matchFile(f,{base:n.folder,relativePath:r,basename:i});return}this.addDirectoryEntries(c,n.folder,r,f)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(c,D,f),{providerTime:I,postProcessTime:l.elapsed()})}finally{o.dispose(),this.activeCancellationTokens.delete(o)}}getSearchOptionsForFolder(n){const f=(0,C.resolvePatternsForProvider)(this.config.includePattern,n.includePattern),o=(0,C.resolvePatternsForProvider)(this.config.excludePattern,n.excludePattern);return{folder:n.folder,excludes:o,includes:f,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,followSymlinks:!n.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries({pathToEntries:n},f,o,g){if(o===this.filePattern){const D=a.basename(this.filePattern);this.matchFile(g,{base:f,relativePath:this.filePattern,basename:D})}function c(D){const v=a.basename(D),h=a.dirname(D);let p=n[h];p||(p=n[h]=[],c(h)),p.push({base:f,relativePath:D,basename:v})}c(o)}matchDirectoryTree({rootEntries:n,pathToEntries:f},o,g){const c=this,D=this.filePattern;function v(h){const p=T.hasSiblingFn(()=>h.map(I=>I.basename));for(let I=0,l=h.length;I<l;I++){const M=h[I],{relativePath:r,basename:i}=M;if(o.matchesExcludesSync(r,i,D!==i?p:void 0))continue;const m=f[r];if(m)v(m);else{if(r===D)continue;c.matchFile(g,M)}if(c.isLimitHit)break}}v(n)}matchFile(n,f){(!this.includePattern||f.relativePath&&this.includePattern(f.relativePath,f.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||n(f))}}class F{constructor(){this.sessions=new Map}fileSearch(n,f,o,g){const c=this.getSessionTokenSource(n.cacheKey),D=new R(n,f,c&&c.token);let v=0;const h=p=>{v+=p.length,o(p.map(I=>this.rawMatchToSearchItem(I)))};return this.doSearch(D,F.BATCH_SIZE,h,g).then(p=>({limitHit:p.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:v,detailStats:p.stats}}))}clearCache(n){const f=this.getSessionTokenSource(n);f&&f.cancel()}getSessionTokenSource(n){if(!!n)return this.sessions.has(n)||this.sessions.set(n,new t.CancellationTokenSource),this.sessions.get(n)}rawMatchToSearchItem(n){return n.relativePath?{resource:k.joinPath(n.base,n.relativePath)}:{resource:n.base}}doSearch(n,f,o,g){g.onCancellationRequested(()=>{n.cancel()});const c=v=>{v&&(D.push(v),f>0&&D.length>=f&&(o(D),D=[]))};let D=[];return n.search(c).then(v=>(D.length&&o(D),v),v=>(D.length&&o(D),Promise.reject(v)))}}e.FileSearchManager=F,F.BATCH_SIZE=512}),define(Ee[218],ye([0,1,16,20,43,29,10,17,24,11,2,40]),function(re,e,a,t,w,T,k,P,C,R,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class n{constructor(h,p,I,l){this.query=h,this.provider=p,this.fileUtils=I,this.processType=l,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(h,p){const I=this.query.folderQueries||[],l=new t.CancellationTokenSource;return p.onCancellationRequested(()=>l.cancel()),new Promise((M,r)=>{this.collector=new o(h);let i=!1;const m=(d,s)=>{if(!i&&!this.isLimitHit){const b=this.resultSize(d);c(d)&&typeof this.query.maxResults=="number"&&this.resultCount+b>this.query.maxResults&&(this.isLimitHit=!0,i=!0,l.cancel(),d=this.trimResultToSize(d,this.query.maxResults-this.resultCount));const y=this.resultSize(d);this.resultCount+=y,(y>0||!c(d))&&this.collector.add(d,s)}};Promise.all(I.map((d,s)=>this.searchInFolder(d,b=>m(b,s),l.token))).then(d=>{l.dispose(),this.collector.flush();const s=d.some(b=>!!b&&!!b.limitHit);M({limitHit:this.isLimitHit||s,messages:(0,a.flatten)(d.map(b=>b?.message?(0,R.isArray)(b.message)?b.message:[b.message]:[])),stats:{type:this.processType}})},d=>{l.dispose();const s=(0,w.toErrorMessage)(d);r(new Error(s))})})}resultSize(h){return c(h)?Array.isArray(h.ranges)?h.ranges.length:1:0}trimResultToSize(h,p){const I=Array.isArray(h.ranges)?h.ranges:[h.ranges],l=Array.isArray(h.preview.matches)?h.preview.matches:[h.preview.matches];return{ranges:I.slice(0,p),preview:{matches:l.slice(0,p),text:h.preview.text},uri:h.uri}}async searchInFolder(h,p,I){const l=new _.QueryGlobTester(this.query,h),M=[],r={report:d=>{if(!this.validateProviderResult(d))return;const s=h.folder.scheme===k.Schemas.file?T.hasSiblingPromiseFn(()=>this.fileUtils.readdir(C.dirname(d.uri))):void 0,b=C.relativePath(h.folder,d.uri);if(b){const y=l.includedInQuery(b,P.basename(b),s);(0,R.isPromise)(y)?M.push(y.then(u=>{u&&p(d)})):y&&p(d)}}},i=this.getSearchOptionsForFolder(h),m=await this.provider.provideTextSearchResults(f(this.query.contentPattern),i,r,I);return M.length&&await Promise.all(M),m}validateProviderResult(h){if(c(h)){if(Array.isArray(h.ranges)){if(!Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(h.preview.matches.length!==h.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(h){const p=(0,_.resolvePatternsForProvider)(this.query.includePattern,h.includePattern),I=(0,_.resolvePatternsForProvider)(this.query.excludePattern,h.excludePattern),l={folder:F.URI.from(h.folder),excludes:I,includes:p,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,followSymlinks:!h.ignoreSymlinks,encoding:h.fileEncoding&&this.fileUtils.toCanonicalName(h.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return l.usePCRE2=this.query.usePCRE2,l}}e.TextSearchManager=n;function f(v){return{isCaseSensitive:v.isCaseSensitive||!1,isRegExp:v.isRegExp||!1,isWordMatch:v.isWordMatch||!1,isMultiline:v.isMultiline||!1,pattern:v.pattern}}class o{constructor(h){this._onResult=h,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new D(512,p=>this.sendItems(p))}add(h,p){this._currentFileMatch&&(this._currentFolderIdx!==p||!C.isEqual(this._currentUri,h.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=p,this._currentFileMatch={resource:h.uri,results:[]}),this._currentFileMatch.results.push(g(h))}pushToCollector(){const h=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,h)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(h){this._onResult(h)}}e.TextSearchResultsCollector=o;function g(v){return c(v)?{preview:{matches:(0,a.mapArrayOrNot)(v.preview.matches,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character})),text:v.preview.text},ranges:(0,a.mapArrayOrNot)(v.ranges,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character}))}:{text:v.text,lineNumber:v.lineNumber}}function c(v){return!!v.preview}e.extensionResultIsMatch=c;class D{constructor(h,p){this.maxBatchSize=h,this.cb=p,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(h,p){!h||this.addItemToBatch(h,p)}addItems(h,p){!h||this.addItemsToBatch(h,p)}addItemToBatch(h,p){this.batch.push(h),this.batchSize+=p,this.onUpdate()}addItemsToBatch(h,p){this.batch=this.batch.concat(h),this.batchSize+=p,this.onUpdate()}onUpdate(){this.totalNumberCompleted<D.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},D.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=D,D.TIMEOUT=4e3,D.START_BATCH_AFTER_COUNT=50}),define(Ee[99],ye([0,1,6,5,3,217,13,65,12,2,218]),function(re,e,a,t,w,T,k,P,C,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,w.createDecorator)("IExtHostSearch");let _=class{constructor(g,c,D){this.extHostRpc=g,this._uriTransformer=c,this._logService=D,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(g){return this._uriTransformer.transformOutgoingScheme(g)}registerTextSearchProvider(g,c){if(this._textSearchUsedSchemes.has(g))throw new Error(`a text search provider for the scheme '${g}' is already registered`);this._textSearchUsedSchemes.add(g);const D=this._handlePool++;return this._textSearchProvider.set(D,c),this._proxy.$registerTextSearchProvider(D,this._transformScheme(g)),(0,a.toDisposable)(()=>{this._textSearchUsedSchemes.delete(g),this._textSearchProvider.delete(D),this._proxy.$unregisterProvider(D)})}registerFileSearchProvider(g,c){if(this._fileSearchUsedSchemes.has(g))throw new Error(`a file search provider for the scheme '${g}' is already registered`);this._fileSearchUsedSchemes.add(g);const D=this._handlePool++;return this._fileSearchProvider.set(D,c),this._proxy.$registerFileSearchProvider(D,this._transformScheme(g)),(0,a.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(g),this._fileSearchProvider.delete(D),this._proxy.$unregisterProvider(D)})}$provideFileSearchResults(g,c,D,v){const h=n(D),p=this._fileSearchProvider.get(g);if(p)return this._fileSearchManager.fileSearch(h,p,I=>{this._proxy.$handleFileMatch(g,c,I.map(l=>l.resource))},v);throw new Error("unknown provider: "+g)}$clearCache(g){return this._fileSearchManager.clearCache(g),Promise.resolve(void 0)}$provideTextSearchResults(g,c,D,v){const h=this._textSearchProvider.get(g);if(!h||!h.provideTextSearchResults)throw new Error(`Unknown provider ${g}`);const p=n(D);return this.createTextSearchManager(p,h).search(l=>this._proxy.$handleTextMatch(g,c,l),v)}$enableExtensionHostSearch(){}createTextSearchManager(g,c){return new F.TextSearchManager(g,c,{readdir:D=>Promise.resolve([]),toCanonicalName:D=>D},"textSearchProvider")}};_=Ue([$e(0,k.IExtHostRpcService),$e(1,P.IURITransformerService),$e(2,C.ILogService)],_),e.ExtHostSearch=_;function n(o){return{...o,folderQueries:o.folderQueries&&o.folderQueries.map(f),extraFileResources:o.extraFileResources&&o.extraFileResources.map(g=>R.URI.revive(g))}}e.reviveQuery=n;function f(o){return{...o,folder:R.URI.revive(o.folder)}}}),define(Ee[219],ye([0,1,20,15,4,34,2,113,232,107,55,45,5,180,179,38,181,32,182,183,184,165,185,48,33,186,166,189,191,193,94,168,198,199,200,71,39,202,169,8,7,205,50,95,31,74,154,188,61,93,97,98,99,12,65,13,28,194,151,64,69,177,203,150,72,49,208,206,207,178,30,201,204,68,70,85,196,96,197,10,139,195,148,187,6,27]),function(re,e,a,t,w,T,k,P,C,R,F,_,n,f,o,g,c,D,v,h,p,I,l,M,r,i,m,d,s,b,y,u,S,A,U,H,E,L,z,N,B,j,ce,K,le,ue,Y,ie,we,Me,Re,Be,Qe,Ke,Xe,$,G,J,ae,q,te,me,Pe,Ne,He,Ye,et,st,Je,nt,lt,pt,Ft,Fe,Mt,V,Q,he,Le,We,ot,Ge,yt,Ie,Ce,ve){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function oe(se){const fe=se.get(G.IExtHostInitDataService),ge=se.get(lt.IExtHostFileSystemInfo),ke=se.get(Ye.IExtHostConsumerFileSystem),ze=se.get(r.IExtHostExtensionService),Oe=se.get(le.IExtHostWorkspace),Ve=se.get(V.IExtHostTelemetry),it=se.get(D.IExtHostConfiguration),rt=se.get(Xe.IURITransformerService),ne=se.get($.IExtHostRpcService),pe=se.get(H.IExtHostStorage),ee=se.get(He.IExtensionStoragePaths),W=se.get(Ke.ILoggerService),be=se.get(Ke.ILogService),De=se.get(q.IExtHostTunnelService),qe=se.get(te.IExtHostApiDeprecationService),xe=se.get(K.IExtHostWindow),ut=se.get(Fe.IExtHostSecretState),vt=se.get(Mt.IExtHostEditorTabs);ne.set(n.ExtHostContext.ExtHostFileSystemInfo,ge),ne.set(n.ExtHostContext.ExtHostLogLevelServiceShape,W),ne.set(n.ExtHostContext.ExtHostWorkspace,Oe),ne.set(n.ExtHostContext.ExtHostConfiguration,it),ne.set(n.ExtHostContext.ExtHostExtensionService,ze),ne.set(n.ExtHostContext.ExtHostStorage,pe),ne.set(n.ExtHostContext.ExtHostTunnelService,De),ne.set(n.ExtHostContext.ExtHostWindow,xe),ne.set(n.ExtHostContext.ExtHostSecretState,ut),ne.set(n.ExtHostContext.ExtHostTelemetry,Ve),ne.set(n.ExtHostContext.ExtHostEditorTabs,vt);const St=ne.set(n.ExtHostContext.ExtHostDecorations,se.get(Me.IExtHostDecorations)),bt=ne.set(n.ExtHostContext.ExtHostDocumentsAndEditors,se.get(M.IExtHostDocumentsAndEditors)),ht=ne.set(n.ExtHostContext.ExtHostCommands,se.get(g.IExtHostCommands)),gt=ne.set(n.ExtHostContext.ExtHostTerminalService,se.get(E.IExtHostTerminalService)),_t=ne.set(n.ExtHostContext.ExtHostDebugService,se.get(Be.IExtHostDebugService)),Lt=ne.set(n.ExtHostContext.ExtHostSearch,se.get(Qe.IExtHostSearch)),It=ne.set(n.ExtHostContext.ExtHostTask,se.get(Re.IExtHostTask)),Pt=ne.set(n.ExtHostContext.ExtHostOutputService,se.get(y.IExtHostOutputService)),At=ne.set(n.ExtHostContext.ExtHostUrls,new j.ExtHostUrls(ne)),Et=ne.set(n.ExtHostContext.ExtHostDocuments,new l.ExtHostDocuments(ne,bt)),Ot=ne.set(n.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(ne,bt,be)),Nt=ne.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new I.ExtHostDocumentSaveParticipant(be,Et,ne.getProxy(n.MainContext.MainThreadBulkEdits))),wt=ne.set(n.ExtHostContext.ExtHostNotebook,new J.ExtHostNotebookController(ne,ht,bt,Et,ee)),$t=ne.set(n.ExtHostContext.ExtHostNotebookDocuments,new yt.ExtHostNotebookDocuments(be,wt)),jt=ne.set(n.ExtHostContext.ExtHostNotebookEditors,new Ge.ExtHostNotebookEditors(be,ne,wt)),oi=ne.set(n.ExtHostContext.ExtHostNotebookKernels,new Q.ExtHostNotebookKernels(ne,fe,wt,ht,be)),si=ne.set(n.ExtHostContext.ExtHostNotebookRenderers,new Le.ExtHostNotebookRenderers(ne,wt)),Tt=ne.set(n.ExtHostContext.ExtHostEditors,new L.ExtHostEditors(ne,bt)),Yt=ne.set(n.ExtHostContext.ExtHostTreeViews,new z.ExtHostTreeViews(ne.getProxy(n.MainContext.MainThreadTreeViews),ht,be)),ai=ne.set(n.ExtHostContext.ExtHostEditorInsets,new Y.ExtHostEditorInsets(ne.getProxy(n.MainContext.MainThreadEditorInsets),Tt,fe)),Xt=ne.set(n.ExtHostContext.ExtHostDiagnostics,new v.ExtHostDiagnostics(ne,be,ge)),Vt=ne.set(n.ExtHostContext.ExtHostLanguages,new s.ExtHostLanguages(ne,Et,ht.converter,rt)),mt=ne.set(n.ExtHostContext.ExtHostLanguageFeatures,new d.ExtHostLanguageFeatures(ne,rt,Et,ht,Xt,be,qe)),li=ne.set(n.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(ne,mt)),xt=ne.set(n.ExtHostContext.ExtHostFileSystemEventService,new m.ExtHostFileSystemEventService(ne,be,bt)),qt=ne.set(n.ExtHostContext.ExtHostQuickOpen,(0,S.createExtHostQuickOpen)(ne,Oe,ht)),Jt=ne.set(n.ExtHostContext.ExtHostSCM,new A.ExtHostSCM(ne,ht,be)),ci=ne.set(n.ExtHostContext.ExtHostComments,(0,c.createExtHostComments)(ne,ht,Et)),fi=ne.set(n.ExtHostContext.ExtHostProgress,new u.ExtHostProgress(ne.getProxy(n.MainContext.MainThreadProgress))),Ei=ne.set(n.ExtHostContext.ExtHosLabelService,new ie.ExtHostLabelService(ne)),mi=ne.set(n.ExtHostContext.ExtHostTheming,new ae.ExtHostTheming(ne)),Zt=ne.set(n.ExtHostContext.ExtHostAuthentication,new me.ExtHostAuthentication(ne)),yi=ne.set(n.ExtHostContext.ExtHostTimeline,new Pe.ExtHostTimeline(ne,ht)),Kt=ne.set(n.ExtHostContext.ExtHostWebviews,new ce.ExtHostWebviews(ne,{remote:fe.remote},Oe,be,qe)),Gt=ne.set(n.ExtHostContext.ExtHostWebviewPanels,new Je.ExtHostWebviewPanels(ne,Kt,Oe)),_i=ne.set(n.ExtHostContext.ExtHostCustomEditors,new st.ExtHostCustomEditors(ne,Et,ee,Kt,Gt)),Ci=ne.set(n.ExtHostContext.ExtHostWebviewViews,new et.ExtHostWebviewViews(ne,Kt)),Qt=ne.set(n.ExtHostContext.ExtHostTesting,new pt.ExtHostTesting(ne,ht)),Si=ne.set(n.ExtHostContext.ExtHostUriOpeners,new Ft.ExtHostUriOpeners(ne));ne.set(n.ExtHostContext.ExtHostInteractive,new Ie.ExtHostInteractive(ne,wt,bt,ht));const ei=(0,ue.values)(n.ExtHostContext);ne.assertRegistered(ei);const Di=new nt.ExtHostBulkEdits(ne,bt),ki=new o.ExtHostClipboard(ne),ui=new b.ExtHostMessageService(ne,be),ti=new h.ExtHostDialogs(ne),gi=new U.ExtHostStatusBar(ne,ht.converter);return f.ExtHostApiCommands.register(ht),function(Ae,Ut,pi){const ft=function(){let X=!Ae.isUnderDevelopment;function de(){X||(be.info(`Extension '${Ae.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),X=!0)}return function Se(ct){if(Array.isArray(ct))ct.forEach(Se);else if(typeof ct=="string")de();else{const Ct=ct;typeof Ct.scheme=="undefined"&&de(),typeof Ct.exclusive=="boolean"&&(0,ve.checkProposedApiEnabled)(Ae,"documentFiltersExclusive")}return ct}}(),ii={getSession(X,de,Se){return Zt.getSession(Ae,X,de,Se)},async hasSession(X,de){return(0,ve.checkProposedApiEnabled)(Ae,"authSession"),!!await Zt.getSession(Ae,X,de,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(X,de,Se,ct){return Zt.registerAuthenticationProvider(X,de,Se,ct)}},Ii={registerCommand(X,de,Se){return ht.registerCommand(!0,X,de,Se,void 0,Ae)},registerTextEditorCommand(X,de,Se){return ht.registerCommand(!0,X,(...ct)=>{const Ct=Tt.getActiveTextEditor();if(!Ct){be.warn("Cannot execute "+X+" because there is no active text editor.");return}return Ct.edit(Dt=>{de.apply(Se,[Ct,Dt,...ct])}).then(Dt=>{Dt||be.warn("Edits from command "+X+" were not applied.")},Dt=>{be.warn("An error occurred while running command "+X,Dt)})},void 0,void 0,Ae)},registerDiffInformationCommand:(X,de,Se)=>((0,ve.checkProposedApiEnabled)(Ae,"diffCommand"),ht.registerCommand(!0,X,async(...ct)=>{const Ct=bt.activeEditor(!0);if(!Ct){be.warn("Cannot execute "+X+" because there is no active text editor.");return}const Dt=await Tt.getDiffInformation(Ct.id);de.apply(Se,[Dt,...ct])},void 0,void 0,Ae)),executeCommand(X,...de){return ht.executeCommand(X,...de)},getCommands(X=!1){return ht.getCommands(X)}},vi={get machineId(){return fe.telemetryInfo.machineId},get sessionId(){return fe.telemetryInfo.sessionId},get language(){return fe.environment.appLanguage},get appName(){return fe.environment.appName},get appRoot(){return fe.environment.appRoot?.fsPath??""},get appHost(){return fe.environment.appHost},get uriScheme(){return fe.environment.appUriScheme},get clipboard(){return ki.value},get shell(){return gt.getDefaultShell(!1)},get isTelemetryEnabled(){return Ve.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Ve.onDidChangeTelemetryEnabled},get isNewAppInstall(){const X=Date.now()-new Date(fe.telemetryInfo.firstSessionDate).getTime();return isNaN(X)?!1:X<1e3*60*60*24},openExternal(X,de){return xe.openUri(X,{allowTunneling:!!fe.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(X){if(X.scheme===fe.environment.appUriScheme)return At.createAppUri(X);try{return await xe.asExternalUri(X,{allowTunneling:!!fe.remote.authority})}catch(de){if((0,ot.matchesScheme)(X,We.Schemas.http)||(0,ot.matchesScheme)(X,We.Schemas.https))return X;throw de}},get remoteName(){return(0,we.getRemoteName)(fe.remote.authority)},get remoteAuthority(){return(0,ve.checkProposedApiEnabled)(Ae,"resolvers"),fe.remote.authority},get uiKind(){return fe.uiKind}};fe.environment.extensionTestsLocationURI||Object.freeze(vi);const bi=fe.remote.isRemote?B.ExtensionKind.Workspace:B.ExtensionKind.UI,Pi={createTestController(X,de){return Qt.createTestController(X,de)},createTestObserver(){return(0,ve.checkProposedApiEnabled)(Ae,"testObserver"),Qt.createTestObserver()},runTests(X){return(0,ve.checkProposedApiEnabled)(Ae,"testObserver"),Qt.runTests(X)},get onDidChangeTestResults(){return(0,ve.checkProposedApiEnabled)(Ae,"testObserver"),Qt.onResultsChanged},get testResults(){return(0,ve.checkProposedApiEnabled)(Ae,"testObserver"),Qt.results}},Ti={getExtension(X){const de=Ut.getExtensionDescription(X);if(de)return new r.Extension(ze,Ae.identifier,de,bi)},get all(){return Ut.getAllExtensionDescriptions().map(X=>new r.Extension(ze,Ae.identifier,X,bi))},get onDidChange(){return Ut.onDidChange}},Ai={createDiagnosticCollection(X){return Xt.createDiagnosticCollection(Ae.identifier,X)},get onDidChangeDiagnostics(){return Xt.onDidChangeDiagnostics},getDiagnostics:X=>Xt.getDiagnostics(X),getLanguages(){return Vt.getLanguages()},setTextDocumentLanguage(X,de){return Vt.changeLanguage(X.uri,de)},match(X,de){return(0,F.score)(N.LanguageSelector.from(X),de.uri,de.languageId,!0)},registerCodeActionsProvider(X,de,Se){return mt.registerCodeActionProvider(Ae,ft(X),de,Se)},registerCodeLensProvider(X,de){return mt.registerCodeLensProvider(Ae,ft(X),de)},registerDefinitionProvider(X,de){return mt.registerDefinitionProvider(Ae,ft(X),de)},registerDeclarationProvider(X,de){return mt.registerDeclarationProvider(Ae,ft(X),de)},registerImplementationProvider(X,de){return mt.registerImplementationProvider(Ae,ft(X),de)},registerTypeDefinitionProvider(X,de){return mt.registerTypeDefinitionProvider(Ae,ft(X),de)},registerHoverProvider(X,de){return mt.registerHoverProvider(Ae,ft(X),de,Ae.identifier)},registerEvaluatableExpressionProvider(X,de){return mt.registerEvaluatableExpressionProvider(Ae,ft(X),de,Ae.identifier)},registerInlineValuesProvider(X,de){return mt.registerInlineValuesProvider(Ae,ft(X),de,Ae.identifier)},registerDocumentHighlightProvider(X,de){return mt.registerDocumentHighlightProvider(Ae,ft(X),de)},registerLinkedEditingRangeProvider(X,de){return mt.registerLinkedEditingRangeProvider(Ae,ft(X),de)},registerReferenceProvider(X,de){return mt.registerReferenceProvider(Ae,ft(X),de)},registerRenameProvider(X,de){return mt.registerRenameProvider(Ae,ft(X),de)},registerDocumentSymbolProvider(X,de,Se){return mt.registerDocumentSymbolProvider(Ae,ft(X),de,Se)},registerWorkspaceSymbolProvider(X){return mt.registerWorkspaceSymbolProvider(Ae,X)},registerDocumentFormattingEditProvider(X,de){return mt.registerDocumentFormattingEditProvider(Ae,ft(X),de)},registerDocumentRangeFormattingEditProvider(X,de){return mt.registerDocumentRangeFormattingEditProvider(Ae,ft(X),de)},registerOnTypeFormattingEditProvider(X,de,Se,...ct){return mt.registerOnTypeFormattingEditProvider(Ae,ft(X),de,[Se].concat(ct))},registerDocumentSemanticTokensProvider(X,de,Se){return mt.registerDocumentSemanticTokensProvider(Ae,ft(X),de,Se)},registerDocumentRangeSemanticTokensProvider(X,de,Se){return mt.registerDocumentRangeSemanticTokensProvider(Ae,ft(X),de,Se)},registerSignatureHelpProvider(X,de,Se,...ct){return typeof Se=="object"?mt.registerSignatureHelpProvider(Ae,ft(X),de,Se):mt.registerSignatureHelpProvider(Ae,ft(X),de,typeof Se=="undefined"?[]:[Se,...ct])},registerCompletionItemProvider(X,de,...Se){return mt.registerCompletionItemProvider(Ae,ft(X),de,Se)},registerInlineCompletionItemProvider(X,de){return(0,ve.checkProposedApiEnabled)(Ae,"inlineCompletions"),mt.registerInlineCompletionsProvider(Ae,ft(X),de)},registerDocumentLinkProvider(X,de){return mt.registerDocumentLinkProvider(Ae,ft(X),de)},registerColorProvider(X,de){return mt.registerColorProvider(Ae,ft(X),de)},registerFoldingRangeProvider(X,de){return mt.registerFoldingRangeProvider(Ae,ft(X),de)},registerSelectionRangeProvider(X,de){return mt.registerSelectionRangeProvider(Ae,X,de)},registerCallHierarchyProvider(X,de){return mt.registerCallHierarchyProvider(Ae,X,de)},registerTypeHierarchyProvider(X,de){return mt.registerTypeHierarchyProvider(Ae,X,de)},setLanguageConfiguration:(X,de)=>mt.setLanguageConfiguration(Ae,X,de),getTokenInformationAtPosition(X,de){return(0,ve.checkProposedApiEnabled)(Ae,"tokenInformation"),Vt.tokenAtPosition(X,de)},registerInlayHintsProvider(X,de){return(0,ve.checkProposedApiEnabled)(Ae,"inlayHints"),mt.registerInlayHintsProvider(Ae,X,de)},createLanguageStatusItem(X,de){return(0,ve.checkProposedApiEnabled)(Ae,"languageStatus"),Vt.createLanguageStatusItem(Ae,X,de)}},Ri={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(X,de,Se){const ct=await(k.URI.isUri(X)?Promise.resolve(ni.openTextDocument(X)):Promise.resolve(X));return Tt.showTextDocument(ct,de,Se)},createTextEditorDecorationType(X){return Tt.createTextEditorDecorationType(Ae,X)},onDidChangeActiveTextEditor(X,de,Se){return Tt.onDidChangeActiveTextEditor(X,de,Se)},onDidChangeVisibleTextEditors(X,de,Se){return Tt.onDidChangeVisibleTextEditors(X,de,Se)},onDidChangeTextEditorSelection(X,de,Se){return Tt.onDidChangeTextEditorSelection(X,de,Se)},onDidChangeTextEditorOptions(X,de,Se){return Tt.onDidChangeTextEditorOptions(X,de,Se)},onDidChangeTextEditorVisibleRanges(X,de,Se){return Tt.onDidChangeTextEditorVisibleRanges(X,de,Se)},onDidChangeTextEditorViewColumn(X,de,Se){return Tt.onDidChangeTextEditorViewColumn(X,de,Se)},onDidCloseTerminal(X,de,Se){return gt.onDidCloseTerminal(X,de,Se)},onDidOpenTerminal(X,de,Se){return gt.onDidOpenTerminal(X,de,Se)},onDidChangeActiveTerminal(X,de,Se){return gt.onDidChangeActiveTerminal(X,de,Se)},onDidChangeTerminalDimensions(X,de,Se){return(0,ve.checkProposedApiEnabled)(Ae,"terminalDimensions"),gt.onDidChangeTerminalDimensions(X,de,Se)},onDidChangeTerminalState(X,de,Se){return gt.onDidChangeTerminalState(X,de,Se)},onDidWriteTerminalData(X,de,Se){return(0,ve.checkProposedApiEnabled)(Ae,"terminalDataWriteEvent"),gt.onDidWriteTerminalData(X,de,Se)},get state(){return xe.state},onDidChangeWindowState(X,de,Se){return xe.onDidChangeWindowState(X,de,Se)},showInformationMessage(X,...de){return ui.showMessage(Ae,T.default.Info,X,de[0],de.slice(1))},showWarningMessage(X,...de){return ui.showMessage(Ae,T.default.Warning,X,de[0],de.slice(1))},showErrorMessage(X,...de){return ui.showMessage(Ae,T.default.Error,X,de[0],de.slice(1))},showQuickPick(X,de,Se){return Array.isArray(X)&&X.some(ct=>ct.kind!==void 0)&&(0,ve.checkProposedApiEnabled)(Ae,"quickPickSeparators"),qt.showQuickPick(X,de,Se)},showWorkspaceFolderPick(X){return qt.showWorkspaceFolderPick(X)},showInputBox(X,de){return qt.showInput(X,de)},showOpenDialog(X){return ti.showOpenDialog(X)},showSaveDialog(X){return ti.showSaveDialog(X)},createStatusBarItem(X,de,Se){let ct,Ct,Dt;return typeof X=="string"?(ct=X,Ct=de,Dt=Se):(Ct=X,Dt=de),gi.createStatusBarEntry(Ae,ct,Ct,Dt)},setStatusBarMessage(X,de){return gi.setStatusBarMessage(X,de)},withScmProgress(X){return qe.report("window.withScmProgress",Ae,"Use 'withProgress' instead."),fi.withProgress(Ae,{location:B.ProgressLocation.SourceControl},(de,Se)=>X({report(ct){}}))},withProgress(X,de){return fi.withProgress(Ae,X,de)},createOutputChannel(X){return Pt.createOutputChannel(X,Ae)},createWebviewPanel(X,de,Se,ct){return Gt.createWebviewPanel(Ae,X,de,Se,ct)},createWebviewTextEditorInset(X,de,Se,ct){return(0,ve.checkProposedApiEnabled)(Ae,"editorInsets"),ai.createWebviewEditorInset(X,de,Se,ct,Ae)},createTerminal(X,de,Se){return typeof X=="object"?"pty"in X?gt.createExtensionTerminal(X):gt.createTerminalFromOptions(X):gt.createTerminal(X,de,Se)},registerTerminalLinkProvider(X){return gt.registerLinkProvider(X)},registerTerminalProfileProvider(X,de){return gt.registerProfileProvider(Ae,X,de)},registerTreeDataProvider(X,de){return Yt.registerTreeDataProvider(X,de,Ae)},createTreeView(X,de){return Yt.createTreeView(X,de,Ae)},registerWebviewPanelSerializer:(X,de)=>Gt.registerWebviewPanelSerializer(Ae,X,de),registerCustomEditorProvider:(X,de,Se={})=>_i.registerCustomEditorProvider(Ae,X,de,Se),registerFileDecorationProvider(X){return St.registerFileDecorationProvider(X,Ae.identifier)},registerUriHandler(X){return At.registerUriHandler(Ae.identifier,X)},createQuickPick(){return qt.createQuickPick(Ae)},createInputBox(){return qt.createInputBox(Ae.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(X,de,Se){return mi.onDidChangeActiveColorTheme(X,de,Se)},registerWebviewViewProvider(X,de,Se){return Ci.registerWebviewViewProvider(Ae,X,de,Se?.webviewOptions)},get activeNotebookEditor(){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditor"),wt.activeNotebookEditor},onDidChangeActiveNotebookEditor(X,de,Se){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditor"),wt.onDidChangeActiveNotebookEditor(X,de,Se)},get visibleNotebookEditors(){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditor"),wt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditor"),wt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(X,de,Se){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditor"),jt.onDidChangeNotebookEditorSelection(X,de,Se)},onDidChangeNotebookEditorVisibleRanges(X,de,Se){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditor"),jt.onDidChangeNotebookEditorVisibleRanges(X,de,Se)},showNotebookDocument(X,de){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditor"),wt.showNotebookDocument(X,de)},registerExternalUriOpener(X,de,Se){return(0,ve.checkProposedApiEnabled)(Ae,"externalUriOpener"),Si.registerExternalUriOpener(Ae.identifier,X,de,Se)},get tabs(){return(0,ve.checkProposedApiEnabled)(Ae,"tabs"),vt.tabs},get activeTab(){return(0,ve.checkProposedApiEnabled)(Ae,"tabs"),vt.activeTab},get onDidChangeTabs(){return(0,ve.checkProposedApiEnabled)(Ae,"tabs"),vt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,ve.checkProposedApiEnabled)(Ae,"tabs"),vt.onDidChangeActiveTab},getInlineCompletionItemController(X){return(0,ve.checkProposedApiEnabled)(Ae,"inlineCompletions"),d.InlineCompletionController.get(X)}},ni={get rootPath(){return qe.report("workspace.rootPath",Ae,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Oe.getPath()},set rootPath(X){throw t.readonly()},getWorkspaceFolder(X){return Oe.getWorkspaceFolder(X)},get workspaceFolders(){return Oe.getWorkspaceFolders()},get name(){return Oe.name},set name(X){throw t.readonly()},get workspaceFile(){return Oe.workspaceFile},set workspaceFile(X){throw t.readonly()},updateWorkspaceFolders:(X,de,...Se)=>Oe.updateWorkspaceFolders(Ae,X,de||0,...Se),onDidChangeWorkspaceFolders:function(X,de,Se){return Oe.onDidChangeWorkspace(X,de,Se)},asRelativePath:(X,de)=>Oe.getRelativePath(X,de),findFiles:(X,de,Se,ct)=>Oe.findFiles(N.GlobPattern.from(X),N.GlobPattern.from(de),Se,Ae.identifier,ct),findTextInFiles:(X,de,Se,ct)=>{(0,ve.checkProposedApiEnabled)(Ae,"findTextInFiles");let Ct,Dt;return typeof de=="object"?(Ct=de,Dt=Se):(Ct={},Dt=de,ct=Se),Oe.findTextInFiles(X,Ct||{},Dt,Ae.identifier,ct)},saveAll:X=>Oe.saveAll(X),applyEdit(X){return Di.applyWorkspaceEdit(X)},createFileSystemWatcher:(X,de,Se,ct)=>xt.createFileSystemWatcher(N.GlobPattern.from(X),de,Se,ct),get textDocuments(){return Et.getAllDocumentData().map(X=>X.document)},set textDocuments(X){throw t.readonly()},openTextDocument(X){let de;const Se=X;if(typeof X=="string")de=Promise.resolve(k.URI.file(X));else if(k.URI.isUri(X))de=Promise.resolve(X);else if(!Se||typeof Se=="object")de=Et.createDocumentData(Se);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(ct=>Et.ensureDocumentData(ct).then(Ct=>Ct.document))},onDidOpenTextDocument:(X,de,Se)=>Et.onDidAddDocument(X,de,Se),onDidCloseTextDocument:(X,de,Se)=>Et.onDidRemoveDocument(X,de,Se),onDidChangeTextDocument:(X,de,Se)=>Et.onDidChangeDocument(X,de,Se),onDidSaveTextDocument:(X,de,Se)=>Et.onDidSaveDocument(X,de,Se),onWillSaveTextDocument:(X,de,Se)=>Nt.getOnWillSaveTextDocumentEvent(Ae)(X,de,Se),get notebookDocuments(){return wt.notebookDocuments.map(X=>X.apiNotebook)},async openNotebookDocument(X,de){let Se;if(k.URI.isUri(X))Se=X,await wt.openNotebookDocument(X);else if(typeof X=="string")Se=k.URI.revive(await wt.createNotebookDocument({viewType:X,content:de}));else throw new Error("Invalid arguments");return wt.getNotebookDocument(Se).apiNotebook},get onDidOpenNotebookDocument(){return wt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return wt.onDidCloseNotebookDocument},registerNotebookSerializer(X,de,Se,ct){return wt.registerNotebookSerializer(Ae,X,de,Se,(0,ve.isProposedApiEnabled)(Ae,"notebookLiveShare")?ct:void 0)},registerNotebookContentProvider:(X,de,Se,ct)=>((0,ve.checkProposedApiEnabled)(Ae,"notebookContentProvider"),wt.registerNotebookContentProvider(Ae,X,de,Se,(0,ve.isProposedApiEnabled)(Ae,"notebookLiveShare")?ct:void 0)),onDidChangeConfiguration:(X,de,Se)=>pi.onDidChangeConfiguration(X,de,Se),getConfiguration(X,de){return de=arguments.length===1?void 0:de,pi.getConfiguration(X,de,Ae)},registerTextDocumentContentProvider(X,de){return Ot.registerTextDocumentContentProvider(X,de)},registerTaskProvider:(X,de)=>(qe.report("window.registerTaskProvider",Ae,"Use the corresponding function on the 'tasks' namespace instead"),It.registerTaskProvider(Ae,X,de)),registerFileSystemProvider(X,de,Se){return(0,Ce.combinedDisposable)(li.registerFileSystemProvider(Ae,X,de,Se),ke.addFileSystemProvider(X,de))},get fs(){return ke.value},registerFileSearchProvider:(X,de)=>((0,ve.checkProposedApiEnabled)(Ae,"fileSearchProvider"),Lt.registerFileSearchProvider(X,de)),registerTextSearchProvider:(X,de)=>((0,ve.checkProposedApiEnabled)(Ae,"textSearchProvider"),Lt.registerTextSearchProvider(X,de)),registerRemoteAuthorityResolver:(X,de)=>((0,ve.checkProposedApiEnabled)(Ae,"resolvers"),ze.registerRemoteAuthorityResolver(X,de)),registerResourceLabelFormatter:X=>((0,ve.checkProposedApiEnabled)(Ae,"resolvers"),Ei.$registerResourceLabelFormatter(X)),onDidCreateFiles:(X,de,Se)=>xt.onDidCreateFile(X,de,Se),onDidDeleteFiles:(X,de,Se)=>xt.onDidDeleteFile(X,de,Se),onDidRenameFiles:(X,de,Se)=>xt.onDidRenameFile(X,de,Se),onWillCreateFiles:(X,de,Se)=>xt.getOnWillCreateFileEvent(Ae)(X,de,Se),onWillDeleteFiles:(X,de,Se)=>xt.getOnWillDeleteFileEvent(Ae)(X,de,Se),onWillRenameFiles:(X,de,Se)=>xt.getOnWillRenameFileEvent(Ae)(X,de,Se),openTunnel:X=>((0,ve.checkProposedApiEnabled)(Ae,"resolvers"),De.openTunnel(Ae,X).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,ve.checkProposedApiEnabled)(Ae,"resolvers"),De.getTunnels()},onDidChangeTunnels:(X,de,Se)=>((0,ve.checkProposedApiEnabled)(Ae,"resolvers"),De.onDidChangeTunnels(X,de,Se)),registerPortAttributesProvider:(X,de)=>((0,ve.checkProposedApiEnabled)(Ae,"portsAttributes"),De.registerPortsAttributesProvider(X,de)),registerTimelineProvider:(X,de)=>((0,ve.checkProposedApiEnabled)(Ae,"timeline"),yi.registerTimelineProvider(X,de,Ae.identifier,ht.converter)),get isTrusted(){return Oe.trusted},requestWorkspaceTrust:X=>((0,ve.checkProposedApiEnabled)(Ae,"workspaceTrust"),Oe.requestWorkspaceTrust(X)),onDidGrantWorkspaceTrust:(X,de,Se)=>Oe.onDidGrantWorkspaceTrust(X,de,Se)},Fi={get inputBox(){return qe.report("scm.inputBox",Ae,"Use 'SourceControl.inputBox' instead"),Jt.getLastInputBox(Ae)},createSourceControl(X,de,Se){return Jt.createSourceControl(Ae,X,de,Se)}},Mi={createCommentController(X,de){return ci.createCommentController(Ae,X,de)}},Oi={get activeDebugSession(){return _t.activeDebugSession},get activeDebugConsole(){return _t.activeDebugConsole},get breakpoints(){return _t.breakpoints},onDidStartDebugSession(X,de,Se){return _t.onDidStartDebugSession(X,de,Se)},onDidTerminateDebugSession(X,de,Se){return _t.onDidTerminateDebugSession(X,de,Se)},onDidChangeActiveDebugSession(X,de,Se){return _t.onDidChangeActiveDebugSession(X,de,Se)},onDidReceiveDebugSessionCustomEvent(X,de,Se){return _t.onDidReceiveDebugSessionCustomEvent(X,de,Se)},onDidChangeBreakpoints(X,de,Se){return _t.onDidChangeBreakpoints(X,de,Se)},registerDebugConfigurationProvider(X,de,Se){return _t.registerDebugConfigurationProvider(X,de,Se||B.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(X,de){return _t.registerDebugAdapterDescriptorFactory(Ae,X,de)},registerDebugAdapterTrackerFactory(X,de){return _t.registerDebugAdapterTrackerFactory(X,de)},startDebugging(X,de,Se){return!Se||typeof Se=="object"&&"configuration"in Se?_t.startDebugging(X,de,{parentSession:Se}):_t.startDebugging(X,de,Se||{})},stopDebugging(X){return _t.stopDebugging(X)},addBreakpoints(X){return _t.addBreakpoints(X)},removeBreakpoints(X){return _t.removeBreakpoints(X)},asDebugSourceUri(X,de){return _t.asDebugSourceUri(X,de)}},Li={registerTaskProvider:(X,de)=>It.registerTaskProvider(Ae,X,de),fetchTasks:X=>It.fetchTasks(X),executeTask:X=>It.executeTask(Ae,X),get taskExecutions(){return It.taskExecutions},onDidStartTask:(X,de,Se)=>It.onDidStartTask(X,de,Se),onDidEndTask:(X,de,Se)=>It.onDidEndTask(X,de,Se),onDidStartTaskProcess:(X,de,Se)=>It.onDidStartTaskProcess(X,de,Se),onDidEndTaskProcess:(X,de,Se)=>It.onDidEndTaskProcess(X,de,Se)},Ni={createNotebookController(X,de,Se,ct,Ct){return oi.createNotebookController(Ae,X,de,Se,ct,(0,ve.isProposedApiEnabled)(Ae,"notebookMessaging")?Ct:void 0)},registerNotebookCellStatusBarItemProvider:(X,de)=>wt.registerNotebookCellStatusBarItemProvider(Ae,X,de),get onDidSaveNotebookDocument(){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditor"),$t.onDidSaveNotebookDocument},createNotebookEditorDecorationType(X){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditorDecorationType"),jt.createNotebookEditorDecorationType(X)},createRendererMessaging(X){return si.createRendererMessaging(Ae,X)},onDidChangeNotebookDocumentMetadata(X,de,Se){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditor"),$t.onDidChangeNotebookDocumentMetadata(X,de,Se)},onDidChangeNotebookCells(X,de,Se){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditor"),wt.onDidChangeNotebookCells(X,de,Se)},onDidChangeNotebookCellExecutionState(X,de,Se){return(0,ve.checkProposedApiEnabled)(Ae,"notebookCellExecutionState"),wt.onDidChangeNotebookCellExecutionState(X,de,Se)},onDidChangeCellOutputs(X,de,Se){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditor"),wt.onDidChangeCellOutputs(X,de,Se)},onDidChangeCellMetadata(X,de,Se){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditor"),wt.onDidChangeCellMetadata(X,de,Se)},createConcatTextDocument(X,de){return(0,ve.checkProposedApiEnabled)(Ae,"notebookConcatTextDocument"),new Ne.ExtHostNotebookConcatDocument(wt,Et,X,de)}};return{version:fe.version,authentication:ii,commands:Ii,comments:Mi,debug:Oi,env:vi,extensions:Ti,languages:Ai,notebooks:Ni,scm:Fi,tasks:Li,tests:Pi,window:Ri,workspace:ni,Breakpoint:B.Breakpoint,CallHierarchyIncomingCall:B.CallHierarchyIncomingCall,CallHierarchyItem:B.CallHierarchyItem,CallHierarchyOutgoingCall:B.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:a.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:B.CodeAction,CodeActionKind:B.CodeActionKind,CodeActionTriggerKind:B.CodeActionTriggerKind,CodeLens:B.CodeLens,Color:B.Color,ColorInformation:B.ColorInformation,ColorPresentation:B.ColorPresentation,ColorThemeKind:B.ColorThemeKind,CommentMode:B.CommentMode,CommentThreadCollapsibleState:B.CommentThreadCollapsibleState,CompletionItem:B.CompletionItem,CompletionItemKind:B.CompletionItemKind,CompletionItemTag:B.CompletionItemTag,CompletionList:B.CompletionList,CompletionTriggerKind:B.CompletionTriggerKind,ConfigurationTarget:B.ConfigurationTarget,CustomExecution:B.CustomExecution,DebugAdapterExecutable:B.DebugAdapterExecutable,DebugAdapterInlineImplementation:B.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:B.DebugAdapterNamedPipeServer,DebugAdapterServer:B.DebugAdapterServer,DebugConfigurationProviderTriggerKind:B.DebugConfigurationProviderTriggerKind,DebugConsoleMode:B.DebugConsoleMode,DecorationRangeBehavior:B.DecorationRangeBehavior,Diagnostic:B.Diagnostic,DiagnosticRelatedInformation:B.DiagnosticRelatedInformation,DiagnosticSeverity:B.DiagnosticSeverity,DiagnosticTag:B.DiagnosticTag,Disposable:B.Disposable,DocumentHighlight:B.DocumentHighlight,DocumentHighlightKind:B.DocumentHighlightKind,DocumentLink:B.DocumentLink,DocumentSymbol:B.DocumentSymbol,EndOfLine:B.EndOfLine,EnvironmentVariableMutatorType:B.EnvironmentVariableMutatorType,EvaluatableExpression:B.EvaluatableExpression,InlineValueText:B.InlineValueText,InlineValueVariableLookup:B.InlineValueVariableLookup,InlineValueEvaluatableExpression:B.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:B.InlineCompletionTriggerKind,EventEmitter:w.Emitter,ExtensionKind:B.ExtensionKind,ExtensionMode:B.ExtensionMode,ExternalUriOpenerPriority:B.ExternalUriOpenerPriority,FileChangeType:B.FileChangeType,FileDecoration:B.FileDecoration,FileSystemError:B.FileSystemError,FileType:_.FileType,FilePermission:_.FilePermission,FoldingRange:B.FoldingRange,FoldingRangeKind:B.FoldingRangeKind,FunctionBreakpoint:B.FunctionBreakpoint,InlineCompletionItem:B.InlineSuggestion,InlineCompletionList:B.InlineSuggestions,Hover:B.Hover,IndentAction:R.IndentAction,Location:B.Location,MarkdownString:B.MarkdownString,OverviewRulerLane:C.OverviewRulerLane,ParameterInformation:B.ParameterInformation,PortAutoForwardAction:B.PortAutoForwardAction,Position:B.Position,ProcessExecution:B.ProcessExecution,ProgressLocation:B.ProgressLocation,QuickInputButtons:B.QuickInputButtons,Range:B.Range,RelativePattern:B.RelativePattern,Selection:B.Selection,SelectionRange:B.SelectionRange,SemanticTokens:B.SemanticTokens,SemanticTokensBuilder:B.SemanticTokensBuilder,SemanticTokensEdit:B.SemanticTokensEdit,SemanticTokensEdits:B.SemanticTokensEdits,SemanticTokensLegend:B.SemanticTokensLegend,ShellExecution:B.ShellExecution,ShellQuoting:B.ShellQuoting,SignatureHelp:B.SignatureHelp,SignatureHelpTriggerKind:B.SignatureHelpTriggerKind,SignatureInformation:B.SignatureInformation,SnippetString:B.SnippetString,SourceBreakpoint:B.SourceBreakpoint,StandardTokenType:B.StandardTokenType,StatusBarAlignment:B.StatusBarAlignment,SymbolInformation:B.SymbolInformation,SymbolKind:B.SymbolKind,SymbolTag:B.SymbolTag,Task:B.Task,TaskGroup:B.TaskGroup,TaskPanelKind:B.TaskPanelKind,TaskRevealKind:B.TaskRevealKind,TaskScope:B.TaskScope,TerminalLink:B.TerminalLink,TerminalLocation:B.TerminalLocation,TerminalProfile:B.TerminalProfile,TextDocumentSaveReason:B.TextDocumentSaveReason,TextEdit:B.TextEdit,TextEditorCursorStyle:P.TextEditorCursorStyle,TextEditorLineNumbersStyle:B.TextEditorLineNumbersStyle,TextEditorRevealType:B.TextEditorRevealType,TextEditorSelectionChangeKind:B.TextEditorSelectionChangeKind,TextDocumentChangeReason:B.TextDocumentChangeReason,ThemeColor:B.ThemeColor,ThemeIcon:B.ThemeIcon,TreeItem:B.TreeItem,TreeItemCollapsibleState:B.TreeItemCollapsibleState,TypeHierarchyItem:B.TypeHierarchyItem,UIKind:n.UIKind,Uri:k.URI,ViewColumn:B.ViewColumn,WorkspaceEdit:B.WorkspaceEdit,InlayHint:B.InlayHint,InlayHintKind:B.InlayHintKind,RemoteAuthorityResolverError:B.RemoteAuthorityResolverError,ResolvedAuthority:B.ResolvedAuthority,SourceControlInputBoxValidationType:B.SourceControlInputBoxValidationType,ExtensionRuntime:B.ExtensionRuntime,TimelineItem:B.TimelineItem,NotebookRange:B.NotebookRange,NotebookCellKind:B.NotebookCellKind,NotebookCellExecutionState:B.NotebookCellExecutionState,NotebookCellData:B.NotebookCellData,NotebookData:B.NotebookData,NotebookRendererScript:B.NotebookRendererScript,NotebookCellStatusBarAlignment:B.NotebookCellStatusBarAlignment,NotebookEditorRevealType:B.NotebookEditorRevealType,NotebookCellOutput:B.NotebookCellOutput,NotebookCellOutputItem:B.NotebookCellOutputItem,NotebookCellStatusBarItem:B.NotebookCellStatusBarItem,NotebookControllerAffinity:B.NotebookControllerAffinity,PortAttributes:B.PortAttributes,LinkedEditingRanges:B.LinkedEditingRanges,TestResultState:B.TestResultState,TestRunRequest:B.TestRunRequest,TestMessage:B.TestMessage,TestTag:B.TestTag,TestRunProfileKind:B.TestRunProfileKind,TextSearchCompleteMessageType:he.TextSearchCompleteMessageType,TreeDataTransfer:B.TreeDataTransfer,TreeDataTransferItem:B.TreeDataTransferItem,CoveredCount:B.CoveredCount,FileCoverage:B.FileCoverage,StatementCoverage:B.StatementCoverage,BranchCoverage:B.BranchCoverage,FunctionCoverage:B.FunctionCoverage,WorkspaceTrustState:B.WorkspaceTrustState,LanguageStatusSeverity:B.LanguageStatusSeverity,QuickPickItemKind:B.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=oe}),define(Ee[220],ye([0,1,56,94,31,93,32,38,48,39,97,98,99,71,64,69,95,49,30,68,85,70,192,12,175]),function(re,e,a,t,w,T,k,P,C,R,F,_,n,f,o,g,c,D,v,h,p,I,l,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(M.ILoggerService,l.ExtHostLoggerService),(0,a.registerSingleton)(M.ILogService,r.ExtHostLogService),(0,a.registerSingleton)(g.IExtHostApiDeprecationService,g.ExtHostApiDeprecationService),(0,a.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands),(0,a.registerSingleton)(k.IExtHostConfiguration,k.ExtHostConfiguration),(0,a.registerSingleton)(D.IExtHostConsumerFileSystem,D.ExtHostConsumerFileSystem),(0,a.registerSingleton)(_.IExtHostDebugService,_.WorkerExtHostDebugService),(0,a.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,a.registerSingleton)(C.IExtHostDocumentsAndEditors,C.ExtHostDocumentsAndEditors),(0,a.registerSingleton)(v.IExtHostFileSystemInfo,v.ExtHostFileSystemInfo),(0,a.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService),(0,a.registerSingleton)(n.IExtHostSearch,n.ExtHostSearch),(0,a.registerSingleton)(f.IExtHostStorage,f.ExtHostStorage),(0,a.registerSingleton)(F.IExtHostTask,F.WorkerExtHostTask),(0,a.registerSingleton)(R.IExtHostTerminalService,R.WorkerExtHostTerminalService),(0,a.registerSingleton)(o.IExtHostTunnelService,o.ExtHostTunnelService),(0,a.registerSingleton)(c.IExtHostWindow,c.ExtHostWindow),(0,a.registerSingleton)(w.IExtHostWorkspace,w.ExtHostWorkspace),(0,a.registerSingleton)(h.IExtHostSecretState,h.ExtHostSecretState),(0,a.registerSingleton)(p.IExtHostTelemetry,p.ExtHostTelemetry),(0,a.registerSingleton)(I.IExtHostEditorTabs,I.ExtHostEditorTabs)}),define(Ee[221],ye([0,1,219,33,215,7,14,5,10]),function(re,e,a,t,w,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class R extends w.RequireInterceptor{_installInterceptor(){}getModule(o,g){for(let c of this._alternatives){let D=c(o);if(D){o=D;break}}if(this._factories.has(o))return this._factories.get(o).load(o,g,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class F extends t.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=T.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const o=this._extHostContext.getProxy(P.MainContext.MainThreadConsole);n(o,this._initData.environment.isExtensionDevelopmentDebug);const g=this._instaService.invokeFunction(a.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(R,g,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(o){return o.browser}async _loadCommonJSModule(o,g,c){g=g.with({path:_(g.path,".js")}),o&&performance.mark(`code/extHost/willFetchExtensionCode/${o.value}`);const D=await fetch(C.FileAccess.asBrowserUri(g).toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o.value}`),D.status!==200)throw new Error(D.statusText);const v=await D.text(),h=`${g.toString(!0)}#vscode-extension`,p=`${v}
//# sourceURL=${h}`;let I;try{I=new Function("module","exports","require",p)}catch(i){throw console.error(o?`Loading code for extension ${o.value} failed: ${i.message}`:`Loading code failed: ${i.message}`),console.error(`${g.toString(!0)}${typeof i.line=="number"?` line ${i.line}`:""}${typeof i.column=="number"?` column ${i.column}`:""}`),console.error(i),i}const l={},M={exports:l},r=i=>{const m=this._fakeModules.getModule(i,g);if(m===void 0)throw new Error(`Cannot load module '${i}'`);return m};try{return c.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o.value}`),I(M,l,r),M.exports!==l?M.exports:l}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o.value}`),c.codeLoadingStop()}}async $setRemoteEnvironment(o){}async _waitForDebuggerAttachment(o=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const g=Date.now()+o;for(;Date.now()<g&&!("__jsDebugIsReady"in globalThis);)await(0,k.timeout)(10)}}e.ExtHostExtensionService=F;function _(f,o){return f.endsWith(o)?f:f+o}function n(f,o){g("info","log"),g("log","log"),g("warn","warn"),g("error","error");function g(v,h){const p=console[v];console[v]=function(){f.$logExtensionHostMessage({type:"__$console",severity:h,arguments:D(arguments)}),o&&p.apply(console,arguments)}}const c=1e5;function D(v){const h=[],p=[];if(v.length)for(let I=0;I<v.length;I++){if(typeof v[I]=="undefined")v[I]="undefined";else if(v[I]instanceof Error){const l=v[I];l.stack?v[I]=l.stack:v[I]=l.toString()}p.push(v[I])}try{const I=JSON.stringify(p,function(l,M){if(M&&typeof M=="object"){if(h.indexOf(M)!==-1)return"[Circular]";h.push(M)}return M});return I.length>c?"Output omitted for a large object that exceeds the limits":I}catch(I){return`Output omitted for an object that cannot be inspected ('${I.toString()}')`}}}}),define(Ee[222],ye([0,1,56,33,72,221]),function(re,e,a,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(t.IExtHostExtensionService,T.ExtHostExtensionService),(0,a.registerSingleton)(w.IExtensionStoragePaths,w.ExtensionStoragePaths)}),define(Ee[233],ye([0,1,22,4,173,216,210,17,73,10,2,220,222]),function(re,e,a,t,w,T,k,P,C,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const _=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const n=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const f=fetch.bind(self);if(self.fetch=function(h,p){return h instanceof Request||/^file:/i.test(String(h))&&(h=R.FileAccess.asBrowserUri(F.URI.parse(String(h))).toString(!0)),f(h,p)},self.XMLHttpRequest=class extends XMLHttpRequest{open(h,p,I,l,M){return/^file:/i.test(p.toString())&&(p=R.FileAccess.asBrowserUri(F.URI.parse(p.toString())).toString(!0)),super.open(h,p,I??!0,l,M)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const h=self.Worker;Worker=function(p,I){/^file:/i.test(p.toString())&&(p=R.FileAccess.asBrowserUri(F.URI.parse(p.toString())).toString(!0));const M=`(${function(d){function s(u){return typeof u=="string"||u instanceof URL?String(u).replace(/^file:\/\//i,"vscode-file://vscode-app"):u}const b=fetch.bind(self);self.fetch=function(u,S){return u instanceof Request?b(u,S):b(s(u),S)},self.XMLHttpRequest=class extends XMLHttpRequest{open(u,S,A,U,H){return super.open(u,s(S),A??!0,U,H)}};const y=importScripts.bind(self);self.importScripts=(...u)=>{y(...u.map(s))},y(d)}.toString()}('${p}'))`;I=I||{},I.name=I.name||P.basename(p.toString());const r=new Blob([M],{type:"application/javascript"}),i=URL.createObjectURL(r);return new h(i,I)}}else self.Worker=class extends k.NestedWorker{constructor(h,p){super(n,h,{name:P.basename(h.toString()),...p})}};const o=new class{constructor(){this.pid=void 0}exit(h){_()}async exists(h){return!0}async realpath(h){return h}};class g{constructor(){const p=new MessageChannel,I=new t.Emitter;let l=!1;n(p.port2,[p.port2]),p.port1.onmessage=M=>{const{data:r}=M;if(!(r instanceof ArrayBuffer)){console.warn("UNKNOWN data received",r);return}const i=a.VSBuffer.wrap(new Uint8Array(r,0,r.byteLength));if((0,w.isMessageOfType)(i,2)){l=!0,D("received terminate message from renderer");return}I.fire(i)},this.protocol={onMessage:I.event,send:M=>{if(!l){const r=M.buffer.buffer.slice(M.buffer.byteOffset,M.buffer.byteOffset+M.buffer.byteLength);p.port1.postMessage(r,[r])}}}}}function c(h){return new Promise(p=>{const I=h.onMessage(l=>{I.dispose();const M=JSON.parse(l.toString());h.send((0,w.createMessageOfType)(0)),p({protocol:h,initData:M})});h.send((0,w.createMessageOfType)(1))})}let D=h=>_();function v(){const h=new g;C.mark("code/extHost/willConnectToRenderer"),c(h.protocol).then(p=>{C.mark("code/extHost/didWaitForInitData");const I=new T.ExtensionHostMain(p.protocol,p.initData,o,null);D=l=>I.terminate(l)})}e.create=v})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d12df34e31b4a018735d312a8947d79331132368/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
